#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2555
#define LARGE_STATE_COUNT 128
#define SYMBOL_COUNT 314
#define ALIAS_COUNT 4
#define TOKEN_COUNT 148
#define EXTERNAL_TOKEN_COUNT 13
#define FIELD_COUNT 27
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 101

enum ts_symbol_identifiers {
  aux_sym_recipe_token1 = 1,
  anon_sym_NULL = 2,
  anon_sym_EQ = 3,
  anon_sym_QMARK_EQ = 4,
  anon_sym_QMARK_QMARK_EQ = 5,
  anon_sym_COLON_EQ = 6,
  anon_sym_PLUS_EQ = 7,
  anon_sym_EQ_PLUS = 8,
  anon_sym_DOT_EQ = 9,
  anon_sym_EQ_DOT = 10,
  anon_sym_LBRACK = 11,
  anon_sym_noexec = 12,
  aux_sym_variable_flag_token1 = 13,
  anon_sym_RBRACK = 14,
  anon_sym_COLON = 15,
  anon_sym_append = 16,
  anon_sym_prepend = 17,
  anon_sym_remove = 18,
  anon_sym_unset = 19,
  anon_sym_inherit = 20,
  sym_inherit_path = 21,
  anon_sym_INHERIT = 22,
  anon_sym_DQUOTE = 23,
  anon_sym_include = 24,
  aux_sym_include_directive_token1 = 25,
  anon_sym_require = 26,
  anon_sym_export = 27,
  anon_sym_OVERRIDES = 28,
  anon_sym_EXPORT_FUNCTIONS = 29,
  anon_sym_addtask = 30,
  anon_sym_after = 31,
  anon_sym_before = 32,
  anon_sym_deltask = 33,
  anon_sym_addhandler = 34,
  anon_sym_fakeroot = 35,
  anon_sym_python = 36,
  anon_sym_LPAREN = 37,
  anon_sym_RPAREN = 38,
  anon_sym_LBRACE = 39,
  anon_sym_RBRACE = 40,
  aux_sym_string_token1 = 41,
  aux_sym_string_token2 = 42,
  anon_sym_DOLLARBB_ENV_PASSTHROUGH = 43,
  anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS = 44,
  anon_sym_DOLLAR = 45,
  anon_sym_SQUOTE = 46,
  aux_sym_string_token3 = 47,
  aux_sym_string_token4 = 48,
  anon_sym_DOLLAR_LBRACE_AT = 49,
  anon_sym_DOLLAR_LBRACE = 50,
  anon_sym_def = 51,
  anon_sym_DASH_GT = 52,
  anon_sym_SEMI = 53,
  anon_sym_import = 54,
  anon_sym_DOT = 55,
  anon_sym_from = 56,
  anon_sym___future__ = 57,
  anon_sym_COMMA = 58,
  anon_sym_as = 59,
  anon_sym_STAR = 60,
  anon_sym_print = 61,
  anon_sym_GT_GT = 62,
  anon_sym_assert = 63,
  anon_sym_return = 64,
  anon_sym_del = 65,
  anon_sym_raise = 66,
  anon_sym_pass = 67,
  anon_sym_break = 68,
  anon_sym_continue = 69,
  anon_sym_global = 70,
  anon_sym_nonlocal = 71,
  anon_sym_exec = 72,
  anon_sym_in = 73,
  anon_sym_if = 74,
  anon_sym_elif = 75,
  anon_sym_else = 76,
  anon_sym_async = 77,
  anon_sym_for = 78,
  anon_sym_while = 79,
  anon_sym_try = 80,
  anon_sym_except = 81,
  anon_sym_except_STAR = 82,
  anon_sym_finally = 83,
  anon_sym_with = 84,
  anon_sym_not = 85,
  anon_sym_and = 86,
  anon_sym_or = 87,
  anon_sym_PLUS = 88,
  anon_sym_DASH = 89,
  anon_sym_AT = 90,
  anon_sym_SLASH = 91,
  anon_sym_PERCENT = 92,
  anon_sym_SLASH_SLASH = 93,
  anon_sym_STAR_STAR = 94,
  anon_sym_PIPE = 95,
  anon_sym_AMP = 96,
  anon_sym_CARET = 97,
  anon_sym_LT_LT = 98,
  anon_sym_TILDE = 99,
  anon_sym_LT = 100,
  anon_sym_LT_EQ = 101,
  anon_sym_EQ_EQ = 102,
  anon_sym_BANG_EQ = 103,
  anon_sym_GT_EQ = 104,
  anon_sym_GT = 105,
  anon_sym_LT_GT = 106,
  anon_sym_is = 107,
  anon_sym_lambda = 108,
  anon_sym_DASH_EQ = 109,
  anon_sym_STAR_EQ = 110,
  anon_sym_SLASH_EQ = 111,
  anon_sym_AT_EQ = 112,
  anon_sym_SLASH_SLASH_EQ = 113,
  anon_sym_PERCENT_EQ = 114,
  anon_sym_STAR_STAR_EQ = 115,
  anon_sym_GT_GT_EQ = 116,
  anon_sym_LT_LT_EQ = 117,
  anon_sym_AMP_EQ = 118,
  anon_sym_CARET_EQ = 119,
  anon_sym_PIPE_EQ = 120,
  anon_sym_yield = 121,
  sym_ellipsis = 122,
  sym_escape_sequence = 123,
  sym__not_escape_sequence = 124,
  aux_sym_format_specifier_token1 = 125,
  sym_type_conversion = 126,
  anon_sym_await = 127,
  anon_sym_match = 128,
  anon_sym_type = 129,
  sym_integer = 130,
  sym_float = 131,
  sym_true = 132,
  sym_false = 133,
  sym_none = 134,
  sym_python_identifier = 135,
  sym_identifier = 136,
  aux_sym__dotted_identifier_token1 = 137,
  sym_comment = 138,
  sym__concat = 139,
  sym__newline = 140,
  sym__indent = 141,
  sym__dedent = 142,
  sym_string_start = 143,
  sym__string_content = 144,
  sym_escape_interpolation = 145,
  sym_string_end = 146,
  sym_shell_content = 147,
  sym_recipe = 148,
  sym_variable_assignment = 149,
  sym_variable_flag = 150,
  sym_override = 151,
  sym_unset_statement = 152,
  sym_inherit_directive = 153,
  sym_include_directive = 154,
  sym_require_directive = 155,
  sym_export_statement = 156,
  sym_overrides_statement = 157,
  sym_export_functions_statement = 158,
  sym_addtask_statement = 159,
  sym_deltask_statement = 160,
  sym_addhandler_statement = 161,
  sym_anonymous_python_function = 162,
  sym_function_definition = 163,
  sym_literal = 164,
  sym_string = 165,
  sym_inline_python = 166,
  sym_variable_expansion = 167,
  sym_python_function_definition = 168,
  sym__statement = 169,
  sym__simple_statements = 170,
  sym_import_statement = 171,
  sym_import_prefix = 172,
  sym_relative_import = 173,
  sym_future_import_statement = 174,
  sym_import_from_statement = 175,
  sym__import_list = 176,
  sym_aliased_import = 177,
  sym_wildcard_import = 178,
  sym_print_statement = 179,
  sym_chevron = 180,
  sym_assert_statement = 181,
  sym_expression_statement = 182,
  sym_named_expression = 183,
  sym__named_expression_lhs = 184,
  sym_return_statement = 185,
  sym_delete_statement = 186,
  sym_raise_statement = 187,
  sym_pass_statement = 188,
  sym_break_statement = 189,
  sym_continue_statement = 190,
  sym_global_statement = 191,
  sym_nonlocal_statement = 192,
  sym_exec_statement = 193,
  sym_type_parameter = 194,
  sym_parenthesized_list_splat = 195,
  sym_argument_list = 196,
  sym_if_statement = 197,
  sym_elif_clause = 198,
  sym_else_clause = 199,
  sym_for_statement = 200,
  sym_while_statement = 201,
  sym_try_statement = 202,
  sym_except_clause = 203,
  sym_except_group_clause = 204,
  sym_finally_clause = 205,
  sym_with_statement = 206,
  sym_with_clause = 207,
  sym_with_item = 208,
  sym_dotted_name = 209,
  sym_not_operator = 210,
  sym_boolean_operator = 211,
  sym_binary_operator = 212,
  sym_unary_operator = 213,
  sym_comparison_operator = 214,
  sym_lambda = 215,
  sym_lambda_within_for_in_clause = 216,
  sym_assignment = 217,
  sym_augmented_assignment = 218,
  sym_pattern_list = 219,
  sym__right_hand_side = 220,
  sym_yield = 221,
  sym_attribute = 222,
  sym_subscript = 223,
  sym_slice = 224,
  sym_call = 225,
  sym_generator_expression = 226,
  sym__comprehension_clauses = 227,
  sym_parenthesized_expression = 228,
  sym__collection_elements = 229,
  sym_for_in_clause = 230,
  sym_if_clause = 231,
  sym_block = 232,
  sym_expression_list = 233,
  sym_parameters = 234,
  sym_lambda_parameters = 235,
  sym_list_splat = 236,
  sym_dictionary_splat = 237,
  sym__parameters = 238,
  sym__patterns = 239,
  sym_parameter = 240,
  sym_pattern = 241,
  sym_tuple_pattern = 242,
  sym_list_pattern = 243,
  sym_default_parameter = 244,
  sym_typed_default_parameter = 245,
  sym_list_splat_pattern = 246,
  sym_dictionary_splat_pattern = 247,
  sym_as_pattern = 248,
  sym__expression_within_for_in_clause = 249,
  sym_expression = 250,
  sym_primary_expression = 251,
  sym_typed_parameter = 252,
  sym_type = 253,
  sym_splat_type = 254,
  sym_generic_type = 255,
  sym_union_type = 256,
  sym_constrained_type = 257,
  sym_member_type = 258,
  sym_keyword_argument = 259,
  sym_list = 260,
  sym_set = 261,
  sym_tuple = 262,
  sym_dictionary = 263,
  sym_pair = 264,
  sym_list_comprehension = 265,
  sym_dictionary_comprehension = 266,
  sym_set_comprehension = 267,
  sym_conditional_expression = 268,
  sym_concatenated_string = 269,
  sym_python_string = 270,
  sym_string_content = 271,
  sym_interpolation = 272,
  sym__f_expression = 273,
  sym_format_specifier = 274,
  sym_await = 275,
  sym_positional_separator = 276,
  sym_keyword_separator = 277,
  sym_concatenation = 278,
  aux_sym_recipe_repeat1 = 279,
  aux_sym_override_repeat1 = 280,
  aux_sym_inherit_directive_repeat1 = 281,
  aux_sym_overrides_statement_repeat1 = 282,
  aux_sym_export_functions_statement_repeat1 = 283,
  aux_sym_function_definition_repeat1 = 284,
  aux_sym_string_repeat1 = 285,
  aux_sym_string_repeat2 = 286,
  aux_sym__simple_statements_repeat1 = 287,
  aux_sym_import_prefix_repeat1 = 288,
  aux_sym__import_list_repeat1 = 289,
  aux_sym_print_statement_repeat1 = 290,
  aux_sym_assert_statement_repeat1 = 291,
  aux_sym_global_statement_repeat1 = 292,
  aux_sym_type_parameter_repeat1 = 293,
  aux_sym_argument_list_repeat1 = 294,
  aux_sym_if_statement_repeat1 = 295,
  aux_sym_try_statement_repeat1 = 296,
  aux_sym_try_statement_repeat2 = 297,
  aux_sym_with_clause_repeat1 = 298,
  aux_sym_dotted_name_repeat1 = 299,
  aux_sym_comparison_operator_repeat1 = 300,
  aux_sym_pattern_list_repeat1 = 301,
  aux_sym_subscript_repeat1 = 302,
  aux_sym__comprehension_clauses_repeat1 = 303,
  aux_sym__collection_elements_repeat1 = 304,
  aux_sym_for_in_clause_repeat1 = 305,
  aux_sym_block_repeat1 = 306,
  aux_sym__parameters_repeat1 = 307,
  aux_sym_dictionary_repeat1 = 308,
  aux_sym_concatenated_string_repeat1 = 309,
  aux_sym_python_string_repeat1 = 310,
  aux_sym_string_content_repeat1 = 311,
  aux_sym_format_specifier_repeat1 = 312,
  aux_sym_concatenation_repeat1 = 313,
  alias_sym_as_pattern_target = 314,
  alias_sym_format_expression = 315,
  anon_alias_sym_isnot = 316,
  anon_alias_sym_notin = 317,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [aux_sym_recipe_token1] = "recipe_token1",
  [anon_sym_NULL] = "\0",
  [anon_sym_EQ] = "=",
  [anon_sym_QMARK_EQ] = "\?=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_EQ_PLUS] = "=+",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_EQ_DOT] = "=.",
  [anon_sym_LBRACK] = "[",
  [anon_sym_noexec] = "noexec",
  [aux_sym_variable_flag_token1] = "flag",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [anon_sym_append] = "append",
  [anon_sym_prepend] = "prepend",
  [anon_sym_remove] = "remove",
  [anon_sym_unset] = "unset",
  [anon_sym_inherit] = "inherit",
  [sym_inherit_path] = "inherit_path",
  [anon_sym_INHERIT] = "INHERIT",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_include] = "include",
  [aux_sym_include_directive_token1] = "include_path",
  [anon_sym_require] = "require",
  [anon_sym_export] = "export",
  [anon_sym_OVERRIDES] = "OVERRIDES",
  [anon_sym_EXPORT_FUNCTIONS] = "EXPORT_FUNCTIONS",
  [anon_sym_addtask] = "addtask",
  [anon_sym_after] = "after",
  [anon_sym_before] = "before",
  [anon_sym_deltask] = "deltask",
  [anon_sym_addhandler] = "addhandler",
  [anon_sym_fakeroot] = "fakeroot",
  [anon_sym_python] = "python",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym_string_token1] = "string_content",
  [aux_sym_string_token2] = "string_token2",
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = "$BB_ENV_PASSTHROUGH",
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = "$BB_ENV_PASSTHROUGH_ADDITIONS",
  [anon_sym_DOLLAR] = "string_content",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token3] = "string_content",
  [aux_sym_string_token4] = "string_token4",
  [anon_sym_DOLLAR_LBRACE_AT] = "${@",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_SEMI] = ";",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_in] = "in",
  [anon_sym_if] = "if",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_except_STAR] = "except*",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_AT] = "@",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [anon_sym_await] = "await",
  [anon_sym_match] = "python_identifier",
  [anon_sym_type] = "python_identifier",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_python_identifier] = "python_identifier",
  [sym_identifier] = "identifier",
  [aux_sym__dotted_identifier_token1] = "identifier",
  [sym_comment] = "comment",
  [sym__concat] = "_concat",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_string_start] = "string_start",
  [sym__string_content] = "_string_content",
  [sym_escape_interpolation] = "escape_interpolation",
  [sym_string_end] = "string_end",
  [sym_shell_content] = "shell_content",
  [sym_recipe] = "recipe",
  [sym_variable_assignment] = "variable_assignment",
  [sym_variable_flag] = "variable_flag",
  [sym_override] = "override",
  [sym_unset_statement] = "unset_statement",
  [sym_inherit_directive] = "inherit_directive",
  [sym_include_directive] = "include_directive",
  [sym_require_directive] = "require_directive",
  [sym_export_statement] = "export_statement",
  [sym_overrides_statement] = "overrides_statement",
  [sym_export_functions_statement] = "export_functions_statement",
  [sym_addtask_statement] = "addtask_statement",
  [sym_deltask_statement] = "deltask_statement",
  [sym_addhandler_statement] = "addhandler_statement",
  [sym_anonymous_python_function] = "anonymous_python_function",
  [sym_function_definition] = "function_definition",
  [sym_literal] = "literal",
  [sym_string] = "string",
  [sym_inline_python] = "inline_python",
  [sym_variable_expansion] = "variable_expansion",
  [sym_python_function_definition] = "python_function_definition",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym__named_expression_lhs] = "_named_expression_lhs",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_type_parameter] = "type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_except_group_clause] = "except_group_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_dotted_name] = "dotted_name",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_generator_expression] = "generator_expression",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_splat_type] = "splat_type",
  [sym_generic_type] = "generic_type",
  [sym_union_type] = "union_type",
  [sym_constrained_type] = "constrained_type",
  [sym_member_type] = "member_type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_python_string] = "python_string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym_format_specifier] = "format_specifier",
  [sym_await] = "await",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [sym_concatenation] = "concatenation",
  [aux_sym_recipe_repeat1] = "recipe_repeat1",
  [aux_sym_override_repeat1] = "override_repeat1",
  [aux_sym_inherit_directive_repeat1] = "inherit_directive_repeat1",
  [aux_sym_overrides_statement_repeat1] = "overrides_statement_repeat1",
  [aux_sym_export_functions_statement_repeat1] = "export_functions_statement_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_type_parameter_repeat1] = "type_parameter_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_try_statement_repeat2] = "try_statement_repeat2",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_pattern_list_repeat1] = "pattern_list_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_python_string_repeat1] = "python_string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [alias_sym_as_pattern_target] = "as_pattern_target",
  [alias_sym_format_expression] = "format_expression",
  [anon_alias_sym_isnot] = "is not",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [aux_sym_recipe_token1] = aux_sym_recipe_token1,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_QMARK_EQ] = anon_sym_QMARK_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_EQ_PLUS] = anon_sym_EQ_PLUS,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_EQ_DOT] = anon_sym_EQ_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_noexec] = anon_sym_noexec,
  [aux_sym_variable_flag_token1] = aux_sym_variable_flag_token1,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_append] = anon_sym_append,
  [anon_sym_prepend] = anon_sym_prepend,
  [anon_sym_remove] = anon_sym_remove,
  [anon_sym_unset] = anon_sym_unset,
  [anon_sym_inherit] = anon_sym_inherit,
  [sym_inherit_path] = sym_inherit_path,
  [anon_sym_INHERIT] = anon_sym_INHERIT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_include] = anon_sym_include,
  [aux_sym_include_directive_token1] = aux_sym_include_directive_token1,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_OVERRIDES] = anon_sym_OVERRIDES,
  [anon_sym_EXPORT_FUNCTIONS] = anon_sym_EXPORT_FUNCTIONS,
  [anon_sym_addtask] = anon_sym_addtask,
  [anon_sym_after] = anon_sym_after,
  [anon_sym_before] = anon_sym_before,
  [anon_sym_deltask] = anon_sym_deltask,
  [anon_sym_addhandler] = anon_sym_addhandler,
  [anon_sym_fakeroot] = anon_sym_fakeroot,
  [anon_sym_python] = anon_sym_python,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym_string_token1] = sym_string_content,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = anon_sym_DOLLARBB_ENV_PASSTHROUGH,
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
  [anon_sym_DOLLAR] = sym_string_content,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token3] = sym_string_content,
  [aux_sym_string_token4] = aux_sym_string_token4,
  [anon_sym_DOLLAR_LBRACE_AT] = anon_sym_DOLLAR_LBRACE_AT,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_except_STAR] = anon_sym_except_STAR,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_match] = sym_python_identifier,
  [anon_sym_type] = sym_python_identifier,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_python_identifier] = sym_python_identifier,
  [sym_identifier] = sym_identifier,
  [aux_sym__dotted_identifier_token1] = sym_identifier,
  [sym_comment] = sym_comment,
  [sym__concat] = sym__concat,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_string_start] = sym_string_start,
  [sym__string_content] = sym__string_content,
  [sym_escape_interpolation] = sym_escape_interpolation,
  [sym_string_end] = sym_string_end,
  [sym_shell_content] = sym_shell_content,
  [sym_recipe] = sym_recipe,
  [sym_variable_assignment] = sym_variable_assignment,
  [sym_variable_flag] = sym_variable_flag,
  [sym_override] = sym_override,
  [sym_unset_statement] = sym_unset_statement,
  [sym_inherit_directive] = sym_inherit_directive,
  [sym_include_directive] = sym_include_directive,
  [sym_require_directive] = sym_require_directive,
  [sym_export_statement] = sym_export_statement,
  [sym_overrides_statement] = sym_overrides_statement,
  [sym_export_functions_statement] = sym_export_functions_statement,
  [sym_addtask_statement] = sym_addtask_statement,
  [sym_deltask_statement] = sym_deltask_statement,
  [sym_addhandler_statement] = sym_addhandler_statement,
  [sym_anonymous_python_function] = sym_anonymous_python_function,
  [sym_function_definition] = sym_function_definition,
  [sym_literal] = sym_literal,
  [sym_string] = sym_string,
  [sym_inline_python] = sym_inline_python,
  [sym_variable_expansion] = sym_variable_expansion,
  [sym_python_function_definition] = sym_python_function_definition,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym__named_expression_lhs] = sym__named_expression_lhs,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_parameter] = sym_type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_except_group_clause] = sym_except_group_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_dotted_name] = sym_dotted_name,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_generator_expression] = sym_generator_expression,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_splat_type] = sym_splat_type,
  [sym_generic_type] = sym_generic_type,
  [sym_union_type] = sym_union_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_member_type] = sym_member_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_python_string] = sym_python_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym_format_specifier] = sym_format_specifier,
  [sym_await] = sym_await,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [sym_concatenation] = sym_concatenation,
  [aux_sym_recipe_repeat1] = aux_sym_recipe_repeat1,
  [aux_sym_override_repeat1] = aux_sym_override_repeat1,
  [aux_sym_inherit_directive_repeat1] = aux_sym_inherit_directive_repeat1,
  [aux_sym_overrides_statement_repeat1] = aux_sym_overrides_statement_repeat1,
  [aux_sym_export_functions_statement_repeat1] = aux_sym_export_functions_statement_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_type_parameter_repeat1] = aux_sym_type_parameter_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_try_statement_repeat2] = aux_sym_try_statement_repeat2,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_pattern_list_repeat1] = aux_sym_pattern_list_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_python_string_repeat1] = aux_sym_python_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [alias_sym_as_pattern_target] = alias_sym_as_pattern_target,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [anon_alias_sym_isnot] = anon_alias_sym_isnot,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_recipe_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexec] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_flag_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_append] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prepend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inherit] = {
    .visible = true,
    .named = false,
  },
  [sym_inherit_path] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_INHERIT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_directive_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_OVERRIDES] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EXPORT_FUNCTIONS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addtask] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_after] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_before] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deltask] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addhandler] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fakeroot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_python] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token3] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_python_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__dotted_identifier_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_shell_content] = {
    .visible = true,
    .named = true,
  },
  [sym_recipe] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_flag] = {
    .visible = true,
    .named = true,
  },
  [sym_override] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inherit_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_include_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_require_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_overrides_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_functions_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_addtask_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_deltask_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_addhandler_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_python_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_python] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_python_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__named_expression_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_except_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_python_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_recipe_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_override_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inherit_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_overrides_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_functions_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_python_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_as_pattern_target] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_isnot] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_expression = 11,
  field_format_specifier = 12,
  field_function = 13,
  field_key = 14,
  field_left = 15,
  field_module_name = 16,
  field_name = 17,
  field_object = 18,
  field_operator = 19,
  field_operators = 20,
  field_parameters = 21,
  field_return_type = 22,
  field_right = 23,
  field_subscript = 24,
  field_type = 25,
  field_type_conversion = 26,
  field_value = 27,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_expression] = "expression",
  [field_format_specifier] = "format_specifier",
  [field_function] = "function",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_type_conversion] = "type_conversion",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 2},
  [7] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 1},
  [9] = {.index = 7, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 12, .length = 3},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 17, .length = 1},
  [16] = {.index = 18, .length = 2},
  [17] = {.index = 20, .length = 3},
  [18] = {.index = 23, .length = 1},
  [20] = {.index = 24, .length = 1},
  [21] = {.index = 25, .length = 2},
  [22] = {.index = 27, .length = 1},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 30, .length = 2},
  [25] = {.index = 32, .length = 2},
  [26] = {.index = 32, .length = 2},
  [28] = {.index = 34, .length = 1},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 1},
  [31] = {.index = 37, .length = 4},
  [33] = {.index = 41, .length = 2},
  [34] = {.index = 43, .length = 2},
  [35] = {.index = 45, .length = 1},
  [36] = {.index = 46, .length = 3},
  [37] = {.index = 49, .length = 2},
  [38] = {.index = 9, .length = 2},
  [40] = {.index = 51, .length = 1},
  [41] = {.index = 52, .length = 2},
  [42] = {.index = 54, .length = 1},
  [43] = {.index = 55, .length = 2},
  [44] = {.index = 57, .length = 1},
  [45] = {.index = 58, .length = 2},
  [46] = {.index = 60, .length = 2},
  [47] = {.index = 62, .length = 4},
  [48] = {.index = 66, .length = 2},
  [49] = {.index = 68, .length = 2},
  [50] = {.index = 70, .length = 3},
  [51] = {.index = 73, .length = 2},
  [52] = {.index = 75, .length = 3},
  [54] = {.index = 78, .length = 1},
  [55] = {.index = 79, .length = 2},
  [56] = {.index = 81, .length = 2},
  [57] = {.index = 83, .length = 1},
  [58] = {.index = 84, .length = 2},
  [59] = {.index = 86, .length = 1},
  [60] = {.index = 87, .length = 2},
  [61] = {.index = 89, .length = 1},
  [62] = {.index = 90, .length = 5},
  [63] = {.index = 95, .length = 3},
  [64] = {.index = 98, .length = 2},
  [65] = {.index = 100, .length = 3},
  [67] = {.index = 103, .length = 2},
  [68] = {.index = 105, .length = 2},
  [69] = {.index = 8, .length = 1},
  [70] = {.index = 107, .length = 1},
  [71] = {.index = 108, .length = 3},
  [72] = {.index = 111, .length = 3},
  [73] = {.index = 114, .length = 1},
  [74] = {.index = 115, .length = 3},
  [75] = {.index = 118, .length = 3},
  [76] = {.index = 121, .length = 3},
  [77] = {.index = 124, .length = 1},
  [78] = {.index = 125, .length = 3},
  [79] = {.index = 128, .length = 3},
  [80] = {.index = 131, .length = 2},
  [81] = {.index = 133, .length = 2},
  [82] = {.index = 135, .length = 1},
  [83] = {.index = 136, .length = 2},
  [84] = {.index = 138, .length = 4},
  [85] = {.index = 142, .length = 2},
  [86] = {.index = 144, .length = 4},
  [87] = {.index = 148, .length = 4},
  [88] = {.index = 152, .length = 2},
  [89] = {.index = 154, .length = 3},
  [90] = {.index = 157, .length = 4},
  [92] = {.index = 161, .length = 5},
  [93] = {.index = 166, .length = 3},
  [94] = {.index = 169, .length = 4},
  [95] = {.index = 173, .length = 4},
  [97] = {.index = 177, .length = 4},
  [98] = {.index = 181, .length = 4},
  [99] = {.index = 185, .length = 5},
  [100] = {.index = 190, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_operator, 1},
  [1] =
    {field_argument, 1},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_arguments, 1},
    {field_function, 0},
  [6] =
    {field_operators, 1, .inherited = true},
  [7] =
    {field_operator, 2},
  [8] =
    {field_body, 2},
  [9] =
    {field_name, 0},
    {field_value, 2},
  [11] =
    {field_alias, 2},
  [12] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [15] =
    {field_attribute, 2},
    {field_object, 0},
  [17] =
    {field_operators, 0},
  [18] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [20] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [23] =
    {field_expression, 1},
  [24] =
    {field_body, 1},
  [25] =
    {field_key, 0},
    {field_value, 2},
  [27] =
    {field_type, 2},
  [28] =
    {field_body, 3},
    {field_parameters, 1},
  [30] =
    {field_subscript, 2},
    {field_value, 0},
  [32] =
    {field_operators, 0},
    {field_operators, 1},
  [34] =
    {field_name, 1, .inherited = true},
  [35] =
    {field_name, 0},
  [36] =
    {field_code, 1},
  [37] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [41] =
    {field_expression, 1},
    {field_type_conversion, 2},
  [43] =
    {field_expression, 1},
    {field_format_specifier, 2},
  [45] =
    {field_subscript, 1},
  [46] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [49] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [51] =
    {field_value, 0},
  [52] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [54] =
    {field_argument, 2, .inherited = true},
  [55] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [57] =
    {field_cause, 2},
  [58] =
    {field_left, 0},
    {field_right, 2},
  [60] =
    {field_left, 0},
    {field_type, 2},
  [62] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [66] =
    {field_expression, 1},
    {field_type_conversion, 3},
  [68] =
    {field_expression, 1},
    {field_format_specifier, 3},
  [70] =
    {field_expression, 1},
    {field_format_specifier, 3},
    {field_type_conversion, 2},
  [73] =
    {field_left, 1},
    {field_right, 3},
  [75] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [78] =
    {field_name, 1},
  [79] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [81] =
    {field_alias, 2},
    {field_name, 0},
  [83] =
    {field_name, 3, .inherited = true},
  [84] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [86] =
    {field_module_name, 1},
  [87] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [89] =
    {field_cause, 3},
  [90] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [95] =
    {field_expression, 1},
    {field_format_specifier, 4},
    {field_type_conversion, 3},
  [98] =
    {field_left, 2},
    {field_right, 4},
  [100] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [103] =
    {field_condition, 1},
    {field_consequence, 3},
  [105] =
    {field_body, 3},
    {field_condition, 1},
  [107] =
    {field_body, 3},
  [108] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [111] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [114] =
    {field_alternative, 0},
  [115] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [118] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [121] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [124] =
    {field_body, 4},
  [125] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [128] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [131] =
    {field_body, 2},
    {field_body, 3},
  [133] =
    {field_body, 3},
    {field_body, 4},
  [135] =
    {field_name, 4, .inherited = true},
  [136] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [138] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [142] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [144] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [148] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [152] =
    {field_body, 4},
    {field_body, 5},
  [154] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [157] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [161] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [166] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [169] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [173] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [177] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [181] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [185] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [190] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_python_identifier,
  },
  [2] = {
    [0] = sym_list_splat,
  },
  [4] = {
    [1] = sym_python_identifier,
  },
  [12] = {
    [2] = alias_sym_as_pattern_target,
  },
  [17] = {
    [4] = sym_block,
  },
  [19] = {
    [1] = sym_parenthesized_expression,
  },
  [25] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [26] = {
    [0] = anon_alias_sym_isnot,
    [1] = anon_alias_sym_isnot,
  },
  [27] = {
    [4] = sym_block,
  },
  [32] = {
    [0] = alias_sym_format_expression,
  },
  [38] = {
    [0] = sym_python_identifier,
  },
  [39] = {
    [5] = sym_block,
  },
  [47] = {
    [6] = sym_block,
  },
  [53] = {
    [6] = sym_block,
  },
  [66] = {
    [7] = sym_block,
  },
  [67] = {
    [3] = sym_block,
  },
  [68] = {
    [3] = sym_block,
  },
  [69] = {
    [2] = sym_block,
  },
  [70] = {
    [3] = sym_block,
  },
  [74] = {
    [3] = sym_block,
  },
  [75] = {
    [3] = sym_block,
  },
  [77] = {
    [4] = sym_block,
  },
  [78] = {
    [3] = sym_block,
  },
  [84] = {
    [3] = sym_block,
  },
  [89] = {
    [5] = sym_block,
  },
  [91] = {
    [2] = sym_block,
  },
  [93] = {
    [6] = sym_block,
  },
  [94] = {
    [5] = sym_block,
  },
  [96] = {
    [3] = sym_block,
  },
  [97] = {
    [6] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_list_splat_pattern, 2,
    sym_list_splat_pattern,
    sym_list_splat,
  sym_expression, 2,
    sym_expression,
    alias_sym_as_pattern_target,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 5,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 7,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 4,
  [25] = 25,
  [26] = 26,
  [27] = 26,
  [28] = 28,
  [29] = 26,
  [30] = 26,
  [31] = 26,
  [32] = 26,
  [33] = 26,
  [34] = 26,
  [35] = 26,
  [36] = 36,
  [37] = 37,
  [38] = 37,
  [39] = 36,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 47,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 44,
  [61] = 61,
  [62] = 61,
  [63] = 63,
  [64] = 63,
  [65] = 61,
  [66] = 63,
  [67] = 61,
  [68] = 61,
  [69] = 63,
  [70] = 61,
  [71] = 61,
  [72] = 61,
  [73] = 63,
  [74] = 61,
  [75] = 63,
  [76] = 63,
  [77] = 63,
  [78] = 63,
  [79] = 79,
  [80] = 80,
  [81] = 80,
  [82] = 82,
  [83] = 80,
  [84] = 84,
  [85] = 84,
  [86] = 82,
  [87] = 82,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 84,
  [92] = 89,
  [93] = 84,
  [94] = 84,
  [95] = 88,
  [96] = 82,
  [97] = 80,
  [98] = 82,
  [99] = 89,
  [100] = 100,
  [101] = 89,
  [102] = 89,
  [103] = 90,
  [104] = 84,
  [105] = 82,
  [106] = 84,
  [107] = 88,
  [108] = 84,
  [109] = 82,
  [110] = 80,
  [111] = 84,
  [112] = 82,
  [113] = 82,
  [114] = 89,
  [115] = 88,
  [116] = 82,
  [117] = 82,
  [118] = 89,
  [119] = 89,
  [120] = 88,
  [121] = 88,
  [122] = 89,
  [123] = 84,
  [124] = 82,
  [125] = 100,
  [126] = 89,
  [127] = 82,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 130,
  [132] = 129,
  [133] = 133,
  [134] = 130,
  [135] = 135,
  [136] = 129,
  [137] = 129,
  [138] = 135,
  [139] = 139,
  [140] = 135,
  [141] = 130,
  [142] = 130,
  [143] = 129,
  [144] = 129,
  [145] = 135,
  [146] = 135,
  [147] = 130,
  [148] = 129,
  [149] = 135,
  [150] = 135,
  [151] = 129,
  [152] = 135,
  [153] = 130,
  [154] = 129,
  [155] = 129,
  [156] = 129,
  [157] = 139,
  [158] = 158,
  [159] = 130,
  [160] = 130,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 163,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 167,
  [169] = 169,
  [170] = 170,
  [171] = 165,
  [172] = 170,
  [173] = 161,
  [174] = 162,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 167,
  [179] = 175,
  [180] = 176,
  [181] = 167,
  [182] = 167,
  [183] = 167,
  [184] = 165,
  [185] = 165,
  [186] = 170,
  [187] = 187,
  [188] = 175,
  [189] = 167,
  [190] = 190,
  [191] = 175,
  [192] = 167,
  [193] = 170,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 196,
  [199] = 199,
  [200] = 197,
  [201] = 196,
  [202] = 202,
  [203] = 195,
  [204] = 196,
  [205] = 197,
  [206] = 206,
  [207] = 195,
  [208] = 196,
  [209] = 209,
  [210] = 202,
  [211] = 199,
  [212] = 206,
  [213] = 202,
  [214] = 199,
  [215] = 209,
  [216] = 202,
  [217] = 206,
  [218] = 195,
  [219] = 197,
  [220] = 196,
  [221] = 199,
  [222] = 197,
  [223] = 209,
  [224] = 206,
  [225] = 209,
  [226] = 199,
  [227] = 209,
  [228] = 195,
  [229] = 202,
  [230] = 197,
  [231] = 197,
  [232] = 199,
  [233] = 209,
  [234] = 196,
  [235] = 209,
  [236] = 199,
  [237] = 195,
  [238] = 206,
  [239] = 209,
  [240] = 199,
  [241] = 197,
  [242] = 196,
  [243] = 195,
  [244] = 206,
  [245] = 202,
  [246] = 206,
  [247] = 195,
  [248] = 206,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 82,
  [254] = 251,
  [255] = 249,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 251,
  [261] = 252,
  [262] = 250,
  [263] = 257,
  [264] = 258,
  [265] = 100,
  [266] = 252,
  [267] = 257,
  [268] = 268,
  [269] = 258,
  [270] = 250,
  [271] = 249,
  [272] = 272,
  [273] = 273,
  [274] = 273,
  [275] = 272,
  [276] = 272,
  [277] = 273,
  [278] = 278,
  [279] = 272,
  [280] = 273,
  [281] = 166,
  [282] = 272,
  [283] = 272,
  [284] = 278,
  [285] = 273,
  [286] = 272,
  [287] = 273,
  [288] = 273,
  [289] = 273,
  [290] = 278,
  [291] = 291,
  [292] = 272,
  [293] = 166,
  [294] = 166,
  [295] = 295,
  [296] = 259,
  [297] = 295,
  [298] = 298,
  [299] = 298,
  [300] = 300,
  [301] = 300,
  [302] = 302,
  [303] = 300,
  [304] = 304,
  [305] = 295,
  [306] = 295,
  [307] = 300,
  [308] = 298,
  [309] = 298,
  [310] = 295,
  [311] = 298,
  [312] = 312,
  [313] = 300,
  [314] = 300,
  [315] = 82,
  [316] = 316,
  [317] = 300,
  [318] = 298,
  [319] = 295,
  [320] = 300,
  [321] = 321,
  [322] = 300,
  [323] = 298,
  [324] = 295,
  [325] = 300,
  [326] = 298,
  [327] = 298,
  [328] = 295,
  [329] = 295,
  [330] = 256,
  [331] = 298,
  [332] = 295,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 100,
  [339] = 339,
  [340] = 100,
  [341] = 341,
  [342] = 100,
  [343] = 343,
  [344] = 337,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 337,
  [349] = 321,
  [350] = 337,
  [351] = 337,
  [352] = 352,
  [353] = 341,
  [354] = 259,
  [355] = 343,
  [356] = 356,
  [357] = 357,
  [358] = 352,
  [359] = 352,
  [360] = 360,
  [361] = 337,
  [362] = 362,
  [363] = 363,
  [364] = 334,
  [365] = 341,
  [366] = 337,
  [367] = 367,
  [368] = 256,
  [369] = 369,
  [370] = 334,
  [371] = 371,
  [372] = 343,
  [373] = 82,
  [374] = 259,
  [375] = 256,
  [376] = 337,
  [377] = 377,
  [378] = 82,
  [379] = 259,
  [380] = 256,
  [381] = 371,
  [382] = 82,
  [383] = 371,
  [384] = 82,
  [385] = 385,
  [386] = 337,
  [387] = 337,
  [388] = 388,
  [389] = 389,
  [390] = 389,
  [391] = 391,
  [392] = 259,
  [393] = 256,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 406,
  [408] = 406,
  [409] = 406,
  [410] = 406,
  [411] = 406,
  [412] = 406,
  [413] = 413,
  [414] = 406,
  [415] = 415,
  [416] = 413,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 406,
  [421] = 413,
  [422] = 405,
  [423] = 423,
  [424] = 398,
  [425] = 400,
  [426] = 401,
  [427] = 403,
  [428] = 417,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 413,
  [435] = 418,
  [436] = 436,
  [437] = 405,
  [438] = 398,
  [439] = 400,
  [440] = 433,
  [441] = 417,
  [442] = 401,
  [443] = 403,
  [444] = 444,
  [445] = 433,
  [446] = 418,
  [447] = 417,
  [448] = 433,
  [449] = 433,
  [450] = 405,
  [451] = 398,
  [452] = 452,
  [453] = 418,
  [454] = 431,
  [455] = 400,
  [456] = 401,
  [457] = 396,
  [458] = 403,
  [459] = 417,
  [460] = 418,
  [461] = 433,
  [462] = 403,
  [463] = 401,
  [464] = 464,
  [465] = 400,
  [466] = 431,
  [467] = 467,
  [468] = 398,
  [469] = 396,
  [470] = 397,
  [471] = 471,
  [472] = 418,
  [473] = 473,
  [474] = 405,
  [475] = 417,
  [476] = 476,
  [477] = 417,
  [478] = 89,
  [479] = 396,
  [480] = 405,
  [481] = 481,
  [482] = 467,
  [483] = 398,
  [484] = 82,
  [485] = 431,
  [486] = 400,
  [487] = 398,
  [488] = 400,
  [489] = 406,
  [490] = 401,
  [491] = 444,
  [492] = 401,
  [493] = 403,
  [494] = 397,
  [495] = 403,
  [496] = 418,
  [497] = 396,
  [498] = 433,
  [499] = 405,
  [500] = 500,
  [501] = 500,
  [502] = 405,
  [503] = 418,
  [504] = 398,
  [505] = 433,
  [506] = 418,
  [507] = 433,
  [508] = 433,
  [509] = 418,
  [510] = 403,
  [511] = 401,
  [512] = 400,
  [513] = 398,
  [514] = 400,
  [515] = 405,
  [516] = 401,
  [517] = 403,
  [518] = 417,
  [519] = 464,
  [520] = 417,
  [521] = 473,
  [522] = 397,
  [523] = 444,
  [524] = 471,
  [525] = 417,
  [526] = 405,
  [527] = 527,
  [528] = 398,
  [529] = 396,
  [530] = 400,
  [531] = 401,
  [532] = 431,
  [533] = 403,
  [534] = 431,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 544,
  [546] = 543,
  [547] = 547,
  [548] = 161,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 551,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 555,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 552,
  [572] = 162,
  [573] = 567,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 577,
  [582] = 580,
  [583] = 576,
  [584] = 584,
  [585] = 584,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 579,
  [593] = 593,
  [594] = 594,
  [595] = 578,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 584,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 580,
  [609] = 609,
  [610] = 610,
  [611] = 162,
  [612] = 600,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 579,
  [617] = 617,
  [618] = 603,
  [619] = 597,
  [620] = 161,
  [621] = 576,
  [622] = 603,
  [623] = 607,
  [624] = 600,
  [625] = 577,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 628,
  [630] = 584,
  [631] = 628,
  [632] = 579,
  [633] = 580,
  [634] = 580,
  [635] = 577,
  [636] = 628,
  [637] = 577,
  [638] = 584,
  [639] = 576,
  [640] = 579,
  [641] = 628,
  [642] = 642,
  [643] = 628,
  [644] = 576,
  [645] = 580,
  [646] = 646,
  [647] = 579,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 650,
  [657] = 657,
  [658] = 627,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 577,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 584,
  [673] = 642,
  [674] = 576,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 680,
  [682] = 680,
  [683] = 680,
  [684] = 680,
  [685] = 680,
  [686] = 680,
  [687] = 680,
  [688] = 680,
  [689] = 680,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 691,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 692,
  [701] = 692,
  [702] = 702,
  [703] = 699,
  [704] = 692,
  [705] = 692,
  [706] = 692,
  [707] = 691,
  [708] = 708,
  [709] = 695,
  [710] = 702,
  [711] = 694,
  [712] = 712,
  [713] = 692,
  [714] = 697,
  [715] = 693,
  [716] = 698,
  [717] = 690,
  [718] = 692,
  [719] = 690,
  [720] = 692,
  [721] = 690,
  [722] = 708,
  [723] = 702,
  [724] = 692,
  [725] = 690,
  [726] = 708,
  [727] = 699,
  [728] = 692,
  [729] = 692,
  [730] = 690,
  [731] = 690,
  [732] = 692,
  [733] = 697,
  [734] = 693,
  [735] = 690,
  [736] = 698,
  [737] = 691,
  [738] = 692,
  [739] = 691,
  [740] = 695,
  [741] = 694,
  [742] = 712,
  [743] = 697,
  [744] = 693,
  [745] = 745,
  [746] = 690,
  [747] = 698,
  [748] = 745,
  [749] = 692,
  [750] = 691,
  [751] = 695,
  [752] = 702,
  [753] = 694,
  [754] = 712,
  [755] = 697,
  [756] = 693,
  [757] = 698,
  [758] = 699,
  [759] = 745,
  [760] = 708,
  [761] = 708,
  [762] = 699,
  [763] = 692,
  [764] = 702,
  [765] = 745,
  [766] = 690,
  [767] = 708,
  [768] = 695,
  [769] = 695,
  [770] = 699,
  [771] = 694,
  [772] = 712,
  [773] = 708,
  [774] = 698,
  [775] = 693,
  [776] = 697,
  [777] = 712,
  [778] = 694,
  [779] = 695,
  [780] = 699,
  [781] = 708,
  [782] = 691,
  [783] = 697,
  [784] = 693,
  [785] = 698,
  [786] = 702,
  [787] = 787,
  [788] = 745,
  [789] = 691,
  [790] = 695,
  [791] = 691,
  [792] = 695,
  [793] = 694,
  [794] = 712,
  [795] = 697,
  [796] = 693,
  [797] = 698,
  [798] = 691,
  [799] = 695,
  [800] = 702,
  [801] = 702,
  [802] = 694,
  [803] = 712,
  [804] = 699,
  [805] = 697,
  [806] = 693,
  [807] = 698,
  [808] = 708,
  [809] = 690,
  [810] = 692,
  [811] = 694,
  [812] = 708,
  [813] = 698,
  [814] = 699,
  [815] = 712,
  [816] = 693,
  [817] = 699,
  [818] = 692,
  [819] = 712,
  [820] = 691,
  [821] = 695,
  [822] = 702,
  [823] = 694,
  [824] = 712,
  [825] = 697,
  [826] = 693,
  [827] = 698,
  [828] = 787,
  [829] = 697,
  [830] = 712,
  [831] = 694,
  [832] = 702,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 833,
  [838] = 835,
  [839] = 834,
  [840] = 835,
  [841] = 836,
  [842] = 834,
  [843] = 836,
  [844] = 833,
  [845] = 836,
  [846] = 846,
  [847] = 835,
  [848] = 836,
  [849] = 849,
  [850] = 836,
  [851] = 851,
  [852] = 836,
  [853] = 834,
  [854] = 854,
  [855] = 833,
  [856] = 856,
  [857] = 849,
  [858] = 858,
  [859] = 836,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 835,
  [864] = 835,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 833,
  [871] = 866,
  [872] = 846,
  [873] = 873,
  [874] = 874,
  [875] = 834,
  [876] = 854,
  [877] = 877,
  [878] = 833,
  [879] = 877,
  [880] = 834,
  [881] = 874,
  [882] = 834,
  [883] = 854,
  [884] = 856,
  [885] = 856,
  [886] = 849,
  [887] = 877,
  [888] = 865,
  [889] = 867,
  [890] = 868,
  [891] = 851,
  [892] = 866,
  [893] = 835,
  [894] = 851,
  [895] = 833,
  [896] = 846,
  [897] = 865,
  [898] = 867,
  [899] = 868,
  [900] = 874,
  [901] = 873,
  [902] = 873,
  [903] = 856,
  [904] = 904,
  [905] = 851,
  [906] = 866,
  [907] = 868,
  [908] = 867,
  [909] = 865,
  [910] = 849,
  [911] = 856,
  [912] = 846,
  [913] = 851,
  [914] = 868,
  [915] = 565,
  [916] = 916,
  [917] = 867,
  [918] = 564,
  [919] = 563,
  [920] = 561,
  [921] = 860,
  [922] = 559,
  [923] = 547,
  [924] = 543,
  [925] = 865,
  [926] = 550,
  [927] = 849,
  [928] = 544,
  [929] = 858,
  [930] = 542,
  [931] = 570,
  [932] = 877,
  [933] = 569,
  [934] = 858,
  [935] = 935,
  [936] = 936,
  [937] = 861,
  [938] = 938,
  [939] = 862,
  [940] = 940,
  [941] = 869,
  [942] = 873,
  [943] = 874,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 854,
  [948] = 846,
  [949] = 861,
  [950] = 851,
  [951] = 862,
  [952] = 874,
  [953] = 873,
  [954] = 954,
  [955] = 955,
  [956] = 874,
  [957] = 869,
  [958] = 846,
  [959] = 959,
  [960] = 916,
  [961] = 873,
  [962] = 962,
  [963] = 856,
  [964] = 849,
  [965] = 865,
  [966] = 867,
  [967] = 868,
  [968] = 968,
  [969] = 868,
  [970] = 866,
  [971] = 851,
  [972] = 846,
  [973] = 973,
  [974] = 974,
  [975] = 833,
  [976] = 976,
  [977] = 977,
  [978] = 854,
  [979] = 979,
  [980] = 980,
  [981] = 867,
  [982] = 865,
  [983] = 866,
  [984] = 984,
  [985] = 849,
  [986] = 986,
  [987] = 987,
  [988] = 835,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 856,
  [993] = 993,
  [994] = 994,
  [995] = 874,
  [996] = 873,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 877,
  [1001] = 1001,
  [1002] = 854,
  [1003] = 866,
  [1004] = 877,
  [1005] = 556,
  [1006] = 877,
  [1007] = 854,
  [1008] = 860,
  [1009] = 1009,
  [1010] = 836,
  [1011] = 836,
  [1012] = 834,
  [1013] = 869,
  [1014] = 977,
  [1015] = 1009,
  [1016] = 874,
  [1017] = 873,
  [1018] = 866,
  [1019] = 551,
  [1020] = 547,
  [1021] = 938,
  [1022] = 552,
  [1023] = 940,
  [1024] = 979,
  [1025] = 977,
  [1026] = 976,
  [1027] = 556,
  [1028] = 564,
  [1029] = 959,
  [1030] = 565,
  [1031] = 936,
  [1032] = 962,
  [1033] = 904,
  [1034] = 869,
  [1035] = 935,
  [1036] = 856,
  [1037] = 862,
  [1038] = 861,
  [1039] = 849,
  [1040] = 865,
  [1041] = 867,
  [1042] = 868,
  [1043] = 851,
  [1044] = 846,
  [1045] = 563,
  [1046] = 858,
  [1047] = 854,
  [1048] = 877,
  [1049] = 561,
  [1050] = 559,
  [1051] = 570,
  [1052] = 991,
  [1053] = 968,
  [1054] = 973,
  [1055] = 1001,
  [1056] = 954,
  [1057] = 974,
  [1058] = 556,
  [1059] = 569,
  [1060] = 569,
  [1061] = 570,
  [1062] = 946,
  [1063] = 999,
  [1064] = 998,
  [1065] = 997,
  [1066] = 567,
  [1067] = 555,
  [1068] = 990,
  [1069] = 916,
  [1070] = 869,
  [1071] = 860,
  [1072] = 862,
  [1073] = 861,
  [1074] = 858,
  [1075] = 987,
  [1076] = 858,
  [1077] = 861,
  [1078] = 862,
  [1079] = 869,
  [1080] = 543,
  [1081] = 986,
  [1082] = 544,
  [1083] = 542,
  [1084] = 856,
  [1085] = 849,
  [1086] = 865,
  [1087] = 860,
  [1088] = 867,
  [1089] = 868,
  [1090] = 851,
  [1091] = 846,
  [1092] = 989,
  [1093] = 994,
  [1094] = 860,
  [1095] = 979,
  [1096] = 877,
  [1097] = 854,
  [1098] = 976,
  [1099] = 836,
  [1100] = 861,
  [1101] = 862,
  [1102] = 993,
  [1103] = 874,
  [1104] = 873,
  [1105] = 866,
  [1106] = 980,
  [1107] = 860,
  [1108] = 858,
  [1109] = 836,
  [1110] = 935,
  [1111] = 936,
  [1112] = 565,
  [1113] = 550,
  [1114] = 564,
  [1115] = 938,
  [1116] = 940,
  [1117] = 563,
  [1118] = 561,
  [1119] = 559,
  [1120] = 946,
  [1121] = 954,
  [1122] = 904,
  [1123] = 547,
  [1124] = 959,
  [1125] = 962,
  [1126] = 968,
  [1127] = 973,
  [1128] = 974,
  [1129] = 916,
  [1130] = 550,
  [1131] = 984,
  [1132] = 986,
  [1133] = 987,
  [1134] = 989,
  [1135] = 990,
  [1136] = 991,
  [1137] = 542,
  [1138] = 544,
  [1139] = 543,
  [1140] = 1009,
  [1141] = 1001,
  [1142] = 556,
  [1143] = 999,
  [1144] = 998,
  [1145] = 984,
  [1146] = 997,
  [1147] = 994,
  [1148] = 836,
  [1149] = 993,
  [1150] = 980,
  [1151] = 547,
  [1152] = 565,
  [1153] = 564,
  [1154] = 563,
  [1155] = 561,
  [1156] = 559,
  [1157] = 550,
  [1158] = 987,
  [1159] = 565,
  [1160] = 560,
  [1161] = 550,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 860,
  [1165] = 1009,
  [1166] = 1001,
  [1167] = 940,
  [1168] = 547,
  [1169] = 991,
  [1170] = 984,
  [1171] = 556,
  [1172] = 569,
  [1173] = 946,
  [1174] = 569,
  [1175] = 570,
  [1176] = 858,
  [1177] = 570,
  [1178] = 990,
  [1179] = 940,
  [1180] = 938,
  [1181] = 1181,
  [1182] = 989,
  [1183] = 987,
  [1184] = 559,
  [1185] = 561,
  [1186] = 563,
  [1187] = 567,
  [1188] = 555,
  [1189] = 954,
  [1190] = 904,
  [1191] = 936,
  [1192] = 935,
  [1193] = 986,
  [1194] = 552,
  [1195] = 551,
  [1196] = 935,
  [1197] = 556,
  [1198] = 980,
  [1199] = 936,
  [1200] = 999,
  [1201] = 938,
  [1202] = 940,
  [1203] = 998,
  [1204] = 946,
  [1205] = 564,
  [1206] = 565,
  [1207] = 991,
  [1208] = 954,
  [1209] = 993,
  [1210] = 994,
  [1211] = 904,
  [1212] = 990,
  [1213] = 954,
  [1214] = 980,
  [1215] = 959,
  [1216] = 904,
  [1217] = 547,
  [1218] = 962,
  [1219] = 997,
  [1220] = 959,
  [1221] = 559,
  [1222] = 998,
  [1223] = 999,
  [1224] = 968,
  [1225] = 962,
  [1226] = 968,
  [1227] = 973,
  [1228] = 973,
  [1229] = 974,
  [1230] = 567,
  [1231] = 555,
  [1232] = 974,
  [1233] = 989,
  [1234] = 987,
  [1235] = 563,
  [1236] = 984,
  [1237] = 556,
  [1238] = 1001,
  [1239] = 993,
  [1240] = 994,
  [1241] = 836,
  [1242] = 997,
  [1243] = 959,
  [1244] = 962,
  [1245] = 556,
  [1246] = 968,
  [1247] = 973,
  [1248] = 1009,
  [1249] = 974,
  [1250] = 997,
  [1251] = 986,
  [1252] = 935,
  [1253] = 936,
  [1254] = 987,
  [1255] = 989,
  [1256] = 565,
  [1257] = 990,
  [1258] = 991,
  [1259] = 561,
  [1260] = 551,
  [1261] = 552,
  [1262] = 552,
  [1263] = 551,
  [1264] = 998,
  [1265] = 999,
  [1266] = 570,
  [1267] = 1009,
  [1268] = 569,
  [1269] = 1269,
  [1270] = 1001,
  [1271] = 994,
  [1272] = 993,
  [1273] = 984,
  [1274] = 944,
  [1275] = 1001,
  [1276] = 556,
  [1277] = 999,
  [1278] = 998,
  [1279] = 997,
  [1280] = 1009,
  [1281] = 945,
  [1282] = 994,
  [1283] = 993,
  [1284] = 861,
  [1285] = 862,
  [1286] = 564,
  [1287] = 980,
  [1288] = 955,
  [1289] = 869,
  [1290] = 986,
  [1291] = 991,
  [1292] = 990,
  [1293] = 989,
  [1294] = 569,
  [1295] = 570,
  [1296] = 560,
  [1297] = 556,
  [1298] = 986,
  [1299] = 980,
  [1300] = 935,
  [1301] = 555,
  [1302] = 567,
  [1303] = 936,
  [1304] = 938,
  [1305] = 564,
  [1306] = 984,
  [1307] = 938,
  [1308] = 940,
  [1309] = 550,
  [1310] = 550,
  [1311] = 946,
  [1312] = 563,
  [1313] = 561,
  [1314] = 559,
  [1315] = 946,
  [1316] = 974,
  [1317] = 973,
  [1318] = 968,
  [1319] = 954,
  [1320] = 904,
  [1321] = 962,
  [1322] = 959,
  [1323] = 547,
  [1324] = 976,
  [1325] = 940,
  [1326] = 877,
  [1327] = 873,
  [1328] = 984,
  [1329] = 854,
  [1330] = 874,
  [1331] = 547,
  [1332] = 935,
  [1333] = 936,
  [1334] = 550,
  [1335] = 986,
  [1336] = 866,
  [1337] = 559,
  [1338] = 987,
  [1339] = 989,
  [1340] = 990,
  [1341] = 561,
  [1342] = 563,
  [1343] = 991,
  [1344] = 976,
  [1345] = 977,
  [1346] = 979,
  [1347] = 938,
  [1348] = 564,
  [1349] = 565,
  [1350] = 1009,
  [1351] = 974,
  [1352] = 560,
  [1353] = 977,
  [1354] = 973,
  [1355] = 979,
  [1356] = 968,
  [1357] = 962,
  [1358] = 959,
  [1359] = 856,
  [1360] = 979,
  [1361] = 849,
  [1362] = 851,
  [1363] = 904,
  [1364] = 980,
  [1365] = 954,
  [1366] = 1001,
  [1367] = 977,
  [1368] = 976,
  [1369] = 999,
  [1370] = 865,
  [1371] = 998,
  [1372] = 569,
  [1373] = 867,
  [1374] = 997,
  [1375] = 846,
  [1376] = 993,
  [1377] = 560,
  [1378] = 570,
  [1379] = 556,
  [1380] = 946,
  [1381] = 868,
  [1382] = 994,
  [1383] = 1162,
  [1384] = 556,
  [1385] = 1163,
  [1386] = 556,
  [1387] = 556,
  [1388] = 547,
  [1389] = 559,
  [1390] = 561,
  [1391] = 563,
  [1392] = 556,
  [1393] = 570,
  [1394] = 567,
  [1395] = 564,
  [1396] = 552,
  [1397] = 565,
  [1398] = 550,
  [1399] = 569,
  [1400] = 555,
  [1401] = 551,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1403,
  [1405] = 567,
  [1406] = 1402,
  [1407] = 1162,
  [1408] = 551,
  [1409] = 1163,
  [1410] = 555,
  [1411] = 552,
  [1412] = 1403,
  [1413] = 1403,
  [1414] = 1402,
  [1415] = 1402,
  [1416] = 1402,
  [1417] = 1403,
  [1418] = 1403,
  [1419] = 1402,
  [1420] = 1403,
  [1421] = 1421,
  [1422] = 1403,
  [1423] = 556,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1402,
  [1427] = 1403,
  [1428] = 1428,
  [1429] = 1402,
  [1430] = 1430,
  [1431] = 569,
  [1432] = 1402,
  [1433] = 570,
  [1434] = 854,
  [1435] = 1435,
  [1436] = 555,
  [1437] = 1162,
  [1438] = 1435,
  [1439] = 567,
  [1440] = 570,
  [1441] = 555,
  [1442] = 551,
  [1443] = 552,
  [1444] = 1444,
  [1445] = 569,
  [1446] = 552,
  [1447] = 551,
  [1448] = 1435,
  [1449] = 849,
  [1450] = 1450,
  [1451] = 567,
  [1452] = 1428,
  [1453] = 867,
  [1454] = 868,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 551,
  [1458] = 555,
  [1459] = 1163,
  [1460] = 567,
  [1461] = 851,
  [1462] = 846,
  [1463] = 552,
  [1464] = 1435,
  [1465] = 1435,
  [1466] = 1421,
  [1467] = 556,
  [1468] = 1435,
  [1469] = 1162,
  [1470] = 1163,
  [1471] = 1435,
  [1472] = 865,
  [1473] = 1425,
  [1474] = 1435,
  [1475] = 1435,
  [1476] = 877,
  [1477] = 1435,
  [1478] = 1478,
  [1479] = 1163,
  [1480] = 856,
  [1481] = 1162,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1484,
  [1486] = 1482,
  [1487] = 1482,
  [1488] = 1482,
  [1489] = 1489,
  [1490] = 1482,
  [1491] = 1484,
  [1492] = 1482,
  [1493] = 1444,
  [1494] = 1482,
  [1495] = 1482,
  [1496] = 1478,
  [1497] = 1430,
  [1498] = 1482,
  [1499] = 1499,
  [1500] = 1456,
  [1501] = 1455,
  [1502] = 1483,
  [1503] = 1503,
  [1504] = 1424,
  [1505] = 1482,
  [1506] = 1402,
  [1507] = 1403,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1510,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1511,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1518,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1528,
  [1530] = 1528,
  [1531] = 1528,
  [1532] = 1528,
  [1533] = 1533,
  [1534] = 1528,
  [1535] = 1528,
  [1536] = 1528,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1538,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1539,
  [1544] = 1539,
  [1545] = 1539,
  [1546] = 1538,
  [1547] = 1541,
  [1548] = 1538,
  [1549] = 1541,
  [1550] = 1550,
  [1551] = 1539,
  [1552] = 1552,
  [1553] = 1541,
  [1554] = 1538,
  [1555] = 1538,
  [1556] = 1538,
  [1557] = 1557,
  [1558] = 1541,
  [1559] = 1539,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1539,
  [1565] = 1538,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1541,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1541,
  [1575] = 1539,
  [1576] = 1576,
  [1577] = 1541,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1533,
  [1582] = 1527,
  [1583] = 1550,
  [1584] = 1578,
  [1585] = 1537,
  [1586] = 1580,
  [1587] = 1578,
  [1588] = 1578,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1580,
  [1592] = 1527,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1562,
  [1596] = 1580,
  [1597] = 1578,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1578,
  [1601] = 1598,
  [1602] = 1602,
  [1603] = 1580,
  [1604] = 1537,
  [1605] = 1580,
  [1606] = 1576,
  [1607] = 1569,
  [1608] = 1608,
  [1609] = 1578,
  [1610] = 1580,
  [1611] = 1571,
  [1612] = 1578,
  [1613] = 1613,
  [1614] = 1580,
  [1615] = 1580,
  [1616] = 1566,
  [1617] = 1533,
  [1618] = 1578,
  [1619] = 1537,
  [1620] = 1527,
  [1621] = 1569,
  [1622] = 1562,
  [1623] = 1566,
  [1624] = 1624,
  [1625] = 1533,
  [1626] = 1576,
  [1627] = 1571,
  [1628] = 1576,
  [1629] = 1537,
  [1630] = 1527,
  [1631] = 1537,
  [1632] = 1576,
  [1633] = 1571,
  [1634] = 1533,
  [1635] = 1527,
  [1636] = 1566,
  [1637] = 1569,
  [1638] = 1566,
  [1639] = 1550,
  [1640] = 1562,
  [1641] = 1641,
  [1642] = 1550,
  [1643] = 1569,
  [1644] = 1550,
  [1645] = 1562,
  [1646] = 1598,
  [1647] = 1647,
  [1648] = 1571,
  [1649] = 1550,
  [1650] = 1598,
  [1651] = 1533,
  [1652] = 1652,
  [1653] = 1576,
  [1654] = 1566,
  [1655] = 1571,
  [1656] = 1569,
  [1657] = 1562,
  [1658] = 1569,
  [1659] = 1569,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1576,
  [1663] = 1661,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1525,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1666,
  [1671] = 1527,
  [1672] = 1571,
  [1673] = 1525,
  [1674] = 1550,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1562,
  [1678] = 1562,
  [1679] = 1679,
  [1680] = 1522,
  [1681] = 1576,
  [1682] = 1675,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1675,
  [1686] = 1566,
  [1687] = 1675,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1666,
  [1692] = 1576,
  [1693] = 1675,
  [1694] = 1522,
  [1695] = 1695,
  [1696] = 1661,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 1675,
  [1700] = 1675,
  [1701] = 1571,
  [1702] = 1675,
  [1703] = 1695,
  [1704] = 1668,
  [1705] = 1705,
  [1706] = 1593,
  [1707] = 1647,
  [1708] = 1550,
  [1709] = 1537,
  [1710] = 1527,
  [1711] = 1562,
  [1712] = 1533,
  [1713] = 1550,
  [1714] = 1684,
  [1715] = 1537,
  [1716] = 1566,
  [1717] = 1717,
  [1718] = 1533,
  [1719] = 1675,
  [1720] = 1566,
  [1721] = 1668,
  [1722] = 1569,
  [1723] = 1571,
  [1724] = 1675,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1593,
  [1728] = 1525,
  [1729] = 1726,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1730,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1726,
  [1740] = 1730,
  [1741] = 1726,
  [1742] = 1737,
  [1743] = 1726,
  [1744] = 1522,
  [1745] = 1745,
  [1746] = 1745,
  [1747] = 1726,
  [1748] = 1748,
  [1749] = 1593,
  [1750] = 1513,
  [1751] = 1735,
  [1752] = 1737,
  [1753] = 1753,
  [1754] = 1698,
  [1755] = 1755,
  [1756] = 1726,
  [1757] = 1757,
  [1758] = 1745,
  [1759] = 1726,
  [1760] = 1760,
  [1761] = 1647,
  [1762] = 1735,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1624,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1647,
  [1772] = 1772,
  [1773] = 1772,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1424,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1765,
  [1780] = 1780,
  [1781] = 1683,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1766,
  [1787] = 1780,
  [1788] = 1647,
  [1789] = 1774,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1790,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1770,
  [1799] = 1799,
  [1800] = 1772,
  [1801] = 1801,
  [1802] = 1792,
  [1803] = 1766,
  [1804] = 1804,
  [1805] = 1509,
  [1806] = 1806,
  [1807] = 1430,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1764,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1647,
  [1816] = 1795,
  [1817] = 1817,
  [1818] = 1796,
  [1819] = 1624,
  [1820] = 1820,
  [1821] = 1799,
  [1822] = 1808,
  [1823] = 1823,
  [1824] = 1780,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1766,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1767,
  [1833] = 1833,
  [1834] = 1826,
  [1835] = 1799,
  [1836] = 1774,
  [1837] = 1624,
  [1838] = 1838,
  [1839] = 1810,
  [1840] = 1521,
  [1841] = 1770,
  [1842] = 1775,
  [1843] = 1784,
  [1844] = 1826,
  [1845] = 1845,
  [1846] = 1838,
  [1847] = 1847,
  [1848] = 1823,
  [1849] = 1764,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1838,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1562,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1550,
  [1860] = 1767,
  [1861] = 1861,
  [1862] = 1765,
  [1863] = 1863,
  [1864] = 1857,
  [1865] = 1455,
  [1866] = 1866,
  [1867] = 1861,
  [1868] = 1858,
  [1869] = 1869,
  [1870] = 1767,
  [1871] = 1871,
  [1872] = 1813,
  [1873] = 1784,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1861,
  [1877] = 1478,
  [1878] = 1845,
  [1879] = 1801,
  [1880] = 1869,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1863,
  [1885] = 1808,
  [1886] = 1886,
  [1887] = 1857,
  [1888] = 1857,
  [1889] = 1889,
  [1890] = 1456,
  [1891] = 1783,
  [1892] = 1892,
  [1893] = 1796,
  [1894] = 1525,
  [1895] = 1804,
  [1896] = 1795,
  [1897] = 1795,
  [1898] = 1898,
  [1899] = 1698,
  [1900] = 1900,
  [1901] = 1898,
  [1902] = 1796,
  [1903] = 1566,
  [1904] = 1904,
  [1905] = 1569,
  [1906] = 1806,
  [1907] = 1571,
  [1908] = 1808,
  [1909] = 1909,
  [1910] = 1576,
  [1911] = 1898,
  [1912] = 1857,
  [1913] = 1784,
  [1914] = 1914,
  [1915] = 1810,
  [1916] = 1916,
  [1917] = 1838,
  [1918] = 1918,
  [1919] = 1522,
  [1920] = 1523,
  [1921] = 1898,
  [1922] = 1857,
  [1923] = 1923,
  [1924] = 1857,
  [1925] = 1857,
  [1926] = 1869,
  [1927] = 1863,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1810,
  [1933] = 1933,
  [1934] = 1904,
  [1935] = 1765,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1444,
  [1940] = 1940,
  [1941] = 1857,
  [1942] = 1857,
  [1943] = 1943,
  [1944] = 1517,
  [1945] = 1945,
  [1946] = 1519,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1923,
  [1961] = 1961,
  [1962] = 1947,
  [1963] = 1855,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1965,
  [1967] = 1858,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1970,
  [1971] = 1916,
  [1972] = 1972,
  [1973] = 1845,
  [1974] = 1892,
  [1975] = 1526,
  [1976] = 1852,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1909,
  [1982] = 1982,
  [1983] = 1801,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1986,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1778,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1986,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1997,
  [1998] = 1956,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 1943,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 1813,
  [2006] = 2006,
  [2007] = 1831,
  [2008] = 1830,
  [2009] = 2009,
  [2010] = 1827,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 1984,
  [2014] = 1950,
  [2015] = 1783,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 1794,
  [2020] = 1777,
  [2021] = 1829,
  [2022] = 1845,
  [2023] = 2023,
  [2024] = 1424,
  [2025] = 2025,
  [2026] = 1801,
  [2027] = 1430,
  [2028] = 1424,
  [2029] = 2017,
  [2030] = 2018,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2034,
  [2035] = 576,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2009,
  [2039] = 2003,
  [2040] = 2002,
  [2041] = 2004,
  [2042] = 2042,
  [2043] = 1845,
  [2044] = 2044,
  [2045] = 1995,
  [2046] = 1992,
  [2047] = 2047,
  [2048] = 577,
  [2049] = 1986,
  [2050] = 1979,
  [2051] = 1806,
  [2052] = 2009,
  [2053] = 2003,
  [2054] = 2002,
  [2055] = 2055,
  [2056] = 1996,
  [2057] = 1992,
  [2058] = 2036,
  [2059] = 1992,
  [2060] = 1698,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 1444,
  [2064] = 2009,
  [2065] = 2065,
  [2066] = 2055,
  [2067] = 2061,
  [2068] = 2006,
  [2069] = 2069,
  [2070] = 2004,
  [2071] = 2003,
  [2072] = 2002,
  [2073] = 1996,
  [2074] = 2047,
  [2075] = 2044,
  [2076] = 2002,
  [2077] = 1995,
  [2078] = 1986,
  [2079] = 1992,
  [2080] = 1988,
  [2081] = 2032,
  [2082] = 1988,
  [2083] = 1833,
  [2084] = 1801,
  [2085] = 1992,
  [2086] = 1568,
  [2087] = 1563,
  [2088] = 1986,
  [2089] = 1995,
  [2090] = 2055,
  [2091] = 1996,
  [2092] = 2092,
  [2093] = 2061,
  [2094] = 584,
  [2095] = 2003,
  [2096] = 2062,
  [2097] = 2097,
  [2098] = 2002,
  [2099] = 2003,
  [2100] = 1424,
  [2101] = 2004,
  [2102] = 2102,
  [2103] = 2006,
  [2104] = 580,
  [2105] = 579,
  [2106] = 2009,
  [2107] = 2097,
  [2108] = 2108,
  [2109] = 2009,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2006,
  [2114] = 2047,
  [2115] = 2004,
  [2116] = 2044,
  [2117] = 2003,
  [2118] = 1985,
  [2119] = 2025,
  [2120] = 2002,
  [2121] = 2110,
  [2122] = 1996,
  [2123] = 1801,
  [2124] = 1995,
  [2125] = 2125,
  [2126] = 1986,
  [2127] = 2016,
  [2128] = 1992,
  [2129] = 1845,
  [2130] = 1988,
  [2131] = 2131,
  [2132] = 1525,
  [2133] = 2016,
  [2134] = 2134,
  [2135] = 2112,
  [2136] = 2055,
  [2137] = 2137,
  [2138] = 1522,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2061,
  [2143] = 1567,
  [2144] = 2061,
  [2145] = 1560,
  [2146] = 2146,
  [2147] = 2108,
  [2148] = 2009,
  [2149] = 2055,
  [2150] = 2006,
  [2151] = 2004,
  [2152] = 860,
  [2153] = 2153,
  [2154] = 2003,
  [2155] = 2002,
  [2156] = 2156,
  [2157] = 1996,
  [2158] = 1995,
  [2159] = 1986,
  [2160] = 1988,
  [2161] = 1996,
  [2162] = 1992,
  [2163] = 2111,
  [2164] = 2018,
  [2165] = 1992,
  [2166] = 2025,
  [2167] = 1988,
  [2168] = 1999,
  [2169] = 1995,
  [2170] = 2055,
  [2171] = 1996,
  [2172] = 1572,
  [2173] = 2061,
  [2174] = 1524,
  [2175] = 1988,
  [2176] = 858,
  [2177] = 2002,
  [2178] = 2003,
  [2179] = 2031,
  [2180] = 2004,
  [2181] = 2055,
  [2182] = 2006,
  [2183] = 2012,
  [2184] = 2032,
  [2185] = 2009,
  [2186] = 2009,
  [2187] = 2006,
  [2188] = 2004,
  [2189] = 2003,
  [2190] = 2002,
  [2191] = 1995,
  [2192] = 2061,
  [2193] = 1991,
  [2194] = 1999,
  [2195] = 2025,
  [2196] = 2006,
  [2197] = 2017,
  [2198] = 1993,
  [2199] = 2061,
  [2200] = 2200,
  [2201] = 2000,
  [2202] = 1992,
  [2203] = 1996,
  [2204] = 2055,
  [2205] = 2205,
  [2206] = 1988,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2208,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 1455,
  [2220] = 2141,
  [2221] = 2221,
  [2222] = 2140,
  [2223] = 1892,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 580,
  [2227] = 1579,
  [2228] = 1478,
  [2229] = 2229,
  [2230] = 2211,
  [2231] = 577,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2218,
  [2239] = 2216,
  [2240] = 2240,
  [2241] = 2208,
  [2242] = 2242,
  [2243] = 2213,
  [2244] = 2244,
  [2245] = 1456,
  [2246] = 2246,
  [2247] = 579,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2216,
  [2251] = 2235,
  [2252] = 1599,
  [2253] = 1455,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2208,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2208,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 584,
  [2268] = 2268,
  [2269] = 671,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2249,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 576,
  [2276] = 2276,
  [2277] = 2237,
  [2278] = 1444,
  [2279] = 663,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2212,
  [2285] = 2213,
  [2286] = 1914,
  [2287] = 2287,
  [2288] = 2235,
  [2289] = 1589,
  [2290] = 657,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 1456,
  [2295] = 2254,
  [2296] = 2208,
  [2297] = 2297,
  [2298] = 2146,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2218,
  [2307] = 1914,
  [2308] = 2299,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 670,
  [2316] = 2303,
  [2317] = 2317,
  [2318] = 1579,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 1914,
  [2322] = 1478,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2326,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2329,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2326,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2339,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2328,
  [2346] = 2346,
  [2347] = 2331,
  [2348] = 2326,
  [2349] = 2349,
  [2350] = 2332,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2344,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2333,
  [2357] = 2335,
  [2358] = 2358,
  [2359] = 2331,
  [2360] = 2360,
  [2361] = 2335,
  [2362] = 2362,
  [2363] = 2336,
  [2364] = 2364,
  [2365] = 2337,
  [2366] = 2340,
  [2367] = 2367,
  [2368] = 2339,
  [2369] = 579,
  [2370] = 2358,
  [2371] = 2344,
  [2372] = 2349,
  [2373] = 2373,
  [2374] = 2346,
  [2375] = 2375,
  [2376] = 2355,
  [2377] = 2326,
  [2378] = 2349,
  [2379] = 2329,
  [2380] = 2328,
  [2381] = 2331,
  [2382] = 2344,
  [2383] = 2332,
  [2384] = 2333,
  [2385] = 2385,
  [2386] = 2326,
  [2387] = 2335,
  [2388] = 2349,
  [2389] = 2336,
  [2390] = 2337,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2340,
  [2394] = 2339,
  [2395] = 2339,
  [2396] = 2355,
  [2397] = 2344,
  [2398] = 2328,
  [2399] = 2328,
  [2400] = 2344,
  [2401] = 2340,
  [2402] = 2349,
  [2403] = 2329,
  [2404] = 2339,
  [2405] = 2405,
  [2406] = 2340,
  [2407] = 2385,
  [2408] = 2346,
  [2409] = 2336,
  [2410] = 2337,
  [2411] = 2411,
  [2412] = 2337,
  [2413] = 2336,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2335,
  [2417] = 2333,
  [2418] = 2336,
  [2419] = 2335,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2332,
  [2423] = 2344,
  [2424] = 576,
  [2425] = 2331,
  [2426] = 2333,
  [2427] = 2326,
  [2428] = 2329,
  [2429] = 2335,
  [2430] = 2336,
  [2431] = 2337,
  [2432] = 2432,
  [2433] = 2332,
  [2434] = 2434,
  [2435] = 2332,
  [2436] = 2349,
  [2437] = 2333,
  [2438] = 2385,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2331,
  [2442] = 2325,
  [2443] = 2335,
  [2444] = 2336,
  [2445] = 2329,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 2326,
  [2449] = 2337,
  [2450] = 2326,
  [2451] = 2335,
  [2452] = 2336,
  [2453] = 2337,
  [2454] = 2340,
  [2455] = 2337,
  [2456] = 2333,
  [2457] = 2346,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2346,
  [2462] = 2462,
  [2463] = 2358,
  [2464] = 2340,
  [2465] = 2439,
  [2466] = 2466,
  [2467] = 584,
  [2468] = 2339,
  [2469] = 2469,
  [2470] = 2439,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2332,
  [2474] = 2325,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2331,
  [2480] = 2328,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 577,
  [2484] = 2392,
  [2485] = 2362,
  [2486] = 2325,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2349,
  [2490] = 2476,
  [2491] = 2478,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2355,
  [2495] = 2328,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2375,
  [2499] = 580,
  [2500] = 2344,
  [2501] = 2488,
  [2502] = 2362,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2339,
  [2506] = 2392,
  [2507] = 2507,
  [2508] = 2340,
  [2509] = 2487,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2476,
  [2513] = 2337,
  [2514] = 2336,
  [2515] = 2335,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 2333,
  [2522] = 2332,
  [2523] = 2481,
  [2524] = 2524,
  [2525] = 2358,
  [2526] = 2526,
  [2527] = 2331,
  [2528] = 2528,
  [2529] = 2329,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2326,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2325,
  [2537] = 2535,
  [2538] = 2520,
  [2539] = 2539,
  [2540] = 2329,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2385,
  [2544] = 2349,
  [2545] = 2545,
  [2546] = 2346,
  [2547] = 2487,
  [2548] = 2355,
  [2549] = 2549,
  [2550] = 2328,
  [2551] = 2551,
  [2552] = 2482,
  [2553] = 2460,
  [2554] = 2460,
};

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < 'f'
    ? (c < '\''
      ? (c < '"'
        ? c == '\n'
        : c <= '"')
      : (c <= '\'' || (c < 'a'
        ? c == '\\'
        : c <= 'b')))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static inline bool sym_python_identifier_character_set_1(int32_t c) {
  return (c < 43520
    ? (c < 4206
      ? (c < 2738
        ? (c < 2042
          ? (c < 1162
            ? (c < 880
              ? (c < 248
                ? (c < 186
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))
                : (c <= 705 || (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || c == 750))))
              : (c <= 884 || (c < 904
                ? (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 931
                  ? (c < 910
                    ? c == 908
                    : c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))))))
            : (c <= 1327 || (c < 1765
              ? (c < 1519
                ? (c < 1376
                  ? (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)
                  : (c <= 1416 || (c >= 1488 && c <= 1514)))
                : (c <= 1522 || (c < 1649
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1610)
                    : c <= 1647)
                  : (c <= 1747 || c == 1749))))
              : (c <= 1766 || (c < 1810
                ? (c < 1791
                  ? (c < 1786
                    ? (c >= 1774 && c <= 1775)
                    : c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1994
                  ? (c < 1969
                    ? (c >= 1869 && c <= 1957)
                    : c <= 1969)
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))))))))
          : (c <= 2042 || (c < 2493
            ? (c < 2365
              ? (c < 2144
                ? (c < 2084
                  ? (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)
                  : (c <= 2084 || (c < 2112
                    ? c == 2088
                    : c <= 2136)))
                : (c <= 2154 || (c < 2208
                  ? (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)
                  : (c <= 2249 || (c >= 2308 && c <= 2361)))))
              : (c <= 2365 || (c < 2447
                ? (c < 2417
                  ? (c < 2392
                    ? c == 2384
                    : c <= 2401)
                  : (c <= 2432 || (c >= 2437 && c <= 2444)))
                : (c <= 2448 || (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))))))
            : (c <= 2493 || (c < 2610
              ? (c < 2556
                ? (c < 2527
                  ? (c < 2524
                    ? c == 2510
                    : c <= 2525)
                  : (c <= 2529 || (c >= 2544 && c <= 2545)))
                : (c <= 2556 || (c < 2579
                  ? (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)
                  : (c <= 2600 || (c >= 2602 && c <= 2608)))))
              : (c <= 2611 || (c < 2674
                ? (c < 2649
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2652 || c == 2654))
                : (c <= 2676 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))))))))))
        : (c <= 2739 || (c < 3261
          ? (c < 2972
            ? (c < 2869
              ? (c < 2821
                ? (c < 2768
                  ? (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)
                  : (c <= 2768 || (c < 2809
                    ? (c >= 2784 && c <= 2785)
                    : c <= 2809)))
                : (c <= 2828 || (c < 2858
                  ? (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)
                  : (c <= 2864 || (c >= 2866 && c <= 2867)))))
              : (c <= 2873 || (c < 2947
                ? (c < 2911
                  ? (c < 2908
                    ? c == 2877
                    : c <= 2909)
                  : (c <= 2913 || c == 2929))
                : (c <= 2947 || (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c >= 2969 && c <= 2970)))))))
            : (c <= 2972 || (c < 3133
              ? (c < 3024
                ? (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3090
                  ? (c < 3086
                    ? (c >= 3077 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c >= 3114 && c <= 3129)))))
              : (c <= 3133 || (c < 3205
                ? (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3169 || c == 3200))
                : (c <= 3212 || (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))))))))
          : (c <= 3261 || (c < 3716
            ? (c < 3450
              ? (c < 3346
                ? (c < 3313
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3332 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3386 || (c < 3412
                  ? (c < 3406
                    ? c == 3389
                    : c <= 3406)
                  : (c <= 3414 || (c >= 3423 && c <= 3425)))))
              : (c <= 3455 || (c < 3520
                ? (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || c == 3517))
                : (c <= 3526 || (c < 3648
                  ? (c < 3634
                    ? (c >= 3585 && c <= 3632)
                    : c <= 3634)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))))))
            : (c <= 3716 || (c < 3840
              ? (c < 3762
                ? (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))
                : (c <= 3762 || (c < 3782
                  ? (c < 3776
                    ? c == 3773
                    : c <= 3780)
                  : (c <= 3782 || (c >= 3804 && c <= 3807)))))
              : (c <= 3840 || (c < 4159
                ? (c < 3976
                  ? (c < 3913
                    ? (c >= 3904 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3980 || (c >= 4096 && c <= 4138)))
                : (c <= 4159 || (c < 4193
                  ? (c < 4186
                    ? (c >= 4176 && c <= 4181)
                    : c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))))))))))))
      : (c <= 4208 || (c < 8150
        ? (c < 6314
          ? (c < 4882
            ? (c < 4698
              ? (c < 4304
                ? (c < 4256
                  ? (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)
                  : (c <= 4293 || (c < 4301
                    ? c == 4295
                    : c <= 4301)))
                : (c <= 4346 || (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || c == 4696))))
              : (c <= 4701 || (c < 4792
                ? (c < 4752
                  ? (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))
                : (c <= 4798 || (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c >= 4824 && c <= 4880)))))))
            : (c <= 4885 || (c < 5888
              ? (c < 5121
                ? (c < 5024
                  ? (c < 4992
                    ? (c >= 4888 && c <= 4954)
                    : c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c >= 5870 && c <= 5880)))))
              : (c <= 5905 || (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5937)
                    : c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6176
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6108)
                  : (c <= 6264 || (c >= 6272 && c <= 6312)))))))))
          : (c <= 6314 || (c < 7401
            ? (c < 6981
              ? (c < 6576
                ? (c < 6480
                  ? (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)
                  : (c <= 6509 || (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)))
                : (c <= 6601 || (c < 6823
                  ? (c < 6688
                    ? (c >= 6656 && c <= 6678)
                    : c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))))
              : (c <= 6988 || (c < 7245
                ? (c < 7098
                  ? (c < 7086
                    ? (c >= 7043 && c <= 7072)
                    : c <= 7087)
                  : (c <= 7141 || (c >= 7168 && c <= 7203)))
                : (c <= 7247 || (c < 7312
                  ? (c < 7296
                    ? (c >= 7258 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c >= 7357 && c <= 7359)))))))
            : (c <= 7404 || (c < 8025
              ? (c < 7680
                ? (c < 7418
                  ? (c < 7413
                    ? (c >= 7406 && c <= 7411)
                    : c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))))
              : (c <= 8025 || (c < 8118
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c >= 8064 && c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c >= 8144 && c <= 8147)))))))))))
        : (c <= 8155 || (c < 12353
          ? (c < 11499
            ? (c < 8472
              ? (c < 8336
                ? (c < 8182
                  ? (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)
                  : (c <= 8188 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8458
                  ? (c < 8455
                    ? c == 8450
                    : c <= 8455)
                  : (c <= 8467 || c == 8469))))
              : (c <= 8477 || (c < 8508
                ? (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c >= 8490 && c <= 8505)))
                : (c <= 8511 || (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c >= 11264 && c <= 11492)))))))
            : (c <= 11502 || (c < 11696
              ? (c < 11568
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11506 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || c == 11565))
                : (c <= 11623 || (c < 11680
                  ? (c < 11648
                    ? c == 11631
                    : c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))))
              : (c <= 11702 || (c < 11736
                ? (c < 11720
                  ? (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))
                : (c <= 11742 || (c < 12337
                  ? (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12329)
                  : (c <= 12341 || (c >= 12344 && c <= 12348)))))))))
          : (c <= 12438 || (c < 42960
            ? (c < 42192
              ? (c < 12593
                ? (c < 12540
                  ? (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)
                  : (c <= 12543 || (c >= 12549 && c <= 12591)))
                : (c <= 12686 || (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c >= 19968 && c <= 42124)))))
              : (c <= 42237 || (c < 42623
                ? (c < 42538
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42786
                  ? (c < 42775
                    ? (c >= 42656 && c <= 42735)
                    : c <= 42783)
                  : (c <= 42888 || (c >= 42891 && c <= 42954)))))))
            : (c <= 42961 || (c < 43259
              ? (c < 43015
                ? (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))
                : (c <= 43018 || (c < 43138
                  ? (c < 43072
                    ? (c >= 43020 && c <= 43042)
                    : c <= 43123)
                  : (c <= 43187 || (c >= 43250 && c <= 43255)))))
              : (c <= 43259 || (c < 43396
                ? (c < 43312
                  ? (c < 43274
                    ? (c >= 43261 && c <= 43262)
                    : c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43494
                  ? (c < 43488
                    ? c == 43471
                    : c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))))))))))))))
    : (c <= 43560 || (c < 70751
      ? (c < 66964
        ? (c < 65008
          ? (c < 43888
            ? (c < 43739
              ? (c < 43697
                ? (c < 43616
                  ? (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)
                  : (c <= 43638 || (c < 43646
                    ? c == 43642
                    : c <= 43695)))
                : (c <= 43697 || (c < 43712
                  ? (c < 43705
                    ? (c >= 43701 && c <= 43702)
                    : c <= 43709)
                  : (c <= 43712 || c == 43714))))
              : (c <= 43741 || (c < 43793
                ? (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43754)
                    : c <= 43764)
                  : (c <= 43782 || (c >= 43785 && c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))))))
            : (c <= 44002 || (c < 64298
              ? (c < 64112
                ? (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64285 || (c >= 64287 && c <= 64296)))))
              : (c <= 64310 || (c < 64326
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c >= 64323 && c <= 64324)))
                : (c <= 64433 || (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))))))))
          : (c <= 65017 || (c < 65616
            ? (c < 65440
              ? (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65345
                  ? (c < 65313
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65437)))))
              : (c <= 65470 || (c < 65536
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c >= 65498 && c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))))))
            : (c <= 65629 || (c < 66504
              ? (c < 66304
                ? (c < 66176
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66204 || (c >= 66208 && c <= 66256)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66421)
                  : (c <= 66461 || (c >= 66464 && c <= 66499)))))
              : (c <= 66511 || (c < 66816
                ? (c < 66736
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66771 || (c >= 66776 && c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))))))))))
        : (c <= 66965 || (c < 69248
          ? (c < 67840
            ? (c < 67584
              ? (c < 67392
                ? (c < 66995
                  ? (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)
                  : (c <= 67001 || (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)))
                : (c <= 67413 || (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c >= 67506 && c <= 67514)))))
              : (c <= 67589 || (c < 67647
                ? (c < 67639
                  ? (c < 67594
                    ? c == 67592
                    : c <= 67637)
                  : (c <= 67640 || c == 67644))
                : (c <= 67669 || (c < 67808
                  ? (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)
                  : (c <= 67826 || (c >= 67828 && c <= 67829)))))))
            : (c <= 67861 || (c < 68288
              ? (c < 68112
                ? (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || c == 68096))
                : (c <= 68115 || (c < 68192
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68220 || (c >= 68224 && c <= 68252)))))
              : (c <= 68295 || (c < 68480
                ? (c < 68416
                  ? (c < 68352
                    ? (c >= 68297 && c <= 68324)
                    : c <= 68405)
                  : (c <= 68437 || (c >= 68448 && c <= 68466)))
                : (c <= 68497 || (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c >= 68864 && c <= 68899)))))))))
          : (c <= 69289 || (c < 70108
            ? (c < 69763
              ? (c < 69552
                ? (c < 69415
                  ? (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)
                  : (c <= 69415 || (c < 69488
                    ? (c >= 69424 && c <= 69445)
                    : c <= 69505)))
                : (c <= 69572 || (c < 69745
                  ? (c < 69635
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69687)
                  : (c <= 69746 || c == 69749))))
              : (c <= 69807 || (c < 69968
                ? (c < 69956
                  ? (c < 69891
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69926)
                  : (c <= 69956 || c == 69959))
                : (c <= 70002 || (c < 70081
                  ? (c < 70019
                    ? c == 70006
                    : c <= 70066)
                  : (c <= 70084 || c == 70106))))))
            : (c <= 70108 || (c < 70415
              ? (c < 70282
                ? (c < 70272
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70187)
                  : (c <= 70278 || c == 70280))
                : (c <= 70285 || (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70366 || (c >= 70405 && c <= 70412)))))
              : (c <= 70416 || (c < 70461
                ? (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c >= 70453 && c <= 70457)))
                : (c <= 70461 || (c < 70656
                  ? (c < 70493
                    ? c == 70480
                    : c <= 70497)
                  : (c <= 70708 || (c >= 70727 && c <= 70730)))))))))))))
      : (c <= 70753 || (c < 119966
        ? (c < 73063
          ? (c < 72096
            ? (c < 71488
              ? (c < 71168
                ? (c < 70855
                  ? (c < 70852
                    ? (c >= 70784 && c <= 70831)
                    : c <= 70853)
                  : (c <= 70855 || (c < 71128
                    ? (c >= 71040 && c <= 71086)
                    : c <= 71131)))
                : (c <= 71215 || (c < 71352
                  ? (c < 71296
                    ? c == 71236
                    : c <= 71338)
                  : (c <= 71352 || (c >= 71424 && c <= 71450)))))
              : (c <= 71494 || (c < 71948
                ? (c < 71935
                  ? (c < 71840
                    ? (c >= 71680 && c <= 71723)
                    : c <= 71903)
                  : (c <= 71942 || c == 71945))
                : (c <= 71955 || (c < 71999
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71983)
                  : (c <= 71999 || c == 72001))))))
            : (c <= 72103 || (c < 72368
              ? (c < 72203
                ? (c < 72163
                  ? (c < 72161
                    ? (c >= 72106 && c <= 72144)
                    : c <= 72161)
                  : (c <= 72163 || c == 72192))
                : (c <= 72242 || (c < 72284
                  ? (c < 72272
                    ? c == 72250
                    : c <= 72272)
                  : (c <= 72329 || c == 72349))))
              : (c <= 72440 || (c < 72960
                ? (c < 72768
                  ? (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72750)
                  : (c <= 72768 || (c >= 72818 && c <= 72847)))
                : (c <= 72966 || (c < 73030
                  ? (c < 72971
                    ? (c >= 72968 && c <= 72969)
                    : c <= 73008)
                  : (c <= 73030 || (c >= 73056 && c <= 73061)))))))))
          : (c <= 73064 || (c < 94032
            ? (c < 92160
              ? (c < 74752
                ? (c < 73440
                  ? (c < 73112
                    ? (c >= 73066 && c <= 73097)
                    : c <= 73112)
                  : (c <= 73458 || (c < 73728
                    ? c == 73648
                    : c <= 74649)))
                : (c <= 74862 || (c < 77824
                  ? (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)
                  : (c <= 78894 || (c >= 82944 && c <= 83526)))))
              : (c <= 92728 || (c < 92992
                ? (c < 92880
                  ? (c < 92784
                    ? (c >= 92736 && c <= 92766)
                    : c <= 92862)
                  : (c <= 92909 || (c >= 92928 && c <= 92975)))
                : (c <= 92995 || (c < 93760
                  ? (c < 93053
                    ? (c >= 93027 && c <= 93047)
                    : c <= 93071)
                  : (c <= 93823 || (c >= 93952 && c <= 94026)))))))
            : (c <= 94032 || (c < 110592
              ? (c < 100352
                ? (c < 94179
                  ? (c < 94176
                    ? (c >= 94099 && c <= 94111)
                    : c <= 94177)
                  : (c <= 94179 || (c >= 94208 && c <= 100343)))
                : (c <= 101589 || (c < 110581
                  ? (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)
                  : (c <= 110587 || (c >= 110589 && c <= 110590)))))
              : (c <= 110882 || (c < 113776
                ? (c < 110960
                  ? (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)
                  : (c <= 111355 || (c >= 113664 && c <= 113770)))
                : (c <= 113788 || (c < 119808
                  ? (c < 113808
                    ? (c >= 113792 && c <= 113800)
                    : c <= 113817)
                  : (c <= 119892 || (c >= 119894 && c <= 119964)))))))))))
        : (c <= 119967 || (c < 126464
          ? (c < 120598
            ? (c < 120094
              ? (c < 119997
                ? (c < 119977
                  ? (c < 119973
                    ? c == 119970
                    : c <= 119974)
                  : (c <= 119980 || (c < 119995
                    ? (c >= 119982 && c <= 119993)
                    : c <= 119995)))
                : (c <= 120003 || (c < 120077
                  ? (c < 120071
                    ? (c >= 120005 && c <= 120069)
                    : c <= 120074)
                  : (c <= 120084 || (c >= 120086 && c <= 120092)))))
              : (c <= 120121 || (c < 120146
                ? (c < 120134
                  ? (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)
                  : (c <= 120134 || (c >= 120138 && c <= 120144)))
                : (c <= 120485 || (c < 120540
                  ? (c < 120514
                    ? (c >= 120488 && c <= 120512)
                    : c <= 120538)
                  : (c <= 120570 || (c >= 120572 && c <= 120596)))))))
            : (c <= 120628 || (c < 123214
              ? (c < 120746
                ? (c < 120688
                  ? (c < 120656
                    ? (c >= 120630 && c <= 120654)
                    : c <= 120686)
                  : (c <= 120712 || (c >= 120714 && c <= 120744)))
                : (c <= 120770 || (c < 123136
                  ? (c < 122624
                    ? (c >= 120772 && c <= 120779)
                    : c <= 122654)
                  : (c <= 123180 || (c >= 123191 && c <= 123197)))))
              : (c <= 123214 || (c < 124909
                ? (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123565)
                    : c <= 123627)
                  : (c <= 124902 || (c >= 124904 && c <= 124907)))
                : (c <= 124910 || (c < 125184
                  ? (c < 124928
                    ? (c >= 124912 && c <= 124926)
                    : c <= 125124)
                  : (c <= 125251 || c == 125259))))))))
          : (c <= 126467 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126500
                  ? (c < 126497
                    ? (c >= 126469 && c <= 126495)
                    : c <= 126498)
                  : (c <= 126500 || c == 126503))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_python_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'b'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_python_identifier_character_set_3(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_python_identifier_character_set_4(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_python_identifier_character_set_5(int32_t c) {
  return (c < 43739
    ? (c < 3804
      ? (c < 2768
        ? (c < 2160
          ? (c < 1369
            ? (c < 768
              ? (c < 216
                ? (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))
                : (c <= 246 || (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))))
              : (c <= 884 || (c < 910
                ? (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))
                : (c <= 929 || (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))))))
            : (c <= 1369 || (c < 1749
              ? (c < 1479
                ? (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))
                : (c <= 1479 || (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))))
              : (c <= 1756 || (c < 1984
                ? (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))
                : (c <= 2037 || (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))))))))
          : (c <= 2183 || (c < 2579
            ? (c < 2492
              ? (c < 2437
                ? (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))
                : (c <= 2444 || (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))))
              : (c <= 2500 || (c < 2534
                ? (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))
                : (c <= 2545 || (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))))))
            : (c <= 2600 || (c < 2662
              ? (c < 2622
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))
                : (c <= 2626 || (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))))
              : (c <= 2677 || (c < 2738
                ? (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))
                : (c <= 2739 || (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c >= 2763 && c <= 2765)))))))))))
        : (c <= 2768 || (c < 3205
          ? (c < 2972
            ? (c < 2887
              ? (c < 2831
                ? (c < 2809
                  ? (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)
                  : (c <= 2815 || (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)))
                : (c <= 2832 || (c < 2866
                  ? (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)
                  : (c <= 2867 || (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)))))
              : (c <= 2888 || (c < 2929
                ? (c < 2908
                  ? (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)
                  : (c <= 2909 || (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)))
                : (c <= 2929 || (c < 2958
                  ? (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))))))
            : (c <= 2972 || (c < 3086
              ? (c < 3014
                ? (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)))
                : (c <= 3016 || (c < 3031
                  ? (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)
                  : (c <= 3031 || (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)))))
              : (c <= 3088 || (c < 3157
                ? (c < 3132
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3140 || (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)))
                : (c <= 3158 || (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3171 || (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)))))))))
          : (c <= 3212 || (c < 3482
            ? (c < 3313
              ? (c < 3270
                ? (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)))
                : (c <= 3272 || (c < 3293
                  ? (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)
                  : (c <= 3294 || (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)))))
              : (c <= 3314 || (c < 3412
                ? (c < 3346
                  ? (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3396 || (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)))
                : (c <= 3415 || (c < 3450
                  ? (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)
                  : (c <= 3455 || (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)))))))
            : (c <= 3505 || (c < 3664
              ? (c < 3542
                ? (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c < 3535
                    ? c == 3530
                    : c <= 3540)))
                : (c <= 3542 || (c < 3570
                  ? (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)
                  : (c <= 3571 || (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)))))
              : (c <= 3673 || (c < 3751
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)))
                : (c <= 3773 || (c < 3784
                  ? (c < 3782
                    ? (c >= 3776 && c <= 3780)
                    : c <= 3782)
                  : (c <= 3789 || (c >= 3792 && c <= 3801)))))))))))))
      : (c <= 3807 || (c < 8029
        ? (c < 5984
          ? (c < 4704
            ? (c < 4038
              ? (c < 3897
                ? (c < 3872
                  ? (c < 3864
                    ? c == 3840
                    : c <= 3865)
                  : (c <= 3881 || (c < 3895
                    ? c == 3893
                    : c <= 3895)))
                : (c <= 3897 || (c < 3953
                  ? (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3972 || (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)))))
              : (c <= 4038 || (c < 4304
                ? (c < 4256
                  ? (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)
                  : (c <= 4293 || (c < 4301
                    ? c == 4295
                    : c <= 4301)))
                : (c <= 4346 || (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || (c < 4698
                    ? c == 4696
                    : c <= 4701)))))))
            : (c <= 4744 || (c < 4969
              ? (c < 4802
                ? (c < 4786
                  ? (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)
                  : (c <= 4789 || (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)))
                : (c <= 4805 || (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)))))
              : (c <= 4977 || (c < 5761
                ? (c < 5112
                  ? (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)
                  : (c <= 5117 || (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)))
                : (c <= 5786 || (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5909 || (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)))))))))
          : (c <= 5996 || (c < 6800
            ? (c < 6400
              ? (c < 6112
                ? (c < 6016
                  ? (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)
                  : (c <= 6099 || (c < 6108
                    ? c == 6103
                    : c <= 6109)))
                : (c <= 6121 || (c < 6176
                  ? (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)
                  : (c <= 6264 || (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)))))
              : (c <= 6430 || (c < 6576
                ? (c < 6470
                  ? (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)
                  : (c <= 6509 || (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)))
                : (c <= 6601 || (c < 6688
                  ? (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)
                  : (c <= 6750 || (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)))))))
            : (c <= 6809 || (c < 7312
              ? (c < 7019
                ? (c < 6847
                  ? (c < 6832
                    ? c == 6823
                    : c <= 6845)
                  : (c <= 6862 || (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)))
                : (c <= 7027 || (c < 7232
                  ? (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)
                  : (c <= 7241 || (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)))))
              : (c <= 7354 || (c < 7968
                ? (c < 7380
                  ? (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)
                  : (c <= 7418 || (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)))
                : (c <= 8005 || (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))))))))))
        : (c <= 8029 || (c < 11736
          ? (c < 8472
            ? (c < 8255
              ? (c < 8134
                ? (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || (c < 8130
                    ? c == 8126
                    : c <= 8132)))
                : (c <= 8140 || (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))))
              : (c <= 8256 || (c < 8417
                ? (c < 8319
                  ? (c < 8305
                    ? c == 8276
                    : c <= 8305)
                  : (c <= 8319 || (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)))
                : (c <= 8417 || (c < 8455
                  ? (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)
                  : (c <= 8455 || (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)))))))
            : (c <= 8477 || (c < 11559
              ? (c < 8517
                ? (c < 8488
                  ? (c < 8486
                    ? c == 8484
                    : c <= 8486)
                  : (c <= 8488 || (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)))
                : (c <= 8521 || (c < 11264
                  ? (c < 8544
                    ? c == 8526
                    : c <= 8584)
                  : (c <= 11492 || (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)))))
              : (c <= 11559 || (c < 11688
                ? (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)))
                : (c <= 11694 || (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)))))))))
          : (c <= 11742 || (c < 42786
            ? (c < 12593
              ? (c < 12353
                ? (c < 12321
                  ? (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)
                  : (c <= 12335 || (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)))
                : (c <= 12438 || (c < 12449
                  ? (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)
                  : (c <= 12538 || (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)))))
              : (c <= 12686 || (c < 42240
                ? (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)))
                : (c <= 42508 || (c < 42612
                  ? (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)
                  : (c <= 42621 || (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)))))))
            : (c <= 42888 || (c < 43261
              ? (c < 43052
                ? (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)))
                : (c <= 43052 || (c < 43216
                  ? (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)
                  : (c <= 43225 || (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)))))
              : (c <= 43309 || (c < 43520
                ? (c < 43392
                  ? (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)
                  : (c <= 43456 || (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)))
                : (c <= 43574 || (c < 43616
                  ? (c < 43600
                    ? (c >= 43584 && c <= 43597)
                    : c <= 43609)
                  : (c <= 43638 || (c >= 43642 && c <= 43714)))))))))))))))
    : (c <= 43741 || (c < 71472
      ? (c < 67644
        ? (c < 65474
          ? (c < 64320
            ? (c < 44016
              ? (c < 43808
                ? (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)
                  : (c <= 43782 || (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)))
                : (c <= 43814 || (c < 43868
                  ? (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)
                  : (c <= 43881 || (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)))))
              : (c <= 44025 || (c < 64256
                ? (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)))
                : (c <= 64262 || (c < 64298
                  ? (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)
                  : (c <= 64310 || (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)))))))
            : (c <= 64321 || (c < 65137
              ? (c < 64914
                ? (c < 64467
                  ? (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)
                  : (c <= 64605 || (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)))
                : (c <= 64967 || (c < 65056
                  ? (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)
                  : (c <= 65071 || (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)))))
              : (c <= 65137 || (c < 65151
                ? (c < 65145
                  ? (c < 65143
                    ? c == 65139
                    : c <= 65143)
                  : (c <= 65145 || (c < 65149
                    ? c == 65147
                    : c <= 65149)))
                : (c <= 65276 || (c < 65343
                  ? (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)
                  : (c <= 65343 || (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)))))))))
          : (c <= 65479 || (c < 66720
            ? (c < 66045
              ? (c < 65576
                ? (c < 65498
                  ? (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)
                  : (c <= 65500 || (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)))
                : (c <= 65594 || (c < 65616
                  ? (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)
                  : (c <= 65629 || (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)))))
              : (c <= 66045 || (c < 66384
                ? (c < 66272
                  ? (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)
                  : (c <= 66272 || (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)))
                : (c <= 66426 || (c < 66504
                  ? (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)
                  : (c <= 66511 || (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)))))))
            : (c <= 66729 || (c < 67003
              ? (c < 66940
                ? (c < 66816
                  ? (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)
                  : (c <= 66855 || (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)))
                : (c <= 66954 || (c < 66967
                  ? (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)
                  : (c <= 66977 || (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)))))
              : (c <= 67004 || (c < 67506
                ? (c < 67424
                  ? (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)
                  : (c <= 67431 || (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)))
                : (c <= 67514 || (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))))))))))
        : (c <= 67644 || (c < 69968
          ? (c < 68480
            ? (c < 68108
              ? (c < 67840
                ? (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)))
                : (c <= 67861 || (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)))))
              : (c <= 68115 || (c < 68224
                ? (c < 68152
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68154 || (c < 68192
                    ? c == 68159
                    : c <= 68220)))
                : (c <= 68252 || (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)
                  : (c <= 68405 || (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)))))))
            : (c <= 68497 || (c < 69488
              ? (c < 69248
                ? (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)))
                : (c <= 69289 || (c < 69376
                  ? (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69456)))))
              : (c <= 69509 || (c < 69826
                ? (c < 69632
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69702 || (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)))
                : (c <= 69826 || (c < 69888
                  ? (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)
                  : (c <= 69940 || (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)))))))))
          : (c <= 70003 || (c < 70471
            ? (c < 70287
              ? (c < 70144
                ? (c < 70089
                  ? (c < 70016
                    ? c == 70006
                    : c <= 70084)
                  : (c <= 70092 || (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)))
                : (c <= 70161 || (c < 70272
                  ? (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)
                  : (c <= 70278 || (c < 70282
                    ? c == 70280
                    : c <= 70285)))))
              : (c <= 70301 || (c < 70415
                ? (c < 70384
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)
                  : (c <= 70393 || (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)))
                : (c <= 70416 || (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)))))))
            : (c <= 70472 || (c < 70864
              ? (c < 70512
                ? (c < 70487
                  ? (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)
                  : (c <= 70487 || (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)))
                : (c <= 70516 || (c < 70750
                  ? (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)
                  : (c <= 70753 || (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)))))
              : (c <= 70873 || (c < 71248
                ? (c < 71128
                  ? (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)
                  : (c <= 71133 || (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)))
                : (c <= 71257 || (c < 71424
                  ? (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)
                  : (c <= 71450 || (c >= 71453 && c <= 71467)))))))))))))
      : (c <= 71481 || (c < 119973
        ? (c < 82944
          ? (c < 72784
            ? (c < 72096
              ? (c < 71948
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71738)
                  : (c <= 71913 || (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)))
                : (c <= 71955 || (c < 71991
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71989)
                  : (c <= 71992 || (c < 72016
                    ? (c >= 71995 && c <= 72003)
                    : c <= 72025)))))
              : (c <= 72103 || (c < 72272
                ? (c < 72163
                  ? (c < 72154
                    ? (c >= 72106 && c <= 72151)
                    : c <= 72161)
                  : (c <= 72164 || (c < 72263
                    ? (c >= 72192 && c <= 72254)
                    : c <= 72263)))
                : (c <= 72345 || (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c < 72760
                    ? (c >= 72714 && c <= 72758)
                    : c <= 72768)))))))
            : (c <= 72793 || (c < 73063
              ? (c < 72971
                ? (c < 72873
                  ? (c < 72850
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72871)
                  : (c <= 72886 || (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)))
                : (c <= 73014 || (c < 73023
                  ? (c < 73020
                    ? c == 73018
                    : c <= 73021)
                  : (c <= 73031 || (c < 73056
                    ? (c >= 73040 && c <= 73049)
                    : c <= 73061)))))
              : (c <= 73064 || (c < 73648
                ? (c < 73107
                  ? (c < 73104
                    ? (c >= 73066 && c <= 73102)
                    : c <= 73105)
                  : (c <= 73112 || (c < 73440
                    ? (c >= 73120 && c <= 73129)
                    : c <= 73462)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c < 77824
                    ? (c >= 77712 && c <= 77808)
                    : c <= 78894)))))))))
          : (c <= 83526 || (c < 110581
            ? (c < 93053
              ? (c < 92880
                ? (c < 92768
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92777 || (c < 92864
                    ? (c >= 92784 && c <= 92862)
                    : c <= 92873)))
                : (c <= 92909 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92912 && c <= 92916)
                    : c <= 92982)
                  : (c <= 92995 || (c < 93027
                    ? (c >= 93008 && c <= 93017)
                    : c <= 93047)))))
              : (c <= 93071 || (c < 94179
                ? (c < 94031
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94087 || (c < 94176
                    ? (c >= 94095 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94180 || (c < 100352
                  ? (c < 94208
                    ? (c >= 94192 && c <= 94193)
                    : c <= 100343)
                  : (c <= 101589 || (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)))))))
            : (c <= 110587 || (c < 118576
              ? (c < 113664
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c < 110960
                    ? (c >= 110948 && c <= 110951)
                    : c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c < 118528
                    ? (c >= 113821 && c <= 113822)
                    : c <= 118573)))))
              : (c <= 118598 || (c < 119362
                ? (c < 119163
                  ? (c < 119149
                    ? (c >= 119141 && c <= 119145)
                    : c <= 119154)
                  : (c <= 119170 || (c < 119210
                    ? (c >= 119173 && c <= 119179)
                    : c <= 119213)))
                : (c <= 119364 || (c < 119966
                  ? (c < 119894
                    ? (c >= 119808 && c <= 119892)
                    : c <= 119964)
                  : (c <= 119967 || c == 119970))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_python_identifier_character_set_6(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_python_identifier_character_set_7(int32_t c) {
  return (c < 43642
    ? (c < 3784
      ? (c < 2759
        ? (c < 2048
          ? (c < 1155
            ? (c < 736
              ? (c < 183
                ? (c < 'a'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 183 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)))))
              : (c <= 740 || (c < 895
                ? (c < 768
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)))
                : (c <= 895 || (c < 910
                  ? (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)))))))
            : (c <= 1159 || (c < 1552
              ? (c < 1471
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)))
                : (c <= 1471 || (c < 1479
                  ? (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)
                  : (c <= 1479 || (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)))))
              : (c <= 1562 || (c < 1791
                ? (c < 1749
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)
                  : (c <= 1756 || (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)))
                : (c <= 1791 || (c < 1984
                  ? (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)
                  : (c <= 2037 || (c < 2045
                    ? c == 2042
                    : c <= 2045)))))))))
          : (c <= 2093 || (c < 2561
            ? (c < 2474
              ? (c < 2275
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)
                  : (c <= 2183 || (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)))
                : (c <= 2403 || (c < 2437
                  ? (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)
                  : (c <= 2444 || (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)))))
              : (c <= 2480 || (c < 2519
                ? (c < 2492
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2500 || (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)))
                : (c <= 2519 || (c < 2534
                  ? (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)
                  : (c <= 2545 || (c < 2558
                    ? c == 2556
                    : c <= 2558)))))))
            : (c <= 2563 || (c < 2641
              ? (c < 2613
                ? (c < 2579
                  ? (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)
                  : (c <= 2600 || (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)))
                : (c <= 2614 || (c < 2622
                  ? (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)
                  : (c <= 2626 || (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)))))
              : (c <= 2641 || (c < 2703
                ? (c < 2662
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2677 || (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)))
                : (c <= 2705 || (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)))))))))))
        : (c <= 2761 || (c < 3174
          ? (c < 2962
            ? (c < 2869
              ? (c < 2817
                ? (c < 2784
                  ? (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)
                  : (c <= 2787 || (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)))
                : (c <= 2819 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)))))
              : (c <= 2873 || (c < 2911
                ? (c < 2891
                  ? (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)
                  : (c <= 2893 || (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)))
                : (c <= 2915 || (c < 2946
                  ? (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)
                  : (c <= 2947 || (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)))))))
            : (c <= 2965 || (c < 3046
              ? (c < 2990
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)))
                : (c <= 3001 || (c < 3018
                  ? (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)
                  : (c <= 3021 || (c < 3031
                    ? c == 3024
                    : c <= 3031)))))
              : (c <= 3055 || (c < 3142
                ? (c < 3090
                  ? (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)))
                : (c <= 3144 || (c < 3160
                  ? (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)
                  : (c <= 3162 || (c < 3168
                    ? c == 3165
                    : c <= 3171)))))))))
          : (c <= 3183 || (c < 3457
            ? (c < 3296
              ? (c < 3253
                ? (c < 3214
                  ? (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)
                  : (c <= 3216 || (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)))
                : (c <= 3257 || (c < 3274
                  ? (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)
                  : (c <= 3277 || (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)))))
              : (c <= 3299 || (c < 3398
                ? (c < 3328
                  ? (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)
                  : (c <= 3340 || (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)))
                : (c <= 3400 || (c < 3423
                  ? (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)
                  : (c <= 3427 || (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)))))))
            : (c <= 3459 || (c < 3585
              ? (c < 3530
                ? (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || (c < 3520
                    ? c == 3517
                    : c <= 3526)))
                : (c <= 3530 || (c < 3544
                  ? (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)
                  : (c <= 3551 || (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)))))
              : (c <= 3642 || (c < 3724
                ? (c < 3713
                  ? (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)
                  : (c <= 3714 || (c < 3718
                    ? c == 3716
                    : c <= 3722)))
                : (c <= 3747 || (c < 3776
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))))))))))
      : (c <= 3789 || (c < 8027
        ? (c < 5919
          ? (c < 4696
            ? (c < 3974
              ? (c < 3893
                ? (c < 3840
                  ? (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)
                  : (c <= 3840 || (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)))
                : (c <= 3893 || (c < 3902
                  ? (c < 3897
                    ? c == 3895
                    : c <= 3897)
                  : (c <= 3911 || (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)))))
              : (c <= 3991 || (c < 4295
                ? (c < 4096
                  ? (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)
                  : (c <= 4169 || (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)))))))
            : (c <= 4696 || (c < 4888
              ? (c < 4792
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)))
                : (c <= 4798 || (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)))))
              : (c <= 4954 || (c < 5121
                ? (c < 4992
                  ? (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)
                  : (c <= 5007 || (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)))
                : (c <= 5740 || (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)))))))))
          : (c <= 5940 || (c < 6752
            ? (c < 6272
              ? (c < 6103
                ? (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)
                  : (c <= 6000 || (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)))
                : (c <= 6103 || (c < 6155
                  ? (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)
                  : (c <= 6157 || (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)))))
              : (c <= 6314 || (c < 6512
                ? (c < 6432
                  ? (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)
                  : (c <= 6443 || (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6608
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6618 || (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)))))))
            : (c <= 6780 || (c < 7245
              ? (c < 6912
                ? (c < 6823
                  ? (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)
                  : (c <= 6823 || (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)))
                : (c <= 6988 || (c < 7040
                  ? (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)
                  : (c <= 7155 || (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)))))
              : (c <= 7293 || (c < 7424
                ? (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)))
                : (c <= 7957 || (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)))))))))))
        : (c <= 8027 || (c < 11728
          ? (c < 8469
            ? (c < 8182
              ? (c < 8130
                ? (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))))
              : (c <= 8188 || (c < 8400
                ? (c < 8305
                  ? (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)
                  : (c <= 8305 || (c < 8336
                    ? c == 8319
                    : c <= 8348)))
                : (c <= 8412 || (c < 8450
                  ? (c < 8421
                    ? c == 8417
                    : c <= 8432)
                  : (c <= 8450 || (c < 8458
                    ? c == 8455
                    : c <= 8467)))))))
            : (c <= 8469 || (c < 11520
              ? (c < 8508
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || (c < 8490
                    ? c == 8488
                    : c <= 8505)))
                : (c <= 8511 || (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)))))
              : (c <= 11557 || (c < 11680
                ? (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || (c < 11647
                    ? c == 11631
                    : c <= 11670)))
                : (c <= 11686 || (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)))))))))
          : (c <= 11734 || (c < 42775
            ? (c < 12549
              ? (c < 12344
                ? (c < 12293
                  ? (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)
                  : (c <= 12295 || (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))))
              : (c <= 12591 || (c < 42192
                ? (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)))
                : (c <= 42237 || (c < 42560
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)
                  : (c <= 42607 || (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)))))))
            : (c <= 42783 || (c < 43259
              ? (c < 42994
                ? (c < 42960
                  ? (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)
                  : (c <= 42961 || (c < 42965
                    ? c == 42963
                    : c <= 42969)))
                : (c <= 43047 || (c < 43136
                  ? (c < 43072
                    ? c == 43052
                    : c <= 43123)
                  : (c <= 43205 || (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)))))
              : (c <= 43259 || (c < 43488
                ? (c < 43360
                  ? (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)
                  : (c <= 43388 || (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)))
                : (c <= 43518 || (c < 43600
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)
                  : (c <= 43609 || (c >= 43616 && c <= 43638)))))))))))))))
    : (c <= 43714 || (c < 71472
      ? (c < 67644
        ? (c < 65382
          ? (c < 64318
            ? (c < 44012
              ? (c < 43793
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43759)
                  : (c <= 43766 || (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44010)))))
              : (c <= 44013 || (c < 64112
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 44016 && c <= 44025)
                    : c <= 55203)
                  : (c <= 55238 || (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64296 || (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)))))))
            : (c <= 64318 || (c < 65101
              ? (c < 64848
                ? (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)))
                : (c <= 64911 || (c < 65024
                  ? (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)
                  : (c <= 65039 || (c < 65075
                    ? (c >= 65056 && c <= 65071)
                    : c <= 65076)))))
              : (c <= 65103 || (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65313
                  ? (c < 65296
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65305)
                  : (c <= 65338 || (c < 65345
                    ? c == 65343
                    : c <= 65370)))))))))
          : (c <= 65470 || (c < 66560
            ? (c < 65856
              ? (c < 65549
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)))
                : (c <= 65574 || (c < 65599
                  ? (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)
                  : (c <= 65613 || (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)))))
              : (c <= 65908 || (c < 66349
                ? (c < 66208
                  ? (c < 66176
                    ? c == 66045
                    : c <= 66204)
                  : (c <= 66256 || (c < 66304
                    ? c == 66272
                    : c <= 66335)))
                : (c <= 66378 || (c < 66464
                  ? (c < 66432
                    ? (c >= 66384 && c <= 66426)
                    : c <= 66461)
                  : (c <= 66499 || (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)))))))
            : (c <= 66717 || (c < 66995
              ? (c < 66928
                ? (c < 66776
                  ? (c < 66736
                    ? (c >= 66720 && c <= 66729)
                    : c <= 66771)
                  : (c <= 66811 || (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)))
                : (c <= 66938 || (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))))
              : (c <= 67001 || (c < 67463
                ? (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)))
                : (c <= 67504 || (c < 67592
                  ? (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)
                  : (c <= 67592 || (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)))))))))))
        : (c <= 67644 || (c < 69968
          ? (c < 68480
            ? (c < 68108
              ? (c < 67840
                ? (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)))
                : (c <= 67861 || (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)))))
              : (c <= 68115 || (c < 68224
                ? (c < 68152
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68154 || (c < 68192
                    ? c == 68159
                    : c <= 68220)))
                : (c <= 68252 || (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)
                  : (c <= 68405 || (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)))))))
            : (c <= 68497 || (c < 69488
              ? (c < 69248
                ? (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)))
                : (c <= 69289 || (c < 69376
                  ? (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69456)))))
              : (c <= 69509 || (c < 69826
                ? (c < 69632
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69702 || (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)))
                : (c <= 69826 || (c < 69888
                  ? (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)
                  : (c <= 69940 || (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)))))))))
          : (c <= 70003 || (c < 70471
            ? (c < 70287
              ? (c < 70144
                ? (c < 70089
                  ? (c < 70016
                    ? c == 70006
                    : c <= 70084)
                  : (c <= 70092 || (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)))
                : (c <= 70161 || (c < 70272
                  ? (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)
                  : (c <= 70278 || (c < 70282
                    ? c == 70280
                    : c <= 70285)))))
              : (c <= 70301 || (c < 70415
                ? (c < 70384
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)
                  : (c <= 70393 || (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)))
                : (c <= 70416 || (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)))))))
            : (c <= 70472 || (c < 70864
              ? (c < 70512
                ? (c < 70487
                  ? (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)
                  : (c <= 70487 || (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)))
                : (c <= 70516 || (c < 70750
                  ? (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)
                  : (c <= 70753 || (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)))))
              : (c <= 70873 || (c < 71248
                ? (c < 71128
                  ? (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)
                  : (c <= 71133 || (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)))
                : (c <= 71257 || (c < 71424
                  ? (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)
                  : (c <= 71450 || (c >= 71453 && c <= 71467)))))))))))))
      : (c <= 71481 || (c < 119973
        ? (c < 82944
          ? (c < 72784
            ? (c < 72096
              ? (c < 71948
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71738)
                  : (c <= 71913 || (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)))
                : (c <= 71955 || (c < 71991
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71989)
                  : (c <= 71992 || (c < 72016
                    ? (c >= 71995 && c <= 72003)
                    : c <= 72025)))))
              : (c <= 72103 || (c < 72272
                ? (c < 72163
                  ? (c < 72154
                    ? (c >= 72106 && c <= 72151)
                    : c <= 72161)
                  : (c <= 72164 || (c < 72263
                    ? (c >= 72192 && c <= 72254)
                    : c <= 72263)))
                : (c <= 72345 || (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c < 72760
                    ? (c >= 72714 && c <= 72758)
                    : c <= 72768)))))))
            : (c <= 72793 || (c < 73063
              ? (c < 72971
                ? (c < 72873
                  ? (c < 72850
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72871)
                  : (c <= 72886 || (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)))
                : (c <= 73014 || (c < 73023
                  ? (c < 73020
                    ? c == 73018
                    : c <= 73021)
                  : (c <= 73031 || (c < 73056
                    ? (c >= 73040 && c <= 73049)
                    : c <= 73061)))))
              : (c <= 73064 || (c < 73648
                ? (c < 73107
                  ? (c < 73104
                    ? (c >= 73066 && c <= 73102)
                    : c <= 73105)
                  : (c <= 73112 || (c < 73440
                    ? (c >= 73120 && c <= 73129)
                    : c <= 73462)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c < 77824
                    ? (c >= 77712 && c <= 77808)
                    : c <= 78894)))))))))
          : (c <= 83526 || (c < 110581
            ? (c < 93053
              ? (c < 92880
                ? (c < 92768
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92777 || (c < 92864
                    ? (c >= 92784 && c <= 92862)
                    : c <= 92873)))
                : (c <= 92909 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92912 && c <= 92916)
                    : c <= 92982)
                  : (c <= 92995 || (c < 93027
                    ? (c >= 93008 && c <= 93017)
                    : c <= 93047)))))
              : (c <= 93071 || (c < 94179
                ? (c < 94031
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94087 || (c < 94176
                    ? (c >= 94095 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94180 || (c < 100352
                  ? (c < 94208
                    ? (c >= 94192 && c <= 94193)
                    : c <= 100343)
                  : (c <= 101589 || (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)))))))
            : (c <= 110587 || (c < 118576
              ? (c < 113664
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c < 110960
                    ? (c >= 110948 && c <= 110951)
                    : c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c < 118528
                    ? (c >= 113821 && c <= 113822)
                    : c <= 118573)))))
              : (c <= 118598 || (c < 119362
                ? (c < 119163
                  ? (c < 119149
                    ? (c >= 119141 && c <= 119145)
                    : c <= 119154)
                  : (c <= 119170 || (c < 119210
                    ? (c >= 119173 && c <= 119179)
                    : c <= 119213)))
                : (c <= 119364 || (c < 119966
                  ? (c < 119894
                    ? (c >= 119808 && c <= 119892)
                    : c <= 119964)
                  : (c <= 119967 || c == 119970))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (eof) ADVANCE(353);
      if (!eof && lookahead == 0) ADVANCE(359);
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '"') ADVANCE(402);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(441);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '\'') ADVANCE(442);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(538);
      if (lookahead == '.') ADVANCE(462);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == '0') ADVANCE(604);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(363);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '?') ADVANCE(77);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == 'E') ADVANCE(142);
      if (lookahead == 'F') ADVANCE(156);
      if (lookahead == 'I') ADVANCE(112);
      if (lookahead == 'N') ADVANCE(264);
      if (lookahead == 'O') ADVANCE(140);
      if (lookahead == 'T') ADVANCE(282);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '\\') ADVANCE(591);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == '_') ADVANCE(143);
      if (lookahead == 'a') ADVANCE(174);
      if (lookahead == 'b') ADVANCE(196);
      if (lookahead == 'c') ADVANCE(268);
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(232);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'g') ADVANCE(236);
      if (lookahead == 'i') ADVANCE(210);
      if (lookahead == 'l') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(158);
      if (lookahead == 'n') ADVANCE(261);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == 'p') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(157);
      if (lookahead == 't') ADVANCE(284);
      if (lookahead == 'u') ADVANCE(251);
      if (lookahead == 'w') ADVANCE(218);
      if (lookahead == 'y') ADVANCE(221);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(351);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(602);
      END_STATE();
    case 1:
      if (!eof && lookahead == 0) ADVANCE(359);
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(329);
      if (lookahead == '+') ADVANCE(73);
      if (lookahead == '.') ADVANCE(74);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == '=') ADVANCE(362);
      if (lookahead == '?') ADVANCE(77);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(887);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(1);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 2:
      if (!eof && lookahead == 0) ADVANCE(359);
      if (lookahead == '\n') ADVANCE(356);
      if (lookahead == '\r') ADVANCE(2);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == 'b') ADVANCE(886);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(2);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 3:
      if (!eof && lookahead == 0) ADVANCE(359);
      if (lookahead == '\n') ADVANCE(357);
      if (lookahead == '\r') ADVANCE(3);
      if (lookahead == '#') ADVANCE(908);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 4:
      if (!eof && lookahead == 0) ADVANCE(359);
      if (lookahead == '\n') ADVANCE(358);
      if (lookahead == '\r') ADVANCE(4);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == 'a') ADVANCE(209);
      if (lookahead == 'b') ADVANCE(195);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(4);
      END_STATE();
    case 5:
      if (!eof && lookahead == 0) ADVANCE(360);
      if (lookahead == '\n') ADVANCE(355);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == ' ') SKIP(5);
      if (lookahead == '#') ADVANCE(907);
      if (lookahead == '$') ADVANCE(327);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(6);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 6:
      if (!eof && lookahead == 0) ADVANCE(360);
      if (lookahead == '\n') ADVANCE(355);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == ' ') SKIP(5);
      if (lookahead == '#') ADVANCE(398);
      if (lookahead == '$') ADVANCE(397);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(395);
      if (lookahead != 0) ADVANCE(399);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(590);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(447);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(447);
      if (lookahead == '\r') ADVANCE(8);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(10);
      if (lookahead == '#') ADVANCE(593);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(592);
      if (lookahead != 0) ADVANCE(593);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(537);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(250);
      if (lookahead == 'e') ADVANCE(243);
      if (lookahead == 'f') ADVANCE(288);
      if (lookahead == 'i') ADVANCE(211);
      if (lookahead == 'n') ADVANCE(275);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(536);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(250);
      if (lookahead == 'e') ADVANCE(243);
      if (lookahead == 'f') ADVANCE(288);
      if (lookahead == 'i') ADVANCE(211);
      if (lookahead == 'n') ADVANCE(275);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(536);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(250);
      if (lookahead == 'e') ADVANCE(243);
      if (lookahead == 'f') ADVANCE(288);
      if (lookahead == 'i') ADVANCE(211);
      if (lookahead == 'n') ADVANCE(275);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(348);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(348);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(732);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(348);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(348);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 20:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(537);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(250);
      if (lookahead == 'e') ADVANCE(243);
      if (lookahead == 'f') ADVANCE(267);
      if (lookahead == 'i') ADVANCE(210);
      if (lookahead == 'n') ADVANCE(275);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == 'w') ADVANCE(224);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20);
      END_STATE();
    case 21:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(539);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 22:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(539);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 23:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(539);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 24:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(537);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(772);
      if (lookahead == 'i') ADVANCE(769);
      if (lookahead == 'n') ADVANCE(773);
      if (lookahead == 'o') ADVANCE(776);
      if (lookahead == '|') ADVANCE(553);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(24);
      if (sym_python_identifier_character_set_2(lookahead)) ADVANCE(784);
      END_STATE();
    case 25:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 26:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(536);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(364);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(249);
      if (lookahead == 'f') ADVANCE(266);
      if (lookahead == 'i') ADVANCE(211);
      if (lookahead == 'n') ADVANCE(275);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      END_STATE();
    case 27:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(536);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(249);
      if (lookahead == 'f') ADVANCE(266);
      if (lookahead == 'i') ADVANCE(211);
      if (lookahead == 'n') ADVANCE(275);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      END_STATE();
    case 28:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 29:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(732);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 30:
      if (lookahead == '!') ADVANCE(69);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '<') ADVANCE(562);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(568);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(705);
      if (lookahead == 'e') ADVANCE(697);
      if (lookahead == 'i') ADVANCE(669);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'o') ADVANCE(729);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(401);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '\'') ADVANCE(442);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 33:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(329);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == '=') ADVANCE(362);
      if (lookahead == '?') ADVANCE(77);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(717);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'w') ADVANCE(675);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 34:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(329);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '+') ADVANCE(73);
      if (lookahead == '.') ADVANCE(903);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == '=') ADVANCE(362);
      if (lookahead == '?') ADVANCE(77);
      if (lookahead == '[') ADVANCE(372);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 35:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(329);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == ':') ADVANCE(384);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 36:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(329);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(856);
      if (lookahead == 'p') ADVANCE(865);
      if (lookahead == 'r') ADVANCE(824);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 37:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(539);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(66);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 38:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(546);
      if (lookahead == '&') ADVANCE(554);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(463);
      if (lookahead == '/') ADVANCE(545);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '@') ADVANCE(541);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(556);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(703);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(552);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 39:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(476);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == '-') ADVANCE(539);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(65);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(68);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '@') ADVANCE(78);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == '^') ADVANCE(79);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 40:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(670);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 41:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 42:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 43:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '/') ADVANCE(543);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == ';') ADVANCE(457);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (sym_python_identifier_character_set_3(lookahead)) ADVANCE(784);
      END_STATE();
    case 44:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(681);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'w') ADVANCE(675);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 45:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(697);
      if (lookahead == 'f') ADVANCE(717);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'w') ADVANCE(675);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 46:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(696);
      if (lookahead == 'f') ADVANCE(681);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'w') ADVANCE(675);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 47:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(688);
      if (lookahead == 'f') ADVANCE(717);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'w') ADVANCE(675);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 48:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(652);
      if (lookahead == 'e') ADVANCE(698);
      if (lookahead == 'f') ADVANCE(681);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(668);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(727);
      if (lookahead == 'w') ADVANCE(675);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 49:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(666);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(732);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(699);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 50:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'i') ADVANCE(703);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 51:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 52:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(473);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (sym_python_identifier_character_set_3(lookahead)) ADVANCE(784);
      END_STATE();
    case 53:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(739);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(720);
      if (lookahead == 'p') ADVANCE(731);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 54:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == '*') ADVANCE(475);
      if (lookahead == '+') ADVANCE(534);
      if (lookahead == '-') ADVANCE(540);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '0') ADVANCE(605);
      if (lookahead == 'F') ADVANCE(635);
      if (lookahead == 'N') ADVANCE(712);
      if (lookahead == 'T') ADVANCE(726);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(736);
      if (lookahead == 'b') ADVANCE(730);
      if (lookahead == 'c') ADVANCE(715);
      if (lookahead == 'd') ADVANCE(666);
      if (lookahead == 'e') ADVANCE(758);
      if (lookahead == 'f') ADVANCE(732);
      if (lookahead == 'g') ADVANCE(691);
      if (lookahead == 'i') ADVANCE(699);
      if (lookahead == 'l') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(631);
      if (lookahead == 'n') ADVANCE(713);
      if (lookahead == 'p') ADVANCE(632);
      if (lookahead == 'r') ADVANCE(636);
      if (lookahead == 't') ADVANCE(761);
      if (lookahead == 'y') ADVANCE(678);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_1(lookahead)) ADVANCE(784);
      END_STATE();
    case 55:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == '_') ADVANCE(764);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (sym_python_identifier_character_set_4(lookahead)) ADVANCE(784);
      END_STATE();
    case 56:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '.') ADVANCE(461);
      if (lookahead == 'i') ADVANCE(771);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (sym_python_identifier_character_set_3(lookahead)) ADVANCE(784);
      END_STATE();
    case 57:
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == 'p') ADVANCE(897);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 58:
      if (lookahead == '#') ADVANCE(907);
      if (lookahead == '$') ADVANCE(327);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(59);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 59:
      if (lookahead == '#') ADVANCE(398);
      if (lookahead == '$') ADVANCE(397);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(396);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (lookahead != 0) ADVANCE(399);
      END_STATE();
    case 60:
      if (lookahead == '#') ADVANCE(381);
      if (lookahead == 'n') ADVANCE(379);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(375);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60);
      if (lookahead != 0 &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 61:
      if (lookahead == '#') ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(404);
      if (('\n' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      if (lookahead != 0) ADVANCE(406);
      END_STATE();
    case 62:
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '=') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 63:
      if (lookahead == '.') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 64:
      if (lookahead == '.') ADVANCE(589);
      END_STATE();
    case 65:
      if (lookahead == '/') ADVANCE(82);
      if (lookahead == '=') ADVANCE(577);
      END_STATE();
    case 66:
      if (lookahead == '<') ADVANCE(559);
      END_STATE();
    case 67:
      if (lookahead == '<') ADVANCE(558);
      END_STATE();
    case 68:
      if (lookahead == '<') ADVANCE(83);
      END_STATE();
    case 69:
      if (lookahead == '=') ADVANCE(565);
      END_STATE();
    case 70:
      if (lookahead == '=') ADVANCE(565);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(594);
      END_STATE();
    case 71:
      if (lookahead == '=') ADVANCE(580);
      END_STATE();
    case 72:
      if (lookahead == '=') ADVANCE(584);
      END_STATE();
    case 73:
      if (lookahead == '=') ADVANCE(368);
      END_STATE();
    case 74:
      if (lookahead == '=') ADVANCE(370);
      END_STATE();
    case 75:
      if (lookahead == '=') ADVANCE(367);
      END_STATE();
    case 76:
      if (lookahead == '=') ADVANCE(564);
      END_STATE();
    case 77:
      if (lookahead == '=') ADVANCE(365);
      if (lookahead == '?') ADVANCE(85);
      END_STATE();
    case 78:
      if (lookahead == '=') ADVANCE(578);
      END_STATE();
    case 79:
      if (lookahead == '=') ADVANCE(585);
      END_STATE();
    case 80:
      if (lookahead == '=') ADVANCE(586);
      END_STATE();
    case 81:
      if (lookahead == '=') ADVANCE(581);
      END_STATE();
    case 82:
      if (lookahead == '=') ADVANCE(579);
      END_STATE();
    case 83:
      if (lookahead == '=') ADVANCE(583);
      END_STATE();
    case 84:
      if (lookahead == '=') ADVANCE(582);
      END_STATE();
    case 85:
      if (lookahead == '=') ADVANCE(366);
      END_STATE();
    case 86:
      if (lookahead == '>') ADVANCE(456);
      END_STATE();
    case 87:
      if (lookahead == '>') ADVANCE(480);
      END_STATE();
    case 88:
      if (lookahead == '>') ADVANCE(479);
      END_STATE();
    case 89:
      if (lookahead == '>') ADVANCE(84);
      END_STATE();
    case 90:
      if (lookahead == 'A') ADVANCE(96);
      END_STATE();
    case 91:
      if (lookahead == 'A') ADVANCE(131);
      END_STATE();
    case 92:
      if (lookahead == 'B') ADVANCE(93);
      if (lookahead == '{') ADVANCE(451);
      END_STATE();
    case 93:
      if (lookahead == 'B') ADVANCE(149);
      END_STATE();
    case 94:
      if (lookahead == 'C') ADVANCE(136);
      END_STATE();
    case 95:
      if (lookahead == 'D') ADVANCE(99);
      END_STATE();
    case 96:
      if (lookahead == 'D') ADVANCE(97);
      END_STATE();
    case 97:
      if (lookahead == 'D') ADVANCE(111);
      END_STATE();
    case 98:
      if (lookahead == 'E') ADVANCE(127);
      END_STATE();
    case 99:
      if (lookahead == 'E') ADVANCE(128);
      END_STATE();
    case 100:
      if (lookahead == 'E') ADVANCE(114);
      END_STATE();
    case 101:
      if (lookahead == 'E') ADVANCE(124);
      END_STATE();
    case 102:
      if (lookahead == 'F') ADVANCE(139);
      END_STATE();
    case 103:
      if (lookahead == 'G') ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == 'H') ADVANCE(439);
      END_STATE();
    case 105:
      if (lookahead == 'H') ADVANCE(126);
      END_STATE();
    case 106:
      if (lookahead == 'H') ADVANCE(101);
      END_STATE();
    case 107:
      if (lookahead == 'I') ADVANCE(95);
      END_STATE();
    case 108:
      if (lookahead == 'I') ADVANCE(119);
      END_STATE();
    case 109:
      if (lookahead == 'I') ADVANCE(133);
      END_STATE();
    case 110:
      if (lookahead == 'I') ADVANCE(120);
      END_STATE();
    case 111:
      if (lookahead == 'I') ADVANCE(137);
      END_STATE();
    case 112:
      if (lookahead == 'N') ADVANCE(106);
      END_STATE();
    case 113:
      if (lookahead == 'N') ADVANCE(94);
      END_STATE();
    case 114:
      if (lookahead == 'N') ADVANCE(141);
      END_STATE();
    case 115:
      if (lookahead == 'N') ADVANCE(129);
      END_STATE();
    case 116:
      if (lookahead == 'N') ADVANCE(130);
      END_STATE();
    case 117:
      if (lookahead == 'O') ADVANCE(123);
      END_STATE();
    case 118:
      if (lookahead == 'O') ADVANCE(138);
      END_STATE();
    case 119:
      if (lookahead == 'O') ADVANCE(115);
      END_STATE();
    case 120:
      if (lookahead == 'O') ADVANCE(116);
      END_STATE();
    case 121:
      if (lookahead == 'P') ADVANCE(117);
      END_STATE();
    case 122:
      if (lookahead == 'P') ADVANCE(91);
      END_STATE();
    case 123:
      if (lookahead == 'R') ADVANCE(135);
      END_STATE();
    case 124:
      if (lookahead == 'R') ADVANCE(109);
      END_STATE();
    case 125:
      if (lookahead == 'R') ADVANCE(107);
      END_STATE();
    case 126:
      if (lookahead == 'R') ADVANCE(118);
      END_STATE();
    case 127:
      if (lookahead == 'R') ADVANCE(125);
      END_STATE();
    case 128:
      if (lookahead == 'S') ADVANCE(411);
      END_STATE();
    case 129:
      if (lookahead == 'S') ADVANCE(413);
      END_STATE();
    case 130:
      if (lookahead == 'S') ADVANCE(440);
      END_STATE();
    case 131:
      if (lookahead == 'S') ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'S') ADVANCE(134);
      END_STATE();
    case 133:
      if (lookahead == 'T') ADVANCE(400);
      END_STATE();
    case 134:
      if (lookahead == 'T') ADVANCE(105);
      END_STATE();
    case 135:
      if (lookahead == 'T') ADVANCE(146);
      END_STATE();
    case 136:
      if (lookahead == 'T') ADVANCE(108);
      END_STATE();
    case 137:
      if (lookahead == 'T') ADVANCE(110);
      END_STATE();
    case 138:
      if (lookahead == 'U') ADVANCE(103);
      END_STATE();
    case 139:
      if (lookahead == 'U') ADVANCE(113);
      END_STATE();
    case 140:
      if (lookahead == 'V') ADVANCE(98);
      END_STATE();
    case 141:
      if (lookahead == 'V') ADVANCE(148);
      END_STATE();
    case 142:
      if (lookahead == 'X') ADVANCE(121);
      END_STATE();
    case 143:
      if (lookahead == '_') ADVANCE(214);
      END_STATE();
    case 144:
      if (lookahead == '_') ADVANCE(332);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(608);
      END_STATE();
    case 145:
      if (lookahead == '_') ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(609);
      END_STATE();
    case 146:
      if (lookahead == '_') ADVANCE(102);
      END_STATE();
    case 147:
      if (lookahead == '_') ADVANCE(466);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(122);
      END_STATE();
    case 149:
      if (lookahead == '_') ADVANCE(100);
      END_STATE();
    case 150:
      if (lookahead == '_') ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(613);
      END_STATE();
    case 151:
      if (lookahead == '_') ADVANCE(147);
      END_STATE();
    case 152:
      if (lookahead == 'a') ADVANCE(231);
      if (lookahead == 'i') ADVANCE(259);
      if (lookahead == 'o') ADVANCE(285);
      if (lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(245);
      END_STATE();
    case 154:
      if (lookahead == 'a') ADVANCE(298);
      if (lookahead == 'r') ADVANCE(208);
      if (lookahead == 'y') ADVANCE(304);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(573);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(242);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(228);
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(312);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(225);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(297);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 164:
      if (lookahead == 'a') ADVANCE(256);
      END_STATE();
    case 165:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 166:
      if (lookahead == 'b') ADVANCE(180);
      END_STATE();
    case 167:
      if (lookahead == 'b') ADVANCE(163);
      END_STATE();
    case 168:
      if (lookahead == 'c') ADVANCE(498);
      END_STATE();
    case 169:
      if (lookahead == 'c') ADVANCE(510);
      END_STATE();
    case 170:
      if (lookahead == 'c') ADVANCE(373);
      END_STATE();
    case 171:
      if (lookahead == 'c') ADVANCE(217);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(197);
      if (lookahead == 'e') ADVANCE(168);
      if (lookahead == 'p') ADVANCE(271);
      END_STATE();
    case 173:
      if (lookahead == 'c') ADVANCE(165);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(175);
      if (lookahead == 'f') ADVANCE(315);
      if (lookahead == 'n') ADVANCE(176);
      if (lookahead == 'p') ADVANCE(277);
      if (lookahead == 's') ADVANCE(471);
      if (lookahead == 'w') ADVANCE(160);
      END_STATE();
    case 175:
      if (lookahead == 'd') ADVANCE(219);
      END_STATE();
    case 176:
      if (lookahead == 'd') ADVANCE(528);
      END_STATE();
    case 177:
      if (lookahead == 'd') ADVANCE(587);
      END_STATE();
    case 178:
      if (lookahead == 'd') ADVANCE(386);
      END_STATE();
    case 179:
      if (lookahead == 'd') ADVANCE(388);
      END_STATE();
    case 180:
      if (lookahead == 'd') ADVANCE(155);
      END_STATE();
    case 181:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(324);
      if (lookahead == 'n') ADVANCE(239);
      if (lookahead == 't') ADVANCE(525);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(627);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(623);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(508);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(599);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(625);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(486);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(514);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(419);
      END_STATE();
    case 192:
      if (lookahead == 'e') ADVANCE(390);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(492);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(215);
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 198:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 199:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 200:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 202:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 203:
      if (lookahead == 'e') ADVANCE(254);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(280);
      if (lookahead == 'i') ADVANCE(258);
      END_STATE();
    case 209:
      if (lookahead == 'f') ADVANCE(315);
      END_STATE();
    case 210:
      if (lookahead == 'f') ADVANCE(503);
      if (lookahead == 'm') ADVANCE(281);
      if (lookahead == 'n') ADVANCE(500);
      if (lookahead == 's') ADVANCE(570);
      END_STATE();
    case 211:
      if (lookahead == 'f') ADVANCE(503);
      if (lookahead == 'n') ADVANCE(500);
      if (lookahead == 's') ADVANCE(570);
      END_STATE();
    case 212:
      if (lookahead == 'f') ADVANCE(453);
      if (lookahead == 'l') ADVANCE(484);
      END_STATE();
    case 213:
      if (lookahead == 'f') ADVANCE(506);
      END_STATE();
    case 214:
      if (lookahead == 'f') ADVANCE(319);
      END_STATE();
    case 215:
      if (lookahead == 'f') ADVANCE(269);
      END_STATE();
    case 216:
      if (lookahead == 'h') ADVANCE(523);
      END_STATE();
    case 217:
      if (lookahead == 'h') ADVANCE(597);
      END_STATE();
    case 218:
      if (lookahead == 'h') ADVANCE(222);
      if (lookahead == 'i') ADVANCE(313);
      END_STATE();
    case 219:
      if (lookahead == 'h') ADVANCE(164);
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(273);
      END_STATE();
    case 221:
      if (lookahead == 'i') ADVANCE(199);
      END_STATE();
    case 222:
      if (lookahead == 'i') ADVANCE(240);
      END_STATE();
    case 223:
      if (lookahead == 'i') ADVANCE(213);
      if (lookahead == 's') ADVANCE(186);
      END_STATE();
    case 224:
      if (lookahead == 'i') ADVANCE(313);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 226:
      if (lookahead == 'i') ADVANCE(260);
      END_STATE();
    case 227:
      if (lookahead == 'i') ADVANCE(294);
      END_STATE();
    case 228:
      if (lookahead == 'i') ADVANCE(302);
      END_STATE();
    case 229:
      if (lookahead == 'k') ADVANCE(490);
      END_STATE();
    case 230:
      if (lookahead == 'k') ADVANCE(415);
      END_STATE();
    case 231:
      if (lookahead == 'k') ADVANCE(204);
      END_STATE();
    case 232:
      if (lookahead == 'l') ADVANCE(223);
      if (lookahead == 'x') ADVANCE(172);
      END_STATE();
    case 233:
      if (lookahead == 'l') ADVANCE(494);
      END_STATE();
    case 234:
      if (lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 235:
      if (lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 236:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 237:
      if (lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 238:
      if (lookahead == 'l') ADVANCE(235);
      END_STATE();
    case 239:
      if (lookahead == 'l') ADVANCE(270);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 241:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 242:
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 243:
      if (lookahead == 'l') ADVANCE(299);
      END_STATE();
    case 244:
      if (lookahead == 'm') ADVANCE(464);
      END_STATE();
    case 245:
      if (lookahead == 'm') ADVANCE(166);
      END_STATE();
    case 246:
      if (lookahead == 'm') ADVANCE(263);
      if (lookahead == 'q') ADVANCE(318);
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(426);
      END_STATE();
    case 248:
      if (lookahead == 'n') ADVANCE(482);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(176);
      if (lookahead == 's') ADVANCE(471);
      END_STATE();
    case 250:
      if (lookahead == 'n') ADVANCE(176);
      if (lookahead == 's') ADVANCE(469);
      END_STATE();
    case 251:
      if (lookahead == 'n') ADVANCE(300);
      END_STATE();
    case 252:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 253:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 255:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(181);
      END_STATE();
    case 257:
      if (lookahead == 'n') ADVANCE(179);
      END_STATE();
    case 258:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(162);
      END_STATE();
    case 260:
      if (lookahead == 'n') ADVANCE(321);
      END_STATE();
    case 261:
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 262:
      if (lookahead == 'o') ADVANCE(167);
      END_STATE();
    case 263:
      if (lookahead == 'o') ADVANCE(323);
      END_STATE();
    case 264:
      if (lookahead == 'o') ADVANCE(253);
      END_STATE();
    case 265:
      if (lookahead == 'o') ADVANCE(244);
      END_STATE();
    case 266:
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 267:
      if (lookahead == 'o') ADVANCE(285);
      if (lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 268:
      if (lookahead == 'o') ADVANCE(255);
      END_STATE();
    case 269:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 270:
      if (lookahead == 'o') ADVANCE(173);
      END_STATE();
    case 271:
      if (lookahead == 'o') ADVANCE(291);
      END_STATE();
    case 272:
      if (lookahead == 'o') ADVANCE(274);
      END_STATE();
    case 273:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 274:
      if (lookahead == 'o') ADVANCE(311);
      END_STATE();
    case 275:
      if (lookahead == 'o') ADVANCE(303);
      END_STATE();
    case 276:
      if (lookahead == 'o') ADVANCE(292);
      END_STATE();
    case 277:
      if (lookahead == 'p') ADVANCE(203);
      END_STATE();
    case 278:
      if (lookahead == 'p') ADVANCE(308);
      END_STATE();
    case 279:
      if (lookahead == 'p') ADVANCE(187);
      END_STATE();
    case 280:
      if (lookahead == 'p') ADVANCE(206);
      END_STATE();
    case 281:
      if (lookahead == 'p') ADVANCE(276);
      END_STATE();
    case 282:
      if (lookahead == 'r') ADVANCE(317);
      END_STATE();
    case 283:
      if (lookahead == 'r') ADVANCE(531);
      END_STATE();
    case 284:
      if (lookahead == 'r') ADVANCE(325);
      if (lookahead == 'y') ADVANCE(279);
      END_STATE();
    case 285:
      if (lookahead == 'r') ADVANCE(512);
      END_STATE();
    case 286:
      if (lookahead == 'r') ADVANCE(417);
      END_STATE();
    case 287:
      if (lookahead == 'r') ADVANCE(422);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 289:
      if (lookahead == 'r') ADVANCE(272);
      END_STATE();
    case 290:
      if (lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 291:
      if (lookahead == 'r') ADVANCE(309);
      END_STATE();
    case 292:
      if (lookahead == 'r') ADVANCE(310);
      END_STATE();
    case 293:
      if (lookahead == 'r') ADVANCE(191);
      END_STATE();
    case 294:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 295:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 296:
      if (lookahead == 's') ADVANCE(488);
      END_STATE();
    case 297:
      if (lookahead == 's') ADVANCE(230);
      END_STATE();
    case 298:
      if (lookahead == 's') ADVANCE(296);
      END_STATE();
    case 299:
      if (lookahead == 's') ADVANCE(186);
      END_STATE();
    case 300:
      if (lookahead == 's') ADVANCE(207);
      END_STATE();
    case 301:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 302:
      if (lookahead == 's') ADVANCE(189);
      END_STATE();
    case 303:
      if (lookahead == 't') ADVANCE(525);
      END_STATE();
    case 304:
      if (lookahead == 't') ADVANCE(220);
      END_STATE();
    case 305:
      if (lookahead == 't') ADVANCE(595);
      END_STATE();
    case 306:
      if (lookahead == 't') ADVANCE(477);
      END_STATE();
    case 307:
      if (lookahead == 't') ADVANCE(392);
      END_STATE();
    case 308:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(409);
      END_STATE();
    case 310:
      if (lookahead == 't') ADVANCE(458);
      END_STATE();
    case 311:
      if (lookahead == 't') ADVANCE(424);
      END_STATE();
    case 312:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 313:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 314:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 315:
      if (lookahead == 't') ADVANCE(198);
      END_STATE();
    case 316:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 317:
      if (lookahead == 'u') ADVANCE(185);
      END_STATE();
    case 318:
      if (lookahead == 'u') ADVANCE(227);
      END_STATE();
    case 319:
      if (lookahead == 'u') ADVANCE(316);
      END_STATE();
    case 320:
      if (lookahead == 'u') ADVANCE(290);
      END_STATE();
    case 321:
      if (lookahead == 'u') ADVANCE(194);
      END_STATE();
    case 322:
      if (lookahead == 'u') ADVANCE(295);
      END_STATE();
    case 323:
      if (lookahead == 'v') ADVANCE(192);
      END_STATE();
    case 324:
      if (lookahead == 'x') ADVANCE(200);
      END_STATE();
    case 325:
      if (lookahead == 'y') ADVANCE(516);
      END_STATE();
    case 326:
      if (lookahead == 'y') ADVANCE(521);
      END_STATE();
    case 327:
      if (lookahead == '{') ADVANCE(451);
      END_STATE();
    case 328:
      if (lookahead == '{') ADVANCE(350);
      END_STATE();
    case 329:
      if (lookahead == '{') ADVANCE(450);
      END_STATE();
    case 330:
      if (lookahead == '}') ADVANCE(590);
      if (lookahead != 0) ADVANCE(330);
      END_STATE();
    case 331:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(617);
      END_STATE();
    case 332:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(608);
      END_STATE();
    case 333:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(435);
      if (lookahead == '\r') ADVANCE(435);
      if (lookahead == '"') ADVANCE(402);
      if (lookahead == '#') ADVANCE(433);
      if (lookahead == '$') ADVANCE(441);
      if (lookahead == '\\') ADVANCE(437);
      if (lookahead != 0) ADVANCE(436);
      END_STATE();
    case 334:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(444);
      if (lookahead == '\r') ADVANCE(444);
      if (lookahead == '"') ADVANCE(446);
      if (lookahead == '#') ADVANCE(443);
      if (lookahead == '$') ADVANCE(92);
      if (lookahead == '\'') ADVANCE(442);
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead != 0) ADVANCE(447);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(609);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(590);
      END_STATE();
    case 337:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(617);
      END_STATE();
    case 338:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(336);
      END_STATE();
    case 339:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(590);
      END_STATE();
    case 340:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(613);
      END_STATE();
    case 341:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(339);
      END_STATE();
    case 342:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(341);
      END_STATE();
    case 343:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(342);
      END_STATE();
    case 344:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(343);
      END_STATE();
    case 345:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(344);
      END_STATE();
    case 346:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(345);
      END_STATE();
    case 347:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(346);
      END_STATE();
    case 348:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(594);
      END_STATE();
    case 349:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 350:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(330);
      END_STATE();
    case 351:
      if (eof) ADVANCE(353);
      if (!eof && lookahead == 0) ADVANCE(359);
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '"') ADVANCE(402);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(441);
      if (lookahead == '%') ADVANCE(547);
      if (lookahead == '&') ADVANCE(555);
      if (lookahead == '\'') ADVANCE(442);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == '*') ADVANCE(474);
      if (lookahead == '+') ADVANCE(535);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '-') ADVANCE(538);
      if (lookahead == '.') ADVANCE(462);
      if (lookahead == '/') ADVANCE(544);
      if (lookahead == '0') ADVANCE(604);
      if (lookahead == ':') ADVANCE(385);
      if (lookahead == ';') ADVANCE(457);
      if (lookahead == '<') ADVANCE(561);
      if (lookahead == '=') ADVANCE(363);
      if (lookahead == '>') ADVANCE(567);
      if (lookahead == '?') ADVANCE(77);
      if (lookahead == '@') ADVANCE(542);
      if (lookahead == 'E') ADVANCE(142);
      if (lookahead == 'F') ADVANCE(156);
      if (lookahead == 'I') ADVANCE(112);
      if (lookahead == 'N') ADVANCE(264);
      if (lookahead == 'O') ADVANCE(140);
      if (lookahead == 'T') ADVANCE(282);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == ']') ADVANCE(383);
      if (lookahead == '^') ADVANCE(557);
      if (lookahead == '_') ADVANCE(143);
      if (lookahead == 'a') ADVANCE(174);
      if (lookahead == 'b') ADVANCE(196);
      if (lookahead == 'c') ADVANCE(268);
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(232);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'g') ADVANCE(236);
      if (lookahead == 'i') ADVANCE(210);
      if (lookahead == 'l') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(158);
      if (lookahead == 'n') ADVANCE(261);
      if (lookahead == 'o') ADVANCE(283);
      if (lookahead == 'p') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(157);
      if (lookahead == 't') ADVANCE(284);
      if (lookahead == 'u') ADVANCE(251);
      if (lookahead == 'w') ADVANCE(218);
      if (lookahead == 'y') ADVANCE(221);
      if (lookahead == '{') ADVANCE(431);
      if (lookahead == '|') ADVANCE(553);
      if (lookahead == '}') ADVANCE(432);
      if (lookahead == '~') ADVANCE(560);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(351);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(602);
      END_STATE();
    case 352:
      if (eof) ADVANCE(353);
      if (lookahead == '!') ADVANCE(348);
      if (lookahead == '"') ADVANCE(401);
      if (lookahead == '#') ADVANCE(908);
      if (lookahead == '$') ADVANCE(329);
      if (lookahead == '(') ADVANCE(429);
      if (lookahead == ')') ADVANCE(430);
      if (lookahead == ',') ADVANCE(468);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == ':') ADVANCE(384);
      if (lookahead == '=') ADVANCE(361);
      if (lookahead == 'E') ADVANCE(807);
      if (lookahead == 'O') ADVANCE(806);
      if (lookahead == '[') ADVANCE(372);
      if (lookahead == 'a') ADVANCE(817);
      if (lookahead == 'd') ADVANCE(820);
      if (lookahead == 'e') ADVANCE(878);
      if (lookahead == 'f') ADVANCE(809);
      if (lookahead == 'i') ADVANCE(844);
      if (lookahead == 'p') ADVANCE(879);
      if (lookahead == 'r') ADVANCE(821);
      if (lookahead == 'u') ADVANCE(845);
      if (lookahead == '}') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(352);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(354);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(355);
      if (lookahead == '\r') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(6);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(356);
      if (lookahead == '\r') ADVANCE(2);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(357);
      if (lookahead == '\r') ADVANCE(3);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_recipe_token1);
      if (lookahead == '\n') ADVANCE(358);
      if (lookahead == '\r') ADVANCE(4);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_NULL);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '+') ADVANCE(369);
      if (lookahead == '.') ADVANCE(371);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '+') ADVANCE(369);
      if (lookahead == '.') ADVANCE(371);
      if (lookahead == '=') ADVANCE(564);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(564);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_QMARK_EQ);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_EQ_PLUS);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_EQ_DOT);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_noexec);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_noexec);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == '#') ADVANCE(381);
      if (lookahead == 'n') ADVANCE(379);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(375);
      if (lookahead != 0 &&
          (lookahead < '\n' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'c') ADVANCE(374);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'e') ADVANCE(380);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'e') ADVANCE(376);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'o') ADVANCE(377);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == 'x') ADVANCE(378);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ']') ADVANCE(908);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(381);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(aux_sym_variable_flag_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ']') ADVANCE(382);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(367);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_append);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_append);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_prepend);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_prepend);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_remove);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_inherit);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_inherit_path);
      if (!eof && lookahead == 0) ADVANCE(360);
      if (lookahead == '\n') ADVANCE(355);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == '#') ADVANCE(398);
      if (lookahead == '$') ADVANCE(397);
      if (('\t' <= lookahead && lookahead <= '\f')) ADVANCE(395);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead == '#') ADVANCE(398);
      if (lookahead == '$') ADVANCE(397);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(396);
      if (lookahead != 0 &&
          (lookahead < '\n' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead == '{') ADVANCE(452);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead == '\r' ||
          lookahead == ' ') ADVANCE(908);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(398);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_inherit_path);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_INHERIT);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(31);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_include);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '#') ADVANCE(405);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f') ADVANCE(404);
      if (lookahead != 0 &&
          (lookahead < '\n' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(406);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead == '\r' ||
          lookahead == ' ') ADVANCE(908);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(405);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_include_directive_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(406);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_OVERRIDES);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_OVERRIDES);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_EXPORT_FUNCTIONS);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_EXPORT_FUNCTIONS);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_addtask);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_addtask);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_after);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_after);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_before);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_before);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_deltask);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_addhandler);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_addhandler);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_fakeroot);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_fakeroot);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_python);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_python);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_python);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(436);
      if (lookahead == '\r') ADVANCE(433);
      if (lookahead == '\\') ADVANCE(434);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$') ADVANCE(433);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(436);
      if (lookahead == '\r') ADVANCE(433);
      if (lookahead == '\\') ADVANCE(434);
      if (lookahead != 0) ADVANCE(433);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(435);
      if (lookahead == '\r') ADVANCE(435);
      if (lookahead == '#') ADVANCE(433);
      if (lookahead == '\\') ADVANCE(437);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead)) ADVANCE(436);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(436);
      if (lookahead == '\r') ADVANCE(436);
      if (lookahead == '\\') ADVANCE(437);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(436);
      if (lookahead == '\r') ADVANCE(436);
      if (lookahead == '\\') ADVANCE(437);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_DOLLARBB_ENV_PASSTHROUGH);
      if (lookahead == '_') ADVANCE(90);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == 'B') ADVANCE(93);
      if (lookahead == '{') ADVANCE(451);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead == '\n') ADVANCE(447);
      if (lookahead == '\r') ADVANCE(443);
      if (lookahead == '\\') ADVANCE(905);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(443);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(444);
      if (lookahead == '\r') ADVANCE(444);
      if (lookahead == '"') ADVANCE(446);
      if (lookahead == '#') ADVANCE(443);
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(447);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(447);
      if (lookahead == '\r') ADVANCE(447);
      if (lookahead == '"') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(445);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == '"') ADVANCE(447);
      if (lookahead == '\r') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '\'') ADVANCE(445);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(aux_sym_string_token3);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '$' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(447);
      if (lookahead == '\r') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(9);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE_AT);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE_AT);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '@') ADVANCE(448);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      if (lookahead == '@') ADVANCE(449);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(399);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_import);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_import);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '=') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_from);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym___future__);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'y') ADVANCE(704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(252);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_as);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(551);
      if (lookahead == '=') ADVANCE(576);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(550);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(81);
      if (lookahead == '=') ADVANCE(576);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_print);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(582);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_assert);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_return);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_del);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_raise);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_pass);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_break);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_continue);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_global);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_exec);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_in);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_if);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_try);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '*') ADVANCE(520);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_except_STAR);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_finally);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_with);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_not);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_and);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_or);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(368);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(575);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(575);
      if (lookahead == '>') ADVANCE(456);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(575);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(578);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(549);
      if (lookahead == '=') ADVANCE(577);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(548);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(580);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(579);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(581);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(586);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(584);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(585);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(583);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(559);
      if (lookahead == '=') ADVANCE(563);
      if (lookahead == '>') ADVANCE(569);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(558);
      if (lookahead == '=') ADVANCE(563);
      if (lookahead == '>') ADVANCE(569);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(566);
      if (lookahead == '>') ADVANCE(480);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(566);
      if (lookahead == '>') ADVANCE(479);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_is);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_lambda);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_yield);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(590);
      if (lookahead == '\r') ADVANCE(7);
      if (lookahead == 'N') ADVANCE(328);
      if (lookahead == 'U') ADVANCE(347);
      if (lookahead == 'u') ADVANCE(343);
      if (lookahead == 'x') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(338);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '#') ADVANCE(593);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(592);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(593);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(593);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_await);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_match);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(619);
      if (lookahead == '_') ADVANCE(606);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(331);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(602);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(619);
      if (lookahead == '_') ADVANCE(607);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(785);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(614);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(619);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(144);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(145);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(150);
      if (lookahead == '_') ADVANCE(606);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(331);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(602);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(619);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(881);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(882);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(883);
      if (lookahead == '_') ADVANCE(607);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(785);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(614);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(619);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(331);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(602);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(619);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(785);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(614);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(603);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(332);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(601);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(608);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(335);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(609);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(898);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(614);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(610);
      if (lookahead == '-' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(899);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(614);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(611);
      if (lookahead == '-' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(901);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(614);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(612);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(340);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(613);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(619);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(331);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(615);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(620);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(615);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(617);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(621);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(622);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(331);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(615);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(616);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(615);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(617);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(622);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_none);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '*') ADVANCE(520);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(701);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(753);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(738);
      if (lookahead == 'r') ADVANCE(682);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(684);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(574);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(689);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(683);
      if (lookahead == 'e') ADVANCE(752);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(686);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(680);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(687);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'a') ADVANCE(694);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'b') ADVANCE(651);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'b') ADVANCE(637);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'c') ADVANCE(499);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'c') ADVANCE(511);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'c') ADVANCE(674);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'c') ADVANCE(662);
      if (lookahead == 'e') ADVANCE(643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'c') ADVANCE(667);
      if (lookahead == 'e') ADVANCE(643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'c') ADVANCE(639);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'd') ADVANCE(588);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'd') ADVANCE(529);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'd') ADVANCE(634);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(671);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(628);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(624);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(600);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(626);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(487);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(515);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(493);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(509);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(724);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(734);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(690);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(633);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(685);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'e') ADVANCE(725);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'f') ADVANCE(504);
      if (lookahead == 'm') ADVANCE(722);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'f') ADVANCE(504);
      if (lookahead == 'n') ADVANCE(501);
      if (lookahead == 's') ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'f') ADVANCE(504);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'f') ADVANCE(454);
      if (lookahead == 'l') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'f') ADVANCE(507);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'h') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'h') ADVANCE(598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'h') ADVANCE(677);
      if (lookahead == 'i') ADVANCE(745);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(672);
      if (lookahead == 's') ADVANCE(661);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(695);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(664);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(710);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(746);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(711);
      if (lookahead == 'o') ADVANCE(728);
      if (lookahead == 'r') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(708);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'i') ADVANCE(742);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'k') ADVANCE(491);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(495);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(497);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(676);
      if (lookahead == 'x') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(741);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(649);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(714);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(760);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(719);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(692);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(659);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(743);
      if (lookahead == 'x') ADVANCE(646);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(743);
      if (lookahead == 'x') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'l') ADVANCE(743);
      if (lookahead == 'x') ADVANCE(647);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'm') ADVANCE(722);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'm') ADVANCE(465);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'm') ADVANCE(641);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(483);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(501);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(644);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(650);
      if (lookahead == 's') ADVANCE(470);
      if (lookahead == 'w') ADVANCE(638);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(754);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(747);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(693);
      if (lookahead == 't') ADVANCE(526);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(757);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'n') ADVANCE(640);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(707);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(709);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(642);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(700);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(728);
      if (lookahead == 'r') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(728);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(648);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(744);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'o') ADVANCE(735);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'p') ADVANCE(721);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'p') ADVANCE(656);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'p') ADVANCE(750);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'p') ADVANCE(751);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(756);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(759);
      if (lookahead == 'y') ADVANCE(723);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(513);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(532);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(665);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(682);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(748);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'r') ADVANCE(749);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(740);
      if (lookahead == 'w') ADVANCE(638);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(489);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(737);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(762);
      if (lookahead == 'w') ADVANCE(638);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(663);
      if (lookahead == 'y') ADVANCE(704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(657);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(658);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 's') ADVANCE(661);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(526);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(673);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(596);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(478);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(481);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(459);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(519);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(629);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(755);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(645);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 't') ADVANCE(679);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'u') ADVANCE(733);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'u') ADVANCE(655);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'u') ADVANCE(660);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'x') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'y') ADVANCE(517);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'y') ADVANCE(522);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'y') ADVANCE(723);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (lookahead == 'y') ADVANCE(704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '-') ADVANCE(902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(763);
      if (sym_python_identifier_character_set_5(lookahead)) ADVANCE(784);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '_') ADVANCE(770);
      if (sym_python_identifier_character_set_7(lookahead)) ADVANCE(784);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '_') ADVANCE(467);
      if (sym_python_identifier_character_set_7(lookahead)) ADVANCE(784);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == '_') ADVANCE(765);
      if (sym_python_identifier_character_set_7(lookahead)) ADVANCE(784);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'd') ADVANCE(530);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'e') ADVANCE(766);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'f') ADVANCE(505);
      if (lookahead == 'n') ADVANCE(502);
      if (lookahead == 's') ADVANCE(572);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'f') ADVANCE(783);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'm') ADVANCE(775);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'n') ADVANCE(767);
      if (lookahead == 's') ADVANCE(472);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'o') ADVANCE(779);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'o') ADVANCE(778);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'p') ADVANCE(774);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'r') ADVANCE(533);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'r') ADVANCE(768);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'r') ADVANCE(780);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 't') ADVANCE(527);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 't') ADVANCE(460);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 't') ADVANCE(782);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'u') ADVANCE(777);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym_python_identifier);
      if (lookahead == 'u') ADVANCE(781);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym_python_identifier);
      if (sym_python_identifier_character_set_6(lookahead)) ADVANCE(784);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '+') ADVANCE(337);
      if (lookahead == '-') ADVANCE(900);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'C') ADVANCE(804);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'D') ADVANCE(789);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'E') ADVANCE(800);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'E') ADVANCE(801);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'F') ADVANCE(805);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'I') ADVANCE(787);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'I') ADVANCE(796);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'N') ADVANCE(786);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'N') ADVANCE(802);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'O') ADVANCE(798);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'O') ADVANCE(794);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'P') ADVANCE(795);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'R') ADVANCE(803);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'R') ADVANCE(791);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'R') ADVANCE(799);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'S') ADVANCE(412);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'S') ADVANCE(414);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'T') ADVANCE(808);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'T') ADVANCE(792);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'U') ADVANCE(793);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'V') ADVANCE(788);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'X') ADVANCE(797);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '_') ADVANCE(790);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(840);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(866);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(847);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'a') ADVANCE(867);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'c') ADVANCE(841);
      if (lookahead == 'h') ADVANCE(828);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'd') ADVANCE(834);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'd') ADVANCE(387);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'd') ADVANCE(389);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'd') ADVANCE(814);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'd') ADVANCE(842);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'd') ADVANCE(822);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(833);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(859);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(403);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(408);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(843);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(391);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(862);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(870);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(861);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(860);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(848);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'e') ADVANCE(858);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'f') ADVANCE(455);
      if (lookahead == 'l') ADVANCE(874);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'h') ADVANCE(811);
      if (lookahead == 't') ADVANCE(810);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'h') ADVANCE(852);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'i') ADVANCE(864);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'i') ADVANCE(872);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'k') ADVANCE(416);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'k') ADVANCE(421);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'k') ADVANCE(826);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'l') ADVANCE(876);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'l') ADVANCE(829);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'm') ADVANCE(851);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'n') ADVANCE(813);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'n') ADVANCE(868);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'n') ADVANCE(427);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'n') ADVANCE(818);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'n') ADVANCE(815);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'n') ADVANCE(816);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'o') ADVANCE(863);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'o') ADVANCE(877);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'o') ADVANCE(846);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'o') ADVANCE(854);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'o') ADVANCE(873);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'p') ADVANCE(850);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'p') ADVANCE(857);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'p') ADVANCE(830);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'p') ADVANCE(831);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'q') ADVANCE(875);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'r') ADVANCE(423);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'r') ADVANCE(837);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'r') ADVANCE(853);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'r') ADVANCE(871);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'r') ADVANCE(823);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'r') ADVANCE(832);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 's') ADVANCE(838);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 's') ADVANCE(839);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 's') ADVANCE(827);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 't') ADVANCE(835);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 't') ADVANCE(393);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 't') ADVANCE(410);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 't') ADVANCE(394);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 't') ADVANCE(425);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 't') ADVANCE(812);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'u') ADVANCE(836);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'u') ADVANCE(819);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'v') ADVANCE(825);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'x') ADVANCE(855);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == 'y') ADVANCE(869);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(904);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(880);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(898);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(610);
      if (lookahead == '-' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(899);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(611);
      if (lookahead == '-' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(901);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(612);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(893);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(420);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(888);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(895);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(892);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(891);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(428);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(890);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(894);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(418);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(885);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(884);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(889);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(896);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(610);
      if (lookahead == '-' ||
          ('2' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(611);
      if (lookahead == '-' ||
          lookahead == '8' ||
          lookahead == '9' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(618);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(612);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(902);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(aux_sym__dotted_identifier_token1);
      if (lookahead == '=') ADVANCE(370);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(904);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(aux_sym__dotted_identifier_token1);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(904);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(447);
      if (lookahead == '\r') ADVANCE(906);
      if (lookahead != 0) ADVANCE(908);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(447);
      if (lookahead != 0) ADVANCE(908);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r' ||
          lookahead == ' ') ADVANCE(908);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(398);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(908);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 352, .external_lex_state = 2},
  [2] = {.lex_state = 33, .external_lex_state = 3},
  [3] = {.lex_state = 33, .external_lex_state = 3},
  [4] = {.lex_state = 33, .external_lex_state = 3},
  [5] = {.lex_state = 33, .external_lex_state = 3},
  [6] = {.lex_state = 33, .external_lex_state = 3},
  [7] = {.lex_state = 33, .external_lex_state = 3},
  [8] = {.lex_state = 33, .external_lex_state = 3},
  [9] = {.lex_state = 33, .external_lex_state = 3},
  [10] = {.lex_state = 33, .external_lex_state = 3},
  [11] = {.lex_state = 33, .external_lex_state = 3},
  [12] = {.lex_state = 33, .external_lex_state = 3},
  [13] = {.lex_state = 33, .external_lex_state = 3},
  [14] = {.lex_state = 33, .external_lex_state = 3},
  [15] = {.lex_state = 33, .external_lex_state = 3},
  [16] = {.lex_state = 33, .external_lex_state = 3},
  [17] = {.lex_state = 33, .external_lex_state = 3},
  [18] = {.lex_state = 33, .external_lex_state = 3},
  [19] = {.lex_state = 33, .external_lex_state = 3},
  [20] = {.lex_state = 33, .external_lex_state = 3},
  [21] = {.lex_state = 33, .external_lex_state = 3},
  [22] = {.lex_state = 33, .external_lex_state = 3},
  [23] = {.lex_state = 33, .external_lex_state = 3},
  [24] = {.lex_state = 33, .external_lex_state = 3},
  [25] = {.lex_state = 33, .external_lex_state = 3},
  [26] = {.lex_state = 33, .external_lex_state = 3},
  [27] = {.lex_state = 33, .external_lex_state = 3},
  [28] = {.lex_state = 33, .external_lex_state = 3},
  [29] = {.lex_state = 33, .external_lex_state = 3},
  [30] = {.lex_state = 33, .external_lex_state = 3},
  [31] = {.lex_state = 33, .external_lex_state = 3},
  [32] = {.lex_state = 33, .external_lex_state = 3},
  [33] = {.lex_state = 33, .external_lex_state = 3},
  [34] = {.lex_state = 33, .external_lex_state = 3},
  [35] = {.lex_state = 33, .external_lex_state = 3},
  [36] = {.lex_state = 54, .external_lex_state = 4},
  [37] = {.lex_state = 21, .external_lex_state = 5},
  [38] = {.lex_state = 21, .external_lex_state = 5},
  [39] = {.lex_state = 54, .external_lex_state = 4},
  [40] = {.lex_state = 49, .external_lex_state = 4},
  [41] = {.lex_state = 49, .external_lex_state = 4},
  [42] = {.lex_state = 49, .external_lex_state = 4},
  [43] = {.lex_state = 49, .external_lex_state = 4},
  [44] = {.lex_state = 49, .external_lex_state = 4},
  [45] = {.lex_state = 49, .external_lex_state = 4},
  [46] = {.lex_state = 49, .external_lex_state = 4},
  [47] = {.lex_state = 49, .external_lex_state = 4},
  [48] = {.lex_state = 49, .external_lex_state = 4},
  [49] = {.lex_state = 49, .external_lex_state = 4},
  [50] = {.lex_state = 49, .external_lex_state = 4},
  [51] = {.lex_state = 49, .external_lex_state = 4},
  [52] = {.lex_state = 49, .external_lex_state = 4},
  [53] = {.lex_state = 49, .external_lex_state = 4},
  [54] = {.lex_state = 49, .external_lex_state = 4},
  [55] = {.lex_state = 49, .external_lex_state = 4},
  [56] = {.lex_state = 49, .external_lex_state = 4},
  [57] = {.lex_state = 49, .external_lex_state = 4},
  [58] = {.lex_state = 49, .external_lex_state = 4},
  [59] = {.lex_state = 49, .external_lex_state = 4},
  [60] = {.lex_state = 49, .external_lex_state = 4},
  [61] = {.lex_state = 49, .external_lex_state = 5},
  [62] = {.lex_state = 49, .external_lex_state = 5},
  [63] = {.lex_state = 49, .external_lex_state = 5},
  [64] = {.lex_state = 49, .external_lex_state = 5},
  [65] = {.lex_state = 49, .external_lex_state = 5},
  [66] = {.lex_state = 49, .external_lex_state = 5},
  [67] = {.lex_state = 49, .external_lex_state = 5},
  [68] = {.lex_state = 49, .external_lex_state = 5},
  [69] = {.lex_state = 49, .external_lex_state = 5},
  [70] = {.lex_state = 49, .external_lex_state = 5},
  [71] = {.lex_state = 49, .external_lex_state = 5},
  [72] = {.lex_state = 49, .external_lex_state = 5},
  [73] = {.lex_state = 49, .external_lex_state = 5},
  [74] = {.lex_state = 49, .external_lex_state = 5},
  [75] = {.lex_state = 49, .external_lex_state = 5},
  [76] = {.lex_state = 49, .external_lex_state = 5},
  [77] = {.lex_state = 49, .external_lex_state = 5},
  [78] = {.lex_state = 49, .external_lex_state = 5},
  [79] = {.lex_state = 49, .external_lex_state = 6},
  [80] = {.lex_state = 22, .external_lex_state = 5},
  [81] = {.lex_state = 22, .external_lex_state = 5},
  [82] = {.lex_state = 23, .external_lex_state = 5},
  [83] = {.lex_state = 12, .external_lex_state = 7},
  [84] = {.lex_state = 12, .external_lex_state = 7},
  [85] = {.lex_state = 12, .external_lex_state = 5},
  [86] = {.lex_state = 13, .external_lex_state = 5},
  [87] = {.lex_state = 13, .external_lex_state = 7},
  [88] = {.lex_state = 25, .external_lex_state = 7},
  [89] = {.lex_state = 13, .external_lex_state = 5},
  [90] = {.lex_state = 25, .external_lex_state = 8},
  [91] = {.lex_state = 29, .external_lex_state = 5},
  [92] = {.lex_state = 13, .external_lex_state = 7},
  [93] = {.lex_state = 12, .external_lex_state = 8},
  [94] = {.lex_state = 25, .external_lex_state = 7},
  [95] = {.lex_state = 25, .external_lex_state = 8},
  [96] = {.lex_state = 29, .external_lex_state = 5},
  [97] = {.lex_state = 25, .external_lex_state = 8},
  [98] = {.lex_state = 37, .external_lex_state = 5},
  [99] = {.lex_state = 13, .external_lex_state = 8},
  [100] = {.lex_state = 37, .external_lex_state = 5},
  [101] = {.lex_state = 29, .external_lex_state = 5},
  [102] = {.lex_state = 28, .external_lex_state = 7},
  [103] = {.lex_state = 12, .external_lex_state = 8},
  [104] = {.lex_state = 12, .external_lex_state = 9},
  [105] = {.lex_state = 13, .external_lex_state = 8},
  [106] = {.lex_state = 25, .external_lex_state = 9},
  [107] = {.lex_state = 25, .external_lex_state = 9},
  [108] = {.lex_state = 25, .external_lex_state = 8},
  [109] = {.lex_state = 28, .external_lex_state = 7},
  [110] = {.lex_state = 25, .external_lex_state = 9},
  [111] = {.lex_state = 12, .external_lex_state = 6},
  [112] = {.lex_state = 25, .external_lex_state = 8},
  [113] = {.lex_state = 25, .external_lex_state = 9},
  [114] = {.lex_state = 25, .external_lex_state = 8},
  [115] = {.lex_state = 12, .external_lex_state = 8},
  [116] = {.lex_state = 13, .external_lex_state = 9},
  [117] = {.lex_state = 13, .external_lex_state = 6},
  [118] = {.lex_state = 13, .external_lex_state = 9},
  [119] = {.lex_state = 13, .external_lex_state = 6},
  [120] = {.lex_state = 12, .external_lex_state = 7},
  [121] = {.lex_state = 12, .external_lex_state = 9},
  [122] = {.lex_state = 25, .external_lex_state = 9},
  [123] = {.lex_state = 30, .external_lex_state = 6},
  [124] = {.lex_state = 37, .external_lex_state = 6},
  [125] = {.lex_state = 37, .external_lex_state = 6},
  [126] = {.lex_state = 30, .external_lex_state = 6},
  [127] = {.lex_state = 30, .external_lex_state = 6},
  [128] = {.lex_state = 41, .external_lex_state = 6},
  [129] = {.lex_state = 41, .external_lex_state = 9},
  [130] = {.lex_state = 41, .external_lex_state = 8},
  [131] = {.lex_state = 41, .external_lex_state = 8},
  [132] = {.lex_state = 41, .external_lex_state = 9},
  [133] = {.lex_state = 41, .external_lex_state = 6},
  [134] = {.lex_state = 41, .external_lex_state = 8},
  [135] = {.lex_state = 53, .external_lex_state = 7},
  [136] = {.lex_state = 41, .external_lex_state = 9},
  [137] = {.lex_state = 41, .external_lex_state = 9},
  [138] = {.lex_state = 53, .external_lex_state = 7},
  [139] = {.lex_state = 41, .external_lex_state = 8},
  [140] = {.lex_state = 53, .external_lex_state = 7},
  [141] = {.lex_state = 41, .external_lex_state = 8},
  [142] = {.lex_state = 41, .external_lex_state = 8},
  [143] = {.lex_state = 41, .external_lex_state = 9},
  [144] = {.lex_state = 41, .external_lex_state = 9},
  [145] = {.lex_state = 53, .external_lex_state = 7},
  [146] = {.lex_state = 53, .external_lex_state = 7},
  [147] = {.lex_state = 41, .external_lex_state = 8},
  [148] = {.lex_state = 41, .external_lex_state = 9},
  [149] = {.lex_state = 53, .external_lex_state = 7},
  [150] = {.lex_state = 53, .external_lex_state = 7},
  [151] = {.lex_state = 41, .external_lex_state = 9},
  [152] = {.lex_state = 53, .external_lex_state = 7},
  [153] = {.lex_state = 41, .external_lex_state = 8},
  [154] = {.lex_state = 41, .external_lex_state = 9},
  [155] = {.lex_state = 41, .external_lex_state = 9},
  [156] = {.lex_state = 41, .external_lex_state = 9},
  [157] = {.lex_state = 41, .external_lex_state = 8},
  [158] = {.lex_state = 41, .external_lex_state = 6},
  [159] = {.lex_state = 41, .external_lex_state = 8},
  [160] = {.lex_state = 41, .external_lex_state = 8},
  [161] = {.lex_state = 39, .external_lex_state = 5},
  [162] = {.lex_state = 39, .external_lex_state = 5},
  [163] = {.lex_state = 41, .external_lex_state = 6},
  [164] = {.lex_state = 41, .external_lex_state = 6},
  [165] = {.lex_state = 42, .external_lex_state = 6},
  [166] = {.lex_state = 17, .external_lex_state = 7},
  [167] = {.lex_state = 42, .external_lex_state = 8},
  [168] = {.lex_state = 42, .external_lex_state = 8},
  [169] = {.lex_state = 42, .external_lex_state = 6},
  [170] = {.lex_state = 42, .external_lex_state = 6},
  [171] = {.lex_state = 42, .external_lex_state = 6},
  [172] = {.lex_state = 42, .external_lex_state = 6},
  [173] = {.lex_state = 39, .external_lex_state = 6},
  [174] = {.lex_state = 39, .external_lex_state = 6},
  [175] = {.lex_state = 42, .external_lex_state = 6},
  [176] = {.lex_state = 42, .external_lex_state = 6},
  [177] = {.lex_state = 42, .external_lex_state = 6},
  [178] = {.lex_state = 42, .external_lex_state = 8},
  [179] = {.lex_state = 42, .external_lex_state = 6},
  [180] = {.lex_state = 42, .external_lex_state = 6},
  [181] = {.lex_state = 42, .external_lex_state = 8},
  [182] = {.lex_state = 42, .external_lex_state = 8},
  [183] = {.lex_state = 42, .external_lex_state = 8},
  [184] = {.lex_state = 42, .external_lex_state = 6},
  [185] = {.lex_state = 42, .external_lex_state = 6},
  [186] = {.lex_state = 42, .external_lex_state = 6},
  [187] = {.lex_state = 42, .external_lex_state = 6},
  [188] = {.lex_state = 42, .external_lex_state = 6},
  [189] = {.lex_state = 42, .external_lex_state = 8},
  [190] = {.lex_state = 41, .external_lex_state = 8},
  [191] = {.lex_state = 42, .external_lex_state = 6},
  [192] = {.lex_state = 42, .external_lex_state = 8},
  [193] = {.lex_state = 42, .external_lex_state = 6},
  [194] = {.lex_state = 42, .external_lex_state = 6},
  [195] = {.lex_state = 41, .external_lex_state = 9},
  [196] = {.lex_state = 42, .external_lex_state = 8},
  [197] = {.lex_state = 42, .external_lex_state = 8},
  [198] = {.lex_state = 42, .external_lex_state = 8},
  [199] = {.lex_state = 42, .external_lex_state = 8},
  [200] = {.lex_state = 42, .external_lex_state = 8},
  [201] = {.lex_state = 42, .external_lex_state = 8},
  [202] = {.lex_state = 41, .external_lex_state = 8},
  [203] = {.lex_state = 41, .external_lex_state = 9},
  [204] = {.lex_state = 42, .external_lex_state = 8},
  [205] = {.lex_state = 42, .external_lex_state = 8},
  [206] = {.lex_state = 41, .external_lex_state = 8},
  [207] = {.lex_state = 41, .external_lex_state = 9},
  [208] = {.lex_state = 42, .external_lex_state = 8},
  [209] = {.lex_state = 42, .external_lex_state = 8},
  [210] = {.lex_state = 41, .external_lex_state = 8},
  [211] = {.lex_state = 42, .external_lex_state = 8},
  [212] = {.lex_state = 41, .external_lex_state = 8},
  [213] = {.lex_state = 41, .external_lex_state = 8},
  [214] = {.lex_state = 42, .external_lex_state = 8},
  [215] = {.lex_state = 42, .external_lex_state = 8},
  [216] = {.lex_state = 41, .external_lex_state = 8},
  [217] = {.lex_state = 41, .external_lex_state = 8},
  [218] = {.lex_state = 41, .external_lex_state = 9},
  [219] = {.lex_state = 42, .external_lex_state = 8},
  [220] = {.lex_state = 42, .external_lex_state = 8},
  [221] = {.lex_state = 42, .external_lex_state = 8},
  [222] = {.lex_state = 42, .external_lex_state = 8},
  [223] = {.lex_state = 42, .external_lex_state = 8},
  [224] = {.lex_state = 41, .external_lex_state = 8},
  [225] = {.lex_state = 42, .external_lex_state = 8},
  [226] = {.lex_state = 42, .external_lex_state = 8},
  [227] = {.lex_state = 42, .external_lex_state = 8},
  [228] = {.lex_state = 41, .external_lex_state = 9},
  [229] = {.lex_state = 41, .external_lex_state = 8},
  [230] = {.lex_state = 42, .external_lex_state = 8},
  [231] = {.lex_state = 42, .external_lex_state = 8},
  [232] = {.lex_state = 42, .external_lex_state = 8},
  [233] = {.lex_state = 42, .external_lex_state = 8},
  [234] = {.lex_state = 42, .external_lex_state = 8},
  [235] = {.lex_state = 42, .external_lex_state = 8},
  [236] = {.lex_state = 42, .external_lex_state = 8},
  [237] = {.lex_state = 41, .external_lex_state = 9},
  [238] = {.lex_state = 41, .external_lex_state = 8},
  [239] = {.lex_state = 42, .external_lex_state = 8},
  [240] = {.lex_state = 42, .external_lex_state = 8},
  [241] = {.lex_state = 42, .external_lex_state = 8},
  [242] = {.lex_state = 42, .external_lex_state = 8},
  [243] = {.lex_state = 41, .external_lex_state = 9},
  [244] = {.lex_state = 41, .external_lex_state = 8},
  [245] = {.lex_state = 41, .external_lex_state = 8},
  [246] = {.lex_state = 41, .external_lex_state = 8},
  [247] = {.lex_state = 41, .external_lex_state = 9},
  [248] = {.lex_state = 41, .external_lex_state = 8},
  [249] = {.lex_state = 40, .external_lex_state = 9},
  [250] = {.lex_state = 40, .external_lex_state = 7},
  [251] = {.lex_state = 40, .external_lex_state = 9},
  [252] = {.lex_state = 41, .external_lex_state = 8},
  [253] = {.lex_state = 16, .external_lex_state = 7},
  [254] = {.lex_state = 40, .external_lex_state = 7},
  [255] = {.lex_state = 40, .external_lex_state = 7},
  [256] = {.lex_state = 18, .external_lex_state = 7},
  [257] = {.lex_state = 41, .external_lex_state = 8},
  [258] = {.lex_state = 40, .external_lex_state = 7},
  [259] = {.lex_state = 18, .external_lex_state = 7},
  [260] = {.lex_state = 40, .external_lex_state = 8},
  [261] = {.lex_state = 41, .external_lex_state = 9},
  [262] = {.lex_state = 40, .external_lex_state = 9},
  [263] = {.lex_state = 41, .external_lex_state = 7},
  [264] = {.lex_state = 40, .external_lex_state = 9},
  [265] = {.lex_state = 16, .external_lex_state = 7},
  [266] = {.lex_state = 41, .external_lex_state = 7},
  [267] = {.lex_state = 41, .external_lex_state = 9},
  [268] = {.lex_state = 42, .external_lex_state = 6},
  [269] = {.lex_state = 40, .external_lex_state = 8},
  [270] = {.lex_state = 40, .external_lex_state = 8},
  [271] = {.lex_state = 40, .external_lex_state = 8},
  [272] = {.lex_state = 42, .external_lex_state = 7},
  [273] = {.lex_state = 42, .external_lex_state = 7},
  [274] = {.lex_state = 42, .external_lex_state = 7},
  [275] = {.lex_state = 42, .external_lex_state = 7},
  [276] = {.lex_state = 42, .external_lex_state = 7},
  [277] = {.lex_state = 42, .external_lex_state = 7},
  [278] = {.lex_state = 41, .external_lex_state = 6},
  [279] = {.lex_state = 42, .external_lex_state = 7},
  [280] = {.lex_state = 42, .external_lex_state = 7},
  [281] = {.lex_state = 17, .external_lex_state = 9},
  [282] = {.lex_state = 42, .external_lex_state = 7},
  [283] = {.lex_state = 42, .external_lex_state = 7},
  [284] = {.lex_state = 41, .external_lex_state = 6},
  [285] = {.lex_state = 42, .external_lex_state = 7},
  [286] = {.lex_state = 42, .external_lex_state = 7},
  [287] = {.lex_state = 42, .external_lex_state = 7},
  [288] = {.lex_state = 42, .external_lex_state = 7},
  [289] = {.lex_state = 42, .external_lex_state = 7},
  [290] = {.lex_state = 41, .external_lex_state = 6},
  [291] = {.lex_state = 17, .external_lex_state = 5},
  [292] = {.lex_state = 42, .external_lex_state = 7},
  [293] = {.lex_state = 17, .external_lex_state = 5},
  [294] = {.lex_state = 17, .external_lex_state = 8},
  [295] = {.lex_state = 18, .external_lex_state = 9},
  [296] = {.lex_state = 17, .external_lex_state = 5},
  [297] = {.lex_state = 18, .external_lex_state = 9},
  [298] = {.lex_state = 18, .external_lex_state = 9},
  [299] = {.lex_state = 18, .external_lex_state = 9},
  [300] = {.lex_state = 18, .external_lex_state = 9},
  [301] = {.lex_state = 18, .external_lex_state = 9},
  [302] = {.lex_state = 18, .external_lex_state = 5},
  [303] = {.lex_state = 18, .external_lex_state = 9},
  [304] = {.lex_state = 42, .external_lex_state = 6},
  [305] = {.lex_state = 18, .external_lex_state = 9},
  [306] = {.lex_state = 18, .external_lex_state = 9},
  [307] = {.lex_state = 18, .external_lex_state = 9},
  [308] = {.lex_state = 18, .external_lex_state = 9},
  [309] = {.lex_state = 18, .external_lex_state = 9},
  [310] = {.lex_state = 18, .external_lex_state = 9},
  [311] = {.lex_state = 18, .external_lex_state = 9},
  [312] = {.lex_state = 18, .external_lex_state = 9},
  [313] = {.lex_state = 18, .external_lex_state = 9},
  [314] = {.lex_state = 18, .external_lex_state = 9},
  [315] = {.lex_state = 16, .external_lex_state = 8},
  [316] = {.lex_state = 18, .external_lex_state = 9},
  [317] = {.lex_state = 18, .external_lex_state = 9},
  [318] = {.lex_state = 18, .external_lex_state = 9},
  [319] = {.lex_state = 18, .external_lex_state = 9},
  [320] = {.lex_state = 18, .external_lex_state = 9},
  [321] = {.lex_state = 16, .external_lex_state = 8},
  [322] = {.lex_state = 18, .external_lex_state = 9},
  [323] = {.lex_state = 18, .external_lex_state = 9},
  [324] = {.lex_state = 18, .external_lex_state = 9},
  [325] = {.lex_state = 18, .external_lex_state = 9},
  [326] = {.lex_state = 18, .external_lex_state = 9},
  [327] = {.lex_state = 18, .external_lex_state = 9},
  [328] = {.lex_state = 18, .external_lex_state = 9},
  [329] = {.lex_state = 18, .external_lex_state = 9},
  [330] = {.lex_state = 17, .external_lex_state = 5},
  [331] = {.lex_state = 18, .external_lex_state = 9},
  [332] = {.lex_state = 18, .external_lex_state = 9},
  [333] = {.lex_state = 18, .external_lex_state = 8},
  [334] = {.lex_state = 18, .external_lex_state = 6},
  [335] = {.lex_state = 18, .external_lex_state = 6},
  [336] = {.lex_state = 18, .external_lex_state = 8},
  [337] = {.lex_state = 18, .external_lex_state = 6},
  [338] = {.lex_state = 16, .external_lex_state = 9},
  [339] = {.lex_state = 18, .external_lex_state = 5},
  [340] = {.lex_state = 16, .external_lex_state = 8},
  [341] = {.lex_state = 18, .external_lex_state = 6},
  [342] = {.lex_state = 38, .external_lex_state = 6},
  [343] = {.lex_state = 18, .external_lex_state = 6},
  [344] = {.lex_state = 18, .external_lex_state = 6},
  [345] = {.lex_state = 18, .external_lex_state = 5},
  [346] = {.lex_state = 18, .external_lex_state = 5},
  [347] = {.lex_state = 18, .external_lex_state = 6},
  [348] = {.lex_state = 18, .external_lex_state = 6},
  [349] = {.lex_state = 16, .external_lex_state = 6},
  [350] = {.lex_state = 18, .external_lex_state = 6},
  [351] = {.lex_state = 18, .external_lex_state = 6},
  [352] = {.lex_state = 18, .external_lex_state = 6},
  [353] = {.lex_state = 18, .external_lex_state = 6},
  [354] = {.lex_state = 18, .external_lex_state = 5},
  [355] = {.lex_state = 18, .external_lex_state = 6},
  [356] = {.lex_state = 18, .external_lex_state = 9},
  [357] = {.lex_state = 18, .external_lex_state = 6},
  [358] = {.lex_state = 18, .external_lex_state = 6},
  [359] = {.lex_state = 18, .external_lex_state = 6},
  [360] = {.lex_state = 18, .external_lex_state = 5},
  [361] = {.lex_state = 18, .external_lex_state = 6},
  [362] = {.lex_state = 18, .external_lex_state = 5},
  [363] = {.lex_state = 18, .external_lex_state = 5},
  [364] = {.lex_state = 18, .external_lex_state = 6},
  [365] = {.lex_state = 18, .external_lex_state = 6},
  [366] = {.lex_state = 18, .external_lex_state = 6},
  [367] = {.lex_state = 18, .external_lex_state = 6},
  [368] = {.lex_state = 18, .external_lex_state = 5},
  [369] = {.lex_state = 18, .external_lex_state = 9},
  [370] = {.lex_state = 18, .external_lex_state = 6},
  [371] = {.lex_state = 18, .external_lex_state = 6},
  [372] = {.lex_state = 18, .external_lex_state = 6},
  [373] = {.lex_state = 16, .external_lex_state = 8},
  [374] = {.lex_state = 18, .external_lex_state = 8},
  [375] = {.lex_state = 18, .external_lex_state = 8},
  [376] = {.lex_state = 18, .external_lex_state = 6},
  [377] = {.lex_state = 18, .external_lex_state = 9},
  [378] = {.lex_state = 16, .external_lex_state = 6},
  [379] = {.lex_state = 18, .external_lex_state = 9},
  [380] = {.lex_state = 18, .external_lex_state = 9},
  [381] = {.lex_state = 18, .external_lex_state = 6},
  [382] = {.lex_state = 38, .external_lex_state = 6},
  [383] = {.lex_state = 18, .external_lex_state = 6},
  [384] = {.lex_state = 16, .external_lex_state = 9},
  [385] = {.lex_state = 18, .external_lex_state = 6},
  [386] = {.lex_state = 18, .external_lex_state = 6},
  [387] = {.lex_state = 18, .external_lex_state = 6},
  [388] = {.lex_state = 18, .external_lex_state = 6},
  [389] = {.lex_state = 18, .external_lex_state = 6},
  [390] = {.lex_state = 18, .external_lex_state = 6},
  [391] = {.lex_state = 18, .external_lex_state = 6},
  [392] = {.lex_state = 18, .external_lex_state = 6},
  [393] = {.lex_state = 18, .external_lex_state = 6},
  [394] = {.lex_state = 18, .external_lex_state = 6},
  [395] = {.lex_state = 18, .external_lex_state = 6},
  [396] = {.lex_state = 18, .external_lex_state = 6},
  [397] = {.lex_state = 18, .external_lex_state = 6},
  [398] = {.lex_state = 18, .external_lex_state = 6},
  [399] = {.lex_state = 18, .external_lex_state = 6},
  [400] = {.lex_state = 18, .external_lex_state = 6},
  [401] = {.lex_state = 18, .external_lex_state = 6},
  [402] = {.lex_state = 18, .external_lex_state = 6},
  [403] = {.lex_state = 18, .external_lex_state = 6},
  [404] = {.lex_state = 18, .external_lex_state = 6},
  [405] = {.lex_state = 18, .external_lex_state = 6},
  [406] = {.lex_state = 18, .external_lex_state = 6},
  [407] = {.lex_state = 18, .external_lex_state = 6},
  [408] = {.lex_state = 18, .external_lex_state = 6},
  [409] = {.lex_state = 18, .external_lex_state = 6},
  [410] = {.lex_state = 18, .external_lex_state = 6},
  [411] = {.lex_state = 18, .external_lex_state = 6},
  [412] = {.lex_state = 18, .external_lex_state = 6},
  [413] = {.lex_state = 18, .external_lex_state = 6},
  [414] = {.lex_state = 18, .external_lex_state = 6},
  [415] = {.lex_state = 18, .external_lex_state = 6},
  [416] = {.lex_state = 18, .external_lex_state = 6},
  [417] = {.lex_state = 18, .external_lex_state = 6},
  [418] = {.lex_state = 18, .external_lex_state = 6},
  [419] = {.lex_state = 18, .external_lex_state = 6},
  [420] = {.lex_state = 18, .external_lex_state = 6},
  [421] = {.lex_state = 18, .external_lex_state = 6},
  [422] = {.lex_state = 18, .external_lex_state = 6},
  [423] = {.lex_state = 18, .external_lex_state = 6},
  [424] = {.lex_state = 18, .external_lex_state = 6},
  [425] = {.lex_state = 18, .external_lex_state = 6},
  [426] = {.lex_state = 18, .external_lex_state = 6},
  [427] = {.lex_state = 18, .external_lex_state = 6},
  [428] = {.lex_state = 18, .external_lex_state = 6},
  [429] = {.lex_state = 18, .external_lex_state = 6},
  [430] = {.lex_state = 18, .external_lex_state = 6},
  [431] = {.lex_state = 18, .external_lex_state = 6},
  [432] = {.lex_state = 18, .external_lex_state = 6},
  [433] = {.lex_state = 18, .external_lex_state = 6},
  [434] = {.lex_state = 18, .external_lex_state = 6},
  [435] = {.lex_state = 18, .external_lex_state = 6},
  [436] = {.lex_state = 18, .external_lex_state = 6},
  [437] = {.lex_state = 18, .external_lex_state = 6},
  [438] = {.lex_state = 18, .external_lex_state = 6},
  [439] = {.lex_state = 18, .external_lex_state = 6},
  [440] = {.lex_state = 18, .external_lex_state = 6},
  [441] = {.lex_state = 18, .external_lex_state = 6},
  [442] = {.lex_state = 18, .external_lex_state = 6},
  [443] = {.lex_state = 18, .external_lex_state = 6},
  [444] = {.lex_state = 18, .external_lex_state = 6},
  [445] = {.lex_state = 18, .external_lex_state = 6},
  [446] = {.lex_state = 18, .external_lex_state = 6},
  [447] = {.lex_state = 18, .external_lex_state = 6},
  [448] = {.lex_state = 18, .external_lex_state = 6},
  [449] = {.lex_state = 18, .external_lex_state = 6},
  [450] = {.lex_state = 18, .external_lex_state = 6},
  [451] = {.lex_state = 18, .external_lex_state = 6},
  [452] = {.lex_state = 18, .external_lex_state = 6},
  [453] = {.lex_state = 18, .external_lex_state = 6},
  [454] = {.lex_state = 18, .external_lex_state = 6},
  [455] = {.lex_state = 18, .external_lex_state = 6},
  [456] = {.lex_state = 18, .external_lex_state = 6},
  [457] = {.lex_state = 18, .external_lex_state = 6},
  [458] = {.lex_state = 18, .external_lex_state = 6},
  [459] = {.lex_state = 18, .external_lex_state = 6},
  [460] = {.lex_state = 18, .external_lex_state = 6},
  [461] = {.lex_state = 18, .external_lex_state = 6},
  [462] = {.lex_state = 18, .external_lex_state = 6},
  [463] = {.lex_state = 18, .external_lex_state = 6},
  [464] = {.lex_state = 24, .external_lex_state = 5},
  [465] = {.lex_state = 18, .external_lex_state = 6},
  [466] = {.lex_state = 18, .external_lex_state = 6},
  [467] = {.lex_state = 18, .external_lex_state = 6},
  [468] = {.lex_state = 18, .external_lex_state = 6},
  [469] = {.lex_state = 18, .external_lex_state = 6},
  [470] = {.lex_state = 18, .external_lex_state = 6},
  [471] = {.lex_state = 18, .external_lex_state = 6},
  [472] = {.lex_state = 18, .external_lex_state = 6},
  [473] = {.lex_state = 18, .external_lex_state = 6},
  [474] = {.lex_state = 18, .external_lex_state = 6},
  [475] = {.lex_state = 18, .external_lex_state = 6},
  [476] = {.lex_state = 18, .external_lex_state = 6},
  [477] = {.lex_state = 18, .external_lex_state = 6},
  [478] = {.lex_state = 16, .external_lex_state = 6},
  [479] = {.lex_state = 18, .external_lex_state = 6},
  [480] = {.lex_state = 18, .external_lex_state = 6},
  [481] = {.lex_state = 18, .external_lex_state = 6},
  [482] = {.lex_state = 18, .external_lex_state = 6},
  [483] = {.lex_state = 18, .external_lex_state = 6},
  [484] = {.lex_state = 16, .external_lex_state = 6},
  [485] = {.lex_state = 18, .external_lex_state = 6},
  [486] = {.lex_state = 18, .external_lex_state = 6},
  [487] = {.lex_state = 18, .external_lex_state = 6},
  [488] = {.lex_state = 18, .external_lex_state = 6},
  [489] = {.lex_state = 18, .external_lex_state = 6},
  [490] = {.lex_state = 18, .external_lex_state = 6},
  [491] = {.lex_state = 18, .external_lex_state = 6},
  [492] = {.lex_state = 18, .external_lex_state = 6},
  [493] = {.lex_state = 18, .external_lex_state = 6},
  [494] = {.lex_state = 18, .external_lex_state = 6},
  [495] = {.lex_state = 18, .external_lex_state = 6},
  [496] = {.lex_state = 18, .external_lex_state = 6},
  [497] = {.lex_state = 18, .external_lex_state = 6},
  [498] = {.lex_state = 18, .external_lex_state = 6},
  [499] = {.lex_state = 18, .external_lex_state = 6},
  [500] = {.lex_state = 18, .external_lex_state = 6},
  [501] = {.lex_state = 18, .external_lex_state = 6},
  [502] = {.lex_state = 18, .external_lex_state = 6},
  [503] = {.lex_state = 18, .external_lex_state = 6},
  [504] = {.lex_state = 18, .external_lex_state = 6},
  [505] = {.lex_state = 18, .external_lex_state = 6},
  [506] = {.lex_state = 18, .external_lex_state = 6},
  [507] = {.lex_state = 18, .external_lex_state = 6},
  [508] = {.lex_state = 18, .external_lex_state = 6},
  [509] = {.lex_state = 18, .external_lex_state = 6},
  [510] = {.lex_state = 18, .external_lex_state = 6},
  [511] = {.lex_state = 18, .external_lex_state = 6},
  [512] = {.lex_state = 18, .external_lex_state = 6},
  [513] = {.lex_state = 18, .external_lex_state = 6},
  [514] = {.lex_state = 18, .external_lex_state = 6},
  [515] = {.lex_state = 18, .external_lex_state = 6},
  [516] = {.lex_state = 18, .external_lex_state = 6},
  [517] = {.lex_state = 18, .external_lex_state = 6},
  [518] = {.lex_state = 18, .external_lex_state = 6},
  [519] = {.lex_state = 24, .external_lex_state = 5},
  [520] = {.lex_state = 18, .external_lex_state = 6},
  [521] = {.lex_state = 18, .external_lex_state = 6},
  [522] = {.lex_state = 18, .external_lex_state = 6},
  [523] = {.lex_state = 18, .external_lex_state = 6},
  [524] = {.lex_state = 18, .external_lex_state = 6},
  [525] = {.lex_state = 18, .external_lex_state = 6},
  [526] = {.lex_state = 18, .external_lex_state = 6},
  [527] = {.lex_state = 18, .external_lex_state = 6},
  [528] = {.lex_state = 18, .external_lex_state = 6},
  [529] = {.lex_state = 18, .external_lex_state = 6},
  [530] = {.lex_state = 18, .external_lex_state = 6},
  [531] = {.lex_state = 18, .external_lex_state = 6},
  [532] = {.lex_state = 18, .external_lex_state = 6},
  [533] = {.lex_state = 18, .external_lex_state = 6},
  [534] = {.lex_state = 18, .external_lex_state = 6},
  [535] = {.lex_state = 18, .external_lex_state = 6},
  [536] = {.lex_state = 20, .external_lex_state = 10},
  [537] = {.lex_state = 20, .external_lex_state = 10},
  [538] = {.lex_state = 46, .external_lex_state = 3},
  [539] = {.lex_state = 48, .external_lex_state = 3},
  [540] = {.lex_state = 46, .external_lex_state = 3},
  [541] = {.lex_state = 48, .external_lex_state = 3},
  [542] = {.lex_state = 20, .external_lex_state = 10},
  [543] = {.lex_state = 20, .external_lex_state = 10},
  [544] = {.lex_state = 20, .external_lex_state = 10},
  [545] = {.lex_state = 20, .external_lex_state = 10},
  [546] = {.lex_state = 20, .external_lex_state = 10},
  [547] = {.lex_state = 11, .external_lex_state = 10},
  [548] = {.lex_state = 19, .external_lex_state = 7},
  [549] = {.lex_state = 47, .external_lex_state = 3},
  [550] = {.lex_state = 11, .external_lex_state = 10},
  [551] = {.lex_state = 11, .external_lex_state = 10},
  [552] = {.lex_state = 11, .external_lex_state = 10},
  [553] = {.lex_state = 48, .external_lex_state = 3},
  [554] = {.lex_state = 11, .external_lex_state = 10},
  [555] = {.lex_state = 11, .external_lex_state = 10},
  [556] = {.lex_state = 11, .external_lex_state = 10},
  [557] = {.lex_state = 47, .external_lex_state = 3},
  [558] = {.lex_state = 47, .external_lex_state = 3},
  [559] = {.lex_state = 11, .external_lex_state = 10},
  [560] = {.lex_state = 11, .external_lex_state = 10},
  [561] = {.lex_state = 11, .external_lex_state = 10},
  [562] = {.lex_state = 47, .external_lex_state = 3},
  [563] = {.lex_state = 11, .external_lex_state = 10},
  [564] = {.lex_state = 11, .external_lex_state = 10},
  [565] = {.lex_state = 11, .external_lex_state = 10},
  [566] = {.lex_state = 11, .external_lex_state = 10},
  [567] = {.lex_state = 11, .external_lex_state = 10},
  [568] = {.lex_state = 46, .external_lex_state = 3},
  [569] = {.lex_state = 11, .external_lex_state = 10},
  [570] = {.lex_state = 11, .external_lex_state = 10},
  [571] = {.lex_state = 11, .external_lex_state = 10},
  [572] = {.lex_state = 19, .external_lex_state = 7},
  [573] = {.lex_state = 11, .external_lex_state = 10},
  [574] = {.lex_state = 47, .external_lex_state = 3},
  [575] = {.lex_state = 46, .external_lex_state = 3},
  [576] = {.lex_state = 48, .external_lex_state = 3},
  [577] = {.lex_state = 48, .external_lex_state = 3},
  [578] = {.lex_state = 19, .external_lex_state = 8},
  [579] = {.lex_state = 48, .external_lex_state = 3},
  [580] = {.lex_state = 48, .external_lex_state = 3},
  [581] = {.lex_state = 46, .external_lex_state = 3},
  [582] = {.lex_state = 46, .external_lex_state = 3},
  [583] = {.lex_state = 46, .external_lex_state = 3},
  [584] = {.lex_state = 48, .external_lex_state = 3},
  [585] = {.lex_state = 46, .external_lex_state = 3},
  [586] = {.lex_state = 46, .external_lex_state = 3},
  [587] = {.lex_state = 48, .external_lex_state = 3},
  [588] = {.lex_state = 46, .external_lex_state = 3},
  [589] = {.lex_state = 48, .external_lex_state = 3},
  [590] = {.lex_state = 48, .external_lex_state = 3},
  [591] = {.lex_state = 46, .external_lex_state = 3},
  [592] = {.lex_state = 46, .external_lex_state = 3},
  [593] = {.lex_state = 46, .external_lex_state = 3},
  [594] = {.lex_state = 46, .external_lex_state = 3},
  [595] = {.lex_state = 19, .external_lex_state = 8},
  [596] = {.lex_state = 48, .external_lex_state = 3},
  [597] = {.lex_state = 19, .external_lex_state = 9},
  [598] = {.lex_state = 47, .external_lex_state = 3},
  [599] = {.lex_state = 47, .external_lex_state = 3},
  [600] = {.lex_state = 19, .external_lex_state = 6},
  [601] = {.lex_state = 45, .external_lex_state = 3},
  [602] = {.lex_state = 45, .external_lex_state = 3},
  [603] = {.lex_state = 19, .external_lex_state = 6},
  [604] = {.lex_state = 19, .external_lex_state = 6},
  [605] = {.lex_state = 47, .external_lex_state = 3},
  [606] = {.lex_state = 47, .external_lex_state = 3},
  [607] = {.lex_state = 19, .external_lex_state = 9},
  [608] = {.lex_state = 47, .external_lex_state = 3},
  [609] = {.lex_state = 44, .external_lex_state = 3},
  [610] = {.lex_state = 45, .external_lex_state = 3},
  [611] = {.lex_state = 50, .external_lex_state = 6},
  [612] = {.lex_state = 19, .external_lex_state = 6},
  [613] = {.lex_state = 45, .external_lex_state = 3},
  [614] = {.lex_state = 45, .external_lex_state = 3},
  [615] = {.lex_state = 19, .external_lex_state = 6},
  [616] = {.lex_state = 47, .external_lex_state = 3},
  [617] = {.lex_state = 45, .external_lex_state = 3},
  [618] = {.lex_state = 19, .external_lex_state = 6},
  [619] = {.lex_state = 19, .external_lex_state = 8},
  [620] = {.lex_state = 50, .external_lex_state = 6},
  [621] = {.lex_state = 47, .external_lex_state = 3},
  [622] = {.lex_state = 19, .external_lex_state = 6},
  [623] = {.lex_state = 19, .external_lex_state = 8},
  [624] = {.lex_state = 19, .external_lex_state = 6},
  [625] = {.lex_state = 47, .external_lex_state = 3},
  [626] = {.lex_state = 44, .external_lex_state = 3},
  [627] = {.lex_state = 44, .external_lex_state = 3},
  [628] = {.lex_state = 19, .external_lex_state = 6},
  [629] = {.lex_state = 19, .external_lex_state = 6},
  [630] = {.lex_state = 45, .external_lex_state = 3},
  [631] = {.lex_state = 19, .external_lex_state = 6},
  [632] = {.lex_state = 44, .external_lex_state = 3},
  [633] = {.lex_state = 44, .external_lex_state = 3},
  [634] = {.lex_state = 45, .external_lex_state = 3},
  [635] = {.lex_state = 44, .external_lex_state = 3},
  [636] = {.lex_state = 19, .external_lex_state = 6},
  [637] = {.lex_state = 45, .external_lex_state = 3},
  [638] = {.lex_state = 44, .external_lex_state = 3},
  [639] = {.lex_state = 44, .external_lex_state = 3},
  [640] = {.lex_state = 45, .external_lex_state = 3},
  [641] = {.lex_state = 19, .external_lex_state = 6},
  [642] = {.lex_state = 44, .external_lex_state = 3},
  [643] = {.lex_state = 19, .external_lex_state = 6},
  [644] = {.lex_state = 45, .external_lex_state = 3},
  [645] = {.lex_state = 33, .external_lex_state = 3},
  [646] = {.lex_state = 33, .external_lex_state = 3},
  [647] = {.lex_state = 33, .external_lex_state = 3},
  [648] = {.lex_state = 33, .external_lex_state = 3},
  [649] = {.lex_state = 33, .external_lex_state = 3},
  [650] = {.lex_state = 19, .external_lex_state = 8},
  [651] = {.lex_state = 33, .external_lex_state = 3},
  [652] = {.lex_state = 33, .external_lex_state = 3},
  [653] = {.lex_state = 33, .external_lex_state = 3},
  [654] = {.lex_state = 33, .external_lex_state = 3},
  [655] = {.lex_state = 33, .external_lex_state = 3},
  [656] = {.lex_state = 19, .external_lex_state = 6},
  [657] = {.lex_state = 33, .external_lex_state = 3},
  [658] = {.lex_state = 33, .external_lex_state = 3},
  [659] = {.lex_state = 33, .external_lex_state = 3},
  [660] = {.lex_state = 33, .external_lex_state = 3},
  [661] = {.lex_state = 33, .external_lex_state = 3},
  [662] = {.lex_state = 33, .external_lex_state = 3},
  [663] = {.lex_state = 33, .external_lex_state = 3},
  [664] = {.lex_state = 33, .external_lex_state = 3},
  [665] = {.lex_state = 33, .external_lex_state = 3},
  [666] = {.lex_state = 33, .external_lex_state = 3},
  [667] = {.lex_state = 33, .external_lex_state = 3},
  [668] = {.lex_state = 33, .external_lex_state = 3},
  [669] = {.lex_state = 33, .external_lex_state = 3},
  [670] = {.lex_state = 33, .external_lex_state = 3},
  [671] = {.lex_state = 33, .external_lex_state = 3},
  [672] = {.lex_state = 33, .external_lex_state = 3},
  [673] = {.lex_state = 33, .external_lex_state = 3},
  [674] = {.lex_state = 33, .external_lex_state = 3},
  [675] = {.lex_state = 33, .external_lex_state = 3},
  [676] = {.lex_state = 33, .external_lex_state = 3},
  [677] = {.lex_state = 33, .external_lex_state = 3},
  [678] = {.lex_state = 33, .external_lex_state = 3},
  [679] = {.lex_state = 33, .external_lex_state = 3},
  [680] = {.lex_state = 51, .external_lex_state = 6},
  [681] = {.lex_state = 51, .external_lex_state = 6},
  [682] = {.lex_state = 51, .external_lex_state = 6},
  [683] = {.lex_state = 51, .external_lex_state = 6},
  [684] = {.lex_state = 51, .external_lex_state = 6},
  [685] = {.lex_state = 51, .external_lex_state = 6},
  [686] = {.lex_state = 51, .external_lex_state = 6},
  [687] = {.lex_state = 51, .external_lex_state = 6},
  [688] = {.lex_state = 51, .external_lex_state = 6},
  [689] = {.lex_state = 51, .external_lex_state = 6},
  [690] = {.lex_state = 19, .external_lex_state = 6},
  [691] = {.lex_state = 19, .external_lex_state = 6},
  [692] = {.lex_state = 19, .external_lex_state = 6},
  [693] = {.lex_state = 19, .external_lex_state = 6},
  [694] = {.lex_state = 19, .external_lex_state = 6},
  [695] = {.lex_state = 19, .external_lex_state = 6},
  [696] = {.lex_state = 19, .external_lex_state = 6},
  [697] = {.lex_state = 19, .external_lex_state = 6},
  [698] = {.lex_state = 19, .external_lex_state = 6},
  [699] = {.lex_state = 19, .external_lex_state = 6},
  [700] = {.lex_state = 19, .external_lex_state = 6},
  [701] = {.lex_state = 19, .external_lex_state = 6},
  [702] = {.lex_state = 19, .external_lex_state = 6},
  [703] = {.lex_state = 19, .external_lex_state = 6},
  [704] = {.lex_state = 19, .external_lex_state = 6},
  [705] = {.lex_state = 19, .external_lex_state = 6},
  [706] = {.lex_state = 19, .external_lex_state = 6},
  [707] = {.lex_state = 19, .external_lex_state = 6},
  [708] = {.lex_state = 19, .external_lex_state = 6},
  [709] = {.lex_state = 19, .external_lex_state = 6},
  [710] = {.lex_state = 19, .external_lex_state = 6},
  [711] = {.lex_state = 19, .external_lex_state = 6},
  [712] = {.lex_state = 19, .external_lex_state = 6},
  [713] = {.lex_state = 19, .external_lex_state = 6},
  [714] = {.lex_state = 19, .external_lex_state = 6},
  [715] = {.lex_state = 19, .external_lex_state = 6},
  [716] = {.lex_state = 19, .external_lex_state = 6},
  [717] = {.lex_state = 19, .external_lex_state = 6},
  [718] = {.lex_state = 19, .external_lex_state = 6},
  [719] = {.lex_state = 19, .external_lex_state = 6},
  [720] = {.lex_state = 19, .external_lex_state = 6},
  [721] = {.lex_state = 19, .external_lex_state = 6},
  [722] = {.lex_state = 19, .external_lex_state = 6},
  [723] = {.lex_state = 19, .external_lex_state = 6},
  [724] = {.lex_state = 19, .external_lex_state = 6},
  [725] = {.lex_state = 19, .external_lex_state = 6},
  [726] = {.lex_state = 19, .external_lex_state = 6},
  [727] = {.lex_state = 19, .external_lex_state = 6},
  [728] = {.lex_state = 19, .external_lex_state = 6},
  [729] = {.lex_state = 19, .external_lex_state = 6},
  [730] = {.lex_state = 19, .external_lex_state = 6},
  [731] = {.lex_state = 19, .external_lex_state = 6},
  [732] = {.lex_state = 19, .external_lex_state = 6},
  [733] = {.lex_state = 19, .external_lex_state = 6},
  [734] = {.lex_state = 19, .external_lex_state = 6},
  [735] = {.lex_state = 19, .external_lex_state = 6},
  [736] = {.lex_state = 19, .external_lex_state = 6},
  [737] = {.lex_state = 19, .external_lex_state = 6},
  [738] = {.lex_state = 19, .external_lex_state = 6},
  [739] = {.lex_state = 19, .external_lex_state = 6},
  [740] = {.lex_state = 19, .external_lex_state = 6},
  [741] = {.lex_state = 19, .external_lex_state = 6},
  [742] = {.lex_state = 19, .external_lex_state = 6},
  [743] = {.lex_state = 19, .external_lex_state = 6},
  [744] = {.lex_state = 19, .external_lex_state = 6},
  [745] = {.lex_state = 19, .external_lex_state = 6},
  [746] = {.lex_state = 19, .external_lex_state = 6},
  [747] = {.lex_state = 19, .external_lex_state = 6},
  [748] = {.lex_state = 19, .external_lex_state = 6},
  [749] = {.lex_state = 19, .external_lex_state = 6},
  [750] = {.lex_state = 19, .external_lex_state = 6},
  [751] = {.lex_state = 19, .external_lex_state = 6},
  [752] = {.lex_state = 19, .external_lex_state = 6},
  [753] = {.lex_state = 19, .external_lex_state = 6},
  [754] = {.lex_state = 19, .external_lex_state = 6},
  [755] = {.lex_state = 19, .external_lex_state = 6},
  [756] = {.lex_state = 19, .external_lex_state = 6},
  [757] = {.lex_state = 19, .external_lex_state = 6},
  [758] = {.lex_state = 19, .external_lex_state = 6},
  [759] = {.lex_state = 19, .external_lex_state = 6},
  [760] = {.lex_state = 19, .external_lex_state = 6},
  [761] = {.lex_state = 19, .external_lex_state = 6},
  [762] = {.lex_state = 19, .external_lex_state = 6},
  [763] = {.lex_state = 19, .external_lex_state = 6},
  [764] = {.lex_state = 19, .external_lex_state = 6},
  [765] = {.lex_state = 19, .external_lex_state = 6},
  [766] = {.lex_state = 19, .external_lex_state = 6},
  [767] = {.lex_state = 19, .external_lex_state = 6},
  [768] = {.lex_state = 19, .external_lex_state = 6},
  [769] = {.lex_state = 19, .external_lex_state = 6},
  [770] = {.lex_state = 19, .external_lex_state = 6},
  [771] = {.lex_state = 19, .external_lex_state = 6},
  [772] = {.lex_state = 19, .external_lex_state = 6},
  [773] = {.lex_state = 19, .external_lex_state = 6},
  [774] = {.lex_state = 19, .external_lex_state = 6},
  [775] = {.lex_state = 19, .external_lex_state = 6},
  [776] = {.lex_state = 19, .external_lex_state = 6},
  [777] = {.lex_state = 19, .external_lex_state = 6},
  [778] = {.lex_state = 19, .external_lex_state = 6},
  [779] = {.lex_state = 19, .external_lex_state = 6},
  [780] = {.lex_state = 19, .external_lex_state = 6},
  [781] = {.lex_state = 19, .external_lex_state = 6},
  [782] = {.lex_state = 19, .external_lex_state = 6},
  [783] = {.lex_state = 19, .external_lex_state = 6},
  [784] = {.lex_state = 19, .external_lex_state = 6},
  [785] = {.lex_state = 19, .external_lex_state = 6},
  [786] = {.lex_state = 19, .external_lex_state = 6},
  [787] = {.lex_state = 19, .external_lex_state = 6},
  [788] = {.lex_state = 19, .external_lex_state = 6},
  [789] = {.lex_state = 19, .external_lex_state = 6},
  [790] = {.lex_state = 19, .external_lex_state = 6},
  [791] = {.lex_state = 19, .external_lex_state = 6},
  [792] = {.lex_state = 19, .external_lex_state = 6},
  [793] = {.lex_state = 19, .external_lex_state = 6},
  [794] = {.lex_state = 19, .external_lex_state = 6},
  [795] = {.lex_state = 19, .external_lex_state = 6},
  [796] = {.lex_state = 19, .external_lex_state = 6},
  [797] = {.lex_state = 19, .external_lex_state = 6},
  [798] = {.lex_state = 19, .external_lex_state = 6},
  [799] = {.lex_state = 19, .external_lex_state = 6},
  [800] = {.lex_state = 19, .external_lex_state = 6},
  [801] = {.lex_state = 19, .external_lex_state = 6},
  [802] = {.lex_state = 19, .external_lex_state = 6},
  [803] = {.lex_state = 19, .external_lex_state = 6},
  [804] = {.lex_state = 19, .external_lex_state = 6},
  [805] = {.lex_state = 19, .external_lex_state = 6},
  [806] = {.lex_state = 19, .external_lex_state = 6},
  [807] = {.lex_state = 19, .external_lex_state = 6},
  [808] = {.lex_state = 19, .external_lex_state = 6},
  [809] = {.lex_state = 19, .external_lex_state = 6},
  [810] = {.lex_state = 19, .external_lex_state = 6},
  [811] = {.lex_state = 19, .external_lex_state = 6},
  [812] = {.lex_state = 19, .external_lex_state = 6},
  [813] = {.lex_state = 19, .external_lex_state = 6},
  [814] = {.lex_state = 19, .external_lex_state = 6},
  [815] = {.lex_state = 19, .external_lex_state = 6},
  [816] = {.lex_state = 19, .external_lex_state = 6},
  [817] = {.lex_state = 19, .external_lex_state = 6},
  [818] = {.lex_state = 19, .external_lex_state = 6},
  [819] = {.lex_state = 19, .external_lex_state = 6},
  [820] = {.lex_state = 19, .external_lex_state = 6},
  [821] = {.lex_state = 19, .external_lex_state = 6},
  [822] = {.lex_state = 19, .external_lex_state = 6},
  [823] = {.lex_state = 19, .external_lex_state = 6},
  [824] = {.lex_state = 19, .external_lex_state = 6},
  [825] = {.lex_state = 19, .external_lex_state = 6},
  [826] = {.lex_state = 19, .external_lex_state = 6},
  [827] = {.lex_state = 19, .external_lex_state = 6},
  [828] = {.lex_state = 19, .external_lex_state = 6},
  [829] = {.lex_state = 19, .external_lex_state = 6},
  [830] = {.lex_state = 19, .external_lex_state = 6},
  [831] = {.lex_state = 19, .external_lex_state = 6},
  [832] = {.lex_state = 19, .external_lex_state = 6},
  [833] = {.lex_state = 15, .external_lex_state = 5},
  [834] = {.lex_state = 15, .external_lex_state = 5},
  [835] = {.lex_state = 15, .external_lex_state = 5},
  [836] = {.lex_state = 15, .external_lex_state = 10},
  [837] = {.lex_state = 27, .external_lex_state = 7},
  [838] = {.lex_state = 27, .external_lex_state = 7},
  [839] = {.lex_state = 27, .external_lex_state = 7},
  [840] = {.lex_state = 15, .external_lex_state = 7},
  [841] = {.lex_state = 27, .external_lex_state = 11},
  [842] = {.lex_state = 15, .external_lex_state = 7},
  [843] = {.lex_state = 15, .external_lex_state = 11},
  [844] = {.lex_state = 15, .external_lex_state = 7},
  [845] = {.lex_state = 15, .external_lex_state = 10},
  [846] = {.lex_state = 15, .external_lex_state = 10},
  [847] = {.lex_state = 27, .external_lex_state = 9},
  [848] = {.lex_state = 15, .external_lex_state = 12},
  [849] = {.lex_state = 15, .external_lex_state = 10},
  [850] = {.lex_state = 27, .external_lex_state = 13},
  [851] = {.lex_state = 15, .external_lex_state = 11},
  [852] = {.lex_state = 27, .external_lex_state = 12},
  [853] = {.lex_state = 27, .external_lex_state = 8},
  [854] = {.lex_state = 15, .external_lex_state = 10},
  [855] = {.lex_state = 15, .external_lex_state = 6},
  [856] = {.lex_state = 15, .external_lex_state = 11},
  [857] = {.lex_state = 15, .external_lex_state = 11},
  [858] = {.lex_state = 15, .external_lex_state = 5},
  [859] = {.lex_state = 15, .external_lex_state = 10},
  [860] = {.lex_state = 15, .external_lex_state = 5},
  [861] = {.lex_state = 14, .external_lex_state = 10},
  [862] = {.lex_state = 14, .external_lex_state = 10},
  [863] = {.lex_state = 15, .external_lex_state = 6},
  [864] = {.lex_state = 27, .external_lex_state = 8},
  [865] = {.lex_state = 15, .external_lex_state = 11},
  [866] = {.lex_state = 15, .external_lex_state = 10},
  [867] = {.lex_state = 15, .external_lex_state = 11},
  [868] = {.lex_state = 15, .external_lex_state = 11},
  [869] = {.lex_state = 14, .external_lex_state = 10},
  [870] = {.lex_state = 27, .external_lex_state = 8},
  [871] = {.lex_state = 15, .external_lex_state = 11},
  [872] = {.lex_state = 15, .external_lex_state = 11},
  [873] = {.lex_state = 15, .external_lex_state = 10},
  [874] = {.lex_state = 15, .external_lex_state = 10},
  [875] = {.lex_state = 15, .external_lex_state = 8},
  [876] = {.lex_state = 27, .external_lex_state = 11},
  [877] = {.lex_state = 15, .external_lex_state = 11},
  [878] = {.lex_state = 15, .external_lex_state = 8},
  [879] = {.lex_state = 27, .external_lex_state = 11},
  [880] = {.lex_state = 15, .external_lex_state = 6},
  [881] = {.lex_state = 15, .external_lex_state = 11},
  [882] = {.lex_state = 27, .external_lex_state = 9},
  [883] = {.lex_state = 15, .external_lex_state = 11},
  [884] = {.lex_state = 15, .external_lex_state = 10},
  [885] = {.lex_state = 27, .external_lex_state = 11},
  [886] = {.lex_state = 27, .external_lex_state = 11},
  [887] = {.lex_state = 15, .external_lex_state = 10},
  [888] = {.lex_state = 27, .external_lex_state = 11},
  [889] = {.lex_state = 27, .external_lex_state = 11},
  [890] = {.lex_state = 27, .external_lex_state = 11},
  [891] = {.lex_state = 15, .external_lex_state = 10},
  [892] = {.lex_state = 27, .external_lex_state = 11},
  [893] = {.lex_state = 15, .external_lex_state = 8},
  [894] = {.lex_state = 27, .external_lex_state = 11},
  [895] = {.lex_state = 27, .external_lex_state = 9},
  [896] = {.lex_state = 27, .external_lex_state = 11},
  [897] = {.lex_state = 15, .external_lex_state = 10},
  [898] = {.lex_state = 15, .external_lex_state = 10},
  [899] = {.lex_state = 15, .external_lex_state = 10},
  [900] = {.lex_state = 27, .external_lex_state = 11},
  [901] = {.lex_state = 27, .external_lex_state = 11},
  [902] = {.lex_state = 15, .external_lex_state = 11},
  [903] = {.lex_state = 15, .external_lex_state = 12},
  [904] = {.lex_state = 15, .external_lex_state = 10},
  [905] = {.lex_state = 27, .external_lex_state = 13},
  [906] = {.lex_state = 27, .external_lex_state = 13},
  [907] = {.lex_state = 27, .external_lex_state = 13},
  [908] = {.lex_state = 27, .external_lex_state = 13},
  [909] = {.lex_state = 27, .external_lex_state = 13},
  [910] = {.lex_state = 27, .external_lex_state = 13},
  [911] = {.lex_state = 27, .external_lex_state = 13},
  [912] = {.lex_state = 15, .external_lex_state = 12},
  [913] = {.lex_state = 15, .external_lex_state = 12},
  [914] = {.lex_state = 15, .external_lex_state = 12},
  [915] = {.lex_state = 15, .external_lex_state = 10},
  [916] = {.lex_state = 14, .external_lex_state = 12},
  [917] = {.lex_state = 15, .external_lex_state = 12},
  [918] = {.lex_state = 15, .external_lex_state = 10},
  [919] = {.lex_state = 15, .external_lex_state = 10},
  [920] = {.lex_state = 15, .external_lex_state = 10},
  [921] = {.lex_state = 27, .external_lex_state = 7},
  [922] = {.lex_state = 15, .external_lex_state = 10},
  [923] = {.lex_state = 15, .external_lex_state = 10},
  [924] = {.lex_state = 14, .external_lex_state = 11},
  [925] = {.lex_state = 15, .external_lex_state = 12},
  [926] = {.lex_state = 15, .external_lex_state = 10},
  [927] = {.lex_state = 15, .external_lex_state = 12},
  [928] = {.lex_state = 14, .external_lex_state = 11},
  [929] = {.lex_state = 15, .external_lex_state = 7},
  [930] = {.lex_state = 14, .external_lex_state = 11},
  [931] = {.lex_state = 15, .external_lex_state = 10},
  [932] = {.lex_state = 15, .external_lex_state = 12},
  [933] = {.lex_state = 15, .external_lex_state = 10},
  [934] = {.lex_state = 27, .external_lex_state = 7},
  [935] = {.lex_state = 15, .external_lex_state = 10},
  [936] = {.lex_state = 15, .external_lex_state = 10},
  [937] = {.lex_state = 26, .external_lex_state = 11},
  [938] = {.lex_state = 15, .external_lex_state = 10},
  [939] = {.lex_state = 26, .external_lex_state = 11},
  [940] = {.lex_state = 15, .external_lex_state = 10},
  [941] = {.lex_state = 26, .external_lex_state = 11},
  [942] = {.lex_state = 27, .external_lex_state = 13},
  [943] = {.lex_state = 27, .external_lex_state = 13},
  [944] = {.lex_state = 26, .external_lex_state = 12},
  [945] = {.lex_state = 26, .external_lex_state = 12},
  [946] = {.lex_state = 15, .external_lex_state = 10},
  [947] = {.lex_state = 15, .external_lex_state = 12},
  [948] = {.lex_state = 15, .external_lex_state = 10},
  [949] = {.lex_state = 14, .external_lex_state = 11},
  [950] = {.lex_state = 15, .external_lex_state = 10},
  [951] = {.lex_state = 14, .external_lex_state = 11},
  [952] = {.lex_state = 27, .external_lex_state = 12},
  [953] = {.lex_state = 27, .external_lex_state = 12},
  [954] = {.lex_state = 15, .external_lex_state = 10},
  [955] = {.lex_state = 26, .external_lex_state = 12},
  [956] = {.lex_state = 15, .external_lex_state = 12},
  [957] = {.lex_state = 14, .external_lex_state = 11},
  [958] = {.lex_state = 27, .external_lex_state = 13},
  [959] = {.lex_state = 15, .external_lex_state = 10},
  [960] = {.lex_state = 14, .external_lex_state = 10},
  [961] = {.lex_state = 15, .external_lex_state = 12},
  [962] = {.lex_state = 15, .external_lex_state = 10},
  [963] = {.lex_state = 27, .external_lex_state = 12},
  [964] = {.lex_state = 27, .external_lex_state = 12},
  [965] = {.lex_state = 27, .external_lex_state = 12},
  [966] = {.lex_state = 27, .external_lex_state = 12},
  [967] = {.lex_state = 27, .external_lex_state = 12},
  [968] = {.lex_state = 15, .external_lex_state = 10},
  [969] = {.lex_state = 15, .external_lex_state = 10},
  [970] = {.lex_state = 27, .external_lex_state = 12},
  [971] = {.lex_state = 27, .external_lex_state = 12},
  [972] = {.lex_state = 27, .external_lex_state = 12},
  [973] = {.lex_state = 15, .external_lex_state = 10},
  [974] = {.lex_state = 15, .external_lex_state = 10},
  [975] = {.lex_state = 15, .external_lex_state = 9},
  [976] = {.lex_state = 26, .external_lex_state = 11},
  [977] = {.lex_state = 26, .external_lex_state = 11},
  [978] = {.lex_state = 27, .external_lex_state = 13},
  [979] = {.lex_state = 26, .external_lex_state = 11},
  [980] = {.lex_state = 15, .external_lex_state = 10},
  [981] = {.lex_state = 15, .external_lex_state = 10},
  [982] = {.lex_state = 15, .external_lex_state = 10},
  [983] = {.lex_state = 15, .external_lex_state = 12},
  [984] = {.lex_state = 15, .external_lex_state = 10},
  [985] = {.lex_state = 15, .external_lex_state = 10},
  [986] = {.lex_state = 15, .external_lex_state = 10},
  [987] = {.lex_state = 15, .external_lex_state = 10},
  [988] = {.lex_state = 15, .external_lex_state = 9},
  [989] = {.lex_state = 15, .external_lex_state = 10},
  [990] = {.lex_state = 15, .external_lex_state = 10},
  [991] = {.lex_state = 15, .external_lex_state = 10},
  [992] = {.lex_state = 15, .external_lex_state = 10},
  [993] = {.lex_state = 15, .external_lex_state = 10},
  [994] = {.lex_state = 15, .external_lex_state = 10},
  [995] = {.lex_state = 15, .external_lex_state = 10},
  [996] = {.lex_state = 15, .external_lex_state = 10},
  [997] = {.lex_state = 15, .external_lex_state = 10},
  [998] = {.lex_state = 15, .external_lex_state = 10},
  [999] = {.lex_state = 15, .external_lex_state = 10},
  [1000] = {.lex_state = 27, .external_lex_state = 12},
  [1001] = {.lex_state = 15, .external_lex_state = 10},
  [1002] = {.lex_state = 27, .external_lex_state = 12},
  [1003] = {.lex_state = 15, .external_lex_state = 10},
  [1004] = {.lex_state = 27, .external_lex_state = 13},
  [1005] = {.lex_state = 15, .external_lex_state = 10},
  [1006] = {.lex_state = 15, .external_lex_state = 10},
  [1007] = {.lex_state = 15, .external_lex_state = 10},
  [1008] = {.lex_state = 15, .external_lex_state = 7},
  [1009] = {.lex_state = 15, .external_lex_state = 10},
  [1010] = {.lex_state = 15, .external_lex_state = 2},
  [1011] = {.lex_state = 15, .external_lex_state = 13},
  [1012] = {.lex_state = 15, .external_lex_state = 9},
  [1013] = {.lex_state = 14, .external_lex_state = 12},
  [1014] = {.lex_state = 26, .external_lex_state = 12},
  [1015] = {.lex_state = 15, .external_lex_state = 11},
  [1016] = {.lex_state = 15, .external_lex_state = 2},
  [1017] = {.lex_state = 15, .external_lex_state = 2},
  [1018] = {.lex_state = 15, .external_lex_state = 2},
  [1019] = {.lex_state = 15, .external_lex_state = 11},
  [1020] = {.lex_state = 15, .external_lex_state = 11},
  [1021] = {.lex_state = 15, .external_lex_state = 11},
  [1022] = {.lex_state = 15, .external_lex_state = 11},
  [1023] = {.lex_state = 15, .external_lex_state = 11},
  [1024] = {.lex_state = 26, .external_lex_state = 13},
  [1025] = {.lex_state = 26, .external_lex_state = 13},
  [1026] = {.lex_state = 26, .external_lex_state = 13},
  [1027] = {.lex_state = 27, .external_lex_state = 11},
  [1028] = {.lex_state = 15, .external_lex_state = 11},
  [1029] = {.lex_state = 15, .external_lex_state = 11},
  [1030] = {.lex_state = 15, .external_lex_state = 11},
  [1031] = {.lex_state = 15, .external_lex_state = 11},
  [1032] = {.lex_state = 15, .external_lex_state = 11},
  [1033] = {.lex_state = 15, .external_lex_state = 11},
  [1034] = {.lex_state = 26, .external_lex_state = 12},
  [1035] = {.lex_state = 15, .external_lex_state = 11},
  [1036] = {.lex_state = 15, .external_lex_state = 2},
  [1037] = {.lex_state = 26, .external_lex_state = 12},
  [1038] = {.lex_state = 26, .external_lex_state = 12},
  [1039] = {.lex_state = 15, .external_lex_state = 2},
  [1040] = {.lex_state = 15, .external_lex_state = 2},
  [1041] = {.lex_state = 15, .external_lex_state = 2},
  [1042] = {.lex_state = 15, .external_lex_state = 2},
  [1043] = {.lex_state = 15, .external_lex_state = 2},
  [1044] = {.lex_state = 15, .external_lex_state = 2},
  [1045] = {.lex_state = 15, .external_lex_state = 11},
  [1046] = {.lex_state = 27, .external_lex_state = 8},
  [1047] = {.lex_state = 15, .external_lex_state = 2},
  [1048] = {.lex_state = 15, .external_lex_state = 2},
  [1049] = {.lex_state = 15, .external_lex_state = 11},
  [1050] = {.lex_state = 15, .external_lex_state = 11},
  [1051] = {.lex_state = 15, .external_lex_state = 11},
  [1052] = {.lex_state = 15, .external_lex_state = 11},
  [1053] = {.lex_state = 15, .external_lex_state = 11},
  [1054] = {.lex_state = 15, .external_lex_state = 11},
  [1055] = {.lex_state = 15, .external_lex_state = 11},
  [1056] = {.lex_state = 15, .external_lex_state = 11},
  [1057] = {.lex_state = 15, .external_lex_state = 11},
  [1058] = {.lex_state = 15, .external_lex_state = 11},
  [1059] = {.lex_state = 15, .external_lex_state = 11},
  [1060] = {.lex_state = 27, .external_lex_state = 11},
  [1061] = {.lex_state = 27, .external_lex_state = 11},
  [1062] = {.lex_state = 15, .external_lex_state = 11},
  [1063] = {.lex_state = 15, .external_lex_state = 11},
  [1064] = {.lex_state = 15, .external_lex_state = 11},
  [1065] = {.lex_state = 15, .external_lex_state = 11},
  [1066] = {.lex_state = 15, .external_lex_state = 11},
  [1067] = {.lex_state = 15, .external_lex_state = 11},
  [1068] = {.lex_state = 15, .external_lex_state = 11},
  [1069] = {.lex_state = 14, .external_lex_state = 2},
  [1070] = {.lex_state = 26, .external_lex_state = 13},
  [1071] = {.lex_state = 15, .external_lex_state = 8},
  [1072] = {.lex_state = 26, .external_lex_state = 13},
  [1073] = {.lex_state = 26, .external_lex_state = 13},
  [1074] = {.lex_state = 27, .external_lex_state = 9},
  [1075] = {.lex_state = 15, .external_lex_state = 11},
  [1076] = {.lex_state = 15, .external_lex_state = 8},
  [1077] = {.lex_state = 14, .external_lex_state = 2},
  [1078] = {.lex_state = 14, .external_lex_state = 2},
  [1079] = {.lex_state = 14, .external_lex_state = 2},
  [1080] = {.lex_state = 26, .external_lex_state = 13},
  [1081] = {.lex_state = 15, .external_lex_state = 11},
  [1082] = {.lex_state = 26, .external_lex_state = 13},
  [1083] = {.lex_state = 26, .external_lex_state = 13},
  [1084] = {.lex_state = 15, .external_lex_state = 13},
  [1085] = {.lex_state = 15, .external_lex_state = 13},
  [1086] = {.lex_state = 15, .external_lex_state = 13},
  [1087] = {.lex_state = 27, .external_lex_state = 8},
  [1088] = {.lex_state = 15, .external_lex_state = 13},
  [1089] = {.lex_state = 15, .external_lex_state = 13},
  [1090] = {.lex_state = 15, .external_lex_state = 13},
  [1091] = {.lex_state = 15, .external_lex_state = 13},
  [1092] = {.lex_state = 15, .external_lex_state = 11},
  [1093] = {.lex_state = 15, .external_lex_state = 11},
  [1094] = {.lex_state = 27, .external_lex_state = 9},
  [1095] = {.lex_state = 26, .external_lex_state = 12},
  [1096] = {.lex_state = 15, .external_lex_state = 13},
  [1097] = {.lex_state = 15, .external_lex_state = 13},
  [1098] = {.lex_state = 26, .external_lex_state = 12},
  [1099] = {.lex_state = 15, .external_lex_state = 12},
  [1100] = {.lex_state = 14, .external_lex_state = 12},
  [1101] = {.lex_state = 14, .external_lex_state = 12},
  [1102] = {.lex_state = 15, .external_lex_state = 11},
  [1103] = {.lex_state = 15, .external_lex_state = 13},
  [1104] = {.lex_state = 15, .external_lex_state = 13},
  [1105] = {.lex_state = 15, .external_lex_state = 13},
  [1106] = {.lex_state = 15, .external_lex_state = 11},
  [1107] = {.lex_state = 15, .external_lex_state = 6},
  [1108] = {.lex_state = 15, .external_lex_state = 6},
  [1109] = {.lex_state = 15, .external_lex_state = 13},
  [1110] = {.lex_state = 27, .external_lex_state = 11},
  [1111] = {.lex_state = 27, .external_lex_state = 11},
  [1112] = {.lex_state = 27, .external_lex_state = 11},
  [1113] = {.lex_state = 27, .external_lex_state = 12},
  [1114] = {.lex_state = 27, .external_lex_state = 11},
  [1115] = {.lex_state = 27, .external_lex_state = 11},
  [1116] = {.lex_state = 27, .external_lex_state = 11},
  [1117] = {.lex_state = 27, .external_lex_state = 11},
  [1118] = {.lex_state = 27, .external_lex_state = 11},
  [1119] = {.lex_state = 27, .external_lex_state = 11},
  [1120] = {.lex_state = 27, .external_lex_state = 11},
  [1121] = {.lex_state = 27, .external_lex_state = 11},
  [1122] = {.lex_state = 27, .external_lex_state = 11},
  [1123] = {.lex_state = 27, .external_lex_state = 11},
  [1124] = {.lex_state = 27, .external_lex_state = 11},
  [1125] = {.lex_state = 27, .external_lex_state = 11},
  [1126] = {.lex_state = 27, .external_lex_state = 11},
  [1127] = {.lex_state = 27, .external_lex_state = 11},
  [1128] = {.lex_state = 27, .external_lex_state = 11},
  [1129] = {.lex_state = 14, .external_lex_state = 13},
  [1130] = {.lex_state = 27, .external_lex_state = 11},
  [1131] = {.lex_state = 27, .external_lex_state = 11},
  [1132] = {.lex_state = 27, .external_lex_state = 11},
  [1133] = {.lex_state = 27, .external_lex_state = 11},
  [1134] = {.lex_state = 27, .external_lex_state = 11},
  [1135] = {.lex_state = 27, .external_lex_state = 11},
  [1136] = {.lex_state = 27, .external_lex_state = 11},
  [1137] = {.lex_state = 26, .external_lex_state = 12},
  [1138] = {.lex_state = 26, .external_lex_state = 12},
  [1139] = {.lex_state = 26, .external_lex_state = 12},
  [1140] = {.lex_state = 27, .external_lex_state = 11},
  [1141] = {.lex_state = 27, .external_lex_state = 11},
  [1142] = {.lex_state = 27, .external_lex_state = 11},
  [1143] = {.lex_state = 27, .external_lex_state = 11},
  [1144] = {.lex_state = 27, .external_lex_state = 11},
  [1145] = {.lex_state = 15, .external_lex_state = 11},
  [1146] = {.lex_state = 27, .external_lex_state = 11},
  [1147] = {.lex_state = 27, .external_lex_state = 11},
  [1148] = {.lex_state = 15, .external_lex_state = 11},
  [1149] = {.lex_state = 27, .external_lex_state = 11},
  [1150] = {.lex_state = 27, .external_lex_state = 11},
  [1151] = {.lex_state = 27, .external_lex_state = 12},
  [1152] = {.lex_state = 27, .external_lex_state = 12},
  [1153] = {.lex_state = 27, .external_lex_state = 12},
  [1154] = {.lex_state = 27, .external_lex_state = 12},
  [1155] = {.lex_state = 27, .external_lex_state = 12},
  [1156] = {.lex_state = 27, .external_lex_state = 12},
  [1157] = {.lex_state = 15, .external_lex_state = 11},
  [1158] = {.lex_state = 15, .external_lex_state = 12},
  [1159] = {.lex_state = 15, .external_lex_state = 2},
  [1160] = {.lex_state = 15, .external_lex_state = 12},
  [1161] = {.lex_state = 15, .external_lex_state = 12},
  [1162] = {.lex_state = 11, .external_lex_state = 10},
  [1163] = {.lex_state = 11, .external_lex_state = 10},
  [1164] = {.lex_state = 15, .external_lex_state = 9},
  [1165] = {.lex_state = 27, .external_lex_state = 13},
  [1166] = {.lex_state = 27, .external_lex_state = 13},
  [1167] = {.lex_state = 27, .external_lex_state = 13},
  [1168] = {.lex_state = 15, .external_lex_state = 12},
  [1169] = {.lex_state = 27, .external_lex_state = 12},
  [1170] = {.lex_state = 27, .external_lex_state = 12},
  [1171] = {.lex_state = 27, .external_lex_state = 13},
  [1172] = {.lex_state = 27, .external_lex_state = 13},
  [1173] = {.lex_state = 27, .external_lex_state = 12},
  [1174] = {.lex_state = 15, .external_lex_state = 2},
  [1175] = {.lex_state = 27, .external_lex_state = 13},
  [1176] = {.lex_state = 15, .external_lex_state = 9},
  [1177] = {.lex_state = 15, .external_lex_state = 2},
  [1178] = {.lex_state = 27, .external_lex_state = 12},
  [1179] = {.lex_state = 27, .external_lex_state = 12},
  [1180] = {.lex_state = 27, .external_lex_state = 12},
  [1181] = {.lex_state = 352, .external_lex_state = 2},
  [1182] = {.lex_state = 27, .external_lex_state = 12},
  [1183] = {.lex_state = 27, .external_lex_state = 12},
  [1184] = {.lex_state = 15, .external_lex_state = 12},
  [1185] = {.lex_state = 15, .external_lex_state = 12},
  [1186] = {.lex_state = 15, .external_lex_state = 12},
  [1187] = {.lex_state = 11, .external_lex_state = 10},
  [1188] = {.lex_state = 11, .external_lex_state = 10},
  [1189] = {.lex_state = 27, .external_lex_state = 12},
  [1190] = {.lex_state = 27, .external_lex_state = 12},
  [1191] = {.lex_state = 27, .external_lex_state = 12},
  [1192] = {.lex_state = 27, .external_lex_state = 12},
  [1193] = {.lex_state = 27, .external_lex_state = 12},
  [1194] = {.lex_state = 11, .external_lex_state = 10},
  [1195] = {.lex_state = 11, .external_lex_state = 10},
  [1196] = {.lex_state = 15, .external_lex_state = 2},
  [1197] = {.lex_state = 27, .external_lex_state = 12},
  [1198] = {.lex_state = 27, .external_lex_state = 12},
  [1199] = {.lex_state = 15, .external_lex_state = 2},
  [1200] = {.lex_state = 27, .external_lex_state = 13},
  [1201] = {.lex_state = 15, .external_lex_state = 2},
  [1202] = {.lex_state = 15, .external_lex_state = 2},
  [1203] = {.lex_state = 27, .external_lex_state = 13},
  [1204] = {.lex_state = 15, .external_lex_state = 2},
  [1205] = {.lex_state = 15, .external_lex_state = 12},
  [1206] = {.lex_state = 15, .external_lex_state = 12},
  [1207] = {.lex_state = 27, .external_lex_state = 13},
  [1208] = {.lex_state = 15, .external_lex_state = 2},
  [1209] = {.lex_state = 27, .external_lex_state = 12},
  [1210] = {.lex_state = 27, .external_lex_state = 12},
  [1211] = {.lex_state = 15, .external_lex_state = 2},
  [1212] = {.lex_state = 27, .external_lex_state = 13},
  [1213] = {.lex_state = 27, .external_lex_state = 13},
  [1214] = {.lex_state = 15, .external_lex_state = 12},
  [1215] = {.lex_state = 15, .external_lex_state = 2},
  [1216] = {.lex_state = 27, .external_lex_state = 13},
  [1217] = {.lex_state = 27, .external_lex_state = 13},
  [1218] = {.lex_state = 15, .external_lex_state = 2},
  [1219] = {.lex_state = 27, .external_lex_state = 12},
  [1220] = {.lex_state = 27, .external_lex_state = 12},
  [1221] = {.lex_state = 27, .external_lex_state = 13},
  [1222] = {.lex_state = 27, .external_lex_state = 12},
  [1223] = {.lex_state = 27, .external_lex_state = 12},
  [1224] = {.lex_state = 15, .external_lex_state = 2},
  [1225] = {.lex_state = 27, .external_lex_state = 12},
  [1226] = {.lex_state = 27, .external_lex_state = 12},
  [1227] = {.lex_state = 27, .external_lex_state = 12},
  [1228] = {.lex_state = 15, .external_lex_state = 2},
  [1229] = {.lex_state = 15, .external_lex_state = 2},
  [1230] = {.lex_state = 27, .external_lex_state = 12},
  [1231] = {.lex_state = 27, .external_lex_state = 12},
  [1232] = {.lex_state = 27, .external_lex_state = 12},
  [1233] = {.lex_state = 27, .external_lex_state = 13},
  [1234] = {.lex_state = 27, .external_lex_state = 13},
  [1235] = {.lex_state = 27, .external_lex_state = 13},
  [1236] = {.lex_state = 15, .external_lex_state = 2},
  [1237] = {.lex_state = 27, .external_lex_state = 12},
  [1238] = {.lex_state = 27, .external_lex_state = 12},
  [1239] = {.lex_state = 15, .external_lex_state = 12},
  [1240] = {.lex_state = 15, .external_lex_state = 12},
  [1241] = {.lex_state = 15, .external_lex_state = 2},
  [1242] = {.lex_state = 27, .external_lex_state = 13},
  [1243] = {.lex_state = 27, .external_lex_state = 13},
  [1244] = {.lex_state = 27, .external_lex_state = 13},
  [1245] = {.lex_state = 27, .external_lex_state = 13},
  [1246] = {.lex_state = 27, .external_lex_state = 13},
  [1247] = {.lex_state = 27, .external_lex_state = 13},
  [1248] = {.lex_state = 27, .external_lex_state = 12},
  [1249] = {.lex_state = 27, .external_lex_state = 13},
  [1250] = {.lex_state = 15, .external_lex_state = 12},
  [1251] = {.lex_state = 15, .external_lex_state = 2},
  [1252] = {.lex_state = 27, .external_lex_state = 13},
  [1253] = {.lex_state = 27, .external_lex_state = 13},
  [1254] = {.lex_state = 15, .external_lex_state = 2},
  [1255] = {.lex_state = 15, .external_lex_state = 2},
  [1256] = {.lex_state = 27, .external_lex_state = 13},
  [1257] = {.lex_state = 15, .external_lex_state = 2},
  [1258] = {.lex_state = 15, .external_lex_state = 2},
  [1259] = {.lex_state = 27, .external_lex_state = 13},
  [1260] = {.lex_state = 27, .external_lex_state = 13},
  [1261] = {.lex_state = 27, .external_lex_state = 12},
  [1262] = {.lex_state = 27, .external_lex_state = 13},
  [1263] = {.lex_state = 27, .external_lex_state = 12},
  [1264] = {.lex_state = 15, .external_lex_state = 12},
  [1265] = {.lex_state = 15, .external_lex_state = 12},
  [1266] = {.lex_state = 15, .external_lex_state = 12},
  [1267] = {.lex_state = 15, .external_lex_state = 2},
  [1268] = {.lex_state = 15, .external_lex_state = 12},
  [1269] = {.lex_state = 352, .external_lex_state = 2},
  [1270] = {.lex_state = 15, .external_lex_state = 12},
  [1271] = {.lex_state = 27, .external_lex_state = 13},
  [1272] = {.lex_state = 27, .external_lex_state = 13},
  [1273] = {.lex_state = 27, .external_lex_state = 13},
  [1274] = {.lex_state = 14, .external_lex_state = 12},
  [1275] = {.lex_state = 15, .external_lex_state = 2},
  [1276] = {.lex_state = 15, .external_lex_state = 2},
  [1277] = {.lex_state = 15, .external_lex_state = 2},
  [1278] = {.lex_state = 15, .external_lex_state = 2},
  [1279] = {.lex_state = 15, .external_lex_state = 2},
  [1280] = {.lex_state = 15, .external_lex_state = 12},
  [1281] = {.lex_state = 14, .external_lex_state = 12},
  [1282] = {.lex_state = 15, .external_lex_state = 2},
  [1283] = {.lex_state = 15, .external_lex_state = 2},
  [1284] = {.lex_state = 14, .external_lex_state = 13},
  [1285] = {.lex_state = 14, .external_lex_state = 13},
  [1286] = {.lex_state = 27, .external_lex_state = 13},
  [1287] = {.lex_state = 15, .external_lex_state = 2},
  [1288] = {.lex_state = 14, .external_lex_state = 12},
  [1289] = {.lex_state = 14, .external_lex_state = 13},
  [1290] = {.lex_state = 27, .external_lex_state = 13},
  [1291] = {.lex_state = 15, .external_lex_state = 12},
  [1292] = {.lex_state = 15, .external_lex_state = 12},
  [1293] = {.lex_state = 15, .external_lex_state = 12},
  [1294] = {.lex_state = 27, .external_lex_state = 12},
  [1295] = {.lex_state = 27, .external_lex_state = 12},
  [1296] = {.lex_state = 15, .external_lex_state = 10},
  [1297] = {.lex_state = 15, .external_lex_state = 12},
  [1298] = {.lex_state = 15, .external_lex_state = 12},
  [1299] = {.lex_state = 27, .external_lex_state = 13},
  [1300] = {.lex_state = 15, .external_lex_state = 12},
  [1301] = {.lex_state = 27, .external_lex_state = 13},
  [1302] = {.lex_state = 27, .external_lex_state = 13},
  [1303] = {.lex_state = 15, .external_lex_state = 12},
  [1304] = {.lex_state = 27, .external_lex_state = 13},
  [1305] = {.lex_state = 15, .external_lex_state = 2},
  [1306] = {.lex_state = 15, .external_lex_state = 12},
  [1307] = {.lex_state = 15, .external_lex_state = 12},
  [1308] = {.lex_state = 15, .external_lex_state = 12},
  [1309] = {.lex_state = 15, .external_lex_state = 2},
  [1310] = {.lex_state = 27, .external_lex_state = 13},
  [1311] = {.lex_state = 27, .external_lex_state = 13},
  [1312] = {.lex_state = 15, .external_lex_state = 2},
  [1313] = {.lex_state = 15, .external_lex_state = 2},
  [1314] = {.lex_state = 15, .external_lex_state = 2},
  [1315] = {.lex_state = 15, .external_lex_state = 12},
  [1316] = {.lex_state = 15, .external_lex_state = 12},
  [1317] = {.lex_state = 15, .external_lex_state = 12},
  [1318] = {.lex_state = 15, .external_lex_state = 12},
  [1319] = {.lex_state = 15, .external_lex_state = 12},
  [1320] = {.lex_state = 15, .external_lex_state = 12},
  [1321] = {.lex_state = 15, .external_lex_state = 12},
  [1322] = {.lex_state = 15, .external_lex_state = 12},
  [1323] = {.lex_state = 15, .external_lex_state = 2},
  [1324] = {.lex_state = 14, .external_lex_state = 12},
  [1325] = {.lex_state = 15, .external_lex_state = 13},
  [1326] = {.lex_state = 15, .external_lex_state = 2},
  [1327] = {.lex_state = 15, .external_lex_state = 2},
  [1328] = {.lex_state = 15, .external_lex_state = 13},
  [1329] = {.lex_state = 15, .external_lex_state = 2},
  [1330] = {.lex_state = 15, .external_lex_state = 2},
  [1331] = {.lex_state = 15, .external_lex_state = 13},
  [1332] = {.lex_state = 15, .external_lex_state = 13},
  [1333] = {.lex_state = 15, .external_lex_state = 13},
  [1334] = {.lex_state = 15, .external_lex_state = 13},
  [1335] = {.lex_state = 15, .external_lex_state = 13},
  [1336] = {.lex_state = 15, .external_lex_state = 2},
  [1337] = {.lex_state = 15, .external_lex_state = 13},
  [1338] = {.lex_state = 15, .external_lex_state = 13},
  [1339] = {.lex_state = 15, .external_lex_state = 13},
  [1340] = {.lex_state = 15, .external_lex_state = 13},
  [1341] = {.lex_state = 15, .external_lex_state = 13},
  [1342] = {.lex_state = 15, .external_lex_state = 13},
  [1343] = {.lex_state = 15, .external_lex_state = 13},
  [1344] = {.lex_state = 14, .external_lex_state = 11},
  [1345] = {.lex_state = 14, .external_lex_state = 11},
  [1346] = {.lex_state = 14, .external_lex_state = 11},
  [1347] = {.lex_state = 15, .external_lex_state = 13},
  [1348] = {.lex_state = 15, .external_lex_state = 13},
  [1349] = {.lex_state = 15, .external_lex_state = 13},
  [1350] = {.lex_state = 15, .external_lex_state = 13},
  [1351] = {.lex_state = 15, .external_lex_state = 13},
  [1352] = {.lex_state = 15, .external_lex_state = 2},
  [1353] = {.lex_state = 14, .external_lex_state = 12},
  [1354] = {.lex_state = 15, .external_lex_state = 13},
  [1355] = {.lex_state = 14, .external_lex_state = 12},
  [1356] = {.lex_state = 15, .external_lex_state = 13},
  [1357] = {.lex_state = 15, .external_lex_state = 13},
  [1358] = {.lex_state = 15, .external_lex_state = 13},
  [1359] = {.lex_state = 15, .external_lex_state = 2},
  [1360] = {.lex_state = 14, .external_lex_state = 13},
  [1361] = {.lex_state = 15, .external_lex_state = 2},
  [1362] = {.lex_state = 15, .external_lex_state = 2},
  [1363] = {.lex_state = 15, .external_lex_state = 13},
  [1364] = {.lex_state = 15, .external_lex_state = 13},
  [1365] = {.lex_state = 15, .external_lex_state = 13},
  [1366] = {.lex_state = 15, .external_lex_state = 13},
  [1367] = {.lex_state = 14, .external_lex_state = 13},
  [1368] = {.lex_state = 14, .external_lex_state = 13},
  [1369] = {.lex_state = 15, .external_lex_state = 13},
  [1370] = {.lex_state = 15, .external_lex_state = 2},
  [1371] = {.lex_state = 15, .external_lex_state = 13},
  [1372] = {.lex_state = 15, .external_lex_state = 13},
  [1373] = {.lex_state = 15, .external_lex_state = 2},
  [1374] = {.lex_state = 15, .external_lex_state = 13},
  [1375] = {.lex_state = 15, .external_lex_state = 2},
  [1376] = {.lex_state = 15, .external_lex_state = 13},
  [1377] = {.lex_state = 15, .external_lex_state = 13},
  [1378] = {.lex_state = 15, .external_lex_state = 13},
  [1379] = {.lex_state = 15, .external_lex_state = 13},
  [1380] = {.lex_state = 15, .external_lex_state = 13},
  [1381] = {.lex_state = 15, .external_lex_state = 2},
  [1382] = {.lex_state = 15, .external_lex_state = 13},
  [1383] = {.lex_state = 11, .external_lex_state = 2},
  [1384] = {.lex_state = 11, .external_lex_state = 2},
  [1385] = {.lex_state = 11, .external_lex_state = 2},
  [1386] = {.lex_state = 15, .external_lex_state = 12},
  [1387] = {.lex_state = 15, .external_lex_state = 11},
  [1388] = {.lex_state = 11, .external_lex_state = 2},
  [1389] = {.lex_state = 11, .external_lex_state = 2},
  [1390] = {.lex_state = 11, .external_lex_state = 2},
  [1391] = {.lex_state = 11, .external_lex_state = 2},
  [1392] = {.lex_state = 15, .external_lex_state = 13},
  [1393] = {.lex_state = 11, .external_lex_state = 2},
  [1394] = {.lex_state = 11, .external_lex_state = 2},
  [1395] = {.lex_state = 11, .external_lex_state = 2},
  [1396] = {.lex_state = 11, .external_lex_state = 2},
  [1397] = {.lex_state = 11, .external_lex_state = 2},
  [1398] = {.lex_state = 11, .external_lex_state = 2},
  [1399] = {.lex_state = 11, .external_lex_state = 2},
  [1400] = {.lex_state = 11, .external_lex_state = 2},
  [1401] = {.lex_state = 11, .external_lex_state = 2},
  [1402] = {.lex_state = 11, .external_lex_state = 10},
  [1403] = {.lex_state = 11, .external_lex_state = 10},
  [1404] = {.lex_state = 11, .external_lex_state = 12},
  [1405] = {.lex_state = 15, .external_lex_state = 11},
  [1406] = {.lex_state = 11, .external_lex_state = 12},
  [1407] = {.lex_state = 15, .external_lex_state = 11},
  [1408] = {.lex_state = 15, .external_lex_state = 11},
  [1409] = {.lex_state = 15, .external_lex_state = 11},
  [1410] = {.lex_state = 15, .external_lex_state = 11},
  [1411] = {.lex_state = 15, .external_lex_state = 11},
  [1412] = {.lex_state = 11, .external_lex_state = 11},
  [1413] = {.lex_state = 11, .external_lex_state = 13},
  [1414] = {.lex_state = 11, .external_lex_state = 13},
  [1415] = {.lex_state = 11, .external_lex_state = 11},
  [1416] = {.lex_state = 27, .external_lex_state = 11},
  [1417] = {.lex_state = 27, .external_lex_state = 11},
  [1418] = {.lex_state = 11, .external_lex_state = 2},
  [1419] = {.lex_state = 11, .external_lex_state = 2},
  [1420] = {.lex_state = 20, .external_lex_state = 10},
  [1421] = {.lex_state = 15, .external_lex_state = 12},
  [1422] = {.lex_state = 0, .external_lex_state = 13},
  [1423] = {.lex_state = 15, .external_lex_state = 12},
  [1424] = {.lex_state = 23, .external_lex_state = 10},
  [1425] = {.lex_state = 15, .external_lex_state = 12},
  [1426] = {.lex_state = 0, .external_lex_state = 12},
  [1427] = {.lex_state = 0, .external_lex_state = 12},
  [1428] = {.lex_state = 15, .external_lex_state = 12},
  [1429] = {.lex_state = 20, .external_lex_state = 10},
  [1430] = {.lex_state = 23, .external_lex_state = 10},
  [1431] = {.lex_state = 15, .external_lex_state = 12},
  [1432] = {.lex_state = 0, .external_lex_state = 13},
  [1433] = {.lex_state = 15, .external_lex_state = 12},
  [1434] = {.lex_state = 15, .external_lex_state = 2},
  [1435] = {.lex_state = 15, .external_lex_state = 2},
  [1436] = {.lex_state = 15, .external_lex_state = 2},
  [1437] = {.lex_state = 15, .external_lex_state = 12},
  [1438] = {.lex_state = 15, .external_lex_state = 2},
  [1439] = {.lex_state = 15, .external_lex_state = 2},
  [1440] = {.lex_state = 15, .external_lex_state = 2},
  [1441] = {.lex_state = 15, .external_lex_state = 12},
  [1442] = {.lex_state = 15, .external_lex_state = 13},
  [1443] = {.lex_state = 15, .external_lex_state = 13},
  [1444] = {.lex_state = 23, .external_lex_state = 10},
  [1445] = {.lex_state = 15, .external_lex_state = 2},
  [1446] = {.lex_state = 15, .external_lex_state = 2},
  [1447] = {.lex_state = 15, .external_lex_state = 2},
  [1448] = {.lex_state = 15, .external_lex_state = 2},
  [1449] = {.lex_state = 15, .external_lex_state = 2},
  [1450] = {.lex_state = 1, .external_lex_state = 14},
  [1451] = {.lex_state = 15, .external_lex_state = 12},
  [1452] = {.lex_state = 15, .external_lex_state = 2},
  [1453] = {.lex_state = 15, .external_lex_state = 2},
  [1454] = {.lex_state = 15, .external_lex_state = 2},
  [1455] = {.lex_state = 23, .external_lex_state = 10},
  [1456] = {.lex_state = 23, .external_lex_state = 10},
  [1457] = {.lex_state = 15, .external_lex_state = 12},
  [1458] = {.lex_state = 15, .external_lex_state = 13},
  [1459] = {.lex_state = 15, .external_lex_state = 12},
  [1460] = {.lex_state = 15, .external_lex_state = 13},
  [1461] = {.lex_state = 15, .external_lex_state = 2},
  [1462] = {.lex_state = 15, .external_lex_state = 2},
  [1463] = {.lex_state = 15, .external_lex_state = 12},
  [1464] = {.lex_state = 15, .external_lex_state = 2},
  [1465] = {.lex_state = 15, .external_lex_state = 2},
  [1466] = {.lex_state = 15, .external_lex_state = 2},
  [1467] = {.lex_state = 15, .external_lex_state = 2},
  [1468] = {.lex_state = 15, .external_lex_state = 2},
  [1469] = {.lex_state = 15, .external_lex_state = 13},
  [1470] = {.lex_state = 15, .external_lex_state = 13},
  [1471] = {.lex_state = 15, .external_lex_state = 2},
  [1472] = {.lex_state = 15, .external_lex_state = 2},
  [1473] = {.lex_state = 15, .external_lex_state = 2},
  [1474] = {.lex_state = 15, .external_lex_state = 2},
  [1475] = {.lex_state = 15, .external_lex_state = 2},
  [1476] = {.lex_state = 15, .external_lex_state = 2},
  [1477] = {.lex_state = 15, .external_lex_state = 2},
  [1478] = {.lex_state = 23, .external_lex_state = 10},
  [1479] = {.lex_state = 15, .external_lex_state = 2},
  [1480] = {.lex_state = 15, .external_lex_state = 2},
  [1481] = {.lex_state = 15, .external_lex_state = 2},
  [1482] = {.lex_state = 43, .external_lex_state = 2},
  [1483] = {.lex_state = 23, .external_lex_state = 2},
  [1484] = {.lex_state = 43, .external_lex_state = 2},
  [1485] = {.lex_state = 43, .external_lex_state = 2},
  [1486] = {.lex_state = 43, .external_lex_state = 2},
  [1487] = {.lex_state = 43, .external_lex_state = 2},
  [1488] = {.lex_state = 43, .external_lex_state = 2},
  [1489] = {.lex_state = 352, .external_lex_state = 2},
  [1490] = {.lex_state = 43, .external_lex_state = 2},
  [1491] = {.lex_state = 43, .external_lex_state = 2},
  [1492] = {.lex_state = 43, .external_lex_state = 2},
  [1493] = {.lex_state = 11, .external_lex_state = 2},
  [1494] = {.lex_state = 43, .external_lex_state = 2},
  [1495] = {.lex_state = 43, .external_lex_state = 2},
  [1496] = {.lex_state = 11, .external_lex_state = 2},
  [1497] = {.lex_state = 23, .external_lex_state = 2},
  [1498] = {.lex_state = 43, .external_lex_state = 2},
  [1499] = {.lex_state = 23, .external_lex_state = 10},
  [1500] = {.lex_state = 11, .external_lex_state = 2},
  [1501] = {.lex_state = 11, .external_lex_state = 2},
  [1502] = {.lex_state = 23, .external_lex_state = 2},
  [1503] = {.lex_state = 33, .external_lex_state = 14},
  [1504] = {.lex_state = 23, .external_lex_state = 2},
  [1505] = {.lex_state = 43, .external_lex_state = 2},
  [1506] = {.lex_state = 20, .external_lex_state = 2},
  [1507] = {.lex_state = 20, .external_lex_state = 2},
  [1508] = {.lex_state = 43, .external_lex_state = 12},
  [1509] = {.lex_state = 34, .external_lex_state = 2},
  [1510] = {.lex_state = 43, .external_lex_state = 12},
  [1511] = {.lex_state = 43, .external_lex_state = 2},
  [1512] = {.lex_state = 43, .external_lex_state = 2},
  [1513] = {.lex_state = 33, .external_lex_state = 14},
  [1514] = {.lex_state = 23, .external_lex_state = 2},
  [1515] = {.lex_state = 43, .external_lex_state = 12},
  [1516] = {.lex_state = 33, .external_lex_state = 2},
  [1517] = {.lex_state = 33, .external_lex_state = 14},
  [1518] = {.lex_state = 43, .external_lex_state = 2},
  [1519] = {.lex_state = 33, .external_lex_state = 14},
  [1520] = {.lex_state = 43, .external_lex_state = 2},
  [1521] = {.lex_state = 33, .external_lex_state = 14},
  [1522] = {.lex_state = 33, .external_lex_state = 14},
  [1523] = {.lex_state = 33, .external_lex_state = 14},
  [1524] = {.lex_state = 33, .external_lex_state = 14},
  [1525] = {.lex_state = 33, .external_lex_state = 14},
  [1526] = {.lex_state = 33, .external_lex_state = 14},
  [1527] = {.lex_state = 11, .external_lex_state = 10},
  [1528] = {.lex_state = 27, .external_lex_state = 11},
  [1529] = {.lex_state = 27, .external_lex_state = 11},
  [1530] = {.lex_state = 27, .external_lex_state = 11},
  [1531] = {.lex_state = 27, .external_lex_state = 11},
  [1532] = {.lex_state = 27, .external_lex_state = 11},
  [1533] = {.lex_state = 11, .external_lex_state = 10},
  [1534] = {.lex_state = 27, .external_lex_state = 11},
  [1535] = {.lex_state = 27, .external_lex_state = 11},
  [1536] = {.lex_state = 27, .external_lex_state = 11},
  [1537] = {.lex_state = 11, .external_lex_state = 10},
  [1538] = {.lex_state = 0, .external_lex_state = 13},
  [1539] = {.lex_state = 0, .external_lex_state = 12},
  [1540] = {.lex_state = 0, .external_lex_state = 13},
  [1541] = {.lex_state = 0, .external_lex_state = 12},
  [1542] = {.lex_state = 11, .external_lex_state = 10},
  [1543] = {.lex_state = 0, .external_lex_state = 12},
  [1544] = {.lex_state = 0, .external_lex_state = 12},
  [1545] = {.lex_state = 0, .external_lex_state = 12},
  [1546] = {.lex_state = 0, .external_lex_state = 13},
  [1547] = {.lex_state = 0, .external_lex_state = 12},
  [1548] = {.lex_state = 0, .external_lex_state = 13},
  [1549] = {.lex_state = 0, .external_lex_state = 12},
  [1550] = {.lex_state = 11, .external_lex_state = 10},
  [1551] = {.lex_state = 0, .external_lex_state = 12},
  [1552] = {.lex_state = 333, .external_lex_state = 2},
  [1553] = {.lex_state = 0, .external_lex_state = 12},
  [1554] = {.lex_state = 0, .external_lex_state = 13},
  [1555] = {.lex_state = 0, .external_lex_state = 13},
  [1556] = {.lex_state = 0, .external_lex_state = 13},
  [1557] = {.lex_state = 333, .external_lex_state = 2},
  [1558] = {.lex_state = 0, .external_lex_state = 12},
  [1559] = {.lex_state = 0, .external_lex_state = 12},
  [1560] = {.lex_state = 33, .external_lex_state = 2},
  [1561] = {.lex_state = 333, .external_lex_state = 2},
  [1562] = {.lex_state = 11, .external_lex_state = 10},
  [1563] = {.lex_state = 33, .external_lex_state = 2},
  [1564] = {.lex_state = 0, .external_lex_state = 12},
  [1565] = {.lex_state = 0, .external_lex_state = 13},
  [1566] = {.lex_state = 11, .external_lex_state = 10},
  [1567] = {.lex_state = 33, .external_lex_state = 2},
  [1568] = {.lex_state = 33, .external_lex_state = 2},
  [1569] = {.lex_state = 11, .external_lex_state = 10},
  [1570] = {.lex_state = 0, .external_lex_state = 12},
  [1571] = {.lex_state = 11, .external_lex_state = 10},
  [1572] = {.lex_state = 33, .external_lex_state = 2},
  [1573] = {.lex_state = 0, .external_lex_state = 12},
  [1574] = {.lex_state = 0, .external_lex_state = 12},
  [1575] = {.lex_state = 0, .external_lex_state = 12},
  [1576] = {.lex_state = 11, .external_lex_state = 10},
  [1577] = {.lex_state = 0, .external_lex_state = 12},
  [1578] = {.lex_state = 0, .external_lex_state = 15},
  [1579] = {.lex_state = 33, .external_lex_state = 2},
  [1580] = {.lex_state = 0, .external_lex_state = 15},
  [1581] = {.lex_state = 11, .external_lex_state = 12},
  [1582] = {.lex_state = 11, .external_lex_state = 12},
  [1583] = {.lex_state = 11, .external_lex_state = 12},
  [1584] = {.lex_state = 0, .external_lex_state = 15},
  [1585] = {.lex_state = 11, .external_lex_state = 12},
  [1586] = {.lex_state = 0, .external_lex_state = 15},
  [1587] = {.lex_state = 0, .external_lex_state = 15},
  [1588] = {.lex_state = 0, .external_lex_state = 15},
  [1589] = {.lex_state = 33, .external_lex_state = 2},
  [1590] = {.lex_state = 334, .external_lex_state = 2},
  [1591] = {.lex_state = 0, .external_lex_state = 15},
  [1592] = {.lex_state = 11, .external_lex_state = 2},
  [1593] = {.lex_state = 11, .external_lex_state = 11},
  [1594] = {.lex_state = 334, .external_lex_state = 2},
  [1595] = {.lex_state = 11, .external_lex_state = 12},
  [1596] = {.lex_state = 0, .external_lex_state = 15},
  [1597] = {.lex_state = 0, .external_lex_state = 15},
  [1598] = {.lex_state = 11, .external_lex_state = 10},
  [1599] = {.lex_state = 33, .external_lex_state = 2},
  [1600] = {.lex_state = 0, .external_lex_state = 15},
  [1601] = {.lex_state = 11, .external_lex_state = 12},
  [1602] = {.lex_state = 0, .external_lex_state = 15},
  [1603] = {.lex_state = 0, .external_lex_state = 15},
  [1604] = {.lex_state = 11, .external_lex_state = 2},
  [1605] = {.lex_state = 0, .external_lex_state = 15},
  [1606] = {.lex_state = 11, .external_lex_state = 12},
  [1607] = {.lex_state = 11, .external_lex_state = 12},
  [1608] = {.lex_state = 334, .external_lex_state = 2},
  [1609] = {.lex_state = 0, .external_lex_state = 15},
  [1610] = {.lex_state = 0, .external_lex_state = 15},
  [1611] = {.lex_state = 11, .external_lex_state = 12},
  [1612] = {.lex_state = 0, .external_lex_state = 15},
  [1613] = {.lex_state = 11, .external_lex_state = 11},
  [1614] = {.lex_state = 0, .external_lex_state = 15},
  [1615] = {.lex_state = 0, .external_lex_state = 15},
  [1616] = {.lex_state = 11, .external_lex_state = 12},
  [1617] = {.lex_state = 11, .external_lex_state = 2},
  [1618] = {.lex_state = 0, .external_lex_state = 15},
  [1619] = {.lex_state = 27, .external_lex_state = 11},
  [1620] = {.lex_state = 27, .external_lex_state = 11},
  [1621] = {.lex_state = 11, .external_lex_state = 13},
  [1622] = {.lex_state = 11, .external_lex_state = 11},
  [1623] = {.lex_state = 11, .external_lex_state = 11},
  [1624] = {.lex_state = 11, .external_lex_state = 11},
  [1625] = {.lex_state = 11, .external_lex_state = 11},
  [1626] = {.lex_state = 27, .external_lex_state = 11},
  [1627] = {.lex_state = 27, .external_lex_state = 11},
  [1628] = {.lex_state = 11, .external_lex_state = 11},
  [1629] = {.lex_state = 11, .external_lex_state = 11},
  [1630] = {.lex_state = 11, .external_lex_state = 11},
  [1631] = {.lex_state = 11, .external_lex_state = 13},
  [1632] = {.lex_state = 11, .external_lex_state = 2},
  [1633] = {.lex_state = 11, .external_lex_state = 2},
  [1634] = {.lex_state = 27, .external_lex_state = 11},
  [1635] = {.lex_state = 11, .external_lex_state = 13},
  [1636] = {.lex_state = 27, .external_lex_state = 11},
  [1637] = {.lex_state = 11, .external_lex_state = 2},
  [1638] = {.lex_state = 11, .external_lex_state = 2},
  [1639] = {.lex_state = 11, .external_lex_state = 13},
  [1640] = {.lex_state = 11, .external_lex_state = 2},
  [1641] = {.lex_state = 20, .external_lex_state = 10},
  [1642] = {.lex_state = 11, .external_lex_state = 2},
  [1643] = {.lex_state = 27, .external_lex_state = 11},
  [1644] = {.lex_state = 11, .external_lex_state = 11},
  [1645] = {.lex_state = 27, .external_lex_state = 11},
  [1646] = {.lex_state = 11, .external_lex_state = 13},
  [1647] = {.lex_state = 11, .external_lex_state = 11},
  [1648] = {.lex_state = 11, .external_lex_state = 13},
  [1649] = {.lex_state = 27, .external_lex_state = 11},
  [1650] = {.lex_state = 11, .external_lex_state = 2},
  [1651] = {.lex_state = 11, .external_lex_state = 13},
  [1652] = {.lex_state = 33, .external_lex_state = 2},
  [1653] = {.lex_state = 11, .external_lex_state = 13},
  [1654] = {.lex_state = 11, .external_lex_state = 13},
  [1655] = {.lex_state = 11, .external_lex_state = 11},
  [1656] = {.lex_state = 11, .external_lex_state = 11},
  [1657] = {.lex_state = 11, .external_lex_state = 13},
  [1658] = {.lex_state = 20, .external_lex_state = 10},
  [1659] = {.lex_state = 0, .external_lex_state = 13},
  [1660] = {.lex_state = 20, .external_lex_state = 10},
  [1661] = {.lex_state = 0, .external_lex_state = 11},
  [1662] = {.lex_state = 20, .external_lex_state = 10},
  [1663] = {.lex_state = 0, .external_lex_state = 13},
  [1664] = {.lex_state = 20, .external_lex_state = 10},
  [1665] = {.lex_state = 33, .external_lex_state = 2},
  [1666] = {.lex_state = 0, .external_lex_state = 12},
  [1667] = {.lex_state = 33, .external_lex_state = 2},
  [1668] = {.lex_state = 0, .external_lex_state = 11},
  [1669] = {.lex_state = 5, .external_lex_state = 2},
  [1670] = {.lex_state = 0, .external_lex_state = 11},
  [1671] = {.lex_state = 0, .external_lex_state = 12},
  [1672] = {.lex_state = 20, .external_lex_state = 10},
  [1673] = {.lex_state = 333, .external_lex_state = 2},
  [1674] = {.lex_state = 20, .external_lex_state = 10},
  [1675] = {.lex_state = 11, .external_lex_state = 13},
  [1676] = {.lex_state = 20, .external_lex_state = 10},
  [1677] = {.lex_state = 20, .external_lex_state = 10},
  [1678] = {.lex_state = 0, .external_lex_state = 12},
  [1679] = {.lex_state = 20, .external_lex_state = 10},
  [1680] = {.lex_state = 33, .external_lex_state = 2},
  [1681] = {.lex_state = 0, .external_lex_state = 13},
  [1682] = {.lex_state = 11, .external_lex_state = 13},
  [1683] = {.lex_state = 0, .external_lex_state = 11},
  [1684] = {.lex_state = 36, .external_lex_state = 2},
  [1685] = {.lex_state = 11, .external_lex_state = 13},
  [1686] = {.lex_state = 20, .external_lex_state = 10},
  [1687] = {.lex_state = 11, .external_lex_state = 13},
  [1688] = {.lex_state = 5, .external_lex_state = 2},
  [1689] = {.lex_state = 20, .external_lex_state = 10},
  [1690] = {.lex_state = 20, .external_lex_state = 10},
  [1691] = {.lex_state = 0, .external_lex_state = 13},
  [1692] = {.lex_state = 0, .external_lex_state = 12},
  [1693] = {.lex_state = 11, .external_lex_state = 13},
  [1694] = {.lex_state = 333, .external_lex_state = 2},
  [1695] = {.lex_state = 36, .external_lex_state = 2},
  [1696] = {.lex_state = 0, .external_lex_state = 12},
  [1697] = {.lex_state = 0, .external_lex_state = 2},
  [1698] = {.lex_state = 333, .external_lex_state = 2},
  [1699] = {.lex_state = 11, .external_lex_state = 13},
  [1700] = {.lex_state = 11, .external_lex_state = 13},
  [1701] = {.lex_state = 0, .external_lex_state = 13},
  [1702] = {.lex_state = 11, .external_lex_state = 13},
  [1703] = {.lex_state = 36, .external_lex_state = 2},
  [1704] = {.lex_state = 0, .external_lex_state = 12},
  [1705] = {.lex_state = 0, .external_lex_state = 2},
  [1706] = {.lex_state = 20, .external_lex_state = 10},
  [1707] = {.lex_state = 20, .external_lex_state = 10},
  [1708] = {.lex_state = 0, .external_lex_state = 13},
  [1709] = {.lex_state = 0, .external_lex_state = 13},
  [1710] = {.lex_state = 0, .external_lex_state = 13},
  [1711] = {.lex_state = 0, .external_lex_state = 13},
  [1712] = {.lex_state = 0, .external_lex_state = 13},
  [1713] = {.lex_state = 0, .external_lex_state = 12},
  [1714] = {.lex_state = 36, .external_lex_state = 2},
  [1715] = {.lex_state = 0, .external_lex_state = 12},
  [1716] = {.lex_state = 0, .external_lex_state = 12},
  [1717] = {.lex_state = 20, .external_lex_state = 10},
  [1718] = {.lex_state = 0, .external_lex_state = 12},
  [1719] = {.lex_state = 11, .external_lex_state = 13},
  [1720] = {.lex_state = 0, .external_lex_state = 13},
  [1721] = {.lex_state = 0, .external_lex_state = 13},
  [1722] = {.lex_state = 0, .external_lex_state = 12},
  [1723] = {.lex_state = 0, .external_lex_state = 12},
  [1724] = {.lex_state = 11, .external_lex_state = 13},
  [1725] = {.lex_state = 55, .external_lex_state = 2},
  [1726] = {.lex_state = 0, .external_lex_state = 11},
  [1727] = {.lex_state = 20, .external_lex_state = 12},
  [1728] = {.lex_state = 334, .external_lex_state = 2},
  [1729] = {.lex_state = 0, .external_lex_state = 11},
  [1730] = {.lex_state = 0, .external_lex_state = 11},
  [1731] = {.lex_state = 11, .external_lex_state = 13},
  [1732] = {.lex_state = 0, .external_lex_state = 15},
  [1733] = {.lex_state = 11, .external_lex_state = 2},
  [1734] = {.lex_state = 0, .external_lex_state = 12},
  [1735] = {.lex_state = 0, .external_lex_state = 11},
  [1736] = {.lex_state = 20, .external_lex_state = 10},
  [1737] = {.lex_state = 0, .external_lex_state = 12},
  [1738] = {.lex_state = 0, .external_lex_state = 15},
  [1739] = {.lex_state = 0, .external_lex_state = 11},
  [1740] = {.lex_state = 0, .external_lex_state = 13},
  [1741] = {.lex_state = 0, .external_lex_state = 11},
  [1742] = {.lex_state = 0, .external_lex_state = 11},
  [1743] = {.lex_state = 0, .external_lex_state = 11},
  [1744] = {.lex_state = 334, .external_lex_state = 2},
  [1745] = {.lex_state = 0, .external_lex_state = 13},
  [1746] = {.lex_state = 0, .external_lex_state = 11},
  [1747] = {.lex_state = 0, .external_lex_state = 11},
  [1748] = {.lex_state = 11, .external_lex_state = 2},
  [1749] = {.lex_state = 20, .external_lex_state = 13},
  [1750] = {.lex_state = 352, .external_lex_state = 14},
  [1751] = {.lex_state = 0, .external_lex_state = 13},
  [1752] = {.lex_state = 0, .external_lex_state = 13},
  [1753] = {.lex_state = 11, .external_lex_state = 13},
  [1754] = {.lex_state = 334, .external_lex_state = 2},
  [1755] = {.lex_state = 20, .external_lex_state = 10},
  [1756] = {.lex_state = 0, .external_lex_state = 11},
  [1757] = {.lex_state = 52, .external_lex_state = 2},
  [1758] = {.lex_state = 0, .external_lex_state = 12},
  [1759] = {.lex_state = 0, .external_lex_state = 11},
  [1760] = {.lex_state = 11, .external_lex_state = 13},
  [1761] = {.lex_state = 20, .external_lex_state = 10},
  [1762] = {.lex_state = 0, .external_lex_state = 12},
  [1763] = {.lex_state = 11, .external_lex_state = 2},
  [1764] = {.lex_state = 0, .external_lex_state = 12},
  [1765] = {.lex_state = 11, .external_lex_state = 10},
  [1766] = {.lex_state = 11, .external_lex_state = 13},
  [1767] = {.lex_state = 11, .external_lex_state = 12},
  [1768] = {.lex_state = 20, .external_lex_state = 12},
  [1769] = {.lex_state = 20, .external_lex_state = 13},
  [1770] = {.lex_state = 0, .external_lex_state = 13},
  [1771] = {.lex_state = 20, .external_lex_state = 12},
  [1772] = {.lex_state = 20, .external_lex_state = 11},
  [1773] = {.lex_state = 20, .external_lex_state = 12},
  [1774] = {.lex_state = 0, .external_lex_state = 13},
  [1775] = {.lex_state = 11, .external_lex_state = 2},
  [1776] = {.lex_state = 352, .external_lex_state = 11},
  [1777] = {.lex_state = 0, .external_lex_state = 15},
  [1778] = {.lex_state = 0, .external_lex_state = 15},
  [1779] = {.lex_state = 11, .external_lex_state = 12},
  [1780] = {.lex_state = 20, .external_lex_state = 11},
  [1781] = {.lex_state = 20, .external_lex_state = 11},
  [1782] = {.lex_state = 20, .external_lex_state = 10},
  [1783] = {.lex_state = 20, .external_lex_state = 10},
  [1784] = {.lex_state = 11, .external_lex_state = 12},
  [1785] = {.lex_state = 58, .external_lex_state = 2},
  [1786] = {.lex_state = 11, .external_lex_state = 13},
  [1787] = {.lex_state = 20, .external_lex_state = 12},
  [1788] = {.lex_state = 11, .external_lex_state = 2},
  [1789] = {.lex_state = 0, .external_lex_state = 12},
  [1790] = {.lex_state = 20, .external_lex_state = 11},
  [1791] = {.lex_state = 20, .external_lex_state = 10},
  [1792] = {.lex_state = 20, .external_lex_state = 12},
  [1793] = {.lex_state = 20, .external_lex_state = 12},
  [1794] = {.lex_state = 0, .external_lex_state = 15},
  [1795] = {.lex_state = 11, .external_lex_state = 12},
  [1796] = {.lex_state = 11, .external_lex_state = 12},
  [1797] = {.lex_state = 11, .external_lex_state = 10},
  [1798] = {.lex_state = 0, .external_lex_state = 12},
  [1799] = {.lex_state = 0, .external_lex_state = 13},
  [1800] = {.lex_state = 20, .external_lex_state = 13},
  [1801] = {.lex_state = 352, .external_lex_state = 11},
  [1802] = {.lex_state = 11, .external_lex_state = 2},
  [1803] = {.lex_state = 11, .external_lex_state = 13},
  [1804] = {.lex_state = 11, .external_lex_state = 12},
  [1805] = {.lex_state = 35, .external_lex_state = 2},
  [1806] = {.lex_state = 20, .external_lex_state = 10},
  [1807] = {.lex_state = 352, .external_lex_state = 11},
  [1808] = {.lex_state = 11, .external_lex_state = 12},
  [1809] = {.lex_state = 20, .external_lex_state = 12},
  [1810] = {.lex_state = 11, .external_lex_state = 12},
  [1811] = {.lex_state = 20, .external_lex_state = 12},
  [1812] = {.lex_state = 0, .external_lex_state = 13},
  [1813] = {.lex_state = 20, .external_lex_state = 10},
  [1814] = {.lex_state = 20, .external_lex_state = 12},
  [1815] = {.lex_state = 20, .external_lex_state = 13},
  [1816] = {.lex_state = 11, .external_lex_state = 10},
  [1817] = {.lex_state = 35, .external_lex_state = 2},
  [1818] = {.lex_state = 11, .external_lex_state = 10},
  [1819] = {.lex_state = 20, .external_lex_state = 13},
  [1820] = {.lex_state = 11, .external_lex_state = 2},
  [1821] = {.lex_state = 0, .external_lex_state = 12},
  [1822] = {.lex_state = 11, .external_lex_state = 10},
  [1823] = {.lex_state = 20, .external_lex_state = 12},
  [1824] = {.lex_state = 20, .external_lex_state = 13},
  [1825] = {.lex_state = 20, .external_lex_state = 13},
  [1826] = {.lex_state = 0, .external_lex_state = 11},
  [1827] = {.lex_state = 0, .external_lex_state = 15},
  [1828] = {.lex_state = 11, .external_lex_state = 13},
  [1829] = {.lex_state = 0, .external_lex_state = 15},
  [1830] = {.lex_state = 0, .external_lex_state = 15},
  [1831] = {.lex_state = 0, .external_lex_state = 15},
  [1832] = {.lex_state = 11, .external_lex_state = 10},
  [1833] = {.lex_state = 0, .external_lex_state = 15},
  [1834] = {.lex_state = 0, .external_lex_state = 13},
  [1835] = {.lex_state = 0, .external_lex_state = 11},
  [1836] = {.lex_state = 0, .external_lex_state = 11},
  [1837] = {.lex_state = 20, .external_lex_state = 10},
  [1838] = {.lex_state = 11, .external_lex_state = 10},
  [1839] = {.lex_state = 11, .external_lex_state = 10},
  [1840] = {.lex_state = 352, .external_lex_state = 14},
  [1841] = {.lex_state = 0, .external_lex_state = 11},
  [1842] = {.lex_state = 20, .external_lex_state = 12},
  [1843] = {.lex_state = 11, .external_lex_state = 10},
  [1844] = {.lex_state = 0, .external_lex_state = 12},
  [1845] = {.lex_state = 352, .external_lex_state = 11},
  [1846] = {.lex_state = 11, .external_lex_state = 12},
  [1847] = {.lex_state = 20, .external_lex_state = 13},
  [1848] = {.lex_state = 11, .external_lex_state = 2},
  [1849] = {.lex_state = 0, .external_lex_state = 11},
  [1850] = {.lex_state = 32, .external_lex_state = 2},
  [1851] = {.lex_state = 11, .external_lex_state = 2},
  [1852] = {.lex_state = 20, .external_lex_state = 10},
  [1853] = {.lex_state = 11, .external_lex_state = 2},
  [1854] = {.lex_state = 43, .external_lex_state = 2},
  [1855] = {.lex_state = 11, .external_lex_state = 12},
  [1856] = {.lex_state = 20, .external_lex_state = 2},
  [1857] = {.lex_state = 20, .external_lex_state = 2},
  [1858] = {.lex_state = 1, .external_lex_state = 2},
  [1859] = {.lex_state = 20, .external_lex_state = 2},
  [1860] = {.lex_state = 11, .external_lex_state = 13},
  [1861] = {.lex_state = 0, .external_lex_state = 11},
  [1862] = {.lex_state = 11, .external_lex_state = 13},
  [1863] = {.lex_state = 0, .external_lex_state = 11},
  [1864] = {.lex_state = 20, .external_lex_state = 2},
  [1865] = {.lex_state = 352, .external_lex_state = 11},
  [1866] = {.lex_state = 11, .external_lex_state = 2},
  [1867] = {.lex_state = 0, .external_lex_state = 12},
  [1868] = {.lex_state = 2, .external_lex_state = 2},
  [1869] = {.lex_state = 0, .external_lex_state = 12},
  [1870] = {.lex_state = 11, .external_lex_state = 2},
  [1871] = {.lex_state = 0, .external_lex_state = 16},
  [1872] = {.lex_state = 20, .external_lex_state = 12},
  [1873] = {.lex_state = 11, .external_lex_state = 2},
  [1874] = {.lex_state = 10, .external_lex_state = 11},
  [1875] = {.lex_state = 11, .external_lex_state = 2},
  [1876] = {.lex_state = 0, .external_lex_state = 13},
  [1877] = {.lex_state = 352, .external_lex_state = 11},
  [1878] = {.lex_state = 0, .external_lex_state = 10},
  [1879] = {.lex_state = 0, .external_lex_state = 10},
  [1880] = {.lex_state = 0, .external_lex_state = 11},
  [1881] = {.lex_state = 0, .external_lex_state = 16},
  [1882] = {.lex_state = 11, .external_lex_state = 2},
  [1883] = {.lex_state = 11, .external_lex_state = 2},
  [1884] = {.lex_state = 0, .external_lex_state = 12},
  [1885] = {.lex_state = 11, .external_lex_state = 2},
  [1886] = {.lex_state = 11, .external_lex_state = 2},
  [1887] = {.lex_state = 20, .external_lex_state = 2},
  [1888] = {.lex_state = 20, .external_lex_state = 2},
  [1889] = {.lex_state = 32, .external_lex_state = 2},
  [1890] = {.lex_state = 352, .external_lex_state = 11},
  [1891] = {.lex_state = 20, .external_lex_state = 12},
  [1892] = {.lex_state = 20, .external_lex_state = 10},
  [1893] = {.lex_state = 11, .external_lex_state = 2},
  [1894] = {.lex_state = 5, .external_lex_state = 2},
  [1895] = {.lex_state = 11, .external_lex_state = 2},
  [1896] = {.lex_state = 11, .external_lex_state = 13},
  [1897] = {.lex_state = 11, .external_lex_state = 2},
  [1898] = {.lex_state = 20, .external_lex_state = 11},
  [1899] = {.lex_state = 5, .external_lex_state = 2},
  [1900] = {.lex_state = 10, .external_lex_state = 11},
  [1901] = {.lex_state = 20, .external_lex_state = 11},
  [1902] = {.lex_state = 11, .external_lex_state = 13},
  [1903] = {.lex_state = 20, .external_lex_state = 2},
  [1904] = {.lex_state = 352, .external_lex_state = 11},
  [1905] = {.lex_state = 20, .external_lex_state = 2},
  [1906] = {.lex_state = 20, .external_lex_state = 12},
  [1907] = {.lex_state = 20, .external_lex_state = 2},
  [1908] = {.lex_state = 11, .external_lex_state = 13},
  [1909] = {.lex_state = 43, .external_lex_state = 10},
  [1910] = {.lex_state = 20, .external_lex_state = 2},
  [1911] = {.lex_state = 20, .external_lex_state = 11},
  [1912] = {.lex_state = 20, .external_lex_state = 2},
  [1913] = {.lex_state = 11, .external_lex_state = 13},
  [1914] = {.lex_state = 352, .external_lex_state = 11},
  [1915] = {.lex_state = 11, .external_lex_state = 13},
  [1916] = {.lex_state = 43, .external_lex_state = 10},
  [1917] = {.lex_state = 11, .external_lex_state = 13},
  [1918] = {.lex_state = 0, .external_lex_state = 16},
  [1919] = {.lex_state = 5, .external_lex_state = 2},
  [1920] = {.lex_state = 352, .external_lex_state = 14},
  [1921] = {.lex_state = 20, .external_lex_state = 11},
  [1922] = {.lex_state = 20, .external_lex_state = 2},
  [1923] = {.lex_state = 43, .external_lex_state = 10},
  [1924] = {.lex_state = 20, .external_lex_state = 2},
  [1925] = {.lex_state = 20, .external_lex_state = 2},
  [1926] = {.lex_state = 0, .external_lex_state = 13},
  [1927] = {.lex_state = 0, .external_lex_state = 13},
  [1928] = {.lex_state = 0, .external_lex_state = 16},
  [1929] = {.lex_state = 11, .external_lex_state = 2},
  [1930] = {.lex_state = 10, .external_lex_state = 11},
  [1931] = {.lex_state = 0, .external_lex_state = 16},
  [1932] = {.lex_state = 11, .external_lex_state = 2},
  [1933] = {.lex_state = 0, .external_lex_state = 16},
  [1934] = {.lex_state = 352, .external_lex_state = 11},
  [1935] = {.lex_state = 11, .external_lex_state = 2},
  [1936] = {.lex_state = 11, .external_lex_state = 13},
  [1937] = {.lex_state = 2, .external_lex_state = 2},
  [1938] = {.lex_state = 0, .external_lex_state = 16},
  [1939] = {.lex_state = 352, .external_lex_state = 11},
  [1940] = {.lex_state = 1, .external_lex_state = 2},
  [1941] = {.lex_state = 20, .external_lex_state = 2},
  [1942] = {.lex_state = 20, .external_lex_state = 2},
  [1943] = {.lex_state = 20, .external_lex_state = 10},
  [1944] = {.lex_state = 352, .external_lex_state = 14},
  [1945] = {.lex_state = 0, .external_lex_state = 10},
  [1946] = {.lex_state = 352, .external_lex_state = 14},
  [1947] = {.lex_state = 352, .external_lex_state = 11},
  [1948] = {.lex_state = 43, .external_lex_state = 2},
  [1949] = {.lex_state = 3, .external_lex_state = 2},
  [1950] = {.lex_state = 0, .external_lex_state = 10},
  [1951] = {.lex_state = 4, .external_lex_state = 2},
  [1952] = {.lex_state = 0, .external_lex_state = 10},
  [1953] = {.lex_state = 43, .external_lex_state = 2},
  [1954] = {.lex_state = 0, .external_lex_state = 10},
  [1955] = {.lex_state = 0, .external_lex_state = 10},
  [1956] = {.lex_state = 0, .external_lex_state = 10},
  [1957] = {.lex_state = 56, .external_lex_state = 2},
  [1958] = {.lex_state = 0, .external_lex_state = 10},
  [1959] = {.lex_state = 0, .external_lex_state = 10},
  [1960] = {.lex_state = 43, .external_lex_state = 12},
  [1961] = {.lex_state = 3, .external_lex_state = 2},
  [1962] = {.lex_state = 352, .external_lex_state = 11},
  [1963] = {.lex_state = 11, .external_lex_state = 2},
  [1964] = {.lex_state = 0, .external_lex_state = 10},
  [1965] = {.lex_state = 35, .external_lex_state = 2},
  [1966] = {.lex_state = 35, .external_lex_state = 2},
  [1967] = {.lex_state = 3, .external_lex_state = 2},
  [1968] = {.lex_state = 0, .external_lex_state = 10},
  [1969] = {.lex_state = 0, .external_lex_state = 10},
  [1970] = {.lex_state = 0, .external_lex_state = 10},
  [1971] = {.lex_state = 43, .external_lex_state = 12},
  [1972] = {.lex_state = 43, .external_lex_state = 2},
  [1973] = {.lex_state = 0, .external_lex_state = 10},
  [1974] = {.lex_state = 20, .external_lex_state = 12},
  [1975] = {.lex_state = 352, .external_lex_state = 14},
  [1976] = {.lex_state = 20, .external_lex_state = 12},
  [1977] = {.lex_state = 0, .external_lex_state = 10},
  [1978] = {.lex_state = 0, .external_lex_state = 10},
  [1979] = {.lex_state = 0, .external_lex_state = 10},
  [1980] = {.lex_state = 1, .external_lex_state = 2},
  [1981] = {.lex_state = 43, .external_lex_state = 12},
  [1982] = {.lex_state = 56, .external_lex_state = 2},
  [1983] = {.lex_state = 0, .external_lex_state = 10},
  [1984] = {.lex_state = 0, .external_lex_state = 10},
  [1985] = {.lex_state = 352, .external_lex_state = 12},
  [1986] = {.lex_state = 0, .external_lex_state = 12},
  [1987] = {.lex_state = 0, .external_lex_state = 12},
  [1988] = {.lex_state = 0, .external_lex_state = 11},
  [1989] = {.lex_state = 352, .external_lex_state = 2},
  [1990] = {.lex_state = 10, .external_lex_state = 11},
  [1991] = {.lex_state = 0, .external_lex_state = 12},
  [1992] = {.lex_state = 0, .external_lex_state = 13},
  [1993] = {.lex_state = 43, .external_lex_state = 2},
  [1994] = {.lex_state = 0, .external_lex_state = 12},
  [1995] = {.lex_state = 0, .external_lex_state = 12},
  [1996] = {.lex_state = 0, .external_lex_state = 10},
  [1997] = {.lex_state = 0, .external_lex_state = 10},
  [1998] = {.lex_state = 0, .external_lex_state = 12},
  [1999] = {.lex_state = 0, .external_lex_state = 11},
  [2000] = {.lex_state = 352, .external_lex_state = 11},
  [2001] = {.lex_state = 20, .external_lex_state = 12},
  [2002] = {.lex_state = 0, .external_lex_state = 13},
  [2003] = {.lex_state = 0, .external_lex_state = 13},
  [2004] = {.lex_state = 0, .external_lex_state = 12},
  [2005] = {.lex_state = 20, .external_lex_state = 2},
  [2006] = {.lex_state = 0, .external_lex_state = 12},
  [2007] = {.lex_state = 10, .external_lex_state = 11},
  [2008] = {.lex_state = 10, .external_lex_state = 11},
  [2009] = {.lex_state = 0, .external_lex_state = 10},
  [2010] = {.lex_state = 10, .external_lex_state = 11},
  [2011] = {.lex_state = 56, .external_lex_state = 2},
  [2012] = {.lex_state = 352, .external_lex_state = 11},
  [2013] = {.lex_state = 0, .external_lex_state = 12},
  [2014] = {.lex_state = 0, .external_lex_state = 12},
  [2015] = {.lex_state = 20, .external_lex_state = 2},
  [2016] = {.lex_state = 0, .external_lex_state = 11},
  [2017] = {.lex_state = 0, .external_lex_state = 2},
  [2018] = {.lex_state = 0, .external_lex_state = 2},
  [2019] = {.lex_state = 10, .external_lex_state = 11},
  [2020] = {.lex_state = 10, .external_lex_state = 11},
  [2021] = {.lex_state = 10, .external_lex_state = 11},
  [2022] = {.lex_state = 0, .external_lex_state = 13},
  [2023] = {.lex_state = 352, .external_lex_state = 2},
  [2024] = {.lex_state = 0, .external_lex_state = 12},
  [2025] = {.lex_state = 0, .external_lex_state = 13},
  [2026] = {.lex_state = 0, .external_lex_state = 12},
  [2027] = {.lex_state = 0, .external_lex_state = 2},
  [2028] = {.lex_state = 0, .external_lex_state = 2},
  [2029] = {.lex_state = 0, .external_lex_state = 2},
  [2030] = {.lex_state = 0, .external_lex_state = 2},
  [2031] = {.lex_state = 11, .external_lex_state = 2},
  [2032] = {.lex_state = 0, .external_lex_state = 11},
  [2033] = {.lex_state = 0, .external_lex_state = 10},
  [2034] = {.lex_state = 352, .external_lex_state = 2},
  [2035] = {.lex_state = 0, .external_lex_state = 2},
  [2036] = {.lex_state = 352, .external_lex_state = 2},
  [2037] = {.lex_state = 0, .external_lex_state = 10},
  [2038] = {.lex_state = 0, .external_lex_state = 10},
  [2039] = {.lex_state = 0, .external_lex_state = 13},
  [2040] = {.lex_state = 0, .external_lex_state = 13},
  [2041] = {.lex_state = 0, .external_lex_state = 12},
  [2042] = {.lex_state = 0, .external_lex_state = 2},
  [2043] = {.lex_state = 0, .external_lex_state = 12},
  [2044] = {.lex_state = 0, .external_lex_state = 12},
  [2045] = {.lex_state = 0, .external_lex_state = 12},
  [2046] = {.lex_state = 0, .external_lex_state = 13},
  [2047] = {.lex_state = 0, .external_lex_state = 12},
  [2048] = {.lex_state = 0, .external_lex_state = 2},
  [2049] = {.lex_state = 0, .external_lex_state = 12},
  [2050] = {.lex_state = 0, .external_lex_state = 12},
  [2051] = {.lex_state = 20, .external_lex_state = 2},
  [2052] = {.lex_state = 0, .external_lex_state = 10},
  [2053] = {.lex_state = 0, .external_lex_state = 13},
  [2054] = {.lex_state = 0, .external_lex_state = 13},
  [2055] = {.lex_state = 0, .external_lex_state = 11},
  [2056] = {.lex_state = 0, .external_lex_state = 10},
  [2057] = {.lex_state = 0, .external_lex_state = 13},
  [2058] = {.lex_state = 0, .external_lex_state = 12},
  [2059] = {.lex_state = 0, .external_lex_state = 13},
  [2060] = {.lex_state = 0, .external_lex_state = 16},
  [2061] = {.lex_state = 0, .external_lex_state = 12},
  [2062] = {.lex_state = 0, .external_lex_state = 13},
  [2063] = {.lex_state = 352, .external_lex_state = 12},
  [2064] = {.lex_state = 0, .external_lex_state = 10},
  [2065] = {.lex_state = 352, .external_lex_state = 2},
  [2066] = {.lex_state = 0, .external_lex_state = 11},
  [2067] = {.lex_state = 0, .external_lex_state = 12},
  [2068] = {.lex_state = 0, .external_lex_state = 12},
  [2069] = {.lex_state = 352, .external_lex_state = 2},
  [2070] = {.lex_state = 0, .external_lex_state = 12},
  [2071] = {.lex_state = 0, .external_lex_state = 13},
  [2072] = {.lex_state = 0, .external_lex_state = 13},
  [2073] = {.lex_state = 0, .external_lex_state = 10},
  [2074] = {.lex_state = 0, .external_lex_state = 12},
  [2075] = {.lex_state = 0, .external_lex_state = 12},
  [2076] = {.lex_state = 0, .external_lex_state = 13},
  [2077] = {.lex_state = 0, .external_lex_state = 12},
  [2078] = {.lex_state = 0, .external_lex_state = 12},
  [2079] = {.lex_state = 0, .external_lex_state = 13},
  [2080] = {.lex_state = 0, .external_lex_state = 11},
  [2081] = {.lex_state = 0, .external_lex_state = 12},
  [2082] = {.lex_state = 0, .external_lex_state = 11},
  [2083] = {.lex_state = 10, .external_lex_state = 11},
  [2084] = {.lex_state = 0, .external_lex_state = 13},
  [2085] = {.lex_state = 0, .external_lex_state = 13},
  [2086] = {.lex_state = 352, .external_lex_state = 2},
  [2087] = {.lex_state = 352, .external_lex_state = 2},
  [2088] = {.lex_state = 0, .external_lex_state = 12},
  [2089] = {.lex_state = 0, .external_lex_state = 12},
  [2090] = {.lex_state = 0, .external_lex_state = 11},
  [2091] = {.lex_state = 0, .external_lex_state = 10},
  [2092] = {.lex_state = 0, .external_lex_state = 12},
  [2093] = {.lex_state = 0, .external_lex_state = 12},
  [2094] = {.lex_state = 0, .external_lex_state = 2},
  [2095] = {.lex_state = 0, .external_lex_state = 13},
  [2096] = {.lex_state = 0, .external_lex_state = 12},
  [2097] = {.lex_state = 352, .external_lex_state = 2},
  [2098] = {.lex_state = 0, .external_lex_state = 13},
  [2099] = {.lex_state = 0, .external_lex_state = 13},
  [2100] = {.lex_state = 0, .external_lex_state = 13},
  [2101] = {.lex_state = 0, .external_lex_state = 12},
  [2102] = {.lex_state = 352, .external_lex_state = 2},
  [2103] = {.lex_state = 0, .external_lex_state = 12},
  [2104] = {.lex_state = 0, .external_lex_state = 2},
  [2105] = {.lex_state = 0, .external_lex_state = 2},
  [2106] = {.lex_state = 0, .external_lex_state = 10},
  [2107] = {.lex_state = 0, .external_lex_state = 12},
  [2108] = {.lex_state = 0, .external_lex_state = 13},
  [2109] = {.lex_state = 0, .external_lex_state = 10},
  [2110] = {.lex_state = 352, .external_lex_state = 2},
  [2111] = {.lex_state = 352, .external_lex_state = 2},
  [2112] = {.lex_state = 352, .external_lex_state = 12},
  [2113] = {.lex_state = 0, .external_lex_state = 12},
  [2114] = {.lex_state = 0, .external_lex_state = 12},
  [2115] = {.lex_state = 0, .external_lex_state = 12},
  [2116] = {.lex_state = 0, .external_lex_state = 12},
  [2117] = {.lex_state = 0, .external_lex_state = 13},
  [2118] = {.lex_state = 352, .external_lex_state = 2},
  [2119] = {.lex_state = 0, .external_lex_state = 13},
  [2120] = {.lex_state = 0, .external_lex_state = 13},
  [2121] = {.lex_state = 352, .external_lex_state = 12},
  [2122] = {.lex_state = 0, .external_lex_state = 10},
  [2123] = {.lex_state = 352, .external_lex_state = 2},
  [2124] = {.lex_state = 0, .external_lex_state = 12},
  [2125] = {.lex_state = 0, .external_lex_state = 13},
  [2126] = {.lex_state = 0, .external_lex_state = 12},
  [2127] = {.lex_state = 0, .external_lex_state = 12},
  [2128] = {.lex_state = 0, .external_lex_state = 13},
  [2129] = {.lex_state = 352, .external_lex_state = 2},
  [2130] = {.lex_state = 0, .external_lex_state = 11},
  [2131] = {.lex_state = 0, .external_lex_state = 11},
  [2132] = {.lex_state = 352, .external_lex_state = 14},
  [2133] = {.lex_state = 0, .external_lex_state = 13},
  [2134] = {.lex_state = 0, .external_lex_state = 2},
  [2135] = {.lex_state = 352, .external_lex_state = 2},
  [2136] = {.lex_state = 0, .external_lex_state = 11},
  [2137] = {.lex_state = 0, .external_lex_state = 12},
  [2138] = {.lex_state = 352, .external_lex_state = 14},
  [2139] = {.lex_state = 352, .external_lex_state = 2},
  [2140] = {.lex_state = 0, .external_lex_state = 10},
  [2141] = {.lex_state = 0, .external_lex_state = 10},
  [2142] = {.lex_state = 0, .external_lex_state = 12},
  [2143] = {.lex_state = 352, .external_lex_state = 2},
  [2144] = {.lex_state = 0, .external_lex_state = 12},
  [2145] = {.lex_state = 352, .external_lex_state = 2},
  [2146] = {.lex_state = 352, .external_lex_state = 12},
  [2147] = {.lex_state = 0, .external_lex_state = 12},
  [2148] = {.lex_state = 0, .external_lex_state = 10},
  [2149] = {.lex_state = 0, .external_lex_state = 11},
  [2150] = {.lex_state = 0, .external_lex_state = 12},
  [2151] = {.lex_state = 0, .external_lex_state = 12},
  [2152] = {.lex_state = 0, .external_lex_state = 10},
  [2153] = {.lex_state = 352, .external_lex_state = 2},
  [2154] = {.lex_state = 0, .external_lex_state = 13},
  [2155] = {.lex_state = 0, .external_lex_state = 13},
  [2156] = {.lex_state = 0, .external_lex_state = 10},
  [2157] = {.lex_state = 0, .external_lex_state = 10},
  [2158] = {.lex_state = 0, .external_lex_state = 12},
  [2159] = {.lex_state = 0, .external_lex_state = 12},
  [2160] = {.lex_state = 0, .external_lex_state = 11},
  [2161] = {.lex_state = 0, .external_lex_state = 10},
  [2162] = {.lex_state = 0, .external_lex_state = 13},
  [2163] = {.lex_state = 0, .external_lex_state = 12},
  [2164] = {.lex_state = 0, .external_lex_state = 2},
  [2165] = {.lex_state = 0, .external_lex_state = 13},
  [2166] = {.lex_state = 0, .external_lex_state = 13},
  [2167] = {.lex_state = 0, .external_lex_state = 11},
  [2168] = {.lex_state = 0, .external_lex_state = 12},
  [2169] = {.lex_state = 0, .external_lex_state = 12},
  [2170] = {.lex_state = 0, .external_lex_state = 11},
  [2171] = {.lex_state = 0, .external_lex_state = 10},
  [2172] = {.lex_state = 352, .external_lex_state = 2},
  [2173] = {.lex_state = 0, .external_lex_state = 12},
  [2174] = {.lex_state = 352, .external_lex_state = 14},
  [2175] = {.lex_state = 0, .external_lex_state = 11},
  [2176] = {.lex_state = 0, .external_lex_state = 10},
  [2177] = {.lex_state = 0, .external_lex_state = 13},
  [2178] = {.lex_state = 0, .external_lex_state = 13},
  [2179] = {.lex_state = 11, .external_lex_state = 2},
  [2180] = {.lex_state = 0, .external_lex_state = 12},
  [2181] = {.lex_state = 0, .external_lex_state = 11},
  [2182] = {.lex_state = 0, .external_lex_state = 12},
  [2183] = {.lex_state = 352, .external_lex_state = 11},
  [2184] = {.lex_state = 0, .external_lex_state = 13},
  [2185] = {.lex_state = 0, .external_lex_state = 10},
  [2186] = {.lex_state = 0, .external_lex_state = 10},
  [2187] = {.lex_state = 0, .external_lex_state = 12},
  [2188] = {.lex_state = 0, .external_lex_state = 12},
  [2189] = {.lex_state = 0, .external_lex_state = 13},
  [2190] = {.lex_state = 0, .external_lex_state = 13},
  [2191] = {.lex_state = 0, .external_lex_state = 12},
  [2192] = {.lex_state = 0, .external_lex_state = 12},
  [2193] = {.lex_state = 352, .external_lex_state = 2},
  [2194] = {.lex_state = 0, .external_lex_state = 13},
  [2195] = {.lex_state = 0, .external_lex_state = 13},
  [2196] = {.lex_state = 0, .external_lex_state = 12},
  [2197] = {.lex_state = 0, .external_lex_state = 2},
  [2198] = {.lex_state = 43, .external_lex_state = 2},
  [2199] = {.lex_state = 0, .external_lex_state = 12},
  [2200] = {.lex_state = 0, .external_lex_state = 13},
  [2201] = {.lex_state = 352, .external_lex_state = 11},
  [2202] = {.lex_state = 0, .external_lex_state = 13},
  [2203] = {.lex_state = 0, .external_lex_state = 10},
  [2204] = {.lex_state = 0, .external_lex_state = 11},
  [2205] = {.lex_state = 0, .external_lex_state = 12},
  [2206] = {.lex_state = 0, .external_lex_state = 11},
  [2207] = {.lex_state = 10, .external_lex_state = 11},
  [2208] = {.lex_state = 32, .external_lex_state = 11},
  [2209] = {.lex_state = 0, .external_lex_state = 11},
  [2210] = {.lex_state = 1, .external_lex_state = 2},
  [2211] = {.lex_state = 0, .external_lex_state = 12},
  [2212] = {.lex_state = 0, .external_lex_state = 2},
  [2213] = {.lex_state = 0, .external_lex_state = 13},
  [2214] = {.lex_state = 32, .external_lex_state = 11},
  [2215] = {.lex_state = 0, .external_lex_state = 10},
  [2216] = {.lex_state = 0, .external_lex_state = 13},
  [2217] = {.lex_state = 1, .external_lex_state = 2},
  [2218] = {.lex_state = 0, .external_lex_state = 13},
  [2219] = {.lex_state = 0, .external_lex_state = 12},
  [2220] = {.lex_state = 0, .external_lex_state = 12},
  [2221] = {.lex_state = 1, .external_lex_state = 2},
  [2222] = {.lex_state = 0, .external_lex_state = 12},
  [2223] = {.lex_state = 20, .external_lex_state = 2},
  [2224] = {.lex_state = 32, .external_lex_state = 2},
  [2225] = {.lex_state = 43, .external_lex_state = 2},
  [2226] = {.lex_state = 1, .external_lex_state = 2},
  [2227] = {.lex_state = 352, .external_lex_state = 2},
  [2228] = {.lex_state = 0, .external_lex_state = 13},
  [2229] = {.lex_state = 0, .external_lex_state = 10},
  [2230] = {.lex_state = 352, .external_lex_state = 2},
  [2231] = {.lex_state = 1, .external_lex_state = 2},
  [2232] = {.lex_state = 57, .external_lex_state = 2},
  [2233] = {.lex_state = 32, .external_lex_state = 2},
  [2234] = {.lex_state = 32, .external_lex_state = 2},
  [2235] = {.lex_state = 60, .external_lex_state = 2},
  [2236] = {.lex_state = 0, .external_lex_state = 10},
  [2237] = {.lex_state = 352, .external_lex_state = 2},
  [2238] = {.lex_state = 0, .external_lex_state = 11},
  [2239] = {.lex_state = 0, .external_lex_state = 11},
  [2240] = {.lex_state = 0, .external_lex_state = 10},
  [2241] = {.lex_state = 32, .external_lex_state = 11},
  [2242] = {.lex_state = 0, .external_lex_state = 10},
  [2243] = {.lex_state = 0, .external_lex_state = 11},
  [2244] = {.lex_state = 1, .external_lex_state = 2},
  [2245] = {.lex_state = 0, .external_lex_state = 12},
  [2246] = {.lex_state = 1, .external_lex_state = 2},
  [2247] = {.lex_state = 1, .external_lex_state = 2},
  [2248] = {.lex_state = 43, .external_lex_state = 2},
  [2249] = {.lex_state = 43, .external_lex_state = 2},
  [2250] = {.lex_state = 0, .external_lex_state = 12},
  [2251] = {.lex_state = 60, .external_lex_state = 2},
  [2252] = {.lex_state = 352, .external_lex_state = 2},
  [2253] = {.lex_state = 0, .external_lex_state = 13},
  [2254] = {.lex_state = 0, .external_lex_state = 14},
  [2255] = {.lex_state = 1, .external_lex_state = 2},
  [2256] = {.lex_state = 352, .external_lex_state = 2},
  [2257] = {.lex_state = 1, .external_lex_state = 2},
  [2258] = {.lex_state = 1, .external_lex_state = 2},
  [2259] = {.lex_state = 1, .external_lex_state = 2},
  [2260] = {.lex_state = 0, .external_lex_state = 10},
  [2261] = {.lex_state = 32, .external_lex_state = 11},
  [2262] = {.lex_state = 0, .external_lex_state = 10},
  [2263] = {.lex_state = 0, .external_lex_state = 10},
  [2264] = {.lex_state = 32, .external_lex_state = 11},
  [2265] = {.lex_state = 1, .external_lex_state = 2},
  [2266] = {.lex_state = 0, .external_lex_state = 10},
  [2267] = {.lex_state = 1, .external_lex_state = 2},
  [2268] = {.lex_state = 1, .external_lex_state = 2},
  [2269] = {.lex_state = 1, .external_lex_state = 2},
  [2270] = {.lex_state = 1, .external_lex_state = 2},
  [2271] = {.lex_state = 1, .external_lex_state = 2},
  [2272] = {.lex_state = 43, .external_lex_state = 2},
  [2273] = {.lex_state = 1, .external_lex_state = 2},
  [2274] = {.lex_state = 1, .external_lex_state = 2},
  [2275] = {.lex_state = 1, .external_lex_state = 2},
  [2276] = {.lex_state = 1, .external_lex_state = 2},
  [2277] = {.lex_state = 0, .external_lex_state = 12},
  [2278] = {.lex_state = 0, .external_lex_state = 13},
  [2279] = {.lex_state = 1, .external_lex_state = 2},
  [2280] = {.lex_state = 1, .external_lex_state = 2},
  [2281] = {.lex_state = 32, .external_lex_state = 2},
  [2282] = {.lex_state = 0, .external_lex_state = 10},
  [2283] = {.lex_state = 1, .external_lex_state = 2},
  [2284] = {.lex_state = 0, .external_lex_state = 2},
  [2285] = {.lex_state = 0, .external_lex_state = 12},
  [2286] = {.lex_state = 0, .external_lex_state = 10},
  [2287] = {.lex_state = 0, .external_lex_state = 2},
  [2288] = {.lex_state = 60, .external_lex_state = 2},
  [2289] = {.lex_state = 352, .external_lex_state = 2},
  [2290] = {.lex_state = 1, .external_lex_state = 2},
  [2291] = {.lex_state = 1, .external_lex_state = 2},
  [2292] = {.lex_state = 0, .external_lex_state = 12},
  [2293] = {.lex_state = 0, .external_lex_state = 12},
  [2294] = {.lex_state = 0, .external_lex_state = 13},
  [2295] = {.lex_state = 0, .external_lex_state = 14},
  [2296] = {.lex_state = 32, .external_lex_state = 11},
  [2297] = {.lex_state = 0, .external_lex_state = 10},
  [2298] = {.lex_state = 352, .external_lex_state = 2},
  [2299] = {.lex_state = 0, .external_lex_state = 12},
  [2300] = {.lex_state = 0, .external_lex_state = 10},
  [2301] = {.lex_state = 1, .external_lex_state = 2},
  [2302] = {.lex_state = 1, .external_lex_state = 2},
  [2303] = {.lex_state = 352, .external_lex_state = 2},
  [2304] = {.lex_state = 0, .external_lex_state = 10},
  [2305] = {.lex_state = 0, .external_lex_state = 10},
  [2306] = {.lex_state = 0, .external_lex_state = 12},
  [2307] = {.lex_state = 0, .external_lex_state = 13},
  [2308] = {.lex_state = 352, .external_lex_state = 2},
  [2309] = {.lex_state = 32, .external_lex_state = 2},
  [2310] = {.lex_state = 32, .external_lex_state = 2},
  [2311] = {.lex_state = 0, .external_lex_state = 10},
  [2312] = {.lex_state = 1, .external_lex_state = 2},
  [2313] = {.lex_state = 1, .external_lex_state = 2},
  [2314] = {.lex_state = 1, .external_lex_state = 2},
  [2315] = {.lex_state = 1, .external_lex_state = 2},
  [2316] = {.lex_state = 0, .external_lex_state = 12},
  [2317] = {.lex_state = 0, .external_lex_state = 13},
  [2318] = {.lex_state = 1, .external_lex_state = 2},
  [2319] = {.lex_state = 0, .external_lex_state = 10},
  [2320] = {.lex_state = 1, .external_lex_state = 2},
  [2321] = {.lex_state = 0, .external_lex_state = 12},
  [2322] = {.lex_state = 0, .external_lex_state = 12},
  [2323] = {.lex_state = 0, .external_lex_state = 10},
  [2324] = {.lex_state = 1, .external_lex_state = 2},
  [2325] = {.lex_state = 0, .external_lex_state = 13},
  [2326] = {.lex_state = 0, .external_lex_state = 2},
  [2327] = {.lex_state = 0, .external_lex_state = 2},
  [2328] = {.lex_state = 0, .external_lex_state = 11},
  [2329] = {.lex_state = 0, .external_lex_state = 13},
  [2330] = {.lex_state = 0, .external_lex_state = 13},
  [2331] = {.lex_state = 0, .external_lex_state = 12},
  [2332] = {.lex_state = 0, .external_lex_state = 11},
  [2333] = {.lex_state = 0, .external_lex_state = 11},
  [2334] = {.lex_state = 0, .external_lex_state = 2},
  [2335] = {.lex_state = 352, .external_lex_state = 2},
  [2336] = {.lex_state = 43, .external_lex_state = 2},
  [2337] = {.lex_state = 0, .external_lex_state = 2},
  [2338] = {.lex_state = 352, .external_lex_state = 2},
  [2339] = {.lex_state = 0, .external_lex_state = 12},
  [2340] = {.lex_state = 0, .external_lex_state = 13},
  [2341] = {.lex_state = 0, .external_lex_state = 12},
  [2342] = {.lex_state = 43, .external_lex_state = 2},
  [2343] = {.lex_state = 0, .external_lex_state = 2},
  [2344] = {.lex_state = 0, .external_lex_state = 11},
  [2345] = {.lex_state = 0, .external_lex_state = 11},
  [2346] = {.lex_state = 0, .external_lex_state = 11},
  [2347] = {.lex_state = 0, .external_lex_state = 12},
  [2348] = {.lex_state = 0, .external_lex_state = 2},
  [2349] = {.lex_state = 0, .external_lex_state = 12},
  [2350] = {.lex_state = 0, .external_lex_state = 11},
  [2351] = {.lex_state = 0, .external_lex_state = 11},
  [2352] = {.lex_state = 0, .external_lex_state = 11},
  [2353] = {.lex_state = 0, .external_lex_state = 11},
  [2354] = {.lex_state = 32, .external_lex_state = 2},
  [2355] = {.lex_state = 0, .external_lex_state = 12},
  [2356] = {.lex_state = 0, .external_lex_state = 11},
  [2357] = {.lex_state = 352, .external_lex_state = 2},
  [2358] = {.lex_state = 43, .external_lex_state = 2},
  [2359] = {.lex_state = 0, .external_lex_state = 12},
  [2360] = {.lex_state = 0, .external_lex_state = 12},
  [2361] = {.lex_state = 352, .external_lex_state = 2},
  [2362] = {.lex_state = 43, .external_lex_state = 2},
  [2363] = {.lex_state = 43, .external_lex_state = 2},
  [2364] = {.lex_state = 352, .external_lex_state = 2},
  [2365] = {.lex_state = 0, .external_lex_state = 2},
  [2366] = {.lex_state = 0, .external_lex_state = 13},
  [2367] = {.lex_state = 0, .external_lex_state = 12},
  [2368] = {.lex_state = 0, .external_lex_state = 12},
  [2369] = {.lex_state = 0, .external_lex_state = 11},
  [2370] = {.lex_state = 43, .external_lex_state = 2},
  [2371] = {.lex_state = 0, .external_lex_state = 11},
  [2372] = {.lex_state = 0, .external_lex_state = 12},
  [2373] = {.lex_state = 0, .external_lex_state = 12},
  [2374] = {.lex_state = 0, .external_lex_state = 11},
  [2375] = {.lex_state = 0, .external_lex_state = 11},
  [2376] = {.lex_state = 0, .external_lex_state = 12},
  [2377] = {.lex_state = 0, .external_lex_state = 2},
  [2378] = {.lex_state = 0, .external_lex_state = 12},
  [2379] = {.lex_state = 0, .external_lex_state = 13},
  [2380] = {.lex_state = 0, .external_lex_state = 11},
  [2381] = {.lex_state = 0, .external_lex_state = 12},
  [2382] = {.lex_state = 0, .external_lex_state = 11},
  [2383] = {.lex_state = 0, .external_lex_state = 11},
  [2384] = {.lex_state = 0, .external_lex_state = 11},
  [2385] = {.lex_state = 43, .external_lex_state = 2},
  [2386] = {.lex_state = 0, .external_lex_state = 2},
  [2387] = {.lex_state = 352, .external_lex_state = 2},
  [2388] = {.lex_state = 0, .external_lex_state = 12},
  [2389] = {.lex_state = 43, .external_lex_state = 2},
  [2390] = {.lex_state = 0, .external_lex_state = 2},
  [2391] = {.lex_state = 0, .external_lex_state = 2},
  [2392] = {.lex_state = 0, .external_lex_state = 2},
  [2393] = {.lex_state = 0, .external_lex_state = 13},
  [2394] = {.lex_state = 0, .external_lex_state = 12},
  [2395] = {.lex_state = 0, .external_lex_state = 12},
  [2396] = {.lex_state = 0, .external_lex_state = 12},
  [2397] = {.lex_state = 0, .external_lex_state = 11},
  [2398] = {.lex_state = 0, .external_lex_state = 11},
  [2399] = {.lex_state = 0, .external_lex_state = 11},
  [2400] = {.lex_state = 0, .external_lex_state = 11},
  [2401] = {.lex_state = 0, .external_lex_state = 13},
  [2402] = {.lex_state = 0, .external_lex_state = 12},
  [2403] = {.lex_state = 0, .external_lex_state = 13},
  [2404] = {.lex_state = 0, .external_lex_state = 12},
  [2405] = {.lex_state = 0, .external_lex_state = 2},
  [2406] = {.lex_state = 0, .external_lex_state = 13},
  [2407] = {.lex_state = 43, .external_lex_state = 2},
  [2408] = {.lex_state = 0, .external_lex_state = 11},
  [2409] = {.lex_state = 43, .external_lex_state = 2},
  [2410] = {.lex_state = 0, .external_lex_state = 2},
  [2411] = {.lex_state = 0, .external_lex_state = 11},
  [2412] = {.lex_state = 0, .external_lex_state = 2},
  [2413] = {.lex_state = 43, .external_lex_state = 2},
  [2414] = {.lex_state = 0, .external_lex_state = 11},
  [2415] = {.lex_state = 0, .external_lex_state = 12},
  [2416] = {.lex_state = 352, .external_lex_state = 2},
  [2417] = {.lex_state = 0, .external_lex_state = 11},
  [2418] = {.lex_state = 43, .external_lex_state = 2},
  [2419] = {.lex_state = 352, .external_lex_state = 2},
  [2420] = {.lex_state = 32, .external_lex_state = 2},
  [2421] = {.lex_state = 0, .external_lex_state = 11},
  [2422] = {.lex_state = 0, .external_lex_state = 11},
  [2423] = {.lex_state = 0, .external_lex_state = 11},
  [2424] = {.lex_state = 0, .external_lex_state = 11},
  [2425] = {.lex_state = 0, .external_lex_state = 12},
  [2426] = {.lex_state = 0, .external_lex_state = 11},
  [2427] = {.lex_state = 0, .external_lex_state = 2},
  [2428] = {.lex_state = 0, .external_lex_state = 13},
  [2429] = {.lex_state = 352, .external_lex_state = 2},
  [2430] = {.lex_state = 43, .external_lex_state = 2},
  [2431] = {.lex_state = 0, .external_lex_state = 2},
  [2432] = {.lex_state = 352, .external_lex_state = 2},
  [2433] = {.lex_state = 0, .external_lex_state = 11},
  [2434] = {.lex_state = 0, .external_lex_state = 11},
  [2435] = {.lex_state = 0, .external_lex_state = 11},
  [2436] = {.lex_state = 0, .external_lex_state = 12},
  [2437] = {.lex_state = 0, .external_lex_state = 11},
  [2438] = {.lex_state = 43, .external_lex_state = 2},
  [2439] = {.lex_state = 0, .external_lex_state = 13},
  [2440] = {.lex_state = 43, .external_lex_state = 2},
  [2441] = {.lex_state = 0, .external_lex_state = 12},
  [2442] = {.lex_state = 0, .external_lex_state = 13},
  [2443] = {.lex_state = 352, .external_lex_state = 2},
  [2444] = {.lex_state = 43, .external_lex_state = 2},
  [2445] = {.lex_state = 0, .external_lex_state = 13},
  [2446] = {.lex_state = 0, .external_lex_state = 2},
  [2447] = {.lex_state = 0, .external_lex_state = 2},
  [2448] = {.lex_state = 0, .external_lex_state = 2},
  [2449] = {.lex_state = 0, .external_lex_state = 2},
  [2450] = {.lex_state = 0, .external_lex_state = 2},
  [2451] = {.lex_state = 352, .external_lex_state = 2},
  [2452] = {.lex_state = 43, .external_lex_state = 2},
  [2453] = {.lex_state = 0, .external_lex_state = 2},
  [2454] = {.lex_state = 0, .external_lex_state = 13},
  [2455] = {.lex_state = 0, .external_lex_state = 2},
  [2456] = {.lex_state = 0, .external_lex_state = 11},
  [2457] = {.lex_state = 0, .external_lex_state = 11},
  [2458] = {.lex_state = 352, .external_lex_state = 2},
  [2459] = {.lex_state = 0, .external_lex_state = 2},
  [2460] = {.lex_state = 0, .external_lex_state = 2},
  [2461] = {.lex_state = 0, .external_lex_state = 11},
  [2462] = {.lex_state = 0, .external_lex_state = 2},
  [2463] = {.lex_state = 43, .external_lex_state = 2},
  [2464] = {.lex_state = 0, .external_lex_state = 13},
  [2465] = {.lex_state = 0, .external_lex_state = 13},
  [2466] = {.lex_state = 0, .external_lex_state = 11},
  [2467] = {.lex_state = 0, .external_lex_state = 11},
  [2468] = {.lex_state = 0, .external_lex_state = 12},
  [2469] = {.lex_state = 352, .external_lex_state = 2},
  [2470] = {.lex_state = 0, .external_lex_state = 13},
  [2471] = {.lex_state = 0, .external_lex_state = 2},
  [2472] = {.lex_state = 352, .external_lex_state = 2},
  [2473] = {.lex_state = 0, .external_lex_state = 11},
  [2474] = {.lex_state = 0, .external_lex_state = 13},
  [2475] = {.lex_state = 0, .external_lex_state = 2},
  [2476] = {.lex_state = 352, .external_lex_state = 2},
  [2477] = {.lex_state = 352, .external_lex_state = 2},
  [2478] = {.lex_state = 352, .external_lex_state = 2},
  [2479] = {.lex_state = 0, .external_lex_state = 12},
  [2480] = {.lex_state = 0, .external_lex_state = 11},
  [2481] = {.lex_state = 0, .external_lex_state = 11},
  [2482] = {.lex_state = 43, .external_lex_state = 2},
  [2483] = {.lex_state = 0, .external_lex_state = 11},
  [2484] = {.lex_state = 0, .external_lex_state = 2},
  [2485] = {.lex_state = 43, .external_lex_state = 2},
  [2486] = {.lex_state = 0, .external_lex_state = 13},
  [2487] = {.lex_state = 0, .external_lex_state = 2},
  [2488] = {.lex_state = 43, .external_lex_state = 2},
  [2489] = {.lex_state = 0, .external_lex_state = 12},
  [2490] = {.lex_state = 352, .external_lex_state = 2},
  [2491] = {.lex_state = 352, .external_lex_state = 2},
  [2492] = {.lex_state = 0, .external_lex_state = 2},
  [2493] = {.lex_state = 0, .external_lex_state = 12},
  [2494] = {.lex_state = 0, .external_lex_state = 12},
  [2495] = {.lex_state = 0, .external_lex_state = 11},
  [2496] = {.lex_state = 43, .external_lex_state = 2},
  [2497] = {.lex_state = 0, .external_lex_state = 12},
  [2498] = {.lex_state = 0, .external_lex_state = 11},
  [2499] = {.lex_state = 0, .external_lex_state = 11},
  [2500] = {.lex_state = 0, .external_lex_state = 11},
  [2501] = {.lex_state = 43, .external_lex_state = 2},
  [2502] = {.lex_state = 43, .external_lex_state = 2},
  [2503] = {.lex_state = 0, .external_lex_state = 2},
  [2504] = {.lex_state = 0, .external_lex_state = 12},
  [2505] = {.lex_state = 0, .external_lex_state = 12},
  [2506] = {.lex_state = 0, .external_lex_state = 2},
  [2507] = {.lex_state = 0, .external_lex_state = 2},
  [2508] = {.lex_state = 0, .external_lex_state = 13},
  [2509] = {.lex_state = 0, .external_lex_state = 2},
  [2510] = {.lex_state = 0, .external_lex_state = 12},
  [2511] = {.lex_state = 0, .external_lex_state = 2},
  [2512] = {.lex_state = 352, .external_lex_state = 2},
  [2513] = {.lex_state = 0, .external_lex_state = 2},
  [2514] = {.lex_state = 43, .external_lex_state = 2},
  [2515] = {.lex_state = 352, .external_lex_state = 2},
  [2516] = {.lex_state = 0, .external_lex_state = 2},
  [2517] = {.lex_state = 0, .external_lex_state = 2},
  [2518] = {.lex_state = 32, .external_lex_state = 2},
  [2519] = {.lex_state = 32, .external_lex_state = 2},
  [2520] = {.lex_state = 0, .external_lex_state = 11},
  [2521] = {.lex_state = 0, .external_lex_state = 11},
  [2522] = {.lex_state = 0, .external_lex_state = 11},
  [2523] = {.lex_state = 0, .external_lex_state = 11},
  [2524] = {.lex_state = 32, .external_lex_state = 2},
  [2525] = {.lex_state = 43, .external_lex_state = 2},
  [2526] = {.lex_state = 0, .external_lex_state = 12},
  [2527] = {.lex_state = 0, .external_lex_state = 12},
  [2528] = {.lex_state = 0, .external_lex_state = 2},
  [2529] = {.lex_state = 0, .external_lex_state = 13},
  [2530] = {.lex_state = 352, .external_lex_state = 2},
  [2531] = {.lex_state = 0, .external_lex_state = 12},
  [2532] = {.lex_state = 0, .external_lex_state = 2},
  [2533] = {.lex_state = 352, .external_lex_state = 2},
  [2534] = {.lex_state = 352, .external_lex_state = 2},
  [2535] = {.lex_state = 0, .external_lex_state = 11},
  [2536] = {.lex_state = 0, .external_lex_state = 13},
  [2537] = {.lex_state = 0, .external_lex_state = 11},
  [2538] = {.lex_state = 0, .external_lex_state = 11},
  [2539] = {.lex_state = 32, .external_lex_state = 2},
  [2540] = {.lex_state = 0, .external_lex_state = 13},
  [2541] = {.lex_state = 352, .external_lex_state = 2},
  [2542] = {.lex_state = 61, .external_lex_state = 2},
  [2543] = {.lex_state = 43, .external_lex_state = 2},
  [2544] = {.lex_state = 0, .external_lex_state = 12},
  [2545] = {.lex_state = 61, .external_lex_state = 2},
  [2546] = {.lex_state = 0, .external_lex_state = 11},
  [2547] = {.lex_state = 0, .external_lex_state = 2},
  [2548] = {.lex_state = 0, .external_lex_state = 12},
  [2549] = {.lex_state = 0, .external_lex_state = 11},
  [2550] = {.lex_state = 0, .external_lex_state = 11},
  [2551] = {.lex_state = 352, .external_lex_state = 2},
  [2552] = {.lex_state = 43, .external_lex_state = 2},
  [2553] = {.lex_state = 0, .external_lex_state = 2},
  [2554] = {.lex_state = 0, .external_lex_state = 2},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_QMARK_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_EQ_PLUS] = ACTIONS(1),
    [anon_sym_DOT_EQ] = ACTIONS(1),
    [anon_sym_EQ_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_noexec] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_append] = ACTIONS(1),
    [anon_sym_prepend] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_INHERIT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_OVERRIDES] = ACTIONS(1),
    [anon_sym_EXPORT_FUNCTIONS] = ACTIONS(1),
    [anon_sym_addtask] = ACTIONS(1),
    [anon_sym_after] = ACTIONS(1),
    [anon_sym_before] = ACTIONS(1),
    [anon_sym_addhandler] = ACTIONS(1),
    [anon_sym_fakeroot] = ACTIONS(1),
    [anon_sym_python] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [aux_sym_string_token2] = ACTIONS(1),
    [anon_sym_DOLLARBB_ENV_PASSTHROUGH] = ACTIONS(1),
    [anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym_string_token4] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE_AT] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_except_STAR] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym__not_escape_sequence] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym_string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_escape_interpolation] = ACTIONS(1),
    [sym_string_end] = ACTIONS(1),
    [sym_shell_content] = ACTIONS(1),
  },
  [1] = {
    [sym_recipe] = STATE(2462),
    [sym_variable_assignment] = STATE(2258),
    [sym_unset_statement] = STATE(2258),
    [sym_inherit_directive] = STATE(2258),
    [sym_include_directive] = STATE(2258),
    [sym_require_directive] = STATE(2258),
    [sym_export_statement] = STATE(2258),
    [sym_overrides_statement] = STATE(2258),
    [sym_export_functions_statement] = STATE(2258),
    [sym_addtask_statement] = STATE(2258),
    [sym_deltask_statement] = STATE(2258),
    [sym_addhandler_statement] = STATE(2258),
    [sym_anonymous_python_function] = STATE(2258),
    [sym_function_definition] = STATE(2258),
    [sym_variable_expansion] = STATE(2254),
    [sym_python_function_definition] = STATE(2258),
    [sym_concatenation] = STATE(1516),
    [aux_sym_recipe_repeat1] = STATE(1181),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_unset] = ACTIONS(7),
    [anon_sym_inherit] = ACTIONS(9),
    [anon_sym_include] = ACTIONS(11),
    [anon_sym_require] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(15),
    [anon_sym_OVERRIDES] = ACTIONS(17),
    [anon_sym_EXPORT_FUNCTIONS] = ACTIONS(19),
    [anon_sym_addtask] = ACTIONS(21),
    [anon_sym_deltask] = ACTIONS(23),
    [anon_sym_addhandler] = ACTIONS(25),
    [anon_sym_fakeroot] = ACTIONS(27),
    [anon_sym_python] = ACTIONS(29),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [sym_identifier] = ACTIONS(35),
    [aux_sym__dotted_identifier_token1] = ACTIONS(37),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(2414),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [3] = {
    [sym_python_function_definition] = STATE(32),
    [sym__statement] = STATE(32),
    [sym__simple_statements] = STATE(32),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(596),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(113),
  },
  [4] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(670),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [5] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(658),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [6] = {
    [sym_python_function_definition] = STATE(26),
    [sym__statement] = STATE(26),
    [sym__simple_statements] = STATE(26),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(1697),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(26),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(113),
  },
  [7] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(663),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [8] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(2549),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [9] = {
    [sym_python_function_definition] = STATE(27),
    [sym__statement] = STATE(27),
    [sym__simple_statements] = STATE(27),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(627),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(27),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(121),
    [sym_string_start] = ACTIONS(113),
  },
  [10] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(664),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [11] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(669),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [12] = {
    [sym_python_function_definition] = STATE(31),
    [sym__statement] = STATE(31),
    [sym__simple_statements] = STATE(31),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_try_statement] = STATE(31),
    [sym_with_statement] = STATE(31),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(598),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(31),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(123),
    [sym_string_start] = ACTIONS(113),
  },
  [13] = {
    [sym_python_function_definition] = STATE(30),
    [sym__statement] = STATE(30),
    [sym__simple_statements] = STATE(30),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(614),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(30),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(125),
    [sym_string_start] = ACTIONS(113),
  },
  [14] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(2352),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [15] = {
    [sym_python_function_definition] = STATE(35),
    [sym__statement] = STATE(35),
    [sym__simple_statements] = STATE(35),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(2279),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(127),
    [sym_string_start] = ACTIONS(113),
  },
  [16] = {
    [sym_python_function_definition] = STATE(30),
    [sym__statement] = STATE(30),
    [sym__simple_statements] = STATE(30),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(613),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(30),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(125),
    [sym_string_start] = ACTIONS(113),
  },
  [17] = {
    [sym_python_function_definition] = STATE(32),
    [sym__statement] = STATE(32),
    [sym__simple_statements] = STATE(32),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(587),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(113),
  },
  [18] = {
    [sym_python_function_definition] = STATE(34),
    [sym__statement] = STATE(34),
    [sym__simple_statements] = STATE(34),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_with_statement] = STATE(34),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(2421),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(113),
  },
  [19] = {
    [sym_python_function_definition] = STATE(29),
    [sym__statement] = STATE(29),
    [sym__simple_statements] = STATE(29),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(588),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(29),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(129),
    [sym_string_start] = ACTIONS(113),
  },
  [20] = {
    [sym_python_function_definition] = STATE(33),
    [sym__statement] = STATE(33),
    [sym__simple_statements] = STATE(33),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_with_statement] = STATE(33),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(651),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(113),
  },
  [21] = {
    [sym_python_function_definition] = STATE(29),
    [sym__statement] = STATE(29),
    [sym__simple_statements] = STATE(29),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(575),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(29),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(129),
    [sym_string_start] = ACTIONS(113),
  },
  [22] = {
    [sym_python_function_definition] = STATE(30),
    [sym__statement] = STATE(30),
    [sym__simple_statements] = STATE(30),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(602),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(30),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(125),
    [sym_string_start] = ACTIONS(113),
  },
  [23] = {
    [sym_python_function_definition] = STATE(29),
    [sym__statement] = STATE(29),
    [sym__simple_statements] = STATE(29),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(594),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(29),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(129),
    [sym_string_start] = ACTIONS(113),
  },
  [24] = {
    [sym_python_function_definition] = STATE(35),
    [sym__statement] = STATE(35),
    [sym__simple_statements] = STATE(35),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(2315),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(127),
    [sym_string_start] = ACTIONS(113),
  },
  [25] = {
    [sym_python_function_definition] = STATE(31),
    [sym__statement] = STATE(31),
    [sym__simple_statements] = STATE(31),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_try_statement] = STATE(31),
    [sym_with_statement] = STATE(31),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_block] = STATE(558),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(31),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(123),
    [sym_string_start] = ACTIONS(113),
  },
  [26] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(131),
    [sym_string_start] = ACTIONS(113),
  },
  [27] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(113),
  },
  [28] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(138),
    [anon_sym_LBRACE] = ACTIONS(141),
    [anon_sym_def] = ACTIONS(144),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(150),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_print] = ACTIONS(156),
    [anon_sym_assert] = ACTIONS(159),
    [anon_sym_return] = ACTIONS(162),
    [anon_sym_del] = ACTIONS(165),
    [anon_sym_raise] = ACTIONS(168),
    [anon_sym_pass] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(174),
    [anon_sym_continue] = ACTIONS(177),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_nonlocal] = ACTIONS(183),
    [anon_sym_exec] = ACTIONS(186),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(192),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_while] = ACTIONS(198),
    [anon_sym_try] = ACTIONS(201),
    [anon_sym_with] = ACTIONS(204),
    [anon_sym_not] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(210),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(210),
    [anon_sym_lambda] = ACTIONS(216),
    [anon_sym_yield] = ACTIONS(219),
    [sym_ellipsis] = ACTIONS(222),
    [anon_sym_await] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(228),
    [anon_sym_type] = ACTIONS(231),
    [sym_integer] = ACTIONS(234),
    [sym_float] = ACTIONS(234),
    [sym_true] = ACTIONS(234),
    [sym_false] = ACTIONS(234),
    [sym_none] = ACTIONS(234),
    [sym_python_identifier] = ACTIONS(237),
    [sym_identifier] = ACTIONS(240),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(243),
    [sym_string_start] = ACTIONS(245),
  },
  [29] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(248),
    [sym_string_start] = ACTIONS(113),
  },
  [30] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(250),
    [sym_string_start] = ACTIONS(113),
  },
  [31] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(252),
    [sym_string_start] = ACTIONS(113),
  },
  [32] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(254),
    [sym_string_start] = ACTIONS(113),
  },
  [33] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(256),
    [sym_string_start] = ACTIONS(113),
  },
  [34] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(258),
    [sym_string_start] = ACTIONS(113),
  },
  [35] = {
    [sym_python_function_definition] = STATE(28),
    [sym__statement] = STATE(28),
    [sym__simple_statements] = STATE(28),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_if_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [aux_sym_block_repeat1] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_def] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(260),
    [sym_string_start] = ACTIONS(113),
  },
  [36] = {
    [sym__simple_statements] = STATE(2290),
    [sym_import_statement] = STATE(1996),
    [sym_future_import_statement] = STATE(1996),
    [sym_import_from_statement] = STATE(1996),
    [sym_print_statement] = STATE(1996),
    [sym_assert_statement] = STATE(1996),
    [sym_expression_statement] = STATE(1996),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(1996),
    [sym_delete_statement] = STATE(1996),
    [sym_raise_statement] = STATE(1996),
    [sym_pass_statement] = STATE(1996),
    [sym_break_statement] = STATE(1996),
    [sym_continue_statement] = STATE(1996),
    [sym_global_statement] = STATE(1996),
    [sym_nonlocal_statement] = STATE(1996),
    [sym_exec_statement] = STATE(1996),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(554),
    [sym_subscript] = STATE(554),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(571),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1542),
    [sym_primary_expression] = STATE(859),
    [sym_type] = STATE(1897),
    [sym_splat_type] = STATE(1853),
    [sym_generic_type] = STATE(1853),
    [sym_union_type] = STATE(1853),
    [sym_constrained_type] = STATE(1853),
    [sym_member_type] = STATE(1853),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(268),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(272),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_STAR_STAR] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(272),
    [anon_sym_type] = ACTIONS(278),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(280),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(282),
    [sym__indent] = ACTIONS(284),
    [sym_string_start] = ACTIONS(113),
  },
  [37] = {
    [sym_chevron] = STATE(1954),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(836),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(292),
    [anon_sym_COLON] = ACTIONS(286),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(305),
    [anon_sym_print] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_exec] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(312),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(315),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(300),
    [anon_sym_SLASH_SLASH] = ACTIONS(300),
    [anon_sym_STAR_STAR] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_AMP] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_LT_LT] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(318),
    [anon_sym_match] = ACTIONS(308),
    [anon_sym_type] = ACTIONS(320),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(322),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [38] = {
    [sym_chevron] = STATE(1954),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1679),
    [sym_primary_expression] = STATE(836),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(292),
    [anon_sym_COLON] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(305),
    [anon_sym_print] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_exec] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(308),
    [anon_sym_not] = ACTIONS(312),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(315),
    [anon_sym_DASH] = ACTIONS(315),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(300),
    [anon_sym_SLASH_SLASH] = ACTIONS(300),
    [anon_sym_STAR_STAR] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_AMP] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_LT_LT] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(318),
    [anon_sym_match] = ACTIONS(308),
    [anon_sym_type] = ACTIONS(320),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(322),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [39] = {
    [sym__simple_statements] = STATE(657),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(554),
    [sym_subscript] = STATE(554),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(571),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1542),
    [sym_primary_expression] = STATE(859),
    [sym_type] = STATE(1897),
    [sym_splat_type] = STATE(1853),
    [sym_generic_type] = STATE(1853),
    [sym_union_type] = STATE(1853),
    [sym_constrained_type] = STATE(1853),
    [sym_member_type] = STATE(1853),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(268),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(272),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_STAR_STAR] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(272),
    [anon_sym_type] = ACTIONS(278),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(280),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(327),
    [sym__indent] = ACTIONS(329),
    [sym_string_start] = ACTIONS(113),
  },
  [40] = {
    [sym__simple_statements] = STATE(678),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(331),
    [sym__indent] = ACTIONS(333),
    [sym_string_start] = ACTIONS(113),
  },
  [41] = {
    [sym__simple_statements] = STATE(617),
    [sym_import_statement] = STATE(2157),
    [sym_future_import_statement] = STATE(2157),
    [sym_import_from_statement] = STATE(2157),
    [sym_print_statement] = STATE(2157),
    [sym_assert_statement] = STATE(2157),
    [sym_expression_statement] = STATE(2157),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2157),
    [sym_delete_statement] = STATE(2157),
    [sym_raise_statement] = STATE(2157),
    [sym_pass_statement] = STATE(2157),
    [sym_break_statement] = STATE(2157),
    [sym_continue_statement] = STATE(2157),
    [sym_global_statement] = STATE(2157),
    [sym_nonlocal_statement] = STATE(2157),
    [sym_exec_statement] = STATE(2157),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(335),
    [sym__indent] = ACTIONS(337),
    [sym_string_start] = ACTIONS(113),
  },
  [42] = {
    [sym__simple_statements] = STATE(2434),
    [sym_import_statement] = STATE(2161),
    [sym_future_import_statement] = STATE(2161),
    [sym_import_from_statement] = STATE(2161),
    [sym_print_statement] = STATE(2161),
    [sym_assert_statement] = STATE(2161),
    [sym_expression_statement] = STATE(2161),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2161),
    [sym_delete_statement] = STATE(2161),
    [sym_raise_statement] = STATE(2161),
    [sym_pass_statement] = STATE(2161),
    [sym_break_statement] = STATE(2161),
    [sym_continue_statement] = STATE(2161),
    [sym_global_statement] = STATE(2161),
    [sym_nonlocal_statement] = STATE(2161),
    [sym_exec_statement] = STATE(2161),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(339),
    [sym__indent] = ACTIONS(341),
    [sym_string_start] = ACTIONS(113),
  },
  [43] = {
    [sym__simple_statements] = STATE(1705),
    [sym_import_statement] = STATE(2171),
    [sym_future_import_statement] = STATE(2171),
    [sym_import_from_statement] = STATE(2171),
    [sym_print_statement] = STATE(2171),
    [sym_assert_statement] = STATE(2171),
    [sym_expression_statement] = STATE(2171),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2171),
    [sym_delete_statement] = STATE(2171),
    [sym_raise_statement] = STATE(2171),
    [sym_pass_statement] = STATE(2171),
    [sym_break_statement] = STATE(2171),
    [sym_continue_statement] = STATE(2171),
    [sym_global_statement] = STATE(2171),
    [sym_nonlocal_statement] = STATE(2171),
    [sym_exec_statement] = STATE(2171),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(343),
    [sym__indent] = ACTIONS(345),
    [sym_string_start] = ACTIONS(113),
  },
  [44] = {
    [sym__simple_statements] = STATE(642),
    [sym_import_statement] = STATE(2056),
    [sym_future_import_statement] = STATE(2056),
    [sym_import_from_statement] = STATE(2056),
    [sym_print_statement] = STATE(2056),
    [sym_assert_statement] = STATE(2056),
    [sym_expression_statement] = STATE(2056),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2056),
    [sym_delete_statement] = STATE(2056),
    [sym_raise_statement] = STATE(2056),
    [sym_pass_statement] = STATE(2056),
    [sym_break_statement] = STATE(2056),
    [sym_continue_statement] = STATE(2056),
    [sym_global_statement] = STATE(2056),
    [sym_nonlocal_statement] = STATE(2056),
    [sym_exec_statement] = STATE(2056),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__indent] = ACTIONS(349),
    [sym_string_start] = ACTIONS(113),
  },
  [45] = {
    [sym__simple_statements] = STATE(2466),
    [sym_import_statement] = STATE(2161),
    [sym_future_import_statement] = STATE(2161),
    [sym_import_from_statement] = STATE(2161),
    [sym_print_statement] = STATE(2161),
    [sym_assert_statement] = STATE(2161),
    [sym_expression_statement] = STATE(2161),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2161),
    [sym_delete_statement] = STATE(2161),
    [sym_raise_statement] = STATE(2161),
    [sym_pass_statement] = STATE(2161),
    [sym_break_statement] = STATE(2161),
    [sym_continue_statement] = STATE(2161),
    [sym_global_statement] = STATE(2161),
    [sym_nonlocal_statement] = STATE(2161),
    [sym_exec_statement] = STATE(2161),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(351),
    [sym__indent] = ACTIONS(353),
    [sym_string_start] = ACTIONS(113),
  },
  [46] = {
    [sym__simple_statements] = STATE(2411),
    [sym_import_statement] = STATE(2161),
    [sym_future_import_statement] = STATE(2161),
    [sym_import_from_statement] = STATE(2161),
    [sym_print_statement] = STATE(2161),
    [sym_assert_statement] = STATE(2161),
    [sym_expression_statement] = STATE(2161),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2161),
    [sym_delete_statement] = STATE(2161),
    [sym_raise_statement] = STATE(2161),
    [sym_pass_statement] = STATE(2161),
    [sym_break_statement] = STATE(2161),
    [sym_continue_statement] = STATE(2161),
    [sym_global_statement] = STATE(2161),
    [sym_nonlocal_statement] = STATE(2161),
    [sym_exec_statement] = STATE(2161),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(355),
    [sym__indent] = ACTIONS(357),
    [sym_string_start] = ACTIONS(113),
  },
  [47] = {
    [sym__simple_statements] = STATE(2269),
    [sym_import_statement] = STATE(1996),
    [sym_future_import_statement] = STATE(1996),
    [sym_import_from_statement] = STATE(1996),
    [sym_print_statement] = STATE(1996),
    [sym_assert_statement] = STATE(1996),
    [sym_expression_statement] = STATE(1996),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(1996),
    [sym_delete_statement] = STATE(1996),
    [sym_raise_statement] = STATE(1996),
    [sym_pass_statement] = STATE(1996),
    [sym_break_statement] = STATE(1996),
    [sym_continue_statement] = STATE(1996),
    [sym_global_statement] = STATE(1996),
    [sym_nonlocal_statement] = STATE(1996),
    [sym_exec_statement] = STATE(1996),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(359),
    [sym__indent] = ACTIONS(361),
    [sym_string_start] = ACTIONS(113),
  },
  [48] = {
    [sym__simple_statements] = STATE(671),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(363),
    [sym__indent] = ACTIONS(365),
    [sym_string_start] = ACTIONS(113),
  },
  [49] = {
    [sym__simple_statements] = STATE(2351),
    [sym_import_statement] = STATE(2161),
    [sym_future_import_statement] = STATE(2161),
    [sym_import_from_statement] = STATE(2161),
    [sym_print_statement] = STATE(2161),
    [sym_assert_statement] = STATE(2161),
    [sym_expression_statement] = STATE(2161),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2161),
    [sym_delete_statement] = STATE(2161),
    [sym_raise_statement] = STATE(2161),
    [sym_pass_statement] = STATE(2161),
    [sym_break_statement] = STATE(2161),
    [sym_continue_statement] = STATE(2161),
    [sym_global_statement] = STATE(2161),
    [sym_nonlocal_statement] = STATE(2161),
    [sym_exec_statement] = STATE(2161),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(367),
    [sym__indent] = ACTIONS(369),
    [sym_string_start] = ACTIONS(113),
  },
  [50] = {
    [sym__simple_statements] = STATE(562),
    [sym_import_statement] = STATE(2203),
    [sym_future_import_statement] = STATE(2203),
    [sym_import_from_statement] = STATE(2203),
    [sym_print_statement] = STATE(2203),
    [sym_assert_statement] = STATE(2203),
    [sym_expression_statement] = STATE(2203),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2203),
    [sym_delete_statement] = STATE(2203),
    [sym_raise_statement] = STATE(2203),
    [sym_pass_statement] = STATE(2203),
    [sym_break_statement] = STATE(2203),
    [sym_continue_statement] = STATE(2203),
    [sym_global_statement] = STATE(2203),
    [sym_nonlocal_statement] = STATE(2203),
    [sym_exec_statement] = STATE(2203),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__indent] = ACTIONS(373),
    [sym_string_start] = ACTIONS(113),
  },
  [51] = {
    [sym__simple_statements] = STATE(591),
    [sym_import_statement] = STATE(2122),
    [sym_future_import_statement] = STATE(2122),
    [sym_import_from_statement] = STATE(2122),
    [sym_print_statement] = STATE(2122),
    [sym_assert_statement] = STATE(2122),
    [sym_expression_statement] = STATE(2122),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2122),
    [sym_delete_statement] = STATE(2122),
    [sym_raise_statement] = STATE(2122),
    [sym_pass_statement] = STATE(2122),
    [sym_break_statement] = STATE(2122),
    [sym_continue_statement] = STATE(2122),
    [sym_global_statement] = STATE(2122),
    [sym_nonlocal_statement] = STATE(2122),
    [sym_exec_statement] = STATE(2122),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__indent] = ACTIONS(377),
    [sym_string_start] = ACTIONS(113),
  },
  [52] = {
    [sym__simple_statements] = STATE(610),
    [sym_import_statement] = STATE(2157),
    [sym_future_import_statement] = STATE(2157),
    [sym_import_from_statement] = STATE(2157),
    [sym_print_statement] = STATE(2157),
    [sym_assert_statement] = STATE(2157),
    [sym_expression_statement] = STATE(2157),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2157),
    [sym_delete_statement] = STATE(2157),
    [sym_raise_statement] = STATE(2157),
    [sym_pass_statement] = STATE(2157),
    [sym_break_statement] = STATE(2157),
    [sym_continue_statement] = STATE(2157),
    [sym_global_statement] = STATE(2157),
    [sym_nonlocal_statement] = STATE(2157),
    [sym_exec_statement] = STATE(2157),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__indent] = ACTIONS(381),
    [sym_string_start] = ACTIONS(113),
  },
  [53] = {
    [sym__simple_statements] = STATE(655),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__indent] = ACTIONS(385),
    [sym_string_start] = ACTIONS(113),
  },
  [54] = {
    [sym__simple_statements] = STATE(605),
    [sym_import_statement] = STATE(2203),
    [sym_future_import_statement] = STATE(2203),
    [sym_import_from_statement] = STATE(2203),
    [sym_print_statement] = STATE(2203),
    [sym_assert_statement] = STATE(2203),
    [sym_expression_statement] = STATE(2203),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2203),
    [sym_delete_statement] = STATE(2203),
    [sym_raise_statement] = STATE(2203),
    [sym_pass_statement] = STATE(2203),
    [sym_break_statement] = STATE(2203),
    [sym_continue_statement] = STATE(2203),
    [sym_global_statement] = STATE(2203),
    [sym_nonlocal_statement] = STATE(2203),
    [sym_exec_statement] = STATE(2203),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__indent] = ACTIONS(389),
    [sym_string_start] = ACTIONS(113),
  },
  [55] = {
    [sym__simple_statements] = STATE(590),
    [sym_import_statement] = STATE(2073),
    [sym_future_import_statement] = STATE(2073),
    [sym_import_from_statement] = STATE(2073),
    [sym_print_statement] = STATE(2073),
    [sym_assert_statement] = STATE(2073),
    [sym_expression_statement] = STATE(2073),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2073),
    [sym_delete_statement] = STATE(2073),
    [sym_raise_statement] = STATE(2073),
    [sym_pass_statement] = STATE(2073),
    [sym_break_statement] = STATE(2073),
    [sym_continue_statement] = STATE(2073),
    [sym_global_statement] = STATE(2073),
    [sym_nonlocal_statement] = STATE(2073),
    [sym_exec_statement] = STATE(2073),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__indent] = ACTIONS(393),
    [sym_string_start] = ACTIONS(113),
  },
  [56] = {
    [sym__simple_statements] = STATE(586),
    [sym_import_statement] = STATE(2122),
    [sym_future_import_statement] = STATE(2122),
    [sym_import_from_statement] = STATE(2122),
    [sym_print_statement] = STATE(2122),
    [sym_assert_statement] = STATE(2122),
    [sym_expression_statement] = STATE(2122),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2122),
    [sym_delete_statement] = STATE(2122),
    [sym_raise_statement] = STATE(2122),
    [sym_pass_statement] = STATE(2122),
    [sym_break_statement] = STATE(2122),
    [sym_continue_statement] = STATE(2122),
    [sym_global_statement] = STATE(2122),
    [sym_nonlocal_statement] = STATE(2122),
    [sym_exec_statement] = STATE(2122),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__indent] = ACTIONS(397),
    [sym_string_start] = ACTIONS(113),
  },
  [57] = {
    [sym__simple_statements] = STATE(593),
    [sym_import_statement] = STATE(2122),
    [sym_future_import_statement] = STATE(2122),
    [sym_import_from_statement] = STATE(2122),
    [sym_print_statement] = STATE(2122),
    [sym_assert_statement] = STATE(2122),
    [sym_expression_statement] = STATE(2122),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2122),
    [sym_delete_statement] = STATE(2122),
    [sym_raise_statement] = STATE(2122),
    [sym_pass_statement] = STATE(2122),
    [sym_break_statement] = STATE(2122),
    [sym_continue_statement] = STATE(2122),
    [sym_global_statement] = STATE(2122),
    [sym_nonlocal_statement] = STATE(2122),
    [sym_exec_statement] = STATE(2122),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__indent] = ACTIONS(401),
    [sym_string_start] = ACTIONS(113),
  },
  [58] = {
    [sym__simple_statements] = STATE(654),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__indent] = ACTIONS(405),
    [sym_string_start] = ACTIONS(113),
  },
  [59] = {
    [sym__simple_statements] = STATE(601),
    [sym_import_statement] = STATE(2157),
    [sym_future_import_statement] = STATE(2157),
    [sym_import_from_statement] = STATE(2157),
    [sym_print_statement] = STATE(2157),
    [sym_assert_statement] = STATE(2157),
    [sym_expression_statement] = STATE(2157),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2157),
    [sym_delete_statement] = STATE(2157),
    [sym_raise_statement] = STATE(2157),
    [sym_pass_statement] = STATE(2157),
    [sym_break_statement] = STATE(2157),
    [sym_continue_statement] = STATE(2157),
    [sym_global_statement] = STATE(2157),
    [sym_nonlocal_statement] = STATE(2157),
    [sym_exec_statement] = STATE(2157),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__indent] = ACTIONS(409),
    [sym_string_start] = ACTIONS(113),
  },
  [60] = {
    [sym__simple_statements] = STATE(673),
    [sym_import_statement] = STATE(2091),
    [sym_future_import_statement] = STATE(2091),
    [sym_import_from_statement] = STATE(2091),
    [sym_print_statement] = STATE(2091),
    [sym_assert_statement] = STATE(2091),
    [sym_expression_statement] = STATE(2091),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2091),
    [sym_delete_statement] = STATE(2091),
    [sym_raise_statement] = STATE(2091),
    [sym_pass_statement] = STATE(2091),
    [sym_break_statement] = STATE(2091),
    [sym_continue_statement] = STATE(2091),
    [sym_global_statement] = STATE(2091),
    [sym_nonlocal_statement] = STATE(2091),
    [sym_exec_statement] = STATE(2091),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__indent] = ACTIONS(413),
    [sym_string_start] = ACTIONS(113),
  },
  [61] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym_string_start] = ACTIONS(113),
  },
  [62] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(417),
    [sym_string_start] = ACTIONS(113),
  },
  [63] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym_string_start] = ACTIONS(113),
  },
  [64] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(421),
    [sym_string_start] = ACTIONS(113),
  },
  [65] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym_string_start] = ACTIONS(113),
  },
  [66] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(425),
    [sym_string_start] = ACTIONS(113),
  },
  [67] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(427),
    [sym_string_start] = ACTIONS(113),
  },
  [68] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(429),
    [sym_string_start] = ACTIONS(113),
  },
  [69] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(431),
    [sym_string_start] = ACTIONS(113),
  },
  [70] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym_string_start] = ACTIONS(113),
  },
  [71] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(435),
    [sym_string_start] = ACTIONS(113),
  },
  [72] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym_string_start] = ACTIONS(113),
  },
  [73] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(439),
    [sym_string_start] = ACTIONS(113),
  },
  [74] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym_string_start] = ACTIONS(113),
  },
  [75] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(443),
    [sym_string_start] = ACTIONS(113),
  },
  [76] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym_string_start] = ACTIONS(113),
  },
  [77] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(447),
    [sym_string_start] = ACTIONS(113),
  },
  [78] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(449),
    [sym_string_start] = ACTIONS(113),
  },
  [79] = {
    [sym_import_statement] = STATE(2229),
    [sym_future_import_statement] = STATE(2229),
    [sym_import_from_statement] = STATE(2229),
    [sym_print_statement] = STATE(2229),
    [sym_assert_statement] = STATE(2229),
    [sym_expression_statement] = STATE(2229),
    [sym_named_expression] = STATE(1527),
    [sym__named_expression_lhs] = STATE(2377),
    [sym_return_statement] = STATE(2229),
    [sym_delete_statement] = STATE(2229),
    [sym_raise_statement] = STATE(2229),
    [sym_pass_statement] = STATE(2229),
    [sym_break_statement] = STATE(2229),
    [sym_continue_statement] = STATE(2229),
    [sym_global_statement] = STATE(2229),
    [sym_nonlocal_statement] = STATE(2229),
    [sym_exec_statement] = STATE(2229),
    [sym_not_operator] = STATE(1527),
    [sym_boolean_operator] = STATE(1527),
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_comparison_operator] = STATE(1527),
    [sym_lambda] = STATE(1527),
    [sym_assignment] = STATE(2282),
    [sym_augmented_assignment] = STATE(2282),
    [sym_pattern_list] = STATE(1514),
    [sym_yield] = STATE(2282),
    [sym_attribute] = STATE(551),
    [sym_subscript] = STATE(551),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_pattern] = STATE(1483),
    [sym_tuple_pattern] = STATE(1496),
    [sym_list_pattern] = STATE(1496),
    [sym_list_splat_pattern] = STATE(552),
    [sym_as_pattern] = STATE(1527),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(859),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_conditional_expression] = STATE(1527),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_import] = ACTIONS(47),
    [anon_sym_from] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_print] = ACTIONS(53),
    [anon_sym_assert] = ACTIONS(55),
    [anon_sym_return] = ACTIONS(57),
    [anon_sym_del] = ACTIONS(59),
    [anon_sym_raise] = ACTIONS(61),
    [anon_sym_pass] = ACTIONS(63),
    [anon_sym_break] = ACTIONS(65),
    [anon_sym_continue] = ACTIONS(67),
    [anon_sym_global] = ACTIONS(69),
    [anon_sym_nonlocal] = ACTIONS(71),
    [anon_sym_exec] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_lambda] = ACTIONS(93),
    [anon_sym_yield] = ACTIONS(95),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(103),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(107),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(113),
  },
  [80] = {
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_primary_expression] = STATE(887),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(324),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(300),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(300),
    [anon_sym_SLASH_SLASH] = ACTIONS(300),
    [anon_sym_STAR_STAR] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_AMP] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_LT_LT] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [81] = {
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_primary_expression] = STATE(887),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_EQ] = ACTIONS(286),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(286),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(300),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(300),
    [anon_sym_SLASH_SLASH] = ACTIONS(300),
    [anon_sym_STAR_STAR] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_AMP] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_LT_LT] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [82] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_AT_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [83] = {
    [sym_binary_operator] = STATE(1106),
    [sym_unary_operator] = STATE(1106),
    [sym_attribute] = STATE(1106),
    [sym_subscript] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_generator_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_list_splat_pattern] = STATE(1093),
    [sym_primary_expression] = STATE(877),
    [sym_list] = STATE(1106),
    [sym_set] = STATE(1106),
    [sym_tuple] = STATE(1106),
    [sym_dictionary] = STATE(1106),
    [sym_list_comprehension] = STATE(1106),
    [sym_dictionary_comprehension] = STATE(1106),
    [sym_set_comprehension] = STATE(1106),
    [sym_concatenated_string] = STATE(1106),
    [sym_python_string] = STATE(842),
    [sym_await] = STATE(1106),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(298),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [84] = {
    [sym_binary_operator] = STATE(1106),
    [sym_unary_operator] = STATE(1106),
    [sym_attribute] = STATE(1106),
    [sym_subscript] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_generator_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_list_splat_pattern] = STATE(1093),
    [sym_primary_expression] = STATE(877),
    [sym_list] = STATE(1106),
    [sym_set] = STATE(1106),
    [sym_tuple] = STATE(1106),
    [sym_dictionary] = STATE(1106),
    [sym_list_comprehension] = STATE(1106),
    [sym_dictionary_comprehension] = STATE(1106),
    [sym_set_comprehension] = STATE(1106),
    [sym_concatenated_string] = STATE(1106),
    [sym_python_string] = STATE(842),
    [sym_await] = STATE(1106),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(298),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [85] = {
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_primary_expression] = STATE(887),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [86] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [87] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [sym_type_conversion] = ACTIONS(463),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [88] = {
    [sym_binary_operator] = STATE(1106),
    [sym_unary_operator] = STATE(1106),
    [sym_attribute] = STATE(1106),
    [sym_subscript] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_generator_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_list_splat_pattern] = STATE(1093),
    [sym_primary_expression] = STATE(877),
    [sym_list] = STATE(1106),
    [sym_set] = STATE(1106),
    [sym_tuple] = STATE(1106),
    [sym_dictionary] = STATE(1106),
    [sym_list_comprehension] = STATE(1106),
    [sym_dictionary_comprehension] = STATE(1106),
    [sym_set_comprehension] = STATE(1106),
    [sym_concatenated_string] = STATE(1106),
    [sym_python_string] = STATE(842),
    [sym_await] = STATE(1106),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(516),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [89] = {
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_primary_expression] = STATE(887),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [90] = {
    [sym_binary_operator] = STATE(1198),
    [sym_unary_operator] = STATE(1198),
    [sym_attribute] = STATE(1198),
    [sym_subscript] = STATE(1198),
    [sym_call] = STATE(1198),
    [sym_generator_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_list_splat_pattern] = STATE(1210),
    [sym_primary_expression] = STATE(1000),
    [sym_list] = STATE(1198),
    [sym_set] = STATE(1198),
    [sym_tuple] = STATE(1198),
    [sym_dictionary] = STATE(1198),
    [sym_list_comprehension] = STATE(1198),
    [sym_dictionary_comprehension] = STATE(1198),
    [sym_set_comprehension] = STATE(1198),
    [sym_concatenated_string] = STATE(1198),
    [sym_python_string] = STATE(853),
    [sym_await] = STATE(1198),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_print] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(535),
    [anon_sym_await] = ACTIONS(537),
    [anon_sym_match] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(539),
    [sym_integer] = ACTIONS(541),
    [sym_float] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_none] = ACTIONS(541),
    [sym_python_identifier] = ACTIONS(541),
    [sym_identifier] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(543),
  },
  [91] = {
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_primary_expression] = STATE(1006),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_from] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(545),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(547),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [92] = {
    [sym_binary_operator] = STATE(1106),
    [sym_unary_operator] = STATE(1106),
    [sym_attribute] = STATE(1106),
    [sym_subscript] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_generator_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_list_splat_pattern] = STATE(1093),
    [sym_primary_expression] = STATE(877),
    [sym_list] = STATE(1106),
    [sym_set] = STATE(1106),
    [sym_tuple] = STATE(1106),
    [sym_dictionary] = STATE(1106),
    [sym_list_comprehension] = STATE(1106),
    [sym_dictionary_comprehension] = STATE(1106),
    [sym_set_comprehension] = STATE(1106),
    [sym_concatenated_string] = STATE(1106),
    [sym_python_string] = STATE(842),
    [sym_await] = STATE(1106),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(298),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [93] = {
    [sym_binary_operator] = STATE(1214),
    [sym_unary_operator] = STATE(1214),
    [sym_attribute] = STATE(1214),
    [sym_subscript] = STATE(1214),
    [sym_call] = STATE(1214),
    [sym_generator_expression] = STATE(1214),
    [sym_parenthesized_expression] = STATE(1214),
    [sym_list_splat_pattern] = STATE(1240),
    [sym_primary_expression] = STATE(932),
    [sym_list] = STATE(1214),
    [sym_set] = STATE(1214),
    [sym_tuple] = STATE(1214),
    [sym_dictionary] = STATE(1214),
    [sym_list_comprehension] = STATE(1214),
    [sym_dictionary_comprehension] = STATE(1214),
    [sym_set_comprehension] = STATE(1214),
    [sym_concatenated_string] = STATE(1214),
    [sym_python_string] = STATE(875),
    [sym_await] = STATE(1214),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [94] = {
    [sym_binary_operator] = STATE(1150),
    [sym_unary_operator] = STATE(1150),
    [sym_attribute] = STATE(1150),
    [sym_subscript] = STATE(1150),
    [sym_call] = STATE(1150),
    [sym_generator_expression] = STATE(1150),
    [sym_parenthesized_expression] = STATE(1150),
    [sym_list_splat_pattern] = STATE(1147),
    [sym_primary_expression] = STATE(879),
    [sym_list] = STATE(1150),
    [sym_set] = STATE(1150),
    [sym_tuple] = STATE(1150),
    [sym_dictionary] = STATE(1150),
    [sym_list_comprehension] = STATE(1150),
    [sym_dictionary_comprehension] = STATE(1150),
    [sym_set_comprehension] = STATE(1150),
    [sym_concatenated_string] = STATE(1150),
    [sym_python_string] = STATE(839),
    [sym_await] = STATE(1150),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [95] = {
    [sym_binary_operator] = STATE(1214),
    [sym_unary_operator] = STATE(1214),
    [sym_attribute] = STATE(1214),
    [sym_subscript] = STATE(1214),
    [sym_call] = STATE(1214),
    [sym_generator_expression] = STATE(1214),
    [sym_parenthesized_expression] = STATE(1214),
    [sym_list_splat_pattern] = STATE(1240),
    [sym_primary_expression] = STATE(932),
    [sym_list] = STATE(1214),
    [sym_set] = STATE(1214),
    [sym_tuple] = STATE(1214),
    [sym_dictionary] = STATE(1214),
    [sym_list_comprehension] = STATE(1214),
    [sym_dictionary_comprehension] = STATE(1214),
    [sym_set_comprehension] = STATE(1214),
    [sym_concatenated_string] = STATE(1214),
    [sym_python_string] = STATE(875),
    [sym_await] = STATE(1214),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(516),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [96] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_from] = ACTIONS(461),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [97] = {
    [sym_binary_operator] = STATE(1198),
    [sym_unary_operator] = STATE(1198),
    [sym_attribute] = STATE(1198),
    [sym_subscript] = STATE(1198),
    [sym_call] = STATE(1198),
    [sym_generator_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_list_splat_pattern] = STATE(1210),
    [sym_primary_expression] = STATE(1000),
    [sym_list] = STATE(1198),
    [sym_set] = STATE(1198),
    [sym_tuple] = STATE(1198),
    [sym_dictionary] = STATE(1198),
    [sym_list_comprehension] = STATE(1198),
    [sym_dictionary_comprehension] = STATE(1198),
    [sym_set_comprehension] = STATE(1198),
    [sym_concatenated_string] = STATE(1198),
    [sym_python_string] = STATE(853),
    [sym_await] = STATE(1198),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_print] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(535),
    [anon_sym_await] = ACTIONS(537),
    [anon_sym_match] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(539),
    [sym_integer] = ACTIONS(541),
    [sym_float] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_none] = ACTIONS(541),
    [sym_python_identifier] = ACTIONS(541),
    [sym_identifier] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(543),
  },
  [98] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_AT_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym_string_start] = ACTIONS(490),
  },
  [99] = {
    [sym_binary_operator] = STATE(1214),
    [sym_unary_operator] = STATE(1214),
    [sym_attribute] = STATE(1214),
    [sym_subscript] = STATE(1214),
    [sym_call] = STATE(1214),
    [sym_generator_expression] = STATE(1214),
    [sym_parenthesized_expression] = STATE(1214),
    [sym_list_splat_pattern] = STATE(1240),
    [sym_primary_expression] = STATE(932),
    [sym_list] = STATE(1214),
    [sym_set] = STATE(1214),
    [sym_tuple] = STATE(1214),
    [sym_dictionary] = STATE(1214),
    [sym_list_comprehension] = STATE(1214),
    [sym_dictionary_comprehension] = STATE(1214),
    [sym_set_comprehension] = STATE(1214),
    [sym_concatenated_string] = STATE(1214),
    [sym_python_string] = STATE(875),
    [sym_await] = STATE(1214),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [100] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(290),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(290),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(290),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(290),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(300),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(300),
    [anon_sym_SLASH_SLASH] = ACTIONS(300),
    [anon_sym_STAR_STAR] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_AMP] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_LT_LT] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(290),
    [sym_string_start] = ACTIONS(490),
  },
  [101] = {
    [sym_binary_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [sym_attribute] = STATE(980),
    [sym_subscript] = STATE(980),
    [sym_call] = STATE(980),
    [sym_generator_expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_list_splat_pattern] = STATE(994),
    [sym_primary_expression] = STATE(1006),
    [sym_list] = STATE(980),
    [sym_set] = STATE(980),
    [sym_tuple] = STATE(980),
    [sym_dictionary] = STATE(980),
    [sym_list_comprehension] = STATE(980),
    [sym_dictionary_comprehension] = STATE(980),
    [sym_set_comprehension] = STATE(980),
    [sym_concatenated_string] = STATE(980),
    [sym_python_string] = STATE(834),
    [sym_await] = STATE(980),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_from] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(545),
    [anon_sym_print] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(457),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(547),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(109),
    [sym_integer] = ACTIONS(105),
    [sym_float] = ACTIONS(105),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_none] = ACTIONS(105),
    [sym_python_identifier] = ACTIONS(105),
    [sym_identifier] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(298),
    [sym_string_start] = ACTIONS(113),
  },
  [102] = {
    [sym_binary_operator] = STATE(1150),
    [sym_unary_operator] = STATE(1150),
    [sym_attribute] = STATE(1150),
    [sym_subscript] = STATE(1150),
    [sym_call] = STATE(1150),
    [sym_generator_expression] = STATE(1150),
    [sym_parenthesized_expression] = STATE(1150),
    [sym_list_splat_pattern] = STATE(1147),
    [sym_primary_expression] = STATE(879),
    [sym_list] = STATE(1150),
    [sym_set] = STATE(1150),
    [sym_tuple] = STATE(1150),
    [sym_dictionary] = STATE(1150),
    [sym_list_comprehension] = STATE(1150),
    [sym_dictionary_comprehension] = STATE(1150),
    [sym_set_comprehension] = STATE(1150),
    [sym_concatenated_string] = STATE(1150),
    [sym_python_string] = STATE(839),
    [sym_await] = STATE(1150),
    [anon_sym_LBRACK] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(579),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(298),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(583),
    [anon_sym_print] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(585),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(591),
    [anon_sym_await] = ACTIONS(593),
    [anon_sym_match] = ACTIONS(585),
    [anon_sym_type] = ACTIONS(595),
    [sym_integer] = ACTIONS(597),
    [sym_float] = ACTIONS(597),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_none] = ACTIONS(597),
    [sym_python_identifier] = ACTIONS(597),
    [sym_identifier] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(599),
  },
  [103] = {
    [sym_binary_operator] = STATE(1214),
    [sym_unary_operator] = STATE(1214),
    [sym_attribute] = STATE(1214),
    [sym_subscript] = STATE(1214),
    [sym_call] = STATE(1214),
    [sym_generator_expression] = STATE(1214),
    [sym_parenthesized_expression] = STATE(1214),
    [sym_list_splat_pattern] = STATE(1240),
    [sym_primary_expression] = STATE(932),
    [sym_list] = STATE(1214),
    [sym_set] = STATE(1214),
    [sym_tuple] = STATE(1214),
    [sym_dictionary] = STATE(1214),
    [sym_list_comprehension] = STATE(1214),
    [sym_dictionary_comprehension] = STATE(1214),
    [sym_set_comprehension] = STATE(1214),
    [sym_concatenated_string] = STATE(1214),
    [sym_python_string] = STATE(875),
    [sym_await] = STATE(1214),
    [anon_sym_EQ] = ACTIONS(519),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [104] = {
    [sym_binary_operator] = STATE(1364),
    [sym_unary_operator] = STATE(1364),
    [sym_attribute] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_call] = STATE(1364),
    [sym_generator_expression] = STATE(1364),
    [sym_parenthesized_expression] = STATE(1364),
    [sym_list_splat_pattern] = STATE(1382),
    [sym_primary_expression] = STATE(1096),
    [sym_list] = STATE(1364),
    [sym_set] = STATE(1364),
    [sym_tuple] = STATE(1364),
    [sym_dictionary] = STATE(1364),
    [sym_list_comprehension] = STATE(1364),
    [sym_dictionary_comprehension] = STATE(1364),
    [sym_set_comprehension] = STATE(1364),
    [sym_concatenated_string] = STATE(1364),
    [sym_python_string] = STATE(1012),
    [sym_await] = STATE(1364),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(298),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [105] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [106] = {
    [sym_binary_operator] = STATE(1299),
    [sym_unary_operator] = STATE(1299),
    [sym_attribute] = STATE(1299),
    [sym_subscript] = STATE(1299),
    [sym_call] = STATE(1299),
    [sym_generator_expression] = STATE(1299),
    [sym_parenthesized_expression] = STATE(1299),
    [sym_list_splat_pattern] = STATE(1271),
    [sym_primary_expression] = STATE(1004),
    [sym_list] = STATE(1299),
    [sym_set] = STATE(1299),
    [sym_tuple] = STATE(1299),
    [sym_dictionary] = STATE(1299),
    [sym_list_comprehension] = STATE(1299),
    [sym_dictionary_comprehension] = STATE(1299),
    [sym_set_comprehension] = STATE(1299),
    [sym_concatenated_string] = STATE(1299),
    [sym_python_string] = STATE(882),
    [sym_await] = STATE(1299),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [107] = {
    [sym_binary_operator] = STATE(1364),
    [sym_unary_operator] = STATE(1364),
    [sym_attribute] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_call] = STATE(1364),
    [sym_generator_expression] = STATE(1364),
    [sym_parenthesized_expression] = STATE(1364),
    [sym_list_splat_pattern] = STATE(1382),
    [sym_primary_expression] = STATE(1096),
    [sym_list] = STATE(1364),
    [sym_set] = STATE(1364),
    [sym_tuple] = STATE(1364),
    [sym_dictionary] = STATE(1364),
    [sym_list_comprehension] = STATE(1364),
    [sym_dictionary_comprehension] = STATE(1364),
    [sym_set_comprehension] = STATE(1364),
    [sym_concatenated_string] = STATE(1364),
    [sym_python_string] = STATE(1012),
    [sym_await] = STATE(1364),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(516),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(516),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [108] = {
    [sym_binary_operator] = STATE(1198),
    [sym_unary_operator] = STATE(1198),
    [sym_attribute] = STATE(1198),
    [sym_subscript] = STATE(1198),
    [sym_call] = STATE(1198),
    [sym_generator_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_list_splat_pattern] = STATE(1210),
    [sym_primary_expression] = STATE(1000),
    [sym_list] = STATE(1198),
    [sym_set] = STATE(1198),
    [sym_tuple] = STATE(1198),
    [sym_dictionary] = STATE(1198),
    [sym_list_comprehension] = STATE(1198),
    [sym_dictionary_comprehension] = STATE(1198),
    [sym_set_comprehension] = STATE(1198),
    [sym_concatenated_string] = STATE(1198),
    [sym_python_string] = STATE(853),
    [sym_await] = STATE(1198),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_print] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(535),
    [anon_sym_await] = ACTIONS(537),
    [anon_sym_match] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(539),
    [sym_integer] = ACTIONS(541),
    [sym_float] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_none] = ACTIONS(541),
    [sym_python_identifier] = ACTIONS(541),
    [sym_identifier] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(543),
  },
  [109] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [110] = {
    [sym_binary_operator] = STATE(1299),
    [sym_unary_operator] = STATE(1299),
    [sym_attribute] = STATE(1299),
    [sym_subscript] = STATE(1299),
    [sym_call] = STATE(1299),
    [sym_generator_expression] = STATE(1299),
    [sym_parenthesized_expression] = STATE(1299),
    [sym_list_splat_pattern] = STATE(1271),
    [sym_primary_expression] = STATE(1004),
    [sym_list] = STATE(1299),
    [sym_set] = STATE(1299),
    [sym_tuple] = STATE(1299),
    [sym_dictionary] = STATE(1299),
    [sym_list_comprehension] = STATE(1299),
    [sym_dictionary_comprehension] = STATE(1299),
    [sym_set_comprehension] = STATE(1299),
    [sym_concatenated_string] = STATE(1299),
    [sym_python_string] = STATE(882),
    [sym_await] = STATE(1299),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [111] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1048),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(655),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [112] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [113] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [114] = {
    [sym_binary_operator] = STATE(1198),
    [sym_unary_operator] = STATE(1198),
    [sym_attribute] = STATE(1198),
    [sym_subscript] = STATE(1198),
    [sym_call] = STATE(1198),
    [sym_generator_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_list_splat_pattern] = STATE(1210),
    [sym_primary_expression] = STATE(1000),
    [sym_list] = STATE(1198),
    [sym_set] = STATE(1198),
    [sym_tuple] = STATE(1198),
    [sym_dictionary] = STATE(1198),
    [sym_list_comprehension] = STATE(1198),
    [sym_dictionary_comprehension] = STATE(1198),
    [sym_set_comprehension] = STATE(1198),
    [sym_concatenated_string] = STATE(1198),
    [sym_python_string] = STATE(853),
    [sym_await] = STATE(1198),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(298),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_print] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(535),
    [anon_sym_await] = ACTIONS(537),
    [anon_sym_match] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(539),
    [sym_integer] = ACTIONS(541),
    [sym_float] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_none] = ACTIONS(541),
    [sym_python_identifier] = ACTIONS(541),
    [sym_identifier] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(543),
  },
  [115] = {
    [sym_binary_operator] = STATE(1214),
    [sym_unary_operator] = STATE(1214),
    [sym_attribute] = STATE(1214),
    [sym_subscript] = STATE(1214),
    [sym_call] = STATE(1214),
    [sym_generator_expression] = STATE(1214),
    [sym_parenthesized_expression] = STATE(1214),
    [sym_list_splat_pattern] = STATE(1240),
    [sym_primary_expression] = STATE(932),
    [sym_list] = STATE(1214),
    [sym_set] = STATE(1214),
    [sym_tuple] = STATE(1214),
    [sym_dictionary] = STATE(1214),
    [sym_list_comprehension] = STATE(1214),
    [sym_dictionary_comprehension] = STATE(1214),
    [sym_set_comprehension] = STATE(1214),
    [sym_concatenated_string] = STATE(1214),
    [sym_python_string] = STATE(875),
    [sym_await] = STATE(1214),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_print] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(516),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(567),
    [anon_sym_await] = ACTIONS(569),
    [anon_sym_match] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(571),
    [sym_integer] = ACTIONS(573),
    [sym_float] = ACTIONS(573),
    [sym_true] = ACTIONS(573),
    [sym_false] = ACTIONS(573),
    [sym_none] = ACTIONS(573),
    [sym_python_identifier] = ACTIONS(573),
    [sym_identifier] = ACTIONS(571),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(575),
  },
  [116] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [117] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [118] = {
    [sym_binary_operator] = STATE(1364),
    [sym_unary_operator] = STATE(1364),
    [sym_attribute] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_call] = STATE(1364),
    [sym_generator_expression] = STATE(1364),
    [sym_parenthesized_expression] = STATE(1364),
    [sym_list_splat_pattern] = STATE(1382),
    [sym_primary_expression] = STATE(1096),
    [sym_list] = STATE(1364),
    [sym_set] = STATE(1364),
    [sym_tuple] = STATE(1364),
    [sym_dictionary] = STATE(1364),
    [sym_list_comprehension] = STATE(1364),
    [sym_dictionary_comprehension] = STATE(1364),
    [sym_set_comprehension] = STATE(1364),
    [sym_concatenated_string] = STATE(1364),
    [sym_python_string] = STATE(1012),
    [sym_await] = STATE(1364),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(298),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [119] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1048),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(649),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(655),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [120] = {
    [sym_binary_operator] = STATE(1106),
    [sym_unary_operator] = STATE(1106),
    [sym_attribute] = STATE(1106),
    [sym_subscript] = STATE(1106),
    [sym_call] = STATE(1106),
    [sym_generator_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_list_splat_pattern] = STATE(1093),
    [sym_primary_expression] = STATE(877),
    [sym_list] = STATE(1106),
    [sym_set] = STATE(1106),
    [sym_tuple] = STATE(1106),
    [sym_dictionary] = STATE(1106),
    [sym_list_comprehension] = STATE(1106),
    [sym_dictionary_comprehension] = STATE(1106),
    [sym_set_comprehension] = STATE(1106),
    [sym_concatenated_string] = STATE(1106),
    [sym_python_string] = STATE(842),
    [sym_await] = STATE(1106),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(500),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(516),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(508),
    [anon_sym_match] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(510),
    [sym_integer] = ACTIONS(512),
    [sym_float] = ACTIONS(512),
    [sym_true] = ACTIONS(512),
    [sym_false] = ACTIONS(512),
    [sym_none] = ACTIONS(512),
    [sym_python_identifier] = ACTIONS(512),
    [sym_identifier] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(514),
  },
  [121] = {
    [sym_binary_operator] = STATE(1364),
    [sym_unary_operator] = STATE(1364),
    [sym_attribute] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_call] = STATE(1364),
    [sym_generator_expression] = STATE(1364),
    [sym_parenthesized_expression] = STATE(1364),
    [sym_list_splat_pattern] = STATE(1382),
    [sym_primary_expression] = STATE(1096),
    [sym_list] = STATE(1364),
    [sym_set] = STATE(1364),
    [sym_tuple] = STATE(1364),
    [sym_dictionary] = STATE(1364),
    [sym_list_comprehension] = STATE(1364),
    [sym_dictionary_comprehension] = STATE(1364),
    [sym_set_comprehension] = STATE(1364),
    [sym_concatenated_string] = STATE(1364),
    [sym_python_string] = STATE(1012),
    [sym_await] = STATE(1364),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(601),
    [anon_sym_RBRACK] = ACTIONS(516),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_print] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(609),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(609),
    [anon_sym_not] = ACTIONS(471),
    [anon_sym_and] = ACTIONS(471),
    [anon_sym_or] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(613),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_LT_GT] = ACTIONS(516),
    [anon_sym_is] = ACTIONS(471),
    [sym_ellipsis] = ACTIONS(615),
    [anon_sym_await] = ACTIONS(617),
    [anon_sym_match] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(619),
    [sym_integer] = ACTIONS(621),
    [sym_float] = ACTIONS(621),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_none] = ACTIONS(621),
    [sym_python_identifier] = ACTIONS(621),
    [sym_identifier] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(623),
  },
  [122] = {
    [sym_binary_operator] = STATE(1299),
    [sym_unary_operator] = STATE(1299),
    [sym_attribute] = STATE(1299),
    [sym_subscript] = STATE(1299),
    [sym_call] = STATE(1299),
    [sym_generator_expression] = STATE(1299),
    [sym_parenthesized_expression] = STATE(1299),
    [sym_list_splat_pattern] = STATE(1271),
    [sym_primary_expression] = STATE(1004),
    [sym_list] = STATE(1299),
    [sym_set] = STATE(1299),
    [sym_tuple] = STATE(1299),
    [sym_dictionary] = STATE(1299),
    [sym_list_comprehension] = STATE(1299),
    [sym_dictionary_comprehension] = STATE(1299),
    [sym_set_comprehension] = STATE(1299),
    [sym_concatenated_string] = STATE(1299),
    [sym_python_string] = STATE(882),
    [sym_await] = STATE(1299),
    [anon_sym_LBRACK] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(298),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(631),
    [anon_sym_print] = ACTIONS(633),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(300),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(639),
    [anon_sym_await] = ACTIONS(641),
    [anon_sym_match] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(643),
    [sym_integer] = ACTIONS(645),
    [sym_float] = ACTIONS(645),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_none] = ACTIONS(645),
    [sym_python_identifier] = ACTIONS(645),
    [sym_identifier] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(647),
  },
  [123] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1326),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_COLON_EQ] = ACTIONS(288),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_else] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(663),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [124] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(463),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_SLASH_SLASH] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_AT_EQ] = ACTIONS(463),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [125] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_EQ] = ACTIONS(290),
    [anon_sym_PLUS_EQ] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_COLON] = ACTIONS(290),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(290),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(300),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(300),
    [anon_sym_SLASH_SLASH] = ACTIONS(300),
    [anon_sym_STAR_STAR] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(300),
    [anon_sym_AMP] = ACTIONS(300),
    [anon_sym_CARET] = ACTIONS(300),
    [anon_sym_LT_LT] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_DASH_EQ] = ACTIONS(290),
    [anon_sym_STAR_EQ] = ACTIONS(290),
    [anon_sym_SLASH_EQ] = ACTIONS(290),
    [anon_sym_AT_EQ] = ACTIONS(290),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(290),
    [anon_sym_PERCENT_EQ] = ACTIONS(290),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(290),
    [anon_sym_GT_GT_EQ] = ACTIONS(290),
    [anon_sym_LT_LT_EQ] = ACTIONS(290),
    [anon_sym_AMP_EQ] = ACTIONS(290),
    [anon_sym_CARET_EQ] = ACTIONS(290),
    [anon_sym_PIPE_EQ] = ACTIONS(290),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [126] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1326),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(300),
    [anon_sym_as] = ACTIONS(300),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(298),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(300),
    [anon_sym_else] = ACTIONS(300),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(300),
    [anon_sym_and] = ACTIONS(300),
    [anon_sym_or] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_AT] = ACTIONS(298),
    [anon_sym_SLASH] = ACTIONS(300),
    [anon_sym_PERCENT] = ACTIONS(298),
    [anon_sym_SLASH_SLASH] = ACTIONS(298),
    [anon_sym_STAR_STAR] = ACTIONS(298),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_AMP] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(298),
    [anon_sym_LT_LT] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(300),
    [anon_sym_LT_EQ] = ACTIONS(298),
    [anon_sym_EQ_EQ] = ACTIONS(298),
    [anon_sym_BANG_EQ] = ACTIONS(298),
    [anon_sym_GT_EQ] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(300),
    [anon_sym_LT_GT] = ACTIONS(298),
    [anon_sym_is] = ACTIONS(300),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(663),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
  [127] = {
    [sym_binary_operator] = STATE(1287),
    [sym_unary_operator] = STATE(1287),
    [sym_attribute] = STATE(1287),
    [sym_subscript] = STATE(1287),
    [sym_call] = STATE(1287),
    [sym_generator_expression] = STATE(1287),
    [sym_parenthesized_expression] = STATE(1287),
    [sym_list_splat_pattern] = STATE(1282),
    [sym_primary_expression] = STATE(1476),
    [sym_list] = STATE(1287),
    [sym_set] = STATE(1287),
    [sym_tuple] = STATE(1287),
    [sym_dictionary] = STATE(1287),
    [sym_list_comprehension] = STATE(1287),
    [sym_dictionary_comprehension] = STATE(1287),
    [sym_set_comprehension] = STATE(1287),
    [sym_concatenated_string] = STATE(1287),
    [sym_python_string] = STATE(880),
    [sym_await] = STATE(1287),
    [anon_sym_LBRACK] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_print] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_exec] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_else] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_not] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_LT_GT] = ACTIONS(463),
    [anon_sym_is] = ACTIONS(461),
    [sym_ellipsis] = ACTIONS(482),
    [anon_sym_await] = ACTIONS(484),
    [anon_sym_match] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(486),
    [sym_integer] = ACTIONS(488),
    [sym_float] = ACTIONS(488),
    [sym_true] = ACTIONS(488),
    [sym_false] = ACTIONS(488),
    [sym_none] = ACTIONS(488),
    [sym_python_identifier] = ACTIONS(488),
    [sym_identifier] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym_string_start] = ACTIONS(490),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LPAREN,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      anon_sym_STAR,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(95), 1,
      anon_sym_yield,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(99), 1,
      anon_sym_await,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(107), 1,
      sym_python_identifier,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(552), 1,
      sym_list_splat_pattern,
    STATE(834), 1,
      sym_python_string,
    STATE(859), 1,
      sym_primary_expression,
    STATE(1499), 1,
      sym_pattern_list,
    STATE(1502), 1,
      sym_pattern,
    STATE(1690), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(551), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(101), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(2262), 5,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
      sym_expression_list,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [124] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(667), 1,
      anon_sym_RBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1556), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2474), 1,
      sym__patterns,
    STATE(2540), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [252] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_RPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2355), 1,
      sym__patterns,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [382] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(709), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2494), 1,
      sym__patterns,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [512] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(711), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1555), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2379), 1,
      sym__collection_elements,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2474), 1,
      sym__patterns,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [640] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LPAREN,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      anon_sym_STAR,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(95), 1,
      anon_sym_yield,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(99), 1,
      anon_sym_await,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(107), 1,
      sym_python_identifier,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(552), 1,
      sym_list_splat_pattern,
    STATE(834), 1,
      sym_python_string,
    STATE(859), 1,
      sym_primary_expression,
    STATE(1499), 1,
      sym_pattern_list,
    STATE(1502), 1,
      sym_pattern,
    STATE(1690), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(551), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(101), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(2240), 5,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
      sym_expression_list,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [764] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(713), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2396), 1,
      sym__patterns,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [894] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(717), 1,
      anon_sym_RBRACE,
    ACTIONS(719), 1,
      anon_sym_COMMA,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1534), 1,
      sym_expression,
    STATE(1743), 1,
      sym_pair,
    STATE(2149), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2356), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1022] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(739), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1546), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2325), 1,
      sym__patterns,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2403), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1150] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(741), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2474), 1,
      sym__patterns,
    STATE(2529), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1278] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(743), 1,
      anon_sym_RBRACE,
    ACTIONS(745), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1529), 1,
      sym_expression,
    STATE(1726), 1,
      sym_pair,
    STATE(2090), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2384), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1406] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(747), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1549), 1,
      sym_expression,
    STATE(2067), 1,
      sym_yield,
    STATE(2114), 1,
      sym_parenthesized_list_splat,
    STATE(2116), 1,
      sym_list_splat,
    STATE(2147), 1,
      sym_pattern,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2359), 1,
      sym__collection_elements,
    STATE(2396), 1,
      sym__patterns,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1538] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(749), 1,
      anon_sym_RBRACE,
    ACTIONS(751), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1532), 1,
      sym_expression,
    STATE(1756), 1,
      sym_pair,
    STATE(2181), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2456), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1666] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(753), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1570), 1,
      sym_expression,
    STATE(2093), 1,
      sym_yield,
    STATE(2147), 1,
      sym_pattern,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2355), 1,
      sym__patterns,
    STATE(2381), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1796] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(755), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1570), 1,
      sym_expression,
    STATE(2093), 1,
      sym_yield,
    STATE(2147), 1,
      sym_pattern,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2355), 1,
      sym__patterns,
    STATE(2381), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [1926] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(757), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2442), 1,
      sym__patterns,
    STATE(2529), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2054] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(759), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1555), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2379), 1,
      sym__collection_elements,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2474), 1,
      sym__patterns,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2182] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(761), 1,
      anon_sym_RBRACE,
    ACTIONS(763), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1530), 1,
      sym_expression,
    STATE(1729), 1,
      sym_pair,
    STATE(2136), 1,
      sym_dictionary_splat,
    STATE(2333), 1,
      sym__collection_elements,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2310] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(765), 1,
      anon_sym_RBRACE,
    ACTIONS(767), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1536), 1,
      sym_expression,
    STATE(1739), 1,
      sym_pair,
    STATE(2066), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2417), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2438] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(769), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2355), 1,
      sym__patterns,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2568] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(771), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2474), 1,
      sym__patterns,
    STATE(2529), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2696] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(773), 1,
      anon_sym_RBRACE,
    ACTIONS(775), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1528), 1,
      sym_expression,
    STATE(1747), 1,
      sym_pair,
    STATE(2170), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2426), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2824] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(779), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1531), 1,
      sym_expression,
    STATE(1741), 1,
      sym_pair,
    STATE(2204), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2521), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [2952] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(781), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2486), 1,
      sym__patterns,
    STATE(2529), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3080] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_STAR,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(783), 1,
      anon_sym_RBRACE,
    ACTIONS(785), 1,
      anon_sym_COMMA,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1535), 1,
      sym_expression,
    STATE(1759), 1,
      sym_pair,
    STATE(2055), 1,
      sym_dictionary_splat,
    STATE(2334), 1,
      sym__named_expression_lhs,
    STATE(2437), 1,
      sym__collection_elements,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1999), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3208] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(787), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2376), 1,
      sym__patterns,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3338] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(789), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2325), 1,
      sym__patterns,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2529), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3466] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(791), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1554), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2428), 1,
      sym__collection_elements,
    STATE(2536), 1,
      sym__patterns,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3594] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_LBRACK,
    ACTIONS(669), 1,
      anon_sym_LPAREN,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(681), 1,
      anon_sym_await,
    ACTIONS(683), 1,
      anon_sym_type,
    ACTIONS(685), 1,
      sym_python_identifier,
    ACTIONS(793), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1262), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2108), 1,
      sym_pattern,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2529), 1,
      sym__collection_elements,
    STATE(2536), 1,
      sym__patterns,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1260), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3722] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(795), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1541), 1,
      sym_expression,
    STATE(2044), 1,
      sym_list_splat,
    STATE(2047), 1,
      sym_parenthesized_list_splat,
    STATE(2061), 1,
      sym_yield,
    STATE(2147), 1,
      sym_pattern,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2425), 1,
      sym__collection_elements,
    STATE(2548), 1,
      sym__patterns,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3854] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LPAREN,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      anon_sym_STAR,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(95), 1,
      anon_sym_yield,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(99), 1,
      anon_sym_await,
    ACTIONS(103), 1,
      anon_sym_type,
    ACTIONS(107), 1,
      sym_python_identifier,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(552), 1,
      sym_list_splat_pattern,
    STATE(834), 1,
      sym_python_string,
    STATE(859), 1,
      sym_primary_expression,
    STATE(1499), 1,
      sym_pattern_list,
    STATE(1502), 1,
      sym_pattern,
    STATE(1690), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(551), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(101), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(2266), 5,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
      sym_expression_list,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [3978] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1547), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2192), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2355), 1,
      sym__patterns,
    STATE(2479), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4108] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(687), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_LPAREN,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(703), 1,
      anon_sym_await,
    ACTIONS(705), 1,
      anon_sym_type,
    ACTIONS(707), 1,
      sym_python_identifier,
    ACTIONS(799), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1261), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2147), 1,
      sym_pattern,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2527), 1,
      sym__collection_elements,
    STATE(2548), 1,
      sym__patterns,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1263), 2,
      sym_attribute,
      sym_subscript,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(695), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4238] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(803), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_LPAREN,
    ACTIONS(807), 1,
      anon_sym_STAR,
    ACTIONS(811), 1,
      anon_sym_await,
    ACTIONS(813), 1,
      anon_sym_type,
    ACTIONS(815), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1194), 1,
      sym_list_splat_pattern,
    STATE(1448), 1,
      sym_primary_expression,
    STATE(1456), 1,
      sym_pattern,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1195), 2,
      sym_attribute,
      sym_subscript,
    STATE(1478), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(809), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(801), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4347] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(803), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_LPAREN,
    ACTIONS(807), 1,
      anon_sym_STAR,
    ACTIONS(811), 1,
      anon_sym_await,
    ACTIONS(813), 1,
      anon_sym_type,
    ACTIONS(815), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1194), 1,
      sym_list_splat_pattern,
    STATE(1448), 1,
      sym_primary_expression,
    STATE(1456), 1,
      sym_pattern,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1195), 2,
      sym_attribute,
      sym_subscript,
    STATE(1478), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(809), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(817), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4456] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(819), 1,
      anon_sym_LBRACK,
    ACTIONS(821), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(831), 1,
      anon_sym_await,
    ACTIONS(833), 1,
      anon_sym_type,
    ACTIONS(835), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_list_splat_pattern,
    STATE(1613), 1,
      sym_expression,
    STATE(2287), 1,
      sym_pattern,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1019), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    STATE(1934), 4,
      sym_pattern_list,
      sym_yield,
      sym_expression_list,
      sym__f_expression,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4576] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(819), 1,
      anon_sym_LBRACK,
    ACTIONS(821), 1,
      anon_sym_LPAREN,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(831), 1,
      anon_sym_await,
    ACTIONS(833), 1,
      anon_sym_type,
    ACTIONS(835), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_list_splat_pattern,
    STATE(1613), 1,
      sym_expression,
    STATE(2287), 1,
      sym_pattern,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1019), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    STATE(1904), 4,
      sym_pattern_list,
      sym_yield,
      sym_expression_list,
      sym__f_expression,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4696] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1766), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4811] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(855), 1,
      anon_sym_from,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1593), 1,
      sym_expression,
    STATE(1914), 1,
      sym_expression_list,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(853), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [4926] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(867), 1,
      anon_sym_RPAREN,
    ACTIONS(869), 1,
      anon_sym_COMMA,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1539), 1,
      sym_expression,
    STATE(1987), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2191), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5045] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(883), 1,
      anon_sym_RPAREN,
    ACTIONS(885), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1564), 1,
      sym_expression,
    STATE(1994), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1995), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5164] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(887), 1,
      anon_sym_STAR,
    ACTIONS(889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(891), 1,
      sym_python_identifier,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1598), 1,
      sym_expression,
    STATE(1797), 1,
      sym_type,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1838), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5279] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(893), 1,
      anon_sym_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(899), 1,
      anon_sym_STAR_STAR,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(907), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1601), 1,
      sym_expression,
    STATE(1808), 1,
      sym_type,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1846), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5394] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1803), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5509] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(909), 1,
      anon_sym_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(921), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1650), 1,
      sym_expression,
    STATE(1885), 1,
      sym_type,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1853), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5624] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(923), 1,
      anon_sym_LBRACK,
    ACTIONS(925), 1,
      anon_sym_LPAREN,
    ACTIONS(927), 1,
      anon_sym_STAR,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1396), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_primary_expression,
    STATE(1500), 1,
      sym_pattern,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1401), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(929), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(801), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5731] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      anon_sym_TILDE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(923), 1,
      anon_sym_LBRACK,
    ACTIONS(925), 1,
      anon_sym_LPAREN,
    ACTIONS(927), 1,
      anon_sym_STAR,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1396), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_primary_expression,
    STATE(1500), 1,
      sym_pattern,
    ACTIONS(478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1401), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(929), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
    ACTIONS(817), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5838] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(909), 1,
      anon_sym_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(921), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1650), 1,
      sym_expression,
    STATE(1897), 1,
      sym_type,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1853), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [5953] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(909), 1,
      anon_sym_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(921), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1650), 1,
      sym_expression,
    STATE(2031), 1,
      sym_type,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1853), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6068] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(893), 1,
      anon_sym_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(899), 1,
      anon_sym_STAR_STAR,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(907), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1601), 1,
      sym_expression,
    STATE(1804), 1,
      sym_type,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1846), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6183] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(937), 1,
      anon_sym_RPAREN,
    ACTIONS(939), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1543), 1,
      sym_expression,
    STATE(2159), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2158), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6302] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(893), 1,
      anon_sym_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(899), 1,
      anon_sym_STAR_STAR,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(907), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1601), 1,
      sym_expression,
    STATE(1795), 1,
      sym_type,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1846), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6417] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      anon_sym_STAR_STAR,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(909), 1,
      anon_sym_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(921), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1650), 1,
      sym_expression,
    STATE(2179), 1,
      sym_type,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1853), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6532] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(941), 1,
      anon_sym_RPAREN,
    ACTIONS(943), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1551), 1,
      sym_expression,
    STATE(2088), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2089), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6651] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(945), 1,
      anon_sym_RPAREN,
    ACTIONS(947), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1559), 1,
      sym_expression,
    STATE(2126), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2124), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6770] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(949), 1,
      anon_sym_RPAREN,
    ACTIONS(951), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1575), 1,
      sym_expression,
    STATE(2049), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2045), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [6889] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1828), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7004] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1786), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7119] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(887), 1,
      anon_sym_STAR,
    ACTIONS(889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(891), 1,
      sym_python_identifier,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1598), 1,
      sym_expression,
    STATE(1822), 1,
      sym_type,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1838), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7234] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1936), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7349] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(887), 1,
      anon_sym_STAR,
    ACTIONS(889), 1,
      anon_sym_STAR_STAR,
    ACTIONS(891), 1,
      sym_python_identifier,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1598), 1,
      sym_expression,
    STATE(1816), 1,
      sym_type,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1838), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7464] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(953), 1,
      anon_sym_RPAREN,
    ACTIONS(955), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1545), 1,
      sym_expression,
    STATE(2078), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2077), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7583] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(957), 1,
      anon_sym_RPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1573), 1,
      sym_expression,
    STATE(2137), 1,
      sym_with_item,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7704] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1896), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7819] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(871), 1,
      anon_sym_STAR,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_await,
    ACTIONS(879), 1,
      anon_sym_type,
    ACTIONS(881), 1,
      sym_python_identifier,
    ACTIONS(967), 1,
      anon_sym_RPAREN,
    ACTIONS(969), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1544), 1,
      sym_expression,
    STATE(1986), 1,
      sym_parenthesized_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2169), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [7938] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(837), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(851), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_expression,
    STATE(1908), 1,
      sym_type,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1917), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8053] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(893), 1,
      anon_sym_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(899), 1,
      anon_sym_STAR_STAR,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(907), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1601), 1,
      sym_expression,
    STATE(1855), 1,
      sym_type,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1846), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8168] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(971), 1,
      anon_sym_RBRACK,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1546), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2403), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8284] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(985), 1,
      anon_sym_RPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8400] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(997), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8516] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(999), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8632] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1001), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8748] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8864] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [8980] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1007), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1577), 1,
      sym_expression,
    STATE(2074), 1,
      sym_parenthesized_list_splat,
    STATE(2075), 1,
      sym_list_splat,
    STATE(2144), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2347), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9100] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1009), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1540), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2445), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9216] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1011), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9332] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9448] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1015), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1553), 1,
      sym_expression,
    STATE(2173), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2441), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9566] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1017), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1554), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2428), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9682] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1019), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9798] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [9914] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1023), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1549), 1,
      sym_expression,
    STATE(2067), 1,
      sym_yield,
    STATE(2114), 1,
      sym_parenthesized_list_splat,
    STATE(2116), 1,
      sym_list_splat,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2359), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10034] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1025), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10150] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1027), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1541), 1,
      sym_expression,
    STATE(2061), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2425), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10268] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1029), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1574), 1,
      sym_expression,
    STATE(2044), 1,
      sym_list_splat,
    STATE(2047), 1,
      sym_parenthesized_list_splat,
    STATE(2142), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2331), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10388] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1031), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10504] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1033), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10620] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1035), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1547), 1,
      sym_expression,
    STATE(2074), 1,
      sym_parenthesized_list_splat,
    STATE(2075), 1,
      sym_list_splat,
    STATE(2192), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2479), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10740] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1029), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1574), 1,
      sym_expression,
    STATE(2142), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2331), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10858] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1037), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1565), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2529), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [10974] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11090] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1041), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11206] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1043), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11322] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11438] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1047), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11554] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1049), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1570), 1,
      sym_expression,
    STATE(2093), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2381), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11672] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1051), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11788] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1053), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [11904] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1055), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12020] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1057), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1555), 1,
      sym_expression,
    STATE(2379), 1,
      sym__collection_elements,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12136] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1027), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1541), 1,
      sym_expression,
    STATE(2044), 1,
      sym_list_splat,
    STATE(2047), 1,
      sym_parenthesized_list_splat,
    STATE(2061), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2425), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12256] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1059), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12372] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12488] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1063), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12604] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12720] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12836] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1069), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [12952] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13068] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1073), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1556), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    STATE(2540), 1,
      sym__collection_elements,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13184] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1035), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1547), 1,
      sym_expression,
    STATE(2192), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2479), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13302] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1075), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13418] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1077), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13534] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1079), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13650] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13766] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1083), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1538), 1,
      sym_expression,
    STATE(2329), 1,
      sym__collection_elements,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [13882] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1007), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1577), 1,
      sym_expression,
    STATE(2144), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2347), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14000] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1015), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1553), 1,
      sym_expression,
    STATE(2114), 1,
      sym_parenthesized_list_splat,
    STATE(2116), 1,
      sym_list_splat,
    STATE(2173), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2441), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14120] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(957), 1,
      anon_sym_RPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2199), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2527), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14238] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(973), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1085), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1548), 1,
      sym_expression,
    STATE(2330), 1,
      sym__collection_elements,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2194), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14354] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(693), 1,
      anon_sym_STAR,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1023), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1549), 1,
      sym_expression,
    STATE(2067), 1,
      sym_yield,
    STATE(2326), 1,
      sym__named_expression_lhs,
    STATE(2359), 1,
      sym__collection_elements,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2168), 2,
      sym_parenthesized_list_splat,
      sym_list_splat,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14472] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1087), 1,
      anon_sym_RBRACK,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1926), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1091), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14585] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_RBRACE,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1880), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1099), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14698] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    ACTIONS(1103), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1926), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1105), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14811] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(1107), 1,
      anon_sym_RPAREN,
    ACTIONS(1109), 1,
      anon_sym_STAR,
    ACTIONS(1111), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1773), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2285), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [14924] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(463), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(516), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15023] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    ACTIONS(1103), 1,
      anon_sym_RBRACE,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1880), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1105), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15136] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1087), 1,
      anon_sym_RBRACE,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1880), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1091), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15249] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1113), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15358] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_STAR,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1115), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1773), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2285), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15471] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    ACTIONS(1117), 1,
      anon_sym_RBRACE,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1880), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1119), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15584] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1121), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15693] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1103), 1,
      anon_sym_RPAREN,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1869), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1105), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15806] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1107), 1,
      anon_sym_RBRACK,
    ACTIONS(1127), 1,
      anon_sym_LPAREN,
    ACTIONS(1129), 1,
      anon_sym_STAR,
    ACTIONS(1131), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1800), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2213), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [15919] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    ACTIONS(1095), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1926), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1099), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16032] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    ACTIONS(1115), 1,
      anon_sym_RBRACE,
    ACTIONS(1133), 1,
      anon_sym_LPAREN,
    ACTIONS(1135), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1772), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2243), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16145] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    ACTIONS(1117), 1,
      anon_sym_RBRACK,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1926), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1119), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16258] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(290), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16357] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    ACTIONS(1107), 1,
      anon_sym_RBRACE,
    ACTIONS(1133), 1,
      anon_sym_LPAREN,
    ACTIONS(1135), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1772), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2243), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16470] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1115), 1,
      anon_sym_RBRACK,
    ACTIONS(1127), 1,
      anon_sym_LPAREN,
    ACTIONS(1129), 1,
      anon_sym_STAR,
    ACTIONS(1131), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1800), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2213), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16583] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(875), 1,
      anon_sym_STAR_STAR,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(987), 1,
      anon_sym_STAR,
    ACTIONS(991), 1,
      anon_sym_await,
    ACTIONS(993), 1,
      anon_sym_type,
    ACTIONS(995), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2293), 1,
      sym_parenthesized_list_splat,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2292), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(989), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16696] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1869), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1119), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16809] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1095), 1,
      anon_sym_RPAREN,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1869), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1099), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [16922] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1087), 1,
      anon_sym_RPAREN,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1869), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 3,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_match,
    ACTIONS(1091), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17035] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(1139), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17147] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1141), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17259] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17371] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1145), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17483] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1147), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17595] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1149), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17707] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(701), 1,
      anon_sym_yield,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(983), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_STAR,
    ACTIONS(1111), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1773), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2285), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17817] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1151), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [17929] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1153), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18041] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1155), 1,
      anon_sym_from,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2307), 1,
      sym_expression_list,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(853), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18153] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18265] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18377] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(731), 1,
      anon_sym_yield,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    ACTIONS(1133), 1,
      anon_sym_LPAREN,
    ACTIONS(1135), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1772), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2243), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18487] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1167), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18823] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1169), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [18935] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1171), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19047] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(679), 1,
      anon_sym_yield,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1127), 1,
      anon_sym_LPAREN,
    ACTIONS(1129), 1,
      anon_sym_STAR,
    ACTIONS(1131), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1800), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2213), 3,
      sym_parenthesized_list_splat,
      sym_yield,
      sym_list_splat,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19157] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1175), 1,
      anon_sym_from,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1641), 1,
      sym_expression,
    STATE(2033), 1,
      sym_expression_list,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1173), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19269] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19381] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1187), 1,
      anon_sym_from,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1706), 1,
      sym_expression,
    STATE(2286), 1,
      sym_expression_list,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(853), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19493] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1191), 1,
      anon_sym_from,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1727), 1,
      sym_expression,
    STATE(2321), 1,
      sym_expression_list,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(853), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19605] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1195), 1,
      anon_sym_RBRACK,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19716] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    ACTIONS(1199), 1,
      anon_sym_from,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1707), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1121), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19825] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1201), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [19936] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1203), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20047] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1205), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20158] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1207), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20269] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1209), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20380] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1717), 1,
      sym_expression,
    STATE(2236), 1,
      sym_expression_list,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1211), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20489] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1213), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20600] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(649), 1,
      anon_sym_STAR,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(727), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2209), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20709] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1215), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20820] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1217), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [20931] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1219), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21042] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1221), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21153] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1223), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21264] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21375] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1227), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21486] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1231), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1760), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1229), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21595] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1233), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21706] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1235), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21817] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(463), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [21914] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1239), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1731), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1237), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22023] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1241), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22134] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1243), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22245] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1245), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22356] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1247), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22467] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(1249), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22564] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1251), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22675] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1253), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22786] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [22897] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1257), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23008] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1259), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23119] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1261), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23230] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1263), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23341] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1265), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23452] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    ACTIONS(1267), 1,
      anon_sym_from,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1707), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1113), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23561] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1269), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23672] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    ACTIONS(1271), 1,
      anon_sym_RBRACK,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23783] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1842), 1,
      sym_expression,
    STATE(2211), 1,
      sym_with_item,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23891] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1869), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [23997] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1275), 1,
      anon_sym_COLON,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2230), 1,
      sym_with_item,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24105] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    ACTIONS(1279), 1,
      anon_sym_RPAREN,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1842), 1,
      sym_expression,
    STATE(2211), 1,
      sym_with_item,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24213] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1675), 1,
      sym_expression,
    STATE(2057), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24321] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24417] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1761), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1281), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24523] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24619] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1721), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1927), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24725] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(286), 1,
      anon_sym_in,
    ACTIONS(290), 1,
      anon_sym_COMMA,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24823] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1691), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1876), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [24929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1693), 1,
      sym_expression,
    STATE(2079), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25037] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1736), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1283), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25143] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1736), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1285), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25249] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    ACTIONS(1287), 1,
      anon_sym_COLON,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2230), 1,
      sym_with_item,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25357] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1687), 1,
      sym_expression,
    STATE(2128), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25465] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(1249), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25561] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1702), 1,
      sym_expression,
    STATE(2059), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25669] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1685), 1,
      sym_expression,
    STATE(2162), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25777] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1789), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25883] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1704), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1884), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [25989] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1761), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1121), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26095] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1666), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1867), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26201] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1769), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1289), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26307] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2317), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26415] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1774), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26521] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1836), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26627] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1761), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1291), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26733] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1724), 1,
      sym_expression,
    STATE(2202), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26841] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1736), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1293), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [26947] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1736), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1295), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27053] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1880), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27159] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1668), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1863), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27265] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1682), 1,
      sym_expression,
    STATE(2165), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27373] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    ACTIONS(1297), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2034), 1,
      sym_with_item,
    STATE(2338), 1,
      sym_with_clause,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27481] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1761), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1113), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27587] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1825), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1229), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27693] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1926), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27799] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1661), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1826), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [27905] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1101), 1,
      anon_sym_lambda,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1670), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1861), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28011] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(463), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(516), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28107] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1771), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1121), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28213] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1771), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1113), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28319] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1699), 1,
      sym_expression,
    STATE(2046), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28427] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1847), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1299), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28533] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(463), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28629] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1815), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1121), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28735] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1815), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1113), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28841] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1093), 1,
      anon_sym_lambda,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1663), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1834), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [28947] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 1,
      anon_sym_in,
    ACTIONS(463), 1,
      anon_sym_COMMA,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(516), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29045] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1125), 1,
      anon_sym_lambda,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1844), 2,
      sym_lambda_within_for_in_clause,
      sym__expression_within_for_in_clause,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29151] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(463), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(516), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29247] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    ACTIONS(1297), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2034), 1,
      sym_with_item,
    STATE(2427), 1,
      sym__named_expression_lhs,
    STATE(2472), 1,
      sym_with_clause,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29355] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1700), 1,
      sym_expression,
    STATE(1992), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29463] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1197), 1,
      anon_sym_COLON,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1719), 1,
      sym_expression,
    STATE(2085), 1,
      sym_slice,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29571] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1676), 1,
      sym_expression,
    STATE(2242), 1,
      sym_expression_list,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29676] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2230), 1,
      sym_with_item,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29781] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1842), 1,
      sym_expression,
    STATE(2211), 1,
      sym_with_item,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29886] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1748), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    STATE(2541), 1,
      sym_expression_list,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [29991] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1121), 1,
      anon_sym_COLON,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1788), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30096] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1113), 1,
      anon_sym_COLON,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1788), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30201] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1733), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    STATE(2477), 1,
      sym_expression_list,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30306] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    ACTIONS(1301), 1,
      anon_sym_COLON,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1820), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30411] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    ACTIONS(1305), 1,
      anon_sym_await,
    ACTIONS(1307), 1,
      anon_sym_type,
    ACTIONS(1309), 1,
      sym_python_identifier,
    STATE(875), 1,
      sym_python_string,
    STATE(1099), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1237), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1303), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30515] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1768), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30617] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1571), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30719] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1929), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30821] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [30923] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1533), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31025] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1866), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31127] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1566), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31229] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1875), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31331] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1576), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31433] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1922), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31535] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1857), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31637] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1942), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31739] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1941), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31841] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1887), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [31943] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1888), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32045] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1924), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32147] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1898), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32249] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1912), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32351] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1755), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32453] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1921), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32555] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1715), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32657] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1562), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32759] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1736), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32861] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1925), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [32963] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1911), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33065] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33167] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1782), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33269] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1723), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33371] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1722), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33473] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1718), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33575] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1716), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33677] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1537), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33779] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1851), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33881] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1763), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [33983] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34085] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1883), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34187] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1550), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34289] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1901), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34391] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1678), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34493] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1886), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34595] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1632), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34697] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1633), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34799] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1637), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [34901] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1713), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35003] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1629), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35105] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1617), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35207] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1638), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35309] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1751), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35411] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1859), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35513] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1640), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35615] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1619), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1708), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1642), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [35921] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36023] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36125] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1689), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36227] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1856), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36329] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1788), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36431] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1643), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36533] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36635] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1321), 1,
      anon_sym_await,
    ACTIONS(1323), 1,
      anon_sym_type,
    ACTIONS(1325), 1,
      sym_python_identifier,
    STATE(1012), 1,
      sym_python_string,
    STATE(1109), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1824), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1171), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1319), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36739] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1636), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36841] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1709), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [36943] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1645), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37045] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1649), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37147] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1903), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37249] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1617), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37351] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(286), 1,
      anon_sym_EQ,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(324), 1,
      anon_sym_COLON,
    ACTIONS(1327), 1,
      sym_python_identifier,
    ACTIONS(1329), 1,
      sym_string_start,
    STATE(2037), 1,
      sym_python_string,
    ACTIONS(298), 10,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [37427] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1905), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37529] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1707), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37631] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1790), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37733] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1907), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37835] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    ACTIONS(1333), 1,
      anon_sym_await,
    ACTIONS(1335), 1,
      anon_sym_type,
    ACTIONS(1337), 1,
      sym_python_identifier,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1386), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1331), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [37939] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1819), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38041] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1848), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38143] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1622), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38245] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38347] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1910), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38449] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1604), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38551] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1811), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38653] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38755] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(300), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(298), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38847] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(1341), 1,
      anon_sym_await,
    ACTIONS(1343), 1,
      anon_sym_type,
    ACTIONS(1345), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1148), 1,
      sym_primary_expression,
    STATE(1780), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1142), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1339), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [38951] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39053] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1814), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39155] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1793), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39257] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1648), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39359] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_STAR,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_primary_expression,
    ACTIONS(471), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    ACTIONS(516), 9,
      anon_sym_GT_GT,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39451] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1771), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39553] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1621), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39655] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1655), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39757] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39859] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1313), 1,
      anon_sym_not,
    ACTIONS(1315), 1,
      anon_sym_lambda,
    ACTIONS(1317), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1864), 1,
      sym_expression,
    STATE(2327), 1,
      sym__named_expression_lhs,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [39961] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1625), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40063] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1735), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40165] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1651), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40267] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1623), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40369] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1837), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40471] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1654), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40573] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1711), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40675] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1349), 1,
      anon_sym_await,
    ACTIONS(1351), 1,
      anon_sym_type,
    ACTIONS(1353), 1,
      sym_python_identifier,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1824), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1392), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1347), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40779] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1583), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40881] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1681), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [40983] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(595), 1,
      sym_identifier,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(725), 1,
      anon_sym_not,
    ACTIONS(729), 1,
      anon_sym_lambda,
    ACTIONS(733), 1,
      anon_sym_await,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      sym_python_identifier,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(841), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    STATE(1683), 1,
      sym_expression,
    STATE(2334), 1,
      sym__named_expression_lhs,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(723), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1620), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41085] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1781), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41187] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41289] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1595), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41391] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41493] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1644), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41595] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1657), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41697] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1674), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41799] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [41901] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1677), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42003] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1686), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42105] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1533), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42207] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1658), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42309] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1672), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42411] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1659), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42513] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1662), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42615] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(643), 1,
      sym_identifier,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(675), 1,
      anon_sym_not,
    ACTIONS(677), 1,
      anon_sym_lambda,
    ACTIONS(977), 1,
      anon_sym_await,
    ACTIONS(979), 1,
      anon_sym_type,
    ACTIONS(981), 1,
      sym_python_identifier,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(850), 1,
      sym_primary_expression,
    STATE(882), 1,
      sym_python_string,
    STATE(1271), 1,
      sym_list_splat_pattern,
    STATE(1720), 1,
      sym_expression,
    STATE(2386), 1,
      sym__named_expression_lhs,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(975), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1710), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1179), 1,
      anon_sym_not,
    ACTIONS(1181), 1,
      anon_sym_lambda,
    ACTIONS(1183), 1,
      anon_sym_await,
    STATE(834), 1,
      sym_python_string,
    STATE(845), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1537), 1,
      sym_expression,
    STATE(2450), 1,
      sym__named_expression_lhs,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [42921] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(1327), 1,
      sym_python_identifier,
    ACTIONS(1329), 1,
      sym_string_start,
    STATE(2037), 1,
      sym_python_string,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(298), 10,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [42995] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(913), 1,
      anon_sym_not,
    ACTIONS(915), 1,
      anon_sym_lambda,
    ACTIONS(917), 1,
      anon_sym_await,
    ACTIONS(919), 1,
      anon_sym_type,
    ACTIONS(1139), 1,
      sym_python_identifier,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1604), 1,
      sym_expression,
    STATE(2427), 1,
      sym__named_expression_lhs,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(911), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1592), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43097] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1792), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43199] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(859), 1,
      anon_sym_await,
    ACTIONS(861), 1,
      anon_sym_type,
    ACTIONS(863), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(857), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43301] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(539), 1,
      sym_identifier,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(697), 1,
      anon_sym_not,
    ACTIONS(699), 1,
      anon_sym_lambda,
    ACTIONS(961), 1,
      anon_sym_await,
    ACTIONS(963), 1,
      anon_sym_type,
    ACTIONS(965), 1,
      sym_python_identifier,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(852), 1,
      sym_primary_expression,
    STATE(853), 1,
      sym_python_string,
    STATE(1210), 1,
      sym_list_splat_pattern,
    STATE(1762), 1,
      sym_expression,
    STATE(2326), 1,
      sym__named_expression_lhs,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(959), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1671), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43403] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1823), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43505] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1585), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43607] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1606), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43709] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1664), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43811] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1611), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [43913] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(510), 1,
      sym_identifier,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(827), 1,
      anon_sym_not,
    ACTIONS(829), 1,
      anon_sym_lambda,
    ACTIONS(1357), 1,
      anon_sym_await,
    ACTIONS(1359), 1,
      anon_sym_type,
    ACTIONS(1361), 1,
      sym_python_identifier,
    STATE(842), 1,
      sym_python_string,
    STATE(843), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2348), 1,
      sym__named_expression_lhs,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1387), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1355), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1630), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1106), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44017] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1607), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44119] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1581), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44221] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1761), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44323] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(571), 1,
      sym_identifier,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(897), 1,
      anon_sym_not,
    ACTIONS(901), 1,
      anon_sym_lambda,
    ACTIONS(903), 1,
      anon_sym_await,
    ACTIONS(905), 1,
      anon_sym_type,
    ACTIONS(1111), 1,
      sym_python_identifier,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(848), 1,
      sym_primary_expression,
    STATE(875), 1,
      sym_python_string,
    STATE(1240), 1,
      sym_list_splat_pattern,
    STATE(1616), 1,
      sym_expression,
    STATE(2448), 1,
      sym__named_expression_lhs,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(895), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1582), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44425] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(619), 1,
      sym_identifier,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(841), 1,
      anon_sym_not,
    ACTIONS(845), 1,
      anon_sym_lambda,
    ACTIONS(847), 1,
      anon_sym_await,
    ACTIONS(849), 1,
      anon_sym_type,
    ACTIONS(1131), 1,
      sym_python_identifier,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1012), 1,
      sym_python_string,
    STATE(1382), 1,
      sym_list_splat_pattern,
    STATE(1815), 1,
      sym_expression,
    STATE(2532), 1,
      sym__named_expression_lhs,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(839), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1635), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44527] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(87), 1,
      anon_sym_not,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(93), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(109), 1,
      sym_identifier,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(318), 1,
      anon_sym_await,
    ACTIONS(320), 1,
      anon_sym_type,
    ACTIONS(322), 1,
      sym_python_identifier,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(836), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1791), 1,
      sym_expression,
    STATE(2377), 1,
      sym__named_expression_lhs,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(308), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1527), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_as_pattern,
      sym_conditional_expression,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [44629] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(1363), 1,
      anon_sym_for,
    ACTIONS(1365), 1,
      anon_sym_with,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44700] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_EQ,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1373), 1,
      anon_sym_LBRACK,
    ACTIONS(1375), 1,
      anon_sym_COLON,
    ACTIONS(1380), 1,
      anon_sym_COMMA,
    STATE(1935), 1,
      sym_type_parameter,
    ACTIONS(1371), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1383), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 16,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44772] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_else,
    ACTIONS(1391), 1,
      anon_sym_except,
    ACTIONS(1393), 1,
      anon_sym_finally,
    STATE(626), 1,
      sym_else_clause,
    STATE(652), 1,
      sym_finally_clause,
    STATE(568), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1385), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1387), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [44842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_else,
    ACTIONS(1393), 1,
      anon_sym_finally,
    ACTIONS(1395), 1,
      anon_sym_except_STAR,
    STATE(626), 1,
      sym_else_clause,
    STATE(652), 1,
      sym_finally_clause,
    STATE(553), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1385), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1387), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [44912] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_else,
    ACTIONS(1391), 1,
      anon_sym_except,
    ACTIONS(1393), 1,
      anon_sym_finally,
    STATE(609), 1,
      sym_else_clause,
    STATE(661), 1,
      sym_finally_clause,
    STATE(568), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1397), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1399), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [44982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 1,
      anon_sym_else,
    ACTIONS(1393), 1,
      anon_sym_finally,
    ACTIONS(1395), 1,
      anon_sym_except_STAR,
    STATE(609), 1,
      sym_else_clause,
    STATE(661), 1,
      sym_finally_clause,
    STATE(553), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1397), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1399), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1380), 1,
      anon_sym_COMMA,
    ACTIONS(1367), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1371), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1383), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(286), 1,
      anon_sym_EQ,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(324), 1,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45184] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(286), 1,
      anon_sym_EQ,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(324), 1,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45251] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45316] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(286), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(290), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(300), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45437] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1405), 1,
      anon_sym_LBRACK,
    ACTIONS(1407), 1,
      anon_sym_LPAREN,
    ACTIONS(1409), 1,
      anon_sym_STAR,
    ACTIONS(1413), 1,
      anon_sym_await,
    ACTIONS(1415), 1,
      anon_sym_type,
    ACTIONS(1417), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1411), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_primary_expression,
    STATE(1890), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1408), 2,
      sym_attribute,
      sym_subscript,
    STATE(1877), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(801), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1411), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [45533] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 1,
      anon_sym_elif,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(574), 1,
      aux_sym_if_statement_repeat1,
    STATE(606), 1,
      sym_elif_clause,
    STATE(660), 1,
      sym_else_clause,
    ACTIONS(1419), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1421), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_EQ,
    ACTIONS(1380), 1,
      anon_sym_COMMA,
    ACTIONS(1371), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1383), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_EQ,
    ACTIONS(1433), 1,
      anon_sym_COMMA,
    ACTIONS(1371), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1436), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1442), 1,
      anon_sym_except_STAR,
    STATE(553), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1438), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1440), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [45839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_EQ,
    ACTIONS(1380), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1371), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1383), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_EQ,
    ACTIONS(1451), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1447), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1454), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1463), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 29,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 1,
      anon_sym_elif,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(574), 1,
      aux_sym_if_statement_repeat1,
    STATE(606), 1,
      sym_elif_clause,
    STATE(646), 1,
      sym_else_clause,
    ACTIONS(1466), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1468), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 1,
      anon_sym_elif,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(549), 1,
      aux_sym_if_statement_repeat1,
    STATE(606), 1,
      sym_elif_clause,
    STATE(666), 1,
      sym_else_clause,
    ACTIONS(1470), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1472), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_PIPE,
    ACTIONS(1460), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(1478), 2,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(1456), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 12,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 28,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 1,
      anon_sym_elif,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(557), 1,
      aux_sym_if_statement_repeat1,
    STATE(606), 1,
      sym_elif_clause,
    STATE(675), 1,
      sym_else_clause,
    ACTIONS(1486), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1488), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 16,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 32,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_EQ,
    ACTIONS(1451), 1,
      anon_sym_COMMA,
    ACTIONS(1447), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1454), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 1,
      anon_sym_EQ,
    ACTIONS(1500), 1,
      anon_sym_COMMA,
    ACTIONS(1496), 14,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1503), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_except,
    STATE(568), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1505), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1507), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [46749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 29,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 29,
      sym__newline,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_EQ,
    ACTIONS(1433), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1371), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1436), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46931] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1405), 1,
      anon_sym_LBRACK,
    ACTIONS(1407), 1,
      anon_sym_LPAREN,
    ACTIONS(1409), 1,
      anon_sym_STAR,
    ACTIONS(1413), 1,
      anon_sym_await,
    ACTIONS(1415), 1,
      anon_sym_type,
    ACTIONS(1417), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1411), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_primary_expression,
    STATE(1890), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1408), 2,
      sym_attribute,
      sym_subscript,
    STATE(1877), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(817), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1411), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [47027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 1,
      anon_sym_EQ,
    ACTIONS(1500), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1496), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1503), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 17,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [47089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 1,
      anon_sym_elif,
    STATE(574), 1,
      aux_sym_if_statement_repeat1,
    STATE(606), 1,
      sym_elif_clause,
    ACTIONS(1512), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1514), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1521), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47312] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1531), 1,
      anon_sym_LBRACK,
    ACTIONS(1533), 1,
      anon_sym_LPAREN,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
    ACTIONS(1537), 1,
      anon_sym_STAR,
    ACTIONS(1541), 1,
      anon_sym_await,
    ACTIONS(1543), 1,
      anon_sym_type,
    ACTIONS(1545), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1438), 1,
      sym_primary_expression,
    STATE(1463), 1,
      sym_list_splat_pattern,
    STATE(2147), 1,
      sym_pattern,
    STATE(2355), 1,
      sym__patterns,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1539), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [47408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1553), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1553), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1557), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1557), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1561), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1563), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1565), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1567), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1569), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [47948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1573), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1575), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1577), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1581), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1585), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1589), 37,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48272] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1531), 1,
      anon_sym_LBRACK,
    ACTIONS(1533), 1,
      anon_sym_LPAREN,
    ACTIONS(1537), 1,
      anon_sym_STAR,
    ACTIONS(1541), 1,
      anon_sym_await,
    ACTIONS(1543), 1,
      anon_sym_type,
    ACTIONS(1545), 1,
      sym_python_identifier,
    ACTIONS(1591), 1,
      anon_sym_RPAREN,
    STATE(880), 1,
      sym_python_string,
    STATE(1438), 1,
      sym_primary_expression,
    STATE(1463), 1,
      sym_list_splat_pattern,
    STATE(2147), 1,
      sym_pattern,
    STATE(2548), 1,
      sym__patterns,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1539), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [48368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 10,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1595), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48422] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1597), 1,
      anon_sym_LBRACK,
    ACTIONS(1599), 1,
      anon_sym_RBRACK,
    ACTIONS(1601), 1,
      anon_sym_LPAREN,
    ACTIONS(1603), 1,
      anon_sym_STAR,
    ACTIONS(1607), 1,
      anon_sym_await,
    ACTIONS(1609), 1,
      anon_sym_type,
    ACTIONS(1611), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1443), 1,
      sym_list_splat_pattern,
    STATE(1474), 1,
      sym_primary_expression,
    STATE(2294), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1442), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1605), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [48515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1615), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1557), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48621] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2030), 1,
      sym_pattern,
    STATE(2484), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [48714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(667), 1,
      sym_else_clause,
    ACTIONS(1631), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1633), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(677), 1,
      sym_else_clause,
    ACTIONS(1635), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1637), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [48828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2029), 1,
      sym_pattern,
    STATE(2487), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [48921] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2134), 1,
      sym_pattern,
    STATE(2343), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1639), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1641), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1645), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49120] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1597), 1,
      anon_sym_LBRACK,
    ACTIONS(1601), 1,
      anon_sym_LPAREN,
    ACTIONS(1603), 1,
      anon_sym_STAR,
    ACTIONS(1607), 1,
      anon_sym_await,
    ACTIONS(1609), 1,
      anon_sym_type,
    ACTIONS(1611), 1,
      sym_python_identifier,
    ACTIONS(1647), 1,
      anon_sym_RBRACK,
    STATE(880), 1,
      sym_python_string,
    STATE(1443), 1,
      sym_list_splat_pattern,
    STATE(1474), 1,
      sym_primary_expression,
    STATE(2294), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1442), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1605), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1553), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 1,
      anon_sym_finally,
    STATE(653), 1,
      sym_finally_clause,
    ACTIONS(1649), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1651), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(679), 1,
      sym_else_clause,
    ACTIONS(1653), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1655), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49380] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    ACTIONS(1657), 1,
      anon_sym_in,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49473] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2018), 1,
      sym_pattern,
    STATE(2506), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(659), 1,
      sym_else_clause,
    ACTIONS(1659), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1661), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(665), 1,
      sym_else_clause,
    ACTIONS(1663), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1665), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49680] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2042), 1,
      sym_pattern,
    STATE(2459), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 1,
      anon_sym_else,
    STATE(662), 1,
      sym_else_clause,
    ACTIONS(1667), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1669), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [49883] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2017), 1,
      sym_pattern,
    STATE(2509), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [49976] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1531), 1,
      anon_sym_LBRACK,
    ACTIONS(1533), 1,
      anon_sym_LPAREN,
    ACTIONS(1537), 1,
      anon_sym_STAR,
    ACTIONS(1541), 1,
      anon_sym_await,
    ACTIONS(1543), 1,
      anon_sym_type,
    ACTIONS(1545), 1,
      sym_python_identifier,
    ACTIONS(1599), 1,
      anon_sym_RPAREN,
    STATE(880), 1,
      sym_python_string,
    STATE(1438), 1,
      sym_primary_expression,
    STATE(1463), 1,
      sym_list_splat_pattern,
    STATE(2245), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1539), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50069] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    ACTIONS(1671), 1,
      anon_sym_in,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50215] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2197), 1,
      sym_pattern,
    STATE(2547), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50308] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1531), 1,
      anon_sym_LBRACK,
    ACTIONS(1533), 1,
      anon_sym_LPAREN,
    ACTIONS(1537), 1,
      anon_sym_STAR,
    ACTIONS(1541), 1,
      anon_sym_await,
    ACTIONS(1543), 1,
      anon_sym_type,
    ACTIONS(1545), 1,
      sym_python_identifier,
    ACTIONS(1647), 1,
      anon_sym_RPAREN,
    STATE(880), 1,
      sym_python_string,
    STATE(1438), 1,
      sym_primary_expression,
    STATE(1463), 1,
      sym_list_splat_pattern,
    STATE(2245), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1539), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50401] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(2164), 1,
      sym_pattern,
    STATE(2392), 1,
      sym_pattern_list,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 36,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1393), 1,
      anon_sym_finally,
    STATE(648), 1,
      sym_finally_clause,
    ACTIONS(1673), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1675), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1679), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50656] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1405), 1,
      anon_sym_LBRACK,
    ACTIONS(1407), 1,
      anon_sym_LPAREN,
    ACTIONS(1409), 1,
      anon_sym_STAR,
    ACTIONS(1413), 1,
      anon_sym_await,
    ACTIONS(1415), 1,
      anon_sym_type,
    ACTIONS(1417), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1411), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_primary_expression,
    STATE(1890), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1408), 2,
      sym_attribute,
      sym_subscript,
    STATE(1877), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1411), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50746] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1617), 1,
      anon_sym_LBRACK,
    ACTIONS(1619), 1,
      anon_sym_LPAREN,
    ACTIONS(1621), 1,
      anon_sym_STAR,
    ACTIONS(1625), 1,
      anon_sym_await,
    ACTIONS(1627), 1,
      anon_sym_type,
    ACTIONS(1629), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1435), 1,
      sym_primary_expression,
    STATE(1446), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1447), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1623), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1557), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [50888] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(803), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_LPAREN,
    ACTIONS(811), 1,
      anon_sym_await,
    ACTIONS(813), 1,
      anon_sym_type,
    ACTIONS(815), 1,
      sym_python_identifier,
    ACTIONS(1681), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1194), 1,
      sym_list_splat_pattern,
    STATE(1448), 1,
      sym_primary_expression,
    STATE(1456), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1195), 2,
      sym_attribute,
      sym_subscript,
    STATE(1478), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(809), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [50978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1553), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1553), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51186] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1597), 1,
      anon_sym_LBRACK,
    ACTIONS(1601), 1,
      anon_sym_LPAREN,
    ACTIONS(1603), 1,
      anon_sym_STAR,
    ACTIONS(1607), 1,
      anon_sym_await,
    ACTIONS(1609), 1,
      anon_sym_type,
    ACTIONS(1611), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1443), 1,
      sym_list_splat_pattern,
    STATE(1474), 1,
      sym_primary_expression,
    STATE(2294), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1442), 2,
      sym_attribute,
      sym_subscript,
    STATE(2228), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1605), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1557), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51484] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(923), 1,
      anon_sym_LBRACK,
    ACTIONS(925), 1,
      anon_sym_LPAREN,
    ACTIONS(931), 1,
      anon_sym_await,
    ACTIONS(933), 1,
      anon_sym_type,
    ACTIONS(935), 1,
      sym_python_identifier,
    ACTIONS(1683), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1396), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_primary_expression,
    STATE(1500), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1401), 2,
      sym_attribute,
      sym_subscript,
    STATE(1496), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(929), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1685), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1687), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51626] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1531), 1,
      anon_sym_LBRACK,
    ACTIONS(1533), 1,
      anon_sym_LPAREN,
    ACTIONS(1537), 1,
      anon_sym_STAR,
    ACTIONS(1541), 1,
      anon_sym_await,
    ACTIONS(1543), 1,
      anon_sym_type,
    ACTIONS(1545), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1438), 1,
      sym_primary_expression,
    STATE(1463), 1,
      sym_list_splat_pattern,
    STATE(2245), 1,
      sym_pattern,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    STATE(2322), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(1539), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [51716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 35,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1553), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1691), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1549), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1695), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [51972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1385), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1387), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52023] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1703), 1,
      anon_sym_await,
    ACTIONS(1705), 1,
      anon_sym_type,
    ACTIONS(1707), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1438), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1697), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1423), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1701), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [52110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1709), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1711), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1675), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1713), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1715), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1717), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1719), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1723), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52365] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1727), 1,
      anon_sym_await,
    ACTIONS(1729), 1,
      anon_sym_type,
    ACTIONS(1731), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1697), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(1467), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1725), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [52452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1735), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1679), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1739), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1743), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1651), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1745), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1747), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1751), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1753), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1755), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1757), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1759), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1763), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [52962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1765), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1767), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1529), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1771), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1773), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1775), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1779), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1557), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1685), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1687), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1525), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1781), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1783), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1397), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1399), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1787), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1791), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1793), 9,
      sym__dedent,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
    ACTIONS(1795), 34,
      anon_sym_def,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_not,
      anon_sym_DASH,
      anon_sym_lambda,
      anon_sym_yield,
      anon_sym_await,
      anon_sym_match,
      anon_sym_type,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
      sym_identifier,
  [53625] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    ACTIONS(1797), 1,
      anon_sym_not,
    STATE(834), 1,
      sym_python_string,
    STATE(866), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [53705] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    ACTIONS(1799), 1,
      anon_sym_not,
    STATE(880), 1,
      sym_python_string,
    STATE(1018), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [53785] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    ACTIONS(1801), 1,
      anon_sym_not,
    STATE(1012), 1,
      sym_python_string,
    STATE(1105), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [53865] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    ACTIONS(1803), 1,
      anon_sym_not,
    STATE(839), 1,
      sym_python_string,
    STATE(892), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [53945] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_not,
    STATE(882), 1,
      sym_python_string,
    STATE(906), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54025] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    ACTIONS(1807), 1,
      anon_sym_not,
    STATE(834), 1,
      sym_python_string,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1003), 1,
      sym_primary_expression,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54105] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(1809), 1,
      anon_sym_not,
    STATE(853), 1,
      sym_python_string,
    STATE(970), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54185] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    ACTIONS(1811), 1,
      anon_sym_not,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1336), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54265] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      anon_sym_not,
    STATE(875), 1,
      sym_python_string,
    STATE(983), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54345] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    ACTIONS(1815), 1,
      anon_sym_not,
    STATE(842), 1,
      sym_python_string,
    STATE(871), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54425] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(978), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54502] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1044), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54579] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1819), 1,
      anon_sym_await,
    ACTIONS(1821), 1,
      anon_sym_type,
    ACTIONS(1823), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1448), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(556), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54662] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1361), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54739] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1381), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54816] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1362), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54893] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1375), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [54970] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1370), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55047] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1359), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55124] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(881), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55201] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1827), 1,
      anon_sym_await,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1831), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1474), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1379), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55284] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1835), 1,
      anon_sym_await,
    ACTIONS(1837), 1,
      anon_sym_type,
    ACTIONS(1839), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1384), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1833), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55367] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1018), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55444] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(956), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55521] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1843), 1,
      anon_sym_await,
    ACTIONS(1845), 1,
      anon_sym_type,
    ACTIONS(1847), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1058), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1841), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55604] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1851), 1,
      anon_sym_await,
    ACTIONS(1853), 1,
      anon_sym_type,
    ACTIONS(1855), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1005), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1849), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55687] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1853), 1,
      anon_sym_type,
    ACTIONS(1855), 1,
      sym_python_identifier,
    ACTIONS(1857), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1005), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1849), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55770] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(972), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55847] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(961), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [55924] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(971), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56001] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(970), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56078] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(967), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56155] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(966), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56232] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1861), 1,
      anon_sym_await,
    ACTIONS(1863), 1,
      anon_sym_type,
    ACTIONS(1865), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1276), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1859), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56315] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(965), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56392] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(964), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56469] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(963), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56546] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1007), 1,
      sym_primary_expression,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56623] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1863), 1,
      anon_sym_type,
    ACTIONS(1865), 1,
      sym_python_identifier,
    ACTIONS(1867), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1276), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1859), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56706] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1047), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56783] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      anon_sym_type,
    ACTIONS(1823), 1,
      sym_python_identifier,
    ACTIONS(1869), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1448), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(556), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56866] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(854), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [56943] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(902), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57020] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(983), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57097] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1863), 1,
      anon_sym_type,
    ACTIONS(1865), 1,
      sym_python_identifier,
    ACTIONS(1871), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1276), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1859), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57180] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1329), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57257] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(953), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57334] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(952), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57411] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1875), 1,
      anon_sym_await,
    ACTIONS(1877), 1,
      anon_sym_type,
    ACTIONS(1879), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1438), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1297), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57494] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1845), 1,
      anon_sym_type,
    ACTIONS(1847), 1,
      sym_python_identifier,
    ACTIONS(1881), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1058), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1841), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57577] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(883), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57654] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(947), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57731] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1885), 1,
      anon_sym_await,
    ACTIONS(1887), 1,
      anon_sym_type,
    ACTIONS(1889), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1465), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1027), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1883), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57814] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(865), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57891] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(857), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [57968] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1097), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58045] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(856), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58122] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1091), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58199] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1893), 1,
      anon_sym_await,
    ACTIONS(1895), 1,
      anon_sym_type,
    ACTIONS(1897), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1438), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1197), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1891), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58282] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(846), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58359] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(891), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58436] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(899), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58513] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(898), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58590] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(897), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58667] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(849), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58744] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      anon_sym_type,
    ACTIONS(1869), 1,
      anon_sym_await,
    ACTIONS(1899), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1448), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(556), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58827] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1434), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58904] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(884), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [58981] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1861), 1,
      anon_sym_await,
    ACTIONS(1863), 1,
      anon_sym_type,
    ACTIONS(1901), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1276), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1859), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59064] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1877), 1,
      anon_sym_type,
    ACTIONS(1879), 1,
      sym_python_identifier,
    ACTIONS(1903), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1297), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59147] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(896), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59224] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(894), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59301] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(892), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59378] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(890), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59455] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(889), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59532] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(888), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59609] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(886), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59686] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(885), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59763] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(995), 1,
      sym_primary_expression,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59840] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1877), 1,
      anon_sym_type,
    ACTIONS(1903), 1,
      anon_sym_await,
    ACTIONS(1905), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1468), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1297), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1873), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [59923] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(996), 1,
      sym_primary_expression,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60000] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(901), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60077] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(900), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60154] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1909), 1,
      anon_sym_await,
    ACTIONS(1911), 1,
      anon_sym_type,
    ACTIONS(1913), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1474), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1245), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1907), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60237] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(994), 1,
      sym_list_splat_pattern,
    STATE(1003), 1,
      sym_primary_expression,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60314] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1915), 1,
      anon_sym_await,
    ACTIONS(1917), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1477), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1379), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60397] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(577), 1,
      anon_sym_LBRACK,
    ACTIONS(579), 1,
      anon_sym_LPAREN,
    ACTIONS(581), 1,
      anon_sym_LBRACE,
    ACTIONS(589), 1,
      anon_sym_DASH,
    ACTIONS(591), 1,
      sym_ellipsis,
    ACTIONS(593), 1,
      anon_sym_await,
    ACTIONS(599), 1,
      sym_string_start,
    ACTIONS(1097), 1,
      anon_sym_STAR,
    STATE(839), 1,
      sym_python_string,
    STATE(876), 1,
      sym_primary_expression,
    STATE(1147), 1,
      sym_list_splat_pattern,
    ACTIONS(587), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(595), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(585), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(597), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1150), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60474] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1017), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60551] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1043), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60628] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1090), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60705] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(943), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60782] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1042), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60859] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1041), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [60936] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(942), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61013] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(903), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61090] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(927), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61167] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(925), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61244] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(917), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61321] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(914), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61398] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(913), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61475] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(874), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61552] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(873), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61629] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(557), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_DASH,
    ACTIONS(567), 1,
      sym_ellipsis,
    ACTIONS(569), 1,
      anon_sym_await,
    ACTIONS(575), 1,
      sym_string_start,
    ACTIONS(1193), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym_python_string,
    STATE(912), 1,
      sym_primary_expression,
    STATE(1240), 1,
      sym_list_splat_pattern,
    ACTIONS(563), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(571), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(561), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(573), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1214), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61706] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61783] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1039), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61860] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1036), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [61937] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(91), 1,
      anon_sym_DASH,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(459), 1,
      anon_sym_await,
    ACTIONS(1189), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(866), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(89), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62014] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1921), 1,
      anon_sym_await,
    ACTIONS(1923), 1,
      anon_sym_type,
    ACTIONS(1925), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1452), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1919), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62097] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1853), 1,
      anon_sym_type,
    ACTIONS(1857), 1,
      anon_sym_await,
    ACTIONS(1927), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1005), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1849), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62180] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(872), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62257] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(851), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62334] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(948), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62411] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(950), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62488] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62565] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(981), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62642] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(982), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62719] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(985), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62796] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_ellipsis,
    ACTIONS(113), 1,
      sym_string_start,
    ACTIONS(451), 1,
      anon_sym_LBRACK,
    ACTIONS(453), 1,
      anon_sym_LPAREN,
    ACTIONS(549), 1,
      anon_sym_DASH,
    ACTIONS(551), 1,
      anon_sym_await,
    ACTIONS(1177), 1,
      anon_sym_STAR,
    STATE(834), 1,
      sym_python_string,
    STATE(992), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_list_splat_pattern,
    ACTIONS(109), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(547), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(457), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(105), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(980), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62873] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1462), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [62950] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1461), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63027] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(871), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63104] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1105), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63181] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1454), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63258] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1453), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63335] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1330), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63412] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1472), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63489] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1449), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63566] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(484), 1,
      anon_sym_await,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1480), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63643] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1327), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63720] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LPAREN,
    ACTIONS(525), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      anon_sym_DASH,
    ACTIONS(535), 1,
      sym_ellipsis,
    ACTIONS(537), 1,
      anon_sym_await,
    ACTIONS(543), 1,
      sym_string_start,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    STATE(853), 1,
      sym_python_string,
    STATE(1002), 1,
      sym_primary_expression,
    STATE(1210), 1,
      sym_list_splat_pattern,
    ACTIONS(531), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(539), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(529), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(541), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1198), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63797] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1829), 1,
      anon_sym_type,
    ACTIONS(1831), 1,
      sym_python_identifier,
    ACTIONS(1915), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1477), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1379), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63880] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(868), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [63957] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1104), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64034] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1084), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64111] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1103), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64188] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1373), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64265] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1085), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64342] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_DASH,
    ACTIONS(655), 1,
      anon_sym_await,
    ACTIONS(1277), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1016), 1,
      sym_primary_expression,
    STATE(1282), 1,
      sym_list_splat_pattern,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(651), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64419] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1863), 1,
      anon_sym_type,
    ACTIONS(1865), 1,
      sym_python_identifier,
    ACTIONS(1929), 1,
      anon_sym_await,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1435), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1276), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1859), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64502] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      anon_sym_LBRACK,
    ACTIONS(494), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(504), 1,
      anon_sym_DASH,
    ACTIONS(506), 1,
      sym_ellipsis,
    ACTIONS(508), 1,
      anon_sym_await,
    ACTIONS(514), 1,
      sym_string_start,
    ACTIONS(823), 1,
      anon_sym_STAR,
    STATE(842), 1,
      sym_python_string,
    STATE(867), 1,
      sym_primary_expression,
    STATE(1093), 1,
      sym_list_splat_pattern,
    ACTIONS(502), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(510), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(500), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(512), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1106), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64579] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(958), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64656] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(905), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64733] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(906), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64810] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(907), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64887] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(908), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [64964] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(909), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65041] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(910), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65118] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(625), 1,
      anon_sym_LBRACK,
    ACTIONS(627), 1,
      anon_sym_LPAREN,
    ACTIONS(629), 1,
      anon_sym_LBRACE,
    ACTIONS(637), 1,
      anon_sym_DASH,
    ACTIONS(639), 1,
      sym_ellipsis,
    ACTIONS(641), 1,
      anon_sym_await,
    ACTIONS(647), 1,
      sym_string_start,
    ACTIONS(1089), 1,
      anon_sym_STAR,
    STATE(882), 1,
      sym_python_string,
    STATE(911), 1,
      sym_primary_expression,
    STATE(1271), 1,
      sym_list_splat_pattern,
    ACTIONS(635), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(643), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(633), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(645), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1299), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65195] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(478), 1,
      anon_sym_DASH,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(486), 1,
      sym_identifier,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(1699), 1,
      anon_sym_STAR,
    ACTIONS(1933), 1,
      anon_sym_await,
    ACTIONS(1935), 1,
      anon_sym_type,
    ACTIONS(1937), 1,
      sym_python_identifier,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1438), 1,
      sym_primary_expression,
    ACTIONS(480), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1428), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(1931), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 5,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
    STATE(1287), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65278] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1086), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65355] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1088), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65432] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(603), 1,
      anon_sym_LPAREN,
    ACTIONS(605), 1,
      anon_sym_LBRACE,
    ACTIONS(613), 1,
      anon_sym_DASH,
    ACTIONS(615), 1,
      sym_ellipsis,
    ACTIONS(617), 1,
      anon_sym_await,
    ACTIONS(623), 1,
      sym_string_start,
    ACTIONS(1157), 1,
      anon_sym_STAR,
    STATE(1012), 1,
      sym_python_string,
    STATE(1089), 1,
      sym_primary_expression,
    STATE(1382), 1,
      sym_list_splat_pattern,
    ACTIONS(611), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(619), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(609), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(621), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1364), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65509] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      anon_sym_LBRACK,
    ACTIONS(467), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_ellipsis,
    ACTIONS(490), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_DASH,
    ACTIONS(663), 1,
      anon_sym_await,
    ACTIONS(1311), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym_python_string,
    STATE(1282), 1,
      sym_list_splat_pattern,
    STATE(1336), 1,
      sym_primary_expression,
    ACTIONS(486), 2,
      anon_sym_type,
      sym_identifier,
    ACTIONS(659), 2,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(476), 4,
      anon_sym_print,
      anon_sym_exec,
      anon_sym_async,
      anon_sym_match,
    ACTIONS(488), 6,
      sym_integer,
      sym_float,
      sym_true,
      sym_false,
      sym_none,
      sym_python_identifier,
    STATE(1287), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_concatenated_string,
      sym_await,
  [65586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      sym_string_start,
    STATE(833), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [65637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(835), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [65688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      sym_string_start,
    STATE(833), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [65739] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_EQ,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1966), 1,
      anon_sym_not,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 1,
      anon_sym_PIPE,
    ACTIONS(1976), 1,
      anon_sym_AMP,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1982), 1,
      anon_sym_is,
    STATE(1402), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1980), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1964), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [65819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      sym_string_start,
    STATE(837), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [65869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 1,
      sym_string_start,
    STATE(837), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [65919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(599), 1,
      sym_string_start,
    STATE(838), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [65969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(514), 1,
      sym_string_start,
    STATE(844), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66019] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_as,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(1999), 1,
      anon_sym_not,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(2009), 1,
      anon_sym_AMP,
    ACTIONS(2011), 1,
      anon_sym_CARET,
    ACTIONS(2015), 1,
      anon_sym_is,
    STATE(1416), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1997), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [66099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(514), 1,
      sym_string_start,
    STATE(840), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66149] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_EQ,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2029), 1,
      anon_sym_not,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2037), 1,
      anon_sym_PIPE,
    ACTIONS(2039), 1,
      anon_sym_AMP,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2045), 1,
      anon_sym_is,
    STATE(1415), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2043), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2027), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [66229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 1,
      sym_string_start,
    STATE(844), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66279] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2056), 1,
      anon_sym_not,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2064), 1,
      anon_sym_PIPE,
    ACTIONS(2066), 1,
      anon_sym_AMP,
    ACTIONS(2068), 1,
      anon_sym_CARET,
    ACTIONS(2072), 1,
      anon_sym_is,
    STATE(1429), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2070), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2054), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [66356] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      sym_string_start,
    STATE(895), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66460] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_EQ,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2090), 1,
      anon_sym_not,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2098), 1,
      anon_sym_PIPE,
    ACTIONS(2100), 1,
      anon_sym_AMP,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2106), 1,
      anon_sym_is,
    STATE(1406), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2104), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2088), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 7,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [66539] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 18,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66604] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_as,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2120), 1,
      anon_sym_not,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2128), 1,
      anon_sym_PIPE,
    ACTIONS(2130), 1,
      anon_sym_AMP,
    ACTIONS(2132), 1,
      anon_sym_CARET,
    ACTIONS(2136), 1,
      anon_sym_is,
    STATE(1432), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2134), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2118), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [66683] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 21,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [66744] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_as,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2150), 1,
      anon_sym_not,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2158), 1,
      anon_sym_PIPE,
    ACTIONS(2160), 1,
      anon_sym_AMP,
    ACTIONS(2162), 1,
      anon_sym_CARET,
    ACTIONS(2166), 1,
      anon_sym_is,
    STATE(1426), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2164), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2148), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [66823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      sym_string_start,
    STATE(864), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66872] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2172), 1,
      sym_string_start,
    STATE(855), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [66976] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 19,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67039] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 18,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 32,
      sym__newline,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67149] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1966), 1,
      anon_sym_not,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 1,
      anon_sym_PIPE,
    ACTIONS(1976), 1,
      anon_sym_AMP,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1982), 1,
      anon_sym_is,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    STATE(1402), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1980), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1964), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 8,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [67226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 32,
      sym__newline,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 30,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 30,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(855), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      sym_string_start,
    STATE(870), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67463] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2039), 1,
      anon_sym_AMP,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 17,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67530] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 1,
      anon_sym_PIPE,
    ACTIONS(1976), 1,
      anon_sym_AMP,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2189), 16,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67654] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 23,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 30,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 1,
      sym_string_start,
    STATE(870), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67809] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2037), 1,
      anon_sym_PIPE,
    ACTIONS(2039), 1,
      anon_sym_AMP,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2189), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67933] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 1,
      anon_sym_PIPE,
    ACTIONS(1976), 1,
      anon_sym_AMP,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2194), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2196), 16,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68002] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 1,
      anon_sym_PIPE,
    ACTIONS(1976), 1,
      anon_sym_AMP,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2198), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 16,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      sym_string_start,
    STATE(893), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68120] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68175] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 1,
      sym_string_start,
    STATE(878), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68279] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(490), 1,
      sym_string_start,
    STATE(863), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68383] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2037), 1,
      anon_sym_PIPE,
    ACTIONS(2039), 1,
      anon_sym_AMP,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2198), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(647), 1,
      sym_string_start,
    STATE(847), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68501] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68556] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 19,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68619] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 19,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68682] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2011), 1,
      anon_sym_CARET,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 18,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68747] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68802] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2009), 1,
      anon_sym_AMP,
    ACTIONS(2011), 1,
      anon_sym_CARET,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 17,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68924] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 23,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68983] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 21,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69044] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(2009), 1,
      anon_sym_AMP,
    ACTIONS(2011), 1,
      anon_sym_CARET,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2189), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      sym_string_start,
    STATE(878), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69162] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 21,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 1,
      sym_string_start,
    STATE(895), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69272] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69327] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1976), 1,
      anon_sym_AMP,
    ACTIONS(1978), 1,
      anon_sym_CARET,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1962), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1968), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69394] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69449] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(1972), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1970), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 23,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69508] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(2009), 1,
      anon_sym_AMP,
    ACTIONS(2011), 1,
      anon_sym_CARET,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2198), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69577] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2007), 1,
      anon_sym_PIPE,
    ACTIONS(2009), 1,
      anon_sym_AMP,
    ACTIONS(2011), 1,
      anon_sym_CARET,
    ACTIONS(1993), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1995), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2001), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1140), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2003), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2194), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2196), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69646] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2037), 1,
      anon_sym_PIPE,
    ACTIONS(2039), 1,
      anon_sym_AMP,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2194), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2196), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69715] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 18,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69821] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 20,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69881] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2128), 1,
      anon_sym_PIPE,
    ACTIONS(2130), 1,
      anon_sym_AMP,
    ACTIONS(2132), 1,
      anon_sym_CARET,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2189), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69949] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 22,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70061] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2130), 1,
      anon_sym_AMP,
    ACTIONS(2132), 1,
      anon_sym_CARET,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 16,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70127] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2132), 1,
      anon_sym_CARET,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 17,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70191] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 18,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70307] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 20,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 22,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2216), 1,
      anon_sym_LBRACK,
    STATE(1779), 1,
      sym_type_parameter,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70519] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70885] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2100), 1,
      anon_sym_AMP,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 16,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70995] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 17,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1380), 1,
      anon_sym_COMMA,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71247] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71707] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2128), 1,
      anon_sym_PIPE,
    ACTIONS(2130), 1,
      anon_sym_AMP,
    ACTIONS(2132), 1,
      anon_sym_CARET,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2194), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2196), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71775] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2128), 1,
      anon_sym_PIPE,
    ACTIONS(2130), 1,
      anon_sym_AMP,
    ACTIONS(2132), 1,
      anon_sym_CARET,
    ACTIONS(2114), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2116), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2122), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2124), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2198), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 25,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72037] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72137] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 21,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72243] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2158), 1,
      anon_sym_PIPE,
    ACTIONS(2160), 1,
      anon_sym_AMP,
    ACTIONS(2162), 1,
      anon_sym_CARET,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2198), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72311] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2158), 1,
      anon_sym_PIPE,
    ACTIONS(2160), 1,
      anon_sym_AMP,
    ACTIONS(2162), 1,
      anon_sym_CARET,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2194), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2196), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2242), 1,
      anon_sym_EQ,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72471] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2098), 1,
      anon_sym_PIPE,
    ACTIONS(2100), 1,
      anon_sym_AMP,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2198), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72585] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    STATE(1765), 1,
      sym_type_parameter,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72733] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2098), 1,
      anon_sym_PIPE,
    ACTIONS(2100), 1,
      anon_sym_AMP,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2194), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2196), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72845] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72907] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2162), 1,
      anon_sym_CARET,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72971] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2160), 1,
      anon_sym_AMP,
    ACTIONS(2162), 1,
      anon_sym_CARET,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73037] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73091] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73193] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 23,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73251] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2158), 1,
      anon_sym_PIPE,
    ACTIONS(2160), 1,
      anon_sym_AMP,
    ACTIONS(2162), 1,
      anon_sym_CARET,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2146), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2189), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2144), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2152), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2154), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      sym_string_start,
    STATE(975), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1939), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1941), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1456), 1,
      anon_sym_COLON,
    ACTIONS(1458), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1463), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(461), 1,
      anon_sym_COLON,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(461), 1,
      anon_sym_COLON,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73817] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73871] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2066), 1,
      anon_sym_AMP,
    ACTIONS(2068), 1,
      anon_sym_CARET,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73937] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2098), 1,
      anon_sym_PIPE,
    ACTIONS(2100), 1,
      anon_sym_AMP,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2189), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74049] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2068), 1,
      anon_sym_CARET,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 1,
      sym_string_start,
    STATE(975), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1946), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1948), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74381] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 19,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74531] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2064), 1,
      anon_sym_PIPE,
    ACTIONS(2066), 1,
      anon_sym_AMP,
    ACTIONS(2068), 1,
      anon_sym_CARET,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2198), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2200), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74599] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2064), 1,
      anon_sym_PIPE,
    ACTIONS(2066), 1,
      anon_sym_AMP,
    ACTIONS(2068), 1,
      anon_sym_CARET,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2194), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2196), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74799] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74897] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2156), 1,
      anon_sym_STAR_STAR,
    STATE(1248), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74951] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2064), 1,
      anon_sym_PIPE,
    ACTIONS(2066), 1,
      anon_sym_AMP,
    ACTIONS(2068), 1,
      anon_sym_CARET,
    ACTIONS(2050), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2052), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2058), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2187), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2060), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2189), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2110), 1,
      anon_sym_LPAREN,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2126), 1,
      anon_sym_STAR_STAR,
    STATE(1165), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 25,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75175] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_LPAREN,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2062), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 31,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 31,
      sym__newline,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75317] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_EQ,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2313), 1,
      anon_sym_not,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2321), 1,
      anon_sym_PIPE,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    ACTIONS(2325), 1,
      anon_sym_CARET,
    ACTIONS(2329), 1,
      anon_sym_is,
    STATE(1419), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2327), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1954), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2311), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [75395] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2343), 1,
      anon_sym_not,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2359), 1,
      anon_sym_is,
    STATE(1414), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2357), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2341), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1954), 7,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [75471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(623), 1,
      sym_string_start,
    STATE(988), 2,
      sym_python_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1383), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75654] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2321), 1,
      anon_sym_PIPE,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    ACTIONS(2325), 1,
      anon_sym_CARET,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2198), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2200), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75721] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2321), 1,
      anon_sym_PIPE,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    ACTIONS(2325), 1,
      anon_sym_CARET,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2194), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2196), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75788] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2321), 1,
      anon_sym_PIPE,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    ACTIONS(2325), 1,
      anon_sym_CARET,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2187), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2189), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 1,
      anon_sym_COMMA,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 1,
      anon_sym_COMMA,
    ACTIONS(1436), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1458), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1463), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76608] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76759] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      anon_sym_CARET,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76822] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    ACTIONS(2325), 1,
      anon_sym_CARET,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2309), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76887] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76940] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76997] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2315), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2317), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77056] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 24,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 1,
      anon_sym_COMMA,
    ACTIONS(1503), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      anon_sym_COMMA,
    ACTIONS(1454), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1373), 1,
      anon_sym_LBRACK,
    STATE(1935), 1,
      sym_type_parameter,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 26,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1380), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78860] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 18,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78921] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 17,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78984] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 16,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79092] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79145] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 22,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 20,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79261] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(463), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(471), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79490] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79543] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 25,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79596] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1458), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1463), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79643] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 1,
      anon_sym_LPAREN,
    ACTIONS(2090), 1,
      anon_sym_not,
    ACTIONS(2096), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2098), 1,
      anon_sym_PIPE,
    ACTIONS(2100), 1,
      anon_sym_AMP,
    ACTIONS(2102), 1,
      anon_sym_CARET,
    ACTIONS(2106), 1,
      anon_sym_is,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    STATE(1406), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2084), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2086), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2092), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2104), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1280), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2094), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1954), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2088), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [79718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79851] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2198), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2200), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79918] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2194), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2196), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79985] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2187), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2189), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80181] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2333), 1,
      anon_sym_LPAREN,
    ACTIONS(2343), 1,
      anon_sym_not,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_AMP,
    ACTIONS(2355), 1,
      anon_sym_CARET,
    ACTIONS(2359), 1,
      anon_sym_is,
    STATE(1414), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2337), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2339), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2357), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1350), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2347), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1954), 6,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2341), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [80256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    STATE(1862), 1,
      sym_type_parameter,
    ACTIONS(1383), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1380), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(302), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 3,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1463), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81910] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2019), 1,
      anon_sym_LPAREN,
    ACTIONS(2029), 1,
      anon_sym_not,
    ACTIONS(2035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2037), 1,
      anon_sym_PIPE,
    ACTIONS(2039), 1,
      anon_sym_AMP,
    ACTIONS(2041), 1,
      anon_sym_CARET,
    ACTIONS(2045), 1,
      anon_sym_is,
    STATE(1415), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2023), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2043), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1015), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2033), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1954), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2027), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [81985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82456] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_EQ,
    ACTIONS(1456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1478), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(1458), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1460), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [82506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(300), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [82592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(300), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [82636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2185), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1463), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2177), 30,
      sym_string_start,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83368] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_unset,
    ACTIONS(9), 1,
      anon_sym_inherit,
    ACTIONS(11), 1,
      anon_sym_include,
    ACTIONS(13), 1,
      anon_sym_require,
    ACTIONS(15), 1,
      anon_sym_export,
    ACTIONS(17), 1,
      anon_sym_OVERRIDES,
    ACTIONS(19), 1,
      anon_sym_EXPORT_FUNCTIONS,
    ACTIONS(21), 1,
      anon_sym_addtask,
    ACTIONS(23), 1,
      anon_sym_deltask,
    ACTIONS(25), 1,
      anon_sym_addhandler,
    ACTIONS(27), 1,
      anon_sym_fakeroot,
    ACTIONS(29), 1,
      anon_sym_python,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(33), 1,
      anon_sym_def,
    ACTIONS(35), 1,
      sym_identifier,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(2363), 1,
      ts_builtin_sym_end,
    STATE(1269), 1,
      aux_sym_recipe_repeat1,
    STATE(1516), 1,
      sym_concatenation,
    STATE(2254), 1,
      sym_variable_expansion,
    STATE(2258), 14,
      sym_variable_assignment,
      sym_unset_statement,
      sym_inherit_directive,
      sym_include_directive,
      sym_require_directive,
      sym_export_statement,
      sym_overrides_statement,
      sym_export_functions_statement,
      sym_addtask_statement,
      sym_deltask_statement,
      sym_addhandler_statement,
      sym_anonymous_python_function,
      sym_function_definition,
      sym_python_function_definition,
  [83448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1496), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [83702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1447), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [83746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1371), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [84000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1371), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [84044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1454), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1463), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85944] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2371), 1,
      anon_sym_not,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_PIPE,
    ACTIONS(2381), 1,
      anon_sym_AMP,
    ACTIONS(2383), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_is,
    STATE(1506), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2385), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1954), 5,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2369), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [86018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 15,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1436), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1436), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87172] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 1,
      ts_builtin_sym_end,
    ACTIONS(2391), 1,
      anon_sym_unset,
    ACTIONS(2394), 1,
      anon_sym_inherit,
    ACTIONS(2397), 1,
      anon_sym_include,
    ACTIONS(2400), 1,
      anon_sym_require,
    ACTIONS(2403), 1,
      anon_sym_export,
    ACTIONS(2406), 1,
      anon_sym_OVERRIDES,
    ACTIONS(2409), 1,
      anon_sym_EXPORT_FUNCTIONS,
    ACTIONS(2412), 1,
      anon_sym_addtask,
    ACTIONS(2415), 1,
      anon_sym_deltask,
    ACTIONS(2418), 1,
      anon_sym_addhandler,
    ACTIONS(2421), 1,
      anon_sym_fakeroot,
    ACTIONS(2424), 1,
      anon_sym_python,
    ACTIONS(2427), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2430), 1,
      anon_sym_def,
    ACTIONS(2433), 1,
      sym_identifier,
    ACTIONS(2436), 1,
      aux_sym__dotted_identifier_token1,
    STATE(1269), 1,
      aux_sym_recipe_repeat1,
    STATE(1516), 1,
      sym_concatenation,
    STATE(2254), 1,
      sym_variable_expansion,
    STATE(2258), 14,
      sym_variable_assignment,
      sym_unset_statement,
      sym_inherit_directive,
      sym_include_directive,
      sym_require_directive,
      sym_export_statement,
      sym_overrides_statement,
      sym_export_functions_statement,
      sym_addtask_statement,
      sym_deltask_statement,
      sym_addhandler_statement,
      sym_anonymous_python_function,
      sym_function_definition,
      sym_python_function_definition,
  [87252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(300), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(519), 1,
      anon_sym_EQ,
    ACTIONS(300), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1383), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2242), 1,
      anon_sym_EQ,
    ACTIONS(1383), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(300), 5,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88282] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(461), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_EQ,
    ACTIONS(1456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1478), 5,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
    ACTIONS(1458), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1460), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [88424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1456), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 15,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1454), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1500), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1463), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89650] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2202), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2204), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89701] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_PIPE,
    ACTIONS(2381), 1,
      anon_sym_AMP,
    ACTIONS(2383), 1,
      anon_sym_CARET,
    ACTIONS(2194), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2196), 13,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2271), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89807] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2168), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2170), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89858] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_PIPE,
    ACTIONS(2381), 1,
      anon_sym_AMP,
    ACTIONS(2383), 1,
      anon_sym_CARET,
    ACTIONS(2198), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2200), 13,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2220), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2275), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90128] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_PIPE,
    ACTIONS(2381), 1,
      anon_sym_AMP,
    ACTIONS(2383), 1,
      anon_sym_CARET,
    ACTIONS(2187), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2189), 13,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1476), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2283), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2287), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2291), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1463), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1492), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2264), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_EQ,
    ACTIONS(1456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1478), 4,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(1458), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1460), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [90863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2258), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2252), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2246), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91113] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 16,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91215] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2383), 1,
      anon_sym_CARET,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 15,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 18,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2214), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1378), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2240), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(288), 1,
      anon_sym_COLON_EQ,
    ACTIONS(471), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(516), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1463), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91624] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2381), 1,
      anon_sym_AMP,
    ACTIONS(2383), 1,
      anon_sym_CARET,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2367), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 14,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1498), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91773] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1449), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2074), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2076), 23,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(298), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1478), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(1458), 12,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1460), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [92004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(471), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(516), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 15,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92135] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2377), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2365), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2375), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 20,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_else,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(300), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1463), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1458), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(298), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(300), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(290), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1403), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1476), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1484), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1484), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1460), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_in,
      anon_sym_if,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(516), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1496), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1492), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1436), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1371), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1492), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1429), 19,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(516), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(463), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1447), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
    ACTIONS(1383), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1371), 16,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1966), 1,
      anon_sym_not,
    ACTIONS(1982), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    STATE(1403), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1980), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1964), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 10,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    ACTIONS(2450), 1,
      anon_sym_not,
    ACTIONS(2456), 1,
      anon_sym_is,
    STATE(1403), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2453), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2447), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 10,
      sym__newline,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    ACTIONS(2462), 1,
      anon_sym_not,
    ACTIONS(2468), 1,
      anon_sym_is,
    STATE(1404), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2465), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2459), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 9,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1496), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1498), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93159] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2090), 1,
      anon_sym_not,
    ACTIONS(2106), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    STATE(1404), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2104), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2088), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 9,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(290), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1371), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(290), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1447), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1449), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1371), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
    ACTIONS(1431), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93353] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    ACTIONS(2474), 1,
      anon_sym_not,
    ACTIONS(2480), 1,
      anon_sym_is,
    STATE(1412), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2477), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [93391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_not,
    ACTIONS(2492), 1,
      anon_sym_is,
    STATE(1413), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2483), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_not,
    ACTIONS(2359), 1,
      anon_sym_is,
    STATE(1413), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2357), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2341), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_not,
    ACTIONS(2045), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    STATE(1412), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2043), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2027), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [93501] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_not,
    ACTIONS(2015), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_as,
    STATE(1417), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2013), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1997), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [93539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_as,
    ACTIONS(2498), 1,
      anon_sym_not,
    ACTIONS(2504), 1,
      anon_sym_is,
    STATE(1417), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2501), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2495), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [93577] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_EQ,
    ACTIONS(2510), 1,
      anon_sym_not,
    ACTIONS(2516), 1,
      anon_sym_is,
    STATE(1418), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2513), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2507), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 8,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_not,
    ACTIONS(2329), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_EQ,
    STATE(1418), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2327), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2311), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [93653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_not,
    ACTIONS(2528), 1,
      anon_sym_is,
    STATE(1420), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2525), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2519), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [93688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1249), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_as,
    ACTIONS(2534), 1,
      anon_sym_not,
    ACTIONS(2540), 1,
      anon_sym_is,
    STATE(1422), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2537), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [93754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1458), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_COMMA,
    STATE(1424), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(2543), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1249), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93841] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      anon_sym_not,
    ACTIONS(2166), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_as,
    STATE(1427), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2164), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2148), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [93878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      anon_sym_as,
    ACTIONS(2551), 1,
      anon_sym_not,
    ACTIONS(2557), 1,
      anon_sym_is,
    STATE(1427), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2554), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2445), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [93915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2560), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93944] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym_not,
    ACTIONS(2072), 1,
      anon_sym_is,
    STATE(1420), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2070), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2054), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [93979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_COMMA,
    STATE(1424), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(801), 17,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94037] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_not,
    ACTIONS(2136), 1,
      anon_sym_is,
    ACTIONS(2439), 1,
      anon_sym_as,
    STATE(1422), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2134), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2118), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2441), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [94074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94103] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2168), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2170), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94139] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [94185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1449), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94241] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_LBRACK,
    ACTIONS(2142), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [94287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1503), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1498), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1449), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1431), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(463), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1431), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94535] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [94581] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2076), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [94625] = 10,
    ACTIONS(2582), 1,
      aux_sym_recipe_token1,
    ACTIONS(2584), 1,
      anon_sym_NULL,
    ACTIONS(2588), 1,
      anon_sym_LBRACK,
    ACTIONS(2590), 1,
      anon_sym_COLON,
    ACTIONS(2592), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__concat,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
    STATE(1665), 3,
      sym_variable_flag,
      sym_override,
      sym_variable_expansion,
    ACTIONS(2586), 8,
      anon_sym_EQ,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [94665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1503), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1498), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2560), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94721] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2076), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94757] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 7,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1447), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1454), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1449), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(1503), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1498), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94955] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2076), 5,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94995] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2076), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1431), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95059] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(2021), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95105] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LBRACK,
    ACTIONS(1991), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1249), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1458), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(1378), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95207] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2082), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95309] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2600), 1,
      anon_sym_LBRACK,
    ACTIONS(2602), 1,
      anon_sym_DOT,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95355] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_PIPE,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1249), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95429] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2108), 1,
      anon_sym_LBRACK,
    ACTIONS(2112), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95475] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_LBRACK,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2202), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2204), 10,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95557] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2335), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2576), 1,
      anon_sym_AMP,
    ACTIONS(2578), 1,
      anon_sym_CARET,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 18,
      sym__newline,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95655] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2566), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2568), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1267), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2076), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(2572), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [95697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(290), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(300), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(298), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [95725] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      anon_sym_COLON,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2419), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [95770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_EQ,
    ACTIONS(2620), 1,
      anon_sym_COLON,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1497), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(2618), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95801] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2624), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2512), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [95846] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2626), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2490), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [95891] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2628), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2451), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [95936] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2630), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2361), 1,
      sym_lambda_parameters,
    STATE(2364), 1,
      sym__parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [95981] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2632), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2357), 1,
      sym_lambda_parameters,
    STATE(2364), 1,
      sym__parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2389), 2,
      ts_builtin_sym_end,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2634), 15,
      anon_sym_unset,
      anon_sym_inherit,
      anon_sym_include,
      anon_sym_require,
      anon_sym_export,
      anon_sym_OVERRIDES,
      anon_sym_EXPORT_FUNCTIONS,
      anon_sym_addtask,
      anon_sym_deltask,
      anon_sym_addhandler,
      anon_sym_fakeroot,
      anon_sym_python,
      anon_sym_def,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [96051] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2636), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2515), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96096] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2638), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2476), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96141] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2640), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2443), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96209] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2642), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2416), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96254] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2644), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2429), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_COMMA,
    STATE(1504), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(801), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96349] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2648), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2335), 1,
      sym_lambda_parameters,
    STATE(2364), 1,
      sym__parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_EQ,
    ACTIONS(2620), 1,
      anon_sym_COLON,
    ACTIONS(2650), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2618), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 17,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_EQ,
    ACTIONS(2620), 1,
      anon_sym_COLON,
    ACTIONS(2652), 1,
      anon_sym_COMMA,
    STATE(1430), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(2618), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96500] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_EQ,
    ACTIONS(2590), 1,
      anon_sym_COLON,
    ACTIONS(2596), 1,
      sym__concat,
    ACTIONS(2656), 1,
      anon_sym_LBRACK,
    ACTIONS(2658), 1,
      anon_sym_LPAREN,
    ACTIONS(2660), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
    STATE(1652), 1,
      sym_override,
    STATE(1665), 2,
      sym_variable_flag,
      sym_variable_expansion,
    ACTIONS(2654), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [96541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2662), 1,
      anon_sym_COMMA,
    STATE(1504), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(2543), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_COLON,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96568] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2665), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2111), 1,
      sym_parameter,
    STATE(2364), 1,
      sym__parameters,
    STATE(2387), 1,
      sym_lambda_parameters,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 1,
      anon_sym_not,
    ACTIONS(2387), 1,
      anon_sym_is,
    STATE(1507), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2385), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2441), 5,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2369), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [96645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_not,
    ACTIONS(2676), 1,
      anon_sym_is,
    STATE(1507), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(2673), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2445), 5,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2667), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [96677] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_LPAREN,
    ACTIONS(2681), 1,
      anon_sym_RPAREN,
    ACTIONS(2683), 1,
      anon_sym_STAR,
    ACTIONS(2685), 1,
      anon_sym_SLASH,
    ACTIONS(2687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2689), 1,
      sym_python_identifier,
    STATE(2121), 1,
      sym_tuple_pattern,
    STATE(2163), 1,
      sym_parameter,
    STATE(2531), 1,
      sym__parameters,
    STATE(2146), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2316), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1524), 1,
      sym_variable_expansion,
    ACTIONS(2691), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2695), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
    ACTIONS(2693), 9,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [96748] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_LPAREN,
    ACTIONS(2683), 1,
      anon_sym_STAR,
    ACTIONS(2685), 1,
      anon_sym_SLASH,
    ACTIONS(2687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2689), 1,
      sym_python_identifier,
    ACTIONS(2697), 1,
      anon_sym_RPAREN,
    STATE(2121), 1,
      sym_tuple_pattern,
    STATE(2277), 1,
      sym_parameter,
    STATE(2146), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2316), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96787] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2699), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2237), 1,
      sym_parameter,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96826] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    ACTIONS(2697), 1,
      anon_sym_COLON,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2237), 1,
      sym_parameter,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__concat,
    ACTIONS(2656), 1,
      anon_sym_LBRACK,
    ACTIONS(2701), 1,
      anon_sym_EQ,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
    STATE(1560), 1,
      aux_sym_override_repeat1,
    STATE(1567), 1,
      sym_variable_flag,
    ACTIONS(2703), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [96900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_EQ,
    ACTIONS(2620), 1,
      anon_sym_COLON,
    ACTIONS(2618), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96925] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_LPAREN,
    ACTIONS(2683), 1,
      anon_sym_STAR,
    ACTIONS(2685), 1,
      anon_sym_SLASH,
    ACTIONS(2687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2689), 1,
      sym_python_identifier,
    ACTIONS(2699), 1,
      anon_sym_RPAREN,
    STATE(2121), 1,
      sym_tuple_pattern,
    STATE(2277), 1,
      sym_parameter,
    STATE(2146), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2316), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [96964] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_EQ,
    ACTIONS(2590), 1,
      anon_sym_COLON,
    ACTIONS(2656), 1,
      anon_sym_LBRACK,
    ACTIONS(2660), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1665), 3,
      sym_variable_flag,
      sym_override,
      sym_variable_expansion,
    ACTIONS(2654), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [96994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 1,
      sym__concat,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2707), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2709), 10,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [97020] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LPAREN,
    ACTIONS(2608), 1,
      anon_sym_STAR,
    ACTIONS(2610), 1,
      anon_sym_SLASH,
    ACTIONS(2612), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2614), 1,
      sym_python_identifier,
    STATE(2110), 1,
      sym_tuple_pattern,
    STATE(2237), 1,
      sym_parameter,
    STATE(2298), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2303), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      sym__concat,
    STATE(1519), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2713), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2715), 10,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [97082] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_LPAREN,
    ACTIONS(2683), 1,
      anon_sym_STAR,
    ACTIONS(2685), 1,
      anon_sym_SLASH,
    ACTIONS(2687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2689), 1,
      sym_python_identifier,
    STATE(2121), 1,
      sym_tuple_pattern,
    STATE(2277), 1,
      sym_parameter,
    STATE(2146), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2316), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [97118] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__concat,
    ACTIONS(2656), 1,
      anon_sym_LBRACK,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
    STATE(1599), 1,
      sym_variable_flag,
    ACTIONS(2720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2722), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [97148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2724), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2726), 11,
      sym__concat,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [97169] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__concat,
    ACTIONS(2701), 1,
      anon_sym_EQ,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
    STATE(1560), 1,
      aux_sym_override_repeat1,
    ACTIONS(2703), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [97198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2713), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2715), 11,
      sym__concat,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [97219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2728), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2730), 11,
      sym__concat,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LBRACE,
  [97240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__concat,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2722), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [97264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 12,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [97282] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2382), 1,
      sym__comprehension_clauses,
  [97322] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2397), 1,
      sym__comprehension_clauses,
  [97362] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2344), 1,
      sym__comprehension_clauses,
  [97402] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2500), 1,
      sym__comprehension_clauses,
  [97442] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2353), 1,
      sym__comprehension_clauses,
  [97482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 12,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [97500] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2371), 1,
      sym__comprehension_clauses,
  [97540] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2423), 1,
      sym__comprehension_clauses,
  [97580] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2400), 1,
      sym__comprehension_clauses,
  [97620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 12,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [97638] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2340), 1,
      sym__comprehension_clauses,
  [97675] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      anon_sym_RPAREN,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2187), 1,
      aux_sym_argument_list_repeat1,
    STATE(2505), 1,
      sym__comprehension_clauses,
  [97712] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2401), 1,
      sym__comprehension_clauses,
  [97749] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2784), 1,
      anon_sym_RPAREN,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2404), 1,
      sym__comprehension_clauses,
  [97786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_COMMA,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    STATE(1970), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2790), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2788), 3,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_PIPE,
  [97817] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2802), 1,
      anon_sym_RPAREN,
    ACTIONS(2804), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2150), 1,
      aux_sym_argument_list_repeat1,
    STATE(2395), 1,
      sym__comprehension_clauses,
  [97854] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2806), 1,
      anon_sym_RPAREN,
    ACTIONS(2808), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2182), 1,
      aux_sym_argument_list_repeat1,
    STATE(2368), 1,
      sym__comprehension_clauses,
  [97891] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2810), 1,
      anon_sym_RPAREN,
    ACTIONS(2812), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2068), 1,
      aux_sym_argument_list_repeat1,
    STATE(2394), 1,
      sym__comprehension_clauses,
  [97928] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2464), 1,
      sym__comprehension_clauses,
  [97965] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2814), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2339), 1,
      sym__comprehension_clauses,
  [98002] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2366), 1,
      sym__comprehension_clauses,
  [98039] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2816), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2468), 1,
      sym__comprehension_clauses,
  [98076] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(2818), 7,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [98101] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2820), 1,
      anon_sym_RPAREN,
    ACTIONS(2822), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2103), 1,
      aux_sym_argument_list_repeat1,
    STATE(2404), 1,
      sym__comprehension_clauses,
  [98138] = 7,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_DQUOTE,
    ACTIONS(2826), 1,
      aux_sym_string_token1,
    ACTIONS(2830), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2832), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1561), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat1,
    ACTIONS(2828), 4,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
  [98165] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2834), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2395), 1,
      sym__comprehension_clauses,
  [98202] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2406), 1,
      sym__comprehension_clauses,
  [98239] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2393), 1,
      sym__comprehension_clauses,
  [98276] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2454), 1,
      sym__comprehension_clauses,
  [98313] = 7,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2830), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2832), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2836), 1,
      anon_sym_DQUOTE,
    ACTIONS(2838), 1,
      aux_sym_string_token1,
    STATE(1552), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat1,
    ACTIONS(2840), 4,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
  [98340] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2842), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2505), 1,
      sym__comprehension_clauses,
  [98377] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2844), 1,
      anon_sym_RPAREN,
    ACTIONS(2846), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2113), 1,
      aux_sym_argument_list_repeat1,
    STATE(2341), 1,
      sym__comprehension_clauses,
  [98414] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    ACTIONS(2848), 1,
      anon_sym_EQ,
    STATE(1563), 1,
      aux_sym_override_repeat1,
    ACTIONS(2850), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98437] = 7,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_DQUOTE,
    ACTIONS(2854), 1,
      aux_sym_string_token1,
    ACTIONS(2860), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2863), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1561), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat1,
    ACTIONS(2857), 4,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
  [98464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(2866), 7,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [98489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_EQ,
    ACTIONS(2868), 1,
      anon_sym_COLON,
    STATE(1563), 1,
      aux_sym_override_repeat1,
    ACTIONS(2722), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98512] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2871), 1,
      anon_sym_RPAREN,
    ACTIONS(2873), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2006), 1,
      aux_sym_argument_list_repeat1,
    STATE(2468), 1,
      sym__comprehension_clauses,
  [98549] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    STATE(1740), 1,
      sym_for_in_clause,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2508), 1,
      sym__comprehension_clauses,
  [98586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2750), 10,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [98605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    ACTIONS(2848), 1,
      anon_sym_EQ,
    STATE(1568), 1,
      aux_sym_override_repeat1,
    ACTIONS(2850), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    ACTIONS(2875), 1,
      anon_sym_EQ,
    STATE(1563), 1,
      aux_sym_override_repeat1,
    ACTIONS(2877), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(2879), 9,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [98672] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2881), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2394), 1,
      sym__comprehension_clauses,
  [98709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(2885), 1,
      anon_sym_as,
    ACTIONS(2883), 8,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [98732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_EQ,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    STATE(1560), 1,
      aux_sym_override_repeat1,
    ACTIONS(2703), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98755] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2842), 1,
      anon_sym_RPAREN,
    ACTIONS(2888), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2505), 1,
      sym__comprehension_clauses,
  [98792] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2341), 1,
      sym__comprehension_clauses,
  [98829] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2893), 1,
      anon_sym_RPAREN,
    ACTIONS(2895), 1,
      anon_sym_COMMA,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2196), 1,
      aux_sym_argument_list_repeat1,
    STATE(2339), 1,
      sym__comprehension_clauses,
  [98866] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(2897), 7,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [98891] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2899), 1,
      anon_sym_RPAREN,
    STATE(1734), 1,
      sym_for_in_clause,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2368), 1,
      sym__comprehension_clauses,
  [98928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2907), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [98954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2911), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [98972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2913), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1600), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [98998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [99014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [99030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(2818), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99054] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2923), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [99096] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2925), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1578), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99122] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2927), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99148] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2929), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2722), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99192] = 7,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_SQUOTE,
    ACTIONS(2936), 1,
      aux_sym_string_token3,
    ACTIONS(2939), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2942), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2931), 3,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      aux_sym_string_token4,
    STATE(1590), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat2,
  [99218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2945), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1612), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [99260] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_COMMA,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    STATE(1801), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2947), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [99288] = 7,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2836), 1,
      anon_sym_SQUOTE,
    ACTIONS(2961), 1,
      aux_sym_string_token3,
    ACTIONS(2963), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2965), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2959), 3,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      aux_sym_string_token4,
    STATE(1608), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat2,
  [99314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(2866), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99338] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2967), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1584), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99364] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2969), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(2788), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [99414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2973), 8,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
      anon_sym_LPAREN,
  [99432] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2975), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(2788), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99482] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_LBRACE,
    ACTIONS(2983), 1,
      sym__not_escape_sequence,
    ACTIONS(2986), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2980), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2988), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1609), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [99550] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2990), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1587), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(2897), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [99600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(2879), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [99620] = 7,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_SQUOTE,
    ACTIONS(2963), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(2965), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2994), 1,
      aux_sym_string_token3,
    ACTIONS(2992), 3,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      aux_sym_string_token4,
    STATE(1590), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_string_repeat2,
  [99646] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2996), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(2998), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1597), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3000), 1,
      anon_sym_as,
    ACTIONS(2883), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [99720] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(3003), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99746] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_COMMA,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    STATE(1801), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3005), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [99774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(3007), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1588), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99800] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(3009), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1618), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2750), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [99844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [99860] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      sym__not_escape_sequence,
    ACTIONS(3011), 1,
      sym_string_end,
    STATE(1738), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2903), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1602), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_python_string_repeat1,
  [99886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_as,
    ACTIONS(2752), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [99903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_as,
    ACTIONS(1954), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [99920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(2879), 7,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [99939] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(2866), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [99962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2750), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      sym_type_conversion,
  [99979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3019), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [100002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [100017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(2897), 5,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [100040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3021), 1,
      anon_sym_as,
    ACTIONS(2883), 6,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(2897), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [100084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [100099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [100114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [100129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2897), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3032), 1,
      anon_sym_as,
    ACTIONS(2883), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [100173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_as,
    ACTIONS(2750), 8,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [100190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [100205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(3035), 1,
      anon_sym_as,
    ACTIONS(2750), 7,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [100224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2879), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_PIPE,
  [100243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(2750), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [100260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(2818), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2866), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_from,
    ACTIONS(3045), 1,
      anon_sym_COMMA,
    ACTIONS(3047), 1,
      anon_sym_as,
    ACTIONS(3049), 1,
      anon_sym_if,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    STATE(1879), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3041), 2,
      sym__newline,
      anon_sym_SEMI,
  [100335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2818), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3055), 1,
      anon_sym_as,
    ACTIONS(2879), 6,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(2818), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [100402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(2866), 5,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [100425] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(2788), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3057), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [100471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3059), 1,
      anon_sym_as,
    ACTIONS(2883), 6,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_PIPE,
  [100492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(2818), 5,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [100515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2788), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 9,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
  [100553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3064), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [100572] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(2897), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(2750), 8,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
      anon_sym_PIPE,
  [100612] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3068), 1,
      anon_sym_as,
    ACTIONS(2883), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      sym_type_conversion,
  [100633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(2879), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      sym_type_conversion,
  [100652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(2866), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [100675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    ACTIONS(2879), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
  [100693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(3055), 1,
      anon_sym_as,
    ACTIONS(2879), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_COMMA,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    STATE(1970), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2790), 2,
      sym__newline,
      anon_sym_SEMI,
  [100739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_as,
    ACTIONS(3049), 1,
      anon_sym_if,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    ACTIONS(2897), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [100781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100801] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(1978), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3073), 2,
      sym__newline,
      anon_sym_SEMI,
  [100827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(3064), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [100843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2728), 1,
      anon_sym_EQ,
    ACTIONS(2730), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [100879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100899] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3079), 1,
      sym_inherit_path,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3077), 2,
      aux_sym_recipe_token1,
      anon_sym_NULL,
    STATE(1688), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_inherit_directive_repeat1,
  [100921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [100941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_as,
    ACTIONS(1954), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [100957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    ACTIONS(3085), 1,
      anon_sym_as,
    ACTIONS(2883), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
  [100977] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2730), 1,
      aux_sym_string_token1,
    ACTIONS(2728), 7,
      anon_sym_DQUOTE,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [100993] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_as,
    ACTIONS(3049), 1,
      anon_sym_if,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    ACTIONS(2818), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [101015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3088), 1,
      anon_sym_RBRACK,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3092), 1,
      anon_sym_COMMA,
    STATE(2053), 1,
      aux_sym_subscript_repeat1,
  [101043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3096), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3094), 2,
      sym__newline,
      anon_sym_SEMI,
  [101069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_as,
    ACTIONS(3049), 1,
      anon_sym_if,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    ACTIONS(2866), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [101091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2866), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101113] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3100), 1,
      anon_sym_COMMA,
    STATE(1969), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3098), 2,
      sym__newline,
      anon_sym_SEMI,
  [101139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2724), 1,
      anon_sym_EQ,
    ACTIONS(2726), 7,
      anon_sym_QMARK_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_EQ_PLUS,
      anon_sym_DOT_EQ,
      anon_sym_EQ_DOT,
  [101155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(2897), 4,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101177] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3102), 1,
      anon_sym_RBRACK,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    STATE(2178), 1,
      aux_sym_subscript_repeat1,
  [101205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2740), 1,
      anon_sym_if,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3106), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101227] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3110), 1,
      sym_identifier,
    STATE(1523), 1,
      sym_variable_expansion,
    STATE(1572), 1,
      sym_concatenation,
    ACTIONS(3108), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [101251] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3112), 1,
      anon_sym_RBRACK,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    STATE(2154), 1,
      aux_sym_subscript_repeat1,
  [101279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(2750), 7,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
  [101295] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3116), 1,
      anon_sym_RBRACK,
    ACTIONS(3118), 1,
      anon_sym_COMMA,
    STATE(2117), 1,
      aux_sym_subscript_repeat1,
  [101323] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3122), 1,
      sym_inherit_path,
    ACTIONS(3125), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3128), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3120), 2,
      aux_sym_recipe_token1,
      anon_sym_NULL,
    STATE(1688), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_inherit_directive_repeat1,
  [101345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(1968), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3131), 2,
      sym__newline,
      anon_sym_SEMI,
  [101371] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3096), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2650), 2,
      sym__newline,
      anon_sym_SEMI,
  [101397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [101417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2897), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101439] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3133), 1,
      anon_sym_RBRACK,
    ACTIONS(3135), 1,
      anon_sym_COMMA,
    STATE(2071), 1,
      aux_sym_subscript_repeat1,
  [101467] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2726), 1,
      aux_sym_string_token1,
    ACTIONS(2724), 7,
      anon_sym_DQUOTE,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [101483] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3139), 1,
      sym_identifier,
    STATE(1526), 1,
      sym_variable_expansion,
    STATE(1589), 1,
      sym_concatenation,
    ACTIONS(3137), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [101507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [101527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_except,
    ACTIONS(1395), 1,
      anon_sym_except_STAR,
    ACTIONS(3141), 1,
      anon_sym_finally,
    STATE(676), 1,
      sym_finally_clause,
    STATE(540), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(541), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [101551] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3145), 1,
      aux_sym_string_token1,
    ACTIONS(3143), 7,
      anon_sym_DQUOTE,
      aux_sym_string_token2,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_DOLLAR,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [101567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3147), 1,
      anon_sym_RBRACK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    STATE(2039), 1,
      aux_sym_subscript_repeat1,
  [101595] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3151), 1,
      anon_sym_RBRACK,
    ACTIONS(3153), 1,
      anon_sym_COMMA,
    STATE(2003), 1,
      aux_sym_subscript_repeat1,
  [101623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(3155), 1,
      anon_sym_as,
    ACTIONS(2883), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [101643] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3158), 1,
      anon_sym_RBRACK,
    ACTIONS(3160), 1,
      anon_sym_COMMA,
    STATE(2095), 1,
      aux_sym_subscript_repeat1,
  [101671] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3166), 1,
      sym_identifier,
    ACTIONS(3168), 1,
      aux_sym__dotted_identifier_token1,
    STATE(1975), 1,
      sym_variable_expansion,
    STATE(2289), 1,
      sym_concatenation,
    ACTIONS(3162), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [101695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [101715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_except,
    ACTIONS(1395), 1,
      anon_sym_except_STAR,
    ACTIONS(3141), 1,
      anon_sym_finally,
    STATE(649), 1,
      sym_finally_clause,
    STATE(538), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(539), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [101739] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3096), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2947), 2,
      sym__newline,
      anon_sym_SEMI,
  [101765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_as,
    ACTIONS(3049), 1,
      anon_sym_if,
    ACTIONS(3051), 1,
      anon_sym_and,
    ACTIONS(3053), 1,
      anon_sym_or,
    ACTIONS(3057), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [101787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(2818), 4,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_as,
    ACTIONS(2752), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [101825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_as,
    ACTIONS(1954), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [101841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2758), 1,
      anon_sym_if,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(2866), 4,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_as,
    ACTIONS(2750), 7,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [101879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2774), 1,
      anon_sym_if,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(2818), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [101901] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3168), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3172), 1,
      sym_identifier,
    STATE(1920), 1,
      sym_variable_expansion,
    STATE(2172), 1,
      sym_concatenation,
    ACTIONS(3170), 3,
      anon_sym_append,
      anon_sym_prepend,
      anon_sym_remove,
  [101925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_as,
    ACTIONS(2752), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [101941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(3035), 1,
      anon_sym_as,
    ACTIONS(2750), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [101959] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3096), 1,
      anon_sym_COMMA,
    STATE(1983), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3174), 2,
      sym__newline,
      anon_sym_SEMI,
  [101985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_as,
    ACTIONS(2750), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [102001] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3176), 1,
      anon_sym_RBRACK,
    ACTIONS(3178), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_subscript_repeat1,
  [102029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(3035), 1,
      anon_sym_as,
    ACTIONS(2750), 6,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [102047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(3071), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3055), 1,
      anon_sym_as,
    ACTIONS(2879), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3180), 1,
      anon_sym_as,
    ACTIONS(2883), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3183), 1,
      anon_sym_RBRACK,
    ACTIONS(3185), 1,
      anon_sym_COMMA,
    STATE(2189), 1,
      aux_sym_subscript_repeat1,
  [102135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_DOT,
    ACTIONS(3189), 1,
      anon_sym___future__,
    ACTIONS(3191), 1,
      sym_python_identifier,
    STATE(1982), 1,
      aux_sym_import_prefix_repeat1,
    STATE(2011), 1,
      sym_import_prefix,
    STATE(2517), 2,
      sym_relative_import,
      sym_dotted_name,
  [102158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3193), 1,
      anon_sym_RBRACE,
    ACTIONS(3195), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2082), 1,
      aux_sym_dictionary_repeat1,
    STATE(2398), 1,
      sym__comprehension_clauses,
  [102183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(2947), 1,
      anon_sym_RPAREN,
    ACTIONS(3197), 1,
      anon_sym_COMMA,
    STATE(2026), 1,
      aux_sym_assert_statement_repeat1,
  [102208] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2730), 1,
      aux_sym_string_token3,
    ACTIONS(2728), 6,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_SQUOTE,
      aux_sym_string_token4,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [102223] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3199), 1,
      anon_sym_RBRACE,
    ACTIONS(3201), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2130), 1,
      aux_sym_dictionary_repeat1,
    STATE(2345), 1,
      sym__comprehension_clauses,
  [102248] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3203), 1,
      anon_sym_RBRACE,
    ACTIONS(3205), 1,
      anon_sym_if,
    STATE(1746), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102269] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_COLON,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(1229), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [102292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      sym__not_escape_sequence,
    STATE(1732), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3207), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(3209), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [102311] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3215), 1,
      anon_sym_COLON,
    ACTIONS(3217), 1,
      anon_sym_COMMA,
    STATE(2123), 1,
      aux_sym_assert_statement_repeat1,
  [102336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(3203), 1,
      anon_sym_RPAREN,
    ACTIONS(3219), 1,
      anon_sym_if,
    STATE(1758), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2746), 1,
      anon_sym_and,
    ACTIONS(2748), 1,
      anon_sym_or,
    ACTIONS(3221), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3223), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [102397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 1,
      anon_sym_RPAREN,
    ACTIONS(3227), 1,
      anon_sym_if,
    ACTIONS(3230), 1,
      anon_sym_async,
    ACTIONS(3233), 1,
      anon_sym_for,
    STATE(1737), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 1,
      sym__not_escape_sequence,
    STATE(1732), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3236), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(3238), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [102437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3242), 1,
      anon_sym_RBRACE,
    ACTIONS(3244), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2080), 1,
      aux_sym_dictionary_repeat1,
    STATE(2399), 1,
      sym__comprehension_clauses,
  [102462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(3203), 1,
      anon_sym_RBRACK,
    ACTIONS(3246), 1,
      anon_sym_if,
    STATE(1745), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3248), 1,
      anon_sym_RBRACE,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2206), 1,
      aux_sym_dictionary_repeat1,
    STATE(2495), 1,
      sym__comprehension_clauses,
  [102508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 1,
      anon_sym_RBRACE,
    ACTIONS(3252), 1,
      anon_sym_if,
    ACTIONS(3255), 1,
      anon_sym_async,
    ACTIONS(3258), 1,
      anon_sym_for,
    STATE(1742), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3261), 1,
      anon_sym_RBRACE,
    ACTIONS(3263), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2160), 1,
      aux_sym_dictionary_repeat1,
    STATE(2480), 1,
      sym__comprehension_clauses,
  [102554] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2726), 1,
      aux_sym_string_token3,
    ACTIONS(2724), 6,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_SQUOTE,
      aux_sym_string_token4,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [102569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_async,
    ACTIONS(2762), 1,
      anon_sym_for,
    ACTIONS(3246), 1,
      anon_sym_if,
    ACTIONS(3265), 1,
      anon_sym_RBRACK,
    STATE(1752), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3205), 1,
      anon_sym_if,
    ACTIONS(3265), 1,
      anon_sym_RBRACE,
    STATE(1742), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(3269), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2167), 1,
      aux_sym_dictionary_repeat1,
    STATE(2380), 1,
      sym__comprehension_clauses,
  [102636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3217), 1,
      anon_sym_COMMA,
    ACTIONS(3271), 1,
      anon_sym_COLON,
    STATE(2123), 1,
      aux_sym_assert_statement_repeat1,
  [102661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_RBRACK,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    STATE(2084), 1,
      aux_sym_assert_statement_repeat1,
  [102686] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_LPAREN,
    ACTIONS(3275), 1,
      anon_sym_LBRACK,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3279), 1,
      sym__concat,
    STATE(1944), 1,
      aux_sym_concatenation_repeat1,
    STATE(2143), 1,
      sym_variable_flag,
    STATE(2145), 1,
      aux_sym_override_repeat1,
  [102711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_as,
    ACTIONS(2764), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_or,
    ACTIONS(3221), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102730] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 1,
      anon_sym_RBRACK,
    ACTIONS(3281), 1,
      anon_sym_if,
    ACTIONS(3284), 1,
      anon_sym_async,
    ACTIONS(3287), 1,
      anon_sym_for,
    STATE(1752), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102751] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3090), 1,
      anon_sym_COLON,
    ACTIONS(3290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [102774] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3145), 1,
      aux_sym_string_token3,
    ACTIONS(3143), 6,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH,
      anon_sym_DOLLARBB_ENV_PASSTHROUGH_ADDITIONS,
      anon_sym_SQUOTE,
      aux_sym_string_token4,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [102789] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3292), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [102810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3294), 1,
      anon_sym_RBRACE,
    ACTIONS(3296), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(2175), 1,
      aux_sym_dictionary_repeat1,
    STATE(2328), 1,
      sym__comprehension_clauses,
  [102835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LPAREN,
    ACTIONS(3300), 1,
      anon_sym_STAR,
    ACTIONS(3302), 1,
      sym_python_identifier,
    STATE(1852), 1,
      sym_dotted_name,
    STATE(1979), 1,
      sym_aliased_import,
    STATE(2304), 1,
      sym_wildcard_import,
    STATE(2311), 1,
      sym__import_list,
  [102860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_async,
    ACTIONS(2778), 1,
      anon_sym_for,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3265), 1,
      anon_sym_RPAREN,
    STATE(1737), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [102881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_async,
    ACTIONS(2744), 1,
      anon_sym_for,
    ACTIONS(3304), 1,
      anon_sym_RBRACE,
    ACTIONS(3306), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      sym_for_in_clause,
    STATE(1988), 1,
      aux_sym_dictionary_repeat1,
    STATE(2550), 1,
      sym__comprehension_clauses,
  [102906] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3308), 1,
      anon_sym_COLON,
    ACTIONS(1299), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [102929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3057), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [102950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_as,
    ACTIONS(2780), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_or,
    ACTIONS(3221), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [102969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2879), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
  [102985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3312), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3310), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [103013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_RBRACK,
    ACTIONS(3319), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_DOT,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    STATE(2195), 1,
      aux_sym_type_parameter_repeat1,
  [103035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [103047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3019), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3327), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [103087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3329), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3057), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3333), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [103143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3333), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 1,
      anon_sym_COMMA,
    STATE(1799), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3335), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3339), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [103199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_COMMA,
    STATE(1776), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(2543), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [103215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3346), 1,
      sym__not_escape_sequence,
    ACTIONS(3344), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [103229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3350), 1,
      sym__not_escape_sequence,
    ACTIONS(3348), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [103243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [103255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3352), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [103275] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3106), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [103295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3354), 2,
      sym__newline,
      anon_sym_SEMI,
  [103315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 1,
      anon_sym_DOT,
    STATE(1813), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3356), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [103331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [103343] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3081), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3083), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(3362), 1,
      sym_inherit_path,
    STATE(1669), 3,
      sym_inline_python,
      sym_variable_expansion,
      aux_sym_inherit_directive_repeat1,
  [103361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_DOT,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    ACTIONS(3364), 1,
      anon_sym_RBRACK,
    STATE(2025), 1,
      aux_sym_type_parameter_repeat1,
  [103383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3352), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3057), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [103423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_COMMA,
    STATE(1821), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3335), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3368), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [103459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3370), 2,
      sym__newline,
      anon_sym_SEMI,
  [103479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3372), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3368), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 1,
      sym__not_escape_sequence,
    ACTIONS(3374), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [103533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_COLON,
    ACTIONS(3382), 1,
      anon_sym_DOT,
    ACTIONS(3384), 1,
      anon_sym_PIPE,
    ACTIONS(3378), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [103563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 1,
      anon_sym_EQ,
    ACTIONS(3390), 1,
      anon_sym_COLON,
    ACTIONS(3394), 1,
      anon_sym_DOT,
    ACTIONS(3396), 1,
      anon_sym_PIPE,
    ACTIONS(3392), 2,
      sym__newline,
      anon_sym_SEMI,
  [103583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3398), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3329), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3400), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3333), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [103635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3404), 1,
      anon_sym_COMMA,
    STATE(1845), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1113), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [103651] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3372), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [103671] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_DOT,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    ACTIONS(3406), 1,
      anon_sym_RBRACK,
    STATE(2166), 1,
      aux_sym_type_parameter_repeat1,
  [103693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_COLON,
    ACTIONS(3382), 1,
      anon_sym_DOT,
    ACTIONS(3384), 1,
      anon_sym_PIPE,
    ACTIONS(3408), 1,
      anon_sym_EQ,
    ACTIONS(3410), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(2174), 1,
      sym_variable_expansion,
    ACTIONS(2693), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(3412), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [103731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 1,
      anon_sym_DOT,
    STATE(1783), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3414), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [103747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3416), 1,
      anon_sym_COMMA,
    STATE(1776), 1,
      aux_sym_pattern_list_repeat1,
    ACTIONS(801), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [103763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [103775] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3420), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [103807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3424), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3310), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [103843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_DOT,
    STATE(1813), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3429), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [103859] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3434), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [103879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3057), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [103899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3390), 1,
      anon_sym_COLON,
    ACTIONS(3394), 1,
      anon_sym_DOT,
    ACTIONS(3396), 1,
      anon_sym_PIPE,
    ACTIONS(3378), 3,
      sym__newline,
      anon_sym_EQ,
      anon_sym_SEMI,
  [103917] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(37), 1,
      aux_sym__dotted_identifier_token1,
    ACTIONS(3436), 1,
      sym_identifier,
    STATE(1516), 1,
      sym_concatenation,
    STATE(2254), 1,
      sym_variable_expansion,
    STATE(2276), 1,
      sym_variable_assignment,
  [103939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [103951] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3019), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [103971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3438), 1,
      anon_sym_COLON,
    ACTIONS(3440), 1,
      anon_sym_COMMA,
    ACTIONS(3442), 1,
      anon_sym_as,
  [103993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3444), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3400), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [104021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3446), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [104041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(3352), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [104061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(1299), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [104081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 1,
      anon_sym_COMMA,
    STATE(1841), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3448), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      sym__not_escape_sequence,
    ACTIONS(3452), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [104111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_DOT,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    ACTIONS(3456), 1,
      anon_sym_RBRACK,
    STATE(2119), 1,
      aux_sym_type_parameter_repeat1,
  [104133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      sym__not_escape_sequence,
    ACTIONS(3458), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [104147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      sym__not_escape_sequence,
    ACTIONS(3462), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [104161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym__not_escape_sequence,
    ACTIONS(3466), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [104175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [104187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3472), 1,
      sym__not_escape_sequence,
    ACTIONS(3470), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [104201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3448), 4,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3476), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3400), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    STATE(1835), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3335), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_as,
    ACTIONS(2796), 1,
      anon_sym_if,
    ACTIONS(2798), 1,
      anon_sym_and,
    ACTIONS(2800), 1,
      anon_sym_or,
    ACTIONS(3019), 2,
      sym__newline,
      anon_sym_SEMI,
  [104269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [104281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [104293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_LBRACK,
    ACTIONS(3279), 1,
      sym__concat,
    STATE(1944), 1,
      aux_sym_concatenation_repeat1,
    STATE(2252), 1,
      sym_variable_flag,
    ACTIONS(2722), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [104313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3329), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104329] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_as,
    ACTIONS(2917), 1,
      anon_sym_if,
    ACTIONS(2919), 1,
      anon_sym_and,
    ACTIONS(2921), 1,
      anon_sym_or,
    ACTIONS(3339), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [104349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 6,
      sym__newline,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE,
  [104361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 1,
      anon_sym_COMMA,
    STATE(1798), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3448), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    STATE(1845), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3057), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_and,
    ACTIONS(3017), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_as,
    ACTIONS(3039), 1,
      anon_sym_if,
    ACTIONS(1289), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [104425] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3446), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [104445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3310), 4,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_DQUOTE,
    ACTIONS(3492), 1,
      anon_sym_SQUOTE,
    ACTIONS(3494), 1,
      sym_identifier,
    STATE(2259), 1,
      sym_string,
    STATE(2320), 1,
      sym_literal,
  [104480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3496), 1,
      anon_sym_COLON,
  [104499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      anon_sym_as,
    STATE(1984), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3498), 2,
      sym__newline,
      anon_sym_SEMI,
  [104516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      sym_python_identifier,
    ACTIONS(3504), 1,
      anon_sym_LPAREN,
    STATE(1852), 1,
      sym_dotted_name,
    STATE(1979), 1,
      sym_aliased_import,
    STATE(2323), 1,
      sym__import_list,
  [104546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 1,
      anon_sym_COLON,
    ACTIONS(3382), 1,
      anon_sym_DOT,
    ACTIONS(3384), 1,
      anon_sym_PIPE,
    ACTIONS(3410), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [104563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_else,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
  [104582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3514), 1,
      anon_sym_else,
  [104601] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3516), 1,
      aux_sym_recipe_token1,
    ACTIONS(3520), 1,
      sym_identifier,
    STATE(1858), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(3518), 2,
      anon_sym_NULL,
      anon_sym_after,
  [104618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2818), 1,
      anon_sym_else,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
  [104637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3527), 1,
      anon_sym_else,
  [104700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [104711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3529), 1,
      anon_sym_COLON,
  [104730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104741] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3516), 1,
      aux_sym_recipe_token1,
    ACTIONS(3531), 1,
      sym_identifier,
    STATE(1868), 1,
      aux_sym_export_functions_statement_repeat1,
    ACTIONS(3518), 2,
      anon_sym_NULL,
      anon_sym_before,
  [104758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 1,
      anon_sym_RBRACE,
    ACTIONS(3536), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3538), 1,
      sym_shell_content,
    STATE(1933), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [104797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 1,
      anon_sym_DOT,
    STATE(1872), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3429), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [104812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104823] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_LBRACE,
    ACTIONS(3546), 1,
      anon_sym_RBRACE,
    ACTIONS(3548), 1,
      aux_sym_format_specifier_token1,
    STATE(1874), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2207), 1,
      sym_interpolation,
  [104842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3551), 1,
      anon_sym_COLON,
  [104861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [104883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3057), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [104898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1113), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [104913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 1,
      anon_sym_RBRACE,
    ACTIONS(3536), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3558), 1,
      sym_shell_content,
    STATE(1918), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [104941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3560), 1,
      anon_sym_COLON,
  [104960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(2879), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_if,
  [104975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [104997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3562), 1,
      anon_sym_COLON,
    ACTIONS(3564), 1,
      anon_sym_as,
  [105016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3566), 1,
      anon_sym_else,
  [105035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3568), 1,
      anon_sym_else,
  [105054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_DQUOTE,
    ACTIONS(3492), 1,
      anon_sym_SQUOTE,
    ACTIONS(3494), 1,
      sym_identifier,
    STATE(2257), 1,
      sym_literal,
    STATE(2259), 1,
      sym_string,
  [105073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [105084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_DOT,
    STATE(1872), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3356), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [105099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [105110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105121] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2728), 5,
      aux_sym_recipe_token1,
      anon_sym_NULL,
      sym_inherit_path,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [105132] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 1,
      anon_sym_COMMA,
    ACTIONS(3572), 1,
      anon_sym_EQ,
    ACTIONS(3574), 1,
      anon_sym_COLON,
    ACTIONS(3576), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_PIPE,
  [105151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_DOT,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    ACTIONS(3378), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [105168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_COLON,
    ACTIONS(3576), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_PIPE,
    ACTIONS(3378), 2,
      anon_sym_EQ,
      anon_sym_COMMA,
  [105185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3580), 1,
      anon_sym_RBRACE,
  [105204] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3143), 5,
      aux_sym_recipe_token1,
      anon_sym_NULL,
      sym_inherit_path,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [105215] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_LBRACE,
    ACTIONS(3584), 1,
      anon_sym_RBRACE,
    ACTIONS(3586), 1,
      aux_sym_format_specifier_token1,
    STATE(1874), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2207), 1,
      sym_interpolation,
  [105234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3588), 1,
      anon_sym_RBRACE,
  [105253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(2750), 4,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
      anon_sym_or,
  [105277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3590), 1,
      anon_sym_EQ,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3594), 1,
      anon_sym_RBRACE,
    ACTIONS(3596), 1,
      sym_type_conversion,
    STATE(2537), 1,
      sym_format_specifier,
  [105296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(2879), 3,
      anon_sym_as,
      anon_sym_if,
      anon_sym_else,
  [105311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_DOT,
    STATE(1891), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3414), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [105326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3598), 1,
      anon_sym_as,
    ACTIONS(2883), 2,
      anon_sym_if,
      anon_sym_else,
  [105343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3418), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      sym_python_identifier,
    STATE(1943), 1,
      sym_dotted_name,
    STATE(2140), 1,
      sym_aliased_import,
    ACTIONS(3601), 2,
      sym__newline,
      anon_sym_SEMI,
  [105371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_else,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
  [105390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3603), 1,
      anon_sym_RBRACE,
  [105409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3605), 1,
      anon_sym_else,
  [105428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3360), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [105450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      sym_python_identifier,
    STATE(1943), 1,
      sym_dotted_name,
    STATE(2140), 1,
      sym_aliased_import,
    ACTIONS(3607), 2,
      sym__newline,
      anon_sym_SEMI,
  [105478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 5,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_RBRACE,
    ACTIONS(3611), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3614), 1,
      sym_shell_content,
    STATE(1918), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [105506] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2724), 5,
      aux_sym_recipe_token1,
      anon_sym_NULL,
      sym_inherit_path,
      anon_sym_DOLLAR_LBRACE_AT,
      anon_sym_DOLLAR_LBRACE,
  [105517] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_LPAREN,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3279), 1,
      sym__concat,
    STATE(1944), 1,
      aux_sym_concatenation_repeat1,
    STATE(2145), 1,
      aux_sym_override_repeat1,
  [105536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_as,
    ACTIONS(2953), 1,
      anon_sym_if,
    ACTIONS(2955), 1,
      anon_sym_and,
    ACTIONS(2957), 1,
      anon_sym_or,
    ACTIONS(3617), 1,
      anon_sym_RBRACE,
  [105555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3619), 1,
      anon_sym_else,
  [105574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      sym_python_identifier,
    STATE(1943), 1,
      sym_dotted_name,
    STATE(2140), 1,
      sym_aliased_import,
    ACTIONS(3607), 2,
      sym__newline,
      anon_sym_SEMI,
  [105591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3621), 1,
      anon_sym_else,
  [105610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3623), 1,
      anon_sym_else,
  [105629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 5,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3558), 1,
      sym_shell_content,
    ACTIONS(3625), 1,
      anon_sym_RBRACE,
    STATE(1918), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [105668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 1,
      anon_sym_as,
    ACTIONS(3026), 1,
      anon_sym_if,
    ACTIONS(3028), 1,
      anon_sym_and,
    ACTIONS(3030), 1,
      anon_sym_or,
    ACTIONS(3627), 1,
      anon_sym_COLON,
  [105687] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_LBRACE,
    ACTIONS(3629), 1,
      anon_sym_RBRACE,
    ACTIONS(3631), 1,
      aux_sym_format_specifier_token1,
    STATE(1900), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2207), 1,
      sym_interpolation,
  [105706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3633), 1,
      anon_sym_RBRACE,
    ACTIONS(3635), 1,
      sym_shell_content,
    STATE(1881), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [105723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3558), 1,
      sym_shell_content,
    ACTIONS(3637), 1,
      anon_sym_RBRACE,
    STATE(1918), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [105751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3639), 1,
      anon_sym_EQ,
    ACTIONS(3641), 1,
      anon_sym_RBRACE,
    ACTIONS(3643), 1,
      sym_type_conversion,
    STATE(2535), 1,
      sym_format_specifier,
  [105770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [105781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_DOT,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    ACTIONS(3645), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [105798] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3647), 1,
      aux_sym_recipe_token1,
    ACTIONS(3649), 1,
      anon_sym_NULL,
    ACTIONS(3651), 1,
      anon_sym_before,
    ACTIONS(3653), 1,
      sym_identifier,
    STATE(1868), 1,
      aux_sym_export_functions_statement_repeat1,
  [105817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_DOLLAR_LBRACE_AT,
    ACTIONS(3637), 1,
      anon_sym_RBRACE,
    ACTIONS(3655), 1,
      sym_shell_content,
    STATE(1928), 2,
      sym_inline_python,
      aux_sym_function_definition_repeat1,
  [105834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      sym_type_conversion,
  [105845] = 6,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3647), 1,
      aux_sym_recipe_token1,
    ACTIONS(3649), 1,
      anon_sym_NULL,
    ACTIONS(3651), 1,
      anon_sym_after,
    ACTIONS(3657), 1,
      sym_identifier,
    STATE(1858), 1,
      aux_sym_export_functions_statement_repeat1,
  [105864] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3659), 1,
      anon_sym_else,
  [105883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_as,
    ACTIONS(3508), 1,
      anon_sym_if,
    ACTIONS(3510), 1,
      anon_sym_and,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(3661), 1,
      anon_sym_else,
  [105902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_as,
    ACTIONS(3663), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [105914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      sym__concat,
    STATE(1946), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2709), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [105928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3667), 2,
      sym__newline,
      anon_sym_SEMI,
  [105942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 1,
      sym__concat,
    STATE(1946), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2715), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [105956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3675), 1,
      anon_sym_RBRACE,
    ACTIONS(3677), 1,
      sym_type_conversion,
    STATE(2481), 1,
      sym_format_specifier,
  [105972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      sym_python_identifier,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2050), 1,
      sym_aliased_import,
    STATE(2493), 1,
      sym__import_list,
  [105988] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3681), 1,
      aux_sym_recipe_token1,
    ACTIONS(3683), 1,
      anon_sym_NULL,
    ACTIONS(3685), 1,
      sym_identifier,
    STATE(1967), 1,
      aux_sym_export_functions_statement_repeat1,
  [106004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 1,
      anon_sym_COMMA,
    STATE(1956), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3687), 2,
      sym__newline,
      anon_sym_SEMI,
  [106018] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3691), 1,
      aux_sym_recipe_token1,
    ACTIONS(3693), 1,
      anon_sym_NULL,
    ACTIONS(3695), 1,
      anon_sym_after,
    ACTIONS(3697), 1,
      anon_sym_before,
  [106034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3699), 2,
      sym__newline,
      anon_sym_SEMI,
  [106048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      sym_python_identifier,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2050), 1,
      sym_aliased_import,
    STATE(2504), 1,
      sym__import_list,
  [106064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      anon_sym_COMMA,
    STATE(1977), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3703), 2,
      sym__newline,
      anon_sym_SEMI,
  [106078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3707), 2,
      sym__newline,
      anon_sym_SEMI,
  [106092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_COMMA,
    STATE(1956), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3709), 2,
      sym__newline,
      anon_sym_SEMI,
  [106106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_DOT,
    STATE(1957), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3714), 2,
      anon_sym_import,
      sym_python_identifier,
  [106120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_COMMA,
    STATE(1952), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3719), 2,
      sym__newline,
      anon_sym_SEMI,
  [106134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_COMMA,
    STATE(1955), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3721), 2,
      sym__newline,
      anon_sym_SEMI,
  [106148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_RPAREN,
    ACTIONS(3679), 1,
      sym_python_identifier,
    STATE(2001), 1,
      sym_dotted_name,
    STATE(2222), 1,
      sym_aliased_import,
  [106164] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3685), 1,
      sym_identifier,
    ACTIONS(3723), 1,
      aux_sym_recipe_token1,
    ACTIONS(3725), 1,
      anon_sym_NULL,
    STATE(1967), 1,
      aux_sym_export_functions_statement_repeat1,
  [106180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3727), 1,
      anon_sym_RBRACE,
    ACTIONS(3729), 1,
      sym_type_conversion,
    STATE(2523), 1,
      sym_format_specifier,
  [106196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 1,
      anon_sym_COMMA,
    ACTIONS(3574), 1,
      anon_sym_COLON,
    ACTIONS(3576), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_PIPE,
  [106212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      anon_sym_COMMA,
    STATE(1964), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3731), 2,
      sym__newline,
      anon_sym_SEMI,
  [106226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(2174), 1,
      sym_variable_expansion,
    ACTIONS(3412), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [106240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(1524), 1,
      sym_variable_expansion,
    ACTIONS(2695), 2,
      sym_identifier,
      aux_sym__dotted_identifier_token1,
  [106254] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3516), 1,
      aux_sym_recipe_token1,
    ACTIONS(3518), 1,
      anon_sym_NULL,
    ACTIONS(3736), 1,
      sym_identifier,
    STATE(1967), 1,
      aux_sym_export_functions_statement_repeat1,
  [106270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(1973), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3739), 2,
      sym__newline,
      anon_sym_SEMI,
  [106284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_COMMA,
    STATE(1964), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3741), 2,
      sym__newline,
      anon_sym_SEMI,
  [106298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 1,
      anon_sym_COMMA,
    STATE(1973), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1281), 2,
      sym__newline,
      anon_sym_SEMI,
  [106312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_RPAREN,
    ACTIONS(3679), 1,
      sym_python_identifier,
    STATE(2001), 1,
      sym_dotted_name,
    STATE(2222), 1,
      sym_aliased_import,
  [106328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      sym_python_identifier,
    STATE(1852), 1,
      sym_dotted_name,
    STATE(1979), 1,
      sym_aliased_import,
    STATE(2215), 1,
      sym__import_list,
  [106344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3747), 1,
      anon_sym_COMMA,
    STATE(1973), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3057), 2,
      sym__newline,
      anon_sym_SEMI,
  [106358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 4,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [106368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3279), 1,
      sym__concat,
    STATE(1944), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(2722), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [106382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    ACTIONS(3750), 1,
      anon_sym_COMMA,
    ACTIONS(3752), 1,
      anon_sym_as,
    STATE(2013), 1,
      aux_sym__import_list_repeat1,
  [106398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 1,
      anon_sym_COMMA,
    STATE(1964), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3754), 2,
      sym__newline,
      anon_sym_SEMI,
  [106412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(1973), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3758), 2,
      sym__newline,
      anon_sym_SEMI,
  [106426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    STATE(1950), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3498), 2,
      sym__newline,
      anon_sym_SEMI,
  [106440] = 5,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3760), 1,
      aux_sym_recipe_token1,
    ACTIONS(3762), 1,
      anon_sym_NULL,
    ACTIONS(3764), 1,
      anon_sym_LBRACK,
    STATE(2302), 1,
      sym_variable_flag,
  [106456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_RPAREN,
    ACTIONS(3679), 1,
      sym_python_identifier,
    STATE(2001), 1,
      sym_dotted_name,
    STATE(2222), 1,
      sym_aliased_import,
  [106472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DOT,
    STATE(1957), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3766), 2,
      anon_sym_import,
      sym_python_identifier,
  [106486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_COMMA,
    STATE(1973), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1113), 2,
      sym__newline,
      anon_sym_SEMI,
  [106500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 1,
      anon_sym_COMMA,
    STATE(1956), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3687), 2,
      sym__newline,
      anon_sym_SEMI,
  [106514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 1,
      anon_sym_EQ,
    ACTIONS(3776), 1,
      anon_sym_COLON,
    ACTIONS(3778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [106528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_RPAREN,
    ACTIONS(3782), 1,
      anon_sym_COMMA,
    STATE(2180), 1,
      aux_sym_argument_list_repeat1,
  [106541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3784), 1,
      anon_sym_RPAREN,
    ACTIONS(3786), 1,
      anon_sym_COMMA,
    STATE(2188), 1,
      aux_sym_argument_list_repeat1,
  [106554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [106567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_COLON,
    ACTIONS(3793), 1,
      anon_sym_DQUOTE,
    STATE(1989), 1,
      aux_sym_overrides_statement_repeat1,
  [106580] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3348), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3350), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      anon_sym_COMMA,
    STATE(1991), 1,
      aux_sym_with_clause_repeat1,
  [106604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_RBRACK,
    ACTIONS(3153), 1,
      anon_sym_COMMA,
    STATE(2002), 1,
      aux_sym_subscript_repeat1,
  [106617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      sym_python_identifier,
    STATE(2001), 1,
      sym_dotted_name,
    STATE(2222), 1,
      sym_aliased_import,
  [106630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 1,
      anon_sym_RPAREN,
    ACTIONS(3802), 1,
      anon_sym_COMMA,
    STATE(2004), 1,
      aux_sym_argument_list_repeat1,
  [106643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 1,
      anon_sym_RPAREN,
    ACTIONS(2873), 1,
      anon_sym_COMMA,
    STATE(2006), 1,
      aux_sym_argument_list_repeat1,
  [106656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_SEMI,
    ACTIONS(3806), 1,
      sym__newline,
    STATE(2009), 1,
      aux_sym__simple_statements_repeat1,
  [106669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 1,
      anon_sym_SEMI,
    ACTIONS(3811), 1,
      sym__newline,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [106682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3709), 1,
      anon_sym_RPAREN,
    ACTIONS(3813), 1,
      anon_sym_COMMA,
    STATE(1998), 1,
      aux_sym__import_list_repeat1,
  [106695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    STATE(2016), 1,
      aux_sym__collection_elements_repeat1,
  [106708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3816), 1,
      anon_sym_RBRACE,
    STATE(2520), 1,
      sym_format_specifier,
  [106721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_as,
    ACTIONS(3663), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [106732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 1,
      anon_sym_RBRACK,
    ACTIONS(3820), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [106745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_RBRACK,
    ACTIONS(3824), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [106758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_RPAREN,
    ACTIONS(3826), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [106771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_import,
    ACTIONS(3828), 1,
      anon_sym_DOT,
    STATE(2005), 1,
      aux_sym_dotted_name_repeat1,
  [106784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [106797] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3468), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106808] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3462), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3464), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(417), 1,
      sym__newline,
    ACTIONS(3833), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [106832] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3452), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3454), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 1,
      sym_python_identifier,
    ACTIONS(3835), 1,
      anon_sym_import,
    STATE(2492), 1,
      sym_dotted_name,
  [106856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(3837), 1,
      anon_sym_RBRACE,
    STATE(2498), 1,
      sym_format_specifier,
  [106869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 1,
      anon_sym_RPAREN,
    ACTIONS(3839), 1,
      anon_sym_COMMA,
    STATE(1998), 1,
      aux_sym__import_list_repeat1,
  [106882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3687), 1,
      anon_sym_RPAREN,
    ACTIONS(3841), 1,
      anon_sym_COMMA,
    STATE(1998), 1,
      aux_sym__import_list_repeat1,
  [106895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3356), 1,
      anon_sym_import,
    ACTIONS(3843), 1,
      anon_sym_DOT,
    STATE(2005), 1,
      aux_sym_dotted_name_repeat1,
  [106908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_RBRACE,
    ACTIONS(3845), 1,
      anon_sym_COMMA,
    STATE(2032), 1,
      aux_sym__collection_elements_repeat1,
  [106921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(3849), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [106934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(3851), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [106947] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3374), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3376), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106958] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3344), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3346), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106969] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3458), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3460), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [106980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_RBRACK,
    ACTIONS(3853), 1,
      anon_sym_COMMA,
    STATE(2022), 1,
      aux_sym_assert_statement_repeat1,
  [106993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_COLON,
    ACTIONS(3858), 1,
      anon_sym_DQUOTE,
    STATE(2102), 1,
      aux_sym_overrides_statement_repeat1,
  [107006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_RPAREN,
    ACTIONS(3860), 1,
      anon_sym_COMMA,
    STATE(2024), 1,
      aux_sym_pattern_list_repeat1,
  [107019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(3863), 1,
      anon_sym_RBRACK,
    STATE(2200), 1,
      aux_sym_type_parameter_repeat1,
  [107032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
    ACTIONS(3865), 1,
      anon_sym_COMMA,
    STATE(2043), 1,
      aux_sym_assert_statement_repeat1,
  [107045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_in,
    ACTIONS(3867), 1,
      anon_sym_COMMA,
    STATE(2028), 1,
      aux_sym_pattern_list_repeat1,
  [107058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_in,
    ACTIONS(3869), 1,
      anon_sym_COMMA,
    STATE(2028), 1,
      aux_sym_pattern_list_repeat1,
  [107071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(3872), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [107084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(3874), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [107097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_PIPE,
    ACTIONS(3876), 1,
      anon_sym_COLON,
  [107110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_RBRACE,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    STATE(2032), 1,
      aux_sym__collection_elements_repeat1,
  [107123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_from,
    ACTIONS(3041), 2,
      sym__newline,
      anon_sym_SEMI,
  [107134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 1,
      anon_sym_COLON,
    ACTIONS(3883), 1,
      anon_sym_COMMA,
    STATE(2139), 1,
      aux_sym_with_clause_repeat1,
  [107147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_except,
    ACTIONS(1523), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [107158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 1,
      anon_sym_COLON,
    ACTIONS(3887), 1,
      anon_sym_COMMA,
    STATE(2036), 1,
      aux_sym__parameters_repeat1,
  [107171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_in,
    ACTIONS(3890), 2,
      sym__newline,
      anon_sym_SEMI,
  [107182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(415), 1,
      sym__newline,
    ACTIONS(3894), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [107195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_RBRACK,
    ACTIONS(3898), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3900), 1,
      anon_sym_RBRACK,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1011), 1,
      anon_sym_RPAREN,
    ACTIONS(3904), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [107234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(3906), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [107247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_RPAREN,
    ACTIONS(3908), 1,
      anon_sym_COMMA,
    STATE(2043), 1,
      aux_sym_assert_statement_repeat1,
  [107260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(3911), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 1,
      anon_sym_RPAREN,
    ACTIONS(2895), 1,
      anon_sym_COMMA,
    STATE(2196), 1,
      aux_sym_argument_list_repeat1,
  [107286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3147), 1,
      anon_sym_RBRACK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    STATE(2040), 1,
      aux_sym_subscript_repeat1,
  [107299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(3913), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 1,
      anon_sym_except,
    ACTIONS(1527), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [107323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 1,
      anon_sym_RPAREN,
    ACTIONS(3917), 1,
      anon_sym_COMMA,
    STATE(2041), 1,
      aux_sym_argument_list_repeat1,
  [107336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    ACTIONS(3750), 1,
      anon_sym_COMMA,
    STATE(2014), 1,
      aux_sym__import_list_repeat1,
  [107349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_import,
    ACTIONS(3843), 1,
      anon_sym_DOT,
    STATE(2015), 1,
      aux_sym_dotted_name_repeat1,
  [107362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      sym__newline,
    ACTIONS(3919), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [107375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3921), 1,
      anon_sym_RBRACK,
    ACTIONS(3923), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3925), 1,
      anon_sym_RBRACK,
    ACTIONS(3927), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 1,
      anon_sym_RBRACE,
    ACTIONS(3306), 1,
      anon_sym_COMMA,
    STATE(1988), 1,
      aux_sym_dictionary_repeat1,
  [107414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3929), 1,
      anon_sym_SEMI,
    ACTIONS(3931), 1,
      sym__newline,
    STATE(2052), 1,
      aux_sym__simple_statements_repeat1,
  [107427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_RBRACK,
    ACTIONS(3092), 1,
      anon_sym_COMMA,
    STATE(2054), 1,
      aux_sym_subscript_repeat1,
  [107440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 1,
      anon_sym_RPAREN,
    ACTIONS(3933), 1,
      anon_sym_COMMA,
    STATE(2058), 1,
      aux_sym__parameters_repeat1,
  [107453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_RBRACK,
    ACTIONS(3160), 1,
      anon_sym_COMMA,
    STATE(2076), 1,
      aux_sym_subscript_repeat1,
  [107466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 3,
      sym_shell_content,
      anon_sym_RBRACE,
      anon_sym_DOLLAR_LBRACE_AT,
  [107475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_RPAREN,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_RBRACK,
    ACTIONS(3936), 1,
      anon_sym_COMMA,
    STATE(2100), 1,
      aux_sym_pattern_list_repeat1,
  [107501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(433), 1,
      sym__newline,
    ACTIONS(3938), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [107523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_LPAREN,
    ACTIONS(3940), 1,
      anon_sym_COLON,
    STATE(2446), 1,
      sym_override,
  [107536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3242), 1,
      anon_sym_RBRACE,
    ACTIONS(3244), 1,
      anon_sym_COMMA,
    STATE(2080), 1,
      aux_sym_dictionary_repeat1,
  [107549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2816), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    ACTIONS(3942), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [107575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COLON,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    STATE(2405), 1,
      sym_override,
  [107588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 1,
      anon_sym_RPAREN,
    ACTIONS(3946), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [107601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 1,
      anon_sym_RBRACK,
    ACTIONS(3950), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      anon_sym_RBRACK,
    ACTIONS(3954), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_SEMI,
    ACTIONS(3958), 1,
      sym__newline,
    STATE(2064), 1,
      aux_sym__simple_statements_repeat1,
  [107640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(3960), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(3962), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 1,
      anon_sym_RBRACK,
    ACTIONS(3966), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_RPAREN,
    ACTIONS(2812), 1,
      anon_sym_COMMA,
    STATE(2068), 1,
      aux_sym_argument_list_repeat1,
  [107692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3968), 1,
      anon_sym_RPAREN,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(2070), 1,
      aux_sym_argument_list_repeat1,
  [107705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_RBRACK,
    ACTIONS(3135), 1,
      anon_sym_COMMA,
    STATE(2072), 1,
      aux_sym_subscript_repeat1,
  [107718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    ACTIONS(3972), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [107731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_RPAREN,
    ACTIONS(3974), 1,
      anon_sym_COMMA,
    STATE(2081), 1,
      aux_sym__collection_elements_repeat1,
  [107744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(3977), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [107757] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(3470), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(3472), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [107768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      anon_sym_RBRACK,
    ACTIONS(3979), 1,
      anon_sym_COMMA,
    STATE(2022), 1,
      aux_sym_assert_statement_repeat1,
  [107781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 1,
      anon_sym_RBRACK,
    ACTIONS(3178), 1,
      anon_sym_COMMA,
    STATE(2098), 1,
      aux_sym_subscript_repeat1,
  [107794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 1,
      anon_sym_LPAREN,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    STATE(2087), 1,
      aux_sym_override_repeat1,
  [107807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 1,
      anon_sym_LPAREN,
    ACTIONS(3981), 1,
      anon_sym_COLON,
    STATE(2087), 1,
      aux_sym_override_repeat1,
  [107820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_RPAREN,
    ACTIONS(3986), 1,
      anon_sym_COMMA,
    STATE(2101), 1,
      aux_sym_argument_list_repeat1,
  [107833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_RPAREN,
    ACTIONS(2822), 1,
      anon_sym_COMMA,
    STATE(2103), 1,
      aux_sym_argument_list_repeat1,
  [107846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_RBRACE,
    ACTIONS(3195), 1,
      anon_sym_COMMA,
    STATE(2082), 1,
      aux_sym_dictionary_repeat1,
  [107859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_SEMI,
    ACTIONS(3990), 1,
      sym__newline,
    STATE(2106), 1,
      aux_sym__simple_statements_repeat1,
  [107872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3420), 1,
      anon_sym_RPAREN,
    ACTIONS(3992), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [107885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2881), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [107898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_except,
    ACTIONS(1555), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [107909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_RBRACK,
    ACTIONS(3997), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_RPAREN,
    ACTIONS(3999), 1,
      anon_sym_COMMA,
    STATE(2024), 1,
      aux_sym_pattern_list_repeat1,
  [107935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_COLON,
    ACTIONS(4001), 1,
      anon_sym_COMMA,
    STATE(2036), 1,
      aux_sym__parameters_repeat1,
  [107948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_RBRACK,
    ACTIONS(4005), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 1,
      anon_sym_RBRACK,
    ACTIONS(4009), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [107974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_RBRACK,
    ACTIONS(4011), 1,
      anon_sym_COMMA,
    STATE(2100), 1,
      aux_sym_pattern_list_repeat1,
  [107987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 1,
      anon_sym_RPAREN,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_COLON,
    ACTIONS(4016), 1,
      anon_sym_DQUOTE,
    STATE(1989), 1,
      aux_sym_overrides_statement_repeat1,
  [108013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    ACTIONS(4018), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 1,
      anon_sym_except,
    ACTIONS(1551), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [108037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      anon_sym_except,
    ACTIONS(1547), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [108048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym__newline,
    ACTIONS(4020), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [108061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_RPAREN,
    ACTIONS(4022), 1,
      anon_sym_COMMA,
    STATE(2058), 1,
      aux_sym__parameters_repeat1,
  [108074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_RBRACK,
    ACTIONS(4026), 1,
      anon_sym_COMMA,
    STATE(2062), 1,
      aux_sym_pattern_list_repeat1,
  [108087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      sym__newline,
    ACTIONS(4028), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [108100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 1,
      anon_sym_EQ,
    ACTIONS(3778), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [108111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_COLON,
    ACTIONS(4034), 1,
      anon_sym_COMMA,
    STATE(2097), 1,
      aux_sym__parameters_repeat1,
  [108124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 1,
      anon_sym_RPAREN,
    ACTIONS(4036), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(4038), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [108159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
    ACTIONS(4040), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(4042), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [108185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_RBRACK,
    ACTIONS(4046), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 1,
      anon_sym_EQ,
    ACTIONS(3778), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [108209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(4048), 1,
      anon_sym_RBRACK,
    STATE(2200), 1,
      aux_sym_type_parameter_repeat1,
  [108222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4050), 1,
      anon_sym_RBRACK,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 1,
      anon_sym_EQ,
    ACTIONS(3778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_SEMI,
    ACTIONS(4056), 1,
      sym__newline,
    STATE(2109), 1,
      aux_sym__simple_statements_repeat1,
  [108259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      anon_sym_COLON,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      aux_sym_assert_statement_repeat1,
  [108272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_RPAREN,
    ACTIONS(2846), 1,
      anon_sym_COMMA,
    STATE(2113), 1,
      aux_sym_argument_list_repeat1,
  [108285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4060), 1,
      anon_sym_RBRACK,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 1,
      anon_sym_RPAREN,
    ACTIONS(4067), 1,
      anon_sym_COMMA,
    STATE(2115), 1,
      aux_sym_argument_list_repeat1,
  [108311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_RPAREN,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    STATE(2081), 1,
      aux_sym__collection_elements_repeat1,
  [108324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_RBRACK,
    ACTIONS(3118), 1,
      anon_sym_COMMA,
    STATE(2120), 1,
      aux_sym_subscript_repeat1,
  [108337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_COLON,
    ACTIONS(4071), 1,
      anon_sym_COMMA,
    STATE(2129), 1,
      aux_sym_assert_statement_repeat1,
  [108350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_RBRACE,
    ACTIONS(4074), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [108363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4076), 1,
      anon_sym_RBRACE,
    ACTIONS(4078), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [108376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 3,
      sym__concat,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [108385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_RBRACK,
    ACTIONS(4081), 1,
      anon_sym_COMMA,
    STATE(2184), 1,
      aux_sym__collection_elements_repeat1,
  [108398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(4083), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [108411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COMMA,
  [108420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_RBRACE,
    ACTIONS(3201), 1,
      anon_sym_COMMA,
    STATE(2130), 1,
      aux_sym_dictionary_repeat1,
  [108433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
    STATE(2205), 1,
      aux_sym_with_clause_repeat1,
  [108446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 3,
      sym__concat,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [108455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_COLON,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    STATE(2193), 1,
      aux_sym_with_clause_repeat1,
  [108468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [108477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [108486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [108499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    STATE(2086), 1,
      aux_sym_override_repeat1,
  [108512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2899), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [108525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    STATE(2087), 1,
      aux_sym_override_repeat1,
  [108538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_COLON,
    ACTIONS(3778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_RPAREN,
    ACTIONS(4095), 1,
      anon_sym_COMMA,
    STATE(2096), 1,
      aux_sym_pattern_list_repeat1,
  [108562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(435), 1,
      sym__newline,
    ACTIONS(4097), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [108575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 1,
      anon_sym_RBRACE,
    ACTIONS(3263), 1,
      anon_sym_COMMA,
    STATE(2160), 1,
      aux_sym_dictionary_repeat1,
  [108588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
    ACTIONS(4099), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 1,
      anon_sym_RPAREN,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [108623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COLON,
    ACTIONS(4103), 1,
      anon_sym_LPAREN,
    STATE(2511), 1,
      sym_override,
  [108636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4105), 1,
      anon_sym_RBRACK,
    ACTIONS(4107), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4109), 1,
      anon_sym_RBRACK,
    ACTIONS(4111), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [108671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 1,
      anon_sym_SEMI,
    ACTIONS(4115), 1,
      sym__newline,
    STATE(2148), 1,
      aux_sym__simple_statements_repeat1,
  [108684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 1,
      anon_sym_RPAREN,
    ACTIONS(2804), 1,
      anon_sym_COMMA,
    STATE(2150), 1,
      aux_sym_argument_list_repeat1,
  [108697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 1,
      anon_sym_RPAREN,
    ACTIONS(4119), 1,
      anon_sym_COMMA,
    STATE(2151), 1,
      aux_sym_argument_list_repeat1,
  [108710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_RBRACE,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [108723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4123), 1,
      anon_sym_SEMI,
    ACTIONS(4125), 1,
      sym__newline,
    STATE(2038), 1,
      aux_sym__simple_statements_repeat1,
  [108736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 1,
      anon_sym_RBRACK,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    STATE(2155), 1,
      aux_sym_subscript_repeat1,
  [108749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_RPAREN,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    STATE(2107), 1,
      aux_sym__parameters_repeat1,
  [108762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(4129), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [108775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 1,
      anon_sym_RBRACK,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    STATE(2177), 1,
      aux_sym_subscript_repeat1,
  [108788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(4131), 1,
      anon_sym_RBRACK,
    STATE(2200), 1,
      aux_sym_type_parameter_repeat1,
  [108801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_RBRACE,
    ACTIONS(4133), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [108814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RPAREN,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [108827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 1,
      anon_sym_RPAREN,
    ACTIONS(2808), 1,
      anon_sym_COMMA,
    STATE(2182), 1,
      aux_sym_argument_list_repeat1,
  [108840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
    ACTIONS(3269), 1,
      anon_sym_COMMA,
    STATE(2167), 1,
      aux_sym_dictionary_repeat1,
  [108853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      sym__newline,
    STATE(2185), 1,
      aux_sym__simple_statements_repeat1,
  [108866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_LPAREN,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    STATE(2145), 1,
      aux_sym_override_repeat1,
  [108879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2834), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [108892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2715), 3,
      sym__concat,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [108901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    ACTIONS(4139), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [108914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [108923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 1,
      anon_sym_RBRACK,
    ACTIONS(4143), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 1,
      anon_sym_RBRACK,
    ACTIONS(4147), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [108949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_DOT,
    ACTIONS(3578), 1,
      anon_sym_PIPE,
    ACTIONS(4149), 1,
      anon_sym_COLON,
  [108962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    ACTIONS(4151), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [108975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_RBRACE,
    ACTIONS(3296), 1,
      anon_sym_COMMA,
    STATE(2175), 1,
      aux_sym_dictionary_repeat1,
  [108988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_RPAREN,
    ACTIONS(4153), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [109001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(4155), 1,
      anon_sym_RBRACE,
    STATE(2375), 1,
      sym_format_specifier,
  [109014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_RBRACK,
    ACTIONS(4157), 1,
      anon_sym_COMMA,
    STATE(2184), 1,
      aux_sym__collection_elements_repeat1,
  [109027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(423), 1,
      sym__newline,
    ACTIONS(4160), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [109040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(441), 1,
      sym__newline,
    ACTIONS(4162), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym__simple_statements_repeat1,
  [109053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 1,
      anon_sym_RPAREN,
    ACTIONS(4164), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [109066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    ACTIONS(4166), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [109079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4168), 1,
      anon_sym_RBRACK,
    ACTIONS(4170), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [109092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4172), 1,
      anon_sym_RBRACK,
    ACTIONS(4174), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_subscript_repeat1,
  [109105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      anon_sym_RPAREN,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(2187), 1,
      aux_sym_argument_list_repeat1,
  [109118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2814), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [109131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_COLON,
    ACTIONS(4176), 1,
      anon_sym_COMMA,
    STATE(2193), 1,
      aux_sym_with_clause_repeat1,
  [109144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RBRACK,
    ACTIONS(2754), 1,
      anon_sym_COMMA,
    STATE(2133), 1,
      aux_sym__collection_elements_repeat1,
  [109157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(4179), 1,
      anon_sym_RBRACK,
    STATE(2200), 1,
      aux_sym_type_parameter_repeat1,
  [109170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    ACTIONS(4181), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_argument_list_repeat1,
  [109183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(4183), 1,
      anon_sym_in,
    STATE(2027), 1,
      aux_sym_pattern_list_repeat1,
  [109196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3302), 1,
      sym_python_identifier,
    STATE(1943), 1,
      sym_dotted_name,
    STATE(2140), 1,
      sym_aliased_import,
  [109209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_COMMA,
    ACTIONS(2842), 1,
      anon_sym_RPAREN,
    STATE(2127), 1,
      aux_sym__collection_elements_repeat1,
  [109222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3645), 1,
      anon_sym_RBRACK,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    STATE(2200), 1,
      aux_sym_type_parameter_repeat1,
  [109235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(4188), 1,
      anon_sym_RBRACE,
    STATE(2538), 1,
      sym_format_specifier,
  [109248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3183), 1,
      anon_sym_RBRACK,
    ACTIONS(3185), 1,
      anon_sym_COMMA,
    STATE(2190), 1,
      aux_sym_subscript_repeat1,
  [109261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4190), 1,
      anon_sym_SEMI,
    ACTIONS(4192), 1,
      sym__newline,
    STATE(2186), 1,
      aux_sym__simple_statements_repeat1,
  [109274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 1,
      anon_sym_RBRACE,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(2206), 1,
      aux_sym_dictionary_repeat1,
  [109287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_RPAREN,
    ACTIONS(4194), 1,
      anon_sym_COMMA,
    STATE(1991), 1,
      aux_sym_with_clause_repeat1,
  [109300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_RBRACE,
    ACTIONS(4196), 1,
      anon_sym_COMMA,
    STATE(2131), 1,
      aux_sym_dictionary_repeat1,
  [109313] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4200), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(4198), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [109324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4202), 1,
      anon_sym_RBRACE,
    ACTIONS(4204), 1,
      sym_identifier,
  [109334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4076), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [109342] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4206), 1,
      aux_sym_recipe_token1,
    ACTIONS(4208), 1,
      anon_sym_NULL,
  [109352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4210), 1,
      anon_sym_LPAREN,
    STATE(2249), 1,
      sym_parameters,
  [109370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [109378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 1,
      anon_sym_RBRACE,
    ACTIONS(4214), 1,
      sym_identifier,
  [109388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 2,
      sym__newline,
      anon_sym_SEMI,
  [109396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [109404] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4220), 1,
      aux_sym_recipe_token1,
    ACTIONS(4222), 1,
      anon_sym_NULL,
  [109414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [109422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109438] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4226), 1,
      aux_sym_recipe_token1,
    ACTIONS(4228), 1,
      anon_sym_NULL,
  [109448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 2,
      anon_sym_import,
      anon_sym_DOT,
  [109464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      sym_identifier,
    STATE(1949), 1,
      aux_sym_export_functions_statement_repeat1,
  [109474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4232), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [109482] = 3,
    ACTIONS(1551), 1,
      aux_sym_recipe_token1,
    ACTIONS(1553), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [109500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [109508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3811), 2,
      sym__newline,
      anon_sym_SEMI,
  [109516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [109524] = 3,
    ACTIONS(1527), 1,
      aux_sym_recipe_token1,
    ACTIONS(1529), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4234), 1,
      anon_sym_python,
    ACTIONS(4236), 1,
      sym_identifier,
  [109544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 1,
      anon_sym_LPAREN,
    ACTIONS(4240), 1,
      sym_identifier,
  [109554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      sym_identifier,
    STATE(1961), 1,
      aux_sym_export_functions_statement_repeat1,
  [109564] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4244), 2,
      anon_sym_noexec,
      aux_sym_variable_flag_token1,
  [109572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 2,
      sym__newline,
      anon_sym_SEMI,
  [109580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [109588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [109596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [109604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 2,
      sym__newline,
      anon_sym_SEMI,
  [109612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_RBRACE,
    ACTIONS(4250), 1,
      sym_identifier,
  [109622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 2,
      sym__newline,
      anon_sym_SEMI,
  [109630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [109638] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4252), 1,
      aux_sym_recipe_token1,
    ACTIONS(4254), 1,
      anon_sym_NULL,
  [109648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109656] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4256), 1,
      aux_sym_recipe_token1,
    ACTIONS(4258), 1,
      anon_sym_NULL,
  [109666] = 3,
    ACTIONS(1547), 1,
      aux_sym_recipe_token1,
    ACTIONS(1549), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [109684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4262), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_DASH_GT,
  [109694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109702] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4266), 2,
      anon_sym_noexec,
      aux_sym_variable_flag_token1,
  [109710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [109718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [109726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      sym__concat,
    STATE(1517), 1,
      aux_sym_concatenation_repeat1,
  [109736] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4268), 1,
      aux_sym_recipe_token1,
    ACTIONS(4270), 1,
      anon_sym_NULL,
  [109746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 2,
      anon_sym_COLON,
      anon_sym_DQUOTE,
  [109754] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4272), 1,
      aux_sym_recipe_token1,
    ACTIONS(4274), 1,
      anon_sym_NULL,
  [109764] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4276), 1,
      aux_sym_recipe_token1,
    ACTIONS(4278), 1,
      anon_sym_NULL,
  [109774] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4280), 1,
      aux_sym_recipe_token1,
    ACTIONS(4282), 1,
      anon_sym_NULL,
  [109784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4284), 2,
      sym__newline,
      anon_sym_SEMI,
  [109792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4286), 1,
      anon_sym_RBRACE,
    ACTIONS(4288), 1,
      sym_identifier,
  [109802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 2,
      sym__newline,
      anon_sym_SEMI,
  [109810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 2,
      sym__newline,
      anon_sym_SEMI,
  [109818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4294), 1,
      anon_sym_RBRACE,
    ACTIONS(4296), 1,
      sym_identifier,
  [109828] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4298), 1,
      aux_sym_recipe_token1,
    ACTIONS(4300), 1,
      anon_sym_NULL,
  [109838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 2,
      sym__newline,
      anon_sym_SEMI,
  [109846] = 3,
    ACTIONS(1555), 1,
      aux_sym_recipe_token1,
    ACTIONS(1557), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109856] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4304), 1,
      aux_sym_recipe_token1,
    ACTIONS(4306), 1,
      anon_sym_NULL,
  [109866] = 3,
    ACTIONS(1777), 1,
      aux_sym_recipe_token1,
    ACTIONS(1779), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109876] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4308), 1,
      aux_sym_recipe_token1,
    ACTIONS(4310), 1,
      anon_sym_NULL,
  [109886] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4312), 1,
      aux_sym_recipe_token1,
    ACTIONS(4314), 1,
      anon_sym_NULL,
  [109896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4316), 1,
      anon_sym_COLON,
    ACTIONS(4318), 1,
      anon_sym_DASH_GT,
  [109906] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4320), 1,
      aux_sym_recipe_token1,
    ACTIONS(4322), 1,
      anon_sym_NULL,
  [109916] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4324), 1,
      aux_sym_recipe_token1,
    ACTIONS(4326), 1,
      anon_sym_NULL,
  [109926] = 3,
    ACTIONS(1523), 1,
      aux_sym_recipe_token1,
    ACTIONS(1525), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109936] = 3,
    ACTIONS(2582), 1,
      aux_sym_recipe_token1,
    ACTIONS(2584), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [109962] = 3,
    ACTIONS(1749), 1,
      aux_sym_recipe_token1,
    ACTIONS(1751), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [109972] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4328), 1,
      aux_sym_recipe_token1,
    ACTIONS(4330), 1,
      anon_sym_NULL,
  [109982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    ACTIONS(4332), 1,
      sym_identifier,
  [109992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 2,
      sym__newline,
      anon_sym_SEMI,
  [110000] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4334), 1,
      aux_sym_recipe_token1,
    ACTIONS(4336), 1,
      anon_sym_NULL,
  [110010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4210), 1,
      anon_sym_LPAREN,
    STATE(2272), 1,
      sym_parameters,
  [110020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 2,
      sym__newline,
      anon_sym_SEMI,
  [110036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4338), 1,
      anon_sym_COMMA,
    STATE(1807), 1,
      aux_sym_pattern_list_repeat1,
  [110046] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4340), 2,
      anon_sym_noexec,
      aux_sym_variable_flag_token1,
  [110054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 2,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [110062] = 3,
    ACTIONS(1733), 1,
      aux_sym_recipe_token1,
    ACTIONS(1735), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [110072] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4342), 1,
      aux_sym_recipe_token1,
    ACTIONS(4344), 1,
      anon_sym_NULL,
  [110082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3420), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [110106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3279), 1,
      sym__concat,
    STATE(1944), 1,
      aux_sym_concatenation_repeat1,
  [110116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_RBRACE,
    ACTIONS(4350), 1,
      sym_identifier,
  [110126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4352), 2,
      sym__newline,
      anon_sym_SEMI,
  [110134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [110142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4354), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4356), 2,
      sym__newline,
      anon_sym_SEMI,
  [110158] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4358), 1,
      aux_sym_recipe_token1,
    ACTIONS(4360), 1,
      anon_sym_NULL,
  [110168] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4362), 1,
      aux_sym_recipe_token1,
    ACTIONS(4364), 1,
      anon_sym_NULL,
  [110178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [110186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4366), 2,
      sym__newline,
      anon_sym_SEMI,
  [110194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4368), 2,
      sym__newline,
      anon_sym_SEMI,
  [110202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [110218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4354), 2,
      anon_sym_COLON,
      anon_sym_COMMA,
  [110226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4370), 1,
      sym_identifier,
    STATE(1940), 1,
      aux_sym_export_functions_statement_repeat1,
  [110236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4372), 1,
      sym_identifier,
    STATE(1937), 1,
      aux_sym_export_functions_statement_repeat1,
  [110246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4374), 2,
      sym__newline,
      anon_sym_SEMI,
  [110254] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4376), 1,
      aux_sym_recipe_token1,
    ACTIONS(4378), 1,
      anon_sym_NULL,
  [110264] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4380), 1,
      aux_sym_recipe_token1,
    ACTIONS(4382), 1,
      anon_sym_NULL,
  [110274] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4384), 1,
      aux_sym_recipe_token1,
    ACTIONS(4386), 1,
      anon_sym_NULL,
  [110284] = 3,
    ACTIONS(1773), 1,
      aux_sym_recipe_token1,
    ACTIONS(1775), 1,
      anon_sym_NULL,
    ACTIONS(2594), 1,
      sym_comment,
  [110294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [110310] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(2909), 1,
      anon_sym_NULL,
    ACTIONS(2911), 1,
      aux_sym_recipe_token1,
  [110320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4388), 2,
      sym__newline,
      anon_sym_SEMI,
  [110328] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4390), 1,
      aux_sym_recipe_token1,
    ACTIONS(4392), 1,
      anon_sym_NULL,
  [110338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4394), 2,
      sym__newline,
      anon_sym_SEMI,
  [110362] = 3,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4396), 1,
      aux_sym_recipe_token1,
    ACTIONS(4398), 1,
      anon_sym_NULL,
  [110372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 1,
      anon_sym_RBRACK,
  [110379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4402), 1,
      anon_sym_COLON_EQ,
  [110386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_COLON_EQ,
  [110393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 1,
      anon_sym_RBRACE,
  [110400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_RBRACK,
  [110407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_RBRACK,
  [110414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_RPAREN,
  [110421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_RBRACE,
  [110428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4414), 1,
      anon_sym_RBRACE,
  [110435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4416), 1,
      anon_sym_COLON_EQ,
  [110442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4418), 1,
      anon_sym_COLON,
  [110449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4420), 1,
      sym_python_identifier,
  [110456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 1,
      anon_sym_in,
  [110463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_COLON,
  [110470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 1,
      anon_sym_RPAREN,
  [110477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4428), 1,
      anon_sym_RBRACK,
  [110484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
  [110491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 1,
      sym_python_identifier,
  [110498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      anon_sym_in,
  [110505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 1,
      anon_sym_RBRACE,
  [110512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_RBRACE,
  [110519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4438), 1,
      anon_sym_RBRACE,
  [110526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4440), 1,
      anon_sym_RPAREN,
  [110533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4442), 1,
      anon_sym_COLON_EQ,
  [110540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_RPAREN,
  [110547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 1,
      anon_sym_RBRACE,
  [110554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4444), 1,
      anon_sym_RBRACE,
  [110561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4446), 1,
      anon_sym_RBRACE,
  [110568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_RBRACE,
  [110575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4450), 1,
      sym_identifier,
  [110582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4452), 1,
      anon_sym_RPAREN,
  [110589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4454), 1,
      anon_sym_RBRACE,
  [110596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4456), 1,
      anon_sym_COLON,
  [110603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4458), 1,
      sym_python_identifier,
  [110610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4460), 1,
      anon_sym_RPAREN,
  [110617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_RPAREN,
  [110624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4464), 1,
      anon_sym_COLON,
  [110631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      sym_python_identifier,
  [110638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4468), 1,
      sym_python_identifier,
  [110645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_COLON,
  [110652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_in,
  [110659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_RBRACK,
  [110666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
  [110673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4478), 1,
      anon_sym_RPAREN,
  [110680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_RBRACE,
  [110687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      sym_python_identifier,
  [110694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_RBRACE,
  [110701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 1,
      anon_sym_RPAREN,
  [110708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_RPAREN,
  [110715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4486), 1,
      anon_sym_RBRACE,
  [110722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 1,
      anon_sym_RBRACE,
  [110729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_RPAREN,
  [110736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4492), 1,
      anon_sym_COLON_EQ,
  [110743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 1,
      anon_sym_RPAREN,
  [110750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 1,
      anon_sym_RBRACK,
  [110757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 1,
      anon_sym_RBRACE,
  [110764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_RPAREN,
  [110771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 1,
      anon_sym_RBRACE,
  [110778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_RBRACE,
  [110785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_RBRACE,
  [110792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4504), 1,
      sym_python_identifier,
  [110799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_COLON_EQ,
  [110806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4508), 1,
      anon_sym_COLON,
  [110813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_RPAREN,
  [110820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      sym_python_identifier,
  [110827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_in,
  [110834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 1,
      anon_sym_LBRACE,
  [110841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 1,
      anon_sym_in,
  [110848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4516), 1,
      anon_sym_RBRACK,
  [110855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
  [110862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4520), 1,
      anon_sym_RPAREN,
  [110869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_RPAREN,
  [110876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_RBRACE,
  [110883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 1,
      anon_sym_RBRACE,
  [110890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      anon_sym_RBRACE,
  [110897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 1,
      anon_sym_RBRACE,
  [110904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 1,
      anon_sym_RBRACK,
  [110911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2810), 1,
      anon_sym_RPAREN,
  [110918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_RBRACK,
  [110925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 1,
      anon_sym_RPAREN,
  [110932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 1,
      anon_sym_LPAREN,
  [110939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_RBRACK,
  [110946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4540), 1,
      sym_python_identifier,
  [110953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 1,
      anon_sym_RBRACE,
  [110960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 1,
      sym_python_identifier,
  [110967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 1,
      anon_sym_in,
  [110974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 1,
      anon_sym_RBRACE,
  [110981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 1,
      anon_sym_in,
  [110988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym_python_identifier,
  [110995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_RBRACE,
  [111002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_RPAREN,
  [111009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_COLON,
  [111016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_RBRACE,
  [111023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      sym_python_identifier,
  [111030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_COLON,
  [111037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      sym_identifier,
  [111044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4568), 1,
      anon_sym_RBRACE,
  [111051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3242), 1,
      anon_sym_RBRACE,
  [111058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4570), 1,
      anon_sym_RBRACE,
  [111065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_RBRACE,
  [111072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 1,
      anon_sym_RPAREN,
  [111079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_RBRACE,
  [111086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4576), 1,
      anon_sym_COLON_EQ,
  [111093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4578), 1,
      anon_sym_RBRACK,
  [111100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4580), 1,
      anon_sym_COLON,
  [111107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      sym_python_identifier,
  [111114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_in,
  [111121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_DQUOTE,
  [111128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_RBRACE,
  [111135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_RBRACE,
  [111142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3304), 1,
      anon_sym_RBRACE,
  [111149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 1,
      anon_sym_RPAREN,
  [111156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4590), 1,
      anon_sym_RBRACE,
  [111163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4592), 1,
      sym_python_identifier,
  [111170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4594), 1,
      anon_sym_RBRACK,
  [111177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4596), 1,
      sym_python_identifier,
  [111184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4598), 1,
      anon_sym_RPAREN,
  [111191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4600), 1,
      anon_sym_RBRACK,
  [111198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4602), 1,
      anon_sym_COLON,
  [111205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4604), 1,
      sym_python_identifier,
  [111212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4606), 1,
      anon_sym_RBRACK,
  [111219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_LPAREN,
  [111226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4610), 1,
      anon_sym_LBRACE,
  [111233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4612), 1,
      anon_sym_COLON_EQ,
  [111240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_in,
  [111247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4616), 1,
      anon_sym_COLON_EQ,
  [111254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_COLON,
  [111261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 1,
      sym_python_identifier,
  [111268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4622), 1,
      anon_sym_in,
  [111275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_RBRACK,
  [111282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_in,
  [111289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_RBRACE,
  [111296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_RBRACE,
  [111303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4632), 1,
      anon_sym_COLON,
  [111310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_in,
  [111317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4634), 1,
      anon_sym_for,
  [111324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4636), 1,
      anon_sym_RBRACE,
  [111331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4638), 1,
      ts_builtin_sym_end,
  [111338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4640), 1,
      sym_python_identifier,
  [111345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_RBRACK,
  [111352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 1,
      anon_sym_RBRACK,
  [111359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      anon_sym_RBRACE,
  [111366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      anon_sym_RBRACE,
  [111373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      anon_sym_RPAREN,
  [111380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_COLON,
  [111387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4652), 1,
      anon_sym_RBRACK,
  [111394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 1,
      anon_sym_LBRACE,
  [111401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_COLON,
  [111408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_RBRACE,
  [111415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4658), 1,
      anon_sym_RBRACK,
  [111422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4660), 1,
      anon_sym_LBRACE,
  [111429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4662), 1,
      anon_sym_COLON,
  [111436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3215), 1,
      anon_sym_COLON,
  [111443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4664), 1,
      anon_sym_COLON,
  [111450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4666), 1,
      anon_sym_RPAREN,
  [111457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4668), 1,
      anon_sym_RBRACE,
  [111464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      anon_sym_RBRACE,
  [111471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4672), 1,
      sym_python_identifier,
  [111478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 1,
      anon_sym_RBRACE,
  [111485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_in,
  [111492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4674), 1,
      sym_python_identifier,
  [111499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4676), 1,
      anon_sym_RBRACK,
  [111506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3872), 1,
      anon_sym_in,
  [111513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym_python_identifier,
  [111520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      anon_sym_RPAREN,
  [111527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4680), 1,
      anon_sym_COLON,
  [111534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4682), 1,
      anon_sym_COLON,
  [111541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4684), 1,
      anon_sym_import,
  [111548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4686), 1,
      anon_sym_RPAREN,
  [111555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_RPAREN,
  [111562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4690), 1,
      anon_sym_RBRACE,
  [111569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      sym_python_identifier,
  [111576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_RPAREN,
  [111583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_RBRACE,
  [111590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 1,
      anon_sym_RBRACE,
  [111597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_RBRACE,
  [111604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      sym_python_identifier,
  [111611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4702), 1,
      sym_python_identifier,
  [111618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4704), 1,
      anon_sym_LBRACE,
  [111625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4706), 1,
      anon_sym_RPAREN,
  [111632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4708), 1,
      anon_sym_RPAREN,
  [111639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3851), 1,
      anon_sym_in,
  [111646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_LBRACE,
  [111653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_RBRACK,
  [111660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_in,
  [111667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4714), 1,
      anon_sym_RPAREN,
  [111674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 1,
      anon_sym_LPAREN,
  [111681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_COLON,
  [111688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 1,
      anon_sym_in,
  [111695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4722), 1,
      sym_python_identifier,
  [111702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 1,
      anon_sym_COLON,
  [111709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_LBRACE,
  [111716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_import,
  [111723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4730), 1,
      sym_identifier,
  [111730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      sym_identifier,
  [111737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4734), 1,
      anon_sym_RBRACE,
  [111744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_RBRACE,
  [111751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 1,
      anon_sym_RBRACE,
  [111758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 1,
      anon_sym_RBRACE,
  [111765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4740), 1,
      sym_identifier,
  [111772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4742), 1,
      sym_python_identifier,
  [111779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 1,
      anon_sym_RPAREN,
  [111786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4746), 1,
      anon_sym_RPAREN,
  [111793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_import,
  [111800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      anon_sym_RBRACK,
  [111807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 1,
      anon_sym_COLON,
  [111814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      anon_sym_RPAREN,
  [111821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_COLON_EQ,
  [111828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4756), 1,
      anon_sym_COLON,
  [111835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      anon_sym_EQ,
  [111842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      anon_sym_RBRACE,
  [111849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_RBRACK,
  [111856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4764), 1,
      anon_sym_RBRACE,
  [111863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
  [111870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4768), 1,
      sym_identifier,
  [111877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4770), 1,
      anon_sym_RBRACK,
  [111884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 1,
      anon_sym_COLON,
  [111891] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4772), 1,
      aux_sym_include_directive_token1,
  [111898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4774), 1,
      sym_python_identifier,
  [111905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 1,
      anon_sym_RPAREN,
  [111912] = 2,
    ACTIONS(2594), 1,
      sym_comment,
    ACTIONS(4776), 1,
      aux_sym_include_directive_token1,
  [111919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4778), 1,
      anon_sym_RBRACE,
  [111926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_in,
  [111933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4780), 1,
      anon_sym_RPAREN,
  [111940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4782), 1,
      anon_sym_RBRACE,
  [111947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4784), 1,
      anon_sym_RBRACE,
  [111954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4786), 1,
      anon_sym_COLON,
  [111961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      sym_python_identifier,
  [111968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      anon_sym_for,
  [111975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4792), 1,
      anon_sym_for,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(128)] = 0,
  [SMALL_STATE(129)] = 124,
  [SMALL_STATE(130)] = 252,
  [SMALL_STATE(131)] = 382,
  [SMALL_STATE(132)] = 512,
  [SMALL_STATE(133)] = 640,
  [SMALL_STATE(134)] = 764,
  [SMALL_STATE(135)] = 894,
  [SMALL_STATE(136)] = 1022,
  [SMALL_STATE(137)] = 1150,
  [SMALL_STATE(138)] = 1278,
  [SMALL_STATE(139)] = 1406,
  [SMALL_STATE(140)] = 1538,
  [SMALL_STATE(141)] = 1666,
  [SMALL_STATE(142)] = 1796,
  [SMALL_STATE(143)] = 1926,
  [SMALL_STATE(144)] = 2054,
  [SMALL_STATE(145)] = 2182,
  [SMALL_STATE(146)] = 2310,
  [SMALL_STATE(147)] = 2438,
  [SMALL_STATE(148)] = 2568,
  [SMALL_STATE(149)] = 2696,
  [SMALL_STATE(150)] = 2824,
  [SMALL_STATE(151)] = 2952,
  [SMALL_STATE(152)] = 3080,
  [SMALL_STATE(153)] = 3208,
  [SMALL_STATE(154)] = 3338,
  [SMALL_STATE(155)] = 3466,
  [SMALL_STATE(156)] = 3594,
  [SMALL_STATE(157)] = 3722,
  [SMALL_STATE(158)] = 3854,
  [SMALL_STATE(159)] = 3978,
  [SMALL_STATE(160)] = 4108,
  [SMALL_STATE(161)] = 4238,
  [SMALL_STATE(162)] = 4347,
  [SMALL_STATE(163)] = 4456,
  [SMALL_STATE(164)] = 4576,
  [SMALL_STATE(165)] = 4696,
  [SMALL_STATE(166)] = 4811,
  [SMALL_STATE(167)] = 4926,
  [SMALL_STATE(168)] = 5045,
  [SMALL_STATE(169)] = 5164,
  [SMALL_STATE(170)] = 5279,
  [SMALL_STATE(171)] = 5394,
  [SMALL_STATE(172)] = 5509,
  [SMALL_STATE(173)] = 5624,
  [SMALL_STATE(174)] = 5731,
  [SMALL_STATE(175)] = 5838,
  [SMALL_STATE(176)] = 5953,
  [SMALL_STATE(177)] = 6068,
  [SMALL_STATE(178)] = 6183,
  [SMALL_STATE(179)] = 6302,
  [SMALL_STATE(180)] = 6417,
  [SMALL_STATE(181)] = 6532,
  [SMALL_STATE(182)] = 6651,
  [SMALL_STATE(183)] = 6770,
  [SMALL_STATE(184)] = 6889,
  [SMALL_STATE(185)] = 7004,
  [SMALL_STATE(186)] = 7119,
  [SMALL_STATE(187)] = 7234,
  [SMALL_STATE(188)] = 7349,
  [SMALL_STATE(189)] = 7464,
  [SMALL_STATE(190)] = 7583,
  [SMALL_STATE(191)] = 7704,
  [SMALL_STATE(192)] = 7819,
  [SMALL_STATE(193)] = 7938,
  [SMALL_STATE(194)] = 8053,
  [SMALL_STATE(195)] = 8168,
  [SMALL_STATE(196)] = 8284,
  [SMALL_STATE(197)] = 8400,
  [SMALL_STATE(198)] = 8516,
  [SMALL_STATE(199)] = 8632,
  [SMALL_STATE(200)] = 8748,
  [SMALL_STATE(201)] = 8864,
  [SMALL_STATE(202)] = 8980,
  [SMALL_STATE(203)] = 9100,
  [SMALL_STATE(204)] = 9216,
  [SMALL_STATE(205)] = 9332,
  [SMALL_STATE(206)] = 9448,
  [SMALL_STATE(207)] = 9566,
  [SMALL_STATE(208)] = 9682,
  [SMALL_STATE(209)] = 9798,
  [SMALL_STATE(210)] = 9914,
  [SMALL_STATE(211)] = 10034,
  [SMALL_STATE(212)] = 10150,
  [SMALL_STATE(213)] = 10268,
  [SMALL_STATE(214)] = 10388,
  [SMALL_STATE(215)] = 10504,
  [SMALL_STATE(216)] = 10620,
  [SMALL_STATE(217)] = 10740,
  [SMALL_STATE(218)] = 10858,
  [SMALL_STATE(219)] = 10974,
  [SMALL_STATE(220)] = 11090,
  [SMALL_STATE(221)] = 11206,
  [SMALL_STATE(222)] = 11322,
  [SMALL_STATE(223)] = 11438,
  [SMALL_STATE(224)] = 11554,
  [SMALL_STATE(225)] = 11672,
  [SMALL_STATE(226)] = 11788,
  [SMALL_STATE(227)] = 11904,
  [SMALL_STATE(228)] = 12020,
  [SMALL_STATE(229)] = 12136,
  [SMALL_STATE(230)] = 12256,
  [SMALL_STATE(231)] = 12372,
  [SMALL_STATE(232)] = 12488,
  [SMALL_STATE(233)] = 12604,
  [SMALL_STATE(234)] = 12720,
  [SMALL_STATE(235)] = 12836,
  [SMALL_STATE(236)] = 12952,
  [SMALL_STATE(237)] = 13068,
  [SMALL_STATE(238)] = 13184,
  [SMALL_STATE(239)] = 13302,
  [SMALL_STATE(240)] = 13418,
  [SMALL_STATE(241)] = 13534,
  [SMALL_STATE(242)] = 13650,
  [SMALL_STATE(243)] = 13766,
  [SMALL_STATE(244)] = 13882,
  [SMALL_STATE(245)] = 14000,
  [SMALL_STATE(246)] = 14120,
  [SMALL_STATE(247)] = 14238,
  [SMALL_STATE(248)] = 14354,
  [SMALL_STATE(249)] = 14472,
  [SMALL_STATE(250)] = 14585,
  [SMALL_STATE(251)] = 14698,
  [SMALL_STATE(252)] = 14811,
  [SMALL_STATE(253)] = 14924,
  [SMALL_STATE(254)] = 15023,
  [SMALL_STATE(255)] = 15136,
  [SMALL_STATE(256)] = 15249,
  [SMALL_STATE(257)] = 15358,
  [SMALL_STATE(258)] = 15471,
  [SMALL_STATE(259)] = 15584,
  [SMALL_STATE(260)] = 15693,
  [SMALL_STATE(261)] = 15806,
  [SMALL_STATE(262)] = 15919,
  [SMALL_STATE(263)] = 16032,
  [SMALL_STATE(264)] = 16145,
  [SMALL_STATE(265)] = 16258,
  [SMALL_STATE(266)] = 16357,
  [SMALL_STATE(267)] = 16470,
  [SMALL_STATE(268)] = 16583,
  [SMALL_STATE(269)] = 16696,
  [SMALL_STATE(270)] = 16809,
  [SMALL_STATE(271)] = 16922,
  [SMALL_STATE(272)] = 17035,
  [SMALL_STATE(273)] = 17147,
  [SMALL_STATE(274)] = 17259,
  [SMALL_STATE(275)] = 17371,
  [SMALL_STATE(276)] = 17483,
  [SMALL_STATE(277)] = 17595,
  [SMALL_STATE(278)] = 17707,
  [SMALL_STATE(279)] = 17817,
  [SMALL_STATE(280)] = 17929,
  [SMALL_STATE(281)] = 18041,
  [SMALL_STATE(282)] = 18153,
  [SMALL_STATE(283)] = 18265,
  [SMALL_STATE(284)] = 18377,
  [SMALL_STATE(285)] = 18487,
  [SMALL_STATE(286)] = 18599,
  [SMALL_STATE(287)] = 18711,
  [SMALL_STATE(288)] = 18823,
  [SMALL_STATE(289)] = 18935,
  [SMALL_STATE(290)] = 19047,
  [SMALL_STATE(291)] = 19157,
  [SMALL_STATE(292)] = 19269,
  [SMALL_STATE(293)] = 19381,
  [SMALL_STATE(294)] = 19493,
  [SMALL_STATE(295)] = 19605,
  [SMALL_STATE(296)] = 19716,
  [SMALL_STATE(297)] = 19825,
  [SMALL_STATE(298)] = 19936,
  [SMALL_STATE(299)] = 20047,
  [SMALL_STATE(300)] = 20158,
  [SMALL_STATE(301)] = 20269,
  [SMALL_STATE(302)] = 20380,
  [SMALL_STATE(303)] = 20489,
  [SMALL_STATE(304)] = 20600,
  [SMALL_STATE(305)] = 20709,
  [SMALL_STATE(306)] = 20820,
  [SMALL_STATE(307)] = 20931,
  [SMALL_STATE(308)] = 21042,
  [SMALL_STATE(309)] = 21153,
  [SMALL_STATE(310)] = 21264,
  [SMALL_STATE(311)] = 21375,
  [SMALL_STATE(312)] = 21486,
  [SMALL_STATE(313)] = 21595,
  [SMALL_STATE(314)] = 21706,
  [SMALL_STATE(315)] = 21817,
  [SMALL_STATE(316)] = 21914,
  [SMALL_STATE(317)] = 22023,
  [SMALL_STATE(318)] = 22134,
  [SMALL_STATE(319)] = 22245,
  [SMALL_STATE(320)] = 22356,
  [SMALL_STATE(321)] = 22467,
  [SMALL_STATE(322)] = 22564,
  [SMALL_STATE(323)] = 22675,
  [SMALL_STATE(324)] = 22786,
  [SMALL_STATE(325)] = 22897,
  [SMALL_STATE(326)] = 23008,
  [SMALL_STATE(327)] = 23119,
  [SMALL_STATE(328)] = 23230,
  [SMALL_STATE(329)] = 23341,
  [SMALL_STATE(330)] = 23452,
  [SMALL_STATE(331)] = 23561,
  [SMALL_STATE(332)] = 23672,
  [SMALL_STATE(333)] = 23783,
  [SMALL_STATE(334)] = 23891,
  [SMALL_STATE(335)] = 23997,
  [SMALL_STATE(336)] = 24105,
  [SMALL_STATE(337)] = 24213,
  [SMALL_STATE(338)] = 24321,
  [SMALL_STATE(339)] = 24417,
  [SMALL_STATE(340)] = 24523,
  [SMALL_STATE(341)] = 24619,
  [SMALL_STATE(342)] = 24725,
  [SMALL_STATE(343)] = 24823,
  [SMALL_STATE(344)] = 24929,
  [SMALL_STATE(345)] = 25037,
  [SMALL_STATE(346)] = 25143,
  [SMALL_STATE(347)] = 25249,
  [SMALL_STATE(348)] = 25357,
  [SMALL_STATE(349)] = 25465,
  [SMALL_STATE(350)] = 25561,
  [SMALL_STATE(351)] = 25669,
  [SMALL_STATE(352)] = 25777,
  [SMALL_STATE(353)] = 25883,
  [SMALL_STATE(354)] = 25989,
  [SMALL_STATE(355)] = 26095,
  [SMALL_STATE(356)] = 26201,
  [SMALL_STATE(357)] = 26307,
  [SMALL_STATE(358)] = 26415,
  [SMALL_STATE(359)] = 26521,
  [SMALL_STATE(360)] = 26627,
  [SMALL_STATE(361)] = 26733,
  [SMALL_STATE(362)] = 26841,
  [SMALL_STATE(363)] = 26947,
  [SMALL_STATE(364)] = 27053,
  [SMALL_STATE(365)] = 27159,
  [SMALL_STATE(366)] = 27265,
  [SMALL_STATE(367)] = 27373,
  [SMALL_STATE(368)] = 27481,
  [SMALL_STATE(369)] = 27587,
  [SMALL_STATE(370)] = 27693,
  [SMALL_STATE(371)] = 27799,
  [SMALL_STATE(372)] = 27905,
  [SMALL_STATE(373)] = 28011,
  [SMALL_STATE(374)] = 28107,
  [SMALL_STATE(375)] = 28213,
  [SMALL_STATE(376)] = 28319,
  [SMALL_STATE(377)] = 28427,
  [SMALL_STATE(378)] = 28533,
  [SMALL_STATE(379)] = 28629,
  [SMALL_STATE(380)] = 28735,
  [SMALL_STATE(381)] = 28841,
  [SMALL_STATE(382)] = 28947,
  [SMALL_STATE(383)] = 29045,
  [SMALL_STATE(384)] = 29151,
  [SMALL_STATE(385)] = 29247,
  [SMALL_STATE(386)] = 29355,
  [SMALL_STATE(387)] = 29463,
  [SMALL_STATE(388)] = 29571,
  [SMALL_STATE(389)] = 29676,
  [SMALL_STATE(390)] = 29781,
  [SMALL_STATE(391)] = 29886,
  [SMALL_STATE(392)] = 29991,
  [SMALL_STATE(393)] = 30096,
  [SMALL_STATE(394)] = 30201,
  [SMALL_STATE(395)] = 30306,
  [SMALL_STATE(396)] = 30411,
  [SMALL_STATE(397)] = 30515,
  [SMALL_STATE(398)] = 30617,
  [SMALL_STATE(399)] = 30719,
  [SMALL_STATE(400)] = 30821,
  [SMALL_STATE(401)] = 30923,
  [SMALL_STATE(402)] = 31025,
  [SMALL_STATE(403)] = 31127,
  [SMALL_STATE(404)] = 31229,
  [SMALL_STATE(405)] = 31331,
  [SMALL_STATE(406)] = 31433,
  [SMALL_STATE(407)] = 31535,
  [SMALL_STATE(408)] = 31637,
  [SMALL_STATE(409)] = 31739,
  [SMALL_STATE(410)] = 31841,
  [SMALL_STATE(411)] = 31943,
  [SMALL_STATE(412)] = 32045,
  [SMALL_STATE(413)] = 32147,
  [SMALL_STATE(414)] = 32249,
  [SMALL_STATE(415)] = 32351,
  [SMALL_STATE(416)] = 32453,
  [SMALL_STATE(417)] = 32555,
  [SMALL_STATE(418)] = 32657,
  [SMALL_STATE(419)] = 32759,
  [SMALL_STATE(420)] = 32861,
  [SMALL_STATE(421)] = 32963,
  [SMALL_STATE(422)] = 33065,
  [SMALL_STATE(423)] = 33167,
  [SMALL_STATE(424)] = 33269,
  [SMALL_STATE(425)] = 33371,
  [SMALL_STATE(426)] = 33473,
  [SMALL_STATE(427)] = 33575,
  [SMALL_STATE(428)] = 33677,
  [SMALL_STATE(429)] = 33779,
  [SMALL_STATE(430)] = 33881,
  [SMALL_STATE(431)] = 33983,
  [SMALL_STATE(432)] = 34085,
  [SMALL_STATE(433)] = 34187,
  [SMALL_STATE(434)] = 34289,
  [SMALL_STATE(435)] = 34391,
  [SMALL_STATE(436)] = 34493,
  [SMALL_STATE(437)] = 34595,
  [SMALL_STATE(438)] = 34697,
  [SMALL_STATE(439)] = 34799,
  [SMALL_STATE(440)] = 34901,
  [SMALL_STATE(441)] = 35003,
  [SMALL_STATE(442)] = 35105,
  [SMALL_STATE(443)] = 35207,
  [SMALL_STATE(444)] = 35309,
  [SMALL_STATE(445)] = 35411,
  [SMALL_STATE(446)] = 35513,
  [SMALL_STATE(447)] = 35615,
  [SMALL_STATE(448)] = 35717,
  [SMALL_STATE(449)] = 35819,
  [SMALL_STATE(450)] = 35921,
  [SMALL_STATE(451)] = 36023,
  [SMALL_STATE(452)] = 36125,
  [SMALL_STATE(453)] = 36227,
  [SMALL_STATE(454)] = 36329,
  [SMALL_STATE(455)] = 36431,
  [SMALL_STATE(456)] = 36533,
  [SMALL_STATE(457)] = 36635,
  [SMALL_STATE(458)] = 36739,
  [SMALL_STATE(459)] = 36841,
  [SMALL_STATE(460)] = 36943,
  [SMALL_STATE(461)] = 37045,
  [SMALL_STATE(462)] = 37147,
  [SMALL_STATE(463)] = 37249,
  [SMALL_STATE(464)] = 37351,
  [SMALL_STATE(465)] = 37427,
  [SMALL_STATE(466)] = 37529,
  [SMALL_STATE(467)] = 37631,
  [SMALL_STATE(468)] = 37733,
  [SMALL_STATE(469)] = 37835,
  [SMALL_STATE(470)] = 37939,
  [SMALL_STATE(471)] = 38041,
  [SMALL_STATE(472)] = 38143,
  [SMALL_STATE(473)] = 38245,
  [SMALL_STATE(474)] = 38347,
  [SMALL_STATE(475)] = 38449,
  [SMALL_STATE(476)] = 38551,
  [SMALL_STATE(477)] = 38653,
  [SMALL_STATE(478)] = 38755,
  [SMALL_STATE(479)] = 38847,
  [SMALL_STATE(480)] = 38951,
  [SMALL_STATE(481)] = 39053,
  [SMALL_STATE(482)] = 39155,
  [SMALL_STATE(483)] = 39257,
  [SMALL_STATE(484)] = 39359,
  [SMALL_STATE(485)] = 39451,
  [SMALL_STATE(486)] = 39553,
  [SMALL_STATE(487)] = 39655,
  [SMALL_STATE(488)] = 39757,
  [SMALL_STATE(489)] = 39859,
  [SMALL_STATE(490)] = 39961,
  [SMALL_STATE(491)] = 40063,
  [SMALL_STATE(492)] = 40165,
  [SMALL_STATE(493)] = 40267,
  [SMALL_STATE(494)] = 40369,
  [SMALL_STATE(495)] = 40471,
  [SMALL_STATE(496)] = 40573,
  [SMALL_STATE(497)] = 40675,
  [SMALL_STATE(498)] = 40779,
  [SMALL_STATE(499)] = 40881,
  [SMALL_STATE(500)] = 40983,
  [SMALL_STATE(501)] = 41085,
  [SMALL_STATE(502)] = 41187,
  [SMALL_STATE(503)] = 41289,
  [SMALL_STATE(504)] = 41391,
  [SMALL_STATE(505)] = 41493,
  [SMALL_STATE(506)] = 41595,
  [SMALL_STATE(507)] = 41697,
  [SMALL_STATE(508)] = 41799,
  [SMALL_STATE(509)] = 41901,
  [SMALL_STATE(510)] = 42003,
  [SMALL_STATE(511)] = 42105,
  [SMALL_STATE(512)] = 42207,
  [SMALL_STATE(513)] = 42309,
  [SMALL_STATE(514)] = 42411,
  [SMALL_STATE(515)] = 42513,
  [SMALL_STATE(516)] = 42615,
  [SMALL_STATE(517)] = 42717,
  [SMALL_STATE(518)] = 42819,
  [SMALL_STATE(519)] = 42921,
  [SMALL_STATE(520)] = 42995,
  [SMALL_STATE(521)] = 43097,
  [SMALL_STATE(522)] = 43199,
  [SMALL_STATE(523)] = 43301,
  [SMALL_STATE(524)] = 43403,
  [SMALL_STATE(525)] = 43505,
  [SMALL_STATE(526)] = 43607,
  [SMALL_STATE(527)] = 43709,
  [SMALL_STATE(528)] = 43811,
  [SMALL_STATE(529)] = 43913,
  [SMALL_STATE(530)] = 44017,
  [SMALL_STATE(531)] = 44119,
  [SMALL_STATE(532)] = 44221,
  [SMALL_STATE(533)] = 44323,
  [SMALL_STATE(534)] = 44425,
  [SMALL_STATE(535)] = 44527,
  [SMALL_STATE(536)] = 44629,
  [SMALL_STATE(537)] = 44700,
  [SMALL_STATE(538)] = 44772,
  [SMALL_STATE(539)] = 44842,
  [SMALL_STATE(540)] = 44912,
  [SMALL_STATE(541)] = 44982,
  [SMALL_STATE(542)] = 45052,
  [SMALL_STATE(543)] = 45117,
  [SMALL_STATE(544)] = 45184,
  [SMALL_STATE(545)] = 45251,
  [SMALL_STATE(546)] = 45316,
  [SMALL_STATE(547)] = 45381,
  [SMALL_STATE(548)] = 45437,
  [SMALL_STATE(549)] = 45533,
  [SMALL_STATE(550)] = 45599,
  [SMALL_STATE(551)] = 45655,
  [SMALL_STATE(552)] = 45717,
  [SMALL_STATE(553)] = 45779,
  [SMALL_STATE(554)] = 45839,
  [SMALL_STATE(555)] = 45901,
  [SMALL_STATE(556)] = 45963,
  [SMALL_STATE(557)] = 46023,
  [SMALL_STATE(558)] = 46089,
  [SMALL_STATE(559)] = 46155,
  [SMALL_STATE(560)] = 46211,
  [SMALL_STATE(561)] = 46275,
  [SMALL_STATE(562)] = 46331,
  [SMALL_STATE(563)] = 46397,
  [SMALL_STATE(564)] = 46453,
  [SMALL_STATE(565)] = 46509,
  [SMALL_STATE(566)] = 46565,
  [SMALL_STATE(567)] = 46627,
  [SMALL_STATE(568)] = 46689,
  [SMALL_STATE(569)] = 46749,
  [SMALL_STATE(570)] = 46809,
  [SMALL_STATE(571)] = 46869,
  [SMALL_STATE(572)] = 46931,
  [SMALL_STATE(573)] = 47027,
  [SMALL_STATE(574)] = 47089,
  [SMALL_STATE(575)] = 47150,
  [SMALL_STATE(576)] = 47204,
  [SMALL_STATE(577)] = 47258,
  [SMALL_STATE(578)] = 47312,
  [SMALL_STATE(579)] = 47408,
  [SMALL_STATE(580)] = 47462,
  [SMALL_STATE(581)] = 47516,
  [SMALL_STATE(582)] = 47570,
  [SMALL_STATE(583)] = 47624,
  [SMALL_STATE(584)] = 47678,
  [SMALL_STATE(585)] = 47732,
  [SMALL_STATE(586)] = 47786,
  [SMALL_STATE(587)] = 47840,
  [SMALL_STATE(588)] = 47894,
  [SMALL_STATE(589)] = 47948,
  [SMALL_STATE(590)] = 48002,
  [SMALL_STATE(591)] = 48056,
  [SMALL_STATE(592)] = 48110,
  [SMALL_STATE(593)] = 48164,
  [SMALL_STATE(594)] = 48218,
  [SMALL_STATE(595)] = 48272,
  [SMALL_STATE(596)] = 48368,
  [SMALL_STATE(597)] = 48422,
  [SMALL_STATE(598)] = 48515,
  [SMALL_STATE(599)] = 48568,
  [SMALL_STATE(600)] = 48621,
  [SMALL_STATE(601)] = 48714,
  [SMALL_STATE(602)] = 48771,
  [SMALL_STATE(603)] = 48828,
  [SMALL_STATE(604)] = 48921,
  [SMALL_STATE(605)] = 49014,
  [SMALL_STATE(606)] = 49067,
  [SMALL_STATE(607)] = 49120,
  [SMALL_STATE(608)] = 49213,
  [SMALL_STATE(609)] = 49266,
  [SMALL_STATE(610)] = 49323,
  [SMALL_STATE(611)] = 49380,
  [SMALL_STATE(612)] = 49473,
  [SMALL_STATE(613)] = 49566,
  [SMALL_STATE(614)] = 49623,
  [SMALL_STATE(615)] = 49680,
  [SMALL_STATE(616)] = 49773,
  [SMALL_STATE(617)] = 49826,
  [SMALL_STATE(618)] = 49883,
  [SMALL_STATE(619)] = 49976,
  [SMALL_STATE(620)] = 50069,
  [SMALL_STATE(621)] = 50162,
  [SMALL_STATE(622)] = 50215,
  [SMALL_STATE(623)] = 50308,
  [SMALL_STATE(624)] = 50401,
  [SMALL_STATE(625)] = 50494,
  [SMALL_STATE(626)] = 50547,
  [SMALL_STATE(627)] = 50604,
  [SMALL_STATE(628)] = 50656,
  [SMALL_STATE(629)] = 50746,
  [SMALL_STATE(630)] = 50836,
  [SMALL_STATE(631)] = 50888,
  [SMALL_STATE(632)] = 50978,
  [SMALL_STATE(633)] = 51030,
  [SMALL_STATE(634)] = 51082,
  [SMALL_STATE(635)] = 51134,
  [SMALL_STATE(636)] = 51186,
  [SMALL_STATE(637)] = 51276,
  [SMALL_STATE(638)] = 51328,
  [SMALL_STATE(639)] = 51380,
  [SMALL_STATE(640)] = 51432,
  [SMALL_STATE(641)] = 51484,
  [SMALL_STATE(642)] = 51574,
  [SMALL_STATE(643)] = 51626,
  [SMALL_STATE(644)] = 51716,
  [SMALL_STATE(645)] = 51768,
  [SMALL_STATE(646)] = 51819,
  [SMALL_STATE(647)] = 51870,
  [SMALL_STATE(648)] = 51921,
  [SMALL_STATE(649)] = 51972,
  [SMALL_STATE(650)] = 52023,
  [SMALL_STATE(651)] = 52110,
  [SMALL_STATE(652)] = 52161,
  [SMALL_STATE(653)] = 52212,
  [SMALL_STATE(654)] = 52263,
  [SMALL_STATE(655)] = 52314,
  [SMALL_STATE(656)] = 52365,
  [SMALL_STATE(657)] = 52452,
  [SMALL_STATE(658)] = 52503,
  [SMALL_STATE(659)] = 52554,
  [SMALL_STATE(660)] = 52605,
  [SMALL_STATE(661)] = 52656,
  [SMALL_STATE(662)] = 52707,
  [SMALL_STATE(663)] = 52758,
  [SMALL_STATE(664)] = 52809,
  [SMALL_STATE(665)] = 52860,
  [SMALL_STATE(666)] = 52911,
  [SMALL_STATE(667)] = 52962,
  [SMALL_STATE(668)] = 53013,
  [SMALL_STATE(669)] = 53064,
  [SMALL_STATE(670)] = 53115,
  [SMALL_STATE(671)] = 53166,
  [SMALL_STATE(672)] = 53217,
  [SMALL_STATE(673)] = 53268,
  [SMALL_STATE(674)] = 53319,
  [SMALL_STATE(675)] = 53370,
  [SMALL_STATE(676)] = 53421,
  [SMALL_STATE(677)] = 53472,
  [SMALL_STATE(678)] = 53523,
  [SMALL_STATE(679)] = 53574,
  [SMALL_STATE(680)] = 53625,
  [SMALL_STATE(681)] = 53705,
  [SMALL_STATE(682)] = 53785,
  [SMALL_STATE(683)] = 53865,
  [SMALL_STATE(684)] = 53945,
  [SMALL_STATE(685)] = 54025,
  [SMALL_STATE(686)] = 54105,
  [SMALL_STATE(687)] = 54185,
  [SMALL_STATE(688)] = 54265,
  [SMALL_STATE(689)] = 54345,
  [SMALL_STATE(690)] = 54425,
  [SMALL_STATE(691)] = 54502,
  [SMALL_STATE(692)] = 54579,
  [SMALL_STATE(693)] = 54662,
  [SMALL_STATE(694)] = 54739,
  [SMALL_STATE(695)] = 54816,
  [SMALL_STATE(696)] = 54893,
  [SMALL_STATE(697)] = 54970,
  [SMALL_STATE(698)] = 55047,
  [SMALL_STATE(699)] = 55124,
  [SMALL_STATE(700)] = 55201,
  [SMALL_STATE(701)] = 55284,
  [SMALL_STATE(702)] = 55367,
  [SMALL_STATE(703)] = 55444,
  [SMALL_STATE(704)] = 55521,
  [SMALL_STATE(705)] = 55604,
  [SMALL_STATE(706)] = 55687,
  [SMALL_STATE(707)] = 55770,
  [SMALL_STATE(708)] = 55847,
  [SMALL_STATE(709)] = 55924,
  [SMALL_STATE(710)] = 56001,
  [SMALL_STATE(711)] = 56078,
  [SMALL_STATE(712)] = 56155,
  [SMALL_STATE(713)] = 56232,
  [SMALL_STATE(714)] = 56315,
  [SMALL_STATE(715)] = 56392,
  [SMALL_STATE(716)] = 56469,
  [SMALL_STATE(717)] = 56546,
  [SMALL_STATE(718)] = 56623,
  [SMALL_STATE(719)] = 56706,
  [SMALL_STATE(720)] = 56783,
  [SMALL_STATE(721)] = 56866,
  [SMALL_STATE(722)] = 56943,
  [SMALL_STATE(723)] = 57020,
  [SMALL_STATE(724)] = 57097,
  [SMALL_STATE(725)] = 57180,
  [SMALL_STATE(726)] = 57257,
  [SMALL_STATE(727)] = 57334,
  [SMALL_STATE(728)] = 57411,
  [SMALL_STATE(729)] = 57494,
  [SMALL_STATE(730)] = 57577,
  [SMALL_STATE(731)] = 57654,
  [SMALL_STATE(732)] = 57731,
  [SMALL_STATE(733)] = 57814,
  [SMALL_STATE(734)] = 57891,
  [SMALL_STATE(735)] = 57968,
  [SMALL_STATE(736)] = 58045,
  [SMALL_STATE(737)] = 58122,
  [SMALL_STATE(738)] = 58199,
  [SMALL_STATE(739)] = 58282,
  [SMALL_STATE(740)] = 58359,
  [SMALL_STATE(741)] = 58436,
  [SMALL_STATE(742)] = 58513,
  [SMALL_STATE(743)] = 58590,
  [SMALL_STATE(744)] = 58667,
  [SMALL_STATE(745)] = 58744,
  [SMALL_STATE(746)] = 58827,
  [SMALL_STATE(747)] = 58904,
  [SMALL_STATE(748)] = 58981,
  [SMALL_STATE(749)] = 59064,
  [SMALL_STATE(750)] = 59147,
  [SMALL_STATE(751)] = 59224,
  [SMALL_STATE(752)] = 59301,
  [SMALL_STATE(753)] = 59378,
  [SMALL_STATE(754)] = 59455,
  [SMALL_STATE(755)] = 59532,
  [SMALL_STATE(756)] = 59609,
  [SMALL_STATE(757)] = 59686,
  [SMALL_STATE(758)] = 59763,
  [SMALL_STATE(759)] = 59840,
  [SMALL_STATE(760)] = 59923,
  [SMALL_STATE(761)] = 60000,
  [SMALL_STATE(762)] = 60077,
  [SMALL_STATE(763)] = 60154,
  [SMALL_STATE(764)] = 60237,
  [SMALL_STATE(765)] = 60314,
  [SMALL_STATE(766)] = 60397,
  [SMALL_STATE(767)] = 60474,
  [SMALL_STATE(768)] = 60551,
  [SMALL_STATE(769)] = 60628,
  [SMALL_STATE(770)] = 60705,
  [SMALL_STATE(771)] = 60782,
  [SMALL_STATE(772)] = 60859,
  [SMALL_STATE(773)] = 60936,
  [SMALL_STATE(774)] = 61013,
  [SMALL_STATE(775)] = 61090,
  [SMALL_STATE(776)] = 61167,
  [SMALL_STATE(777)] = 61244,
  [SMALL_STATE(778)] = 61321,
  [SMALL_STATE(779)] = 61398,
  [SMALL_STATE(780)] = 61475,
  [SMALL_STATE(781)] = 61552,
  [SMALL_STATE(782)] = 61629,
  [SMALL_STATE(783)] = 61706,
  [SMALL_STATE(784)] = 61783,
  [SMALL_STATE(785)] = 61860,
  [SMALL_STATE(786)] = 61937,
  [SMALL_STATE(787)] = 62014,
  [SMALL_STATE(788)] = 62097,
  [SMALL_STATE(789)] = 62180,
  [SMALL_STATE(790)] = 62257,
  [SMALL_STATE(791)] = 62334,
  [SMALL_STATE(792)] = 62411,
  [SMALL_STATE(793)] = 62488,
  [SMALL_STATE(794)] = 62565,
  [SMALL_STATE(795)] = 62642,
  [SMALL_STATE(796)] = 62719,
  [SMALL_STATE(797)] = 62796,
  [SMALL_STATE(798)] = 62873,
  [SMALL_STATE(799)] = 62950,
  [SMALL_STATE(800)] = 63027,
  [SMALL_STATE(801)] = 63104,
  [SMALL_STATE(802)] = 63181,
  [SMALL_STATE(803)] = 63258,
  [SMALL_STATE(804)] = 63335,
  [SMALL_STATE(805)] = 63412,
  [SMALL_STATE(806)] = 63489,
  [SMALL_STATE(807)] = 63566,
  [SMALL_STATE(808)] = 63643,
  [SMALL_STATE(809)] = 63720,
  [SMALL_STATE(810)] = 63797,
  [SMALL_STATE(811)] = 63880,
  [SMALL_STATE(812)] = 63957,
  [SMALL_STATE(813)] = 64034,
  [SMALL_STATE(814)] = 64111,
  [SMALL_STATE(815)] = 64188,
  [SMALL_STATE(816)] = 64265,
  [SMALL_STATE(817)] = 64342,
  [SMALL_STATE(818)] = 64419,
  [SMALL_STATE(819)] = 64502,
  [SMALL_STATE(820)] = 64579,
  [SMALL_STATE(821)] = 64656,
  [SMALL_STATE(822)] = 64733,
  [SMALL_STATE(823)] = 64810,
  [SMALL_STATE(824)] = 64887,
  [SMALL_STATE(825)] = 64964,
  [SMALL_STATE(826)] = 65041,
  [SMALL_STATE(827)] = 65118,
  [SMALL_STATE(828)] = 65195,
  [SMALL_STATE(829)] = 65278,
  [SMALL_STATE(830)] = 65355,
  [SMALL_STATE(831)] = 65432,
  [SMALL_STATE(832)] = 65509,
  [SMALL_STATE(833)] = 65586,
  [SMALL_STATE(834)] = 65637,
  [SMALL_STATE(835)] = 65688,
  [SMALL_STATE(836)] = 65739,
  [SMALL_STATE(837)] = 65819,
  [SMALL_STATE(838)] = 65869,
  [SMALL_STATE(839)] = 65919,
  [SMALL_STATE(840)] = 65969,
  [SMALL_STATE(841)] = 66019,
  [SMALL_STATE(842)] = 66099,
  [SMALL_STATE(843)] = 66149,
  [SMALL_STATE(844)] = 66229,
  [SMALL_STATE(845)] = 66279,
  [SMALL_STATE(846)] = 66356,
  [SMALL_STATE(847)] = 66411,
  [SMALL_STATE(848)] = 66460,
  [SMALL_STATE(849)] = 66539,
  [SMALL_STATE(850)] = 66604,
  [SMALL_STATE(851)] = 66683,
  [SMALL_STATE(852)] = 66744,
  [SMALL_STATE(853)] = 66823,
  [SMALL_STATE(854)] = 66872,
  [SMALL_STATE(855)] = 66927,
  [SMALL_STATE(856)] = 66976,
  [SMALL_STATE(857)] = 67039,
  [SMALL_STATE(858)] = 67104,
  [SMALL_STATE(859)] = 67149,
  [SMALL_STATE(860)] = 67226,
  [SMALL_STATE(861)] = 67271,
  [SMALL_STATE(862)] = 67318,
  [SMALL_STATE(863)] = 67365,
  [SMALL_STATE(864)] = 67414,
  [SMALL_STATE(865)] = 67463,
  [SMALL_STATE(866)] = 67530,
  [SMALL_STATE(867)] = 67599,
  [SMALL_STATE(868)] = 67654,
  [SMALL_STATE(869)] = 67713,
  [SMALL_STATE(870)] = 67760,
  [SMALL_STATE(871)] = 67809,
  [SMALL_STATE(872)] = 67878,
  [SMALL_STATE(873)] = 67933,
  [SMALL_STATE(874)] = 68002,
  [SMALL_STATE(875)] = 68071,
  [SMALL_STATE(876)] = 68120,
  [SMALL_STATE(877)] = 68175,
  [SMALL_STATE(878)] = 68230,
  [SMALL_STATE(879)] = 68279,
  [SMALL_STATE(880)] = 68334,
  [SMALL_STATE(881)] = 68383,
  [SMALL_STATE(882)] = 68452,
  [SMALL_STATE(883)] = 68501,
  [SMALL_STATE(884)] = 68556,
  [SMALL_STATE(885)] = 68619,
  [SMALL_STATE(886)] = 68682,
  [SMALL_STATE(887)] = 68747,
  [SMALL_STATE(888)] = 68802,
  [SMALL_STATE(889)] = 68869,
  [SMALL_STATE(890)] = 68924,
  [SMALL_STATE(891)] = 68983,
  [SMALL_STATE(892)] = 69044,
  [SMALL_STATE(893)] = 69113,
  [SMALL_STATE(894)] = 69162,
  [SMALL_STATE(895)] = 69223,
  [SMALL_STATE(896)] = 69272,
  [SMALL_STATE(897)] = 69327,
  [SMALL_STATE(898)] = 69394,
  [SMALL_STATE(899)] = 69449,
  [SMALL_STATE(900)] = 69508,
  [SMALL_STATE(901)] = 69577,
  [SMALL_STATE(902)] = 69646,
  [SMALL_STATE(903)] = 69715,
  [SMALL_STATE(904)] = 69777,
  [SMALL_STATE(905)] = 69821,
  [SMALL_STATE(906)] = 69881,
  [SMALL_STATE(907)] = 69949,
  [SMALL_STATE(908)] = 70007,
  [SMALL_STATE(909)] = 70061,
  [SMALL_STATE(910)] = 70127,
  [SMALL_STATE(911)] = 70191,
  [SMALL_STATE(912)] = 70253,
  [SMALL_STATE(913)] = 70307,
  [SMALL_STATE(914)] = 70367,
  [SMALL_STATE(915)] = 70425,
  [SMALL_STATE(916)] = 70469,
  [SMALL_STATE(917)] = 70519,
  [SMALL_STATE(918)] = 70573,
  [SMALL_STATE(919)] = 70617,
  [SMALL_STATE(920)] = 70661,
  [SMALL_STATE(921)] = 70705,
  [SMALL_STATE(922)] = 70749,
  [SMALL_STATE(923)] = 70793,
  [SMALL_STATE(924)] = 70837,
  [SMALL_STATE(925)] = 70885,
  [SMALL_STATE(926)] = 70951,
  [SMALL_STATE(927)] = 70995,
  [SMALL_STATE(928)] = 71059,
  [SMALL_STATE(929)] = 71107,
  [SMALL_STATE(930)] = 71151,
  [SMALL_STATE(931)] = 71199,
  [SMALL_STATE(932)] = 71247,
  [SMALL_STATE(933)] = 71301,
  [SMALL_STATE(934)] = 71349,
  [SMALL_STATE(935)] = 71393,
  [SMALL_STATE(936)] = 71437,
  [SMALL_STATE(937)] = 71481,
  [SMALL_STATE(938)] = 71527,
  [SMALL_STATE(939)] = 71571,
  [SMALL_STATE(940)] = 71617,
  [SMALL_STATE(941)] = 71661,
  [SMALL_STATE(942)] = 71707,
  [SMALL_STATE(943)] = 71775,
  [SMALL_STATE(944)] = 71843,
  [SMALL_STATE(945)] = 71891,
  [SMALL_STATE(946)] = 71939,
  [SMALL_STATE(947)] = 71983,
  [SMALL_STATE(948)] = 72037,
  [SMALL_STATE(949)] = 72091,
  [SMALL_STATE(950)] = 72137,
  [SMALL_STATE(951)] = 72197,
  [SMALL_STATE(952)] = 72243,
  [SMALL_STATE(953)] = 72311,
  [SMALL_STATE(954)] = 72379,
  [SMALL_STATE(955)] = 72423,
  [SMALL_STATE(956)] = 72471,
  [SMALL_STATE(957)] = 72539,
  [SMALL_STATE(958)] = 72585,
  [SMALL_STATE(959)] = 72639,
  [SMALL_STATE(960)] = 72683,
  [SMALL_STATE(961)] = 72733,
  [SMALL_STATE(962)] = 72801,
  [SMALL_STATE(963)] = 72845,
  [SMALL_STATE(964)] = 72907,
  [SMALL_STATE(965)] = 72971,
  [SMALL_STATE(966)] = 73037,
  [SMALL_STATE(967)] = 73091,
  [SMALL_STATE(968)] = 73149,
  [SMALL_STATE(969)] = 73193,
  [SMALL_STATE(970)] = 73251,
  [SMALL_STATE(971)] = 73319,
  [SMALL_STATE(972)] = 73379,
  [SMALL_STATE(973)] = 73433,
  [SMALL_STATE(974)] = 73477,
  [SMALL_STATE(975)] = 73521,
  [SMALL_STATE(976)] = 73569,
  [SMALL_STATE(977)] = 73619,
  [SMALL_STATE(978)] = 73669,
  [SMALL_STATE(979)] = 73723,
  [SMALL_STATE(980)] = 73773,
  [SMALL_STATE(981)] = 73817,
  [SMALL_STATE(982)] = 73871,
  [SMALL_STATE(983)] = 73937,
  [SMALL_STATE(984)] = 74005,
  [SMALL_STATE(985)] = 74049,
  [SMALL_STATE(986)] = 74113,
  [SMALL_STATE(987)] = 74157,
  [SMALL_STATE(988)] = 74201,
  [SMALL_STATE(989)] = 74249,
  [SMALL_STATE(990)] = 74293,
  [SMALL_STATE(991)] = 74337,
  [SMALL_STATE(992)] = 74381,
  [SMALL_STATE(993)] = 74443,
  [SMALL_STATE(994)] = 74487,
  [SMALL_STATE(995)] = 74531,
  [SMALL_STATE(996)] = 74599,
  [SMALL_STATE(997)] = 74667,
  [SMALL_STATE(998)] = 74711,
  [SMALL_STATE(999)] = 74755,
  [SMALL_STATE(1000)] = 74799,
  [SMALL_STATE(1001)] = 74853,
  [SMALL_STATE(1002)] = 74897,
  [SMALL_STATE(1003)] = 74951,
  [SMALL_STATE(1004)] = 75019,
  [SMALL_STATE(1005)] = 75073,
  [SMALL_STATE(1006)] = 75121,
  [SMALL_STATE(1007)] = 75175,
  [SMALL_STATE(1008)] = 75229,
  [SMALL_STATE(1009)] = 75273,
  [SMALL_STATE(1010)] = 75317,
  [SMALL_STATE(1011)] = 75395,
  [SMALL_STATE(1012)] = 75471,
  [SMALL_STATE(1013)] = 75519,
  [SMALL_STATE(1014)] = 75564,
  [SMALL_STATE(1015)] = 75611,
  [SMALL_STATE(1016)] = 75654,
  [SMALL_STATE(1017)] = 75721,
  [SMALL_STATE(1018)] = 75788,
  [SMALL_STATE(1019)] = 75855,
  [SMALL_STATE(1020)] = 75900,
  [SMALL_STATE(1021)] = 75943,
  [SMALL_STATE(1022)] = 75986,
  [SMALL_STATE(1023)] = 76031,
  [SMALL_STATE(1024)] = 76074,
  [SMALL_STATE(1025)] = 76121,
  [SMALL_STATE(1026)] = 76168,
  [SMALL_STATE(1027)] = 76215,
  [SMALL_STATE(1028)] = 76262,
  [SMALL_STATE(1029)] = 76305,
  [SMALL_STATE(1030)] = 76348,
  [SMALL_STATE(1031)] = 76391,
  [SMALL_STATE(1032)] = 76434,
  [SMALL_STATE(1033)] = 76477,
  [SMALL_STATE(1034)] = 76520,
  [SMALL_STATE(1035)] = 76565,
  [SMALL_STATE(1036)] = 76608,
  [SMALL_STATE(1037)] = 76669,
  [SMALL_STATE(1038)] = 76714,
  [SMALL_STATE(1039)] = 76759,
  [SMALL_STATE(1040)] = 76822,
  [SMALL_STATE(1041)] = 76887,
  [SMALL_STATE(1042)] = 76940,
  [SMALL_STATE(1043)] = 76997,
  [SMALL_STATE(1044)] = 77056,
  [SMALL_STATE(1045)] = 77109,
  [SMALL_STATE(1046)] = 77152,
  [SMALL_STATE(1047)] = 77195,
  [SMALL_STATE(1048)] = 77248,
  [SMALL_STATE(1049)] = 77301,
  [SMALL_STATE(1050)] = 77344,
  [SMALL_STATE(1051)] = 77387,
  [SMALL_STATE(1052)] = 77434,
  [SMALL_STATE(1053)] = 77477,
  [SMALL_STATE(1054)] = 77520,
  [SMALL_STATE(1055)] = 77563,
  [SMALL_STATE(1056)] = 77606,
  [SMALL_STATE(1057)] = 77649,
  [SMALL_STATE(1058)] = 77692,
  [SMALL_STATE(1059)] = 77739,
  [SMALL_STATE(1060)] = 77786,
  [SMALL_STATE(1061)] = 77833,
  [SMALL_STATE(1062)] = 77880,
  [SMALL_STATE(1063)] = 77923,
  [SMALL_STATE(1064)] = 77966,
  [SMALL_STATE(1065)] = 78009,
  [SMALL_STATE(1066)] = 78052,
  [SMALL_STATE(1067)] = 78097,
  [SMALL_STATE(1068)] = 78142,
  [SMALL_STATE(1069)] = 78185,
  [SMALL_STATE(1070)] = 78234,
  [SMALL_STATE(1071)] = 78279,
  [SMALL_STATE(1072)] = 78322,
  [SMALL_STATE(1073)] = 78367,
  [SMALL_STATE(1074)] = 78412,
  [SMALL_STATE(1075)] = 78455,
  [SMALL_STATE(1076)] = 78498,
  [SMALL_STATE(1077)] = 78541,
  [SMALL_STATE(1078)] = 78586,
  [SMALL_STATE(1079)] = 78631,
  [SMALL_STATE(1080)] = 78676,
  [SMALL_STATE(1081)] = 78723,
  [SMALL_STATE(1082)] = 78766,
  [SMALL_STATE(1083)] = 78813,
  [SMALL_STATE(1084)] = 78860,
  [SMALL_STATE(1085)] = 78921,
  [SMALL_STATE(1086)] = 78984,
  [SMALL_STATE(1087)] = 79049,
  [SMALL_STATE(1088)] = 79092,
  [SMALL_STATE(1089)] = 79145,
  [SMALL_STATE(1090)] = 79202,
  [SMALL_STATE(1091)] = 79261,
  [SMALL_STATE(1092)] = 79314,
  [SMALL_STATE(1093)] = 79357,
  [SMALL_STATE(1094)] = 79400,
  [SMALL_STATE(1095)] = 79443,
  [SMALL_STATE(1096)] = 79490,
  [SMALL_STATE(1097)] = 79543,
  [SMALL_STATE(1098)] = 79596,
  [SMALL_STATE(1099)] = 79643,
  [SMALL_STATE(1100)] = 79718,
  [SMALL_STATE(1101)] = 79763,
  [SMALL_STATE(1102)] = 79808,
  [SMALL_STATE(1103)] = 79851,
  [SMALL_STATE(1104)] = 79918,
  [SMALL_STATE(1105)] = 79985,
  [SMALL_STATE(1106)] = 80052,
  [SMALL_STATE(1107)] = 80095,
  [SMALL_STATE(1108)] = 80138,
  [SMALL_STATE(1109)] = 80181,
  [SMALL_STATE(1110)] = 80256,
  [SMALL_STATE(1111)] = 80299,
  [SMALL_STATE(1112)] = 80342,
  [SMALL_STATE(1113)] = 80385,
  [SMALL_STATE(1114)] = 80428,
  [SMALL_STATE(1115)] = 80471,
  [SMALL_STATE(1116)] = 80514,
  [SMALL_STATE(1117)] = 80557,
  [SMALL_STATE(1118)] = 80600,
  [SMALL_STATE(1119)] = 80643,
  [SMALL_STATE(1120)] = 80686,
  [SMALL_STATE(1121)] = 80729,
  [SMALL_STATE(1122)] = 80772,
  [SMALL_STATE(1123)] = 80815,
  [SMALL_STATE(1124)] = 80858,
  [SMALL_STATE(1125)] = 80901,
  [SMALL_STATE(1126)] = 80944,
  [SMALL_STATE(1127)] = 80987,
  [SMALL_STATE(1128)] = 81030,
  [SMALL_STATE(1129)] = 81073,
  [SMALL_STATE(1130)] = 81122,
  [SMALL_STATE(1131)] = 81165,
  [SMALL_STATE(1132)] = 81208,
  [SMALL_STATE(1133)] = 81251,
  [SMALL_STATE(1134)] = 81294,
  [SMALL_STATE(1135)] = 81337,
  [SMALL_STATE(1136)] = 81380,
  [SMALL_STATE(1137)] = 81423,
  [SMALL_STATE(1138)] = 81470,
  [SMALL_STATE(1139)] = 81517,
  [SMALL_STATE(1140)] = 81564,
  [SMALL_STATE(1141)] = 81607,
  [SMALL_STATE(1142)] = 81650,
  [SMALL_STATE(1143)] = 81695,
  [SMALL_STATE(1144)] = 81738,
  [SMALL_STATE(1145)] = 81781,
  [SMALL_STATE(1146)] = 81824,
  [SMALL_STATE(1147)] = 81867,
  [SMALL_STATE(1148)] = 81910,
  [SMALL_STATE(1149)] = 81985,
  [SMALL_STATE(1150)] = 82028,
  [SMALL_STATE(1151)] = 82071,
  [SMALL_STATE(1152)] = 82114,
  [SMALL_STATE(1153)] = 82157,
  [SMALL_STATE(1154)] = 82200,
  [SMALL_STATE(1155)] = 82243,
  [SMALL_STATE(1156)] = 82286,
  [SMALL_STATE(1157)] = 82329,
  [SMALL_STATE(1158)] = 82372,
  [SMALL_STATE(1159)] = 82414,
  [SMALL_STATE(1160)] = 82456,
  [SMALL_STATE(1161)] = 82506,
  [SMALL_STATE(1162)] = 82548,
  [SMALL_STATE(1163)] = 82592,
  [SMALL_STATE(1164)] = 82636,
  [SMALL_STATE(1165)] = 82678,
  [SMALL_STATE(1166)] = 82720,
  [SMALL_STATE(1167)] = 82762,
  [SMALL_STATE(1168)] = 82804,
  [SMALL_STATE(1169)] = 82846,
  [SMALL_STATE(1170)] = 82888,
  [SMALL_STATE(1171)] = 82930,
  [SMALL_STATE(1172)] = 82974,
  [SMALL_STATE(1173)] = 83020,
  [SMALL_STATE(1174)] = 83062,
  [SMALL_STATE(1175)] = 83108,
  [SMALL_STATE(1176)] = 83154,
  [SMALL_STATE(1177)] = 83196,
  [SMALL_STATE(1178)] = 83242,
  [SMALL_STATE(1179)] = 83284,
  [SMALL_STATE(1180)] = 83326,
  [SMALL_STATE(1181)] = 83368,
  [SMALL_STATE(1182)] = 83448,
  [SMALL_STATE(1183)] = 83490,
  [SMALL_STATE(1184)] = 83532,
  [SMALL_STATE(1185)] = 83574,
  [SMALL_STATE(1186)] = 83616,
  [SMALL_STATE(1187)] = 83658,
  [SMALL_STATE(1188)] = 83702,
  [SMALL_STATE(1189)] = 83746,
  [SMALL_STATE(1190)] = 83788,
  [SMALL_STATE(1191)] = 83830,
  [SMALL_STATE(1192)] = 83872,
  [SMALL_STATE(1193)] = 83914,
  [SMALL_STATE(1194)] = 83956,
  [SMALL_STATE(1195)] = 84000,
  [SMALL_STATE(1196)] = 84044,
  [SMALL_STATE(1197)] = 84086,
  [SMALL_STATE(1198)] = 84132,
  [SMALL_STATE(1199)] = 84174,
  [SMALL_STATE(1200)] = 84216,
  [SMALL_STATE(1201)] = 84258,
  [SMALL_STATE(1202)] = 84300,
  [SMALL_STATE(1203)] = 84342,
  [SMALL_STATE(1204)] = 84384,
  [SMALL_STATE(1205)] = 84426,
  [SMALL_STATE(1206)] = 84468,
  [SMALL_STATE(1207)] = 84510,
  [SMALL_STATE(1208)] = 84552,
  [SMALL_STATE(1209)] = 84594,
  [SMALL_STATE(1210)] = 84636,
  [SMALL_STATE(1211)] = 84678,
  [SMALL_STATE(1212)] = 84720,
  [SMALL_STATE(1213)] = 84762,
  [SMALL_STATE(1214)] = 84804,
  [SMALL_STATE(1215)] = 84846,
  [SMALL_STATE(1216)] = 84888,
  [SMALL_STATE(1217)] = 84930,
  [SMALL_STATE(1218)] = 84972,
  [SMALL_STATE(1219)] = 85014,
  [SMALL_STATE(1220)] = 85056,
  [SMALL_STATE(1221)] = 85098,
  [SMALL_STATE(1222)] = 85140,
  [SMALL_STATE(1223)] = 85182,
  [SMALL_STATE(1224)] = 85224,
  [SMALL_STATE(1225)] = 85266,
  [SMALL_STATE(1226)] = 85308,
  [SMALL_STATE(1227)] = 85350,
  [SMALL_STATE(1228)] = 85392,
  [SMALL_STATE(1229)] = 85434,
  [SMALL_STATE(1230)] = 85476,
  [SMALL_STATE(1231)] = 85520,
  [SMALL_STATE(1232)] = 85564,
  [SMALL_STATE(1233)] = 85606,
  [SMALL_STATE(1234)] = 85648,
  [SMALL_STATE(1235)] = 85690,
  [SMALL_STATE(1236)] = 85732,
  [SMALL_STATE(1237)] = 85774,
  [SMALL_STATE(1238)] = 85818,
  [SMALL_STATE(1239)] = 85860,
  [SMALL_STATE(1240)] = 85902,
  [SMALL_STATE(1241)] = 85944,
  [SMALL_STATE(1242)] = 86018,
  [SMALL_STATE(1243)] = 86060,
  [SMALL_STATE(1244)] = 86102,
  [SMALL_STATE(1245)] = 86144,
  [SMALL_STATE(1246)] = 86190,
  [SMALL_STATE(1247)] = 86232,
  [SMALL_STATE(1248)] = 86274,
  [SMALL_STATE(1249)] = 86316,
  [SMALL_STATE(1250)] = 86358,
  [SMALL_STATE(1251)] = 86400,
  [SMALL_STATE(1252)] = 86442,
  [SMALL_STATE(1253)] = 86484,
  [SMALL_STATE(1254)] = 86526,
  [SMALL_STATE(1255)] = 86568,
  [SMALL_STATE(1256)] = 86610,
  [SMALL_STATE(1257)] = 86652,
  [SMALL_STATE(1258)] = 86694,
  [SMALL_STATE(1259)] = 86736,
  [SMALL_STATE(1260)] = 86778,
  [SMALL_STATE(1261)] = 86822,
  [SMALL_STATE(1262)] = 86866,
  [SMALL_STATE(1263)] = 86910,
  [SMALL_STATE(1264)] = 86954,
  [SMALL_STATE(1265)] = 86996,
  [SMALL_STATE(1266)] = 87038,
  [SMALL_STATE(1267)] = 87084,
  [SMALL_STATE(1268)] = 87126,
  [SMALL_STATE(1269)] = 87172,
  [SMALL_STATE(1270)] = 87252,
  [SMALL_STATE(1271)] = 87294,
  [SMALL_STATE(1272)] = 87336,
  [SMALL_STATE(1273)] = 87378,
  [SMALL_STATE(1274)] = 87420,
  [SMALL_STATE(1275)] = 87466,
  [SMALL_STATE(1276)] = 87508,
  [SMALL_STATE(1277)] = 87554,
  [SMALL_STATE(1278)] = 87596,
  [SMALL_STATE(1279)] = 87638,
  [SMALL_STATE(1280)] = 87680,
  [SMALL_STATE(1281)] = 87722,
  [SMALL_STATE(1282)] = 87768,
  [SMALL_STATE(1283)] = 87810,
  [SMALL_STATE(1284)] = 87852,
  [SMALL_STATE(1285)] = 87896,
  [SMALL_STATE(1286)] = 87940,
  [SMALL_STATE(1287)] = 87982,
  [SMALL_STATE(1288)] = 88024,
  [SMALL_STATE(1289)] = 88070,
  [SMALL_STATE(1290)] = 88114,
  [SMALL_STATE(1291)] = 88156,
  [SMALL_STATE(1292)] = 88198,
  [SMALL_STATE(1293)] = 88240,
  [SMALL_STATE(1294)] = 88282,
  [SMALL_STATE(1295)] = 88328,
  [SMALL_STATE(1296)] = 88374,
  [SMALL_STATE(1297)] = 88424,
  [SMALL_STATE(1298)] = 88470,
  [SMALL_STATE(1299)] = 88512,
  [SMALL_STATE(1300)] = 88554,
  [SMALL_STATE(1301)] = 88596,
  [SMALL_STATE(1302)] = 88640,
  [SMALL_STATE(1303)] = 88684,
  [SMALL_STATE(1304)] = 88726,
  [SMALL_STATE(1305)] = 88768,
  [SMALL_STATE(1306)] = 88810,
  [SMALL_STATE(1307)] = 88852,
  [SMALL_STATE(1308)] = 88894,
  [SMALL_STATE(1309)] = 88936,
  [SMALL_STATE(1310)] = 88978,
  [SMALL_STATE(1311)] = 89020,
  [SMALL_STATE(1312)] = 89062,
  [SMALL_STATE(1313)] = 89104,
  [SMALL_STATE(1314)] = 89146,
  [SMALL_STATE(1315)] = 89188,
  [SMALL_STATE(1316)] = 89230,
  [SMALL_STATE(1317)] = 89272,
  [SMALL_STATE(1318)] = 89314,
  [SMALL_STATE(1319)] = 89356,
  [SMALL_STATE(1320)] = 89398,
  [SMALL_STATE(1321)] = 89440,
  [SMALL_STATE(1322)] = 89482,
  [SMALL_STATE(1323)] = 89524,
  [SMALL_STATE(1324)] = 89566,
  [SMALL_STATE(1325)] = 89609,
  [SMALL_STATE(1326)] = 89650,
  [SMALL_STATE(1327)] = 89701,
  [SMALL_STATE(1328)] = 89766,
  [SMALL_STATE(1329)] = 89807,
  [SMALL_STATE(1330)] = 89858,
  [SMALL_STATE(1331)] = 89923,
  [SMALL_STATE(1332)] = 89964,
  [SMALL_STATE(1333)] = 90005,
  [SMALL_STATE(1334)] = 90046,
  [SMALL_STATE(1335)] = 90087,
  [SMALL_STATE(1336)] = 90128,
  [SMALL_STATE(1337)] = 90193,
  [SMALL_STATE(1338)] = 90234,
  [SMALL_STATE(1339)] = 90275,
  [SMALL_STATE(1340)] = 90316,
  [SMALL_STATE(1341)] = 90357,
  [SMALL_STATE(1342)] = 90398,
  [SMALL_STATE(1343)] = 90439,
  [SMALL_STATE(1344)] = 90480,
  [SMALL_STATE(1345)] = 90523,
  [SMALL_STATE(1346)] = 90566,
  [SMALL_STATE(1347)] = 90609,
  [SMALL_STATE(1348)] = 90650,
  [SMALL_STATE(1349)] = 90691,
  [SMALL_STATE(1350)] = 90732,
  [SMALL_STATE(1351)] = 90773,
  [SMALL_STATE(1352)] = 90814,
  [SMALL_STATE(1353)] = 90863,
  [SMALL_STATE(1354)] = 90906,
  [SMALL_STATE(1355)] = 90947,
  [SMALL_STATE(1356)] = 90990,
  [SMALL_STATE(1357)] = 91031,
  [SMALL_STATE(1358)] = 91072,
  [SMALL_STATE(1359)] = 91113,
  [SMALL_STATE(1360)] = 91172,
  [SMALL_STATE(1361)] = 91215,
  [SMALL_STATE(1362)] = 91276,
  [SMALL_STATE(1363)] = 91333,
  [SMALL_STATE(1364)] = 91374,
  [SMALL_STATE(1365)] = 91415,
  [SMALL_STATE(1366)] = 91456,
  [SMALL_STATE(1367)] = 91497,
  [SMALL_STATE(1368)] = 91540,
  [SMALL_STATE(1369)] = 91583,
  [SMALL_STATE(1370)] = 91624,
  [SMALL_STATE(1371)] = 91687,
  [SMALL_STATE(1372)] = 91728,
  [SMALL_STATE(1373)] = 91773,
  [SMALL_STATE(1374)] = 91824,
  [SMALL_STATE(1375)] = 91865,
  [SMALL_STATE(1376)] = 91916,
  [SMALL_STATE(1377)] = 91957,
  [SMALL_STATE(1378)] = 92004,
  [SMALL_STATE(1379)] = 92049,
  [SMALL_STATE(1380)] = 92094,
  [SMALL_STATE(1381)] = 92135,
  [SMALL_STATE(1382)] = 92190,
  [SMALL_STATE(1383)] = 92231,
  [SMALL_STATE(1384)] = 92273,
  [SMALL_STATE(1385)] = 92315,
  [SMALL_STATE(1386)] = 92357,
  [SMALL_STATE(1387)] = 92397,
  [SMALL_STATE(1388)] = 92437,
  [SMALL_STATE(1389)] = 92477,
  [SMALL_STATE(1390)] = 92517,
  [SMALL_STATE(1391)] = 92557,
  [SMALL_STATE(1392)] = 92597,
  [SMALL_STATE(1393)] = 92637,
  [SMALL_STATE(1394)] = 92679,
  [SMALL_STATE(1395)] = 92721,
  [SMALL_STATE(1396)] = 92761,
  [SMALL_STATE(1397)] = 92803,
  [SMALL_STATE(1398)] = 92843,
  [SMALL_STATE(1399)] = 92883,
  [SMALL_STATE(1400)] = 92925,
  [SMALL_STATE(1401)] = 92967,
  [SMALL_STATE(1402)] = 93009,
  [SMALL_STATE(1403)] = 93049,
  [SMALL_STATE(1404)] = 93089,
  [SMALL_STATE(1405)] = 93128,
  [SMALL_STATE(1406)] = 93159,
  [SMALL_STATE(1407)] = 93198,
  [SMALL_STATE(1408)] = 93229,
  [SMALL_STATE(1409)] = 93260,
  [SMALL_STATE(1410)] = 93291,
  [SMALL_STATE(1411)] = 93322,
  [SMALL_STATE(1412)] = 93353,
  [SMALL_STATE(1413)] = 93391,
  [SMALL_STATE(1414)] = 93427,
  [SMALL_STATE(1415)] = 93463,
  [SMALL_STATE(1416)] = 93501,
  [SMALL_STATE(1417)] = 93539,
  [SMALL_STATE(1418)] = 93577,
  [SMALL_STATE(1419)] = 93615,
  [SMALL_STATE(1420)] = 93653,
  [SMALL_STATE(1421)] = 93688,
  [SMALL_STATE(1422)] = 93717,
  [SMALL_STATE(1423)] = 93754,
  [SMALL_STATE(1424)] = 93783,
  [SMALL_STATE(1425)] = 93812,
  [SMALL_STATE(1426)] = 93841,
  [SMALL_STATE(1427)] = 93878,
  [SMALL_STATE(1428)] = 93915,
  [SMALL_STATE(1429)] = 93944,
  [SMALL_STATE(1430)] = 93979,
  [SMALL_STATE(1431)] = 94008,
  [SMALL_STATE(1432)] = 94037,
  [SMALL_STATE(1433)] = 94074,
  [SMALL_STATE(1434)] = 94103,
  [SMALL_STATE(1435)] = 94139,
  [SMALL_STATE(1436)] = 94185,
  [SMALL_STATE(1437)] = 94213,
  [SMALL_STATE(1438)] = 94241,
  [SMALL_STATE(1439)] = 94287,
  [SMALL_STATE(1440)] = 94315,
  [SMALL_STATE(1441)] = 94343,
  [SMALL_STATE(1442)] = 94371,
  [SMALL_STATE(1443)] = 94399,
  [SMALL_STATE(1444)] = 94427,
  [SMALL_STATE(1445)] = 94451,
  [SMALL_STATE(1446)] = 94479,
  [SMALL_STATE(1447)] = 94507,
  [SMALL_STATE(1448)] = 94535,
  [SMALL_STATE(1449)] = 94581,
  [SMALL_STATE(1450)] = 94625,
  [SMALL_STATE(1451)] = 94665,
  [SMALL_STATE(1452)] = 94693,
  [SMALL_STATE(1453)] = 94721,
  [SMALL_STATE(1454)] = 94757,
  [SMALL_STATE(1455)] = 94795,
  [SMALL_STATE(1456)] = 94819,
  [SMALL_STATE(1457)] = 94843,
  [SMALL_STATE(1458)] = 94871,
  [SMALL_STATE(1459)] = 94899,
  [SMALL_STATE(1460)] = 94927,
  [SMALL_STATE(1461)] = 94955,
  [SMALL_STATE(1462)] = 94995,
  [SMALL_STATE(1463)] = 95031,
  [SMALL_STATE(1464)] = 95059,
  [SMALL_STATE(1465)] = 95105,
  [SMALL_STATE(1466)] = 95151,
  [SMALL_STATE(1467)] = 95179,
  [SMALL_STATE(1468)] = 95207,
  [SMALL_STATE(1469)] = 95253,
  [SMALL_STATE(1470)] = 95281,
  [SMALL_STATE(1471)] = 95309,
  [SMALL_STATE(1472)] = 95355,
  [SMALL_STATE(1473)] = 95401,
  [SMALL_STATE(1474)] = 95429,
  [SMALL_STATE(1475)] = 95475,
  [SMALL_STATE(1476)] = 95521,
  [SMALL_STATE(1477)] = 95557,
  [SMALL_STATE(1478)] = 95603,
  [SMALL_STATE(1479)] = 95627,
  [SMALL_STATE(1480)] = 95655,
  [SMALL_STATE(1481)] = 95697,
  [SMALL_STATE(1482)] = 95725,
  [SMALL_STATE(1483)] = 95770,
  [SMALL_STATE(1484)] = 95801,
  [SMALL_STATE(1485)] = 95846,
  [SMALL_STATE(1486)] = 95891,
  [SMALL_STATE(1487)] = 95936,
  [SMALL_STATE(1488)] = 95981,
  [SMALL_STATE(1489)] = 96026,
  [SMALL_STATE(1490)] = 96051,
  [SMALL_STATE(1491)] = 96096,
  [SMALL_STATE(1492)] = 96141,
  [SMALL_STATE(1493)] = 96186,
  [SMALL_STATE(1494)] = 96209,
  [SMALL_STATE(1495)] = 96254,
  [SMALL_STATE(1496)] = 96299,
  [SMALL_STATE(1497)] = 96322,
  [SMALL_STATE(1498)] = 96349,
  [SMALL_STATE(1499)] = 96394,
  [SMALL_STATE(1500)] = 96423,
  [SMALL_STATE(1501)] = 96446,
  [SMALL_STATE(1502)] = 96469,
  [SMALL_STATE(1503)] = 96500,
  [SMALL_STATE(1504)] = 96541,
  [SMALL_STATE(1505)] = 96568,
  [SMALL_STATE(1506)] = 96613,
  [SMALL_STATE(1507)] = 96645,
  [SMALL_STATE(1508)] = 96677,
  [SMALL_STATE(1509)] = 96719,
  [SMALL_STATE(1510)] = 96748,
  [SMALL_STATE(1511)] = 96787,
  [SMALL_STATE(1512)] = 96826,
  [SMALL_STATE(1513)] = 96865,
  [SMALL_STATE(1514)] = 96900,
  [SMALL_STATE(1515)] = 96925,
  [SMALL_STATE(1516)] = 96964,
  [SMALL_STATE(1517)] = 96994,
  [SMALL_STATE(1518)] = 97020,
  [SMALL_STATE(1519)] = 97056,
  [SMALL_STATE(1520)] = 97082,
  [SMALL_STATE(1521)] = 97118,
  [SMALL_STATE(1522)] = 97148,
  [SMALL_STATE(1523)] = 97169,
  [SMALL_STATE(1524)] = 97198,
  [SMALL_STATE(1525)] = 97219,
  [SMALL_STATE(1526)] = 97240,
  [SMALL_STATE(1527)] = 97264,
  [SMALL_STATE(1528)] = 97282,
  [SMALL_STATE(1529)] = 97322,
  [SMALL_STATE(1530)] = 97362,
  [SMALL_STATE(1531)] = 97402,
  [SMALL_STATE(1532)] = 97442,
  [SMALL_STATE(1533)] = 97482,
  [SMALL_STATE(1534)] = 97500,
  [SMALL_STATE(1535)] = 97540,
  [SMALL_STATE(1536)] = 97580,
  [SMALL_STATE(1537)] = 97620,
  [SMALL_STATE(1538)] = 97638,
  [SMALL_STATE(1539)] = 97675,
  [SMALL_STATE(1540)] = 97712,
  [SMALL_STATE(1541)] = 97749,
  [SMALL_STATE(1542)] = 97786,
  [SMALL_STATE(1543)] = 97817,
  [SMALL_STATE(1544)] = 97854,
  [SMALL_STATE(1545)] = 97891,
  [SMALL_STATE(1546)] = 97928,
  [SMALL_STATE(1547)] = 97965,
  [SMALL_STATE(1548)] = 98002,
  [SMALL_STATE(1549)] = 98039,
  [SMALL_STATE(1550)] = 98076,
  [SMALL_STATE(1551)] = 98101,
  [SMALL_STATE(1552)] = 98138,
  [SMALL_STATE(1553)] = 98165,
  [SMALL_STATE(1554)] = 98202,
  [SMALL_STATE(1555)] = 98239,
  [SMALL_STATE(1556)] = 98276,
  [SMALL_STATE(1557)] = 98313,
  [SMALL_STATE(1558)] = 98340,
  [SMALL_STATE(1559)] = 98377,
  [SMALL_STATE(1560)] = 98414,
  [SMALL_STATE(1561)] = 98437,
  [SMALL_STATE(1562)] = 98464,
  [SMALL_STATE(1563)] = 98489,
  [SMALL_STATE(1564)] = 98512,
  [SMALL_STATE(1565)] = 98549,
  [SMALL_STATE(1566)] = 98586,
  [SMALL_STATE(1567)] = 98605,
  [SMALL_STATE(1568)] = 98628,
  [SMALL_STATE(1569)] = 98651,
  [SMALL_STATE(1570)] = 98672,
  [SMALL_STATE(1571)] = 98709,
  [SMALL_STATE(1572)] = 98732,
  [SMALL_STATE(1573)] = 98755,
  [SMALL_STATE(1574)] = 98792,
  [SMALL_STATE(1575)] = 98829,
  [SMALL_STATE(1576)] = 98866,
  [SMALL_STATE(1577)] = 98891,
  [SMALL_STATE(1578)] = 98928,
  [SMALL_STATE(1579)] = 98954,
  [SMALL_STATE(1580)] = 98972,
  [SMALL_STATE(1581)] = 98998,
  [SMALL_STATE(1582)] = 99014,
  [SMALL_STATE(1583)] = 99030,
  [SMALL_STATE(1584)] = 99054,
  [SMALL_STATE(1585)] = 99080,
  [SMALL_STATE(1586)] = 99096,
  [SMALL_STATE(1587)] = 99122,
  [SMALL_STATE(1588)] = 99148,
  [SMALL_STATE(1589)] = 99174,
  [SMALL_STATE(1590)] = 99192,
  [SMALL_STATE(1591)] = 99218,
  [SMALL_STATE(1592)] = 99244,
  [SMALL_STATE(1593)] = 99260,
  [SMALL_STATE(1594)] = 99288,
  [SMALL_STATE(1595)] = 99314,
  [SMALL_STATE(1596)] = 99338,
  [SMALL_STATE(1597)] = 99364,
  [SMALL_STATE(1598)] = 99390,
  [SMALL_STATE(1599)] = 99414,
  [SMALL_STATE(1600)] = 99432,
  [SMALL_STATE(1601)] = 99458,
  [SMALL_STATE(1602)] = 99482,
  [SMALL_STATE(1603)] = 99508,
  [SMALL_STATE(1604)] = 99534,
  [SMALL_STATE(1605)] = 99550,
  [SMALL_STATE(1606)] = 99576,
  [SMALL_STATE(1607)] = 99600,
  [SMALL_STATE(1608)] = 99620,
  [SMALL_STATE(1609)] = 99646,
  [SMALL_STATE(1610)] = 99672,
  [SMALL_STATE(1611)] = 99698,
  [SMALL_STATE(1612)] = 99720,
  [SMALL_STATE(1613)] = 99746,
  [SMALL_STATE(1614)] = 99774,
  [SMALL_STATE(1615)] = 99800,
  [SMALL_STATE(1616)] = 99826,
  [SMALL_STATE(1617)] = 99844,
  [SMALL_STATE(1618)] = 99860,
  [SMALL_STATE(1619)] = 99886,
  [SMALL_STATE(1620)] = 99903,
  [SMALL_STATE(1621)] = 99920,
  [SMALL_STATE(1622)] = 99939,
  [SMALL_STATE(1623)] = 99962,
  [SMALL_STATE(1624)] = 99979,
  [SMALL_STATE(1625)] = 100002,
  [SMALL_STATE(1626)] = 100017,
  [SMALL_STATE(1627)] = 100040,
  [SMALL_STATE(1628)] = 100061,
  [SMALL_STATE(1629)] = 100084,
  [SMALL_STATE(1630)] = 100099,
  [SMALL_STATE(1631)] = 100114,
  [SMALL_STATE(1632)] = 100129,
  [SMALL_STATE(1633)] = 100152,
  [SMALL_STATE(1634)] = 100173,
  [SMALL_STATE(1635)] = 100190,
  [SMALL_STATE(1636)] = 100205,
  [SMALL_STATE(1637)] = 100224,
  [SMALL_STATE(1638)] = 100243,
  [SMALL_STATE(1639)] = 100260,
  [SMALL_STATE(1640)] = 100283,
  [SMALL_STATE(1641)] = 100306,
  [SMALL_STATE(1642)] = 100335,
  [SMALL_STATE(1643)] = 100358,
  [SMALL_STATE(1644)] = 100379,
  [SMALL_STATE(1645)] = 100402,
  [SMALL_STATE(1646)] = 100425,
  [SMALL_STATE(1647)] = 100448,
  [SMALL_STATE(1648)] = 100471,
  [SMALL_STATE(1649)] = 100492,
  [SMALL_STATE(1650)] = 100515,
  [SMALL_STATE(1651)] = 100538,
  [SMALL_STATE(1652)] = 100553,
  [SMALL_STATE(1653)] = 100572,
  [SMALL_STATE(1654)] = 100595,
  [SMALL_STATE(1655)] = 100612,
  [SMALL_STATE(1656)] = 100633,
  [SMALL_STATE(1657)] = 100652,
  [SMALL_STATE(1658)] = 100675,
  [SMALL_STATE(1659)] = 100693,
  [SMALL_STATE(1660)] = 100713,
  [SMALL_STATE(1661)] = 100739,
  [SMALL_STATE(1662)] = 100759,
  [SMALL_STATE(1663)] = 100781,
  [SMALL_STATE(1664)] = 100801,
  [SMALL_STATE(1665)] = 100827,
  [SMALL_STATE(1666)] = 100843,
  [SMALL_STATE(1667)] = 100863,
  [SMALL_STATE(1668)] = 100879,
  [SMALL_STATE(1669)] = 100899,
  [SMALL_STATE(1670)] = 100921,
  [SMALL_STATE(1671)] = 100941,
  [SMALL_STATE(1672)] = 100957,
  [SMALL_STATE(1673)] = 100977,
  [SMALL_STATE(1674)] = 100993,
  [SMALL_STATE(1675)] = 101015,
  [SMALL_STATE(1676)] = 101043,
  [SMALL_STATE(1677)] = 101069,
  [SMALL_STATE(1678)] = 101091,
  [SMALL_STATE(1679)] = 101113,
  [SMALL_STATE(1680)] = 101139,
  [SMALL_STATE(1681)] = 101155,
  [SMALL_STATE(1682)] = 101177,
  [SMALL_STATE(1683)] = 101205,
  [SMALL_STATE(1684)] = 101227,
  [SMALL_STATE(1685)] = 101251,
  [SMALL_STATE(1686)] = 101279,
  [SMALL_STATE(1687)] = 101295,
  [SMALL_STATE(1688)] = 101323,
  [SMALL_STATE(1689)] = 101345,
  [SMALL_STATE(1690)] = 101371,
  [SMALL_STATE(1691)] = 101397,
  [SMALL_STATE(1692)] = 101417,
  [SMALL_STATE(1693)] = 101439,
  [SMALL_STATE(1694)] = 101467,
  [SMALL_STATE(1695)] = 101483,
  [SMALL_STATE(1696)] = 101507,
  [SMALL_STATE(1697)] = 101527,
  [SMALL_STATE(1698)] = 101551,
  [SMALL_STATE(1699)] = 101567,
  [SMALL_STATE(1700)] = 101595,
  [SMALL_STATE(1701)] = 101623,
  [SMALL_STATE(1702)] = 101643,
  [SMALL_STATE(1703)] = 101671,
  [SMALL_STATE(1704)] = 101695,
  [SMALL_STATE(1705)] = 101715,
  [SMALL_STATE(1706)] = 101739,
  [SMALL_STATE(1707)] = 101765,
  [SMALL_STATE(1708)] = 101787,
  [SMALL_STATE(1709)] = 101809,
  [SMALL_STATE(1710)] = 101825,
  [SMALL_STATE(1711)] = 101841,
  [SMALL_STATE(1712)] = 101863,
  [SMALL_STATE(1713)] = 101879,
  [SMALL_STATE(1714)] = 101901,
  [SMALL_STATE(1715)] = 101925,
  [SMALL_STATE(1716)] = 101941,
  [SMALL_STATE(1717)] = 101959,
  [SMALL_STATE(1718)] = 101985,
  [SMALL_STATE(1719)] = 102001,
  [SMALL_STATE(1720)] = 102029,
  [SMALL_STATE(1721)] = 102047,
  [SMALL_STATE(1722)] = 102067,
  [SMALL_STATE(1723)] = 102087,
  [SMALL_STATE(1724)] = 102107,
  [SMALL_STATE(1725)] = 102135,
  [SMALL_STATE(1726)] = 102158,
  [SMALL_STATE(1727)] = 102183,
  [SMALL_STATE(1728)] = 102208,
  [SMALL_STATE(1729)] = 102223,
  [SMALL_STATE(1730)] = 102248,
  [SMALL_STATE(1731)] = 102269,
  [SMALL_STATE(1732)] = 102292,
  [SMALL_STATE(1733)] = 102311,
  [SMALL_STATE(1734)] = 102336,
  [SMALL_STATE(1735)] = 102357,
  [SMALL_STATE(1736)] = 102376,
  [SMALL_STATE(1737)] = 102397,
  [SMALL_STATE(1738)] = 102418,
  [SMALL_STATE(1739)] = 102437,
  [SMALL_STATE(1740)] = 102462,
  [SMALL_STATE(1741)] = 102483,
  [SMALL_STATE(1742)] = 102508,
  [SMALL_STATE(1743)] = 102529,
  [SMALL_STATE(1744)] = 102554,
  [SMALL_STATE(1745)] = 102569,
  [SMALL_STATE(1746)] = 102590,
  [SMALL_STATE(1747)] = 102611,
  [SMALL_STATE(1748)] = 102636,
  [SMALL_STATE(1749)] = 102661,
  [SMALL_STATE(1750)] = 102686,
  [SMALL_STATE(1751)] = 102711,
  [SMALL_STATE(1752)] = 102730,
  [SMALL_STATE(1753)] = 102751,
  [SMALL_STATE(1754)] = 102774,
  [SMALL_STATE(1755)] = 102789,
  [SMALL_STATE(1756)] = 102810,
  [SMALL_STATE(1757)] = 102835,
  [SMALL_STATE(1758)] = 102860,
  [SMALL_STATE(1759)] = 102881,
  [SMALL_STATE(1760)] = 102906,
  [SMALL_STATE(1761)] = 102929,
  [SMALL_STATE(1762)] = 102950,
  [SMALL_STATE(1763)] = 102969,
  [SMALL_STATE(1764)] = 102985,
  [SMALL_STATE(1765)] = 103001,
  [SMALL_STATE(1766)] = 103013,
  [SMALL_STATE(1767)] = 103035,
  [SMALL_STATE(1768)] = 103047,
  [SMALL_STATE(1769)] = 103067,
  [SMALL_STATE(1770)] = 103087,
  [SMALL_STATE(1771)] = 103103,
  [SMALL_STATE(1772)] = 103123,
  [SMALL_STATE(1773)] = 103143,
  [SMALL_STATE(1774)] = 103163,
  [SMALL_STATE(1775)] = 103179,
  [SMALL_STATE(1776)] = 103199,
  [SMALL_STATE(1777)] = 103215,
  [SMALL_STATE(1778)] = 103229,
  [SMALL_STATE(1779)] = 103243,
  [SMALL_STATE(1780)] = 103255,
  [SMALL_STATE(1781)] = 103275,
  [SMALL_STATE(1782)] = 103295,
  [SMALL_STATE(1783)] = 103315,
  [SMALL_STATE(1784)] = 103331,
  [SMALL_STATE(1785)] = 103343,
  [SMALL_STATE(1786)] = 103361,
  [SMALL_STATE(1787)] = 103383,
  [SMALL_STATE(1788)] = 103403,
  [SMALL_STATE(1789)] = 103423,
  [SMALL_STATE(1790)] = 103439,
  [SMALL_STATE(1791)] = 103459,
  [SMALL_STATE(1792)] = 103479,
  [SMALL_STATE(1793)] = 103499,
  [SMALL_STATE(1794)] = 103519,
  [SMALL_STATE(1795)] = 103533,
  [SMALL_STATE(1796)] = 103551,
  [SMALL_STATE(1797)] = 103563,
  [SMALL_STATE(1798)] = 103583,
  [SMALL_STATE(1799)] = 103599,
  [SMALL_STATE(1800)] = 103615,
  [SMALL_STATE(1801)] = 103635,
  [SMALL_STATE(1802)] = 103651,
  [SMALL_STATE(1803)] = 103671,
  [SMALL_STATE(1804)] = 103693,
  [SMALL_STATE(1805)] = 103713,
  [SMALL_STATE(1806)] = 103731,
  [SMALL_STATE(1807)] = 103747,
  [SMALL_STATE(1808)] = 103763,
  [SMALL_STATE(1809)] = 103775,
  [SMALL_STATE(1810)] = 103795,
  [SMALL_STATE(1811)] = 103807,
  [SMALL_STATE(1812)] = 103827,
  [SMALL_STATE(1813)] = 103843,
  [SMALL_STATE(1814)] = 103859,
  [SMALL_STATE(1815)] = 103879,
  [SMALL_STATE(1816)] = 103899,
  [SMALL_STATE(1817)] = 103917,
  [SMALL_STATE(1818)] = 103939,
  [SMALL_STATE(1819)] = 103951,
  [SMALL_STATE(1820)] = 103971,
  [SMALL_STATE(1821)] = 103993,
  [SMALL_STATE(1822)] = 104009,
  [SMALL_STATE(1823)] = 104021,
  [SMALL_STATE(1824)] = 104041,
  [SMALL_STATE(1825)] = 104061,
  [SMALL_STATE(1826)] = 104081,
  [SMALL_STATE(1827)] = 104097,
  [SMALL_STATE(1828)] = 104111,
  [SMALL_STATE(1829)] = 104133,
  [SMALL_STATE(1830)] = 104147,
  [SMALL_STATE(1831)] = 104161,
  [SMALL_STATE(1832)] = 104175,
  [SMALL_STATE(1833)] = 104187,
  [SMALL_STATE(1834)] = 104201,
  [SMALL_STATE(1835)] = 104217,
  [SMALL_STATE(1836)] = 104233,
  [SMALL_STATE(1837)] = 104249,
  [SMALL_STATE(1838)] = 104269,
  [SMALL_STATE(1839)] = 104281,
  [SMALL_STATE(1840)] = 104293,
  [SMALL_STATE(1841)] = 104313,
  [SMALL_STATE(1842)] = 104329,
  [SMALL_STATE(1843)] = 104349,
  [SMALL_STATE(1844)] = 104361,
  [SMALL_STATE(1845)] = 104377,
  [SMALL_STATE(1846)] = 104393,
  [SMALL_STATE(1847)] = 104405,
  [SMALL_STATE(1848)] = 104425,
  [SMALL_STATE(1849)] = 104445,
  [SMALL_STATE(1850)] = 104461,
  [SMALL_STATE(1851)] = 104480,
  [SMALL_STATE(1852)] = 104499,
  [SMALL_STATE(1853)] = 104516,
  [SMALL_STATE(1854)] = 104527,
  [SMALL_STATE(1855)] = 104546,
  [SMALL_STATE(1856)] = 104563,
  [SMALL_STATE(1857)] = 104582,
  [SMALL_STATE(1858)] = 104601,
  [SMALL_STATE(1859)] = 104618,
  [SMALL_STATE(1860)] = 104637,
  [SMALL_STATE(1861)] = 104648,
  [SMALL_STATE(1862)] = 104659,
  [SMALL_STATE(1863)] = 104670,
  [SMALL_STATE(1864)] = 104681,
  [SMALL_STATE(1865)] = 104700,
  [SMALL_STATE(1866)] = 104711,
  [SMALL_STATE(1867)] = 104730,
  [SMALL_STATE(1868)] = 104741,
  [SMALL_STATE(1869)] = 104758,
  [SMALL_STATE(1870)] = 104769,
  [SMALL_STATE(1871)] = 104780,
  [SMALL_STATE(1872)] = 104797,
  [SMALL_STATE(1873)] = 104812,
  [SMALL_STATE(1874)] = 104823,
  [SMALL_STATE(1875)] = 104842,
  [SMALL_STATE(1876)] = 104861,
  [SMALL_STATE(1877)] = 104872,
  [SMALL_STATE(1878)] = 104883,
  [SMALL_STATE(1879)] = 104898,
  [SMALL_STATE(1880)] = 104913,
  [SMALL_STATE(1881)] = 104924,
  [SMALL_STATE(1882)] = 104941,
  [SMALL_STATE(1883)] = 104960,
  [SMALL_STATE(1884)] = 104975,
  [SMALL_STATE(1885)] = 104986,
  [SMALL_STATE(1886)] = 104997,
  [SMALL_STATE(1887)] = 105016,
  [SMALL_STATE(1888)] = 105035,
  [SMALL_STATE(1889)] = 105054,
  [SMALL_STATE(1890)] = 105073,
  [SMALL_STATE(1891)] = 105084,
  [SMALL_STATE(1892)] = 105099,
  [SMALL_STATE(1893)] = 105110,
  [SMALL_STATE(1894)] = 105121,
  [SMALL_STATE(1895)] = 105132,
  [SMALL_STATE(1896)] = 105151,
  [SMALL_STATE(1897)] = 105168,
  [SMALL_STATE(1898)] = 105185,
  [SMALL_STATE(1899)] = 105204,
  [SMALL_STATE(1900)] = 105215,
  [SMALL_STATE(1901)] = 105234,
  [SMALL_STATE(1902)] = 105253,
  [SMALL_STATE(1903)] = 105264,
  [SMALL_STATE(1904)] = 105277,
  [SMALL_STATE(1905)] = 105296,
  [SMALL_STATE(1906)] = 105311,
  [SMALL_STATE(1907)] = 105326,
  [SMALL_STATE(1908)] = 105343,
  [SMALL_STATE(1909)] = 105354,
  [SMALL_STATE(1910)] = 105371,
  [SMALL_STATE(1911)] = 105390,
  [SMALL_STATE(1912)] = 105409,
  [SMALL_STATE(1913)] = 105428,
  [SMALL_STATE(1914)] = 105439,
  [SMALL_STATE(1915)] = 105450,
  [SMALL_STATE(1916)] = 105461,
  [SMALL_STATE(1917)] = 105478,
  [SMALL_STATE(1918)] = 105489,
  [SMALL_STATE(1919)] = 105506,
  [SMALL_STATE(1920)] = 105517,
  [SMALL_STATE(1921)] = 105536,
  [SMALL_STATE(1922)] = 105555,
  [SMALL_STATE(1923)] = 105574,
  [SMALL_STATE(1924)] = 105591,
  [SMALL_STATE(1925)] = 105610,
  [SMALL_STATE(1926)] = 105629,
  [SMALL_STATE(1927)] = 105640,
  [SMALL_STATE(1928)] = 105651,
  [SMALL_STATE(1929)] = 105668,
  [SMALL_STATE(1930)] = 105687,
  [SMALL_STATE(1931)] = 105706,
  [SMALL_STATE(1932)] = 105723,
  [SMALL_STATE(1933)] = 105734,
  [SMALL_STATE(1934)] = 105751,
  [SMALL_STATE(1935)] = 105770,
  [SMALL_STATE(1936)] = 105781,
  [SMALL_STATE(1937)] = 105798,
  [SMALL_STATE(1938)] = 105817,
  [SMALL_STATE(1939)] = 105834,
  [SMALL_STATE(1940)] = 105845,
  [SMALL_STATE(1941)] = 105864,
  [SMALL_STATE(1942)] = 105883,
  [SMALL_STATE(1943)] = 105902,
  [SMALL_STATE(1944)] = 105914,
  [SMALL_STATE(1945)] = 105928,
  [SMALL_STATE(1946)] = 105942,
  [SMALL_STATE(1947)] = 105956,
  [SMALL_STATE(1948)] = 105972,
  [SMALL_STATE(1949)] = 105988,
  [SMALL_STATE(1950)] = 106004,
  [SMALL_STATE(1951)] = 106018,
  [SMALL_STATE(1952)] = 106034,
  [SMALL_STATE(1953)] = 106048,
  [SMALL_STATE(1954)] = 106064,
  [SMALL_STATE(1955)] = 106078,
  [SMALL_STATE(1956)] = 106092,
  [SMALL_STATE(1957)] = 106106,
  [SMALL_STATE(1958)] = 106120,
  [SMALL_STATE(1959)] = 106134,
  [SMALL_STATE(1960)] = 106148,
  [SMALL_STATE(1961)] = 106164,
  [SMALL_STATE(1962)] = 106180,
  [SMALL_STATE(1963)] = 106196,
  [SMALL_STATE(1964)] = 106212,
  [SMALL_STATE(1965)] = 106226,
  [SMALL_STATE(1966)] = 106240,
  [SMALL_STATE(1967)] = 106254,
  [SMALL_STATE(1968)] = 106270,
  [SMALL_STATE(1969)] = 106284,
  [SMALL_STATE(1970)] = 106298,
  [SMALL_STATE(1971)] = 106312,
  [SMALL_STATE(1972)] = 106328,
  [SMALL_STATE(1973)] = 106344,
  [SMALL_STATE(1974)] = 106358,
  [SMALL_STATE(1975)] = 106368,
  [SMALL_STATE(1976)] = 106382,
  [SMALL_STATE(1977)] = 106398,
  [SMALL_STATE(1978)] = 106412,
  [SMALL_STATE(1979)] = 106426,
  [SMALL_STATE(1980)] = 106440,
  [SMALL_STATE(1981)] = 106456,
  [SMALL_STATE(1982)] = 106472,
  [SMALL_STATE(1983)] = 106486,
  [SMALL_STATE(1984)] = 106500,
  [SMALL_STATE(1985)] = 106514,
  [SMALL_STATE(1986)] = 106528,
  [SMALL_STATE(1987)] = 106541,
  [SMALL_STATE(1988)] = 106554,
  [SMALL_STATE(1989)] = 106567,
  [SMALL_STATE(1990)] = 106580,
  [SMALL_STATE(1991)] = 106591,
  [SMALL_STATE(1992)] = 106604,
  [SMALL_STATE(1993)] = 106617,
  [SMALL_STATE(1994)] = 106630,
  [SMALL_STATE(1995)] = 106643,
  [SMALL_STATE(1996)] = 106656,
  [SMALL_STATE(1997)] = 106669,
  [SMALL_STATE(1998)] = 106682,
  [SMALL_STATE(1999)] = 106695,
  [SMALL_STATE(2000)] = 106708,
  [SMALL_STATE(2001)] = 106721,
  [SMALL_STATE(2002)] = 106732,
  [SMALL_STATE(2003)] = 106745,
  [SMALL_STATE(2004)] = 106758,
  [SMALL_STATE(2005)] = 106771,
  [SMALL_STATE(2006)] = 106784,
  [SMALL_STATE(2007)] = 106797,
  [SMALL_STATE(2008)] = 106808,
  [SMALL_STATE(2009)] = 106819,
  [SMALL_STATE(2010)] = 106832,
  [SMALL_STATE(2011)] = 106843,
  [SMALL_STATE(2012)] = 106856,
  [SMALL_STATE(2013)] = 106869,
  [SMALL_STATE(2014)] = 106882,
  [SMALL_STATE(2015)] = 106895,
  [SMALL_STATE(2016)] = 106908,
  [SMALL_STATE(2017)] = 106921,
  [SMALL_STATE(2018)] = 106934,
  [SMALL_STATE(2019)] = 106947,
  [SMALL_STATE(2020)] = 106958,
  [SMALL_STATE(2021)] = 106969,
  [SMALL_STATE(2022)] = 106980,
  [SMALL_STATE(2023)] = 106993,
  [SMALL_STATE(2024)] = 107006,
  [SMALL_STATE(2025)] = 107019,
  [SMALL_STATE(2026)] = 107032,
  [SMALL_STATE(2027)] = 107045,
  [SMALL_STATE(2028)] = 107058,
  [SMALL_STATE(2029)] = 107071,
  [SMALL_STATE(2030)] = 107084,
  [SMALL_STATE(2031)] = 107097,
  [SMALL_STATE(2032)] = 107110,
  [SMALL_STATE(2033)] = 107123,
  [SMALL_STATE(2034)] = 107134,
  [SMALL_STATE(2035)] = 107147,
  [SMALL_STATE(2036)] = 107158,
  [SMALL_STATE(2037)] = 107171,
  [SMALL_STATE(2038)] = 107182,
  [SMALL_STATE(2039)] = 107195,
  [SMALL_STATE(2040)] = 107208,
  [SMALL_STATE(2041)] = 107221,
  [SMALL_STATE(2042)] = 107234,
  [SMALL_STATE(2043)] = 107247,
  [SMALL_STATE(2044)] = 107260,
  [SMALL_STATE(2045)] = 107273,
  [SMALL_STATE(2046)] = 107286,
  [SMALL_STATE(2047)] = 107299,
  [SMALL_STATE(2048)] = 107312,
  [SMALL_STATE(2049)] = 107323,
  [SMALL_STATE(2050)] = 107336,
  [SMALL_STATE(2051)] = 107349,
  [SMALL_STATE(2052)] = 107362,
  [SMALL_STATE(2053)] = 107375,
  [SMALL_STATE(2054)] = 107388,
  [SMALL_STATE(2055)] = 107401,
  [SMALL_STATE(2056)] = 107414,
  [SMALL_STATE(2057)] = 107427,
  [SMALL_STATE(2058)] = 107440,
  [SMALL_STATE(2059)] = 107453,
  [SMALL_STATE(2060)] = 107466,
  [SMALL_STATE(2061)] = 107475,
  [SMALL_STATE(2062)] = 107488,
  [SMALL_STATE(2063)] = 107501,
  [SMALL_STATE(2064)] = 107510,
  [SMALL_STATE(2065)] = 107523,
  [SMALL_STATE(2066)] = 107536,
  [SMALL_STATE(2067)] = 107549,
  [SMALL_STATE(2068)] = 107562,
  [SMALL_STATE(2069)] = 107575,
  [SMALL_STATE(2070)] = 107588,
  [SMALL_STATE(2071)] = 107601,
  [SMALL_STATE(2072)] = 107614,
  [SMALL_STATE(2073)] = 107627,
  [SMALL_STATE(2074)] = 107640,
  [SMALL_STATE(2075)] = 107653,
  [SMALL_STATE(2076)] = 107666,
  [SMALL_STATE(2077)] = 107679,
  [SMALL_STATE(2078)] = 107692,
  [SMALL_STATE(2079)] = 107705,
  [SMALL_STATE(2080)] = 107718,
  [SMALL_STATE(2081)] = 107731,
  [SMALL_STATE(2082)] = 107744,
  [SMALL_STATE(2083)] = 107757,
  [SMALL_STATE(2084)] = 107768,
  [SMALL_STATE(2085)] = 107781,
  [SMALL_STATE(2086)] = 107794,
  [SMALL_STATE(2087)] = 107807,
  [SMALL_STATE(2088)] = 107820,
  [SMALL_STATE(2089)] = 107833,
  [SMALL_STATE(2090)] = 107846,
  [SMALL_STATE(2091)] = 107859,
  [SMALL_STATE(2092)] = 107872,
  [SMALL_STATE(2093)] = 107885,
  [SMALL_STATE(2094)] = 107898,
  [SMALL_STATE(2095)] = 107909,
  [SMALL_STATE(2096)] = 107922,
  [SMALL_STATE(2097)] = 107935,
  [SMALL_STATE(2098)] = 107948,
  [SMALL_STATE(2099)] = 107961,
  [SMALL_STATE(2100)] = 107974,
  [SMALL_STATE(2101)] = 107987,
  [SMALL_STATE(2102)] = 108000,
  [SMALL_STATE(2103)] = 108013,
  [SMALL_STATE(2104)] = 108026,
  [SMALL_STATE(2105)] = 108037,
  [SMALL_STATE(2106)] = 108048,
  [SMALL_STATE(2107)] = 108061,
  [SMALL_STATE(2108)] = 108074,
  [SMALL_STATE(2109)] = 108087,
  [SMALL_STATE(2110)] = 108100,
  [SMALL_STATE(2111)] = 108111,
  [SMALL_STATE(2112)] = 108124,
  [SMALL_STATE(2113)] = 108133,
  [SMALL_STATE(2114)] = 108146,
  [SMALL_STATE(2115)] = 108159,
  [SMALL_STATE(2116)] = 108172,
  [SMALL_STATE(2117)] = 108185,
  [SMALL_STATE(2118)] = 108198,
  [SMALL_STATE(2119)] = 108209,
  [SMALL_STATE(2120)] = 108222,
  [SMALL_STATE(2121)] = 108235,
  [SMALL_STATE(2122)] = 108246,
  [SMALL_STATE(2123)] = 108259,
  [SMALL_STATE(2124)] = 108272,
  [SMALL_STATE(2125)] = 108285,
  [SMALL_STATE(2126)] = 108298,
  [SMALL_STATE(2127)] = 108311,
  [SMALL_STATE(2128)] = 108324,
  [SMALL_STATE(2129)] = 108337,
  [SMALL_STATE(2130)] = 108350,
  [SMALL_STATE(2131)] = 108363,
  [SMALL_STATE(2132)] = 108376,
  [SMALL_STATE(2133)] = 108385,
  [SMALL_STATE(2134)] = 108398,
  [SMALL_STATE(2135)] = 108411,
  [SMALL_STATE(2136)] = 108420,
  [SMALL_STATE(2137)] = 108433,
  [SMALL_STATE(2138)] = 108446,
  [SMALL_STATE(2139)] = 108455,
  [SMALL_STATE(2140)] = 108468,
  [SMALL_STATE(2141)] = 108477,
  [SMALL_STATE(2142)] = 108486,
  [SMALL_STATE(2143)] = 108499,
  [SMALL_STATE(2144)] = 108512,
  [SMALL_STATE(2145)] = 108525,
  [SMALL_STATE(2146)] = 108538,
  [SMALL_STATE(2147)] = 108549,
  [SMALL_STATE(2148)] = 108562,
  [SMALL_STATE(2149)] = 108575,
  [SMALL_STATE(2150)] = 108588,
  [SMALL_STATE(2151)] = 108601,
  [SMALL_STATE(2152)] = 108614,
  [SMALL_STATE(2153)] = 108623,
  [SMALL_STATE(2154)] = 108636,
  [SMALL_STATE(2155)] = 108649,
  [SMALL_STATE(2156)] = 108662,
  [SMALL_STATE(2157)] = 108671,
  [SMALL_STATE(2158)] = 108684,
  [SMALL_STATE(2159)] = 108697,
  [SMALL_STATE(2160)] = 108710,
  [SMALL_STATE(2161)] = 108723,
  [SMALL_STATE(2162)] = 108736,
  [SMALL_STATE(2163)] = 108749,
  [SMALL_STATE(2164)] = 108762,
  [SMALL_STATE(2165)] = 108775,
  [SMALL_STATE(2166)] = 108788,
  [SMALL_STATE(2167)] = 108801,
  [SMALL_STATE(2168)] = 108814,
  [SMALL_STATE(2169)] = 108827,
  [SMALL_STATE(2170)] = 108840,
  [SMALL_STATE(2171)] = 108853,
  [SMALL_STATE(2172)] = 108866,
  [SMALL_STATE(2173)] = 108879,
  [SMALL_STATE(2174)] = 108892,
  [SMALL_STATE(2175)] = 108901,
  [SMALL_STATE(2176)] = 108914,
  [SMALL_STATE(2177)] = 108923,
  [SMALL_STATE(2178)] = 108936,
  [SMALL_STATE(2179)] = 108949,
  [SMALL_STATE(2180)] = 108962,
  [SMALL_STATE(2181)] = 108975,
  [SMALL_STATE(2182)] = 108988,
  [SMALL_STATE(2183)] = 109001,
  [SMALL_STATE(2184)] = 109014,
  [SMALL_STATE(2185)] = 109027,
  [SMALL_STATE(2186)] = 109040,
  [SMALL_STATE(2187)] = 109053,
  [SMALL_STATE(2188)] = 109066,
  [SMALL_STATE(2189)] = 109079,
  [SMALL_STATE(2190)] = 109092,
  [SMALL_STATE(2191)] = 109105,
  [SMALL_STATE(2192)] = 109118,
  [SMALL_STATE(2193)] = 109131,
  [SMALL_STATE(2194)] = 109144,
  [SMALL_STATE(2195)] = 109157,
  [SMALL_STATE(2196)] = 109170,
  [SMALL_STATE(2197)] = 109183,
  [SMALL_STATE(2198)] = 109196,
  [SMALL_STATE(2199)] = 109209,
  [SMALL_STATE(2200)] = 109222,
  [SMALL_STATE(2201)] = 109235,
  [SMALL_STATE(2202)] = 109248,
  [SMALL_STATE(2203)] = 109261,
  [SMALL_STATE(2204)] = 109274,
  [SMALL_STATE(2205)] = 109287,
  [SMALL_STATE(2206)] = 109300,
  [SMALL_STATE(2207)] = 109313,
  [SMALL_STATE(2208)] = 109324,
  [SMALL_STATE(2209)] = 109334,
  [SMALL_STATE(2210)] = 109342,
  [SMALL_STATE(2211)] = 109352,
  [SMALL_STATE(2212)] = 109360,
  [SMALL_STATE(2213)] = 109370,
  [SMALL_STATE(2214)] = 109378,
  [SMALL_STATE(2215)] = 109388,
  [SMALL_STATE(2216)] = 109396,
  [SMALL_STATE(2217)] = 109404,
  [SMALL_STATE(2218)] = 109414,
  [SMALL_STATE(2219)] = 109422,
  [SMALL_STATE(2220)] = 109430,
  [SMALL_STATE(2221)] = 109438,
  [SMALL_STATE(2222)] = 109448,
  [SMALL_STATE(2223)] = 109456,
  [SMALL_STATE(2224)] = 109464,
  [SMALL_STATE(2225)] = 109474,
  [SMALL_STATE(2226)] = 109482,
  [SMALL_STATE(2227)] = 109492,
  [SMALL_STATE(2228)] = 109500,
  [SMALL_STATE(2229)] = 109508,
  [SMALL_STATE(2230)] = 109516,
  [SMALL_STATE(2231)] = 109524,
  [SMALL_STATE(2232)] = 109534,
  [SMALL_STATE(2233)] = 109544,
  [SMALL_STATE(2234)] = 109554,
  [SMALL_STATE(2235)] = 109564,
  [SMALL_STATE(2236)] = 109572,
  [SMALL_STATE(2237)] = 109580,
  [SMALL_STATE(2238)] = 109588,
  [SMALL_STATE(2239)] = 109596,
  [SMALL_STATE(2240)] = 109604,
  [SMALL_STATE(2241)] = 109612,
  [SMALL_STATE(2242)] = 109622,
  [SMALL_STATE(2243)] = 109630,
  [SMALL_STATE(2244)] = 109638,
  [SMALL_STATE(2245)] = 109648,
  [SMALL_STATE(2246)] = 109656,
  [SMALL_STATE(2247)] = 109666,
  [SMALL_STATE(2248)] = 109676,
  [SMALL_STATE(2249)] = 109684,
  [SMALL_STATE(2250)] = 109694,
  [SMALL_STATE(2251)] = 109702,
  [SMALL_STATE(2252)] = 109710,
  [SMALL_STATE(2253)] = 109718,
  [SMALL_STATE(2254)] = 109726,
  [SMALL_STATE(2255)] = 109736,
  [SMALL_STATE(2256)] = 109746,
  [SMALL_STATE(2257)] = 109754,
  [SMALL_STATE(2258)] = 109764,
  [SMALL_STATE(2259)] = 109774,
  [SMALL_STATE(2260)] = 109784,
  [SMALL_STATE(2261)] = 109792,
  [SMALL_STATE(2262)] = 109802,
  [SMALL_STATE(2263)] = 109810,
  [SMALL_STATE(2264)] = 109818,
  [SMALL_STATE(2265)] = 109828,
  [SMALL_STATE(2266)] = 109838,
  [SMALL_STATE(2267)] = 109846,
  [SMALL_STATE(2268)] = 109856,
  [SMALL_STATE(2269)] = 109866,
  [SMALL_STATE(2270)] = 109876,
  [SMALL_STATE(2271)] = 109886,
  [SMALL_STATE(2272)] = 109896,
  [SMALL_STATE(2273)] = 109906,
  [SMALL_STATE(2274)] = 109916,
  [SMALL_STATE(2275)] = 109926,
  [SMALL_STATE(2276)] = 109936,
  [SMALL_STATE(2277)] = 109946,
  [SMALL_STATE(2278)] = 109954,
  [SMALL_STATE(2279)] = 109962,
  [SMALL_STATE(2280)] = 109972,
  [SMALL_STATE(2281)] = 109982,
  [SMALL_STATE(2282)] = 109992,
  [SMALL_STATE(2283)] = 110000,
  [SMALL_STATE(2284)] = 110010,
  [SMALL_STATE(2285)] = 110020,
  [SMALL_STATE(2286)] = 110028,
  [SMALL_STATE(2287)] = 110036,
  [SMALL_STATE(2288)] = 110046,
  [SMALL_STATE(2289)] = 110054,
  [SMALL_STATE(2290)] = 110062,
  [SMALL_STATE(2291)] = 110072,
  [SMALL_STATE(2292)] = 110082,
  [SMALL_STATE(2293)] = 110090,
  [SMALL_STATE(2294)] = 110098,
  [SMALL_STATE(2295)] = 110106,
  [SMALL_STATE(2296)] = 110116,
  [SMALL_STATE(2297)] = 110126,
  [SMALL_STATE(2298)] = 110134,
  [SMALL_STATE(2299)] = 110142,
  [SMALL_STATE(2300)] = 110150,
  [SMALL_STATE(2301)] = 110158,
  [SMALL_STATE(2302)] = 110168,
  [SMALL_STATE(2303)] = 110178,
  [SMALL_STATE(2304)] = 110186,
  [SMALL_STATE(2305)] = 110194,
  [SMALL_STATE(2306)] = 110202,
  [SMALL_STATE(2307)] = 110210,
  [SMALL_STATE(2308)] = 110218,
  [SMALL_STATE(2309)] = 110226,
  [SMALL_STATE(2310)] = 110236,
  [SMALL_STATE(2311)] = 110246,
  [SMALL_STATE(2312)] = 110254,
  [SMALL_STATE(2313)] = 110264,
  [SMALL_STATE(2314)] = 110274,
  [SMALL_STATE(2315)] = 110284,
  [SMALL_STATE(2316)] = 110294,
  [SMALL_STATE(2317)] = 110302,
  [SMALL_STATE(2318)] = 110310,
  [SMALL_STATE(2319)] = 110320,
  [SMALL_STATE(2320)] = 110328,
  [SMALL_STATE(2321)] = 110338,
  [SMALL_STATE(2322)] = 110346,
  [SMALL_STATE(2323)] = 110354,
  [SMALL_STATE(2324)] = 110362,
  [SMALL_STATE(2325)] = 110372,
  [SMALL_STATE(2326)] = 110379,
  [SMALL_STATE(2327)] = 110386,
  [SMALL_STATE(2328)] = 110393,
  [SMALL_STATE(2329)] = 110400,
  [SMALL_STATE(2330)] = 110407,
  [SMALL_STATE(2331)] = 110414,
  [SMALL_STATE(2332)] = 110421,
  [SMALL_STATE(2333)] = 110428,
  [SMALL_STATE(2334)] = 110435,
  [SMALL_STATE(2335)] = 110442,
  [SMALL_STATE(2336)] = 110449,
  [SMALL_STATE(2337)] = 110456,
  [SMALL_STATE(2338)] = 110463,
  [SMALL_STATE(2339)] = 110470,
  [SMALL_STATE(2340)] = 110477,
  [SMALL_STATE(2341)] = 110484,
  [SMALL_STATE(2342)] = 110491,
  [SMALL_STATE(2343)] = 110498,
  [SMALL_STATE(2344)] = 110505,
  [SMALL_STATE(2345)] = 110512,
  [SMALL_STATE(2346)] = 110519,
  [SMALL_STATE(2347)] = 110526,
  [SMALL_STATE(2348)] = 110533,
  [SMALL_STATE(2349)] = 110540,
  [SMALL_STATE(2350)] = 110547,
  [SMALL_STATE(2351)] = 110554,
  [SMALL_STATE(2352)] = 110561,
  [SMALL_STATE(2353)] = 110568,
  [SMALL_STATE(2354)] = 110575,
  [SMALL_STATE(2355)] = 110582,
  [SMALL_STATE(2356)] = 110589,
  [SMALL_STATE(2357)] = 110596,
  [SMALL_STATE(2358)] = 110603,
  [SMALL_STATE(2359)] = 110610,
  [SMALL_STATE(2360)] = 110617,
  [SMALL_STATE(2361)] = 110624,
  [SMALL_STATE(2362)] = 110631,
  [SMALL_STATE(2363)] = 110638,
  [SMALL_STATE(2364)] = 110645,
  [SMALL_STATE(2365)] = 110652,
  [SMALL_STATE(2366)] = 110659,
  [SMALL_STATE(2367)] = 110666,
  [SMALL_STATE(2368)] = 110673,
  [SMALL_STATE(2369)] = 110680,
  [SMALL_STATE(2370)] = 110687,
  [SMALL_STATE(2371)] = 110694,
  [SMALL_STATE(2372)] = 110701,
  [SMALL_STATE(2373)] = 110708,
  [SMALL_STATE(2374)] = 110715,
  [SMALL_STATE(2375)] = 110722,
  [SMALL_STATE(2376)] = 110729,
  [SMALL_STATE(2377)] = 110736,
  [SMALL_STATE(2378)] = 110743,
  [SMALL_STATE(2379)] = 110750,
  [SMALL_STATE(2380)] = 110757,
  [SMALL_STATE(2381)] = 110764,
  [SMALL_STATE(2382)] = 110771,
  [SMALL_STATE(2383)] = 110778,
  [SMALL_STATE(2384)] = 110785,
  [SMALL_STATE(2385)] = 110792,
  [SMALL_STATE(2386)] = 110799,
  [SMALL_STATE(2387)] = 110806,
  [SMALL_STATE(2388)] = 110813,
  [SMALL_STATE(2389)] = 110820,
  [SMALL_STATE(2390)] = 110827,
  [SMALL_STATE(2391)] = 110834,
  [SMALL_STATE(2392)] = 110841,
  [SMALL_STATE(2393)] = 110848,
  [SMALL_STATE(2394)] = 110855,
  [SMALL_STATE(2395)] = 110862,
  [SMALL_STATE(2396)] = 110869,
  [SMALL_STATE(2397)] = 110876,
  [SMALL_STATE(2398)] = 110883,
  [SMALL_STATE(2399)] = 110890,
  [SMALL_STATE(2400)] = 110897,
  [SMALL_STATE(2401)] = 110904,
  [SMALL_STATE(2402)] = 110911,
  [SMALL_STATE(2403)] = 110918,
  [SMALL_STATE(2404)] = 110925,
  [SMALL_STATE(2405)] = 110932,
  [SMALL_STATE(2406)] = 110939,
  [SMALL_STATE(2407)] = 110946,
  [SMALL_STATE(2408)] = 110953,
  [SMALL_STATE(2409)] = 110960,
  [SMALL_STATE(2410)] = 110967,
  [SMALL_STATE(2411)] = 110974,
  [SMALL_STATE(2412)] = 110981,
  [SMALL_STATE(2413)] = 110988,
  [SMALL_STATE(2414)] = 110995,
  [SMALL_STATE(2415)] = 111002,
  [SMALL_STATE(2416)] = 111009,
  [SMALL_STATE(2417)] = 111016,
  [SMALL_STATE(2418)] = 111023,
  [SMALL_STATE(2419)] = 111030,
  [SMALL_STATE(2420)] = 111037,
  [SMALL_STATE(2421)] = 111044,
  [SMALL_STATE(2422)] = 111051,
  [SMALL_STATE(2423)] = 111058,
  [SMALL_STATE(2424)] = 111065,
  [SMALL_STATE(2425)] = 111072,
  [SMALL_STATE(2426)] = 111079,
  [SMALL_STATE(2427)] = 111086,
  [SMALL_STATE(2428)] = 111093,
  [SMALL_STATE(2429)] = 111100,
  [SMALL_STATE(2430)] = 111107,
  [SMALL_STATE(2431)] = 111114,
  [SMALL_STATE(2432)] = 111121,
  [SMALL_STATE(2433)] = 111128,
  [SMALL_STATE(2434)] = 111135,
  [SMALL_STATE(2435)] = 111142,
  [SMALL_STATE(2436)] = 111149,
  [SMALL_STATE(2437)] = 111156,
  [SMALL_STATE(2438)] = 111163,
  [SMALL_STATE(2439)] = 111170,
  [SMALL_STATE(2440)] = 111177,
  [SMALL_STATE(2441)] = 111184,
  [SMALL_STATE(2442)] = 111191,
  [SMALL_STATE(2443)] = 111198,
  [SMALL_STATE(2444)] = 111205,
  [SMALL_STATE(2445)] = 111212,
  [SMALL_STATE(2446)] = 111219,
  [SMALL_STATE(2447)] = 111226,
  [SMALL_STATE(2448)] = 111233,
  [SMALL_STATE(2449)] = 111240,
  [SMALL_STATE(2450)] = 111247,
  [SMALL_STATE(2451)] = 111254,
  [SMALL_STATE(2452)] = 111261,
  [SMALL_STATE(2453)] = 111268,
  [SMALL_STATE(2454)] = 111275,
  [SMALL_STATE(2455)] = 111282,
  [SMALL_STATE(2456)] = 111289,
  [SMALL_STATE(2457)] = 111296,
  [SMALL_STATE(2458)] = 111303,
  [SMALL_STATE(2459)] = 111310,
  [SMALL_STATE(2460)] = 111317,
  [SMALL_STATE(2461)] = 111324,
  [SMALL_STATE(2462)] = 111331,
  [SMALL_STATE(2463)] = 111338,
  [SMALL_STATE(2464)] = 111345,
  [SMALL_STATE(2465)] = 111352,
  [SMALL_STATE(2466)] = 111359,
  [SMALL_STATE(2467)] = 111366,
  [SMALL_STATE(2468)] = 111373,
  [SMALL_STATE(2469)] = 111380,
  [SMALL_STATE(2470)] = 111387,
  [SMALL_STATE(2471)] = 111394,
  [SMALL_STATE(2472)] = 111401,
  [SMALL_STATE(2473)] = 111408,
  [SMALL_STATE(2474)] = 111415,
  [SMALL_STATE(2475)] = 111422,
  [SMALL_STATE(2476)] = 111429,
  [SMALL_STATE(2477)] = 111436,
  [SMALL_STATE(2478)] = 111443,
  [SMALL_STATE(2479)] = 111450,
  [SMALL_STATE(2480)] = 111457,
  [SMALL_STATE(2481)] = 111464,
  [SMALL_STATE(2482)] = 111471,
  [SMALL_STATE(2483)] = 111478,
  [SMALL_STATE(2484)] = 111485,
  [SMALL_STATE(2485)] = 111492,
  [SMALL_STATE(2486)] = 111499,
  [SMALL_STATE(2487)] = 111506,
  [SMALL_STATE(2488)] = 111513,
  [SMALL_STATE(2489)] = 111520,
  [SMALL_STATE(2490)] = 111527,
  [SMALL_STATE(2491)] = 111534,
  [SMALL_STATE(2492)] = 111541,
  [SMALL_STATE(2493)] = 111548,
  [SMALL_STATE(2494)] = 111555,
  [SMALL_STATE(2495)] = 111562,
  [SMALL_STATE(2496)] = 111569,
  [SMALL_STATE(2497)] = 111576,
  [SMALL_STATE(2498)] = 111583,
  [SMALL_STATE(2499)] = 111590,
  [SMALL_STATE(2500)] = 111597,
  [SMALL_STATE(2501)] = 111604,
  [SMALL_STATE(2502)] = 111611,
  [SMALL_STATE(2503)] = 111618,
  [SMALL_STATE(2504)] = 111625,
  [SMALL_STATE(2505)] = 111632,
  [SMALL_STATE(2506)] = 111639,
  [SMALL_STATE(2507)] = 111646,
  [SMALL_STATE(2508)] = 111653,
  [SMALL_STATE(2509)] = 111660,
  [SMALL_STATE(2510)] = 111667,
  [SMALL_STATE(2511)] = 111674,
  [SMALL_STATE(2512)] = 111681,
  [SMALL_STATE(2513)] = 111688,
  [SMALL_STATE(2514)] = 111695,
  [SMALL_STATE(2515)] = 111702,
  [SMALL_STATE(2516)] = 111709,
  [SMALL_STATE(2517)] = 111716,
  [SMALL_STATE(2518)] = 111723,
  [SMALL_STATE(2519)] = 111730,
  [SMALL_STATE(2520)] = 111737,
  [SMALL_STATE(2521)] = 111744,
  [SMALL_STATE(2522)] = 111751,
  [SMALL_STATE(2523)] = 111758,
  [SMALL_STATE(2524)] = 111765,
  [SMALL_STATE(2525)] = 111772,
  [SMALL_STATE(2526)] = 111779,
  [SMALL_STATE(2527)] = 111786,
  [SMALL_STATE(2528)] = 111793,
  [SMALL_STATE(2529)] = 111800,
  [SMALL_STATE(2530)] = 111807,
  [SMALL_STATE(2531)] = 111814,
  [SMALL_STATE(2532)] = 111821,
  [SMALL_STATE(2533)] = 111828,
  [SMALL_STATE(2534)] = 111835,
  [SMALL_STATE(2535)] = 111842,
  [SMALL_STATE(2536)] = 111849,
  [SMALL_STATE(2537)] = 111856,
  [SMALL_STATE(2538)] = 111863,
  [SMALL_STATE(2539)] = 111870,
  [SMALL_STATE(2540)] = 111877,
  [SMALL_STATE(2541)] = 111884,
  [SMALL_STATE(2542)] = 111891,
  [SMALL_STATE(2543)] = 111898,
  [SMALL_STATE(2544)] = 111905,
  [SMALL_STATE(2545)] = 111912,
  [SMALL_STATE(2546)] = 111919,
  [SMALL_STATE(2547)] = 111926,
  [SMALL_STATE(2548)] = 111933,
  [SMALL_STATE(2549)] = 111940,
  [SMALL_STATE(2550)] = 111947,
  [SMALL_STATE(2551)] = 111954,
  [SMALL_STATE(2552)] = 111961,
  [SMALL_STATE(2553)] = 111968,
  [SMALL_STATE(2554)] = 111975,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(144),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(142),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(138),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2552),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1972),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1725),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(720),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(37),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(452),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(302),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(388),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(291),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2297),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2300),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2305),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2342),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2440),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(519),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(399),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(536),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(615),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(402),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2551),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(385),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(428),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(721),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(721),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1505),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(293),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(980),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(81),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(546),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(545),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(980),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(542),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(993),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1580),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, .production_id = 1),
  [290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(228),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(224),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(706),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(428),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(721),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 4),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 4),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 4),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 4),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 65),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 65),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 64),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 64),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, .production_id = 72),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, .production_id = 72),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 51),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, .production_id = 51),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, .production_id = 4),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .dynamic_precedence = -1, .production_id = 43),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 42),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .dynamic_precedence = -1, .production_id = 5),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 69),
  [1387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 69),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 80),
  [1399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 80),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, .production_id = 24),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, .production_id = 24),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 87),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 87),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [1427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 14),
  [1429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 14),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 2),
  [1433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1, .production_id = 2),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 2),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [1442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(436),
  [1445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2),
  [1447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [1449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [1451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2), REDUCE(sym_list, 2),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2),
  [1460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2),
  [1463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 75),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 75),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 76),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 76),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 24),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 24),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_type, 2),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_type, 2),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 36),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 36),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 67),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 67),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, .production_id = 36),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, .production_id = 36),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2), REDUCE(sym_tuple, 2),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [1507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [1509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(395),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 85),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 85),
  [1516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 85), SHIFT_REPEAT(404),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, .production_id = 96),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, .production_id = 96),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 7),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 7),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 6, .production_id = 39),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 6, .production_id = 39),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 4, .production_id = 96),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 4, .production_id = 96),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, .production_id = 39),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, .production_id = 39),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, .production_id = 91),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, .production_id = 91),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 5),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 5),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, .production_id = 76),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, .production_id = 76),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 89),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 89),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 98),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 98),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, .production_id = 67),
  [1641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, .production_id = 67),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 73),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 73),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 80),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 80),
  [1653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 68),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 68),
  [1657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 79),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 79),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 95),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 95),
  [1667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 93),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 93),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 69),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 69),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, .production_id = 80),
  [1679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, .production_id = 80),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, .production_id = 69),
  [1687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, .production_id = 69),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 84),
  [1691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 84),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 69),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 69),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, .production_id = 80),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, .production_id = 80),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, .production_id = 91),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, .production_id = 91),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, .production_id = 70),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, .production_id = 70),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 7, .production_id = 47),
  [1735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 7, .production_id = 47),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, .production_id = 90),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, .production_id = 90),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 92),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 92),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 97),
  [1747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 97),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 8, .production_id = 62),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 8, .production_id = 62),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, .production_id = 88),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, .production_id = 88),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 99),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 99),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 86),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 86),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 94),
  [1767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 94),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 81),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 81),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 6, .production_id = 31),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 6, .production_id = 31),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_function_definition, 5, .production_id = 17),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_function_definition, 5, .production_id = 17),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 74),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 74),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 100),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 100),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 77),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 77),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 78),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 78),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1580),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1586),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1605),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, .production_id = 13),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, .production_id = 13),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, .production_id = 6),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, .production_id = 6),
  [2172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1610),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_string, 2),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_string, 2),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_python_string, 3),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_string, 3),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 15),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 15),
  [2191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1603),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 25),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 25),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 26),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 26),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await, 2),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2),
  [2206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1596),
  [2209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1615),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 19),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 19),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 19),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 19),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5),
  [2236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5),
  [2238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 19),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 19),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 20),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 20),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, .production_id = 20),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, .production_id = 20),
  [2254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4),
  [2256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4),
  [2258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, .production_id = 20),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, .production_id = 20),
  [2262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, .production_id = 20),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, .production_id = 20),
  [2266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1591),
  [2269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3),
  [2281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [2283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [2285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [2293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2),
  [2297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, .production_id = 7),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, .production_id = 7),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recipe, 1),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2),
  [2391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2420),
  [2394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(1785),
  [2397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2545),
  [2400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2542),
  [2403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(1817),
  [2406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2534),
  [2409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2224),
  [2412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2524),
  [2415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2519),
  [2418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2518),
  [2421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2232),
  [2424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2233),
  [2427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2241),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2482),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(1503),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2), SHIFT_REPEAT(2254),
  [2439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, .production_id = 8),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, .production_id = 8),
  [2443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16),
  [2447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(786),
  [2450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2390),
  [2453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(786),
  [2456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(680),
  [2459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(723),
  [2462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2410),
  [2465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(723),
  [2468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(688),
  [2471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(800),
  [2474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2449),
  [2477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(800),
  [2480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(689),
  [2483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(801),
  [2486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2513),
  [2489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(801),
  [2492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(682),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(752),
  [2498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2365),
  [2501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(752),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(683),
  [2507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(702),
  [2510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2431),
  [2513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(702),
  [2516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(681),
  [2519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(764),
  [2522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2453),
  [2525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(764),
  [2528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(685),
  [2531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(822),
  [2534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2455),
  [2537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(822),
  [2540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(684),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2),
  [2545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2), SHIFT_REPEAT(631),
  [2548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(710),
  [2551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2412),
  [2554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(710),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(686),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [2634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_recipe_repeat1, 2),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [2662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2), SHIFT_REPEAT(641),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(832),
  [2670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(2337),
  [2673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(832),
  [2676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 16), SHIFT_REPEAT(687),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [2691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 3),
  [2693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 3),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override, 2),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override, 2),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2),
  [2709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1966),
  [2720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_override_repeat1, 2),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_repeat1, 2),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_expansion, 3),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_expansion, 3),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_expansion, 2),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_expansion, 2),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, .production_id = 13),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, .production_id = 5),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override, 3),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override, 3),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1561),
  [2857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1561),
  [2860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(421),
  [2863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2214),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 23),
  [2868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_override_repeat1, 2), SHIFT_REPEAT(1695),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override, 4),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override, 4),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, .production_id = 12),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11),
  [2885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(400),
  [2888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = 1, .production_id = 40), SHIFT(252),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 10),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_flag, 3),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_flag, 3),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [2931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(1590),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [2936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(1590),
  [2939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(416),
  [2942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2261),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_override_repeat1, 3),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_repeat1, 3),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_python_string_repeat1, 2), SHIFT_REPEAT(164),
  [2980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_python_string_repeat1, 2), SHIFT_REPEAT(1738),
  [2983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_python_string_repeat1, 2), SHIFT_REPEAT(1738),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_python_string_repeat1, 2),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [3000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(530),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, .production_id = 5),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3),
  [3021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(455),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(439),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, .production_id = 13),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, .production_id = 12),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [3059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(486),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [3068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(488),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, .production_id = 30),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inherit_directive, 2),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [3085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(512),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, .dynamic_precedence = -1, .production_id = 5),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 21),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2),
  [3122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2), SHIFT_REPEAT(1688),
  [3125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2), SHIFT_REPEAT(434),
  [3128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inherit_directive_repeat1, 2), SHIFT_REPEAT(2296),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [3143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_python, 3),
  [3145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_python, 3),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(514),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(425),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2),
  [3209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(1732),
  [3212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(1732),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 5),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [3227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(523),
  [3230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(2553),
  [3233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(600),
  [3236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(491),
  [3255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(2554),
  [3258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(612),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [3281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(444),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(2460),
  [3287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(624),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 35),
  [3292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [3312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(334),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 65),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 64),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = 1, .production_id = 40),
  [3341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2), SHIFT_REPEAT(628),
  [3344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 33),
  [3346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 33),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, .production_id = 63),
  [3350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, .production_id = 63),
  [3352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, .production_id = 44),
  [3356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, .production_id = 61),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 11),
  [3374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 34),
  [3376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 34),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 46),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 72),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, .production_id = 22),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 11),
  [3426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(370),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [3431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2485),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 38),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 52),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, .production_id = 51),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 48),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 48),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 18),
  [3460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 18),
  [3462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 49),
  [3464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 49),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 50),
  [3468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 50),
  [3470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, .production_id = 18),
  [3472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, .production_id = 18),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(431),
  [3487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(364),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, .production_id = 29),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2),
  [3518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2),
  [3520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2), SHIFT_REPEAT(1858),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 23),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 10),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [3531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2), SHIFT_REPEAT(1868),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [3540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2362),
  [3543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(163),
  [3546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [3548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(1874),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(466),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [3598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 11), SHIFT(465),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 29),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, .production_id = 41),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2),
  [3611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(413),
  [3614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(1918),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addtask_statement, 4),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addtask_statement, 4),
  [3651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 54),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [3669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(2496),
  [3672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1965),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_functions_statement, 2),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_functions_statement, 2),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 41),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addtask_statement, 2),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addtask_statement, 2),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [3697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [3703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 55),
  [3711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 55), SHIFT_REPEAT(2198),
  [3714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [3716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(1957),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2),
  [3723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addtask_statement, 6),
  [3725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addtask_statement, 6),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [3731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 60),
  [3733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 60), SHIFT_REPEAT(419),
  [3736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_functions_statement_repeat1, 2), SHIFT_REPEAT(1967),
  [3739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .dynamic_precedence = -1, .production_id = 43),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(532),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [3754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 42),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, .production_id = 30),
  [3760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 2),
  [3762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 2),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [3766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overrides_statement_repeat1, 2), SHIFT_REPEAT(2539),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_overrides_statement_repeat1, 2),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2),
  [3797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(390),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [3808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(79),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [3813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 55), SHIFT_REPEAT(1993),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2502),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(534),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [3860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2), SHIFT_REPEAT(643),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [3869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2), SHIFT_REPEAT(629),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [3878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(284),
  [3881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2),
  [3887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1518),
  [3890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, .production_id = 30),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(485),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [3933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1520),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [3974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(278),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_override_repeat1, 2), SHIFT_REPEAT(1703),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [3992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(268),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_list_repeat1, 2), SHIFT_REPEAT(636),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 37),
  [4062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 37), SHIFT_REPEAT(357),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(454),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [4078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(304),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, .production_id = 56),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [4157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(290),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(389),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2), SHIFT_REPEAT(187),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 32),
  [4200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 32),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [4206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 9, .production_id = 66),
  [4208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 9, .production_id = 66),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [4216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, .production_id = 28),
  [4218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3),
  [4220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overrides_statement, 5),
  [4222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_overrides_statement, 5),
  [4224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, .production_id = 19),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [4228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [4244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, .production_id = 71),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [4252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 10),
  [4254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 10),
  [4256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 7),
  [4258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 7),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [4268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5),
  [4270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_assignment, 3, .production_id = 3),
  [4274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_assignment, 3, .production_id = 3),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [4280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [4282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [4284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, .production_id = 82),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 45),
  [4292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, .production_id = 83),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [4298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [4300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, .production_id = 13),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overrides_statement, 6),
  [4306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_overrides_statement, 6),
  [4308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7),
  [4310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7),
  [4312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6),
  [4314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_directive, 2),
  [4322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include_directive, 2),
  [4324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_directive, 2),
  [4326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_require_directive, 2),
  [4328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_addhandler_statement, 2),
  [4330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_addhandler_statement, 2),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 7, .production_id = 39),
  [4336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 7, .production_id = 39),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 9),
  [4344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 9),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 19),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1),
  [4354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1),
  [4356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [4358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deltask_statement, 2),
  [4360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deltask_statement, 2),
  [4362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 3),
  [4364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 3),
  [4366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 59),
  [4368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [4374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 58),
  [4376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 8),
  [4378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 8),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 8, .production_id = 53),
  [4382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 8, .production_id = 53),
  [4384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8),
  [4386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8),
  [4388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_assignment, 4, .production_id = 9),
  [4392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_assignment, 4, .production_id = 9),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, .production_id = 57),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_python_function, 6, .production_id = 27),
  [4398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_python_function, 6, .production_id = 27),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [4632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [4638] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [4684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__concat = 0,
  ts_external_token__newline = 1,
  ts_external_token__indent = 2,
  ts_external_token__dedent = 3,
  ts_external_token_string_start = 4,
  ts_external_token__string_content = 5,
  ts_external_token_escape_interpolation = 6,
  ts_external_token_string_end = 7,
  ts_external_token_comment = 8,
  ts_external_token_RBRACK = 9,
  ts_external_token_RPAREN = 10,
  ts_external_token_RBRACE = 11,
  ts_external_token_shell_content = 12,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_string_start] = sym_string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_escape_interpolation] = sym_escape_interpolation,
  [ts_external_token_string_end] = sym_string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_shell_content] = sym_shell_content,
};

static const bool ts_external_scanner_states[17][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__concat] = true,
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_shell_content] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [7] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [8] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [9] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
  },
  [11] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_comment] = true,
  },
  [15] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
  },
  [16] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_shell_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_bitbake_external_scanner_create(void);
void tree_sitter_bitbake_external_scanner_destroy(void *);
bool tree_sitter_bitbake_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bitbake_external_scanner_serialize(void *, char *);
void tree_sitter_bitbake_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bitbake(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_bitbake_external_scanner_create,
      tree_sitter_bitbake_external_scanner_destroy,
      tree_sitter_bitbake_external_scanner_scan,
      tree_sitter_bitbake_external_scanner_serialize,
      tree_sitter_bitbake_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
