#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1576
#define LARGE_STATE_COUNT 6
#define SYMBOL_COUNT 271
#define ALIAS_COUNT 1
#define TOKEN_COUNT 95
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 76

enum {
  sym_module_comment = 1,
  sym_statement_comment = 2,
  sym_comment = 3,
  anon_sym_if = 4,
  anon_sym_LBRACE = 5,
  anon_sym_RBRACE = 6,
  anon_sym_erlang = 7,
  anon_sym_javascript = 8,
  anon_sym_AT = 9,
  anon_sym_LPAREN = 10,
  anon_sym_COMMA = 11,
  anon_sym_RPAREN = 12,
  anon_sym_COLON = 13,
  anon_sym_import = 14,
  anon_sym_DOT = 15,
  anon_sym_as = 16,
  anon_sym_SLASH = 17,
  anon_sym_type = 18,
  anon_sym_const = 19,
  anon_sym_EQ = 20,
  anon_sym_POUND = 21,
  anon_sym_LBRACK = 22,
  anon_sym_RBRACK = 23,
  anon_sym_LT_LT = 24,
  anon_sym_GT_GT = 25,
  anon_sym_DASH = 26,
  anon_sym_size = 27,
  anon_sym_fn = 28,
  anon_sym_DASH_GT = 29,
  anon_sym_external = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_AMP_AMP = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_BANG_EQ = 34,
  anon_sym_LT = 35,
  anon_sym_LT_EQ = 36,
  anon_sym_LT_DOT = 37,
  anon_sym_LT_EQ_DOT = 38,
  anon_sym_GT = 39,
  anon_sym_GT_EQ = 40,
  anon_sym_GT_DOT = 41,
  anon_sym_GT_EQ_DOT = 42,
  anon_sym_PIPE_GT = 43,
  anon_sym_PLUS = 44,
  anon_sym_PLUS_DOT = 45,
  anon_sym_DASH_DOT = 46,
  anon_sym_STAR = 47,
  anon_sym_STAR_DOT = 48,
  anon_sym_SLASH_DOT = 49,
  anon_sym_PERCENT = 50,
  anon_sym_LT_GT = 51,
  anon_sym_todo = 52,
  anon_sym_panic = 53,
  anon_sym_DOT_DOT = 54,
  anon_sym_case = 55,
  anon_sym_PIPE = 56,
  anon_sym_let = 57,
  anon_sym_assert = 58,
  anon_sym_use = 59,
  anon_sym_LT_DASH = 60,
  anon_sym_BANG = 61,
  sym_visibility_modifier = 62,
  sym_opacity_modifier = 63,
  anon_sym_DQUOTE = 64,
  anon_sym_DQUOTE2 = 65,
  aux_sym_escape_sequence_token1 = 66,
  aux_sym_escape_sequence_token2 = 67,
  sym_float = 68,
  sym__hex = 69,
  sym__decimal = 70,
  sym__octal = 71,
  sym__binary = 72,
  anon_sym_binary = 73,
  anon_sym_bytes = 74,
  anon_sym_int = 75,
  anon_sym_float = 76,
  anon_sym_bit_string = 77,
  anon_sym_bits = 78,
  anon_sym_utf8 = 79,
  anon_sym_utf16 = 80,
  anon_sym_utf32 = 81,
  anon_sym_utf8_codepoint = 82,
  anon_sym_utf16_codepoint = 83,
  anon_sym_utf32_codepoint = 84,
  anon_sym_signed = 85,
  anon_sym_unsigned = 86,
  anon_sym_big = 87,
  anon_sym_little = 88,
  anon_sym_native = 89,
  anon_sym_unit = 90,
  sym__discard_name = 91,
  sym__name = 92,
  sym__upname = 93,
  sym_quoted_content = 94,
  sym_source_file = 95,
  sym__module_statement = 96,
  sym_target_group = 97,
  sym_target = 98,
  sym_attribute = 99,
  sym__attribute_arguments = 100,
  sym_attribute_value = 101,
  sym_import = 102,
  sym_module = 103,
  sym_unqualified_imports = 104,
  sym_unqualified_import = 105,
  sym_constant = 106,
  sym__constant_value = 107,
  sym_constant_tuple = 108,
  sym_constant_list = 109,
  sym__constant_bit_string = 110,
  sym_constant_bit_string_segment = 111,
  sym_constant_bit_string_segment_options = 112,
  sym__constant_bit_string_segment_option = 113,
  sym__constant_bit_string_named_segment_option = 114,
  sym__constant_bit_string_segment_option_size = 115,
  sym_constant_record = 116,
  sym_constant_record_arguments = 117,
  sym_constant_record_argument = 118,
  sym_constant_field_access = 119,
  sym__constant_type = 120,
  sym__constant_type_annotation = 121,
  sym_constant_tuple_type = 122,
  sym_constant_function_type = 123,
  sym_constant_function_parameter_types = 124,
  sym_constant_type = 125,
  sym_constant_type_arguments = 126,
  sym_constant_type_argument = 127,
  sym_external_type = 128,
  sym_external_function = 129,
  sym_external_function_parameters = 130,
  sym_external_function_parameter = 131,
  sym_external_function_body = 132,
  sym_function = 133,
  sym_function_parameters = 134,
  sym_function_parameter = 135,
  sym__labeled_discard_param = 136,
  sym__discard_param = 137,
  sym__labeled_name_param = 138,
  sym__name_param = 139,
  aux_sym__statement_seq = 140,
  sym__statement = 141,
  sym__expression = 142,
  sym_binary_expression = 143,
  sym__expression_unit = 144,
  sym_record = 145,
  sym_todo = 146,
  sym_panic = 147,
  sym_tuple = 148,
  sym_list = 149,
  sym__expression_bit_string = 150,
  sym_expression_bit_string_segment = 151,
  sym_expression_bit_string_segment_options = 152,
  sym__expression_bit_string_segment_option = 153,
  sym__expression_bit_string_named_segment_option = 154,
  sym__expression_bit_string_segment_option_size = 155,
  sym_anonymous_function = 156,
  sym_anonymous_function_parameters = 157,
  sym_anonymous_function_parameter = 158,
  sym_block = 159,
  sym_case = 160,
  sym_case_subjects = 161,
  sym_case_clauses = 162,
  sym_case_clause = 163,
  sym_case_clause_patterns = 164,
  sym_case_clause_pattern = 165,
  sym_case_clause_guard = 166,
  sym__case_clause_guard_expression = 167,
  sym__case_clause_guard_binary_expression = 168,
  sym__case_clause_guard_unit = 169,
  sym__case_clause_tuple_access = 170,
  sym_let_assert = 171,
  sym_let = 172,
  sym_use = 173,
  sym_use_assignments = 174,
  sym_use_assignment = 175,
  sym_assert = 176,
  sym_boolean_negation = 177,
  sym_integer_negation = 178,
  sym__assignment = 179,
  sym_record_update = 180,
  sym_record_update_arguments = 181,
  sym_record_update_argument = 182,
  sym__maybe_tuple_expression = 183,
  sym_tuple_access = 184,
  sym__maybe_record_expression = 185,
  sym_field_access = 186,
  sym__maybe_function_expression = 187,
  sym_arguments = 188,
  sym_argument = 189,
  sym_hole = 190,
  sym_function_call = 191,
  sym__pattern_expression = 192,
  sym__pattern_binary_expression = 193,
  sym__pattern = 194,
  sym_record_pattern = 195,
  sym_record_pattern_arguments = 196,
  sym_record_pattern_argument = 197,
  sym_pattern_spread = 198,
  sym_tuple_pattern = 199,
  sym__pattern_bit_string = 200,
  sym_pattern_bit_string_segment = 201,
  sym_pattern_bit_string_segment_options = 202,
  sym__pattern_bit_string_segment_option = 203,
  sym__pattern_bit_string_named_segment_option = 204,
  sym__pattern_bit_string_segment_option_size = 205,
  sym__pattern_bit_string_segment_argument = 206,
  sym_list_pattern = 207,
  sym_list_pattern_tail = 208,
  sym_type_definition = 209,
  sym_data_constructors = 210,
  sym_data_constructor = 211,
  sym_data_constructor_arguments = 212,
  sym_data_constructor_argument = 213,
  sym_type_alias = 214,
  sym_string = 215,
  sym_escape_sequence = 216,
  sym_integer = 217,
  sym__bit_string_segment_option = 218,
  sym__type = 219,
  sym__type_annotation = 220,
  sym_type_hole = 221,
  sym_tuple_type = 222,
  sym_function_type = 223,
  sym_function_parameter_types = 224,
  sym_type = 225,
  sym_type_arguments = 226,
  sym_type_argument = 227,
  sym_type_var = 228,
  sym_type_name = 229,
  sym_type_parameters = 230,
  sym_type_parameter = 231,
  sym_identifier = 232,
  sym_label = 233,
  sym_discard = 234,
  sym_type_identifier = 235,
  sym_remote_type_identifier = 236,
  sym_constructor_name = 237,
  sym_remote_constructor_name = 238,
  aux_sym_source_file_repeat1 = 239,
  aux_sym_target_group_repeat1 = 240,
  aux_sym__attribute_arguments_repeat1 = 241,
  aux_sym_module_repeat1 = 242,
  aux_sym_unqualified_imports_repeat1 = 243,
  aux_sym_constant_tuple_repeat1 = 244,
  aux_sym__constant_bit_string_repeat1 = 245,
  aux_sym_constant_bit_string_segment_options_repeat1 = 246,
  aux_sym_constant_record_arguments_repeat1 = 247,
  aux_sym_constant_tuple_type_repeat1 = 248,
  aux_sym_constant_type_arguments_repeat1 = 249,
  aux_sym_external_function_parameters_repeat1 = 250,
  aux_sym_function_parameters_repeat1 = 251,
  aux_sym_tuple_repeat1 = 252,
  aux_sym__expression_bit_string_repeat1 = 253,
  aux_sym_expression_bit_string_segment_options_repeat1 = 254,
  aux_sym_anonymous_function_parameters_repeat1 = 255,
  aux_sym_case_clauses_repeat1 = 256,
  aux_sym_case_clause_patterns_repeat1 = 257,
  aux_sym_case_clause_pattern_repeat1 = 258,
  aux_sym_use_assignments_repeat1 = 259,
  aux_sym_record_update_arguments_repeat1 = 260,
  aux_sym_arguments_repeat1 = 261,
  aux_sym_record_pattern_arguments_repeat1 = 262,
  aux_sym__pattern_bit_string_repeat1 = 263,
  aux_sym_pattern_bit_string_segment_options_repeat1 = 264,
  aux_sym_data_constructors_repeat1 = 265,
  aux_sym_data_constructor_arguments_repeat1 = 266,
  aux_sym_string_repeat1 = 267,
  aux_sym_tuple_type_repeat1 = 268,
  aux_sym_type_arguments_repeat1 = 269,
  aux_sym_type_parameters_repeat1 = 270,
  alias_sym_function_body = 271,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_module_comment] = "module_comment",
  [sym_statement_comment] = "statement_comment",
  [sym_comment] = "comment",
  [anon_sym_if] = "if",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_erlang] = "erlang",
  [anon_sym_javascript] = "javascript",
  [anon_sym_AT] = "@",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLON] = ":",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_as] = "as",
  [anon_sym_SLASH] = "/",
  [anon_sym_type] = "type",
  [anon_sym_const] = "const",
  [anon_sym_EQ] = "=",
  [anon_sym_POUND] = "#",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DASH] = "-",
  [anon_sym_size] = "size",
  [anon_sym_fn] = "fn",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_external] = "external",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT_DOT] = "<.",
  [anon_sym_LT_EQ_DOT] = "<=.",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT_DOT] = ">.",
  [anon_sym_GT_EQ_DOT] = ">=.",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_PLUS] = "+",
  [anon_sym_PLUS_DOT] = "+.",
  [anon_sym_DASH_DOT] = "-.",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_DOT] = "*.",
  [anon_sym_SLASH_DOT] = "/.",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_todo] = "todo",
  [anon_sym_panic] = "panic",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_case] = "case",
  [anon_sym_PIPE] = "|",
  [anon_sym_let] = "let",
  [anon_sym_assert] = "assert",
  [anon_sym_use] = "use",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_BANG] = "!",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_opacity_modifier] = "opacity_modifier",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE2] = "\"",
  [aux_sym_escape_sequence_token1] = "escape_sequence_token1",
  [aux_sym_escape_sequence_token2] = "escape_sequence_token2",
  [sym_float] = "float",
  [sym__hex] = "_hex",
  [sym__decimal] = "_decimal",
  [sym__octal] = "_octal",
  [sym__binary] = "_binary",
  [anon_sym_binary] = "binary",
  [anon_sym_bytes] = "bytes",
  [anon_sym_int] = "int",
  [anon_sym_float] = "float",
  [anon_sym_bit_string] = "bit_string",
  [anon_sym_bits] = "bits",
  [anon_sym_utf8] = "utf8",
  [anon_sym_utf16] = "utf16",
  [anon_sym_utf32] = "utf32",
  [anon_sym_utf8_codepoint] = "utf8_codepoint",
  [anon_sym_utf16_codepoint] = "utf16_codepoint",
  [anon_sym_utf32_codepoint] = "utf32_codepoint",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_big] = "big",
  [anon_sym_little] = "little",
  [anon_sym_native] = "native",
  [anon_sym_unit] = "unit",
  [sym__discard_name] = "_discard_name",
  [sym__name] = "_name",
  [sym__upname] = "_upname",
  [sym_quoted_content] = "quoted_content",
  [sym_source_file] = "source_file",
  [sym__module_statement] = "_module_statement",
  [sym_target_group] = "target_group",
  [sym_target] = "target",
  [sym_attribute] = "attribute",
  [sym__attribute_arguments] = "arguments",
  [sym_attribute_value] = "attribute_value",
  [sym_import] = "import",
  [sym_module] = "module",
  [sym_unqualified_imports] = "unqualified_imports",
  [sym_unqualified_import] = "unqualified_import",
  [sym_constant] = "constant",
  [sym__constant_value] = "_constant_value",
  [sym_constant_tuple] = "tuple",
  [sym_constant_list] = "list",
  [sym__constant_bit_string] = "bit_string",
  [sym_constant_bit_string_segment] = "bit_string_segment",
  [sym_constant_bit_string_segment_options] = "bit_string_segment_options",
  [sym__constant_bit_string_segment_option] = "_constant_bit_string_segment_option",
  [sym__constant_bit_string_named_segment_option] = "_constant_bit_string_named_segment_option",
  [sym__constant_bit_string_segment_option_size] = "bit_string_segment_option",
  [sym_constant_record] = "record",
  [sym_constant_record_arguments] = "arguments",
  [sym_constant_record_argument] = "argument",
  [sym_constant_field_access] = "field_access",
  [sym__constant_type] = "_constant_type",
  [sym__constant_type_annotation] = "_constant_type_annotation",
  [sym_constant_tuple_type] = "tuple_type",
  [sym_constant_function_type] = "function_type",
  [sym_constant_function_parameter_types] = "function_parameter_types",
  [sym_constant_type] = "type",
  [sym_constant_type_arguments] = "type_arguments",
  [sym_constant_type_argument] = "type_argument",
  [sym_external_type] = "external_type",
  [sym_external_function] = "external_function",
  [sym_external_function_parameters] = "function_parameters",
  [sym_external_function_parameter] = "function_parameter",
  [sym_external_function_body] = "external_function_body",
  [sym_function] = "function",
  [sym_function_parameters] = "function_parameters",
  [sym_function_parameter] = "function_parameter",
  [sym__labeled_discard_param] = "_labeled_discard_param",
  [sym__discard_param] = "_discard_param",
  [sym__labeled_name_param] = "_labeled_name_param",
  [sym__name_param] = "_name_param",
  [aux_sym__statement_seq] = "_statement_seq",
  [sym__statement] = "_statement",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym__expression_unit] = "_expression_unit",
  [sym_record] = "record",
  [sym_todo] = "todo",
  [sym_panic] = "panic",
  [sym_tuple] = "tuple",
  [sym_list] = "list",
  [sym__expression_bit_string] = "bit_string",
  [sym_expression_bit_string_segment] = "bit_string_segment",
  [sym_expression_bit_string_segment_options] = "bit_string_segment_options",
  [sym__expression_bit_string_segment_option] = "_expression_bit_string_segment_option",
  [sym__expression_bit_string_named_segment_option] = "_expression_bit_string_named_segment_option",
  [sym__expression_bit_string_segment_option_size] = "bit_string_segment_option",
  [sym_anonymous_function] = "anonymous_function",
  [sym_anonymous_function_parameters] = "function_parameters",
  [sym_anonymous_function_parameter] = "function_parameter",
  [sym_block] = "block",
  [sym_case] = "case",
  [sym_case_subjects] = "case_subjects",
  [sym_case_clauses] = "case_clauses",
  [sym_case_clause] = "case_clause",
  [sym_case_clause_patterns] = "case_clause_patterns",
  [sym_case_clause_pattern] = "case_clause_pattern",
  [sym_case_clause_guard] = "case_clause_guard",
  [sym__case_clause_guard_expression] = "_case_clause_guard_expression",
  [sym__case_clause_guard_binary_expression] = "binary_expression",
  [sym__case_clause_guard_unit] = "_case_clause_guard_unit",
  [sym__case_clause_tuple_access] = "tuple_access",
  [sym_let_assert] = "let_assert",
  [sym_let] = "let",
  [sym_use] = "use",
  [sym_use_assignments] = "use_assignments",
  [sym_use_assignment] = "use_assignment",
  [sym_assert] = "assert",
  [sym_boolean_negation] = "boolean_negation",
  [sym_integer_negation] = "integer_negation",
  [sym__assignment] = "_assignment",
  [sym_record_update] = "record_update",
  [sym_record_update_arguments] = "record_update_arguments",
  [sym_record_update_argument] = "record_update_argument",
  [sym__maybe_tuple_expression] = "_maybe_tuple_expression",
  [sym_tuple_access] = "tuple_access",
  [sym__maybe_record_expression] = "_maybe_record_expression",
  [sym_field_access] = "field_access",
  [sym__maybe_function_expression] = "_maybe_function_expression",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym_hole] = "hole",
  [sym_function_call] = "function_call",
  [sym__pattern_expression] = "_pattern_expression",
  [sym__pattern_binary_expression] = "binary_expression",
  [sym__pattern] = "_pattern",
  [sym_record_pattern] = "record_pattern",
  [sym_record_pattern_arguments] = "record_pattern_arguments",
  [sym_record_pattern_argument] = "record_pattern_argument",
  [sym_pattern_spread] = "pattern_spread",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym__pattern_bit_string] = "bit_string_pattern",
  [sym_pattern_bit_string_segment] = "bit_string_segment",
  [sym_pattern_bit_string_segment_options] = "bit_string_segment_options",
  [sym__pattern_bit_string_segment_option] = "_pattern_bit_string_segment_option",
  [sym__pattern_bit_string_named_segment_option] = "_pattern_bit_string_named_segment_option",
  [sym__pattern_bit_string_segment_option_size] = "bit_string_segment_option",
  [sym__pattern_bit_string_segment_argument] = "_pattern_bit_string_segment_argument",
  [sym_list_pattern] = "list_pattern",
  [sym_list_pattern_tail] = "list_pattern_tail",
  [sym_type_definition] = "type_definition",
  [sym_data_constructors] = "data_constructors",
  [sym_data_constructor] = "data_constructor",
  [sym_data_constructor_arguments] = "data_constructor_arguments",
  [sym_data_constructor_argument] = "data_constructor_argument",
  [sym_type_alias] = "type_alias",
  [sym_string] = "string",
  [sym_escape_sequence] = "escape_sequence",
  [sym_integer] = "integer",
  [sym__bit_string_segment_option] = "bit_string_segment_option",
  [sym__type] = "_type",
  [sym__type_annotation] = "_type_annotation",
  [sym_type_hole] = "type_hole",
  [sym_tuple_type] = "tuple_type",
  [sym_function_type] = "function_type",
  [sym_function_parameter_types] = "function_parameter_types",
  [sym_type] = "type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_argument] = "type_argument",
  [sym_type_var] = "type_var",
  [sym_type_name] = "type_name",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_identifier] = "identifier",
  [sym_label] = "label",
  [sym_discard] = "discard",
  [sym_type_identifier] = "type_identifier",
  [sym_remote_type_identifier] = "remote_type_identifier",
  [sym_constructor_name] = "constructor_name",
  [sym_remote_constructor_name] = "remote_constructor_name",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_target_group_repeat1] = "target_group_repeat1",
  [aux_sym__attribute_arguments_repeat1] = "_attribute_arguments_repeat1",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_unqualified_imports_repeat1] = "unqualified_imports_repeat1",
  [aux_sym_constant_tuple_repeat1] = "constant_tuple_repeat1",
  [aux_sym__constant_bit_string_repeat1] = "_constant_bit_string_repeat1",
  [aux_sym_constant_bit_string_segment_options_repeat1] = "constant_bit_string_segment_options_repeat1",
  [aux_sym_constant_record_arguments_repeat1] = "constant_record_arguments_repeat1",
  [aux_sym_constant_tuple_type_repeat1] = "constant_tuple_type_repeat1",
  [aux_sym_constant_type_arguments_repeat1] = "constant_type_arguments_repeat1",
  [aux_sym_external_function_parameters_repeat1] = "external_function_parameters_repeat1",
  [aux_sym_function_parameters_repeat1] = "function_parameters_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym__expression_bit_string_repeat1] = "_expression_bit_string_repeat1",
  [aux_sym_expression_bit_string_segment_options_repeat1] = "expression_bit_string_segment_options_repeat1",
  [aux_sym_anonymous_function_parameters_repeat1] = "anonymous_function_parameters_repeat1",
  [aux_sym_case_clauses_repeat1] = "case_clauses_repeat1",
  [aux_sym_case_clause_patterns_repeat1] = "case_clause_patterns_repeat1",
  [aux_sym_case_clause_pattern_repeat1] = "case_clause_pattern_repeat1",
  [aux_sym_use_assignments_repeat1] = "use_assignments_repeat1",
  [aux_sym_record_update_arguments_repeat1] = "record_update_arguments_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_record_pattern_arguments_repeat1] = "record_pattern_arguments_repeat1",
  [aux_sym__pattern_bit_string_repeat1] = "_pattern_bit_string_repeat1",
  [aux_sym_pattern_bit_string_segment_options_repeat1] = "pattern_bit_string_segment_options_repeat1",
  [aux_sym_data_constructors_repeat1] = "data_constructors_repeat1",
  [aux_sym_data_constructor_arguments_repeat1] = "data_constructor_arguments_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_function_body] = "function_body",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_module_comment] = sym_module_comment,
  [sym_statement_comment] = sym_statement_comment,
  [sym_comment] = sym_comment,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_erlang] = anon_sym_erlang,
  [anon_sym_javascript] = anon_sym_javascript,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_size] = anon_sym_size,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT_DOT] = anon_sym_LT_DOT,
  [anon_sym_LT_EQ_DOT] = anon_sym_LT_EQ_DOT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT_DOT] = anon_sym_GT_DOT,
  [anon_sym_GT_EQ_DOT] = anon_sym_GT_EQ_DOT,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PLUS_DOT] = anon_sym_PLUS_DOT,
  [anon_sym_DASH_DOT] = anon_sym_DASH_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_DOT] = anon_sym_STAR_DOT,
  [anon_sym_SLASH_DOT] = anon_sym_SLASH_DOT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_todo] = anon_sym_todo,
  [anon_sym_panic] = anon_sym_panic,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_opacity_modifier] = sym_opacity_modifier,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [aux_sym_escape_sequence_token1] = aux_sym_escape_sequence_token1,
  [aux_sym_escape_sequence_token2] = aux_sym_escape_sequence_token2,
  [sym_float] = sym_float,
  [sym__hex] = sym__hex,
  [sym__decimal] = sym__decimal,
  [sym__octal] = sym__octal,
  [sym__binary] = sym__binary,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_bytes] = anon_sym_bytes,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_bit_string] = anon_sym_bit_string,
  [anon_sym_bits] = anon_sym_bits,
  [anon_sym_utf8] = anon_sym_utf8,
  [anon_sym_utf16] = anon_sym_utf16,
  [anon_sym_utf32] = anon_sym_utf32,
  [anon_sym_utf8_codepoint] = anon_sym_utf8_codepoint,
  [anon_sym_utf16_codepoint] = anon_sym_utf16_codepoint,
  [anon_sym_utf32_codepoint] = anon_sym_utf32_codepoint,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_big] = anon_sym_big,
  [anon_sym_little] = anon_sym_little,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_unit] = anon_sym_unit,
  [sym__discard_name] = sym__discard_name,
  [sym__name] = sym__name,
  [sym__upname] = sym__upname,
  [sym_quoted_content] = sym_quoted_content,
  [sym_source_file] = sym_source_file,
  [sym__module_statement] = sym__module_statement,
  [sym_target_group] = sym_target_group,
  [sym_target] = sym_target,
  [sym_attribute] = sym_attribute,
  [sym__attribute_arguments] = sym_arguments,
  [sym_attribute_value] = sym_attribute_value,
  [sym_import] = sym_import,
  [sym_module] = sym_module,
  [sym_unqualified_imports] = sym_unqualified_imports,
  [sym_unqualified_import] = sym_unqualified_import,
  [sym_constant] = sym_constant,
  [sym__constant_value] = sym__constant_value,
  [sym_constant_tuple] = sym_tuple,
  [sym_constant_list] = sym_list,
  [sym__constant_bit_string] = sym__constant_bit_string,
  [sym_constant_bit_string_segment] = sym_constant_bit_string_segment,
  [sym_constant_bit_string_segment_options] = sym_constant_bit_string_segment_options,
  [sym__constant_bit_string_segment_option] = sym__constant_bit_string_segment_option,
  [sym__constant_bit_string_named_segment_option] = sym__constant_bit_string_named_segment_option,
  [sym__constant_bit_string_segment_option_size] = sym__constant_bit_string_segment_option_size,
  [sym_constant_record] = sym_record,
  [sym_constant_record_arguments] = sym_arguments,
  [sym_constant_record_argument] = sym_argument,
  [sym_constant_field_access] = sym_field_access,
  [sym__constant_type] = sym__constant_type,
  [sym__constant_type_annotation] = sym__constant_type_annotation,
  [sym_constant_tuple_type] = sym_tuple_type,
  [sym_constant_function_type] = sym_function_type,
  [sym_constant_function_parameter_types] = sym_function_parameter_types,
  [sym_constant_type] = sym_type,
  [sym_constant_type_arguments] = sym_type_arguments,
  [sym_constant_type_argument] = sym_type_argument,
  [sym_external_type] = sym_external_type,
  [sym_external_function] = sym_external_function,
  [sym_external_function_parameters] = sym_function_parameters,
  [sym_external_function_parameter] = sym_function_parameter,
  [sym_external_function_body] = sym_external_function_body,
  [sym_function] = sym_function,
  [sym_function_parameters] = sym_function_parameters,
  [sym_function_parameter] = sym_function_parameter,
  [sym__labeled_discard_param] = sym__labeled_discard_param,
  [sym__discard_param] = sym__discard_param,
  [sym__labeled_name_param] = sym__labeled_name_param,
  [sym__name_param] = sym__name_param,
  [aux_sym__statement_seq] = aux_sym__statement_seq,
  [sym__statement] = sym__statement,
  [sym__expression] = sym__expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym__expression_unit] = sym__expression_unit,
  [sym_record] = sym_record,
  [sym_todo] = sym_todo,
  [sym_panic] = sym_panic,
  [sym_tuple] = sym_tuple,
  [sym_list] = sym_list,
  [sym__expression_bit_string] = sym__constant_bit_string,
  [sym_expression_bit_string_segment] = sym_constant_bit_string_segment,
  [sym_expression_bit_string_segment_options] = sym_constant_bit_string_segment_options,
  [sym__expression_bit_string_segment_option] = sym__expression_bit_string_segment_option,
  [sym__expression_bit_string_named_segment_option] = sym__expression_bit_string_named_segment_option,
  [sym__expression_bit_string_segment_option_size] = sym__constant_bit_string_segment_option_size,
  [sym_anonymous_function] = sym_anonymous_function,
  [sym_anonymous_function_parameters] = sym_function_parameters,
  [sym_anonymous_function_parameter] = sym_function_parameter,
  [sym_block] = sym_block,
  [sym_case] = sym_case,
  [sym_case_subjects] = sym_case_subjects,
  [sym_case_clauses] = sym_case_clauses,
  [sym_case_clause] = sym_case_clause,
  [sym_case_clause_patterns] = sym_case_clause_patterns,
  [sym_case_clause_pattern] = sym_case_clause_pattern,
  [sym_case_clause_guard] = sym_case_clause_guard,
  [sym__case_clause_guard_expression] = sym__case_clause_guard_expression,
  [sym__case_clause_guard_binary_expression] = sym_binary_expression,
  [sym__case_clause_guard_unit] = sym__case_clause_guard_unit,
  [sym__case_clause_tuple_access] = sym_tuple_access,
  [sym_let_assert] = sym_let_assert,
  [sym_let] = sym_let,
  [sym_use] = sym_use,
  [sym_use_assignments] = sym_use_assignments,
  [sym_use_assignment] = sym_use_assignment,
  [sym_assert] = sym_assert,
  [sym_boolean_negation] = sym_boolean_negation,
  [sym_integer_negation] = sym_integer_negation,
  [sym__assignment] = sym__assignment,
  [sym_record_update] = sym_record_update,
  [sym_record_update_arguments] = sym_record_update_arguments,
  [sym_record_update_argument] = sym_record_update_argument,
  [sym__maybe_tuple_expression] = sym__maybe_tuple_expression,
  [sym_tuple_access] = sym_tuple_access,
  [sym__maybe_record_expression] = sym__maybe_record_expression,
  [sym_field_access] = sym_field_access,
  [sym__maybe_function_expression] = sym__maybe_function_expression,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym_hole] = sym_hole,
  [sym_function_call] = sym_function_call,
  [sym__pattern_expression] = sym__pattern_expression,
  [sym__pattern_binary_expression] = sym_binary_expression,
  [sym__pattern] = sym__pattern,
  [sym_record_pattern] = sym_record_pattern,
  [sym_record_pattern_arguments] = sym_record_pattern_arguments,
  [sym_record_pattern_argument] = sym_record_pattern_argument,
  [sym_pattern_spread] = sym_pattern_spread,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym__pattern_bit_string] = sym__pattern_bit_string,
  [sym_pattern_bit_string_segment] = sym_constant_bit_string_segment,
  [sym_pattern_bit_string_segment_options] = sym_constant_bit_string_segment_options,
  [sym__pattern_bit_string_segment_option] = sym__pattern_bit_string_segment_option,
  [sym__pattern_bit_string_named_segment_option] = sym__pattern_bit_string_named_segment_option,
  [sym__pattern_bit_string_segment_option_size] = sym__constant_bit_string_segment_option_size,
  [sym__pattern_bit_string_segment_argument] = sym__pattern_bit_string_segment_argument,
  [sym_list_pattern] = sym_list_pattern,
  [sym_list_pattern_tail] = sym_list_pattern_tail,
  [sym_type_definition] = sym_type_definition,
  [sym_data_constructors] = sym_data_constructors,
  [sym_data_constructor] = sym_data_constructor,
  [sym_data_constructor_arguments] = sym_data_constructor_arguments,
  [sym_data_constructor_argument] = sym_data_constructor_argument,
  [sym_type_alias] = sym_type_alias,
  [sym_string] = sym_string,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_integer] = sym_integer,
  [sym__bit_string_segment_option] = sym__constant_bit_string_segment_option_size,
  [sym__type] = sym__type,
  [sym__type_annotation] = sym__type_annotation,
  [sym_type_hole] = sym_type_hole,
  [sym_tuple_type] = sym_tuple_type,
  [sym_function_type] = sym_function_type,
  [sym_function_parameter_types] = sym_function_parameter_types,
  [sym_type] = sym_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_argument] = sym_type_argument,
  [sym_type_var] = sym_type_var,
  [sym_type_name] = sym_type_name,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_identifier] = sym_identifier,
  [sym_label] = sym_label,
  [sym_discard] = sym_discard,
  [sym_type_identifier] = sym_type_identifier,
  [sym_remote_type_identifier] = sym_remote_type_identifier,
  [sym_constructor_name] = sym_constructor_name,
  [sym_remote_constructor_name] = sym_remote_constructor_name,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_target_group_repeat1] = aux_sym_target_group_repeat1,
  [aux_sym__attribute_arguments_repeat1] = aux_sym__attribute_arguments_repeat1,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_unqualified_imports_repeat1] = aux_sym_unqualified_imports_repeat1,
  [aux_sym_constant_tuple_repeat1] = aux_sym_constant_tuple_repeat1,
  [aux_sym__constant_bit_string_repeat1] = aux_sym__constant_bit_string_repeat1,
  [aux_sym_constant_bit_string_segment_options_repeat1] = aux_sym_constant_bit_string_segment_options_repeat1,
  [aux_sym_constant_record_arguments_repeat1] = aux_sym_constant_record_arguments_repeat1,
  [aux_sym_constant_tuple_type_repeat1] = aux_sym_constant_tuple_type_repeat1,
  [aux_sym_constant_type_arguments_repeat1] = aux_sym_constant_type_arguments_repeat1,
  [aux_sym_external_function_parameters_repeat1] = aux_sym_external_function_parameters_repeat1,
  [aux_sym_function_parameters_repeat1] = aux_sym_function_parameters_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym__expression_bit_string_repeat1] = aux_sym__expression_bit_string_repeat1,
  [aux_sym_expression_bit_string_segment_options_repeat1] = aux_sym_expression_bit_string_segment_options_repeat1,
  [aux_sym_anonymous_function_parameters_repeat1] = aux_sym_anonymous_function_parameters_repeat1,
  [aux_sym_case_clauses_repeat1] = aux_sym_case_clauses_repeat1,
  [aux_sym_case_clause_patterns_repeat1] = aux_sym_case_clause_patterns_repeat1,
  [aux_sym_case_clause_pattern_repeat1] = aux_sym_case_clause_pattern_repeat1,
  [aux_sym_use_assignments_repeat1] = aux_sym_use_assignments_repeat1,
  [aux_sym_record_update_arguments_repeat1] = aux_sym_record_update_arguments_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_record_pattern_arguments_repeat1] = aux_sym_record_pattern_arguments_repeat1,
  [aux_sym__pattern_bit_string_repeat1] = aux_sym__pattern_bit_string_repeat1,
  [aux_sym_pattern_bit_string_segment_options_repeat1] = aux_sym_pattern_bit_string_segment_options_repeat1,
  [aux_sym_data_constructors_repeat1] = aux_sym_data_constructors_repeat1,
  [aux_sym_data_constructor_arguments_repeat1] = aux_sym_data_constructor_arguments_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_function_body] = alias_sym_function_body,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_module_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_erlang] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_javascript] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_size] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_todo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_panic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_opacity_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym__hex] = {
    .visible = false,
    .named = true,
  },
  [sym__decimal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bit_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf8_codepoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf16_codepoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf32_codepoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_big] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_little] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unit] = {
    .visible = true,
    .named = false,
  },
  [sym__discard_name] = {
    .visible = false,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym__upname] = {
    .visible = false,
    .named = true,
  },
  [sym_quoted_content] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__module_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_target_group] = {
    .visible = true,
    .named = true,
  },
  [sym_target] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_unqualified_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_unqualified_import] = {
    .visible = true,
    .named = true,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_value] = {
    .visible = false,
    .named = true,
  },
  [sym_constant_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_list] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_bit_string] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_bit_string_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_bit_string_segment_options] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_bit_string_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_bit_string_named_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_bit_string_segment_option_size] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_record] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_record_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_record_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_type] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_constant_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_function_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_external_type] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__labeled_discard_param] = {
    .visible = false,
    .named = true,
  },
  [sym__discard_param] = {
    .visible = false,
    .named = true,
  },
  [sym__labeled_name_param] = {
    .visible = false,
    .named = true,
  },
  [sym__name_param] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statement_seq] = {
    .visible = false,
    .named = false,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_unit] = {
    .visible = false,
    .named = true,
  },
  [sym_record] = {
    .visible = true,
    .named = true,
  },
  [sym_todo] = {
    .visible = true,
    .named = true,
  },
  [sym_panic] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_bit_string] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_bit_string_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_bit_string_segment_options] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_bit_string_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_bit_string_named_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_bit_string_segment_option_size] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_case_subjects] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clauses] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause_guard] = {
    .visible = true,
    .named = true,
  },
  [sym__case_clause_guard_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__case_clause_guard_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__case_clause_guard_unit] = {
    .visible = false,
    .named = true,
  },
  [sym__case_clause_tuple_access] = {
    .visible = true,
    .named = true,
  },
  [sym_let_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_use] = {
    .visible = true,
    .named = true,
  },
  [sym_use_assignments] = {
    .visible = true,
    .named = true,
  },
  [sym_use_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_negation] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_record_update] = {
    .visible = true,
    .named = true,
  },
  [sym_record_update_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_record_update_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__maybe_tuple_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_access] = {
    .visible = true,
    .named = true,
  },
  [sym__maybe_record_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym__maybe_function_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hole] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_record_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_spread] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_bit_string] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_bit_string_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_bit_string_segment_options] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_bit_string_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_bit_string_named_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_bit_string_segment_option_size] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_bit_string_segment_argument] = {
    .visible = false,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern_tail] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructors] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym__bit_string_segment_option] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_type_hole] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_var] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_discard] = {
    .visible = true,
    .named = true,
  },
  [sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_remote_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_remote_constructor_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_target_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unqualified_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__constant_bit_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_bit_string_segment_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_record_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_external_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_bit_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_bit_string_segment_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_assignments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_update_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_pattern_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_bit_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_bit_string_segment_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructor_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_function_body] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_arguments = 2,
  field_assign = 3,
  field_assignments = 4,
  field_body = 5,
  field_clauses = 6,
  field_constructor = 7,
  field_field = 8,
  field_function = 9,
  field_guard = 10,
  field_imports = 11,
  field_index = 12,
  field_label = 13,
  field_left = 14,
  field_message = 15,
  field_module = 16,
  field_name = 17,
  field_operator = 18,
  field_options = 19,
  field_parameter_types = 20,
  field_parameters = 21,
  field_pattern = 22,
  field_patterns = 23,
  field_record = 24,
  field_return_type = 25,
  field_right = 26,
  field_spread = 27,
  field_subjects = 28,
  field_target = 29,
  field_tuple = 30,
  field_type = 31,
  field_value = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_arguments] = "arguments",
  [field_assign] = "assign",
  [field_assignments] = "assignments",
  [field_body] = "body",
  [field_clauses] = "clauses",
  [field_constructor] = "constructor",
  [field_field] = "field",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_imports] = "imports",
  [field_index] = "index",
  [field_label] = "label",
  [field_left] = "left",
  [field_message] = "message",
  [field_module] = "module",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_options] = "options",
  [field_parameter_types] = "parameter_types",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_patterns] = "patterns",
  [field_record] = "record",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_spread] = "spread",
  [field_subjects] = "subjects",
  [field_target] = "target",
  [field_tuple] = "tuple",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 4},
  [5] = {.index = 7, .length = 3},
  [6] = {.index = 10, .length = 1},
  [7] = {.index = 11, .length = 2},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 1},
  [12] = {.index = 20, .length = 2},
  [13] = {.index = 22, .length = 1},
  [14] = {.index = 23, .length = 2},
  [15] = {.index = 25, .length = 4},
  [16] = {.index = 29, .length = 1},
  [17] = {.index = 30, .length = 2},
  [18] = {.index = 32, .length = 3},
  [19] = {.index = 35, .length = 2},
  [20] = {.index = 37, .length = 2},
  [21] = {.index = 39, .length = 2},
  [22] = {.index = 41, .length = 1},
  [23] = {.index = 42, .length = 2},
  [24] = {.index = 44, .length = 2},
  [25] = {.index = 46, .length = 1},
  [26] = {.index = 47, .length = 2},
  [27] = {.index = 49, .length = 3},
  [28] = {.index = 52, .length = 2},
  [29] = {.index = 54, .length = 2},
  [30] = {.index = 56, .length = 1},
  [31] = {.index = 57, .length = 1},
  [32] = {.index = 58, .length = 2},
  [33] = {.index = 60, .length = 3},
  [34] = {.index = 63, .length = 2},
  [35] = {.index = 65, .length = 2},
  [36] = {.index = 67, .length = 2},
  [37] = {.index = 69, .length = 3},
  [38] = {.index = 72, .length = 1},
  [39] = {.index = 73, .length = 2},
  [40] = {.index = 75, .length = 3},
  [41] = {.index = 78, .length = 2},
  [42] = {.index = 80, .length = 3},
  [43] = {.index = 83, .length = 1},
  [44] = {.index = 84, .length = 2},
  [45] = {.index = 86, .length = 2},
  [46] = {.index = 88, .length = 1},
  [47] = {.index = 89, .length = 2},
  [48] = {.index = 91, .length = 4},
  [49] = {.index = 95, .length = 4},
  [50] = {.index = 99, .length = 2},
  [51] = {.index = 101, .length = 2},
  [52] = {.index = 103, .length = 1},
  [53] = {.index = 104, .length = 3},
  [54] = {.index = 107, .length = 1},
  [55] = {.index = 108, .length = 1},
  [56] = {.index = 109, .length = 3},
  [57] = {.index = 112, .length = 2},
  [58] = {.index = 114, .length = 2},
  [59] = {.index = 116, .length = 2},
  [60] = {.index = 118, .length = 3},
  [61] = {.index = 121, .length = 3},
  [62] = {.index = 124, .length = 3},
  [63] = {.index = 127, .length = 2},
  [64] = {.index = 129, .length = 2},
  [65] = {.index = 131, .length = 1},
  [66] = {.index = 132, .length = 3},
  [67] = {.index = 135, .length = 2},
  [68] = {.index = 137, .length = 3},
  [69] = {.index = 140, .length = 3},
  [70] = {.index = 143, .length = 3},
  [71] = {.index = 146, .length = 2},
  [72] = {.index = 148, .length = 4},
  [73] = {.index = 152, .length = 4},
  [74] = {.index = 152, .length = 4},
  [75] = {.index = 156, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_module, 1},
  [2] =
    {field_value, 0},
  [3] =
    {field_assign, 1, .inherited = true},
    {field_pattern, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [7] =
    {field_left, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right, 0, .inherited = true},
  [10] =
    {field_assign, 0, .inherited = true},
  [11] =
    {field_arguments, 1},
    {field_function, 0},
  [13] =
    {field_arguments, 1},
    {field_name, 0},
  [15] =
    {field_arguments, 2},
    {field_name, 1},
  [17] =
    {field_name, 0},
    {field_parameters, 1},
  [19] =
    {field_name, 0, .inherited = true},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_message, 2},
  [23] =
    {field_assign, 0, .inherited = true},
    {field_value, 0},
  [25] =
    {field_assign, 2, .inherited = true},
    {field_pattern, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [29] =
    {field_value, 2},
  [30] =
    {field_assign, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [32] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [35] =
    {field_index, 2},
    {field_tuple, 0},
  [37] =
    {field_field, 2},
    {field_record, 0},
  [39] =
    {field_module, 0},
    {field_name, 2},
  [41] =
    {field_target, 1},
  [42] =
    {field_imports, 3},
    {field_module, 1},
  [44] =
    {field_alias, 3},
    {field_module, 1},
  [46] =
    {field_type, 1},
  [47] =
    {field_name, 1},
    {field_value, 3},
  [49] =
    {field_options, 1},
    {field_options, 2},
    {field_value, 0},
  [52] =
    {field_name, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [54] =
    {field_label, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [56] =
    {field_subjects, 1},
  [57] =
    {field_assign, 1, .inherited = true},
  [58] =
    {field_assign, 1},
    {field_assign, 2},
  [60] =
    {field_assign, 0, .inherited = true},
    {field_pattern, 0},
    {field_value, 2},
  [63] =
    {field_assign, 0, .inherited = true},
    {field_pattern, 0},
  [65] =
    {field_assignments, 1},
    {field_value, 3},
  [67] =
    {field_name, 2},
    {field_parameters, 3},
  [69] =
    {field_name, 1},
    {field_type, 2, .inherited = true},
    {field_value, 4},
  [72] =
    {field_spread, 3},
  [73] =
    {field_body, 3},
    {field_parameters, 1},
  [75] =
    {field_label, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [78] =
    {field_label, 0},
    {field_name, 1},
  [80] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [83] =
    {field_type, 0},
  [84] =
    {field_clauses, 3},
    {field_subjects, 1},
  [86] =
    {field_assign, 0, .inherited = true},
    {field_assign, 1, .inherited = true},
  [88] =
    {field_assign, 2, .inherited = true},
  [89] =
    {field_assign, 1, .inherited = true},
    {field_assign, 2, .inherited = true},
  [91] =
    {field_assign, 0, .inherited = true},
    {field_options, 1},
    {field_options, 2},
    {field_value, 0},
  [95] =
    {field_assign, 0, .inherited = true},
    {field_pattern, 0},
    {field_type, 1, .inherited = true},
    {field_value, 3},
  [99] =
    {field_name, 2},
    {field_value, 4},
  [101] =
    {field_label, 0},
    {field_value, 2},
  [103] =
    {field_name, 1},
  [104] =
    {field_alias, 5},
    {field_imports, 3},
    {field_module, 1},
  [107] =
    {field_return_type, 2},
  [108] =
    {field_spread, 4},
  [109] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [112] =
    {field_index, 0, .inherited = true},
    {field_tuple, 0, .inherited = true},
  [114] =
    {field_patterns, 0},
    {field_value, 2},
  [116] =
    {field_assign, 2, .inherited = true},
    {field_assign, 3, .inherited = true},
  [118] =
    {field_assign, 2, .inherited = true},
    {field_label, 0},
    {field_pattern, 2},
  [121] =
    {field_name, 2},
    {field_type, 3, .inherited = true},
    {field_value, 5},
  [124] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [127] =
    {field_alias, 2},
    {field_name, 0},
  [129] =
    {field_parameter_types, 1},
    {field_return_type, 3},
  [131] =
    {field_spread, 5},
  [132] =
    {field_body, 5},
    {field_parameters, 1},
    {field_return_type, 3},
  [135] =
    {field_name, 0},
    {field_type, 2},
  [137] =
    {field_guard, 1},
    {field_patterns, 0},
    {field_value, 3},
  [140] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [143] =
    {field_arguments, 5},
    {field_constructor, 0},
    {field_spread, 3},
  [146] =
    {field_alias, 3},
    {field_name, 1},
  [148] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [152] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [156] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [39] = {
    [3] = alias_sym_function_body,
  },
  [56] = {
    [4] = alias_sym_function_body,
  },
  [66] = {
    [5] = alias_sym_function_body,
  },
  [69] = {
    [5] = alias_sym_function_body,
  },
  [72] = {
    [6] = alias_sym_function_body,
  },
  [74] = {
    [7] = alias_sym_function_body,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__statement_seq, 2,
    aux_sym__statement_seq,
    alias_sym_function_body,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(168)
      if (lookahead == '\r') SKIP(168)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(265);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(214);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'b') ADVANCE(370);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead == 'f') ADVANCE(381);
      if (lookahead == 'i') ADVANCE(361);
      if (lookahead == 'j') ADVANCE(320);
      if (lookahead == 'l') ADVANCE(353);
      if (lookahead == 'n') ADVANCE(330);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 's') ADVANCE(371);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(386);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(253);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('d' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 1:
      if (lookahead == '&') ADVANCE(226);
      END_STATE();
    case 2:
      if (lookahead == '-') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(269);
      END_STATE();
    case 3:
      if (lookahead == '-') ADVANCE(257);
      if (lookahead == '<') ADVANCE(209);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(257);
      if (lookahead == '>') ADVANCE(247);
      END_STATE();
    case 5:
      if (lookahead == '.') ADVANCE(250);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 7:
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 8:
      if (lookahead == '1') ADVANCE(10);
      if (lookahead == '3') ADVANCE(9);
      if (lookahead == '8') ADVANCE(289);
      END_STATE();
    case 9:
      if (lookahead == '2') ADVANCE(293);
      END_STATE();
    case 10:
      if (lookahead == '6') ADVANCE(291);
      END_STATE();
    case 11:
      if (lookahead == '<') ADVANCE(209);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(228);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(227);
      END_STATE();
    case 14:
      if (lookahead == '>') ADVANCE(222);
      END_STATE();
    case 15:
      if (lookahead == '>') ADVANCE(210);
      END_STATE();
    case 16:
      if (lookahead == '>') ADVANCE(239);
      if (lookahead == '|') ADVANCE(225);
      END_STATE();
    case 17:
      if (lookahead == '_') ADVANCE(110);
      if (lookahead == 's') ADVANCE(287);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(99);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(123);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(115);
      END_STATE();
    case 26:
      if (lookahead == 'b') ADVANCE(260);
      END_STATE();
    case 27:
      if (lookahead == 'c') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 'c') ADVANCE(104);
      END_STATE();
    case 29:
      if (lookahead == 'c') ADVANCE(90);
      END_STATE();
    case 30:
      if (lookahead == 'c') ADVANCE(91);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(303);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(45);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(200);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(31);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(8);
      END_STATE();
    case 49:
      if (lookahead == 'f') ADVANCE(179);
      if (lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 50:
      if (lookahead == 'g') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(20);
      if (lookahead == 't') ADVANCE(17);
      END_STATE();
    case 51:
      if (lookahead == 'g') ADVANCE(183);
      END_STATE();
    case 52:
      if (lookahead == 'g') ADVANCE(285);
      END_STATE();
    case 53:
      if (lookahead == 'g') ADVANCE(77);
      if (lookahead == 'z') ADVANCE(36);
      END_STATE();
    case 54:
      if (lookahead == 'g') ADVANCE(79);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'y') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(53);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(113);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(80);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(81);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 67:
      if (lookahead == 'l') ADVANCE(86);
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 70:
      if (lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 71:
      if (lookahead == 'm') ADVANCE(92);
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(62);
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(38);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 79:
      if (lookahead == 'n') ADVANCE(43);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 83:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 84:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 85:
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 87:
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(64);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(35);
      END_STATE();
    case 92:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 93:
      if (lookahead == 'p') ADVANCE(19);
      END_STATE();
    case 94:
      if (lookahead == 'p') ADVANCE(37);
      END_STATE();
    case 95:
      if (lookahead == 'p') ADVANCE(87);
      END_STATE();
    case 96:
      if (lookahead == 'p') ADVANCE(117);
      END_STATE();
    case 97:
      if (lookahead == 'p') ADVANCE(88);
      END_STATE();
    case 98:
      if (lookahead == 'p') ADVANCE(89);
      END_STATE();
    case 99:
      if (lookahead == 'q') ADVANCE(128);
      END_STATE();
    case 100:
      if (lookahead == 'r') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(122);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(132);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 105:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 106:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(279);
      END_STATE();
    case 108:
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 109:
      if (lookahead == 's') ADVANCE(114);
      END_STATE();
    case 110:
      if (lookahead == 's') ADVANCE(124);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(281);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(192);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 118:
      if (lookahead == 't') ADVANCE(295);
      END_STATE();
    case 119:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(134);
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'e' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(266);
      END_STATE();
    case 127:
      if (lookahead == 'u') ADVANCE(26);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 129:
      if (lookahead == 'v') ADVANCE(23);
      END_STATE();
    case 130:
      if (lookahead == 'v') ADVANCE(40);
      END_STATE();
    case 131:
      if (lookahead == 'x') ADVANCE(122);
      END_STATE();
    case 132:
      if (lookahead == 'y') ADVANCE(277);
      END_STATE();
    case 133:
      if (lookahead == 'y') ADVANCE(94);
      END_STATE();
    case 134:
      if (lookahead == '{') ADVANCE(166);
      END_STATE();
    case 135:
      if (lookahead == '}') ADVANCE(267);
      END_STATE();
    case 136:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(135);
      END_STATE();
    case 137:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 138:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 139:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 140:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(139);
      END_STATE();
    case 141:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(141)
      if (lookahead == '\r') SKIP(141)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 142:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(142)
      if (lookahead == '\r') SKIP(142)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(5);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(3);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(143)
      if (lookahead == '\r') SKIP(143)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(5);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 144:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(144)
      if (lookahead == '\r') SKIP(144)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 145:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(146)
      if (lookahead == '\r') SKIP(146)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '"') ADVANCE(265);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(273);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'b') ADVANCE(55);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead == 'f') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(71);
      if (lookahead == 'j') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(59);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 's') ADVANCE(56);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(274);
      END_STATE();
    case 146:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(146)
      if (lookahead == '\r') SKIP(146)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(273);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'b') ADVANCE(55);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead == 'f') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(71);
      if (lookahead == 'j') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(59);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 's') ADVANCE(56);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(274);
      END_STATE();
    case 147:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(147)
      if (lookahead == '\r') SKIP(147)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 148:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(148)
      if (lookahead == '\r') SKIP(148)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 149:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(149)
      if (lookahead == '\r') SKIP(149)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(426);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 150:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(150)
      if (lookahead == '\r') SKIP(150)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 151:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(151)
      if (lookahead == '\r') SKIP(151)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(253);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 152:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(152)
      if (lookahead == '\r') SKIP(152)
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(3);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 153:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(153)
      if (lookahead == '\r') SKIP(153)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 154:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(154)
      if (lookahead == '\r') SKIP(154)
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'i') ADVANCE(363);
      if (lookahead == '|') ADVANCE(252);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 155:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(155)
      if (lookahead == '\r') SKIP(155)
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(432);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 156:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(156)
      if (lookahead == '\r') SKIP(156)
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(14);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(4);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(252);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 157:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(157)
      if (lookahead == '\r') SKIP(157)
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(4);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 158:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(158)
      if (lookahead == '\r') SKIP(158)
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '_') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(385);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 159:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(159)
      if (lookahead == '\r') SKIP(159)
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(314);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 160:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(160)
      if (lookahead == '\r') SKIP(160)
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(273);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(274);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 161:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(161)
      if (lookahead == '\r') SKIP(161)
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == 't') ADVANCE(455);
      if (lookahead == '}') ADVANCE(182);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 162:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(162)
      if (lookahead == '\r') SKIP(162)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 163:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(276);
      END_STATE();
    case 164:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(275);
      END_STATE();
    case 165:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(269);
      END_STATE();
    case 166:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(140);
      END_STATE();
    case 167:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(270);
      END_STATE();
    case 168:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(168)
      if (lookahead == '\r') SKIP(168)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(214);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'b') ADVANCE(370);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead == 'f') ADVANCE(381);
      if (lookahead == 'i') ADVANCE(361);
      if (lookahead == 'j') ADVANCE(320);
      if (lookahead == 'l') ADVANCE(353);
      if (lookahead == 'n') ADVANCE(330);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 's') ADVANCE(371);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(386);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(253);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('d' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 169:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(169)
      if (lookahead == '\r') SKIP(169)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 170:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(170)
      if (lookahead == '\r') SKIP(170)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 171:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(171)
      if (lookahead == '\r') SKIP(171)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 172:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(172)
      if (lookahead == '\r') SKIP(172)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_module_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_statement_comment);
      if (lookahead == '/') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_statement_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_erlang);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_erlang);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_javascript);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_javascript);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_import);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(250);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_as);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '.') ADVANCE(245);
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_type);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_const);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(227);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '>') ADVANCE(222);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '>') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_size);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_size);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_fn);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_external);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '.') ADVANCE(232);
      if (lookahead == '<') ADVANCE(209);
      if (lookahead == '=') ADVANCE(231);
      if (lookahead == '>') ADVANCE(247);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '.') ADVANCE(232);
      if (lookahead == '=') ADVANCE(231);
      if (lookahead == '>') ADVANCE(247);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '.') ADVANCE(233);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_LT_DOT);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_LT_EQ_DOT);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '.') ADVANCE(237);
      if (lookahead == '=') ADVANCE(236);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '.') ADVANCE(237);
      if (lookahead == '=') ADVANCE(236);
      if (lookahead == '>') ADVANCE(210);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      if (lookahead == '.') ADVANCE(238);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_GT_DOT);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_GT_EQ_DOT);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(241);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '.') ADVANCE(244);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_STAR_DOT);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_SLASH_DOT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_todo);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_panic);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(239);
      if (lookahead == '|') ADVANCE(225);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_let);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_assert);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_use);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(228);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_visibility_modifier);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_visibility_modifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_opacity_modifier);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_opacity_modifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token1);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token2);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'e') ADVANCE(2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(269);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym__hex);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym__decimal);
      if (lookahead == '.') ADVANCE(268);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(163);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(272);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym__decimal);
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym__decimal);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(163);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(274);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym__decimal);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym__octal);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(275);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym__binary);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(276);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_binary);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_bytes);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_bytes);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_int);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_bit_string);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_bit_string);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_bits);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_bits);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_utf8);
      if (lookahead == '_') ADVANCE(27);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_utf8);
      if (lookahead == '_') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_utf16);
      if (lookahead == '_') ADVANCE(29);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_utf16);
      if (lookahead == '_') ADVANCE(336);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_utf32);
      if (lookahead == '_') ADVANCE(30);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_utf32);
      if (lookahead == '_') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_utf8_codepoint);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_utf8_codepoint);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_utf16_codepoint);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_utf16_codepoint);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_utf32_codepoint);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_utf32_codepoint);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_signed);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_big);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_big);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_little);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_little);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_native);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_unit);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_unit);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym__discard_name);
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(313);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(314);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym__discard_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(314);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(315);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '1') ADVANCE(318);
      if (lookahead == '3') ADVANCE(317);
      if (lookahead == '8') ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '2') ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '6') ADVANCE(292);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '_') ADVANCE(431);
      if (lookahead == 's') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(451);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(429);
      if (lookahead == 'o') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(429);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(389);
      if (lookahead == 'u') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(417);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(428);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(444);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(437);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'b') ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(407);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(359);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(421);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(310);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(263);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(338);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(434);
      if (lookahead == 'i') ADVANCE(449);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(434);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(419);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(414);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(180);
      if (lookahead == 'm') ADVANCE(408);
      if (lookahead == 'n') ADVANCE(433);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(180);
      if (lookahead == 'm') ADVANCE(408);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(316);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(306);
      if (lookahead == 'n') ADVANCE(326);
      if (lookahead == 't') ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'z') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(456);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == 'y') ADVANCE(446);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(368);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(452);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(435);
      if (lookahead == 's') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(402);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(377);
      if (lookahead == 's') ADVANCE(344);
      if (lookahead == 't') ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(430);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(441);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(442);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(443);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(340);
      if (lookahead == 'y') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(331);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(343);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(440);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(404);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(405);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'q') ADVANCE(450);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(383);
      if (lookahead == 'x') ADVANCE(448);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(454);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(438);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(439);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(346);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(436);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(447);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(312);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(384);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(357);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(418);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'u') ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'v') ADVANCE(329);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'v') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'x') ADVANCE(448);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'y') ADVANCE(278);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'y') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym__name);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym__upname);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 169},
  [2] = {.lex_state = 169},
  [3] = {.lex_state = 169},
  [4] = {.lex_state = 169},
  [5] = {.lex_state = 169},
  [6] = {.lex_state = 169},
  [7] = {.lex_state = 141},
  [8] = {.lex_state = 141},
  [9] = {.lex_state = 169},
  [10] = {.lex_state = 141},
  [11] = {.lex_state = 169},
  [12] = {.lex_state = 169},
  [13] = {.lex_state = 169},
  [14] = {.lex_state = 141},
  [15] = {.lex_state = 141},
  [16] = {.lex_state = 141},
  [17] = {.lex_state = 141},
  [18] = {.lex_state = 172},
  [19] = {.lex_state = 172},
  [20] = {.lex_state = 141},
  [21] = {.lex_state = 141},
  [22] = {.lex_state = 141},
  [23] = {.lex_state = 169},
  [24] = {.lex_state = 169},
  [25] = {.lex_state = 169},
  [26] = {.lex_state = 141},
  [27] = {.lex_state = 169},
  [28] = {.lex_state = 169},
  [29] = {.lex_state = 169},
  [30] = {.lex_state = 169},
  [31] = {.lex_state = 141},
  [32] = {.lex_state = 169},
  [33] = {.lex_state = 169},
  [34] = {.lex_state = 141},
  [35] = {.lex_state = 141},
  [36] = {.lex_state = 169},
  [37] = {.lex_state = 141},
  [38] = {.lex_state = 141},
  [39] = {.lex_state = 141},
  [40] = {.lex_state = 169},
  [41] = {.lex_state = 141},
  [42] = {.lex_state = 141},
  [43] = {.lex_state = 141},
  [44] = {.lex_state = 141},
  [45] = {.lex_state = 169},
  [46] = {.lex_state = 141},
  [47] = {.lex_state = 169},
  [48] = {.lex_state = 141},
  [49] = {.lex_state = 141},
  [50] = {.lex_state = 141},
  [51] = {.lex_state = 169},
  [52] = {.lex_state = 141},
  [53] = {.lex_state = 141},
  [54] = {.lex_state = 141},
  [55] = {.lex_state = 141},
  [56] = {.lex_state = 141},
  [57] = {.lex_state = 141},
  [58] = {.lex_state = 141},
  [59] = {.lex_state = 141},
  [60] = {.lex_state = 169},
  [61] = {.lex_state = 141},
  [62] = {.lex_state = 141},
  [63] = {.lex_state = 141},
  [64] = {.lex_state = 169},
  [65] = {.lex_state = 141},
  [66] = {.lex_state = 141},
  [67] = {.lex_state = 141},
  [68] = {.lex_state = 169},
  [69] = {.lex_state = 169},
  [70] = {.lex_state = 141},
  [71] = {.lex_state = 169},
  [72] = {.lex_state = 141},
  [73] = {.lex_state = 141},
  [74] = {.lex_state = 169},
  [75] = {.lex_state = 169},
  [76] = {.lex_state = 141},
  [77] = {.lex_state = 169},
  [78] = {.lex_state = 141},
  [79] = {.lex_state = 141},
  [80] = {.lex_state = 141},
  [81] = {.lex_state = 141},
  [82] = {.lex_state = 169},
  [83] = {.lex_state = 169},
  [84] = {.lex_state = 169},
  [85] = {.lex_state = 141},
  [86] = {.lex_state = 169},
  [87] = {.lex_state = 142},
  [88] = {.lex_state = 169},
  [89] = {.lex_state = 169},
  [90] = {.lex_state = 169},
  [91] = {.lex_state = 169},
  [92] = {.lex_state = 169},
  [93] = {.lex_state = 169},
  [94] = {.lex_state = 169},
  [95] = {.lex_state = 169},
  [96] = {.lex_state = 142},
  [97] = {.lex_state = 169},
  [98] = {.lex_state = 169},
  [99] = {.lex_state = 169},
  [100] = {.lex_state = 142},
  [101] = {.lex_state = 169},
  [102] = {.lex_state = 169},
  [103] = {.lex_state = 169},
  [104] = {.lex_state = 169},
  [105] = {.lex_state = 169},
  [106] = {.lex_state = 169},
  [107] = {.lex_state = 169},
  [108] = {.lex_state = 169},
  [109] = {.lex_state = 169},
  [110] = {.lex_state = 169},
  [111] = {.lex_state = 169},
  [112] = {.lex_state = 169},
  [113] = {.lex_state = 142},
  [114] = {.lex_state = 169},
  [115] = {.lex_state = 169},
  [116] = {.lex_state = 169},
  [117] = {.lex_state = 169},
  [118] = {.lex_state = 169},
  [119] = {.lex_state = 169},
  [120] = {.lex_state = 142},
  [121] = {.lex_state = 169},
  [122] = {.lex_state = 169},
  [123] = {.lex_state = 169},
  [124] = {.lex_state = 142},
  [125] = {.lex_state = 142},
  [126] = {.lex_state = 162},
  [127] = {.lex_state = 142},
  [128] = {.lex_state = 162},
  [129] = {.lex_state = 142},
  [130] = {.lex_state = 162},
  [131] = {.lex_state = 142},
  [132] = {.lex_state = 142},
  [133] = {.lex_state = 142},
  [134] = {.lex_state = 162},
  [135] = {.lex_state = 142},
  [136] = {.lex_state = 142},
  [137] = {.lex_state = 142},
  [138] = {.lex_state = 142},
  [139] = {.lex_state = 142},
  [140] = {.lex_state = 142},
  [141] = {.lex_state = 142},
  [142] = {.lex_state = 142},
  [143] = {.lex_state = 142},
  [144] = {.lex_state = 162},
  [145] = {.lex_state = 162},
  [146] = {.lex_state = 162},
  [147] = {.lex_state = 162},
  [148] = {.lex_state = 162},
  [149] = {.lex_state = 162},
  [150] = {.lex_state = 162},
  [151] = {.lex_state = 162},
  [152] = {.lex_state = 162},
  [153] = {.lex_state = 162},
  [154] = {.lex_state = 162},
  [155] = {.lex_state = 162},
  [156] = {.lex_state = 162},
  [157] = {.lex_state = 162},
  [158] = {.lex_state = 162},
  [159] = {.lex_state = 162},
  [160] = {.lex_state = 143},
  [161] = {.lex_state = 143},
  [162] = {.lex_state = 143},
  [163] = {.lex_state = 162},
  [164] = {.lex_state = 143},
  [165] = {.lex_state = 142},
  [166] = {.lex_state = 162},
  [167] = {.lex_state = 143},
  [168] = {.lex_state = 143},
  [169] = {.lex_state = 143},
  [170] = {.lex_state = 162},
  [171] = {.lex_state = 162},
  [172] = {.lex_state = 162},
  [173] = {.lex_state = 143},
  [174] = {.lex_state = 162},
  [175] = {.lex_state = 162},
  [176] = {.lex_state = 143},
  [177] = {.lex_state = 162},
  [178] = {.lex_state = 143},
  [179] = {.lex_state = 162},
  [180] = {.lex_state = 162},
  [181] = {.lex_state = 162},
  [182] = {.lex_state = 162},
  [183] = {.lex_state = 143},
  [184] = {.lex_state = 162},
  [185] = {.lex_state = 143},
  [186] = {.lex_state = 143},
  [187] = {.lex_state = 143},
  [188] = {.lex_state = 162},
  [189] = {.lex_state = 162},
  [190] = {.lex_state = 162},
  [191] = {.lex_state = 143},
  [192] = {.lex_state = 162},
  [193] = {.lex_state = 143},
  [194] = {.lex_state = 143},
  [195] = {.lex_state = 162},
  [196] = {.lex_state = 143},
  [197] = {.lex_state = 143},
  [198] = {.lex_state = 162},
  [199] = {.lex_state = 143},
  [200] = {.lex_state = 143},
  [201] = {.lex_state = 143},
  [202] = {.lex_state = 143},
  [203] = {.lex_state = 143},
  [204] = {.lex_state = 143},
  [205] = {.lex_state = 162},
  [206] = {.lex_state = 162},
  [207] = {.lex_state = 143},
  [208] = {.lex_state = 143},
  [209] = {.lex_state = 143},
  [210] = {.lex_state = 162},
  [211] = {.lex_state = 143},
  [212] = {.lex_state = 162},
  [213] = {.lex_state = 162},
  [214] = {.lex_state = 162},
  [215] = {.lex_state = 143},
  [216] = {.lex_state = 143},
  [217] = {.lex_state = 143},
  [218] = {.lex_state = 143},
  [219] = {.lex_state = 162},
  [220] = {.lex_state = 143},
  [221] = {.lex_state = 162},
  [222] = {.lex_state = 143},
  [223] = {.lex_state = 143},
  [224] = {.lex_state = 143},
  [225] = {.lex_state = 143},
  [226] = {.lex_state = 143},
  [227] = {.lex_state = 143},
  [228] = {.lex_state = 143},
  [229] = {.lex_state = 143},
  [230] = {.lex_state = 143},
  [231] = {.lex_state = 143},
  [232] = {.lex_state = 143},
  [233] = {.lex_state = 143},
  [234] = {.lex_state = 143},
  [235] = {.lex_state = 143},
  [236] = {.lex_state = 143},
  [237] = {.lex_state = 143},
  [238] = {.lex_state = 143},
  [239] = {.lex_state = 143},
  [240] = {.lex_state = 162},
  [241] = {.lex_state = 143},
  [242] = {.lex_state = 143},
  [243] = {.lex_state = 143},
  [244] = {.lex_state = 143},
  [245] = {.lex_state = 143},
  [246] = {.lex_state = 143},
  [247] = {.lex_state = 143},
  [248] = {.lex_state = 143},
  [249] = {.lex_state = 143},
  [250] = {.lex_state = 143},
  [251] = {.lex_state = 143},
  [252] = {.lex_state = 143},
  [253] = {.lex_state = 143},
  [254] = {.lex_state = 143},
  [255] = {.lex_state = 143},
  [256] = {.lex_state = 143},
  [257] = {.lex_state = 143},
  [258] = {.lex_state = 143},
  [259] = {.lex_state = 143},
  [260] = {.lex_state = 143},
  [261] = {.lex_state = 143},
  [262] = {.lex_state = 143},
  [263] = {.lex_state = 143},
  [264] = {.lex_state = 143},
  [265] = {.lex_state = 143},
  [266] = {.lex_state = 143},
  [267] = {.lex_state = 143},
  [268] = {.lex_state = 143},
  [269] = {.lex_state = 143},
  [270] = {.lex_state = 143},
  [271] = {.lex_state = 143},
  [272] = {.lex_state = 143},
  [273] = {.lex_state = 143},
  [274] = {.lex_state = 143},
  [275] = {.lex_state = 143},
  [276] = {.lex_state = 143},
  [277] = {.lex_state = 143},
  [278] = {.lex_state = 143},
  [279] = {.lex_state = 143},
  [280] = {.lex_state = 143},
  [281] = {.lex_state = 143},
  [282] = {.lex_state = 143},
  [283] = {.lex_state = 143},
  [284] = {.lex_state = 143},
  [285] = {.lex_state = 143},
  [286] = {.lex_state = 143},
  [287] = {.lex_state = 143},
  [288] = {.lex_state = 143},
  [289] = {.lex_state = 143},
  [290] = {.lex_state = 143},
  [291] = {.lex_state = 143},
  [292] = {.lex_state = 143},
  [293] = {.lex_state = 143},
  [294] = {.lex_state = 143},
  [295] = {.lex_state = 143},
  [296] = {.lex_state = 143},
  [297] = {.lex_state = 143},
  [298] = {.lex_state = 143},
  [299] = {.lex_state = 143},
  [300] = {.lex_state = 143},
  [301] = {.lex_state = 143},
  [302] = {.lex_state = 143},
  [303] = {.lex_state = 143},
  [304] = {.lex_state = 143},
  [305] = {.lex_state = 143},
  [306] = {.lex_state = 143},
  [307] = {.lex_state = 143},
  [308] = {.lex_state = 143},
  [309] = {.lex_state = 143},
  [310] = {.lex_state = 143},
  [311] = {.lex_state = 143},
  [312] = {.lex_state = 143},
  [313] = {.lex_state = 143},
  [314] = {.lex_state = 143},
  [315] = {.lex_state = 143},
  [316] = {.lex_state = 143},
  [317] = {.lex_state = 143},
  [318] = {.lex_state = 143},
  [319] = {.lex_state = 143},
  [320] = {.lex_state = 143},
  [321] = {.lex_state = 143},
  [322] = {.lex_state = 143},
  [323] = {.lex_state = 143},
  [324] = {.lex_state = 143},
  [325] = {.lex_state = 144},
  [326] = {.lex_state = 144},
  [327] = {.lex_state = 143},
  [328] = {.lex_state = 162},
  [329] = {.lex_state = 143},
  [330] = {.lex_state = 143},
  [331] = {.lex_state = 143},
  [332] = {.lex_state = 143},
  [333] = {.lex_state = 143},
  [334] = {.lex_state = 162},
  [335] = {.lex_state = 162},
  [336] = {.lex_state = 162},
  [337] = {.lex_state = 143},
  [338] = {.lex_state = 162},
  [339] = {.lex_state = 162},
  [340] = {.lex_state = 162},
  [341] = {.lex_state = 162},
  [342] = {.lex_state = 162},
  [343] = {.lex_state = 143},
  [344] = {.lex_state = 162},
  [345] = {.lex_state = 143},
  [346] = {.lex_state = 162},
  [347] = {.lex_state = 143},
  [348] = {.lex_state = 143},
  [349] = {.lex_state = 162},
  [350] = {.lex_state = 143},
  [351] = {.lex_state = 162},
  [352] = {.lex_state = 143},
  [353] = {.lex_state = 162},
  [354] = {.lex_state = 145},
  [355] = {.lex_state = 145},
  [356] = {.lex_state = 145},
  [357] = {.lex_state = 145},
  [358] = {.lex_state = 147},
  [359] = {.lex_state = 145},
  [360] = {.lex_state = 145},
  [361] = {.lex_state = 148},
  [362] = {.lex_state = 148},
  [363] = {.lex_state = 148},
  [364] = {.lex_state = 149},
  [365] = {.lex_state = 149},
  [366] = {.lex_state = 148},
  [367] = {.lex_state = 148},
  [368] = {.lex_state = 148},
  [369] = {.lex_state = 148},
  [370] = {.lex_state = 148},
  [371] = {.lex_state = 148},
  [372] = {.lex_state = 148},
  [373] = {.lex_state = 148},
  [374] = {.lex_state = 148},
  [375] = {.lex_state = 148},
  [376] = {.lex_state = 148},
  [377] = {.lex_state = 148},
  [378] = {.lex_state = 148},
  [379] = {.lex_state = 148},
  [380] = {.lex_state = 148},
  [381] = {.lex_state = 148},
  [382] = {.lex_state = 148},
  [383] = {.lex_state = 148},
  [384] = {.lex_state = 148},
  [385] = {.lex_state = 148},
  [386] = {.lex_state = 148},
  [387] = {.lex_state = 148},
  [388] = {.lex_state = 148},
  [389] = {.lex_state = 148},
  [390] = {.lex_state = 148},
  [391] = {.lex_state = 148},
  [392] = {.lex_state = 148},
  [393] = {.lex_state = 148},
  [394] = {.lex_state = 148},
  [395] = {.lex_state = 148},
  [396] = {.lex_state = 148},
  [397] = {.lex_state = 148},
  [398] = {.lex_state = 148},
  [399] = {.lex_state = 148},
  [400] = {.lex_state = 148},
  [401] = {.lex_state = 148},
  [402] = {.lex_state = 148},
  [403] = {.lex_state = 148},
  [404] = {.lex_state = 148},
  [405] = {.lex_state = 148},
  [406] = {.lex_state = 148},
  [407] = {.lex_state = 148},
  [408] = {.lex_state = 148},
  [409] = {.lex_state = 148},
  [410] = {.lex_state = 148},
  [411] = {.lex_state = 148},
  [412] = {.lex_state = 148},
  [413] = {.lex_state = 148},
  [414] = {.lex_state = 148},
  [415] = {.lex_state = 148},
  [416] = {.lex_state = 148},
  [417] = {.lex_state = 148},
  [418] = {.lex_state = 148},
  [419] = {.lex_state = 148},
  [420] = {.lex_state = 148},
  [421] = {.lex_state = 148},
  [422] = {.lex_state = 148},
  [423] = {.lex_state = 148},
  [424] = {.lex_state = 148},
  [425] = {.lex_state = 172},
  [426] = {.lex_state = 172},
  [427] = {.lex_state = 172},
  [428] = {.lex_state = 147},
  [429] = {.lex_state = 172},
  [430] = {.lex_state = 147},
  [431] = {.lex_state = 147},
  [432] = {.lex_state = 147},
  [433] = {.lex_state = 147},
  [434] = {.lex_state = 147},
  [435] = {.lex_state = 147},
  [436] = {.lex_state = 147},
  [437] = {.lex_state = 147},
  [438] = {.lex_state = 147},
  [439] = {.lex_state = 170},
  [440] = {.lex_state = 147},
  [441] = {.lex_state = 147},
  [442] = {.lex_state = 147},
  [443] = {.lex_state = 147},
  [444] = {.lex_state = 147},
  [445] = {.lex_state = 147},
  [446] = {.lex_state = 147},
  [447] = {.lex_state = 147},
  [448] = {.lex_state = 147},
  [449] = {.lex_state = 147},
  [450] = {.lex_state = 169},
  [451] = {.lex_state = 170},
  [452] = {.lex_state = 169},
  [453] = {.lex_state = 147},
  [454] = {.lex_state = 147},
  [455] = {.lex_state = 147},
  [456] = {.lex_state = 148},
  [457] = {.lex_state = 147},
  [458] = {.lex_state = 148},
  [459] = {.lex_state = 148},
  [460] = {.lex_state = 148},
  [461] = {.lex_state = 147},
  [462] = {.lex_state = 148},
  [463] = {.lex_state = 147},
  [464] = {.lex_state = 147},
  [465] = {.lex_state = 172},
  [466] = {.lex_state = 170},
  [467] = {.lex_state = 147},
  [468] = {.lex_state = 147},
  [469] = {.lex_state = 171},
  [470] = {.lex_state = 148},
  [471] = {.lex_state = 147},
  [472] = {.lex_state = 147},
  [473] = {.lex_state = 147},
  [474] = {.lex_state = 147},
  [475] = {.lex_state = 147},
  [476] = {.lex_state = 147},
  [477] = {.lex_state = 147},
  [478] = {.lex_state = 147},
  [479] = {.lex_state = 147},
  [480] = {.lex_state = 147},
  [481] = {.lex_state = 172},
  [482] = {.lex_state = 147},
  [483] = {.lex_state = 147},
  [484] = {.lex_state = 170},
  [485] = {.lex_state = 147},
  [486] = {.lex_state = 147},
  [487] = {.lex_state = 147},
  [488] = {.lex_state = 148},
  [489] = {.lex_state = 147},
  [490] = {.lex_state = 147},
  [491] = {.lex_state = 172},
  [492] = {.lex_state = 147},
  [493] = {.lex_state = 147},
  [494] = {.lex_state = 147},
  [495] = {.lex_state = 147},
  [496] = {.lex_state = 147},
  [497] = {.lex_state = 148},
  [498] = {.lex_state = 147},
  [499] = {.lex_state = 147},
  [500] = {.lex_state = 170},
  [501] = {.lex_state = 170},
  [502] = {.lex_state = 147},
  [503] = {.lex_state = 170},
  [504] = {.lex_state = 171},
  [505] = {.lex_state = 169},
  [506] = {.lex_state = 170},
  [507] = {.lex_state = 147},
  [508] = {.lex_state = 170},
  [509] = {.lex_state = 172},
  [510] = {.lex_state = 169},
  [511] = {.lex_state = 171},
  [512] = {.lex_state = 171},
  [513] = {.lex_state = 145},
  [514] = {.lex_state = 148},
  [515] = {.lex_state = 172},
  [516] = {.lex_state = 145},
  [517] = {.lex_state = 145},
  [518] = {.lex_state = 145},
  [519] = {.lex_state = 171},
  [520] = {.lex_state = 145},
  [521] = {.lex_state = 172},
  [522] = {.lex_state = 170},
  [523] = {.lex_state = 145},
  [524] = {.lex_state = 148},
  [525] = {.lex_state = 171},
  [526] = {.lex_state = 169},
  [527] = {.lex_state = 169},
  [528] = {.lex_state = 169},
  [529] = {.lex_state = 169},
  [530] = {.lex_state = 150},
  [531] = {.lex_state = 145},
  [532] = {.lex_state = 169},
  [533] = {.lex_state = 147},
  [534] = {.lex_state = 169},
  [535] = {.lex_state = 169},
  [536] = {.lex_state = 150},
  [537] = {.lex_state = 150},
  [538] = {.lex_state = 169},
  [539] = {.lex_state = 169},
  [540] = {.lex_state = 150},
  [541] = {.lex_state = 150},
  [542] = {.lex_state = 169},
  [543] = {.lex_state = 169},
  [544] = {.lex_state = 169},
  [545] = {.lex_state = 169},
  [546] = {.lex_state = 169},
  [547] = {.lex_state = 169},
  [548] = {.lex_state = 150},
  [549] = {.lex_state = 169},
  [550] = {.lex_state = 169},
  [551] = {.lex_state = 169},
  [552] = {.lex_state = 169},
  [553] = {.lex_state = 169},
  [554] = {.lex_state = 169},
  [555] = {.lex_state = 169},
  [556] = {.lex_state = 169},
  [557] = {.lex_state = 169},
  [558] = {.lex_state = 169},
  [559] = {.lex_state = 169},
  [560] = {.lex_state = 169},
  [561] = {.lex_state = 169},
  [562] = {.lex_state = 169},
  [563] = {.lex_state = 150},
  [564] = {.lex_state = 169},
  [565] = {.lex_state = 169},
  [566] = {.lex_state = 169},
  [567] = {.lex_state = 169},
  [568] = {.lex_state = 169},
  [569] = {.lex_state = 169},
  [570] = {.lex_state = 169},
  [571] = {.lex_state = 169},
  [572] = {.lex_state = 169},
  [573] = {.lex_state = 169},
  [574] = {.lex_state = 169},
  [575] = {.lex_state = 169},
  [576] = {.lex_state = 169},
  [577] = {.lex_state = 169},
  [578] = {.lex_state = 169},
  [579] = {.lex_state = 169},
  [580] = {.lex_state = 169},
  [581] = {.lex_state = 150},
  [582] = {.lex_state = 169},
  [583] = {.lex_state = 169},
  [584] = {.lex_state = 169},
  [585] = {.lex_state = 145},
  [586] = {.lex_state = 150},
  [587] = {.lex_state = 169},
  [588] = {.lex_state = 169},
  [589] = {.lex_state = 151},
  [590] = {.lex_state = 145},
  [591] = {.lex_state = 150},
  [592] = {.lex_state = 169},
  [593] = {.lex_state = 169},
  [594] = {.lex_state = 169},
  [595] = {.lex_state = 169},
  [596] = {.lex_state = 169},
  [597] = {.lex_state = 169},
  [598] = {.lex_state = 169},
  [599] = {.lex_state = 169},
  [600] = {.lex_state = 169},
  [601] = {.lex_state = 169},
  [602] = {.lex_state = 169},
  [603] = {.lex_state = 169},
  [604] = {.lex_state = 169},
  [605] = {.lex_state = 169},
  [606] = {.lex_state = 169},
  [607] = {.lex_state = 169},
  [608] = {.lex_state = 152},
  [609] = {.lex_state = 153},
  [610] = {.lex_state = 145},
  [611] = {.lex_state = 145},
  [612] = {.lex_state = 154},
  [613] = {.lex_state = 145},
  [614] = {.lex_state = 154},
  [615] = {.lex_state = 154},
  [616] = {.lex_state = 148},
  [617] = {.lex_state = 154},
  [618] = {.lex_state = 148},
  [619] = {.lex_state = 152},
  [620] = {.lex_state = 148},
  [621] = {.lex_state = 147},
  [622] = {.lex_state = 148},
  [623] = {.lex_state = 148},
  [624] = {.lex_state = 148},
  [625] = {.lex_state = 155},
  [626] = {.lex_state = 152},
  [627] = {.lex_state = 152},
  [628] = {.lex_state = 155},
  [629] = {.lex_state = 148},
  [630] = {.lex_state = 148},
  [631] = {.lex_state = 153},
  [632] = {.lex_state = 153},
  [633] = {.lex_state = 153},
  [634] = {.lex_state = 147},
  [635] = {.lex_state = 148},
  [636] = {.lex_state = 148},
  [637] = {.lex_state = 147},
  [638] = {.lex_state = 148},
  [639] = {.lex_state = 153},
  [640] = {.lex_state = 153},
  [641] = {.lex_state = 153},
  [642] = {.lex_state = 153},
  [643] = {.lex_state = 148},
  [644] = {.lex_state = 153},
  [645] = {.lex_state = 148},
  [646] = {.lex_state = 153},
  [647] = {.lex_state = 148},
  [648] = {.lex_state = 147},
  [649] = {.lex_state = 153},
  [650] = {.lex_state = 148},
  [651] = {.lex_state = 153},
  [652] = {.lex_state = 153},
  [653] = {.lex_state = 147},
  [654] = {.lex_state = 148},
  [655] = {.lex_state = 153},
  [656] = {.lex_state = 147},
  [657] = {.lex_state = 148},
  [658] = {.lex_state = 148},
  [659] = {.lex_state = 153},
  [660] = {.lex_state = 153},
  [661] = {.lex_state = 148},
  [662] = {.lex_state = 153},
  [663] = {.lex_state = 153},
  [664] = {.lex_state = 153},
  [665] = {.lex_state = 148},
  [666] = {.lex_state = 148},
  [667] = {.lex_state = 153},
  [668] = {.lex_state = 150},
  [669] = {.lex_state = 147},
  [670] = {.lex_state = 147},
  [671] = {.lex_state = 153},
  [672] = {.lex_state = 153},
  [673] = {.lex_state = 153},
  [674] = {.lex_state = 153},
  [675] = {.lex_state = 150},
  [676] = {.lex_state = 150},
  [677] = {.lex_state = 150},
  [678] = {.lex_state = 153},
  [679] = {.lex_state = 153},
  [680] = {.lex_state = 148},
  [681] = {.lex_state = 150},
  [682] = {.lex_state = 150},
  [683] = {.lex_state = 147},
  [684] = {.lex_state = 153},
  [685] = {.lex_state = 147},
  [686] = {.lex_state = 153},
  [687] = {.lex_state = 153},
  [688] = {.lex_state = 148},
  [689] = {.lex_state = 150},
  [690] = {.lex_state = 150},
  [691] = {.lex_state = 153},
  [692] = {.lex_state = 153},
  [693] = {.lex_state = 153},
  [694] = {.lex_state = 153},
  [695] = {.lex_state = 147},
  [696] = {.lex_state = 150},
  [697] = {.lex_state = 147},
  [698] = {.lex_state = 153},
  [699] = {.lex_state = 153},
  [700] = {.lex_state = 153},
  [701] = {.lex_state = 153},
  [702] = {.lex_state = 150},
  [703] = {.lex_state = 148},
  [704] = {.lex_state = 153},
  [705] = {.lex_state = 153},
  [706] = {.lex_state = 153},
  [707] = {.lex_state = 153},
  [708] = {.lex_state = 153},
  [709] = {.lex_state = 153},
  [710] = {.lex_state = 150},
  [711] = {.lex_state = 153},
  [712] = {.lex_state = 153},
  [713] = {.lex_state = 150},
  [714] = {.lex_state = 150},
  [715] = {.lex_state = 150},
  [716] = {.lex_state = 148},
  [717] = {.lex_state = 150},
  [718] = {.lex_state = 153},
  [719] = {.lex_state = 150},
  [720] = {.lex_state = 148},
  [721] = {.lex_state = 150},
  [722] = {.lex_state = 147},
  [723] = {.lex_state = 147},
  [724] = {.lex_state = 150},
  [725] = {.lex_state = 147},
  [726] = {.lex_state = 150},
  [727] = {.lex_state = 150},
  [728] = {.lex_state = 153},
  [729] = {.lex_state = 153},
  [730] = {.lex_state = 148},
  [731] = {.lex_state = 153},
  [732] = {.lex_state = 153},
  [733] = {.lex_state = 153},
  [734] = {.lex_state = 147},
  [735] = {.lex_state = 153},
  [736] = {.lex_state = 153},
  [737] = {.lex_state = 147},
  [738] = {.lex_state = 153},
  [739] = {.lex_state = 147},
  [740] = {.lex_state = 153},
  [741] = {.lex_state = 153},
  [742] = {.lex_state = 153},
  [743] = {.lex_state = 153},
  [744] = {.lex_state = 150},
  [745] = {.lex_state = 147},
  [746] = {.lex_state = 153},
  [747] = {.lex_state = 153},
  [748] = {.lex_state = 147},
  [749] = {.lex_state = 153},
  [750] = {.lex_state = 150},
  [751] = {.lex_state = 150},
  [752] = {.lex_state = 147},
  [753] = {.lex_state = 153},
  [754] = {.lex_state = 153},
  [755] = {.lex_state = 150},
  [756] = {.lex_state = 153},
  [757] = {.lex_state = 153},
  [758] = {.lex_state = 153},
  [759] = {.lex_state = 150},
  [760] = {.lex_state = 147},
  [761] = {.lex_state = 150},
  [762] = {.lex_state = 147},
  [763] = {.lex_state = 147},
  [764] = {.lex_state = 150},
  [765] = {.lex_state = 153},
  [766] = {.lex_state = 147},
  [767] = {.lex_state = 147},
  [768] = {.lex_state = 150},
  [769] = {.lex_state = 153},
  [770] = {.lex_state = 153},
  [771] = {.lex_state = 153},
  [772] = {.lex_state = 147},
  [773] = {.lex_state = 153},
  [774] = {.lex_state = 147},
  [775] = {.lex_state = 153},
  [776] = {.lex_state = 147},
  [777] = {.lex_state = 150},
  [778] = {.lex_state = 153},
  [779] = {.lex_state = 147},
  [780] = {.lex_state = 147},
  [781] = {.lex_state = 153},
  [782] = {.lex_state = 150},
  [783] = {.lex_state = 153},
  [784] = {.lex_state = 147},
  [785] = {.lex_state = 147},
  [786] = {.lex_state = 153},
  [787] = {.lex_state = 153},
  [788] = {.lex_state = 150},
  [789] = {.lex_state = 147},
  [790] = {.lex_state = 153},
  [791] = {.lex_state = 147},
  [792] = {.lex_state = 153},
  [793] = {.lex_state = 150},
  [794] = {.lex_state = 153},
  [795] = {.lex_state = 150},
  [796] = {.lex_state = 147},
  [797] = {.lex_state = 150},
  [798] = {.lex_state = 150},
  [799] = {.lex_state = 150},
  [800] = {.lex_state = 150},
  [801] = {.lex_state = 150},
  [802] = {.lex_state = 150},
  [803] = {.lex_state = 150},
  [804] = {.lex_state = 150},
  [805] = {.lex_state = 150},
  [806] = {.lex_state = 150},
  [807] = {.lex_state = 150},
  [808] = {.lex_state = 141},
  [809] = {.lex_state = 156},
  [810] = {.lex_state = 157},
  [811] = {.lex_state = 141},
  [812] = {.lex_state = 141},
  [813] = {.lex_state = 145},
  [814] = {.lex_state = 145},
  [815] = {.lex_state = 145},
  [816] = {.lex_state = 158},
  [817] = {.lex_state = 158},
  [818] = {.lex_state = 158},
  [819] = {.lex_state = 158},
  [820] = {.lex_state = 158},
  [821] = {.lex_state = 158},
  [822] = {.lex_state = 158},
  [823] = {.lex_state = 158},
  [824] = {.lex_state = 156},
  [825] = {.lex_state = 158},
  [826] = {.lex_state = 158},
  [827] = {.lex_state = 158},
  [828] = {.lex_state = 156},
  [829] = {.lex_state = 158},
  [830] = {.lex_state = 158},
  [831] = {.lex_state = 156},
  [832] = {.lex_state = 156},
  [833] = {.lex_state = 158},
  [834] = {.lex_state = 158},
  [835] = {.lex_state = 158},
  [836] = {.lex_state = 158},
  [837] = {.lex_state = 158},
  [838] = {.lex_state = 158},
  [839] = {.lex_state = 158},
  [840] = {.lex_state = 158},
  [841] = {.lex_state = 158},
  [842] = {.lex_state = 158},
  [843] = {.lex_state = 158},
  [844] = {.lex_state = 156},
  [845] = {.lex_state = 158},
  [846] = {.lex_state = 158},
  [847] = {.lex_state = 158},
  [848] = {.lex_state = 158},
  [849] = {.lex_state = 158},
  [850] = {.lex_state = 158},
  [851] = {.lex_state = 158},
  [852] = {.lex_state = 153},
  [853] = {.lex_state = 153},
  [854] = {.lex_state = 158},
  [855] = {.lex_state = 158},
  [856] = {.lex_state = 158},
  [857] = {.lex_state = 156},
  [858] = {.lex_state = 158},
  [859] = {.lex_state = 158},
  [860] = {.lex_state = 158},
  [861] = {.lex_state = 158},
  [862] = {.lex_state = 158},
  [863] = {.lex_state = 158},
  [864] = {.lex_state = 153},
  [865] = {.lex_state = 158},
  [866] = {.lex_state = 158},
  [867] = {.lex_state = 158},
  [868] = {.lex_state = 158},
  [869] = {.lex_state = 158},
  [870] = {.lex_state = 158},
  [871] = {.lex_state = 153},
  [872] = {.lex_state = 153},
  [873] = {.lex_state = 153},
  [874] = {.lex_state = 158},
  [875] = {.lex_state = 158},
  [876] = {.lex_state = 158},
  [877] = {.lex_state = 158},
  [878] = {.lex_state = 158},
  [879] = {.lex_state = 156},
  [880] = {.lex_state = 156},
  [881] = {.lex_state = 156},
  [882] = {.lex_state = 147},
  [883] = {.lex_state = 156},
  [884] = {.lex_state = 158},
  [885] = {.lex_state = 156},
  [886] = {.lex_state = 158},
  [887] = {.lex_state = 158},
  [888] = {.lex_state = 156},
  [889] = {.lex_state = 156},
  [890] = {.lex_state = 156},
  [891] = {.lex_state = 158},
  [892] = {.lex_state = 156},
  [893] = {.lex_state = 158},
  [894] = {.lex_state = 156},
  [895] = {.lex_state = 158},
  [896] = {.lex_state = 158},
  [897] = {.lex_state = 158},
  [898] = {.lex_state = 156},
  [899] = {.lex_state = 158},
  [900] = {.lex_state = 158},
  [901] = {.lex_state = 145},
  [902] = {.lex_state = 156},
  [903] = {.lex_state = 153},
  [904] = {.lex_state = 158},
  [905] = {.lex_state = 156},
  [906] = {.lex_state = 145},
  [907] = {.lex_state = 156},
  [908] = {.lex_state = 156},
  [909] = {.lex_state = 158},
  [910] = {.lex_state = 156},
  [911] = {.lex_state = 158},
  [912] = {.lex_state = 153},
  [913] = {.lex_state = 156},
  [914] = {.lex_state = 147},
  [915] = {.lex_state = 156},
  [916] = {.lex_state = 156},
  [917] = {.lex_state = 156},
  [918] = {.lex_state = 156},
  [919] = {.lex_state = 156},
  [920] = {.lex_state = 156},
  [921] = {.lex_state = 156},
  [922] = {.lex_state = 156},
  [923] = {.lex_state = 153},
  [924] = {.lex_state = 147},
  [925] = {.lex_state = 156},
  [926] = {.lex_state = 156},
  [927] = {.lex_state = 158},
  [928] = {.lex_state = 156},
  [929] = {.lex_state = 147},
  [930] = {.lex_state = 145},
  [931] = {.lex_state = 147},
  [932] = {.lex_state = 156},
  [933] = {.lex_state = 156},
  [934] = {.lex_state = 156},
  [935] = {.lex_state = 156},
  [936] = {.lex_state = 156},
  [937] = {.lex_state = 156},
  [938] = {.lex_state = 156},
  [939] = {.lex_state = 156},
  [940] = {.lex_state = 156},
  [941] = {.lex_state = 156},
  [942] = {.lex_state = 156},
  [943] = {.lex_state = 156},
  [944] = {.lex_state = 153},
  [945] = {.lex_state = 145},
  [946] = {.lex_state = 156},
  [947] = {.lex_state = 159},
  [948] = {.lex_state = 159},
  [949] = {.lex_state = 156},
  [950] = {.lex_state = 159},
  [951] = {.lex_state = 151},
  [952] = {.lex_state = 159},
  [953] = {.lex_state = 156},
  [954] = {.lex_state = 151},
  [955] = {.lex_state = 151},
  [956] = {.lex_state = 151},
  [957] = {.lex_state = 156},
  [958] = {.lex_state = 151},
  [959] = {.lex_state = 156},
  [960] = {.lex_state = 159},
  [961] = {.lex_state = 159},
  [962] = {.lex_state = 156},
  [963] = {.lex_state = 156},
  [964] = {.lex_state = 145},
  [965] = {.lex_state = 156},
  [966] = {.lex_state = 151},
  [967] = {.lex_state = 145},
  [968] = {.lex_state = 145},
  [969] = {.lex_state = 145},
  [970] = {.lex_state = 160},
  [971] = {.lex_state = 145},
  [972] = {.lex_state = 159},
  [973] = {.lex_state = 145},
  [974] = {.lex_state = 145},
  [975] = {.lex_state = 145},
  [976] = {.lex_state = 145},
  [977] = {.lex_state = 156},
  [978] = {.lex_state = 160},
  [979] = {.lex_state = 156},
  [980] = {.lex_state = 145},
  [981] = {.lex_state = 160},
  [982] = {.lex_state = 145},
  [983] = {.lex_state = 156},
  [984] = {.lex_state = 145},
  [985] = {.lex_state = 145},
  [986] = {.lex_state = 145},
  [987] = {.lex_state = 156},
  [988] = {.lex_state = 145},
  [989] = {.lex_state = 145},
  [990] = {.lex_state = 145},
  [991] = {.lex_state = 145},
  [992] = {.lex_state = 156},
  [993] = {.lex_state = 145},
  [994] = {.lex_state = 145},
  [995] = {.lex_state = 156},
  [996] = {.lex_state = 145},
  [997] = {.lex_state = 145},
  [998] = {.lex_state = 145},
  [999] = {.lex_state = 145},
  [1000] = {.lex_state = 145},
  [1001] = {.lex_state = 145},
  [1002] = {.lex_state = 145},
  [1003] = {.lex_state = 145},
  [1004] = {.lex_state = 145},
  [1005] = {.lex_state = 145},
  [1006] = {.lex_state = 145},
  [1007] = {.lex_state = 145},
  [1008] = {.lex_state = 145},
  [1009] = {.lex_state = 145},
  [1010] = {.lex_state = 145},
  [1011] = {.lex_state = 156},
  [1012] = {.lex_state = 145},
  [1013] = {.lex_state = 145},
  [1014] = {.lex_state = 145},
  [1015] = {.lex_state = 159},
  [1016] = {.lex_state = 159},
  [1017] = {.lex_state = 156},
  [1018] = {.lex_state = 159},
  [1019] = {.lex_state = 156},
  [1020] = {.lex_state = 156},
  [1021] = {.lex_state = 156},
  [1022] = {.lex_state = 161},
  [1023] = {.lex_state = 161},
  [1024] = {.lex_state = 161},
  [1025] = {.lex_state = 161},
  [1026] = {.lex_state = 161},
  [1027] = {.lex_state = 156},
  [1028] = {.lex_state = 161},
  [1029] = {.lex_state = 159},
  [1030] = {.lex_state = 160},
  [1031] = {.lex_state = 160},
  [1032] = {.lex_state = 145, .external_lex_state = 1},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 145, .external_lex_state = 1},
  [1035] = {.lex_state = 160},
  [1036] = {.lex_state = 161},
  [1037] = {.lex_state = 160},
  [1038] = {.lex_state = 145},
  [1039] = {.lex_state = 160},
  [1040] = {.lex_state = 145},
  [1041] = {.lex_state = 145},
  [1042] = {.lex_state = 160},
  [1043] = {.lex_state = 160},
  [1044] = {.lex_state = 145, .external_lex_state = 1},
  [1045] = {.lex_state = 145, .external_lex_state = 1},
  [1046] = {.lex_state = 160},
  [1047] = {.lex_state = 145, .external_lex_state = 1},
  [1048] = {.lex_state = 160},
  [1049] = {.lex_state = 145},
  [1050] = {.lex_state = 145, .external_lex_state = 1},
  [1051] = {.lex_state = 145},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 160},
  [1054] = {.lex_state = 145, .external_lex_state = 1},
  [1055] = {.lex_state = 145, .external_lex_state = 1},
  [1056] = {.lex_state = 160},
  [1057] = {.lex_state = 145, .external_lex_state = 1},
  [1058] = {.lex_state = 160},
  [1059] = {.lex_state = 145},
  [1060] = {.lex_state = 145},
  [1061] = {.lex_state = 145},
  [1062] = {.lex_state = 145, .external_lex_state = 1},
  [1063] = {.lex_state = 145, .external_lex_state = 1},
  [1064] = {.lex_state = 145, .external_lex_state = 1},
  [1065] = {.lex_state = 156},
  [1066] = {.lex_state = 145, .external_lex_state = 1},
  [1067] = {.lex_state = 156},
  [1068] = {.lex_state = 142},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 156},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 145},
  [1077] = {.lex_state = 156},
  [1078] = {.lex_state = 145},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 156},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 145},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 145},
  [1088] = {.lex_state = 159},
  [1089] = {.lex_state = 159},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 159},
  [1092] = {.lex_state = 160},
  [1093] = {.lex_state = 145},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 160},
  [1096] = {.lex_state = 145, .external_lex_state = 1},
  [1097] = {.lex_state = 145},
  [1098] = {.lex_state = 145},
  [1099] = {.lex_state = 156},
  [1100] = {.lex_state = 145},
  [1101] = {.lex_state = 160},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 160},
  [1104] = {.lex_state = 160},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 156},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 160},
  [1109] = {.lex_state = 145},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 160},
  [1112] = {.lex_state = 145},
  [1113] = {.lex_state = 145},
  [1114] = {.lex_state = 160},
  [1115] = {.lex_state = 160},
  [1116] = {.lex_state = 145},
  [1117] = {.lex_state = 160},
  [1118] = {.lex_state = 159},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 159},
  [1122] = {.lex_state = 142},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 156},
  [1125] = {.lex_state = 159},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 145},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 142},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 145},
  [1134] = {.lex_state = 145},
  [1135] = {.lex_state = 145},
  [1136] = {.lex_state = 145},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 145},
  [1140] = {.lex_state = 145},
  [1141] = {.lex_state = 159},
  [1142] = {.lex_state = 160},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 142},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 145},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 142},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 142},
  [1158] = {.lex_state = 142},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 142},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 142},
  [1171] = {.lex_state = 151},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 142},
  [1174] = {.lex_state = 145},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 142},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 160},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 142},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 142},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 142},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 145},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 142},
  [1207] = {.lex_state = 142},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 142},
  [1214] = {.lex_state = 142},
  [1215] = {.lex_state = 145},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 145},
  [1218] = {.lex_state = 142},
  [1219] = {.lex_state = 145},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 142},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 160},
  [1224] = {.lex_state = 160},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 145},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 145},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 160},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 169},
  [1239] = {.lex_state = 142},
  [1240] = {.lex_state = 145},
  [1241] = {.lex_state = 160},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 142},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 142},
  [1247] = {.lex_state = 142},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 145},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 145},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 169},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 169},
  [1274] = {.lex_state = 160},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 145},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 156},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 142},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 160},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 169},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 142},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 160},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 160},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 160},
  [1327] = {.lex_state = 169},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 169},
  [1330] = {.lex_state = 160},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 142},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 160},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 145},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 160},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 160},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 142},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 160},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 160},
  [1357] = {.lex_state = 142},
  [1358] = {.lex_state = 160},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 169},
  [1363] = {.lex_state = 142},
  [1364] = {.lex_state = 169},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 169},
  [1369] = {.lex_state = 169},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 0},
  [1375] = {.lex_state = 160},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 160},
  [1379] = {.lex_state = 145},
  [1380] = {.lex_state = 169},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 142},
  [1383] = {.lex_state = 169},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 160},
  [1386] = {.lex_state = 0},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 0},
  [1391] = {.lex_state = 145},
  [1392] = {.lex_state = 160},
  [1393] = {.lex_state = 0},
  [1394] = {.lex_state = 145},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 160},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 160},
  [1399] = {.lex_state = 160},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 160},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 160},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 169},
  [1412] = {.lex_state = 169},
  [1413] = {.lex_state = 160},
  [1414] = {.lex_state = 160},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 0},
  [1417] = {.lex_state = 160},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 0},
  [1421] = {.lex_state = 0},
  [1422] = {.lex_state = 0},
  [1423] = {.lex_state = 0},
  [1424] = {.lex_state = 0},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 0},
  [1427] = {.lex_state = 0},
  [1428] = {.lex_state = 0},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 160},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 160},
  [1435] = {.lex_state = 0},
  [1436] = {.lex_state = 0},
  [1437] = {.lex_state = 0},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 160},
  [1440] = {.lex_state = 169},
  [1441] = {.lex_state = 160},
  [1442] = {.lex_state = 169},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 0},
  [1445] = {.lex_state = 142},
  [1446] = {.lex_state = 0},
  [1447] = {.lex_state = 0},
  [1448] = {.lex_state = 142},
  [1449] = {.lex_state = 0},
  [1450] = {.lex_state = 142},
  [1451] = {.lex_state = 0},
  [1452] = {.lex_state = 0},
  [1453] = {.lex_state = 0},
  [1454] = {.lex_state = 0},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 142},
  [1459] = {.lex_state = 0},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 0},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 0},
  [1471] = {.lex_state = 0},
  [1472] = {.lex_state = 0},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 142},
  [1478] = {.lex_state = 0},
  [1479] = {.lex_state = 0},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 142},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 0},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 145},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 0},
  [1492] = {.lex_state = 0},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 142},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 142},
  [1498] = {.lex_state = 0},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 0},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 0},
  [1508] = {.lex_state = 142},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 142},
  [1511] = {.lex_state = 160},
  [1512] = {.lex_state = 0},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 0},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 160},
  [1520] = {.lex_state = 0},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 0},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 0},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 142},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 0},
  [1531] = {.lex_state = 145},
  [1532] = {.lex_state = 0},
  [1533] = {.lex_state = 142},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 0},
  [1537] = {.lex_state = 145},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 145},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 142},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 0},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 0},
  [1548] = {.lex_state = 0},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 0},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 142},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 0},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 142},
  [1559] = {.lex_state = 0},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 142},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 0},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 142},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 0},
};

enum {
  ts_external_token_quoted_content = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_quoted_content] = sym_quoted_content,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_quoted_content] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_erlang] = ACTIONS(1),
    [anon_sym_javascript] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_size] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_DOT] = ACTIONS(1),
    [anon_sym_LT_EQ_DOT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_DOT] = ACTIONS(1),
    [anon_sym_GT_EQ_DOT] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_DOT] = ACTIONS(1),
    [anon_sym_DASH_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_DOT] = ACTIONS(1),
    [anon_sym_SLASH_DOT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_todo] = ACTIONS(1),
    [anon_sym_panic] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [sym_visibility_modifier] = ACTIONS(1),
    [sym_opacity_modifier] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [aux_sym_escape_sequence_token1] = ACTIONS(1),
    [aux_sym_escape_sequence_token2] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym__hex] = ACTIONS(1),
    [sym__decimal] = ACTIONS(1),
    [sym__octal] = ACTIONS(1),
    [sym__binary] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_bytes] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_bit_string] = ACTIONS(1),
    [anon_sym_bits] = ACTIONS(1),
    [anon_sym_utf8] = ACTIONS(1),
    [anon_sym_utf16] = ACTIONS(1),
    [anon_sym_utf32] = ACTIONS(1),
    [anon_sym_utf8_codepoint] = ACTIONS(1),
    [anon_sym_utf16_codepoint] = ACTIONS(1),
    [anon_sym_utf32_codepoint] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_big] = ACTIONS(1),
    [anon_sym_little] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_unit] = ACTIONS(1),
    [sym__discard_name] = ACTIONS(1),
    [sym__name] = ACTIONS(1),
    [sym__upname] = ACTIONS(1),
    [sym_quoted_content] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(1524),
    [sym__module_statement] = STATE(3),
    [sym_target_group] = STATE(3),
    [sym_attribute] = STATE(3),
    [sym_import] = STATE(3),
    [sym_constant] = STATE(3),
    [sym_external_type] = STATE(3),
    [sym_external_function] = STATE(3),
    [sym_function] = STATE(3),
    [aux_sym__statement_seq] = STATE(5),
    [sym__statement] = STATE(566),
    [sym__expression] = STATE(97),
    [sym_binary_expression] = STATE(97),
    [sym__expression_unit] = STATE(97),
    [sym_record] = STATE(75),
    [sym_todo] = STATE(97),
    [sym_panic] = STATE(97),
    [sym_tuple] = STATE(74),
    [sym_list] = STATE(97),
    [sym__expression_bit_string] = STATE(97),
    [sym_anonymous_function] = STATE(71),
    [sym_block] = STATE(36),
    [sym_case] = STATE(36),
    [sym_let_assert] = STATE(566),
    [sym_let] = STATE(566),
    [sym_use] = STATE(566),
    [sym_assert] = STATE(97),
    [sym_boolean_negation] = STATE(97),
    [sym_integer_negation] = STATE(97),
    [sym_record_update] = STATE(75),
    [sym__maybe_tuple_expression] = STATE(1521),
    [sym_tuple_access] = STATE(36),
    [sym__maybe_record_expression] = STATE(1520),
    [sym_field_access] = STATE(36),
    [sym__maybe_function_expression] = STATE(1367),
    [sym_function_call] = STATE(36),
    [sym_type_definition] = STATE(3),
    [sym_type_alias] = STATE(3),
    [sym_string] = STATE(97),
    [sym_integer] = STATE(97),
    [sym_identifier] = STATE(40),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_POUND] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_external] = ACTIONS(31),
    [anon_sym_todo] = ACTIONS(33),
    [anon_sym_panic] = ACTIONS(35),
    [anon_sym_case] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_assert] = ACTIONS(41),
    [anon_sym_use] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(45),
    [sym_visibility_modifier] = ACTIONS(47),
    [sym_opacity_modifier] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [sym__hex] = ACTIONS(55),
    [sym__decimal] = ACTIONS(57),
    [sym__octal] = ACTIONS(55),
    [sym__binary] = ACTIONS(55),
    [sym__name] = ACTIONS(59),
    [sym__upname] = ACTIONS(61),
  },
  [2] = {
    [sym__module_statement] = STATE(2),
    [sym_target_group] = STATE(2),
    [sym_attribute] = STATE(2),
    [sym_import] = STATE(2),
    [sym_constant] = STATE(2),
    [sym_external_type] = STATE(2),
    [sym_external_function] = STATE(2),
    [sym_function] = STATE(2),
    [aux_sym__statement_seq] = STATE(5),
    [sym__statement] = STATE(566),
    [sym__expression] = STATE(97),
    [sym_binary_expression] = STATE(97),
    [sym__expression_unit] = STATE(97),
    [sym_record] = STATE(75),
    [sym_todo] = STATE(97),
    [sym_panic] = STATE(97),
    [sym_tuple] = STATE(74),
    [sym_list] = STATE(97),
    [sym__expression_bit_string] = STATE(97),
    [sym_anonymous_function] = STATE(71),
    [sym_block] = STATE(36),
    [sym_case] = STATE(36),
    [sym_let_assert] = STATE(566),
    [sym_let] = STATE(566),
    [sym_use] = STATE(566),
    [sym_assert] = STATE(97),
    [sym_boolean_negation] = STATE(97),
    [sym_integer_negation] = STATE(97),
    [sym_record_update] = STATE(75),
    [sym__maybe_tuple_expression] = STATE(1521),
    [sym_tuple_access] = STATE(36),
    [sym__maybe_record_expression] = STATE(1520),
    [sym_field_access] = STATE(36),
    [sym__maybe_function_expression] = STATE(1367),
    [sym_function_call] = STATE(36),
    [sym_type_definition] = STATE(2),
    [sym_type_alias] = STATE(2),
    [sym_string] = STATE(97),
    [sym_integer] = STATE(97),
    [sym_identifier] = STATE(40),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(68),
    [anon_sym_AT] = ACTIONS(71),
    [anon_sym_import] = ACTIONS(74),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_const] = ACTIONS(80),
    [anon_sym_POUND] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(86),
    [anon_sym_LT_LT] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(92),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_external] = ACTIONS(98),
    [anon_sym_todo] = ACTIONS(101),
    [anon_sym_panic] = ACTIONS(104),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_let] = ACTIONS(110),
    [anon_sym_assert] = ACTIONS(113),
    [anon_sym_use] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(119),
    [sym_visibility_modifier] = ACTIONS(122),
    [sym_opacity_modifier] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(128),
    [sym_float] = ACTIONS(131),
    [sym__hex] = ACTIONS(134),
    [sym__decimal] = ACTIONS(137),
    [sym__octal] = ACTIONS(134),
    [sym__binary] = ACTIONS(134),
    [sym__name] = ACTIONS(140),
    [sym__upname] = ACTIONS(143),
  },
  [3] = {
    [sym__module_statement] = STATE(2),
    [sym_target_group] = STATE(2),
    [sym_attribute] = STATE(2),
    [sym_import] = STATE(2),
    [sym_constant] = STATE(2),
    [sym_external_type] = STATE(2),
    [sym_external_function] = STATE(2),
    [sym_function] = STATE(2),
    [aux_sym__statement_seq] = STATE(5),
    [sym__statement] = STATE(566),
    [sym__expression] = STATE(97),
    [sym_binary_expression] = STATE(97),
    [sym__expression_unit] = STATE(97),
    [sym_record] = STATE(75),
    [sym_todo] = STATE(97),
    [sym_panic] = STATE(97),
    [sym_tuple] = STATE(74),
    [sym_list] = STATE(97),
    [sym__expression_bit_string] = STATE(97),
    [sym_anonymous_function] = STATE(71),
    [sym_block] = STATE(36),
    [sym_case] = STATE(36),
    [sym_let_assert] = STATE(566),
    [sym_let] = STATE(566),
    [sym_use] = STATE(566),
    [sym_assert] = STATE(97),
    [sym_boolean_negation] = STATE(97),
    [sym_integer_negation] = STATE(97),
    [sym_record_update] = STATE(75),
    [sym__maybe_tuple_expression] = STATE(1521),
    [sym_tuple_access] = STATE(36),
    [sym__maybe_record_expression] = STATE(1520),
    [sym_field_access] = STATE(36),
    [sym__maybe_function_expression] = STATE(1367),
    [sym_function_call] = STATE(36),
    [sym_type_definition] = STATE(2),
    [sym_type_alias] = STATE(2),
    [sym_string] = STATE(97),
    [sym_integer] = STATE(97),
    [sym_identifier] = STATE(40),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(146),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_POUND] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_external] = ACTIONS(31),
    [anon_sym_todo] = ACTIONS(33),
    [anon_sym_panic] = ACTIONS(35),
    [anon_sym_case] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_assert] = ACTIONS(41),
    [anon_sym_use] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(45),
    [sym_visibility_modifier] = ACTIONS(47),
    [sym_opacity_modifier] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [sym__hex] = ACTIONS(55),
    [sym__decimal] = ACTIONS(57),
    [sym__octal] = ACTIONS(55),
    [sym__binary] = ACTIONS(55),
    [sym__name] = ACTIONS(59),
    [sym__upname] = ACTIONS(61),
  },
  [4] = {
    [aux_sym__statement_seq] = STATE(4),
    [sym__statement] = STATE(566),
    [sym__expression] = STATE(97),
    [sym_binary_expression] = STATE(97),
    [sym__expression_unit] = STATE(97),
    [sym_record] = STATE(75),
    [sym_todo] = STATE(97),
    [sym_panic] = STATE(97),
    [sym_tuple] = STATE(74),
    [sym_list] = STATE(97),
    [sym__expression_bit_string] = STATE(97),
    [sym_anonymous_function] = STATE(71),
    [sym_block] = STATE(36),
    [sym_case] = STATE(36),
    [sym_let_assert] = STATE(566),
    [sym_let] = STATE(566),
    [sym_use] = STATE(566),
    [sym_assert] = STATE(97),
    [sym_boolean_negation] = STATE(97),
    [sym_integer_negation] = STATE(97),
    [sym_record_update] = STATE(75),
    [sym__maybe_tuple_expression] = STATE(1521),
    [sym_tuple_access] = STATE(36),
    [sym__maybe_record_expression] = STATE(1520),
    [sym_field_access] = STATE(36),
    [sym__maybe_function_expression] = STATE(1367),
    [sym_function_call] = STATE(36),
    [sym_string] = STATE(97),
    [sym_integer] = STATE(97),
    [sym_identifier] = STATE(40),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [ts_builtin_sym_end] = ACTIONS(148),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(150),
    [anon_sym_LBRACE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(148),
    [anon_sym_import] = ACTIONS(150),
    [anon_sym_type] = ACTIONS(150),
    [anon_sym_const] = ACTIONS(150),
    [anon_sym_POUND] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_fn] = ACTIONS(167),
    [anon_sym_external] = ACTIONS(150),
    [anon_sym_todo] = ACTIONS(170),
    [anon_sym_panic] = ACTIONS(173),
    [anon_sym_case] = ACTIONS(176),
    [anon_sym_let] = ACTIONS(179),
    [anon_sym_assert] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(188),
    [sym_visibility_modifier] = ACTIONS(150),
    [sym_opacity_modifier] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_float] = ACTIONS(194),
    [sym__hex] = ACTIONS(197),
    [sym__decimal] = ACTIONS(200),
    [sym__octal] = ACTIONS(197),
    [sym__binary] = ACTIONS(197),
    [sym__name] = ACTIONS(203),
    [sym__upname] = ACTIONS(206),
  },
  [5] = {
    [aux_sym__statement_seq] = STATE(4),
    [sym__statement] = STATE(566),
    [sym__expression] = STATE(97),
    [sym_binary_expression] = STATE(97),
    [sym__expression_unit] = STATE(97),
    [sym_record] = STATE(75),
    [sym_todo] = STATE(97),
    [sym_panic] = STATE(97),
    [sym_tuple] = STATE(74),
    [sym_list] = STATE(97),
    [sym__expression_bit_string] = STATE(97),
    [sym_anonymous_function] = STATE(71),
    [sym_block] = STATE(36),
    [sym_case] = STATE(36),
    [sym_let_assert] = STATE(566),
    [sym_let] = STATE(566),
    [sym_use] = STATE(566),
    [sym_assert] = STATE(97),
    [sym_boolean_negation] = STATE(97),
    [sym_integer_negation] = STATE(97),
    [sym_record_update] = STATE(75),
    [sym__maybe_tuple_expression] = STATE(1521),
    [sym_tuple_access] = STATE(36),
    [sym__maybe_record_expression] = STATE(1520),
    [sym_field_access] = STATE(36),
    [sym__maybe_function_expression] = STATE(1367),
    [sym_function_call] = STATE(36),
    [sym_string] = STATE(97),
    [sym_integer] = STATE(97),
    [sym_identifier] = STATE(40),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [ts_builtin_sym_end] = ACTIONS(209),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(213),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_import] = ACTIONS(211),
    [anon_sym_type] = ACTIONS(211),
    [anon_sym_const] = ACTIONS(211),
    [anon_sym_POUND] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(222),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_fn] = ACTIONS(228),
    [anon_sym_external] = ACTIONS(211),
    [anon_sym_todo] = ACTIONS(231),
    [anon_sym_panic] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(237),
    [anon_sym_let] = ACTIONS(240),
    [anon_sym_assert] = ACTIONS(243),
    [anon_sym_use] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(249),
    [sym_visibility_modifier] = ACTIONS(211),
    [sym_opacity_modifier] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_float] = ACTIONS(255),
    [sym__hex] = ACTIONS(258),
    [sym__decimal] = ACTIONS(261),
    [sym__octal] = ACTIONS(258),
    [sym__binary] = ACTIONS(258),
    [sym__name] = ACTIONS(264),
    [sym__upname] = ACTIONS(267),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(274), 1,
      anon_sym_LPAREN,
    STATE(77), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(270), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [71] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_RBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [197] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(316), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [323] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(320), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(318), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [389] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(322), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [515] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(326), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(324), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [581] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(330), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(328), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [647] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(332), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [713] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(336), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [839] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(338), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [965] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(340), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1091] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(342), 1,
      anon_sym_RBRACE,
    STATE(22), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1217] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(348), 1,
      anon_sym_LPAREN,
    ACTIONS(350), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(346), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(344), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1287] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(356), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(354), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(352), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1357] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(360), 1,
      anon_sym_RBRACE,
    STATE(42), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1483] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(362), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1609] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(364), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1735] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(366), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1801] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(370), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1867] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(374), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1933] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(50), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2059] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(380), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2125] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(386), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(384), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2191] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(390), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(388), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2257] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(394), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(392), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2323] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(396), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2449] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(400), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(398), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2515] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(404), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(402), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2581] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(406), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2707] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(408), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2833] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(410), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2903] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(419), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3029] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(421), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3155] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(423), 1,
      anon_sym_RBRACE,
    STATE(14), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3281] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(425), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(410), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [3351] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(429), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3477] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(431), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3603] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(148), 1,
      anon_sym_RBRACE,
    ACTIONS(433), 1,
      anon_sym_LBRACE,
    ACTIONS(436), 1,
      anon_sym_POUND,
    ACTIONS(439), 1,
      anon_sym_LBRACK,
    ACTIONS(442), 1,
      anon_sym_LT_LT,
    ACTIONS(445), 1,
      anon_sym_DASH,
    ACTIONS(448), 1,
      anon_sym_fn,
    ACTIONS(451), 1,
      anon_sym_todo,
    ACTIONS(454), 1,
      anon_sym_panic,
    ACTIONS(457), 1,
      anon_sym_case,
    ACTIONS(460), 1,
      anon_sym_let,
    ACTIONS(463), 1,
      anon_sym_assert,
    ACTIONS(466), 1,
      anon_sym_use,
    ACTIONS(469), 1,
      anon_sym_BANG,
    ACTIONS(472), 1,
      anon_sym_DQUOTE,
    ACTIONS(475), 1,
      sym_float,
    ACTIONS(481), 1,
      sym__decimal,
    ACTIONS(484), 1,
      sym__name,
    ACTIONS(487), 1,
      sym__upname,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(478), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3729] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(490), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3855] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(494), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(492), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [3921] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(496), 1,
      anon_sym_RBRACE,
    STATE(41), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4047] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(500), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(498), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4113] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(502), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4239] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(504), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4365] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(506), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4491] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(510), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(508), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4557] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(512), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4683] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(514), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4809] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(516), 1,
      anon_sym_RBRACE,
    STATE(56), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4935] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(518), 1,
      anon_sym_RBRACE,
    STATE(7), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5061] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(520), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5187] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(522), 1,
      anon_sym_RBRACE,
    STATE(43), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5313] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(524), 1,
      anon_sym_RBRACE,
    STATE(49), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5439] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(48), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5562] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(526), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [5627] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(53), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5750] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(57), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5873] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(38), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5996] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(530), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6061] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(35), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6184] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(37), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6307] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(15), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6430] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(534), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6495] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(538), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6560] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(44), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6683] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(410), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6750] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(16), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6873] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(390), 20,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(388), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6938] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(410), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7005] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(410), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7072] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(21), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7195] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(546), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7260] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(31), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7383] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(8), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7506] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(52), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7629] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(34), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7752] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(550), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7817] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(554), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7882] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(558), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7947] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(296), 1,
      anon_sym_let,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(300), 1,
      anon_sym_use,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(306), 1,
      sym_float,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    STATE(10), 1,
      aux_sym__statement_seq,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(811), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8070] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(562), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8134] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(584), 1,
      anon_sym_DOT_DOT,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1167), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8260] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(608), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(606), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8324] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(612), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(610), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8388] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(616), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(614), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8452] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(618), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(620), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8536] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(642), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(644), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8620] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(648), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(646), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8684] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(652), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(650), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8748] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(654), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8812] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(658), 1,
      anon_sym_RPAREN,
    ACTIONS(660), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1181), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8938] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(662), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(664), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9022] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(666), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9086] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(670), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9150] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(674), 1,
      anon_sym_RPAREN,
    ACTIONS(676), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1242), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [9276] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(678), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(680), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9360] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(682), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(684), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9444] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(688), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(686), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9508] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(690), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(692), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9592] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 23,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9660] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(694), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9724] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9806] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(698), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9870] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(704), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(702), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9934] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(706), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9998] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(710), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10062] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(716), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10126] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(720), 1,
      anon_sym_RPAREN,
    ACTIONS(722), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1271), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [10252] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10332] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(724), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10396] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10474] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(626), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(628), 1,
      anon_sym_AMP_AMP,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(630), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(632), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(634), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(728), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(730), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10558] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(732), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10622] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(636), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 20,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 21,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10696] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(736), 1,
      anon_sym_RPAREN,
    ACTIONS(738), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1231), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [10822] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(638), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(640), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 21,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 21,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10894] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(740), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10958] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(744), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [11022] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(720), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1271), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11145] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(748), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11268] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(404), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(402), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [11331] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11454] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(330), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(328), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [11517] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(736), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1231), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11640] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(386), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(384), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [11703] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(658), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1181), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11826] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(752), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11949] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(754), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12072] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(394), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(392), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [12135] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1167), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12258] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(756), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12381] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(674), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1242), 1,
      sym_argument,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12504] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12627] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(760), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12750] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(762), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12873] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12996] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(766), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [13119] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(594), 1,
      sym_float,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1340), 1,
      sym_hole,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1446), 1,
      sym_argument,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1564), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(723), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [13239] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(768), 1,
      anon_sym_LPAREN,
    STATE(163), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(270), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13305] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(410), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13370] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(374), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13431] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(366), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13492] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(380), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13553] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(400), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(398), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13614] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(320), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(318), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13675] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(326), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(324), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13736] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(770), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(410), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13801] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(370), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13862] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(332), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13923] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(706), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13984] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(670), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14045] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(510), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(508), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14106] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(494), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(492), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14167] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(558), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14227] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(774), 1,
      anon_sym_RBRACK,
    ACTIONS(776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14341] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(782), 1,
      anon_sym_RBRACK,
    ACTIONS(784), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14455] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(786), 1,
      anon_sym_RBRACK,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14569] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(546), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14629] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(790), 1,
      anon_sym_RBRACK,
    ACTIONS(792), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14743] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(600), 1,
      sym__discard_name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(794), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1438), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(725), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14857] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(554), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14917] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(796), 1,
      anon_sym_RBRACK,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15031] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(800), 1,
      anon_sym_RBRACK,
    ACTIONS(802), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15145] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(804), 1,
      anon_sym_RBRACK,
    ACTIONS(806), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15259] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(410), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15321] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(410), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15383] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(534), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15443] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(808), 1,
      anon_sym_RBRACK,
    ACTIONS(810), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15557] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(410), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15619] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(550), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15679] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(812), 1,
      anon_sym_RBRACK,
    ACTIONS(814), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15793] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(526), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15853] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(816), 1,
      anon_sym_RBRACK,
    ACTIONS(818), 1,
      anon_sym_DOT_DOT,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15967] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(538), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16027] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(530), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16087] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(694), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16146] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(732), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16205] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(820), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    STATE(1560), 1,
      sym_case_subjects,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16316] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(724), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16375] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(820), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1474), 1,
      sym_case_subjects,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16486] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(822), 1,
      anon_sym_RPAREN,
    ACTIONS(824), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(685), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16597] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(826), 1,
      anon_sym_RPAREN,
    ACTIONS(828), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(670), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16708] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(744), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16767] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(608), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(606), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16826] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(652), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(650), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16885] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(830), 1,
      anon_sym_RBRACK,
    ACTIONS(832), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(648), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16996] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(654), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17055] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(834), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17166] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(836), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17277] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(648), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(646), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17336] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(838), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17447] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(840), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17558] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(612), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(610), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17617] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(842), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17728] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(820), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1504), 1,
      sym_case_subjects,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17839] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(844), 1,
      anon_sym_RBRACK,
    ACTIONS(846), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(656), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17950] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(820), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1517), 1,
      sym_case_subjects,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18061] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(820), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1529), 1,
      sym_case_subjects,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18172] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(848), 1,
      anon_sym_RBRACK,
    ACTIONS(850), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(653), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18283] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(716), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18342] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(710), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18401] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(852), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18512] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(854), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18623] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(856), 1,
      anon_sym_RPAREN,
    ACTIONS(858), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(695), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18734] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18793] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(860), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18904] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(704), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(702), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18963] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(616), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(614), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [19022] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(740), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [19081] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(862), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19192] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(864), 1,
      anon_sym_RPAREN,
    ACTIONS(866), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(669), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19303] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(868), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19414] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(870), 1,
      anon_sym_RBRACK,
    ACTIONS(872), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(634), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19525] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(666), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [19584] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(874), 1,
      anon_sym_RBRACK,
    ACTIONS(876), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(637), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19695] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(698), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [19754] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(878), 1,
      anon_sym_RPAREN,
    ACTIONS(880), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(683), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19865] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(884), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(104), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19973] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(886), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(335), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20081] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(888), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(476), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20189] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(890), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(477), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20297] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(892), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(762), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20405] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(894), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(478), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20513] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(896), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(479), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20621] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(898), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(763), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20729] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(900), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(734), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20837] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(902), 1,
      anon_sym_GT_GT,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1197), 1,
      sym_expression_bit_string_segment,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20949] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(916), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(796), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21057] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(918), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1252), 1,
      sym_expression_bit_string_segment,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21169] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(920), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(474), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21277] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(922), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(473), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21385] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(924), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(472), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21493] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21601] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(926), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(471), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21709] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(500), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(498), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [21767] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(928), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(487), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21875] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(930), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(779), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21983] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(932), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(785), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22091] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(934), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(784), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22199] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(936), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(776), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22307] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(962), 1,
      sym_float,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(404), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22415] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(972), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(502), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22523] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(974), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(772), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22631] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(976), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(351), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22739] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(978), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(774), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22847] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(980), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(789), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22955] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(982), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(766), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23063] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(984), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(423), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23171] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(986), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(424), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23279] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(988), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(422), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23387] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(990), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(421), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23495] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(992), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(420), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23603] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(994), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(419), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23711] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(996), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(417), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23819] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(998), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(416), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23927] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(1000), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(415), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24035] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(1002), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(393), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24143] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1004), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24255] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(1006), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(400), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24363] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1008), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(737), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24471] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1034), 1,
      sym_float,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(758), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24579] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1044), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(739), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24687] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1046), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(745), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24795] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1048), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(752), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24903] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1050), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(735), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25011] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1052), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(780), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25119] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(1054), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(411), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25227] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1056), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(767), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25335] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1058), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(748), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25443] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1060), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(747), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25551] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1062), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(349), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25659] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1064), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25771] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1066), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(338), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25879] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1068), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(736), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25987] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1070), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(738), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26095] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1072), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(102), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26203] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1074), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(101), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26311] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1076), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(741), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26419] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1078), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(117), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26527] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1080), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26635] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1083), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(742), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26743] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1085), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(743), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26851] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1087), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(746), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26959] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1089), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(757), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27067] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1091), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(775), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27175] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1093), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27287] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1095), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1210), 1,
      sym_expression_bit_string_segment,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27399] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1097), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(475), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27507] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1099), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(328), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27615] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1101), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(342), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27723] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1103), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(341), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27831] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1105), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(340), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27939] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1107), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(339), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28047] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1109), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(346), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28155] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1111), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1149), 1,
      sym_expression_bit_string_segment,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28267] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1113), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(621), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28375] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1116), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28487] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1118), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(336), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28595] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1120), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28707] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1122), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(344), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28815] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1124), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(334), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28923] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1126), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29035] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1128), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(92), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29143] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1130), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(791), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29251] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1132), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(760), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29359] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1134), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(722), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29467] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1136), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29579] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1138), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29691] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1140), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(121), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29799] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1142), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(119), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29907] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1144), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(116), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30015] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1146), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(114), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30123] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1148), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(107), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30231] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1150), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(105), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30339] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1152), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(91), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30447] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1154), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(103), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30555] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1156), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1199), 1,
      sym_expression_bit_string_segment,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30667] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1158), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30779] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    ACTIONS(1160), 1,
      anon_sym_GT_GT,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30891] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1162), 1,
      anon_sym_LPAREN,
    ACTIONS(1164), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(354), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(352), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [30953] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    ACTIONS(1168), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(346), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(344), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31015] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(914), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1423), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31124] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 14,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31190] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1180), 1,
      sym_float,
    ACTIONS(1184), 1,
      sym__decimal,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1182), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(112), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31296] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1186), 1,
      sym_float,
    ACTIONS(1190), 1,
      sym__decimal,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1188), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(492), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31402] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1192), 1,
      sym_float,
    ACTIONS(1196), 1,
      sym__decimal,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1194), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31508] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(1198), 1,
      sym_float,
    ACTIONS(1202), 1,
      sym__decimal,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1200), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(412), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31614] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(938), 1,
      anon_sym_LBRACE,
    ACTIONS(940), 1,
      anon_sym_POUND,
    ACTIONS(942), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 1,
      anon_sym_LT_LT,
    ACTIONS(946), 1,
      anon_sym_DASH,
    ACTIONS(948), 1,
      anon_sym_fn,
    ACTIONS(950), 1,
      anon_sym_todo,
    ACTIONS(952), 1,
      anon_sym_panic,
    ACTIONS(954), 1,
      anon_sym_case,
    ACTIONS(956), 1,
      anon_sym_assert,
    ACTIONS(958), 1,
      anon_sym_BANG,
    ACTIONS(960), 1,
      anon_sym_DQUOTE,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(968), 1,
      sym__name,
    ACTIONS(970), 1,
      sym__upname,
    ACTIONS(1204), 1,
      sym_float,
    STATE(367), 1,
      sym_identifier,
    STATE(386), 1,
      sym_tuple,
    STATE(389), 1,
      sym_anonymous_function,
    STATE(1384), 1,
      sym__maybe_function_expression,
    STATE(1460), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(388), 2,
      sym_record,
      sym_record_update,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(366), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(397), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31720] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(684), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(682), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31796] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 14,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31860] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(620), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(618), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31936] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1216), 1,
      sym_float,
    ACTIONS(1220), 1,
      sym__decimal,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1218), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(787), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32042] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(730), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(728), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32118] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 16,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32178] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(688), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32252] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(688), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32324] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(688), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32394] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(290), 1,
      anon_sym_todo,
    ACTIONS(292), 1,
      anon_sym_panic,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(298), 1,
      anon_sym_assert,
    ACTIONS(302), 1,
      anon_sym_BANG,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1222), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1496), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(195), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32500] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(680), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(678), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32576] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(566), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_POUND,
    ACTIONS(572), 1,
      anon_sym_LBRACK,
    ACTIONS(574), 1,
      anon_sym_LT_LT,
    ACTIONS(576), 1,
      anon_sym_DASH,
    ACTIONS(578), 1,
      anon_sym_fn,
    ACTIONS(580), 1,
      anon_sym_todo,
    ACTIONS(582), 1,
      anon_sym_panic,
    ACTIONS(586), 1,
      anon_sym_case,
    ACTIONS(588), 1,
      anon_sym_assert,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1224), 1,
      sym_float,
    STATE(435), 1,
      sym_identifier,
    STATE(454), 1,
      sym_tuple,
    STATE(455), 1,
      sym_anonymous_function,
    STATE(1341), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1551), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(428), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(434), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(489), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32682] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(688), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32738] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    ACTIONS(1012), 1,
      anon_sym_POUND,
    ACTIONS(1014), 1,
      anon_sym_LBRACK,
    ACTIONS(1016), 1,
      anon_sym_LT_LT,
    ACTIONS(1018), 1,
      anon_sym_DASH,
    ACTIONS(1020), 1,
      anon_sym_fn,
    ACTIONS(1022), 1,
      anon_sym_todo,
    ACTIONS(1024), 1,
      anon_sym_panic,
    ACTIONS(1026), 1,
      anon_sym_case,
    ACTIONS(1028), 1,
      anon_sym_assert,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1226), 1,
      sym_float,
    STATE(679), 1,
      sym_identifier,
    STATE(731), 1,
      sym_anonymous_function,
    STATE(732), 1,
      sym_tuple,
    STATE(1426), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(659), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(709), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(678), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(756), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32844] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(1222), 1,
      sym_float,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(195), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32950] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(692), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(690), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33026] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(882), 1,
      anon_sym_fn,
    ACTIONS(1228), 1,
      sym_float,
    STATE(40), 1,
      sym_identifier,
    STATE(71), 1,
      sym_anonymous_function,
    STATE(74), 1,
      sym_tuple,
    STATE(1367), 1,
      sym__maybe_function_expression,
    STATE(1520), 1,
      sym__maybe_record_expression,
    STATE(1521), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(75), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(36), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(93), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [33132] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(644), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(642), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33208] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(280), 1,
      anon_sym_POUND,
    ACTIONS(282), 1,
      anon_sym_LBRACK,
    ACTIONS(284), 1,
      anon_sym_LT_LT,
    ACTIONS(288), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_case,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(904), 1,
      anon_sym_DASH,
    ACTIONS(906), 1,
      anon_sym_todo,
    ACTIONS(908), 1,
      anon_sym_panic,
    ACTIONS(910), 1,
      anon_sym_assert,
    ACTIONS(912), 1,
      anon_sym_BANG,
    ACTIONS(1192), 1,
      sym_float,
    ACTIONS(1196), 1,
      sym__decimal,
    STATE(152), 1,
      sym_identifier,
    STATE(171), 1,
      sym_tuple,
    STATE(174), 1,
      sym_anonymous_function,
    STATE(1387), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1503), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(170), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1194), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(145), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(205), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [33314] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1206), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1176), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1210), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1178), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1212), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1214), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(664), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(662), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33390] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(404), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(402), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33445] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(386), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(384), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33500] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(390), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(388), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33555] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(394), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(392), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33610] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(330), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(328), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33663] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 9,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(706), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33716] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 9,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(670), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33769] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1230), 1,
      anon_sym_LPAREN,
    STATE(391), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(270), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33824] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(386), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(384), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33874] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(390), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(388), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33924] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1232), 1,
      anon_sym_LPAREN,
    ACTIONS(1234), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(346), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(344), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33978] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1236), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(354), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(352), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34032] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(410), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34086] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(1240), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(410), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34140] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(374), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34190] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(494), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(492), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34240] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(500), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(498), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34290] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(332), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34340] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(326), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(324), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34390] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(320), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(318), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34440] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(370), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34490] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(380), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34540] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(330), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(328), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34590] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(366), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34640] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(404), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(402), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34690] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(400), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(398), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34740] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(510), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(508), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34790] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(394), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(392), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34840] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(558), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34889] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(526), 26,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34938] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(554), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34987] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(530), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35036] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(410), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35087] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(550), 26,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35136] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(410), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35187] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(410), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35238] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(538), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35287] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(546), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35336] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(534), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35385] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(730), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(728), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35453] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(744), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35501] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(706), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35549] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(732), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35597] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(648), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(646), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35645] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(698), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35693] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(666), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35741] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(644), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(642), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35809] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(740), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35857] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(616), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(614), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35905] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(704), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(702), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35953] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1266), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1264), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36021] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(724), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36069] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(612), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(610), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36117] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(654), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36165] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(652), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(650), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36213] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(608), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(606), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36261] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(670), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36309] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1270), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1268), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36377] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(716), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36425] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(710), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36473] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(562), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36521] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 7,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(686), 19,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36577] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 7,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(686), 18,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36635] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 14,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36697] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(694), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36745] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 12,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36809] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 11,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36875] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 9,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(686), 21,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36927] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(688), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(686), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36975] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(684), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(682), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [37043] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(680), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(678), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [37111] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    STATE(427), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1272), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1274), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37161] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    STATE(425), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1278), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1280), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37211] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1286), 1,
      anon_sym_SLASH,
    STATE(427), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1282), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1284), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37261] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1289), 1,
      anon_sym_LPAREN,
    STATE(463), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(270), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37311] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1282), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1284), 19,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37356] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(370), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37401] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1293), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(346), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(344), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37450] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(354), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(352), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37499] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(400), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(398), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37544] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(1299), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37593] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(1302), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37642] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(500), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(498), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37687] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(374), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37732] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(494), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(492), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37777] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1310), 1,
      anon_sym_LPAREN,
    STATE(503), 1,
      sym_type_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1306), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1308), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37826] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(332), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37871] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(326), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(324), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37916] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(366), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37961] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(320), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(318), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38006] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(380), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38051] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(510), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(508), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38096] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1312), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38142] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(530), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38186] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(534), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38230] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(526), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38274] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1318), 1,
      anon_sym_LPAREN,
    STATE(578), 1,
      sym_constant_record_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1314), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1316), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38322] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1320), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1322), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38366] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    STATE(605), 1,
      sym_type_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1324), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1326), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38414] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(538), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38458] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1330), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38504] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38550] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1332), 1,
      anon_sym_RBRACE,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    STATE(1473), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(514), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38634] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(550), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38678] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1356), 1,
      anon_sym_RBRACE,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    STATE(1516), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(514), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38762] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1358), 1,
      anon_sym_RBRACE,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    STATE(1476), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(514), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38846] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1360), 1,
      anon_sym_RBRACE,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    STATE(1555), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(514), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38930] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(558), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38974] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1362), 1,
      anon_sym_RBRACE,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    STATE(1453), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(514), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [39058] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(546), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39102] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(554), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39146] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1364), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1366), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39194] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1372), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1374), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39238] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(608), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(606), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39281] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(704), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(702), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39324] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1376), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1378), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39367] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1384), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1386), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1194), 1,
      sym__pattern,
    STATE(1259), 1,
      sym_record_pattern_argument,
    STATE(1494), 1,
      sym_label,
    STATE(1534), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [39450] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DOT_DOT,
  [39501] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DOT_DOT,
  [39554] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(686), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DOT_DOT,
  [39609] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(686), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DOT_DOT,
  [39666] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(686), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_DOT_DOT,
  [39725] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 6,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
    ACTIONS(686), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DOT_DOT,
  [39772] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(688), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(686), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39815] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(678), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [39876] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(682), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [39937] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(724), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39980] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1408), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1410), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40023] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(732), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40066] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(698), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40109] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1416), 1,
      anon_sym_LBRACE,
    ACTIONS(1418), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1412), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1414), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40156] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(652), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(650), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40199] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(654), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40242] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(728), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [40303] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1384), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1420), 1,
      anon_sym_RPAREN,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1090), 1,
      sym_record_pattern_argument,
    STATE(1194), 1,
      sym__pattern,
    STATE(1493), 1,
      sym_pattern_spread,
    STATE(1494), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [40386] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(648), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(646), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40429] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(612), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(610), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40472] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1426), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1422), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1424), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40517] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(716), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40560] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(710), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40603] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(562), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40646] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(694), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40689] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(744), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40732] = 23,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1428), 1,
      anon_sym_RBRACE,
    ACTIONS(1430), 1,
      anon_sym_POUND,
    ACTIONS(1433), 1,
      anon_sym_LBRACK,
    ACTIONS(1436), 1,
      anon_sym_LT_LT,
    ACTIONS(1439), 1,
      anon_sym_DASH,
    ACTIONS(1442), 1,
      anon_sym_DQUOTE,
    ACTIONS(1445), 1,
      sym_float,
    ACTIONS(1451), 1,
      sym__decimal,
    ACTIONS(1454), 1,
      sym__discard_name,
    ACTIONS(1457), 1,
      sym__name,
    ACTIONS(1460), 1,
      sym__upname,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(497), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1448), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [40813] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(616), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(614), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40856] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(740), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40899] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1463), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1465), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40942] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1467), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1469), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40985] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(642), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [41046] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1471), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1473), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41089] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1479), 1,
      anon_sym_LBRACE,
    ACTIONS(1481), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1475), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1477), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41136] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(388), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1483), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1485), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41181] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1487), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1489), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41228] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(666), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41271] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1495), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1497), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41314] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1499), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1501), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41357] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1507), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1503), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1505), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41402] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1509), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1511), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41445] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACE,
    ACTIONS(1519), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1513), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1515), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41492] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1525), 1,
      anon_sym_size,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1521), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1261), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41549] = 23,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1533), 1,
      anon_sym_RBRACE,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1124), 1,
      sym_case_clause_pattern,
    STATE(1171), 1,
      sym_case_clause_patterns,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(497), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [41630] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1535), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1537), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41673] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1525), 1,
      anon_sym_size,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1539), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1261), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41730] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1543), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1541), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1254), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41787] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1547), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1545), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1240), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41844] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1549), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1551), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41887] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1547), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1553), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1240), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41944] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1555), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1557), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41987] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1559), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1561), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42030] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1543), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1254), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [42087] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1384), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1565), 1,
      anon_sym_RPAREN,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1194), 1,
      sym__pattern,
    STATE(1259), 1,
      sym_record_pattern_argument,
    STATE(1494), 1,
      sym_label,
    STATE(1566), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [42170] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1567), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1569), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42213] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1571), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1573), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42255] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1575), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1577), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42297] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1579), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1581), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42339] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1583), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1585), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42381] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1595), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(873), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(903), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [42453] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1525), 1,
      anon_sym_size,
    ACTIONS(1531), 1,
      anon_sym_unit,
    STATE(1425), 1,
      sym_constant_bit_string_segment_options,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1112), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [42509] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1597), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1599), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42551] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(328), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(390), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(388), 20,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [42595] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1601), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1603), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42637] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1605), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1607), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42679] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1609), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(873), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(912), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [42751] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1611), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(873), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(944), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [42823] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1613), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1615), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42865] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1617), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1619), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42907] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1621), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(873), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(923), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [42979] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1623), 1,
      anon_sym_DASH,
    ACTIONS(1625), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(882), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(914), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [43051] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1631), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1627), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1629), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43095] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1633), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1635), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43137] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1637), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1639), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43179] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1641), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1643), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43221] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1645), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1647), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43263] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1649), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1651), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43305] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1030), 1,
      anon_sym_BANG,
    ACTIONS(1032), 1,
      anon_sym_DQUOTE,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1040), 1,
      sym__name,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1653), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(873), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(852), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [43377] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1655), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1657), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43419] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1659), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1661), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43461] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1663), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1665), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43503] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1667), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1669), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43545] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1671), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1673), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43587] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1675), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1677), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43629] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1679), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1681), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43671] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1683), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1685), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43713] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1687), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1689), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43755] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1691), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1693), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43797] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1695), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1697), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43839] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1699), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1701), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43881] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1703), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1705), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43923] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1707), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1709), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43965] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1623), 1,
      anon_sym_DASH,
    ACTIONS(1653), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(882), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(852), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [44037] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1711), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1713), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44079] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1715), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1717), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44121] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1719), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1721), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44163] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1723), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1725), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44205] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1727), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1729), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44247] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1731), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1733), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44289] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1735), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1737), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44331] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1739), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1741), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44373] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1747), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1743), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1745), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44417] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1749), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1751), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44459] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1753), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1755), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44501] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1757), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1759), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44543] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1761), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1763), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44585] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1765), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1767), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44627] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1769), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1771), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1773), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1775), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44711] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1777), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1779), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44753] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1623), 1,
      anon_sym_DASH,
    ACTIONS(1781), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(882), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(929), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [44825] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1783), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1785), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44867] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1787), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1789), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44909] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1791), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1793), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44951] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1543), 1,
      anon_sym_size,
    STATE(1361), 1,
      sym_pattern_bit_string_segment_options,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1116), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [45007] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1623), 1,
      anon_sym_DASH,
    ACTIONS(1795), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(882), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(931), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [45079] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1797), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1799), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45121] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1801), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1803), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45163] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(500), 9,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PIPE,
    ACTIONS(498), 21,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [45205] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1547), 1,
      anon_sym_size,
    STATE(1424), 1,
      sym_expression_bit_string_segment_options,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1135), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [45261] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(590), 1,
      anon_sym_BANG,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1623), 1,
      anon_sym_DASH,
    ACTIONS(1805), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_guard_binary_expression,
    STATE(872), 1,
      sym__case_clause_tuple_access,
    STATE(882), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(924), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [45333] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1807), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1809), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45375] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1811), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1813), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45417] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1815), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1817), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45459] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1819), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1821), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45501] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1823), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1825), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45543] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1827), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1829), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45585] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1831), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1833), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45627] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1835), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1837), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1839), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1841), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45711] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1843), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1845), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45753] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1847), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1849), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45795] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1851), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1853), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45837] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1487), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1489), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45879] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1855), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1857), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45921] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1859), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1861), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45963] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1863), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1865), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [46005] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1867), 1,
      anon_sym_LT_DASH,
    ACTIONS(1869), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1122), 1,
      sym__pattern,
    STATE(1170), 1,
      sym_use_assignment,
    STATE(1477), 1,
      sym_use_assignments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1067), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46082] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    STATE(632), 1,
      sym_constant_record_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1316), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1314), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [46127] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1543), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1254), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [46180] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1525), 1,
      anon_sym_size,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1261), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [46233] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1873), 1,
      anon_sym_if,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1875), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46308] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(1531), 1,
      anon_sym_unit,
    ACTIONS(1547), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1529), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1240), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1527), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [46361] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1877), 1,
      anon_sym_if,
    ACTIONS(1879), 1,
      anon_sym_DASH_GT,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1281), 1,
      sym_case_clause_pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46438] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1881), 1,
      anon_sym_if,
    ACTIONS(1883), 1,
      anon_sym_DASH_GT,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1281), 1,
      sym_case_clause_pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46515] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    ACTIONS(1887), 1,
      anon_sym_DOT_DOT,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    STATE(1507), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46592] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1889), 1,
      anon_sym_if,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1891), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46667] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1893), 1,
      anon_sym_RBRACK,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1488), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46744] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1869), 1,
      sym_float,
    ACTIONS(1895), 1,
      anon_sym_LT_DASH,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1122), 1,
      sym__pattern,
    STATE(1170), 1,
      sym_use_assignment,
    STATE(1508), 1,
      sym_use_assignments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1067), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46821] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1897), 1,
      anon_sym_RBRACK,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    STATE(1542), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46898] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1899), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [46956] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1194), 1,
      sym__pattern,
    STATE(1259), 1,
      sym_record_pattern_argument,
    STATE(1494), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47030] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1901), 1,
      anon_sym_GT_GT,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1255), 1,
      sym__pattern,
    STATE(1346), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47104] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1903), 1,
      anon_sym_GT_GT,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1183), 1,
      sym_pattern_bit_string_segment,
    STATE(1255), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47178] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1905), 1,
      anon_sym_assert,
    STATE(808), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1214), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47252] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1869), 1,
      sym_float,
    ACTIONS(1907), 1,
      anon_sym_LT_DASH,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1122), 1,
      sym__pattern,
    STATE(1382), 1,
      sym_use_assignment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1067), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47326] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1869), 1,
      sym_float,
    ACTIONS(1909), 1,
      anon_sym_LT_DASH,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1122), 1,
      sym__pattern,
    STATE(1382), 1,
      sym_use_assignment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1067), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47400] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1911), 1,
      anon_sym_assert,
    STATE(593), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1157), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47474] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1913), 1,
      anon_sym_GT_GT,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1255), 1,
      sym__pattern,
    STATE(1346), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47548] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1070), 1,
      sym__pattern,
    STATE(1281), 1,
      sym_case_clause_pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47619] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1677), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1675), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [47658] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1771), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1769), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [47697] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1689), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1687), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [47736] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1917), 1,
      anon_sym_RBRACK,
    ACTIONS(1919), 1,
      anon_sym_DOT_DOT,
    STATE(1131), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [47799] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(792), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1146), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47870] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1869), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1122), 1,
      sym__pattern,
    STATE(1382), 1,
      sym_use_assignment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1067), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47941] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1921), 1,
      anon_sym_COMMA,
    ACTIONS(1923), 1,
      anon_sym_RBRACK,
    ACTIONS(1925), 1,
      anon_sym_DOT_DOT,
    STATE(1107), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [48004] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(406), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1196), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48075] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1665), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1663), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48114] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1755), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1753), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48153] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1751), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1749), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48192] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1779), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1777), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48231] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(583), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1157), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48302] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1669), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1667), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48341] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1927), 1,
      anon_sym_RPAREN,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1178), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48412] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1741), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1739), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48451] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(812), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1214), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48522] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1929), 1,
      anon_sym_COMMA,
    ACTIONS(1931), 1,
      anon_sym_RBRACK,
    ACTIONS(1933), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [48585] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1725), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1723), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48624] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(198), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1214), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48695] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1713), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1711), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48734] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1697), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1695), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48773] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1935), 1,
      anon_sym_COMMA,
    ACTIONS(1937), 1,
      anon_sym_RBRACK,
    ACTIONS(1939), 1,
      anon_sym_DOT_DOT,
    STATE(1123), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [48836] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1941), 1,
      anon_sym_RPAREN,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48907] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1705), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1703), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48946] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(1945), 1,
      anon_sym_RBRACK,
    ACTIONS(1947), 1,
      anon_sym_DOT_DOT,
    STATE(1110), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [49009] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(198), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1247), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49080] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(490), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1247), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49151] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    STATE(729), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(270), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49194] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1685), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1683), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49233] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    ACTIONS(1951), 1,
      anon_sym_RPAREN,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49304] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1693), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1691), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49343] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1681), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1679), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49382] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1673), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1671), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49421] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1255), 1,
      sym__pattern,
    STATE(1346), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49492] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(89), 1,
      sym__assignment,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1157), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49563] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1775), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1773), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49602] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1953), 1,
      anon_sym_RPAREN,
    ACTIONS(1955), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1348), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [49668] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1957), 1,
      anon_sym_COMMA,
    ACTIONS(1959), 1,
      anon_sym_RPAREN,
    STATE(1179), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [49728] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1961), 1,
      anon_sym_COMMA,
    ACTIONS(1963), 1,
      anon_sym_RPAREN,
    STATE(1148), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [49788] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1965), 1,
      anon_sym_LPAREN,
    ACTIONS(1967), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(354), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(352), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49830] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(386), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(384), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49868] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(390), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(388), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49906] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(394), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(392), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49944] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1969), 1,
      anon_sym_RPAREN,
    ACTIONS(1971), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50010] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1955), 1,
      sym_float,
    ACTIONS(1973), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1348), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50076] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      sym_float,
    ACTIONS(1975), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1290), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50142] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(416), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50184] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(1977), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50226] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [50294] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      sym_float,
    ACTIONS(1981), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1324), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50360] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      sym_float,
    ACTIONS(1983), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1324), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50426] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1985), 1,
      anon_sym_COMMA,
    ACTIONS(1987), 1,
      anon_sym_RPAREN,
    STATE(1177), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [50486] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(374), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50524] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1989), 1,
      anon_sym_COMMA,
    ACTIONS(1991), 1,
      anon_sym_RPAREN,
    STATE(1251), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [50584] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(494), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(492), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50622] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(510), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(508), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50660] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1386), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    STATE(1258), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(992), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [50728] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      sym_float,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1324), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50794] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1955), 1,
      sym_float,
    ACTIONS(1995), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1348), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50860] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(332), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50898] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(326), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(324), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50936] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(320), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(318), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50974] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(404), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(402), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51012] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1997), 1,
      anon_sym_COMMA,
    ACTIONS(1999), 1,
      anon_sym_RPAREN,
    STATE(1144), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [51072] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      sym_float,
    ACTIONS(2001), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1324), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51138] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2003), 1,
      anon_sym_LBRACE,
    ACTIONS(2005), 1,
      anon_sym_COMMA,
    STATE(1229), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [51198] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(370), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51236] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(330), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(328), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51274] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(380), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51312] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2007), 1,
      anon_sym_LPAREN,
    ACTIONS(2009), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(346), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(344), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51354] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1955), 1,
      sym_float,
    ACTIONS(2011), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    STATE(1348), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51420] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1344), 1,
      sym_float,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1027), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1065), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [51488] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(366), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51526] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(400), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(398), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51564] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(558), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51601] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(538), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51638] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(526), 17,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51675] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51714] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2013), 1,
      anon_sym_GT_GT,
    ACTIONS(2015), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1443), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51777] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(534), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51814] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(550), 17,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51851] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2015), 1,
      sym_float,
    ACTIONS(2017), 1,
      anon_sym_GT_GT,
    STATE(1052), 1,
      sym_identifier,
    STATE(1276), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51914] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2015), 1,
      sym_float,
    ACTIONS(2019), 1,
      anon_sym_GT_GT,
    STATE(1052), 1,
      sym_identifier,
    STATE(1443), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51977] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2015), 1,
      sym_float,
    ACTIONS(2021), 1,
      anon_sym_GT_GT,
    STATE(1052), 1,
      sym_identifier,
    STATE(1443), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52040] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1340), 1,
      anon_sym_DASH,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(2023), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(933), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [52105] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1955), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1348), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52168] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(530), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52205] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2015), 1,
      sym_float,
    ACTIONS(2025), 1,
      anon_sym_GT_GT,
    STATE(1052), 1,
      sym_identifier,
    STATE(1443), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52268] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1342), 1,
      anon_sym_DQUOTE,
    ACTIONS(1348), 1,
      sym__decimal,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1352), 1,
      sym__name,
    ACTIONS(1354), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(2023), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(987), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1346), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(933), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [52333] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1955), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1245), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52396] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2027), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [52451] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2029), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [52506] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1955), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1212), 1,
      sym_attribute_value,
    STATE(1475), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1400), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52569] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2031), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [52624] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(602), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1324), 1,
      sym_constant_record_argument,
    STATE(1499), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1419), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52687] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2015), 1,
      sym_float,
    ACTIONS(2033), 1,
      anon_sym_GT_GT,
    STATE(1052), 1,
      sym_identifier,
    STATE(1265), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52750] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(554), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52787] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(546), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52824] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1334), 1,
      anon_sym_POUND,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1338), 1,
      anon_sym_LT_LT,
    ACTIONS(1350), 1,
      sym__discard_name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(2023), 1,
      sym_float,
    STATE(902), 1,
      sym__pattern_binary_expression,
    STATE(977), 1,
      sym_identifier,
    STATE(979), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(844), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(933), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [52889] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(414), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52928] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(412), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(410), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52967] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(608), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(606), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53003] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2035), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53057] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(678), 1,
      anon_sym_DASH_GT,
    ACTIONS(2041), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2045), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53111] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 6,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
    ACTIONS(686), 12,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
  [53151] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2057), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53205] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(686), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2045), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53257] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2059), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53311] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(706), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53347] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2045), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(686), 3,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53397] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 5,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [53445] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 9,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53491] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2061), 1,
      anon_sym_RPAREN,
    ACTIONS(2063), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1284), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [53551] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2065), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53605] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(688), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(686), 10,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
  [53649] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(688), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(686), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53685] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2067), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53739] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(744), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53775] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2069), 1,
      anon_sym_RBRACK,
    ACTIONS(2071), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [53835] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      anon_sym_RPAREN,
    ACTIONS(2075), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1269), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [53895] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2077), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [53949] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(652), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(650), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53985] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(654), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54021] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2079), 1,
      anon_sym_RBRACK,
    ACTIONS(2081), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1264), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54081] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(648), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(646), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54117] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(728), 1,
      anon_sym_DASH_GT,
    ACTIONS(2041), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2045), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54171] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(682), 1,
      anon_sym_DASH_GT,
    ACTIONS(2041), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2045), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54225] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2083), 1,
      anon_sym_RBRACK,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54285] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2085), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54339] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2087), 1,
      anon_sym_RBRACK,
    ACTIONS(2089), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1209), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54399] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2091), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54453] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2093), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54507] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2095), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54567] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(704), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(702), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54603] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2097), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54657] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2099), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54711] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2101), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54771] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(616), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(614), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54807] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(740), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54843] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(724), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54879] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2103), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54933] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(732), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54969] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2105), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55023] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(642), 1,
      anon_sym_DASH_GT,
    ACTIONS(2041), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2051), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2039), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2045), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2053), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2047), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2049), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2055), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55077] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2107), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55131] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2109), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55191] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(694), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55227] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2111), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55281] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2113), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55335] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(562), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55371] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2115), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55431] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(710), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55467] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2117), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55521] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2119), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55575] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(666), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55611] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(716), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55647] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2015), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    STATE(1443), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1244), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55707] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2121), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55761] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(698), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55797] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2123), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [55851] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(612), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(610), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55887] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2125), 1,
      anon_sym_RBRACK,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55947] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(670), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55983] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    ACTIONS(2127), 1,
      anon_sym_RBRACK,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56043] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1396), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1404), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1406), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2129), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1388), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1390), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1392), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1402), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1394), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1398), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1400), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [56097] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2131), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1372), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56154] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2133), 1,
      anon_sym_POUND,
    ACTIONS(2135), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      anon_sym_LT_LT,
    ACTIONS(2139), 1,
      anon_sym_DASH,
    ACTIONS(2141), 1,
      sym_float,
    STATE(510), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(450), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(588), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56211] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 1,
      sym_float,
    STATE(968), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1006), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56268] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1200), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56325] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2133), 1,
      anon_sym_POUND,
    ACTIONS(2135), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      anon_sym_LT_LT,
    ACTIONS(2139), 1,
      anon_sym_DASH,
    ACTIONS(2145), 1,
      sym_float,
    STATE(510), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(450), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(528), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56382] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2133), 1,
      anon_sym_POUND,
    ACTIONS(2135), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      anon_sym_LT_LT,
    ACTIONS(2139), 1,
      anon_sym_DASH,
    ACTIONS(2147), 1,
      sym_float,
    STATE(510), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(450), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(569), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56439] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2149), 1,
      sym_float,
    STATE(968), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(991), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56496] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2151), 1,
      sym_float,
    STATE(1052), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1322), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56553] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2153), 1,
      sym_float,
    STATE(968), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(997), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56610] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1382), 1,
      anon_sym_DASH,
    ACTIONS(1589), 1,
      anon_sym_POUND,
    ACTIONS(1591), 1,
      anon_sym_LBRACK,
    ACTIONS(1593), 1,
      anon_sym_LT_LT,
    ACTIONS(2155), 1,
      sym_float,
    STATE(968), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(609), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1008), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56667] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2133), 1,
      anon_sym_POUND,
    ACTIONS(2135), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      anon_sym_LT_LT,
    ACTIONS(2139), 1,
      anon_sym_DASH,
    ACTIONS(2157), 1,
      sym_float,
    STATE(510), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(450), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(527), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56724] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1813), 10,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym__decimal,
      sym__name,
    ACTIONS(1811), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [56758] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1797), 22,
      anon_sym_if,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [56790] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(500), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(498), 21,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [56824] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1721), 10,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym__decimal,
      sym__name,
    ACTIONS(1719), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [56858] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1789), 10,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym__decimal,
      sym__name,
    ACTIONS(1787), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [56892] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2159), 1,
      anon_sym_RBRACE,
    ACTIONS(2161), 1,
      anon_sym_AT,
    ACTIONS(2163), 1,
      anon_sym_import,
    ACTIONS(2165), 1,
      anon_sym_type,
    ACTIONS(2167), 1,
      anon_sym_const,
    ACTIONS(2169), 1,
      anon_sym_fn,
    ACTIONS(2171), 1,
      anon_sym_external,
    ACTIONS(2173), 1,
      sym_visibility_modifier,
    ACTIONS(2175), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(815), 10,
      sym__module_statement,
      sym_attribute,
      sym_import,
      sym_constant,
      sym_external_type,
      sym_external_function,
      sym_function,
      sym_type_definition,
      sym_type_alias,
      aux_sym_target_group_repeat1,
  [56939] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2177), 1,
      anon_sym_RBRACE,
    ACTIONS(2179), 1,
      anon_sym_AT,
    ACTIONS(2182), 1,
      anon_sym_import,
    ACTIONS(2185), 1,
      anon_sym_type,
    ACTIONS(2188), 1,
      anon_sym_const,
    ACTIONS(2191), 1,
      anon_sym_fn,
    ACTIONS(2194), 1,
      anon_sym_external,
    ACTIONS(2197), 1,
      sym_visibility_modifier,
    ACTIONS(2200), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(814), 10,
      sym__module_statement,
      sym_attribute,
      sym_import,
      sym_constant,
      sym_external_type,
      sym_external_function,
      sym_function,
      sym_type_definition,
      sym_type_alias,
      aux_sym_target_group_repeat1,
  [56986] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2161), 1,
      anon_sym_AT,
    ACTIONS(2163), 1,
      anon_sym_import,
    ACTIONS(2165), 1,
      anon_sym_type,
    ACTIONS(2167), 1,
      anon_sym_const,
    ACTIONS(2169), 1,
      anon_sym_fn,
    ACTIONS(2171), 1,
      anon_sym_external,
    ACTIONS(2173), 1,
      sym_visibility_modifier,
    ACTIONS(2175), 1,
      sym_opacity_modifier,
    ACTIONS(2203), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(814), 10,
      sym__module_statement,
      sym_attribute,
      sym_import,
      sym_constant,
      sym_external_type,
      sym_external_function,
      sym_function,
      sym_type_definition,
      sym_type_alias,
      aux_sym_target_group_repeat1,
  [57033] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2205), 1,
      anon_sym_RPAREN,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2213), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    STATE(1192), 1,
      sym_data_constructor_argument,
    STATE(1466), 1,
      sym_label,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1416), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57080] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2213), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2217), 1,
      anon_sym_RPAREN,
    STATE(1318), 1,
      sym_data_constructor_argument,
    STATE(1466), 1,
      sym_label,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1416), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57127] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2213), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2219), 1,
      anon_sym_RPAREN,
    STATE(1318), 1,
      sym_data_constructor_argument,
    STATE(1466), 1,
      sym_label,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1416), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57174] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2221), 1,
      anon_sym_RPAREN,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1311), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57218] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2225), 1,
      anon_sym_RPAREN,
    STATE(1185), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57262] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    STATE(1208), 1,
      sym_external_function_parameter,
    STATE(1393), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1395), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57306] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2229), 1,
      anon_sym_RPAREN,
    STATE(1311), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57350] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
    STATE(1370), 1,
      sym_external_function_parameter,
    STATE(1393), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1395), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57394] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(388), 2,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(1483), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57422] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2233), 1,
      anon_sym_RPAREN,
    STATE(1311), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57466] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2235), 1,
      anon_sym_RPAREN,
    STATE(1294), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57510] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2237), 1,
      anon_sym_RPAREN,
    STATE(1370), 1,
      sym_external_function_parameter,
    STATE(1393), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1395), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57554] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1372), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57580] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2239), 1,
      anon_sym_RPAREN,
    STATE(1311), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57624] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2213), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    STATE(1318), 1,
      sym_data_constructor_argument,
    STATE(1466), 1,
      sym_label,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1416), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57668] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    STATE(879), 1,
      sym_type_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1324), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57698] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1320), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57723] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2243), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57764] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2245), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57805] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2247), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57846] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2249), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57887] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_RPAREN,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    STATE(1315), 1,
      sym_constant_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1325), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [57930] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2257), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1293), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57971] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1311), 1,
      sym_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1432), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58012] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2259), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1190), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58053] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2261), 1,
      anon_sym_RPAREN,
    STATE(1220), 1,
      sym_constant_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1325), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58096] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58137] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    STATE(1315), 1,
      sym_constant_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1325), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58180] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2269), 1,
      anon_sym_LPAREN,
    STATE(916), 1,
      sym_record_pattern_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2267), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [58209] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2271), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58250] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    ACTIONS(2273), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1191), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58291] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1370), 1,
      sym_external_function_parameter,
    STATE(1393), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1395), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58332] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1013), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58370] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2275), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1320), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58410] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(572), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58448] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(575), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58486] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2289), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2287), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [58512] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2293), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2291), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [58538] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1468), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58576] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1313), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58614] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1552), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58652] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1783), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [58676] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1548), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58714] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    STATE(1315), 1,
      sym_constant_type_argument,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1325), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58754] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1540), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58792] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(562), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58830] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(969), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58868] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1314), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58906] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2297), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2295), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [58932] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1004), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58970] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1360), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59008] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2299), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1166), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59048] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(539), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59086] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(542), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59124] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1553), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59162] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2303), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2301), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59188] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2307), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2305), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59214] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2309), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2314), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2311), 9,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59242] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1497), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59280] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1495), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59318] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(584), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59356] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2317), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1320), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59396] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(892), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59434] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1855), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59458] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1843), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59482] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1851), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59506] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2319), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2314), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2311), 9,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59534] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1835), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59558] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2321), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1320), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59598] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1807), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59622] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1556), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59660] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2323), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1226), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59700] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1823), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59724] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1791), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59748] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1761), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59772] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1129), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59810] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1649), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59834] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(889), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59872] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1655), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59896] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(967), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59934] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(982), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59972] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    ACTIONS(2325), 1,
      anon_sym_RPAREN,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1320), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60012] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1715), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60036] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_POUND,
    ACTIONS(2279), 1,
      anon_sym_fn,
    ACTIONS(2281), 1,
      sym__discard_name,
    ACTIONS(2283), 1,
      sym__name,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(452), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(547), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [60074] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2207), 1,
      anon_sym_POUND,
    ACTIONS(2209), 1,
      anon_sym_fn,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2223), 1,
      sym__name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(831), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1569), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [60112] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2327), 1,
      anon_sym_SLASH,
    STATE(906), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1272), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60139] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2329), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60162] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2331), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2333), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2287), 5,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [60189] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1176), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60226] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2335), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60249] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2337), 1,
      anon_sym_SLASH,
    STATE(906), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1282), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60276] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2340), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60299] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2342), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60322] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1320), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60359] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2344), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60382] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1221), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60419] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2346), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 3,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2331), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2333), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60448] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2348), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60471] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2350), 1,
      anon_sym_RBRACE,
    ACTIONS(2352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2354), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2358), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2360), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60504] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2362), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60527] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2364), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60550] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2366), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60573] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2368), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60596] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2370), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60619] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2366), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60642] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2372), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60665] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2374), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60688] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2376), 1,
      anon_sym_DASH_GT,
    ACTIONS(2378), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2380), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2346), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2331), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2333), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60721] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2354), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2287), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
    ACTIONS(2356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2358), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2360), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60752] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2382), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60775] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2384), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60798] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2211), 1,
      sym__discard_name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2253), 1,
      anon_sym_POUND,
    ACTIONS(2255), 1,
      anon_sym_fn,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1068), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1458), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60835] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2386), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60858] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2358), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2360), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2287), 5,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [60885] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2327), 1,
      anon_sym_SLASH,
    STATE(901), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1278), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60912] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 3,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2358), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2360), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60941] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2388), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60964] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2390), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60987] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2392), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61010] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2394), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61033] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2390), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61056] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2396), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61079] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2398), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61102] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2400), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61125] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2398), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61148] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2402), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61171] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2404), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61194] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2406), 1,
      anon_sym_LPAREN,
    STATE(957), 1,
      sym_type_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1306), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61221] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2380), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2287), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
    ACTIONS(2346), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2331), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2333), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [61252] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1284), 1,
      anon_sym_SLASH,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1282), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61276] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    ACTIONS(2410), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1487), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61301] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2412), 1,
      anon_sym_RPAREN,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61342] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    ACTIONS(2418), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1162), 1,
      sym_function_parameter,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61383] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1495), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61404] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    ACTIONS(2420), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61445] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1509), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61466] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    ACTIONS(2422), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1256), 1,
      sym_function_parameter,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61507] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1467), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61528] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1567), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61549] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1549), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61570] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      anon_sym_LBRACE,
    ACTIONS(2426), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1513), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61595] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1471), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61616] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1376), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61637] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1559), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61658] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    ACTIONS(2428), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61699] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    ACTIONS(2430), 1,
      anon_sym_RPAREN,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61740] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2432), 11,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61761] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2434), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1412), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61786] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2438), 1,
      anon_sym_DOT,
    ACTIONS(2440), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1364), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61811] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1463), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61832] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    ACTIONS(2444), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1475), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61857] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2446), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1743), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61879] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2448), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1503), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61901] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2450), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1627), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61923] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(2452), 1,
      anon_sym_DASH,
    ACTIONS(2454), 1,
      sym__name,
    STATE(354), 1,
      sym_constructor_name,
    STATE(649), 1,
      sym_label,
    STATE(853), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [61957] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2456), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1422), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61979] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2416), 1,
      sym__name,
    STATE(1125), 1,
      sym_label,
    STATE(1126), 1,
      sym__name_param,
    STATE(1128), 1,
      sym__labeled_name_param,
    STATE(1130), 1,
      sym__discard_param,
    STATE(1132), 1,
      sym__labeled_discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1331), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [62017] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1499), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62037] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1408), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62057] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1555), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62077] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1535), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62097] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2460), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2458), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [62119] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(1042), 1,
      sym__upname,
    ACTIONS(2462), 1,
      anon_sym_DASH,
    ACTIONS(2464), 1,
      sym__name,
    STATE(649), 1,
      sym_label,
    STATE(694), 1,
      sym_constructor_name,
    STATE(853), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [62153] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2466), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2458), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [62174] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1645), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62193] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    ACTIONS(2468), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1574), 3,
      sym__pattern_bit_string_segment_argument,
      sym_integer,
      sym_identifier,
  [62220] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1757), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62239] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(402), 9,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62258] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1487), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62277] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1815), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62296] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1765), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62315] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2458), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62336] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1859), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62355] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1735), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62374] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1633), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62393] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1731), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62412] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      anon_sym_as,
    ACTIONS(2476), 1,
      anon_sym_LT_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2472), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [62435] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1727), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62454] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1601), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62473] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(388), 9,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62492] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1863), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62511] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1801), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62530] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1839), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62549] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1831), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62568] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1847), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62587] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1819), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62606] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1613), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62625] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1827), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62644] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1617), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62663] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1641), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62682] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1579), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62701] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1597), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62720] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1575), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62739] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1637), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62758] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1659), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62777] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(392), 9,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62796] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1605), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62815] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1707), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62834] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1699), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62853] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2478), 1,
      anon_sym_RPAREN,
    STATE(1137), 1,
      sym__name_param,
    STATE(1138), 1,
      sym__discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1309), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [62885] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2480), 1,
      anon_sym_RPAREN,
    STATE(1137), 1,
      sym__name_param,
    STATE(1138), 1,
      sym__discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1283), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [62917] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2482), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2458), 7,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62937] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2484), 1,
      anon_sym_RPAREN,
    STATE(1137), 1,
      sym__name_param,
    STATE(1138), 1,
      sym__discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1309), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [62969] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(670), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62987] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(384), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [63005] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(706), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [63023] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2486), 1,
      anon_sym_RBRACE,
    ACTIONS(2488), 1,
      anon_sym_type,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1270), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63052] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2488), 1,
      anon_sym_type,
    ACTIONS(2490), 1,
      anon_sym_RBRACE,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63081] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2488), 1,
      anon_sym_type,
    ACTIONS(2492), 1,
      anon_sym_RBRACE,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63110] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2488), 1,
      anon_sym_type,
    ACTIONS(2494), 1,
      anon_sym_RBRACE,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1216), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63139] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2488), 1,
      anon_sym_type,
    ACTIONS(2496), 1,
      anon_sym_RBRACE,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63168] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2498), 7,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
  [63185] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2488), 1,
      anon_sym_type,
    ACTIONS(2500), 1,
      anon_sym_RBRACE,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63214] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    STATE(1137), 1,
      sym__name_param,
    STATE(1138), 1,
      sym__discard_param,
    STATE(1280), 1,
      sym_discard,
    STATE(1282), 1,
      sym_identifier,
    STATE(1309), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63243] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(946), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63267] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1334), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63291] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2502), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2506), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1034), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63313] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2508), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1899), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [63333] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2511), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2513), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63355] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2285), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(484), 1,
      sym_type_name,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(439), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63379] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2488), 1,
      anon_sym_type,
    STATE(1204), 1,
      sym_type_identifier,
    STATE(1215), 1,
      sym_identifier,
    STATE(1437), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63405] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(985), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63429] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(2515), 1,
      anon_sym_DASH,
    STATE(154), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63451] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2285), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(506), 1,
      sym_type_name,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(439), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63475] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    STATE(1567), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63497] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    STATE(1549), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63519] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2285), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(604), 1,
      sym_type_name,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(439), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63543] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(984), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63567] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2517), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2519), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1045), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63589] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2513), 1,
      sym_quoted_content,
    ACTIONS(2521), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63611] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(963), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63635] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2513), 1,
      sym_quoted_content,
    ACTIONS(2523), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63657] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1352), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63681] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(310), 1,
      sym__decimal,
    ACTIONS(1523), 1,
      anon_sym_DASH,
    STATE(154), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(308), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63703] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2525), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2527), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1063), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63725] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1038), 1,
      sym__decimal,
    ACTIONS(2462), 1,
      anon_sym_DASH,
    STATE(691), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1036), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63747] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2529), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1503), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
  [63765] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1357), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63789] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2531), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2536), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2533), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63811] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2539), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2541), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1047), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63833] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1363), 1,
      sym_type_name,
    STATE(1502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(943), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63857] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2513), 1,
      sym_quoted_content,
    ACTIONS(2543), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63879] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2285), 1,
      sym__upname,
    ACTIONS(2468), 1,
      sym__name,
    STATE(594), 1,
      sym_type_name,
    STATE(1491), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(439), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63903] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(966), 1,
      sym__decimal,
    ACTIONS(2545), 1,
      anon_sym_DASH,
    STATE(371), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(964), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63925] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(598), 1,
      sym__decimal,
    ACTIONS(2452), 1,
      anon_sym_DASH,
    STATE(440), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(596), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63947] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(2547), 1,
      anon_sym_DASH,
    STATE(13), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63969] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2549), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2551), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1057), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63991] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2513), 1,
      sym_quoted_content,
    ACTIONS(2553), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [64013] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2513), 1,
      sym_quoted_content,
    ACTIONS(2555), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1054), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [64035] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2557), 1,
      anon_sym_as,
    ACTIONS(2559), 1,
      anon_sym_LT_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2472), 4,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64055] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2563), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2504), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [64077] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2557), 1,
      anon_sym_as,
    ACTIONS(2565), 1,
      anon_sym_LT_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2472), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_DASH,
  [64096] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2567), 1,
      anon_sym_LPAREN,
    STATE(1189), 1,
      sym_constant_type_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2569), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [64115] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    STATE(1506), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1072), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64136] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2573), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2571), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64155] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2575), 1,
      anon_sym_COMMA,
    STATE(1071), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2578), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [64174] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(2580), 1,
      anon_sym_RBRACE,
    STATE(1119), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1079), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64195] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    STATE(1455), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1072), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64216] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(1384), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2582), 1,
      anon_sym_COMMA,
    STATE(1094), 1,
      aux_sym_record_pattern_arguments_repeat1,
    STATE(1534), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64239] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2584), 1,
      anon_sym_COMMA,
    ACTIONS(2586), 1,
      anon_sym_RBRACK,
    STATE(1071), 1,
      aux_sym_case_clause_pattern_repeat1,
    STATE(1523), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64262] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1162), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(352), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT_GT,
  [64281] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2590), 1,
      anon_sym_COMMA,
    STATE(1081), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2588), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64300] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1166), 1,
      anon_sym_LPAREN,
    ACTIONS(1293), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(344), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT_GT,
  [64319] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2592), 1,
      anon_sym_RBRACE,
    ACTIONS(2594), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1079), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64340] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    STATE(1454), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1072), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64361] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2597), 1,
      anon_sym_COMMA,
    STATE(1081), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2578), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64380] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    STATE(1571), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1072), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64401] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2600), 1,
      anon_sym_type,
    ACTIONS(2602), 1,
      anon_sym_const,
    ACTIONS(2604), 1,
      anon_sym_fn,
    ACTIONS(2606), 1,
      anon_sym_external,
    ACTIONS(2608), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64424] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    STATE(1565), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1072), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64445] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2610), 1,
      anon_sym_COMMA,
    ACTIONS(2612), 1,
      anon_sym_RBRACK,
    STATE(1075), 1,
      aux_sym_case_clause_pattern_repeat1,
    STATE(1480), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64468] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(1119), 1,
      sym_constructor_name,
    STATE(1544), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1072), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64489] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2614), 1,
      anon_sym_type,
    ACTIONS(2616), 1,
      anon_sym_const,
    ACTIONS(2618), 1,
      anon_sym_fn,
    ACTIONS(2620), 1,
      anon_sym_external,
    ACTIONS(2622), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64512] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(328), 1,
      sym__discard_name,
    ACTIONS(330), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(388), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [64531] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(2624), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1479), 2,
      sym_identifier,
      sym_discard,
  [64552] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1384), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2626), 1,
      anon_sym_COMMA,
    ACTIONS(2628), 1,
      anon_sym_RPAREN,
    STATE(1074), 1,
      aux_sym_record_pattern_arguments_repeat1,
    STATE(1557), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64575] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(2630), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(538), 2,
      sym_identifier,
      sym_discard,
  [64593] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(1237), 1,
      sym_record_update_argument,
    STATE(1467), 1,
      sym_record_update_arguments,
    STATE(1486), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64613] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2636), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2634), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64629] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    STATE(1094), 1,
      aux_sym_record_pattern_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2641), 2,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [64647] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(1237), 1,
      sym_record_update_argument,
    STATE(1461), 1,
      sym_record_update_arguments,
    STATE(1486), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64667] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2643), 4,
      sym_quoted_content,
      anon_sym_DQUOTE2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
  [64681] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    STATE(1097), 1,
      aux_sym_pattern_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2645), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64699] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2650), 1,
      anon_sym_DASH,
    STATE(1097), 1,
      aux_sym_pattern_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64717] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2654), 1,
      anon_sym_PIPE,
    STATE(1099), 1,
      aux_sym_case_clause_patterns_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2652), 2,
      anon_sym_if,
      anon_sym_DASH_GT,
  [64735] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2659), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2657), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64751] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(604), 1,
      sym__upname,
    ACTIONS(2454), 1,
      sym__name,
    STATE(354), 1,
      sym_constructor_name,
    STATE(649), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64771] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2661), 1,
      anon_sym_COMMA,
    STATE(1102), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2664), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [64789] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    ACTIONS(2666), 1,
      anon_sym_RPAREN,
    STATE(1332), 1,
      sym_record_update_argument,
    STATE(1486), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64809] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(1237), 1,
      sym_record_update_argument,
    STATE(1486), 1,
      sym_label,
    STATE(1509), 1,
      sym_record_update_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64829] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(328), 1,
      anon_sym_COLON,
    ACTIONS(388), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1483), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [64847] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2668), 1,
      anon_sym_PIPE,
    STATE(1099), 1,
      aux_sym_case_clause_patterns_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1879), 2,
      anon_sym_if,
      anon_sym_DASH_GT,
  [64865] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(804), 1,
      anon_sym_RBRACK,
    ACTIONS(806), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2670), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64885] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(1237), 1,
      sym_record_update_argument,
    STATE(1486), 1,
      sym_label,
    STATE(1498), 1,
      sym_record_update_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64905] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2674), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2672), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64921] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(790), 1,
      anon_sym_RBRACK,
    ACTIONS(792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2676), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64941] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    ACTIONS(2678), 1,
      anon_sym_RPAREN,
    STATE(1332), 1,
      sym_record_update_argument,
    STATE(1486), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64961] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2682), 1,
      anon_sym_DASH,
    STATE(1127), 1,
      aux_sym_constant_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64979] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2686), 1,
      anon_sym_DASH,
    STATE(1113), 1,
      aux_sym_expression_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2684), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64997] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(1237), 1,
      sym_record_update_argument,
    STATE(1456), 1,
      sym_record_update_arguments,
    STATE(1486), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65017] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    ACTIONS(2632), 1,
      sym__name,
    STATE(126), 1,
      sym_constructor_name,
    STATE(649), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65037] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2691), 1,
      anon_sym_DASH,
    STATE(1098), 1,
      aux_sym_pattern_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2689), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65055] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1422), 1,
      sym_anonymous_function_parameters,
    STATE(1427), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65075] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(2630), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(546), 2,
      sym_identifier,
      sym_discard,
  [65093] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2697), 1,
      anon_sym_LPAREN,
    STATE(1402), 1,
      sym_data_constructor_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2695), 2,
      anon_sym_RBRACE,
      sym__upname,
  [65111] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(796), 1,
      anon_sym_RBRACK,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2699), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65131] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(980), 2,
      sym_identifier,
      sym_discard,
  [65149] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1445), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2701), 2,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
  [65167] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(816), 1,
      anon_sym_RBRACK,
    ACTIONS(818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2705), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65187] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2709), 1,
      anon_sym_PIPE,
    STATE(1106), 1,
      aux_sym_case_clause_patterns_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2707), 2,
      anon_sym_if,
      anon_sym_DASH_GT,
  [65205] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(312), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    STATE(1201), 1,
      sym_identifier,
    STATE(1203), 1,
      sym_discard,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65225] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1401), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2711), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65243] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2713), 1,
      anon_sym_DASH,
    STATE(1140), 1,
      aux_sym_constant_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1539), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65261] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1403), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2715), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65279] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2717), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_DASH,
  [65293] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1405), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2711), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65311] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(800), 1,
      anon_sym_RBRACK,
    ACTIONS(802), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2719), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65331] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1410), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2715), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65349] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2721), 1,
      anon_sym_DASH,
    STATE(1113), 1,
      aux_sym_expression_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1545), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65367] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2725), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2723), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [65383] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2729), 1,
      anon_sym_DASH,
    STATE(1133), 1,
      aux_sym_expression_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2727), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65401] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2733), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2731), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [65417] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1420), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2735), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65435] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(1421), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2735), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65453] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2739), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2737), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [65469] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2743), 1,
      anon_sym_DASH,
    STATE(1140), 1,
      aux_sym_constant_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2741), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65487] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2414), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1002), 2,
      sym_identifier,
      sym_discard,
  [65505] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2746), 1,
      sym__name,
    STATE(33), 1,
      sym_constructor_name,
    STATE(567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65525] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2325), 1,
      anon_sym_RPAREN,
    ACTIONS(2748), 1,
      anon_sym_COMMA,
    STATE(1298), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65542] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(860), 1,
      anon_sym_RPAREN,
    ACTIONS(2750), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65559] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2752), 1,
      anon_sym_COMMA,
    ACTIONS(2754), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65576] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    ACTIONS(2756), 1,
      anon_sym_EQ,
    STATE(1450), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65593] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2758), 1,
      anon_sym_LPAREN,
    ACTIONS(2760), 1,
      anon_sym_DASH_GT,
    STATE(1528), 1,
      sym_constant_function_parameter_types,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65610] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(854), 1,
      anon_sym_RPAREN,
    ACTIONS(2762), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65627] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2764), 1,
      anon_sym_COMMA,
    ACTIONS(2766), 1,
      anon_sym_GT_GT,
    STATE(1165), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65644] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2219), 1,
      anon_sym_RPAREN,
    ACTIONS(2768), 1,
      anon_sym_COMMA,
    STATE(1188), 1,
      aux_sym_data_constructor_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65661] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2770), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [65674] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
    ACTIONS(2772), 1,
      anon_sym_COMMA,
    STATE(1303), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65691] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2774), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [65704] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2271), 1,
      anon_sym_RPAREN,
    ACTIONS(2776), 1,
      anon_sym_COMMA,
    STATE(1303), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65721] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2778), 1,
      anon_sym_COMMA,
    ACTIONS(2781), 1,
      anon_sym_GT_GT,
    STATE(1155), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65738] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2239), 1,
      anon_sym_RPAREN,
    ACTIONS(2783), 1,
      anon_sym_COMMA,
    STATE(1306), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65755] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    ACTIONS(2785), 1,
      anon_sym_EQ,
    STATE(1448), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65772] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2787), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [65785] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2484), 1,
      anon_sym_RPAREN,
    ACTIONS(2789), 1,
      anon_sym_COMMA,
    STATE(1195), 1,
      aux_sym_anonymous_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65802] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2317), 1,
      anon_sym_RPAREN,
    ACTIONS(2791), 1,
      anon_sym_COMMA,
    STATE(1298), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65819] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(754), 1,
      anon_sym_RPAREN,
    ACTIONS(2793), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65836] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2795), 1,
      anon_sym_COMMA,
    ACTIONS(2797), 1,
      anon_sym_RPAREN,
    STATE(1198), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65853] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2799), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [65866] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2801), 1,
      anon_sym_RBRACE,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    STATE(1164), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65883] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1093), 1,
      anon_sym_GT_GT,
    ACTIONS(2806), 1,
      anon_sym_COMMA,
    STATE(1155), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65900] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2808), 1,
      anon_sym_COMMA,
    ACTIONS(2810), 1,
      anon_sym_RPAREN,
    STATE(1160), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65917] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2812), 1,
      anon_sym_COMMA,
    ACTIONS(2814), 1,
      anon_sym_RPAREN,
    STATE(1184), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65934] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2816), 1,
      anon_sym_LPAREN,
    ACTIONS(2818), 1,
      anon_sym_DASH_GT,
    STATE(1490), 1,
      sym_function_parameter_types,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65951] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2249), 1,
      anon_sym_RPAREN,
    ACTIONS(2820), 1,
      anon_sym_COMMA,
    STATE(1303), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65968] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2822), 1,
      anon_sym_COMMA,
    ACTIONS(2824), 1,
      anon_sym_LT_DASH,
    STATE(1173), 1,
      aux_sym_use_assignments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65985] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2826), 1,
      anon_sym_if,
    ACTIONS(2828), 1,
      anon_sym_DASH_GT,
    STATE(1492), 1,
      sym_case_clause_guard,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66002] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2830), 1,
      anon_sym_COMMA,
    ACTIONS(2833), 1,
      anon_sym_RPAREN,
    STATE(1172), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66019] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1907), 1,
      anon_sym_LT_DASH,
    ACTIONS(2835), 1,
      anon_sym_COMMA,
    STATE(1213), 1,
      aux_sym_use_assignments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66036] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    STATE(1512), 1,
      sym_target,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2837), 2,
      anon_sym_erlang,
      anon_sym_javascript,
  [66051] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2839), 1,
      anon_sym_COMMA,
    ACTIONS(2842), 1,
      anon_sym_RPAREN,
    STATE(1175), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66068] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2844), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66081] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(834), 1,
      anon_sym_RPAREN,
    ACTIONS(2846), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66098] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2848), 1,
      anon_sym_COMMA,
    ACTIONS(2850), 1,
      anon_sym_RPAREN,
    STATE(1235), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66115] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(842), 1,
      anon_sym_RPAREN,
    ACTIONS(2852), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66132] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2854), 1,
      anon_sym_COMMA,
    ACTIONS(2857), 1,
      anon_sym_GT_GT,
    STATE(1180), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66149] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2859), 1,
      anon_sym_COMMA,
    ACTIONS(2861), 1,
      anon_sym_RPAREN,
    STATE(1161), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66166] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2863), 1,
      anon_sym_RPAREN,
    ACTIONS(2865), 1,
      sym__name,
    STATE(1433), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66183] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2867), 1,
      anon_sym_COMMA,
    ACTIONS(2869), 1,
      anon_sym_GT_GT,
    STATE(1186), 1,
      aux_sym__pattern_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66200] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    ACTIONS(2871), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66217] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2873), 1,
      anon_sym_COMMA,
    ACTIONS(2875), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66234] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1901), 1,
      anon_sym_GT_GT,
    ACTIONS(2877), 1,
      anon_sym_COMMA,
    STATE(1272), 1,
      aux_sym__pattern_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66251] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1160), 1,
      anon_sym_GT_GT,
    ACTIONS(2879), 1,
      anon_sym_COMMA,
    STATE(1155), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66268] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2881), 1,
      anon_sym_COMMA,
    ACTIONS(2884), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym_data_constructor_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66285] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2886), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66298] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2888), 1,
      anon_sym_COMMA,
    ACTIONS(2890), 1,
      anon_sym_RPAREN,
    STATE(1154), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66315] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2892), 1,
      anon_sym_COMMA,
    ACTIONS(2894), 1,
      anon_sym_RPAREN,
    STATE(1152), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66332] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    ACTIONS(2898), 1,
      anon_sym_RPAREN,
    STATE(1150), 1,
      aux_sym_data_constructor_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66349] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2900), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66362] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2902), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [66375] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2904), 1,
      anon_sym_COMMA,
    ACTIONS(2907), 1,
      anon_sym_RPAREN,
    STATE(1195), 1,
      aux_sym_anonymous_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66392] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    ACTIONS(2909), 1,
      anon_sym_EQ,
    STATE(1481), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66409] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2911), 1,
      anon_sym_COMMA,
    ACTIONS(2913), 1,
      anon_sym_GT_GT,
    STATE(1301), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66426] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2430), 1,
      anon_sym_RPAREN,
    ACTIONS(2915), 1,
      anon_sym_COMMA,
    STATE(1297), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66443] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2917), 1,
      anon_sym_COMMA,
    ACTIONS(2919), 1,
      anon_sym_GT_GT,
    STATE(1187), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66460] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2664), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [66473] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2921), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [66486] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    ACTIONS(2923), 1,
      anon_sym_COMMA,
    STATE(1287), 1,
      aux_sym_constant_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66503] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2925), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [66516] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2929), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2927), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66531] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2933), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2931), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [66546] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2935), 1,
      anon_sym_COLON,
    ACTIONS(2937), 1,
      anon_sym_EQ,
    STATE(1510), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66563] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2935), 1,
      anon_sym_COLON,
    ACTIONS(2939), 1,
      anon_sym_EQ,
    STATE(1527), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66580] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2941), 1,
      anon_sym_COMMA,
    ACTIONS(2943), 1,
      anon_sym_RPAREN,
    STATE(1296), 1,
      aux_sym_external_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66597] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2945), 1,
      anon_sym_COMMA,
    ACTIONS(2947), 1,
      anon_sym_RBRACK,
    STATE(1268), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66614] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2949), 1,
      anon_sym_COMMA,
    ACTIONS(2951), 1,
      anon_sym_GT_GT,
    STATE(1230), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66631] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2101), 1,
      anon_sym_RPAREN,
    ACTIONS(2953), 1,
      anon_sym_COMMA,
    STATE(1102), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66648] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2955), 1,
      anon_sym_COMMA,
    ACTIONS(2957), 1,
      anon_sym_RPAREN,
    STATE(1299), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66665] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2959), 1,
      anon_sym_COMMA,
    ACTIONS(2962), 1,
      anon_sym_LT_DASH,
    STATE(1213), 1,
      aux_sym_use_assignments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66682] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    ACTIONS(2964), 1,
      anon_sym_EQ,
    STATE(1541), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66699] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2966), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2927), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66714] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2968), 1,
      anon_sym_RBRACE,
    ACTIONS(2970), 1,
      anon_sym_COMMA,
    STATE(1227), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66731] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2972), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [66744] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2935), 1,
      anon_sym_COLON,
    ACTIONS(2974), 1,
      anon_sym_EQ,
    STATE(1563), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66761] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2976), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [66774] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2978), 1,
      anon_sym_COMMA,
    ACTIONS(2980), 1,
      anon_sym_RPAREN,
    STATE(1202), 1,
      aux_sym_constant_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66791] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2982), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66804] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(756), 1,
      anon_sym_RPAREN,
    ACTIONS(2984), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66821] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2865), 1,
      sym__name,
    ACTIONS(2986), 1,
      anon_sym_RPAREN,
    STATE(1433), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66838] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2865), 1,
      sym__name,
    ACTIONS(2988), 1,
      anon_sym_RPAREN,
    STATE(1249), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66855] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2990), 1,
      anon_sym_COMMA,
    ACTIONS(2993), 1,
      anon_sym_RPAREN,
    STATE(1225), 1,
      aux_sym_external_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66872] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2995), 1,
      anon_sym_COMMA,
    ACTIONS(2997), 1,
      anon_sym_RPAREN,
    STATE(1143), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66889] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2500), 1,
      anon_sym_RBRACE,
    ACTIONS(2999), 1,
      anon_sym_COMMA,
    STATE(1164), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66906] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3003), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3001), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66921] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3005), 1,
      anon_sym_LBRACE,
    ACTIONS(3007), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66938] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1116), 1,
      anon_sym_GT_GT,
    ACTIONS(3009), 1,
      anon_sym_COMMA,
    STATE(1155), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66955] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3011), 1,
      anon_sym_COMMA,
    ACTIONS(3013), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66972] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2986), 1,
      anon_sym_RPAREN,
    ACTIONS(3015), 1,
      anon_sym_COMMA,
    STATE(1175), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66989] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1136), 1,
      anon_sym_GT_GT,
    ACTIONS(3017), 1,
      anon_sym_COMMA,
    STATE(1155), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67006] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3019), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67019] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3021), 1,
      anon_sym_COMMA,
    ACTIONS(3023), 1,
      anon_sym_RPAREN,
    STATE(1071), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67036] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(1332), 1,
      sym_record_update_argument,
    STATE(1486), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67053] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3025), 1,
      anon_sym_COMMA,
    ACTIONS(3027), 1,
      anon_sym_RPAREN,
    STATE(1278), 1,
      aux_sym_record_update_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67070] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(607), 1,
      sym_external_function_body,
    STATE(1329), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67087] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2935), 1,
      anon_sym_COLON,
    ACTIONS(3029), 1,
      anon_sym_EQ,
    STATE(1558), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67104] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2684), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67117] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2865), 1,
      sym__name,
    ACTIONS(3031), 1,
      anon_sym_RPAREN,
    STATE(1145), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67134] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3033), 1,
      anon_sym_COMMA,
    ACTIONS(3035), 1,
      anon_sym_RPAREN,
    STATE(1262), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67151] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3037), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67164] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3041), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3039), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [67179] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3043), 1,
      anon_sym_COMMA,
    ACTIONS(3045), 1,
      anon_sym_RPAREN,
    STATE(1267), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67196] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3047), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67209] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    ACTIONS(3049), 1,
      anon_sym_EQ,
    STATE(1533), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67226] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2816), 1,
      anon_sym_LPAREN,
    ACTIONS(3051), 1,
      anon_sym_DASH_GT,
    STATE(1568), 1,
      sym_function_parameter_types,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67243] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3053), 1,
      anon_sym_COMMA,
    ACTIONS(3055), 1,
      anon_sym_RPAREN,
    STATE(1275), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67260] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67277] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(836), 1,
      anon_sym_RPAREN,
    ACTIONS(3061), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67294] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3063), 1,
      anon_sym_COMMA,
    ACTIONS(3065), 1,
      anon_sym_GT_GT,
    STATE(1233), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67311] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    ACTIONS(3067), 1,
      anon_sym_COMMA,
    STATE(1289), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67328] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2645), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67341] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3071), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3069), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [67356] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3073), 1,
      anon_sym_COMMA,
    ACTIONS(3075), 1,
      anon_sym_RPAREN,
    STATE(1279), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67373] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    ACTIONS(3077), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67390] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3079), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [67403] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2641), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [67416] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2025), 1,
      anon_sym_GT_GT,
    ACTIONS(3081), 1,
      anon_sym_COMMA,
    STATE(1180), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67433] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2741), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67446] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67463] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1003), 1,
      sym_external_function_body,
    STATE(1327), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67480] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3085), 1,
      anon_sym_COMMA,
    ACTIONS(3087), 1,
      anon_sym_RBRACK,
    STATE(1286), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67497] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3091), 1,
      anon_sym_GT_GT,
    STATE(1288), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67514] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3093), 1,
      anon_sym_COMMA,
    ACTIONS(3096), 1,
      anon_sym_RPAREN,
    STATE(1266), 1,
      aux_sym_record_update_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67531] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1973), 1,
      anon_sym_RPAREN,
    ACTIONS(3098), 1,
      anon_sym_COMMA,
    STATE(1285), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67548] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2069), 1,
      anon_sym_RBRACK,
    ACTIONS(3100), 1,
      anon_sym_COMMA,
    STATE(1102), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67565] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3102), 1,
      anon_sym_COMMA,
    ACTIONS(3104), 1,
      anon_sym_RPAREN,
    STATE(1211), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67582] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3106), 1,
      anon_sym_RBRACE,
    ACTIONS(3108), 1,
      anon_sym_COMMA,
    STATE(1292), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67599] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3110), 1,
      anon_sym_COMMA,
    ACTIONS(3112), 1,
      anon_sym_RPAREN,
    STATE(1257), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67616] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    ACTIONS(3117), 1,
      anon_sym_GT_GT,
    STATE(1272), 1,
      aux_sym__pattern_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67633] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(597), 1,
      sym_external_function_body,
    STATE(1329), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67650] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2865), 1,
      sym__name,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    STATE(1433), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67667] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    ACTIONS(3121), 1,
      anon_sym_COMMA,
    STATE(1175), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67684] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3123), 1,
      anon_sym_COMMA,
    ACTIONS(3125), 1,
      anon_sym_GT_GT,
    STATE(1260), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67701] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3127), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67714] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2678), 1,
      anon_sym_RPAREN,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    STATE(1266), 1,
      aux_sym_record_update_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67731] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2428), 1,
      anon_sym_RPAREN,
    ACTIONS(3131), 1,
      anon_sym_COMMA,
    STATE(1297), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67748] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3133), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67761] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2652), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [67774] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3135), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67787] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3137), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    STATE(1159), 1,
      aux_sym_anonymous_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67804] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3141), 1,
      anon_sym_COMMA,
    ACTIONS(3143), 1,
      anon_sym_RPAREN,
    STATE(1305), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67821] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3145), 1,
      anon_sym_COMMA,
    ACTIONS(3148), 1,
      anon_sym_RPAREN,
    STATE(1285), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67838] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2127), 1,
      anon_sym_RBRACK,
    ACTIONS(3150), 1,
      anon_sym_COMMA,
    STATE(1102), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67855] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3155), 1,
      anon_sym_RPAREN,
    STATE(1287), 1,
      aux_sym_constant_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67872] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2013), 1,
      anon_sym_GT_GT,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    STATE(1180), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67889] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3159), 1,
      anon_sym_COMMA,
    ACTIONS(3162), 1,
      anon_sym_RPAREN,
    STATE(1289), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67906] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3164), 1,
      anon_sym_COMMA,
    ACTIONS(3166), 1,
      anon_sym_RPAREN,
    STATE(1302), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67923] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3168), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67936] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2496), 1,
      anon_sym_RBRACE,
    ACTIONS(3170), 1,
      anon_sym_COMMA,
    STATE(1164), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67953] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3172), 1,
      anon_sym_COMMA,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    STATE(1169), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67970] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3176), 1,
      anon_sym_COMMA,
    ACTIONS(3178), 1,
      anon_sym_RPAREN,
    STATE(1307), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67987] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2865), 1,
      sym__name,
    ACTIONS(3180), 1,
      anon_sym_RPAREN,
    STATE(1433), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68004] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
    ACTIONS(3182), 1,
      anon_sym_COMMA,
    STATE(1225), 1,
      aux_sym_external_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68021] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3184), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_RPAREN,
    STATE(1297), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68038] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3189), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
    STATE(1298), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68055] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1953), 1,
      anon_sym_RPAREN,
    ACTIONS(3194), 1,
      anon_sym_COMMA,
    STATE(1285), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68072] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(996), 1,
      sym_external_function_body,
    STATE(1327), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68089] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1126), 1,
      anon_sym_GT_GT,
    ACTIONS(3196), 1,
      anon_sym_COMMA,
    STATE(1155), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68106] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2001), 1,
      anon_sym_RPAREN,
    ACTIONS(3198), 1,
      anon_sym_COMMA,
    STATE(1289), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68123] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RPAREN,
    STATE(1303), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68140] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3205), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [68153] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2095), 1,
      anon_sym_RPAREN,
    ACTIONS(3207), 1,
      anon_sym_COMMA,
    STATE(1102), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68170] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(3212), 1,
      anon_sym_RPAREN,
    STATE(1306), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68187] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2233), 1,
      anon_sym_RPAREN,
    ACTIONS(3214), 1,
      anon_sym_COMMA,
    STATE(1306), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68204] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    STATE(1321), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68218] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2907), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68230] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1317), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68244] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3212), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68256] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1323), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68270] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3203), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68282] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3216), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68294] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3155), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68306] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3218), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [68318] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3220), 1,
      anon_sym_LPAREN,
    STATE(1562), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68332] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2884), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68344] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3222), 2,
      anon_sym_RBRACE,
      sym__upname,
  [68356] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3192), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68368] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3224), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [68380] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3226), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68392] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3220), 1,
      anon_sym_LPAREN,
    STATE(1561), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68406] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3162), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68418] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3228), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68430] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1374), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68444] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(592), 1,
      anon_sym_DQUOTE,
    STATE(998), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68458] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1338), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68472] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    STATE(600), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68486] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3230), 1,
      sym__name,
    STATE(465), 1,
      sym_module,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68500] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3187), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68512] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3096), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68524] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1339), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68538] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3232), 1,
      anon_sym_LBRACE,
    ACTIONS(3234), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68552] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1422), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68566] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1218), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68580] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1342), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68594] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3236), 1,
      anon_sym_LBRACE,
    ACTIONS(3238), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68608] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3240), 1,
      anon_sym_LBRACE,
    ACTIONS(3242), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68622] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2029), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68634] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3244), 1,
      anon_sym_LPAREN,
    STATE(437), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68648] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3246), 1,
      anon_sym_LBRACE,
    ACTIONS(3248), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68662] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3250), 2,
      anon_sym_RBRACE,
      sym__upname,
  [68674] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3220), 1,
      anon_sym_LPAREN,
    STATE(1472), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68688] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3252), 1,
      anon_sym_type,
    ACTIONS(3254), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68702] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3117), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [68714] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1381), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68728] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3148), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68740] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2454), 1,
      sym__name,
    STATE(441), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68754] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3256), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68766] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2285), 1,
      sym__upname,
    STATE(451), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68780] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    ACTIONS(2410), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68794] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3258), 1,
      anon_sym_LPAREN,
    STATE(956), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68808] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3260), 1,
      sym__name,
    STATE(936), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68822] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3262), 1,
      anon_sym_LBRACE,
    ACTIONS(3264), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68836] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3260), 1,
      sym__name,
    STATE(962), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68850] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68864] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1365), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68878] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1354), 1,
      sym__upname,
    STATE(983), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68892] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3266), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68904] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3268), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [68916] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1451), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68930] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3270), 1,
      anon_sym_LBRACE,
    ACTIONS(3272), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68944] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1452), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68958] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3220), 1,
      anon_sym_LPAREN,
    STATE(1570), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68972] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3274), 1,
      anon_sym_LBRACE,
    STATE(491), 1,
      sym_unqualified_imports,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68986] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3276), 1,
      anon_sym_LPAREN,
    STATE(25), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69000] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1482), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69014] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1484), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69028] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2993), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69040] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3278), 1,
      anon_sym_LBRACE,
    STATE(971), 1,
      sym_unqualified_imports,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69054] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3280), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69066] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1355), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69080] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3282), 1,
      anon_sym_LPAREN,
    STATE(544), 1,
      sym__attribute_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69094] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2632), 1,
      sym__name,
    STATE(151), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69108] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(61), 1,
      sym__upname,
    STATE(33), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69122] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3284), 1,
      anon_sym_LPAREN,
    STATE(512), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69136] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2746), 1,
      sym__name,
    STATE(11), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69150] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3286), 1,
      anon_sym_type,
    ACTIONS(3288), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69164] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1536), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69178] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3258), 1,
      anon_sym_LPAREN,
    STATE(966), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69192] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2962), 2,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
  [69204] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1538), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69218] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3290), 1,
      anon_sym_LPAREN,
    STATE(368), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69232] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1429), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69246] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3292), 1,
      anon_sym_LPAREN,
    STATE(1009), 1,
      sym__attribute_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69260] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3294), 1,
      anon_sym_LPAREN,
    STATE(146), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69274] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    STATE(1429), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69288] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(604), 1,
      sym__upname,
    STATE(354), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69302] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3296), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69314] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3298), 1,
      anon_sym_type,
    ACTIONS(3300), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69328] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3302), 1,
      sym__name,
    STATE(372), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69342] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3304), 1,
      anon_sym_COLON,
    ACTIONS(3306), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69356] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3308), 1,
      anon_sym_type,
    ACTIONS(3310), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69370] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3312), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69382] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1377), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69396] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3314), 1,
      anon_sym_COMMA,
    ACTIONS(3316), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69410] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1206), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69424] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3318), 1,
      sym__name,
    STATE(964), 1,
      sym_module,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69438] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3320), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69450] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3322), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69462] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3324), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69474] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3326), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69486] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1042), 1,
      sym__upname,
    STATE(694), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69500] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3322), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69512] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1353), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69526] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__upname,
    STATE(126), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69540] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1239), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69554] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    STATE(832), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69568] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3326), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69580] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1535), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69594] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1532), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69608] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1207), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69622] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1386), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69636] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3328), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [69648] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3330), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69660] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2865), 1,
      sym__name,
    STATE(1433), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69674] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3332), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [69686] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3334), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69698] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3336), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69710] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3336), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69722] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3338), 1,
      anon_sym_LBRACE,
    ACTIONS(3340), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69736] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2781), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69748] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3342), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69760] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3344), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69772] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3346), 1,
      anon_sym_LPAREN,
    STATE(684), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69786] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3284), 1,
      anon_sym_LPAREN,
    STATE(504), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69800] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3348), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69812] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3350), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69824] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(962), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69838] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2215), 1,
      sym__upname,
    STATE(1228), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69852] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3352), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69864] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2842), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69876] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2464), 1,
      sym__name,
    STATE(692), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69890] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(970), 1,
      sym__upname,
    STATE(378), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69904] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3354), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69916] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2801), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69928] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2031), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69940] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      sym__name,
    STATE(1344), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69954] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1547), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69968] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3356), 1,
      sym__name,
    STATE(936), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69982] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(304), 1,
      anon_sym_DQUOTE,
    STATE(1545), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69996] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2857), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [70008] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3358), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [70020] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3360), 2,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
  [70032] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2833), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70044] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3362), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70055] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3364), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70066] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3366), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70077] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3368), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70088] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3370), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70099] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3372), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70110] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3374), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70121] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3376), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70132] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3378), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70143] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3380), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70154] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3382), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70165] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3384), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70176] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3386), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70187] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3388), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70198] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3390), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70209] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3392), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70220] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3394), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70231] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3396), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70242] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3398), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70253] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3400), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70264] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3402), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70275] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3404), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70286] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3406), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70297] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3408), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70308] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3410), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70319] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3412), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70330] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3414), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70341] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3416), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70352] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3418), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70363] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3420), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70374] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3422), 1,
      anon_sym_LT_DASH,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70385] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3424), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70396] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3426), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70407] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3428), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70418] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3430), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70429] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3432), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70440] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3434), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70451] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3436), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70462] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3438), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70473] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3440), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70484] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3442), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70495] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3444), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70506] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3446), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70517] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3448), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70528] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3450), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70539] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3452), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70550] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2628), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70561] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3454), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70572] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3456), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70583] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3458), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70594] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70605] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3462), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70616] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3464), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70627] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70638] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3468), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70649] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3306), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70660] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3470), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70671] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70682] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70693] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3476), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70704] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3478), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70715] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3480), 1,
      anon_sym_LT_DASH,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70726] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3482), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70737] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3484), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70748] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3486), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70759] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3488), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70770] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3490), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70781] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3492), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70792] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3494), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70803] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3496), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70814] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3498), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70825] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70836] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3502), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70847] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70858] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3506), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70869] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3508), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70880] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70891] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3512), 1,
      ts_builtin_sym_end,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70902] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3514), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70913] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3516), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70924] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3518), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70935] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3520), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70946] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3522), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70957] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3524), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70968] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3526), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70979] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70990] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3530), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71001] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1565), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71012] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3532), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71023] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71034] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3536), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71045] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3538), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71056] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3540), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71067] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3542), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71078] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3544), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71089] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3546), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71100] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3548), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71111] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3550), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71122] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3552), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71133] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3554), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71144] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3556), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71155] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3558), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71166] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3560), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71177] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3562), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71188] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3564), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71199] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3566), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71210] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3568), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71221] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3570), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71232] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3572), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71243] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3574), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71254] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71265] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3576), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71276] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3578), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71287] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3580), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71298] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3582), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71309] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3584), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71320] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3586), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71331] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3588), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71342] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3590), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71353] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3592), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71364] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3594), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71375] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3596), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71386] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3598), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71397] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3600), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71408] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3602), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71419] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3604), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71430] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3606), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71441] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3608), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71452] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3610), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(6)] = 0,
  [SMALL_STATE(7)] = 71,
  [SMALL_STATE(8)] = 197,
  [SMALL_STATE(9)] = 323,
  [SMALL_STATE(10)] = 389,
  [SMALL_STATE(11)] = 515,
  [SMALL_STATE(12)] = 581,
  [SMALL_STATE(13)] = 647,
  [SMALL_STATE(14)] = 713,
  [SMALL_STATE(15)] = 839,
  [SMALL_STATE(16)] = 965,
  [SMALL_STATE(17)] = 1091,
  [SMALL_STATE(18)] = 1217,
  [SMALL_STATE(19)] = 1287,
  [SMALL_STATE(20)] = 1357,
  [SMALL_STATE(21)] = 1483,
  [SMALL_STATE(22)] = 1609,
  [SMALL_STATE(23)] = 1735,
  [SMALL_STATE(24)] = 1801,
  [SMALL_STATE(25)] = 1867,
  [SMALL_STATE(26)] = 1933,
  [SMALL_STATE(27)] = 2059,
  [SMALL_STATE(28)] = 2125,
  [SMALL_STATE(29)] = 2191,
  [SMALL_STATE(30)] = 2257,
  [SMALL_STATE(31)] = 2323,
  [SMALL_STATE(32)] = 2449,
  [SMALL_STATE(33)] = 2515,
  [SMALL_STATE(34)] = 2581,
  [SMALL_STATE(35)] = 2707,
  [SMALL_STATE(36)] = 2833,
  [SMALL_STATE(37)] = 2903,
  [SMALL_STATE(38)] = 3029,
  [SMALL_STATE(39)] = 3155,
  [SMALL_STATE(40)] = 3281,
  [SMALL_STATE(41)] = 3351,
  [SMALL_STATE(42)] = 3477,
  [SMALL_STATE(43)] = 3603,
  [SMALL_STATE(44)] = 3729,
  [SMALL_STATE(45)] = 3855,
  [SMALL_STATE(46)] = 3921,
  [SMALL_STATE(47)] = 4047,
  [SMALL_STATE(48)] = 4113,
  [SMALL_STATE(49)] = 4239,
  [SMALL_STATE(50)] = 4365,
  [SMALL_STATE(51)] = 4491,
  [SMALL_STATE(52)] = 4557,
  [SMALL_STATE(53)] = 4683,
  [SMALL_STATE(54)] = 4809,
  [SMALL_STATE(55)] = 4935,
  [SMALL_STATE(56)] = 5061,
  [SMALL_STATE(57)] = 5187,
  [SMALL_STATE(58)] = 5313,
  [SMALL_STATE(59)] = 5439,
  [SMALL_STATE(60)] = 5562,
  [SMALL_STATE(61)] = 5627,
  [SMALL_STATE(62)] = 5750,
  [SMALL_STATE(63)] = 5873,
  [SMALL_STATE(64)] = 5996,
  [SMALL_STATE(65)] = 6061,
  [SMALL_STATE(66)] = 6184,
  [SMALL_STATE(67)] = 6307,
  [SMALL_STATE(68)] = 6430,
  [SMALL_STATE(69)] = 6495,
  [SMALL_STATE(70)] = 6560,
  [SMALL_STATE(71)] = 6683,
  [SMALL_STATE(72)] = 6750,
  [SMALL_STATE(73)] = 6873,
  [SMALL_STATE(74)] = 6938,
  [SMALL_STATE(75)] = 7005,
  [SMALL_STATE(76)] = 7072,
  [SMALL_STATE(77)] = 7195,
  [SMALL_STATE(78)] = 7260,
  [SMALL_STATE(79)] = 7383,
  [SMALL_STATE(80)] = 7506,
  [SMALL_STATE(81)] = 7629,
  [SMALL_STATE(82)] = 7752,
  [SMALL_STATE(83)] = 7817,
  [SMALL_STATE(84)] = 7882,
  [SMALL_STATE(85)] = 7947,
  [SMALL_STATE(86)] = 8070,
  [SMALL_STATE(87)] = 8134,
  [SMALL_STATE(88)] = 8260,
  [SMALL_STATE(89)] = 8324,
  [SMALL_STATE(90)] = 8388,
  [SMALL_STATE(91)] = 8452,
  [SMALL_STATE(92)] = 8536,
  [SMALL_STATE(93)] = 8620,
  [SMALL_STATE(94)] = 8684,
  [SMALL_STATE(95)] = 8748,
  [SMALL_STATE(96)] = 8812,
  [SMALL_STATE(97)] = 8938,
  [SMALL_STATE(98)] = 9022,
  [SMALL_STATE(99)] = 9086,
  [SMALL_STATE(100)] = 9150,
  [SMALL_STATE(101)] = 9276,
  [SMALL_STATE(102)] = 9360,
  [SMALL_STATE(103)] = 9444,
  [SMALL_STATE(104)] = 9508,
  [SMALL_STATE(105)] = 9592,
  [SMALL_STATE(106)] = 9660,
  [SMALL_STATE(107)] = 9724,
  [SMALL_STATE(108)] = 9806,
  [SMALL_STATE(109)] = 9870,
  [SMALL_STATE(110)] = 9934,
  [SMALL_STATE(111)] = 9998,
  [SMALL_STATE(112)] = 10062,
  [SMALL_STATE(113)] = 10126,
  [SMALL_STATE(114)] = 10252,
  [SMALL_STATE(115)] = 10332,
  [SMALL_STATE(116)] = 10396,
  [SMALL_STATE(117)] = 10474,
  [SMALL_STATE(118)] = 10558,
  [SMALL_STATE(119)] = 10622,
  [SMALL_STATE(120)] = 10696,
  [SMALL_STATE(121)] = 10822,
  [SMALL_STATE(122)] = 10894,
  [SMALL_STATE(123)] = 10958,
  [SMALL_STATE(124)] = 11022,
  [SMALL_STATE(125)] = 11145,
  [SMALL_STATE(126)] = 11268,
  [SMALL_STATE(127)] = 11331,
  [SMALL_STATE(128)] = 11454,
  [SMALL_STATE(129)] = 11517,
  [SMALL_STATE(130)] = 11640,
  [SMALL_STATE(131)] = 11703,
  [SMALL_STATE(132)] = 11826,
  [SMALL_STATE(133)] = 11949,
  [SMALL_STATE(134)] = 12072,
  [SMALL_STATE(135)] = 12135,
  [SMALL_STATE(136)] = 12258,
  [SMALL_STATE(137)] = 12381,
  [SMALL_STATE(138)] = 12504,
  [SMALL_STATE(139)] = 12627,
  [SMALL_STATE(140)] = 12750,
  [SMALL_STATE(141)] = 12873,
  [SMALL_STATE(142)] = 12996,
  [SMALL_STATE(143)] = 13119,
  [SMALL_STATE(144)] = 13239,
  [SMALL_STATE(145)] = 13305,
  [SMALL_STATE(146)] = 13370,
  [SMALL_STATE(147)] = 13431,
  [SMALL_STATE(148)] = 13492,
  [SMALL_STATE(149)] = 13553,
  [SMALL_STATE(150)] = 13614,
  [SMALL_STATE(151)] = 13675,
  [SMALL_STATE(152)] = 13736,
  [SMALL_STATE(153)] = 13801,
  [SMALL_STATE(154)] = 13862,
  [SMALL_STATE(155)] = 13923,
  [SMALL_STATE(156)] = 13984,
  [SMALL_STATE(157)] = 14045,
  [SMALL_STATE(158)] = 14106,
  [SMALL_STATE(159)] = 14167,
  [SMALL_STATE(160)] = 14227,
  [SMALL_STATE(161)] = 14341,
  [SMALL_STATE(162)] = 14455,
  [SMALL_STATE(163)] = 14569,
  [SMALL_STATE(164)] = 14629,
  [SMALL_STATE(165)] = 14743,
  [SMALL_STATE(166)] = 14857,
  [SMALL_STATE(167)] = 14917,
  [SMALL_STATE(168)] = 15031,
  [SMALL_STATE(169)] = 15145,
  [SMALL_STATE(170)] = 15259,
  [SMALL_STATE(171)] = 15321,
  [SMALL_STATE(172)] = 15383,
  [SMALL_STATE(173)] = 15443,
  [SMALL_STATE(174)] = 15557,
  [SMALL_STATE(175)] = 15619,
  [SMALL_STATE(176)] = 15679,
  [SMALL_STATE(177)] = 15793,
  [SMALL_STATE(178)] = 15853,
  [SMALL_STATE(179)] = 15967,
  [SMALL_STATE(180)] = 16027,
  [SMALL_STATE(181)] = 16087,
  [SMALL_STATE(182)] = 16146,
  [SMALL_STATE(183)] = 16205,
  [SMALL_STATE(184)] = 16316,
  [SMALL_STATE(185)] = 16375,
  [SMALL_STATE(186)] = 16486,
  [SMALL_STATE(187)] = 16597,
  [SMALL_STATE(188)] = 16708,
  [SMALL_STATE(189)] = 16767,
  [SMALL_STATE(190)] = 16826,
  [SMALL_STATE(191)] = 16885,
  [SMALL_STATE(192)] = 16996,
  [SMALL_STATE(193)] = 17055,
  [SMALL_STATE(194)] = 17166,
  [SMALL_STATE(195)] = 17277,
  [SMALL_STATE(196)] = 17336,
  [SMALL_STATE(197)] = 17447,
  [SMALL_STATE(198)] = 17558,
  [SMALL_STATE(199)] = 17617,
  [SMALL_STATE(200)] = 17728,
  [SMALL_STATE(201)] = 17839,
  [SMALL_STATE(202)] = 17950,
  [SMALL_STATE(203)] = 18061,
  [SMALL_STATE(204)] = 18172,
  [SMALL_STATE(205)] = 18283,
  [SMALL_STATE(206)] = 18342,
  [SMALL_STATE(207)] = 18401,
  [SMALL_STATE(208)] = 18512,
  [SMALL_STATE(209)] = 18623,
  [SMALL_STATE(210)] = 18734,
  [SMALL_STATE(211)] = 18793,
  [SMALL_STATE(212)] = 18904,
  [SMALL_STATE(213)] = 18963,
  [SMALL_STATE(214)] = 19022,
  [SMALL_STATE(215)] = 19081,
  [SMALL_STATE(216)] = 19192,
  [SMALL_STATE(217)] = 19303,
  [SMALL_STATE(218)] = 19414,
  [SMALL_STATE(219)] = 19525,
  [SMALL_STATE(220)] = 19584,
  [SMALL_STATE(221)] = 19695,
  [SMALL_STATE(222)] = 19754,
  [SMALL_STATE(223)] = 19865,
  [SMALL_STATE(224)] = 19973,
  [SMALL_STATE(225)] = 20081,
  [SMALL_STATE(226)] = 20189,
  [SMALL_STATE(227)] = 20297,
  [SMALL_STATE(228)] = 20405,
  [SMALL_STATE(229)] = 20513,
  [SMALL_STATE(230)] = 20621,
  [SMALL_STATE(231)] = 20729,
  [SMALL_STATE(232)] = 20837,
  [SMALL_STATE(233)] = 20949,
  [SMALL_STATE(234)] = 21057,
  [SMALL_STATE(235)] = 21169,
  [SMALL_STATE(236)] = 21277,
  [SMALL_STATE(237)] = 21385,
  [SMALL_STATE(238)] = 21493,
  [SMALL_STATE(239)] = 21601,
  [SMALL_STATE(240)] = 21709,
  [SMALL_STATE(241)] = 21767,
  [SMALL_STATE(242)] = 21875,
  [SMALL_STATE(243)] = 21983,
  [SMALL_STATE(244)] = 22091,
  [SMALL_STATE(245)] = 22199,
  [SMALL_STATE(246)] = 22307,
  [SMALL_STATE(247)] = 22415,
  [SMALL_STATE(248)] = 22523,
  [SMALL_STATE(249)] = 22631,
  [SMALL_STATE(250)] = 22739,
  [SMALL_STATE(251)] = 22847,
  [SMALL_STATE(252)] = 22955,
  [SMALL_STATE(253)] = 23063,
  [SMALL_STATE(254)] = 23171,
  [SMALL_STATE(255)] = 23279,
  [SMALL_STATE(256)] = 23387,
  [SMALL_STATE(257)] = 23495,
  [SMALL_STATE(258)] = 23603,
  [SMALL_STATE(259)] = 23711,
  [SMALL_STATE(260)] = 23819,
  [SMALL_STATE(261)] = 23927,
  [SMALL_STATE(262)] = 24035,
  [SMALL_STATE(263)] = 24143,
  [SMALL_STATE(264)] = 24255,
  [SMALL_STATE(265)] = 24363,
  [SMALL_STATE(266)] = 24471,
  [SMALL_STATE(267)] = 24579,
  [SMALL_STATE(268)] = 24687,
  [SMALL_STATE(269)] = 24795,
  [SMALL_STATE(270)] = 24903,
  [SMALL_STATE(271)] = 25011,
  [SMALL_STATE(272)] = 25119,
  [SMALL_STATE(273)] = 25227,
  [SMALL_STATE(274)] = 25335,
  [SMALL_STATE(275)] = 25443,
  [SMALL_STATE(276)] = 25551,
  [SMALL_STATE(277)] = 25659,
  [SMALL_STATE(278)] = 25771,
  [SMALL_STATE(279)] = 25879,
  [SMALL_STATE(280)] = 25987,
  [SMALL_STATE(281)] = 26095,
  [SMALL_STATE(282)] = 26203,
  [SMALL_STATE(283)] = 26311,
  [SMALL_STATE(284)] = 26419,
  [SMALL_STATE(285)] = 26527,
  [SMALL_STATE(286)] = 26635,
  [SMALL_STATE(287)] = 26743,
  [SMALL_STATE(288)] = 26851,
  [SMALL_STATE(289)] = 26959,
  [SMALL_STATE(290)] = 27067,
  [SMALL_STATE(291)] = 27175,
  [SMALL_STATE(292)] = 27287,
  [SMALL_STATE(293)] = 27399,
  [SMALL_STATE(294)] = 27507,
  [SMALL_STATE(295)] = 27615,
  [SMALL_STATE(296)] = 27723,
  [SMALL_STATE(297)] = 27831,
  [SMALL_STATE(298)] = 27939,
  [SMALL_STATE(299)] = 28047,
  [SMALL_STATE(300)] = 28155,
  [SMALL_STATE(301)] = 28267,
  [SMALL_STATE(302)] = 28375,
  [SMALL_STATE(303)] = 28487,
  [SMALL_STATE(304)] = 28595,
  [SMALL_STATE(305)] = 28707,
  [SMALL_STATE(306)] = 28815,
  [SMALL_STATE(307)] = 28923,
  [SMALL_STATE(308)] = 29035,
  [SMALL_STATE(309)] = 29143,
  [SMALL_STATE(310)] = 29251,
  [SMALL_STATE(311)] = 29359,
  [SMALL_STATE(312)] = 29467,
  [SMALL_STATE(313)] = 29579,
  [SMALL_STATE(314)] = 29691,
  [SMALL_STATE(315)] = 29799,
  [SMALL_STATE(316)] = 29907,
  [SMALL_STATE(317)] = 30015,
  [SMALL_STATE(318)] = 30123,
  [SMALL_STATE(319)] = 30231,
  [SMALL_STATE(320)] = 30339,
  [SMALL_STATE(321)] = 30447,
  [SMALL_STATE(322)] = 30555,
  [SMALL_STATE(323)] = 30667,
  [SMALL_STATE(324)] = 30779,
  [SMALL_STATE(325)] = 30891,
  [SMALL_STATE(326)] = 30953,
  [SMALL_STATE(327)] = 31015,
  [SMALL_STATE(328)] = 31124,
  [SMALL_STATE(329)] = 31190,
  [SMALL_STATE(330)] = 31296,
  [SMALL_STATE(331)] = 31402,
  [SMALL_STATE(332)] = 31508,
  [SMALL_STATE(333)] = 31614,
  [SMALL_STATE(334)] = 31720,
  [SMALL_STATE(335)] = 31796,
  [SMALL_STATE(336)] = 31860,
  [SMALL_STATE(337)] = 31936,
  [SMALL_STATE(338)] = 32042,
  [SMALL_STATE(339)] = 32118,
  [SMALL_STATE(340)] = 32178,
  [SMALL_STATE(341)] = 32252,
  [SMALL_STATE(342)] = 32324,
  [SMALL_STATE(343)] = 32394,
  [SMALL_STATE(344)] = 32500,
  [SMALL_STATE(345)] = 32576,
  [SMALL_STATE(346)] = 32682,
  [SMALL_STATE(347)] = 32738,
  [SMALL_STATE(348)] = 32844,
  [SMALL_STATE(349)] = 32950,
  [SMALL_STATE(350)] = 33026,
  [SMALL_STATE(351)] = 33132,
  [SMALL_STATE(352)] = 33208,
  [SMALL_STATE(353)] = 33314,
  [SMALL_STATE(354)] = 33390,
  [SMALL_STATE(355)] = 33445,
  [SMALL_STATE(356)] = 33500,
  [SMALL_STATE(357)] = 33555,
  [SMALL_STATE(358)] = 33610,
  [SMALL_STATE(359)] = 33663,
  [SMALL_STATE(360)] = 33716,
  [SMALL_STATE(361)] = 33769,
  [SMALL_STATE(362)] = 33824,
  [SMALL_STATE(363)] = 33874,
  [SMALL_STATE(364)] = 33924,
  [SMALL_STATE(365)] = 33978,
  [SMALL_STATE(366)] = 34032,
  [SMALL_STATE(367)] = 34086,
  [SMALL_STATE(368)] = 34140,
  [SMALL_STATE(369)] = 34190,
  [SMALL_STATE(370)] = 34240,
  [SMALL_STATE(371)] = 34290,
  [SMALL_STATE(372)] = 34340,
  [SMALL_STATE(373)] = 34390,
  [SMALL_STATE(374)] = 34440,
  [SMALL_STATE(375)] = 34490,
  [SMALL_STATE(376)] = 34540,
  [SMALL_STATE(377)] = 34590,
  [SMALL_STATE(378)] = 34640,
  [SMALL_STATE(379)] = 34690,
  [SMALL_STATE(380)] = 34740,
  [SMALL_STATE(381)] = 34790,
  [SMALL_STATE(382)] = 34840,
  [SMALL_STATE(383)] = 34889,
  [SMALL_STATE(384)] = 34938,
  [SMALL_STATE(385)] = 34987,
  [SMALL_STATE(386)] = 35036,
  [SMALL_STATE(387)] = 35087,
  [SMALL_STATE(388)] = 35136,
  [SMALL_STATE(389)] = 35187,
  [SMALL_STATE(390)] = 35238,
  [SMALL_STATE(391)] = 35287,
  [SMALL_STATE(392)] = 35336,
  [SMALL_STATE(393)] = 35385,
  [SMALL_STATE(394)] = 35453,
  [SMALL_STATE(395)] = 35501,
  [SMALL_STATE(396)] = 35549,
  [SMALL_STATE(397)] = 35597,
  [SMALL_STATE(398)] = 35645,
  [SMALL_STATE(399)] = 35693,
  [SMALL_STATE(400)] = 35741,
  [SMALL_STATE(401)] = 35809,
  [SMALL_STATE(402)] = 35857,
  [SMALL_STATE(403)] = 35905,
  [SMALL_STATE(404)] = 35953,
  [SMALL_STATE(405)] = 36021,
  [SMALL_STATE(406)] = 36069,
  [SMALL_STATE(407)] = 36117,
  [SMALL_STATE(408)] = 36165,
  [SMALL_STATE(409)] = 36213,
  [SMALL_STATE(410)] = 36261,
  [SMALL_STATE(411)] = 36309,
  [SMALL_STATE(412)] = 36377,
  [SMALL_STATE(413)] = 36425,
  [SMALL_STATE(414)] = 36473,
  [SMALL_STATE(415)] = 36521,
  [SMALL_STATE(416)] = 36577,
  [SMALL_STATE(417)] = 36635,
  [SMALL_STATE(418)] = 36697,
  [SMALL_STATE(419)] = 36745,
  [SMALL_STATE(420)] = 36809,
  [SMALL_STATE(421)] = 36875,
  [SMALL_STATE(422)] = 36927,
  [SMALL_STATE(423)] = 36975,
  [SMALL_STATE(424)] = 37043,
  [SMALL_STATE(425)] = 37111,
  [SMALL_STATE(426)] = 37161,
  [SMALL_STATE(427)] = 37211,
  [SMALL_STATE(428)] = 37261,
  [SMALL_STATE(429)] = 37311,
  [SMALL_STATE(430)] = 37356,
  [SMALL_STATE(431)] = 37401,
  [SMALL_STATE(432)] = 37450,
  [SMALL_STATE(433)] = 37499,
  [SMALL_STATE(434)] = 37544,
  [SMALL_STATE(435)] = 37593,
  [SMALL_STATE(436)] = 37642,
  [SMALL_STATE(437)] = 37687,
  [SMALL_STATE(438)] = 37732,
  [SMALL_STATE(439)] = 37777,
  [SMALL_STATE(440)] = 37826,
  [SMALL_STATE(441)] = 37871,
  [SMALL_STATE(442)] = 37916,
  [SMALL_STATE(443)] = 37961,
  [SMALL_STATE(444)] = 38006,
  [SMALL_STATE(445)] = 38051,
  [SMALL_STATE(446)] = 38096,
  [SMALL_STATE(447)] = 38142,
  [SMALL_STATE(448)] = 38186,
  [SMALL_STATE(449)] = 38230,
  [SMALL_STATE(450)] = 38274,
  [SMALL_STATE(451)] = 38322,
  [SMALL_STATE(452)] = 38366,
  [SMALL_STATE(453)] = 38414,
  [SMALL_STATE(454)] = 38458,
  [SMALL_STATE(455)] = 38504,
  [SMALL_STATE(456)] = 38550,
  [SMALL_STATE(457)] = 38634,
  [SMALL_STATE(458)] = 38678,
  [SMALL_STATE(459)] = 38762,
  [SMALL_STATE(460)] = 38846,
  [SMALL_STATE(461)] = 38930,
  [SMALL_STATE(462)] = 38974,
  [SMALL_STATE(463)] = 39058,
  [SMALL_STATE(464)] = 39102,
  [SMALL_STATE(465)] = 39146,
  [SMALL_STATE(466)] = 39194,
  [SMALL_STATE(467)] = 39238,
  [SMALL_STATE(468)] = 39281,
  [SMALL_STATE(469)] = 39324,
  [SMALL_STATE(470)] = 39367,
  [SMALL_STATE(471)] = 39450,
  [SMALL_STATE(472)] = 39501,
  [SMALL_STATE(473)] = 39554,
  [SMALL_STATE(474)] = 39609,
  [SMALL_STATE(475)] = 39666,
  [SMALL_STATE(476)] = 39725,
  [SMALL_STATE(477)] = 39772,
  [SMALL_STATE(478)] = 39815,
  [SMALL_STATE(479)] = 39876,
  [SMALL_STATE(480)] = 39937,
  [SMALL_STATE(481)] = 39980,
  [SMALL_STATE(482)] = 40023,
  [SMALL_STATE(483)] = 40066,
  [SMALL_STATE(484)] = 40109,
  [SMALL_STATE(485)] = 40156,
  [SMALL_STATE(486)] = 40199,
  [SMALL_STATE(487)] = 40242,
  [SMALL_STATE(488)] = 40303,
  [SMALL_STATE(489)] = 40386,
  [SMALL_STATE(490)] = 40429,
  [SMALL_STATE(491)] = 40472,
  [SMALL_STATE(492)] = 40517,
  [SMALL_STATE(493)] = 40560,
  [SMALL_STATE(494)] = 40603,
  [SMALL_STATE(495)] = 40646,
  [SMALL_STATE(496)] = 40689,
  [SMALL_STATE(497)] = 40732,
  [SMALL_STATE(498)] = 40813,
  [SMALL_STATE(499)] = 40856,
  [SMALL_STATE(500)] = 40899,
  [SMALL_STATE(501)] = 40942,
  [SMALL_STATE(502)] = 40985,
  [SMALL_STATE(503)] = 41046,
  [SMALL_STATE(504)] = 41089,
  [SMALL_STATE(505)] = 41136,
  [SMALL_STATE(506)] = 41181,
  [SMALL_STATE(507)] = 41228,
  [SMALL_STATE(508)] = 41271,
  [SMALL_STATE(509)] = 41314,
  [SMALL_STATE(510)] = 41357,
  [SMALL_STATE(511)] = 41402,
  [SMALL_STATE(512)] = 41445,
  [SMALL_STATE(513)] = 41492,
  [SMALL_STATE(514)] = 41549,
  [SMALL_STATE(515)] = 41630,
  [SMALL_STATE(516)] = 41673,
  [SMALL_STATE(517)] = 41730,
  [SMALL_STATE(518)] = 41787,
  [SMALL_STATE(519)] = 41844,
  [SMALL_STATE(520)] = 41887,
  [SMALL_STATE(521)] = 41944,
  [SMALL_STATE(522)] = 41987,
  [SMALL_STATE(523)] = 42030,
  [SMALL_STATE(524)] = 42087,
  [SMALL_STATE(525)] = 42170,
  [SMALL_STATE(526)] = 42213,
  [SMALL_STATE(527)] = 42255,
  [SMALL_STATE(528)] = 42297,
  [SMALL_STATE(529)] = 42339,
  [SMALL_STATE(530)] = 42381,
  [SMALL_STATE(531)] = 42453,
  [SMALL_STATE(532)] = 42509,
  [SMALL_STATE(533)] = 42551,
  [SMALL_STATE(534)] = 42595,
  [SMALL_STATE(535)] = 42637,
  [SMALL_STATE(536)] = 42679,
  [SMALL_STATE(537)] = 42751,
  [SMALL_STATE(538)] = 42823,
  [SMALL_STATE(539)] = 42865,
  [SMALL_STATE(540)] = 42907,
  [SMALL_STATE(541)] = 42979,
  [SMALL_STATE(542)] = 43051,
  [SMALL_STATE(543)] = 43095,
  [SMALL_STATE(544)] = 43137,
  [SMALL_STATE(545)] = 43179,
  [SMALL_STATE(546)] = 43221,
  [SMALL_STATE(547)] = 43263,
  [SMALL_STATE(548)] = 43305,
  [SMALL_STATE(549)] = 43377,
  [SMALL_STATE(550)] = 43419,
  [SMALL_STATE(551)] = 43461,
  [SMALL_STATE(552)] = 43503,
  [SMALL_STATE(553)] = 43545,
  [SMALL_STATE(554)] = 43587,
  [SMALL_STATE(555)] = 43629,
  [SMALL_STATE(556)] = 43671,
  [SMALL_STATE(557)] = 43713,
  [SMALL_STATE(558)] = 43755,
  [SMALL_STATE(559)] = 43797,
  [SMALL_STATE(560)] = 43839,
  [SMALL_STATE(561)] = 43881,
  [SMALL_STATE(562)] = 43923,
  [SMALL_STATE(563)] = 43965,
  [SMALL_STATE(564)] = 44037,
  [SMALL_STATE(565)] = 44079,
  [SMALL_STATE(566)] = 44121,
  [SMALL_STATE(567)] = 44163,
  [SMALL_STATE(568)] = 44205,
  [SMALL_STATE(569)] = 44247,
  [SMALL_STATE(570)] = 44289,
  [SMALL_STATE(571)] = 44331,
  [SMALL_STATE(572)] = 44373,
  [SMALL_STATE(573)] = 44417,
  [SMALL_STATE(574)] = 44459,
  [SMALL_STATE(575)] = 44501,
  [SMALL_STATE(576)] = 44543,
  [SMALL_STATE(577)] = 44585,
  [SMALL_STATE(578)] = 44627,
  [SMALL_STATE(579)] = 44669,
  [SMALL_STATE(580)] = 44711,
  [SMALL_STATE(581)] = 44753,
  [SMALL_STATE(582)] = 44825,
  [SMALL_STATE(583)] = 44867,
  [SMALL_STATE(584)] = 44909,
  [SMALL_STATE(585)] = 44951,
  [SMALL_STATE(586)] = 45007,
  [SMALL_STATE(587)] = 45079,
  [SMALL_STATE(588)] = 45121,
  [SMALL_STATE(589)] = 45163,
  [SMALL_STATE(590)] = 45205,
  [SMALL_STATE(591)] = 45261,
  [SMALL_STATE(592)] = 45333,
  [SMALL_STATE(593)] = 45375,
  [SMALL_STATE(594)] = 45417,
  [SMALL_STATE(595)] = 45459,
  [SMALL_STATE(596)] = 45501,
  [SMALL_STATE(597)] = 45543,
  [SMALL_STATE(598)] = 45585,
  [SMALL_STATE(599)] = 45627,
  [SMALL_STATE(600)] = 45669,
  [SMALL_STATE(601)] = 45711,
  [SMALL_STATE(602)] = 45753,
  [SMALL_STATE(603)] = 45795,
  [SMALL_STATE(604)] = 45837,
  [SMALL_STATE(605)] = 45879,
  [SMALL_STATE(606)] = 45921,
  [SMALL_STATE(607)] = 45963,
  [SMALL_STATE(608)] = 46005,
  [SMALL_STATE(609)] = 46082,
  [SMALL_STATE(610)] = 46127,
  [SMALL_STATE(611)] = 46180,
  [SMALL_STATE(612)] = 46233,
  [SMALL_STATE(613)] = 46308,
  [SMALL_STATE(614)] = 46361,
  [SMALL_STATE(615)] = 46438,
  [SMALL_STATE(616)] = 46515,
  [SMALL_STATE(617)] = 46592,
  [SMALL_STATE(618)] = 46667,
  [SMALL_STATE(619)] = 46744,
  [SMALL_STATE(620)] = 46821,
  [SMALL_STATE(621)] = 46898,
  [SMALL_STATE(622)] = 46956,
  [SMALL_STATE(623)] = 47030,
  [SMALL_STATE(624)] = 47104,
  [SMALL_STATE(625)] = 47178,
  [SMALL_STATE(626)] = 47252,
  [SMALL_STATE(627)] = 47326,
  [SMALL_STATE(628)] = 47400,
  [SMALL_STATE(629)] = 47474,
  [SMALL_STATE(630)] = 47548,
  [SMALL_STATE(631)] = 47619,
  [SMALL_STATE(632)] = 47658,
  [SMALL_STATE(633)] = 47697,
  [SMALL_STATE(634)] = 47736,
  [SMALL_STATE(635)] = 47799,
  [SMALL_STATE(636)] = 47870,
  [SMALL_STATE(637)] = 47941,
  [SMALL_STATE(638)] = 48004,
  [SMALL_STATE(639)] = 48075,
  [SMALL_STATE(640)] = 48114,
  [SMALL_STATE(641)] = 48153,
  [SMALL_STATE(642)] = 48192,
  [SMALL_STATE(643)] = 48231,
  [SMALL_STATE(644)] = 48302,
  [SMALL_STATE(645)] = 48341,
  [SMALL_STATE(646)] = 48412,
  [SMALL_STATE(647)] = 48451,
  [SMALL_STATE(648)] = 48522,
  [SMALL_STATE(649)] = 48585,
  [SMALL_STATE(650)] = 48624,
  [SMALL_STATE(651)] = 48695,
  [SMALL_STATE(652)] = 48734,
  [SMALL_STATE(653)] = 48773,
  [SMALL_STATE(654)] = 48836,
  [SMALL_STATE(655)] = 48907,
  [SMALL_STATE(656)] = 48946,
  [SMALL_STATE(657)] = 49009,
  [SMALL_STATE(658)] = 49080,
  [SMALL_STATE(659)] = 49151,
  [SMALL_STATE(660)] = 49194,
  [SMALL_STATE(661)] = 49233,
  [SMALL_STATE(662)] = 49304,
  [SMALL_STATE(663)] = 49343,
  [SMALL_STATE(664)] = 49382,
  [SMALL_STATE(665)] = 49421,
  [SMALL_STATE(666)] = 49492,
  [SMALL_STATE(667)] = 49563,
  [SMALL_STATE(668)] = 49602,
  [SMALL_STATE(669)] = 49668,
  [SMALL_STATE(670)] = 49728,
  [SMALL_STATE(671)] = 49788,
  [SMALL_STATE(672)] = 49830,
  [SMALL_STATE(673)] = 49868,
  [SMALL_STATE(674)] = 49906,
  [SMALL_STATE(675)] = 49944,
  [SMALL_STATE(676)] = 50010,
  [SMALL_STATE(677)] = 50076,
  [SMALL_STATE(678)] = 50142,
  [SMALL_STATE(679)] = 50184,
  [SMALL_STATE(680)] = 50226,
  [SMALL_STATE(681)] = 50294,
  [SMALL_STATE(682)] = 50360,
  [SMALL_STATE(683)] = 50426,
  [SMALL_STATE(684)] = 50486,
  [SMALL_STATE(685)] = 50524,
  [SMALL_STATE(686)] = 50584,
  [SMALL_STATE(687)] = 50622,
  [SMALL_STATE(688)] = 50660,
  [SMALL_STATE(689)] = 50728,
  [SMALL_STATE(690)] = 50794,
  [SMALL_STATE(691)] = 50860,
  [SMALL_STATE(692)] = 50898,
  [SMALL_STATE(693)] = 50936,
  [SMALL_STATE(694)] = 50974,
  [SMALL_STATE(695)] = 51012,
  [SMALL_STATE(696)] = 51072,
  [SMALL_STATE(697)] = 51138,
  [SMALL_STATE(698)] = 51198,
  [SMALL_STATE(699)] = 51236,
  [SMALL_STATE(700)] = 51274,
  [SMALL_STATE(701)] = 51312,
  [SMALL_STATE(702)] = 51354,
  [SMALL_STATE(703)] = 51420,
  [SMALL_STATE(704)] = 51488,
  [SMALL_STATE(705)] = 51526,
  [SMALL_STATE(706)] = 51564,
  [SMALL_STATE(707)] = 51601,
  [SMALL_STATE(708)] = 51638,
  [SMALL_STATE(709)] = 51675,
  [SMALL_STATE(710)] = 51714,
  [SMALL_STATE(711)] = 51777,
  [SMALL_STATE(712)] = 51814,
  [SMALL_STATE(713)] = 51851,
  [SMALL_STATE(714)] = 51914,
  [SMALL_STATE(715)] = 51977,
  [SMALL_STATE(716)] = 52040,
  [SMALL_STATE(717)] = 52105,
  [SMALL_STATE(718)] = 52168,
  [SMALL_STATE(719)] = 52205,
  [SMALL_STATE(720)] = 52268,
  [SMALL_STATE(721)] = 52333,
  [SMALL_STATE(722)] = 52396,
  [SMALL_STATE(723)] = 52451,
  [SMALL_STATE(724)] = 52506,
  [SMALL_STATE(725)] = 52569,
  [SMALL_STATE(726)] = 52624,
  [SMALL_STATE(727)] = 52687,
  [SMALL_STATE(728)] = 52750,
  [SMALL_STATE(729)] = 52787,
  [SMALL_STATE(730)] = 52824,
  [SMALL_STATE(731)] = 52889,
  [SMALL_STATE(732)] = 52928,
  [SMALL_STATE(733)] = 52967,
  [SMALL_STATE(734)] = 53003,
  [SMALL_STATE(735)] = 53057,
  [SMALL_STATE(736)] = 53111,
  [SMALL_STATE(737)] = 53151,
  [SMALL_STATE(738)] = 53205,
  [SMALL_STATE(739)] = 53257,
  [SMALL_STATE(740)] = 53311,
  [SMALL_STATE(741)] = 53347,
  [SMALL_STATE(742)] = 53397,
  [SMALL_STATE(743)] = 53445,
  [SMALL_STATE(744)] = 53491,
  [SMALL_STATE(745)] = 53551,
  [SMALL_STATE(746)] = 53605,
  [SMALL_STATE(747)] = 53649,
  [SMALL_STATE(748)] = 53685,
  [SMALL_STATE(749)] = 53739,
  [SMALL_STATE(750)] = 53775,
  [SMALL_STATE(751)] = 53835,
  [SMALL_STATE(752)] = 53895,
  [SMALL_STATE(753)] = 53949,
  [SMALL_STATE(754)] = 53985,
  [SMALL_STATE(755)] = 54021,
  [SMALL_STATE(756)] = 54081,
  [SMALL_STATE(757)] = 54117,
  [SMALL_STATE(758)] = 54171,
  [SMALL_STATE(759)] = 54225,
  [SMALL_STATE(760)] = 54285,
  [SMALL_STATE(761)] = 54339,
  [SMALL_STATE(762)] = 54399,
  [SMALL_STATE(763)] = 54453,
  [SMALL_STATE(764)] = 54507,
  [SMALL_STATE(765)] = 54567,
  [SMALL_STATE(766)] = 54603,
  [SMALL_STATE(767)] = 54657,
  [SMALL_STATE(768)] = 54711,
  [SMALL_STATE(769)] = 54771,
  [SMALL_STATE(770)] = 54807,
  [SMALL_STATE(771)] = 54843,
  [SMALL_STATE(772)] = 54879,
  [SMALL_STATE(773)] = 54933,
  [SMALL_STATE(774)] = 54969,
  [SMALL_STATE(775)] = 55023,
  [SMALL_STATE(776)] = 55077,
  [SMALL_STATE(777)] = 55131,
  [SMALL_STATE(778)] = 55191,
  [SMALL_STATE(779)] = 55227,
  [SMALL_STATE(780)] = 55281,
  [SMALL_STATE(781)] = 55335,
  [SMALL_STATE(782)] = 55371,
  [SMALL_STATE(783)] = 55431,
  [SMALL_STATE(784)] = 55467,
  [SMALL_STATE(785)] = 55521,
  [SMALL_STATE(786)] = 55575,
  [SMALL_STATE(787)] = 55611,
  [SMALL_STATE(788)] = 55647,
  [SMALL_STATE(789)] = 55707,
  [SMALL_STATE(790)] = 55761,
  [SMALL_STATE(791)] = 55797,
  [SMALL_STATE(792)] = 55851,
  [SMALL_STATE(793)] = 55887,
  [SMALL_STATE(794)] = 55947,
  [SMALL_STATE(795)] = 55983,
  [SMALL_STATE(796)] = 56043,
  [SMALL_STATE(797)] = 56097,
  [SMALL_STATE(798)] = 56154,
  [SMALL_STATE(799)] = 56211,
  [SMALL_STATE(800)] = 56268,
  [SMALL_STATE(801)] = 56325,
  [SMALL_STATE(802)] = 56382,
  [SMALL_STATE(803)] = 56439,
  [SMALL_STATE(804)] = 56496,
  [SMALL_STATE(805)] = 56553,
  [SMALL_STATE(806)] = 56610,
  [SMALL_STATE(807)] = 56667,
  [SMALL_STATE(808)] = 56724,
  [SMALL_STATE(809)] = 56758,
  [SMALL_STATE(810)] = 56790,
  [SMALL_STATE(811)] = 56824,
  [SMALL_STATE(812)] = 56858,
  [SMALL_STATE(813)] = 56892,
  [SMALL_STATE(814)] = 56939,
  [SMALL_STATE(815)] = 56986,
  [SMALL_STATE(816)] = 57033,
  [SMALL_STATE(817)] = 57080,
  [SMALL_STATE(818)] = 57127,
  [SMALL_STATE(819)] = 57174,
  [SMALL_STATE(820)] = 57218,
  [SMALL_STATE(821)] = 57262,
  [SMALL_STATE(822)] = 57306,
  [SMALL_STATE(823)] = 57350,
  [SMALL_STATE(824)] = 57394,
  [SMALL_STATE(825)] = 57422,
  [SMALL_STATE(826)] = 57466,
  [SMALL_STATE(827)] = 57510,
  [SMALL_STATE(828)] = 57554,
  [SMALL_STATE(829)] = 57580,
  [SMALL_STATE(830)] = 57624,
  [SMALL_STATE(831)] = 57668,
  [SMALL_STATE(832)] = 57698,
  [SMALL_STATE(833)] = 57723,
  [SMALL_STATE(834)] = 57764,
  [SMALL_STATE(835)] = 57805,
  [SMALL_STATE(836)] = 57846,
  [SMALL_STATE(837)] = 57887,
  [SMALL_STATE(838)] = 57930,
  [SMALL_STATE(839)] = 57971,
  [SMALL_STATE(840)] = 58012,
  [SMALL_STATE(841)] = 58053,
  [SMALL_STATE(842)] = 58096,
  [SMALL_STATE(843)] = 58137,
  [SMALL_STATE(844)] = 58180,
  [SMALL_STATE(845)] = 58209,
  [SMALL_STATE(846)] = 58250,
  [SMALL_STATE(847)] = 58291,
  [SMALL_STATE(848)] = 58332,
  [SMALL_STATE(849)] = 58370,
  [SMALL_STATE(850)] = 58410,
  [SMALL_STATE(851)] = 58448,
  [SMALL_STATE(852)] = 58486,
  [SMALL_STATE(853)] = 58512,
  [SMALL_STATE(854)] = 58538,
  [SMALL_STATE(855)] = 58576,
  [SMALL_STATE(856)] = 58614,
  [SMALL_STATE(857)] = 58652,
  [SMALL_STATE(858)] = 58676,
  [SMALL_STATE(859)] = 58714,
  [SMALL_STATE(860)] = 58754,
  [SMALL_STATE(861)] = 58792,
  [SMALL_STATE(862)] = 58830,
  [SMALL_STATE(863)] = 58868,
  [SMALL_STATE(864)] = 58906,
  [SMALL_STATE(865)] = 58932,
  [SMALL_STATE(866)] = 58970,
  [SMALL_STATE(867)] = 59008,
  [SMALL_STATE(868)] = 59048,
  [SMALL_STATE(869)] = 59086,
  [SMALL_STATE(870)] = 59124,
  [SMALL_STATE(871)] = 59162,
  [SMALL_STATE(872)] = 59188,
  [SMALL_STATE(873)] = 59214,
  [SMALL_STATE(874)] = 59242,
  [SMALL_STATE(875)] = 59280,
  [SMALL_STATE(876)] = 59318,
  [SMALL_STATE(877)] = 59356,
  [SMALL_STATE(878)] = 59396,
  [SMALL_STATE(879)] = 59434,
  [SMALL_STATE(880)] = 59458,
  [SMALL_STATE(881)] = 59482,
  [SMALL_STATE(882)] = 59506,
  [SMALL_STATE(883)] = 59534,
  [SMALL_STATE(884)] = 59558,
  [SMALL_STATE(885)] = 59598,
  [SMALL_STATE(886)] = 59622,
  [SMALL_STATE(887)] = 59660,
  [SMALL_STATE(888)] = 59700,
  [SMALL_STATE(889)] = 59724,
  [SMALL_STATE(890)] = 59748,
  [SMALL_STATE(891)] = 59772,
  [SMALL_STATE(892)] = 59810,
  [SMALL_STATE(893)] = 59834,
  [SMALL_STATE(894)] = 59872,
  [SMALL_STATE(895)] = 59896,
  [SMALL_STATE(896)] = 59934,
  [SMALL_STATE(897)] = 59972,
  [SMALL_STATE(898)] = 60012,
  [SMALL_STATE(899)] = 60036,
  [SMALL_STATE(900)] = 60074,
  [SMALL_STATE(901)] = 60112,
  [SMALL_STATE(902)] = 60139,
  [SMALL_STATE(903)] = 60162,
  [SMALL_STATE(904)] = 60189,
  [SMALL_STATE(905)] = 60226,
  [SMALL_STATE(906)] = 60249,
  [SMALL_STATE(907)] = 60276,
  [SMALL_STATE(908)] = 60299,
  [SMALL_STATE(909)] = 60322,
  [SMALL_STATE(910)] = 60359,
  [SMALL_STATE(911)] = 60382,
  [SMALL_STATE(912)] = 60419,
  [SMALL_STATE(913)] = 60448,
  [SMALL_STATE(914)] = 60471,
  [SMALL_STATE(915)] = 60504,
  [SMALL_STATE(916)] = 60527,
  [SMALL_STATE(917)] = 60550,
  [SMALL_STATE(918)] = 60573,
  [SMALL_STATE(919)] = 60596,
  [SMALL_STATE(920)] = 60619,
  [SMALL_STATE(921)] = 60642,
  [SMALL_STATE(922)] = 60665,
  [SMALL_STATE(923)] = 60688,
  [SMALL_STATE(924)] = 60721,
  [SMALL_STATE(925)] = 60752,
  [SMALL_STATE(926)] = 60775,
  [SMALL_STATE(927)] = 60798,
  [SMALL_STATE(928)] = 60835,
  [SMALL_STATE(929)] = 60858,
  [SMALL_STATE(930)] = 60885,
  [SMALL_STATE(931)] = 60912,
  [SMALL_STATE(932)] = 60941,
  [SMALL_STATE(933)] = 60964,
  [SMALL_STATE(934)] = 60987,
  [SMALL_STATE(935)] = 61010,
  [SMALL_STATE(936)] = 61033,
  [SMALL_STATE(937)] = 61056,
  [SMALL_STATE(938)] = 61079,
  [SMALL_STATE(939)] = 61102,
  [SMALL_STATE(940)] = 61125,
  [SMALL_STATE(941)] = 61148,
  [SMALL_STATE(942)] = 61171,
  [SMALL_STATE(943)] = 61194,
  [SMALL_STATE(944)] = 61221,
  [SMALL_STATE(945)] = 61252,
  [SMALL_STATE(946)] = 61276,
  [SMALL_STATE(947)] = 61301,
  [SMALL_STATE(948)] = 61342,
  [SMALL_STATE(949)] = 61383,
  [SMALL_STATE(950)] = 61404,
  [SMALL_STATE(951)] = 61445,
  [SMALL_STATE(952)] = 61466,
  [SMALL_STATE(953)] = 61507,
  [SMALL_STATE(954)] = 61528,
  [SMALL_STATE(955)] = 61549,
  [SMALL_STATE(956)] = 61570,
  [SMALL_STATE(957)] = 61595,
  [SMALL_STATE(958)] = 61616,
  [SMALL_STATE(959)] = 61637,
  [SMALL_STATE(960)] = 61658,
  [SMALL_STATE(961)] = 61699,
  [SMALL_STATE(962)] = 61740,
  [SMALL_STATE(963)] = 61761,
  [SMALL_STATE(964)] = 61786,
  [SMALL_STATE(965)] = 61811,
  [SMALL_STATE(966)] = 61832,
  [SMALL_STATE(967)] = 61857,
  [SMALL_STATE(968)] = 61879,
  [SMALL_STATE(969)] = 61901,
  [SMALL_STATE(970)] = 61923,
  [SMALL_STATE(971)] = 61957,
  [SMALL_STATE(972)] = 61979,
  [SMALL_STATE(973)] = 62017,
  [SMALL_STATE(974)] = 62037,
  [SMALL_STATE(975)] = 62057,
  [SMALL_STATE(976)] = 62077,
  [SMALL_STATE(977)] = 62097,
  [SMALL_STATE(978)] = 62119,
  [SMALL_STATE(979)] = 62153,
  [SMALL_STATE(980)] = 62174,
  [SMALL_STATE(981)] = 62193,
  [SMALL_STATE(982)] = 62220,
  [SMALL_STATE(983)] = 62239,
  [SMALL_STATE(984)] = 62258,
  [SMALL_STATE(985)] = 62277,
  [SMALL_STATE(986)] = 62296,
  [SMALL_STATE(987)] = 62315,
  [SMALL_STATE(988)] = 62336,
  [SMALL_STATE(989)] = 62355,
  [SMALL_STATE(990)] = 62374,
  [SMALL_STATE(991)] = 62393,
  [SMALL_STATE(992)] = 62412,
  [SMALL_STATE(993)] = 62435,
  [SMALL_STATE(994)] = 62454,
  [SMALL_STATE(995)] = 62473,
  [SMALL_STATE(996)] = 62492,
  [SMALL_STATE(997)] = 62511,
  [SMALL_STATE(998)] = 62530,
  [SMALL_STATE(999)] = 62549,
  [SMALL_STATE(1000)] = 62568,
  [SMALL_STATE(1001)] = 62587,
  [SMALL_STATE(1002)] = 62606,
  [SMALL_STATE(1003)] = 62625,
  [SMALL_STATE(1004)] = 62644,
  [SMALL_STATE(1005)] = 62663,
  [SMALL_STATE(1006)] = 62682,
  [SMALL_STATE(1007)] = 62701,
  [SMALL_STATE(1008)] = 62720,
  [SMALL_STATE(1009)] = 62739,
  [SMALL_STATE(1010)] = 62758,
  [SMALL_STATE(1011)] = 62777,
  [SMALL_STATE(1012)] = 62796,
  [SMALL_STATE(1013)] = 62815,
  [SMALL_STATE(1014)] = 62834,
  [SMALL_STATE(1015)] = 62853,
  [SMALL_STATE(1016)] = 62885,
  [SMALL_STATE(1017)] = 62917,
  [SMALL_STATE(1018)] = 62937,
  [SMALL_STATE(1019)] = 62969,
  [SMALL_STATE(1020)] = 62987,
  [SMALL_STATE(1021)] = 63005,
  [SMALL_STATE(1022)] = 63023,
  [SMALL_STATE(1023)] = 63052,
  [SMALL_STATE(1024)] = 63081,
  [SMALL_STATE(1025)] = 63110,
  [SMALL_STATE(1026)] = 63139,
  [SMALL_STATE(1027)] = 63168,
  [SMALL_STATE(1028)] = 63185,
  [SMALL_STATE(1029)] = 63214,
  [SMALL_STATE(1030)] = 63243,
  [SMALL_STATE(1031)] = 63267,
  [SMALL_STATE(1032)] = 63291,
  [SMALL_STATE(1033)] = 63313,
  [SMALL_STATE(1034)] = 63333,
  [SMALL_STATE(1035)] = 63355,
  [SMALL_STATE(1036)] = 63379,
  [SMALL_STATE(1037)] = 63405,
  [SMALL_STATE(1038)] = 63429,
  [SMALL_STATE(1039)] = 63451,
  [SMALL_STATE(1040)] = 63475,
  [SMALL_STATE(1041)] = 63497,
  [SMALL_STATE(1042)] = 63519,
  [SMALL_STATE(1043)] = 63543,
  [SMALL_STATE(1044)] = 63567,
  [SMALL_STATE(1045)] = 63589,
  [SMALL_STATE(1046)] = 63611,
  [SMALL_STATE(1047)] = 63635,
  [SMALL_STATE(1048)] = 63657,
  [SMALL_STATE(1049)] = 63681,
  [SMALL_STATE(1050)] = 63703,
  [SMALL_STATE(1051)] = 63725,
  [SMALL_STATE(1052)] = 63747,
  [SMALL_STATE(1053)] = 63765,
  [SMALL_STATE(1054)] = 63789,
  [SMALL_STATE(1055)] = 63811,
  [SMALL_STATE(1056)] = 63833,
  [SMALL_STATE(1057)] = 63857,
  [SMALL_STATE(1058)] = 63879,
  [SMALL_STATE(1059)] = 63903,
  [SMALL_STATE(1060)] = 63925,
  [SMALL_STATE(1061)] = 63947,
  [SMALL_STATE(1062)] = 63969,
  [SMALL_STATE(1063)] = 63991,
  [SMALL_STATE(1064)] = 64013,
  [SMALL_STATE(1065)] = 64035,
  [SMALL_STATE(1066)] = 64055,
  [SMALL_STATE(1067)] = 64077,
  [SMALL_STATE(1068)] = 64096,
  [SMALL_STATE(1069)] = 64115,
  [SMALL_STATE(1070)] = 64136,
  [SMALL_STATE(1071)] = 64155,
  [SMALL_STATE(1072)] = 64174,
  [SMALL_STATE(1073)] = 64195,
  [SMALL_STATE(1074)] = 64216,
  [SMALL_STATE(1075)] = 64239,
  [SMALL_STATE(1076)] = 64262,
  [SMALL_STATE(1077)] = 64281,
  [SMALL_STATE(1078)] = 64300,
  [SMALL_STATE(1079)] = 64319,
  [SMALL_STATE(1080)] = 64340,
  [SMALL_STATE(1081)] = 64361,
  [SMALL_STATE(1082)] = 64380,
  [SMALL_STATE(1083)] = 64401,
  [SMALL_STATE(1084)] = 64424,
  [SMALL_STATE(1085)] = 64445,
  [SMALL_STATE(1086)] = 64468,
  [SMALL_STATE(1087)] = 64489,
  [SMALL_STATE(1088)] = 64512,
  [SMALL_STATE(1089)] = 64531,
  [SMALL_STATE(1090)] = 64552,
  [SMALL_STATE(1091)] = 64575,
  [SMALL_STATE(1092)] = 64593,
  [SMALL_STATE(1093)] = 64613,
  [SMALL_STATE(1094)] = 64629,
  [SMALL_STATE(1095)] = 64647,
  [SMALL_STATE(1096)] = 64667,
  [SMALL_STATE(1097)] = 64681,
  [SMALL_STATE(1098)] = 64699,
  [SMALL_STATE(1099)] = 64717,
  [SMALL_STATE(1100)] = 64735,
  [SMALL_STATE(1101)] = 64751,
  [SMALL_STATE(1102)] = 64771,
  [SMALL_STATE(1103)] = 64789,
  [SMALL_STATE(1104)] = 64809,
  [SMALL_STATE(1105)] = 64829,
  [SMALL_STATE(1106)] = 64847,
  [SMALL_STATE(1107)] = 64865,
  [SMALL_STATE(1108)] = 64885,
  [SMALL_STATE(1109)] = 64905,
  [SMALL_STATE(1110)] = 64921,
  [SMALL_STATE(1111)] = 64941,
  [SMALL_STATE(1112)] = 64961,
  [SMALL_STATE(1113)] = 64979,
  [SMALL_STATE(1114)] = 64997,
  [SMALL_STATE(1115)] = 65017,
  [SMALL_STATE(1116)] = 65037,
  [SMALL_STATE(1117)] = 65055,
  [SMALL_STATE(1118)] = 65075,
  [SMALL_STATE(1119)] = 65093,
  [SMALL_STATE(1120)] = 65111,
  [SMALL_STATE(1121)] = 65131,
  [SMALL_STATE(1122)] = 65149,
  [SMALL_STATE(1123)] = 65167,
  [SMALL_STATE(1124)] = 65187,
  [SMALL_STATE(1125)] = 65205,
  [SMALL_STATE(1126)] = 65225,
  [SMALL_STATE(1127)] = 65243,
  [SMALL_STATE(1128)] = 65261,
  [SMALL_STATE(1129)] = 65279,
  [SMALL_STATE(1130)] = 65293,
  [SMALL_STATE(1131)] = 65311,
  [SMALL_STATE(1132)] = 65331,
  [SMALL_STATE(1133)] = 65349,
  [SMALL_STATE(1134)] = 65367,
  [SMALL_STATE(1135)] = 65383,
  [SMALL_STATE(1136)] = 65401,
  [SMALL_STATE(1137)] = 65417,
  [SMALL_STATE(1138)] = 65435,
  [SMALL_STATE(1139)] = 65453,
  [SMALL_STATE(1140)] = 65469,
  [SMALL_STATE(1141)] = 65487,
  [SMALL_STATE(1142)] = 65505,
  [SMALL_STATE(1143)] = 65525,
  [SMALL_STATE(1144)] = 65542,
  [SMALL_STATE(1145)] = 65559,
  [SMALL_STATE(1146)] = 65576,
  [SMALL_STATE(1147)] = 65593,
  [SMALL_STATE(1148)] = 65610,
  [SMALL_STATE(1149)] = 65627,
  [SMALL_STATE(1150)] = 65644,
  [SMALL_STATE(1151)] = 65661,
  [SMALL_STATE(1152)] = 65674,
  [SMALL_STATE(1153)] = 65691,
  [SMALL_STATE(1154)] = 65704,
  [SMALL_STATE(1155)] = 65721,
  [SMALL_STATE(1156)] = 65738,
  [SMALL_STATE(1157)] = 65755,
  [SMALL_STATE(1158)] = 65772,
  [SMALL_STATE(1159)] = 65785,
  [SMALL_STATE(1160)] = 65802,
  [SMALL_STATE(1161)] = 65819,
  [SMALL_STATE(1162)] = 65836,
  [SMALL_STATE(1163)] = 65853,
  [SMALL_STATE(1164)] = 65866,
  [SMALL_STATE(1165)] = 65883,
  [SMALL_STATE(1166)] = 65900,
  [SMALL_STATE(1167)] = 65917,
  [SMALL_STATE(1168)] = 65934,
  [SMALL_STATE(1169)] = 65951,
  [SMALL_STATE(1170)] = 65968,
  [SMALL_STATE(1171)] = 65985,
  [SMALL_STATE(1172)] = 66002,
  [SMALL_STATE(1173)] = 66019,
  [SMALL_STATE(1174)] = 66036,
  [SMALL_STATE(1175)] = 66051,
  [SMALL_STATE(1176)] = 66068,
  [SMALL_STATE(1177)] = 66081,
  [SMALL_STATE(1178)] = 66098,
  [SMALL_STATE(1179)] = 66115,
  [SMALL_STATE(1180)] = 66132,
  [SMALL_STATE(1181)] = 66149,
  [SMALL_STATE(1182)] = 66166,
  [SMALL_STATE(1183)] = 66183,
  [SMALL_STATE(1184)] = 66200,
  [SMALL_STATE(1185)] = 66217,
  [SMALL_STATE(1186)] = 66234,
  [SMALL_STATE(1187)] = 66251,
  [SMALL_STATE(1188)] = 66268,
  [SMALL_STATE(1189)] = 66285,
  [SMALL_STATE(1190)] = 66298,
  [SMALL_STATE(1191)] = 66315,
  [SMALL_STATE(1192)] = 66332,
  [SMALL_STATE(1193)] = 66349,
  [SMALL_STATE(1194)] = 66362,
  [SMALL_STATE(1195)] = 66375,
  [SMALL_STATE(1196)] = 66392,
  [SMALL_STATE(1197)] = 66409,
  [SMALL_STATE(1198)] = 66426,
  [SMALL_STATE(1199)] = 66443,
  [SMALL_STATE(1200)] = 66460,
  [SMALL_STATE(1201)] = 66473,
  [SMALL_STATE(1202)] = 66486,
  [SMALL_STATE(1203)] = 66503,
  [SMALL_STATE(1204)] = 66516,
  [SMALL_STATE(1205)] = 66531,
  [SMALL_STATE(1206)] = 66546,
  [SMALL_STATE(1207)] = 66563,
  [SMALL_STATE(1208)] = 66580,
  [SMALL_STATE(1209)] = 66597,
  [SMALL_STATE(1210)] = 66614,
  [SMALL_STATE(1211)] = 66631,
  [SMALL_STATE(1212)] = 66648,
  [SMALL_STATE(1213)] = 66665,
  [SMALL_STATE(1214)] = 66682,
  [SMALL_STATE(1215)] = 66699,
  [SMALL_STATE(1216)] = 66714,
  [SMALL_STATE(1217)] = 66731,
  [SMALL_STATE(1218)] = 66744,
  [SMALL_STATE(1219)] = 66761,
  [SMALL_STATE(1220)] = 66774,
  [SMALL_STATE(1221)] = 66791,
  [SMALL_STATE(1222)] = 66804,
  [SMALL_STATE(1223)] = 66821,
  [SMALL_STATE(1224)] = 66838,
  [SMALL_STATE(1225)] = 66855,
  [SMALL_STATE(1226)] = 66872,
  [SMALL_STATE(1227)] = 66889,
  [SMALL_STATE(1228)] = 66906,
  [SMALL_STATE(1229)] = 66921,
  [SMALL_STATE(1230)] = 66938,
  [SMALL_STATE(1231)] = 66955,
  [SMALL_STATE(1232)] = 66972,
  [SMALL_STATE(1233)] = 66989,
  [SMALL_STATE(1234)] = 67006,
  [SMALL_STATE(1235)] = 67019,
  [SMALL_STATE(1236)] = 67036,
  [SMALL_STATE(1237)] = 67053,
  [SMALL_STATE(1238)] = 67070,
  [SMALL_STATE(1239)] = 67087,
  [SMALL_STATE(1240)] = 67104,
  [SMALL_STATE(1241)] = 67117,
  [SMALL_STATE(1242)] = 67134,
  [SMALL_STATE(1243)] = 67151,
  [SMALL_STATE(1244)] = 67164,
  [SMALL_STATE(1245)] = 67179,
  [SMALL_STATE(1246)] = 67196,
  [SMALL_STATE(1247)] = 67209,
  [SMALL_STATE(1248)] = 67226,
  [SMALL_STATE(1249)] = 67243,
  [SMALL_STATE(1250)] = 67260,
  [SMALL_STATE(1251)] = 67277,
  [SMALL_STATE(1252)] = 67294,
  [SMALL_STATE(1253)] = 67311,
  [SMALL_STATE(1254)] = 67328,
  [SMALL_STATE(1255)] = 67341,
  [SMALL_STATE(1256)] = 67356,
  [SMALL_STATE(1257)] = 67373,
  [SMALL_STATE(1258)] = 67390,
  [SMALL_STATE(1259)] = 67403,
  [SMALL_STATE(1260)] = 67416,
  [SMALL_STATE(1261)] = 67433,
  [SMALL_STATE(1262)] = 67446,
  [SMALL_STATE(1263)] = 67463,
  [SMALL_STATE(1264)] = 67480,
  [SMALL_STATE(1265)] = 67497,
  [SMALL_STATE(1266)] = 67514,
  [SMALL_STATE(1267)] = 67531,
  [SMALL_STATE(1268)] = 67548,
  [SMALL_STATE(1269)] = 67565,
  [SMALL_STATE(1270)] = 67582,
  [SMALL_STATE(1271)] = 67599,
  [SMALL_STATE(1272)] = 67616,
  [SMALL_STATE(1273)] = 67633,
  [SMALL_STATE(1274)] = 67650,
  [SMALL_STATE(1275)] = 67667,
  [SMALL_STATE(1276)] = 67684,
  [SMALL_STATE(1277)] = 67701,
  [SMALL_STATE(1278)] = 67714,
  [SMALL_STATE(1279)] = 67731,
  [SMALL_STATE(1280)] = 67748,
  [SMALL_STATE(1281)] = 67761,
  [SMALL_STATE(1282)] = 67774,
  [SMALL_STATE(1283)] = 67787,
  [SMALL_STATE(1284)] = 67804,
  [SMALL_STATE(1285)] = 67821,
  [SMALL_STATE(1286)] = 67838,
  [SMALL_STATE(1287)] = 67855,
  [SMALL_STATE(1288)] = 67872,
  [SMALL_STATE(1289)] = 67889,
  [SMALL_STATE(1290)] = 67906,
  [SMALL_STATE(1291)] = 67923,
  [SMALL_STATE(1292)] = 67936,
  [SMALL_STATE(1293)] = 67953,
  [SMALL_STATE(1294)] = 67970,
  [SMALL_STATE(1295)] = 67987,
  [SMALL_STATE(1296)] = 68004,
  [SMALL_STATE(1297)] = 68021,
  [SMALL_STATE(1298)] = 68038,
  [SMALL_STATE(1299)] = 68055,
  [SMALL_STATE(1300)] = 68072,
  [SMALL_STATE(1301)] = 68089,
  [SMALL_STATE(1302)] = 68106,
  [SMALL_STATE(1303)] = 68123,
  [SMALL_STATE(1304)] = 68140,
  [SMALL_STATE(1305)] = 68153,
  [SMALL_STATE(1306)] = 68170,
  [SMALL_STATE(1307)] = 68187,
  [SMALL_STATE(1308)] = 68204,
  [SMALL_STATE(1309)] = 68218,
  [SMALL_STATE(1310)] = 68230,
  [SMALL_STATE(1311)] = 68244,
  [SMALL_STATE(1312)] = 68256,
  [SMALL_STATE(1313)] = 68270,
  [SMALL_STATE(1314)] = 68282,
  [SMALL_STATE(1315)] = 68294,
  [SMALL_STATE(1316)] = 68306,
  [SMALL_STATE(1317)] = 68318,
  [SMALL_STATE(1318)] = 68332,
  [SMALL_STATE(1319)] = 68344,
  [SMALL_STATE(1320)] = 68356,
  [SMALL_STATE(1321)] = 68368,
  [SMALL_STATE(1322)] = 68380,
  [SMALL_STATE(1323)] = 68392,
  [SMALL_STATE(1324)] = 68406,
  [SMALL_STATE(1325)] = 68418,
  [SMALL_STATE(1326)] = 68430,
  [SMALL_STATE(1327)] = 68444,
  [SMALL_STATE(1328)] = 68458,
  [SMALL_STATE(1329)] = 68472,
  [SMALL_STATE(1330)] = 68486,
  [SMALL_STATE(1331)] = 68500,
  [SMALL_STATE(1332)] = 68512,
  [SMALL_STATE(1333)] = 68524,
  [SMALL_STATE(1334)] = 68538,
  [SMALL_STATE(1335)] = 68552,
  [SMALL_STATE(1336)] = 68566,
  [SMALL_STATE(1337)] = 68580,
  [SMALL_STATE(1338)] = 68594,
  [SMALL_STATE(1339)] = 68608,
  [SMALL_STATE(1340)] = 68622,
  [SMALL_STATE(1341)] = 68634,
  [SMALL_STATE(1342)] = 68648,
  [SMALL_STATE(1343)] = 68662,
  [SMALL_STATE(1344)] = 68674,
  [SMALL_STATE(1345)] = 68688,
  [SMALL_STATE(1346)] = 68702,
  [SMALL_STATE(1347)] = 68714,
  [SMALL_STATE(1348)] = 68728,
  [SMALL_STATE(1349)] = 68740,
  [SMALL_STATE(1350)] = 68754,
  [SMALL_STATE(1351)] = 68766,
  [SMALL_STATE(1352)] = 68780,
  [SMALL_STATE(1353)] = 68794,
  [SMALL_STATE(1354)] = 68808,
  [SMALL_STATE(1355)] = 68822,
  [SMALL_STATE(1356)] = 68836,
  [SMALL_STATE(1357)] = 68850,
  [SMALL_STATE(1358)] = 68864,
  [SMALL_STATE(1359)] = 68878,
  [SMALL_STATE(1360)] = 68892,
  [SMALL_STATE(1361)] = 68904,
  [SMALL_STATE(1362)] = 68916,
  [SMALL_STATE(1363)] = 68930,
  [SMALL_STATE(1364)] = 68944,
  [SMALL_STATE(1365)] = 68958,
  [SMALL_STATE(1366)] = 68972,
  [SMALL_STATE(1367)] = 68986,
  [SMALL_STATE(1368)] = 69000,
  [SMALL_STATE(1369)] = 69014,
  [SMALL_STATE(1370)] = 69028,
  [SMALL_STATE(1371)] = 69040,
  [SMALL_STATE(1372)] = 69054,
  [SMALL_STATE(1373)] = 69066,
  [SMALL_STATE(1374)] = 69080,
  [SMALL_STATE(1375)] = 69094,
  [SMALL_STATE(1376)] = 69108,
  [SMALL_STATE(1377)] = 69122,
  [SMALL_STATE(1378)] = 69136,
  [SMALL_STATE(1379)] = 69150,
  [SMALL_STATE(1380)] = 69164,
  [SMALL_STATE(1381)] = 69178,
  [SMALL_STATE(1382)] = 69192,
  [SMALL_STATE(1383)] = 69204,
  [SMALL_STATE(1384)] = 69218,
  [SMALL_STATE(1385)] = 69232,
  [SMALL_STATE(1386)] = 69246,
  [SMALL_STATE(1387)] = 69260,
  [SMALL_STATE(1388)] = 69274,
  [SMALL_STATE(1389)] = 69288,
  [SMALL_STATE(1390)] = 69302,
  [SMALL_STATE(1391)] = 69314,
  [SMALL_STATE(1392)] = 69328,
  [SMALL_STATE(1393)] = 69342,
  [SMALL_STATE(1394)] = 69356,
  [SMALL_STATE(1395)] = 69370,
  [SMALL_STATE(1396)] = 69382,
  [SMALL_STATE(1397)] = 69396,
  [SMALL_STATE(1398)] = 69410,
  [SMALL_STATE(1399)] = 69424,
  [SMALL_STATE(1400)] = 69438,
  [SMALL_STATE(1401)] = 69450,
  [SMALL_STATE(1402)] = 69462,
  [SMALL_STATE(1403)] = 69474,
  [SMALL_STATE(1404)] = 69486,
  [SMALL_STATE(1405)] = 69500,
  [SMALL_STATE(1406)] = 69512,
  [SMALL_STATE(1407)] = 69526,
  [SMALL_STATE(1408)] = 69540,
  [SMALL_STATE(1409)] = 69554,
  [SMALL_STATE(1410)] = 69568,
  [SMALL_STATE(1411)] = 69580,
  [SMALL_STATE(1412)] = 69594,
  [SMALL_STATE(1413)] = 69608,
  [SMALL_STATE(1414)] = 69622,
  [SMALL_STATE(1415)] = 69636,
  [SMALL_STATE(1416)] = 69648,
  [SMALL_STATE(1417)] = 69660,
  [SMALL_STATE(1418)] = 69674,
  [SMALL_STATE(1419)] = 69686,
  [SMALL_STATE(1420)] = 69698,
  [SMALL_STATE(1421)] = 69710,
  [SMALL_STATE(1422)] = 69722,
  [SMALL_STATE(1423)] = 69736,
  [SMALL_STATE(1424)] = 69748,
  [SMALL_STATE(1425)] = 69760,
  [SMALL_STATE(1426)] = 69772,
  [SMALL_STATE(1427)] = 69786,
  [SMALL_STATE(1428)] = 69800,
  [SMALL_STATE(1429)] = 69812,
  [SMALL_STATE(1430)] = 69824,
  [SMALL_STATE(1431)] = 69838,
  [SMALL_STATE(1432)] = 69852,
  [SMALL_STATE(1433)] = 69864,
  [SMALL_STATE(1434)] = 69876,
  [SMALL_STATE(1435)] = 69890,
  [SMALL_STATE(1436)] = 69904,
  [SMALL_STATE(1437)] = 69916,
  [SMALL_STATE(1438)] = 69928,
  [SMALL_STATE(1439)] = 69940,
  [SMALL_STATE(1440)] = 69954,
  [SMALL_STATE(1441)] = 69968,
  [SMALL_STATE(1442)] = 69982,
  [SMALL_STATE(1443)] = 69996,
  [SMALL_STATE(1444)] = 70008,
  [SMALL_STATE(1445)] = 70020,
  [SMALL_STATE(1446)] = 70032,
  [SMALL_STATE(1447)] = 70044,
  [SMALL_STATE(1448)] = 70055,
  [SMALL_STATE(1449)] = 70066,
  [SMALL_STATE(1450)] = 70077,
  [SMALL_STATE(1451)] = 70088,
  [SMALL_STATE(1452)] = 70099,
  [SMALL_STATE(1453)] = 70110,
  [SMALL_STATE(1454)] = 70121,
  [SMALL_STATE(1455)] = 70132,
  [SMALL_STATE(1456)] = 70143,
  [SMALL_STATE(1457)] = 70154,
  [SMALL_STATE(1458)] = 70165,
  [SMALL_STATE(1459)] = 70176,
  [SMALL_STATE(1460)] = 70187,
  [SMALL_STATE(1461)] = 70198,
  [SMALL_STATE(1462)] = 70209,
  [SMALL_STATE(1463)] = 70220,
  [SMALL_STATE(1464)] = 70231,
  [SMALL_STATE(1465)] = 70242,
  [SMALL_STATE(1466)] = 70253,
  [SMALL_STATE(1467)] = 70264,
  [SMALL_STATE(1468)] = 70275,
  [SMALL_STATE(1469)] = 70286,
  [SMALL_STATE(1470)] = 70297,
  [SMALL_STATE(1471)] = 70308,
  [SMALL_STATE(1472)] = 70319,
  [SMALL_STATE(1473)] = 70330,
  [SMALL_STATE(1474)] = 70341,
  [SMALL_STATE(1475)] = 70352,
  [SMALL_STATE(1476)] = 70363,
  [SMALL_STATE(1477)] = 70374,
  [SMALL_STATE(1478)] = 70385,
  [SMALL_STATE(1479)] = 70396,
  [SMALL_STATE(1480)] = 70407,
  [SMALL_STATE(1481)] = 70418,
  [SMALL_STATE(1482)] = 70429,
  [SMALL_STATE(1483)] = 70440,
  [SMALL_STATE(1484)] = 70451,
  [SMALL_STATE(1485)] = 70462,
  [SMALL_STATE(1486)] = 70473,
  [SMALL_STATE(1487)] = 70484,
  [SMALL_STATE(1488)] = 70495,
  [SMALL_STATE(1489)] = 70506,
  [SMALL_STATE(1490)] = 70517,
  [SMALL_STATE(1491)] = 70528,
  [SMALL_STATE(1492)] = 70539,
  [SMALL_STATE(1493)] = 70550,
  [SMALL_STATE(1494)] = 70561,
  [SMALL_STATE(1495)] = 70572,
  [SMALL_STATE(1496)] = 70583,
  [SMALL_STATE(1497)] = 70594,
  [SMALL_STATE(1498)] = 70605,
  [SMALL_STATE(1499)] = 70616,
  [SMALL_STATE(1500)] = 70627,
  [SMALL_STATE(1501)] = 70638,
  [SMALL_STATE(1502)] = 70649,
  [SMALL_STATE(1503)] = 70660,
  [SMALL_STATE(1504)] = 70671,
  [SMALL_STATE(1505)] = 70682,
  [SMALL_STATE(1506)] = 70693,
  [SMALL_STATE(1507)] = 70704,
  [SMALL_STATE(1508)] = 70715,
  [SMALL_STATE(1509)] = 70726,
  [SMALL_STATE(1510)] = 70737,
  [SMALL_STATE(1511)] = 70748,
  [SMALL_STATE(1512)] = 70759,
  [SMALL_STATE(1513)] = 70770,
  [SMALL_STATE(1514)] = 70781,
  [SMALL_STATE(1515)] = 70792,
  [SMALL_STATE(1516)] = 70803,
  [SMALL_STATE(1517)] = 70814,
  [SMALL_STATE(1518)] = 70825,
  [SMALL_STATE(1519)] = 70836,
  [SMALL_STATE(1520)] = 70847,
  [SMALL_STATE(1521)] = 70858,
  [SMALL_STATE(1522)] = 70869,
  [SMALL_STATE(1523)] = 70880,
  [SMALL_STATE(1524)] = 70891,
  [SMALL_STATE(1525)] = 70902,
  [SMALL_STATE(1526)] = 70913,
  [SMALL_STATE(1527)] = 70924,
  [SMALL_STATE(1528)] = 70935,
  [SMALL_STATE(1529)] = 70946,
  [SMALL_STATE(1530)] = 70957,
  [SMALL_STATE(1531)] = 70968,
  [SMALL_STATE(1532)] = 70979,
  [SMALL_STATE(1533)] = 70990,
  [SMALL_STATE(1534)] = 71001,
  [SMALL_STATE(1535)] = 71012,
  [SMALL_STATE(1536)] = 71023,
  [SMALL_STATE(1537)] = 71034,
  [SMALL_STATE(1538)] = 71045,
  [SMALL_STATE(1539)] = 71056,
  [SMALL_STATE(1540)] = 71067,
  [SMALL_STATE(1541)] = 71078,
  [SMALL_STATE(1542)] = 71089,
  [SMALL_STATE(1543)] = 71100,
  [SMALL_STATE(1544)] = 71111,
  [SMALL_STATE(1545)] = 71122,
  [SMALL_STATE(1546)] = 71133,
  [SMALL_STATE(1547)] = 71144,
  [SMALL_STATE(1548)] = 71155,
  [SMALL_STATE(1549)] = 71166,
  [SMALL_STATE(1550)] = 71177,
  [SMALL_STATE(1551)] = 71188,
  [SMALL_STATE(1552)] = 71199,
  [SMALL_STATE(1553)] = 71210,
  [SMALL_STATE(1554)] = 71221,
  [SMALL_STATE(1555)] = 71232,
  [SMALL_STATE(1556)] = 71243,
  [SMALL_STATE(1557)] = 71254,
  [SMALL_STATE(1558)] = 71265,
  [SMALL_STATE(1559)] = 71276,
  [SMALL_STATE(1560)] = 71287,
  [SMALL_STATE(1561)] = 71298,
  [SMALL_STATE(1562)] = 71309,
  [SMALL_STATE(1563)] = 71320,
  [SMALL_STATE(1564)] = 71331,
  [SMALL_STATE(1565)] = 71342,
  [SMALL_STATE(1566)] = 71353,
  [SMALL_STATE(1567)] = 71364,
  [SMALL_STATE(1568)] = 71375,
  [SMALL_STATE(1569)] = 71386,
  [SMALL_STATE(1570)] = 71397,
  [SMALL_STATE(1571)] = 71408,
  [SMALL_STATE(1572)] = 71419,
  [SMALL_STATE(1573)] = 71430,
  [SMALL_STATE(1574)] = 71441,
  [SMALL_STATE(1575)] = 71452,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1174),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(70),
  [71] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1326),
  [74] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1330),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1035),
  [80] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1336),
  [83] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1554),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(201),
  [89] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(232),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(329),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1117),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1345),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(18),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(19),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(183),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(628),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(666),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(608),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(350),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1083),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1531),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1062),
  [131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(97),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(28),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(28),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(29),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(30),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2),
  [150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2),
  [152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(70),
  [155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1554),
  [158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(201),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(232),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(329),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1335),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(18),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(19),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(183),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(628),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(666),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(608),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(350),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1062),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(97),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(28),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(28),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(29),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(30),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(70),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(1554),
  [219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(201),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(232),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(329),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(1335),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(18),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(19),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(183),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(628),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(666),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(608),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(350),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(1062),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(97),
  [258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(28),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(28),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(29),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(30),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 1, .production_id = 1),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record, 1, .production_id = 1),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 20),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 20),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 1),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 1),
  [332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_access, 3, .production_id = 19),
  [334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_access, 3, .production_id = 19),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 1),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 1),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_panic, 1),
  [354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_panic, 1),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, .production_id = 44),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, .production_id = 44),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, .production_id = 30),
  [372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, .production_id = 30),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, .production_id = 7),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, .production_id = 7),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_name, 1),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_name, 1),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remote_constructor_name, 3, .production_id = 21),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_remote_constructor_name, 3, .production_id = 21),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_unit, 1),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_unit, 1),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_function_expression, 1),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [425] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1376),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(66),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1470),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(191),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(292),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(331),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1373),
  [451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(326),
  [454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(325),
  [457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(185),
  [460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(625),
  [463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(650),
  [466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(619),
  [469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(343),
  [472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1050),
  [475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(353),
  [478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(130),
  [481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(130),
  [484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(73),
  [487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(134),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 2),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 2),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 7, .production_id = 66),
  [528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 7, .production_id = 66),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 4),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 4),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update, 7, .production_id = 70),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_update, 7, .production_id = 70),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 6),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 6),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_record_expression, 1),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 2, .production_id = 8),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record, 2, .production_id = 8),
  [550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 5, .production_id = 39),
  [552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 5, .production_id = 39),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 5),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 5),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 2),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 2),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 4),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 4),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert, 2, .production_id = 4),
  [612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert, 2, .production_id = 4),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use, 3, .production_id = 16),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use, 3, .production_id = 16),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment, 4, .production_id = 49),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment, 4, .production_id = 49),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_negation, 2),
  [648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_negation, 2),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 4, .production_id = 13),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 4, .production_id = 13),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_panic, 4, .production_id = 13),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_panic, 4, .production_id = 13),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 6, .production_id = 55),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 6, .production_id = 55),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_panic, 3, .production_id = 13),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_panic, 3, .production_id = 13),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 3, .production_id = 13),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 3, .production_id = 13),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 18),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 18),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use, 4, .production_id = 35),
  [692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use, 4, .production_id = 35),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 7, .production_id = 65),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 7, .production_id = 65),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5, .production_id = 38),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5, .production_id = 38),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_integer, 1), REDUCE(sym_integer, 2),
  [713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_integer, 1), REDUCE(sym_integer, 2),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_negation, 2),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_negation, 2),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 3),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 3),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment, 3, .production_id = 33),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment, 3, .production_id = 33),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 5),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 5),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [770] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1407),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_subjects, 3), SHIFT(63),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_subjects, 2), SHIFT(63),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1240] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1435),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 3, .production_id = 58),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause, 3, .production_id = 58),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 4, .production_id = 68),
  [1270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause, 4, .production_id = 68),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 1),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [1284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1519),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1),
  [1302] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1389),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 1),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 1),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__maybe_record_expression, 1),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record, 1, .production_id = 1),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record, 1, .production_id = 1),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remote_type_identifier, 3, .production_id = 21),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_remote_type_identifier, 3, .production_id = 21),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, .production_id = 1),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, .production_id = 1),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__maybe_tuple_expression, 1),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 2, .production_id = 2),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 2, .production_id = 2),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_identifier, 1),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_identifier, 1),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 3),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 3),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 3),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 3),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_type, 2),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_type, 2),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, .production_id = 23),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 4, .production_id = 23),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2),
  [1430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1447),
  [1433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(618),
  [1436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(624),
  [1439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1139),
  [1442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1055),
  [1445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1065),
  [1448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1020),
  [1451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1020),
  [1454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(809),
  [1457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(995),
  [1460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1011),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 2, .production_id = 10),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 2, .production_id = 10),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 12),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 12),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_var, 1),
  [1485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_var, 1),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_type, 3),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_type, 3),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 2),
  [1497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 2),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 2),
  [1501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 2),
  [1503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_value, 1),
  [1505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_value, 1),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 2),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 2),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 36),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 36),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment_options, 3),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clauses, 1),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 5),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 5),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment_options, 2),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment_options, 3),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment_options, 2),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 5),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 5),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment_options, 3),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 4),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 4),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment_options, 2),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 4),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 4),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_group, 5, .production_id = 22),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_group, 5, .production_id = 22),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 4, .production_id = 26),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 4, .production_id = 26),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 5, .production_id = 50),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 5, .production_id = 50),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_group, 4, .production_id = 22),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_group, 4, .production_id = 22),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_arguments, 4),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_arguments, 4),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, .production_id = 56),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, .production_id = 56),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_arguments, 3),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_arguments, 3),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, .production_id = 53),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 6, .production_id = 53),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 5),
  [1619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 5),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 42),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 42),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 12),
  [1635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 12),
  [1637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 9),
  [1639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 9),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5),
  [1643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5),
  [1645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, .production_id = 24),
  [1647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 4, .production_id = 24),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 54),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 54),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [1657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 7, .production_id = 69),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 7, .production_id = 69),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 5),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 5),
  [1667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 6),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 6),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 4),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 4),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 5),
  [1677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 5),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 5),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 5),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 5),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 5),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 3),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 3),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 4),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 4),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 4),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 4),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 7),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 7),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 4),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 4),
  [1707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 4),
  [1709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 4),
  [1711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 2),
  [1713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 2),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_seq, 1),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_seq, 1),
  [1723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_field_access, 3, .production_id = 20),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_field_access, 3, .production_id = 20),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 6, .production_id = 61),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 6, .production_id = 61),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, .production_id = 36),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, .production_id = 36),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 3),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 3),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, .production_id = 62),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, .production_id = 62),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 3),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 3),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 3),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 3),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 6),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 6),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 7, .production_id = 42),
  [1767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 7, .production_id = 42),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record, 2, .production_id = 8),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record, 2, .production_id = 8),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 2),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 2),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 2),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 2),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hole, 1),
  [1785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_hole, 1),
  [1787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_assert, 3, .production_id = 15),
  [1789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_assert, 3, .production_id = 15),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 64),
  [1793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 64),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard, 1),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard, 1),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 5, .production_id = 37),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 5, .production_id = 37),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 2, .production_id = 4),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 2, .production_id = 4),
  [1815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_type, 4),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_type, 4),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_arguments, 5),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_arguments, 5),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function, 9, .production_id = 75),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_function, 9, .production_id = 75),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 9, .production_id = 74),
  [1833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 9, .production_id = 74),
  [1835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_body, 2),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_function_body, 2),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 8, .production_id = 72),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 8, .production_id = 72),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 6),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 6),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, .production_id = 8),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2, .production_id = 8),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 8, .production_id = 62),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 8, .production_id = 62),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function, 8, .production_id = 73),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_function, 8, .production_id = 73),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_pattern, 2, .production_id = 6),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 2, .production_id = 6),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_patterns, 2),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_patterns, 2),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_patterns, 3),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_patterns, 3),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_pattern, 3, .production_id = 45),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 3, .production_id = 45),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignments, 2),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignments, 3),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1977] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1404),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_subjects, 1),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_argument, 3, .production_id = 51),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, .production_id = 3),
  [2031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, .production_id = 51),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2),
  [2179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1414),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1399),
  [2185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1046),
  [2188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1413),
  [2191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1347),
  [2194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1391),
  [2197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1087),
  [2200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1537),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 1, .production_id = 1),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_binary_expression, 3, .production_id = 18),
  [2289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_binary_expression, 3, .production_id = 18),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_tuple_access, 3, .production_id = 19),
  [2293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_tuple_access, 3, .production_id = 19),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_unit, 3),
  [2297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_unit, 3),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_expression, 1, .production_id = 5),
  [2303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_expression, 1, .production_id = 5),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_unit, 1, .production_id = 57),
  [2307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_unit, 1, .production_id = 57),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constant_value, 1), REDUCE(sym__case_clause_guard_unit, 1),
  [2314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constant_value, 1), REDUCE(sym__case_clause_guard_unit, 1),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [2329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expression, 1, .production_id = 5),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, .production_id = 46),
  [2337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1511),
  [2340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 6),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 3),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 4),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, .production_id = 47),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 2, .production_id = 8),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, .production_id = 31),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 6, .production_id = 59),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, .production_id = 46),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 6, .production_id = 47),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_guard, 2),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 4),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 5),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 5),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, .production_id = 31),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_binary_expression, 3, .production_id = 18),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, .production_id = 59),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 3),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, .production_id = 47),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 2),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, .production_id = 31),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 2),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 3, .production_id = 32),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expression, 1),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 31),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(238),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2),
  [2533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1096),
  [2536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1054),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type, 1, .production_id = 1),
  [2571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 1, .production_id = 6),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 45), SHIFT_REPEAT(680),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 45),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructors, 1),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 2, .production_id = 45),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2),
  [2594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2), SHIFT_REPEAT(134),
  [2597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 45), SHIFT_REPEAT(703),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern_tail, 1),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [2638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_arguments_repeat1, 2), SHIFT_REPEAT(622),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_pattern_arguments_repeat1, 2),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_bit_string_segment_options_repeat1, 2),
  [2647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_bit_string_segment_options_repeat1, 2), SHIFT_REPEAT(610),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_patterns_repeat1, 2),
  [2654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_patterns_repeat1, 2), SHIFT_REPEAT(630),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [2661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_tuple_repeat1, 2), SHIFT_REPEAT(800),
  [2664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_tuple_repeat1, 2),
  [2666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_arguments, 3),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_arguments, 2),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment_options, 1),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_bit_string_segment_options_repeat1, 2),
  [2686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_bit_string_segment_options_repeat1, 2), SHIFT_REPEAT(613),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment_options, 1),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1, .production_id = 1),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignment, 1, .production_id = 6),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_patterns, 1),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 1, .production_id = 11),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 1, .production_id = 29),
  [2717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_annotation, 2, .production_id = 25),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment_options, 1),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameter, 1, .production_id = 11),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_bit_string_segment_options_repeat1, 2),
  [2743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_bit_string_segment_options_repeat1, 2), SHIFT_REPEAT(611),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bit_string_segment_option, 1),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 2),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_bit_string_repeat1, 2), SHIFT_REPEAT(327),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_bit_string_repeat1, 2),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 4),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 3),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unqualified_imports_repeat1, 2),
  [2803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unqualified_imports_repeat1, 2), SHIFT_REPEAT(1036),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignments, 1),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(143),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [2839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(1417),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_type, 4, .production_id = 64),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__constant_bit_string_repeat1, 2), SHIFT_REPEAT(788),
  [2857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__constant_bit_string_repeat1, 2),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_arguments_repeat1, 2), SHIFT_REPEAT(830),
  [2884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructor_arguments_repeat1, 2),
  [2886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type, 2, .production_id = 8),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [2900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 3),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_argument, 1, .production_id = 34),
  [2904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_function_parameters_repeat1, 2), SHIFT_REPEAT(1029),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_parameters_repeat1, 2),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__labeled_name_param, 2, .production_id = 41),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__labeled_discard_param, 2, .production_id = 41),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 1, .production_id = 1),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment, 1, .production_id = 3),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_assignments_repeat1, 2), SHIFT_REPEAT(636),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_assignments_repeat1, 2),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string_segment_option_size, 4),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bit_string_segment_option, 4),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_type, 3, .production_id = 54),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_external_function_parameters_repeat1, 2), SHIFT_REPEAT(847),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_external_function_parameters_repeat1, 2),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 2, .production_id = 52),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_subjects, 2),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string_segment_option_size, 4),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_arguments, 1),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 5),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment, 1, .production_id = 3),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 6),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment, 1, .production_id = 14),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_argument, 3, .production_id = 60),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_update_arguments_repeat1, 2), SHIFT_REPEAT(1236),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_update_arguments_repeat1, 2),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [3114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_bit_string_repeat1, 2), SHIFT_REPEAT(665),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_bit_string_repeat1, 2),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string_segment_option_size, 4),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__discard_param, 1, .production_id = 1),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_param, 1, .production_id = 1),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [3145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_arguments_repeat1, 2), SHIFT_REPEAT(717),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_arguments_repeat1, 2),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [3152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_type_arguments_repeat1, 2), SHIFT_REPEAT(859),
  [3155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_type_arguments_repeat1, 2),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [3159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_record_arguments_repeat1, 2), SHIFT_REPEAT(726),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_record_arguments_repeat1, 2),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [3168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 4),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2), SHIFT_REPEAT(972),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2),
  [3189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_tuple_type_repeat1, 2), SHIFT_REPEAT(909),
  [3192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_tuple_type_repeat1, 2),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [3200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(855),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 5),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(839),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_argument, 3, .production_id = 51),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 2),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 4),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 4, .production_id = 71),
  [3226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_argument, 3, .production_id = 51),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_argument, 1),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 5),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [3256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hole, 1),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameter, 3, .production_id = 67),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment, 3, .production_id = 48),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [3280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_value, 3, .production_id = 51),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 2),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameter, 1, .production_id = 43),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_spread, 1),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [3320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_value, 1),
  [3322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, .production_id = 28),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, .production_id = 8),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, .production_id = 40),
  [3328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 4),
  [3330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_argument, 1, .production_id = 3),
  [3332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 3),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_argument, 1, .production_id = 3),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameter, 2, .production_id = 28),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment, 3, .production_id = 27),
  [3344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment, 3, .production_id = 27),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 3),
  [3350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 3, .production_id = 63),
  [3352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 1),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 5),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignment, 2, .production_id = 17),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_type_annotation, 2, .production_id = 25),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [3394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 2),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [3398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 3),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 3),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [3426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern_tail, 2),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 2),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [3494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 4),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target, 1),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 2),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3512] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [3548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 5),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 5),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_spread, 2),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 3),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [3604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 5),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 4),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 4),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_gleam_external_scanner_create(void);
void tree_sitter_gleam_external_scanner_destroy(void *);
bool tree_sitter_gleam_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_gleam_external_scanner_serialize(void *, char *);
void tree_sitter_gleam_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_gleam(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_gleam_external_scanner_create,
      tree_sitter_gleam_external_scanner_destroy,
      tree_sitter_gleam_external_scanner_scan,
      tree_sitter_gleam_external_scanner_serialize,
      tree_sitter_gleam_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
