#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 827
#define LARGE_STATE_COUNT 314
#define SYMBOL_COUNT 511
#define ALIAS_COUNT 3
#define TOKEN_COUNT 320
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 87

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_pragma = 2,
  anon_sym_PIPE_PIPE = 3,
  anon_sym_DASH = 4,
  anon_sym_solidity = 5,
  aux_sym_pragma_value_token1 = 6,
  sym_solidity_version = 7,
  anon_sym_LT_EQ = 8,
  anon_sym_LT = 9,
  anon_sym_CARET = 10,
  anon_sym_GT = 11,
  anon_sym_GT_EQ = 12,
  anon_sym_TILDE = 13,
  anon_sym_EQ = 14,
  anon_sym_import = 15,
  anon_sym_from = 16,
  anon_sym_STAR = 17,
  anon_sym_LBRACE = 18,
  anon_sym_COMMA = 19,
  anon_sym_RBRACE = 20,
  anon_sym_as = 21,
  anon_sym_type = 22,
  anon_sym_is = 23,
  anon_sym_constant = 24,
  anon_sym_abstract = 25,
  anon_sym_contract = 26,
  anon_sym_error = 27,
  anon_sym_LPAREN = 28,
  anon_sym_RPAREN = 29,
  anon_sym_interface = 30,
  anon_sym_library = 31,
  anon_sym_struct = 32,
  anon_sym_enum = 33,
  anon_sym_event = 34,
  anon_sym_anonymous = 35,
  anon_sym_indexed = 36,
  anon_sym_using = 37,
  anon_sym_for = 38,
  anon_sym_assembly = 39,
  anon_sym_DQUOTEevmasm_DQUOTE = 40,
  anon_sym_COLON = 41,
  sym_yul_leave = 42,
  anon_sym_break = 43,
  anon_sym_continue = 44,
  anon_sym_DOT = 45,
  sym_yul_decimal_number = 46,
  sym_yul_hex_number = 47,
  anon_sym_true = 48,
  anon_sym_false = 49,
  anon_sym_let = 50,
  anon_sym_COLON_EQ = 51,
  anon_sym_if = 52,
  anon_sym_switch = 53,
  anon_sym_default = 54,
  anon_sym_case = 55,
  anon_sym_function = 56,
  anon_sym_DASH_GT = 57,
  anon_sym_stop = 58,
  anon_sym_add = 59,
  anon_sym_sub = 60,
  anon_sym_mul = 61,
  anon_sym_div = 62,
  anon_sym_sdiv = 63,
  anon_sym_mod = 64,
  anon_sym_smod = 65,
  anon_sym_exp = 66,
  anon_sym_not = 67,
  anon_sym_lt = 68,
  anon_sym_gt = 69,
  anon_sym_slt = 70,
  anon_sym_sgt = 71,
  anon_sym_eq = 72,
  anon_sym_iszero = 73,
  anon_sym_and = 74,
  anon_sym_or = 75,
  anon_sym_xor = 76,
  anon_sym_byte = 77,
  anon_sym_shl = 78,
  anon_sym_shr = 79,
  anon_sym_sar = 80,
  anon_sym_addmod = 81,
  anon_sym_mulmod = 82,
  anon_sym_signextend = 83,
  anon_sym_keccak256 = 84,
  anon_sym_pop = 85,
  anon_sym_mload = 86,
  anon_sym_mstore = 87,
  anon_sym_mstore8 = 88,
  anon_sym_sload = 89,
  anon_sym_sstore = 90,
  anon_sym_msize = 91,
  anon_sym_gas = 92,
  anon_sym_address = 93,
  anon_sym_balance = 94,
  anon_sym_selfbalance = 95,
  anon_sym_caller = 96,
  anon_sym_callvalue = 97,
  anon_sym_calldataload = 98,
  anon_sym_calldatasize = 99,
  anon_sym_calldatacopy = 100,
  anon_sym_extcodesize = 101,
  anon_sym_extcodecopy = 102,
  anon_sym_returndatasize = 103,
  anon_sym_returndatacopy = 104,
  anon_sym_extcodehash = 105,
  anon_sym_create = 106,
  anon_sym_create2 = 107,
  anon_sym_call = 108,
  anon_sym_callcode = 109,
  anon_sym_delegatecall = 110,
  anon_sym_staticcall = 111,
  anon_sym_return = 112,
  anon_sym_revert = 113,
  anon_sym_selfdestruct = 114,
  anon_sym_invalid = 115,
  anon_sym_log0 = 116,
  anon_sym_log1 = 117,
  anon_sym_log2 = 118,
  anon_sym_log3 = 119,
  anon_sym_log4 = 120,
  anon_sym_chainid = 121,
  anon_sym_origin = 122,
  anon_sym_gasprice = 123,
  anon_sym_blockhash = 124,
  anon_sym_coinbase = 125,
  anon_sym_timestamp = 126,
  anon_sym_number = 127,
  anon_sym_difficulty = 128,
  anon_sym_gaslimit = 129,
  sym_unchecked = 130,
  anon_sym_memory = 131,
  anon_sym_storage = 132,
  anon_sym_calldata = 133,
  anon_sym_var = 134,
  anon_sym_else = 135,
  anon_sym_while = 136,
  anon_sym_do = 137,
  anon_sym_try = 138,
  anon_sym_returns = 139,
  anon_sym_catch = 140,
  anon_sym_emit = 141,
  anon_sym_public = 142,
  anon_sym_internal = 143,
  anon_sym_private = 144,
  anon_sym_external = 145,
  anon_sym_pure = 146,
  anon_sym_view = 147,
  anon_sym_payable = 148,
  sym_immutable = 149,
  anon_sym_override = 150,
  anon_sym_modifier = 151,
  anon_sym_constructor = 152,
  anon_sym_fallback = 153,
  anon_sym_receive = 154,
  sym_virtual = 155,
  anon_sym_QMARK = 156,
  anon_sym_new = 157,
  anon_sym_LBRACK = 158,
  anon_sym_RBRACK = 159,
  anon_sym_AMP_AMP = 160,
  anon_sym_GT_GT = 161,
  anon_sym_GT_GT_GT = 162,
  anon_sym_LT_LT = 163,
  anon_sym_AMP = 164,
  anon_sym_PIPE = 165,
  anon_sym_PLUS = 166,
  anon_sym_SLASH = 167,
  anon_sym_PERCENT = 168,
  anon_sym_STAR_STAR = 169,
  anon_sym_EQ_EQ = 170,
  anon_sym_BANG_EQ = 171,
  anon_sym_BANG_EQ_EQ = 172,
  anon_sym_BANG = 173,
  anon_sym_delete = 174,
  anon_sym_PLUS_PLUS = 175,
  anon_sym_DASH_DASH = 176,
  anon_sym_PLUS_EQ = 177,
  anon_sym_DASH_EQ = 178,
  anon_sym_STAR_EQ = 179,
  anon_sym_SLASH_EQ = 180,
  anon_sym_PERCENT_EQ = 181,
  anon_sym_CARET_EQ = 182,
  anon_sym_AMP_EQ = 183,
  anon_sym_PIPE_EQ = 184,
  anon_sym_GT_GT_EQ = 185,
  anon_sym_GT_GT_GT_EQ = 186,
  anon_sym_LT_LT_EQ = 187,
  anon_sym_mapping = 188,
  anon_sym_EQ_GT = 189,
  anon_sym_bool = 190,
  anon_sym_string = 191,
  anon_sym_int = 192,
  anon_sym_int8 = 193,
  anon_sym_int16 = 194,
  anon_sym_int24 = 195,
  anon_sym_int32 = 196,
  anon_sym_int40 = 197,
  anon_sym_int48 = 198,
  anon_sym_int56 = 199,
  anon_sym_int64 = 200,
  anon_sym_int72 = 201,
  anon_sym_int80 = 202,
  anon_sym_int88 = 203,
  anon_sym_int96 = 204,
  anon_sym_int104 = 205,
  anon_sym_int112 = 206,
  anon_sym_int120 = 207,
  anon_sym_int128 = 208,
  anon_sym_int136 = 209,
  anon_sym_int144 = 210,
  anon_sym_int152 = 211,
  anon_sym_int160 = 212,
  anon_sym_int168 = 213,
  anon_sym_int176 = 214,
  anon_sym_int184 = 215,
  anon_sym_int192 = 216,
  anon_sym_int200 = 217,
  anon_sym_int208 = 218,
  anon_sym_int216 = 219,
  anon_sym_int224 = 220,
  anon_sym_int232 = 221,
  anon_sym_int240 = 222,
  anon_sym_int248 = 223,
  anon_sym_int256 = 224,
  anon_sym_uint = 225,
  anon_sym_uint8 = 226,
  anon_sym_uint16 = 227,
  anon_sym_uint24 = 228,
  anon_sym_uint32 = 229,
  anon_sym_uint40 = 230,
  anon_sym_uint48 = 231,
  anon_sym_uint56 = 232,
  anon_sym_uint64 = 233,
  anon_sym_uint72 = 234,
  anon_sym_uint80 = 235,
  anon_sym_uint88 = 236,
  anon_sym_uint96 = 237,
  anon_sym_uint104 = 238,
  anon_sym_uint112 = 239,
  anon_sym_uint120 = 240,
  anon_sym_uint128 = 241,
  anon_sym_uint136 = 242,
  anon_sym_uint144 = 243,
  anon_sym_uint152 = 244,
  anon_sym_uint160 = 245,
  anon_sym_uint168 = 246,
  anon_sym_uint176 = 247,
  anon_sym_uint184 = 248,
  anon_sym_uint192 = 249,
  anon_sym_uint200 = 250,
  anon_sym_uint208 = 251,
  anon_sym_uint216 = 252,
  anon_sym_uint224 = 253,
  anon_sym_uint232 = 254,
  anon_sym_uint240 = 255,
  anon_sym_uint248 = 256,
  anon_sym_uint256 = 257,
  anon_sym_bytes = 258,
  anon_sym_bytes1 = 259,
  anon_sym_bytes2 = 260,
  anon_sym_bytes3 = 261,
  anon_sym_bytes4 = 262,
  anon_sym_bytes5 = 263,
  anon_sym_bytes6 = 264,
  anon_sym_bytes7 = 265,
  anon_sym_bytes8 = 266,
  anon_sym_bytes9 = 267,
  anon_sym_bytes10 = 268,
  anon_sym_bytes11 = 269,
  anon_sym_bytes12 = 270,
  anon_sym_bytes13 = 271,
  anon_sym_bytes14 = 272,
  anon_sym_bytes15 = 273,
  anon_sym_bytes16 = 274,
  anon_sym_bytes17 = 275,
  anon_sym_bytes18 = 276,
  anon_sym_bytes19 = 277,
  anon_sym_bytes20 = 278,
  anon_sym_bytes21 = 279,
  anon_sym_bytes22 = 280,
  anon_sym_bytes23 = 281,
  anon_sym_bytes24 = 282,
  anon_sym_bytes25 = 283,
  anon_sym_bytes26 = 284,
  anon_sym_bytes27 = 285,
  anon_sym_bytes28 = 286,
  anon_sym_bytes29 = 287,
  anon_sym_bytes30 = 288,
  anon_sym_bytes31 = 289,
  anon_sym_bytes32 = 290,
  anon_sym_fixed = 291,
  aux_sym__fixed_token1 = 292,
  anon_sym_ufixed = 293,
  aux_sym__ufixed_token1 = 294,
  sym__semicolon = 295,
  aux_sym__decimal_number_token1 = 296,
  aux_sym__decimal_number_token2 = 297,
  aux_sym__hex_number_token1 = 298,
  sym__hex_digit = 299,
  anon_sym_wei = 300,
  anon_sym_szabo = 301,
  anon_sym_finney = 302,
  anon_sym_gwei = 303,
  anon_sym_ether = 304,
  anon_sym_seconds = 305,
  anon_sym_minutes = 306,
  anon_sym_hours = 307,
  anon_sym_days = 308,
  anon_sym_weeks = 309,
  anon_sym_years = 310,
  anon_sym_hex = 311,
  anon_sym_DQUOTE = 312,
  anon_sym__ = 313,
  anon_sym_SQUOTE = 314,
  sym__escape_sequence = 315,
  aux_sym__single_quoted_unicode_char_token1 = 316,
  aux_sym__double_quoted_unicode_char_token1 = 317,
  anon_sym_unicode = 318,
  sym_comment = 319,
  sym_source_file = 320,
  sym__source_unit = 321,
  sym__directive = 322,
  sym_pragma_directive = 323,
  sym_solidity_pragma_token = 324,
  sym_any_pragma_token = 325,
  sym__solidity = 326,
  sym_pragma_value = 327,
  sym__pragma_version_constraint = 328,
  sym_solidity_version_comparison_operator = 329,
  sym_import_directive = 330,
  sym__source_import = 331,
  sym__import_clause = 332,
  sym__from_clause = 333,
  sym__single_import = 334,
  sym__multiple_import = 335,
  sym__import_declaration = 336,
  sym__import_alias = 337,
  sym__declaration = 338,
  sym_user_defined_type_definition = 339,
  sym_constant_variable_declaration = 340,
  sym_contract_declaration = 341,
  sym_error_declaration = 342,
  sym_error_parameter = 343,
  sym_interface_declaration = 344,
  sym_library_declaration = 345,
  sym__class_heritage = 346,
  sym_inheritance_specifier = 347,
  sym_contract_body = 348,
  sym__contract_member = 349,
  sym_struct_declaration = 350,
  sym_struct_member = 351,
  sym_struct_body = 352,
  sym_enum_declaration = 353,
  sym_enum_body = 354,
  sym_event_definition = 355,
  sym__event_parameter_list = 356,
  sym_event_parameter = 357,
  sym_using_directive = 358,
  sym_any_source_type = 359,
  sym__statement = 360,
  sym_assembly_statement = 361,
  sym_assembly_flags = 362,
  sym__yul_statement = 363,
  sym_yul_label = 364,
  sym_yul_break = 365,
  sym_yul_continue = 366,
  sym_yul_identifier = 367,
  sym__yul_expression = 368,
  sym_yul_path = 369,
  sym__yul_literal = 370,
  sym_yul_string_literal = 371,
  sym_yul_boolean = 372,
  sym_yul_block = 373,
  sym_yul_variable_declaration = 374,
  sym__yul_assignment_operator = 375,
  sym_yul_assignment = 376,
  sym_yul_function_call = 377,
  sym_yul_if_statement = 378,
  sym_yul_for_statement = 379,
  sym_yul_switch_statement = 380,
  sym_yul_function_definition = 381,
  sym_yul_evm_builtin = 382,
  sym_block_statement = 383,
  sym_variable_declaration_statement = 384,
  sym_variable_declaration = 385,
  sym_variable_declaration_tuple = 386,
  sym_expression_statement = 387,
  sym_if_statement = 388,
  sym_for_statement = 389,
  sym_while_statement = 390,
  sym_do_while_statement = 391,
  sym_continue_statement = 392,
  sym_break_statement = 393,
  sym_revert_statement = 394,
  sym_try_statement = 395,
  sym_catch_clause = 396,
  sym_return_statement = 397,
  sym_emit_statement = 398,
  sym_state_variable_declaration = 399,
  sym_visibility = 400,
  sym_state_mutability = 401,
  sym_override_specifier = 402,
  sym_modifier_definition = 403,
  sym_constructor_definition = 404,
  sym_fallback_receive_definition = 405,
  sym_function_definition = 406,
  sym_return_type_definition = 407,
  sym_modifier_invocation = 408,
  sym__call_arguments = 409,
  sym_call_argument = 410,
  sym_call_struct_argument = 411,
  sym_function_body = 412,
  sym__expression = 413,
  sym__primary_expression = 414,
  sym_type_cast_expression = 415,
  sym_ternary_expression = 416,
  sym_new_expression = 417,
  sym_tuple_expression = 418,
  sym_inline_array_expression = 419,
  sym_binary_expression = 420,
  sym_unary_expression = 421,
  sym_update_expression = 422,
  sym_member_expression = 423,
  sym_array_access = 424,
  sym_slice_access = 425,
  sym_struct_expression = 426,
  sym_struct_field_assignment = 427,
  sym_parenthesized_expression = 428,
  sym_assignment_expression = 429,
  sym_augmented_assignment_expression = 430,
  sym_call_expression = 431,
  sym_payable_conversion_expression = 432,
  sym_meta_type_expression = 433,
  sym_type_name = 434,
  sym__array_type = 435,
  sym__function_type = 436,
  sym__parameter_list = 437,
  sym__return_parameters = 438,
  sym__nameless_parameter = 439,
  sym_parameter = 440,
  sym__storage_location = 441,
  sym_user_defined_type = 442,
  sym__identifier_path = 443,
  sym__mapping = 444,
  sym__mapping_key = 445,
  sym_primitive_type = 446,
  sym__int = 447,
  sym__uint = 448,
  sym__bytes = 449,
  sym__fixed = 450,
  sym__ufixed = 451,
  sym__literal = 452,
  sym_string_literal = 453,
  sym_number_literal = 454,
  sym__decimal_number = 455,
  sym__hex_number = 456,
  sym_number_unit = 457,
  sym_true = 458,
  sym_false = 459,
  sym_boolean_literal = 460,
  sym_hex_string_literal = 461,
  sym__single_quoted_unicode_char = 462,
  sym__double_quoted_unicode_char = 463,
  sym_unicode_string_literal = 464,
  sym_string = 465,
  sym__string_immediate_elt_inside_double_quote = 466,
  sym__string_immediate_elt_inside_quote = 467,
  aux_sym_source_file_repeat1 = 468,
  aux_sym_solidity_pragma_token_repeat1 = 469,
  aux_sym__multiple_import_repeat1 = 470,
  aux_sym_error_declaration_repeat1 = 471,
  aux_sym__class_heritage_repeat1 = 472,
  aux_sym_contract_body_repeat1 = 473,
  aux_sym_struct_body_repeat1 = 474,
  aux_sym_enum_body_repeat1 = 475,
  aux_sym__event_parameter_list_repeat1 = 476,
  aux_sym_assembly_statement_repeat1 = 477,
  aux_sym_assembly_flags_repeat1 = 478,
  aux_sym_yul_path_repeat1 = 479,
  aux_sym_yul_variable_declaration_repeat1 = 480,
  aux_sym_yul_assignment_repeat1 = 481,
  aux_sym_yul_function_call_repeat1 = 482,
  aux_sym_yul_switch_statement_repeat1 = 483,
  aux_sym_block_statement_repeat1 = 484,
  aux_sym_variable_declaration_tuple_repeat1 = 485,
  aux_sym_variable_declaration_tuple_repeat2 = 486,
  aux_sym_try_statement_repeat1 = 487,
  aux_sym_state_variable_declaration_repeat1 = 488,
  aux_sym_override_specifier_repeat1 = 489,
  aux_sym_modifier_definition_repeat1 = 490,
  aux_sym_constructor_definition_repeat1 = 491,
  aux_sym_fallback_receive_definition_repeat1 = 492,
  aux_sym_function_definition_repeat1 = 493,
  aux_sym__call_arguments_repeat1 = 494,
  aux_sym_call_argument_repeat1 = 495,
  aux_sym_tuple_expression_repeat1 = 496,
  aux_sym_inline_array_expression_repeat1 = 497,
  aux_sym_struct_expression_repeat1 = 498,
  aux_sym__function_type_repeat1 = 499,
  aux_sym__parameter_list_repeat1 = 500,
  aux_sym__return_parameters_repeat1 = 501,
  aux_sym__identifier_path_repeat1 = 502,
  aux_sym_string_literal_repeat1 = 503,
  aux_sym_hex_string_literal_repeat1 = 504,
  aux_sym_hex_string_literal_repeat2 = 505,
  aux_sym_unicode_string_literal_repeat1 = 506,
  aux_sym_unicode_string_literal_repeat2 = 507,
  aux_sym_unicode_string_literal_repeat3 = 508,
  aux_sym_string_repeat1 = 509,
  aux_sym_string_repeat2 = 510,
  alias_sym_enum_value = 511,
  alias_sym_revert_arguments = 512,
  alias_sym_type_alias = 513,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_pragma] = "pragma",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_DASH] = "-",
  [anon_sym_solidity] = "solidity",
  [aux_sym_pragma_value_token1] = "pragma_value_token1",
  [sym_solidity_version] = "solidity_version",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_CARET] = "^",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ] = "=",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_type] = "type",
  [anon_sym_is] = "is",
  [anon_sym_constant] = "constant",
  [anon_sym_abstract] = "abstract",
  [anon_sym_contract] = "contract",
  [anon_sym_error] = "error",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_interface] = "interface",
  [anon_sym_library] = "library",
  [anon_sym_struct] = "struct",
  [anon_sym_enum] = "enum",
  [anon_sym_event] = "event",
  [anon_sym_anonymous] = "anonymous",
  [anon_sym_indexed] = "indexed",
  [anon_sym_using] = "using",
  [anon_sym_for] = "for",
  [anon_sym_assembly] = "assembly",
  [anon_sym_DQUOTEevmasm_DQUOTE] = "\"evmasm\"",
  [anon_sym_COLON] = ":",
  [sym_yul_leave] = "yul_leave",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_DOT] = ".",
  [sym_yul_decimal_number] = "yul_decimal_number",
  [sym_yul_hex_number] = "yul_hex_number",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_let] = "let",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_default] = "default",
  [anon_sym_case] = "case",
  [anon_sym_function] = "function",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_stop] = "stop",
  [anon_sym_add] = "add",
  [anon_sym_sub] = "sub",
  [anon_sym_mul] = "mul",
  [anon_sym_div] = "div",
  [anon_sym_sdiv] = "sdiv",
  [anon_sym_mod] = "mod",
  [anon_sym_smod] = "smod",
  [anon_sym_exp] = "exp",
  [anon_sym_not] = "not",
  [anon_sym_lt] = "lt",
  [anon_sym_gt] = "gt",
  [anon_sym_slt] = "slt",
  [anon_sym_sgt] = "sgt",
  [anon_sym_eq] = "eq",
  [anon_sym_iszero] = "iszero",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_byte] = "byte",
  [anon_sym_shl] = "shl",
  [anon_sym_shr] = "shr",
  [anon_sym_sar] = "sar",
  [anon_sym_addmod] = "addmod",
  [anon_sym_mulmod] = "mulmod",
  [anon_sym_signextend] = "signextend",
  [anon_sym_keccak256] = "keccak256",
  [anon_sym_pop] = "pop",
  [anon_sym_mload] = "mload",
  [anon_sym_mstore] = "mstore",
  [anon_sym_mstore8] = "mstore8",
  [anon_sym_sload] = "sload",
  [anon_sym_sstore] = "sstore",
  [anon_sym_msize] = "msize",
  [anon_sym_gas] = "gas",
  [anon_sym_address] = "address",
  [anon_sym_balance] = "balance",
  [anon_sym_selfbalance] = "selfbalance",
  [anon_sym_caller] = "caller",
  [anon_sym_callvalue] = "callvalue",
  [anon_sym_calldataload] = "calldataload",
  [anon_sym_calldatasize] = "calldatasize",
  [anon_sym_calldatacopy] = "calldatacopy",
  [anon_sym_extcodesize] = "extcodesize",
  [anon_sym_extcodecopy] = "extcodecopy",
  [anon_sym_returndatasize] = "returndatasize",
  [anon_sym_returndatacopy] = "returndatacopy",
  [anon_sym_extcodehash] = "extcodehash",
  [anon_sym_create] = "create",
  [anon_sym_create2] = "create2",
  [anon_sym_call] = "call",
  [anon_sym_callcode] = "callcode",
  [anon_sym_delegatecall] = "delegatecall",
  [anon_sym_staticcall] = "staticcall",
  [anon_sym_return] = "return",
  [anon_sym_revert] = "revert",
  [anon_sym_selfdestruct] = "selfdestruct",
  [anon_sym_invalid] = "invalid",
  [anon_sym_log0] = "log0",
  [anon_sym_log1] = "log1",
  [anon_sym_log2] = "log2",
  [anon_sym_log3] = "log3",
  [anon_sym_log4] = "log4",
  [anon_sym_chainid] = "chainid",
  [anon_sym_origin] = "origin",
  [anon_sym_gasprice] = "gasprice",
  [anon_sym_blockhash] = "blockhash",
  [anon_sym_coinbase] = "coinbase",
  [anon_sym_timestamp] = "timestamp",
  [anon_sym_number] = "number",
  [anon_sym_difficulty] = "difficulty",
  [anon_sym_gaslimit] = "gaslimit",
  [sym_unchecked] = "unchecked",
  [anon_sym_memory] = "memory",
  [anon_sym_storage] = "storage",
  [anon_sym_calldata] = "calldata",
  [anon_sym_var] = "var",
  [anon_sym_else] = "else",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_returns] = "returns",
  [anon_sym_catch] = "catch",
  [anon_sym_emit] = "emit",
  [anon_sym_public] = "public",
  [anon_sym_internal] = "internal",
  [anon_sym_private] = "private",
  [anon_sym_external] = "external",
  [anon_sym_pure] = "pure",
  [anon_sym_view] = "view",
  [anon_sym_payable] = "payable",
  [sym_immutable] = "immutable",
  [anon_sym_override] = "override",
  [anon_sym_modifier] = "modifier",
  [anon_sym_constructor] = "constructor",
  [anon_sym_fallback] = "fallback",
  [anon_sym_receive] = "receive",
  [sym_virtual] = "virtual",
  [anon_sym_QMARK] = "\?",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_BANG] = "!",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_mapping] = "mapping",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_bool] = "bool",
  [anon_sym_string] = "string",
  [anon_sym_int] = "int",
  [anon_sym_int8] = "int8",
  [anon_sym_int16] = "int16",
  [anon_sym_int24] = "int24",
  [anon_sym_int32] = "int32",
  [anon_sym_int40] = "int40",
  [anon_sym_int48] = "int48",
  [anon_sym_int56] = "int56",
  [anon_sym_int64] = "int64",
  [anon_sym_int72] = "int72",
  [anon_sym_int80] = "int80",
  [anon_sym_int88] = "int88",
  [anon_sym_int96] = "int96",
  [anon_sym_int104] = "int104",
  [anon_sym_int112] = "int112",
  [anon_sym_int120] = "int120",
  [anon_sym_int128] = "int128",
  [anon_sym_int136] = "int136",
  [anon_sym_int144] = "int144",
  [anon_sym_int152] = "int152",
  [anon_sym_int160] = "int160",
  [anon_sym_int168] = "int168",
  [anon_sym_int176] = "int176",
  [anon_sym_int184] = "int184",
  [anon_sym_int192] = "int192",
  [anon_sym_int200] = "int200",
  [anon_sym_int208] = "int208",
  [anon_sym_int216] = "int216",
  [anon_sym_int224] = "int224",
  [anon_sym_int232] = "int232",
  [anon_sym_int240] = "int240",
  [anon_sym_int248] = "int248",
  [anon_sym_int256] = "int256",
  [anon_sym_uint] = "uint",
  [anon_sym_uint8] = "uint8",
  [anon_sym_uint16] = "uint16",
  [anon_sym_uint24] = "uint24",
  [anon_sym_uint32] = "uint32",
  [anon_sym_uint40] = "uint40",
  [anon_sym_uint48] = "uint48",
  [anon_sym_uint56] = "uint56",
  [anon_sym_uint64] = "uint64",
  [anon_sym_uint72] = "uint72",
  [anon_sym_uint80] = "uint80",
  [anon_sym_uint88] = "uint88",
  [anon_sym_uint96] = "uint96",
  [anon_sym_uint104] = "uint104",
  [anon_sym_uint112] = "uint112",
  [anon_sym_uint120] = "uint120",
  [anon_sym_uint128] = "uint128",
  [anon_sym_uint136] = "uint136",
  [anon_sym_uint144] = "uint144",
  [anon_sym_uint152] = "uint152",
  [anon_sym_uint160] = "uint160",
  [anon_sym_uint168] = "uint168",
  [anon_sym_uint176] = "uint176",
  [anon_sym_uint184] = "uint184",
  [anon_sym_uint192] = "uint192",
  [anon_sym_uint200] = "uint200",
  [anon_sym_uint208] = "uint208",
  [anon_sym_uint216] = "uint216",
  [anon_sym_uint224] = "uint224",
  [anon_sym_uint232] = "uint232",
  [anon_sym_uint240] = "uint240",
  [anon_sym_uint248] = "uint248",
  [anon_sym_uint256] = "uint256",
  [anon_sym_bytes] = "bytes",
  [anon_sym_bytes1] = "bytes1",
  [anon_sym_bytes2] = "bytes2",
  [anon_sym_bytes3] = "bytes3",
  [anon_sym_bytes4] = "bytes4",
  [anon_sym_bytes5] = "bytes5",
  [anon_sym_bytes6] = "bytes6",
  [anon_sym_bytes7] = "bytes7",
  [anon_sym_bytes8] = "bytes8",
  [anon_sym_bytes9] = "bytes9",
  [anon_sym_bytes10] = "bytes10",
  [anon_sym_bytes11] = "bytes11",
  [anon_sym_bytes12] = "bytes12",
  [anon_sym_bytes13] = "bytes13",
  [anon_sym_bytes14] = "bytes14",
  [anon_sym_bytes15] = "bytes15",
  [anon_sym_bytes16] = "bytes16",
  [anon_sym_bytes17] = "bytes17",
  [anon_sym_bytes18] = "bytes18",
  [anon_sym_bytes19] = "bytes19",
  [anon_sym_bytes20] = "bytes20",
  [anon_sym_bytes21] = "bytes21",
  [anon_sym_bytes22] = "bytes22",
  [anon_sym_bytes23] = "bytes23",
  [anon_sym_bytes24] = "bytes24",
  [anon_sym_bytes25] = "bytes25",
  [anon_sym_bytes26] = "bytes26",
  [anon_sym_bytes27] = "bytes27",
  [anon_sym_bytes28] = "bytes28",
  [anon_sym_bytes29] = "bytes29",
  [anon_sym_bytes30] = "bytes30",
  [anon_sym_bytes31] = "bytes31",
  [anon_sym_bytes32] = "bytes32",
  [anon_sym_fixed] = "fixed",
  [aux_sym__fixed_token1] = "_fixed_token1",
  [anon_sym_ufixed] = "ufixed",
  [aux_sym__ufixed_token1] = "_ufixed_token1",
  [sym__semicolon] = "_semicolon",
  [aux_sym__decimal_number_token1] = "_decimal_number_token1",
  [aux_sym__decimal_number_token2] = "_decimal_number_token2",
  [aux_sym__hex_number_token1] = "_hex_number_token1",
  [sym__hex_digit] = "_hex_digit",
  [anon_sym_wei] = "wei",
  [anon_sym_szabo] = "szabo",
  [anon_sym_finney] = "finney",
  [anon_sym_gwei] = "gwei",
  [anon_sym_ether] = "ether",
  [anon_sym_seconds] = "seconds",
  [anon_sym_minutes] = "minutes",
  [anon_sym_hours] = "hours",
  [anon_sym_days] = "days",
  [anon_sym_weeks] = "weeks",
  [anon_sym_years] = "years",
  [anon_sym_hex] = "hex",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym__] = "_",
  [anon_sym_SQUOTE] = "'",
  [sym__escape_sequence] = "_escape_sequence",
  [aux_sym__single_quoted_unicode_char_token1] = "_single_quoted_unicode_char_token1",
  [aux_sym__double_quoted_unicode_char_token1] = "_double_quoted_unicode_char_token1",
  [anon_sym_unicode] = "unicode",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__source_unit] = "_source_unit",
  [sym__directive] = "_directive",
  [sym_pragma_directive] = "pragma_directive",
  [sym_solidity_pragma_token] = "solidity_pragma_token",
  [sym_any_pragma_token] = "any_pragma_token",
  [sym__solidity] = "_solidity",
  [sym_pragma_value] = "pragma_value",
  [sym__pragma_version_constraint] = "_pragma_version_constraint",
  [sym_solidity_version_comparison_operator] = "solidity_version_comparison_operator",
  [sym_import_directive] = "import_directive",
  [sym__source_import] = "_source_import",
  [sym__import_clause] = "_import_clause",
  [sym__from_clause] = "_from_clause",
  [sym__single_import] = "_single_import",
  [sym__multiple_import] = "_multiple_import",
  [sym__import_declaration] = "_import_declaration",
  [sym__import_alias] = "_import_alias",
  [sym__declaration] = "_declaration",
  [sym_user_defined_type_definition] = "user_defined_type_definition",
  [sym_constant_variable_declaration] = "constant_variable_declaration",
  [sym_contract_declaration] = "contract_declaration",
  [sym_error_declaration] = "error_declaration",
  [sym_error_parameter] = "error_parameter",
  [sym_interface_declaration] = "interface_declaration",
  [sym_library_declaration] = "library_declaration",
  [sym__class_heritage] = "_class_heritage",
  [sym_inheritance_specifier] = "inheritance_specifier",
  [sym_contract_body] = "contract_body",
  [sym__contract_member] = "_contract_member",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_member] = "struct_member",
  [sym_struct_body] = "struct_body",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_event_definition] = "event_definition",
  [sym__event_parameter_list] = "_event_parameter_list",
  [sym_event_parameter] = "event_parameter",
  [sym_using_directive] = "using_directive",
  [sym_any_source_type] = "any_source_type",
  [sym__statement] = "_statement",
  [sym_assembly_statement] = "assembly_statement",
  [sym_assembly_flags] = "assembly_flags",
  [sym__yul_statement] = "_yul_statement",
  [sym_yul_label] = "yul_label",
  [sym_yul_break] = "yul_break",
  [sym_yul_continue] = "yul_continue",
  [sym_yul_identifier] = "yul_identifier",
  [sym__yul_expression] = "_yul_expression",
  [sym_yul_path] = "yul_path",
  [sym__yul_literal] = "_yul_literal",
  [sym_yul_string_literal] = "yul_string_literal",
  [sym_yul_boolean] = "yul_boolean",
  [sym_yul_block] = "yul_block",
  [sym_yul_variable_declaration] = "yul_variable_declaration",
  [sym__yul_assignment_operator] = "_yul_assignment_operator",
  [sym_yul_assignment] = "yul_assignment",
  [sym_yul_function_call] = "yul_function_call",
  [sym_yul_if_statement] = "yul_if_statement",
  [sym_yul_for_statement] = "yul_for_statement",
  [sym_yul_switch_statement] = "yul_switch_statement",
  [sym_yul_function_definition] = "yul_function_definition",
  [sym_yul_evm_builtin] = "yul_evm_builtin",
  [sym_block_statement] = "block_statement",
  [sym_variable_declaration_statement] = "variable_declaration_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_variable_declaration_tuple] = "variable_declaration_tuple",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_while_statement] = "do_while_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_revert_statement] = "revert_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_return_statement] = "return_statement",
  [sym_emit_statement] = "emit_statement",
  [sym_state_variable_declaration] = "state_variable_declaration",
  [sym_visibility] = "visibility",
  [sym_state_mutability] = "state_mutability",
  [sym_override_specifier] = "override_specifier",
  [sym_modifier_definition] = "modifier_definition",
  [sym_constructor_definition] = "constructor_definition",
  [sym_fallback_receive_definition] = "fallback_receive_definition",
  [sym_function_definition] = "function_definition",
  [sym_return_type_definition] = "return_type_definition",
  [sym_modifier_invocation] = "modifier_invocation",
  [sym__call_arguments] = "_call_arguments",
  [sym_call_argument] = "call_argument",
  [sym_call_struct_argument] = "call_struct_argument",
  [sym_function_body] = "function_body",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_new_expression] = "new_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_inline_array_expression] = "inline_array_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_member_expression] = "member_expression",
  [sym_array_access] = "array_access",
  [sym_slice_access] = "slice_access",
  [sym_struct_expression] = "struct_expression",
  [sym_struct_field_assignment] = "struct_field_assignment",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_call_expression] = "call_expression",
  [sym_payable_conversion_expression] = "payable_conversion_expression",
  [sym_meta_type_expression] = "meta_type_expression",
  [sym_type_name] = "type_name",
  [sym__array_type] = "_array_type",
  [sym__function_type] = "_function_type",
  [sym__parameter_list] = "_parameter_list",
  [sym__return_parameters] = "_return_parameters",
  [sym__nameless_parameter] = "return_parameter",
  [sym_parameter] = "parameter",
  [sym__storage_location] = "_storage_location",
  [sym_user_defined_type] = "user_defined_type",
  [sym__identifier_path] = "_identifier_path",
  [sym__mapping] = "_mapping",
  [sym__mapping_key] = "_mapping_key",
  [sym_primitive_type] = "primitive_type",
  [sym__int] = "_int",
  [sym__uint] = "_uint",
  [sym__bytes] = "_bytes",
  [sym__fixed] = "_fixed",
  [sym__ufixed] = "_ufixed",
  [sym__literal] = "_literal",
  [sym_string_literal] = "string_literal",
  [sym_number_literal] = "number_literal",
  [sym__decimal_number] = "_decimal_number",
  [sym__hex_number] = "_hex_number",
  [sym_number_unit] = "number_unit",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_boolean_literal] = "boolean_literal",
  [sym_hex_string_literal] = "hex_string_literal",
  [sym__single_quoted_unicode_char] = "_single_quoted_unicode_char",
  [sym__double_quoted_unicode_char] = "_double_quoted_unicode_char",
  [sym_unicode_string_literal] = "unicode_string_literal",
  [sym_string] = "string",
  [sym__string_immediate_elt_inside_double_quote] = "_string_immediate_elt_inside_double_quote",
  [sym__string_immediate_elt_inside_quote] = "_string_immediate_elt_inside_quote",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_solidity_pragma_token_repeat1] = "solidity_pragma_token_repeat1",
  [aux_sym__multiple_import_repeat1] = "_multiple_import_repeat1",
  [aux_sym_error_declaration_repeat1] = "error_declaration_repeat1",
  [aux_sym__class_heritage_repeat1] = "_class_heritage_repeat1",
  [aux_sym_contract_body_repeat1] = "contract_body_repeat1",
  [aux_sym_struct_body_repeat1] = "struct_body_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym__event_parameter_list_repeat1] = "_event_parameter_list_repeat1",
  [aux_sym_assembly_statement_repeat1] = "assembly_statement_repeat1",
  [aux_sym_assembly_flags_repeat1] = "assembly_flags_repeat1",
  [aux_sym_yul_path_repeat1] = "yul_path_repeat1",
  [aux_sym_yul_variable_declaration_repeat1] = "yul_variable_declaration_repeat1",
  [aux_sym_yul_assignment_repeat1] = "yul_assignment_repeat1",
  [aux_sym_yul_function_call_repeat1] = "yul_function_call_repeat1",
  [aux_sym_yul_switch_statement_repeat1] = "yul_switch_statement_repeat1",
  [aux_sym_block_statement_repeat1] = "block_statement_repeat1",
  [aux_sym_variable_declaration_tuple_repeat1] = "variable_declaration_tuple_repeat1",
  [aux_sym_variable_declaration_tuple_repeat2] = "variable_declaration_tuple_repeat2",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_state_variable_declaration_repeat1] = "state_variable_declaration_repeat1",
  [aux_sym_override_specifier_repeat1] = "override_specifier_repeat1",
  [aux_sym_modifier_definition_repeat1] = "modifier_definition_repeat1",
  [aux_sym_constructor_definition_repeat1] = "constructor_definition_repeat1",
  [aux_sym_fallback_receive_definition_repeat1] = "fallback_receive_definition_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym__call_arguments_repeat1] = "_call_arguments_repeat1",
  [aux_sym_call_argument_repeat1] = "call_argument_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_inline_array_expression_repeat1] = "inline_array_expression_repeat1",
  [aux_sym_struct_expression_repeat1] = "struct_expression_repeat1",
  [aux_sym__function_type_repeat1] = "_function_type_repeat1",
  [aux_sym__parameter_list_repeat1] = "_parameter_list_repeat1",
  [aux_sym__return_parameters_repeat1] = "_return_parameters_repeat1",
  [aux_sym__identifier_path_repeat1] = "_identifier_path_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_hex_string_literal_repeat1] = "hex_string_literal_repeat1",
  [aux_sym_hex_string_literal_repeat2] = "hex_string_literal_repeat2",
  [aux_sym_unicode_string_literal_repeat1] = "unicode_string_literal_repeat1",
  [aux_sym_unicode_string_literal_repeat2] = "unicode_string_literal_repeat2",
  [aux_sym_unicode_string_literal_repeat3] = "unicode_string_literal_repeat3",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [alias_sym_enum_value] = "enum_value",
  [alias_sym_revert_arguments] = "revert_arguments",
  [alias_sym_type_alias] = "type_alias",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_pragma] = anon_sym_pragma,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_solidity] = anon_sym_solidity,
  [aux_sym_pragma_value_token1] = aux_sym_pragma_value_token1,
  [sym_solidity_version] = sym_solidity_version,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_constant] = anon_sym_constant,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_contract] = anon_sym_contract,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_library] = anon_sym_library,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_anonymous] = anon_sym_anonymous,
  [anon_sym_indexed] = anon_sym_indexed,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_DQUOTEevmasm_DQUOTE] = anon_sym_DQUOTEevmasm_DQUOTE,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_yul_leave] = sym_yul_leave,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_yul_decimal_number] = sym_yul_decimal_number,
  [sym_yul_hex_number] = sym_yul_hex_number,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_stop] = anon_sym_stop,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_div] = anon_sym_div,
  [anon_sym_sdiv] = anon_sym_sdiv,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_smod] = anon_sym_smod,
  [anon_sym_exp] = anon_sym_exp,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_lt] = anon_sym_lt,
  [anon_sym_gt] = anon_sym_gt,
  [anon_sym_slt] = anon_sym_slt,
  [anon_sym_sgt] = anon_sym_sgt,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_iszero] = anon_sym_iszero,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_shr] = anon_sym_shr,
  [anon_sym_sar] = anon_sym_sar,
  [anon_sym_addmod] = anon_sym_addmod,
  [anon_sym_mulmod] = anon_sym_mulmod,
  [anon_sym_signextend] = anon_sym_signextend,
  [anon_sym_keccak256] = anon_sym_keccak256,
  [anon_sym_pop] = anon_sym_pop,
  [anon_sym_mload] = anon_sym_mload,
  [anon_sym_mstore] = anon_sym_mstore,
  [anon_sym_mstore8] = anon_sym_mstore8,
  [anon_sym_sload] = anon_sym_sload,
  [anon_sym_sstore] = anon_sym_sstore,
  [anon_sym_msize] = anon_sym_msize,
  [anon_sym_gas] = anon_sym_gas,
  [anon_sym_address] = anon_sym_address,
  [anon_sym_balance] = anon_sym_balance,
  [anon_sym_selfbalance] = anon_sym_selfbalance,
  [anon_sym_caller] = anon_sym_caller,
  [anon_sym_callvalue] = anon_sym_callvalue,
  [anon_sym_calldataload] = anon_sym_calldataload,
  [anon_sym_calldatasize] = anon_sym_calldatasize,
  [anon_sym_calldatacopy] = anon_sym_calldatacopy,
  [anon_sym_extcodesize] = anon_sym_extcodesize,
  [anon_sym_extcodecopy] = anon_sym_extcodecopy,
  [anon_sym_returndatasize] = anon_sym_returndatasize,
  [anon_sym_returndatacopy] = anon_sym_returndatacopy,
  [anon_sym_extcodehash] = anon_sym_extcodehash,
  [anon_sym_create] = anon_sym_create,
  [anon_sym_create2] = anon_sym_create2,
  [anon_sym_call] = anon_sym_call,
  [anon_sym_callcode] = anon_sym_callcode,
  [anon_sym_delegatecall] = anon_sym_delegatecall,
  [anon_sym_staticcall] = anon_sym_staticcall,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_revert] = anon_sym_revert,
  [anon_sym_selfdestruct] = anon_sym_selfdestruct,
  [anon_sym_invalid] = anon_sym_invalid,
  [anon_sym_log0] = anon_sym_log0,
  [anon_sym_log1] = anon_sym_log1,
  [anon_sym_log2] = anon_sym_log2,
  [anon_sym_log3] = anon_sym_log3,
  [anon_sym_log4] = anon_sym_log4,
  [anon_sym_chainid] = anon_sym_chainid,
  [anon_sym_origin] = anon_sym_origin,
  [anon_sym_gasprice] = anon_sym_gasprice,
  [anon_sym_blockhash] = anon_sym_blockhash,
  [anon_sym_coinbase] = anon_sym_coinbase,
  [anon_sym_timestamp] = anon_sym_timestamp,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_difficulty] = anon_sym_difficulty,
  [anon_sym_gaslimit] = anon_sym_gaslimit,
  [sym_unchecked] = sym_unchecked,
  [anon_sym_memory] = anon_sym_memory,
  [anon_sym_storage] = anon_sym_storage,
  [anon_sym_calldata] = anon_sym_calldata,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_returns] = anon_sym_returns,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_emit] = anon_sym_emit,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_pure] = anon_sym_pure,
  [anon_sym_view] = anon_sym_view,
  [anon_sym_payable] = anon_sym_payable,
  [sym_immutable] = sym_immutable,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_modifier] = anon_sym_modifier,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_fallback] = anon_sym_fallback,
  [anon_sym_receive] = anon_sym_receive,
  [sym_virtual] = sym_virtual,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_mapping] = anon_sym_mapping,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_int8] = anon_sym_int8,
  [anon_sym_int16] = anon_sym_int16,
  [anon_sym_int24] = anon_sym_int24,
  [anon_sym_int32] = anon_sym_int32,
  [anon_sym_int40] = anon_sym_int40,
  [anon_sym_int48] = anon_sym_int48,
  [anon_sym_int56] = anon_sym_int56,
  [anon_sym_int64] = anon_sym_int64,
  [anon_sym_int72] = anon_sym_int72,
  [anon_sym_int80] = anon_sym_int80,
  [anon_sym_int88] = anon_sym_int88,
  [anon_sym_int96] = anon_sym_int96,
  [anon_sym_int104] = anon_sym_int104,
  [anon_sym_int112] = anon_sym_int112,
  [anon_sym_int120] = anon_sym_int120,
  [anon_sym_int128] = anon_sym_int128,
  [anon_sym_int136] = anon_sym_int136,
  [anon_sym_int144] = anon_sym_int144,
  [anon_sym_int152] = anon_sym_int152,
  [anon_sym_int160] = anon_sym_int160,
  [anon_sym_int168] = anon_sym_int168,
  [anon_sym_int176] = anon_sym_int176,
  [anon_sym_int184] = anon_sym_int184,
  [anon_sym_int192] = anon_sym_int192,
  [anon_sym_int200] = anon_sym_int200,
  [anon_sym_int208] = anon_sym_int208,
  [anon_sym_int216] = anon_sym_int216,
  [anon_sym_int224] = anon_sym_int224,
  [anon_sym_int232] = anon_sym_int232,
  [anon_sym_int240] = anon_sym_int240,
  [anon_sym_int248] = anon_sym_int248,
  [anon_sym_int256] = anon_sym_int256,
  [anon_sym_uint] = anon_sym_uint,
  [anon_sym_uint8] = anon_sym_uint8,
  [anon_sym_uint16] = anon_sym_uint16,
  [anon_sym_uint24] = anon_sym_uint24,
  [anon_sym_uint32] = anon_sym_uint32,
  [anon_sym_uint40] = anon_sym_uint40,
  [anon_sym_uint48] = anon_sym_uint48,
  [anon_sym_uint56] = anon_sym_uint56,
  [anon_sym_uint64] = anon_sym_uint64,
  [anon_sym_uint72] = anon_sym_uint72,
  [anon_sym_uint80] = anon_sym_uint80,
  [anon_sym_uint88] = anon_sym_uint88,
  [anon_sym_uint96] = anon_sym_uint96,
  [anon_sym_uint104] = anon_sym_uint104,
  [anon_sym_uint112] = anon_sym_uint112,
  [anon_sym_uint120] = anon_sym_uint120,
  [anon_sym_uint128] = anon_sym_uint128,
  [anon_sym_uint136] = anon_sym_uint136,
  [anon_sym_uint144] = anon_sym_uint144,
  [anon_sym_uint152] = anon_sym_uint152,
  [anon_sym_uint160] = anon_sym_uint160,
  [anon_sym_uint168] = anon_sym_uint168,
  [anon_sym_uint176] = anon_sym_uint176,
  [anon_sym_uint184] = anon_sym_uint184,
  [anon_sym_uint192] = anon_sym_uint192,
  [anon_sym_uint200] = anon_sym_uint200,
  [anon_sym_uint208] = anon_sym_uint208,
  [anon_sym_uint216] = anon_sym_uint216,
  [anon_sym_uint224] = anon_sym_uint224,
  [anon_sym_uint232] = anon_sym_uint232,
  [anon_sym_uint240] = anon_sym_uint240,
  [anon_sym_uint248] = anon_sym_uint248,
  [anon_sym_uint256] = anon_sym_uint256,
  [anon_sym_bytes] = anon_sym_bytes,
  [anon_sym_bytes1] = anon_sym_bytes1,
  [anon_sym_bytes2] = anon_sym_bytes2,
  [anon_sym_bytes3] = anon_sym_bytes3,
  [anon_sym_bytes4] = anon_sym_bytes4,
  [anon_sym_bytes5] = anon_sym_bytes5,
  [anon_sym_bytes6] = anon_sym_bytes6,
  [anon_sym_bytes7] = anon_sym_bytes7,
  [anon_sym_bytes8] = anon_sym_bytes8,
  [anon_sym_bytes9] = anon_sym_bytes9,
  [anon_sym_bytes10] = anon_sym_bytes10,
  [anon_sym_bytes11] = anon_sym_bytes11,
  [anon_sym_bytes12] = anon_sym_bytes12,
  [anon_sym_bytes13] = anon_sym_bytes13,
  [anon_sym_bytes14] = anon_sym_bytes14,
  [anon_sym_bytes15] = anon_sym_bytes15,
  [anon_sym_bytes16] = anon_sym_bytes16,
  [anon_sym_bytes17] = anon_sym_bytes17,
  [anon_sym_bytes18] = anon_sym_bytes18,
  [anon_sym_bytes19] = anon_sym_bytes19,
  [anon_sym_bytes20] = anon_sym_bytes20,
  [anon_sym_bytes21] = anon_sym_bytes21,
  [anon_sym_bytes22] = anon_sym_bytes22,
  [anon_sym_bytes23] = anon_sym_bytes23,
  [anon_sym_bytes24] = anon_sym_bytes24,
  [anon_sym_bytes25] = anon_sym_bytes25,
  [anon_sym_bytes26] = anon_sym_bytes26,
  [anon_sym_bytes27] = anon_sym_bytes27,
  [anon_sym_bytes28] = anon_sym_bytes28,
  [anon_sym_bytes29] = anon_sym_bytes29,
  [anon_sym_bytes30] = anon_sym_bytes30,
  [anon_sym_bytes31] = anon_sym_bytes31,
  [anon_sym_bytes32] = anon_sym_bytes32,
  [anon_sym_fixed] = anon_sym_fixed,
  [aux_sym__fixed_token1] = aux_sym__fixed_token1,
  [anon_sym_ufixed] = anon_sym_ufixed,
  [aux_sym__ufixed_token1] = aux_sym__ufixed_token1,
  [sym__semicolon] = sym__semicolon,
  [aux_sym__decimal_number_token1] = aux_sym__decimal_number_token1,
  [aux_sym__decimal_number_token2] = aux_sym__decimal_number_token2,
  [aux_sym__hex_number_token1] = aux_sym__hex_number_token1,
  [sym__hex_digit] = sym__hex_digit,
  [anon_sym_wei] = anon_sym_wei,
  [anon_sym_szabo] = anon_sym_szabo,
  [anon_sym_finney] = anon_sym_finney,
  [anon_sym_gwei] = anon_sym_gwei,
  [anon_sym_ether] = anon_sym_ether,
  [anon_sym_seconds] = anon_sym_seconds,
  [anon_sym_minutes] = anon_sym_minutes,
  [anon_sym_hours] = anon_sym_hours,
  [anon_sym_days] = anon_sym_days,
  [anon_sym_weeks] = anon_sym_weeks,
  [anon_sym_years] = anon_sym_years,
  [anon_sym_hex] = anon_sym_hex,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym__] = anon_sym__,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym__escape_sequence] = sym__escape_sequence,
  [aux_sym__single_quoted_unicode_char_token1] = aux_sym__single_quoted_unicode_char_token1,
  [aux_sym__double_quoted_unicode_char_token1] = aux_sym__double_quoted_unicode_char_token1,
  [anon_sym_unicode] = anon_sym_unicode,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__source_unit] = sym__source_unit,
  [sym__directive] = sym__directive,
  [sym_pragma_directive] = sym_pragma_directive,
  [sym_solidity_pragma_token] = sym_solidity_pragma_token,
  [sym_any_pragma_token] = sym_any_pragma_token,
  [sym__solidity] = sym__solidity,
  [sym_pragma_value] = sym_pragma_value,
  [sym__pragma_version_constraint] = sym__pragma_version_constraint,
  [sym_solidity_version_comparison_operator] = sym_solidity_version_comparison_operator,
  [sym_import_directive] = sym_import_directive,
  [sym__source_import] = sym__source_import,
  [sym__import_clause] = sym__import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym__single_import] = sym__single_import,
  [sym__multiple_import] = sym__multiple_import,
  [sym__import_declaration] = sym__import_declaration,
  [sym__import_alias] = sym__import_alias,
  [sym__declaration] = sym__declaration,
  [sym_user_defined_type_definition] = sym_user_defined_type_definition,
  [sym_constant_variable_declaration] = sym_constant_variable_declaration,
  [sym_contract_declaration] = sym_contract_declaration,
  [sym_error_declaration] = sym_error_declaration,
  [sym_error_parameter] = sym_error_parameter,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_library_declaration] = sym_library_declaration,
  [sym__class_heritage] = sym__class_heritage,
  [sym_inheritance_specifier] = sym_inheritance_specifier,
  [sym_contract_body] = sym_contract_body,
  [sym__contract_member] = sym__contract_member,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_struct_member] = sym_struct_member,
  [sym_struct_body] = sym_struct_body,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_event_definition] = sym_event_definition,
  [sym__event_parameter_list] = sym__event_parameter_list,
  [sym_event_parameter] = sym_event_parameter,
  [sym_using_directive] = sym_using_directive,
  [sym_any_source_type] = sym_any_source_type,
  [sym__statement] = sym__statement,
  [sym_assembly_statement] = sym_assembly_statement,
  [sym_assembly_flags] = sym_assembly_flags,
  [sym__yul_statement] = sym__yul_statement,
  [sym_yul_label] = sym_yul_label,
  [sym_yul_break] = sym_yul_break,
  [sym_yul_continue] = sym_yul_continue,
  [sym_yul_identifier] = sym_yul_identifier,
  [sym__yul_expression] = sym__yul_expression,
  [sym_yul_path] = sym_yul_path,
  [sym__yul_literal] = sym__yul_literal,
  [sym_yul_string_literal] = sym_yul_string_literal,
  [sym_yul_boolean] = sym_yul_boolean,
  [sym_yul_block] = sym_yul_block,
  [sym_yul_variable_declaration] = sym_yul_variable_declaration,
  [sym__yul_assignment_operator] = sym__yul_assignment_operator,
  [sym_yul_assignment] = sym_yul_assignment,
  [sym_yul_function_call] = sym_yul_function_call,
  [sym_yul_if_statement] = sym_yul_if_statement,
  [sym_yul_for_statement] = sym_yul_for_statement,
  [sym_yul_switch_statement] = sym_yul_switch_statement,
  [sym_yul_function_definition] = sym_yul_function_definition,
  [sym_yul_evm_builtin] = sym_yul_evm_builtin,
  [sym_block_statement] = sym_block_statement,
  [sym_variable_declaration_statement] = sym_variable_declaration_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_variable_declaration_tuple] = sym_variable_declaration_tuple,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_while_statement] = sym_do_while_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_revert_statement] = sym_revert_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_return_statement] = sym_return_statement,
  [sym_emit_statement] = sym_emit_statement,
  [sym_state_variable_declaration] = sym_state_variable_declaration,
  [sym_visibility] = sym_visibility,
  [sym_state_mutability] = sym_state_mutability,
  [sym_override_specifier] = sym_override_specifier,
  [sym_modifier_definition] = sym_modifier_definition,
  [sym_constructor_definition] = sym_constructor_definition,
  [sym_fallback_receive_definition] = sym_fallback_receive_definition,
  [sym_function_definition] = sym_function_definition,
  [sym_return_type_definition] = sym_return_type_definition,
  [sym_modifier_invocation] = sym_modifier_invocation,
  [sym__call_arguments] = sym__call_arguments,
  [sym_call_argument] = sym_call_argument,
  [sym_call_struct_argument] = sym_call_struct_argument,
  [sym_function_body] = sym_function_body,
  [sym__expression] = sym__expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_inline_array_expression] = sym_inline_array_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_array_access] = sym_array_access,
  [sym_slice_access] = sym_slice_access,
  [sym_struct_expression] = sym_struct_expression,
  [sym_struct_field_assignment] = sym_struct_field_assignment,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_payable_conversion_expression] = sym_payable_conversion_expression,
  [sym_meta_type_expression] = sym_meta_type_expression,
  [sym_type_name] = sym_type_name,
  [sym__array_type] = sym__array_type,
  [sym__function_type] = sym__function_type,
  [sym__parameter_list] = sym__parameter_list,
  [sym__return_parameters] = sym__return_parameters,
  [sym__nameless_parameter] = sym__nameless_parameter,
  [sym_parameter] = sym_parameter,
  [sym__storage_location] = sym__storage_location,
  [sym_user_defined_type] = sym_user_defined_type,
  [sym__identifier_path] = sym__identifier_path,
  [sym__mapping] = sym__mapping,
  [sym__mapping_key] = sym__mapping_key,
  [sym_primitive_type] = sym_primitive_type,
  [sym__int] = sym__int,
  [sym__uint] = sym__uint,
  [sym__bytes] = sym__bytes,
  [sym__fixed] = sym__fixed,
  [sym__ufixed] = sym__ufixed,
  [sym__literal] = sym__literal,
  [sym_string_literal] = sym_string_literal,
  [sym_number_literal] = sym_number_literal,
  [sym__decimal_number] = sym__decimal_number,
  [sym__hex_number] = sym__hex_number,
  [sym_number_unit] = sym_number_unit,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_hex_string_literal] = sym_hex_string_literal,
  [sym__single_quoted_unicode_char] = sym__single_quoted_unicode_char,
  [sym__double_quoted_unicode_char] = sym__double_quoted_unicode_char,
  [sym_unicode_string_literal] = sym_unicode_string_literal,
  [sym_string] = sym_string,
  [sym__string_immediate_elt_inside_double_quote] = sym__string_immediate_elt_inside_double_quote,
  [sym__string_immediate_elt_inside_quote] = sym__string_immediate_elt_inside_quote,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_solidity_pragma_token_repeat1] = aux_sym_solidity_pragma_token_repeat1,
  [aux_sym__multiple_import_repeat1] = aux_sym__multiple_import_repeat1,
  [aux_sym_error_declaration_repeat1] = aux_sym_error_declaration_repeat1,
  [aux_sym__class_heritage_repeat1] = aux_sym__class_heritage_repeat1,
  [aux_sym_contract_body_repeat1] = aux_sym_contract_body_repeat1,
  [aux_sym_struct_body_repeat1] = aux_sym_struct_body_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym__event_parameter_list_repeat1] = aux_sym__event_parameter_list_repeat1,
  [aux_sym_assembly_statement_repeat1] = aux_sym_assembly_statement_repeat1,
  [aux_sym_assembly_flags_repeat1] = aux_sym_assembly_flags_repeat1,
  [aux_sym_yul_path_repeat1] = aux_sym_yul_path_repeat1,
  [aux_sym_yul_variable_declaration_repeat1] = aux_sym_yul_variable_declaration_repeat1,
  [aux_sym_yul_assignment_repeat1] = aux_sym_yul_assignment_repeat1,
  [aux_sym_yul_function_call_repeat1] = aux_sym_yul_function_call_repeat1,
  [aux_sym_yul_switch_statement_repeat1] = aux_sym_yul_switch_statement_repeat1,
  [aux_sym_block_statement_repeat1] = aux_sym_block_statement_repeat1,
  [aux_sym_variable_declaration_tuple_repeat1] = aux_sym_variable_declaration_tuple_repeat1,
  [aux_sym_variable_declaration_tuple_repeat2] = aux_sym_variable_declaration_tuple_repeat2,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_state_variable_declaration_repeat1] = aux_sym_state_variable_declaration_repeat1,
  [aux_sym_override_specifier_repeat1] = aux_sym_override_specifier_repeat1,
  [aux_sym_modifier_definition_repeat1] = aux_sym_modifier_definition_repeat1,
  [aux_sym_constructor_definition_repeat1] = aux_sym_constructor_definition_repeat1,
  [aux_sym_fallback_receive_definition_repeat1] = aux_sym_fallback_receive_definition_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym__call_arguments_repeat1] = aux_sym__call_arguments_repeat1,
  [aux_sym_call_argument_repeat1] = aux_sym_call_argument_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_inline_array_expression_repeat1] = aux_sym_inline_array_expression_repeat1,
  [aux_sym_struct_expression_repeat1] = aux_sym_struct_expression_repeat1,
  [aux_sym__function_type_repeat1] = aux_sym__function_type_repeat1,
  [aux_sym__parameter_list_repeat1] = aux_sym__parameter_list_repeat1,
  [aux_sym__return_parameters_repeat1] = aux_sym__return_parameters_repeat1,
  [aux_sym__identifier_path_repeat1] = aux_sym__identifier_path_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_hex_string_literal_repeat1] = aux_sym_hex_string_literal_repeat1,
  [aux_sym_hex_string_literal_repeat2] = aux_sym_hex_string_literal_repeat2,
  [aux_sym_unicode_string_literal_repeat1] = aux_sym_unicode_string_literal_repeat1,
  [aux_sym_unicode_string_literal_repeat2] = aux_sym_unicode_string_literal_repeat2,
  [aux_sym_unicode_string_literal_repeat3] = aux_sym_unicode_string_literal_repeat3,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [alias_sym_enum_value] = alias_sym_enum_value,
  [alias_sym_revert_arguments] = alias_sym_revert_arguments,
  [alias_sym_type_alias] = alias_sym_type_alias,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_pragma] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_solidity] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pragma_value_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_solidity_version] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_contract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_library] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anonymous] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indexed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEevmasm_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_yul_leave] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_yul_decimal_number] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_hex_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_div] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_smod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_slt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iszero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addmod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mulmod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signextend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keccak256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mstore8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_msize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_address] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_balance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selfbalance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_caller] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldataload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldatasize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldatacopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodesize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodecopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returndatasize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returndatacopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodehash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_create] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_create2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callcode] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegatecall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_staticcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_revert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selfdestruct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invalid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chainid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_origin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gasprice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blockhash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coinbase] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_timestamp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_difficulty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gaslimit] = {
    .visible = true,
    .named = false,
  },
  [sym_unchecked] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_storage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returns] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_emit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_view] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_payable] = {
    .visible = true,
    .named = false,
  },
  [sym_immutable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_modifier] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallback] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_receive] = {
    .visible = true,
    .named = false,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mapping] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int40] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int48] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int56] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int72] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int88] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int96] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int104] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int112] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int120] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int136] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int144] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int152] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int160] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int168] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int176] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int184] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int224] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int232] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint40] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint48] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint56] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint72] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint88] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint96] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint104] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint112] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint120] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint136] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint144] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint152] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint160] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint168] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint176] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint184] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint224] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint232] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes9] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes10] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes11] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes12] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes13] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes14] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes15] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes17] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes18] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes19] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes20] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes21] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes22] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes23] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes25] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes26] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes27] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes28] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes29] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes30] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes31] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__fixed_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_ufixed] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__ufixed_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__decimal_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_number_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hex_number_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__hex_digit] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_wei] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_szabo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finney] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gwei] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ether] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_seconds] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minutes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hours] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_days] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weeks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_years] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hex] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quoted_unicode_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_unicode_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_unicode] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__source_unit] = {
    .visible = false,
    .named = true,
  },
  [sym__directive] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_solidity_pragma_token] = {
    .visible = true,
    .named = true,
  },
  [sym_any_pragma_token] = {
    .visible = true,
    .named = true,
  },
  [sym__solidity] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_value] = {
    .visible = true,
    .named = true,
  },
  [sym__pragma_version_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_solidity_version_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_import_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__source_import] = {
    .visible = false,
    .named = true,
  },
  [sym__import_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__single_import] = {
    .visible = false,
    .named = true,
  },
  [sym__multiple_import] = {
    .visible = false,
    .named = true,
  },
  [sym__import_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__import_alias] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_user_defined_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_contract_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_library_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_heritage] = {
    .visible = false,
    .named = true,
  },
  [sym_inheritance_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_contract_body] = {
    .visible = true,
    .named = true,
  },
  [sym__contract_member] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_member] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_event_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__event_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym_event_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_any_source_type] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_assembly_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assembly_flags] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_label] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_break] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_continue] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_path] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_block] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_assignment_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_evm_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_block_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_revert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_emit_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_state_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility] = {
    .visible = true,
    .named = true,
  },
  [sym_state_mutability] = {
    .visible = true,
    .named = true,
  },
  [sym_override_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_fallback_receive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_return_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym__call_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_call_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_call_struct_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_access] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_field_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_payable_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym__array_type] = {
    .visible = false,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__return_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__nameless_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__storage_location] = {
    .visible = false,
    .named = true,
  },
  [sym_user_defined_type] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_path] = {
    .visible = false,
    .named = true,
  },
  [sym__mapping] = {
    .visible = false,
    .named = true,
  },
  [sym__mapping_key] = {
    .visible = false,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym__int] = {
    .visible = false,
    .named = true,
  },
  [sym__uint] = {
    .visible = false,
    .named = true,
  },
  [sym__bytes] = {
    .visible = false,
    .named = true,
  },
  [sym__fixed] = {
    .visible = false,
    .named = true,
  },
  [sym__ufixed] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__decimal_number] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_number] = {
    .visible = false,
    .named = true,
  },
  [sym_number_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quoted_unicode_char] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quoted_unicode_char] = {
    .visible = false,
    .named = true,
  },
  [sym_unicode_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_immediate_elt_inside_double_quote] = {
    .visible = false,
    .named = true,
  },
  [sym__string_immediate_elt_inside_quote] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_solidity_pragma_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiple_import_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_error_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_heritage_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_contract_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__event_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assembly_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assembly_flags_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_assignment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_function_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_tuple_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_state_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_override_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifier_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fallback_receive_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__call_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inline_array_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__return_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_enum_value] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_revert_arguments] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_alias] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_ancestor = 2,
  field_ancestor_arguments = 3,
  field_argument = 4,
  field_attempt = 5,
  field_base = 6,
  field_body = 7,
  field_condition = 8,
  field_else = 9,
  field_error = 10,
  field_from = 11,
  field_function = 12,
  field_import_name = 13,
  field_index = 14,
  field_initial = 15,
  field_key_identifier = 16,
  field_key_type = 17,
  field_left = 18,
  field_location = 19,
  field_name = 20,
  field_object = 21,
  field_operator = 22,
  field_parameters = 23,
  field_property = 24,
  field_return_type = 25,
  field_right = 26,
  field_source = 27,
  field_to = 28,
  field_type = 29,
  field_update = 30,
  field_value = 31,
  field_value_identifier = 32,
  field_value_type = 33,
  field_version_constraint = 34,
  field_visibility = 35,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_ancestor] = "ancestor",
  [field_ancestor_arguments] = "ancestor_arguments",
  [field_argument] = "argument",
  [field_attempt] = "attempt",
  [field_base] = "base",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_error] = "error",
  [field_from] = "from",
  [field_function] = "function",
  [field_import_name] = "import_name",
  [field_index] = "index",
  [field_initial] = "initial",
  [field_key_identifier] = "key_identifier",
  [field_key_type] = "key_type",
  [field_left] = "left",
  [field_location] = "location",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_to] = "to",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
  [field_value_identifier] = "value_identifier",
  [field_value_type] = "value_type",
  [field_version_constraint] = "version_constraint",
  [field_visibility] = "visibility",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 2},
  [5] = {.index = 8, .length = 1},
  [6] = {.index = 9, .length = 1},
  [7] = {.index = 10, .length = 1},
  [8] = {.index = 11, .length = 1},
  [9] = {.index = 12, .length = 1},
  [10] = {.index = 13, .length = 2},
  [11] = {.index = 15, .length = 2},
  [12] = {.index = 17, .length = 2},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 2},
  [16] = {.index = 24, .length = 1},
  [17] = {.index = 25, .length = 2},
  [18] = {.index = 27, .length = 1},
  [19] = {.index = 28, .length = 3},
  [20] = {.index = 31, .length = 2},
  [21] = {.index = 33, .length = 1},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 2},
  [24] = {.index = 38, .length = 2},
  [25] = {.index = 40, .length = 1},
  [26] = {.index = 41, .length = 2},
  [27] = {.index = 43, .length = 2},
  [28] = {.index = 45, .length = 1},
  [29] = {.index = 46, .length = 4},
  [30] = {.index = 50, .length = 4},
  [31] = {.index = 54, .length = 2},
  [32] = {.index = 56, .length = 1},
  [33] = {.index = 57, .length = 2},
  [35] = {.index = 59, .length = 3},
  [36] = {.index = 62, .length = 2},
  [37] = {.index = 64, .length = 3},
  [38] = {.index = 67, .length = 2},
  [39] = {.index = 69, .length = 2},
  [40] = {.index = 71, .length = 3},
  [41] = {.index = 74, .length = 2},
  [42] = {.index = 76, .length = 1},
  [43] = {.index = 77, .length = 1},
  [44] = {.index = 78, .length = 2},
  [45] = {.index = 80, .length = 2},
  [46] = {.index = 82, .length = 3},
  [47] = {.index = 85, .length = 2},
  [48] = {.index = 87, .length = 2},
  [49] = {.index = 89, .length = 3},
  [50] = {.index = 92, .length = 2},
  [51] = {.index = 94, .length = 1},
  [52] = {.index = 95, .length = 3},
  [54] = {.index = 98, .length = 1},
  [55] = {.index = 99, .length = 2},
  [56] = {.index = 101, .length = 3},
  [57] = {.index = 104, .length = 3},
  [58] = {.index = 107, .length = 2},
  [59] = {.index = 109, .length = 2},
  [60] = {.index = 111, .length = 2},
  [61] = {.index = 113, .length = 1},
  [62] = {.index = 114, .length = 3},
  [63] = {.index = 117, .length = 1},
  [64] = {.index = 98, .length = 1},
  [65] = {.index = 118, .length = 2},
  [66] = {.index = 120, .length = 1},
  [67] = {.index = 121, .length = 4},
  [68] = {.index = 125, .length = 3},
  [69] = {.index = 128, .length = 2},
  [70] = {.index = 130, .length = 4},
  [71] = {.index = 134, .length = 2},
  [72] = {.index = 136, .length = 2},
  [73] = {.index = 138, .length = 1},
  [74] = {.index = 139, .length = 3},
  [75] = {.index = 142, .length = 3},
  [76] = {.index = 145, .length = 2},
  [77] = {.index = 147, .length = 2},
  [78] = {.index = 149, .length = 4},
  [79] = {.index = 153, .length = 4},
  [80] = {.index = 157, .length = 3},
  [81] = {.index = 160, .length = 4},
  [82] = {.index = 164, .length = 2},
  [83] = {.index = 166, .length = 4},
  [84] = {.index = 170, .length = 5},
  [85] = {.index = 175, .length = 5},
  [86] = {.index = 180, .length = 6},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_parameters, 0, .inherited = true},
  [1] =
    {field_key_identifier, 0, .inherited = true},
    {field_key_type, 0, .inherited = true},
    {field_value_identifier, 0, .inherited = true},
    {field_value_type, 0, .inherited = true},
  [5] =
    {field_import_name, 0},
  [6] =
    {field_alias, 0, .inherited = true},
    {field_import_name, 0, .inherited = true},
  [8] =
    {field_source, 0},
  [9] =
    {field_parameters, 1},
  [10] =
    {field_version_constraint, 0},
  [11] =
    {field_version_constraint, 1, .inherited = true},
  [12] =
    {field_alias, 1, .inherited = true},
  [13] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 0},
  [15] =
    {field_alias, 1, .inherited = true},
    {field_source, 1, .inherited = true},
  [17] =
    {field_alias, 1, .inherited = true},
    {field_source, 0},
  [19] =
    {field_body, 2},
    {field_name, 1},
  [21] =
    {field_type, 0},
  [22] =
    {field_version_constraint, 0, .inherited = true},
    {field_version_constraint, 1, .inherited = true},
  [24] =
    {field_alias, 1},
  [25] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 1, .inherited = true},
  [27] =
    {field_source, 1},
  [28] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 1, .inherited = true},
    {field_source, 2, .inherited = true},
  [31] =
    {field_body, 3},
    {field_name, 2},
  [33] =
    {field_ancestor, 0},
  [34] =
    {field_body, 3},
    {field_name, 1},
  [36] =
    {field_name, 1},
    {field_type, 0},
  [38] =
    {field_location, 1},
    {field_type, 0},
  [40] =
    {field_name, 1},
  [41] =
    {field_argument, 1},
    {field_operator, 0},
  [43] =
    {field_argument, 0},
    {field_operator, 1},
  [45] =
    {field_function, 0},
  [46] =
    {field_alias, 1, .inherited = true},
    {field_alias, 2, .inherited = true},
    {field_import_name, 1, .inherited = true},
    {field_import_name, 2, .inherited = true},
  [50] =
    {field_alias, 0, .inherited = true},
    {field_alias, 1, .inherited = true},
    {field_import_name, 0, .inherited = true},
    {field_import_name, 1, .inherited = true},
  [54] =
    {field_body, 4},
    {field_name, 2},
  [56] =
    {field_visibility, 0},
  [57] =
    {field_ancestor, 0},
    {field_ancestor_arguments, 1},
  [59] =
    {field_location, 1},
    {field_name, 2},
    {field_type, 0},
  [62] =
    {field_name, 1},
    {field_return_type, 3},
  [64] =
    {field_body, 4},
    {field_name, 1},
    {field_return_type, 3},
  [67] =
    {field_body, 4},
    {field_name, 1},
  [69] =
    {field_object, 0},
    {field_property, 2},
  [71] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [74] =
    {field_left, 0},
    {field_right, 2},
  [76] =
    {field_base, 0},
  [77] =
    {field_body, 2},
  [78] =
    {field_visibility, 0, .inherited = true},
    {field_visibility, 1, .inherited = true},
  [80] =
    {field_name, 1},
    {field_return_type, 4},
  [82] =
    {field_body, 5},
    {field_name, 1},
    {field_return_type, 4},
  [85] =
    {field_location, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [87] =
    {field_key_type, 2},
    {field_value_type, 4},
  [89] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 4},
  [92] =
    {field_base, 0},
    {field_index, 2},
  [94] =
    {field_body, 3},
  [95] =
    {field_name, 2},
    {field_type, 0},
    {field_visibility, 1, .inherited = true},
  [98] =
    {field_error, 1},
  [99] =
    {field_location, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [101] =
    {field_key_type, 2},
    {field_value_identifier, 5},
    {field_value_type, 4},
  [104] =
    {field_key_identifier, 3},
    {field_key_type, 2},
    {field_value_type, 5},
  [107] =
    {field_name, 0},
    {field_value, 2},
  [109] =
    {field_base, 0},
    {field_to, 3},
  [111] =
    {field_base, 0},
    {field_from, 2},
  [113] =
    {field_source, 3},
  [114] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 3},
  [117] =
    {field_left, 1},
  [118] =
    {field_attempt, 1},
    {field_body, 2},
  [120] =
    {field_value, 2},
  [121] =
    {field_key_identifier, 3},
    {field_key_type, 2},
    {field_value_identifier, 6},
    {field_value_type, 5},
  [125] =
    {field_base, 0},
    {field_from, 2},
    {field_to, 4},
  [128] =
    {field_name, 2},
    {field_type, 0},
  [130] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 4},
    {field_visibility, 1, .inherited = true},
  [134] =
    {field_left, 1},
    {field_left, 2},
  [136] =
    {field_body, 4},
    {field_condition, 2},
  [138] =
    {field_body, 1},
  [139] =
    {field_body, 5},
    {field_condition, 3},
    {field_initial, 2},
  [142] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
  [145] =
    {field_left, 1},
    {field_right, 3},
  [147] =
    {field_attempt, 1},
    {field_body, 4},
  [149] =
    {field_body, 6},
    {field_condition, 3},
    {field_initial, 2},
    {field_update, 4},
  [153] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
  [157] =
    {field_left, 1},
    {field_left, 2},
    {field_right, 4},
  [160] =
    {field_body, 4},
    {field_body, 6},
    {field_condition, 2},
    {field_else, 5},
  [164] =
    {field_body, 1},
    {field_condition, 4},
  [166] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_right, 5},
  [170] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_left, 5},
  [175] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_right, 6},
  [180] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_left, 5},
    {field_right, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [34] = {
    [1] = alias_sym_enum_value,
  },
  [53] = {
    [1] = alias_sym_revert_arguments,
  },
  [61] = {
    [1] = alias_sym_type_alias,
  },
  [64] = {
    [2] = alias_sym_revert_arguments,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__call_arguments, 2,
    sym__call_arguments,
    alias_sym_revert_arguments,
  sym_user_defined_type, 2,
    sym_user_defined_type,
    alias_sym_type_alias,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 4,
  [6] = 6,
  [7] = 3,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 105,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 110,
  [120] = 120,
  [121] = 121,
  [122] = 114,
  [123] = 117,
  [124] = 112,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 159,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 162,
  [170] = 170,
  [171] = 163,
  [172] = 172,
  [173] = 173,
  [174] = 154,
  [175] = 168,
  [176] = 176,
  [177] = 177,
  [178] = 155,
  [179] = 147,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 172,
  [184] = 184,
  [185] = 185,
  [186] = 151,
  [187] = 187,
  [188] = 188,
  [189] = 136,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 192,
  [194] = 194,
  [195] = 195,
  [196] = 149,
  [197] = 138,
  [198] = 150,
  [199] = 140,
  [200] = 200,
  [201] = 201,
  [202] = 145,
  [203] = 203,
  [204] = 177,
  [205] = 164,
  [206] = 182,
  [207] = 185,
  [208] = 141,
  [209] = 209,
  [210] = 181,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 213,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 279,
  [341] = 281,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 339,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 439,
  [442] = 440,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 484,
  [486] = 486,
  [487] = 483,
  [488] = 482,
  [489] = 489,
  [490] = 490,
  [491] = 481,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 538,
  [568] = 568,
  [569] = 550,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 547,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 537,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 545,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 543,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 652,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 651,
  [675] = 675,
  [676] = 645,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 667,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 657,
  [711] = 662,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 768,
  [799] = 759,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 753,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 735,
  [811] = 811,
  [812] = 738,
  [813] = 750,
  [814] = 751,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 737,
  [824] = 749,
  [825] = 802,
  [826] = 811,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(51);
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '%') ADVANCE(105);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(103);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == '0') ADVANCE(88);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(70);
      if (lookahead == '_') ADVANCE(142);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(81);
      if (lookahead == '~') ADVANCE(74);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(49)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(13)
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0) ADVANCE(162);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(156);
      if (lookahead == '\r') ADVANCE(145);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\\') ADVANCE(4);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(154);
      if (lookahead != 0) ADVANCE(155);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(146);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 5:
      if (lookahead == ' ') ADVANCE(5);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (lookahead == '-') ADVANCE(53);
      if (lookahead == '.') ADVANCE(6);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '<') ADVANCE(68);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(71);
      if (lookahead == '^') ADVANCE(69);
      if (lookahead == '|') ADVANCE(34);
      if (lookahead == '~') ADVANCE(74);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      END_STATE();
    case 6:
      if (lookahead == ' ') ADVANCE(36);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 7:
      if (lookahead == ' ') ADVANCE(36);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (lookahead == '.') ADVANCE(6);
      END_STATE();
    case 8:
      if (lookahead == ' ') ADVANCE(37);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '%') ADVANCE(105);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(103);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == ':') ADVANCE(85);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(70);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(81);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '"') ADVANCE(27);
      if (lookahead == '%') ADVANCE(105);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(103);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == ':') ADVANCE(85);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(70);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(81);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(110);
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == '+') ADVANCE(102);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(132);
      if (lookahead == ':') ADVANCE(85);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '_') ADVANCE(128);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == '}') ADVANCE(81);
      if (lookahead == '~') ADVANCE(74);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(131);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '_') ADVANCE(141);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(84);
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      END_STATE();
    case 16:
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '{') ADVANCE(79);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(165);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(136);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(56);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 24:
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 28:
      if (lookahead == 'm') ADVANCE(26);
      END_STATE();
    case 29:
      if (lookahead == 'm') ADVANCE(14);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(29);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 32:
      if (lookahead == 'v') ADVANCE(28);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 34:
      if (lookahead == '|') ADVANCE(52);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 37:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(135);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(136);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(139);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 49:
      if (eof) ADVANCE(51);
      if (lookahead == '!') ADVANCE(111);
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '%') ADVANCE(105);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(103);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == '0') ADVANCE(88);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(70);
      if (lookahead == '_') ADVANCE(142);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(81);
      if (lookahead == '~') ADVANCE(74);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(49)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 50:
      if (eof) ADVANCE(51);
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '%') ADVANCE(105);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '(') ADVANCE(82);
      if (lookahead == ')') ADVANCE(83);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(103);
      if (lookahead == ',') ADVANCE(80);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead == '0') ADVANCE(88);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(126);
      if (lookahead == '<') ADVANCE(67);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(72);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(70);
      if (lookahead == '{') ADVANCE(79);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(81);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(50)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(113);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(113);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(58);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '/') ADVANCE(56);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_solidity_version);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == ' ') ADVANCE(63);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      if (lookahead == '.') ADVANCE(38);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '.') ADVANCE(38);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (lookahead == '.') ADVANCE(8);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(99);
      if (lookahead == '=') ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(66);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(73);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(97);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(107);
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DQUOTEevmasm_DQUOTE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_yul_decimal_number);
      if (lookahead == 'x') ADVANCE(90);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_yul_decimal_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_yul_hex_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(98);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(96);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '|') ADVANCE(52);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(112);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(112);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(129);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(128);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(127);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(129);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '.') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(131);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '.') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(131);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(46);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym__decimal_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(135);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym__decimal_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym__hex_number_token1);
      if (lookahead == '_') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym__hex_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__hex_digit);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym__escape_sequence);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (lookahead == '\n') ADVANCE(156);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (lookahead == '\n') ADVANCE(149);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(144);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '\r') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '\r') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ';') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(165);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'h') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'k') ADVANCE(10);
      if (lookahead == 'l') ADVANCE(11);
      if (lookahead == 'm') ADVANCE(12);
      if (lookahead == 'n') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      if (lookahead == 'p') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'v') ADVANCE(20);
      if (lookahead == 'w') ADVANCE(21);
      if (lookahead == 'x') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(24);
      if (lookahead == 'd') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(26);
      if (lookahead == 's') ADVANCE(27);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      if (lookahead == 'r') ADVANCE(31);
      if (lookahead == 'y') ADVANCE(32);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'h') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(41);
      if (lookahead == 'm') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(43);
      if (lookahead == 'q') ADVANCE(44);
      if (lookahead == 'r') ADVANCE(45);
      if (lookahead == 't') ADVANCE(46);
      if (lookahead == 'v') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(48);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 't') ADVANCE(55);
      if (lookahead == 'w') ADVANCE(56);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 'o') ADVANCE(58);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(59);
      if (lookahead == 'm') ADVANCE(60);
      if (lookahead == 'n') ADVANCE(61);
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'i') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(68);
      if (lookahead == 'e') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'l') ADVANCE(71);
      if (lookahead == 'o') ADVANCE(72);
      if (lookahead == 's') ADVANCE(73);
      if (lookahead == 'u') ADVANCE(74);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(78);
      if (lookahead == 'v') ADVANCE(79);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'r') ADVANCE(82);
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(85);
      if (lookahead == 'd') ADVANCE(86);
      if (lookahead == 'e') ADVANCE(87);
      if (lookahead == 'g') ADVANCE(88);
      if (lookahead == 'h') ADVANCE(89);
      if (lookahead == 'i') ADVANCE(90);
      if (lookahead == 'l') ADVANCE(91);
      if (lookahead == 'm') ADVANCE(92);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 's') ADVANCE(94);
      if (lookahead == 't') ADVANCE(95);
      if (lookahead == 'u') ADVANCE(96);
      if (lookahead == 'w') ADVANCE(97);
      if (lookahead == 'z') ADVANCE(98);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(99);
      if (lookahead == 'r') ADVANCE(100);
      if (lookahead == 'y') ADVANCE(101);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(102);
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'n') ADVANCE(104);
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'i') ADVANCE(107);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(108);
      if (lookahead == 'h') ADVANCE(109);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(112);
      END_STATE();
    case 25:
      if (lookahead == 'd') ADVANCE(113);
      END_STATE();
    case 26:
      if (lookahead == 'd') ADVANCE(114);
      if (lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 29:
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(119);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(122);
      if (lookahead == 's') ADVANCE(123);
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(126);
      if (lookahead == 'n') ADVANCE(127);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 37:
      if (lookahead == 'y') ADVANCE(129);
      END_STATE();
    case 38:
      if (lookahead == 'f') ADVANCE(130);
      if (lookahead == 'l') ADVANCE(131);
      END_STATE();
    case 39:
      if (lookahead == 'f') ADVANCE(132);
      if (lookahead == 'v') ADVANCE(133);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(134);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 43:
      if (lookahead == 'u') ADVANCE(136);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(138);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(140);
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead == 'x') ADVANCE(144);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(145);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(147);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_gt);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 57:
      if (lookahead == 'x') ADVANCE(150);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(151);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(152);
      if (lookahead == 'p') ADVANCE(153);
      END_STATE();
    case 61:
      if (lookahead == 'd') ADVANCE(154);
      if (lookahead == 't') ADVANCE(155);
      if (lookahead == 'v') ADVANCE(156);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == 'z') ADVANCE(157);
      END_STATE();
    case 63:
      if (lookahead == 'c') ADVANCE(158);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(159);
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 65:
      if (lookahead == 'b') ADVANCE(161);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(162);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_lt);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(163);
      END_STATE();
    case 69:
      if (lookahead == 'm') ADVANCE(164);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(165);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 72:
      if (lookahead == 'd') ADVANCE(167);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 74:
      if (lookahead == 'l') ADVANCE(170);
      END_STATE();
    case 75:
      if (lookahead == 'w') ADVANCE(171);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 77:
      if (lookahead == 'm') ADVANCE(173);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 80:
      if (lookahead == 'y') ADVANCE(176);
      END_STATE();
    case 81:
      if (lookahead == 'p') ADVANCE(177);
      END_STATE();
    case 82:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 83:
      if (lookahead == 'b') ADVANCE(180);
      if (lookahead == 'r') ADVANCE(181);
      END_STATE();
    case 84:
      if (lookahead == 'c') ADVANCE(182);
      if (lookahead == 't') ADVANCE(183);
      if (lookahead == 'v') ADVANCE(184);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 86:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(187);
      if (lookahead == 'l') ADVANCE(188);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(190);
      if (lookahead == 'r') ADVANCE(191);
      END_STATE();
    case 90:
      if (lookahead == 'g') ADVANCE(192);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(193);
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(195);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(196);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(198);
      if (lookahead == 'o') ADVANCE(199);
      if (lookahead == 'r') ADVANCE(200);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(201);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(202);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(203);
      END_STATE();
    case 99:
      if (lookahead == 'm') ADVANCE(204);
      END_STATE();
    case 100:
      if (lookahead == 'u') ADVANCE(205);
      if (lookahead == 'y') ADVANCE(206);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(207);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(208);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(209);
      END_STATE();
    case 104:
      if (lookahead == 'c') ADVANCE(210);
      if (lookahead == 'i') ADVANCE(211);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 106:
      if (lookahead == 'r') ADVANCE(213);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(214);
      if (lookahead == 'r') ADVANCE(215);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(216);
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 109:
      if (lookahead == 'i') ADVANCE(218);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(220);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(221);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'm') ADVANCE(222);
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 115:
      if (lookahead == 'n') ADVANCE(224);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(225);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 118:
      if (lookahead == 'c') ADVANCE(227);
      END_STATE();
    case 119:
      if (lookahead == 'l') ADVANCE(228);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 124:
      if (lookahead == 'c') ADVANCE(233);
      END_STATE();
    case 125:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 126:
      if (lookahead == 'n') ADVANCE(235);
      END_STATE();
    case 127:
      if (lookahead == 's') ADVANCE(236);
      if (lookahead == 't') ADVANCE(237);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(240);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 132:
      if (lookahead == 'f') ADVANCE(242);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_div);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(244);
      END_STATE();
    case 136:
      if (lookahead == 'm') ADVANCE(245);
      END_STATE();
    case 137:
      if (lookahead == 'o') ADVANCE(246);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(247);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_exp);
      END_STATE();
    case 141:
      if (lookahead == 'c') ADVANCE(249);
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 142:
      if (lookahead == 'l') ADVANCE(251);
      if (lookahead == 's') ADVANCE(252);
      END_STATE();
    case 143:
      if (lookahead == 'n') ADVANCE(253);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(254);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 146:
      if (lookahead == 'm') ADVANCE(255);
      END_STATE();
    case 147:
      if (lookahead == 'c') ADVANCE(256);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_gas);
      if (lookahead == 'l') ADVANCE(257);
      if (lookahead == 'p') ADVANCE(258);
      END_STATE();
    case 149:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_hex);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(260);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(261);
      END_STATE();
    case 153:
      if (lookahead == 'o') ADVANCE(262);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == '1') ADVANCE(264);
      if (lookahead == '2') ADVANCE(265);
      if (lookahead == '3') ADVANCE(266);
      if (lookahead == '4') ADVANCE(267);
      if (lookahead == '5') ADVANCE(268);
      if (lookahead == '6') ADVANCE(269);
      if (lookahead == '7') ADVANCE(270);
      if (lookahead == '8') ADVANCE(271);
      if (lookahead == '9') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(274);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 158:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 159:
      if (lookahead == 'v') ADVANCE(277);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 162:
      if (lookahead == '0') ADVANCE(279);
      if (lookahead == '1') ADVANCE(280);
      if (lookahead == '2') ADVANCE(281);
      if (lookahead == '3') ADVANCE(282);
      if (lookahead == '4') ADVANCE(283);
      END_STATE();
    case 163:
      if (lookahead == 'p') ADVANCE(284);
      END_STATE();
    case 164:
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 165:
      if (lookahead == 'u') ADVANCE(286);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_mod);
      if (lookahead == 'i') ADVANCE(288);
      END_STATE();
    case 168:
      if (lookahead == 'z') ADVANCE(289);
      END_STATE();
    case 169:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_mul);
      if (lookahead == 'm') ADVANCE(291);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 173:
      if (lookahead == 'b') ADVANCE(292);
      END_STATE();
    case 174:
      if (lookahead == 'g') ADVANCE(293);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(294);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(295);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_pop);
      END_STATE();
    case 178:
      if (lookahead == 'g') ADVANCE(296);
      END_STATE();
    case 179:
      if (lookahead == 'v') ADVANCE(297);
      END_STATE();
    case 180:
      if (lookahead == 'l') ADVANCE(298);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 183:
      if (lookahead == 'u') ADVANCE(301);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_sar);
      END_STATE();
    case 186:
      if (lookahead == 'v') ADVANCE(303);
      END_STATE();
    case 187:
      if (lookahead == 'o') ADVANCE(304);
      END_STATE();
    case 188:
      if (lookahead == 'f') ADVANCE(305);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_sgt);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_shr);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 193:
      if (lookahead == 'a') ADVANCE(307);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_slt);
      END_STATE();
    case 195:
      if (lookahead == 'd') ADVANCE(308);
      END_STATE();
    case 196:
      if (lookahead == 'i') ADVANCE(309);
      END_STATE();
    case 197:
      if (lookahead == 'o') ADVANCE(310);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 199:
      if (lookahead == 'p') ADVANCE(312);
      if (lookahead == 'r') ADVANCE(313);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(314);
      if (lookahead == 'u') ADVANCE(315);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(316);
      END_STATE();
    case 203:
      if (lookahead == 'b') ADVANCE(317);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 208:
      if (lookahead == 'x') ADVANCE(321);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 210:
      if (lookahead == 'h') ADVANCE(323);
      END_STATE();
    case 211:
      if (lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 212:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 214:
      if (lookahead == 'w') ADVANCE(326);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(327);
      END_STATE();
    case 216:
      if (lookahead == 'k') ADVANCE(328);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_wei);
      END_STATE();
    case 218:
      if (lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 220:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(331);
      END_STATE();
    case 222:
      if (lookahead == 'o') ADVANCE(332);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 224:
      if (lookahead == 'y') ADVANCE(334);
      END_STATE();
    case 225:
      if (lookahead == 'm') ADVANCE(335);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(336);
      END_STATE();
    case 227:
      if (lookahead == 'k') ADVANCE(337);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 229:
      if (lookahead == 'k') ADVANCE(338);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_byte);
      if (lookahead == 's') ADVANCE(339);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == 'c') ADVANCE(340);
      if (lookahead == 'd') ADVANCE(341);
      if (lookahead == 'e') ADVANCE(342);
      if (lookahead == 'v') ADVANCE(343);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 233:
      if (lookahead == 'h') ADVANCE(344);
      END_STATE();
    case 234:
      if (lookahead == 'n') ADVANCE(345);
      END_STATE();
    case 235:
      if (lookahead == 'b') ADVANCE(346);
      END_STATE();
    case 236:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 237:
      if (lookahead == 'i') ADVANCE(348);
      if (lookahead == 'r') ADVANCE(349);
      END_STATE();
    case 238:
      if (lookahead == 't') ADVANCE(350);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_days);
      END_STATE();
    case 240:
      if (lookahead == 'u') ADVANCE(351);
      END_STATE();
    case 241:
      if (lookahead == 'g') ADVANCE(352);
      if (lookahead == 't') ADVANCE(353);
      END_STATE();
    case 242:
      if (lookahead == 'i') ADVANCE(354);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_emit);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 246:
      if (lookahead == 'r') ADVANCE(355);
      END_STATE();
    case 247:
      if (lookahead == 'r') ADVANCE(356);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(357);
      END_STATE();
    case 249:
      if (lookahead == 'o') ADVANCE(358);
      END_STATE();
    case 250:
      if (lookahead == 'r') ADVANCE(359);
      END_STATE();
    case 251:
      if (lookahead == 'b') ADVANCE(360);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(362);
      END_STATE();
    case 254:
      if (lookahead == 'd') ADVANCE(363);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 257:
      if (lookahead == 'i') ADVANCE(365);
      END_STATE();
    case 258:
      if (lookahead == 'r') ADVANCE(366);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_gwei);
      END_STATE();
    case 260:
      if (lookahead == 's') ADVANCE(367);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(368);
      END_STATE();
    case 262:
      if (lookahead == 'r') ADVANCE(369);
      END_STATE();
    case 263:
      if (lookahead == 'x') ADVANCE(370);
      END_STATE();
    case 264:
      if (lookahead == '0') ADVANCE(371);
      if (lookahead == '1') ADVANCE(372);
      if (lookahead == '2') ADVANCE(373);
      if (lookahead == '3') ADVANCE(374);
      if (lookahead == '4') ADVANCE(375);
      if (lookahead == '5') ADVANCE(376);
      if (lookahead == '6') ADVANCE(377);
      if (lookahead == '7') ADVANCE(378);
      if (lookahead == '8') ADVANCE(379);
      if (lookahead == '9') ADVANCE(380);
      END_STATE();
    case 265:
      if (lookahead == '0') ADVANCE(381);
      if (lookahead == '1') ADVANCE(382);
      if (lookahead == '2') ADVANCE(383);
      if (lookahead == '3') ADVANCE(384);
      if (lookahead == '4') ADVANCE(385);
      if (lookahead == '5') ADVANCE(386);
      END_STATE();
    case 266:
      if (lookahead == '2') ADVANCE(387);
      END_STATE();
    case 267:
      if (lookahead == '0') ADVANCE(388);
      if (lookahead == '8') ADVANCE(389);
      END_STATE();
    case 268:
      if (lookahead == '6') ADVANCE(390);
      END_STATE();
    case 269:
      if (lookahead == '4') ADVANCE(391);
      END_STATE();
    case 270:
      if (lookahead == '2') ADVANCE(392);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_int8);
      if (lookahead == '0') ADVANCE(393);
      if (lookahead == '8') ADVANCE(394);
      END_STATE();
    case 272:
      if (lookahead == '6') ADVANCE(395);
      END_STATE();
    case 273:
      if (lookahead == 'r') ADVANCE(396);
      END_STATE();
    case 274:
      if (lookahead == 'l') ADVANCE(397);
      END_STATE();
    case 275:
      if (lookahead == 'r') ADVANCE(398);
      END_STATE();
    case 276:
      if (lookahead == 'a') ADVANCE(399);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 278:
      if (lookahead == 'a') ADVANCE(401);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_log0);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_log1);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_log2);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_log3);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_log4);
      END_STATE();
    case 284:
      if (lookahead == 'i') ADVANCE(402);
      END_STATE();
    case 285:
      if (lookahead == 'r') ADVANCE(403);
      END_STATE();
    case 286:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(405);
      END_STATE();
    case 288:
      if (lookahead == 'f') ADVANCE(406);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 290:
      if (lookahead == 'r') ADVANCE(408);
      END_STATE();
    case 291:
      if (lookahead == 'o') ADVANCE(409);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(410);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(411);
      END_STATE();
    case 294:
      if (lookahead == 'r') ADVANCE(412);
      END_STATE();
    case 295:
      if (lookahead == 'b') ADVANCE(413);
      END_STATE();
    case 296:
      if (lookahead == 'm') ADVANCE(414);
      END_STATE();
    case 297:
      if (lookahead == 'a') ADVANCE(415);
      END_STATE();
    case 298:
      if (lookahead == 'i') ADVANCE(416);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_pure);
      END_STATE();
    case 300:
      if (lookahead == 'i') ADVANCE(417);
      END_STATE();
    case 301:
      if (lookahead == 'r') ADVANCE(418);
      END_STATE();
    case 302:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_sdiv);
      END_STATE();
    case 304:
      if (lookahead == 'n') ADVANCE(420);
      END_STATE();
    case 305:
      if (lookahead == 'b') ADVANCE(421);
      if (lookahead == 'd') ADVANCE(422);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 307:
      if (lookahead == 'd') ADVANCE(424);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_smod);
      END_STATE();
    case 309:
      if (lookahead == 'd') ADVANCE(425);
      END_STATE();
    case 310:
      if (lookahead == 'r') ADVANCE(426);
      END_STATE();
    case 311:
      if (lookahead == 'i') ADVANCE(427);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_stop);
      END_STATE();
    case 313:
      if (lookahead == 'a') ADVANCE(428);
      END_STATE();
    case 314:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 315:
      if (lookahead == 'c') ADVANCE(430);
      END_STATE();
    case 316:
      if (lookahead == 'c') ADVANCE(431);
      END_STATE();
    case 317:
      if (lookahead == 'o') ADVANCE(432);
      END_STATE();
    case 318:
      if (lookahead == 's') ADVANCE(433);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_uint);
      if (lookahead == '1') ADVANCE(435);
      if (lookahead == '2') ADVANCE(436);
      if (lookahead == '3') ADVANCE(437);
      if (lookahead == '4') ADVANCE(438);
      if (lookahead == '5') ADVANCE(439);
      if (lookahead == '6') ADVANCE(440);
      if (lookahead == '7') ADVANCE(441);
      if (lookahead == '8') ADVANCE(442);
      if (lookahead == '9') ADVANCE(443);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(444);
      END_STATE();
    case 324:
      if (lookahead == 'o') ADVANCE(445);
      END_STATE();
    case 325:
      if (lookahead == 'g') ADVANCE(446);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_view);
      END_STATE();
    case 327:
      if (lookahead == 'u') ADVANCE(447);
      END_STATE();
    case 328:
      if (lookahead == 's') ADVANCE(448);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(449);
      END_STATE();
    case 330:
      if (lookahead == 's') ADVANCE(450);
      END_STATE();
    case 331:
      if (lookahead == 'a') ADVANCE(451);
      END_STATE();
    case 332:
      if (lookahead == 'd') ADVANCE(452);
      END_STATE();
    case 333:
      if (lookahead == 's') ADVANCE(453);
      END_STATE();
    case 334:
      if (lookahead == 'm') ADVANCE(454);
      END_STATE();
    case 335:
      if (lookahead == 'b') ADVANCE(455);
      END_STATE();
    case 336:
      if (lookahead == 'c') ADVANCE(456);
      END_STATE();
    case 337:
      if (lookahead == 'h') ADVANCE(457);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_bytes);
      if (lookahead == '1') ADVANCE(458);
      if (lookahead == '2') ADVANCE(459);
      if (lookahead == '3') ADVANCE(460);
      if (lookahead == '4') ADVANCE(461);
      if (lookahead == '5') ADVANCE(462);
      if (lookahead == '6') ADVANCE(463);
      if (lookahead == '7') ADVANCE(464);
      if (lookahead == '8') ADVANCE(465);
      if (lookahead == '9') ADVANCE(466);
      END_STATE();
    case 340:
      if (lookahead == 'o') ADVANCE(467);
      END_STATE();
    case 341:
      if (lookahead == 'a') ADVANCE(468);
      END_STATE();
    case 342:
      if (lookahead == 'r') ADVANCE(469);
      END_STATE();
    case 343:
      if (lookahead == 'a') ADVANCE(470);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 345:
      if (lookahead == 'i') ADVANCE(471);
      END_STATE();
    case 346:
      if (lookahead == 'a') ADVANCE(472);
      END_STATE();
    case 347:
      if (lookahead == 'a') ADVANCE(473);
      if (lookahead == 'r') ADVANCE(474);
      END_STATE();
    case 348:
      if (lookahead == 'n') ADVANCE(475);
      END_STATE();
    case 349:
      if (lookahead == 'a') ADVANCE(476);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 351:
      if (lookahead == 'l') ADVANCE(478);
      END_STATE();
    case 352:
      if (lookahead == 'a') ADVANCE(479);
      END_STATE();
    case 353:
      if (lookahead == 'e') ADVANCE(480);
      END_STATE();
    case 354:
      if (lookahead == 'c') ADVANCE(481);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_ether);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 358:
      if (lookahead == 'd') ADVANCE(482);
      END_STATE();
    case 359:
      if (lookahead == 'n') ADVANCE(483);
      END_STATE();
    case 360:
      if (lookahead == 'a') ADVANCE(484);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 362:
      if (lookahead == 'y') ADVANCE(485);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_fixed);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(486);
      END_STATE();
    case 364:
      if (lookahead == 'i') ADVANCE(487);
      END_STATE();
    case 365:
      if (lookahead == 'm') ADVANCE(488);
      END_STATE();
    case 366:
      if (lookahead == 'i') ADVANCE(489);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_hours);
      END_STATE();
    case 368:
      if (lookahead == 'a') ADVANCE(490);
      END_STATE();
    case 369:
      if (lookahead == 't') ADVANCE(491);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(492);
      END_STATE();
    case 371:
      if (lookahead == '4') ADVANCE(493);
      END_STATE();
    case 372:
      if (lookahead == '2') ADVANCE(494);
      END_STATE();
    case 373:
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '8') ADVANCE(496);
      END_STATE();
    case 374:
      if (lookahead == '6') ADVANCE(497);
      END_STATE();
    case 375:
      if (lookahead == '4') ADVANCE(498);
      END_STATE();
    case 376:
      if (lookahead == '2') ADVANCE(499);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_int16);
      if (lookahead == '0') ADVANCE(500);
      if (lookahead == '8') ADVANCE(501);
      END_STATE();
    case 378:
      if (lookahead == '6') ADVANCE(502);
      END_STATE();
    case 379:
      if (lookahead == '4') ADVANCE(503);
      END_STATE();
    case 380:
      if (lookahead == '2') ADVANCE(504);
      END_STATE();
    case 381:
      if (lookahead == '0') ADVANCE(505);
      if (lookahead == '8') ADVANCE(506);
      END_STATE();
    case 382:
      if (lookahead == '6') ADVANCE(507);
      END_STATE();
    case 383:
      if (lookahead == '4') ADVANCE(508);
      END_STATE();
    case 384:
      if (lookahead == '2') ADVANCE(509);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_int24);
      if (lookahead == '0') ADVANCE(510);
      if (lookahead == '8') ADVANCE(511);
      END_STATE();
    case 386:
      if (lookahead == '6') ADVANCE(512);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_int32);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_int40);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_int48);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_int56);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_int64);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_int72);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_int80);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_int88);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_int96);
      END_STATE();
    case 396:
      if (lookahead == 'f') ADVANCE(513);
      if (lookahead == 'n') ADVANCE(514);
      END_STATE();
    case 397:
      if (lookahead == 'i') ADVANCE(515);
      END_STATE();
    case 398:
      if (lookahead == 'o') ADVANCE(516);
      END_STATE();
    case 399:
      if (lookahead == 'k') ADVANCE(517);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_yul_leave);
      END_STATE();
    case 401:
      if (lookahead == 'r') ADVANCE(518);
      END_STATE();
    case 402:
      if (lookahead == 'n') ADVANCE(519);
      END_STATE();
    case 403:
      if (lookahead == 'y') ADVANCE(520);
      END_STATE();
    case 404:
      if (lookahead == 'e') ADVANCE(521);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_mload);
      END_STATE();
    case 406:
      if (lookahead == 'i') ADVANCE(522);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_msize);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(523);
      END_STATE();
    case 409:
      if (lookahead == 'd') ADVANCE(524);
      END_STATE();
    case 410:
      if (lookahead == 'r') ADVANCE(525);
      END_STATE();
    case 411:
      if (lookahead == 'n') ADVANCE(526);
      END_STATE();
    case 412:
      if (lookahead == 'i') ADVANCE(527);
      END_STATE();
    case 413:
      if (lookahead == 'l') ADVANCE(528);
      END_STATE();
    case 414:
      if (lookahead == 'a') ADVANCE(529);
      END_STATE();
    case 415:
      if (lookahead == 't') ADVANCE(530);
      END_STATE();
    case 416:
      if (lookahead == 'c') ADVANCE(531);
      END_STATE();
    case 417:
      if (lookahead == 'v') ADVANCE(532);
      END_STATE();
    case 418:
      if (lookahead == 'n') ADVANCE(533);
      END_STATE();
    case 419:
      if (lookahead == 't') ADVANCE(534);
      END_STATE();
    case 420:
      if (lookahead == 'd') ADVANCE(535);
      END_STATE();
    case 421:
      if (lookahead == 'a') ADVANCE(536);
      END_STATE();
    case 422:
      if (lookahead == 'e') ADVANCE(537);
      END_STATE();
    case 423:
      if (lookahead == 'x') ADVANCE(538);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_sload);
      END_STATE();
    case 425:
      if (lookahead == 'i') ADVANCE(539);
      END_STATE();
    case 426:
      if (lookahead == 'e') ADVANCE(540);
      END_STATE();
    case 427:
      if (lookahead == 'c') ADVANCE(541);
      END_STATE();
    case 428:
      if (lookahead == 'g') ADVANCE(542);
      END_STATE();
    case 429:
      if (lookahead == 'g') ADVANCE(543);
      END_STATE();
    case 430:
      if (lookahead == 't') ADVANCE(544);
      END_STATE();
    case 431:
      if (lookahead == 'h') ADVANCE(545);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_szabo);
      END_STATE();
    case 433:
      if (lookahead == 't') ADVANCE(546);
      END_STATE();
    case 434:
      if (lookahead == 'd') ADVANCE(547);
      END_STATE();
    case 435:
      if (lookahead == '0') ADVANCE(548);
      if (lookahead == '1') ADVANCE(549);
      if (lookahead == '2') ADVANCE(550);
      if (lookahead == '3') ADVANCE(551);
      if (lookahead == '4') ADVANCE(552);
      if (lookahead == '5') ADVANCE(553);
      if (lookahead == '6') ADVANCE(554);
      if (lookahead == '7') ADVANCE(555);
      if (lookahead == '8') ADVANCE(556);
      if (lookahead == '9') ADVANCE(557);
      END_STATE();
    case 436:
      if (lookahead == '0') ADVANCE(558);
      if (lookahead == '1') ADVANCE(559);
      if (lookahead == '2') ADVANCE(560);
      if (lookahead == '3') ADVANCE(561);
      if (lookahead == '4') ADVANCE(562);
      if (lookahead == '5') ADVANCE(563);
      END_STATE();
    case 437:
      if (lookahead == '2') ADVANCE(564);
      END_STATE();
    case 438:
      if (lookahead == '0') ADVANCE(565);
      if (lookahead == '8') ADVANCE(566);
      END_STATE();
    case 439:
      if (lookahead == '6') ADVANCE(567);
      END_STATE();
    case 440:
      if (lookahead == '4') ADVANCE(568);
      END_STATE();
    case 441:
      if (lookahead == '2') ADVANCE(569);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_uint8);
      if (lookahead == '0') ADVANCE(570);
      if (lookahead == '8') ADVANCE(571);
      END_STATE();
    case 443:
      if (lookahead == '6') ADVANCE(572);
      END_STATE();
    case 444:
      if (lookahead == 'c') ADVANCE(573);
      END_STATE();
    case 445:
      if (lookahead == 'd') ADVANCE(574);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 447:
      if (lookahead == 'a') ADVANCE(575);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_weeks);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_years);
      END_STATE();
    case 451:
      if (lookahead == 'c') ADVANCE(576);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_addmod);
      END_STATE();
    case 453:
      if (lookahead == 's') ADVANCE(577);
      END_STATE();
    case 454:
      if (lookahead == 'o') ADVANCE(578);
      END_STATE();
    case 455:
      if (lookahead == 'l') ADVANCE(579);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(580);
      END_STATE();
    case 457:
      if (lookahead == 'a') ADVANCE(581);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_bytes1);
      if (lookahead == '0') ADVANCE(582);
      if (lookahead == '1') ADVANCE(583);
      if (lookahead == '2') ADVANCE(584);
      if (lookahead == '3') ADVANCE(585);
      if (lookahead == '4') ADVANCE(586);
      if (lookahead == '5') ADVANCE(587);
      if (lookahead == '6') ADVANCE(588);
      if (lookahead == '7') ADVANCE(589);
      if (lookahead == '8') ADVANCE(590);
      if (lookahead == '9') ADVANCE(591);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_bytes2);
      if (lookahead == '0') ADVANCE(592);
      if (lookahead == '1') ADVANCE(593);
      if (lookahead == '2') ADVANCE(594);
      if (lookahead == '3') ADVANCE(595);
      if (lookahead == '4') ADVANCE(596);
      if (lookahead == '5') ADVANCE(597);
      if (lookahead == '6') ADVANCE(598);
      if (lookahead == '7') ADVANCE(599);
      if (lookahead == '8') ADVANCE(600);
      if (lookahead == '9') ADVANCE(601);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_bytes3);
      if (lookahead == '0') ADVANCE(602);
      if (lookahead == '1') ADVANCE(603);
      if (lookahead == '2') ADVANCE(604);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_bytes4);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_bytes5);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_bytes6);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_bytes7);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_bytes8);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_bytes9);
      END_STATE();
    case 467:
      if (lookahead == 'd') ADVANCE(605);
      END_STATE();
    case 468:
      if (lookahead == 't') ADVANCE(606);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_caller);
      END_STATE();
    case 470:
      if (lookahead == 'l') ADVANCE(607);
      END_STATE();
    case 471:
      if (lookahead == 'd') ADVANCE(608);
      END_STATE();
    case 472:
      if (lookahead == 's') ADVANCE(609);
      END_STATE();
    case 473:
      if (lookahead == 'n') ADVANCE(610);
      END_STATE();
    case 474:
      if (lookahead == 'u') ADVANCE(611);
      END_STATE();
    case 475:
      if (lookahead == 'u') ADVANCE(612);
      END_STATE();
    case 476:
      if (lookahead == 'c') ADVANCE(613);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_create);
      if (lookahead == '2') ADVANCE(614);
      END_STATE();
    case 478:
      if (lookahead == 't') ADVANCE(615);
      END_STATE();
    case 479:
      if (lookahead == 't') ADVANCE(616);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 481:
      if (lookahead == 'u') ADVANCE(617);
      END_STATE();
    case 482:
      if (lookahead == 'e') ADVANCE(618);
      END_STATE();
    case 483:
      if (lookahead == 'a') ADVANCE(619);
      END_STATE();
    case 484:
      if (lookahead == 'c') ADVANCE(620);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_finney);
      END_STATE();
    case 486:
      if (lookahead == 'x') ADVANCE(621);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(486);
      END_STATE();
    case 487:
      if (lookahead == 'o') ADVANCE(622);
      END_STATE();
    case 488:
      if (lookahead == 'i') ADVANCE(623);
      END_STATE();
    case 489:
      if (lookahead == 'c') ADVANCE(624);
      END_STATE();
    case 490:
      if (lookahead == 'b') ADVANCE(625);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 492:
      if (lookahead == 'd') ADVANCE(626);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_int104);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_int112);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_int120);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_int128);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_int136);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_int144);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_int152);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_int160);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_int168);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_int176);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_int184);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_int192);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_int200);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_int208);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_int216);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_int224);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_int232);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_int240);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_int248);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_int256);
      END_STATE();
    case 513:
      if (lookahead == 'a') ADVANCE(627);
      END_STATE();
    case 514:
      if (lookahead == 'a') ADVANCE(628);
      END_STATE();
    case 515:
      if (lookahead == 'd') ADVANCE(629);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_iszero);
      END_STATE();
    case 517:
      if (lookahead == '2') ADVANCE(630);
      END_STATE();
    case 518:
      if (lookahead == 'y') ADVANCE(631);
      END_STATE();
    case 519:
      if (lookahead == 'g') ADVANCE(632);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_memory);
      END_STATE();
    case 521:
      if (lookahead == 's') ADVANCE(633);
      END_STATE();
    case 522:
      if (lookahead == 'e') ADVANCE(634);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_mstore);
      if (lookahead == '8') ADVANCE(635);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_mulmod);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_origin);
      END_STATE();
    case 527:
      if (lookahead == 'd') ADVANCE(636);
      END_STATE();
    case 528:
      if (lookahead == 'e') ADVANCE(637);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_pragma);
      END_STATE();
    case 530:
      if (lookahead == 'e') ADVANCE(638);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 532:
      if (lookahead == 'e') ADVANCE(639);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_return);
      if (lookahead == 'd') ADVANCE(640);
      if (lookahead == 's') ADVANCE(641);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_revert);
      END_STATE();
    case 535:
      if (lookahead == 's') ADVANCE(642);
      END_STATE();
    case 536:
      if (lookahead == 'l') ADVANCE(643);
      END_STATE();
    case 537:
      if (lookahead == 's') ADVANCE(644);
      END_STATE();
    case 538:
      if (lookahead == 't') ADVANCE(645);
      END_STATE();
    case 539:
      if (lookahead == 't') ADVANCE(646);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_sstore);
      END_STATE();
    case 541:
      if (lookahead == 'c') ADVANCE(647);
      END_STATE();
    case 542:
      if (lookahead == 'e') ADVANCE(648);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 546:
      if (lookahead == 'a') ADVANCE(649);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_ufixed);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(650);
      END_STATE();
    case 548:
      if (lookahead == '4') ADVANCE(651);
      END_STATE();
    case 549:
      if (lookahead == '2') ADVANCE(652);
      END_STATE();
    case 550:
      if (lookahead == '0') ADVANCE(653);
      if (lookahead == '8') ADVANCE(654);
      END_STATE();
    case 551:
      if (lookahead == '6') ADVANCE(655);
      END_STATE();
    case 552:
      if (lookahead == '4') ADVANCE(656);
      END_STATE();
    case 553:
      if (lookahead == '2') ADVANCE(657);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_uint16);
      if (lookahead == '0') ADVANCE(658);
      if (lookahead == '8') ADVANCE(659);
      END_STATE();
    case 555:
      if (lookahead == '6') ADVANCE(660);
      END_STATE();
    case 556:
      if (lookahead == '4') ADVANCE(661);
      END_STATE();
    case 557:
      if (lookahead == '2') ADVANCE(662);
      END_STATE();
    case 558:
      if (lookahead == '0') ADVANCE(663);
      if (lookahead == '8') ADVANCE(664);
      END_STATE();
    case 559:
      if (lookahead == '6') ADVANCE(665);
      END_STATE();
    case 560:
      if (lookahead == '4') ADVANCE(666);
      END_STATE();
    case 561:
      if (lookahead == '2') ADVANCE(667);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_uint24);
      if (lookahead == '0') ADVANCE(668);
      if (lookahead == '8') ADVANCE(669);
      END_STATE();
    case 563:
      if (lookahead == '6') ADVANCE(670);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_uint32);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_uint40);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_uint48);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_uint56);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_uint64);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_uint72);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_uint80);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_uint88);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_uint96);
      END_STATE();
    case 573:
      if (lookahead == 'k') ADVANCE(671);
      END_STATE();
    case 574:
      if (lookahead == 'e') ADVANCE(672);
      END_STATE();
    case 575:
      if (lookahead == 'l') ADVANCE(673);
      END_STATE();
    case 576:
      if (lookahead == 't') ADVANCE(674);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_address);
      END_STATE();
    case 578:
      if (lookahead == 'u') ADVANCE(675);
      END_STATE();
    case 579:
      if (lookahead == 'y') ADVANCE(676);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_balance);
      END_STATE();
    case 581:
      if (lookahead == 's') ADVANCE(677);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_bytes10);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_bytes11);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_bytes12);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_bytes13);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_bytes14);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_bytes15);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_bytes16);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_bytes17);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_bytes18);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_bytes19);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_bytes20);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_bytes21);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_bytes22);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_bytes23);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_bytes24);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_bytes25);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_bytes26);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_bytes27);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_bytes28);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_bytes29);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_bytes30);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_bytes31);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_bytes32);
      END_STATE();
    case 605:
      if (lookahead == 'e') ADVANCE(678);
      END_STATE();
    case 606:
      if (lookahead == 'a') ADVANCE(679);
      END_STATE();
    case 607:
      if (lookahead == 'u') ADVANCE(680);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_chainid);
      END_STATE();
    case 609:
      if (lookahead == 'e') ADVANCE(681);
      END_STATE();
    case 610:
      if (lookahead == 't') ADVANCE(682);
      END_STATE();
    case 611:
      if (lookahead == 'c') ADVANCE(683);
      END_STATE();
    case 612:
      if (lookahead == 'e') ADVANCE(684);
      END_STATE();
    case 613:
      if (lookahead == 't') ADVANCE(685);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_create2);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 616:
      if (lookahead == 'e') ADVANCE(686);
      END_STATE();
    case 617:
      if (lookahead == 'l') ADVANCE(687);
      END_STATE();
    case 618:
      if (lookahead == 'c') ADVANCE(688);
      if (lookahead == 'h') ADVANCE(689);
      if (lookahead == 's') ADVANCE(690);
      END_STATE();
    case 619:
      if (lookahead == 'l') ADVANCE(691);
      END_STATE();
    case 620:
      if (lookahead == 'k') ADVANCE(692);
      END_STATE();
    case 621:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(693);
      END_STATE();
    case 622:
      if (lookahead == 'n') ADVANCE(694);
      END_STATE();
    case 623:
      if (lookahead == 't') ADVANCE(695);
      END_STATE();
    case 624:
      if (lookahead == 'e') ADVANCE(696);
      END_STATE();
    case 625:
      if (lookahead == 'l') ADVANCE(697);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_indexed);
      END_STATE();
    case 627:
      if (lookahead == 'c') ADVANCE(698);
      END_STATE();
    case 628:
      if (lookahead == 'l') ADVANCE(699);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym_invalid);
      END_STATE();
    case 630:
      if (lookahead == '5') ADVANCE(700);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_library);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_mapping);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(anon_sym_minutes);
      END_STATE();
    case 634:
      if (lookahead == 'r') ADVANCE(701);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(anon_sym_mstore8);
      END_STATE();
    case 636:
      if (lookahead == 'e') ADVANCE(702);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(anon_sym_payable);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym_receive);
      END_STATE();
    case 640:
      if (lookahead == 'a') ADVANCE(703);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(anon_sym_returns);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(anon_sym_seconds);
      END_STATE();
    case 643:
      if (lookahead == 'a') ADVANCE(704);
      END_STATE();
    case 644:
      if (lookahead == 't') ADVANCE(705);
      END_STATE();
    case 645:
      if (lookahead == 'e') ADVANCE(706);
      END_STATE();
    case 646:
      if (lookahead == 'y') ADVANCE(707);
      END_STATE();
    case 647:
      if (lookahead == 'a') ADVANCE(708);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_storage);
      END_STATE();
    case 649:
      if (lookahead == 'm') ADVANCE(709);
      END_STATE();
    case 650:
      if (lookahead == 'x') ADVANCE(710);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(650);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_uint104);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym_uint112);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym_uint120);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym_uint128);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_uint136);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(anon_sym_uint144);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym_uint152);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym_uint160);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(anon_sym_uint168);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(anon_sym_uint176);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(anon_sym_uint184);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_uint192);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(anon_sym_uint200);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(anon_sym_uint208);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(anon_sym_uint216);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym_uint224);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(anon_sym_uint232);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(anon_sym_uint240);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(anon_sym_uint248);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(anon_sym_uint256);
      END_STATE();
    case 671:
      if (lookahead == 'e') ADVANCE(711);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(anon_sym_unicode);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_virtual);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 675:
      if (lookahead == 's') ADVANCE(712);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 677:
      if (lookahead == 'h') ADVANCE(713);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(anon_sym_callcode);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(anon_sym_calldata);
      if (lookahead == 'c') ADVANCE(714);
      if (lookahead == 'l') ADVANCE(715);
      if (lookahead == 's') ADVANCE(716);
      END_STATE();
    case 680:
      if (lookahead == 'e') ADVANCE(717);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(anon_sym_coinbase);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(anon_sym_constant);
      END_STATE();
    case 683:
      if (lookahead == 't') ADVANCE(718);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(anon_sym_contract);
      END_STATE();
    case 686:
      if (lookahead == 'c') ADVANCE(719);
      END_STATE();
    case 687:
      if (lookahead == 't') ADVANCE(720);
      END_STATE();
    case 688:
      if (lookahead == 'o') ADVANCE(721);
      END_STATE();
    case 689:
      if (lookahead == 'a') ADVANCE(722);
      END_STATE();
    case 690:
      if (lookahead == 'i') ADVANCE(723);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(anon_sym_fallback);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(aux_sym__fixed_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(693);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(anon_sym_gaslimit);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(anon_sym_gasprice);
      END_STATE();
    case 697:
      if (lookahead == 'e') ADVANCE(724);
      END_STATE();
    case 698:
      if (lookahead == 'e') ADVANCE(725);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 700:
      if (lookahead == '6') ADVANCE(726);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(anon_sym_modifier);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 703:
      if (lookahead == 't') ADVANCE(727);
      END_STATE();
    case 704:
      if (lookahead == 'n') ADVANCE(728);
      END_STATE();
    case 705:
      if (lookahead == 'r') ADVANCE(729);
      END_STATE();
    case 706:
      if (lookahead == 'n') ADVANCE(730);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(anon_sym_solidity);
      END_STATE();
    case 708:
      if (lookahead == 'l') ADVANCE(731);
      END_STATE();
    case 709:
      if (lookahead == 'p') ADVANCE(732);
      END_STATE();
    case 710:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(733);
      END_STATE();
    case 711:
      if (lookahead == 'd') ADVANCE(734);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(anon_sym_anonymous);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(anon_sym_blockhash);
      END_STATE();
    case 714:
      if (lookahead == 'o') ADVANCE(735);
      END_STATE();
    case 715:
      if (lookahead == 'o') ADVANCE(736);
      END_STATE();
    case 716:
      if (lookahead == 'i') ADVANCE(737);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(anon_sym_callvalue);
      END_STATE();
    case 718:
      if (lookahead == 'o') ADVANCE(738);
      END_STATE();
    case 719:
      if (lookahead == 'a') ADVANCE(739);
      END_STATE();
    case 720:
      if (lookahead == 'y') ADVANCE(740);
      END_STATE();
    case 721:
      if (lookahead == 'p') ADVANCE(741);
      END_STATE();
    case 722:
      if (lookahead == 's') ADVANCE(742);
      END_STATE();
    case 723:
      if (lookahead == 'z') ADVANCE(743);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym_immutable);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(anon_sym_keccak256);
      END_STATE();
    case 727:
      if (lookahead == 'a') ADVANCE(744);
      END_STATE();
    case 728:
      if (lookahead == 'c') ADVANCE(745);
      END_STATE();
    case 729:
      if (lookahead == 'u') ADVANCE(746);
      END_STATE();
    case 730:
      if (lookahead == 'd') ADVANCE(747);
      END_STATE();
    case 731:
      if (lookahead == 'l') ADVANCE(748);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(anon_sym_timestamp);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(aux_sym__ufixed_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(733);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_unchecked);
      END_STATE();
    case 735:
      if (lookahead == 'p') ADVANCE(749);
      END_STATE();
    case 736:
      if (lookahead == 'a') ADVANCE(750);
      END_STATE();
    case 737:
      if (lookahead == 'z') ADVANCE(751);
      END_STATE();
    case 738:
      if (lookahead == 'r') ADVANCE(752);
      END_STATE();
    case 739:
      if (lookahead == 'l') ADVANCE(753);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(anon_sym_difficulty);
      END_STATE();
    case 741:
      if (lookahead == 'y') ADVANCE(754);
      END_STATE();
    case 742:
      if (lookahead == 'h') ADVANCE(755);
      END_STATE();
    case 743:
      if (lookahead == 'e') ADVANCE(756);
      END_STATE();
    case 744:
      if (lookahead == 'c') ADVANCE(757);
      if (lookahead == 's') ADVANCE(758);
      END_STATE();
    case 745:
      if (lookahead == 'e') ADVANCE(759);
      END_STATE();
    case 746:
      if (lookahead == 'c') ADVANCE(760);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(anon_sym_signextend);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(anon_sym_staticcall);
      END_STATE();
    case 749:
      if (lookahead == 'y') ADVANCE(761);
      END_STATE();
    case 750:
      if (lookahead == 'd') ADVANCE(762);
      END_STATE();
    case 751:
      if (lookahead == 'e') ADVANCE(763);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    case 753:
      if (lookahead == 'l') ADVANCE(764);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(anon_sym_extcodecopy);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(anon_sym_extcodehash);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(anon_sym_extcodesize);
      END_STATE();
    case 757:
      if (lookahead == 'o') ADVANCE(765);
      END_STATE();
    case 758:
      if (lookahead == 'i') ADVANCE(766);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(anon_sym_selfbalance);
      END_STATE();
    case 760:
      if (lookahead == 't') ADVANCE(767);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(anon_sym_calldatacopy);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(anon_sym_calldataload);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(anon_sym_calldatasize);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(anon_sym_delegatecall);
      END_STATE();
    case 765:
      if (lookahead == 'p') ADVANCE(768);
      END_STATE();
    case 766:
      if (lookahead == 'z') ADVANCE(769);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(anon_sym_selfdestruct);
      END_STATE();
    case 768:
      if (lookahead == 'y') ADVANCE(770);
      END_STATE();
    case 769:
      if (lookahead == 'e') ADVANCE(771);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(anon_sym_returndatacopy);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(anon_sym_returndatasize);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 50},
  [2] = {.lex_state = 11},
  [3] = {.lex_state = 11},
  [4] = {.lex_state = 11},
  [5] = {.lex_state = 11},
  [6] = {.lex_state = 11},
  [7] = {.lex_state = 11},
  [8] = {.lex_state = 11},
  [9] = {.lex_state = 11},
  [10] = {.lex_state = 11},
  [11] = {.lex_state = 11},
  [12] = {.lex_state = 11},
  [13] = {.lex_state = 11},
  [14] = {.lex_state = 11},
  [15] = {.lex_state = 11},
  [16] = {.lex_state = 11},
  [17] = {.lex_state = 11},
  [18] = {.lex_state = 11},
  [19] = {.lex_state = 11},
  [20] = {.lex_state = 11},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 11},
  [24] = {.lex_state = 11},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 11},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 11},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 11},
  [38] = {.lex_state = 11},
  [39] = {.lex_state = 11},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 11},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 11},
  [44] = {.lex_state = 11},
  [45] = {.lex_state = 11},
  [46] = {.lex_state = 11},
  [47] = {.lex_state = 11},
  [48] = {.lex_state = 11},
  [49] = {.lex_state = 11},
  [50] = {.lex_state = 11},
  [51] = {.lex_state = 11},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 11},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 11},
  [56] = {.lex_state = 11},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 11},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 11},
  [62] = {.lex_state = 11},
  [63] = {.lex_state = 11},
  [64] = {.lex_state = 11},
  [65] = {.lex_state = 11},
  [66] = {.lex_state = 11},
  [67] = {.lex_state = 11},
  [68] = {.lex_state = 11},
  [69] = {.lex_state = 11},
  [70] = {.lex_state = 11},
  [71] = {.lex_state = 11},
  [72] = {.lex_state = 50},
  [73] = {.lex_state = 50},
  [74] = {.lex_state = 11},
  [75] = {.lex_state = 11},
  [76] = {.lex_state = 11},
  [77] = {.lex_state = 11},
  [78] = {.lex_state = 11},
  [79] = {.lex_state = 11},
  [80] = {.lex_state = 11},
  [81] = {.lex_state = 11},
  [82] = {.lex_state = 11},
  [83] = {.lex_state = 11},
  [84] = {.lex_state = 11},
  [85] = {.lex_state = 50},
  [86] = {.lex_state = 50},
  [87] = {.lex_state = 11},
  [88] = {.lex_state = 11},
  [89] = {.lex_state = 11},
  [90] = {.lex_state = 11},
  [91] = {.lex_state = 11},
  [92] = {.lex_state = 11},
  [93] = {.lex_state = 11},
  [94] = {.lex_state = 11},
  [95] = {.lex_state = 11},
  [96] = {.lex_state = 11},
  [97] = {.lex_state = 11},
  [98] = {.lex_state = 11},
  [99] = {.lex_state = 11},
  [100] = {.lex_state = 11},
  [101] = {.lex_state = 50},
  [102] = {.lex_state = 11},
  [103] = {.lex_state = 11},
  [104] = {.lex_state = 50},
  [105] = {.lex_state = 50},
  [106] = {.lex_state = 50},
  [107] = {.lex_state = 50},
  [108] = {.lex_state = 50},
  [109] = {.lex_state = 50},
  [110] = {.lex_state = 50},
  [111] = {.lex_state = 50},
  [112] = {.lex_state = 50},
  [113] = {.lex_state = 50},
  [114] = {.lex_state = 50},
  [115] = {.lex_state = 50},
  [116] = {.lex_state = 50},
  [117] = {.lex_state = 50},
  [118] = {.lex_state = 50},
  [119] = {.lex_state = 50},
  [120] = {.lex_state = 50},
  [121] = {.lex_state = 50},
  [122] = {.lex_state = 50},
  [123] = {.lex_state = 50},
  [124] = {.lex_state = 50},
  [125] = {.lex_state = 50},
  [126] = {.lex_state = 50},
  [127] = {.lex_state = 50},
  [128] = {.lex_state = 50},
  [129] = {.lex_state = 50},
  [130] = {.lex_state = 50},
  [131] = {.lex_state = 50},
  [132] = {.lex_state = 50},
  [133] = {.lex_state = 50},
  [134] = {.lex_state = 50},
  [135] = {.lex_state = 50},
  [136] = {.lex_state = 50},
  [137] = {.lex_state = 50},
  [138] = {.lex_state = 50},
  [139] = {.lex_state = 50},
  [140] = {.lex_state = 50},
  [141] = {.lex_state = 50},
  [142] = {.lex_state = 50},
  [143] = {.lex_state = 50},
  [144] = {.lex_state = 50},
  [145] = {.lex_state = 50},
  [146] = {.lex_state = 50},
  [147] = {.lex_state = 50},
  [148] = {.lex_state = 50},
  [149] = {.lex_state = 50},
  [150] = {.lex_state = 50},
  [151] = {.lex_state = 50},
  [152] = {.lex_state = 50},
  [153] = {.lex_state = 50},
  [154] = {.lex_state = 50},
  [155] = {.lex_state = 50},
  [156] = {.lex_state = 50},
  [157] = {.lex_state = 50},
  [158] = {.lex_state = 50},
  [159] = {.lex_state = 50},
  [160] = {.lex_state = 50},
  [161] = {.lex_state = 50},
  [162] = {.lex_state = 50},
  [163] = {.lex_state = 50},
  [164] = {.lex_state = 50},
  [165] = {.lex_state = 50},
  [166] = {.lex_state = 50},
  [167] = {.lex_state = 50},
  [168] = {.lex_state = 50},
  [169] = {.lex_state = 50},
  [170] = {.lex_state = 50},
  [171] = {.lex_state = 50},
  [172] = {.lex_state = 50},
  [173] = {.lex_state = 50},
  [174] = {.lex_state = 50},
  [175] = {.lex_state = 50},
  [176] = {.lex_state = 50},
  [177] = {.lex_state = 50},
  [178] = {.lex_state = 50},
  [179] = {.lex_state = 50},
  [180] = {.lex_state = 50},
  [181] = {.lex_state = 50},
  [182] = {.lex_state = 50},
  [183] = {.lex_state = 50},
  [184] = {.lex_state = 50},
  [185] = {.lex_state = 50},
  [186] = {.lex_state = 50},
  [187] = {.lex_state = 50},
  [188] = {.lex_state = 50},
  [189] = {.lex_state = 50},
  [190] = {.lex_state = 50},
  [191] = {.lex_state = 50},
  [192] = {.lex_state = 50},
  [193] = {.lex_state = 50},
  [194] = {.lex_state = 50},
  [195] = {.lex_state = 50},
  [196] = {.lex_state = 50},
  [197] = {.lex_state = 50},
  [198] = {.lex_state = 50},
  [199] = {.lex_state = 50},
  [200] = {.lex_state = 50},
  [201] = {.lex_state = 50},
  [202] = {.lex_state = 50},
  [203] = {.lex_state = 50},
  [204] = {.lex_state = 50},
  [205] = {.lex_state = 50},
  [206] = {.lex_state = 50},
  [207] = {.lex_state = 50},
  [208] = {.lex_state = 50},
  [209] = {.lex_state = 50},
  [210] = {.lex_state = 50},
  [211] = {.lex_state = 50},
  [212] = {.lex_state = 50},
  [213] = {.lex_state = 50},
  [214] = {.lex_state = 50},
  [215] = {.lex_state = 50},
  [216] = {.lex_state = 50},
  [217] = {.lex_state = 50},
  [218] = {.lex_state = 50},
  [219] = {.lex_state = 50},
  [220] = {.lex_state = 50},
  [221] = {.lex_state = 50},
  [222] = {.lex_state = 50},
  [223] = {.lex_state = 50},
  [224] = {.lex_state = 50},
  [225] = {.lex_state = 50},
  [226] = {.lex_state = 50},
  [227] = {.lex_state = 50},
  [228] = {.lex_state = 50},
  [229] = {.lex_state = 50},
  [230] = {.lex_state = 50},
  [231] = {.lex_state = 50},
  [232] = {.lex_state = 50},
  [233] = {.lex_state = 50},
  [234] = {.lex_state = 50},
  [235] = {.lex_state = 50},
  [236] = {.lex_state = 50},
  [237] = {.lex_state = 50},
  [238] = {.lex_state = 50},
  [239] = {.lex_state = 50},
  [240] = {.lex_state = 50},
  [241] = {.lex_state = 50},
  [242] = {.lex_state = 50},
  [243] = {.lex_state = 50},
  [244] = {.lex_state = 50},
  [245] = {.lex_state = 50},
  [246] = {.lex_state = 50},
  [247] = {.lex_state = 50},
  [248] = {.lex_state = 50},
  [249] = {.lex_state = 50},
  [250] = {.lex_state = 50},
  [251] = {.lex_state = 50},
  [252] = {.lex_state = 50},
  [253] = {.lex_state = 50},
  [254] = {.lex_state = 50},
  [255] = {.lex_state = 50},
  [256] = {.lex_state = 50},
  [257] = {.lex_state = 50},
  [258] = {.lex_state = 50},
  [259] = {.lex_state = 50},
  [260] = {.lex_state = 50},
  [261] = {.lex_state = 50},
  [262] = {.lex_state = 50},
  [263] = {.lex_state = 50},
  [264] = {.lex_state = 50},
  [265] = {.lex_state = 50},
  [266] = {.lex_state = 50},
  [267] = {.lex_state = 50},
  [268] = {.lex_state = 50},
  [269] = {.lex_state = 50},
  [270] = {.lex_state = 50},
  [271] = {.lex_state = 50},
  [272] = {.lex_state = 50},
  [273] = {.lex_state = 50},
  [274] = {.lex_state = 50},
  [275] = {.lex_state = 50},
  [276] = {.lex_state = 50},
  [277] = {.lex_state = 50},
  [278] = {.lex_state = 50},
  [279] = {.lex_state = 50},
  [280] = {.lex_state = 50},
  [281] = {.lex_state = 50},
  [282] = {.lex_state = 50},
  [283] = {.lex_state = 50},
  [284] = {.lex_state = 50},
  [285] = {.lex_state = 50},
  [286] = {.lex_state = 50},
  [287] = {.lex_state = 50},
  [288] = {.lex_state = 50},
  [289] = {.lex_state = 50},
  [290] = {.lex_state = 50},
  [291] = {.lex_state = 50},
  [292] = {.lex_state = 50},
  [293] = {.lex_state = 50},
  [294] = {.lex_state = 50},
  [295] = {.lex_state = 50},
  [296] = {.lex_state = 50},
  [297] = {.lex_state = 50},
  [298] = {.lex_state = 50},
  [299] = {.lex_state = 50},
  [300] = {.lex_state = 50},
  [301] = {.lex_state = 50},
  [302] = {.lex_state = 50},
  [303] = {.lex_state = 9},
  [304] = {.lex_state = 10},
  [305] = {.lex_state = 9},
  [306] = {.lex_state = 10},
  [307] = {.lex_state = 9},
  [308] = {.lex_state = 9},
  [309] = {.lex_state = 9},
  [310] = {.lex_state = 9},
  [311] = {.lex_state = 9},
  [312] = {.lex_state = 9},
  [313] = {.lex_state = 9},
  [314] = {.lex_state = 10},
  [315] = {.lex_state = 10},
  [316] = {.lex_state = 10},
  [317] = {.lex_state = 10},
  [318] = {.lex_state = 9},
  [319] = {.lex_state = 9},
  [320] = {.lex_state = 9},
  [321] = {.lex_state = 9},
  [322] = {.lex_state = 9},
  [323] = {.lex_state = 9},
  [324] = {.lex_state = 9},
  [325] = {.lex_state = 9},
  [326] = {.lex_state = 9},
  [327] = {.lex_state = 9},
  [328] = {.lex_state = 9},
  [329] = {.lex_state = 9},
  [330] = {.lex_state = 9},
  [331] = {.lex_state = 9},
  [332] = {.lex_state = 9},
  [333] = {.lex_state = 9},
  [334] = {.lex_state = 9},
  [335] = {.lex_state = 9},
  [336] = {.lex_state = 9},
  [337] = {.lex_state = 9},
  [338] = {.lex_state = 9},
  [339] = {.lex_state = 9},
  [340] = {.lex_state = 9},
  [341] = {.lex_state = 9},
  [342] = {.lex_state = 9},
  [343] = {.lex_state = 9},
  [344] = {.lex_state = 9},
  [345] = {.lex_state = 9},
  [346] = {.lex_state = 9},
  [347] = {.lex_state = 9},
  [348] = {.lex_state = 9},
  [349] = {.lex_state = 9},
  [350] = {.lex_state = 9},
  [351] = {.lex_state = 9},
  [352] = {.lex_state = 9},
  [353] = {.lex_state = 9},
  [354] = {.lex_state = 9},
  [355] = {.lex_state = 9},
  [356] = {.lex_state = 9},
  [357] = {.lex_state = 9},
  [358] = {.lex_state = 9},
  [359] = {.lex_state = 9},
  [360] = {.lex_state = 9},
  [361] = {.lex_state = 9},
  [362] = {.lex_state = 9},
  [363] = {.lex_state = 9},
  [364] = {.lex_state = 9},
  [365] = {.lex_state = 9},
  [366] = {.lex_state = 9},
  [367] = {.lex_state = 9},
  [368] = {.lex_state = 9},
  [369] = {.lex_state = 9},
  [370] = {.lex_state = 9},
  [371] = {.lex_state = 9},
  [372] = {.lex_state = 9},
  [373] = {.lex_state = 9},
  [374] = {.lex_state = 9},
  [375] = {.lex_state = 9},
  [376] = {.lex_state = 9},
  [377] = {.lex_state = 9},
  [378] = {.lex_state = 9},
  [379] = {.lex_state = 9},
  [380] = {.lex_state = 9},
  [381] = {.lex_state = 9},
  [382] = {.lex_state = 9},
  [383] = {.lex_state = 9},
  [384] = {.lex_state = 9},
  [385] = {.lex_state = 9},
  [386] = {.lex_state = 9},
  [387] = {.lex_state = 9},
  [388] = {.lex_state = 50},
  [389] = {.lex_state = 9},
  [390] = {.lex_state = 9},
  [391] = {.lex_state = 9},
  [392] = {.lex_state = 9},
  [393] = {.lex_state = 9},
  [394] = {.lex_state = 9},
  [395] = {.lex_state = 9},
  [396] = {.lex_state = 9},
  [397] = {.lex_state = 9},
  [398] = {.lex_state = 9},
  [399] = {.lex_state = 9},
  [400] = {.lex_state = 9},
  [401] = {.lex_state = 50},
  [402] = {.lex_state = 9},
  [403] = {.lex_state = 50},
  [404] = {.lex_state = 50},
  [405] = {.lex_state = 50},
  [406] = {.lex_state = 50},
  [407] = {.lex_state = 50},
  [408] = {.lex_state = 50},
  [409] = {.lex_state = 9},
  [410] = {.lex_state = 50},
  [411] = {.lex_state = 50},
  [412] = {.lex_state = 50},
  [413] = {.lex_state = 50},
  [414] = {.lex_state = 50},
  [415] = {.lex_state = 9},
  [416] = {.lex_state = 50},
  [417] = {.lex_state = 50},
  [418] = {.lex_state = 50},
  [419] = {.lex_state = 50},
  [420] = {.lex_state = 50},
  [421] = {.lex_state = 50},
  [422] = {.lex_state = 50},
  [423] = {.lex_state = 50},
  [424] = {.lex_state = 50},
  [425] = {.lex_state = 50},
  [426] = {.lex_state = 50},
  [427] = {.lex_state = 50},
  [428] = {.lex_state = 50},
  [429] = {.lex_state = 50},
  [430] = {.lex_state = 50},
  [431] = {.lex_state = 50},
  [432] = {.lex_state = 50},
  [433] = {.lex_state = 50},
  [434] = {.lex_state = 50},
  [435] = {.lex_state = 50},
  [436] = {.lex_state = 16},
  [437] = {.lex_state = 16},
  [438] = {.lex_state = 50},
  [439] = {.lex_state = 50},
  [440] = {.lex_state = 50},
  [441] = {.lex_state = 50},
  [442] = {.lex_state = 50},
  [443] = {.lex_state = 50},
  [444] = {.lex_state = 50},
  [445] = {.lex_state = 50},
  [446] = {.lex_state = 50},
  [447] = {.lex_state = 50},
  [448] = {.lex_state = 50},
  [449] = {.lex_state = 50},
  [450] = {.lex_state = 50},
  [451] = {.lex_state = 50},
  [452] = {.lex_state = 50},
  [453] = {.lex_state = 50},
  [454] = {.lex_state = 5},
  [455] = {.lex_state = 5},
  [456] = {.lex_state = 50},
  [457] = {.lex_state = 5},
  [458] = {.lex_state = 50},
  [459] = {.lex_state = 5},
  [460] = {.lex_state = 5},
  [461] = {.lex_state = 50},
  [462] = {.lex_state = 50},
  [463] = {.lex_state = 50},
  [464] = {.lex_state = 50},
  [465] = {.lex_state = 5},
  [466] = {.lex_state = 50},
  [467] = {.lex_state = 50},
  [468] = {.lex_state = 50},
  [469] = {.lex_state = 50},
  [470] = {.lex_state = 50},
  [471] = {.lex_state = 50},
  [472] = {.lex_state = 50},
  [473] = {.lex_state = 50},
  [474] = {.lex_state = 50},
  [475] = {.lex_state = 50},
  [476] = {.lex_state = 50},
  [477] = {.lex_state = 1},
  [478] = {.lex_state = 12},
  [479] = {.lex_state = 50},
  [480] = {.lex_state = 50},
  [481] = {.lex_state = 3},
  [482] = {.lex_state = 1},
  [483] = {.lex_state = 3},
  [484] = {.lex_state = 1},
  [485] = {.lex_state = 1},
  [486] = {.lex_state = 50},
  [487] = {.lex_state = 3},
  [488] = {.lex_state = 1},
  [489] = {.lex_state = 50},
  [490] = {.lex_state = 50},
  [491] = {.lex_state = 3},
  [492] = {.lex_state = 3},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 50},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 50},
  [498] = {.lex_state = 50},
  [499] = {.lex_state = 50},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 50},
  [503] = {.lex_state = 50},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 12},
  [506] = {.lex_state = 50},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 12},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 50},
  [511] = {.lex_state = 0},
  [512] = {.lex_state = 50},
  [513] = {.lex_state = 50},
  [514] = {.lex_state = 50},
  [515] = {.lex_state = 12},
  [516] = {.lex_state = 1},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 50},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 1},
  [521] = {.lex_state = 50},
  [522] = {.lex_state = 50},
  [523] = {.lex_state = 50},
  [524] = {.lex_state = 50},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 50},
  [528] = {.lex_state = 10},
  [529] = {.lex_state = 12},
  [530] = {.lex_state = 1},
  [531] = {.lex_state = 50},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 0},
  [534] = {.lex_state = 12},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 50},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 50},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 50},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 50},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 50},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 50},
  [560] = {.lex_state = 50},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 50},
  [564] = {.lex_state = 50},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 50},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 50},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 50},
  [571] = {.lex_state = 50},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 16},
  [577] = {.lex_state = 50},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 50},
  [580] = {.lex_state = 50},
  [581] = {.lex_state = 16},
  [582] = {.lex_state = 50},
  [583] = {.lex_state = 50},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 16},
  [590] = {.lex_state = 50},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 50},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 50},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 50},
  [598] = {.lex_state = 50},
  [599] = {.lex_state = 50},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 50},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 50},
  [610] = {.lex_state = 16},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 50},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 50},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 50},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 50},
  [621] = {.lex_state = 50},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 50},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 50},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 50},
  [629] = {.lex_state = 50},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 50},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 50},
  [640] = {.lex_state = 50},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 50},
  [649] = {.lex_state = 50},
  [650] = {.lex_state = 50},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 50},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 22},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 50},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 50},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 50},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 50},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 50},
  [673] = {.lex_state = 50},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 50},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 50},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 50},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 50},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 50},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 16},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 50},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 50},
  [705] = {.lex_state = 50},
  [706] = {.lex_state = 50},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 50},
  [712] = {.lex_state = 50},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 50},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 50},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 50},
  [721] = {.lex_state = 50},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 50},
  [726] = {.lex_state = 50},
  [727] = {.lex_state = 12},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 12},
  [730] = {.lex_state = 50},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 50},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 50},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 50},
  [740] = {.lex_state = 50},
  [741] = {.lex_state = 50},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 50},
  [744] = {.lex_state = 50},
  [745] = {.lex_state = 50},
  [746] = {.lex_state = 50},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 50},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 50},
  [751] = {.lex_state = 50},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 50},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 12},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 50},
  [762] = {.lex_state = 50},
  [763] = {.lex_state = 50},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 50},
  [766] = {.lex_state = 50},
  [767] = {.lex_state = 50},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 50},
  [772] = {.lex_state = 50},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 11},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 50},
  [779] = {.lex_state = 11},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 50},
  [790] = {.lex_state = 50},
  [791] = {.lex_state = 50},
  [792] = {.lex_state = 50},
  [793] = {.lex_state = 50},
  [794] = {.lex_state = 50},
  [795] = {.lex_state = 50},
  [796] = {.lex_state = 50},
  [797] = {.lex_state = 5},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 5},
  [801] = {.lex_state = 50},
  [802] = {.lex_state = 50},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 50},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 50},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 50},
  [814] = {.lex_state = 50},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 50},
  [817] = {.lex_state = 50},
  [818] = {.lex_state = 11},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 50},
  [823] = {.lex_state = 50},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 50},
  [826] = {.lex_state = 50},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_pragma] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_solidity] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_constant] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_contract] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_library] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_anonymous] = ACTIONS(1),
    [anon_sym_indexed] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_yul_leave] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_yul_decimal_number] = ACTIONS(1),
    [sym_yul_hex_number] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_stop] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_div] = ACTIONS(1),
    [anon_sym_sdiv] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_smod] = ACTIONS(1),
    [anon_sym_exp] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_lt] = ACTIONS(1),
    [anon_sym_gt] = ACTIONS(1),
    [anon_sym_slt] = ACTIONS(1),
    [anon_sym_sgt] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_iszero] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_shr] = ACTIONS(1),
    [anon_sym_sar] = ACTIONS(1),
    [anon_sym_addmod] = ACTIONS(1),
    [anon_sym_mulmod] = ACTIONS(1),
    [anon_sym_signextend] = ACTIONS(1),
    [anon_sym_keccak256] = ACTIONS(1),
    [anon_sym_pop] = ACTIONS(1),
    [anon_sym_mload] = ACTIONS(1),
    [anon_sym_mstore] = ACTIONS(1),
    [anon_sym_mstore8] = ACTIONS(1),
    [anon_sym_sload] = ACTIONS(1),
    [anon_sym_sstore] = ACTIONS(1),
    [anon_sym_msize] = ACTIONS(1),
    [anon_sym_gas] = ACTIONS(1),
    [anon_sym_address] = ACTIONS(1),
    [anon_sym_balance] = ACTIONS(1),
    [anon_sym_selfbalance] = ACTIONS(1),
    [anon_sym_caller] = ACTIONS(1),
    [anon_sym_callvalue] = ACTIONS(1),
    [anon_sym_calldataload] = ACTIONS(1),
    [anon_sym_calldatasize] = ACTIONS(1),
    [anon_sym_calldatacopy] = ACTIONS(1),
    [anon_sym_extcodesize] = ACTIONS(1),
    [anon_sym_extcodecopy] = ACTIONS(1),
    [anon_sym_returndatasize] = ACTIONS(1),
    [anon_sym_returndatacopy] = ACTIONS(1),
    [anon_sym_extcodehash] = ACTIONS(1),
    [anon_sym_create] = ACTIONS(1),
    [anon_sym_create2] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [anon_sym_callcode] = ACTIONS(1),
    [anon_sym_delegatecall] = ACTIONS(1),
    [anon_sym_staticcall] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_revert] = ACTIONS(1),
    [anon_sym_selfdestruct] = ACTIONS(1),
    [anon_sym_invalid] = ACTIONS(1),
    [anon_sym_log0] = ACTIONS(1),
    [anon_sym_log1] = ACTIONS(1),
    [anon_sym_log2] = ACTIONS(1),
    [anon_sym_log3] = ACTIONS(1),
    [anon_sym_log4] = ACTIONS(1),
    [anon_sym_chainid] = ACTIONS(1),
    [anon_sym_origin] = ACTIONS(1),
    [anon_sym_gasprice] = ACTIONS(1),
    [anon_sym_blockhash] = ACTIONS(1),
    [anon_sym_coinbase] = ACTIONS(1),
    [anon_sym_timestamp] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_difficulty] = ACTIONS(1),
    [anon_sym_gaslimit] = ACTIONS(1),
    [sym_unchecked] = ACTIONS(1),
    [anon_sym_memory] = ACTIONS(1),
    [anon_sym_storage] = ACTIONS(1),
    [anon_sym_calldata] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_returns] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_emit] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_pure] = ACTIONS(1),
    [anon_sym_view] = ACTIONS(1),
    [anon_sym_payable] = ACTIONS(1),
    [sym_immutable] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_modifier] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_fallback] = ACTIONS(1),
    [anon_sym_receive] = ACTIONS(1),
    [sym_virtual] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_mapping] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_int8] = ACTIONS(1),
    [anon_sym_int16] = ACTIONS(1),
    [anon_sym_int24] = ACTIONS(1),
    [anon_sym_int32] = ACTIONS(1),
    [anon_sym_int40] = ACTIONS(1),
    [anon_sym_int48] = ACTIONS(1),
    [anon_sym_int56] = ACTIONS(1),
    [anon_sym_int64] = ACTIONS(1),
    [anon_sym_int72] = ACTIONS(1),
    [anon_sym_int80] = ACTIONS(1),
    [anon_sym_int88] = ACTIONS(1),
    [anon_sym_int96] = ACTIONS(1),
    [anon_sym_int104] = ACTIONS(1),
    [anon_sym_int112] = ACTIONS(1),
    [anon_sym_int120] = ACTIONS(1),
    [anon_sym_int128] = ACTIONS(1),
    [anon_sym_int136] = ACTIONS(1),
    [anon_sym_int144] = ACTIONS(1),
    [anon_sym_int152] = ACTIONS(1),
    [anon_sym_int160] = ACTIONS(1),
    [anon_sym_int168] = ACTIONS(1),
    [anon_sym_int176] = ACTIONS(1),
    [anon_sym_int184] = ACTIONS(1),
    [anon_sym_int192] = ACTIONS(1),
    [anon_sym_int200] = ACTIONS(1),
    [anon_sym_int208] = ACTIONS(1),
    [anon_sym_int216] = ACTIONS(1),
    [anon_sym_int224] = ACTIONS(1),
    [anon_sym_int232] = ACTIONS(1),
    [anon_sym_int240] = ACTIONS(1),
    [anon_sym_int248] = ACTIONS(1),
    [anon_sym_int256] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_uint8] = ACTIONS(1),
    [anon_sym_uint16] = ACTIONS(1),
    [anon_sym_uint24] = ACTIONS(1),
    [anon_sym_uint32] = ACTIONS(1),
    [anon_sym_uint40] = ACTIONS(1),
    [anon_sym_uint48] = ACTIONS(1),
    [anon_sym_uint56] = ACTIONS(1),
    [anon_sym_uint64] = ACTIONS(1),
    [anon_sym_uint72] = ACTIONS(1),
    [anon_sym_uint80] = ACTIONS(1),
    [anon_sym_uint88] = ACTIONS(1),
    [anon_sym_uint96] = ACTIONS(1),
    [anon_sym_uint104] = ACTIONS(1),
    [anon_sym_uint112] = ACTIONS(1),
    [anon_sym_uint120] = ACTIONS(1),
    [anon_sym_uint128] = ACTIONS(1),
    [anon_sym_uint136] = ACTIONS(1),
    [anon_sym_uint144] = ACTIONS(1),
    [anon_sym_uint152] = ACTIONS(1),
    [anon_sym_uint160] = ACTIONS(1),
    [anon_sym_uint168] = ACTIONS(1),
    [anon_sym_uint176] = ACTIONS(1),
    [anon_sym_uint184] = ACTIONS(1),
    [anon_sym_uint192] = ACTIONS(1),
    [anon_sym_uint200] = ACTIONS(1),
    [anon_sym_uint208] = ACTIONS(1),
    [anon_sym_uint216] = ACTIONS(1),
    [anon_sym_uint224] = ACTIONS(1),
    [anon_sym_uint232] = ACTIONS(1),
    [anon_sym_uint240] = ACTIONS(1),
    [anon_sym_uint248] = ACTIONS(1),
    [anon_sym_uint256] = ACTIONS(1),
    [anon_sym_bytes] = ACTIONS(1),
    [anon_sym_bytes1] = ACTIONS(1),
    [anon_sym_bytes2] = ACTIONS(1),
    [anon_sym_bytes3] = ACTIONS(1),
    [anon_sym_bytes4] = ACTIONS(1),
    [anon_sym_bytes5] = ACTIONS(1),
    [anon_sym_bytes6] = ACTIONS(1),
    [anon_sym_bytes7] = ACTIONS(1),
    [anon_sym_bytes8] = ACTIONS(1),
    [anon_sym_bytes9] = ACTIONS(1),
    [anon_sym_bytes10] = ACTIONS(1),
    [anon_sym_bytes11] = ACTIONS(1),
    [anon_sym_bytes12] = ACTIONS(1),
    [anon_sym_bytes13] = ACTIONS(1),
    [anon_sym_bytes14] = ACTIONS(1),
    [anon_sym_bytes15] = ACTIONS(1),
    [anon_sym_bytes16] = ACTIONS(1),
    [anon_sym_bytes17] = ACTIONS(1),
    [anon_sym_bytes18] = ACTIONS(1),
    [anon_sym_bytes19] = ACTIONS(1),
    [anon_sym_bytes20] = ACTIONS(1),
    [anon_sym_bytes21] = ACTIONS(1),
    [anon_sym_bytes22] = ACTIONS(1),
    [anon_sym_bytes23] = ACTIONS(1),
    [anon_sym_bytes24] = ACTIONS(1),
    [anon_sym_bytes25] = ACTIONS(1),
    [anon_sym_bytes26] = ACTIONS(1),
    [anon_sym_bytes27] = ACTIONS(1),
    [anon_sym_bytes28] = ACTIONS(1),
    [anon_sym_bytes29] = ACTIONS(1),
    [anon_sym_bytes30] = ACTIONS(1),
    [anon_sym_bytes31] = ACTIONS(1),
    [anon_sym_bytes32] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [aux_sym__fixed_token1] = ACTIONS(1),
    [anon_sym_ufixed] = ACTIONS(1),
    [aux_sym__ufixed_token1] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
    [anon_sym_wei] = ACTIONS(1),
    [anon_sym_szabo] = ACTIONS(1),
    [anon_sym_finney] = ACTIONS(1),
    [anon_sym_gwei] = ACTIONS(1),
    [anon_sym_ether] = ACTIONS(1),
    [anon_sym_seconds] = ACTIONS(1),
    [anon_sym_minutes] = ACTIONS(1),
    [anon_sym_hours] = ACTIONS(1),
    [anon_sym_days] = ACTIONS(1),
    [anon_sym_weeks] = ACTIONS(1),
    [anon_sym_years] = ACTIONS(1),
    [anon_sym_hex] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym__escape_sequence] = ACTIONS(1),
    [anon_sym_unicode] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(758),
    [sym__source_unit] = STATE(73),
    [sym__directive] = STATE(73),
    [sym_pragma_directive] = STATE(73),
    [sym_import_directive] = STATE(73),
    [sym__declaration] = STATE(73),
    [sym_user_defined_type_definition] = STATE(73),
    [sym_constant_variable_declaration] = STATE(73),
    [sym_contract_declaration] = STATE(73),
    [sym_error_declaration] = STATE(73),
    [sym_interface_declaration] = STATE(73),
    [sym_library_declaration] = STATE(73),
    [sym_struct_declaration] = STATE(73),
    [sym_enum_declaration] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_type_name] = STATE(701),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_source_file_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pragma] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_contract] = ACTIONS(17),
    [anon_sym_error] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_library] = ACTIONS(23),
    [anon_sym_struct] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_function] = ACTIONS(29),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__statement] = STATE(8),
    [sym_assembly_statement] = STATE(8),
    [sym_block_statement] = STATE(8),
    [sym_variable_declaration_statement] = STATE(8),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_while_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_revert_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_emit_statement] = STATE(8),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_struct_field_assignment] = STATE(637),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(8),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__statement] = STATE(10),
    [sym_assembly_statement] = STATE(10),
    [sym_block_statement] = STATE(10),
    [sym_variable_declaration_statement] = STATE(10),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_while_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_revert_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_emit_statement] = STATE(10),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__statement] = STATE(3),
    [sym_assembly_statement] = STATE(3),
    [sym_block_statement] = STATE(3),
    [sym_variable_declaration_statement] = STATE(3),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(3),
    [sym_if_statement] = STATE(3),
    [sym_for_statement] = STATE(3),
    [sym_while_statement] = STATE(3),
    [sym_do_while_statement] = STATE(3),
    [sym_continue_statement] = STATE(3),
    [sym_break_statement] = STATE(3),
    [sym_revert_statement] = STATE(3),
    [sym_try_statement] = STATE(3),
    [sym_return_statement] = STATE(3),
    [sym_emit_statement] = STATE(3),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(3),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__statement] = STATE(7),
    [sym_assembly_statement] = STATE(7),
    [sym_block_statement] = STATE(7),
    [sym_variable_declaration_statement] = STATE(7),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_while_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_revert_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_emit_statement] = STATE(7),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__statement] = STATE(8),
    [sym_assembly_statement] = STATE(8),
    [sym_block_statement] = STATE(8),
    [sym_variable_declaration_statement] = STATE(8),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_while_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_revert_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_emit_statement] = STATE(8),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(8),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__statement] = STATE(10),
    [sym_assembly_statement] = STATE(10),
    [sym_block_statement] = STATE(10),
    [sym_variable_declaration_statement] = STATE(10),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_while_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_revert_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_emit_statement] = STATE(10),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__statement] = STATE(10),
    [sym_assembly_statement] = STATE(10),
    [sym_block_statement] = STATE(10),
    [sym_variable_declaration_statement] = STATE(10),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_while_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_revert_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_emit_statement] = STATE(10),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__statement] = STATE(10),
    [sym_assembly_statement] = STATE(10),
    [sym_block_statement] = STATE(10),
    [sym_variable_declaration_statement] = STATE(10),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_while_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_revert_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_emit_statement] = STATE(10),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__statement] = STATE(10),
    [sym_assembly_statement] = STATE(10),
    [sym_block_statement] = STATE(10),
    [sym_variable_declaration_statement] = STATE(10),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_while_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_revert_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_emit_statement] = STATE(10),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(124),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_LBRACE] = ACTIONS(130),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(138),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_assembly] = ACTIONS(144),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(150),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(156),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(162),
    [anon_sym_byte] = ACTIONS(165),
    [anon_sym_address] = ACTIONS(168),
    [anon_sym_return] = ACTIONS(171),
    [anon_sym_revert] = ACTIONS(174),
    [sym_unchecked] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(180),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(186),
    [anon_sym_try] = ACTIONS(189),
    [anon_sym_emit] = ACTIONS(192),
    [anon_sym_payable] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(127),
    [anon_sym_delete] = ACTIONS(204),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_mapping] = ACTIONS(210),
    [anon_sym_bool] = ACTIONS(165),
    [anon_sym_string] = ACTIONS(165),
    [anon_sym_int] = ACTIONS(165),
    [anon_sym_int8] = ACTIONS(165),
    [anon_sym_int16] = ACTIONS(165),
    [anon_sym_int24] = ACTIONS(165),
    [anon_sym_int32] = ACTIONS(165),
    [anon_sym_int40] = ACTIONS(165),
    [anon_sym_int48] = ACTIONS(165),
    [anon_sym_int56] = ACTIONS(165),
    [anon_sym_int64] = ACTIONS(165),
    [anon_sym_int72] = ACTIONS(165),
    [anon_sym_int80] = ACTIONS(165),
    [anon_sym_int88] = ACTIONS(165),
    [anon_sym_int96] = ACTIONS(165),
    [anon_sym_int104] = ACTIONS(165),
    [anon_sym_int112] = ACTIONS(165),
    [anon_sym_int120] = ACTIONS(165),
    [anon_sym_int128] = ACTIONS(165),
    [anon_sym_int136] = ACTIONS(165),
    [anon_sym_int144] = ACTIONS(165),
    [anon_sym_int152] = ACTIONS(165),
    [anon_sym_int160] = ACTIONS(165),
    [anon_sym_int168] = ACTIONS(165),
    [anon_sym_int176] = ACTIONS(165),
    [anon_sym_int184] = ACTIONS(165),
    [anon_sym_int192] = ACTIONS(165),
    [anon_sym_int200] = ACTIONS(165),
    [anon_sym_int208] = ACTIONS(165),
    [anon_sym_int216] = ACTIONS(165),
    [anon_sym_int224] = ACTIONS(165),
    [anon_sym_int232] = ACTIONS(165),
    [anon_sym_int240] = ACTIONS(165),
    [anon_sym_int248] = ACTIONS(165),
    [anon_sym_int256] = ACTIONS(165),
    [anon_sym_uint] = ACTIONS(165),
    [anon_sym_uint8] = ACTIONS(165),
    [anon_sym_uint16] = ACTIONS(165),
    [anon_sym_uint24] = ACTIONS(165),
    [anon_sym_uint32] = ACTIONS(165),
    [anon_sym_uint40] = ACTIONS(165),
    [anon_sym_uint48] = ACTIONS(165),
    [anon_sym_uint56] = ACTIONS(165),
    [anon_sym_uint64] = ACTIONS(165),
    [anon_sym_uint72] = ACTIONS(165),
    [anon_sym_uint80] = ACTIONS(165),
    [anon_sym_uint88] = ACTIONS(165),
    [anon_sym_uint96] = ACTIONS(165),
    [anon_sym_uint104] = ACTIONS(165),
    [anon_sym_uint112] = ACTIONS(165),
    [anon_sym_uint120] = ACTIONS(165),
    [anon_sym_uint128] = ACTIONS(165),
    [anon_sym_uint136] = ACTIONS(165),
    [anon_sym_uint144] = ACTIONS(165),
    [anon_sym_uint152] = ACTIONS(165),
    [anon_sym_uint160] = ACTIONS(165),
    [anon_sym_uint168] = ACTIONS(165),
    [anon_sym_uint176] = ACTIONS(165),
    [anon_sym_uint184] = ACTIONS(165),
    [anon_sym_uint192] = ACTIONS(165),
    [anon_sym_uint200] = ACTIONS(165),
    [anon_sym_uint208] = ACTIONS(165),
    [anon_sym_uint216] = ACTIONS(165),
    [anon_sym_uint224] = ACTIONS(165),
    [anon_sym_uint232] = ACTIONS(165),
    [anon_sym_uint240] = ACTIONS(165),
    [anon_sym_uint248] = ACTIONS(165),
    [anon_sym_uint256] = ACTIONS(165),
    [anon_sym_bytes] = ACTIONS(165),
    [anon_sym_bytes1] = ACTIONS(165),
    [anon_sym_bytes2] = ACTIONS(165),
    [anon_sym_bytes3] = ACTIONS(165),
    [anon_sym_bytes4] = ACTIONS(165),
    [anon_sym_bytes5] = ACTIONS(165),
    [anon_sym_bytes6] = ACTIONS(165),
    [anon_sym_bytes7] = ACTIONS(165),
    [anon_sym_bytes8] = ACTIONS(165),
    [anon_sym_bytes9] = ACTIONS(165),
    [anon_sym_bytes10] = ACTIONS(165),
    [anon_sym_bytes11] = ACTIONS(165),
    [anon_sym_bytes12] = ACTIONS(165),
    [anon_sym_bytes13] = ACTIONS(165),
    [anon_sym_bytes14] = ACTIONS(165),
    [anon_sym_bytes15] = ACTIONS(165),
    [anon_sym_bytes16] = ACTIONS(165),
    [anon_sym_bytes17] = ACTIONS(165),
    [anon_sym_bytes18] = ACTIONS(165),
    [anon_sym_bytes19] = ACTIONS(165),
    [anon_sym_bytes20] = ACTIONS(165),
    [anon_sym_bytes21] = ACTIONS(165),
    [anon_sym_bytes22] = ACTIONS(165),
    [anon_sym_bytes23] = ACTIONS(165),
    [anon_sym_bytes24] = ACTIONS(165),
    [anon_sym_bytes25] = ACTIONS(165),
    [anon_sym_bytes26] = ACTIONS(165),
    [anon_sym_bytes27] = ACTIONS(165),
    [anon_sym_bytes28] = ACTIONS(165),
    [anon_sym_bytes29] = ACTIONS(165),
    [anon_sym_bytes30] = ACTIONS(165),
    [anon_sym_bytes31] = ACTIONS(165),
    [anon_sym_bytes32] = ACTIONS(165),
    [anon_sym_fixed] = ACTIONS(165),
    [aux_sym__fixed_token1] = ACTIONS(165),
    [anon_sym_ufixed] = ACTIONS(165),
    [aux_sym__ufixed_token1] = ACTIONS(165),
    [aux_sym__decimal_number_token1] = ACTIONS(213),
    [aux_sym__decimal_number_token2] = ACTIONS(216),
    [aux_sym__hex_number_token1] = ACTIONS(216),
    [anon_sym_hex] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(222),
    [anon_sym_SQUOTE] = ACTIONS(225),
    [anon_sym_unicode] = ACTIONS(228),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__statement] = STATE(9),
    [sym_assembly_statement] = STATE(9),
    [sym_block_statement] = STATE(9),
    [sym_variable_declaration_statement] = STATE(9),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_while_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_revert_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_emit_statement] = STATE(9),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_block_statement_repeat1] = STATE(9),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__statement] = STATE(801),
    [sym_assembly_statement] = STATE(801),
    [sym_block_statement] = STATE(801),
    [sym_variable_declaration_statement] = STATE(801),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(801),
    [sym_if_statement] = STATE(801),
    [sym_for_statement] = STATE(801),
    [sym_while_statement] = STATE(801),
    [sym_do_while_statement] = STATE(801),
    [sym_continue_statement] = STATE(801),
    [sym_break_statement] = STATE(801),
    [sym_revert_statement] = STATE(801),
    [sym_try_statement] = STATE(801),
    [sym_return_statement] = STATE(801),
    [sym_emit_statement] = STATE(801),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__statement] = STATE(90),
    [sym_assembly_statement] = STATE(90),
    [sym_block_statement] = STATE(90),
    [sym_variable_declaration_statement] = STATE(90),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_while_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_revert_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_emit_statement] = STATE(90),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__statement] = STATE(84),
    [sym_assembly_statement] = STATE(84),
    [sym_block_statement] = STATE(84),
    [sym_variable_declaration_statement] = STATE(84),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_while_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_revert_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_emit_statement] = STATE(84),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__statement] = STATE(100),
    [sym_assembly_statement] = STATE(100),
    [sym_block_statement] = STATE(100),
    [sym_variable_declaration_statement] = STATE(100),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_while_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_revert_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_emit_statement] = STATE(100),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__statement] = STATE(92),
    [sym_assembly_statement] = STATE(92),
    [sym_block_statement] = STATE(92),
    [sym_variable_declaration_statement] = STATE(92),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(92),
    [sym_if_statement] = STATE(92),
    [sym_for_statement] = STATE(92),
    [sym_while_statement] = STATE(92),
    [sym_do_while_statement] = STATE(92),
    [sym_continue_statement] = STATE(92),
    [sym_break_statement] = STATE(92),
    [sym_revert_statement] = STATE(92),
    [sym_try_statement] = STATE(92),
    [sym_return_statement] = STATE(92),
    [sym_emit_statement] = STATE(92),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__statement] = STATE(103),
    [sym_assembly_statement] = STATE(103),
    [sym_block_statement] = STATE(103),
    [sym_variable_declaration_statement] = STATE(103),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_while_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_revert_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_emit_statement] = STATE(103),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [anon_sym_assembly] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(55),
    [anon_sym_continue] = ACTIONS(57),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_if] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(67),
    [anon_sym_revert] = ACTIONS(69),
    [sym_unchecked] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_try] = ACTIONS(79),
    [anon_sym_emit] = ACTIONS(81),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_variable_declaration] = STATE(635),
    [sym__expression] = STATE(407),
    [sym__primary_expression] = STATE(407),
    [sym_type_cast_expression] = STATE(407),
    [sym_ternary_expression] = STATE(407),
    [sym_new_expression] = STATE(407),
    [sym_tuple_expression] = STATE(407),
    [sym_inline_array_expression] = STATE(407),
    [sym_binary_expression] = STATE(407),
    [sym_unary_expression] = STATE(407),
    [sym_update_expression] = STATE(407),
    [sym_member_expression] = STATE(407),
    [sym_array_access] = STATE(407),
    [sym_slice_access] = STATE(407),
    [sym_struct_expression] = STATE(407),
    [sym_parenthesized_expression] = STATE(407),
    [sym_assignment_expression] = STATE(407),
    [sym_augmented_assignment_expression] = STATE(407),
    [sym_call_expression] = STATE(407),
    [sym_payable_conversion_expression] = STATE(407),
    [sym_meta_type_expression] = STATE(407),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(407),
    [sym_string_literal] = STATE(407),
    [sym_number_literal] = STATE(407),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(407),
    [sym_hex_string_literal] = STATE(407),
    [sym_unicode_string_literal] = STATE(407),
    [sym_string] = STATE(343),
    [aux_sym_variable_declaration_tuple_repeat1] = STATE(634),
    [aux_sym_tuple_expression_repeat1] = STATE(578),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_variable_declaration_statement] = STATE(33),
    [sym_variable_declaration] = STATE(684),
    [sym_variable_declaration_tuple] = STATE(790),
    [sym_expression_statement] = STATE(33),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(73),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym__semicolon] = ACTIONS(237),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_variable_declaration] = STATE(723),
    [sym__expression] = STATE(408),
    [sym__primary_expression] = STATE(408),
    [sym_type_cast_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_tuple_expression] = STATE(408),
    [sym_inline_array_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_member_expression] = STATE(408),
    [sym_array_access] = STATE(408),
    [sym_slice_access] = STATE(408),
    [sym_struct_expression] = STATE(408),
    [sym_parenthesized_expression] = STATE(408),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_payable_conversion_expression] = STATE(408),
    [sym_meta_type_expression] = STATE(408),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(401),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(388),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(408),
    [sym_string_literal] = STATE(408),
    [sym_number_literal] = STATE(408),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(408),
    [sym_hex_string_literal] = STATE(408),
    [sym_unicode_string_literal] = STATE(408),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(239),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(242),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_call_argument] = STATE(627),
    [sym__expression] = STATE(404),
    [sym__primary_expression] = STATE(404),
    [sym_type_cast_expression] = STATE(404),
    [sym_ternary_expression] = STATE(404),
    [sym_new_expression] = STATE(404),
    [sym_tuple_expression] = STATE(404),
    [sym_inline_array_expression] = STATE(404),
    [sym_binary_expression] = STATE(404),
    [sym_unary_expression] = STATE(404),
    [sym_update_expression] = STATE(404),
    [sym_member_expression] = STATE(404),
    [sym_array_access] = STATE(404),
    [sym_slice_access] = STATE(404),
    [sym_struct_expression] = STATE(404),
    [sym_parenthesized_expression] = STATE(404),
    [sym_assignment_expression] = STATE(404),
    [sym_augmented_assignment_expression] = STATE(404),
    [sym_call_expression] = STATE(404),
    [sym_payable_conversion_expression] = STATE(404),
    [sym_meta_type_expression] = STATE(404),
    [sym_user_defined_type] = STATE(404),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(404),
    [sym_string_literal] = STATE(404),
    [sym_number_literal] = STATE(404),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(404),
    [sym_hex_string_literal] = STATE(404),
    [sym_unicode_string_literal] = STATE(404),
    [sym_string] = STATE(343),
    [aux_sym_tuple_expression_repeat1] = STATE(578),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(248),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_call_argument] = STATE(663),
    [sym__expression] = STATE(412),
    [sym__primary_expression] = STATE(412),
    [sym_type_cast_expression] = STATE(412),
    [sym_ternary_expression] = STATE(412),
    [sym_new_expression] = STATE(412),
    [sym_tuple_expression] = STATE(412),
    [sym_inline_array_expression] = STATE(412),
    [sym_binary_expression] = STATE(412),
    [sym_unary_expression] = STATE(412),
    [sym_update_expression] = STATE(412),
    [sym_member_expression] = STATE(412),
    [sym_array_access] = STATE(412),
    [sym_slice_access] = STATE(412),
    [sym_struct_expression] = STATE(412),
    [sym_parenthesized_expression] = STATE(412),
    [sym_assignment_expression] = STATE(412),
    [sym_augmented_assignment_expression] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_payable_conversion_expression] = STATE(412),
    [sym_meta_type_expression] = STATE(412),
    [sym_user_defined_type] = STATE(412),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(412),
    [sym_string_literal] = STATE(412),
    [sym_number_literal] = STATE(412),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(412),
    [sym_hex_string_literal] = STATE(412),
    [sym_unicode_string_literal] = STATE(412),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_call_argument] = STATE(627),
    [sym__expression] = STATE(412),
    [sym__primary_expression] = STATE(412),
    [sym_type_cast_expression] = STATE(412),
    [sym_ternary_expression] = STATE(412),
    [sym_new_expression] = STATE(412),
    [sym_tuple_expression] = STATE(412),
    [sym_inline_array_expression] = STATE(412),
    [sym_binary_expression] = STATE(412),
    [sym_unary_expression] = STATE(412),
    [sym_update_expression] = STATE(412),
    [sym_member_expression] = STATE(412),
    [sym_array_access] = STATE(412),
    [sym_slice_access] = STATE(412),
    [sym_struct_expression] = STATE(412),
    [sym_parenthesized_expression] = STATE(412),
    [sym_assignment_expression] = STATE(412),
    [sym_augmented_assignment_expression] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_payable_conversion_expression] = STATE(412),
    [sym_meta_type_expression] = STATE(412),
    [sym_user_defined_type] = STATE(412),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(412),
    [sym_string_literal] = STATE(412),
    [sym_number_literal] = STATE(412),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(412),
    [sym_hex_string_literal] = STATE(412),
    [sym_unicode_string_literal] = STATE(412),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_call_argument] = STATE(663),
    [sym__expression] = STATE(412),
    [sym__primary_expression] = STATE(412),
    [sym_type_cast_expression] = STATE(412),
    [sym_ternary_expression] = STATE(412),
    [sym_new_expression] = STATE(412),
    [sym_tuple_expression] = STATE(412),
    [sym_inline_array_expression] = STATE(412),
    [sym_binary_expression] = STATE(412),
    [sym_unary_expression] = STATE(412),
    [sym_update_expression] = STATE(412),
    [sym_member_expression] = STATE(412),
    [sym_array_access] = STATE(412),
    [sym_slice_access] = STATE(412),
    [sym_struct_expression] = STATE(412),
    [sym_parenthesized_expression] = STATE(412),
    [sym_assignment_expression] = STATE(412),
    [sym_augmented_assignment_expression] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_payable_conversion_expression] = STATE(412),
    [sym_meta_type_expression] = STATE(412),
    [sym_user_defined_type] = STATE(412),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(412),
    [sym_string_literal] = STATE(412),
    [sym_number_literal] = STATE(412),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(412),
    [sym_hex_string_literal] = STATE(412),
    [sym_unicode_string_literal] = STATE(412),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__expression] = STATE(407),
    [sym__primary_expression] = STATE(407),
    [sym_type_cast_expression] = STATE(407),
    [sym_ternary_expression] = STATE(407),
    [sym_new_expression] = STATE(407),
    [sym_tuple_expression] = STATE(407),
    [sym_inline_array_expression] = STATE(407),
    [sym_binary_expression] = STATE(407),
    [sym_unary_expression] = STATE(407),
    [sym_update_expression] = STATE(407),
    [sym_member_expression] = STATE(407),
    [sym_array_access] = STATE(407),
    [sym_slice_access] = STATE(407),
    [sym_struct_expression] = STATE(407),
    [sym_parenthesized_expression] = STATE(407),
    [sym_assignment_expression] = STATE(407),
    [sym_augmented_assignment_expression] = STATE(407),
    [sym_call_expression] = STATE(407),
    [sym_payable_conversion_expression] = STATE(407),
    [sym_meta_type_expression] = STATE(407),
    [sym_user_defined_type] = STATE(407),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(407),
    [sym_string_literal] = STATE(407),
    [sym_number_literal] = STATE(407),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(407),
    [sym_hex_string_literal] = STATE(407),
    [sym_unicode_string_literal] = STATE(407),
    [sym_string] = STATE(343),
    [aux_sym_tuple_expression_repeat1] = STATE(578),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(246),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_call_argument] = STATE(663),
    [sym__expression] = STATE(412),
    [sym__primary_expression] = STATE(412),
    [sym_type_cast_expression] = STATE(412),
    [sym_ternary_expression] = STATE(412),
    [sym_new_expression] = STATE(412),
    [sym_tuple_expression] = STATE(412),
    [sym_inline_array_expression] = STATE(412),
    [sym_binary_expression] = STATE(412),
    [sym_unary_expression] = STATE(412),
    [sym_update_expression] = STATE(412),
    [sym_member_expression] = STATE(412),
    [sym_array_access] = STATE(412),
    [sym_slice_access] = STATE(412),
    [sym_struct_expression] = STATE(412),
    [sym_parenthesized_expression] = STATE(412),
    [sym_assignment_expression] = STATE(412),
    [sym_augmented_assignment_expression] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_payable_conversion_expression] = STATE(412),
    [sym_meta_type_expression] = STATE(412),
    [sym_user_defined_type] = STATE(412),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(412),
    [sym_string_literal] = STATE(412),
    [sym_number_literal] = STATE(412),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(412),
    [sym_hex_string_literal] = STATE(412),
    [sym_unicode_string_literal] = STATE(412),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__expression] = STATE(408),
    [sym__primary_expression] = STATE(408),
    [sym_type_cast_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_tuple_expression] = STATE(408),
    [sym_inline_array_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_member_expression] = STATE(408),
    [sym_array_access] = STATE(408),
    [sym_slice_access] = STATE(408),
    [sym_struct_expression] = STATE(408),
    [sym_parenthesized_expression] = STATE(408),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_payable_conversion_expression] = STATE(408),
    [sym_meta_type_expression] = STATE(408),
    [sym_user_defined_type] = STATE(408),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(408),
    [sym_string_literal] = STATE(408),
    [sym_number_literal] = STATE(408),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(408),
    [sym_hex_string_literal] = STATE(408),
    [sym_unicode_string_literal] = STATE(408),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(258),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(260),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__call_arguments] = STATE(803),
    [sym__expression] = STATE(427),
    [sym__primary_expression] = STATE(427),
    [sym_type_cast_expression] = STATE(427),
    [sym_ternary_expression] = STATE(427),
    [sym_new_expression] = STATE(427),
    [sym_tuple_expression] = STATE(427),
    [sym_inline_array_expression] = STATE(427),
    [sym_binary_expression] = STATE(427),
    [sym_unary_expression] = STATE(427),
    [sym_update_expression] = STATE(427),
    [sym_member_expression] = STATE(427),
    [sym_array_access] = STATE(427),
    [sym_slice_access] = STATE(427),
    [sym_struct_expression] = STATE(427),
    [sym_parenthesized_expression] = STATE(427),
    [sym_assignment_expression] = STATE(427),
    [sym_augmented_assignment_expression] = STATE(427),
    [sym_call_expression] = STATE(427),
    [sym_payable_conversion_expression] = STATE(427),
    [sym_meta_type_expression] = STATE(427),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(427),
    [sym_string_literal] = STATE(427),
    [sym_number_literal] = STATE(427),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(427),
    [sym_hex_string_literal] = STATE(427),
    [sym_unicode_string_literal] = STATE(427),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(262),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym__semicolon] = ACTIONS(264),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__expression] = STATE(408),
    [sym__primary_expression] = STATE(408),
    [sym_type_cast_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_tuple_expression] = STATE(408),
    [sym_inline_array_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_member_expression] = STATE(408),
    [sym_array_access] = STATE(408),
    [sym_slice_access] = STATE(408),
    [sym_struct_expression] = STATE(408),
    [sym_parenthesized_expression] = STATE(408),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_payable_conversion_expression] = STATE(408),
    [sym_meta_type_expression] = STATE(408),
    [sym_user_defined_type] = STATE(408),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(408),
    [sym_string_literal] = STATE(408),
    [sym_number_literal] = STATE(408),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(408),
    [sym_hex_string_literal] = STATE(408),
    [sym_unicode_string_literal] = STATE(408),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(258),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(266),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__expression] = STATE(408),
    [sym__primary_expression] = STATE(408),
    [sym_type_cast_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_tuple_expression] = STATE(408),
    [sym_inline_array_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_member_expression] = STATE(408),
    [sym_array_access] = STATE(408),
    [sym_slice_access] = STATE(408),
    [sym_struct_expression] = STATE(408),
    [sym_parenthesized_expression] = STATE(408),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_payable_conversion_expression] = STATE(408),
    [sym_meta_type_expression] = STATE(408),
    [sym_user_defined_type] = STATE(408),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(408),
    [sym_string_literal] = STATE(408),
    [sym_number_literal] = STATE(408),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(408),
    [sym_hex_string_literal] = STATE(408),
    [sym_unicode_string_literal] = STATE(408),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(258),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(258),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__expression] = STATE(409),
    [sym__primary_expression] = STATE(409),
    [sym_type_cast_expression] = STATE(409),
    [sym_ternary_expression] = STATE(409),
    [sym_new_expression] = STATE(409),
    [sym_tuple_expression] = STATE(409),
    [sym_inline_array_expression] = STATE(409),
    [sym_binary_expression] = STATE(409),
    [sym_unary_expression] = STATE(409),
    [sym_update_expression] = STATE(409),
    [sym_member_expression] = STATE(409),
    [sym_array_access] = STATE(409),
    [sym_slice_access] = STATE(409),
    [sym_struct_expression] = STATE(409),
    [sym_parenthesized_expression] = STATE(409),
    [sym_assignment_expression] = STATE(409),
    [sym_augmented_assignment_expression] = STATE(409),
    [sym_call_expression] = STATE(409),
    [sym_payable_conversion_expression] = STATE(409),
    [sym_meta_type_expression] = STATE(409),
    [sym_user_defined_type] = STATE(409),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(409),
    [sym_string_literal] = STATE(409),
    [sym_number_literal] = STATE(409),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(409),
    [sym_hex_string_literal] = STATE(409),
    [sym_unicode_string_literal] = STATE(409),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_COLON] = ACTIONS(268),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(270),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__expression] = STATE(408),
    [sym__primary_expression] = STATE(408),
    [sym_type_cast_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_tuple_expression] = STATE(408),
    [sym_inline_array_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_member_expression] = STATE(408),
    [sym_array_access] = STATE(408),
    [sym_slice_access] = STATE(408),
    [sym_struct_expression] = STATE(408),
    [sym_parenthesized_expression] = STATE(408),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_payable_conversion_expression] = STATE(408),
    [sym_meta_type_expression] = STATE(408),
    [sym_user_defined_type] = STATE(408),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(408),
    [sym_string_literal] = STATE(408),
    [sym_number_literal] = STATE(408),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(408),
    [sym_hex_string_literal] = STATE(408),
    [sym_unicode_string_literal] = STATE(408),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(258),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(272),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_expression_statement] = STATE(35),
    [sym__expression] = STATE(419),
    [sym__primary_expression] = STATE(419),
    [sym_type_cast_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_tuple_expression] = STATE(419),
    [sym_inline_array_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_member_expression] = STATE(419),
    [sym_array_access] = STATE(419),
    [sym_slice_access] = STATE(419),
    [sym_struct_expression] = STATE(419),
    [sym_parenthesized_expression] = STATE(419),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_payable_conversion_expression] = STATE(419),
    [sym_meta_type_expression] = STATE(419),
    [sym_user_defined_type] = STATE(419),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(419),
    [sym_string_literal] = STATE(419),
    [sym_number_literal] = STATE(419),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(419),
    [sym_hex_string_literal] = STATE(419),
    [sym_unicode_string_literal] = STATE(419),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym__semicolon] = ACTIONS(274),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__expression] = STATE(413),
    [sym__primary_expression] = STATE(413),
    [sym_type_cast_expression] = STATE(413),
    [sym_ternary_expression] = STATE(413),
    [sym_new_expression] = STATE(413),
    [sym_tuple_expression] = STATE(413),
    [sym_inline_array_expression] = STATE(413),
    [sym_binary_expression] = STATE(413),
    [sym_unary_expression] = STATE(413),
    [sym_update_expression] = STATE(413),
    [sym_member_expression] = STATE(413),
    [sym_array_access] = STATE(413),
    [sym_slice_access] = STATE(413),
    [sym_struct_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_augmented_assignment_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_payable_conversion_expression] = STATE(413),
    [sym_meta_type_expression] = STATE(413),
    [sym_user_defined_type] = STATE(413),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(413),
    [sym_string_literal] = STATE(413),
    [sym_number_literal] = STATE(413),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(413),
    [sym_hex_string_literal] = STATE(413),
    [sym_unicode_string_literal] = STATE(413),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__expression] = STATE(424),
    [sym__primary_expression] = STATE(424),
    [sym_type_cast_expression] = STATE(424),
    [sym_ternary_expression] = STATE(424),
    [sym_new_expression] = STATE(424),
    [sym_tuple_expression] = STATE(424),
    [sym_inline_array_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_member_expression] = STATE(424),
    [sym_array_access] = STATE(424),
    [sym_slice_access] = STATE(424),
    [sym_struct_expression] = STATE(424),
    [sym_parenthesized_expression] = STATE(424),
    [sym_assignment_expression] = STATE(424),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym_call_expression] = STATE(424),
    [sym_payable_conversion_expression] = STATE(424),
    [sym_meta_type_expression] = STATE(424),
    [sym_user_defined_type] = STATE(424),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(424),
    [sym_string_literal] = STATE(424),
    [sym_number_literal] = STATE(424),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(424),
    [sym_hex_string_literal] = STATE(424),
    [sym_unicode_string_literal] = STATE(424),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_RPAREN] = ACTIONS(278),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__expression] = STATE(428),
    [sym__primary_expression] = STATE(428),
    [sym_type_cast_expression] = STATE(428),
    [sym_ternary_expression] = STATE(428),
    [sym_new_expression] = STATE(428),
    [sym_tuple_expression] = STATE(428),
    [sym_inline_array_expression] = STATE(428),
    [sym_binary_expression] = STATE(428),
    [sym_unary_expression] = STATE(428),
    [sym_update_expression] = STATE(428),
    [sym_member_expression] = STATE(428),
    [sym_array_access] = STATE(428),
    [sym_slice_access] = STATE(428),
    [sym_struct_expression] = STATE(428),
    [sym_parenthesized_expression] = STATE(428),
    [sym_assignment_expression] = STATE(428),
    [sym_augmented_assignment_expression] = STATE(428),
    [sym_call_expression] = STATE(428),
    [sym_payable_conversion_expression] = STATE(428),
    [sym_meta_type_expression] = STATE(428),
    [sym_user_defined_type] = STATE(428),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(428),
    [sym_string_literal] = STATE(428),
    [sym_number_literal] = STATE(428),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(428),
    [sym_hex_string_literal] = STATE(428),
    [sym_unicode_string_literal] = STATE(428),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__expression] = STATE(429),
    [sym__primary_expression] = STATE(429),
    [sym_type_cast_expression] = STATE(429),
    [sym_ternary_expression] = STATE(429),
    [sym_new_expression] = STATE(429),
    [sym_tuple_expression] = STATE(429),
    [sym_inline_array_expression] = STATE(429),
    [sym_binary_expression] = STATE(429),
    [sym_unary_expression] = STATE(429),
    [sym_update_expression] = STATE(429),
    [sym_member_expression] = STATE(429),
    [sym_array_access] = STATE(429),
    [sym_slice_access] = STATE(429),
    [sym_struct_expression] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_assignment_expression] = STATE(429),
    [sym_augmented_assignment_expression] = STATE(429),
    [sym_call_expression] = STATE(429),
    [sym_payable_conversion_expression] = STATE(429),
    [sym_meta_type_expression] = STATE(429),
    [sym_user_defined_type] = STATE(429),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(429),
    [sym_string_literal] = STATE(429),
    [sym_number_literal] = STATE(429),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(429),
    [sym_hex_string_literal] = STATE(429),
    [sym_unicode_string_literal] = STATE(429),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym__semicolon] = ACTIONS(282),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__expression] = STATE(413),
    [sym__primary_expression] = STATE(413),
    [sym_type_cast_expression] = STATE(413),
    [sym_ternary_expression] = STATE(413),
    [sym_new_expression] = STATE(413),
    [sym_tuple_expression] = STATE(413),
    [sym_inline_array_expression] = STATE(413),
    [sym_binary_expression] = STATE(413),
    [sym_unary_expression] = STATE(413),
    [sym_update_expression] = STATE(413),
    [sym_member_expression] = STATE(413),
    [sym_array_access] = STATE(413),
    [sym_slice_access] = STATE(413),
    [sym_struct_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_augmented_assignment_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_payable_conversion_expression] = STATE(413),
    [sym_meta_type_expression] = STATE(413),
    [sym_user_defined_type] = STATE(413),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(413),
    [sym_string_literal] = STATE(413),
    [sym_number_literal] = STATE(413),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(413),
    [sym_hex_string_literal] = STATE(413),
    [sym_unicode_string_literal] = STATE(413),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(284),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__expression] = STATE(420),
    [sym__primary_expression] = STATE(420),
    [sym_type_cast_expression] = STATE(420),
    [sym_ternary_expression] = STATE(420),
    [sym_new_expression] = STATE(420),
    [sym_tuple_expression] = STATE(420),
    [sym_inline_array_expression] = STATE(420),
    [sym_binary_expression] = STATE(420),
    [sym_unary_expression] = STATE(420),
    [sym_update_expression] = STATE(420),
    [sym_member_expression] = STATE(420),
    [sym_array_access] = STATE(420),
    [sym_slice_access] = STATE(420),
    [sym_struct_expression] = STATE(420),
    [sym_parenthesized_expression] = STATE(420),
    [sym_assignment_expression] = STATE(420),
    [sym_augmented_assignment_expression] = STATE(420),
    [sym_call_expression] = STATE(420),
    [sym_payable_conversion_expression] = STATE(420),
    [sym_meta_type_expression] = STATE(420),
    [sym_user_defined_type] = STATE(420),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(420),
    [sym_string_literal] = STATE(420),
    [sym_number_literal] = STATE(420),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(420),
    [sym_hex_string_literal] = STATE(420),
    [sym_unicode_string_literal] = STATE(420),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(286),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__expression] = STATE(406),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(288),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__expression] = STATE(426),
    [sym__primary_expression] = STATE(426),
    [sym_type_cast_expression] = STATE(426),
    [sym_ternary_expression] = STATE(426),
    [sym_new_expression] = STATE(426),
    [sym_tuple_expression] = STATE(426),
    [sym_inline_array_expression] = STATE(426),
    [sym_binary_expression] = STATE(426),
    [sym_unary_expression] = STATE(426),
    [sym_update_expression] = STATE(426),
    [sym_member_expression] = STATE(426),
    [sym_array_access] = STATE(426),
    [sym_slice_access] = STATE(426),
    [sym_struct_expression] = STATE(426),
    [sym_parenthesized_expression] = STATE(426),
    [sym_assignment_expression] = STATE(426),
    [sym_augmented_assignment_expression] = STATE(426),
    [sym_call_expression] = STATE(426),
    [sym_payable_conversion_expression] = STATE(426),
    [sym_meta_type_expression] = STATE(426),
    [sym_user_defined_type] = STATE(426),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_number_literal] = STATE(426),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(426),
    [sym_hex_string_literal] = STATE(426),
    [sym_unicode_string_literal] = STATE(426),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_RBRACK] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__expression] = STATE(415),
    [sym__primary_expression] = STATE(415),
    [sym_type_cast_expression] = STATE(415),
    [sym_ternary_expression] = STATE(415),
    [sym_new_expression] = STATE(415),
    [sym_tuple_expression] = STATE(415),
    [sym_inline_array_expression] = STATE(415),
    [sym_binary_expression] = STATE(415),
    [sym_unary_expression] = STATE(415),
    [sym_update_expression] = STATE(415),
    [sym_member_expression] = STATE(415),
    [sym_array_access] = STATE(415),
    [sym_slice_access] = STATE(415),
    [sym_struct_expression] = STATE(415),
    [sym_parenthesized_expression] = STATE(415),
    [sym_assignment_expression] = STATE(415),
    [sym_augmented_assignment_expression] = STATE(415),
    [sym_call_expression] = STATE(415),
    [sym_payable_conversion_expression] = STATE(415),
    [sym_meta_type_expression] = STATE(415),
    [sym_user_defined_type] = STATE(415),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(415),
    [sym_string_literal] = STATE(415),
    [sym_number_literal] = STATE(415),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(415),
    [sym_hex_string_literal] = STATE(415),
    [sym_unicode_string_literal] = STATE(415),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__expression] = STATE(356),
    [sym__primary_expression] = STATE(356),
    [sym_type_cast_expression] = STATE(356),
    [sym_ternary_expression] = STATE(356),
    [sym_new_expression] = STATE(356),
    [sym_tuple_expression] = STATE(356),
    [sym_inline_array_expression] = STATE(356),
    [sym_binary_expression] = STATE(356),
    [sym_unary_expression] = STATE(356),
    [sym_update_expression] = STATE(356),
    [sym_member_expression] = STATE(356),
    [sym_array_access] = STATE(356),
    [sym_slice_access] = STATE(356),
    [sym_struct_expression] = STATE(356),
    [sym_parenthesized_expression] = STATE(356),
    [sym_assignment_expression] = STATE(356),
    [sym_augmented_assignment_expression] = STATE(356),
    [sym_call_expression] = STATE(356),
    [sym_payable_conversion_expression] = STATE(356),
    [sym_meta_type_expression] = STATE(356),
    [sym_user_defined_type] = STATE(356),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(356),
    [sym_string_literal] = STATE(356),
    [sym_number_literal] = STATE(356),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(356),
    [sym_hex_string_literal] = STATE(356),
    [sym_unicode_string_literal] = STATE(356),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__expression] = STATE(416),
    [sym__primary_expression] = STATE(416),
    [sym_type_cast_expression] = STATE(416),
    [sym_ternary_expression] = STATE(416),
    [sym_new_expression] = STATE(416),
    [sym_tuple_expression] = STATE(416),
    [sym_inline_array_expression] = STATE(416),
    [sym_binary_expression] = STATE(416),
    [sym_unary_expression] = STATE(416),
    [sym_update_expression] = STATE(416),
    [sym_member_expression] = STATE(416),
    [sym_array_access] = STATE(416),
    [sym_slice_access] = STATE(416),
    [sym_struct_expression] = STATE(416),
    [sym_parenthesized_expression] = STATE(416),
    [sym_assignment_expression] = STATE(416),
    [sym_augmented_assignment_expression] = STATE(416),
    [sym_call_expression] = STATE(416),
    [sym_payable_conversion_expression] = STATE(416),
    [sym_meta_type_expression] = STATE(416),
    [sym_user_defined_type] = STATE(416),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(416),
    [sym_string_literal] = STATE(416),
    [sym_number_literal] = STATE(416),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(416),
    [sym_hex_string_literal] = STATE(416),
    [sym_unicode_string_literal] = STATE(416),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__expression] = STATE(410),
    [sym__primary_expression] = STATE(410),
    [sym_type_cast_expression] = STATE(410),
    [sym_ternary_expression] = STATE(410),
    [sym_new_expression] = STATE(410),
    [sym_tuple_expression] = STATE(410),
    [sym_inline_array_expression] = STATE(410),
    [sym_binary_expression] = STATE(410),
    [sym_unary_expression] = STATE(410),
    [sym_update_expression] = STATE(410),
    [sym_member_expression] = STATE(410),
    [sym_array_access] = STATE(410),
    [sym_slice_access] = STATE(410),
    [sym_struct_expression] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_assignment_expression] = STATE(410),
    [sym_augmented_assignment_expression] = STATE(410),
    [sym_call_expression] = STATE(410),
    [sym_payable_conversion_expression] = STATE(410),
    [sym_meta_type_expression] = STATE(410),
    [sym_user_defined_type] = STATE(410),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(410),
    [sym_string_literal] = STATE(410),
    [sym_number_literal] = STATE(410),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(410),
    [sym_hex_string_literal] = STATE(410),
    [sym_unicode_string_literal] = STATE(410),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__expression] = STATE(422),
    [sym__primary_expression] = STATE(422),
    [sym_type_cast_expression] = STATE(422),
    [sym_ternary_expression] = STATE(422),
    [sym_new_expression] = STATE(422),
    [sym_tuple_expression] = STATE(422),
    [sym_inline_array_expression] = STATE(422),
    [sym_binary_expression] = STATE(422),
    [sym_unary_expression] = STATE(422),
    [sym_update_expression] = STATE(422),
    [sym_member_expression] = STATE(422),
    [sym_array_access] = STATE(422),
    [sym_slice_access] = STATE(422),
    [sym_struct_expression] = STATE(422),
    [sym_parenthesized_expression] = STATE(422),
    [sym_assignment_expression] = STATE(422),
    [sym_augmented_assignment_expression] = STATE(422),
    [sym_call_expression] = STATE(422),
    [sym_payable_conversion_expression] = STATE(422),
    [sym_meta_type_expression] = STATE(422),
    [sym_user_defined_type] = STATE(422),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(422),
    [sym_string_literal] = STATE(422),
    [sym_number_literal] = STATE(422),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(422),
    [sym_hex_string_literal] = STATE(422),
    [sym_unicode_string_literal] = STATE(422),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__expression] = STATE(425),
    [sym__primary_expression] = STATE(425),
    [sym_type_cast_expression] = STATE(425),
    [sym_ternary_expression] = STATE(425),
    [sym_new_expression] = STATE(425),
    [sym_tuple_expression] = STATE(425),
    [sym_inline_array_expression] = STATE(425),
    [sym_binary_expression] = STATE(425),
    [sym_unary_expression] = STATE(425),
    [sym_update_expression] = STATE(425),
    [sym_member_expression] = STATE(425),
    [sym_array_access] = STATE(425),
    [sym_slice_access] = STATE(425),
    [sym_struct_expression] = STATE(425),
    [sym_parenthesized_expression] = STATE(425),
    [sym_assignment_expression] = STATE(425),
    [sym_augmented_assignment_expression] = STATE(425),
    [sym_call_expression] = STATE(425),
    [sym_payable_conversion_expression] = STATE(425),
    [sym_meta_type_expression] = STATE(425),
    [sym_user_defined_type] = STATE(425),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(425),
    [sym_string_literal] = STATE(425),
    [sym_number_literal] = STATE(425),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(425),
    [sym_hex_string_literal] = STATE(425),
    [sym_unicode_string_literal] = STATE(425),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__expression] = STATE(421),
    [sym__primary_expression] = STATE(421),
    [sym_type_cast_expression] = STATE(421),
    [sym_ternary_expression] = STATE(421),
    [sym_new_expression] = STATE(421),
    [sym_tuple_expression] = STATE(421),
    [sym_inline_array_expression] = STATE(421),
    [sym_binary_expression] = STATE(421),
    [sym_unary_expression] = STATE(421),
    [sym_update_expression] = STATE(421),
    [sym_member_expression] = STATE(421),
    [sym_array_access] = STATE(421),
    [sym_slice_access] = STATE(421),
    [sym_struct_expression] = STATE(421),
    [sym_parenthesized_expression] = STATE(421),
    [sym_assignment_expression] = STATE(421),
    [sym_augmented_assignment_expression] = STATE(421),
    [sym_call_expression] = STATE(421),
    [sym_payable_conversion_expression] = STATE(421),
    [sym_meta_type_expression] = STATE(421),
    [sym_user_defined_type] = STATE(421),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(421),
    [sym_string_literal] = STATE(421),
    [sym_number_literal] = STATE(421),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(421),
    [sym_hex_string_literal] = STATE(421),
    [sym_unicode_string_literal] = STATE(421),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__expression] = STATE(423),
    [sym__primary_expression] = STATE(423),
    [sym_type_cast_expression] = STATE(423),
    [sym_ternary_expression] = STATE(423),
    [sym_new_expression] = STATE(423),
    [sym_tuple_expression] = STATE(423),
    [sym_inline_array_expression] = STATE(423),
    [sym_binary_expression] = STATE(423),
    [sym_unary_expression] = STATE(423),
    [sym_update_expression] = STATE(423),
    [sym_member_expression] = STATE(423),
    [sym_array_access] = STATE(423),
    [sym_slice_access] = STATE(423),
    [sym_struct_expression] = STATE(423),
    [sym_parenthesized_expression] = STATE(423),
    [sym_assignment_expression] = STATE(423),
    [sym_augmented_assignment_expression] = STATE(423),
    [sym_call_expression] = STATE(423),
    [sym_payable_conversion_expression] = STATE(423),
    [sym_meta_type_expression] = STATE(423),
    [sym_user_defined_type] = STATE(423),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(423),
    [sym_string_literal] = STATE(423),
    [sym_number_literal] = STATE(423),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(423),
    [sym_hex_string_literal] = STATE(423),
    [sym_unicode_string_literal] = STATE(423),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__expression] = STATE(367),
    [sym__primary_expression] = STATE(367),
    [sym_type_cast_expression] = STATE(367),
    [sym_ternary_expression] = STATE(367),
    [sym_new_expression] = STATE(367),
    [sym_tuple_expression] = STATE(367),
    [sym_inline_array_expression] = STATE(367),
    [sym_binary_expression] = STATE(367),
    [sym_unary_expression] = STATE(367),
    [sym_update_expression] = STATE(367),
    [sym_member_expression] = STATE(367),
    [sym_array_access] = STATE(367),
    [sym_slice_access] = STATE(367),
    [sym_struct_expression] = STATE(367),
    [sym_parenthesized_expression] = STATE(367),
    [sym_assignment_expression] = STATE(367),
    [sym_augmented_assignment_expression] = STATE(367),
    [sym_call_expression] = STATE(367),
    [sym_payable_conversion_expression] = STATE(367),
    [sym_meta_type_expression] = STATE(367),
    [sym_user_defined_type] = STATE(367),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(367),
    [sym_string_literal] = STATE(367),
    [sym_number_literal] = STATE(367),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(367),
    [sym_hex_string_literal] = STATE(367),
    [sym_unicode_string_literal] = STATE(367),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__expression] = STATE(363),
    [sym__primary_expression] = STATE(363),
    [sym_type_cast_expression] = STATE(363),
    [sym_ternary_expression] = STATE(363),
    [sym_new_expression] = STATE(363),
    [sym_tuple_expression] = STATE(363),
    [sym_inline_array_expression] = STATE(363),
    [sym_binary_expression] = STATE(363),
    [sym_unary_expression] = STATE(363),
    [sym_update_expression] = STATE(363),
    [sym_member_expression] = STATE(363),
    [sym_array_access] = STATE(363),
    [sym_slice_access] = STATE(363),
    [sym_struct_expression] = STATE(363),
    [sym_parenthesized_expression] = STATE(363),
    [sym_assignment_expression] = STATE(363),
    [sym_augmented_assignment_expression] = STATE(363),
    [sym_call_expression] = STATE(363),
    [sym_payable_conversion_expression] = STATE(363),
    [sym_meta_type_expression] = STATE(363),
    [sym_user_defined_type] = STATE(363),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(363),
    [sym_string_literal] = STATE(363),
    [sym_number_literal] = STATE(363),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(363),
    [sym_hex_string_literal] = STATE(363),
    [sym_unicode_string_literal] = STATE(363),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__expression] = STATE(360),
    [sym__primary_expression] = STATE(360),
    [sym_type_cast_expression] = STATE(360),
    [sym_ternary_expression] = STATE(360),
    [sym_new_expression] = STATE(360),
    [sym_tuple_expression] = STATE(360),
    [sym_inline_array_expression] = STATE(360),
    [sym_binary_expression] = STATE(360),
    [sym_unary_expression] = STATE(360),
    [sym_update_expression] = STATE(360),
    [sym_member_expression] = STATE(360),
    [sym_array_access] = STATE(360),
    [sym_slice_access] = STATE(360),
    [sym_struct_expression] = STATE(360),
    [sym_parenthesized_expression] = STATE(360),
    [sym_assignment_expression] = STATE(360),
    [sym_augmented_assignment_expression] = STATE(360),
    [sym_call_expression] = STATE(360),
    [sym_payable_conversion_expression] = STATE(360),
    [sym_meta_type_expression] = STATE(360),
    [sym_user_defined_type] = STATE(360),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(360),
    [sym_string_literal] = STATE(360),
    [sym_number_literal] = STATE(360),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(360),
    [sym_hex_string_literal] = STATE(360),
    [sym_unicode_string_literal] = STATE(360),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__expression] = STATE(432),
    [sym__primary_expression] = STATE(432),
    [sym_type_cast_expression] = STATE(432),
    [sym_ternary_expression] = STATE(432),
    [sym_new_expression] = STATE(432),
    [sym_tuple_expression] = STATE(432),
    [sym_inline_array_expression] = STATE(432),
    [sym_binary_expression] = STATE(432),
    [sym_unary_expression] = STATE(432),
    [sym_update_expression] = STATE(432),
    [sym_member_expression] = STATE(432),
    [sym_array_access] = STATE(432),
    [sym_slice_access] = STATE(432),
    [sym_struct_expression] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_assignment_expression] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(432),
    [sym_call_expression] = STATE(432),
    [sym_payable_conversion_expression] = STATE(432),
    [sym_meta_type_expression] = STATE(432),
    [sym_user_defined_type] = STATE(432),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(432),
    [sym_string_literal] = STATE(432),
    [sym_number_literal] = STATE(432),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(432),
    [sym_hex_string_literal] = STATE(432),
    [sym_unicode_string_literal] = STATE(432),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__expression] = STATE(368),
    [sym__primary_expression] = STATE(368),
    [sym_type_cast_expression] = STATE(368),
    [sym_ternary_expression] = STATE(368),
    [sym_new_expression] = STATE(368),
    [sym_tuple_expression] = STATE(368),
    [sym_inline_array_expression] = STATE(368),
    [sym_binary_expression] = STATE(368),
    [sym_unary_expression] = STATE(368),
    [sym_update_expression] = STATE(368),
    [sym_member_expression] = STATE(368),
    [sym_array_access] = STATE(368),
    [sym_slice_access] = STATE(368),
    [sym_struct_expression] = STATE(368),
    [sym_parenthesized_expression] = STATE(368),
    [sym_assignment_expression] = STATE(368),
    [sym_augmented_assignment_expression] = STATE(368),
    [sym_call_expression] = STATE(368),
    [sym_payable_conversion_expression] = STATE(368),
    [sym_meta_type_expression] = STATE(368),
    [sym_user_defined_type] = STATE(368),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(368),
    [sym_string_literal] = STATE(368),
    [sym_number_literal] = STATE(368),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(368),
    [sym_hex_string_literal] = STATE(368),
    [sym_unicode_string_literal] = STATE(368),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__expression] = STATE(405),
    [sym__primary_expression] = STATE(405),
    [sym_type_cast_expression] = STATE(405),
    [sym_ternary_expression] = STATE(405),
    [sym_new_expression] = STATE(405),
    [sym_tuple_expression] = STATE(405),
    [sym_inline_array_expression] = STATE(405),
    [sym_binary_expression] = STATE(405),
    [sym_unary_expression] = STATE(405),
    [sym_update_expression] = STATE(405),
    [sym_member_expression] = STATE(405),
    [sym_array_access] = STATE(405),
    [sym_slice_access] = STATE(405),
    [sym_struct_expression] = STATE(405),
    [sym_parenthesized_expression] = STATE(405),
    [sym_assignment_expression] = STATE(405),
    [sym_augmented_assignment_expression] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_payable_conversion_expression] = STATE(405),
    [sym_meta_type_expression] = STATE(405),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(405),
    [sym_string_literal] = STATE(405),
    [sym_number_literal] = STATE(405),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(405),
    [sym_hex_string_literal] = STATE(405),
    [sym_unicode_string_literal] = STATE(405),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__expression] = STATE(418),
    [sym__primary_expression] = STATE(418),
    [sym_type_cast_expression] = STATE(418),
    [sym_ternary_expression] = STATE(418),
    [sym_new_expression] = STATE(418),
    [sym_tuple_expression] = STATE(418),
    [sym_inline_array_expression] = STATE(418),
    [sym_binary_expression] = STATE(418),
    [sym_unary_expression] = STATE(418),
    [sym_update_expression] = STATE(418),
    [sym_member_expression] = STATE(418),
    [sym_array_access] = STATE(418),
    [sym_slice_access] = STATE(418),
    [sym_struct_expression] = STATE(418),
    [sym_parenthesized_expression] = STATE(418),
    [sym_assignment_expression] = STATE(418),
    [sym_augmented_assignment_expression] = STATE(418),
    [sym_call_expression] = STATE(418),
    [sym_payable_conversion_expression] = STATE(418),
    [sym_meta_type_expression] = STATE(418),
    [sym_user_defined_type] = STATE(418),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(418),
    [sym_string_literal] = STATE(418),
    [sym_number_literal] = STATE(418),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(418),
    [sym_hex_string_literal] = STATE(418),
    [sym_unicode_string_literal] = STATE(418),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__expression] = STATE(355),
    [sym__primary_expression] = STATE(355),
    [sym_type_cast_expression] = STATE(355),
    [sym_ternary_expression] = STATE(355),
    [sym_new_expression] = STATE(355),
    [sym_tuple_expression] = STATE(355),
    [sym_inline_array_expression] = STATE(355),
    [sym_binary_expression] = STATE(355),
    [sym_unary_expression] = STATE(355),
    [sym_update_expression] = STATE(355),
    [sym_member_expression] = STATE(355),
    [sym_array_access] = STATE(355),
    [sym_slice_access] = STATE(355),
    [sym_struct_expression] = STATE(355),
    [sym_parenthesized_expression] = STATE(355),
    [sym_assignment_expression] = STATE(355),
    [sym_augmented_assignment_expression] = STATE(355),
    [sym_call_expression] = STATE(355),
    [sym_payable_conversion_expression] = STATE(355),
    [sym_meta_type_expression] = STATE(355),
    [sym_user_defined_type] = STATE(355),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(355),
    [sym_string_literal] = STATE(355),
    [sym_number_literal] = STATE(355),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(355),
    [sym_hex_string_literal] = STATE(355),
    [sym_unicode_string_literal] = STATE(355),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__expression] = STATE(353),
    [sym__primary_expression] = STATE(353),
    [sym_type_cast_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_new_expression] = STATE(353),
    [sym_tuple_expression] = STATE(353),
    [sym_inline_array_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_member_expression] = STATE(353),
    [sym_array_access] = STATE(353),
    [sym_slice_access] = STATE(353),
    [sym_struct_expression] = STATE(353),
    [sym_parenthesized_expression] = STATE(353),
    [sym_assignment_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_payable_conversion_expression] = STATE(353),
    [sym_meta_type_expression] = STATE(353),
    [sym_user_defined_type] = STATE(353),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(353),
    [sym_string_literal] = STATE(353),
    [sym_number_literal] = STATE(353),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(353),
    [sym_hex_string_literal] = STATE(353),
    [sym_unicode_string_literal] = STATE(353),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__expression] = STATE(352),
    [sym__primary_expression] = STATE(352),
    [sym_type_cast_expression] = STATE(352),
    [sym_ternary_expression] = STATE(352),
    [sym_new_expression] = STATE(352),
    [sym_tuple_expression] = STATE(352),
    [sym_inline_array_expression] = STATE(352),
    [sym_binary_expression] = STATE(352),
    [sym_unary_expression] = STATE(352),
    [sym_update_expression] = STATE(352),
    [sym_member_expression] = STATE(352),
    [sym_array_access] = STATE(352),
    [sym_slice_access] = STATE(352),
    [sym_struct_expression] = STATE(352),
    [sym_parenthesized_expression] = STATE(352),
    [sym_assignment_expression] = STATE(352),
    [sym_augmented_assignment_expression] = STATE(352),
    [sym_call_expression] = STATE(352),
    [sym_payable_conversion_expression] = STATE(352),
    [sym_meta_type_expression] = STATE(352),
    [sym_user_defined_type] = STATE(352),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(352),
    [sym_string_literal] = STATE(352),
    [sym_number_literal] = STATE(352),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(352),
    [sym_hex_string_literal] = STATE(352),
    [sym_unicode_string_literal] = STATE(352),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__expression] = STATE(364),
    [sym__primary_expression] = STATE(364),
    [sym_type_cast_expression] = STATE(364),
    [sym_ternary_expression] = STATE(364),
    [sym_new_expression] = STATE(364),
    [sym_tuple_expression] = STATE(364),
    [sym_inline_array_expression] = STATE(364),
    [sym_binary_expression] = STATE(364),
    [sym_unary_expression] = STATE(364),
    [sym_update_expression] = STATE(364),
    [sym_member_expression] = STATE(364),
    [sym_array_access] = STATE(364),
    [sym_slice_access] = STATE(364),
    [sym_struct_expression] = STATE(364),
    [sym_parenthesized_expression] = STATE(364),
    [sym_assignment_expression] = STATE(364),
    [sym_augmented_assignment_expression] = STATE(364),
    [sym_call_expression] = STATE(364),
    [sym_payable_conversion_expression] = STATE(364),
    [sym_meta_type_expression] = STATE(364),
    [sym_user_defined_type] = STATE(364),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(364),
    [sym_string_literal] = STATE(364),
    [sym_number_literal] = STATE(364),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(364),
    [sym_hex_string_literal] = STATE(364),
    [sym_unicode_string_literal] = STATE(364),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__expression] = STATE(366),
    [sym__primary_expression] = STATE(366),
    [sym_type_cast_expression] = STATE(366),
    [sym_ternary_expression] = STATE(366),
    [sym_new_expression] = STATE(366),
    [sym_tuple_expression] = STATE(366),
    [sym_inline_array_expression] = STATE(366),
    [sym_binary_expression] = STATE(366),
    [sym_unary_expression] = STATE(366),
    [sym_update_expression] = STATE(366),
    [sym_member_expression] = STATE(366),
    [sym_array_access] = STATE(366),
    [sym_slice_access] = STATE(366),
    [sym_struct_expression] = STATE(366),
    [sym_parenthesized_expression] = STATE(366),
    [sym_assignment_expression] = STATE(366),
    [sym_augmented_assignment_expression] = STATE(366),
    [sym_call_expression] = STATE(366),
    [sym_payable_conversion_expression] = STATE(366),
    [sym_meta_type_expression] = STATE(366),
    [sym_user_defined_type] = STATE(366),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(366),
    [sym_string_literal] = STATE(366),
    [sym_number_literal] = STATE(366),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(366),
    [sym_hex_string_literal] = STATE(366),
    [sym_unicode_string_literal] = STATE(366),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__expression] = STATE(417),
    [sym__primary_expression] = STATE(417),
    [sym_type_cast_expression] = STATE(417),
    [sym_ternary_expression] = STATE(417),
    [sym_new_expression] = STATE(417),
    [sym_tuple_expression] = STATE(417),
    [sym_inline_array_expression] = STATE(417),
    [sym_binary_expression] = STATE(417),
    [sym_unary_expression] = STATE(417),
    [sym_update_expression] = STATE(417),
    [sym_member_expression] = STATE(417),
    [sym_array_access] = STATE(417),
    [sym_slice_access] = STATE(417),
    [sym_struct_expression] = STATE(417),
    [sym_parenthesized_expression] = STATE(417),
    [sym_assignment_expression] = STATE(417),
    [sym_augmented_assignment_expression] = STATE(417),
    [sym_call_expression] = STATE(417),
    [sym_payable_conversion_expression] = STATE(417),
    [sym_meta_type_expression] = STATE(417),
    [sym_user_defined_type] = STATE(417),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(417),
    [sym_string_literal] = STATE(417),
    [sym_number_literal] = STATE(417),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(417),
    [sym_hex_string_literal] = STATE(417),
    [sym_unicode_string_literal] = STATE(417),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__expression] = STATE(413),
    [sym__primary_expression] = STATE(413),
    [sym_type_cast_expression] = STATE(413),
    [sym_ternary_expression] = STATE(413),
    [sym_new_expression] = STATE(413),
    [sym_tuple_expression] = STATE(413),
    [sym_inline_array_expression] = STATE(413),
    [sym_binary_expression] = STATE(413),
    [sym_unary_expression] = STATE(413),
    [sym_update_expression] = STATE(413),
    [sym_member_expression] = STATE(413),
    [sym_array_access] = STATE(413),
    [sym_slice_access] = STATE(413),
    [sym_struct_expression] = STATE(413),
    [sym_parenthesized_expression] = STATE(413),
    [sym_assignment_expression] = STATE(413),
    [sym_augmented_assignment_expression] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_payable_conversion_expression] = STATE(413),
    [sym_meta_type_expression] = STATE(413),
    [sym_user_defined_type] = STATE(413),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(413),
    [sym_string_literal] = STATE(413),
    [sym_number_literal] = STATE(413),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(413),
    [sym_hex_string_literal] = STATE(413),
    [sym_unicode_string_literal] = STATE(413),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__expression] = STATE(351),
    [sym__primary_expression] = STATE(351),
    [sym_type_cast_expression] = STATE(351),
    [sym_ternary_expression] = STATE(351),
    [sym_new_expression] = STATE(351),
    [sym_tuple_expression] = STATE(351),
    [sym_inline_array_expression] = STATE(351),
    [sym_binary_expression] = STATE(351),
    [sym_unary_expression] = STATE(351),
    [sym_update_expression] = STATE(351),
    [sym_member_expression] = STATE(351),
    [sym_array_access] = STATE(351),
    [sym_slice_access] = STATE(351),
    [sym_struct_expression] = STATE(351),
    [sym_parenthesized_expression] = STATE(351),
    [sym_assignment_expression] = STATE(351),
    [sym_augmented_assignment_expression] = STATE(351),
    [sym_call_expression] = STATE(351),
    [sym_payable_conversion_expression] = STATE(351),
    [sym_meta_type_expression] = STATE(351),
    [sym_user_defined_type] = STATE(351),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(351),
    [sym_string_literal] = STATE(351),
    [sym_number_literal] = STATE(351),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(351),
    [sym_hex_string_literal] = STATE(351),
    [sym_unicode_string_literal] = STATE(351),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__expression] = STATE(349),
    [sym__primary_expression] = STATE(349),
    [sym_type_cast_expression] = STATE(349),
    [sym_ternary_expression] = STATE(349),
    [sym_new_expression] = STATE(349),
    [sym_tuple_expression] = STATE(349),
    [sym_inline_array_expression] = STATE(349),
    [sym_binary_expression] = STATE(349),
    [sym_unary_expression] = STATE(349),
    [sym_update_expression] = STATE(349),
    [sym_member_expression] = STATE(349),
    [sym_array_access] = STATE(349),
    [sym_slice_access] = STATE(349),
    [sym_struct_expression] = STATE(349),
    [sym_parenthesized_expression] = STATE(349),
    [sym_assignment_expression] = STATE(349),
    [sym_augmented_assignment_expression] = STATE(349),
    [sym_call_expression] = STATE(349),
    [sym_payable_conversion_expression] = STATE(349),
    [sym_meta_type_expression] = STATE(349),
    [sym_user_defined_type] = STATE(349),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(349),
    [sym_string_literal] = STATE(349),
    [sym_number_literal] = STATE(349),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(349),
    [sym_hex_string_literal] = STATE(349),
    [sym_unicode_string_literal] = STATE(349),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__expression] = STATE(357),
    [sym__primary_expression] = STATE(357),
    [sym_type_cast_expression] = STATE(357),
    [sym_ternary_expression] = STATE(357),
    [sym_new_expression] = STATE(357),
    [sym_tuple_expression] = STATE(357),
    [sym_inline_array_expression] = STATE(357),
    [sym_binary_expression] = STATE(357),
    [sym_unary_expression] = STATE(357),
    [sym_update_expression] = STATE(357),
    [sym_member_expression] = STATE(357),
    [sym_array_access] = STATE(357),
    [sym_slice_access] = STATE(357),
    [sym_struct_expression] = STATE(357),
    [sym_parenthesized_expression] = STATE(357),
    [sym_assignment_expression] = STATE(357),
    [sym_augmented_assignment_expression] = STATE(357),
    [sym_call_expression] = STATE(357),
    [sym_payable_conversion_expression] = STATE(357),
    [sym_meta_type_expression] = STATE(357),
    [sym_user_defined_type] = STATE(357),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(357),
    [sym_string_literal] = STATE(357),
    [sym_number_literal] = STATE(357),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(357),
    [sym_hex_string_literal] = STATE(357),
    [sym_unicode_string_literal] = STATE(357),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__expression] = STATE(414),
    [sym__primary_expression] = STATE(414),
    [sym_type_cast_expression] = STATE(414),
    [sym_ternary_expression] = STATE(414),
    [sym_new_expression] = STATE(414),
    [sym_tuple_expression] = STATE(414),
    [sym_inline_array_expression] = STATE(414),
    [sym_binary_expression] = STATE(414),
    [sym_unary_expression] = STATE(414),
    [sym_update_expression] = STATE(414),
    [sym_member_expression] = STATE(414),
    [sym_array_access] = STATE(414),
    [sym_slice_access] = STATE(414),
    [sym_struct_expression] = STATE(414),
    [sym_parenthesized_expression] = STATE(414),
    [sym_assignment_expression] = STATE(414),
    [sym_augmented_assignment_expression] = STATE(414),
    [sym_call_expression] = STATE(414),
    [sym_payable_conversion_expression] = STATE(414),
    [sym_meta_type_expression] = STATE(414),
    [sym_user_defined_type] = STATE(414),
    [sym__identifier_path] = STATE(315),
    [sym_primitive_type] = STATE(354),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym__literal] = STATE(414),
    [sym_string_literal] = STATE(414),
    [sym_number_literal] = STATE(414),
    [sym__decimal_number] = STATE(326),
    [sym__hex_number] = STATE(326),
    [sym_true] = STATE(385),
    [sym_false] = STATE(385),
    [sym_boolean_literal] = STATE(414),
    [sym_hex_string_literal] = STATE(414),
    [sym_unicode_string_literal] = STATE(414),
    [sym_string] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(343),
    [aux_sym_hex_string_literal_repeat2] = STATE(347),
    [aux_sym_unicode_string_literal_repeat3] = STATE(348),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(39),
    [anon_sym_TILDE] = ACTIONS(41),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(59),
    [anon_sym_false] = ACTIONS(61),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_payable] = ACTIONS(83),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_delete] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_catch_clause] = STATE(69),
    [aux_sym_try_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(292),
    [anon_sym_DASH] = ACTIONS(292),
    [anon_sym_TILDE] = ACTIONS(294),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_RBRACE] = ACTIONS(294),
    [anon_sym_type] = ACTIONS(292),
    [anon_sym_LPAREN] = ACTIONS(294),
    [anon_sym_for] = ACTIONS(292),
    [anon_sym_assembly] = ACTIONS(292),
    [anon_sym_break] = ACTIONS(292),
    [anon_sym_continue] = ACTIONS(292),
    [anon_sym_true] = ACTIONS(292),
    [anon_sym_false] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(292),
    [anon_sym_function] = ACTIONS(292),
    [anon_sym_byte] = ACTIONS(292),
    [anon_sym_address] = ACTIONS(292),
    [anon_sym_return] = ACTIONS(292),
    [anon_sym_revert] = ACTIONS(292),
    [sym_unchecked] = ACTIONS(292),
    [anon_sym_var] = ACTIONS(292),
    [anon_sym_else] = ACTIONS(292),
    [anon_sym_while] = ACTIONS(292),
    [anon_sym_do] = ACTIONS(292),
    [anon_sym_try] = ACTIONS(292),
    [anon_sym_catch] = ACTIONS(296),
    [anon_sym_emit] = ACTIONS(292),
    [anon_sym_payable] = ACTIONS(292),
    [anon_sym_new] = ACTIONS(292),
    [anon_sym_LBRACK] = ACTIONS(294),
    [anon_sym_PLUS] = ACTIONS(292),
    [anon_sym_BANG] = ACTIONS(294),
    [anon_sym_delete] = ACTIONS(292),
    [anon_sym_PLUS_PLUS] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(294),
    [anon_sym_mapping] = ACTIONS(292),
    [anon_sym_bool] = ACTIONS(292),
    [anon_sym_string] = ACTIONS(292),
    [anon_sym_int] = ACTIONS(292),
    [anon_sym_int8] = ACTIONS(292),
    [anon_sym_int16] = ACTIONS(292),
    [anon_sym_int24] = ACTIONS(292),
    [anon_sym_int32] = ACTIONS(292),
    [anon_sym_int40] = ACTIONS(292),
    [anon_sym_int48] = ACTIONS(292),
    [anon_sym_int56] = ACTIONS(292),
    [anon_sym_int64] = ACTIONS(292),
    [anon_sym_int72] = ACTIONS(292),
    [anon_sym_int80] = ACTIONS(292),
    [anon_sym_int88] = ACTIONS(292),
    [anon_sym_int96] = ACTIONS(292),
    [anon_sym_int104] = ACTIONS(292),
    [anon_sym_int112] = ACTIONS(292),
    [anon_sym_int120] = ACTIONS(292),
    [anon_sym_int128] = ACTIONS(292),
    [anon_sym_int136] = ACTIONS(292),
    [anon_sym_int144] = ACTIONS(292),
    [anon_sym_int152] = ACTIONS(292),
    [anon_sym_int160] = ACTIONS(292),
    [anon_sym_int168] = ACTIONS(292),
    [anon_sym_int176] = ACTIONS(292),
    [anon_sym_int184] = ACTIONS(292),
    [anon_sym_int192] = ACTIONS(292),
    [anon_sym_int200] = ACTIONS(292),
    [anon_sym_int208] = ACTIONS(292),
    [anon_sym_int216] = ACTIONS(292),
    [anon_sym_int224] = ACTIONS(292),
    [anon_sym_int232] = ACTIONS(292),
    [anon_sym_int240] = ACTIONS(292),
    [anon_sym_int248] = ACTIONS(292),
    [anon_sym_int256] = ACTIONS(292),
    [anon_sym_uint] = ACTIONS(292),
    [anon_sym_uint8] = ACTIONS(292),
    [anon_sym_uint16] = ACTIONS(292),
    [anon_sym_uint24] = ACTIONS(292),
    [anon_sym_uint32] = ACTIONS(292),
    [anon_sym_uint40] = ACTIONS(292),
    [anon_sym_uint48] = ACTIONS(292),
    [anon_sym_uint56] = ACTIONS(292),
    [anon_sym_uint64] = ACTIONS(292),
    [anon_sym_uint72] = ACTIONS(292),
    [anon_sym_uint80] = ACTIONS(292),
    [anon_sym_uint88] = ACTIONS(292),
    [anon_sym_uint96] = ACTIONS(292),
    [anon_sym_uint104] = ACTIONS(292),
    [anon_sym_uint112] = ACTIONS(292),
    [anon_sym_uint120] = ACTIONS(292),
    [anon_sym_uint128] = ACTIONS(292),
    [anon_sym_uint136] = ACTIONS(292),
    [anon_sym_uint144] = ACTIONS(292),
    [anon_sym_uint152] = ACTIONS(292),
    [anon_sym_uint160] = ACTIONS(292),
    [anon_sym_uint168] = ACTIONS(292),
    [anon_sym_uint176] = ACTIONS(292),
    [anon_sym_uint184] = ACTIONS(292),
    [anon_sym_uint192] = ACTIONS(292),
    [anon_sym_uint200] = ACTIONS(292),
    [anon_sym_uint208] = ACTIONS(292),
    [anon_sym_uint216] = ACTIONS(292),
    [anon_sym_uint224] = ACTIONS(292),
    [anon_sym_uint232] = ACTIONS(292),
    [anon_sym_uint240] = ACTIONS(292),
    [anon_sym_uint248] = ACTIONS(292),
    [anon_sym_uint256] = ACTIONS(292),
    [anon_sym_bytes] = ACTIONS(292),
    [anon_sym_bytes1] = ACTIONS(292),
    [anon_sym_bytes2] = ACTIONS(292),
    [anon_sym_bytes3] = ACTIONS(292),
    [anon_sym_bytes4] = ACTIONS(292),
    [anon_sym_bytes5] = ACTIONS(292),
    [anon_sym_bytes6] = ACTIONS(292),
    [anon_sym_bytes7] = ACTIONS(292),
    [anon_sym_bytes8] = ACTIONS(292),
    [anon_sym_bytes9] = ACTIONS(292),
    [anon_sym_bytes10] = ACTIONS(292),
    [anon_sym_bytes11] = ACTIONS(292),
    [anon_sym_bytes12] = ACTIONS(292),
    [anon_sym_bytes13] = ACTIONS(292),
    [anon_sym_bytes14] = ACTIONS(292),
    [anon_sym_bytes15] = ACTIONS(292),
    [anon_sym_bytes16] = ACTIONS(292),
    [anon_sym_bytes17] = ACTIONS(292),
    [anon_sym_bytes18] = ACTIONS(292),
    [anon_sym_bytes19] = ACTIONS(292),
    [anon_sym_bytes20] = ACTIONS(292),
    [anon_sym_bytes21] = ACTIONS(292),
    [anon_sym_bytes22] = ACTIONS(292),
    [anon_sym_bytes23] = ACTIONS(292),
    [anon_sym_bytes24] = ACTIONS(292),
    [anon_sym_bytes25] = ACTIONS(292),
    [anon_sym_bytes26] = ACTIONS(292),
    [anon_sym_bytes27] = ACTIONS(292),
    [anon_sym_bytes28] = ACTIONS(292),
    [anon_sym_bytes29] = ACTIONS(292),
    [anon_sym_bytes30] = ACTIONS(292),
    [anon_sym_bytes31] = ACTIONS(292),
    [anon_sym_bytes32] = ACTIONS(292),
    [anon_sym_fixed] = ACTIONS(292),
    [aux_sym__fixed_token1] = ACTIONS(292),
    [anon_sym_ufixed] = ACTIONS(292),
    [aux_sym__ufixed_token1] = ACTIONS(292),
    [aux_sym__decimal_number_token1] = ACTIONS(292),
    [aux_sym__decimal_number_token2] = ACTIONS(294),
    [aux_sym__hex_number_token1] = ACTIONS(294),
    [anon_sym_hex] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_SQUOTE] = ACTIONS(294),
    [anon_sym_unicode] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_catch_clause] = STATE(69),
    [aux_sym_try_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(298),
    [anon_sym_DASH] = ACTIONS(298),
    [anon_sym_TILDE] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(300),
    [anon_sym_RBRACE] = ACTIONS(300),
    [anon_sym_type] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(300),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_assembly] = ACTIONS(298),
    [anon_sym_break] = ACTIONS(298),
    [anon_sym_continue] = ACTIONS(298),
    [anon_sym_true] = ACTIONS(298),
    [anon_sym_false] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_function] = ACTIONS(298),
    [anon_sym_byte] = ACTIONS(298),
    [anon_sym_address] = ACTIONS(298),
    [anon_sym_return] = ACTIONS(298),
    [anon_sym_revert] = ACTIONS(298),
    [sym_unchecked] = ACTIONS(298),
    [anon_sym_var] = ACTIONS(298),
    [anon_sym_else] = ACTIONS(298),
    [anon_sym_while] = ACTIONS(298),
    [anon_sym_do] = ACTIONS(298),
    [anon_sym_try] = ACTIONS(298),
    [anon_sym_catch] = ACTIONS(302),
    [anon_sym_emit] = ACTIONS(298),
    [anon_sym_payable] = ACTIONS(298),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(298),
    [anon_sym_BANG] = ACTIONS(300),
    [anon_sym_delete] = ACTIONS(298),
    [anon_sym_PLUS_PLUS] = ACTIONS(300),
    [anon_sym_DASH_DASH] = ACTIONS(300),
    [anon_sym_mapping] = ACTIONS(298),
    [anon_sym_bool] = ACTIONS(298),
    [anon_sym_string] = ACTIONS(298),
    [anon_sym_int] = ACTIONS(298),
    [anon_sym_int8] = ACTIONS(298),
    [anon_sym_int16] = ACTIONS(298),
    [anon_sym_int24] = ACTIONS(298),
    [anon_sym_int32] = ACTIONS(298),
    [anon_sym_int40] = ACTIONS(298),
    [anon_sym_int48] = ACTIONS(298),
    [anon_sym_int56] = ACTIONS(298),
    [anon_sym_int64] = ACTIONS(298),
    [anon_sym_int72] = ACTIONS(298),
    [anon_sym_int80] = ACTIONS(298),
    [anon_sym_int88] = ACTIONS(298),
    [anon_sym_int96] = ACTIONS(298),
    [anon_sym_int104] = ACTIONS(298),
    [anon_sym_int112] = ACTIONS(298),
    [anon_sym_int120] = ACTIONS(298),
    [anon_sym_int128] = ACTIONS(298),
    [anon_sym_int136] = ACTIONS(298),
    [anon_sym_int144] = ACTIONS(298),
    [anon_sym_int152] = ACTIONS(298),
    [anon_sym_int160] = ACTIONS(298),
    [anon_sym_int168] = ACTIONS(298),
    [anon_sym_int176] = ACTIONS(298),
    [anon_sym_int184] = ACTIONS(298),
    [anon_sym_int192] = ACTIONS(298),
    [anon_sym_int200] = ACTIONS(298),
    [anon_sym_int208] = ACTIONS(298),
    [anon_sym_int216] = ACTIONS(298),
    [anon_sym_int224] = ACTIONS(298),
    [anon_sym_int232] = ACTIONS(298),
    [anon_sym_int240] = ACTIONS(298),
    [anon_sym_int248] = ACTIONS(298),
    [anon_sym_int256] = ACTIONS(298),
    [anon_sym_uint] = ACTIONS(298),
    [anon_sym_uint8] = ACTIONS(298),
    [anon_sym_uint16] = ACTIONS(298),
    [anon_sym_uint24] = ACTIONS(298),
    [anon_sym_uint32] = ACTIONS(298),
    [anon_sym_uint40] = ACTIONS(298),
    [anon_sym_uint48] = ACTIONS(298),
    [anon_sym_uint56] = ACTIONS(298),
    [anon_sym_uint64] = ACTIONS(298),
    [anon_sym_uint72] = ACTIONS(298),
    [anon_sym_uint80] = ACTIONS(298),
    [anon_sym_uint88] = ACTIONS(298),
    [anon_sym_uint96] = ACTIONS(298),
    [anon_sym_uint104] = ACTIONS(298),
    [anon_sym_uint112] = ACTIONS(298),
    [anon_sym_uint120] = ACTIONS(298),
    [anon_sym_uint128] = ACTIONS(298),
    [anon_sym_uint136] = ACTIONS(298),
    [anon_sym_uint144] = ACTIONS(298),
    [anon_sym_uint152] = ACTIONS(298),
    [anon_sym_uint160] = ACTIONS(298),
    [anon_sym_uint168] = ACTIONS(298),
    [anon_sym_uint176] = ACTIONS(298),
    [anon_sym_uint184] = ACTIONS(298),
    [anon_sym_uint192] = ACTIONS(298),
    [anon_sym_uint200] = ACTIONS(298),
    [anon_sym_uint208] = ACTIONS(298),
    [anon_sym_uint216] = ACTIONS(298),
    [anon_sym_uint224] = ACTIONS(298),
    [anon_sym_uint232] = ACTIONS(298),
    [anon_sym_uint240] = ACTIONS(298),
    [anon_sym_uint248] = ACTIONS(298),
    [anon_sym_uint256] = ACTIONS(298),
    [anon_sym_bytes] = ACTIONS(298),
    [anon_sym_bytes1] = ACTIONS(298),
    [anon_sym_bytes2] = ACTIONS(298),
    [anon_sym_bytes3] = ACTIONS(298),
    [anon_sym_bytes4] = ACTIONS(298),
    [anon_sym_bytes5] = ACTIONS(298),
    [anon_sym_bytes6] = ACTIONS(298),
    [anon_sym_bytes7] = ACTIONS(298),
    [anon_sym_bytes8] = ACTIONS(298),
    [anon_sym_bytes9] = ACTIONS(298),
    [anon_sym_bytes10] = ACTIONS(298),
    [anon_sym_bytes11] = ACTIONS(298),
    [anon_sym_bytes12] = ACTIONS(298),
    [anon_sym_bytes13] = ACTIONS(298),
    [anon_sym_bytes14] = ACTIONS(298),
    [anon_sym_bytes15] = ACTIONS(298),
    [anon_sym_bytes16] = ACTIONS(298),
    [anon_sym_bytes17] = ACTIONS(298),
    [anon_sym_bytes18] = ACTIONS(298),
    [anon_sym_bytes19] = ACTIONS(298),
    [anon_sym_bytes20] = ACTIONS(298),
    [anon_sym_bytes21] = ACTIONS(298),
    [anon_sym_bytes22] = ACTIONS(298),
    [anon_sym_bytes23] = ACTIONS(298),
    [anon_sym_bytes24] = ACTIONS(298),
    [anon_sym_bytes25] = ACTIONS(298),
    [anon_sym_bytes26] = ACTIONS(298),
    [anon_sym_bytes27] = ACTIONS(298),
    [anon_sym_bytes28] = ACTIONS(298),
    [anon_sym_bytes29] = ACTIONS(298),
    [anon_sym_bytes30] = ACTIONS(298),
    [anon_sym_bytes31] = ACTIONS(298),
    [anon_sym_bytes32] = ACTIONS(298),
    [anon_sym_fixed] = ACTIONS(298),
    [aux_sym__fixed_token1] = ACTIONS(298),
    [anon_sym_ufixed] = ACTIONS(298),
    [aux_sym__ufixed_token1] = ACTIONS(298),
    [aux_sym__decimal_number_token1] = ACTIONS(298),
    [aux_sym__decimal_number_token2] = ACTIONS(300),
    [aux_sym__hex_number_token1] = ACTIONS(300),
    [anon_sym_hex] = ACTIONS(298),
    [anon_sym_DQUOTE] = ACTIONS(300),
    [anon_sym_SQUOTE] = ACTIONS(300),
    [anon_sym_unicode] = ACTIONS(298),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_catch_clause] = STATE(69),
    [aux_sym_try_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(305),
    [anon_sym_DASH] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_type] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_assembly] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(305),
    [anon_sym_continue] = ACTIONS(305),
    [anon_sym_true] = ACTIONS(305),
    [anon_sym_false] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(305),
    [anon_sym_function] = ACTIONS(305),
    [anon_sym_byte] = ACTIONS(305),
    [anon_sym_address] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_revert] = ACTIONS(305),
    [sym_unchecked] = ACTIONS(305),
    [anon_sym_var] = ACTIONS(305),
    [anon_sym_else] = ACTIONS(305),
    [anon_sym_while] = ACTIONS(305),
    [anon_sym_do] = ACTIONS(305),
    [anon_sym_try] = ACTIONS(305),
    [anon_sym_catch] = ACTIONS(296),
    [anon_sym_emit] = ACTIONS(305),
    [anon_sym_payable] = ACTIONS(305),
    [anon_sym_new] = ACTIONS(305),
    [anon_sym_LBRACK] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(305),
    [anon_sym_BANG] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(305),
    [anon_sym_PLUS_PLUS] = ACTIONS(307),
    [anon_sym_DASH_DASH] = ACTIONS(307),
    [anon_sym_mapping] = ACTIONS(305),
    [anon_sym_bool] = ACTIONS(305),
    [anon_sym_string] = ACTIONS(305),
    [anon_sym_int] = ACTIONS(305),
    [anon_sym_int8] = ACTIONS(305),
    [anon_sym_int16] = ACTIONS(305),
    [anon_sym_int24] = ACTIONS(305),
    [anon_sym_int32] = ACTIONS(305),
    [anon_sym_int40] = ACTIONS(305),
    [anon_sym_int48] = ACTIONS(305),
    [anon_sym_int56] = ACTIONS(305),
    [anon_sym_int64] = ACTIONS(305),
    [anon_sym_int72] = ACTIONS(305),
    [anon_sym_int80] = ACTIONS(305),
    [anon_sym_int88] = ACTIONS(305),
    [anon_sym_int96] = ACTIONS(305),
    [anon_sym_int104] = ACTIONS(305),
    [anon_sym_int112] = ACTIONS(305),
    [anon_sym_int120] = ACTIONS(305),
    [anon_sym_int128] = ACTIONS(305),
    [anon_sym_int136] = ACTIONS(305),
    [anon_sym_int144] = ACTIONS(305),
    [anon_sym_int152] = ACTIONS(305),
    [anon_sym_int160] = ACTIONS(305),
    [anon_sym_int168] = ACTIONS(305),
    [anon_sym_int176] = ACTIONS(305),
    [anon_sym_int184] = ACTIONS(305),
    [anon_sym_int192] = ACTIONS(305),
    [anon_sym_int200] = ACTIONS(305),
    [anon_sym_int208] = ACTIONS(305),
    [anon_sym_int216] = ACTIONS(305),
    [anon_sym_int224] = ACTIONS(305),
    [anon_sym_int232] = ACTIONS(305),
    [anon_sym_int240] = ACTIONS(305),
    [anon_sym_int248] = ACTIONS(305),
    [anon_sym_int256] = ACTIONS(305),
    [anon_sym_uint] = ACTIONS(305),
    [anon_sym_uint8] = ACTIONS(305),
    [anon_sym_uint16] = ACTIONS(305),
    [anon_sym_uint24] = ACTIONS(305),
    [anon_sym_uint32] = ACTIONS(305),
    [anon_sym_uint40] = ACTIONS(305),
    [anon_sym_uint48] = ACTIONS(305),
    [anon_sym_uint56] = ACTIONS(305),
    [anon_sym_uint64] = ACTIONS(305),
    [anon_sym_uint72] = ACTIONS(305),
    [anon_sym_uint80] = ACTIONS(305),
    [anon_sym_uint88] = ACTIONS(305),
    [anon_sym_uint96] = ACTIONS(305),
    [anon_sym_uint104] = ACTIONS(305),
    [anon_sym_uint112] = ACTIONS(305),
    [anon_sym_uint120] = ACTIONS(305),
    [anon_sym_uint128] = ACTIONS(305),
    [anon_sym_uint136] = ACTIONS(305),
    [anon_sym_uint144] = ACTIONS(305),
    [anon_sym_uint152] = ACTIONS(305),
    [anon_sym_uint160] = ACTIONS(305),
    [anon_sym_uint168] = ACTIONS(305),
    [anon_sym_uint176] = ACTIONS(305),
    [anon_sym_uint184] = ACTIONS(305),
    [anon_sym_uint192] = ACTIONS(305),
    [anon_sym_uint200] = ACTIONS(305),
    [anon_sym_uint208] = ACTIONS(305),
    [anon_sym_uint216] = ACTIONS(305),
    [anon_sym_uint224] = ACTIONS(305),
    [anon_sym_uint232] = ACTIONS(305),
    [anon_sym_uint240] = ACTIONS(305),
    [anon_sym_uint248] = ACTIONS(305),
    [anon_sym_uint256] = ACTIONS(305),
    [anon_sym_bytes] = ACTIONS(305),
    [anon_sym_bytes1] = ACTIONS(305),
    [anon_sym_bytes2] = ACTIONS(305),
    [anon_sym_bytes3] = ACTIONS(305),
    [anon_sym_bytes4] = ACTIONS(305),
    [anon_sym_bytes5] = ACTIONS(305),
    [anon_sym_bytes6] = ACTIONS(305),
    [anon_sym_bytes7] = ACTIONS(305),
    [anon_sym_bytes8] = ACTIONS(305),
    [anon_sym_bytes9] = ACTIONS(305),
    [anon_sym_bytes10] = ACTIONS(305),
    [anon_sym_bytes11] = ACTIONS(305),
    [anon_sym_bytes12] = ACTIONS(305),
    [anon_sym_bytes13] = ACTIONS(305),
    [anon_sym_bytes14] = ACTIONS(305),
    [anon_sym_bytes15] = ACTIONS(305),
    [anon_sym_bytes16] = ACTIONS(305),
    [anon_sym_bytes17] = ACTIONS(305),
    [anon_sym_bytes18] = ACTIONS(305),
    [anon_sym_bytes19] = ACTIONS(305),
    [anon_sym_bytes20] = ACTIONS(305),
    [anon_sym_bytes21] = ACTIONS(305),
    [anon_sym_bytes22] = ACTIONS(305),
    [anon_sym_bytes23] = ACTIONS(305),
    [anon_sym_bytes24] = ACTIONS(305),
    [anon_sym_bytes25] = ACTIONS(305),
    [anon_sym_bytes26] = ACTIONS(305),
    [anon_sym_bytes27] = ACTIONS(305),
    [anon_sym_bytes28] = ACTIONS(305),
    [anon_sym_bytes29] = ACTIONS(305),
    [anon_sym_bytes30] = ACTIONS(305),
    [anon_sym_bytes31] = ACTIONS(305),
    [anon_sym_bytes32] = ACTIONS(305),
    [anon_sym_fixed] = ACTIONS(305),
    [aux_sym__fixed_token1] = ACTIONS(305),
    [anon_sym_ufixed] = ACTIONS(305),
    [aux_sym__ufixed_token1] = ACTIONS(305),
    [aux_sym__decimal_number_token1] = ACTIONS(305),
    [aux_sym__decimal_number_token2] = ACTIONS(307),
    [aux_sym__hex_number_token1] = ACTIONS(307),
    [anon_sym_hex] = ACTIONS(305),
    [anon_sym_DQUOTE] = ACTIONS(307),
    [anon_sym_SQUOTE] = ACTIONS(307),
    [anon_sym_unicode] = ACTIONS(305),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_identifier] = ACTIONS(309),
    [anon_sym_DASH] = ACTIONS(309),
    [anon_sym_TILDE] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(311),
    [anon_sym_RBRACE] = ACTIONS(311),
    [anon_sym_type] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(309),
    [anon_sym_assembly] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_true] = ACTIONS(309),
    [anon_sym_false] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(309),
    [anon_sym_function] = ACTIONS(309),
    [anon_sym_byte] = ACTIONS(309),
    [anon_sym_address] = ACTIONS(309),
    [anon_sym_return] = ACTIONS(309),
    [anon_sym_revert] = ACTIONS(309),
    [sym_unchecked] = ACTIONS(309),
    [anon_sym_var] = ACTIONS(309),
    [anon_sym_else] = ACTIONS(309),
    [anon_sym_while] = ACTIONS(309),
    [anon_sym_do] = ACTIONS(309),
    [anon_sym_try] = ACTIONS(309),
    [anon_sym_emit] = ACTIONS(309),
    [anon_sym_payable] = ACTIONS(309),
    [anon_sym_new] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_PLUS] = ACTIONS(309),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_delete] = ACTIONS(309),
    [anon_sym_PLUS_PLUS] = ACTIONS(311),
    [anon_sym_DASH_DASH] = ACTIONS(311),
    [anon_sym_mapping] = ACTIONS(309),
    [anon_sym_bool] = ACTIONS(309),
    [anon_sym_string] = ACTIONS(309),
    [anon_sym_int] = ACTIONS(309),
    [anon_sym_int8] = ACTIONS(309),
    [anon_sym_int16] = ACTIONS(309),
    [anon_sym_int24] = ACTIONS(309),
    [anon_sym_int32] = ACTIONS(309),
    [anon_sym_int40] = ACTIONS(309),
    [anon_sym_int48] = ACTIONS(309),
    [anon_sym_int56] = ACTIONS(309),
    [anon_sym_int64] = ACTIONS(309),
    [anon_sym_int72] = ACTIONS(309),
    [anon_sym_int80] = ACTIONS(309),
    [anon_sym_int88] = ACTIONS(309),
    [anon_sym_int96] = ACTIONS(309),
    [anon_sym_int104] = ACTIONS(309),
    [anon_sym_int112] = ACTIONS(309),
    [anon_sym_int120] = ACTIONS(309),
    [anon_sym_int128] = ACTIONS(309),
    [anon_sym_int136] = ACTIONS(309),
    [anon_sym_int144] = ACTIONS(309),
    [anon_sym_int152] = ACTIONS(309),
    [anon_sym_int160] = ACTIONS(309),
    [anon_sym_int168] = ACTIONS(309),
    [anon_sym_int176] = ACTIONS(309),
    [anon_sym_int184] = ACTIONS(309),
    [anon_sym_int192] = ACTIONS(309),
    [anon_sym_int200] = ACTIONS(309),
    [anon_sym_int208] = ACTIONS(309),
    [anon_sym_int216] = ACTIONS(309),
    [anon_sym_int224] = ACTIONS(309),
    [anon_sym_int232] = ACTIONS(309),
    [anon_sym_int240] = ACTIONS(309),
    [anon_sym_int248] = ACTIONS(309),
    [anon_sym_int256] = ACTIONS(309),
    [anon_sym_uint] = ACTIONS(309),
    [anon_sym_uint8] = ACTIONS(309),
    [anon_sym_uint16] = ACTIONS(309),
    [anon_sym_uint24] = ACTIONS(309),
    [anon_sym_uint32] = ACTIONS(309),
    [anon_sym_uint40] = ACTIONS(309),
    [anon_sym_uint48] = ACTIONS(309),
    [anon_sym_uint56] = ACTIONS(309),
    [anon_sym_uint64] = ACTIONS(309),
    [anon_sym_uint72] = ACTIONS(309),
    [anon_sym_uint80] = ACTIONS(309),
    [anon_sym_uint88] = ACTIONS(309),
    [anon_sym_uint96] = ACTIONS(309),
    [anon_sym_uint104] = ACTIONS(309),
    [anon_sym_uint112] = ACTIONS(309),
    [anon_sym_uint120] = ACTIONS(309),
    [anon_sym_uint128] = ACTIONS(309),
    [anon_sym_uint136] = ACTIONS(309),
    [anon_sym_uint144] = ACTIONS(309),
    [anon_sym_uint152] = ACTIONS(309),
    [anon_sym_uint160] = ACTIONS(309),
    [anon_sym_uint168] = ACTIONS(309),
    [anon_sym_uint176] = ACTIONS(309),
    [anon_sym_uint184] = ACTIONS(309),
    [anon_sym_uint192] = ACTIONS(309),
    [anon_sym_uint200] = ACTIONS(309),
    [anon_sym_uint208] = ACTIONS(309),
    [anon_sym_uint216] = ACTIONS(309),
    [anon_sym_uint224] = ACTIONS(309),
    [anon_sym_uint232] = ACTIONS(309),
    [anon_sym_uint240] = ACTIONS(309),
    [anon_sym_uint248] = ACTIONS(309),
    [anon_sym_uint256] = ACTIONS(309),
    [anon_sym_bytes] = ACTIONS(309),
    [anon_sym_bytes1] = ACTIONS(309),
    [anon_sym_bytes2] = ACTIONS(309),
    [anon_sym_bytes3] = ACTIONS(309),
    [anon_sym_bytes4] = ACTIONS(309),
    [anon_sym_bytes5] = ACTIONS(309),
    [anon_sym_bytes6] = ACTIONS(309),
    [anon_sym_bytes7] = ACTIONS(309),
    [anon_sym_bytes8] = ACTIONS(309),
    [anon_sym_bytes9] = ACTIONS(309),
    [anon_sym_bytes10] = ACTIONS(309),
    [anon_sym_bytes11] = ACTIONS(309),
    [anon_sym_bytes12] = ACTIONS(309),
    [anon_sym_bytes13] = ACTIONS(309),
    [anon_sym_bytes14] = ACTIONS(309),
    [anon_sym_bytes15] = ACTIONS(309),
    [anon_sym_bytes16] = ACTIONS(309),
    [anon_sym_bytes17] = ACTIONS(309),
    [anon_sym_bytes18] = ACTIONS(309),
    [anon_sym_bytes19] = ACTIONS(309),
    [anon_sym_bytes20] = ACTIONS(309),
    [anon_sym_bytes21] = ACTIONS(309),
    [anon_sym_bytes22] = ACTIONS(309),
    [anon_sym_bytes23] = ACTIONS(309),
    [anon_sym_bytes24] = ACTIONS(309),
    [anon_sym_bytes25] = ACTIONS(309),
    [anon_sym_bytes26] = ACTIONS(309),
    [anon_sym_bytes27] = ACTIONS(309),
    [anon_sym_bytes28] = ACTIONS(309),
    [anon_sym_bytes29] = ACTIONS(309),
    [anon_sym_bytes30] = ACTIONS(309),
    [anon_sym_bytes31] = ACTIONS(309),
    [anon_sym_bytes32] = ACTIONS(309),
    [anon_sym_fixed] = ACTIONS(309),
    [aux_sym__fixed_token1] = ACTIONS(309),
    [anon_sym_ufixed] = ACTIONS(309),
    [aux_sym__ufixed_token1] = ACTIONS(309),
    [sym__semicolon] = ACTIONS(311),
    [aux_sym__decimal_number_token1] = ACTIONS(309),
    [aux_sym__decimal_number_token2] = ACTIONS(311),
    [aux_sym__hex_number_token1] = ACTIONS(311),
    [anon_sym_hex] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [anon_sym_unicode] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__source_unit] = STATE(72),
    [sym__directive] = STATE(72),
    [sym_pragma_directive] = STATE(72),
    [sym_import_directive] = STATE(72),
    [sym__declaration] = STATE(72),
    [sym_user_defined_type_definition] = STATE(72),
    [sym_constant_variable_declaration] = STATE(72),
    [sym_contract_declaration] = STATE(72),
    [sym_error_declaration] = STATE(72),
    [sym_interface_declaration] = STATE(72),
    [sym_library_declaration] = STATE(72),
    [sym_struct_declaration] = STATE(72),
    [sym_enum_declaration] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_type_name] = STATE(701),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_source_file_repeat1] = STATE(72),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym_identifier] = ACTIONS(315),
    [anon_sym_pragma] = ACTIONS(318),
    [anon_sym_import] = ACTIONS(321),
    [anon_sym_type] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(327),
    [anon_sym_contract] = ACTIONS(330),
    [anon_sym_error] = ACTIONS(333),
    [anon_sym_interface] = ACTIONS(336),
    [anon_sym_library] = ACTIONS(339),
    [anon_sym_struct] = ACTIONS(342),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(348),
    [anon_sym_byte] = ACTIONS(351),
    [anon_sym_address] = ACTIONS(354),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_mapping] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(351),
    [anon_sym_string] = ACTIONS(351),
    [anon_sym_int] = ACTIONS(351),
    [anon_sym_int8] = ACTIONS(351),
    [anon_sym_int16] = ACTIONS(351),
    [anon_sym_int24] = ACTIONS(351),
    [anon_sym_int32] = ACTIONS(351),
    [anon_sym_int40] = ACTIONS(351),
    [anon_sym_int48] = ACTIONS(351),
    [anon_sym_int56] = ACTIONS(351),
    [anon_sym_int64] = ACTIONS(351),
    [anon_sym_int72] = ACTIONS(351),
    [anon_sym_int80] = ACTIONS(351),
    [anon_sym_int88] = ACTIONS(351),
    [anon_sym_int96] = ACTIONS(351),
    [anon_sym_int104] = ACTIONS(351),
    [anon_sym_int112] = ACTIONS(351),
    [anon_sym_int120] = ACTIONS(351),
    [anon_sym_int128] = ACTIONS(351),
    [anon_sym_int136] = ACTIONS(351),
    [anon_sym_int144] = ACTIONS(351),
    [anon_sym_int152] = ACTIONS(351),
    [anon_sym_int160] = ACTIONS(351),
    [anon_sym_int168] = ACTIONS(351),
    [anon_sym_int176] = ACTIONS(351),
    [anon_sym_int184] = ACTIONS(351),
    [anon_sym_int192] = ACTIONS(351),
    [anon_sym_int200] = ACTIONS(351),
    [anon_sym_int208] = ACTIONS(351),
    [anon_sym_int216] = ACTIONS(351),
    [anon_sym_int224] = ACTIONS(351),
    [anon_sym_int232] = ACTIONS(351),
    [anon_sym_int240] = ACTIONS(351),
    [anon_sym_int248] = ACTIONS(351),
    [anon_sym_int256] = ACTIONS(351),
    [anon_sym_uint] = ACTIONS(351),
    [anon_sym_uint8] = ACTIONS(351),
    [anon_sym_uint16] = ACTIONS(351),
    [anon_sym_uint24] = ACTIONS(351),
    [anon_sym_uint32] = ACTIONS(351),
    [anon_sym_uint40] = ACTIONS(351),
    [anon_sym_uint48] = ACTIONS(351),
    [anon_sym_uint56] = ACTIONS(351),
    [anon_sym_uint64] = ACTIONS(351),
    [anon_sym_uint72] = ACTIONS(351),
    [anon_sym_uint80] = ACTIONS(351),
    [anon_sym_uint88] = ACTIONS(351),
    [anon_sym_uint96] = ACTIONS(351),
    [anon_sym_uint104] = ACTIONS(351),
    [anon_sym_uint112] = ACTIONS(351),
    [anon_sym_uint120] = ACTIONS(351),
    [anon_sym_uint128] = ACTIONS(351),
    [anon_sym_uint136] = ACTIONS(351),
    [anon_sym_uint144] = ACTIONS(351),
    [anon_sym_uint152] = ACTIONS(351),
    [anon_sym_uint160] = ACTIONS(351),
    [anon_sym_uint168] = ACTIONS(351),
    [anon_sym_uint176] = ACTIONS(351),
    [anon_sym_uint184] = ACTIONS(351),
    [anon_sym_uint192] = ACTIONS(351),
    [anon_sym_uint200] = ACTIONS(351),
    [anon_sym_uint208] = ACTIONS(351),
    [anon_sym_uint216] = ACTIONS(351),
    [anon_sym_uint224] = ACTIONS(351),
    [anon_sym_uint232] = ACTIONS(351),
    [anon_sym_uint240] = ACTIONS(351),
    [anon_sym_uint248] = ACTIONS(351),
    [anon_sym_uint256] = ACTIONS(351),
    [anon_sym_bytes] = ACTIONS(351),
    [anon_sym_bytes1] = ACTIONS(351),
    [anon_sym_bytes2] = ACTIONS(351),
    [anon_sym_bytes3] = ACTIONS(351),
    [anon_sym_bytes4] = ACTIONS(351),
    [anon_sym_bytes5] = ACTIONS(351),
    [anon_sym_bytes6] = ACTIONS(351),
    [anon_sym_bytes7] = ACTIONS(351),
    [anon_sym_bytes8] = ACTIONS(351),
    [anon_sym_bytes9] = ACTIONS(351),
    [anon_sym_bytes10] = ACTIONS(351),
    [anon_sym_bytes11] = ACTIONS(351),
    [anon_sym_bytes12] = ACTIONS(351),
    [anon_sym_bytes13] = ACTIONS(351),
    [anon_sym_bytes14] = ACTIONS(351),
    [anon_sym_bytes15] = ACTIONS(351),
    [anon_sym_bytes16] = ACTIONS(351),
    [anon_sym_bytes17] = ACTIONS(351),
    [anon_sym_bytes18] = ACTIONS(351),
    [anon_sym_bytes19] = ACTIONS(351),
    [anon_sym_bytes20] = ACTIONS(351),
    [anon_sym_bytes21] = ACTIONS(351),
    [anon_sym_bytes22] = ACTIONS(351),
    [anon_sym_bytes23] = ACTIONS(351),
    [anon_sym_bytes24] = ACTIONS(351),
    [anon_sym_bytes25] = ACTIONS(351),
    [anon_sym_bytes26] = ACTIONS(351),
    [anon_sym_bytes27] = ACTIONS(351),
    [anon_sym_bytes28] = ACTIONS(351),
    [anon_sym_bytes29] = ACTIONS(351),
    [anon_sym_bytes30] = ACTIONS(351),
    [anon_sym_bytes31] = ACTIONS(351),
    [anon_sym_bytes32] = ACTIONS(351),
    [anon_sym_fixed] = ACTIONS(351),
    [aux_sym__fixed_token1] = ACTIONS(351),
    [anon_sym_ufixed] = ACTIONS(351),
    [aux_sym__ufixed_token1] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__source_unit] = STATE(72),
    [sym__directive] = STATE(72),
    [sym_pragma_directive] = STATE(72),
    [sym_import_directive] = STATE(72),
    [sym__declaration] = STATE(72),
    [sym_user_defined_type_definition] = STATE(72),
    [sym_constant_variable_declaration] = STATE(72),
    [sym_contract_declaration] = STATE(72),
    [sym_error_declaration] = STATE(72),
    [sym_interface_declaration] = STATE(72),
    [sym_library_declaration] = STATE(72),
    [sym_struct_declaration] = STATE(72),
    [sym_enum_declaration] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_type_name] = STATE(701),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_source_file_repeat1] = STATE(72),
    [ts_builtin_sym_end] = ACTIONS(360),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pragma] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_contract] = ACTIONS(17),
    [anon_sym_error] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_library] = ACTIONS(23),
    [anon_sym_struct] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_function] = ACTIONS(29),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_identifier] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(362),
    [anon_sym_TILDE] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(364),
    [anon_sym_RBRACE] = ACTIONS(364),
    [anon_sym_type] = ACTIONS(362),
    [anon_sym_LPAREN] = ACTIONS(364),
    [anon_sym_for] = ACTIONS(362),
    [anon_sym_assembly] = ACTIONS(362),
    [anon_sym_break] = ACTIONS(362),
    [anon_sym_continue] = ACTIONS(362),
    [anon_sym_true] = ACTIONS(362),
    [anon_sym_false] = ACTIONS(362),
    [anon_sym_if] = ACTIONS(362),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_byte] = ACTIONS(362),
    [anon_sym_address] = ACTIONS(362),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_revert] = ACTIONS(362),
    [sym_unchecked] = ACTIONS(362),
    [anon_sym_var] = ACTIONS(362),
    [anon_sym_else] = ACTIONS(362),
    [anon_sym_while] = ACTIONS(362),
    [anon_sym_do] = ACTIONS(362),
    [anon_sym_try] = ACTIONS(362),
    [anon_sym_catch] = ACTIONS(362),
    [anon_sym_emit] = ACTIONS(362),
    [anon_sym_payable] = ACTIONS(362),
    [anon_sym_new] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(362),
    [anon_sym_BANG] = ACTIONS(364),
    [anon_sym_delete] = ACTIONS(362),
    [anon_sym_PLUS_PLUS] = ACTIONS(364),
    [anon_sym_DASH_DASH] = ACTIONS(364),
    [anon_sym_mapping] = ACTIONS(362),
    [anon_sym_bool] = ACTIONS(362),
    [anon_sym_string] = ACTIONS(362),
    [anon_sym_int] = ACTIONS(362),
    [anon_sym_int8] = ACTIONS(362),
    [anon_sym_int16] = ACTIONS(362),
    [anon_sym_int24] = ACTIONS(362),
    [anon_sym_int32] = ACTIONS(362),
    [anon_sym_int40] = ACTIONS(362),
    [anon_sym_int48] = ACTIONS(362),
    [anon_sym_int56] = ACTIONS(362),
    [anon_sym_int64] = ACTIONS(362),
    [anon_sym_int72] = ACTIONS(362),
    [anon_sym_int80] = ACTIONS(362),
    [anon_sym_int88] = ACTIONS(362),
    [anon_sym_int96] = ACTIONS(362),
    [anon_sym_int104] = ACTIONS(362),
    [anon_sym_int112] = ACTIONS(362),
    [anon_sym_int120] = ACTIONS(362),
    [anon_sym_int128] = ACTIONS(362),
    [anon_sym_int136] = ACTIONS(362),
    [anon_sym_int144] = ACTIONS(362),
    [anon_sym_int152] = ACTIONS(362),
    [anon_sym_int160] = ACTIONS(362),
    [anon_sym_int168] = ACTIONS(362),
    [anon_sym_int176] = ACTIONS(362),
    [anon_sym_int184] = ACTIONS(362),
    [anon_sym_int192] = ACTIONS(362),
    [anon_sym_int200] = ACTIONS(362),
    [anon_sym_int208] = ACTIONS(362),
    [anon_sym_int216] = ACTIONS(362),
    [anon_sym_int224] = ACTIONS(362),
    [anon_sym_int232] = ACTIONS(362),
    [anon_sym_int240] = ACTIONS(362),
    [anon_sym_int248] = ACTIONS(362),
    [anon_sym_int256] = ACTIONS(362),
    [anon_sym_uint] = ACTIONS(362),
    [anon_sym_uint8] = ACTIONS(362),
    [anon_sym_uint16] = ACTIONS(362),
    [anon_sym_uint24] = ACTIONS(362),
    [anon_sym_uint32] = ACTIONS(362),
    [anon_sym_uint40] = ACTIONS(362),
    [anon_sym_uint48] = ACTIONS(362),
    [anon_sym_uint56] = ACTIONS(362),
    [anon_sym_uint64] = ACTIONS(362),
    [anon_sym_uint72] = ACTIONS(362),
    [anon_sym_uint80] = ACTIONS(362),
    [anon_sym_uint88] = ACTIONS(362),
    [anon_sym_uint96] = ACTIONS(362),
    [anon_sym_uint104] = ACTIONS(362),
    [anon_sym_uint112] = ACTIONS(362),
    [anon_sym_uint120] = ACTIONS(362),
    [anon_sym_uint128] = ACTIONS(362),
    [anon_sym_uint136] = ACTIONS(362),
    [anon_sym_uint144] = ACTIONS(362),
    [anon_sym_uint152] = ACTIONS(362),
    [anon_sym_uint160] = ACTIONS(362),
    [anon_sym_uint168] = ACTIONS(362),
    [anon_sym_uint176] = ACTIONS(362),
    [anon_sym_uint184] = ACTIONS(362),
    [anon_sym_uint192] = ACTIONS(362),
    [anon_sym_uint200] = ACTIONS(362),
    [anon_sym_uint208] = ACTIONS(362),
    [anon_sym_uint216] = ACTIONS(362),
    [anon_sym_uint224] = ACTIONS(362),
    [anon_sym_uint232] = ACTIONS(362),
    [anon_sym_uint240] = ACTIONS(362),
    [anon_sym_uint248] = ACTIONS(362),
    [anon_sym_uint256] = ACTIONS(362),
    [anon_sym_bytes] = ACTIONS(362),
    [anon_sym_bytes1] = ACTIONS(362),
    [anon_sym_bytes2] = ACTIONS(362),
    [anon_sym_bytes3] = ACTIONS(362),
    [anon_sym_bytes4] = ACTIONS(362),
    [anon_sym_bytes5] = ACTIONS(362),
    [anon_sym_bytes6] = ACTIONS(362),
    [anon_sym_bytes7] = ACTIONS(362),
    [anon_sym_bytes8] = ACTIONS(362),
    [anon_sym_bytes9] = ACTIONS(362),
    [anon_sym_bytes10] = ACTIONS(362),
    [anon_sym_bytes11] = ACTIONS(362),
    [anon_sym_bytes12] = ACTIONS(362),
    [anon_sym_bytes13] = ACTIONS(362),
    [anon_sym_bytes14] = ACTIONS(362),
    [anon_sym_bytes15] = ACTIONS(362),
    [anon_sym_bytes16] = ACTIONS(362),
    [anon_sym_bytes17] = ACTIONS(362),
    [anon_sym_bytes18] = ACTIONS(362),
    [anon_sym_bytes19] = ACTIONS(362),
    [anon_sym_bytes20] = ACTIONS(362),
    [anon_sym_bytes21] = ACTIONS(362),
    [anon_sym_bytes22] = ACTIONS(362),
    [anon_sym_bytes23] = ACTIONS(362),
    [anon_sym_bytes24] = ACTIONS(362),
    [anon_sym_bytes25] = ACTIONS(362),
    [anon_sym_bytes26] = ACTIONS(362),
    [anon_sym_bytes27] = ACTIONS(362),
    [anon_sym_bytes28] = ACTIONS(362),
    [anon_sym_bytes29] = ACTIONS(362),
    [anon_sym_bytes30] = ACTIONS(362),
    [anon_sym_bytes31] = ACTIONS(362),
    [anon_sym_bytes32] = ACTIONS(362),
    [anon_sym_fixed] = ACTIONS(362),
    [aux_sym__fixed_token1] = ACTIONS(362),
    [anon_sym_ufixed] = ACTIONS(362),
    [aux_sym__ufixed_token1] = ACTIONS(362),
    [aux_sym__decimal_number_token1] = ACTIONS(362),
    [aux_sym__decimal_number_token2] = ACTIONS(364),
    [aux_sym__hex_number_token1] = ACTIONS(364),
    [anon_sym_hex] = ACTIONS(362),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [anon_sym_SQUOTE] = ACTIONS(364),
    [anon_sym_unicode] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_identifier] = ACTIONS(366),
    [anon_sym_DASH] = ACTIONS(366),
    [anon_sym_TILDE] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(368),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_type] = ACTIONS(366),
    [anon_sym_LPAREN] = ACTIONS(368),
    [anon_sym_for] = ACTIONS(366),
    [anon_sym_assembly] = ACTIONS(366),
    [anon_sym_break] = ACTIONS(366),
    [anon_sym_continue] = ACTIONS(366),
    [anon_sym_true] = ACTIONS(366),
    [anon_sym_false] = ACTIONS(366),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_function] = ACTIONS(366),
    [anon_sym_byte] = ACTIONS(366),
    [anon_sym_address] = ACTIONS(366),
    [anon_sym_return] = ACTIONS(366),
    [anon_sym_revert] = ACTIONS(366),
    [sym_unchecked] = ACTIONS(366),
    [anon_sym_var] = ACTIONS(366),
    [anon_sym_else] = ACTIONS(366),
    [anon_sym_while] = ACTIONS(366),
    [anon_sym_do] = ACTIONS(366),
    [anon_sym_try] = ACTIONS(366),
    [anon_sym_catch] = ACTIONS(366),
    [anon_sym_emit] = ACTIONS(366),
    [anon_sym_payable] = ACTIONS(366),
    [anon_sym_new] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(366),
    [anon_sym_BANG] = ACTIONS(368),
    [anon_sym_delete] = ACTIONS(366),
    [anon_sym_PLUS_PLUS] = ACTIONS(368),
    [anon_sym_DASH_DASH] = ACTIONS(368),
    [anon_sym_mapping] = ACTIONS(366),
    [anon_sym_bool] = ACTIONS(366),
    [anon_sym_string] = ACTIONS(366),
    [anon_sym_int] = ACTIONS(366),
    [anon_sym_int8] = ACTIONS(366),
    [anon_sym_int16] = ACTIONS(366),
    [anon_sym_int24] = ACTIONS(366),
    [anon_sym_int32] = ACTIONS(366),
    [anon_sym_int40] = ACTIONS(366),
    [anon_sym_int48] = ACTIONS(366),
    [anon_sym_int56] = ACTIONS(366),
    [anon_sym_int64] = ACTIONS(366),
    [anon_sym_int72] = ACTIONS(366),
    [anon_sym_int80] = ACTIONS(366),
    [anon_sym_int88] = ACTIONS(366),
    [anon_sym_int96] = ACTIONS(366),
    [anon_sym_int104] = ACTIONS(366),
    [anon_sym_int112] = ACTIONS(366),
    [anon_sym_int120] = ACTIONS(366),
    [anon_sym_int128] = ACTIONS(366),
    [anon_sym_int136] = ACTIONS(366),
    [anon_sym_int144] = ACTIONS(366),
    [anon_sym_int152] = ACTIONS(366),
    [anon_sym_int160] = ACTIONS(366),
    [anon_sym_int168] = ACTIONS(366),
    [anon_sym_int176] = ACTIONS(366),
    [anon_sym_int184] = ACTIONS(366),
    [anon_sym_int192] = ACTIONS(366),
    [anon_sym_int200] = ACTIONS(366),
    [anon_sym_int208] = ACTIONS(366),
    [anon_sym_int216] = ACTIONS(366),
    [anon_sym_int224] = ACTIONS(366),
    [anon_sym_int232] = ACTIONS(366),
    [anon_sym_int240] = ACTIONS(366),
    [anon_sym_int248] = ACTIONS(366),
    [anon_sym_int256] = ACTIONS(366),
    [anon_sym_uint] = ACTIONS(366),
    [anon_sym_uint8] = ACTIONS(366),
    [anon_sym_uint16] = ACTIONS(366),
    [anon_sym_uint24] = ACTIONS(366),
    [anon_sym_uint32] = ACTIONS(366),
    [anon_sym_uint40] = ACTIONS(366),
    [anon_sym_uint48] = ACTIONS(366),
    [anon_sym_uint56] = ACTIONS(366),
    [anon_sym_uint64] = ACTIONS(366),
    [anon_sym_uint72] = ACTIONS(366),
    [anon_sym_uint80] = ACTIONS(366),
    [anon_sym_uint88] = ACTIONS(366),
    [anon_sym_uint96] = ACTIONS(366),
    [anon_sym_uint104] = ACTIONS(366),
    [anon_sym_uint112] = ACTIONS(366),
    [anon_sym_uint120] = ACTIONS(366),
    [anon_sym_uint128] = ACTIONS(366),
    [anon_sym_uint136] = ACTIONS(366),
    [anon_sym_uint144] = ACTIONS(366),
    [anon_sym_uint152] = ACTIONS(366),
    [anon_sym_uint160] = ACTIONS(366),
    [anon_sym_uint168] = ACTIONS(366),
    [anon_sym_uint176] = ACTIONS(366),
    [anon_sym_uint184] = ACTIONS(366),
    [anon_sym_uint192] = ACTIONS(366),
    [anon_sym_uint200] = ACTIONS(366),
    [anon_sym_uint208] = ACTIONS(366),
    [anon_sym_uint216] = ACTIONS(366),
    [anon_sym_uint224] = ACTIONS(366),
    [anon_sym_uint232] = ACTIONS(366),
    [anon_sym_uint240] = ACTIONS(366),
    [anon_sym_uint248] = ACTIONS(366),
    [anon_sym_uint256] = ACTIONS(366),
    [anon_sym_bytes] = ACTIONS(366),
    [anon_sym_bytes1] = ACTIONS(366),
    [anon_sym_bytes2] = ACTIONS(366),
    [anon_sym_bytes3] = ACTIONS(366),
    [anon_sym_bytes4] = ACTIONS(366),
    [anon_sym_bytes5] = ACTIONS(366),
    [anon_sym_bytes6] = ACTIONS(366),
    [anon_sym_bytes7] = ACTIONS(366),
    [anon_sym_bytes8] = ACTIONS(366),
    [anon_sym_bytes9] = ACTIONS(366),
    [anon_sym_bytes10] = ACTIONS(366),
    [anon_sym_bytes11] = ACTIONS(366),
    [anon_sym_bytes12] = ACTIONS(366),
    [anon_sym_bytes13] = ACTIONS(366),
    [anon_sym_bytes14] = ACTIONS(366),
    [anon_sym_bytes15] = ACTIONS(366),
    [anon_sym_bytes16] = ACTIONS(366),
    [anon_sym_bytes17] = ACTIONS(366),
    [anon_sym_bytes18] = ACTIONS(366),
    [anon_sym_bytes19] = ACTIONS(366),
    [anon_sym_bytes20] = ACTIONS(366),
    [anon_sym_bytes21] = ACTIONS(366),
    [anon_sym_bytes22] = ACTIONS(366),
    [anon_sym_bytes23] = ACTIONS(366),
    [anon_sym_bytes24] = ACTIONS(366),
    [anon_sym_bytes25] = ACTIONS(366),
    [anon_sym_bytes26] = ACTIONS(366),
    [anon_sym_bytes27] = ACTIONS(366),
    [anon_sym_bytes28] = ACTIONS(366),
    [anon_sym_bytes29] = ACTIONS(366),
    [anon_sym_bytes30] = ACTIONS(366),
    [anon_sym_bytes31] = ACTIONS(366),
    [anon_sym_bytes32] = ACTIONS(366),
    [anon_sym_fixed] = ACTIONS(366),
    [aux_sym__fixed_token1] = ACTIONS(366),
    [anon_sym_ufixed] = ACTIONS(366),
    [aux_sym__ufixed_token1] = ACTIONS(366),
    [aux_sym__decimal_number_token1] = ACTIONS(366),
    [aux_sym__decimal_number_token2] = ACTIONS(368),
    [aux_sym__hex_number_token1] = ACTIONS(368),
    [anon_sym_hex] = ACTIONS(366),
    [anon_sym_DQUOTE] = ACTIONS(368),
    [anon_sym_SQUOTE] = ACTIONS(368),
    [anon_sym_unicode] = ACTIONS(366),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_identifier] = ACTIONS(370),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_TILDE] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_type] = ACTIONS(370),
    [anon_sym_LPAREN] = ACTIONS(372),
    [anon_sym_for] = ACTIONS(370),
    [anon_sym_assembly] = ACTIONS(370),
    [anon_sym_break] = ACTIONS(370),
    [anon_sym_continue] = ACTIONS(370),
    [anon_sym_true] = ACTIONS(370),
    [anon_sym_false] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(370),
    [anon_sym_function] = ACTIONS(370),
    [anon_sym_byte] = ACTIONS(370),
    [anon_sym_address] = ACTIONS(370),
    [anon_sym_return] = ACTIONS(370),
    [anon_sym_revert] = ACTIONS(370),
    [sym_unchecked] = ACTIONS(370),
    [anon_sym_var] = ACTIONS(370),
    [anon_sym_else] = ACTIONS(370),
    [anon_sym_while] = ACTIONS(370),
    [anon_sym_do] = ACTIONS(370),
    [anon_sym_try] = ACTIONS(370),
    [anon_sym_catch] = ACTIONS(370),
    [anon_sym_emit] = ACTIONS(370),
    [anon_sym_payable] = ACTIONS(370),
    [anon_sym_new] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(372),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(372),
    [anon_sym_delete] = ACTIONS(370),
    [anon_sym_PLUS_PLUS] = ACTIONS(372),
    [anon_sym_DASH_DASH] = ACTIONS(372),
    [anon_sym_mapping] = ACTIONS(370),
    [anon_sym_bool] = ACTIONS(370),
    [anon_sym_string] = ACTIONS(370),
    [anon_sym_int] = ACTIONS(370),
    [anon_sym_int8] = ACTIONS(370),
    [anon_sym_int16] = ACTIONS(370),
    [anon_sym_int24] = ACTIONS(370),
    [anon_sym_int32] = ACTIONS(370),
    [anon_sym_int40] = ACTIONS(370),
    [anon_sym_int48] = ACTIONS(370),
    [anon_sym_int56] = ACTIONS(370),
    [anon_sym_int64] = ACTIONS(370),
    [anon_sym_int72] = ACTIONS(370),
    [anon_sym_int80] = ACTIONS(370),
    [anon_sym_int88] = ACTIONS(370),
    [anon_sym_int96] = ACTIONS(370),
    [anon_sym_int104] = ACTIONS(370),
    [anon_sym_int112] = ACTIONS(370),
    [anon_sym_int120] = ACTIONS(370),
    [anon_sym_int128] = ACTIONS(370),
    [anon_sym_int136] = ACTIONS(370),
    [anon_sym_int144] = ACTIONS(370),
    [anon_sym_int152] = ACTIONS(370),
    [anon_sym_int160] = ACTIONS(370),
    [anon_sym_int168] = ACTIONS(370),
    [anon_sym_int176] = ACTIONS(370),
    [anon_sym_int184] = ACTIONS(370),
    [anon_sym_int192] = ACTIONS(370),
    [anon_sym_int200] = ACTIONS(370),
    [anon_sym_int208] = ACTIONS(370),
    [anon_sym_int216] = ACTIONS(370),
    [anon_sym_int224] = ACTIONS(370),
    [anon_sym_int232] = ACTIONS(370),
    [anon_sym_int240] = ACTIONS(370),
    [anon_sym_int248] = ACTIONS(370),
    [anon_sym_int256] = ACTIONS(370),
    [anon_sym_uint] = ACTIONS(370),
    [anon_sym_uint8] = ACTIONS(370),
    [anon_sym_uint16] = ACTIONS(370),
    [anon_sym_uint24] = ACTIONS(370),
    [anon_sym_uint32] = ACTIONS(370),
    [anon_sym_uint40] = ACTIONS(370),
    [anon_sym_uint48] = ACTIONS(370),
    [anon_sym_uint56] = ACTIONS(370),
    [anon_sym_uint64] = ACTIONS(370),
    [anon_sym_uint72] = ACTIONS(370),
    [anon_sym_uint80] = ACTIONS(370),
    [anon_sym_uint88] = ACTIONS(370),
    [anon_sym_uint96] = ACTIONS(370),
    [anon_sym_uint104] = ACTIONS(370),
    [anon_sym_uint112] = ACTIONS(370),
    [anon_sym_uint120] = ACTIONS(370),
    [anon_sym_uint128] = ACTIONS(370),
    [anon_sym_uint136] = ACTIONS(370),
    [anon_sym_uint144] = ACTIONS(370),
    [anon_sym_uint152] = ACTIONS(370),
    [anon_sym_uint160] = ACTIONS(370),
    [anon_sym_uint168] = ACTIONS(370),
    [anon_sym_uint176] = ACTIONS(370),
    [anon_sym_uint184] = ACTIONS(370),
    [anon_sym_uint192] = ACTIONS(370),
    [anon_sym_uint200] = ACTIONS(370),
    [anon_sym_uint208] = ACTIONS(370),
    [anon_sym_uint216] = ACTIONS(370),
    [anon_sym_uint224] = ACTIONS(370),
    [anon_sym_uint232] = ACTIONS(370),
    [anon_sym_uint240] = ACTIONS(370),
    [anon_sym_uint248] = ACTIONS(370),
    [anon_sym_uint256] = ACTIONS(370),
    [anon_sym_bytes] = ACTIONS(370),
    [anon_sym_bytes1] = ACTIONS(370),
    [anon_sym_bytes2] = ACTIONS(370),
    [anon_sym_bytes3] = ACTIONS(370),
    [anon_sym_bytes4] = ACTIONS(370),
    [anon_sym_bytes5] = ACTIONS(370),
    [anon_sym_bytes6] = ACTIONS(370),
    [anon_sym_bytes7] = ACTIONS(370),
    [anon_sym_bytes8] = ACTIONS(370),
    [anon_sym_bytes9] = ACTIONS(370),
    [anon_sym_bytes10] = ACTIONS(370),
    [anon_sym_bytes11] = ACTIONS(370),
    [anon_sym_bytes12] = ACTIONS(370),
    [anon_sym_bytes13] = ACTIONS(370),
    [anon_sym_bytes14] = ACTIONS(370),
    [anon_sym_bytes15] = ACTIONS(370),
    [anon_sym_bytes16] = ACTIONS(370),
    [anon_sym_bytes17] = ACTIONS(370),
    [anon_sym_bytes18] = ACTIONS(370),
    [anon_sym_bytes19] = ACTIONS(370),
    [anon_sym_bytes20] = ACTIONS(370),
    [anon_sym_bytes21] = ACTIONS(370),
    [anon_sym_bytes22] = ACTIONS(370),
    [anon_sym_bytes23] = ACTIONS(370),
    [anon_sym_bytes24] = ACTIONS(370),
    [anon_sym_bytes25] = ACTIONS(370),
    [anon_sym_bytes26] = ACTIONS(370),
    [anon_sym_bytes27] = ACTIONS(370),
    [anon_sym_bytes28] = ACTIONS(370),
    [anon_sym_bytes29] = ACTIONS(370),
    [anon_sym_bytes30] = ACTIONS(370),
    [anon_sym_bytes31] = ACTIONS(370),
    [anon_sym_bytes32] = ACTIONS(370),
    [anon_sym_fixed] = ACTIONS(370),
    [aux_sym__fixed_token1] = ACTIONS(370),
    [anon_sym_ufixed] = ACTIONS(370),
    [aux_sym__ufixed_token1] = ACTIONS(370),
    [aux_sym__decimal_number_token1] = ACTIONS(370),
    [aux_sym__decimal_number_token2] = ACTIONS(372),
    [aux_sym__hex_number_token1] = ACTIONS(372),
    [anon_sym_hex] = ACTIONS(370),
    [anon_sym_DQUOTE] = ACTIONS(372),
    [anon_sym_SQUOTE] = ACTIONS(372),
    [anon_sym_unicode] = ACTIONS(370),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_identifier] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(374),
    [anon_sym_TILDE] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_type] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_for] = ACTIONS(374),
    [anon_sym_assembly] = ACTIONS(374),
    [anon_sym_break] = ACTIONS(374),
    [anon_sym_continue] = ACTIONS(374),
    [anon_sym_true] = ACTIONS(374),
    [anon_sym_false] = ACTIONS(374),
    [anon_sym_if] = ACTIONS(374),
    [anon_sym_function] = ACTIONS(374),
    [anon_sym_byte] = ACTIONS(374),
    [anon_sym_address] = ACTIONS(374),
    [anon_sym_return] = ACTIONS(374),
    [anon_sym_revert] = ACTIONS(374),
    [sym_unchecked] = ACTIONS(374),
    [anon_sym_var] = ACTIONS(374),
    [anon_sym_else] = ACTIONS(374),
    [anon_sym_while] = ACTIONS(374),
    [anon_sym_do] = ACTIONS(374),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_catch] = ACTIONS(374),
    [anon_sym_emit] = ACTIONS(374),
    [anon_sym_payable] = ACTIONS(374),
    [anon_sym_new] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(376),
    [anon_sym_PLUS] = ACTIONS(374),
    [anon_sym_BANG] = ACTIONS(376),
    [anon_sym_delete] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_mapping] = ACTIONS(374),
    [anon_sym_bool] = ACTIONS(374),
    [anon_sym_string] = ACTIONS(374),
    [anon_sym_int] = ACTIONS(374),
    [anon_sym_int8] = ACTIONS(374),
    [anon_sym_int16] = ACTIONS(374),
    [anon_sym_int24] = ACTIONS(374),
    [anon_sym_int32] = ACTIONS(374),
    [anon_sym_int40] = ACTIONS(374),
    [anon_sym_int48] = ACTIONS(374),
    [anon_sym_int56] = ACTIONS(374),
    [anon_sym_int64] = ACTIONS(374),
    [anon_sym_int72] = ACTIONS(374),
    [anon_sym_int80] = ACTIONS(374),
    [anon_sym_int88] = ACTIONS(374),
    [anon_sym_int96] = ACTIONS(374),
    [anon_sym_int104] = ACTIONS(374),
    [anon_sym_int112] = ACTIONS(374),
    [anon_sym_int120] = ACTIONS(374),
    [anon_sym_int128] = ACTIONS(374),
    [anon_sym_int136] = ACTIONS(374),
    [anon_sym_int144] = ACTIONS(374),
    [anon_sym_int152] = ACTIONS(374),
    [anon_sym_int160] = ACTIONS(374),
    [anon_sym_int168] = ACTIONS(374),
    [anon_sym_int176] = ACTIONS(374),
    [anon_sym_int184] = ACTIONS(374),
    [anon_sym_int192] = ACTIONS(374),
    [anon_sym_int200] = ACTIONS(374),
    [anon_sym_int208] = ACTIONS(374),
    [anon_sym_int216] = ACTIONS(374),
    [anon_sym_int224] = ACTIONS(374),
    [anon_sym_int232] = ACTIONS(374),
    [anon_sym_int240] = ACTIONS(374),
    [anon_sym_int248] = ACTIONS(374),
    [anon_sym_int256] = ACTIONS(374),
    [anon_sym_uint] = ACTIONS(374),
    [anon_sym_uint8] = ACTIONS(374),
    [anon_sym_uint16] = ACTIONS(374),
    [anon_sym_uint24] = ACTIONS(374),
    [anon_sym_uint32] = ACTIONS(374),
    [anon_sym_uint40] = ACTIONS(374),
    [anon_sym_uint48] = ACTIONS(374),
    [anon_sym_uint56] = ACTIONS(374),
    [anon_sym_uint64] = ACTIONS(374),
    [anon_sym_uint72] = ACTIONS(374),
    [anon_sym_uint80] = ACTIONS(374),
    [anon_sym_uint88] = ACTIONS(374),
    [anon_sym_uint96] = ACTIONS(374),
    [anon_sym_uint104] = ACTIONS(374),
    [anon_sym_uint112] = ACTIONS(374),
    [anon_sym_uint120] = ACTIONS(374),
    [anon_sym_uint128] = ACTIONS(374),
    [anon_sym_uint136] = ACTIONS(374),
    [anon_sym_uint144] = ACTIONS(374),
    [anon_sym_uint152] = ACTIONS(374),
    [anon_sym_uint160] = ACTIONS(374),
    [anon_sym_uint168] = ACTIONS(374),
    [anon_sym_uint176] = ACTIONS(374),
    [anon_sym_uint184] = ACTIONS(374),
    [anon_sym_uint192] = ACTIONS(374),
    [anon_sym_uint200] = ACTIONS(374),
    [anon_sym_uint208] = ACTIONS(374),
    [anon_sym_uint216] = ACTIONS(374),
    [anon_sym_uint224] = ACTIONS(374),
    [anon_sym_uint232] = ACTIONS(374),
    [anon_sym_uint240] = ACTIONS(374),
    [anon_sym_uint248] = ACTIONS(374),
    [anon_sym_uint256] = ACTIONS(374),
    [anon_sym_bytes] = ACTIONS(374),
    [anon_sym_bytes1] = ACTIONS(374),
    [anon_sym_bytes2] = ACTIONS(374),
    [anon_sym_bytes3] = ACTIONS(374),
    [anon_sym_bytes4] = ACTIONS(374),
    [anon_sym_bytes5] = ACTIONS(374),
    [anon_sym_bytes6] = ACTIONS(374),
    [anon_sym_bytes7] = ACTIONS(374),
    [anon_sym_bytes8] = ACTIONS(374),
    [anon_sym_bytes9] = ACTIONS(374),
    [anon_sym_bytes10] = ACTIONS(374),
    [anon_sym_bytes11] = ACTIONS(374),
    [anon_sym_bytes12] = ACTIONS(374),
    [anon_sym_bytes13] = ACTIONS(374),
    [anon_sym_bytes14] = ACTIONS(374),
    [anon_sym_bytes15] = ACTIONS(374),
    [anon_sym_bytes16] = ACTIONS(374),
    [anon_sym_bytes17] = ACTIONS(374),
    [anon_sym_bytes18] = ACTIONS(374),
    [anon_sym_bytes19] = ACTIONS(374),
    [anon_sym_bytes20] = ACTIONS(374),
    [anon_sym_bytes21] = ACTIONS(374),
    [anon_sym_bytes22] = ACTIONS(374),
    [anon_sym_bytes23] = ACTIONS(374),
    [anon_sym_bytes24] = ACTIONS(374),
    [anon_sym_bytes25] = ACTIONS(374),
    [anon_sym_bytes26] = ACTIONS(374),
    [anon_sym_bytes27] = ACTIONS(374),
    [anon_sym_bytes28] = ACTIONS(374),
    [anon_sym_bytes29] = ACTIONS(374),
    [anon_sym_bytes30] = ACTIONS(374),
    [anon_sym_bytes31] = ACTIONS(374),
    [anon_sym_bytes32] = ACTIONS(374),
    [anon_sym_fixed] = ACTIONS(374),
    [aux_sym__fixed_token1] = ACTIONS(374),
    [anon_sym_ufixed] = ACTIONS(374),
    [aux_sym__ufixed_token1] = ACTIONS(374),
    [aux_sym__decimal_number_token1] = ACTIONS(374),
    [aux_sym__decimal_number_token2] = ACTIONS(376),
    [aux_sym__hex_number_token1] = ACTIONS(376),
    [anon_sym_hex] = ACTIONS(374),
    [anon_sym_DQUOTE] = ACTIONS(376),
    [anon_sym_SQUOTE] = ACTIONS(376),
    [anon_sym_unicode] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_identifier] = ACTIONS(378),
    [anon_sym_DASH] = ACTIONS(378),
    [anon_sym_TILDE] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_type] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(378),
    [anon_sym_assembly] = ACTIONS(378),
    [anon_sym_break] = ACTIONS(378),
    [anon_sym_continue] = ACTIONS(378),
    [anon_sym_true] = ACTIONS(378),
    [anon_sym_false] = ACTIONS(378),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_function] = ACTIONS(378),
    [anon_sym_byte] = ACTIONS(378),
    [anon_sym_address] = ACTIONS(378),
    [anon_sym_return] = ACTIONS(378),
    [anon_sym_revert] = ACTIONS(378),
    [sym_unchecked] = ACTIONS(378),
    [anon_sym_var] = ACTIONS(378),
    [anon_sym_else] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(378),
    [anon_sym_do] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(378),
    [anon_sym_emit] = ACTIONS(378),
    [anon_sym_payable] = ACTIONS(378),
    [anon_sym_new] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_PLUS] = ACTIONS(378),
    [anon_sym_BANG] = ACTIONS(380),
    [anon_sym_delete] = ACTIONS(378),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_mapping] = ACTIONS(378),
    [anon_sym_bool] = ACTIONS(378),
    [anon_sym_string] = ACTIONS(378),
    [anon_sym_int] = ACTIONS(378),
    [anon_sym_int8] = ACTIONS(378),
    [anon_sym_int16] = ACTIONS(378),
    [anon_sym_int24] = ACTIONS(378),
    [anon_sym_int32] = ACTIONS(378),
    [anon_sym_int40] = ACTIONS(378),
    [anon_sym_int48] = ACTIONS(378),
    [anon_sym_int56] = ACTIONS(378),
    [anon_sym_int64] = ACTIONS(378),
    [anon_sym_int72] = ACTIONS(378),
    [anon_sym_int80] = ACTIONS(378),
    [anon_sym_int88] = ACTIONS(378),
    [anon_sym_int96] = ACTIONS(378),
    [anon_sym_int104] = ACTIONS(378),
    [anon_sym_int112] = ACTIONS(378),
    [anon_sym_int120] = ACTIONS(378),
    [anon_sym_int128] = ACTIONS(378),
    [anon_sym_int136] = ACTIONS(378),
    [anon_sym_int144] = ACTIONS(378),
    [anon_sym_int152] = ACTIONS(378),
    [anon_sym_int160] = ACTIONS(378),
    [anon_sym_int168] = ACTIONS(378),
    [anon_sym_int176] = ACTIONS(378),
    [anon_sym_int184] = ACTIONS(378),
    [anon_sym_int192] = ACTIONS(378),
    [anon_sym_int200] = ACTIONS(378),
    [anon_sym_int208] = ACTIONS(378),
    [anon_sym_int216] = ACTIONS(378),
    [anon_sym_int224] = ACTIONS(378),
    [anon_sym_int232] = ACTIONS(378),
    [anon_sym_int240] = ACTIONS(378),
    [anon_sym_int248] = ACTIONS(378),
    [anon_sym_int256] = ACTIONS(378),
    [anon_sym_uint] = ACTIONS(378),
    [anon_sym_uint8] = ACTIONS(378),
    [anon_sym_uint16] = ACTIONS(378),
    [anon_sym_uint24] = ACTIONS(378),
    [anon_sym_uint32] = ACTIONS(378),
    [anon_sym_uint40] = ACTIONS(378),
    [anon_sym_uint48] = ACTIONS(378),
    [anon_sym_uint56] = ACTIONS(378),
    [anon_sym_uint64] = ACTIONS(378),
    [anon_sym_uint72] = ACTIONS(378),
    [anon_sym_uint80] = ACTIONS(378),
    [anon_sym_uint88] = ACTIONS(378),
    [anon_sym_uint96] = ACTIONS(378),
    [anon_sym_uint104] = ACTIONS(378),
    [anon_sym_uint112] = ACTIONS(378),
    [anon_sym_uint120] = ACTIONS(378),
    [anon_sym_uint128] = ACTIONS(378),
    [anon_sym_uint136] = ACTIONS(378),
    [anon_sym_uint144] = ACTIONS(378),
    [anon_sym_uint152] = ACTIONS(378),
    [anon_sym_uint160] = ACTIONS(378),
    [anon_sym_uint168] = ACTIONS(378),
    [anon_sym_uint176] = ACTIONS(378),
    [anon_sym_uint184] = ACTIONS(378),
    [anon_sym_uint192] = ACTIONS(378),
    [anon_sym_uint200] = ACTIONS(378),
    [anon_sym_uint208] = ACTIONS(378),
    [anon_sym_uint216] = ACTIONS(378),
    [anon_sym_uint224] = ACTIONS(378),
    [anon_sym_uint232] = ACTIONS(378),
    [anon_sym_uint240] = ACTIONS(378),
    [anon_sym_uint248] = ACTIONS(378),
    [anon_sym_uint256] = ACTIONS(378),
    [anon_sym_bytes] = ACTIONS(378),
    [anon_sym_bytes1] = ACTIONS(378),
    [anon_sym_bytes2] = ACTIONS(378),
    [anon_sym_bytes3] = ACTIONS(378),
    [anon_sym_bytes4] = ACTIONS(378),
    [anon_sym_bytes5] = ACTIONS(378),
    [anon_sym_bytes6] = ACTIONS(378),
    [anon_sym_bytes7] = ACTIONS(378),
    [anon_sym_bytes8] = ACTIONS(378),
    [anon_sym_bytes9] = ACTIONS(378),
    [anon_sym_bytes10] = ACTIONS(378),
    [anon_sym_bytes11] = ACTIONS(378),
    [anon_sym_bytes12] = ACTIONS(378),
    [anon_sym_bytes13] = ACTIONS(378),
    [anon_sym_bytes14] = ACTIONS(378),
    [anon_sym_bytes15] = ACTIONS(378),
    [anon_sym_bytes16] = ACTIONS(378),
    [anon_sym_bytes17] = ACTIONS(378),
    [anon_sym_bytes18] = ACTIONS(378),
    [anon_sym_bytes19] = ACTIONS(378),
    [anon_sym_bytes20] = ACTIONS(378),
    [anon_sym_bytes21] = ACTIONS(378),
    [anon_sym_bytes22] = ACTIONS(378),
    [anon_sym_bytes23] = ACTIONS(378),
    [anon_sym_bytes24] = ACTIONS(378),
    [anon_sym_bytes25] = ACTIONS(378),
    [anon_sym_bytes26] = ACTIONS(378),
    [anon_sym_bytes27] = ACTIONS(378),
    [anon_sym_bytes28] = ACTIONS(378),
    [anon_sym_bytes29] = ACTIONS(378),
    [anon_sym_bytes30] = ACTIONS(378),
    [anon_sym_bytes31] = ACTIONS(378),
    [anon_sym_bytes32] = ACTIONS(378),
    [anon_sym_fixed] = ACTIONS(378),
    [aux_sym__fixed_token1] = ACTIONS(378),
    [anon_sym_ufixed] = ACTIONS(378),
    [aux_sym__ufixed_token1] = ACTIONS(378),
    [sym__semicolon] = ACTIONS(380),
    [aux_sym__decimal_number_token1] = ACTIONS(378),
    [aux_sym__decimal_number_token2] = ACTIONS(380),
    [aux_sym__hex_number_token1] = ACTIONS(380),
    [anon_sym_hex] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [anon_sym_SQUOTE] = ACTIONS(380),
    [anon_sym_unicode] = ACTIONS(378),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_identifier] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_type] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_assembly] = ACTIONS(382),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(382),
    [anon_sym_true] = ACTIONS(382),
    [anon_sym_false] = ACTIONS(382),
    [anon_sym_if] = ACTIONS(382),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_byte] = ACTIONS(382),
    [anon_sym_address] = ACTIONS(382),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_revert] = ACTIONS(382),
    [sym_unchecked] = ACTIONS(382),
    [anon_sym_var] = ACTIONS(382),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_catch] = ACTIONS(382),
    [anon_sym_emit] = ACTIONS(382),
    [anon_sym_payable] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(384),
    [anon_sym_delete] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_mapping] = ACTIONS(382),
    [anon_sym_bool] = ACTIONS(382),
    [anon_sym_string] = ACTIONS(382),
    [anon_sym_int] = ACTIONS(382),
    [anon_sym_int8] = ACTIONS(382),
    [anon_sym_int16] = ACTIONS(382),
    [anon_sym_int24] = ACTIONS(382),
    [anon_sym_int32] = ACTIONS(382),
    [anon_sym_int40] = ACTIONS(382),
    [anon_sym_int48] = ACTIONS(382),
    [anon_sym_int56] = ACTIONS(382),
    [anon_sym_int64] = ACTIONS(382),
    [anon_sym_int72] = ACTIONS(382),
    [anon_sym_int80] = ACTIONS(382),
    [anon_sym_int88] = ACTIONS(382),
    [anon_sym_int96] = ACTIONS(382),
    [anon_sym_int104] = ACTIONS(382),
    [anon_sym_int112] = ACTIONS(382),
    [anon_sym_int120] = ACTIONS(382),
    [anon_sym_int128] = ACTIONS(382),
    [anon_sym_int136] = ACTIONS(382),
    [anon_sym_int144] = ACTIONS(382),
    [anon_sym_int152] = ACTIONS(382),
    [anon_sym_int160] = ACTIONS(382),
    [anon_sym_int168] = ACTIONS(382),
    [anon_sym_int176] = ACTIONS(382),
    [anon_sym_int184] = ACTIONS(382),
    [anon_sym_int192] = ACTIONS(382),
    [anon_sym_int200] = ACTIONS(382),
    [anon_sym_int208] = ACTIONS(382),
    [anon_sym_int216] = ACTIONS(382),
    [anon_sym_int224] = ACTIONS(382),
    [anon_sym_int232] = ACTIONS(382),
    [anon_sym_int240] = ACTIONS(382),
    [anon_sym_int248] = ACTIONS(382),
    [anon_sym_int256] = ACTIONS(382),
    [anon_sym_uint] = ACTIONS(382),
    [anon_sym_uint8] = ACTIONS(382),
    [anon_sym_uint16] = ACTIONS(382),
    [anon_sym_uint24] = ACTIONS(382),
    [anon_sym_uint32] = ACTIONS(382),
    [anon_sym_uint40] = ACTIONS(382),
    [anon_sym_uint48] = ACTIONS(382),
    [anon_sym_uint56] = ACTIONS(382),
    [anon_sym_uint64] = ACTIONS(382),
    [anon_sym_uint72] = ACTIONS(382),
    [anon_sym_uint80] = ACTIONS(382),
    [anon_sym_uint88] = ACTIONS(382),
    [anon_sym_uint96] = ACTIONS(382),
    [anon_sym_uint104] = ACTIONS(382),
    [anon_sym_uint112] = ACTIONS(382),
    [anon_sym_uint120] = ACTIONS(382),
    [anon_sym_uint128] = ACTIONS(382),
    [anon_sym_uint136] = ACTIONS(382),
    [anon_sym_uint144] = ACTIONS(382),
    [anon_sym_uint152] = ACTIONS(382),
    [anon_sym_uint160] = ACTIONS(382),
    [anon_sym_uint168] = ACTIONS(382),
    [anon_sym_uint176] = ACTIONS(382),
    [anon_sym_uint184] = ACTIONS(382),
    [anon_sym_uint192] = ACTIONS(382),
    [anon_sym_uint200] = ACTIONS(382),
    [anon_sym_uint208] = ACTIONS(382),
    [anon_sym_uint216] = ACTIONS(382),
    [anon_sym_uint224] = ACTIONS(382),
    [anon_sym_uint232] = ACTIONS(382),
    [anon_sym_uint240] = ACTIONS(382),
    [anon_sym_uint248] = ACTIONS(382),
    [anon_sym_uint256] = ACTIONS(382),
    [anon_sym_bytes] = ACTIONS(382),
    [anon_sym_bytes1] = ACTIONS(382),
    [anon_sym_bytes2] = ACTIONS(382),
    [anon_sym_bytes3] = ACTIONS(382),
    [anon_sym_bytes4] = ACTIONS(382),
    [anon_sym_bytes5] = ACTIONS(382),
    [anon_sym_bytes6] = ACTIONS(382),
    [anon_sym_bytes7] = ACTIONS(382),
    [anon_sym_bytes8] = ACTIONS(382),
    [anon_sym_bytes9] = ACTIONS(382),
    [anon_sym_bytes10] = ACTIONS(382),
    [anon_sym_bytes11] = ACTIONS(382),
    [anon_sym_bytes12] = ACTIONS(382),
    [anon_sym_bytes13] = ACTIONS(382),
    [anon_sym_bytes14] = ACTIONS(382),
    [anon_sym_bytes15] = ACTIONS(382),
    [anon_sym_bytes16] = ACTIONS(382),
    [anon_sym_bytes17] = ACTIONS(382),
    [anon_sym_bytes18] = ACTIONS(382),
    [anon_sym_bytes19] = ACTIONS(382),
    [anon_sym_bytes20] = ACTIONS(382),
    [anon_sym_bytes21] = ACTIONS(382),
    [anon_sym_bytes22] = ACTIONS(382),
    [anon_sym_bytes23] = ACTIONS(382),
    [anon_sym_bytes24] = ACTIONS(382),
    [anon_sym_bytes25] = ACTIONS(382),
    [anon_sym_bytes26] = ACTIONS(382),
    [anon_sym_bytes27] = ACTIONS(382),
    [anon_sym_bytes28] = ACTIONS(382),
    [anon_sym_bytes29] = ACTIONS(382),
    [anon_sym_bytes30] = ACTIONS(382),
    [anon_sym_bytes31] = ACTIONS(382),
    [anon_sym_bytes32] = ACTIONS(382),
    [anon_sym_fixed] = ACTIONS(382),
    [aux_sym__fixed_token1] = ACTIONS(382),
    [anon_sym_ufixed] = ACTIONS(382),
    [aux_sym__ufixed_token1] = ACTIONS(382),
    [aux_sym__decimal_number_token1] = ACTIONS(382),
    [aux_sym__decimal_number_token2] = ACTIONS(384),
    [aux_sym__hex_number_token1] = ACTIONS(384),
    [anon_sym_hex] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(384),
    [anon_sym_SQUOTE] = ACTIONS(384),
    [anon_sym_unicode] = ACTIONS(382),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_identifier] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_type] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_assembly] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(386),
    [anon_sym_continue] = ACTIONS(386),
    [anon_sym_true] = ACTIONS(386),
    [anon_sym_false] = ACTIONS(386),
    [anon_sym_if] = ACTIONS(386),
    [anon_sym_function] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(386),
    [anon_sym_address] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_revert] = ACTIONS(386),
    [sym_unchecked] = ACTIONS(386),
    [anon_sym_var] = ACTIONS(386),
    [anon_sym_else] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(386),
    [anon_sym_do] = ACTIONS(386),
    [anon_sym_try] = ACTIONS(386),
    [anon_sym_catch] = ACTIONS(386),
    [anon_sym_emit] = ACTIONS(386),
    [anon_sym_payable] = ACTIONS(386),
    [anon_sym_new] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(388),
    [anon_sym_delete] = ACTIONS(386),
    [anon_sym_PLUS_PLUS] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(388),
    [anon_sym_mapping] = ACTIONS(386),
    [anon_sym_bool] = ACTIONS(386),
    [anon_sym_string] = ACTIONS(386),
    [anon_sym_int] = ACTIONS(386),
    [anon_sym_int8] = ACTIONS(386),
    [anon_sym_int16] = ACTIONS(386),
    [anon_sym_int24] = ACTIONS(386),
    [anon_sym_int32] = ACTIONS(386),
    [anon_sym_int40] = ACTIONS(386),
    [anon_sym_int48] = ACTIONS(386),
    [anon_sym_int56] = ACTIONS(386),
    [anon_sym_int64] = ACTIONS(386),
    [anon_sym_int72] = ACTIONS(386),
    [anon_sym_int80] = ACTIONS(386),
    [anon_sym_int88] = ACTIONS(386),
    [anon_sym_int96] = ACTIONS(386),
    [anon_sym_int104] = ACTIONS(386),
    [anon_sym_int112] = ACTIONS(386),
    [anon_sym_int120] = ACTIONS(386),
    [anon_sym_int128] = ACTIONS(386),
    [anon_sym_int136] = ACTIONS(386),
    [anon_sym_int144] = ACTIONS(386),
    [anon_sym_int152] = ACTIONS(386),
    [anon_sym_int160] = ACTIONS(386),
    [anon_sym_int168] = ACTIONS(386),
    [anon_sym_int176] = ACTIONS(386),
    [anon_sym_int184] = ACTIONS(386),
    [anon_sym_int192] = ACTIONS(386),
    [anon_sym_int200] = ACTIONS(386),
    [anon_sym_int208] = ACTIONS(386),
    [anon_sym_int216] = ACTIONS(386),
    [anon_sym_int224] = ACTIONS(386),
    [anon_sym_int232] = ACTIONS(386),
    [anon_sym_int240] = ACTIONS(386),
    [anon_sym_int248] = ACTIONS(386),
    [anon_sym_int256] = ACTIONS(386),
    [anon_sym_uint] = ACTIONS(386),
    [anon_sym_uint8] = ACTIONS(386),
    [anon_sym_uint16] = ACTIONS(386),
    [anon_sym_uint24] = ACTIONS(386),
    [anon_sym_uint32] = ACTIONS(386),
    [anon_sym_uint40] = ACTIONS(386),
    [anon_sym_uint48] = ACTIONS(386),
    [anon_sym_uint56] = ACTIONS(386),
    [anon_sym_uint64] = ACTIONS(386),
    [anon_sym_uint72] = ACTIONS(386),
    [anon_sym_uint80] = ACTIONS(386),
    [anon_sym_uint88] = ACTIONS(386),
    [anon_sym_uint96] = ACTIONS(386),
    [anon_sym_uint104] = ACTIONS(386),
    [anon_sym_uint112] = ACTIONS(386),
    [anon_sym_uint120] = ACTIONS(386),
    [anon_sym_uint128] = ACTIONS(386),
    [anon_sym_uint136] = ACTIONS(386),
    [anon_sym_uint144] = ACTIONS(386),
    [anon_sym_uint152] = ACTIONS(386),
    [anon_sym_uint160] = ACTIONS(386),
    [anon_sym_uint168] = ACTIONS(386),
    [anon_sym_uint176] = ACTIONS(386),
    [anon_sym_uint184] = ACTIONS(386),
    [anon_sym_uint192] = ACTIONS(386),
    [anon_sym_uint200] = ACTIONS(386),
    [anon_sym_uint208] = ACTIONS(386),
    [anon_sym_uint216] = ACTIONS(386),
    [anon_sym_uint224] = ACTIONS(386),
    [anon_sym_uint232] = ACTIONS(386),
    [anon_sym_uint240] = ACTIONS(386),
    [anon_sym_uint248] = ACTIONS(386),
    [anon_sym_uint256] = ACTIONS(386),
    [anon_sym_bytes] = ACTIONS(386),
    [anon_sym_bytes1] = ACTIONS(386),
    [anon_sym_bytes2] = ACTIONS(386),
    [anon_sym_bytes3] = ACTIONS(386),
    [anon_sym_bytes4] = ACTIONS(386),
    [anon_sym_bytes5] = ACTIONS(386),
    [anon_sym_bytes6] = ACTIONS(386),
    [anon_sym_bytes7] = ACTIONS(386),
    [anon_sym_bytes8] = ACTIONS(386),
    [anon_sym_bytes9] = ACTIONS(386),
    [anon_sym_bytes10] = ACTIONS(386),
    [anon_sym_bytes11] = ACTIONS(386),
    [anon_sym_bytes12] = ACTIONS(386),
    [anon_sym_bytes13] = ACTIONS(386),
    [anon_sym_bytes14] = ACTIONS(386),
    [anon_sym_bytes15] = ACTIONS(386),
    [anon_sym_bytes16] = ACTIONS(386),
    [anon_sym_bytes17] = ACTIONS(386),
    [anon_sym_bytes18] = ACTIONS(386),
    [anon_sym_bytes19] = ACTIONS(386),
    [anon_sym_bytes20] = ACTIONS(386),
    [anon_sym_bytes21] = ACTIONS(386),
    [anon_sym_bytes22] = ACTIONS(386),
    [anon_sym_bytes23] = ACTIONS(386),
    [anon_sym_bytes24] = ACTIONS(386),
    [anon_sym_bytes25] = ACTIONS(386),
    [anon_sym_bytes26] = ACTIONS(386),
    [anon_sym_bytes27] = ACTIONS(386),
    [anon_sym_bytes28] = ACTIONS(386),
    [anon_sym_bytes29] = ACTIONS(386),
    [anon_sym_bytes30] = ACTIONS(386),
    [anon_sym_bytes31] = ACTIONS(386),
    [anon_sym_bytes32] = ACTIONS(386),
    [anon_sym_fixed] = ACTIONS(386),
    [aux_sym__fixed_token1] = ACTIONS(386),
    [anon_sym_ufixed] = ACTIONS(386),
    [aux_sym__ufixed_token1] = ACTIONS(386),
    [aux_sym__decimal_number_token1] = ACTIONS(386),
    [aux_sym__decimal_number_token2] = ACTIONS(388),
    [aux_sym__hex_number_token1] = ACTIONS(388),
    [anon_sym_hex] = ACTIONS(386),
    [anon_sym_DQUOTE] = ACTIONS(388),
    [anon_sym_SQUOTE] = ACTIONS(388),
    [anon_sym_unicode] = ACTIONS(386),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_identifier] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(392),
    [anon_sym_LBRACE] = ACTIONS(392),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_type] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_assembly] = ACTIONS(390),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_function] = ACTIONS(390),
    [anon_sym_byte] = ACTIONS(390),
    [anon_sym_address] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_revert] = ACTIONS(390),
    [sym_unchecked] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_emit] = ACTIONS(390),
    [anon_sym_payable] = ACTIONS(390),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(392),
    [anon_sym_delete] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_mapping] = ACTIONS(390),
    [anon_sym_bool] = ACTIONS(390),
    [anon_sym_string] = ACTIONS(390),
    [anon_sym_int] = ACTIONS(390),
    [anon_sym_int8] = ACTIONS(390),
    [anon_sym_int16] = ACTIONS(390),
    [anon_sym_int24] = ACTIONS(390),
    [anon_sym_int32] = ACTIONS(390),
    [anon_sym_int40] = ACTIONS(390),
    [anon_sym_int48] = ACTIONS(390),
    [anon_sym_int56] = ACTIONS(390),
    [anon_sym_int64] = ACTIONS(390),
    [anon_sym_int72] = ACTIONS(390),
    [anon_sym_int80] = ACTIONS(390),
    [anon_sym_int88] = ACTIONS(390),
    [anon_sym_int96] = ACTIONS(390),
    [anon_sym_int104] = ACTIONS(390),
    [anon_sym_int112] = ACTIONS(390),
    [anon_sym_int120] = ACTIONS(390),
    [anon_sym_int128] = ACTIONS(390),
    [anon_sym_int136] = ACTIONS(390),
    [anon_sym_int144] = ACTIONS(390),
    [anon_sym_int152] = ACTIONS(390),
    [anon_sym_int160] = ACTIONS(390),
    [anon_sym_int168] = ACTIONS(390),
    [anon_sym_int176] = ACTIONS(390),
    [anon_sym_int184] = ACTIONS(390),
    [anon_sym_int192] = ACTIONS(390),
    [anon_sym_int200] = ACTIONS(390),
    [anon_sym_int208] = ACTIONS(390),
    [anon_sym_int216] = ACTIONS(390),
    [anon_sym_int224] = ACTIONS(390),
    [anon_sym_int232] = ACTIONS(390),
    [anon_sym_int240] = ACTIONS(390),
    [anon_sym_int248] = ACTIONS(390),
    [anon_sym_int256] = ACTIONS(390),
    [anon_sym_uint] = ACTIONS(390),
    [anon_sym_uint8] = ACTIONS(390),
    [anon_sym_uint16] = ACTIONS(390),
    [anon_sym_uint24] = ACTIONS(390),
    [anon_sym_uint32] = ACTIONS(390),
    [anon_sym_uint40] = ACTIONS(390),
    [anon_sym_uint48] = ACTIONS(390),
    [anon_sym_uint56] = ACTIONS(390),
    [anon_sym_uint64] = ACTIONS(390),
    [anon_sym_uint72] = ACTIONS(390),
    [anon_sym_uint80] = ACTIONS(390),
    [anon_sym_uint88] = ACTIONS(390),
    [anon_sym_uint96] = ACTIONS(390),
    [anon_sym_uint104] = ACTIONS(390),
    [anon_sym_uint112] = ACTIONS(390),
    [anon_sym_uint120] = ACTIONS(390),
    [anon_sym_uint128] = ACTIONS(390),
    [anon_sym_uint136] = ACTIONS(390),
    [anon_sym_uint144] = ACTIONS(390),
    [anon_sym_uint152] = ACTIONS(390),
    [anon_sym_uint160] = ACTIONS(390),
    [anon_sym_uint168] = ACTIONS(390),
    [anon_sym_uint176] = ACTIONS(390),
    [anon_sym_uint184] = ACTIONS(390),
    [anon_sym_uint192] = ACTIONS(390),
    [anon_sym_uint200] = ACTIONS(390),
    [anon_sym_uint208] = ACTIONS(390),
    [anon_sym_uint216] = ACTIONS(390),
    [anon_sym_uint224] = ACTIONS(390),
    [anon_sym_uint232] = ACTIONS(390),
    [anon_sym_uint240] = ACTIONS(390),
    [anon_sym_uint248] = ACTIONS(390),
    [anon_sym_uint256] = ACTIONS(390),
    [anon_sym_bytes] = ACTIONS(390),
    [anon_sym_bytes1] = ACTIONS(390),
    [anon_sym_bytes2] = ACTIONS(390),
    [anon_sym_bytes3] = ACTIONS(390),
    [anon_sym_bytes4] = ACTIONS(390),
    [anon_sym_bytes5] = ACTIONS(390),
    [anon_sym_bytes6] = ACTIONS(390),
    [anon_sym_bytes7] = ACTIONS(390),
    [anon_sym_bytes8] = ACTIONS(390),
    [anon_sym_bytes9] = ACTIONS(390),
    [anon_sym_bytes10] = ACTIONS(390),
    [anon_sym_bytes11] = ACTIONS(390),
    [anon_sym_bytes12] = ACTIONS(390),
    [anon_sym_bytes13] = ACTIONS(390),
    [anon_sym_bytes14] = ACTIONS(390),
    [anon_sym_bytes15] = ACTIONS(390),
    [anon_sym_bytes16] = ACTIONS(390),
    [anon_sym_bytes17] = ACTIONS(390),
    [anon_sym_bytes18] = ACTIONS(390),
    [anon_sym_bytes19] = ACTIONS(390),
    [anon_sym_bytes20] = ACTIONS(390),
    [anon_sym_bytes21] = ACTIONS(390),
    [anon_sym_bytes22] = ACTIONS(390),
    [anon_sym_bytes23] = ACTIONS(390),
    [anon_sym_bytes24] = ACTIONS(390),
    [anon_sym_bytes25] = ACTIONS(390),
    [anon_sym_bytes26] = ACTIONS(390),
    [anon_sym_bytes27] = ACTIONS(390),
    [anon_sym_bytes28] = ACTIONS(390),
    [anon_sym_bytes29] = ACTIONS(390),
    [anon_sym_bytes30] = ACTIONS(390),
    [anon_sym_bytes31] = ACTIONS(390),
    [anon_sym_bytes32] = ACTIONS(390),
    [anon_sym_fixed] = ACTIONS(390),
    [aux_sym__fixed_token1] = ACTIONS(390),
    [anon_sym_ufixed] = ACTIONS(390),
    [aux_sym__ufixed_token1] = ACTIONS(390),
    [sym__semicolon] = ACTIONS(392),
    [aux_sym__decimal_number_token1] = ACTIONS(390),
    [aux_sym__decimal_number_token2] = ACTIONS(392),
    [aux_sym__hex_number_token1] = ACTIONS(392),
    [anon_sym_hex] = ACTIONS(390),
    [anon_sym_DQUOTE] = ACTIONS(392),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [anon_sym_unicode] = ACTIONS(390),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_identifier] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(394),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_type] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(396),
    [anon_sym_for] = ACTIONS(394),
    [anon_sym_assembly] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(394),
    [anon_sym_continue] = ACTIONS(394),
    [anon_sym_true] = ACTIONS(394),
    [anon_sym_false] = ACTIONS(394),
    [anon_sym_if] = ACTIONS(394),
    [anon_sym_function] = ACTIONS(394),
    [anon_sym_byte] = ACTIONS(394),
    [anon_sym_address] = ACTIONS(394),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_revert] = ACTIONS(394),
    [sym_unchecked] = ACTIONS(394),
    [anon_sym_var] = ACTIONS(394),
    [anon_sym_else] = ACTIONS(394),
    [anon_sym_while] = ACTIONS(394),
    [anon_sym_do] = ACTIONS(394),
    [anon_sym_try] = ACTIONS(394),
    [anon_sym_emit] = ACTIONS(394),
    [anon_sym_payable] = ACTIONS(394),
    [anon_sym_new] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(396),
    [anon_sym_PLUS] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(396),
    [anon_sym_delete] = ACTIONS(394),
    [anon_sym_PLUS_PLUS] = ACTIONS(396),
    [anon_sym_DASH_DASH] = ACTIONS(396),
    [anon_sym_mapping] = ACTIONS(394),
    [anon_sym_bool] = ACTIONS(394),
    [anon_sym_string] = ACTIONS(394),
    [anon_sym_int] = ACTIONS(394),
    [anon_sym_int8] = ACTIONS(394),
    [anon_sym_int16] = ACTIONS(394),
    [anon_sym_int24] = ACTIONS(394),
    [anon_sym_int32] = ACTIONS(394),
    [anon_sym_int40] = ACTIONS(394),
    [anon_sym_int48] = ACTIONS(394),
    [anon_sym_int56] = ACTIONS(394),
    [anon_sym_int64] = ACTIONS(394),
    [anon_sym_int72] = ACTIONS(394),
    [anon_sym_int80] = ACTIONS(394),
    [anon_sym_int88] = ACTIONS(394),
    [anon_sym_int96] = ACTIONS(394),
    [anon_sym_int104] = ACTIONS(394),
    [anon_sym_int112] = ACTIONS(394),
    [anon_sym_int120] = ACTIONS(394),
    [anon_sym_int128] = ACTIONS(394),
    [anon_sym_int136] = ACTIONS(394),
    [anon_sym_int144] = ACTIONS(394),
    [anon_sym_int152] = ACTIONS(394),
    [anon_sym_int160] = ACTIONS(394),
    [anon_sym_int168] = ACTIONS(394),
    [anon_sym_int176] = ACTIONS(394),
    [anon_sym_int184] = ACTIONS(394),
    [anon_sym_int192] = ACTIONS(394),
    [anon_sym_int200] = ACTIONS(394),
    [anon_sym_int208] = ACTIONS(394),
    [anon_sym_int216] = ACTIONS(394),
    [anon_sym_int224] = ACTIONS(394),
    [anon_sym_int232] = ACTIONS(394),
    [anon_sym_int240] = ACTIONS(394),
    [anon_sym_int248] = ACTIONS(394),
    [anon_sym_int256] = ACTIONS(394),
    [anon_sym_uint] = ACTIONS(394),
    [anon_sym_uint8] = ACTIONS(394),
    [anon_sym_uint16] = ACTIONS(394),
    [anon_sym_uint24] = ACTIONS(394),
    [anon_sym_uint32] = ACTIONS(394),
    [anon_sym_uint40] = ACTIONS(394),
    [anon_sym_uint48] = ACTIONS(394),
    [anon_sym_uint56] = ACTIONS(394),
    [anon_sym_uint64] = ACTIONS(394),
    [anon_sym_uint72] = ACTIONS(394),
    [anon_sym_uint80] = ACTIONS(394),
    [anon_sym_uint88] = ACTIONS(394),
    [anon_sym_uint96] = ACTIONS(394),
    [anon_sym_uint104] = ACTIONS(394),
    [anon_sym_uint112] = ACTIONS(394),
    [anon_sym_uint120] = ACTIONS(394),
    [anon_sym_uint128] = ACTIONS(394),
    [anon_sym_uint136] = ACTIONS(394),
    [anon_sym_uint144] = ACTIONS(394),
    [anon_sym_uint152] = ACTIONS(394),
    [anon_sym_uint160] = ACTIONS(394),
    [anon_sym_uint168] = ACTIONS(394),
    [anon_sym_uint176] = ACTIONS(394),
    [anon_sym_uint184] = ACTIONS(394),
    [anon_sym_uint192] = ACTIONS(394),
    [anon_sym_uint200] = ACTIONS(394),
    [anon_sym_uint208] = ACTIONS(394),
    [anon_sym_uint216] = ACTIONS(394),
    [anon_sym_uint224] = ACTIONS(394),
    [anon_sym_uint232] = ACTIONS(394),
    [anon_sym_uint240] = ACTIONS(394),
    [anon_sym_uint248] = ACTIONS(394),
    [anon_sym_uint256] = ACTIONS(394),
    [anon_sym_bytes] = ACTIONS(394),
    [anon_sym_bytes1] = ACTIONS(394),
    [anon_sym_bytes2] = ACTIONS(394),
    [anon_sym_bytes3] = ACTIONS(394),
    [anon_sym_bytes4] = ACTIONS(394),
    [anon_sym_bytes5] = ACTIONS(394),
    [anon_sym_bytes6] = ACTIONS(394),
    [anon_sym_bytes7] = ACTIONS(394),
    [anon_sym_bytes8] = ACTIONS(394),
    [anon_sym_bytes9] = ACTIONS(394),
    [anon_sym_bytes10] = ACTIONS(394),
    [anon_sym_bytes11] = ACTIONS(394),
    [anon_sym_bytes12] = ACTIONS(394),
    [anon_sym_bytes13] = ACTIONS(394),
    [anon_sym_bytes14] = ACTIONS(394),
    [anon_sym_bytes15] = ACTIONS(394),
    [anon_sym_bytes16] = ACTIONS(394),
    [anon_sym_bytes17] = ACTIONS(394),
    [anon_sym_bytes18] = ACTIONS(394),
    [anon_sym_bytes19] = ACTIONS(394),
    [anon_sym_bytes20] = ACTIONS(394),
    [anon_sym_bytes21] = ACTIONS(394),
    [anon_sym_bytes22] = ACTIONS(394),
    [anon_sym_bytes23] = ACTIONS(394),
    [anon_sym_bytes24] = ACTIONS(394),
    [anon_sym_bytes25] = ACTIONS(394),
    [anon_sym_bytes26] = ACTIONS(394),
    [anon_sym_bytes27] = ACTIONS(394),
    [anon_sym_bytes28] = ACTIONS(394),
    [anon_sym_bytes29] = ACTIONS(394),
    [anon_sym_bytes30] = ACTIONS(394),
    [anon_sym_bytes31] = ACTIONS(394),
    [anon_sym_bytes32] = ACTIONS(394),
    [anon_sym_fixed] = ACTIONS(394),
    [aux_sym__fixed_token1] = ACTIONS(394),
    [anon_sym_ufixed] = ACTIONS(394),
    [aux_sym__ufixed_token1] = ACTIONS(394),
    [aux_sym__decimal_number_token1] = ACTIONS(394),
    [aux_sym__decimal_number_token2] = ACTIONS(396),
    [aux_sym__hex_number_token1] = ACTIONS(396),
    [anon_sym_hex] = ACTIONS(394),
    [anon_sym_DQUOTE] = ACTIONS(396),
    [anon_sym_SQUOTE] = ACTIONS(396),
    [anon_sym_unicode] = ACTIONS(394),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_identifier] = ACTIONS(398),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(400),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_RBRACE] = ACTIONS(400),
    [anon_sym_type] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(400),
    [anon_sym_for] = ACTIONS(398),
    [anon_sym_assembly] = ACTIONS(398),
    [anon_sym_break] = ACTIONS(398),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_true] = ACTIONS(398),
    [anon_sym_false] = ACTIONS(398),
    [anon_sym_if] = ACTIONS(398),
    [anon_sym_function] = ACTIONS(398),
    [anon_sym_byte] = ACTIONS(398),
    [anon_sym_address] = ACTIONS(398),
    [anon_sym_return] = ACTIONS(398),
    [anon_sym_revert] = ACTIONS(398),
    [sym_unchecked] = ACTIONS(398),
    [anon_sym_var] = ACTIONS(398),
    [anon_sym_else] = ACTIONS(398),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_do] = ACTIONS(398),
    [anon_sym_try] = ACTIONS(398),
    [anon_sym_emit] = ACTIONS(398),
    [anon_sym_payable] = ACTIONS(398),
    [anon_sym_new] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_BANG] = ACTIONS(400),
    [anon_sym_delete] = ACTIONS(398),
    [anon_sym_PLUS_PLUS] = ACTIONS(400),
    [anon_sym_DASH_DASH] = ACTIONS(400),
    [anon_sym_mapping] = ACTIONS(398),
    [anon_sym_bool] = ACTIONS(398),
    [anon_sym_string] = ACTIONS(398),
    [anon_sym_int] = ACTIONS(398),
    [anon_sym_int8] = ACTIONS(398),
    [anon_sym_int16] = ACTIONS(398),
    [anon_sym_int24] = ACTIONS(398),
    [anon_sym_int32] = ACTIONS(398),
    [anon_sym_int40] = ACTIONS(398),
    [anon_sym_int48] = ACTIONS(398),
    [anon_sym_int56] = ACTIONS(398),
    [anon_sym_int64] = ACTIONS(398),
    [anon_sym_int72] = ACTIONS(398),
    [anon_sym_int80] = ACTIONS(398),
    [anon_sym_int88] = ACTIONS(398),
    [anon_sym_int96] = ACTIONS(398),
    [anon_sym_int104] = ACTIONS(398),
    [anon_sym_int112] = ACTIONS(398),
    [anon_sym_int120] = ACTIONS(398),
    [anon_sym_int128] = ACTIONS(398),
    [anon_sym_int136] = ACTIONS(398),
    [anon_sym_int144] = ACTIONS(398),
    [anon_sym_int152] = ACTIONS(398),
    [anon_sym_int160] = ACTIONS(398),
    [anon_sym_int168] = ACTIONS(398),
    [anon_sym_int176] = ACTIONS(398),
    [anon_sym_int184] = ACTIONS(398),
    [anon_sym_int192] = ACTIONS(398),
    [anon_sym_int200] = ACTIONS(398),
    [anon_sym_int208] = ACTIONS(398),
    [anon_sym_int216] = ACTIONS(398),
    [anon_sym_int224] = ACTIONS(398),
    [anon_sym_int232] = ACTIONS(398),
    [anon_sym_int240] = ACTIONS(398),
    [anon_sym_int248] = ACTIONS(398),
    [anon_sym_int256] = ACTIONS(398),
    [anon_sym_uint] = ACTIONS(398),
    [anon_sym_uint8] = ACTIONS(398),
    [anon_sym_uint16] = ACTIONS(398),
    [anon_sym_uint24] = ACTIONS(398),
    [anon_sym_uint32] = ACTIONS(398),
    [anon_sym_uint40] = ACTIONS(398),
    [anon_sym_uint48] = ACTIONS(398),
    [anon_sym_uint56] = ACTIONS(398),
    [anon_sym_uint64] = ACTIONS(398),
    [anon_sym_uint72] = ACTIONS(398),
    [anon_sym_uint80] = ACTIONS(398),
    [anon_sym_uint88] = ACTIONS(398),
    [anon_sym_uint96] = ACTIONS(398),
    [anon_sym_uint104] = ACTIONS(398),
    [anon_sym_uint112] = ACTIONS(398),
    [anon_sym_uint120] = ACTIONS(398),
    [anon_sym_uint128] = ACTIONS(398),
    [anon_sym_uint136] = ACTIONS(398),
    [anon_sym_uint144] = ACTIONS(398),
    [anon_sym_uint152] = ACTIONS(398),
    [anon_sym_uint160] = ACTIONS(398),
    [anon_sym_uint168] = ACTIONS(398),
    [anon_sym_uint176] = ACTIONS(398),
    [anon_sym_uint184] = ACTIONS(398),
    [anon_sym_uint192] = ACTIONS(398),
    [anon_sym_uint200] = ACTIONS(398),
    [anon_sym_uint208] = ACTIONS(398),
    [anon_sym_uint216] = ACTIONS(398),
    [anon_sym_uint224] = ACTIONS(398),
    [anon_sym_uint232] = ACTIONS(398),
    [anon_sym_uint240] = ACTIONS(398),
    [anon_sym_uint248] = ACTIONS(398),
    [anon_sym_uint256] = ACTIONS(398),
    [anon_sym_bytes] = ACTIONS(398),
    [anon_sym_bytes1] = ACTIONS(398),
    [anon_sym_bytes2] = ACTIONS(398),
    [anon_sym_bytes3] = ACTIONS(398),
    [anon_sym_bytes4] = ACTIONS(398),
    [anon_sym_bytes5] = ACTIONS(398),
    [anon_sym_bytes6] = ACTIONS(398),
    [anon_sym_bytes7] = ACTIONS(398),
    [anon_sym_bytes8] = ACTIONS(398),
    [anon_sym_bytes9] = ACTIONS(398),
    [anon_sym_bytes10] = ACTIONS(398),
    [anon_sym_bytes11] = ACTIONS(398),
    [anon_sym_bytes12] = ACTIONS(398),
    [anon_sym_bytes13] = ACTIONS(398),
    [anon_sym_bytes14] = ACTIONS(398),
    [anon_sym_bytes15] = ACTIONS(398),
    [anon_sym_bytes16] = ACTIONS(398),
    [anon_sym_bytes17] = ACTIONS(398),
    [anon_sym_bytes18] = ACTIONS(398),
    [anon_sym_bytes19] = ACTIONS(398),
    [anon_sym_bytes20] = ACTIONS(398),
    [anon_sym_bytes21] = ACTIONS(398),
    [anon_sym_bytes22] = ACTIONS(398),
    [anon_sym_bytes23] = ACTIONS(398),
    [anon_sym_bytes24] = ACTIONS(398),
    [anon_sym_bytes25] = ACTIONS(398),
    [anon_sym_bytes26] = ACTIONS(398),
    [anon_sym_bytes27] = ACTIONS(398),
    [anon_sym_bytes28] = ACTIONS(398),
    [anon_sym_bytes29] = ACTIONS(398),
    [anon_sym_bytes30] = ACTIONS(398),
    [anon_sym_bytes31] = ACTIONS(398),
    [anon_sym_bytes32] = ACTIONS(398),
    [anon_sym_fixed] = ACTIONS(398),
    [aux_sym__fixed_token1] = ACTIONS(398),
    [anon_sym_ufixed] = ACTIONS(398),
    [aux_sym__ufixed_token1] = ACTIONS(398),
    [aux_sym__decimal_number_token1] = ACTIONS(398),
    [aux_sym__decimal_number_token2] = ACTIONS(400),
    [aux_sym__hex_number_token1] = ACTIONS(400),
    [anon_sym_hex] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_SQUOTE] = ACTIONS(400),
    [anon_sym_unicode] = ACTIONS(398),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_identifier] = ACTIONS(402),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_TILDE] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_RBRACE] = ACTIONS(404),
    [anon_sym_type] = ACTIONS(402),
    [anon_sym_LPAREN] = ACTIONS(404),
    [anon_sym_for] = ACTIONS(402),
    [anon_sym_assembly] = ACTIONS(402),
    [anon_sym_break] = ACTIONS(402),
    [anon_sym_continue] = ACTIONS(402),
    [anon_sym_true] = ACTIONS(402),
    [anon_sym_false] = ACTIONS(402),
    [anon_sym_if] = ACTIONS(402),
    [anon_sym_function] = ACTIONS(402),
    [anon_sym_byte] = ACTIONS(402),
    [anon_sym_address] = ACTIONS(402),
    [anon_sym_return] = ACTIONS(402),
    [anon_sym_revert] = ACTIONS(402),
    [sym_unchecked] = ACTIONS(402),
    [anon_sym_var] = ACTIONS(402),
    [anon_sym_else] = ACTIONS(402),
    [anon_sym_while] = ACTIONS(402),
    [anon_sym_do] = ACTIONS(402),
    [anon_sym_try] = ACTIONS(402),
    [anon_sym_emit] = ACTIONS(402),
    [anon_sym_payable] = ACTIONS(402),
    [anon_sym_new] = ACTIONS(402),
    [anon_sym_LBRACK] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_BANG] = ACTIONS(404),
    [anon_sym_delete] = ACTIONS(402),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_mapping] = ACTIONS(402),
    [anon_sym_bool] = ACTIONS(402),
    [anon_sym_string] = ACTIONS(402),
    [anon_sym_int] = ACTIONS(402),
    [anon_sym_int8] = ACTIONS(402),
    [anon_sym_int16] = ACTIONS(402),
    [anon_sym_int24] = ACTIONS(402),
    [anon_sym_int32] = ACTIONS(402),
    [anon_sym_int40] = ACTIONS(402),
    [anon_sym_int48] = ACTIONS(402),
    [anon_sym_int56] = ACTIONS(402),
    [anon_sym_int64] = ACTIONS(402),
    [anon_sym_int72] = ACTIONS(402),
    [anon_sym_int80] = ACTIONS(402),
    [anon_sym_int88] = ACTIONS(402),
    [anon_sym_int96] = ACTIONS(402),
    [anon_sym_int104] = ACTIONS(402),
    [anon_sym_int112] = ACTIONS(402),
    [anon_sym_int120] = ACTIONS(402),
    [anon_sym_int128] = ACTIONS(402),
    [anon_sym_int136] = ACTIONS(402),
    [anon_sym_int144] = ACTIONS(402),
    [anon_sym_int152] = ACTIONS(402),
    [anon_sym_int160] = ACTIONS(402),
    [anon_sym_int168] = ACTIONS(402),
    [anon_sym_int176] = ACTIONS(402),
    [anon_sym_int184] = ACTIONS(402),
    [anon_sym_int192] = ACTIONS(402),
    [anon_sym_int200] = ACTIONS(402),
    [anon_sym_int208] = ACTIONS(402),
    [anon_sym_int216] = ACTIONS(402),
    [anon_sym_int224] = ACTIONS(402),
    [anon_sym_int232] = ACTIONS(402),
    [anon_sym_int240] = ACTIONS(402),
    [anon_sym_int248] = ACTIONS(402),
    [anon_sym_int256] = ACTIONS(402),
    [anon_sym_uint] = ACTIONS(402),
    [anon_sym_uint8] = ACTIONS(402),
    [anon_sym_uint16] = ACTIONS(402),
    [anon_sym_uint24] = ACTIONS(402),
    [anon_sym_uint32] = ACTIONS(402),
    [anon_sym_uint40] = ACTIONS(402),
    [anon_sym_uint48] = ACTIONS(402),
    [anon_sym_uint56] = ACTIONS(402),
    [anon_sym_uint64] = ACTIONS(402),
    [anon_sym_uint72] = ACTIONS(402),
    [anon_sym_uint80] = ACTIONS(402),
    [anon_sym_uint88] = ACTIONS(402),
    [anon_sym_uint96] = ACTIONS(402),
    [anon_sym_uint104] = ACTIONS(402),
    [anon_sym_uint112] = ACTIONS(402),
    [anon_sym_uint120] = ACTIONS(402),
    [anon_sym_uint128] = ACTIONS(402),
    [anon_sym_uint136] = ACTIONS(402),
    [anon_sym_uint144] = ACTIONS(402),
    [anon_sym_uint152] = ACTIONS(402),
    [anon_sym_uint160] = ACTIONS(402),
    [anon_sym_uint168] = ACTIONS(402),
    [anon_sym_uint176] = ACTIONS(402),
    [anon_sym_uint184] = ACTIONS(402),
    [anon_sym_uint192] = ACTIONS(402),
    [anon_sym_uint200] = ACTIONS(402),
    [anon_sym_uint208] = ACTIONS(402),
    [anon_sym_uint216] = ACTIONS(402),
    [anon_sym_uint224] = ACTIONS(402),
    [anon_sym_uint232] = ACTIONS(402),
    [anon_sym_uint240] = ACTIONS(402),
    [anon_sym_uint248] = ACTIONS(402),
    [anon_sym_uint256] = ACTIONS(402),
    [anon_sym_bytes] = ACTIONS(402),
    [anon_sym_bytes1] = ACTIONS(402),
    [anon_sym_bytes2] = ACTIONS(402),
    [anon_sym_bytes3] = ACTIONS(402),
    [anon_sym_bytes4] = ACTIONS(402),
    [anon_sym_bytes5] = ACTIONS(402),
    [anon_sym_bytes6] = ACTIONS(402),
    [anon_sym_bytes7] = ACTIONS(402),
    [anon_sym_bytes8] = ACTIONS(402),
    [anon_sym_bytes9] = ACTIONS(402),
    [anon_sym_bytes10] = ACTIONS(402),
    [anon_sym_bytes11] = ACTIONS(402),
    [anon_sym_bytes12] = ACTIONS(402),
    [anon_sym_bytes13] = ACTIONS(402),
    [anon_sym_bytes14] = ACTIONS(402),
    [anon_sym_bytes15] = ACTIONS(402),
    [anon_sym_bytes16] = ACTIONS(402),
    [anon_sym_bytes17] = ACTIONS(402),
    [anon_sym_bytes18] = ACTIONS(402),
    [anon_sym_bytes19] = ACTIONS(402),
    [anon_sym_bytes20] = ACTIONS(402),
    [anon_sym_bytes21] = ACTIONS(402),
    [anon_sym_bytes22] = ACTIONS(402),
    [anon_sym_bytes23] = ACTIONS(402),
    [anon_sym_bytes24] = ACTIONS(402),
    [anon_sym_bytes25] = ACTIONS(402),
    [anon_sym_bytes26] = ACTIONS(402),
    [anon_sym_bytes27] = ACTIONS(402),
    [anon_sym_bytes28] = ACTIONS(402),
    [anon_sym_bytes29] = ACTIONS(402),
    [anon_sym_bytes30] = ACTIONS(402),
    [anon_sym_bytes31] = ACTIONS(402),
    [anon_sym_bytes32] = ACTIONS(402),
    [anon_sym_fixed] = ACTIONS(402),
    [aux_sym__fixed_token1] = ACTIONS(402),
    [anon_sym_ufixed] = ACTIONS(402),
    [aux_sym__ufixed_token1] = ACTIONS(402),
    [aux_sym__decimal_number_token1] = ACTIONS(402),
    [aux_sym__decimal_number_token2] = ACTIONS(404),
    [aux_sym__hex_number_token1] = ACTIONS(404),
    [anon_sym_hex] = ACTIONS(402),
    [anon_sym_DQUOTE] = ACTIONS(404),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_unicode] = ACTIONS(402),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_user_defined_type_definition] = STATE(86),
    [sym_error_declaration] = STATE(86),
    [sym__contract_member] = STATE(86),
    [sym_struct_declaration] = STATE(86),
    [sym_enum_declaration] = STATE(86),
    [sym_event_definition] = STATE(86),
    [sym_using_directive] = STATE(86),
    [sym_state_variable_declaration] = STATE(86),
    [sym_modifier_definition] = STATE(86),
    [sym_constructor_definition] = STATE(86),
    [sym_fallback_receive_definition] = STATE(86),
    [sym_function_definition] = STATE(86),
    [sym_type_name] = STATE(456),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_contract_body_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(406),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_error] = ACTIONS(410),
    [anon_sym_struct] = ACTIONS(412),
    [anon_sym_enum] = ACTIONS(414),
    [anon_sym_event] = ACTIONS(416),
    [anon_sym_using] = ACTIONS(418),
    [anon_sym_function] = ACTIONS(420),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_modifier] = ACTIONS(422),
    [anon_sym_constructor] = ACTIONS(424),
    [anon_sym_fallback] = ACTIONS(426),
    [anon_sym_receive] = ACTIONS(426),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_user_defined_type_definition] = STATE(101),
    [sym_error_declaration] = STATE(101),
    [sym__contract_member] = STATE(101),
    [sym_struct_declaration] = STATE(101),
    [sym_enum_declaration] = STATE(101),
    [sym_event_definition] = STATE(101),
    [sym_using_directive] = STATE(101),
    [sym_state_variable_declaration] = STATE(101),
    [sym_modifier_definition] = STATE(101),
    [sym_constructor_definition] = STATE(101),
    [sym_fallback_receive_definition] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_type_name] = STATE(456),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_contract_body_repeat1] = STATE(101),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(428),
    [anon_sym_type] = ACTIONS(408),
    [anon_sym_error] = ACTIONS(410),
    [anon_sym_struct] = ACTIONS(412),
    [anon_sym_enum] = ACTIONS(414),
    [anon_sym_event] = ACTIONS(416),
    [anon_sym_using] = ACTIONS(418),
    [anon_sym_function] = ACTIONS(420),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_modifier] = ACTIONS(422),
    [anon_sym_constructor] = ACTIONS(424),
    [anon_sym_fallback] = ACTIONS(426),
    [anon_sym_receive] = ACTIONS(426),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_identifier] = ACTIONS(430),
    [anon_sym_DASH] = ACTIONS(430),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_RBRACE] = ACTIONS(432),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_for] = ACTIONS(430),
    [anon_sym_assembly] = ACTIONS(430),
    [anon_sym_break] = ACTIONS(430),
    [anon_sym_continue] = ACTIONS(430),
    [anon_sym_true] = ACTIONS(430),
    [anon_sym_false] = ACTIONS(430),
    [anon_sym_if] = ACTIONS(430),
    [anon_sym_function] = ACTIONS(430),
    [anon_sym_byte] = ACTIONS(430),
    [anon_sym_address] = ACTIONS(430),
    [anon_sym_return] = ACTIONS(430),
    [anon_sym_revert] = ACTIONS(430),
    [sym_unchecked] = ACTIONS(430),
    [anon_sym_var] = ACTIONS(430),
    [anon_sym_else] = ACTIONS(430),
    [anon_sym_while] = ACTIONS(430),
    [anon_sym_do] = ACTIONS(430),
    [anon_sym_try] = ACTIONS(430),
    [anon_sym_emit] = ACTIONS(430),
    [anon_sym_payable] = ACTIONS(430),
    [anon_sym_new] = ACTIONS(430),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_PLUS] = ACTIONS(430),
    [anon_sym_BANG] = ACTIONS(432),
    [anon_sym_delete] = ACTIONS(430),
    [anon_sym_PLUS_PLUS] = ACTIONS(432),
    [anon_sym_DASH_DASH] = ACTIONS(432),
    [anon_sym_mapping] = ACTIONS(430),
    [anon_sym_bool] = ACTIONS(430),
    [anon_sym_string] = ACTIONS(430),
    [anon_sym_int] = ACTIONS(430),
    [anon_sym_int8] = ACTIONS(430),
    [anon_sym_int16] = ACTIONS(430),
    [anon_sym_int24] = ACTIONS(430),
    [anon_sym_int32] = ACTIONS(430),
    [anon_sym_int40] = ACTIONS(430),
    [anon_sym_int48] = ACTIONS(430),
    [anon_sym_int56] = ACTIONS(430),
    [anon_sym_int64] = ACTIONS(430),
    [anon_sym_int72] = ACTIONS(430),
    [anon_sym_int80] = ACTIONS(430),
    [anon_sym_int88] = ACTIONS(430),
    [anon_sym_int96] = ACTIONS(430),
    [anon_sym_int104] = ACTIONS(430),
    [anon_sym_int112] = ACTIONS(430),
    [anon_sym_int120] = ACTIONS(430),
    [anon_sym_int128] = ACTIONS(430),
    [anon_sym_int136] = ACTIONS(430),
    [anon_sym_int144] = ACTIONS(430),
    [anon_sym_int152] = ACTIONS(430),
    [anon_sym_int160] = ACTIONS(430),
    [anon_sym_int168] = ACTIONS(430),
    [anon_sym_int176] = ACTIONS(430),
    [anon_sym_int184] = ACTIONS(430),
    [anon_sym_int192] = ACTIONS(430),
    [anon_sym_int200] = ACTIONS(430),
    [anon_sym_int208] = ACTIONS(430),
    [anon_sym_int216] = ACTIONS(430),
    [anon_sym_int224] = ACTIONS(430),
    [anon_sym_int232] = ACTIONS(430),
    [anon_sym_int240] = ACTIONS(430),
    [anon_sym_int248] = ACTIONS(430),
    [anon_sym_int256] = ACTIONS(430),
    [anon_sym_uint] = ACTIONS(430),
    [anon_sym_uint8] = ACTIONS(430),
    [anon_sym_uint16] = ACTIONS(430),
    [anon_sym_uint24] = ACTIONS(430),
    [anon_sym_uint32] = ACTIONS(430),
    [anon_sym_uint40] = ACTIONS(430),
    [anon_sym_uint48] = ACTIONS(430),
    [anon_sym_uint56] = ACTIONS(430),
    [anon_sym_uint64] = ACTIONS(430),
    [anon_sym_uint72] = ACTIONS(430),
    [anon_sym_uint80] = ACTIONS(430),
    [anon_sym_uint88] = ACTIONS(430),
    [anon_sym_uint96] = ACTIONS(430),
    [anon_sym_uint104] = ACTIONS(430),
    [anon_sym_uint112] = ACTIONS(430),
    [anon_sym_uint120] = ACTIONS(430),
    [anon_sym_uint128] = ACTIONS(430),
    [anon_sym_uint136] = ACTIONS(430),
    [anon_sym_uint144] = ACTIONS(430),
    [anon_sym_uint152] = ACTIONS(430),
    [anon_sym_uint160] = ACTIONS(430),
    [anon_sym_uint168] = ACTIONS(430),
    [anon_sym_uint176] = ACTIONS(430),
    [anon_sym_uint184] = ACTIONS(430),
    [anon_sym_uint192] = ACTIONS(430),
    [anon_sym_uint200] = ACTIONS(430),
    [anon_sym_uint208] = ACTIONS(430),
    [anon_sym_uint216] = ACTIONS(430),
    [anon_sym_uint224] = ACTIONS(430),
    [anon_sym_uint232] = ACTIONS(430),
    [anon_sym_uint240] = ACTIONS(430),
    [anon_sym_uint248] = ACTIONS(430),
    [anon_sym_uint256] = ACTIONS(430),
    [anon_sym_bytes] = ACTIONS(430),
    [anon_sym_bytes1] = ACTIONS(430),
    [anon_sym_bytes2] = ACTIONS(430),
    [anon_sym_bytes3] = ACTIONS(430),
    [anon_sym_bytes4] = ACTIONS(430),
    [anon_sym_bytes5] = ACTIONS(430),
    [anon_sym_bytes6] = ACTIONS(430),
    [anon_sym_bytes7] = ACTIONS(430),
    [anon_sym_bytes8] = ACTIONS(430),
    [anon_sym_bytes9] = ACTIONS(430),
    [anon_sym_bytes10] = ACTIONS(430),
    [anon_sym_bytes11] = ACTIONS(430),
    [anon_sym_bytes12] = ACTIONS(430),
    [anon_sym_bytes13] = ACTIONS(430),
    [anon_sym_bytes14] = ACTIONS(430),
    [anon_sym_bytes15] = ACTIONS(430),
    [anon_sym_bytes16] = ACTIONS(430),
    [anon_sym_bytes17] = ACTIONS(430),
    [anon_sym_bytes18] = ACTIONS(430),
    [anon_sym_bytes19] = ACTIONS(430),
    [anon_sym_bytes20] = ACTIONS(430),
    [anon_sym_bytes21] = ACTIONS(430),
    [anon_sym_bytes22] = ACTIONS(430),
    [anon_sym_bytes23] = ACTIONS(430),
    [anon_sym_bytes24] = ACTIONS(430),
    [anon_sym_bytes25] = ACTIONS(430),
    [anon_sym_bytes26] = ACTIONS(430),
    [anon_sym_bytes27] = ACTIONS(430),
    [anon_sym_bytes28] = ACTIONS(430),
    [anon_sym_bytes29] = ACTIONS(430),
    [anon_sym_bytes30] = ACTIONS(430),
    [anon_sym_bytes31] = ACTIONS(430),
    [anon_sym_bytes32] = ACTIONS(430),
    [anon_sym_fixed] = ACTIONS(430),
    [aux_sym__fixed_token1] = ACTIONS(430),
    [anon_sym_ufixed] = ACTIONS(430),
    [aux_sym__ufixed_token1] = ACTIONS(430),
    [aux_sym__decimal_number_token1] = ACTIONS(430),
    [aux_sym__decimal_number_token2] = ACTIONS(432),
    [aux_sym__hex_number_token1] = ACTIONS(432),
    [anon_sym_hex] = ACTIONS(430),
    [anon_sym_DQUOTE] = ACTIONS(432),
    [anon_sym_SQUOTE] = ACTIONS(432),
    [anon_sym_unicode] = ACTIONS(430),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_identifier] = ACTIONS(434),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_TILDE] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_RBRACE] = ACTIONS(436),
    [anon_sym_type] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_for] = ACTIONS(434),
    [anon_sym_assembly] = ACTIONS(434),
    [anon_sym_break] = ACTIONS(434),
    [anon_sym_continue] = ACTIONS(434),
    [anon_sym_true] = ACTIONS(434),
    [anon_sym_false] = ACTIONS(434),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_function] = ACTIONS(434),
    [anon_sym_byte] = ACTIONS(434),
    [anon_sym_address] = ACTIONS(434),
    [anon_sym_return] = ACTIONS(434),
    [anon_sym_revert] = ACTIONS(434),
    [sym_unchecked] = ACTIONS(434),
    [anon_sym_var] = ACTIONS(434),
    [anon_sym_else] = ACTIONS(434),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_do] = ACTIONS(434),
    [anon_sym_try] = ACTIONS(434),
    [anon_sym_emit] = ACTIONS(434),
    [anon_sym_payable] = ACTIONS(434),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_LBRACK] = ACTIONS(436),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_BANG] = ACTIONS(436),
    [anon_sym_delete] = ACTIONS(434),
    [anon_sym_PLUS_PLUS] = ACTIONS(436),
    [anon_sym_DASH_DASH] = ACTIONS(436),
    [anon_sym_mapping] = ACTIONS(434),
    [anon_sym_bool] = ACTIONS(434),
    [anon_sym_string] = ACTIONS(434),
    [anon_sym_int] = ACTIONS(434),
    [anon_sym_int8] = ACTIONS(434),
    [anon_sym_int16] = ACTIONS(434),
    [anon_sym_int24] = ACTIONS(434),
    [anon_sym_int32] = ACTIONS(434),
    [anon_sym_int40] = ACTIONS(434),
    [anon_sym_int48] = ACTIONS(434),
    [anon_sym_int56] = ACTIONS(434),
    [anon_sym_int64] = ACTIONS(434),
    [anon_sym_int72] = ACTIONS(434),
    [anon_sym_int80] = ACTIONS(434),
    [anon_sym_int88] = ACTIONS(434),
    [anon_sym_int96] = ACTIONS(434),
    [anon_sym_int104] = ACTIONS(434),
    [anon_sym_int112] = ACTIONS(434),
    [anon_sym_int120] = ACTIONS(434),
    [anon_sym_int128] = ACTIONS(434),
    [anon_sym_int136] = ACTIONS(434),
    [anon_sym_int144] = ACTIONS(434),
    [anon_sym_int152] = ACTIONS(434),
    [anon_sym_int160] = ACTIONS(434),
    [anon_sym_int168] = ACTIONS(434),
    [anon_sym_int176] = ACTIONS(434),
    [anon_sym_int184] = ACTIONS(434),
    [anon_sym_int192] = ACTIONS(434),
    [anon_sym_int200] = ACTIONS(434),
    [anon_sym_int208] = ACTIONS(434),
    [anon_sym_int216] = ACTIONS(434),
    [anon_sym_int224] = ACTIONS(434),
    [anon_sym_int232] = ACTIONS(434),
    [anon_sym_int240] = ACTIONS(434),
    [anon_sym_int248] = ACTIONS(434),
    [anon_sym_int256] = ACTIONS(434),
    [anon_sym_uint] = ACTIONS(434),
    [anon_sym_uint8] = ACTIONS(434),
    [anon_sym_uint16] = ACTIONS(434),
    [anon_sym_uint24] = ACTIONS(434),
    [anon_sym_uint32] = ACTIONS(434),
    [anon_sym_uint40] = ACTIONS(434),
    [anon_sym_uint48] = ACTIONS(434),
    [anon_sym_uint56] = ACTIONS(434),
    [anon_sym_uint64] = ACTIONS(434),
    [anon_sym_uint72] = ACTIONS(434),
    [anon_sym_uint80] = ACTIONS(434),
    [anon_sym_uint88] = ACTIONS(434),
    [anon_sym_uint96] = ACTIONS(434),
    [anon_sym_uint104] = ACTIONS(434),
    [anon_sym_uint112] = ACTIONS(434),
    [anon_sym_uint120] = ACTIONS(434),
    [anon_sym_uint128] = ACTIONS(434),
    [anon_sym_uint136] = ACTIONS(434),
    [anon_sym_uint144] = ACTIONS(434),
    [anon_sym_uint152] = ACTIONS(434),
    [anon_sym_uint160] = ACTIONS(434),
    [anon_sym_uint168] = ACTIONS(434),
    [anon_sym_uint176] = ACTIONS(434),
    [anon_sym_uint184] = ACTIONS(434),
    [anon_sym_uint192] = ACTIONS(434),
    [anon_sym_uint200] = ACTIONS(434),
    [anon_sym_uint208] = ACTIONS(434),
    [anon_sym_uint216] = ACTIONS(434),
    [anon_sym_uint224] = ACTIONS(434),
    [anon_sym_uint232] = ACTIONS(434),
    [anon_sym_uint240] = ACTIONS(434),
    [anon_sym_uint248] = ACTIONS(434),
    [anon_sym_uint256] = ACTIONS(434),
    [anon_sym_bytes] = ACTIONS(434),
    [anon_sym_bytes1] = ACTIONS(434),
    [anon_sym_bytes2] = ACTIONS(434),
    [anon_sym_bytes3] = ACTIONS(434),
    [anon_sym_bytes4] = ACTIONS(434),
    [anon_sym_bytes5] = ACTIONS(434),
    [anon_sym_bytes6] = ACTIONS(434),
    [anon_sym_bytes7] = ACTIONS(434),
    [anon_sym_bytes8] = ACTIONS(434),
    [anon_sym_bytes9] = ACTIONS(434),
    [anon_sym_bytes10] = ACTIONS(434),
    [anon_sym_bytes11] = ACTIONS(434),
    [anon_sym_bytes12] = ACTIONS(434),
    [anon_sym_bytes13] = ACTIONS(434),
    [anon_sym_bytes14] = ACTIONS(434),
    [anon_sym_bytes15] = ACTIONS(434),
    [anon_sym_bytes16] = ACTIONS(434),
    [anon_sym_bytes17] = ACTIONS(434),
    [anon_sym_bytes18] = ACTIONS(434),
    [anon_sym_bytes19] = ACTIONS(434),
    [anon_sym_bytes20] = ACTIONS(434),
    [anon_sym_bytes21] = ACTIONS(434),
    [anon_sym_bytes22] = ACTIONS(434),
    [anon_sym_bytes23] = ACTIONS(434),
    [anon_sym_bytes24] = ACTIONS(434),
    [anon_sym_bytes25] = ACTIONS(434),
    [anon_sym_bytes26] = ACTIONS(434),
    [anon_sym_bytes27] = ACTIONS(434),
    [anon_sym_bytes28] = ACTIONS(434),
    [anon_sym_bytes29] = ACTIONS(434),
    [anon_sym_bytes30] = ACTIONS(434),
    [anon_sym_bytes31] = ACTIONS(434),
    [anon_sym_bytes32] = ACTIONS(434),
    [anon_sym_fixed] = ACTIONS(434),
    [aux_sym__fixed_token1] = ACTIONS(434),
    [anon_sym_ufixed] = ACTIONS(434),
    [aux_sym__ufixed_token1] = ACTIONS(434),
    [aux_sym__decimal_number_token1] = ACTIONS(434),
    [aux_sym__decimal_number_token2] = ACTIONS(436),
    [aux_sym__hex_number_token1] = ACTIONS(436),
    [anon_sym_hex] = ACTIONS(434),
    [anon_sym_DQUOTE] = ACTIONS(436),
    [anon_sym_SQUOTE] = ACTIONS(436),
    [anon_sym_unicode] = ACTIONS(434),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_identifier] = ACTIONS(438),
    [anon_sym_DASH] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(440),
    [anon_sym_LBRACE] = ACTIONS(440),
    [anon_sym_RBRACE] = ACTIONS(440),
    [anon_sym_type] = ACTIONS(438),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_for] = ACTIONS(438),
    [anon_sym_assembly] = ACTIONS(438),
    [anon_sym_break] = ACTIONS(438),
    [anon_sym_continue] = ACTIONS(438),
    [anon_sym_true] = ACTIONS(438),
    [anon_sym_false] = ACTIONS(438),
    [anon_sym_if] = ACTIONS(438),
    [anon_sym_function] = ACTIONS(438),
    [anon_sym_byte] = ACTIONS(438),
    [anon_sym_address] = ACTIONS(438),
    [anon_sym_return] = ACTIONS(438),
    [anon_sym_revert] = ACTIONS(438),
    [sym_unchecked] = ACTIONS(438),
    [anon_sym_var] = ACTIONS(438),
    [anon_sym_else] = ACTIONS(438),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(438),
    [anon_sym_try] = ACTIONS(438),
    [anon_sym_emit] = ACTIONS(438),
    [anon_sym_payable] = ACTIONS(438),
    [anon_sym_new] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(438),
    [anon_sym_BANG] = ACTIONS(440),
    [anon_sym_delete] = ACTIONS(438),
    [anon_sym_PLUS_PLUS] = ACTIONS(440),
    [anon_sym_DASH_DASH] = ACTIONS(440),
    [anon_sym_mapping] = ACTIONS(438),
    [anon_sym_bool] = ACTIONS(438),
    [anon_sym_string] = ACTIONS(438),
    [anon_sym_int] = ACTIONS(438),
    [anon_sym_int8] = ACTIONS(438),
    [anon_sym_int16] = ACTIONS(438),
    [anon_sym_int24] = ACTIONS(438),
    [anon_sym_int32] = ACTIONS(438),
    [anon_sym_int40] = ACTIONS(438),
    [anon_sym_int48] = ACTIONS(438),
    [anon_sym_int56] = ACTIONS(438),
    [anon_sym_int64] = ACTIONS(438),
    [anon_sym_int72] = ACTIONS(438),
    [anon_sym_int80] = ACTIONS(438),
    [anon_sym_int88] = ACTIONS(438),
    [anon_sym_int96] = ACTIONS(438),
    [anon_sym_int104] = ACTIONS(438),
    [anon_sym_int112] = ACTIONS(438),
    [anon_sym_int120] = ACTIONS(438),
    [anon_sym_int128] = ACTIONS(438),
    [anon_sym_int136] = ACTIONS(438),
    [anon_sym_int144] = ACTIONS(438),
    [anon_sym_int152] = ACTIONS(438),
    [anon_sym_int160] = ACTIONS(438),
    [anon_sym_int168] = ACTIONS(438),
    [anon_sym_int176] = ACTIONS(438),
    [anon_sym_int184] = ACTIONS(438),
    [anon_sym_int192] = ACTIONS(438),
    [anon_sym_int200] = ACTIONS(438),
    [anon_sym_int208] = ACTIONS(438),
    [anon_sym_int216] = ACTIONS(438),
    [anon_sym_int224] = ACTIONS(438),
    [anon_sym_int232] = ACTIONS(438),
    [anon_sym_int240] = ACTIONS(438),
    [anon_sym_int248] = ACTIONS(438),
    [anon_sym_int256] = ACTIONS(438),
    [anon_sym_uint] = ACTIONS(438),
    [anon_sym_uint8] = ACTIONS(438),
    [anon_sym_uint16] = ACTIONS(438),
    [anon_sym_uint24] = ACTIONS(438),
    [anon_sym_uint32] = ACTIONS(438),
    [anon_sym_uint40] = ACTIONS(438),
    [anon_sym_uint48] = ACTIONS(438),
    [anon_sym_uint56] = ACTIONS(438),
    [anon_sym_uint64] = ACTIONS(438),
    [anon_sym_uint72] = ACTIONS(438),
    [anon_sym_uint80] = ACTIONS(438),
    [anon_sym_uint88] = ACTIONS(438),
    [anon_sym_uint96] = ACTIONS(438),
    [anon_sym_uint104] = ACTIONS(438),
    [anon_sym_uint112] = ACTIONS(438),
    [anon_sym_uint120] = ACTIONS(438),
    [anon_sym_uint128] = ACTIONS(438),
    [anon_sym_uint136] = ACTIONS(438),
    [anon_sym_uint144] = ACTIONS(438),
    [anon_sym_uint152] = ACTIONS(438),
    [anon_sym_uint160] = ACTIONS(438),
    [anon_sym_uint168] = ACTIONS(438),
    [anon_sym_uint176] = ACTIONS(438),
    [anon_sym_uint184] = ACTIONS(438),
    [anon_sym_uint192] = ACTIONS(438),
    [anon_sym_uint200] = ACTIONS(438),
    [anon_sym_uint208] = ACTIONS(438),
    [anon_sym_uint216] = ACTIONS(438),
    [anon_sym_uint224] = ACTIONS(438),
    [anon_sym_uint232] = ACTIONS(438),
    [anon_sym_uint240] = ACTIONS(438),
    [anon_sym_uint248] = ACTIONS(438),
    [anon_sym_uint256] = ACTIONS(438),
    [anon_sym_bytes] = ACTIONS(438),
    [anon_sym_bytes1] = ACTIONS(438),
    [anon_sym_bytes2] = ACTIONS(438),
    [anon_sym_bytes3] = ACTIONS(438),
    [anon_sym_bytes4] = ACTIONS(438),
    [anon_sym_bytes5] = ACTIONS(438),
    [anon_sym_bytes6] = ACTIONS(438),
    [anon_sym_bytes7] = ACTIONS(438),
    [anon_sym_bytes8] = ACTIONS(438),
    [anon_sym_bytes9] = ACTIONS(438),
    [anon_sym_bytes10] = ACTIONS(438),
    [anon_sym_bytes11] = ACTIONS(438),
    [anon_sym_bytes12] = ACTIONS(438),
    [anon_sym_bytes13] = ACTIONS(438),
    [anon_sym_bytes14] = ACTIONS(438),
    [anon_sym_bytes15] = ACTIONS(438),
    [anon_sym_bytes16] = ACTIONS(438),
    [anon_sym_bytes17] = ACTIONS(438),
    [anon_sym_bytes18] = ACTIONS(438),
    [anon_sym_bytes19] = ACTIONS(438),
    [anon_sym_bytes20] = ACTIONS(438),
    [anon_sym_bytes21] = ACTIONS(438),
    [anon_sym_bytes22] = ACTIONS(438),
    [anon_sym_bytes23] = ACTIONS(438),
    [anon_sym_bytes24] = ACTIONS(438),
    [anon_sym_bytes25] = ACTIONS(438),
    [anon_sym_bytes26] = ACTIONS(438),
    [anon_sym_bytes27] = ACTIONS(438),
    [anon_sym_bytes28] = ACTIONS(438),
    [anon_sym_bytes29] = ACTIONS(438),
    [anon_sym_bytes30] = ACTIONS(438),
    [anon_sym_bytes31] = ACTIONS(438),
    [anon_sym_bytes32] = ACTIONS(438),
    [anon_sym_fixed] = ACTIONS(438),
    [aux_sym__fixed_token1] = ACTIONS(438),
    [anon_sym_ufixed] = ACTIONS(438),
    [aux_sym__ufixed_token1] = ACTIONS(438),
    [aux_sym__decimal_number_token1] = ACTIONS(438),
    [aux_sym__decimal_number_token2] = ACTIONS(440),
    [aux_sym__hex_number_token1] = ACTIONS(440),
    [anon_sym_hex] = ACTIONS(438),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [anon_sym_SQUOTE] = ACTIONS(440),
    [anon_sym_unicode] = ACTIONS(438),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_identifier] = ACTIONS(442),
    [anon_sym_DASH] = ACTIONS(442),
    [anon_sym_TILDE] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_type] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_for] = ACTIONS(442),
    [anon_sym_assembly] = ACTIONS(442),
    [anon_sym_break] = ACTIONS(442),
    [anon_sym_continue] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(442),
    [anon_sym_false] = ACTIONS(442),
    [anon_sym_if] = ACTIONS(442),
    [anon_sym_function] = ACTIONS(442),
    [anon_sym_byte] = ACTIONS(442),
    [anon_sym_address] = ACTIONS(442),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_revert] = ACTIONS(442),
    [sym_unchecked] = ACTIONS(442),
    [anon_sym_var] = ACTIONS(442),
    [anon_sym_else] = ACTIONS(442),
    [anon_sym_while] = ACTIONS(442),
    [anon_sym_do] = ACTIONS(442),
    [anon_sym_try] = ACTIONS(442),
    [anon_sym_emit] = ACTIONS(442),
    [anon_sym_payable] = ACTIONS(442),
    [anon_sym_new] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_PLUS] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_delete] = ACTIONS(442),
    [anon_sym_PLUS_PLUS] = ACTIONS(444),
    [anon_sym_DASH_DASH] = ACTIONS(444),
    [anon_sym_mapping] = ACTIONS(442),
    [anon_sym_bool] = ACTIONS(442),
    [anon_sym_string] = ACTIONS(442),
    [anon_sym_int] = ACTIONS(442),
    [anon_sym_int8] = ACTIONS(442),
    [anon_sym_int16] = ACTIONS(442),
    [anon_sym_int24] = ACTIONS(442),
    [anon_sym_int32] = ACTIONS(442),
    [anon_sym_int40] = ACTIONS(442),
    [anon_sym_int48] = ACTIONS(442),
    [anon_sym_int56] = ACTIONS(442),
    [anon_sym_int64] = ACTIONS(442),
    [anon_sym_int72] = ACTIONS(442),
    [anon_sym_int80] = ACTIONS(442),
    [anon_sym_int88] = ACTIONS(442),
    [anon_sym_int96] = ACTIONS(442),
    [anon_sym_int104] = ACTIONS(442),
    [anon_sym_int112] = ACTIONS(442),
    [anon_sym_int120] = ACTIONS(442),
    [anon_sym_int128] = ACTIONS(442),
    [anon_sym_int136] = ACTIONS(442),
    [anon_sym_int144] = ACTIONS(442),
    [anon_sym_int152] = ACTIONS(442),
    [anon_sym_int160] = ACTIONS(442),
    [anon_sym_int168] = ACTIONS(442),
    [anon_sym_int176] = ACTIONS(442),
    [anon_sym_int184] = ACTIONS(442),
    [anon_sym_int192] = ACTIONS(442),
    [anon_sym_int200] = ACTIONS(442),
    [anon_sym_int208] = ACTIONS(442),
    [anon_sym_int216] = ACTIONS(442),
    [anon_sym_int224] = ACTIONS(442),
    [anon_sym_int232] = ACTIONS(442),
    [anon_sym_int240] = ACTIONS(442),
    [anon_sym_int248] = ACTIONS(442),
    [anon_sym_int256] = ACTIONS(442),
    [anon_sym_uint] = ACTIONS(442),
    [anon_sym_uint8] = ACTIONS(442),
    [anon_sym_uint16] = ACTIONS(442),
    [anon_sym_uint24] = ACTIONS(442),
    [anon_sym_uint32] = ACTIONS(442),
    [anon_sym_uint40] = ACTIONS(442),
    [anon_sym_uint48] = ACTIONS(442),
    [anon_sym_uint56] = ACTIONS(442),
    [anon_sym_uint64] = ACTIONS(442),
    [anon_sym_uint72] = ACTIONS(442),
    [anon_sym_uint80] = ACTIONS(442),
    [anon_sym_uint88] = ACTIONS(442),
    [anon_sym_uint96] = ACTIONS(442),
    [anon_sym_uint104] = ACTIONS(442),
    [anon_sym_uint112] = ACTIONS(442),
    [anon_sym_uint120] = ACTIONS(442),
    [anon_sym_uint128] = ACTIONS(442),
    [anon_sym_uint136] = ACTIONS(442),
    [anon_sym_uint144] = ACTIONS(442),
    [anon_sym_uint152] = ACTIONS(442),
    [anon_sym_uint160] = ACTIONS(442),
    [anon_sym_uint168] = ACTIONS(442),
    [anon_sym_uint176] = ACTIONS(442),
    [anon_sym_uint184] = ACTIONS(442),
    [anon_sym_uint192] = ACTIONS(442),
    [anon_sym_uint200] = ACTIONS(442),
    [anon_sym_uint208] = ACTIONS(442),
    [anon_sym_uint216] = ACTIONS(442),
    [anon_sym_uint224] = ACTIONS(442),
    [anon_sym_uint232] = ACTIONS(442),
    [anon_sym_uint240] = ACTIONS(442),
    [anon_sym_uint248] = ACTIONS(442),
    [anon_sym_uint256] = ACTIONS(442),
    [anon_sym_bytes] = ACTIONS(442),
    [anon_sym_bytes1] = ACTIONS(442),
    [anon_sym_bytes2] = ACTIONS(442),
    [anon_sym_bytes3] = ACTIONS(442),
    [anon_sym_bytes4] = ACTIONS(442),
    [anon_sym_bytes5] = ACTIONS(442),
    [anon_sym_bytes6] = ACTIONS(442),
    [anon_sym_bytes7] = ACTIONS(442),
    [anon_sym_bytes8] = ACTIONS(442),
    [anon_sym_bytes9] = ACTIONS(442),
    [anon_sym_bytes10] = ACTIONS(442),
    [anon_sym_bytes11] = ACTIONS(442),
    [anon_sym_bytes12] = ACTIONS(442),
    [anon_sym_bytes13] = ACTIONS(442),
    [anon_sym_bytes14] = ACTIONS(442),
    [anon_sym_bytes15] = ACTIONS(442),
    [anon_sym_bytes16] = ACTIONS(442),
    [anon_sym_bytes17] = ACTIONS(442),
    [anon_sym_bytes18] = ACTIONS(442),
    [anon_sym_bytes19] = ACTIONS(442),
    [anon_sym_bytes20] = ACTIONS(442),
    [anon_sym_bytes21] = ACTIONS(442),
    [anon_sym_bytes22] = ACTIONS(442),
    [anon_sym_bytes23] = ACTIONS(442),
    [anon_sym_bytes24] = ACTIONS(442),
    [anon_sym_bytes25] = ACTIONS(442),
    [anon_sym_bytes26] = ACTIONS(442),
    [anon_sym_bytes27] = ACTIONS(442),
    [anon_sym_bytes28] = ACTIONS(442),
    [anon_sym_bytes29] = ACTIONS(442),
    [anon_sym_bytes30] = ACTIONS(442),
    [anon_sym_bytes31] = ACTIONS(442),
    [anon_sym_bytes32] = ACTIONS(442),
    [anon_sym_fixed] = ACTIONS(442),
    [aux_sym__fixed_token1] = ACTIONS(442),
    [anon_sym_ufixed] = ACTIONS(442),
    [aux_sym__ufixed_token1] = ACTIONS(442),
    [aux_sym__decimal_number_token1] = ACTIONS(442),
    [aux_sym__decimal_number_token2] = ACTIONS(444),
    [aux_sym__hex_number_token1] = ACTIONS(444),
    [anon_sym_hex] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [anon_sym_SQUOTE] = ACTIONS(444),
    [anon_sym_unicode] = ACTIONS(442),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_identifier] = ACTIONS(446),
    [anon_sym_DASH] = ACTIONS(446),
    [anon_sym_TILDE] = ACTIONS(448),
    [anon_sym_LBRACE] = ACTIONS(448),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_type] = ACTIONS(446),
    [anon_sym_LPAREN] = ACTIONS(448),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_assembly] = ACTIONS(446),
    [anon_sym_break] = ACTIONS(446),
    [anon_sym_continue] = ACTIONS(446),
    [anon_sym_true] = ACTIONS(446),
    [anon_sym_false] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_function] = ACTIONS(446),
    [anon_sym_byte] = ACTIONS(446),
    [anon_sym_address] = ACTIONS(446),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_revert] = ACTIONS(446),
    [sym_unchecked] = ACTIONS(446),
    [anon_sym_var] = ACTIONS(446),
    [anon_sym_else] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(446),
    [anon_sym_do] = ACTIONS(446),
    [anon_sym_try] = ACTIONS(446),
    [anon_sym_emit] = ACTIONS(446),
    [anon_sym_payable] = ACTIONS(446),
    [anon_sym_new] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(448),
    [anon_sym_PLUS] = ACTIONS(446),
    [anon_sym_BANG] = ACTIONS(448),
    [anon_sym_delete] = ACTIONS(446),
    [anon_sym_PLUS_PLUS] = ACTIONS(448),
    [anon_sym_DASH_DASH] = ACTIONS(448),
    [anon_sym_mapping] = ACTIONS(446),
    [anon_sym_bool] = ACTIONS(446),
    [anon_sym_string] = ACTIONS(446),
    [anon_sym_int] = ACTIONS(446),
    [anon_sym_int8] = ACTIONS(446),
    [anon_sym_int16] = ACTIONS(446),
    [anon_sym_int24] = ACTIONS(446),
    [anon_sym_int32] = ACTIONS(446),
    [anon_sym_int40] = ACTIONS(446),
    [anon_sym_int48] = ACTIONS(446),
    [anon_sym_int56] = ACTIONS(446),
    [anon_sym_int64] = ACTIONS(446),
    [anon_sym_int72] = ACTIONS(446),
    [anon_sym_int80] = ACTIONS(446),
    [anon_sym_int88] = ACTIONS(446),
    [anon_sym_int96] = ACTIONS(446),
    [anon_sym_int104] = ACTIONS(446),
    [anon_sym_int112] = ACTIONS(446),
    [anon_sym_int120] = ACTIONS(446),
    [anon_sym_int128] = ACTIONS(446),
    [anon_sym_int136] = ACTIONS(446),
    [anon_sym_int144] = ACTIONS(446),
    [anon_sym_int152] = ACTIONS(446),
    [anon_sym_int160] = ACTIONS(446),
    [anon_sym_int168] = ACTIONS(446),
    [anon_sym_int176] = ACTIONS(446),
    [anon_sym_int184] = ACTIONS(446),
    [anon_sym_int192] = ACTIONS(446),
    [anon_sym_int200] = ACTIONS(446),
    [anon_sym_int208] = ACTIONS(446),
    [anon_sym_int216] = ACTIONS(446),
    [anon_sym_int224] = ACTIONS(446),
    [anon_sym_int232] = ACTIONS(446),
    [anon_sym_int240] = ACTIONS(446),
    [anon_sym_int248] = ACTIONS(446),
    [anon_sym_int256] = ACTIONS(446),
    [anon_sym_uint] = ACTIONS(446),
    [anon_sym_uint8] = ACTIONS(446),
    [anon_sym_uint16] = ACTIONS(446),
    [anon_sym_uint24] = ACTIONS(446),
    [anon_sym_uint32] = ACTIONS(446),
    [anon_sym_uint40] = ACTIONS(446),
    [anon_sym_uint48] = ACTIONS(446),
    [anon_sym_uint56] = ACTIONS(446),
    [anon_sym_uint64] = ACTIONS(446),
    [anon_sym_uint72] = ACTIONS(446),
    [anon_sym_uint80] = ACTIONS(446),
    [anon_sym_uint88] = ACTIONS(446),
    [anon_sym_uint96] = ACTIONS(446),
    [anon_sym_uint104] = ACTIONS(446),
    [anon_sym_uint112] = ACTIONS(446),
    [anon_sym_uint120] = ACTIONS(446),
    [anon_sym_uint128] = ACTIONS(446),
    [anon_sym_uint136] = ACTIONS(446),
    [anon_sym_uint144] = ACTIONS(446),
    [anon_sym_uint152] = ACTIONS(446),
    [anon_sym_uint160] = ACTIONS(446),
    [anon_sym_uint168] = ACTIONS(446),
    [anon_sym_uint176] = ACTIONS(446),
    [anon_sym_uint184] = ACTIONS(446),
    [anon_sym_uint192] = ACTIONS(446),
    [anon_sym_uint200] = ACTIONS(446),
    [anon_sym_uint208] = ACTIONS(446),
    [anon_sym_uint216] = ACTIONS(446),
    [anon_sym_uint224] = ACTIONS(446),
    [anon_sym_uint232] = ACTIONS(446),
    [anon_sym_uint240] = ACTIONS(446),
    [anon_sym_uint248] = ACTIONS(446),
    [anon_sym_uint256] = ACTIONS(446),
    [anon_sym_bytes] = ACTIONS(446),
    [anon_sym_bytes1] = ACTIONS(446),
    [anon_sym_bytes2] = ACTIONS(446),
    [anon_sym_bytes3] = ACTIONS(446),
    [anon_sym_bytes4] = ACTIONS(446),
    [anon_sym_bytes5] = ACTIONS(446),
    [anon_sym_bytes6] = ACTIONS(446),
    [anon_sym_bytes7] = ACTIONS(446),
    [anon_sym_bytes8] = ACTIONS(446),
    [anon_sym_bytes9] = ACTIONS(446),
    [anon_sym_bytes10] = ACTIONS(446),
    [anon_sym_bytes11] = ACTIONS(446),
    [anon_sym_bytes12] = ACTIONS(446),
    [anon_sym_bytes13] = ACTIONS(446),
    [anon_sym_bytes14] = ACTIONS(446),
    [anon_sym_bytes15] = ACTIONS(446),
    [anon_sym_bytes16] = ACTIONS(446),
    [anon_sym_bytes17] = ACTIONS(446),
    [anon_sym_bytes18] = ACTIONS(446),
    [anon_sym_bytes19] = ACTIONS(446),
    [anon_sym_bytes20] = ACTIONS(446),
    [anon_sym_bytes21] = ACTIONS(446),
    [anon_sym_bytes22] = ACTIONS(446),
    [anon_sym_bytes23] = ACTIONS(446),
    [anon_sym_bytes24] = ACTIONS(446),
    [anon_sym_bytes25] = ACTIONS(446),
    [anon_sym_bytes26] = ACTIONS(446),
    [anon_sym_bytes27] = ACTIONS(446),
    [anon_sym_bytes28] = ACTIONS(446),
    [anon_sym_bytes29] = ACTIONS(446),
    [anon_sym_bytes30] = ACTIONS(446),
    [anon_sym_bytes31] = ACTIONS(446),
    [anon_sym_bytes32] = ACTIONS(446),
    [anon_sym_fixed] = ACTIONS(446),
    [aux_sym__fixed_token1] = ACTIONS(446),
    [anon_sym_ufixed] = ACTIONS(446),
    [aux_sym__ufixed_token1] = ACTIONS(446),
    [aux_sym__decimal_number_token1] = ACTIONS(446),
    [aux_sym__decimal_number_token2] = ACTIONS(448),
    [aux_sym__hex_number_token1] = ACTIONS(448),
    [anon_sym_hex] = ACTIONS(446),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(448),
    [anon_sym_unicode] = ACTIONS(446),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(450),
    [anon_sym_DASH] = ACTIONS(450),
    [anon_sym_TILDE] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(452),
    [anon_sym_RBRACE] = ACTIONS(452),
    [anon_sym_type] = ACTIONS(450),
    [anon_sym_LPAREN] = ACTIONS(452),
    [anon_sym_for] = ACTIONS(450),
    [anon_sym_assembly] = ACTIONS(450),
    [anon_sym_break] = ACTIONS(450),
    [anon_sym_continue] = ACTIONS(450),
    [anon_sym_true] = ACTIONS(450),
    [anon_sym_false] = ACTIONS(450),
    [anon_sym_if] = ACTIONS(450),
    [anon_sym_function] = ACTIONS(450),
    [anon_sym_byte] = ACTIONS(450),
    [anon_sym_address] = ACTIONS(450),
    [anon_sym_return] = ACTIONS(450),
    [anon_sym_revert] = ACTIONS(450),
    [sym_unchecked] = ACTIONS(450),
    [anon_sym_var] = ACTIONS(450),
    [anon_sym_else] = ACTIONS(454),
    [anon_sym_while] = ACTIONS(450),
    [anon_sym_do] = ACTIONS(450),
    [anon_sym_try] = ACTIONS(450),
    [anon_sym_emit] = ACTIONS(450),
    [anon_sym_payable] = ACTIONS(450),
    [anon_sym_new] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(452),
    [anon_sym_PLUS] = ACTIONS(450),
    [anon_sym_BANG] = ACTIONS(452),
    [anon_sym_delete] = ACTIONS(450),
    [anon_sym_PLUS_PLUS] = ACTIONS(452),
    [anon_sym_DASH_DASH] = ACTIONS(452),
    [anon_sym_mapping] = ACTIONS(450),
    [anon_sym_bool] = ACTIONS(450),
    [anon_sym_string] = ACTIONS(450),
    [anon_sym_int] = ACTIONS(450),
    [anon_sym_int8] = ACTIONS(450),
    [anon_sym_int16] = ACTIONS(450),
    [anon_sym_int24] = ACTIONS(450),
    [anon_sym_int32] = ACTIONS(450),
    [anon_sym_int40] = ACTIONS(450),
    [anon_sym_int48] = ACTIONS(450),
    [anon_sym_int56] = ACTIONS(450),
    [anon_sym_int64] = ACTIONS(450),
    [anon_sym_int72] = ACTIONS(450),
    [anon_sym_int80] = ACTIONS(450),
    [anon_sym_int88] = ACTIONS(450),
    [anon_sym_int96] = ACTIONS(450),
    [anon_sym_int104] = ACTIONS(450),
    [anon_sym_int112] = ACTIONS(450),
    [anon_sym_int120] = ACTIONS(450),
    [anon_sym_int128] = ACTIONS(450),
    [anon_sym_int136] = ACTIONS(450),
    [anon_sym_int144] = ACTIONS(450),
    [anon_sym_int152] = ACTIONS(450),
    [anon_sym_int160] = ACTIONS(450),
    [anon_sym_int168] = ACTIONS(450),
    [anon_sym_int176] = ACTIONS(450),
    [anon_sym_int184] = ACTIONS(450),
    [anon_sym_int192] = ACTIONS(450),
    [anon_sym_int200] = ACTIONS(450),
    [anon_sym_int208] = ACTIONS(450),
    [anon_sym_int216] = ACTIONS(450),
    [anon_sym_int224] = ACTIONS(450),
    [anon_sym_int232] = ACTIONS(450),
    [anon_sym_int240] = ACTIONS(450),
    [anon_sym_int248] = ACTIONS(450),
    [anon_sym_int256] = ACTIONS(450),
    [anon_sym_uint] = ACTIONS(450),
    [anon_sym_uint8] = ACTIONS(450),
    [anon_sym_uint16] = ACTIONS(450),
    [anon_sym_uint24] = ACTIONS(450),
    [anon_sym_uint32] = ACTIONS(450),
    [anon_sym_uint40] = ACTIONS(450),
    [anon_sym_uint48] = ACTIONS(450),
    [anon_sym_uint56] = ACTIONS(450),
    [anon_sym_uint64] = ACTIONS(450),
    [anon_sym_uint72] = ACTIONS(450),
    [anon_sym_uint80] = ACTIONS(450),
    [anon_sym_uint88] = ACTIONS(450),
    [anon_sym_uint96] = ACTIONS(450),
    [anon_sym_uint104] = ACTIONS(450),
    [anon_sym_uint112] = ACTIONS(450),
    [anon_sym_uint120] = ACTIONS(450),
    [anon_sym_uint128] = ACTIONS(450),
    [anon_sym_uint136] = ACTIONS(450),
    [anon_sym_uint144] = ACTIONS(450),
    [anon_sym_uint152] = ACTIONS(450),
    [anon_sym_uint160] = ACTIONS(450),
    [anon_sym_uint168] = ACTIONS(450),
    [anon_sym_uint176] = ACTIONS(450),
    [anon_sym_uint184] = ACTIONS(450),
    [anon_sym_uint192] = ACTIONS(450),
    [anon_sym_uint200] = ACTIONS(450),
    [anon_sym_uint208] = ACTIONS(450),
    [anon_sym_uint216] = ACTIONS(450),
    [anon_sym_uint224] = ACTIONS(450),
    [anon_sym_uint232] = ACTIONS(450),
    [anon_sym_uint240] = ACTIONS(450),
    [anon_sym_uint248] = ACTIONS(450),
    [anon_sym_uint256] = ACTIONS(450),
    [anon_sym_bytes] = ACTIONS(450),
    [anon_sym_bytes1] = ACTIONS(450),
    [anon_sym_bytes2] = ACTIONS(450),
    [anon_sym_bytes3] = ACTIONS(450),
    [anon_sym_bytes4] = ACTIONS(450),
    [anon_sym_bytes5] = ACTIONS(450),
    [anon_sym_bytes6] = ACTIONS(450),
    [anon_sym_bytes7] = ACTIONS(450),
    [anon_sym_bytes8] = ACTIONS(450),
    [anon_sym_bytes9] = ACTIONS(450),
    [anon_sym_bytes10] = ACTIONS(450),
    [anon_sym_bytes11] = ACTIONS(450),
    [anon_sym_bytes12] = ACTIONS(450),
    [anon_sym_bytes13] = ACTIONS(450),
    [anon_sym_bytes14] = ACTIONS(450),
    [anon_sym_bytes15] = ACTIONS(450),
    [anon_sym_bytes16] = ACTIONS(450),
    [anon_sym_bytes17] = ACTIONS(450),
    [anon_sym_bytes18] = ACTIONS(450),
    [anon_sym_bytes19] = ACTIONS(450),
    [anon_sym_bytes20] = ACTIONS(450),
    [anon_sym_bytes21] = ACTIONS(450),
    [anon_sym_bytes22] = ACTIONS(450),
    [anon_sym_bytes23] = ACTIONS(450),
    [anon_sym_bytes24] = ACTIONS(450),
    [anon_sym_bytes25] = ACTIONS(450),
    [anon_sym_bytes26] = ACTIONS(450),
    [anon_sym_bytes27] = ACTIONS(450),
    [anon_sym_bytes28] = ACTIONS(450),
    [anon_sym_bytes29] = ACTIONS(450),
    [anon_sym_bytes30] = ACTIONS(450),
    [anon_sym_bytes31] = ACTIONS(450),
    [anon_sym_bytes32] = ACTIONS(450),
    [anon_sym_fixed] = ACTIONS(450),
    [aux_sym__fixed_token1] = ACTIONS(450),
    [anon_sym_ufixed] = ACTIONS(450),
    [aux_sym__ufixed_token1] = ACTIONS(450),
    [aux_sym__decimal_number_token1] = ACTIONS(450),
    [aux_sym__decimal_number_token2] = ACTIONS(452),
    [aux_sym__hex_number_token1] = ACTIONS(452),
    [anon_sym_hex] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [anon_sym_SQUOTE] = ACTIONS(452),
    [anon_sym_unicode] = ACTIONS(450),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_TILDE] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(458),
    [anon_sym_RBRACE] = ACTIONS(458),
    [anon_sym_type] = ACTIONS(456),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_for] = ACTIONS(456),
    [anon_sym_assembly] = ACTIONS(456),
    [anon_sym_break] = ACTIONS(456),
    [anon_sym_continue] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(456),
    [anon_sym_false] = ACTIONS(456),
    [anon_sym_if] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(456),
    [anon_sym_byte] = ACTIONS(456),
    [anon_sym_address] = ACTIONS(456),
    [anon_sym_return] = ACTIONS(456),
    [anon_sym_revert] = ACTIONS(456),
    [sym_unchecked] = ACTIONS(456),
    [anon_sym_var] = ACTIONS(456),
    [anon_sym_else] = ACTIONS(456),
    [anon_sym_while] = ACTIONS(456),
    [anon_sym_do] = ACTIONS(456),
    [anon_sym_try] = ACTIONS(456),
    [anon_sym_emit] = ACTIONS(456),
    [anon_sym_payable] = ACTIONS(456),
    [anon_sym_new] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_delete] = ACTIONS(456),
    [anon_sym_PLUS_PLUS] = ACTIONS(458),
    [anon_sym_DASH_DASH] = ACTIONS(458),
    [anon_sym_mapping] = ACTIONS(456),
    [anon_sym_bool] = ACTIONS(456),
    [anon_sym_string] = ACTIONS(456),
    [anon_sym_int] = ACTIONS(456),
    [anon_sym_int8] = ACTIONS(456),
    [anon_sym_int16] = ACTIONS(456),
    [anon_sym_int24] = ACTIONS(456),
    [anon_sym_int32] = ACTIONS(456),
    [anon_sym_int40] = ACTIONS(456),
    [anon_sym_int48] = ACTIONS(456),
    [anon_sym_int56] = ACTIONS(456),
    [anon_sym_int64] = ACTIONS(456),
    [anon_sym_int72] = ACTIONS(456),
    [anon_sym_int80] = ACTIONS(456),
    [anon_sym_int88] = ACTIONS(456),
    [anon_sym_int96] = ACTIONS(456),
    [anon_sym_int104] = ACTIONS(456),
    [anon_sym_int112] = ACTIONS(456),
    [anon_sym_int120] = ACTIONS(456),
    [anon_sym_int128] = ACTIONS(456),
    [anon_sym_int136] = ACTIONS(456),
    [anon_sym_int144] = ACTIONS(456),
    [anon_sym_int152] = ACTIONS(456),
    [anon_sym_int160] = ACTIONS(456),
    [anon_sym_int168] = ACTIONS(456),
    [anon_sym_int176] = ACTIONS(456),
    [anon_sym_int184] = ACTIONS(456),
    [anon_sym_int192] = ACTIONS(456),
    [anon_sym_int200] = ACTIONS(456),
    [anon_sym_int208] = ACTIONS(456),
    [anon_sym_int216] = ACTIONS(456),
    [anon_sym_int224] = ACTIONS(456),
    [anon_sym_int232] = ACTIONS(456),
    [anon_sym_int240] = ACTIONS(456),
    [anon_sym_int248] = ACTIONS(456),
    [anon_sym_int256] = ACTIONS(456),
    [anon_sym_uint] = ACTIONS(456),
    [anon_sym_uint8] = ACTIONS(456),
    [anon_sym_uint16] = ACTIONS(456),
    [anon_sym_uint24] = ACTIONS(456),
    [anon_sym_uint32] = ACTIONS(456),
    [anon_sym_uint40] = ACTIONS(456),
    [anon_sym_uint48] = ACTIONS(456),
    [anon_sym_uint56] = ACTIONS(456),
    [anon_sym_uint64] = ACTIONS(456),
    [anon_sym_uint72] = ACTIONS(456),
    [anon_sym_uint80] = ACTIONS(456),
    [anon_sym_uint88] = ACTIONS(456),
    [anon_sym_uint96] = ACTIONS(456),
    [anon_sym_uint104] = ACTIONS(456),
    [anon_sym_uint112] = ACTIONS(456),
    [anon_sym_uint120] = ACTIONS(456),
    [anon_sym_uint128] = ACTIONS(456),
    [anon_sym_uint136] = ACTIONS(456),
    [anon_sym_uint144] = ACTIONS(456),
    [anon_sym_uint152] = ACTIONS(456),
    [anon_sym_uint160] = ACTIONS(456),
    [anon_sym_uint168] = ACTIONS(456),
    [anon_sym_uint176] = ACTIONS(456),
    [anon_sym_uint184] = ACTIONS(456),
    [anon_sym_uint192] = ACTIONS(456),
    [anon_sym_uint200] = ACTIONS(456),
    [anon_sym_uint208] = ACTIONS(456),
    [anon_sym_uint216] = ACTIONS(456),
    [anon_sym_uint224] = ACTIONS(456),
    [anon_sym_uint232] = ACTIONS(456),
    [anon_sym_uint240] = ACTIONS(456),
    [anon_sym_uint248] = ACTIONS(456),
    [anon_sym_uint256] = ACTIONS(456),
    [anon_sym_bytes] = ACTIONS(456),
    [anon_sym_bytes1] = ACTIONS(456),
    [anon_sym_bytes2] = ACTIONS(456),
    [anon_sym_bytes3] = ACTIONS(456),
    [anon_sym_bytes4] = ACTIONS(456),
    [anon_sym_bytes5] = ACTIONS(456),
    [anon_sym_bytes6] = ACTIONS(456),
    [anon_sym_bytes7] = ACTIONS(456),
    [anon_sym_bytes8] = ACTIONS(456),
    [anon_sym_bytes9] = ACTIONS(456),
    [anon_sym_bytes10] = ACTIONS(456),
    [anon_sym_bytes11] = ACTIONS(456),
    [anon_sym_bytes12] = ACTIONS(456),
    [anon_sym_bytes13] = ACTIONS(456),
    [anon_sym_bytes14] = ACTIONS(456),
    [anon_sym_bytes15] = ACTIONS(456),
    [anon_sym_bytes16] = ACTIONS(456),
    [anon_sym_bytes17] = ACTIONS(456),
    [anon_sym_bytes18] = ACTIONS(456),
    [anon_sym_bytes19] = ACTIONS(456),
    [anon_sym_bytes20] = ACTIONS(456),
    [anon_sym_bytes21] = ACTIONS(456),
    [anon_sym_bytes22] = ACTIONS(456),
    [anon_sym_bytes23] = ACTIONS(456),
    [anon_sym_bytes24] = ACTIONS(456),
    [anon_sym_bytes25] = ACTIONS(456),
    [anon_sym_bytes26] = ACTIONS(456),
    [anon_sym_bytes27] = ACTIONS(456),
    [anon_sym_bytes28] = ACTIONS(456),
    [anon_sym_bytes29] = ACTIONS(456),
    [anon_sym_bytes30] = ACTIONS(456),
    [anon_sym_bytes31] = ACTIONS(456),
    [anon_sym_bytes32] = ACTIONS(456),
    [anon_sym_fixed] = ACTIONS(456),
    [aux_sym__fixed_token1] = ACTIONS(456),
    [anon_sym_ufixed] = ACTIONS(456),
    [aux_sym__ufixed_token1] = ACTIONS(456),
    [aux_sym__decimal_number_token1] = ACTIONS(456),
    [aux_sym__decimal_number_token2] = ACTIONS(458),
    [aux_sym__hex_number_token1] = ACTIONS(458),
    [anon_sym_hex] = ACTIONS(456),
    [anon_sym_DQUOTE] = ACTIONS(458),
    [anon_sym_SQUOTE] = ACTIONS(458),
    [anon_sym_unicode] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(460),
    [anon_sym_DASH] = ACTIONS(460),
    [anon_sym_TILDE] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(462),
    [anon_sym_RBRACE] = ACTIONS(462),
    [anon_sym_type] = ACTIONS(460),
    [anon_sym_LPAREN] = ACTIONS(462),
    [anon_sym_for] = ACTIONS(460),
    [anon_sym_assembly] = ACTIONS(460),
    [anon_sym_break] = ACTIONS(460),
    [anon_sym_continue] = ACTIONS(460),
    [anon_sym_true] = ACTIONS(460),
    [anon_sym_false] = ACTIONS(460),
    [anon_sym_if] = ACTIONS(460),
    [anon_sym_function] = ACTIONS(460),
    [anon_sym_byte] = ACTIONS(460),
    [anon_sym_address] = ACTIONS(460),
    [anon_sym_return] = ACTIONS(460),
    [anon_sym_revert] = ACTIONS(460),
    [sym_unchecked] = ACTIONS(460),
    [anon_sym_var] = ACTIONS(460),
    [anon_sym_else] = ACTIONS(460),
    [anon_sym_while] = ACTIONS(460),
    [anon_sym_do] = ACTIONS(460),
    [anon_sym_try] = ACTIONS(460),
    [anon_sym_emit] = ACTIONS(460),
    [anon_sym_payable] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(460),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_PLUS] = ACTIONS(460),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_delete] = ACTIONS(460),
    [anon_sym_PLUS_PLUS] = ACTIONS(462),
    [anon_sym_DASH_DASH] = ACTIONS(462),
    [anon_sym_mapping] = ACTIONS(460),
    [anon_sym_bool] = ACTIONS(460),
    [anon_sym_string] = ACTIONS(460),
    [anon_sym_int] = ACTIONS(460),
    [anon_sym_int8] = ACTIONS(460),
    [anon_sym_int16] = ACTIONS(460),
    [anon_sym_int24] = ACTIONS(460),
    [anon_sym_int32] = ACTIONS(460),
    [anon_sym_int40] = ACTIONS(460),
    [anon_sym_int48] = ACTIONS(460),
    [anon_sym_int56] = ACTIONS(460),
    [anon_sym_int64] = ACTIONS(460),
    [anon_sym_int72] = ACTIONS(460),
    [anon_sym_int80] = ACTIONS(460),
    [anon_sym_int88] = ACTIONS(460),
    [anon_sym_int96] = ACTIONS(460),
    [anon_sym_int104] = ACTIONS(460),
    [anon_sym_int112] = ACTIONS(460),
    [anon_sym_int120] = ACTIONS(460),
    [anon_sym_int128] = ACTIONS(460),
    [anon_sym_int136] = ACTIONS(460),
    [anon_sym_int144] = ACTIONS(460),
    [anon_sym_int152] = ACTIONS(460),
    [anon_sym_int160] = ACTIONS(460),
    [anon_sym_int168] = ACTIONS(460),
    [anon_sym_int176] = ACTIONS(460),
    [anon_sym_int184] = ACTIONS(460),
    [anon_sym_int192] = ACTIONS(460),
    [anon_sym_int200] = ACTIONS(460),
    [anon_sym_int208] = ACTIONS(460),
    [anon_sym_int216] = ACTIONS(460),
    [anon_sym_int224] = ACTIONS(460),
    [anon_sym_int232] = ACTIONS(460),
    [anon_sym_int240] = ACTIONS(460),
    [anon_sym_int248] = ACTIONS(460),
    [anon_sym_int256] = ACTIONS(460),
    [anon_sym_uint] = ACTIONS(460),
    [anon_sym_uint8] = ACTIONS(460),
    [anon_sym_uint16] = ACTIONS(460),
    [anon_sym_uint24] = ACTIONS(460),
    [anon_sym_uint32] = ACTIONS(460),
    [anon_sym_uint40] = ACTIONS(460),
    [anon_sym_uint48] = ACTIONS(460),
    [anon_sym_uint56] = ACTIONS(460),
    [anon_sym_uint64] = ACTIONS(460),
    [anon_sym_uint72] = ACTIONS(460),
    [anon_sym_uint80] = ACTIONS(460),
    [anon_sym_uint88] = ACTIONS(460),
    [anon_sym_uint96] = ACTIONS(460),
    [anon_sym_uint104] = ACTIONS(460),
    [anon_sym_uint112] = ACTIONS(460),
    [anon_sym_uint120] = ACTIONS(460),
    [anon_sym_uint128] = ACTIONS(460),
    [anon_sym_uint136] = ACTIONS(460),
    [anon_sym_uint144] = ACTIONS(460),
    [anon_sym_uint152] = ACTIONS(460),
    [anon_sym_uint160] = ACTIONS(460),
    [anon_sym_uint168] = ACTIONS(460),
    [anon_sym_uint176] = ACTIONS(460),
    [anon_sym_uint184] = ACTIONS(460),
    [anon_sym_uint192] = ACTIONS(460),
    [anon_sym_uint200] = ACTIONS(460),
    [anon_sym_uint208] = ACTIONS(460),
    [anon_sym_uint216] = ACTIONS(460),
    [anon_sym_uint224] = ACTIONS(460),
    [anon_sym_uint232] = ACTIONS(460),
    [anon_sym_uint240] = ACTIONS(460),
    [anon_sym_uint248] = ACTIONS(460),
    [anon_sym_uint256] = ACTIONS(460),
    [anon_sym_bytes] = ACTIONS(460),
    [anon_sym_bytes1] = ACTIONS(460),
    [anon_sym_bytes2] = ACTIONS(460),
    [anon_sym_bytes3] = ACTIONS(460),
    [anon_sym_bytes4] = ACTIONS(460),
    [anon_sym_bytes5] = ACTIONS(460),
    [anon_sym_bytes6] = ACTIONS(460),
    [anon_sym_bytes7] = ACTIONS(460),
    [anon_sym_bytes8] = ACTIONS(460),
    [anon_sym_bytes9] = ACTIONS(460),
    [anon_sym_bytes10] = ACTIONS(460),
    [anon_sym_bytes11] = ACTIONS(460),
    [anon_sym_bytes12] = ACTIONS(460),
    [anon_sym_bytes13] = ACTIONS(460),
    [anon_sym_bytes14] = ACTIONS(460),
    [anon_sym_bytes15] = ACTIONS(460),
    [anon_sym_bytes16] = ACTIONS(460),
    [anon_sym_bytes17] = ACTIONS(460),
    [anon_sym_bytes18] = ACTIONS(460),
    [anon_sym_bytes19] = ACTIONS(460),
    [anon_sym_bytes20] = ACTIONS(460),
    [anon_sym_bytes21] = ACTIONS(460),
    [anon_sym_bytes22] = ACTIONS(460),
    [anon_sym_bytes23] = ACTIONS(460),
    [anon_sym_bytes24] = ACTIONS(460),
    [anon_sym_bytes25] = ACTIONS(460),
    [anon_sym_bytes26] = ACTIONS(460),
    [anon_sym_bytes27] = ACTIONS(460),
    [anon_sym_bytes28] = ACTIONS(460),
    [anon_sym_bytes29] = ACTIONS(460),
    [anon_sym_bytes30] = ACTIONS(460),
    [anon_sym_bytes31] = ACTIONS(460),
    [anon_sym_bytes32] = ACTIONS(460),
    [anon_sym_fixed] = ACTIONS(460),
    [aux_sym__fixed_token1] = ACTIONS(460),
    [anon_sym_ufixed] = ACTIONS(460),
    [aux_sym__ufixed_token1] = ACTIONS(460),
    [aux_sym__decimal_number_token1] = ACTIONS(460),
    [aux_sym__decimal_number_token2] = ACTIONS(462),
    [aux_sym__hex_number_token1] = ACTIONS(462),
    [anon_sym_hex] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(462),
    [anon_sym_SQUOTE] = ACTIONS(462),
    [anon_sym_unicode] = ACTIONS(460),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(464),
    [anon_sym_DASH] = ACTIONS(464),
    [anon_sym_TILDE] = ACTIONS(466),
    [anon_sym_LBRACE] = ACTIONS(466),
    [anon_sym_RBRACE] = ACTIONS(466),
    [anon_sym_type] = ACTIONS(464),
    [anon_sym_LPAREN] = ACTIONS(466),
    [anon_sym_for] = ACTIONS(464),
    [anon_sym_assembly] = ACTIONS(464),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_continue] = ACTIONS(464),
    [anon_sym_true] = ACTIONS(464),
    [anon_sym_false] = ACTIONS(464),
    [anon_sym_if] = ACTIONS(464),
    [anon_sym_function] = ACTIONS(464),
    [anon_sym_byte] = ACTIONS(464),
    [anon_sym_address] = ACTIONS(464),
    [anon_sym_return] = ACTIONS(464),
    [anon_sym_revert] = ACTIONS(464),
    [sym_unchecked] = ACTIONS(464),
    [anon_sym_var] = ACTIONS(464),
    [anon_sym_else] = ACTIONS(464),
    [anon_sym_while] = ACTIONS(464),
    [anon_sym_do] = ACTIONS(464),
    [anon_sym_try] = ACTIONS(464),
    [anon_sym_emit] = ACTIONS(464),
    [anon_sym_payable] = ACTIONS(464),
    [anon_sym_new] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(466),
    [anon_sym_PLUS] = ACTIONS(464),
    [anon_sym_BANG] = ACTIONS(466),
    [anon_sym_delete] = ACTIONS(464),
    [anon_sym_PLUS_PLUS] = ACTIONS(466),
    [anon_sym_DASH_DASH] = ACTIONS(466),
    [anon_sym_mapping] = ACTIONS(464),
    [anon_sym_bool] = ACTIONS(464),
    [anon_sym_string] = ACTIONS(464),
    [anon_sym_int] = ACTIONS(464),
    [anon_sym_int8] = ACTIONS(464),
    [anon_sym_int16] = ACTIONS(464),
    [anon_sym_int24] = ACTIONS(464),
    [anon_sym_int32] = ACTIONS(464),
    [anon_sym_int40] = ACTIONS(464),
    [anon_sym_int48] = ACTIONS(464),
    [anon_sym_int56] = ACTIONS(464),
    [anon_sym_int64] = ACTIONS(464),
    [anon_sym_int72] = ACTIONS(464),
    [anon_sym_int80] = ACTIONS(464),
    [anon_sym_int88] = ACTIONS(464),
    [anon_sym_int96] = ACTIONS(464),
    [anon_sym_int104] = ACTIONS(464),
    [anon_sym_int112] = ACTIONS(464),
    [anon_sym_int120] = ACTIONS(464),
    [anon_sym_int128] = ACTIONS(464),
    [anon_sym_int136] = ACTIONS(464),
    [anon_sym_int144] = ACTIONS(464),
    [anon_sym_int152] = ACTIONS(464),
    [anon_sym_int160] = ACTIONS(464),
    [anon_sym_int168] = ACTIONS(464),
    [anon_sym_int176] = ACTIONS(464),
    [anon_sym_int184] = ACTIONS(464),
    [anon_sym_int192] = ACTIONS(464),
    [anon_sym_int200] = ACTIONS(464),
    [anon_sym_int208] = ACTIONS(464),
    [anon_sym_int216] = ACTIONS(464),
    [anon_sym_int224] = ACTIONS(464),
    [anon_sym_int232] = ACTIONS(464),
    [anon_sym_int240] = ACTIONS(464),
    [anon_sym_int248] = ACTIONS(464),
    [anon_sym_int256] = ACTIONS(464),
    [anon_sym_uint] = ACTIONS(464),
    [anon_sym_uint8] = ACTIONS(464),
    [anon_sym_uint16] = ACTIONS(464),
    [anon_sym_uint24] = ACTIONS(464),
    [anon_sym_uint32] = ACTIONS(464),
    [anon_sym_uint40] = ACTIONS(464),
    [anon_sym_uint48] = ACTIONS(464),
    [anon_sym_uint56] = ACTIONS(464),
    [anon_sym_uint64] = ACTIONS(464),
    [anon_sym_uint72] = ACTIONS(464),
    [anon_sym_uint80] = ACTIONS(464),
    [anon_sym_uint88] = ACTIONS(464),
    [anon_sym_uint96] = ACTIONS(464),
    [anon_sym_uint104] = ACTIONS(464),
    [anon_sym_uint112] = ACTIONS(464),
    [anon_sym_uint120] = ACTIONS(464),
    [anon_sym_uint128] = ACTIONS(464),
    [anon_sym_uint136] = ACTIONS(464),
    [anon_sym_uint144] = ACTIONS(464),
    [anon_sym_uint152] = ACTIONS(464),
    [anon_sym_uint160] = ACTIONS(464),
    [anon_sym_uint168] = ACTIONS(464),
    [anon_sym_uint176] = ACTIONS(464),
    [anon_sym_uint184] = ACTIONS(464),
    [anon_sym_uint192] = ACTIONS(464),
    [anon_sym_uint200] = ACTIONS(464),
    [anon_sym_uint208] = ACTIONS(464),
    [anon_sym_uint216] = ACTIONS(464),
    [anon_sym_uint224] = ACTIONS(464),
    [anon_sym_uint232] = ACTIONS(464),
    [anon_sym_uint240] = ACTIONS(464),
    [anon_sym_uint248] = ACTIONS(464),
    [anon_sym_uint256] = ACTIONS(464),
    [anon_sym_bytes] = ACTIONS(464),
    [anon_sym_bytes1] = ACTIONS(464),
    [anon_sym_bytes2] = ACTIONS(464),
    [anon_sym_bytes3] = ACTIONS(464),
    [anon_sym_bytes4] = ACTIONS(464),
    [anon_sym_bytes5] = ACTIONS(464),
    [anon_sym_bytes6] = ACTIONS(464),
    [anon_sym_bytes7] = ACTIONS(464),
    [anon_sym_bytes8] = ACTIONS(464),
    [anon_sym_bytes9] = ACTIONS(464),
    [anon_sym_bytes10] = ACTIONS(464),
    [anon_sym_bytes11] = ACTIONS(464),
    [anon_sym_bytes12] = ACTIONS(464),
    [anon_sym_bytes13] = ACTIONS(464),
    [anon_sym_bytes14] = ACTIONS(464),
    [anon_sym_bytes15] = ACTIONS(464),
    [anon_sym_bytes16] = ACTIONS(464),
    [anon_sym_bytes17] = ACTIONS(464),
    [anon_sym_bytes18] = ACTIONS(464),
    [anon_sym_bytes19] = ACTIONS(464),
    [anon_sym_bytes20] = ACTIONS(464),
    [anon_sym_bytes21] = ACTIONS(464),
    [anon_sym_bytes22] = ACTIONS(464),
    [anon_sym_bytes23] = ACTIONS(464),
    [anon_sym_bytes24] = ACTIONS(464),
    [anon_sym_bytes25] = ACTIONS(464),
    [anon_sym_bytes26] = ACTIONS(464),
    [anon_sym_bytes27] = ACTIONS(464),
    [anon_sym_bytes28] = ACTIONS(464),
    [anon_sym_bytes29] = ACTIONS(464),
    [anon_sym_bytes30] = ACTIONS(464),
    [anon_sym_bytes31] = ACTIONS(464),
    [anon_sym_bytes32] = ACTIONS(464),
    [anon_sym_fixed] = ACTIONS(464),
    [aux_sym__fixed_token1] = ACTIONS(464),
    [anon_sym_ufixed] = ACTIONS(464),
    [aux_sym__ufixed_token1] = ACTIONS(464),
    [aux_sym__decimal_number_token1] = ACTIONS(464),
    [aux_sym__decimal_number_token2] = ACTIONS(466),
    [aux_sym__hex_number_token1] = ACTIONS(466),
    [anon_sym_hex] = ACTIONS(464),
    [anon_sym_DQUOTE] = ACTIONS(466),
    [anon_sym_SQUOTE] = ACTIONS(466),
    [anon_sym_unicode] = ACTIONS(464),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(468),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_TILDE] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(470),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_type] = ACTIONS(468),
    [anon_sym_LPAREN] = ACTIONS(470),
    [anon_sym_for] = ACTIONS(468),
    [anon_sym_assembly] = ACTIONS(468),
    [anon_sym_break] = ACTIONS(468),
    [anon_sym_continue] = ACTIONS(468),
    [anon_sym_true] = ACTIONS(468),
    [anon_sym_false] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(468),
    [anon_sym_byte] = ACTIONS(468),
    [anon_sym_address] = ACTIONS(468),
    [anon_sym_return] = ACTIONS(468),
    [anon_sym_revert] = ACTIONS(468),
    [sym_unchecked] = ACTIONS(468),
    [anon_sym_var] = ACTIONS(468),
    [anon_sym_else] = ACTIONS(468),
    [anon_sym_while] = ACTIONS(468),
    [anon_sym_do] = ACTIONS(468),
    [anon_sym_try] = ACTIONS(468),
    [anon_sym_emit] = ACTIONS(468),
    [anon_sym_payable] = ACTIONS(468),
    [anon_sym_new] = ACTIONS(468),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_delete] = ACTIONS(468),
    [anon_sym_PLUS_PLUS] = ACTIONS(470),
    [anon_sym_DASH_DASH] = ACTIONS(470),
    [anon_sym_mapping] = ACTIONS(468),
    [anon_sym_bool] = ACTIONS(468),
    [anon_sym_string] = ACTIONS(468),
    [anon_sym_int] = ACTIONS(468),
    [anon_sym_int8] = ACTIONS(468),
    [anon_sym_int16] = ACTIONS(468),
    [anon_sym_int24] = ACTIONS(468),
    [anon_sym_int32] = ACTIONS(468),
    [anon_sym_int40] = ACTIONS(468),
    [anon_sym_int48] = ACTIONS(468),
    [anon_sym_int56] = ACTIONS(468),
    [anon_sym_int64] = ACTIONS(468),
    [anon_sym_int72] = ACTIONS(468),
    [anon_sym_int80] = ACTIONS(468),
    [anon_sym_int88] = ACTIONS(468),
    [anon_sym_int96] = ACTIONS(468),
    [anon_sym_int104] = ACTIONS(468),
    [anon_sym_int112] = ACTIONS(468),
    [anon_sym_int120] = ACTIONS(468),
    [anon_sym_int128] = ACTIONS(468),
    [anon_sym_int136] = ACTIONS(468),
    [anon_sym_int144] = ACTIONS(468),
    [anon_sym_int152] = ACTIONS(468),
    [anon_sym_int160] = ACTIONS(468),
    [anon_sym_int168] = ACTIONS(468),
    [anon_sym_int176] = ACTIONS(468),
    [anon_sym_int184] = ACTIONS(468),
    [anon_sym_int192] = ACTIONS(468),
    [anon_sym_int200] = ACTIONS(468),
    [anon_sym_int208] = ACTIONS(468),
    [anon_sym_int216] = ACTIONS(468),
    [anon_sym_int224] = ACTIONS(468),
    [anon_sym_int232] = ACTIONS(468),
    [anon_sym_int240] = ACTIONS(468),
    [anon_sym_int248] = ACTIONS(468),
    [anon_sym_int256] = ACTIONS(468),
    [anon_sym_uint] = ACTIONS(468),
    [anon_sym_uint8] = ACTIONS(468),
    [anon_sym_uint16] = ACTIONS(468),
    [anon_sym_uint24] = ACTIONS(468),
    [anon_sym_uint32] = ACTIONS(468),
    [anon_sym_uint40] = ACTIONS(468),
    [anon_sym_uint48] = ACTIONS(468),
    [anon_sym_uint56] = ACTIONS(468),
    [anon_sym_uint64] = ACTIONS(468),
    [anon_sym_uint72] = ACTIONS(468),
    [anon_sym_uint80] = ACTIONS(468),
    [anon_sym_uint88] = ACTIONS(468),
    [anon_sym_uint96] = ACTIONS(468),
    [anon_sym_uint104] = ACTIONS(468),
    [anon_sym_uint112] = ACTIONS(468),
    [anon_sym_uint120] = ACTIONS(468),
    [anon_sym_uint128] = ACTIONS(468),
    [anon_sym_uint136] = ACTIONS(468),
    [anon_sym_uint144] = ACTIONS(468),
    [anon_sym_uint152] = ACTIONS(468),
    [anon_sym_uint160] = ACTIONS(468),
    [anon_sym_uint168] = ACTIONS(468),
    [anon_sym_uint176] = ACTIONS(468),
    [anon_sym_uint184] = ACTIONS(468),
    [anon_sym_uint192] = ACTIONS(468),
    [anon_sym_uint200] = ACTIONS(468),
    [anon_sym_uint208] = ACTIONS(468),
    [anon_sym_uint216] = ACTIONS(468),
    [anon_sym_uint224] = ACTIONS(468),
    [anon_sym_uint232] = ACTIONS(468),
    [anon_sym_uint240] = ACTIONS(468),
    [anon_sym_uint248] = ACTIONS(468),
    [anon_sym_uint256] = ACTIONS(468),
    [anon_sym_bytes] = ACTIONS(468),
    [anon_sym_bytes1] = ACTIONS(468),
    [anon_sym_bytes2] = ACTIONS(468),
    [anon_sym_bytes3] = ACTIONS(468),
    [anon_sym_bytes4] = ACTIONS(468),
    [anon_sym_bytes5] = ACTIONS(468),
    [anon_sym_bytes6] = ACTIONS(468),
    [anon_sym_bytes7] = ACTIONS(468),
    [anon_sym_bytes8] = ACTIONS(468),
    [anon_sym_bytes9] = ACTIONS(468),
    [anon_sym_bytes10] = ACTIONS(468),
    [anon_sym_bytes11] = ACTIONS(468),
    [anon_sym_bytes12] = ACTIONS(468),
    [anon_sym_bytes13] = ACTIONS(468),
    [anon_sym_bytes14] = ACTIONS(468),
    [anon_sym_bytes15] = ACTIONS(468),
    [anon_sym_bytes16] = ACTIONS(468),
    [anon_sym_bytes17] = ACTIONS(468),
    [anon_sym_bytes18] = ACTIONS(468),
    [anon_sym_bytes19] = ACTIONS(468),
    [anon_sym_bytes20] = ACTIONS(468),
    [anon_sym_bytes21] = ACTIONS(468),
    [anon_sym_bytes22] = ACTIONS(468),
    [anon_sym_bytes23] = ACTIONS(468),
    [anon_sym_bytes24] = ACTIONS(468),
    [anon_sym_bytes25] = ACTIONS(468),
    [anon_sym_bytes26] = ACTIONS(468),
    [anon_sym_bytes27] = ACTIONS(468),
    [anon_sym_bytes28] = ACTIONS(468),
    [anon_sym_bytes29] = ACTIONS(468),
    [anon_sym_bytes30] = ACTIONS(468),
    [anon_sym_bytes31] = ACTIONS(468),
    [anon_sym_bytes32] = ACTIONS(468),
    [anon_sym_fixed] = ACTIONS(468),
    [aux_sym__fixed_token1] = ACTIONS(468),
    [anon_sym_ufixed] = ACTIONS(468),
    [aux_sym__ufixed_token1] = ACTIONS(468),
    [aux_sym__decimal_number_token1] = ACTIONS(468),
    [aux_sym__decimal_number_token2] = ACTIONS(470),
    [aux_sym__hex_number_token1] = ACTIONS(470),
    [anon_sym_hex] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(470),
    [anon_sym_unicode] = ACTIONS(468),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_TILDE] = ACTIONS(474),
    [anon_sym_LBRACE] = ACTIONS(474),
    [anon_sym_RBRACE] = ACTIONS(474),
    [anon_sym_type] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(472),
    [anon_sym_assembly] = ACTIONS(472),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_continue] = ACTIONS(472),
    [anon_sym_true] = ACTIONS(472),
    [anon_sym_false] = ACTIONS(472),
    [anon_sym_if] = ACTIONS(472),
    [anon_sym_function] = ACTIONS(472),
    [anon_sym_byte] = ACTIONS(472),
    [anon_sym_address] = ACTIONS(472),
    [anon_sym_return] = ACTIONS(472),
    [anon_sym_revert] = ACTIONS(472),
    [sym_unchecked] = ACTIONS(472),
    [anon_sym_var] = ACTIONS(472),
    [anon_sym_else] = ACTIONS(472),
    [anon_sym_while] = ACTIONS(472),
    [anon_sym_do] = ACTIONS(472),
    [anon_sym_try] = ACTIONS(472),
    [anon_sym_emit] = ACTIONS(472),
    [anon_sym_payable] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(472),
    [anon_sym_LBRACK] = ACTIONS(474),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_BANG] = ACTIONS(474),
    [anon_sym_delete] = ACTIONS(472),
    [anon_sym_PLUS_PLUS] = ACTIONS(474),
    [anon_sym_DASH_DASH] = ACTIONS(474),
    [anon_sym_mapping] = ACTIONS(472),
    [anon_sym_bool] = ACTIONS(472),
    [anon_sym_string] = ACTIONS(472),
    [anon_sym_int] = ACTIONS(472),
    [anon_sym_int8] = ACTIONS(472),
    [anon_sym_int16] = ACTIONS(472),
    [anon_sym_int24] = ACTIONS(472),
    [anon_sym_int32] = ACTIONS(472),
    [anon_sym_int40] = ACTIONS(472),
    [anon_sym_int48] = ACTIONS(472),
    [anon_sym_int56] = ACTIONS(472),
    [anon_sym_int64] = ACTIONS(472),
    [anon_sym_int72] = ACTIONS(472),
    [anon_sym_int80] = ACTIONS(472),
    [anon_sym_int88] = ACTIONS(472),
    [anon_sym_int96] = ACTIONS(472),
    [anon_sym_int104] = ACTIONS(472),
    [anon_sym_int112] = ACTIONS(472),
    [anon_sym_int120] = ACTIONS(472),
    [anon_sym_int128] = ACTIONS(472),
    [anon_sym_int136] = ACTIONS(472),
    [anon_sym_int144] = ACTIONS(472),
    [anon_sym_int152] = ACTIONS(472),
    [anon_sym_int160] = ACTIONS(472),
    [anon_sym_int168] = ACTIONS(472),
    [anon_sym_int176] = ACTIONS(472),
    [anon_sym_int184] = ACTIONS(472),
    [anon_sym_int192] = ACTIONS(472),
    [anon_sym_int200] = ACTIONS(472),
    [anon_sym_int208] = ACTIONS(472),
    [anon_sym_int216] = ACTIONS(472),
    [anon_sym_int224] = ACTIONS(472),
    [anon_sym_int232] = ACTIONS(472),
    [anon_sym_int240] = ACTIONS(472),
    [anon_sym_int248] = ACTIONS(472),
    [anon_sym_int256] = ACTIONS(472),
    [anon_sym_uint] = ACTIONS(472),
    [anon_sym_uint8] = ACTIONS(472),
    [anon_sym_uint16] = ACTIONS(472),
    [anon_sym_uint24] = ACTIONS(472),
    [anon_sym_uint32] = ACTIONS(472),
    [anon_sym_uint40] = ACTIONS(472),
    [anon_sym_uint48] = ACTIONS(472),
    [anon_sym_uint56] = ACTIONS(472),
    [anon_sym_uint64] = ACTIONS(472),
    [anon_sym_uint72] = ACTIONS(472),
    [anon_sym_uint80] = ACTIONS(472),
    [anon_sym_uint88] = ACTIONS(472),
    [anon_sym_uint96] = ACTIONS(472),
    [anon_sym_uint104] = ACTIONS(472),
    [anon_sym_uint112] = ACTIONS(472),
    [anon_sym_uint120] = ACTIONS(472),
    [anon_sym_uint128] = ACTIONS(472),
    [anon_sym_uint136] = ACTIONS(472),
    [anon_sym_uint144] = ACTIONS(472),
    [anon_sym_uint152] = ACTIONS(472),
    [anon_sym_uint160] = ACTIONS(472),
    [anon_sym_uint168] = ACTIONS(472),
    [anon_sym_uint176] = ACTIONS(472),
    [anon_sym_uint184] = ACTIONS(472),
    [anon_sym_uint192] = ACTIONS(472),
    [anon_sym_uint200] = ACTIONS(472),
    [anon_sym_uint208] = ACTIONS(472),
    [anon_sym_uint216] = ACTIONS(472),
    [anon_sym_uint224] = ACTIONS(472),
    [anon_sym_uint232] = ACTIONS(472),
    [anon_sym_uint240] = ACTIONS(472),
    [anon_sym_uint248] = ACTIONS(472),
    [anon_sym_uint256] = ACTIONS(472),
    [anon_sym_bytes] = ACTIONS(472),
    [anon_sym_bytes1] = ACTIONS(472),
    [anon_sym_bytes2] = ACTIONS(472),
    [anon_sym_bytes3] = ACTIONS(472),
    [anon_sym_bytes4] = ACTIONS(472),
    [anon_sym_bytes5] = ACTIONS(472),
    [anon_sym_bytes6] = ACTIONS(472),
    [anon_sym_bytes7] = ACTIONS(472),
    [anon_sym_bytes8] = ACTIONS(472),
    [anon_sym_bytes9] = ACTIONS(472),
    [anon_sym_bytes10] = ACTIONS(472),
    [anon_sym_bytes11] = ACTIONS(472),
    [anon_sym_bytes12] = ACTIONS(472),
    [anon_sym_bytes13] = ACTIONS(472),
    [anon_sym_bytes14] = ACTIONS(472),
    [anon_sym_bytes15] = ACTIONS(472),
    [anon_sym_bytes16] = ACTIONS(472),
    [anon_sym_bytes17] = ACTIONS(472),
    [anon_sym_bytes18] = ACTIONS(472),
    [anon_sym_bytes19] = ACTIONS(472),
    [anon_sym_bytes20] = ACTIONS(472),
    [anon_sym_bytes21] = ACTIONS(472),
    [anon_sym_bytes22] = ACTIONS(472),
    [anon_sym_bytes23] = ACTIONS(472),
    [anon_sym_bytes24] = ACTIONS(472),
    [anon_sym_bytes25] = ACTIONS(472),
    [anon_sym_bytes26] = ACTIONS(472),
    [anon_sym_bytes27] = ACTIONS(472),
    [anon_sym_bytes28] = ACTIONS(472),
    [anon_sym_bytes29] = ACTIONS(472),
    [anon_sym_bytes30] = ACTIONS(472),
    [anon_sym_bytes31] = ACTIONS(472),
    [anon_sym_bytes32] = ACTIONS(472),
    [anon_sym_fixed] = ACTIONS(472),
    [aux_sym__fixed_token1] = ACTIONS(472),
    [anon_sym_ufixed] = ACTIONS(472),
    [aux_sym__ufixed_token1] = ACTIONS(472),
    [aux_sym__decimal_number_token1] = ACTIONS(472),
    [aux_sym__decimal_number_token2] = ACTIONS(474),
    [aux_sym__hex_number_token1] = ACTIONS(474),
    [anon_sym_hex] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [anon_sym_SQUOTE] = ACTIONS(474),
    [anon_sym_unicode] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(476),
    [anon_sym_TILDE] = ACTIONS(478),
    [anon_sym_LBRACE] = ACTIONS(478),
    [anon_sym_RBRACE] = ACTIONS(478),
    [anon_sym_type] = ACTIONS(476),
    [anon_sym_LPAREN] = ACTIONS(478),
    [anon_sym_for] = ACTIONS(476),
    [anon_sym_assembly] = ACTIONS(476),
    [anon_sym_break] = ACTIONS(476),
    [anon_sym_continue] = ACTIONS(476),
    [anon_sym_true] = ACTIONS(476),
    [anon_sym_false] = ACTIONS(476),
    [anon_sym_if] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(476),
    [anon_sym_byte] = ACTIONS(476),
    [anon_sym_address] = ACTIONS(476),
    [anon_sym_return] = ACTIONS(476),
    [anon_sym_revert] = ACTIONS(476),
    [sym_unchecked] = ACTIONS(476),
    [anon_sym_var] = ACTIONS(476),
    [anon_sym_else] = ACTIONS(476),
    [anon_sym_while] = ACTIONS(476),
    [anon_sym_do] = ACTIONS(476),
    [anon_sym_try] = ACTIONS(476),
    [anon_sym_emit] = ACTIONS(476),
    [anon_sym_payable] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(476),
    [anon_sym_LBRACK] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(476),
    [anon_sym_BANG] = ACTIONS(478),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_mapping] = ACTIONS(476),
    [anon_sym_bool] = ACTIONS(476),
    [anon_sym_string] = ACTIONS(476),
    [anon_sym_int] = ACTIONS(476),
    [anon_sym_int8] = ACTIONS(476),
    [anon_sym_int16] = ACTIONS(476),
    [anon_sym_int24] = ACTIONS(476),
    [anon_sym_int32] = ACTIONS(476),
    [anon_sym_int40] = ACTIONS(476),
    [anon_sym_int48] = ACTIONS(476),
    [anon_sym_int56] = ACTIONS(476),
    [anon_sym_int64] = ACTIONS(476),
    [anon_sym_int72] = ACTIONS(476),
    [anon_sym_int80] = ACTIONS(476),
    [anon_sym_int88] = ACTIONS(476),
    [anon_sym_int96] = ACTIONS(476),
    [anon_sym_int104] = ACTIONS(476),
    [anon_sym_int112] = ACTIONS(476),
    [anon_sym_int120] = ACTIONS(476),
    [anon_sym_int128] = ACTIONS(476),
    [anon_sym_int136] = ACTIONS(476),
    [anon_sym_int144] = ACTIONS(476),
    [anon_sym_int152] = ACTIONS(476),
    [anon_sym_int160] = ACTIONS(476),
    [anon_sym_int168] = ACTIONS(476),
    [anon_sym_int176] = ACTIONS(476),
    [anon_sym_int184] = ACTIONS(476),
    [anon_sym_int192] = ACTIONS(476),
    [anon_sym_int200] = ACTIONS(476),
    [anon_sym_int208] = ACTIONS(476),
    [anon_sym_int216] = ACTIONS(476),
    [anon_sym_int224] = ACTIONS(476),
    [anon_sym_int232] = ACTIONS(476),
    [anon_sym_int240] = ACTIONS(476),
    [anon_sym_int248] = ACTIONS(476),
    [anon_sym_int256] = ACTIONS(476),
    [anon_sym_uint] = ACTIONS(476),
    [anon_sym_uint8] = ACTIONS(476),
    [anon_sym_uint16] = ACTIONS(476),
    [anon_sym_uint24] = ACTIONS(476),
    [anon_sym_uint32] = ACTIONS(476),
    [anon_sym_uint40] = ACTIONS(476),
    [anon_sym_uint48] = ACTIONS(476),
    [anon_sym_uint56] = ACTIONS(476),
    [anon_sym_uint64] = ACTIONS(476),
    [anon_sym_uint72] = ACTIONS(476),
    [anon_sym_uint80] = ACTIONS(476),
    [anon_sym_uint88] = ACTIONS(476),
    [anon_sym_uint96] = ACTIONS(476),
    [anon_sym_uint104] = ACTIONS(476),
    [anon_sym_uint112] = ACTIONS(476),
    [anon_sym_uint120] = ACTIONS(476),
    [anon_sym_uint128] = ACTIONS(476),
    [anon_sym_uint136] = ACTIONS(476),
    [anon_sym_uint144] = ACTIONS(476),
    [anon_sym_uint152] = ACTIONS(476),
    [anon_sym_uint160] = ACTIONS(476),
    [anon_sym_uint168] = ACTIONS(476),
    [anon_sym_uint176] = ACTIONS(476),
    [anon_sym_uint184] = ACTIONS(476),
    [anon_sym_uint192] = ACTIONS(476),
    [anon_sym_uint200] = ACTIONS(476),
    [anon_sym_uint208] = ACTIONS(476),
    [anon_sym_uint216] = ACTIONS(476),
    [anon_sym_uint224] = ACTIONS(476),
    [anon_sym_uint232] = ACTIONS(476),
    [anon_sym_uint240] = ACTIONS(476),
    [anon_sym_uint248] = ACTIONS(476),
    [anon_sym_uint256] = ACTIONS(476),
    [anon_sym_bytes] = ACTIONS(476),
    [anon_sym_bytes1] = ACTIONS(476),
    [anon_sym_bytes2] = ACTIONS(476),
    [anon_sym_bytes3] = ACTIONS(476),
    [anon_sym_bytes4] = ACTIONS(476),
    [anon_sym_bytes5] = ACTIONS(476),
    [anon_sym_bytes6] = ACTIONS(476),
    [anon_sym_bytes7] = ACTIONS(476),
    [anon_sym_bytes8] = ACTIONS(476),
    [anon_sym_bytes9] = ACTIONS(476),
    [anon_sym_bytes10] = ACTIONS(476),
    [anon_sym_bytes11] = ACTIONS(476),
    [anon_sym_bytes12] = ACTIONS(476),
    [anon_sym_bytes13] = ACTIONS(476),
    [anon_sym_bytes14] = ACTIONS(476),
    [anon_sym_bytes15] = ACTIONS(476),
    [anon_sym_bytes16] = ACTIONS(476),
    [anon_sym_bytes17] = ACTIONS(476),
    [anon_sym_bytes18] = ACTIONS(476),
    [anon_sym_bytes19] = ACTIONS(476),
    [anon_sym_bytes20] = ACTIONS(476),
    [anon_sym_bytes21] = ACTIONS(476),
    [anon_sym_bytes22] = ACTIONS(476),
    [anon_sym_bytes23] = ACTIONS(476),
    [anon_sym_bytes24] = ACTIONS(476),
    [anon_sym_bytes25] = ACTIONS(476),
    [anon_sym_bytes26] = ACTIONS(476),
    [anon_sym_bytes27] = ACTIONS(476),
    [anon_sym_bytes28] = ACTIONS(476),
    [anon_sym_bytes29] = ACTIONS(476),
    [anon_sym_bytes30] = ACTIONS(476),
    [anon_sym_bytes31] = ACTIONS(476),
    [anon_sym_bytes32] = ACTIONS(476),
    [anon_sym_fixed] = ACTIONS(476),
    [aux_sym__fixed_token1] = ACTIONS(476),
    [anon_sym_ufixed] = ACTIONS(476),
    [aux_sym__ufixed_token1] = ACTIONS(476),
    [aux_sym__decimal_number_token1] = ACTIONS(476),
    [aux_sym__decimal_number_token2] = ACTIONS(478),
    [aux_sym__hex_number_token1] = ACTIONS(478),
    [anon_sym_hex] = ACTIONS(476),
    [anon_sym_DQUOTE] = ACTIONS(478),
    [anon_sym_SQUOTE] = ACTIONS(478),
    [anon_sym_unicode] = ACTIONS(476),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(480),
    [anon_sym_DASH] = ACTIONS(480),
    [anon_sym_TILDE] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(482),
    [anon_sym_RBRACE] = ACTIONS(482),
    [anon_sym_type] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(482),
    [anon_sym_for] = ACTIONS(480),
    [anon_sym_assembly] = ACTIONS(480),
    [anon_sym_break] = ACTIONS(480),
    [anon_sym_continue] = ACTIONS(480),
    [anon_sym_true] = ACTIONS(480),
    [anon_sym_false] = ACTIONS(480),
    [anon_sym_if] = ACTIONS(480),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_byte] = ACTIONS(480),
    [anon_sym_address] = ACTIONS(480),
    [anon_sym_return] = ACTIONS(480),
    [anon_sym_revert] = ACTIONS(480),
    [sym_unchecked] = ACTIONS(480),
    [anon_sym_var] = ACTIONS(480),
    [anon_sym_else] = ACTIONS(480),
    [anon_sym_while] = ACTIONS(480),
    [anon_sym_do] = ACTIONS(480),
    [anon_sym_try] = ACTIONS(480),
    [anon_sym_emit] = ACTIONS(480),
    [anon_sym_payable] = ACTIONS(480),
    [anon_sym_new] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(480),
    [anon_sym_BANG] = ACTIONS(482),
    [anon_sym_delete] = ACTIONS(480),
    [anon_sym_PLUS_PLUS] = ACTIONS(482),
    [anon_sym_DASH_DASH] = ACTIONS(482),
    [anon_sym_mapping] = ACTIONS(480),
    [anon_sym_bool] = ACTIONS(480),
    [anon_sym_string] = ACTIONS(480),
    [anon_sym_int] = ACTIONS(480),
    [anon_sym_int8] = ACTIONS(480),
    [anon_sym_int16] = ACTIONS(480),
    [anon_sym_int24] = ACTIONS(480),
    [anon_sym_int32] = ACTIONS(480),
    [anon_sym_int40] = ACTIONS(480),
    [anon_sym_int48] = ACTIONS(480),
    [anon_sym_int56] = ACTIONS(480),
    [anon_sym_int64] = ACTIONS(480),
    [anon_sym_int72] = ACTIONS(480),
    [anon_sym_int80] = ACTIONS(480),
    [anon_sym_int88] = ACTIONS(480),
    [anon_sym_int96] = ACTIONS(480),
    [anon_sym_int104] = ACTIONS(480),
    [anon_sym_int112] = ACTIONS(480),
    [anon_sym_int120] = ACTIONS(480),
    [anon_sym_int128] = ACTIONS(480),
    [anon_sym_int136] = ACTIONS(480),
    [anon_sym_int144] = ACTIONS(480),
    [anon_sym_int152] = ACTIONS(480),
    [anon_sym_int160] = ACTIONS(480),
    [anon_sym_int168] = ACTIONS(480),
    [anon_sym_int176] = ACTIONS(480),
    [anon_sym_int184] = ACTIONS(480),
    [anon_sym_int192] = ACTIONS(480),
    [anon_sym_int200] = ACTIONS(480),
    [anon_sym_int208] = ACTIONS(480),
    [anon_sym_int216] = ACTIONS(480),
    [anon_sym_int224] = ACTIONS(480),
    [anon_sym_int232] = ACTIONS(480),
    [anon_sym_int240] = ACTIONS(480),
    [anon_sym_int248] = ACTIONS(480),
    [anon_sym_int256] = ACTIONS(480),
    [anon_sym_uint] = ACTIONS(480),
    [anon_sym_uint8] = ACTIONS(480),
    [anon_sym_uint16] = ACTIONS(480),
    [anon_sym_uint24] = ACTIONS(480),
    [anon_sym_uint32] = ACTIONS(480),
    [anon_sym_uint40] = ACTIONS(480),
    [anon_sym_uint48] = ACTIONS(480),
    [anon_sym_uint56] = ACTIONS(480),
    [anon_sym_uint64] = ACTIONS(480),
    [anon_sym_uint72] = ACTIONS(480),
    [anon_sym_uint80] = ACTIONS(480),
    [anon_sym_uint88] = ACTIONS(480),
    [anon_sym_uint96] = ACTIONS(480),
    [anon_sym_uint104] = ACTIONS(480),
    [anon_sym_uint112] = ACTIONS(480),
    [anon_sym_uint120] = ACTIONS(480),
    [anon_sym_uint128] = ACTIONS(480),
    [anon_sym_uint136] = ACTIONS(480),
    [anon_sym_uint144] = ACTIONS(480),
    [anon_sym_uint152] = ACTIONS(480),
    [anon_sym_uint160] = ACTIONS(480),
    [anon_sym_uint168] = ACTIONS(480),
    [anon_sym_uint176] = ACTIONS(480),
    [anon_sym_uint184] = ACTIONS(480),
    [anon_sym_uint192] = ACTIONS(480),
    [anon_sym_uint200] = ACTIONS(480),
    [anon_sym_uint208] = ACTIONS(480),
    [anon_sym_uint216] = ACTIONS(480),
    [anon_sym_uint224] = ACTIONS(480),
    [anon_sym_uint232] = ACTIONS(480),
    [anon_sym_uint240] = ACTIONS(480),
    [anon_sym_uint248] = ACTIONS(480),
    [anon_sym_uint256] = ACTIONS(480),
    [anon_sym_bytes] = ACTIONS(480),
    [anon_sym_bytes1] = ACTIONS(480),
    [anon_sym_bytes2] = ACTIONS(480),
    [anon_sym_bytes3] = ACTIONS(480),
    [anon_sym_bytes4] = ACTIONS(480),
    [anon_sym_bytes5] = ACTIONS(480),
    [anon_sym_bytes6] = ACTIONS(480),
    [anon_sym_bytes7] = ACTIONS(480),
    [anon_sym_bytes8] = ACTIONS(480),
    [anon_sym_bytes9] = ACTIONS(480),
    [anon_sym_bytes10] = ACTIONS(480),
    [anon_sym_bytes11] = ACTIONS(480),
    [anon_sym_bytes12] = ACTIONS(480),
    [anon_sym_bytes13] = ACTIONS(480),
    [anon_sym_bytes14] = ACTIONS(480),
    [anon_sym_bytes15] = ACTIONS(480),
    [anon_sym_bytes16] = ACTIONS(480),
    [anon_sym_bytes17] = ACTIONS(480),
    [anon_sym_bytes18] = ACTIONS(480),
    [anon_sym_bytes19] = ACTIONS(480),
    [anon_sym_bytes20] = ACTIONS(480),
    [anon_sym_bytes21] = ACTIONS(480),
    [anon_sym_bytes22] = ACTIONS(480),
    [anon_sym_bytes23] = ACTIONS(480),
    [anon_sym_bytes24] = ACTIONS(480),
    [anon_sym_bytes25] = ACTIONS(480),
    [anon_sym_bytes26] = ACTIONS(480),
    [anon_sym_bytes27] = ACTIONS(480),
    [anon_sym_bytes28] = ACTIONS(480),
    [anon_sym_bytes29] = ACTIONS(480),
    [anon_sym_bytes30] = ACTIONS(480),
    [anon_sym_bytes31] = ACTIONS(480),
    [anon_sym_bytes32] = ACTIONS(480),
    [anon_sym_fixed] = ACTIONS(480),
    [aux_sym__fixed_token1] = ACTIONS(480),
    [anon_sym_ufixed] = ACTIONS(480),
    [aux_sym__ufixed_token1] = ACTIONS(480),
    [aux_sym__decimal_number_token1] = ACTIONS(480),
    [aux_sym__decimal_number_token2] = ACTIONS(482),
    [aux_sym__hex_number_token1] = ACTIONS(482),
    [anon_sym_hex] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [anon_sym_unicode] = ACTIONS(480),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(484),
    [anon_sym_DASH] = ACTIONS(484),
    [anon_sym_TILDE] = ACTIONS(486),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_RBRACE] = ACTIONS(486),
    [anon_sym_type] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_for] = ACTIONS(484),
    [anon_sym_assembly] = ACTIONS(484),
    [anon_sym_break] = ACTIONS(484),
    [anon_sym_continue] = ACTIONS(484),
    [anon_sym_true] = ACTIONS(484),
    [anon_sym_false] = ACTIONS(484),
    [anon_sym_if] = ACTIONS(484),
    [anon_sym_function] = ACTIONS(484),
    [anon_sym_byte] = ACTIONS(484),
    [anon_sym_address] = ACTIONS(484),
    [anon_sym_return] = ACTIONS(484),
    [anon_sym_revert] = ACTIONS(484),
    [sym_unchecked] = ACTIONS(484),
    [anon_sym_var] = ACTIONS(484),
    [anon_sym_else] = ACTIONS(484),
    [anon_sym_while] = ACTIONS(484),
    [anon_sym_do] = ACTIONS(484),
    [anon_sym_try] = ACTIONS(484),
    [anon_sym_emit] = ACTIONS(484),
    [anon_sym_payable] = ACTIONS(484),
    [anon_sym_new] = ACTIONS(484),
    [anon_sym_LBRACK] = ACTIONS(486),
    [anon_sym_PLUS] = ACTIONS(484),
    [anon_sym_BANG] = ACTIONS(486),
    [anon_sym_delete] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(486),
    [anon_sym_DASH_DASH] = ACTIONS(486),
    [anon_sym_mapping] = ACTIONS(484),
    [anon_sym_bool] = ACTIONS(484),
    [anon_sym_string] = ACTIONS(484),
    [anon_sym_int] = ACTIONS(484),
    [anon_sym_int8] = ACTIONS(484),
    [anon_sym_int16] = ACTIONS(484),
    [anon_sym_int24] = ACTIONS(484),
    [anon_sym_int32] = ACTIONS(484),
    [anon_sym_int40] = ACTIONS(484),
    [anon_sym_int48] = ACTIONS(484),
    [anon_sym_int56] = ACTIONS(484),
    [anon_sym_int64] = ACTIONS(484),
    [anon_sym_int72] = ACTIONS(484),
    [anon_sym_int80] = ACTIONS(484),
    [anon_sym_int88] = ACTIONS(484),
    [anon_sym_int96] = ACTIONS(484),
    [anon_sym_int104] = ACTIONS(484),
    [anon_sym_int112] = ACTIONS(484),
    [anon_sym_int120] = ACTIONS(484),
    [anon_sym_int128] = ACTIONS(484),
    [anon_sym_int136] = ACTIONS(484),
    [anon_sym_int144] = ACTIONS(484),
    [anon_sym_int152] = ACTIONS(484),
    [anon_sym_int160] = ACTIONS(484),
    [anon_sym_int168] = ACTIONS(484),
    [anon_sym_int176] = ACTIONS(484),
    [anon_sym_int184] = ACTIONS(484),
    [anon_sym_int192] = ACTIONS(484),
    [anon_sym_int200] = ACTIONS(484),
    [anon_sym_int208] = ACTIONS(484),
    [anon_sym_int216] = ACTIONS(484),
    [anon_sym_int224] = ACTIONS(484),
    [anon_sym_int232] = ACTIONS(484),
    [anon_sym_int240] = ACTIONS(484),
    [anon_sym_int248] = ACTIONS(484),
    [anon_sym_int256] = ACTIONS(484),
    [anon_sym_uint] = ACTIONS(484),
    [anon_sym_uint8] = ACTIONS(484),
    [anon_sym_uint16] = ACTIONS(484),
    [anon_sym_uint24] = ACTIONS(484),
    [anon_sym_uint32] = ACTIONS(484),
    [anon_sym_uint40] = ACTIONS(484),
    [anon_sym_uint48] = ACTIONS(484),
    [anon_sym_uint56] = ACTIONS(484),
    [anon_sym_uint64] = ACTIONS(484),
    [anon_sym_uint72] = ACTIONS(484),
    [anon_sym_uint80] = ACTIONS(484),
    [anon_sym_uint88] = ACTIONS(484),
    [anon_sym_uint96] = ACTIONS(484),
    [anon_sym_uint104] = ACTIONS(484),
    [anon_sym_uint112] = ACTIONS(484),
    [anon_sym_uint120] = ACTIONS(484),
    [anon_sym_uint128] = ACTIONS(484),
    [anon_sym_uint136] = ACTIONS(484),
    [anon_sym_uint144] = ACTIONS(484),
    [anon_sym_uint152] = ACTIONS(484),
    [anon_sym_uint160] = ACTIONS(484),
    [anon_sym_uint168] = ACTIONS(484),
    [anon_sym_uint176] = ACTIONS(484),
    [anon_sym_uint184] = ACTIONS(484),
    [anon_sym_uint192] = ACTIONS(484),
    [anon_sym_uint200] = ACTIONS(484),
    [anon_sym_uint208] = ACTIONS(484),
    [anon_sym_uint216] = ACTIONS(484),
    [anon_sym_uint224] = ACTIONS(484),
    [anon_sym_uint232] = ACTIONS(484),
    [anon_sym_uint240] = ACTIONS(484),
    [anon_sym_uint248] = ACTIONS(484),
    [anon_sym_uint256] = ACTIONS(484),
    [anon_sym_bytes] = ACTIONS(484),
    [anon_sym_bytes1] = ACTIONS(484),
    [anon_sym_bytes2] = ACTIONS(484),
    [anon_sym_bytes3] = ACTIONS(484),
    [anon_sym_bytes4] = ACTIONS(484),
    [anon_sym_bytes5] = ACTIONS(484),
    [anon_sym_bytes6] = ACTIONS(484),
    [anon_sym_bytes7] = ACTIONS(484),
    [anon_sym_bytes8] = ACTIONS(484),
    [anon_sym_bytes9] = ACTIONS(484),
    [anon_sym_bytes10] = ACTIONS(484),
    [anon_sym_bytes11] = ACTIONS(484),
    [anon_sym_bytes12] = ACTIONS(484),
    [anon_sym_bytes13] = ACTIONS(484),
    [anon_sym_bytes14] = ACTIONS(484),
    [anon_sym_bytes15] = ACTIONS(484),
    [anon_sym_bytes16] = ACTIONS(484),
    [anon_sym_bytes17] = ACTIONS(484),
    [anon_sym_bytes18] = ACTIONS(484),
    [anon_sym_bytes19] = ACTIONS(484),
    [anon_sym_bytes20] = ACTIONS(484),
    [anon_sym_bytes21] = ACTIONS(484),
    [anon_sym_bytes22] = ACTIONS(484),
    [anon_sym_bytes23] = ACTIONS(484),
    [anon_sym_bytes24] = ACTIONS(484),
    [anon_sym_bytes25] = ACTIONS(484),
    [anon_sym_bytes26] = ACTIONS(484),
    [anon_sym_bytes27] = ACTIONS(484),
    [anon_sym_bytes28] = ACTIONS(484),
    [anon_sym_bytes29] = ACTIONS(484),
    [anon_sym_bytes30] = ACTIONS(484),
    [anon_sym_bytes31] = ACTIONS(484),
    [anon_sym_bytes32] = ACTIONS(484),
    [anon_sym_fixed] = ACTIONS(484),
    [aux_sym__fixed_token1] = ACTIONS(484),
    [anon_sym_ufixed] = ACTIONS(484),
    [aux_sym__ufixed_token1] = ACTIONS(484),
    [aux_sym__decimal_number_token1] = ACTIONS(484),
    [aux_sym__decimal_number_token2] = ACTIONS(486),
    [aux_sym__hex_number_token1] = ACTIONS(486),
    [anon_sym_hex] = ACTIONS(484),
    [anon_sym_DQUOTE] = ACTIONS(486),
    [anon_sym_SQUOTE] = ACTIONS(486),
    [anon_sym_unicode] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_user_defined_type_definition] = STATE(101),
    [sym_error_declaration] = STATE(101),
    [sym__contract_member] = STATE(101),
    [sym_struct_declaration] = STATE(101),
    [sym_enum_declaration] = STATE(101),
    [sym_event_definition] = STATE(101),
    [sym_using_directive] = STATE(101),
    [sym_state_variable_declaration] = STATE(101),
    [sym_modifier_definition] = STATE(101),
    [sym_constructor_definition] = STATE(101),
    [sym_fallback_receive_definition] = STATE(101),
    [sym_function_definition] = STATE(101),
    [sym_type_name] = STATE(456),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_contract_body_repeat1] = STATE(101),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_error] = ACTIONS(496),
    [anon_sym_struct] = ACTIONS(499),
    [anon_sym_enum] = ACTIONS(502),
    [anon_sym_event] = ACTIONS(505),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(511),
    [anon_sym_byte] = ACTIONS(514),
    [anon_sym_address] = ACTIONS(517),
    [anon_sym_var] = ACTIONS(514),
    [anon_sym_modifier] = ACTIONS(520),
    [anon_sym_constructor] = ACTIONS(523),
    [anon_sym_fallback] = ACTIONS(526),
    [anon_sym_receive] = ACTIONS(526),
    [anon_sym_mapping] = ACTIONS(529),
    [anon_sym_bool] = ACTIONS(514),
    [anon_sym_string] = ACTIONS(514),
    [anon_sym_int] = ACTIONS(514),
    [anon_sym_int8] = ACTIONS(514),
    [anon_sym_int16] = ACTIONS(514),
    [anon_sym_int24] = ACTIONS(514),
    [anon_sym_int32] = ACTIONS(514),
    [anon_sym_int40] = ACTIONS(514),
    [anon_sym_int48] = ACTIONS(514),
    [anon_sym_int56] = ACTIONS(514),
    [anon_sym_int64] = ACTIONS(514),
    [anon_sym_int72] = ACTIONS(514),
    [anon_sym_int80] = ACTIONS(514),
    [anon_sym_int88] = ACTIONS(514),
    [anon_sym_int96] = ACTIONS(514),
    [anon_sym_int104] = ACTIONS(514),
    [anon_sym_int112] = ACTIONS(514),
    [anon_sym_int120] = ACTIONS(514),
    [anon_sym_int128] = ACTIONS(514),
    [anon_sym_int136] = ACTIONS(514),
    [anon_sym_int144] = ACTIONS(514),
    [anon_sym_int152] = ACTIONS(514),
    [anon_sym_int160] = ACTIONS(514),
    [anon_sym_int168] = ACTIONS(514),
    [anon_sym_int176] = ACTIONS(514),
    [anon_sym_int184] = ACTIONS(514),
    [anon_sym_int192] = ACTIONS(514),
    [anon_sym_int200] = ACTIONS(514),
    [anon_sym_int208] = ACTIONS(514),
    [anon_sym_int216] = ACTIONS(514),
    [anon_sym_int224] = ACTIONS(514),
    [anon_sym_int232] = ACTIONS(514),
    [anon_sym_int240] = ACTIONS(514),
    [anon_sym_int248] = ACTIONS(514),
    [anon_sym_int256] = ACTIONS(514),
    [anon_sym_uint] = ACTIONS(514),
    [anon_sym_uint8] = ACTIONS(514),
    [anon_sym_uint16] = ACTIONS(514),
    [anon_sym_uint24] = ACTIONS(514),
    [anon_sym_uint32] = ACTIONS(514),
    [anon_sym_uint40] = ACTIONS(514),
    [anon_sym_uint48] = ACTIONS(514),
    [anon_sym_uint56] = ACTIONS(514),
    [anon_sym_uint64] = ACTIONS(514),
    [anon_sym_uint72] = ACTIONS(514),
    [anon_sym_uint80] = ACTIONS(514),
    [anon_sym_uint88] = ACTIONS(514),
    [anon_sym_uint96] = ACTIONS(514),
    [anon_sym_uint104] = ACTIONS(514),
    [anon_sym_uint112] = ACTIONS(514),
    [anon_sym_uint120] = ACTIONS(514),
    [anon_sym_uint128] = ACTIONS(514),
    [anon_sym_uint136] = ACTIONS(514),
    [anon_sym_uint144] = ACTIONS(514),
    [anon_sym_uint152] = ACTIONS(514),
    [anon_sym_uint160] = ACTIONS(514),
    [anon_sym_uint168] = ACTIONS(514),
    [anon_sym_uint176] = ACTIONS(514),
    [anon_sym_uint184] = ACTIONS(514),
    [anon_sym_uint192] = ACTIONS(514),
    [anon_sym_uint200] = ACTIONS(514),
    [anon_sym_uint208] = ACTIONS(514),
    [anon_sym_uint216] = ACTIONS(514),
    [anon_sym_uint224] = ACTIONS(514),
    [anon_sym_uint232] = ACTIONS(514),
    [anon_sym_uint240] = ACTIONS(514),
    [anon_sym_uint248] = ACTIONS(514),
    [anon_sym_uint256] = ACTIONS(514),
    [anon_sym_bytes] = ACTIONS(514),
    [anon_sym_bytes1] = ACTIONS(514),
    [anon_sym_bytes2] = ACTIONS(514),
    [anon_sym_bytes3] = ACTIONS(514),
    [anon_sym_bytes4] = ACTIONS(514),
    [anon_sym_bytes5] = ACTIONS(514),
    [anon_sym_bytes6] = ACTIONS(514),
    [anon_sym_bytes7] = ACTIONS(514),
    [anon_sym_bytes8] = ACTIONS(514),
    [anon_sym_bytes9] = ACTIONS(514),
    [anon_sym_bytes10] = ACTIONS(514),
    [anon_sym_bytes11] = ACTIONS(514),
    [anon_sym_bytes12] = ACTIONS(514),
    [anon_sym_bytes13] = ACTIONS(514),
    [anon_sym_bytes14] = ACTIONS(514),
    [anon_sym_bytes15] = ACTIONS(514),
    [anon_sym_bytes16] = ACTIONS(514),
    [anon_sym_bytes17] = ACTIONS(514),
    [anon_sym_bytes18] = ACTIONS(514),
    [anon_sym_bytes19] = ACTIONS(514),
    [anon_sym_bytes20] = ACTIONS(514),
    [anon_sym_bytes21] = ACTIONS(514),
    [anon_sym_bytes22] = ACTIONS(514),
    [anon_sym_bytes23] = ACTIONS(514),
    [anon_sym_bytes24] = ACTIONS(514),
    [anon_sym_bytes25] = ACTIONS(514),
    [anon_sym_bytes26] = ACTIONS(514),
    [anon_sym_bytes27] = ACTIONS(514),
    [anon_sym_bytes28] = ACTIONS(514),
    [anon_sym_bytes29] = ACTIONS(514),
    [anon_sym_bytes30] = ACTIONS(514),
    [anon_sym_bytes31] = ACTIONS(514),
    [anon_sym_bytes32] = ACTIONS(514),
    [anon_sym_fixed] = ACTIONS(514),
    [aux_sym__fixed_token1] = ACTIONS(514),
    [anon_sym_ufixed] = ACTIONS(514),
    [aux_sym__ufixed_token1] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(534),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_type] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_assembly] = ACTIONS(532),
    [anon_sym_break] = ACTIONS(532),
    [anon_sym_continue] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(532),
    [anon_sym_false] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_byte] = ACTIONS(532),
    [anon_sym_address] = ACTIONS(532),
    [anon_sym_return] = ACTIONS(532),
    [anon_sym_revert] = ACTIONS(532),
    [sym_unchecked] = ACTIONS(532),
    [anon_sym_var] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_emit] = ACTIONS(532),
    [anon_sym_payable] = ACTIONS(532),
    [anon_sym_new] = ACTIONS(532),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(534),
    [anon_sym_delete] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_DASH_DASH] = ACTIONS(534),
    [anon_sym_mapping] = ACTIONS(532),
    [anon_sym_bool] = ACTIONS(532),
    [anon_sym_string] = ACTIONS(532),
    [anon_sym_int] = ACTIONS(532),
    [anon_sym_int8] = ACTIONS(532),
    [anon_sym_int16] = ACTIONS(532),
    [anon_sym_int24] = ACTIONS(532),
    [anon_sym_int32] = ACTIONS(532),
    [anon_sym_int40] = ACTIONS(532),
    [anon_sym_int48] = ACTIONS(532),
    [anon_sym_int56] = ACTIONS(532),
    [anon_sym_int64] = ACTIONS(532),
    [anon_sym_int72] = ACTIONS(532),
    [anon_sym_int80] = ACTIONS(532),
    [anon_sym_int88] = ACTIONS(532),
    [anon_sym_int96] = ACTIONS(532),
    [anon_sym_int104] = ACTIONS(532),
    [anon_sym_int112] = ACTIONS(532),
    [anon_sym_int120] = ACTIONS(532),
    [anon_sym_int128] = ACTIONS(532),
    [anon_sym_int136] = ACTIONS(532),
    [anon_sym_int144] = ACTIONS(532),
    [anon_sym_int152] = ACTIONS(532),
    [anon_sym_int160] = ACTIONS(532),
    [anon_sym_int168] = ACTIONS(532),
    [anon_sym_int176] = ACTIONS(532),
    [anon_sym_int184] = ACTIONS(532),
    [anon_sym_int192] = ACTIONS(532),
    [anon_sym_int200] = ACTIONS(532),
    [anon_sym_int208] = ACTIONS(532),
    [anon_sym_int216] = ACTIONS(532),
    [anon_sym_int224] = ACTIONS(532),
    [anon_sym_int232] = ACTIONS(532),
    [anon_sym_int240] = ACTIONS(532),
    [anon_sym_int248] = ACTIONS(532),
    [anon_sym_int256] = ACTIONS(532),
    [anon_sym_uint] = ACTIONS(532),
    [anon_sym_uint8] = ACTIONS(532),
    [anon_sym_uint16] = ACTIONS(532),
    [anon_sym_uint24] = ACTIONS(532),
    [anon_sym_uint32] = ACTIONS(532),
    [anon_sym_uint40] = ACTIONS(532),
    [anon_sym_uint48] = ACTIONS(532),
    [anon_sym_uint56] = ACTIONS(532),
    [anon_sym_uint64] = ACTIONS(532),
    [anon_sym_uint72] = ACTIONS(532),
    [anon_sym_uint80] = ACTIONS(532),
    [anon_sym_uint88] = ACTIONS(532),
    [anon_sym_uint96] = ACTIONS(532),
    [anon_sym_uint104] = ACTIONS(532),
    [anon_sym_uint112] = ACTIONS(532),
    [anon_sym_uint120] = ACTIONS(532),
    [anon_sym_uint128] = ACTIONS(532),
    [anon_sym_uint136] = ACTIONS(532),
    [anon_sym_uint144] = ACTIONS(532),
    [anon_sym_uint152] = ACTIONS(532),
    [anon_sym_uint160] = ACTIONS(532),
    [anon_sym_uint168] = ACTIONS(532),
    [anon_sym_uint176] = ACTIONS(532),
    [anon_sym_uint184] = ACTIONS(532),
    [anon_sym_uint192] = ACTIONS(532),
    [anon_sym_uint200] = ACTIONS(532),
    [anon_sym_uint208] = ACTIONS(532),
    [anon_sym_uint216] = ACTIONS(532),
    [anon_sym_uint224] = ACTIONS(532),
    [anon_sym_uint232] = ACTIONS(532),
    [anon_sym_uint240] = ACTIONS(532),
    [anon_sym_uint248] = ACTIONS(532),
    [anon_sym_uint256] = ACTIONS(532),
    [anon_sym_bytes] = ACTIONS(532),
    [anon_sym_bytes1] = ACTIONS(532),
    [anon_sym_bytes2] = ACTIONS(532),
    [anon_sym_bytes3] = ACTIONS(532),
    [anon_sym_bytes4] = ACTIONS(532),
    [anon_sym_bytes5] = ACTIONS(532),
    [anon_sym_bytes6] = ACTIONS(532),
    [anon_sym_bytes7] = ACTIONS(532),
    [anon_sym_bytes8] = ACTIONS(532),
    [anon_sym_bytes9] = ACTIONS(532),
    [anon_sym_bytes10] = ACTIONS(532),
    [anon_sym_bytes11] = ACTIONS(532),
    [anon_sym_bytes12] = ACTIONS(532),
    [anon_sym_bytes13] = ACTIONS(532),
    [anon_sym_bytes14] = ACTIONS(532),
    [anon_sym_bytes15] = ACTIONS(532),
    [anon_sym_bytes16] = ACTIONS(532),
    [anon_sym_bytes17] = ACTIONS(532),
    [anon_sym_bytes18] = ACTIONS(532),
    [anon_sym_bytes19] = ACTIONS(532),
    [anon_sym_bytes20] = ACTIONS(532),
    [anon_sym_bytes21] = ACTIONS(532),
    [anon_sym_bytes22] = ACTIONS(532),
    [anon_sym_bytes23] = ACTIONS(532),
    [anon_sym_bytes24] = ACTIONS(532),
    [anon_sym_bytes25] = ACTIONS(532),
    [anon_sym_bytes26] = ACTIONS(532),
    [anon_sym_bytes27] = ACTIONS(532),
    [anon_sym_bytes28] = ACTIONS(532),
    [anon_sym_bytes29] = ACTIONS(532),
    [anon_sym_bytes30] = ACTIONS(532),
    [anon_sym_bytes31] = ACTIONS(532),
    [anon_sym_bytes32] = ACTIONS(532),
    [anon_sym_fixed] = ACTIONS(532),
    [aux_sym__fixed_token1] = ACTIONS(532),
    [anon_sym_ufixed] = ACTIONS(532),
    [aux_sym__ufixed_token1] = ACTIONS(532),
    [aux_sym__decimal_number_token1] = ACTIONS(532),
    [aux_sym__decimal_number_token2] = ACTIONS(534),
    [aux_sym__hex_number_token1] = ACTIONS(534),
    [anon_sym_hex] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(534),
    [anon_sym_unicode] = ACTIONS(532),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(538),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(536),
    [anon_sym_assembly] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(536),
    [anon_sym_continue] = ACTIONS(536),
    [anon_sym_true] = ACTIONS(536),
    [anon_sym_false] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_function] = ACTIONS(536),
    [anon_sym_byte] = ACTIONS(536),
    [anon_sym_address] = ACTIONS(536),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_revert] = ACTIONS(536),
    [sym_unchecked] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(536),
    [anon_sym_else] = ACTIONS(536),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(536),
    [anon_sym_emit] = ACTIONS(536),
    [anon_sym_payable] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_delete] = ACTIONS(536),
    [anon_sym_PLUS_PLUS] = ACTIONS(538),
    [anon_sym_DASH_DASH] = ACTIONS(538),
    [anon_sym_mapping] = ACTIONS(536),
    [anon_sym_bool] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_int] = ACTIONS(536),
    [anon_sym_int8] = ACTIONS(536),
    [anon_sym_int16] = ACTIONS(536),
    [anon_sym_int24] = ACTIONS(536),
    [anon_sym_int32] = ACTIONS(536),
    [anon_sym_int40] = ACTIONS(536),
    [anon_sym_int48] = ACTIONS(536),
    [anon_sym_int56] = ACTIONS(536),
    [anon_sym_int64] = ACTIONS(536),
    [anon_sym_int72] = ACTIONS(536),
    [anon_sym_int80] = ACTIONS(536),
    [anon_sym_int88] = ACTIONS(536),
    [anon_sym_int96] = ACTIONS(536),
    [anon_sym_int104] = ACTIONS(536),
    [anon_sym_int112] = ACTIONS(536),
    [anon_sym_int120] = ACTIONS(536),
    [anon_sym_int128] = ACTIONS(536),
    [anon_sym_int136] = ACTIONS(536),
    [anon_sym_int144] = ACTIONS(536),
    [anon_sym_int152] = ACTIONS(536),
    [anon_sym_int160] = ACTIONS(536),
    [anon_sym_int168] = ACTIONS(536),
    [anon_sym_int176] = ACTIONS(536),
    [anon_sym_int184] = ACTIONS(536),
    [anon_sym_int192] = ACTIONS(536),
    [anon_sym_int200] = ACTIONS(536),
    [anon_sym_int208] = ACTIONS(536),
    [anon_sym_int216] = ACTIONS(536),
    [anon_sym_int224] = ACTIONS(536),
    [anon_sym_int232] = ACTIONS(536),
    [anon_sym_int240] = ACTIONS(536),
    [anon_sym_int248] = ACTIONS(536),
    [anon_sym_int256] = ACTIONS(536),
    [anon_sym_uint] = ACTIONS(536),
    [anon_sym_uint8] = ACTIONS(536),
    [anon_sym_uint16] = ACTIONS(536),
    [anon_sym_uint24] = ACTIONS(536),
    [anon_sym_uint32] = ACTIONS(536),
    [anon_sym_uint40] = ACTIONS(536),
    [anon_sym_uint48] = ACTIONS(536),
    [anon_sym_uint56] = ACTIONS(536),
    [anon_sym_uint64] = ACTIONS(536),
    [anon_sym_uint72] = ACTIONS(536),
    [anon_sym_uint80] = ACTIONS(536),
    [anon_sym_uint88] = ACTIONS(536),
    [anon_sym_uint96] = ACTIONS(536),
    [anon_sym_uint104] = ACTIONS(536),
    [anon_sym_uint112] = ACTIONS(536),
    [anon_sym_uint120] = ACTIONS(536),
    [anon_sym_uint128] = ACTIONS(536),
    [anon_sym_uint136] = ACTIONS(536),
    [anon_sym_uint144] = ACTIONS(536),
    [anon_sym_uint152] = ACTIONS(536),
    [anon_sym_uint160] = ACTIONS(536),
    [anon_sym_uint168] = ACTIONS(536),
    [anon_sym_uint176] = ACTIONS(536),
    [anon_sym_uint184] = ACTIONS(536),
    [anon_sym_uint192] = ACTIONS(536),
    [anon_sym_uint200] = ACTIONS(536),
    [anon_sym_uint208] = ACTIONS(536),
    [anon_sym_uint216] = ACTIONS(536),
    [anon_sym_uint224] = ACTIONS(536),
    [anon_sym_uint232] = ACTIONS(536),
    [anon_sym_uint240] = ACTIONS(536),
    [anon_sym_uint248] = ACTIONS(536),
    [anon_sym_uint256] = ACTIONS(536),
    [anon_sym_bytes] = ACTIONS(536),
    [anon_sym_bytes1] = ACTIONS(536),
    [anon_sym_bytes2] = ACTIONS(536),
    [anon_sym_bytes3] = ACTIONS(536),
    [anon_sym_bytes4] = ACTIONS(536),
    [anon_sym_bytes5] = ACTIONS(536),
    [anon_sym_bytes6] = ACTIONS(536),
    [anon_sym_bytes7] = ACTIONS(536),
    [anon_sym_bytes8] = ACTIONS(536),
    [anon_sym_bytes9] = ACTIONS(536),
    [anon_sym_bytes10] = ACTIONS(536),
    [anon_sym_bytes11] = ACTIONS(536),
    [anon_sym_bytes12] = ACTIONS(536),
    [anon_sym_bytes13] = ACTIONS(536),
    [anon_sym_bytes14] = ACTIONS(536),
    [anon_sym_bytes15] = ACTIONS(536),
    [anon_sym_bytes16] = ACTIONS(536),
    [anon_sym_bytes17] = ACTIONS(536),
    [anon_sym_bytes18] = ACTIONS(536),
    [anon_sym_bytes19] = ACTIONS(536),
    [anon_sym_bytes20] = ACTIONS(536),
    [anon_sym_bytes21] = ACTIONS(536),
    [anon_sym_bytes22] = ACTIONS(536),
    [anon_sym_bytes23] = ACTIONS(536),
    [anon_sym_bytes24] = ACTIONS(536),
    [anon_sym_bytes25] = ACTIONS(536),
    [anon_sym_bytes26] = ACTIONS(536),
    [anon_sym_bytes27] = ACTIONS(536),
    [anon_sym_bytes28] = ACTIONS(536),
    [anon_sym_bytes29] = ACTIONS(536),
    [anon_sym_bytes30] = ACTIONS(536),
    [anon_sym_bytes31] = ACTIONS(536),
    [anon_sym_bytes32] = ACTIONS(536),
    [anon_sym_fixed] = ACTIONS(536),
    [aux_sym__fixed_token1] = ACTIONS(536),
    [anon_sym_ufixed] = ACTIONS(536),
    [aux_sym__ufixed_token1] = ACTIONS(536),
    [aux_sym__decimal_number_token1] = ACTIONS(536),
    [aux_sym__decimal_number_token2] = ACTIONS(538),
    [aux_sym__hex_number_token1] = ACTIONS(538),
    [anon_sym_hex] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [anon_sym_SQUOTE] = ACTIONS(538),
    [anon_sym_unicode] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_variable_declaration] = STATE(723),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_struct_member] = STATE(109),
    [sym_type_name] = STATE(706),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_struct_body_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_variable_declaration] = STATE(723),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(546),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_struct_member] = STATE(109),
    [sym_type_name] = STATE(706),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_struct_body_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_variable_declaration] = STATE(723),
    [sym_type_name] = STATE(486),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_struct_member] = STATE(109),
    [sym_type_name] = STATE(706),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_struct_body_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_function] = ACTIONS(555),
    [anon_sym_byte] = ACTIONS(558),
    [anon_sym_address] = ACTIONS(561),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_mapping] = ACTIONS(564),
    [anon_sym_bool] = ACTIONS(558),
    [anon_sym_string] = ACTIONS(558),
    [anon_sym_int] = ACTIONS(558),
    [anon_sym_int8] = ACTIONS(558),
    [anon_sym_int16] = ACTIONS(558),
    [anon_sym_int24] = ACTIONS(558),
    [anon_sym_int32] = ACTIONS(558),
    [anon_sym_int40] = ACTIONS(558),
    [anon_sym_int48] = ACTIONS(558),
    [anon_sym_int56] = ACTIONS(558),
    [anon_sym_int64] = ACTIONS(558),
    [anon_sym_int72] = ACTIONS(558),
    [anon_sym_int80] = ACTIONS(558),
    [anon_sym_int88] = ACTIONS(558),
    [anon_sym_int96] = ACTIONS(558),
    [anon_sym_int104] = ACTIONS(558),
    [anon_sym_int112] = ACTIONS(558),
    [anon_sym_int120] = ACTIONS(558),
    [anon_sym_int128] = ACTIONS(558),
    [anon_sym_int136] = ACTIONS(558),
    [anon_sym_int144] = ACTIONS(558),
    [anon_sym_int152] = ACTIONS(558),
    [anon_sym_int160] = ACTIONS(558),
    [anon_sym_int168] = ACTIONS(558),
    [anon_sym_int176] = ACTIONS(558),
    [anon_sym_int184] = ACTIONS(558),
    [anon_sym_int192] = ACTIONS(558),
    [anon_sym_int200] = ACTIONS(558),
    [anon_sym_int208] = ACTIONS(558),
    [anon_sym_int216] = ACTIONS(558),
    [anon_sym_int224] = ACTIONS(558),
    [anon_sym_int232] = ACTIONS(558),
    [anon_sym_int240] = ACTIONS(558),
    [anon_sym_int248] = ACTIONS(558),
    [anon_sym_int256] = ACTIONS(558),
    [anon_sym_uint] = ACTIONS(558),
    [anon_sym_uint8] = ACTIONS(558),
    [anon_sym_uint16] = ACTIONS(558),
    [anon_sym_uint24] = ACTIONS(558),
    [anon_sym_uint32] = ACTIONS(558),
    [anon_sym_uint40] = ACTIONS(558),
    [anon_sym_uint48] = ACTIONS(558),
    [anon_sym_uint56] = ACTIONS(558),
    [anon_sym_uint64] = ACTIONS(558),
    [anon_sym_uint72] = ACTIONS(558),
    [anon_sym_uint80] = ACTIONS(558),
    [anon_sym_uint88] = ACTIONS(558),
    [anon_sym_uint96] = ACTIONS(558),
    [anon_sym_uint104] = ACTIONS(558),
    [anon_sym_uint112] = ACTIONS(558),
    [anon_sym_uint120] = ACTIONS(558),
    [anon_sym_uint128] = ACTIONS(558),
    [anon_sym_uint136] = ACTIONS(558),
    [anon_sym_uint144] = ACTIONS(558),
    [anon_sym_uint152] = ACTIONS(558),
    [anon_sym_uint160] = ACTIONS(558),
    [anon_sym_uint168] = ACTIONS(558),
    [anon_sym_uint176] = ACTIONS(558),
    [anon_sym_uint184] = ACTIONS(558),
    [anon_sym_uint192] = ACTIONS(558),
    [anon_sym_uint200] = ACTIONS(558),
    [anon_sym_uint208] = ACTIONS(558),
    [anon_sym_uint216] = ACTIONS(558),
    [anon_sym_uint224] = ACTIONS(558),
    [anon_sym_uint232] = ACTIONS(558),
    [anon_sym_uint240] = ACTIONS(558),
    [anon_sym_uint248] = ACTIONS(558),
    [anon_sym_uint256] = ACTIONS(558),
    [anon_sym_bytes] = ACTIONS(558),
    [anon_sym_bytes1] = ACTIONS(558),
    [anon_sym_bytes2] = ACTIONS(558),
    [anon_sym_bytes3] = ACTIONS(558),
    [anon_sym_bytes4] = ACTIONS(558),
    [anon_sym_bytes5] = ACTIONS(558),
    [anon_sym_bytes6] = ACTIONS(558),
    [anon_sym_bytes7] = ACTIONS(558),
    [anon_sym_bytes8] = ACTIONS(558),
    [anon_sym_bytes9] = ACTIONS(558),
    [anon_sym_bytes10] = ACTIONS(558),
    [anon_sym_bytes11] = ACTIONS(558),
    [anon_sym_bytes12] = ACTIONS(558),
    [anon_sym_bytes13] = ACTIONS(558),
    [anon_sym_bytes14] = ACTIONS(558),
    [anon_sym_bytes15] = ACTIONS(558),
    [anon_sym_bytes16] = ACTIONS(558),
    [anon_sym_bytes17] = ACTIONS(558),
    [anon_sym_bytes18] = ACTIONS(558),
    [anon_sym_bytes19] = ACTIONS(558),
    [anon_sym_bytes20] = ACTIONS(558),
    [anon_sym_bytes21] = ACTIONS(558),
    [anon_sym_bytes22] = ACTIONS(558),
    [anon_sym_bytes23] = ACTIONS(558),
    [anon_sym_bytes24] = ACTIONS(558),
    [anon_sym_bytes25] = ACTIONS(558),
    [anon_sym_bytes26] = ACTIONS(558),
    [anon_sym_bytes27] = ACTIONS(558),
    [anon_sym_bytes28] = ACTIONS(558),
    [anon_sym_bytes29] = ACTIONS(558),
    [anon_sym_bytes30] = ACTIONS(558),
    [anon_sym_bytes31] = ACTIONS(558),
    [anon_sym_bytes32] = ACTIONS(558),
    [anon_sym_fixed] = ACTIONS(558),
    [aux_sym__fixed_token1] = ACTIONS(558),
    [anon_sym_ufixed] = ACTIONS(558),
    [aux_sym__ufixed_token1] = ACTIONS(558),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_struct_member] = STATE(105),
    [sym_type_name] = STATE(706),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_struct_body_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_event_parameter] = STATE(587),
    [sym_type_name] = STATE(479),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_error_parameter] = STATE(644),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_type_name] = STATE(469),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_parameter] = STATE(708),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(571),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_error_parameter] = STATE(644),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_any_source_type] = STATE(780),
    [sym_type_name] = STATE(731),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(575),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_type_name] = STATE(471),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym__nameless_parameter] = STATE(656),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(577),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_error_parameter] = STATE(538),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(579),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_type_name] = STATE(469),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_parameter] = STATE(557),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(581),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_struct_member] = STATE(107),
    [sym_type_name] = STATE(706),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [aux_sym_struct_body_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_event_parameter] = STATE(668),
    [sym_type_name] = STATE(479),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_event_parameter] = STATE(668),
    [sym_type_name] = STATE(479),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_error_parameter] = STATE(644),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(587),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_error_parameter] = STATE(567),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_error_parameter] = STATE(644),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(591),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_type_name] = STATE(469),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_parameter] = STATE(708),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_type_name] = STATE(471),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym__nameless_parameter] = STATE(656),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_type_name] = STATE(471),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym__nameless_parameter] = STATE(619),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_event_parameter] = STATE(668),
    [sym_type_name] = STATE(479),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_type_name] = STATE(471),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym__nameless_parameter] = STATE(656),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_error_parameter] = STATE(644),
    [sym_type_name] = STATE(503),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_type_name] = STATE(469),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_parameter] = STATE(708),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_type_name] = STATE(609),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_type_name] = STATE(620),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_type_name] = STATE(669),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_type_name] = STATE(359),
    [sym__array_type] = STATE(318),
    [sym__function_type] = STATE(327),
    [sym_user_defined_type] = STATE(318),
    [sym__identifier_path] = STATE(315),
    [sym__mapping] = STATE(324),
    [sym_primitive_type] = STATE(318),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(597),
    [anon_sym_function] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_mapping] = ACTIONS(35),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_identifier] = ACTIONS(599),
    [anon_sym_RBRACE] = ACTIONS(601),
    [anon_sym_type] = ACTIONS(599),
    [anon_sym_error] = ACTIONS(599),
    [anon_sym_struct] = ACTIONS(599),
    [anon_sym_enum] = ACTIONS(599),
    [anon_sym_event] = ACTIONS(599),
    [anon_sym_using] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(599),
    [anon_sym_byte] = ACTIONS(599),
    [anon_sym_address] = ACTIONS(599),
    [anon_sym_var] = ACTIONS(599),
    [anon_sym_modifier] = ACTIONS(599),
    [anon_sym_constructor] = ACTIONS(599),
    [anon_sym_fallback] = ACTIONS(599),
    [anon_sym_receive] = ACTIONS(599),
    [anon_sym_mapping] = ACTIONS(599),
    [anon_sym_bool] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_int] = ACTIONS(599),
    [anon_sym_int8] = ACTIONS(599),
    [anon_sym_int16] = ACTIONS(599),
    [anon_sym_int24] = ACTIONS(599),
    [anon_sym_int32] = ACTIONS(599),
    [anon_sym_int40] = ACTIONS(599),
    [anon_sym_int48] = ACTIONS(599),
    [anon_sym_int56] = ACTIONS(599),
    [anon_sym_int64] = ACTIONS(599),
    [anon_sym_int72] = ACTIONS(599),
    [anon_sym_int80] = ACTIONS(599),
    [anon_sym_int88] = ACTIONS(599),
    [anon_sym_int96] = ACTIONS(599),
    [anon_sym_int104] = ACTIONS(599),
    [anon_sym_int112] = ACTIONS(599),
    [anon_sym_int120] = ACTIONS(599),
    [anon_sym_int128] = ACTIONS(599),
    [anon_sym_int136] = ACTIONS(599),
    [anon_sym_int144] = ACTIONS(599),
    [anon_sym_int152] = ACTIONS(599),
    [anon_sym_int160] = ACTIONS(599),
    [anon_sym_int168] = ACTIONS(599),
    [anon_sym_int176] = ACTIONS(599),
    [anon_sym_int184] = ACTIONS(599),
    [anon_sym_int192] = ACTIONS(599),
    [anon_sym_int200] = ACTIONS(599),
    [anon_sym_int208] = ACTIONS(599),
    [anon_sym_int216] = ACTIONS(599),
    [anon_sym_int224] = ACTIONS(599),
    [anon_sym_int232] = ACTIONS(599),
    [anon_sym_int240] = ACTIONS(599),
    [anon_sym_int248] = ACTIONS(599),
    [anon_sym_int256] = ACTIONS(599),
    [anon_sym_uint] = ACTIONS(599),
    [anon_sym_uint8] = ACTIONS(599),
    [anon_sym_uint16] = ACTIONS(599),
    [anon_sym_uint24] = ACTIONS(599),
    [anon_sym_uint32] = ACTIONS(599),
    [anon_sym_uint40] = ACTIONS(599),
    [anon_sym_uint48] = ACTIONS(599),
    [anon_sym_uint56] = ACTIONS(599),
    [anon_sym_uint64] = ACTIONS(599),
    [anon_sym_uint72] = ACTIONS(599),
    [anon_sym_uint80] = ACTIONS(599),
    [anon_sym_uint88] = ACTIONS(599),
    [anon_sym_uint96] = ACTIONS(599),
    [anon_sym_uint104] = ACTIONS(599),
    [anon_sym_uint112] = ACTIONS(599),
    [anon_sym_uint120] = ACTIONS(599),
    [anon_sym_uint128] = ACTIONS(599),
    [anon_sym_uint136] = ACTIONS(599),
    [anon_sym_uint144] = ACTIONS(599),
    [anon_sym_uint152] = ACTIONS(599),
    [anon_sym_uint160] = ACTIONS(599),
    [anon_sym_uint168] = ACTIONS(599),
    [anon_sym_uint176] = ACTIONS(599),
    [anon_sym_uint184] = ACTIONS(599),
    [anon_sym_uint192] = ACTIONS(599),
    [anon_sym_uint200] = ACTIONS(599),
    [anon_sym_uint208] = ACTIONS(599),
    [anon_sym_uint216] = ACTIONS(599),
    [anon_sym_uint224] = ACTIONS(599),
    [anon_sym_uint232] = ACTIONS(599),
    [anon_sym_uint240] = ACTIONS(599),
    [anon_sym_uint248] = ACTIONS(599),
    [anon_sym_uint256] = ACTIONS(599),
    [anon_sym_bytes] = ACTIONS(599),
    [anon_sym_bytes1] = ACTIONS(599),
    [anon_sym_bytes2] = ACTIONS(599),
    [anon_sym_bytes3] = ACTIONS(599),
    [anon_sym_bytes4] = ACTIONS(599),
    [anon_sym_bytes5] = ACTIONS(599),
    [anon_sym_bytes6] = ACTIONS(599),
    [anon_sym_bytes7] = ACTIONS(599),
    [anon_sym_bytes8] = ACTIONS(599),
    [anon_sym_bytes9] = ACTIONS(599),
    [anon_sym_bytes10] = ACTIONS(599),
    [anon_sym_bytes11] = ACTIONS(599),
    [anon_sym_bytes12] = ACTIONS(599),
    [anon_sym_bytes13] = ACTIONS(599),
    [anon_sym_bytes14] = ACTIONS(599),
    [anon_sym_bytes15] = ACTIONS(599),
    [anon_sym_bytes16] = ACTIONS(599),
    [anon_sym_bytes17] = ACTIONS(599),
    [anon_sym_bytes18] = ACTIONS(599),
    [anon_sym_bytes19] = ACTIONS(599),
    [anon_sym_bytes20] = ACTIONS(599),
    [anon_sym_bytes21] = ACTIONS(599),
    [anon_sym_bytes22] = ACTIONS(599),
    [anon_sym_bytes23] = ACTIONS(599),
    [anon_sym_bytes24] = ACTIONS(599),
    [anon_sym_bytes25] = ACTIONS(599),
    [anon_sym_bytes26] = ACTIONS(599),
    [anon_sym_bytes27] = ACTIONS(599),
    [anon_sym_bytes28] = ACTIONS(599),
    [anon_sym_bytes29] = ACTIONS(599),
    [anon_sym_bytes30] = ACTIONS(599),
    [anon_sym_bytes31] = ACTIONS(599),
    [anon_sym_bytes32] = ACTIONS(599),
    [anon_sym_fixed] = ACTIONS(599),
    [aux_sym__fixed_token1] = ACTIONS(599),
    [anon_sym_ufixed] = ACTIONS(599),
    [aux_sym__ufixed_token1] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_identifier] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(603),
    [anon_sym_error] = ACTIONS(603),
    [anon_sym_struct] = ACTIONS(603),
    [anon_sym_enum] = ACTIONS(603),
    [anon_sym_event] = ACTIONS(603),
    [anon_sym_using] = ACTIONS(603),
    [anon_sym_function] = ACTIONS(603),
    [anon_sym_byte] = ACTIONS(603),
    [anon_sym_address] = ACTIONS(603),
    [anon_sym_var] = ACTIONS(603),
    [anon_sym_modifier] = ACTIONS(603),
    [anon_sym_constructor] = ACTIONS(603),
    [anon_sym_fallback] = ACTIONS(603),
    [anon_sym_receive] = ACTIONS(603),
    [anon_sym_mapping] = ACTIONS(603),
    [anon_sym_bool] = ACTIONS(603),
    [anon_sym_string] = ACTIONS(603),
    [anon_sym_int] = ACTIONS(603),
    [anon_sym_int8] = ACTIONS(603),
    [anon_sym_int16] = ACTIONS(603),
    [anon_sym_int24] = ACTIONS(603),
    [anon_sym_int32] = ACTIONS(603),
    [anon_sym_int40] = ACTIONS(603),
    [anon_sym_int48] = ACTIONS(603),
    [anon_sym_int56] = ACTIONS(603),
    [anon_sym_int64] = ACTIONS(603),
    [anon_sym_int72] = ACTIONS(603),
    [anon_sym_int80] = ACTIONS(603),
    [anon_sym_int88] = ACTIONS(603),
    [anon_sym_int96] = ACTIONS(603),
    [anon_sym_int104] = ACTIONS(603),
    [anon_sym_int112] = ACTIONS(603),
    [anon_sym_int120] = ACTIONS(603),
    [anon_sym_int128] = ACTIONS(603),
    [anon_sym_int136] = ACTIONS(603),
    [anon_sym_int144] = ACTIONS(603),
    [anon_sym_int152] = ACTIONS(603),
    [anon_sym_int160] = ACTIONS(603),
    [anon_sym_int168] = ACTIONS(603),
    [anon_sym_int176] = ACTIONS(603),
    [anon_sym_int184] = ACTIONS(603),
    [anon_sym_int192] = ACTIONS(603),
    [anon_sym_int200] = ACTIONS(603),
    [anon_sym_int208] = ACTIONS(603),
    [anon_sym_int216] = ACTIONS(603),
    [anon_sym_int224] = ACTIONS(603),
    [anon_sym_int232] = ACTIONS(603),
    [anon_sym_int240] = ACTIONS(603),
    [anon_sym_int248] = ACTIONS(603),
    [anon_sym_int256] = ACTIONS(603),
    [anon_sym_uint] = ACTIONS(603),
    [anon_sym_uint8] = ACTIONS(603),
    [anon_sym_uint16] = ACTIONS(603),
    [anon_sym_uint24] = ACTIONS(603),
    [anon_sym_uint32] = ACTIONS(603),
    [anon_sym_uint40] = ACTIONS(603),
    [anon_sym_uint48] = ACTIONS(603),
    [anon_sym_uint56] = ACTIONS(603),
    [anon_sym_uint64] = ACTIONS(603),
    [anon_sym_uint72] = ACTIONS(603),
    [anon_sym_uint80] = ACTIONS(603),
    [anon_sym_uint88] = ACTIONS(603),
    [anon_sym_uint96] = ACTIONS(603),
    [anon_sym_uint104] = ACTIONS(603),
    [anon_sym_uint112] = ACTIONS(603),
    [anon_sym_uint120] = ACTIONS(603),
    [anon_sym_uint128] = ACTIONS(603),
    [anon_sym_uint136] = ACTIONS(603),
    [anon_sym_uint144] = ACTIONS(603),
    [anon_sym_uint152] = ACTIONS(603),
    [anon_sym_uint160] = ACTIONS(603),
    [anon_sym_uint168] = ACTIONS(603),
    [anon_sym_uint176] = ACTIONS(603),
    [anon_sym_uint184] = ACTIONS(603),
    [anon_sym_uint192] = ACTIONS(603),
    [anon_sym_uint200] = ACTIONS(603),
    [anon_sym_uint208] = ACTIONS(603),
    [anon_sym_uint216] = ACTIONS(603),
    [anon_sym_uint224] = ACTIONS(603),
    [anon_sym_uint232] = ACTIONS(603),
    [anon_sym_uint240] = ACTIONS(603),
    [anon_sym_uint248] = ACTIONS(603),
    [anon_sym_uint256] = ACTIONS(603),
    [anon_sym_bytes] = ACTIONS(603),
    [anon_sym_bytes1] = ACTIONS(603),
    [anon_sym_bytes2] = ACTIONS(603),
    [anon_sym_bytes3] = ACTIONS(603),
    [anon_sym_bytes4] = ACTIONS(603),
    [anon_sym_bytes5] = ACTIONS(603),
    [anon_sym_bytes6] = ACTIONS(603),
    [anon_sym_bytes7] = ACTIONS(603),
    [anon_sym_bytes8] = ACTIONS(603),
    [anon_sym_bytes9] = ACTIONS(603),
    [anon_sym_bytes10] = ACTIONS(603),
    [anon_sym_bytes11] = ACTIONS(603),
    [anon_sym_bytes12] = ACTIONS(603),
    [anon_sym_bytes13] = ACTIONS(603),
    [anon_sym_bytes14] = ACTIONS(603),
    [anon_sym_bytes15] = ACTIONS(603),
    [anon_sym_bytes16] = ACTIONS(603),
    [anon_sym_bytes17] = ACTIONS(603),
    [anon_sym_bytes18] = ACTIONS(603),
    [anon_sym_bytes19] = ACTIONS(603),
    [anon_sym_bytes20] = ACTIONS(603),
    [anon_sym_bytes21] = ACTIONS(603),
    [anon_sym_bytes22] = ACTIONS(603),
    [anon_sym_bytes23] = ACTIONS(603),
    [anon_sym_bytes24] = ACTIONS(603),
    [anon_sym_bytes25] = ACTIONS(603),
    [anon_sym_bytes26] = ACTIONS(603),
    [anon_sym_bytes27] = ACTIONS(603),
    [anon_sym_bytes28] = ACTIONS(603),
    [anon_sym_bytes29] = ACTIONS(603),
    [anon_sym_bytes30] = ACTIONS(603),
    [anon_sym_bytes31] = ACTIONS(603),
    [anon_sym_bytes32] = ACTIONS(603),
    [anon_sym_fixed] = ACTIONS(603),
    [aux_sym__fixed_token1] = ACTIONS(603),
    [anon_sym_ufixed] = ACTIONS(603),
    [aux_sym__ufixed_token1] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_identifier] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_type] = ACTIONS(607),
    [anon_sym_error] = ACTIONS(607),
    [anon_sym_struct] = ACTIONS(607),
    [anon_sym_enum] = ACTIONS(607),
    [anon_sym_event] = ACTIONS(607),
    [anon_sym_using] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(607),
    [anon_sym_byte] = ACTIONS(607),
    [anon_sym_address] = ACTIONS(607),
    [anon_sym_var] = ACTIONS(607),
    [anon_sym_modifier] = ACTIONS(607),
    [anon_sym_constructor] = ACTIONS(607),
    [anon_sym_fallback] = ACTIONS(607),
    [anon_sym_receive] = ACTIONS(607),
    [anon_sym_mapping] = ACTIONS(607),
    [anon_sym_bool] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_int8] = ACTIONS(607),
    [anon_sym_int16] = ACTIONS(607),
    [anon_sym_int24] = ACTIONS(607),
    [anon_sym_int32] = ACTIONS(607),
    [anon_sym_int40] = ACTIONS(607),
    [anon_sym_int48] = ACTIONS(607),
    [anon_sym_int56] = ACTIONS(607),
    [anon_sym_int64] = ACTIONS(607),
    [anon_sym_int72] = ACTIONS(607),
    [anon_sym_int80] = ACTIONS(607),
    [anon_sym_int88] = ACTIONS(607),
    [anon_sym_int96] = ACTIONS(607),
    [anon_sym_int104] = ACTIONS(607),
    [anon_sym_int112] = ACTIONS(607),
    [anon_sym_int120] = ACTIONS(607),
    [anon_sym_int128] = ACTIONS(607),
    [anon_sym_int136] = ACTIONS(607),
    [anon_sym_int144] = ACTIONS(607),
    [anon_sym_int152] = ACTIONS(607),
    [anon_sym_int160] = ACTIONS(607),
    [anon_sym_int168] = ACTIONS(607),
    [anon_sym_int176] = ACTIONS(607),
    [anon_sym_int184] = ACTIONS(607),
    [anon_sym_int192] = ACTIONS(607),
    [anon_sym_int200] = ACTIONS(607),
    [anon_sym_int208] = ACTIONS(607),
    [anon_sym_int216] = ACTIONS(607),
    [anon_sym_int224] = ACTIONS(607),
    [anon_sym_int232] = ACTIONS(607),
    [anon_sym_int240] = ACTIONS(607),
    [anon_sym_int248] = ACTIONS(607),
    [anon_sym_int256] = ACTIONS(607),
    [anon_sym_uint] = ACTIONS(607),
    [anon_sym_uint8] = ACTIONS(607),
    [anon_sym_uint16] = ACTIONS(607),
    [anon_sym_uint24] = ACTIONS(607),
    [anon_sym_uint32] = ACTIONS(607),
    [anon_sym_uint40] = ACTIONS(607),
    [anon_sym_uint48] = ACTIONS(607),
    [anon_sym_uint56] = ACTIONS(607),
    [anon_sym_uint64] = ACTIONS(607),
    [anon_sym_uint72] = ACTIONS(607),
    [anon_sym_uint80] = ACTIONS(607),
    [anon_sym_uint88] = ACTIONS(607),
    [anon_sym_uint96] = ACTIONS(607),
    [anon_sym_uint104] = ACTIONS(607),
    [anon_sym_uint112] = ACTIONS(607),
    [anon_sym_uint120] = ACTIONS(607),
    [anon_sym_uint128] = ACTIONS(607),
    [anon_sym_uint136] = ACTIONS(607),
    [anon_sym_uint144] = ACTIONS(607),
    [anon_sym_uint152] = ACTIONS(607),
    [anon_sym_uint160] = ACTIONS(607),
    [anon_sym_uint168] = ACTIONS(607),
    [anon_sym_uint176] = ACTIONS(607),
    [anon_sym_uint184] = ACTIONS(607),
    [anon_sym_uint192] = ACTIONS(607),
    [anon_sym_uint200] = ACTIONS(607),
    [anon_sym_uint208] = ACTIONS(607),
    [anon_sym_uint216] = ACTIONS(607),
    [anon_sym_uint224] = ACTIONS(607),
    [anon_sym_uint232] = ACTIONS(607),
    [anon_sym_uint240] = ACTIONS(607),
    [anon_sym_uint248] = ACTIONS(607),
    [anon_sym_uint256] = ACTIONS(607),
    [anon_sym_bytes] = ACTIONS(607),
    [anon_sym_bytes1] = ACTIONS(607),
    [anon_sym_bytes2] = ACTIONS(607),
    [anon_sym_bytes3] = ACTIONS(607),
    [anon_sym_bytes4] = ACTIONS(607),
    [anon_sym_bytes5] = ACTIONS(607),
    [anon_sym_bytes6] = ACTIONS(607),
    [anon_sym_bytes7] = ACTIONS(607),
    [anon_sym_bytes8] = ACTIONS(607),
    [anon_sym_bytes9] = ACTIONS(607),
    [anon_sym_bytes10] = ACTIONS(607),
    [anon_sym_bytes11] = ACTIONS(607),
    [anon_sym_bytes12] = ACTIONS(607),
    [anon_sym_bytes13] = ACTIONS(607),
    [anon_sym_bytes14] = ACTIONS(607),
    [anon_sym_bytes15] = ACTIONS(607),
    [anon_sym_bytes16] = ACTIONS(607),
    [anon_sym_bytes17] = ACTIONS(607),
    [anon_sym_bytes18] = ACTIONS(607),
    [anon_sym_bytes19] = ACTIONS(607),
    [anon_sym_bytes20] = ACTIONS(607),
    [anon_sym_bytes21] = ACTIONS(607),
    [anon_sym_bytes22] = ACTIONS(607),
    [anon_sym_bytes23] = ACTIONS(607),
    [anon_sym_bytes24] = ACTIONS(607),
    [anon_sym_bytes25] = ACTIONS(607),
    [anon_sym_bytes26] = ACTIONS(607),
    [anon_sym_bytes27] = ACTIONS(607),
    [anon_sym_bytes28] = ACTIONS(607),
    [anon_sym_bytes29] = ACTIONS(607),
    [anon_sym_bytes30] = ACTIONS(607),
    [anon_sym_bytes31] = ACTIONS(607),
    [anon_sym_bytes32] = ACTIONS(607),
    [anon_sym_fixed] = ACTIONS(607),
    [aux_sym__fixed_token1] = ACTIONS(607),
    [anon_sym_ufixed] = ACTIONS(607),
    [aux_sym__ufixed_token1] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym_identifier] = ACTIONS(613),
    [anon_sym_pragma] = ACTIONS(613),
    [anon_sym_import] = ACTIONS(613),
    [anon_sym_type] = ACTIONS(613),
    [anon_sym_abstract] = ACTIONS(613),
    [anon_sym_contract] = ACTIONS(613),
    [anon_sym_error] = ACTIONS(613),
    [anon_sym_interface] = ACTIONS(613),
    [anon_sym_library] = ACTIONS(613),
    [anon_sym_struct] = ACTIONS(613),
    [anon_sym_enum] = ACTIONS(613),
    [anon_sym_function] = ACTIONS(613),
    [anon_sym_byte] = ACTIONS(613),
    [anon_sym_address] = ACTIONS(613),
    [anon_sym_var] = ACTIONS(613),
    [anon_sym_mapping] = ACTIONS(613),
    [anon_sym_bool] = ACTIONS(613),
    [anon_sym_string] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_int8] = ACTIONS(613),
    [anon_sym_int16] = ACTIONS(613),
    [anon_sym_int24] = ACTIONS(613),
    [anon_sym_int32] = ACTIONS(613),
    [anon_sym_int40] = ACTIONS(613),
    [anon_sym_int48] = ACTIONS(613),
    [anon_sym_int56] = ACTIONS(613),
    [anon_sym_int64] = ACTIONS(613),
    [anon_sym_int72] = ACTIONS(613),
    [anon_sym_int80] = ACTIONS(613),
    [anon_sym_int88] = ACTIONS(613),
    [anon_sym_int96] = ACTIONS(613),
    [anon_sym_int104] = ACTIONS(613),
    [anon_sym_int112] = ACTIONS(613),
    [anon_sym_int120] = ACTIONS(613),
    [anon_sym_int128] = ACTIONS(613),
    [anon_sym_int136] = ACTIONS(613),
    [anon_sym_int144] = ACTIONS(613),
    [anon_sym_int152] = ACTIONS(613),
    [anon_sym_int160] = ACTIONS(613),
    [anon_sym_int168] = ACTIONS(613),
    [anon_sym_int176] = ACTIONS(613),
    [anon_sym_int184] = ACTIONS(613),
    [anon_sym_int192] = ACTIONS(613),
    [anon_sym_int200] = ACTIONS(613),
    [anon_sym_int208] = ACTIONS(613),
    [anon_sym_int216] = ACTIONS(613),
    [anon_sym_int224] = ACTIONS(613),
    [anon_sym_int232] = ACTIONS(613),
    [anon_sym_int240] = ACTIONS(613),
    [anon_sym_int248] = ACTIONS(613),
    [anon_sym_int256] = ACTIONS(613),
    [anon_sym_uint] = ACTIONS(613),
    [anon_sym_uint8] = ACTIONS(613),
    [anon_sym_uint16] = ACTIONS(613),
    [anon_sym_uint24] = ACTIONS(613),
    [anon_sym_uint32] = ACTIONS(613),
    [anon_sym_uint40] = ACTIONS(613),
    [anon_sym_uint48] = ACTIONS(613),
    [anon_sym_uint56] = ACTIONS(613),
    [anon_sym_uint64] = ACTIONS(613),
    [anon_sym_uint72] = ACTIONS(613),
    [anon_sym_uint80] = ACTIONS(613),
    [anon_sym_uint88] = ACTIONS(613),
    [anon_sym_uint96] = ACTIONS(613),
    [anon_sym_uint104] = ACTIONS(613),
    [anon_sym_uint112] = ACTIONS(613),
    [anon_sym_uint120] = ACTIONS(613),
    [anon_sym_uint128] = ACTIONS(613),
    [anon_sym_uint136] = ACTIONS(613),
    [anon_sym_uint144] = ACTIONS(613),
    [anon_sym_uint152] = ACTIONS(613),
    [anon_sym_uint160] = ACTIONS(613),
    [anon_sym_uint168] = ACTIONS(613),
    [anon_sym_uint176] = ACTIONS(613),
    [anon_sym_uint184] = ACTIONS(613),
    [anon_sym_uint192] = ACTIONS(613),
    [anon_sym_uint200] = ACTIONS(613),
    [anon_sym_uint208] = ACTIONS(613),
    [anon_sym_uint216] = ACTIONS(613),
    [anon_sym_uint224] = ACTIONS(613),
    [anon_sym_uint232] = ACTIONS(613),
    [anon_sym_uint240] = ACTIONS(613),
    [anon_sym_uint248] = ACTIONS(613),
    [anon_sym_uint256] = ACTIONS(613),
    [anon_sym_bytes] = ACTIONS(613),
    [anon_sym_bytes1] = ACTIONS(613),
    [anon_sym_bytes2] = ACTIONS(613),
    [anon_sym_bytes3] = ACTIONS(613),
    [anon_sym_bytes4] = ACTIONS(613),
    [anon_sym_bytes5] = ACTIONS(613),
    [anon_sym_bytes6] = ACTIONS(613),
    [anon_sym_bytes7] = ACTIONS(613),
    [anon_sym_bytes8] = ACTIONS(613),
    [anon_sym_bytes9] = ACTIONS(613),
    [anon_sym_bytes10] = ACTIONS(613),
    [anon_sym_bytes11] = ACTIONS(613),
    [anon_sym_bytes12] = ACTIONS(613),
    [anon_sym_bytes13] = ACTIONS(613),
    [anon_sym_bytes14] = ACTIONS(613),
    [anon_sym_bytes15] = ACTIONS(613),
    [anon_sym_bytes16] = ACTIONS(613),
    [anon_sym_bytes17] = ACTIONS(613),
    [anon_sym_bytes18] = ACTIONS(613),
    [anon_sym_bytes19] = ACTIONS(613),
    [anon_sym_bytes20] = ACTIONS(613),
    [anon_sym_bytes21] = ACTIONS(613),
    [anon_sym_bytes22] = ACTIONS(613),
    [anon_sym_bytes23] = ACTIONS(613),
    [anon_sym_bytes24] = ACTIONS(613),
    [anon_sym_bytes25] = ACTIONS(613),
    [anon_sym_bytes26] = ACTIONS(613),
    [anon_sym_bytes27] = ACTIONS(613),
    [anon_sym_bytes28] = ACTIONS(613),
    [anon_sym_bytes29] = ACTIONS(613),
    [anon_sym_bytes30] = ACTIONS(613),
    [anon_sym_bytes31] = ACTIONS(613),
    [anon_sym_bytes32] = ACTIONS(613),
    [anon_sym_fixed] = ACTIONS(613),
    [aux_sym__fixed_token1] = ACTIONS(613),
    [anon_sym_ufixed] = ACTIONS(613),
    [aux_sym__ufixed_token1] = ACTIONS(613),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_identifier] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(615),
    [anon_sym_error] = ACTIONS(615),
    [anon_sym_struct] = ACTIONS(615),
    [anon_sym_enum] = ACTIONS(615),
    [anon_sym_event] = ACTIONS(615),
    [anon_sym_using] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(615),
    [anon_sym_byte] = ACTIONS(615),
    [anon_sym_address] = ACTIONS(615),
    [anon_sym_var] = ACTIONS(615),
    [anon_sym_modifier] = ACTIONS(615),
    [anon_sym_constructor] = ACTIONS(615),
    [anon_sym_fallback] = ACTIONS(615),
    [anon_sym_receive] = ACTIONS(615),
    [anon_sym_mapping] = ACTIONS(615),
    [anon_sym_bool] = ACTIONS(615),
    [anon_sym_string] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_int8] = ACTIONS(615),
    [anon_sym_int16] = ACTIONS(615),
    [anon_sym_int24] = ACTIONS(615),
    [anon_sym_int32] = ACTIONS(615),
    [anon_sym_int40] = ACTIONS(615),
    [anon_sym_int48] = ACTIONS(615),
    [anon_sym_int56] = ACTIONS(615),
    [anon_sym_int64] = ACTIONS(615),
    [anon_sym_int72] = ACTIONS(615),
    [anon_sym_int80] = ACTIONS(615),
    [anon_sym_int88] = ACTIONS(615),
    [anon_sym_int96] = ACTIONS(615),
    [anon_sym_int104] = ACTIONS(615),
    [anon_sym_int112] = ACTIONS(615),
    [anon_sym_int120] = ACTIONS(615),
    [anon_sym_int128] = ACTIONS(615),
    [anon_sym_int136] = ACTIONS(615),
    [anon_sym_int144] = ACTIONS(615),
    [anon_sym_int152] = ACTIONS(615),
    [anon_sym_int160] = ACTIONS(615),
    [anon_sym_int168] = ACTIONS(615),
    [anon_sym_int176] = ACTIONS(615),
    [anon_sym_int184] = ACTIONS(615),
    [anon_sym_int192] = ACTIONS(615),
    [anon_sym_int200] = ACTIONS(615),
    [anon_sym_int208] = ACTIONS(615),
    [anon_sym_int216] = ACTIONS(615),
    [anon_sym_int224] = ACTIONS(615),
    [anon_sym_int232] = ACTIONS(615),
    [anon_sym_int240] = ACTIONS(615),
    [anon_sym_int248] = ACTIONS(615),
    [anon_sym_int256] = ACTIONS(615),
    [anon_sym_uint] = ACTIONS(615),
    [anon_sym_uint8] = ACTIONS(615),
    [anon_sym_uint16] = ACTIONS(615),
    [anon_sym_uint24] = ACTIONS(615),
    [anon_sym_uint32] = ACTIONS(615),
    [anon_sym_uint40] = ACTIONS(615),
    [anon_sym_uint48] = ACTIONS(615),
    [anon_sym_uint56] = ACTIONS(615),
    [anon_sym_uint64] = ACTIONS(615),
    [anon_sym_uint72] = ACTIONS(615),
    [anon_sym_uint80] = ACTIONS(615),
    [anon_sym_uint88] = ACTIONS(615),
    [anon_sym_uint96] = ACTIONS(615),
    [anon_sym_uint104] = ACTIONS(615),
    [anon_sym_uint112] = ACTIONS(615),
    [anon_sym_uint120] = ACTIONS(615),
    [anon_sym_uint128] = ACTIONS(615),
    [anon_sym_uint136] = ACTIONS(615),
    [anon_sym_uint144] = ACTIONS(615),
    [anon_sym_uint152] = ACTIONS(615),
    [anon_sym_uint160] = ACTIONS(615),
    [anon_sym_uint168] = ACTIONS(615),
    [anon_sym_uint176] = ACTIONS(615),
    [anon_sym_uint184] = ACTIONS(615),
    [anon_sym_uint192] = ACTIONS(615),
    [anon_sym_uint200] = ACTIONS(615),
    [anon_sym_uint208] = ACTIONS(615),
    [anon_sym_uint216] = ACTIONS(615),
    [anon_sym_uint224] = ACTIONS(615),
    [anon_sym_uint232] = ACTIONS(615),
    [anon_sym_uint240] = ACTIONS(615),
    [anon_sym_uint248] = ACTIONS(615),
    [anon_sym_uint256] = ACTIONS(615),
    [anon_sym_bytes] = ACTIONS(615),
    [anon_sym_bytes1] = ACTIONS(615),
    [anon_sym_bytes2] = ACTIONS(615),
    [anon_sym_bytes3] = ACTIONS(615),
    [anon_sym_bytes4] = ACTIONS(615),
    [anon_sym_bytes5] = ACTIONS(615),
    [anon_sym_bytes6] = ACTIONS(615),
    [anon_sym_bytes7] = ACTIONS(615),
    [anon_sym_bytes8] = ACTIONS(615),
    [anon_sym_bytes9] = ACTIONS(615),
    [anon_sym_bytes10] = ACTIONS(615),
    [anon_sym_bytes11] = ACTIONS(615),
    [anon_sym_bytes12] = ACTIONS(615),
    [anon_sym_bytes13] = ACTIONS(615),
    [anon_sym_bytes14] = ACTIONS(615),
    [anon_sym_bytes15] = ACTIONS(615),
    [anon_sym_bytes16] = ACTIONS(615),
    [anon_sym_bytes17] = ACTIONS(615),
    [anon_sym_bytes18] = ACTIONS(615),
    [anon_sym_bytes19] = ACTIONS(615),
    [anon_sym_bytes20] = ACTIONS(615),
    [anon_sym_bytes21] = ACTIONS(615),
    [anon_sym_bytes22] = ACTIONS(615),
    [anon_sym_bytes23] = ACTIONS(615),
    [anon_sym_bytes24] = ACTIONS(615),
    [anon_sym_bytes25] = ACTIONS(615),
    [anon_sym_bytes26] = ACTIONS(615),
    [anon_sym_bytes27] = ACTIONS(615),
    [anon_sym_bytes28] = ACTIONS(615),
    [anon_sym_bytes29] = ACTIONS(615),
    [anon_sym_bytes30] = ACTIONS(615),
    [anon_sym_bytes31] = ACTIONS(615),
    [anon_sym_bytes32] = ACTIONS(615),
    [anon_sym_fixed] = ACTIONS(615),
    [aux_sym__fixed_token1] = ACTIONS(615),
    [anon_sym_ufixed] = ACTIONS(615),
    [aux_sym__ufixed_token1] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_pragma] = ACTIONS(621),
    [anon_sym_import] = ACTIONS(621),
    [anon_sym_type] = ACTIONS(621),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_contract] = ACTIONS(621),
    [anon_sym_error] = ACTIONS(621),
    [anon_sym_interface] = ACTIONS(621),
    [anon_sym_library] = ACTIONS(621),
    [anon_sym_struct] = ACTIONS(621),
    [anon_sym_enum] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(621),
    [anon_sym_byte] = ACTIONS(621),
    [anon_sym_address] = ACTIONS(621),
    [anon_sym_var] = ACTIONS(621),
    [anon_sym_mapping] = ACTIONS(621),
    [anon_sym_bool] = ACTIONS(621),
    [anon_sym_string] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_int8] = ACTIONS(621),
    [anon_sym_int16] = ACTIONS(621),
    [anon_sym_int24] = ACTIONS(621),
    [anon_sym_int32] = ACTIONS(621),
    [anon_sym_int40] = ACTIONS(621),
    [anon_sym_int48] = ACTIONS(621),
    [anon_sym_int56] = ACTIONS(621),
    [anon_sym_int64] = ACTIONS(621),
    [anon_sym_int72] = ACTIONS(621),
    [anon_sym_int80] = ACTIONS(621),
    [anon_sym_int88] = ACTIONS(621),
    [anon_sym_int96] = ACTIONS(621),
    [anon_sym_int104] = ACTIONS(621),
    [anon_sym_int112] = ACTIONS(621),
    [anon_sym_int120] = ACTIONS(621),
    [anon_sym_int128] = ACTIONS(621),
    [anon_sym_int136] = ACTIONS(621),
    [anon_sym_int144] = ACTIONS(621),
    [anon_sym_int152] = ACTIONS(621),
    [anon_sym_int160] = ACTIONS(621),
    [anon_sym_int168] = ACTIONS(621),
    [anon_sym_int176] = ACTIONS(621),
    [anon_sym_int184] = ACTIONS(621),
    [anon_sym_int192] = ACTIONS(621),
    [anon_sym_int200] = ACTIONS(621),
    [anon_sym_int208] = ACTIONS(621),
    [anon_sym_int216] = ACTIONS(621),
    [anon_sym_int224] = ACTIONS(621),
    [anon_sym_int232] = ACTIONS(621),
    [anon_sym_int240] = ACTIONS(621),
    [anon_sym_int248] = ACTIONS(621),
    [anon_sym_int256] = ACTIONS(621),
    [anon_sym_uint] = ACTIONS(621),
    [anon_sym_uint8] = ACTIONS(621),
    [anon_sym_uint16] = ACTIONS(621),
    [anon_sym_uint24] = ACTIONS(621),
    [anon_sym_uint32] = ACTIONS(621),
    [anon_sym_uint40] = ACTIONS(621),
    [anon_sym_uint48] = ACTIONS(621),
    [anon_sym_uint56] = ACTIONS(621),
    [anon_sym_uint64] = ACTIONS(621),
    [anon_sym_uint72] = ACTIONS(621),
    [anon_sym_uint80] = ACTIONS(621),
    [anon_sym_uint88] = ACTIONS(621),
    [anon_sym_uint96] = ACTIONS(621),
    [anon_sym_uint104] = ACTIONS(621),
    [anon_sym_uint112] = ACTIONS(621),
    [anon_sym_uint120] = ACTIONS(621),
    [anon_sym_uint128] = ACTIONS(621),
    [anon_sym_uint136] = ACTIONS(621),
    [anon_sym_uint144] = ACTIONS(621),
    [anon_sym_uint152] = ACTIONS(621),
    [anon_sym_uint160] = ACTIONS(621),
    [anon_sym_uint168] = ACTIONS(621),
    [anon_sym_uint176] = ACTIONS(621),
    [anon_sym_uint184] = ACTIONS(621),
    [anon_sym_uint192] = ACTIONS(621),
    [anon_sym_uint200] = ACTIONS(621),
    [anon_sym_uint208] = ACTIONS(621),
    [anon_sym_uint216] = ACTIONS(621),
    [anon_sym_uint224] = ACTIONS(621),
    [anon_sym_uint232] = ACTIONS(621),
    [anon_sym_uint240] = ACTIONS(621),
    [anon_sym_uint248] = ACTIONS(621),
    [anon_sym_uint256] = ACTIONS(621),
    [anon_sym_bytes] = ACTIONS(621),
    [anon_sym_bytes1] = ACTIONS(621),
    [anon_sym_bytes2] = ACTIONS(621),
    [anon_sym_bytes3] = ACTIONS(621),
    [anon_sym_bytes4] = ACTIONS(621),
    [anon_sym_bytes5] = ACTIONS(621),
    [anon_sym_bytes6] = ACTIONS(621),
    [anon_sym_bytes7] = ACTIONS(621),
    [anon_sym_bytes8] = ACTIONS(621),
    [anon_sym_bytes9] = ACTIONS(621),
    [anon_sym_bytes10] = ACTIONS(621),
    [anon_sym_bytes11] = ACTIONS(621),
    [anon_sym_bytes12] = ACTIONS(621),
    [anon_sym_bytes13] = ACTIONS(621),
    [anon_sym_bytes14] = ACTIONS(621),
    [anon_sym_bytes15] = ACTIONS(621),
    [anon_sym_bytes16] = ACTIONS(621),
    [anon_sym_bytes17] = ACTIONS(621),
    [anon_sym_bytes18] = ACTIONS(621),
    [anon_sym_bytes19] = ACTIONS(621),
    [anon_sym_bytes20] = ACTIONS(621),
    [anon_sym_bytes21] = ACTIONS(621),
    [anon_sym_bytes22] = ACTIONS(621),
    [anon_sym_bytes23] = ACTIONS(621),
    [anon_sym_bytes24] = ACTIONS(621),
    [anon_sym_bytes25] = ACTIONS(621),
    [anon_sym_bytes26] = ACTIONS(621),
    [anon_sym_bytes27] = ACTIONS(621),
    [anon_sym_bytes28] = ACTIONS(621),
    [anon_sym_bytes29] = ACTIONS(621),
    [anon_sym_bytes30] = ACTIONS(621),
    [anon_sym_bytes31] = ACTIONS(621),
    [anon_sym_bytes32] = ACTIONS(621),
    [anon_sym_fixed] = ACTIONS(621),
    [aux_sym__fixed_token1] = ACTIONS(621),
    [anon_sym_ufixed] = ACTIONS(621),
    [aux_sym__ufixed_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_pragma] = ACTIONS(625),
    [anon_sym_import] = ACTIONS(625),
    [anon_sym_type] = ACTIONS(625),
    [anon_sym_abstract] = ACTIONS(625),
    [anon_sym_contract] = ACTIONS(625),
    [anon_sym_error] = ACTIONS(625),
    [anon_sym_interface] = ACTIONS(625),
    [anon_sym_library] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(625),
    [anon_sym_enum] = ACTIONS(625),
    [anon_sym_function] = ACTIONS(625),
    [anon_sym_byte] = ACTIONS(625),
    [anon_sym_address] = ACTIONS(625),
    [anon_sym_var] = ACTIONS(625),
    [anon_sym_mapping] = ACTIONS(625),
    [anon_sym_bool] = ACTIONS(625),
    [anon_sym_string] = ACTIONS(625),
    [anon_sym_int] = ACTIONS(625),
    [anon_sym_int8] = ACTIONS(625),
    [anon_sym_int16] = ACTIONS(625),
    [anon_sym_int24] = ACTIONS(625),
    [anon_sym_int32] = ACTIONS(625),
    [anon_sym_int40] = ACTIONS(625),
    [anon_sym_int48] = ACTIONS(625),
    [anon_sym_int56] = ACTIONS(625),
    [anon_sym_int64] = ACTIONS(625),
    [anon_sym_int72] = ACTIONS(625),
    [anon_sym_int80] = ACTIONS(625),
    [anon_sym_int88] = ACTIONS(625),
    [anon_sym_int96] = ACTIONS(625),
    [anon_sym_int104] = ACTIONS(625),
    [anon_sym_int112] = ACTIONS(625),
    [anon_sym_int120] = ACTIONS(625),
    [anon_sym_int128] = ACTIONS(625),
    [anon_sym_int136] = ACTIONS(625),
    [anon_sym_int144] = ACTIONS(625),
    [anon_sym_int152] = ACTIONS(625),
    [anon_sym_int160] = ACTIONS(625),
    [anon_sym_int168] = ACTIONS(625),
    [anon_sym_int176] = ACTIONS(625),
    [anon_sym_int184] = ACTIONS(625),
    [anon_sym_int192] = ACTIONS(625),
    [anon_sym_int200] = ACTIONS(625),
    [anon_sym_int208] = ACTIONS(625),
    [anon_sym_int216] = ACTIONS(625),
    [anon_sym_int224] = ACTIONS(625),
    [anon_sym_int232] = ACTIONS(625),
    [anon_sym_int240] = ACTIONS(625),
    [anon_sym_int248] = ACTIONS(625),
    [anon_sym_int256] = ACTIONS(625),
    [anon_sym_uint] = ACTIONS(625),
    [anon_sym_uint8] = ACTIONS(625),
    [anon_sym_uint16] = ACTIONS(625),
    [anon_sym_uint24] = ACTIONS(625),
    [anon_sym_uint32] = ACTIONS(625),
    [anon_sym_uint40] = ACTIONS(625),
    [anon_sym_uint48] = ACTIONS(625),
    [anon_sym_uint56] = ACTIONS(625),
    [anon_sym_uint64] = ACTIONS(625),
    [anon_sym_uint72] = ACTIONS(625),
    [anon_sym_uint80] = ACTIONS(625),
    [anon_sym_uint88] = ACTIONS(625),
    [anon_sym_uint96] = ACTIONS(625),
    [anon_sym_uint104] = ACTIONS(625),
    [anon_sym_uint112] = ACTIONS(625),
    [anon_sym_uint120] = ACTIONS(625),
    [anon_sym_uint128] = ACTIONS(625),
    [anon_sym_uint136] = ACTIONS(625),
    [anon_sym_uint144] = ACTIONS(625),
    [anon_sym_uint152] = ACTIONS(625),
    [anon_sym_uint160] = ACTIONS(625),
    [anon_sym_uint168] = ACTIONS(625),
    [anon_sym_uint176] = ACTIONS(625),
    [anon_sym_uint184] = ACTIONS(625),
    [anon_sym_uint192] = ACTIONS(625),
    [anon_sym_uint200] = ACTIONS(625),
    [anon_sym_uint208] = ACTIONS(625),
    [anon_sym_uint216] = ACTIONS(625),
    [anon_sym_uint224] = ACTIONS(625),
    [anon_sym_uint232] = ACTIONS(625),
    [anon_sym_uint240] = ACTIONS(625),
    [anon_sym_uint248] = ACTIONS(625),
    [anon_sym_uint256] = ACTIONS(625),
    [anon_sym_bytes] = ACTIONS(625),
    [anon_sym_bytes1] = ACTIONS(625),
    [anon_sym_bytes2] = ACTIONS(625),
    [anon_sym_bytes3] = ACTIONS(625),
    [anon_sym_bytes4] = ACTIONS(625),
    [anon_sym_bytes5] = ACTIONS(625),
    [anon_sym_bytes6] = ACTIONS(625),
    [anon_sym_bytes7] = ACTIONS(625),
    [anon_sym_bytes8] = ACTIONS(625),
    [anon_sym_bytes9] = ACTIONS(625),
    [anon_sym_bytes10] = ACTIONS(625),
    [anon_sym_bytes11] = ACTIONS(625),
    [anon_sym_bytes12] = ACTIONS(625),
    [anon_sym_bytes13] = ACTIONS(625),
    [anon_sym_bytes14] = ACTIONS(625),
    [anon_sym_bytes15] = ACTIONS(625),
    [anon_sym_bytes16] = ACTIONS(625),
    [anon_sym_bytes17] = ACTIONS(625),
    [anon_sym_bytes18] = ACTIONS(625),
    [anon_sym_bytes19] = ACTIONS(625),
    [anon_sym_bytes20] = ACTIONS(625),
    [anon_sym_bytes21] = ACTIONS(625),
    [anon_sym_bytes22] = ACTIONS(625),
    [anon_sym_bytes23] = ACTIONS(625),
    [anon_sym_bytes24] = ACTIONS(625),
    [anon_sym_bytes25] = ACTIONS(625),
    [anon_sym_bytes26] = ACTIONS(625),
    [anon_sym_bytes27] = ACTIONS(625),
    [anon_sym_bytes28] = ACTIONS(625),
    [anon_sym_bytes29] = ACTIONS(625),
    [anon_sym_bytes30] = ACTIONS(625),
    [anon_sym_bytes31] = ACTIONS(625),
    [anon_sym_bytes32] = ACTIONS(625),
    [anon_sym_fixed] = ACTIONS(625),
    [aux_sym__fixed_token1] = ACTIONS(625),
    [anon_sym_ufixed] = ACTIONS(625),
    [aux_sym__ufixed_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(627),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_pragma] = ACTIONS(629),
    [anon_sym_import] = ACTIONS(629),
    [anon_sym_type] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(629),
    [anon_sym_contract] = ACTIONS(629),
    [anon_sym_error] = ACTIONS(629),
    [anon_sym_interface] = ACTIONS(629),
    [anon_sym_library] = ACTIONS(629),
    [anon_sym_struct] = ACTIONS(629),
    [anon_sym_enum] = ACTIONS(629),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_byte] = ACTIONS(629),
    [anon_sym_address] = ACTIONS(629),
    [anon_sym_var] = ACTIONS(629),
    [anon_sym_mapping] = ACTIONS(629),
    [anon_sym_bool] = ACTIONS(629),
    [anon_sym_string] = ACTIONS(629),
    [anon_sym_int] = ACTIONS(629),
    [anon_sym_int8] = ACTIONS(629),
    [anon_sym_int16] = ACTIONS(629),
    [anon_sym_int24] = ACTIONS(629),
    [anon_sym_int32] = ACTIONS(629),
    [anon_sym_int40] = ACTIONS(629),
    [anon_sym_int48] = ACTIONS(629),
    [anon_sym_int56] = ACTIONS(629),
    [anon_sym_int64] = ACTIONS(629),
    [anon_sym_int72] = ACTIONS(629),
    [anon_sym_int80] = ACTIONS(629),
    [anon_sym_int88] = ACTIONS(629),
    [anon_sym_int96] = ACTIONS(629),
    [anon_sym_int104] = ACTIONS(629),
    [anon_sym_int112] = ACTIONS(629),
    [anon_sym_int120] = ACTIONS(629),
    [anon_sym_int128] = ACTIONS(629),
    [anon_sym_int136] = ACTIONS(629),
    [anon_sym_int144] = ACTIONS(629),
    [anon_sym_int152] = ACTIONS(629),
    [anon_sym_int160] = ACTIONS(629),
    [anon_sym_int168] = ACTIONS(629),
    [anon_sym_int176] = ACTIONS(629),
    [anon_sym_int184] = ACTIONS(629),
    [anon_sym_int192] = ACTIONS(629),
    [anon_sym_int200] = ACTIONS(629),
    [anon_sym_int208] = ACTIONS(629),
    [anon_sym_int216] = ACTIONS(629),
    [anon_sym_int224] = ACTIONS(629),
    [anon_sym_int232] = ACTIONS(629),
    [anon_sym_int240] = ACTIONS(629),
    [anon_sym_int248] = ACTIONS(629),
    [anon_sym_int256] = ACTIONS(629),
    [anon_sym_uint] = ACTIONS(629),
    [anon_sym_uint8] = ACTIONS(629),
    [anon_sym_uint16] = ACTIONS(629),
    [anon_sym_uint24] = ACTIONS(629),
    [anon_sym_uint32] = ACTIONS(629),
    [anon_sym_uint40] = ACTIONS(629),
    [anon_sym_uint48] = ACTIONS(629),
    [anon_sym_uint56] = ACTIONS(629),
    [anon_sym_uint64] = ACTIONS(629),
    [anon_sym_uint72] = ACTIONS(629),
    [anon_sym_uint80] = ACTIONS(629),
    [anon_sym_uint88] = ACTIONS(629),
    [anon_sym_uint96] = ACTIONS(629),
    [anon_sym_uint104] = ACTIONS(629),
    [anon_sym_uint112] = ACTIONS(629),
    [anon_sym_uint120] = ACTIONS(629),
    [anon_sym_uint128] = ACTIONS(629),
    [anon_sym_uint136] = ACTIONS(629),
    [anon_sym_uint144] = ACTIONS(629),
    [anon_sym_uint152] = ACTIONS(629),
    [anon_sym_uint160] = ACTIONS(629),
    [anon_sym_uint168] = ACTIONS(629),
    [anon_sym_uint176] = ACTIONS(629),
    [anon_sym_uint184] = ACTIONS(629),
    [anon_sym_uint192] = ACTIONS(629),
    [anon_sym_uint200] = ACTIONS(629),
    [anon_sym_uint208] = ACTIONS(629),
    [anon_sym_uint216] = ACTIONS(629),
    [anon_sym_uint224] = ACTIONS(629),
    [anon_sym_uint232] = ACTIONS(629),
    [anon_sym_uint240] = ACTIONS(629),
    [anon_sym_uint248] = ACTIONS(629),
    [anon_sym_uint256] = ACTIONS(629),
    [anon_sym_bytes] = ACTIONS(629),
    [anon_sym_bytes1] = ACTIONS(629),
    [anon_sym_bytes2] = ACTIONS(629),
    [anon_sym_bytes3] = ACTIONS(629),
    [anon_sym_bytes4] = ACTIONS(629),
    [anon_sym_bytes5] = ACTIONS(629),
    [anon_sym_bytes6] = ACTIONS(629),
    [anon_sym_bytes7] = ACTIONS(629),
    [anon_sym_bytes8] = ACTIONS(629),
    [anon_sym_bytes9] = ACTIONS(629),
    [anon_sym_bytes10] = ACTIONS(629),
    [anon_sym_bytes11] = ACTIONS(629),
    [anon_sym_bytes12] = ACTIONS(629),
    [anon_sym_bytes13] = ACTIONS(629),
    [anon_sym_bytes14] = ACTIONS(629),
    [anon_sym_bytes15] = ACTIONS(629),
    [anon_sym_bytes16] = ACTIONS(629),
    [anon_sym_bytes17] = ACTIONS(629),
    [anon_sym_bytes18] = ACTIONS(629),
    [anon_sym_bytes19] = ACTIONS(629),
    [anon_sym_bytes20] = ACTIONS(629),
    [anon_sym_bytes21] = ACTIONS(629),
    [anon_sym_bytes22] = ACTIONS(629),
    [anon_sym_bytes23] = ACTIONS(629),
    [anon_sym_bytes24] = ACTIONS(629),
    [anon_sym_bytes25] = ACTIONS(629),
    [anon_sym_bytes26] = ACTIONS(629),
    [anon_sym_bytes27] = ACTIONS(629),
    [anon_sym_bytes28] = ACTIONS(629),
    [anon_sym_bytes29] = ACTIONS(629),
    [anon_sym_bytes30] = ACTIONS(629),
    [anon_sym_bytes31] = ACTIONS(629),
    [anon_sym_bytes32] = ACTIONS(629),
    [anon_sym_fixed] = ACTIONS(629),
    [aux_sym__fixed_token1] = ACTIONS(629),
    [anon_sym_ufixed] = ACTIONS(629),
    [aux_sym__ufixed_token1] = ACTIONS(629),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_type] = ACTIONS(631),
    [anon_sym_error] = ACTIONS(631),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_enum] = ACTIONS(631),
    [anon_sym_event] = ACTIONS(631),
    [anon_sym_using] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(631),
    [anon_sym_byte] = ACTIONS(631),
    [anon_sym_address] = ACTIONS(631),
    [anon_sym_var] = ACTIONS(631),
    [anon_sym_modifier] = ACTIONS(631),
    [anon_sym_constructor] = ACTIONS(631),
    [anon_sym_fallback] = ACTIONS(631),
    [anon_sym_receive] = ACTIONS(631),
    [anon_sym_mapping] = ACTIONS(631),
    [anon_sym_bool] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_int8] = ACTIONS(631),
    [anon_sym_int16] = ACTIONS(631),
    [anon_sym_int24] = ACTIONS(631),
    [anon_sym_int32] = ACTIONS(631),
    [anon_sym_int40] = ACTIONS(631),
    [anon_sym_int48] = ACTIONS(631),
    [anon_sym_int56] = ACTIONS(631),
    [anon_sym_int64] = ACTIONS(631),
    [anon_sym_int72] = ACTIONS(631),
    [anon_sym_int80] = ACTIONS(631),
    [anon_sym_int88] = ACTIONS(631),
    [anon_sym_int96] = ACTIONS(631),
    [anon_sym_int104] = ACTIONS(631),
    [anon_sym_int112] = ACTIONS(631),
    [anon_sym_int120] = ACTIONS(631),
    [anon_sym_int128] = ACTIONS(631),
    [anon_sym_int136] = ACTIONS(631),
    [anon_sym_int144] = ACTIONS(631),
    [anon_sym_int152] = ACTIONS(631),
    [anon_sym_int160] = ACTIONS(631),
    [anon_sym_int168] = ACTIONS(631),
    [anon_sym_int176] = ACTIONS(631),
    [anon_sym_int184] = ACTIONS(631),
    [anon_sym_int192] = ACTIONS(631),
    [anon_sym_int200] = ACTIONS(631),
    [anon_sym_int208] = ACTIONS(631),
    [anon_sym_int216] = ACTIONS(631),
    [anon_sym_int224] = ACTIONS(631),
    [anon_sym_int232] = ACTIONS(631),
    [anon_sym_int240] = ACTIONS(631),
    [anon_sym_int248] = ACTIONS(631),
    [anon_sym_int256] = ACTIONS(631),
    [anon_sym_uint] = ACTIONS(631),
    [anon_sym_uint8] = ACTIONS(631),
    [anon_sym_uint16] = ACTIONS(631),
    [anon_sym_uint24] = ACTIONS(631),
    [anon_sym_uint32] = ACTIONS(631),
    [anon_sym_uint40] = ACTIONS(631),
    [anon_sym_uint48] = ACTIONS(631),
    [anon_sym_uint56] = ACTIONS(631),
    [anon_sym_uint64] = ACTIONS(631),
    [anon_sym_uint72] = ACTIONS(631),
    [anon_sym_uint80] = ACTIONS(631),
    [anon_sym_uint88] = ACTIONS(631),
    [anon_sym_uint96] = ACTIONS(631),
    [anon_sym_uint104] = ACTIONS(631),
    [anon_sym_uint112] = ACTIONS(631),
    [anon_sym_uint120] = ACTIONS(631),
    [anon_sym_uint128] = ACTIONS(631),
    [anon_sym_uint136] = ACTIONS(631),
    [anon_sym_uint144] = ACTIONS(631),
    [anon_sym_uint152] = ACTIONS(631),
    [anon_sym_uint160] = ACTIONS(631),
    [anon_sym_uint168] = ACTIONS(631),
    [anon_sym_uint176] = ACTIONS(631),
    [anon_sym_uint184] = ACTIONS(631),
    [anon_sym_uint192] = ACTIONS(631),
    [anon_sym_uint200] = ACTIONS(631),
    [anon_sym_uint208] = ACTIONS(631),
    [anon_sym_uint216] = ACTIONS(631),
    [anon_sym_uint224] = ACTIONS(631),
    [anon_sym_uint232] = ACTIONS(631),
    [anon_sym_uint240] = ACTIONS(631),
    [anon_sym_uint248] = ACTIONS(631),
    [anon_sym_uint256] = ACTIONS(631),
    [anon_sym_bytes] = ACTIONS(631),
    [anon_sym_bytes1] = ACTIONS(631),
    [anon_sym_bytes2] = ACTIONS(631),
    [anon_sym_bytes3] = ACTIONS(631),
    [anon_sym_bytes4] = ACTIONS(631),
    [anon_sym_bytes5] = ACTIONS(631),
    [anon_sym_bytes6] = ACTIONS(631),
    [anon_sym_bytes7] = ACTIONS(631),
    [anon_sym_bytes8] = ACTIONS(631),
    [anon_sym_bytes9] = ACTIONS(631),
    [anon_sym_bytes10] = ACTIONS(631),
    [anon_sym_bytes11] = ACTIONS(631),
    [anon_sym_bytes12] = ACTIONS(631),
    [anon_sym_bytes13] = ACTIONS(631),
    [anon_sym_bytes14] = ACTIONS(631),
    [anon_sym_bytes15] = ACTIONS(631),
    [anon_sym_bytes16] = ACTIONS(631),
    [anon_sym_bytes17] = ACTIONS(631),
    [anon_sym_bytes18] = ACTIONS(631),
    [anon_sym_bytes19] = ACTIONS(631),
    [anon_sym_bytes20] = ACTIONS(631),
    [anon_sym_bytes21] = ACTIONS(631),
    [anon_sym_bytes22] = ACTIONS(631),
    [anon_sym_bytes23] = ACTIONS(631),
    [anon_sym_bytes24] = ACTIONS(631),
    [anon_sym_bytes25] = ACTIONS(631),
    [anon_sym_bytes26] = ACTIONS(631),
    [anon_sym_bytes27] = ACTIONS(631),
    [anon_sym_bytes28] = ACTIONS(631),
    [anon_sym_bytes29] = ACTIONS(631),
    [anon_sym_bytes30] = ACTIONS(631),
    [anon_sym_bytes31] = ACTIONS(631),
    [anon_sym_bytes32] = ACTIONS(631),
    [anon_sym_fixed] = ACTIONS(631),
    [aux_sym__fixed_token1] = ACTIONS(631),
    [anon_sym_ufixed] = ACTIONS(631),
    [aux_sym__ufixed_token1] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(635),
    [sym_identifier] = ACTIONS(637),
    [anon_sym_pragma] = ACTIONS(637),
    [anon_sym_import] = ACTIONS(637),
    [anon_sym_type] = ACTIONS(637),
    [anon_sym_abstract] = ACTIONS(637),
    [anon_sym_contract] = ACTIONS(637),
    [anon_sym_error] = ACTIONS(637),
    [anon_sym_interface] = ACTIONS(637),
    [anon_sym_library] = ACTIONS(637),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_enum] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(637),
    [anon_sym_byte] = ACTIONS(637),
    [anon_sym_address] = ACTIONS(637),
    [anon_sym_var] = ACTIONS(637),
    [anon_sym_mapping] = ACTIONS(637),
    [anon_sym_bool] = ACTIONS(637),
    [anon_sym_string] = ACTIONS(637),
    [anon_sym_int] = ACTIONS(637),
    [anon_sym_int8] = ACTIONS(637),
    [anon_sym_int16] = ACTIONS(637),
    [anon_sym_int24] = ACTIONS(637),
    [anon_sym_int32] = ACTIONS(637),
    [anon_sym_int40] = ACTIONS(637),
    [anon_sym_int48] = ACTIONS(637),
    [anon_sym_int56] = ACTIONS(637),
    [anon_sym_int64] = ACTIONS(637),
    [anon_sym_int72] = ACTIONS(637),
    [anon_sym_int80] = ACTIONS(637),
    [anon_sym_int88] = ACTIONS(637),
    [anon_sym_int96] = ACTIONS(637),
    [anon_sym_int104] = ACTIONS(637),
    [anon_sym_int112] = ACTIONS(637),
    [anon_sym_int120] = ACTIONS(637),
    [anon_sym_int128] = ACTIONS(637),
    [anon_sym_int136] = ACTIONS(637),
    [anon_sym_int144] = ACTIONS(637),
    [anon_sym_int152] = ACTIONS(637),
    [anon_sym_int160] = ACTIONS(637),
    [anon_sym_int168] = ACTIONS(637),
    [anon_sym_int176] = ACTIONS(637),
    [anon_sym_int184] = ACTIONS(637),
    [anon_sym_int192] = ACTIONS(637),
    [anon_sym_int200] = ACTIONS(637),
    [anon_sym_int208] = ACTIONS(637),
    [anon_sym_int216] = ACTIONS(637),
    [anon_sym_int224] = ACTIONS(637),
    [anon_sym_int232] = ACTIONS(637),
    [anon_sym_int240] = ACTIONS(637),
    [anon_sym_int248] = ACTIONS(637),
    [anon_sym_int256] = ACTIONS(637),
    [anon_sym_uint] = ACTIONS(637),
    [anon_sym_uint8] = ACTIONS(637),
    [anon_sym_uint16] = ACTIONS(637),
    [anon_sym_uint24] = ACTIONS(637),
    [anon_sym_uint32] = ACTIONS(637),
    [anon_sym_uint40] = ACTIONS(637),
    [anon_sym_uint48] = ACTIONS(637),
    [anon_sym_uint56] = ACTIONS(637),
    [anon_sym_uint64] = ACTIONS(637),
    [anon_sym_uint72] = ACTIONS(637),
    [anon_sym_uint80] = ACTIONS(637),
    [anon_sym_uint88] = ACTIONS(637),
    [anon_sym_uint96] = ACTIONS(637),
    [anon_sym_uint104] = ACTIONS(637),
    [anon_sym_uint112] = ACTIONS(637),
    [anon_sym_uint120] = ACTIONS(637),
    [anon_sym_uint128] = ACTIONS(637),
    [anon_sym_uint136] = ACTIONS(637),
    [anon_sym_uint144] = ACTIONS(637),
    [anon_sym_uint152] = ACTIONS(637),
    [anon_sym_uint160] = ACTIONS(637),
    [anon_sym_uint168] = ACTIONS(637),
    [anon_sym_uint176] = ACTIONS(637),
    [anon_sym_uint184] = ACTIONS(637),
    [anon_sym_uint192] = ACTIONS(637),
    [anon_sym_uint200] = ACTIONS(637),
    [anon_sym_uint208] = ACTIONS(637),
    [anon_sym_uint216] = ACTIONS(637),
    [anon_sym_uint224] = ACTIONS(637),
    [anon_sym_uint232] = ACTIONS(637),
    [anon_sym_uint240] = ACTIONS(637),
    [anon_sym_uint248] = ACTIONS(637),
    [anon_sym_uint256] = ACTIONS(637),
    [anon_sym_bytes] = ACTIONS(637),
    [anon_sym_bytes1] = ACTIONS(637),
    [anon_sym_bytes2] = ACTIONS(637),
    [anon_sym_bytes3] = ACTIONS(637),
    [anon_sym_bytes4] = ACTIONS(637),
    [anon_sym_bytes5] = ACTIONS(637),
    [anon_sym_bytes6] = ACTIONS(637),
    [anon_sym_bytes7] = ACTIONS(637),
    [anon_sym_bytes8] = ACTIONS(637),
    [anon_sym_bytes9] = ACTIONS(637),
    [anon_sym_bytes10] = ACTIONS(637),
    [anon_sym_bytes11] = ACTIONS(637),
    [anon_sym_bytes12] = ACTIONS(637),
    [anon_sym_bytes13] = ACTIONS(637),
    [anon_sym_bytes14] = ACTIONS(637),
    [anon_sym_bytes15] = ACTIONS(637),
    [anon_sym_bytes16] = ACTIONS(637),
    [anon_sym_bytes17] = ACTIONS(637),
    [anon_sym_bytes18] = ACTIONS(637),
    [anon_sym_bytes19] = ACTIONS(637),
    [anon_sym_bytes20] = ACTIONS(637),
    [anon_sym_bytes21] = ACTIONS(637),
    [anon_sym_bytes22] = ACTIONS(637),
    [anon_sym_bytes23] = ACTIONS(637),
    [anon_sym_bytes24] = ACTIONS(637),
    [anon_sym_bytes25] = ACTIONS(637),
    [anon_sym_bytes26] = ACTIONS(637),
    [anon_sym_bytes27] = ACTIONS(637),
    [anon_sym_bytes28] = ACTIONS(637),
    [anon_sym_bytes29] = ACTIONS(637),
    [anon_sym_bytes30] = ACTIONS(637),
    [anon_sym_bytes31] = ACTIONS(637),
    [anon_sym_bytes32] = ACTIONS(637),
    [anon_sym_fixed] = ACTIONS(637),
    [aux_sym__fixed_token1] = ACTIONS(637),
    [anon_sym_ufixed] = ACTIONS(637),
    [aux_sym__ufixed_token1] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_identifier] = ACTIONS(639),
    [anon_sym_RBRACE] = ACTIONS(641),
    [anon_sym_type] = ACTIONS(639),
    [anon_sym_error] = ACTIONS(639),
    [anon_sym_struct] = ACTIONS(639),
    [anon_sym_enum] = ACTIONS(639),
    [anon_sym_event] = ACTIONS(639),
    [anon_sym_using] = ACTIONS(639),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_byte] = ACTIONS(639),
    [anon_sym_address] = ACTIONS(639),
    [anon_sym_var] = ACTIONS(639),
    [anon_sym_modifier] = ACTIONS(639),
    [anon_sym_constructor] = ACTIONS(639),
    [anon_sym_fallback] = ACTIONS(639),
    [anon_sym_receive] = ACTIONS(639),
    [anon_sym_mapping] = ACTIONS(639),
    [anon_sym_bool] = ACTIONS(639),
    [anon_sym_string] = ACTIONS(639),
    [anon_sym_int] = ACTIONS(639),
    [anon_sym_int8] = ACTIONS(639),
    [anon_sym_int16] = ACTIONS(639),
    [anon_sym_int24] = ACTIONS(639),
    [anon_sym_int32] = ACTIONS(639),
    [anon_sym_int40] = ACTIONS(639),
    [anon_sym_int48] = ACTIONS(639),
    [anon_sym_int56] = ACTIONS(639),
    [anon_sym_int64] = ACTIONS(639),
    [anon_sym_int72] = ACTIONS(639),
    [anon_sym_int80] = ACTIONS(639),
    [anon_sym_int88] = ACTIONS(639),
    [anon_sym_int96] = ACTIONS(639),
    [anon_sym_int104] = ACTIONS(639),
    [anon_sym_int112] = ACTIONS(639),
    [anon_sym_int120] = ACTIONS(639),
    [anon_sym_int128] = ACTIONS(639),
    [anon_sym_int136] = ACTIONS(639),
    [anon_sym_int144] = ACTIONS(639),
    [anon_sym_int152] = ACTIONS(639),
    [anon_sym_int160] = ACTIONS(639),
    [anon_sym_int168] = ACTIONS(639),
    [anon_sym_int176] = ACTIONS(639),
    [anon_sym_int184] = ACTIONS(639),
    [anon_sym_int192] = ACTIONS(639),
    [anon_sym_int200] = ACTIONS(639),
    [anon_sym_int208] = ACTIONS(639),
    [anon_sym_int216] = ACTIONS(639),
    [anon_sym_int224] = ACTIONS(639),
    [anon_sym_int232] = ACTIONS(639),
    [anon_sym_int240] = ACTIONS(639),
    [anon_sym_int248] = ACTIONS(639),
    [anon_sym_int256] = ACTIONS(639),
    [anon_sym_uint] = ACTIONS(639),
    [anon_sym_uint8] = ACTIONS(639),
    [anon_sym_uint16] = ACTIONS(639),
    [anon_sym_uint24] = ACTIONS(639),
    [anon_sym_uint32] = ACTIONS(639),
    [anon_sym_uint40] = ACTIONS(639),
    [anon_sym_uint48] = ACTIONS(639),
    [anon_sym_uint56] = ACTIONS(639),
    [anon_sym_uint64] = ACTIONS(639),
    [anon_sym_uint72] = ACTIONS(639),
    [anon_sym_uint80] = ACTIONS(639),
    [anon_sym_uint88] = ACTIONS(639),
    [anon_sym_uint96] = ACTIONS(639),
    [anon_sym_uint104] = ACTIONS(639),
    [anon_sym_uint112] = ACTIONS(639),
    [anon_sym_uint120] = ACTIONS(639),
    [anon_sym_uint128] = ACTIONS(639),
    [anon_sym_uint136] = ACTIONS(639),
    [anon_sym_uint144] = ACTIONS(639),
    [anon_sym_uint152] = ACTIONS(639),
    [anon_sym_uint160] = ACTIONS(639),
    [anon_sym_uint168] = ACTIONS(639),
    [anon_sym_uint176] = ACTIONS(639),
    [anon_sym_uint184] = ACTIONS(639),
    [anon_sym_uint192] = ACTIONS(639),
    [anon_sym_uint200] = ACTIONS(639),
    [anon_sym_uint208] = ACTIONS(639),
    [anon_sym_uint216] = ACTIONS(639),
    [anon_sym_uint224] = ACTIONS(639),
    [anon_sym_uint232] = ACTIONS(639),
    [anon_sym_uint240] = ACTIONS(639),
    [anon_sym_uint248] = ACTIONS(639),
    [anon_sym_uint256] = ACTIONS(639),
    [anon_sym_bytes] = ACTIONS(639),
    [anon_sym_bytes1] = ACTIONS(639),
    [anon_sym_bytes2] = ACTIONS(639),
    [anon_sym_bytes3] = ACTIONS(639),
    [anon_sym_bytes4] = ACTIONS(639),
    [anon_sym_bytes5] = ACTIONS(639),
    [anon_sym_bytes6] = ACTIONS(639),
    [anon_sym_bytes7] = ACTIONS(639),
    [anon_sym_bytes8] = ACTIONS(639),
    [anon_sym_bytes9] = ACTIONS(639),
    [anon_sym_bytes10] = ACTIONS(639),
    [anon_sym_bytes11] = ACTIONS(639),
    [anon_sym_bytes12] = ACTIONS(639),
    [anon_sym_bytes13] = ACTIONS(639),
    [anon_sym_bytes14] = ACTIONS(639),
    [anon_sym_bytes15] = ACTIONS(639),
    [anon_sym_bytes16] = ACTIONS(639),
    [anon_sym_bytes17] = ACTIONS(639),
    [anon_sym_bytes18] = ACTIONS(639),
    [anon_sym_bytes19] = ACTIONS(639),
    [anon_sym_bytes20] = ACTIONS(639),
    [anon_sym_bytes21] = ACTIONS(639),
    [anon_sym_bytes22] = ACTIONS(639),
    [anon_sym_bytes23] = ACTIONS(639),
    [anon_sym_bytes24] = ACTIONS(639),
    [anon_sym_bytes25] = ACTIONS(639),
    [anon_sym_bytes26] = ACTIONS(639),
    [anon_sym_bytes27] = ACTIONS(639),
    [anon_sym_bytes28] = ACTIONS(639),
    [anon_sym_bytes29] = ACTIONS(639),
    [anon_sym_bytes30] = ACTIONS(639),
    [anon_sym_bytes31] = ACTIONS(639),
    [anon_sym_bytes32] = ACTIONS(639),
    [anon_sym_fixed] = ACTIONS(639),
    [aux_sym__fixed_token1] = ACTIONS(639),
    [anon_sym_ufixed] = ACTIONS(639),
    [aux_sym__ufixed_token1] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(643),
    [sym_identifier] = ACTIONS(645),
    [anon_sym_pragma] = ACTIONS(645),
    [anon_sym_import] = ACTIONS(645),
    [anon_sym_type] = ACTIONS(645),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_contract] = ACTIONS(645),
    [anon_sym_error] = ACTIONS(645),
    [anon_sym_interface] = ACTIONS(645),
    [anon_sym_library] = ACTIONS(645),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_enum] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(645),
    [anon_sym_byte] = ACTIONS(645),
    [anon_sym_address] = ACTIONS(645),
    [anon_sym_var] = ACTIONS(645),
    [anon_sym_mapping] = ACTIONS(645),
    [anon_sym_bool] = ACTIONS(645),
    [anon_sym_string] = ACTIONS(645),
    [anon_sym_int] = ACTIONS(645),
    [anon_sym_int8] = ACTIONS(645),
    [anon_sym_int16] = ACTIONS(645),
    [anon_sym_int24] = ACTIONS(645),
    [anon_sym_int32] = ACTIONS(645),
    [anon_sym_int40] = ACTIONS(645),
    [anon_sym_int48] = ACTIONS(645),
    [anon_sym_int56] = ACTIONS(645),
    [anon_sym_int64] = ACTIONS(645),
    [anon_sym_int72] = ACTIONS(645),
    [anon_sym_int80] = ACTIONS(645),
    [anon_sym_int88] = ACTIONS(645),
    [anon_sym_int96] = ACTIONS(645),
    [anon_sym_int104] = ACTIONS(645),
    [anon_sym_int112] = ACTIONS(645),
    [anon_sym_int120] = ACTIONS(645),
    [anon_sym_int128] = ACTIONS(645),
    [anon_sym_int136] = ACTIONS(645),
    [anon_sym_int144] = ACTIONS(645),
    [anon_sym_int152] = ACTIONS(645),
    [anon_sym_int160] = ACTIONS(645),
    [anon_sym_int168] = ACTIONS(645),
    [anon_sym_int176] = ACTIONS(645),
    [anon_sym_int184] = ACTIONS(645),
    [anon_sym_int192] = ACTIONS(645),
    [anon_sym_int200] = ACTIONS(645),
    [anon_sym_int208] = ACTIONS(645),
    [anon_sym_int216] = ACTIONS(645),
    [anon_sym_int224] = ACTIONS(645),
    [anon_sym_int232] = ACTIONS(645),
    [anon_sym_int240] = ACTIONS(645),
    [anon_sym_int248] = ACTIONS(645),
    [anon_sym_int256] = ACTIONS(645),
    [anon_sym_uint] = ACTIONS(645),
    [anon_sym_uint8] = ACTIONS(645),
    [anon_sym_uint16] = ACTIONS(645),
    [anon_sym_uint24] = ACTIONS(645),
    [anon_sym_uint32] = ACTIONS(645),
    [anon_sym_uint40] = ACTIONS(645),
    [anon_sym_uint48] = ACTIONS(645),
    [anon_sym_uint56] = ACTIONS(645),
    [anon_sym_uint64] = ACTIONS(645),
    [anon_sym_uint72] = ACTIONS(645),
    [anon_sym_uint80] = ACTIONS(645),
    [anon_sym_uint88] = ACTIONS(645),
    [anon_sym_uint96] = ACTIONS(645),
    [anon_sym_uint104] = ACTIONS(645),
    [anon_sym_uint112] = ACTIONS(645),
    [anon_sym_uint120] = ACTIONS(645),
    [anon_sym_uint128] = ACTIONS(645),
    [anon_sym_uint136] = ACTIONS(645),
    [anon_sym_uint144] = ACTIONS(645),
    [anon_sym_uint152] = ACTIONS(645),
    [anon_sym_uint160] = ACTIONS(645),
    [anon_sym_uint168] = ACTIONS(645),
    [anon_sym_uint176] = ACTIONS(645),
    [anon_sym_uint184] = ACTIONS(645),
    [anon_sym_uint192] = ACTIONS(645),
    [anon_sym_uint200] = ACTIONS(645),
    [anon_sym_uint208] = ACTIONS(645),
    [anon_sym_uint216] = ACTIONS(645),
    [anon_sym_uint224] = ACTIONS(645),
    [anon_sym_uint232] = ACTIONS(645),
    [anon_sym_uint240] = ACTIONS(645),
    [anon_sym_uint248] = ACTIONS(645),
    [anon_sym_uint256] = ACTIONS(645),
    [anon_sym_bytes] = ACTIONS(645),
    [anon_sym_bytes1] = ACTIONS(645),
    [anon_sym_bytes2] = ACTIONS(645),
    [anon_sym_bytes3] = ACTIONS(645),
    [anon_sym_bytes4] = ACTIONS(645),
    [anon_sym_bytes5] = ACTIONS(645),
    [anon_sym_bytes6] = ACTIONS(645),
    [anon_sym_bytes7] = ACTIONS(645),
    [anon_sym_bytes8] = ACTIONS(645),
    [anon_sym_bytes9] = ACTIONS(645),
    [anon_sym_bytes10] = ACTIONS(645),
    [anon_sym_bytes11] = ACTIONS(645),
    [anon_sym_bytes12] = ACTIONS(645),
    [anon_sym_bytes13] = ACTIONS(645),
    [anon_sym_bytes14] = ACTIONS(645),
    [anon_sym_bytes15] = ACTIONS(645),
    [anon_sym_bytes16] = ACTIONS(645),
    [anon_sym_bytes17] = ACTIONS(645),
    [anon_sym_bytes18] = ACTIONS(645),
    [anon_sym_bytes19] = ACTIONS(645),
    [anon_sym_bytes20] = ACTIONS(645),
    [anon_sym_bytes21] = ACTIONS(645),
    [anon_sym_bytes22] = ACTIONS(645),
    [anon_sym_bytes23] = ACTIONS(645),
    [anon_sym_bytes24] = ACTIONS(645),
    [anon_sym_bytes25] = ACTIONS(645),
    [anon_sym_bytes26] = ACTIONS(645),
    [anon_sym_bytes27] = ACTIONS(645),
    [anon_sym_bytes28] = ACTIONS(645),
    [anon_sym_bytes29] = ACTIONS(645),
    [anon_sym_bytes30] = ACTIONS(645),
    [anon_sym_bytes31] = ACTIONS(645),
    [anon_sym_bytes32] = ACTIONS(645),
    [anon_sym_fixed] = ACTIONS(645),
    [aux_sym__fixed_token1] = ACTIONS(645),
    [anon_sym_ufixed] = ACTIONS(645),
    [aux_sym__ufixed_token1] = ACTIONS(645),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_identifier] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_type] = ACTIONS(647),
    [anon_sym_error] = ACTIONS(647),
    [anon_sym_struct] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(647),
    [anon_sym_event] = ACTIONS(647),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_byte] = ACTIONS(647),
    [anon_sym_address] = ACTIONS(647),
    [anon_sym_var] = ACTIONS(647),
    [anon_sym_modifier] = ACTIONS(647),
    [anon_sym_constructor] = ACTIONS(647),
    [anon_sym_fallback] = ACTIONS(647),
    [anon_sym_receive] = ACTIONS(647),
    [anon_sym_mapping] = ACTIONS(647),
    [anon_sym_bool] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_int8] = ACTIONS(647),
    [anon_sym_int16] = ACTIONS(647),
    [anon_sym_int24] = ACTIONS(647),
    [anon_sym_int32] = ACTIONS(647),
    [anon_sym_int40] = ACTIONS(647),
    [anon_sym_int48] = ACTIONS(647),
    [anon_sym_int56] = ACTIONS(647),
    [anon_sym_int64] = ACTIONS(647),
    [anon_sym_int72] = ACTIONS(647),
    [anon_sym_int80] = ACTIONS(647),
    [anon_sym_int88] = ACTIONS(647),
    [anon_sym_int96] = ACTIONS(647),
    [anon_sym_int104] = ACTIONS(647),
    [anon_sym_int112] = ACTIONS(647),
    [anon_sym_int120] = ACTIONS(647),
    [anon_sym_int128] = ACTIONS(647),
    [anon_sym_int136] = ACTIONS(647),
    [anon_sym_int144] = ACTIONS(647),
    [anon_sym_int152] = ACTIONS(647),
    [anon_sym_int160] = ACTIONS(647),
    [anon_sym_int168] = ACTIONS(647),
    [anon_sym_int176] = ACTIONS(647),
    [anon_sym_int184] = ACTIONS(647),
    [anon_sym_int192] = ACTIONS(647),
    [anon_sym_int200] = ACTIONS(647),
    [anon_sym_int208] = ACTIONS(647),
    [anon_sym_int216] = ACTIONS(647),
    [anon_sym_int224] = ACTIONS(647),
    [anon_sym_int232] = ACTIONS(647),
    [anon_sym_int240] = ACTIONS(647),
    [anon_sym_int248] = ACTIONS(647),
    [anon_sym_int256] = ACTIONS(647),
    [anon_sym_uint] = ACTIONS(647),
    [anon_sym_uint8] = ACTIONS(647),
    [anon_sym_uint16] = ACTIONS(647),
    [anon_sym_uint24] = ACTIONS(647),
    [anon_sym_uint32] = ACTIONS(647),
    [anon_sym_uint40] = ACTIONS(647),
    [anon_sym_uint48] = ACTIONS(647),
    [anon_sym_uint56] = ACTIONS(647),
    [anon_sym_uint64] = ACTIONS(647),
    [anon_sym_uint72] = ACTIONS(647),
    [anon_sym_uint80] = ACTIONS(647),
    [anon_sym_uint88] = ACTIONS(647),
    [anon_sym_uint96] = ACTIONS(647),
    [anon_sym_uint104] = ACTIONS(647),
    [anon_sym_uint112] = ACTIONS(647),
    [anon_sym_uint120] = ACTIONS(647),
    [anon_sym_uint128] = ACTIONS(647),
    [anon_sym_uint136] = ACTIONS(647),
    [anon_sym_uint144] = ACTIONS(647),
    [anon_sym_uint152] = ACTIONS(647),
    [anon_sym_uint160] = ACTIONS(647),
    [anon_sym_uint168] = ACTIONS(647),
    [anon_sym_uint176] = ACTIONS(647),
    [anon_sym_uint184] = ACTIONS(647),
    [anon_sym_uint192] = ACTIONS(647),
    [anon_sym_uint200] = ACTIONS(647),
    [anon_sym_uint208] = ACTIONS(647),
    [anon_sym_uint216] = ACTIONS(647),
    [anon_sym_uint224] = ACTIONS(647),
    [anon_sym_uint232] = ACTIONS(647),
    [anon_sym_uint240] = ACTIONS(647),
    [anon_sym_uint248] = ACTIONS(647),
    [anon_sym_uint256] = ACTIONS(647),
    [anon_sym_bytes] = ACTIONS(647),
    [anon_sym_bytes1] = ACTIONS(647),
    [anon_sym_bytes2] = ACTIONS(647),
    [anon_sym_bytes3] = ACTIONS(647),
    [anon_sym_bytes4] = ACTIONS(647),
    [anon_sym_bytes5] = ACTIONS(647),
    [anon_sym_bytes6] = ACTIONS(647),
    [anon_sym_bytes7] = ACTIONS(647),
    [anon_sym_bytes8] = ACTIONS(647),
    [anon_sym_bytes9] = ACTIONS(647),
    [anon_sym_bytes10] = ACTIONS(647),
    [anon_sym_bytes11] = ACTIONS(647),
    [anon_sym_bytes12] = ACTIONS(647),
    [anon_sym_bytes13] = ACTIONS(647),
    [anon_sym_bytes14] = ACTIONS(647),
    [anon_sym_bytes15] = ACTIONS(647),
    [anon_sym_bytes16] = ACTIONS(647),
    [anon_sym_bytes17] = ACTIONS(647),
    [anon_sym_bytes18] = ACTIONS(647),
    [anon_sym_bytes19] = ACTIONS(647),
    [anon_sym_bytes20] = ACTIONS(647),
    [anon_sym_bytes21] = ACTIONS(647),
    [anon_sym_bytes22] = ACTIONS(647),
    [anon_sym_bytes23] = ACTIONS(647),
    [anon_sym_bytes24] = ACTIONS(647),
    [anon_sym_bytes25] = ACTIONS(647),
    [anon_sym_bytes26] = ACTIONS(647),
    [anon_sym_bytes27] = ACTIONS(647),
    [anon_sym_bytes28] = ACTIONS(647),
    [anon_sym_bytes29] = ACTIONS(647),
    [anon_sym_bytes30] = ACTIONS(647),
    [anon_sym_bytes31] = ACTIONS(647),
    [anon_sym_bytes32] = ACTIONS(647),
    [anon_sym_fixed] = ACTIONS(647),
    [aux_sym__fixed_token1] = ACTIONS(647),
    [anon_sym_ufixed] = ACTIONS(647),
    [aux_sym__ufixed_token1] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(651),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_pragma] = ACTIONS(653),
    [anon_sym_import] = ACTIONS(653),
    [anon_sym_type] = ACTIONS(653),
    [anon_sym_abstract] = ACTIONS(653),
    [anon_sym_contract] = ACTIONS(653),
    [anon_sym_error] = ACTIONS(653),
    [anon_sym_interface] = ACTIONS(653),
    [anon_sym_library] = ACTIONS(653),
    [anon_sym_struct] = ACTIONS(653),
    [anon_sym_enum] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(653),
    [anon_sym_byte] = ACTIONS(653),
    [anon_sym_address] = ACTIONS(653),
    [anon_sym_var] = ACTIONS(653),
    [anon_sym_mapping] = ACTIONS(653),
    [anon_sym_bool] = ACTIONS(653),
    [anon_sym_string] = ACTIONS(653),
    [anon_sym_int] = ACTIONS(653),
    [anon_sym_int8] = ACTIONS(653),
    [anon_sym_int16] = ACTIONS(653),
    [anon_sym_int24] = ACTIONS(653),
    [anon_sym_int32] = ACTIONS(653),
    [anon_sym_int40] = ACTIONS(653),
    [anon_sym_int48] = ACTIONS(653),
    [anon_sym_int56] = ACTIONS(653),
    [anon_sym_int64] = ACTIONS(653),
    [anon_sym_int72] = ACTIONS(653),
    [anon_sym_int80] = ACTIONS(653),
    [anon_sym_int88] = ACTIONS(653),
    [anon_sym_int96] = ACTIONS(653),
    [anon_sym_int104] = ACTIONS(653),
    [anon_sym_int112] = ACTIONS(653),
    [anon_sym_int120] = ACTIONS(653),
    [anon_sym_int128] = ACTIONS(653),
    [anon_sym_int136] = ACTIONS(653),
    [anon_sym_int144] = ACTIONS(653),
    [anon_sym_int152] = ACTIONS(653),
    [anon_sym_int160] = ACTIONS(653),
    [anon_sym_int168] = ACTIONS(653),
    [anon_sym_int176] = ACTIONS(653),
    [anon_sym_int184] = ACTIONS(653),
    [anon_sym_int192] = ACTIONS(653),
    [anon_sym_int200] = ACTIONS(653),
    [anon_sym_int208] = ACTIONS(653),
    [anon_sym_int216] = ACTIONS(653),
    [anon_sym_int224] = ACTIONS(653),
    [anon_sym_int232] = ACTIONS(653),
    [anon_sym_int240] = ACTIONS(653),
    [anon_sym_int248] = ACTIONS(653),
    [anon_sym_int256] = ACTIONS(653),
    [anon_sym_uint] = ACTIONS(653),
    [anon_sym_uint8] = ACTIONS(653),
    [anon_sym_uint16] = ACTIONS(653),
    [anon_sym_uint24] = ACTIONS(653),
    [anon_sym_uint32] = ACTIONS(653),
    [anon_sym_uint40] = ACTIONS(653),
    [anon_sym_uint48] = ACTIONS(653),
    [anon_sym_uint56] = ACTIONS(653),
    [anon_sym_uint64] = ACTIONS(653),
    [anon_sym_uint72] = ACTIONS(653),
    [anon_sym_uint80] = ACTIONS(653),
    [anon_sym_uint88] = ACTIONS(653),
    [anon_sym_uint96] = ACTIONS(653),
    [anon_sym_uint104] = ACTIONS(653),
    [anon_sym_uint112] = ACTIONS(653),
    [anon_sym_uint120] = ACTIONS(653),
    [anon_sym_uint128] = ACTIONS(653),
    [anon_sym_uint136] = ACTIONS(653),
    [anon_sym_uint144] = ACTIONS(653),
    [anon_sym_uint152] = ACTIONS(653),
    [anon_sym_uint160] = ACTIONS(653),
    [anon_sym_uint168] = ACTIONS(653),
    [anon_sym_uint176] = ACTIONS(653),
    [anon_sym_uint184] = ACTIONS(653),
    [anon_sym_uint192] = ACTIONS(653),
    [anon_sym_uint200] = ACTIONS(653),
    [anon_sym_uint208] = ACTIONS(653),
    [anon_sym_uint216] = ACTIONS(653),
    [anon_sym_uint224] = ACTIONS(653),
    [anon_sym_uint232] = ACTIONS(653),
    [anon_sym_uint240] = ACTIONS(653),
    [anon_sym_uint248] = ACTIONS(653),
    [anon_sym_uint256] = ACTIONS(653),
    [anon_sym_bytes] = ACTIONS(653),
    [anon_sym_bytes1] = ACTIONS(653),
    [anon_sym_bytes2] = ACTIONS(653),
    [anon_sym_bytes3] = ACTIONS(653),
    [anon_sym_bytes4] = ACTIONS(653),
    [anon_sym_bytes5] = ACTIONS(653),
    [anon_sym_bytes6] = ACTIONS(653),
    [anon_sym_bytes7] = ACTIONS(653),
    [anon_sym_bytes8] = ACTIONS(653),
    [anon_sym_bytes9] = ACTIONS(653),
    [anon_sym_bytes10] = ACTIONS(653),
    [anon_sym_bytes11] = ACTIONS(653),
    [anon_sym_bytes12] = ACTIONS(653),
    [anon_sym_bytes13] = ACTIONS(653),
    [anon_sym_bytes14] = ACTIONS(653),
    [anon_sym_bytes15] = ACTIONS(653),
    [anon_sym_bytes16] = ACTIONS(653),
    [anon_sym_bytes17] = ACTIONS(653),
    [anon_sym_bytes18] = ACTIONS(653),
    [anon_sym_bytes19] = ACTIONS(653),
    [anon_sym_bytes20] = ACTIONS(653),
    [anon_sym_bytes21] = ACTIONS(653),
    [anon_sym_bytes22] = ACTIONS(653),
    [anon_sym_bytes23] = ACTIONS(653),
    [anon_sym_bytes24] = ACTIONS(653),
    [anon_sym_bytes25] = ACTIONS(653),
    [anon_sym_bytes26] = ACTIONS(653),
    [anon_sym_bytes27] = ACTIONS(653),
    [anon_sym_bytes28] = ACTIONS(653),
    [anon_sym_bytes29] = ACTIONS(653),
    [anon_sym_bytes30] = ACTIONS(653),
    [anon_sym_bytes31] = ACTIONS(653),
    [anon_sym_bytes32] = ACTIONS(653),
    [anon_sym_fixed] = ACTIONS(653),
    [aux_sym__fixed_token1] = ACTIONS(653),
    [anon_sym_ufixed] = ACTIONS(653),
    [aux_sym__ufixed_token1] = ACTIONS(653),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym_identifier] = ACTIONS(657),
    [anon_sym_pragma] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(657),
    [anon_sym_type] = ACTIONS(657),
    [anon_sym_abstract] = ACTIONS(657),
    [anon_sym_contract] = ACTIONS(657),
    [anon_sym_error] = ACTIONS(657),
    [anon_sym_interface] = ACTIONS(657),
    [anon_sym_library] = ACTIONS(657),
    [anon_sym_struct] = ACTIONS(657),
    [anon_sym_enum] = ACTIONS(657),
    [anon_sym_function] = ACTIONS(657),
    [anon_sym_byte] = ACTIONS(657),
    [anon_sym_address] = ACTIONS(657),
    [anon_sym_var] = ACTIONS(657),
    [anon_sym_mapping] = ACTIONS(657),
    [anon_sym_bool] = ACTIONS(657),
    [anon_sym_string] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_int8] = ACTIONS(657),
    [anon_sym_int16] = ACTIONS(657),
    [anon_sym_int24] = ACTIONS(657),
    [anon_sym_int32] = ACTIONS(657),
    [anon_sym_int40] = ACTIONS(657),
    [anon_sym_int48] = ACTIONS(657),
    [anon_sym_int56] = ACTIONS(657),
    [anon_sym_int64] = ACTIONS(657),
    [anon_sym_int72] = ACTIONS(657),
    [anon_sym_int80] = ACTIONS(657),
    [anon_sym_int88] = ACTIONS(657),
    [anon_sym_int96] = ACTIONS(657),
    [anon_sym_int104] = ACTIONS(657),
    [anon_sym_int112] = ACTIONS(657),
    [anon_sym_int120] = ACTIONS(657),
    [anon_sym_int128] = ACTIONS(657),
    [anon_sym_int136] = ACTIONS(657),
    [anon_sym_int144] = ACTIONS(657),
    [anon_sym_int152] = ACTIONS(657),
    [anon_sym_int160] = ACTIONS(657),
    [anon_sym_int168] = ACTIONS(657),
    [anon_sym_int176] = ACTIONS(657),
    [anon_sym_int184] = ACTIONS(657),
    [anon_sym_int192] = ACTIONS(657),
    [anon_sym_int200] = ACTIONS(657),
    [anon_sym_int208] = ACTIONS(657),
    [anon_sym_int216] = ACTIONS(657),
    [anon_sym_int224] = ACTIONS(657),
    [anon_sym_int232] = ACTIONS(657),
    [anon_sym_int240] = ACTIONS(657),
    [anon_sym_int248] = ACTIONS(657),
    [anon_sym_int256] = ACTIONS(657),
    [anon_sym_uint] = ACTIONS(657),
    [anon_sym_uint8] = ACTIONS(657),
    [anon_sym_uint16] = ACTIONS(657),
    [anon_sym_uint24] = ACTIONS(657),
    [anon_sym_uint32] = ACTIONS(657),
    [anon_sym_uint40] = ACTIONS(657),
    [anon_sym_uint48] = ACTIONS(657),
    [anon_sym_uint56] = ACTIONS(657),
    [anon_sym_uint64] = ACTIONS(657),
    [anon_sym_uint72] = ACTIONS(657),
    [anon_sym_uint80] = ACTIONS(657),
    [anon_sym_uint88] = ACTIONS(657),
    [anon_sym_uint96] = ACTIONS(657),
    [anon_sym_uint104] = ACTIONS(657),
    [anon_sym_uint112] = ACTIONS(657),
    [anon_sym_uint120] = ACTIONS(657),
    [anon_sym_uint128] = ACTIONS(657),
    [anon_sym_uint136] = ACTIONS(657),
    [anon_sym_uint144] = ACTIONS(657),
    [anon_sym_uint152] = ACTIONS(657),
    [anon_sym_uint160] = ACTIONS(657),
    [anon_sym_uint168] = ACTIONS(657),
    [anon_sym_uint176] = ACTIONS(657),
    [anon_sym_uint184] = ACTIONS(657),
    [anon_sym_uint192] = ACTIONS(657),
    [anon_sym_uint200] = ACTIONS(657),
    [anon_sym_uint208] = ACTIONS(657),
    [anon_sym_uint216] = ACTIONS(657),
    [anon_sym_uint224] = ACTIONS(657),
    [anon_sym_uint232] = ACTIONS(657),
    [anon_sym_uint240] = ACTIONS(657),
    [anon_sym_uint248] = ACTIONS(657),
    [anon_sym_uint256] = ACTIONS(657),
    [anon_sym_bytes] = ACTIONS(657),
    [anon_sym_bytes1] = ACTIONS(657),
    [anon_sym_bytes2] = ACTIONS(657),
    [anon_sym_bytes3] = ACTIONS(657),
    [anon_sym_bytes4] = ACTIONS(657),
    [anon_sym_bytes5] = ACTIONS(657),
    [anon_sym_bytes6] = ACTIONS(657),
    [anon_sym_bytes7] = ACTIONS(657),
    [anon_sym_bytes8] = ACTIONS(657),
    [anon_sym_bytes9] = ACTIONS(657),
    [anon_sym_bytes10] = ACTIONS(657),
    [anon_sym_bytes11] = ACTIONS(657),
    [anon_sym_bytes12] = ACTIONS(657),
    [anon_sym_bytes13] = ACTIONS(657),
    [anon_sym_bytes14] = ACTIONS(657),
    [anon_sym_bytes15] = ACTIONS(657),
    [anon_sym_bytes16] = ACTIONS(657),
    [anon_sym_bytes17] = ACTIONS(657),
    [anon_sym_bytes18] = ACTIONS(657),
    [anon_sym_bytes19] = ACTIONS(657),
    [anon_sym_bytes20] = ACTIONS(657),
    [anon_sym_bytes21] = ACTIONS(657),
    [anon_sym_bytes22] = ACTIONS(657),
    [anon_sym_bytes23] = ACTIONS(657),
    [anon_sym_bytes24] = ACTIONS(657),
    [anon_sym_bytes25] = ACTIONS(657),
    [anon_sym_bytes26] = ACTIONS(657),
    [anon_sym_bytes27] = ACTIONS(657),
    [anon_sym_bytes28] = ACTIONS(657),
    [anon_sym_bytes29] = ACTIONS(657),
    [anon_sym_bytes30] = ACTIONS(657),
    [anon_sym_bytes31] = ACTIONS(657),
    [anon_sym_bytes32] = ACTIONS(657),
    [anon_sym_fixed] = ACTIONS(657),
    [aux_sym__fixed_token1] = ACTIONS(657),
    [anon_sym_ufixed] = ACTIONS(657),
    [aux_sym__ufixed_token1] = ACTIONS(657),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(659),
    [sym_identifier] = ACTIONS(661),
    [anon_sym_pragma] = ACTIONS(661),
    [anon_sym_import] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_abstract] = ACTIONS(661),
    [anon_sym_contract] = ACTIONS(661),
    [anon_sym_error] = ACTIONS(661),
    [anon_sym_interface] = ACTIONS(661),
    [anon_sym_library] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_function] = ACTIONS(661),
    [anon_sym_byte] = ACTIONS(661),
    [anon_sym_address] = ACTIONS(661),
    [anon_sym_var] = ACTIONS(661),
    [anon_sym_mapping] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_string] = ACTIONS(661),
    [anon_sym_int] = ACTIONS(661),
    [anon_sym_int8] = ACTIONS(661),
    [anon_sym_int16] = ACTIONS(661),
    [anon_sym_int24] = ACTIONS(661),
    [anon_sym_int32] = ACTIONS(661),
    [anon_sym_int40] = ACTIONS(661),
    [anon_sym_int48] = ACTIONS(661),
    [anon_sym_int56] = ACTIONS(661),
    [anon_sym_int64] = ACTIONS(661),
    [anon_sym_int72] = ACTIONS(661),
    [anon_sym_int80] = ACTIONS(661),
    [anon_sym_int88] = ACTIONS(661),
    [anon_sym_int96] = ACTIONS(661),
    [anon_sym_int104] = ACTIONS(661),
    [anon_sym_int112] = ACTIONS(661),
    [anon_sym_int120] = ACTIONS(661),
    [anon_sym_int128] = ACTIONS(661),
    [anon_sym_int136] = ACTIONS(661),
    [anon_sym_int144] = ACTIONS(661),
    [anon_sym_int152] = ACTIONS(661),
    [anon_sym_int160] = ACTIONS(661),
    [anon_sym_int168] = ACTIONS(661),
    [anon_sym_int176] = ACTIONS(661),
    [anon_sym_int184] = ACTIONS(661),
    [anon_sym_int192] = ACTIONS(661),
    [anon_sym_int200] = ACTIONS(661),
    [anon_sym_int208] = ACTIONS(661),
    [anon_sym_int216] = ACTIONS(661),
    [anon_sym_int224] = ACTIONS(661),
    [anon_sym_int232] = ACTIONS(661),
    [anon_sym_int240] = ACTIONS(661),
    [anon_sym_int248] = ACTIONS(661),
    [anon_sym_int256] = ACTIONS(661),
    [anon_sym_uint] = ACTIONS(661),
    [anon_sym_uint8] = ACTIONS(661),
    [anon_sym_uint16] = ACTIONS(661),
    [anon_sym_uint24] = ACTIONS(661),
    [anon_sym_uint32] = ACTIONS(661),
    [anon_sym_uint40] = ACTIONS(661),
    [anon_sym_uint48] = ACTIONS(661),
    [anon_sym_uint56] = ACTIONS(661),
    [anon_sym_uint64] = ACTIONS(661),
    [anon_sym_uint72] = ACTIONS(661),
    [anon_sym_uint80] = ACTIONS(661),
    [anon_sym_uint88] = ACTIONS(661),
    [anon_sym_uint96] = ACTIONS(661),
    [anon_sym_uint104] = ACTIONS(661),
    [anon_sym_uint112] = ACTIONS(661),
    [anon_sym_uint120] = ACTIONS(661),
    [anon_sym_uint128] = ACTIONS(661),
    [anon_sym_uint136] = ACTIONS(661),
    [anon_sym_uint144] = ACTIONS(661),
    [anon_sym_uint152] = ACTIONS(661),
    [anon_sym_uint160] = ACTIONS(661),
    [anon_sym_uint168] = ACTIONS(661),
    [anon_sym_uint176] = ACTIONS(661),
    [anon_sym_uint184] = ACTIONS(661),
    [anon_sym_uint192] = ACTIONS(661),
    [anon_sym_uint200] = ACTIONS(661),
    [anon_sym_uint208] = ACTIONS(661),
    [anon_sym_uint216] = ACTIONS(661),
    [anon_sym_uint224] = ACTIONS(661),
    [anon_sym_uint232] = ACTIONS(661),
    [anon_sym_uint240] = ACTIONS(661),
    [anon_sym_uint248] = ACTIONS(661),
    [anon_sym_uint256] = ACTIONS(661),
    [anon_sym_bytes] = ACTIONS(661),
    [anon_sym_bytes1] = ACTIONS(661),
    [anon_sym_bytes2] = ACTIONS(661),
    [anon_sym_bytes3] = ACTIONS(661),
    [anon_sym_bytes4] = ACTIONS(661),
    [anon_sym_bytes5] = ACTIONS(661),
    [anon_sym_bytes6] = ACTIONS(661),
    [anon_sym_bytes7] = ACTIONS(661),
    [anon_sym_bytes8] = ACTIONS(661),
    [anon_sym_bytes9] = ACTIONS(661),
    [anon_sym_bytes10] = ACTIONS(661),
    [anon_sym_bytes11] = ACTIONS(661),
    [anon_sym_bytes12] = ACTIONS(661),
    [anon_sym_bytes13] = ACTIONS(661),
    [anon_sym_bytes14] = ACTIONS(661),
    [anon_sym_bytes15] = ACTIONS(661),
    [anon_sym_bytes16] = ACTIONS(661),
    [anon_sym_bytes17] = ACTIONS(661),
    [anon_sym_bytes18] = ACTIONS(661),
    [anon_sym_bytes19] = ACTIONS(661),
    [anon_sym_bytes20] = ACTIONS(661),
    [anon_sym_bytes21] = ACTIONS(661),
    [anon_sym_bytes22] = ACTIONS(661),
    [anon_sym_bytes23] = ACTIONS(661),
    [anon_sym_bytes24] = ACTIONS(661),
    [anon_sym_bytes25] = ACTIONS(661),
    [anon_sym_bytes26] = ACTIONS(661),
    [anon_sym_bytes27] = ACTIONS(661),
    [anon_sym_bytes28] = ACTIONS(661),
    [anon_sym_bytes29] = ACTIONS(661),
    [anon_sym_bytes30] = ACTIONS(661),
    [anon_sym_bytes31] = ACTIONS(661),
    [anon_sym_bytes32] = ACTIONS(661),
    [anon_sym_fixed] = ACTIONS(661),
    [aux_sym__fixed_token1] = ACTIONS(661),
    [anon_sym_ufixed] = ACTIONS(661),
    [aux_sym__ufixed_token1] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_pragma] = ACTIONS(665),
    [anon_sym_import] = ACTIONS(665),
    [anon_sym_type] = ACTIONS(665),
    [anon_sym_abstract] = ACTIONS(665),
    [anon_sym_contract] = ACTIONS(665),
    [anon_sym_error] = ACTIONS(665),
    [anon_sym_interface] = ACTIONS(665),
    [anon_sym_library] = ACTIONS(665),
    [anon_sym_struct] = ACTIONS(665),
    [anon_sym_enum] = ACTIONS(665),
    [anon_sym_function] = ACTIONS(665),
    [anon_sym_byte] = ACTIONS(665),
    [anon_sym_address] = ACTIONS(665),
    [anon_sym_var] = ACTIONS(665),
    [anon_sym_mapping] = ACTIONS(665),
    [anon_sym_bool] = ACTIONS(665),
    [anon_sym_string] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_int8] = ACTIONS(665),
    [anon_sym_int16] = ACTIONS(665),
    [anon_sym_int24] = ACTIONS(665),
    [anon_sym_int32] = ACTIONS(665),
    [anon_sym_int40] = ACTIONS(665),
    [anon_sym_int48] = ACTIONS(665),
    [anon_sym_int56] = ACTIONS(665),
    [anon_sym_int64] = ACTIONS(665),
    [anon_sym_int72] = ACTIONS(665),
    [anon_sym_int80] = ACTIONS(665),
    [anon_sym_int88] = ACTIONS(665),
    [anon_sym_int96] = ACTIONS(665),
    [anon_sym_int104] = ACTIONS(665),
    [anon_sym_int112] = ACTIONS(665),
    [anon_sym_int120] = ACTIONS(665),
    [anon_sym_int128] = ACTIONS(665),
    [anon_sym_int136] = ACTIONS(665),
    [anon_sym_int144] = ACTIONS(665),
    [anon_sym_int152] = ACTIONS(665),
    [anon_sym_int160] = ACTIONS(665),
    [anon_sym_int168] = ACTIONS(665),
    [anon_sym_int176] = ACTIONS(665),
    [anon_sym_int184] = ACTIONS(665),
    [anon_sym_int192] = ACTIONS(665),
    [anon_sym_int200] = ACTIONS(665),
    [anon_sym_int208] = ACTIONS(665),
    [anon_sym_int216] = ACTIONS(665),
    [anon_sym_int224] = ACTIONS(665),
    [anon_sym_int232] = ACTIONS(665),
    [anon_sym_int240] = ACTIONS(665),
    [anon_sym_int248] = ACTIONS(665),
    [anon_sym_int256] = ACTIONS(665),
    [anon_sym_uint] = ACTIONS(665),
    [anon_sym_uint8] = ACTIONS(665),
    [anon_sym_uint16] = ACTIONS(665),
    [anon_sym_uint24] = ACTIONS(665),
    [anon_sym_uint32] = ACTIONS(665),
    [anon_sym_uint40] = ACTIONS(665),
    [anon_sym_uint48] = ACTIONS(665),
    [anon_sym_uint56] = ACTIONS(665),
    [anon_sym_uint64] = ACTIONS(665),
    [anon_sym_uint72] = ACTIONS(665),
    [anon_sym_uint80] = ACTIONS(665),
    [anon_sym_uint88] = ACTIONS(665),
    [anon_sym_uint96] = ACTIONS(665),
    [anon_sym_uint104] = ACTIONS(665),
    [anon_sym_uint112] = ACTIONS(665),
    [anon_sym_uint120] = ACTIONS(665),
    [anon_sym_uint128] = ACTIONS(665),
    [anon_sym_uint136] = ACTIONS(665),
    [anon_sym_uint144] = ACTIONS(665),
    [anon_sym_uint152] = ACTIONS(665),
    [anon_sym_uint160] = ACTIONS(665),
    [anon_sym_uint168] = ACTIONS(665),
    [anon_sym_uint176] = ACTIONS(665),
    [anon_sym_uint184] = ACTIONS(665),
    [anon_sym_uint192] = ACTIONS(665),
    [anon_sym_uint200] = ACTIONS(665),
    [anon_sym_uint208] = ACTIONS(665),
    [anon_sym_uint216] = ACTIONS(665),
    [anon_sym_uint224] = ACTIONS(665),
    [anon_sym_uint232] = ACTIONS(665),
    [anon_sym_uint240] = ACTIONS(665),
    [anon_sym_uint248] = ACTIONS(665),
    [anon_sym_uint256] = ACTIONS(665),
    [anon_sym_bytes] = ACTIONS(665),
    [anon_sym_bytes1] = ACTIONS(665),
    [anon_sym_bytes2] = ACTIONS(665),
    [anon_sym_bytes3] = ACTIONS(665),
    [anon_sym_bytes4] = ACTIONS(665),
    [anon_sym_bytes5] = ACTIONS(665),
    [anon_sym_bytes6] = ACTIONS(665),
    [anon_sym_bytes7] = ACTIONS(665),
    [anon_sym_bytes8] = ACTIONS(665),
    [anon_sym_bytes9] = ACTIONS(665),
    [anon_sym_bytes10] = ACTIONS(665),
    [anon_sym_bytes11] = ACTIONS(665),
    [anon_sym_bytes12] = ACTIONS(665),
    [anon_sym_bytes13] = ACTIONS(665),
    [anon_sym_bytes14] = ACTIONS(665),
    [anon_sym_bytes15] = ACTIONS(665),
    [anon_sym_bytes16] = ACTIONS(665),
    [anon_sym_bytes17] = ACTIONS(665),
    [anon_sym_bytes18] = ACTIONS(665),
    [anon_sym_bytes19] = ACTIONS(665),
    [anon_sym_bytes20] = ACTIONS(665),
    [anon_sym_bytes21] = ACTIONS(665),
    [anon_sym_bytes22] = ACTIONS(665),
    [anon_sym_bytes23] = ACTIONS(665),
    [anon_sym_bytes24] = ACTIONS(665),
    [anon_sym_bytes25] = ACTIONS(665),
    [anon_sym_bytes26] = ACTIONS(665),
    [anon_sym_bytes27] = ACTIONS(665),
    [anon_sym_bytes28] = ACTIONS(665),
    [anon_sym_bytes29] = ACTIONS(665),
    [anon_sym_bytes30] = ACTIONS(665),
    [anon_sym_bytes31] = ACTIONS(665),
    [anon_sym_bytes32] = ACTIONS(665),
    [anon_sym_fixed] = ACTIONS(665),
    [aux_sym__fixed_token1] = ACTIONS(665),
    [anon_sym_ufixed] = ACTIONS(665),
    [aux_sym__ufixed_token1] = ACTIONS(665),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_identifier] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_type] = ACTIONS(667),
    [anon_sym_error] = ACTIONS(667),
    [anon_sym_struct] = ACTIONS(667),
    [anon_sym_enum] = ACTIONS(667),
    [anon_sym_event] = ACTIONS(667),
    [anon_sym_using] = ACTIONS(667),
    [anon_sym_function] = ACTIONS(667),
    [anon_sym_byte] = ACTIONS(667),
    [anon_sym_address] = ACTIONS(667),
    [anon_sym_var] = ACTIONS(667),
    [anon_sym_modifier] = ACTIONS(667),
    [anon_sym_constructor] = ACTIONS(667),
    [anon_sym_fallback] = ACTIONS(667),
    [anon_sym_receive] = ACTIONS(667),
    [anon_sym_mapping] = ACTIONS(667),
    [anon_sym_bool] = ACTIONS(667),
    [anon_sym_string] = ACTIONS(667),
    [anon_sym_int] = ACTIONS(667),
    [anon_sym_int8] = ACTIONS(667),
    [anon_sym_int16] = ACTIONS(667),
    [anon_sym_int24] = ACTIONS(667),
    [anon_sym_int32] = ACTIONS(667),
    [anon_sym_int40] = ACTIONS(667),
    [anon_sym_int48] = ACTIONS(667),
    [anon_sym_int56] = ACTIONS(667),
    [anon_sym_int64] = ACTIONS(667),
    [anon_sym_int72] = ACTIONS(667),
    [anon_sym_int80] = ACTIONS(667),
    [anon_sym_int88] = ACTIONS(667),
    [anon_sym_int96] = ACTIONS(667),
    [anon_sym_int104] = ACTIONS(667),
    [anon_sym_int112] = ACTIONS(667),
    [anon_sym_int120] = ACTIONS(667),
    [anon_sym_int128] = ACTIONS(667),
    [anon_sym_int136] = ACTIONS(667),
    [anon_sym_int144] = ACTIONS(667),
    [anon_sym_int152] = ACTIONS(667),
    [anon_sym_int160] = ACTIONS(667),
    [anon_sym_int168] = ACTIONS(667),
    [anon_sym_int176] = ACTIONS(667),
    [anon_sym_int184] = ACTIONS(667),
    [anon_sym_int192] = ACTIONS(667),
    [anon_sym_int200] = ACTIONS(667),
    [anon_sym_int208] = ACTIONS(667),
    [anon_sym_int216] = ACTIONS(667),
    [anon_sym_int224] = ACTIONS(667),
    [anon_sym_int232] = ACTIONS(667),
    [anon_sym_int240] = ACTIONS(667),
    [anon_sym_int248] = ACTIONS(667),
    [anon_sym_int256] = ACTIONS(667),
    [anon_sym_uint] = ACTIONS(667),
    [anon_sym_uint8] = ACTIONS(667),
    [anon_sym_uint16] = ACTIONS(667),
    [anon_sym_uint24] = ACTIONS(667),
    [anon_sym_uint32] = ACTIONS(667),
    [anon_sym_uint40] = ACTIONS(667),
    [anon_sym_uint48] = ACTIONS(667),
    [anon_sym_uint56] = ACTIONS(667),
    [anon_sym_uint64] = ACTIONS(667),
    [anon_sym_uint72] = ACTIONS(667),
    [anon_sym_uint80] = ACTIONS(667),
    [anon_sym_uint88] = ACTIONS(667),
    [anon_sym_uint96] = ACTIONS(667),
    [anon_sym_uint104] = ACTIONS(667),
    [anon_sym_uint112] = ACTIONS(667),
    [anon_sym_uint120] = ACTIONS(667),
    [anon_sym_uint128] = ACTIONS(667),
    [anon_sym_uint136] = ACTIONS(667),
    [anon_sym_uint144] = ACTIONS(667),
    [anon_sym_uint152] = ACTIONS(667),
    [anon_sym_uint160] = ACTIONS(667),
    [anon_sym_uint168] = ACTIONS(667),
    [anon_sym_uint176] = ACTIONS(667),
    [anon_sym_uint184] = ACTIONS(667),
    [anon_sym_uint192] = ACTIONS(667),
    [anon_sym_uint200] = ACTIONS(667),
    [anon_sym_uint208] = ACTIONS(667),
    [anon_sym_uint216] = ACTIONS(667),
    [anon_sym_uint224] = ACTIONS(667),
    [anon_sym_uint232] = ACTIONS(667),
    [anon_sym_uint240] = ACTIONS(667),
    [anon_sym_uint248] = ACTIONS(667),
    [anon_sym_uint256] = ACTIONS(667),
    [anon_sym_bytes] = ACTIONS(667),
    [anon_sym_bytes1] = ACTIONS(667),
    [anon_sym_bytes2] = ACTIONS(667),
    [anon_sym_bytes3] = ACTIONS(667),
    [anon_sym_bytes4] = ACTIONS(667),
    [anon_sym_bytes5] = ACTIONS(667),
    [anon_sym_bytes6] = ACTIONS(667),
    [anon_sym_bytes7] = ACTIONS(667),
    [anon_sym_bytes8] = ACTIONS(667),
    [anon_sym_bytes9] = ACTIONS(667),
    [anon_sym_bytes10] = ACTIONS(667),
    [anon_sym_bytes11] = ACTIONS(667),
    [anon_sym_bytes12] = ACTIONS(667),
    [anon_sym_bytes13] = ACTIONS(667),
    [anon_sym_bytes14] = ACTIONS(667),
    [anon_sym_bytes15] = ACTIONS(667),
    [anon_sym_bytes16] = ACTIONS(667),
    [anon_sym_bytes17] = ACTIONS(667),
    [anon_sym_bytes18] = ACTIONS(667),
    [anon_sym_bytes19] = ACTIONS(667),
    [anon_sym_bytes20] = ACTIONS(667),
    [anon_sym_bytes21] = ACTIONS(667),
    [anon_sym_bytes22] = ACTIONS(667),
    [anon_sym_bytes23] = ACTIONS(667),
    [anon_sym_bytes24] = ACTIONS(667),
    [anon_sym_bytes25] = ACTIONS(667),
    [anon_sym_bytes26] = ACTIONS(667),
    [anon_sym_bytes27] = ACTIONS(667),
    [anon_sym_bytes28] = ACTIONS(667),
    [anon_sym_bytes29] = ACTIONS(667),
    [anon_sym_bytes30] = ACTIONS(667),
    [anon_sym_bytes31] = ACTIONS(667),
    [anon_sym_bytes32] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(667),
    [aux_sym__fixed_token1] = ACTIONS(667),
    [anon_sym_ufixed] = ACTIONS(667),
    [aux_sym__ufixed_token1] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(671),
    [sym_identifier] = ACTIONS(673),
    [anon_sym_pragma] = ACTIONS(673),
    [anon_sym_import] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(673),
    [anon_sym_abstract] = ACTIONS(673),
    [anon_sym_contract] = ACTIONS(673),
    [anon_sym_error] = ACTIONS(673),
    [anon_sym_interface] = ACTIONS(673),
    [anon_sym_library] = ACTIONS(673),
    [anon_sym_struct] = ACTIONS(673),
    [anon_sym_enum] = ACTIONS(673),
    [anon_sym_function] = ACTIONS(673),
    [anon_sym_byte] = ACTIONS(673),
    [anon_sym_address] = ACTIONS(673),
    [anon_sym_var] = ACTIONS(673),
    [anon_sym_mapping] = ACTIONS(673),
    [anon_sym_bool] = ACTIONS(673),
    [anon_sym_string] = ACTIONS(673),
    [anon_sym_int] = ACTIONS(673),
    [anon_sym_int8] = ACTIONS(673),
    [anon_sym_int16] = ACTIONS(673),
    [anon_sym_int24] = ACTIONS(673),
    [anon_sym_int32] = ACTIONS(673),
    [anon_sym_int40] = ACTIONS(673),
    [anon_sym_int48] = ACTIONS(673),
    [anon_sym_int56] = ACTIONS(673),
    [anon_sym_int64] = ACTIONS(673),
    [anon_sym_int72] = ACTIONS(673),
    [anon_sym_int80] = ACTIONS(673),
    [anon_sym_int88] = ACTIONS(673),
    [anon_sym_int96] = ACTIONS(673),
    [anon_sym_int104] = ACTIONS(673),
    [anon_sym_int112] = ACTIONS(673),
    [anon_sym_int120] = ACTIONS(673),
    [anon_sym_int128] = ACTIONS(673),
    [anon_sym_int136] = ACTIONS(673),
    [anon_sym_int144] = ACTIONS(673),
    [anon_sym_int152] = ACTIONS(673),
    [anon_sym_int160] = ACTIONS(673),
    [anon_sym_int168] = ACTIONS(673),
    [anon_sym_int176] = ACTIONS(673),
    [anon_sym_int184] = ACTIONS(673),
    [anon_sym_int192] = ACTIONS(673),
    [anon_sym_int200] = ACTIONS(673),
    [anon_sym_int208] = ACTIONS(673),
    [anon_sym_int216] = ACTIONS(673),
    [anon_sym_int224] = ACTIONS(673),
    [anon_sym_int232] = ACTIONS(673),
    [anon_sym_int240] = ACTIONS(673),
    [anon_sym_int248] = ACTIONS(673),
    [anon_sym_int256] = ACTIONS(673),
    [anon_sym_uint] = ACTIONS(673),
    [anon_sym_uint8] = ACTIONS(673),
    [anon_sym_uint16] = ACTIONS(673),
    [anon_sym_uint24] = ACTIONS(673),
    [anon_sym_uint32] = ACTIONS(673),
    [anon_sym_uint40] = ACTIONS(673),
    [anon_sym_uint48] = ACTIONS(673),
    [anon_sym_uint56] = ACTIONS(673),
    [anon_sym_uint64] = ACTIONS(673),
    [anon_sym_uint72] = ACTIONS(673),
    [anon_sym_uint80] = ACTIONS(673),
    [anon_sym_uint88] = ACTIONS(673),
    [anon_sym_uint96] = ACTIONS(673),
    [anon_sym_uint104] = ACTIONS(673),
    [anon_sym_uint112] = ACTIONS(673),
    [anon_sym_uint120] = ACTIONS(673),
    [anon_sym_uint128] = ACTIONS(673),
    [anon_sym_uint136] = ACTIONS(673),
    [anon_sym_uint144] = ACTIONS(673),
    [anon_sym_uint152] = ACTIONS(673),
    [anon_sym_uint160] = ACTIONS(673),
    [anon_sym_uint168] = ACTIONS(673),
    [anon_sym_uint176] = ACTIONS(673),
    [anon_sym_uint184] = ACTIONS(673),
    [anon_sym_uint192] = ACTIONS(673),
    [anon_sym_uint200] = ACTIONS(673),
    [anon_sym_uint208] = ACTIONS(673),
    [anon_sym_uint216] = ACTIONS(673),
    [anon_sym_uint224] = ACTIONS(673),
    [anon_sym_uint232] = ACTIONS(673),
    [anon_sym_uint240] = ACTIONS(673),
    [anon_sym_uint248] = ACTIONS(673),
    [anon_sym_uint256] = ACTIONS(673),
    [anon_sym_bytes] = ACTIONS(673),
    [anon_sym_bytes1] = ACTIONS(673),
    [anon_sym_bytes2] = ACTIONS(673),
    [anon_sym_bytes3] = ACTIONS(673),
    [anon_sym_bytes4] = ACTIONS(673),
    [anon_sym_bytes5] = ACTIONS(673),
    [anon_sym_bytes6] = ACTIONS(673),
    [anon_sym_bytes7] = ACTIONS(673),
    [anon_sym_bytes8] = ACTIONS(673),
    [anon_sym_bytes9] = ACTIONS(673),
    [anon_sym_bytes10] = ACTIONS(673),
    [anon_sym_bytes11] = ACTIONS(673),
    [anon_sym_bytes12] = ACTIONS(673),
    [anon_sym_bytes13] = ACTIONS(673),
    [anon_sym_bytes14] = ACTIONS(673),
    [anon_sym_bytes15] = ACTIONS(673),
    [anon_sym_bytes16] = ACTIONS(673),
    [anon_sym_bytes17] = ACTIONS(673),
    [anon_sym_bytes18] = ACTIONS(673),
    [anon_sym_bytes19] = ACTIONS(673),
    [anon_sym_bytes20] = ACTIONS(673),
    [anon_sym_bytes21] = ACTIONS(673),
    [anon_sym_bytes22] = ACTIONS(673),
    [anon_sym_bytes23] = ACTIONS(673),
    [anon_sym_bytes24] = ACTIONS(673),
    [anon_sym_bytes25] = ACTIONS(673),
    [anon_sym_bytes26] = ACTIONS(673),
    [anon_sym_bytes27] = ACTIONS(673),
    [anon_sym_bytes28] = ACTIONS(673),
    [anon_sym_bytes29] = ACTIONS(673),
    [anon_sym_bytes30] = ACTIONS(673),
    [anon_sym_bytes31] = ACTIONS(673),
    [anon_sym_bytes32] = ACTIONS(673),
    [anon_sym_fixed] = ACTIONS(673),
    [aux_sym__fixed_token1] = ACTIONS(673),
    [anon_sym_ufixed] = ACTIONS(673),
    [aux_sym__ufixed_token1] = ACTIONS(673),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_identifier] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(677),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_error] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_event] = ACTIONS(675),
    [anon_sym_using] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(675),
    [anon_sym_byte] = ACTIONS(675),
    [anon_sym_address] = ACTIONS(675),
    [anon_sym_var] = ACTIONS(675),
    [anon_sym_modifier] = ACTIONS(675),
    [anon_sym_constructor] = ACTIONS(675),
    [anon_sym_fallback] = ACTIONS(675),
    [anon_sym_receive] = ACTIONS(675),
    [anon_sym_mapping] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_string] = ACTIONS(675),
    [anon_sym_int] = ACTIONS(675),
    [anon_sym_int8] = ACTIONS(675),
    [anon_sym_int16] = ACTIONS(675),
    [anon_sym_int24] = ACTIONS(675),
    [anon_sym_int32] = ACTIONS(675),
    [anon_sym_int40] = ACTIONS(675),
    [anon_sym_int48] = ACTIONS(675),
    [anon_sym_int56] = ACTIONS(675),
    [anon_sym_int64] = ACTIONS(675),
    [anon_sym_int72] = ACTIONS(675),
    [anon_sym_int80] = ACTIONS(675),
    [anon_sym_int88] = ACTIONS(675),
    [anon_sym_int96] = ACTIONS(675),
    [anon_sym_int104] = ACTIONS(675),
    [anon_sym_int112] = ACTIONS(675),
    [anon_sym_int120] = ACTIONS(675),
    [anon_sym_int128] = ACTIONS(675),
    [anon_sym_int136] = ACTIONS(675),
    [anon_sym_int144] = ACTIONS(675),
    [anon_sym_int152] = ACTIONS(675),
    [anon_sym_int160] = ACTIONS(675),
    [anon_sym_int168] = ACTIONS(675),
    [anon_sym_int176] = ACTIONS(675),
    [anon_sym_int184] = ACTIONS(675),
    [anon_sym_int192] = ACTIONS(675),
    [anon_sym_int200] = ACTIONS(675),
    [anon_sym_int208] = ACTIONS(675),
    [anon_sym_int216] = ACTIONS(675),
    [anon_sym_int224] = ACTIONS(675),
    [anon_sym_int232] = ACTIONS(675),
    [anon_sym_int240] = ACTIONS(675),
    [anon_sym_int248] = ACTIONS(675),
    [anon_sym_int256] = ACTIONS(675),
    [anon_sym_uint] = ACTIONS(675),
    [anon_sym_uint8] = ACTIONS(675),
    [anon_sym_uint16] = ACTIONS(675),
    [anon_sym_uint24] = ACTIONS(675),
    [anon_sym_uint32] = ACTIONS(675),
    [anon_sym_uint40] = ACTIONS(675),
    [anon_sym_uint48] = ACTIONS(675),
    [anon_sym_uint56] = ACTIONS(675),
    [anon_sym_uint64] = ACTIONS(675),
    [anon_sym_uint72] = ACTIONS(675),
    [anon_sym_uint80] = ACTIONS(675),
    [anon_sym_uint88] = ACTIONS(675),
    [anon_sym_uint96] = ACTIONS(675),
    [anon_sym_uint104] = ACTIONS(675),
    [anon_sym_uint112] = ACTIONS(675),
    [anon_sym_uint120] = ACTIONS(675),
    [anon_sym_uint128] = ACTIONS(675),
    [anon_sym_uint136] = ACTIONS(675),
    [anon_sym_uint144] = ACTIONS(675),
    [anon_sym_uint152] = ACTIONS(675),
    [anon_sym_uint160] = ACTIONS(675),
    [anon_sym_uint168] = ACTIONS(675),
    [anon_sym_uint176] = ACTIONS(675),
    [anon_sym_uint184] = ACTIONS(675),
    [anon_sym_uint192] = ACTIONS(675),
    [anon_sym_uint200] = ACTIONS(675),
    [anon_sym_uint208] = ACTIONS(675),
    [anon_sym_uint216] = ACTIONS(675),
    [anon_sym_uint224] = ACTIONS(675),
    [anon_sym_uint232] = ACTIONS(675),
    [anon_sym_uint240] = ACTIONS(675),
    [anon_sym_uint248] = ACTIONS(675),
    [anon_sym_uint256] = ACTIONS(675),
    [anon_sym_bytes] = ACTIONS(675),
    [anon_sym_bytes1] = ACTIONS(675),
    [anon_sym_bytes2] = ACTIONS(675),
    [anon_sym_bytes3] = ACTIONS(675),
    [anon_sym_bytes4] = ACTIONS(675),
    [anon_sym_bytes5] = ACTIONS(675),
    [anon_sym_bytes6] = ACTIONS(675),
    [anon_sym_bytes7] = ACTIONS(675),
    [anon_sym_bytes8] = ACTIONS(675),
    [anon_sym_bytes9] = ACTIONS(675),
    [anon_sym_bytes10] = ACTIONS(675),
    [anon_sym_bytes11] = ACTIONS(675),
    [anon_sym_bytes12] = ACTIONS(675),
    [anon_sym_bytes13] = ACTIONS(675),
    [anon_sym_bytes14] = ACTIONS(675),
    [anon_sym_bytes15] = ACTIONS(675),
    [anon_sym_bytes16] = ACTIONS(675),
    [anon_sym_bytes17] = ACTIONS(675),
    [anon_sym_bytes18] = ACTIONS(675),
    [anon_sym_bytes19] = ACTIONS(675),
    [anon_sym_bytes20] = ACTIONS(675),
    [anon_sym_bytes21] = ACTIONS(675),
    [anon_sym_bytes22] = ACTIONS(675),
    [anon_sym_bytes23] = ACTIONS(675),
    [anon_sym_bytes24] = ACTIONS(675),
    [anon_sym_bytes25] = ACTIONS(675),
    [anon_sym_bytes26] = ACTIONS(675),
    [anon_sym_bytes27] = ACTIONS(675),
    [anon_sym_bytes28] = ACTIONS(675),
    [anon_sym_bytes29] = ACTIONS(675),
    [anon_sym_bytes30] = ACTIONS(675),
    [anon_sym_bytes31] = ACTIONS(675),
    [anon_sym_bytes32] = ACTIONS(675),
    [anon_sym_fixed] = ACTIONS(675),
    [aux_sym__fixed_token1] = ACTIONS(675),
    [anon_sym_ufixed] = ACTIONS(675),
    [aux_sym__ufixed_token1] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(679),
    [sym_identifier] = ACTIONS(681),
    [anon_sym_pragma] = ACTIONS(681),
    [anon_sym_import] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(681),
    [anon_sym_abstract] = ACTIONS(681),
    [anon_sym_contract] = ACTIONS(681),
    [anon_sym_error] = ACTIONS(681),
    [anon_sym_interface] = ACTIONS(681),
    [anon_sym_library] = ACTIONS(681),
    [anon_sym_struct] = ACTIONS(681),
    [anon_sym_enum] = ACTIONS(681),
    [anon_sym_function] = ACTIONS(681),
    [anon_sym_byte] = ACTIONS(681),
    [anon_sym_address] = ACTIONS(681),
    [anon_sym_var] = ACTIONS(681),
    [anon_sym_mapping] = ACTIONS(681),
    [anon_sym_bool] = ACTIONS(681),
    [anon_sym_string] = ACTIONS(681),
    [anon_sym_int] = ACTIONS(681),
    [anon_sym_int8] = ACTIONS(681),
    [anon_sym_int16] = ACTIONS(681),
    [anon_sym_int24] = ACTIONS(681),
    [anon_sym_int32] = ACTIONS(681),
    [anon_sym_int40] = ACTIONS(681),
    [anon_sym_int48] = ACTIONS(681),
    [anon_sym_int56] = ACTIONS(681),
    [anon_sym_int64] = ACTIONS(681),
    [anon_sym_int72] = ACTIONS(681),
    [anon_sym_int80] = ACTIONS(681),
    [anon_sym_int88] = ACTIONS(681),
    [anon_sym_int96] = ACTIONS(681),
    [anon_sym_int104] = ACTIONS(681),
    [anon_sym_int112] = ACTIONS(681),
    [anon_sym_int120] = ACTIONS(681),
    [anon_sym_int128] = ACTIONS(681),
    [anon_sym_int136] = ACTIONS(681),
    [anon_sym_int144] = ACTIONS(681),
    [anon_sym_int152] = ACTIONS(681),
    [anon_sym_int160] = ACTIONS(681),
    [anon_sym_int168] = ACTIONS(681),
    [anon_sym_int176] = ACTIONS(681),
    [anon_sym_int184] = ACTIONS(681),
    [anon_sym_int192] = ACTIONS(681),
    [anon_sym_int200] = ACTIONS(681),
    [anon_sym_int208] = ACTIONS(681),
    [anon_sym_int216] = ACTIONS(681),
    [anon_sym_int224] = ACTIONS(681),
    [anon_sym_int232] = ACTIONS(681),
    [anon_sym_int240] = ACTIONS(681),
    [anon_sym_int248] = ACTIONS(681),
    [anon_sym_int256] = ACTIONS(681),
    [anon_sym_uint] = ACTIONS(681),
    [anon_sym_uint8] = ACTIONS(681),
    [anon_sym_uint16] = ACTIONS(681),
    [anon_sym_uint24] = ACTIONS(681),
    [anon_sym_uint32] = ACTIONS(681),
    [anon_sym_uint40] = ACTIONS(681),
    [anon_sym_uint48] = ACTIONS(681),
    [anon_sym_uint56] = ACTIONS(681),
    [anon_sym_uint64] = ACTIONS(681),
    [anon_sym_uint72] = ACTIONS(681),
    [anon_sym_uint80] = ACTIONS(681),
    [anon_sym_uint88] = ACTIONS(681),
    [anon_sym_uint96] = ACTIONS(681),
    [anon_sym_uint104] = ACTIONS(681),
    [anon_sym_uint112] = ACTIONS(681),
    [anon_sym_uint120] = ACTIONS(681),
    [anon_sym_uint128] = ACTIONS(681),
    [anon_sym_uint136] = ACTIONS(681),
    [anon_sym_uint144] = ACTIONS(681),
    [anon_sym_uint152] = ACTIONS(681),
    [anon_sym_uint160] = ACTIONS(681),
    [anon_sym_uint168] = ACTIONS(681),
    [anon_sym_uint176] = ACTIONS(681),
    [anon_sym_uint184] = ACTIONS(681),
    [anon_sym_uint192] = ACTIONS(681),
    [anon_sym_uint200] = ACTIONS(681),
    [anon_sym_uint208] = ACTIONS(681),
    [anon_sym_uint216] = ACTIONS(681),
    [anon_sym_uint224] = ACTIONS(681),
    [anon_sym_uint232] = ACTIONS(681),
    [anon_sym_uint240] = ACTIONS(681),
    [anon_sym_uint248] = ACTIONS(681),
    [anon_sym_uint256] = ACTIONS(681),
    [anon_sym_bytes] = ACTIONS(681),
    [anon_sym_bytes1] = ACTIONS(681),
    [anon_sym_bytes2] = ACTIONS(681),
    [anon_sym_bytes3] = ACTIONS(681),
    [anon_sym_bytes4] = ACTIONS(681),
    [anon_sym_bytes5] = ACTIONS(681),
    [anon_sym_bytes6] = ACTIONS(681),
    [anon_sym_bytes7] = ACTIONS(681),
    [anon_sym_bytes8] = ACTIONS(681),
    [anon_sym_bytes9] = ACTIONS(681),
    [anon_sym_bytes10] = ACTIONS(681),
    [anon_sym_bytes11] = ACTIONS(681),
    [anon_sym_bytes12] = ACTIONS(681),
    [anon_sym_bytes13] = ACTIONS(681),
    [anon_sym_bytes14] = ACTIONS(681),
    [anon_sym_bytes15] = ACTIONS(681),
    [anon_sym_bytes16] = ACTIONS(681),
    [anon_sym_bytes17] = ACTIONS(681),
    [anon_sym_bytes18] = ACTIONS(681),
    [anon_sym_bytes19] = ACTIONS(681),
    [anon_sym_bytes20] = ACTIONS(681),
    [anon_sym_bytes21] = ACTIONS(681),
    [anon_sym_bytes22] = ACTIONS(681),
    [anon_sym_bytes23] = ACTIONS(681),
    [anon_sym_bytes24] = ACTIONS(681),
    [anon_sym_bytes25] = ACTIONS(681),
    [anon_sym_bytes26] = ACTIONS(681),
    [anon_sym_bytes27] = ACTIONS(681),
    [anon_sym_bytes28] = ACTIONS(681),
    [anon_sym_bytes29] = ACTIONS(681),
    [anon_sym_bytes30] = ACTIONS(681),
    [anon_sym_bytes31] = ACTIONS(681),
    [anon_sym_bytes32] = ACTIONS(681),
    [anon_sym_fixed] = ACTIONS(681),
    [aux_sym__fixed_token1] = ACTIONS(681),
    [anon_sym_ufixed] = ACTIONS(681),
    [aux_sym__ufixed_token1] = ACTIONS(681),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_identifier] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(683),
    [anon_sym_error] = ACTIONS(683),
    [anon_sym_struct] = ACTIONS(683),
    [anon_sym_enum] = ACTIONS(683),
    [anon_sym_event] = ACTIONS(683),
    [anon_sym_using] = ACTIONS(683),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_byte] = ACTIONS(683),
    [anon_sym_address] = ACTIONS(683),
    [anon_sym_var] = ACTIONS(683),
    [anon_sym_modifier] = ACTIONS(683),
    [anon_sym_constructor] = ACTIONS(683),
    [anon_sym_fallback] = ACTIONS(683),
    [anon_sym_receive] = ACTIONS(683),
    [anon_sym_mapping] = ACTIONS(683),
    [anon_sym_bool] = ACTIONS(683),
    [anon_sym_string] = ACTIONS(683),
    [anon_sym_int] = ACTIONS(683),
    [anon_sym_int8] = ACTIONS(683),
    [anon_sym_int16] = ACTIONS(683),
    [anon_sym_int24] = ACTIONS(683),
    [anon_sym_int32] = ACTIONS(683),
    [anon_sym_int40] = ACTIONS(683),
    [anon_sym_int48] = ACTIONS(683),
    [anon_sym_int56] = ACTIONS(683),
    [anon_sym_int64] = ACTIONS(683),
    [anon_sym_int72] = ACTIONS(683),
    [anon_sym_int80] = ACTIONS(683),
    [anon_sym_int88] = ACTIONS(683),
    [anon_sym_int96] = ACTIONS(683),
    [anon_sym_int104] = ACTIONS(683),
    [anon_sym_int112] = ACTIONS(683),
    [anon_sym_int120] = ACTIONS(683),
    [anon_sym_int128] = ACTIONS(683),
    [anon_sym_int136] = ACTIONS(683),
    [anon_sym_int144] = ACTIONS(683),
    [anon_sym_int152] = ACTIONS(683),
    [anon_sym_int160] = ACTIONS(683),
    [anon_sym_int168] = ACTIONS(683),
    [anon_sym_int176] = ACTIONS(683),
    [anon_sym_int184] = ACTIONS(683),
    [anon_sym_int192] = ACTIONS(683),
    [anon_sym_int200] = ACTIONS(683),
    [anon_sym_int208] = ACTIONS(683),
    [anon_sym_int216] = ACTIONS(683),
    [anon_sym_int224] = ACTIONS(683),
    [anon_sym_int232] = ACTIONS(683),
    [anon_sym_int240] = ACTIONS(683),
    [anon_sym_int248] = ACTIONS(683),
    [anon_sym_int256] = ACTIONS(683),
    [anon_sym_uint] = ACTIONS(683),
    [anon_sym_uint8] = ACTIONS(683),
    [anon_sym_uint16] = ACTIONS(683),
    [anon_sym_uint24] = ACTIONS(683),
    [anon_sym_uint32] = ACTIONS(683),
    [anon_sym_uint40] = ACTIONS(683),
    [anon_sym_uint48] = ACTIONS(683),
    [anon_sym_uint56] = ACTIONS(683),
    [anon_sym_uint64] = ACTIONS(683),
    [anon_sym_uint72] = ACTIONS(683),
    [anon_sym_uint80] = ACTIONS(683),
    [anon_sym_uint88] = ACTIONS(683),
    [anon_sym_uint96] = ACTIONS(683),
    [anon_sym_uint104] = ACTIONS(683),
    [anon_sym_uint112] = ACTIONS(683),
    [anon_sym_uint120] = ACTIONS(683),
    [anon_sym_uint128] = ACTIONS(683),
    [anon_sym_uint136] = ACTIONS(683),
    [anon_sym_uint144] = ACTIONS(683),
    [anon_sym_uint152] = ACTIONS(683),
    [anon_sym_uint160] = ACTIONS(683),
    [anon_sym_uint168] = ACTIONS(683),
    [anon_sym_uint176] = ACTIONS(683),
    [anon_sym_uint184] = ACTIONS(683),
    [anon_sym_uint192] = ACTIONS(683),
    [anon_sym_uint200] = ACTIONS(683),
    [anon_sym_uint208] = ACTIONS(683),
    [anon_sym_uint216] = ACTIONS(683),
    [anon_sym_uint224] = ACTIONS(683),
    [anon_sym_uint232] = ACTIONS(683),
    [anon_sym_uint240] = ACTIONS(683),
    [anon_sym_uint248] = ACTIONS(683),
    [anon_sym_uint256] = ACTIONS(683),
    [anon_sym_bytes] = ACTIONS(683),
    [anon_sym_bytes1] = ACTIONS(683),
    [anon_sym_bytes2] = ACTIONS(683),
    [anon_sym_bytes3] = ACTIONS(683),
    [anon_sym_bytes4] = ACTIONS(683),
    [anon_sym_bytes5] = ACTIONS(683),
    [anon_sym_bytes6] = ACTIONS(683),
    [anon_sym_bytes7] = ACTIONS(683),
    [anon_sym_bytes8] = ACTIONS(683),
    [anon_sym_bytes9] = ACTIONS(683),
    [anon_sym_bytes10] = ACTIONS(683),
    [anon_sym_bytes11] = ACTIONS(683),
    [anon_sym_bytes12] = ACTIONS(683),
    [anon_sym_bytes13] = ACTIONS(683),
    [anon_sym_bytes14] = ACTIONS(683),
    [anon_sym_bytes15] = ACTIONS(683),
    [anon_sym_bytes16] = ACTIONS(683),
    [anon_sym_bytes17] = ACTIONS(683),
    [anon_sym_bytes18] = ACTIONS(683),
    [anon_sym_bytes19] = ACTIONS(683),
    [anon_sym_bytes20] = ACTIONS(683),
    [anon_sym_bytes21] = ACTIONS(683),
    [anon_sym_bytes22] = ACTIONS(683),
    [anon_sym_bytes23] = ACTIONS(683),
    [anon_sym_bytes24] = ACTIONS(683),
    [anon_sym_bytes25] = ACTIONS(683),
    [anon_sym_bytes26] = ACTIONS(683),
    [anon_sym_bytes27] = ACTIONS(683),
    [anon_sym_bytes28] = ACTIONS(683),
    [anon_sym_bytes29] = ACTIONS(683),
    [anon_sym_bytes30] = ACTIONS(683),
    [anon_sym_bytes31] = ACTIONS(683),
    [anon_sym_bytes32] = ACTIONS(683),
    [anon_sym_fixed] = ACTIONS(683),
    [aux_sym__fixed_token1] = ACTIONS(683),
    [anon_sym_ufixed] = ACTIONS(683),
    [aux_sym__ufixed_token1] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_identifier] = ACTIONS(687),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_error] = ACTIONS(687),
    [anon_sym_struct] = ACTIONS(687),
    [anon_sym_enum] = ACTIONS(687),
    [anon_sym_event] = ACTIONS(687),
    [anon_sym_using] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_byte] = ACTIONS(687),
    [anon_sym_address] = ACTIONS(687),
    [anon_sym_var] = ACTIONS(687),
    [anon_sym_modifier] = ACTIONS(687),
    [anon_sym_constructor] = ACTIONS(687),
    [anon_sym_fallback] = ACTIONS(687),
    [anon_sym_receive] = ACTIONS(687),
    [anon_sym_mapping] = ACTIONS(687),
    [anon_sym_bool] = ACTIONS(687),
    [anon_sym_string] = ACTIONS(687),
    [anon_sym_int] = ACTIONS(687),
    [anon_sym_int8] = ACTIONS(687),
    [anon_sym_int16] = ACTIONS(687),
    [anon_sym_int24] = ACTIONS(687),
    [anon_sym_int32] = ACTIONS(687),
    [anon_sym_int40] = ACTIONS(687),
    [anon_sym_int48] = ACTIONS(687),
    [anon_sym_int56] = ACTIONS(687),
    [anon_sym_int64] = ACTIONS(687),
    [anon_sym_int72] = ACTIONS(687),
    [anon_sym_int80] = ACTIONS(687),
    [anon_sym_int88] = ACTIONS(687),
    [anon_sym_int96] = ACTIONS(687),
    [anon_sym_int104] = ACTIONS(687),
    [anon_sym_int112] = ACTIONS(687),
    [anon_sym_int120] = ACTIONS(687),
    [anon_sym_int128] = ACTIONS(687),
    [anon_sym_int136] = ACTIONS(687),
    [anon_sym_int144] = ACTIONS(687),
    [anon_sym_int152] = ACTIONS(687),
    [anon_sym_int160] = ACTIONS(687),
    [anon_sym_int168] = ACTIONS(687),
    [anon_sym_int176] = ACTIONS(687),
    [anon_sym_int184] = ACTIONS(687),
    [anon_sym_int192] = ACTIONS(687),
    [anon_sym_int200] = ACTIONS(687),
    [anon_sym_int208] = ACTIONS(687),
    [anon_sym_int216] = ACTIONS(687),
    [anon_sym_int224] = ACTIONS(687),
    [anon_sym_int232] = ACTIONS(687),
    [anon_sym_int240] = ACTIONS(687),
    [anon_sym_int248] = ACTIONS(687),
    [anon_sym_int256] = ACTIONS(687),
    [anon_sym_uint] = ACTIONS(687),
    [anon_sym_uint8] = ACTIONS(687),
    [anon_sym_uint16] = ACTIONS(687),
    [anon_sym_uint24] = ACTIONS(687),
    [anon_sym_uint32] = ACTIONS(687),
    [anon_sym_uint40] = ACTIONS(687),
    [anon_sym_uint48] = ACTIONS(687),
    [anon_sym_uint56] = ACTIONS(687),
    [anon_sym_uint64] = ACTIONS(687),
    [anon_sym_uint72] = ACTIONS(687),
    [anon_sym_uint80] = ACTIONS(687),
    [anon_sym_uint88] = ACTIONS(687),
    [anon_sym_uint96] = ACTIONS(687),
    [anon_sym_uint104] = ACTIONS(687),
    [anon_sym_uint112] = ACTIONS(687),
    [anon_sym_uint120] = ACTIONS(687),
    [anon_sym_uint128] = ACTIONS(687),
    [anon_sym_uint136] = ACTIONS(687),
    [anon_sym_uint144] = ACTIONS(687),
    [anon_sym_uint152] = ACTIONS(687),
    [anon_sym_uint160] = ACTIONS(687),
    [anon_sym_uint168] = ACTIONS(687),
    [anon_sym_uint176] = ACTIONS(687),
    [anon_sym_uint184] = ACTIONS(687),
    [anon_sym_uint192] = ACTIONS(687),
    [anon_sym_uint200] = ACTIONS(687),
    [anon_sym_uint208] = ACTIONS(687),
    [anon_sym_uint216] = ACTIONS(687),
    [anon_sym_uint224] = ACTIONS(687),
    [anon_sym_uint232] = ACTIONS(687),
    [anon_sym_uint240] = ACTIONS(687),
    [anon_sym_uint248] = ACTIONS(687),
    [anon_sym_uint256] = ACTIONS(687),
    [anon_sym_bytes] = ACTIONS(687),
    [anon_sym_bytes1] = ACTIONS(687),
    [anon_sym_bytes2] = ACTIONS(687),
    [anon_sym_bytes3] = ACTIONS(687),
    [anon_sym_bytes4] = ACTIONS(687),
    [anon_sym_bytes5] = ACTIONS(687),
    [anon_sym_bytes6] = ACTIONS(687),
    [anon_sym_bytes7] = ACTIONS(687),
    [anon_sym_bytes8] = ACTIONS(687),
    [anon_sym_bytes9] = ACTIONS(687),
    [anon_sym_bytes10] = ACTIONS(687),
    [anon_sym_bytes11] = ACTIONS(687),
    [anon_sym_bytes12] = ACTIONS(687),
    [anon_sym_bytes13] = ACTIONS(687),
    [anon_sym_bytes14] = ACTIONS(687),
    [anon_sym_bytes15] = ACTIONS(687),
    [anon_sym_bytes16] = ACTIONS(687),
    [anon_sym_bytes17] = ACTIONS(687),
    [anon_sym_bytes18] = ACTIONS(687),
    [anon_sym_bytes19] = ACTIONS(687),
    [anon_sym_bytes20] = ACTIONS(687),
    [anon_sym_bytes21] = ACTIONS(687),
    [anon_sym_bytes22] = ACTIONS(687),
    [anon_sym_bytes23] = ACTIONS(687),
    [anon_sym_bytes24] = ACTIONS(687),
    [anon_sym_bytes25] = ACTIONS(687),
    [anon_sym_bytes26] = ACTIONS(687),
    [anon_sym_bytes27] = ACTIONS(687),
    [anon_sym_bytes28] = ACTIONS(687),
    [anon_sym_bytes29] = ACTIONS(687),
    [anon_sym_bytes30] = ACTIONS(687),
    [anon_sym_bytes31] = ACTIONS(687),
    [anon_sym_bytes32] = ACTIONS(687),
    [anon_sym_fixed] = ACTIONS(687),
    [aux_sym__fixed_token1] = ACTIONS(687),
    [anon_sym_ufixed] = ACTIONS(687),
    [aux_sym__ufixed_token1] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(691),
    [sym_identifier] = ACTIONS(693),
    [anon_sym_pragma] = ACTIONS(693),
    [anon_sym_import] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_abstract] = ACTIONS(693),
    [anon_sym_contract] = ACTIONS(693),
    [anon_sym_error] = ACTIONS(693),
    [anon_sym_interface] = ACTIONS(693),
    [anon_sym_library] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(693),
    [anon_sym_byte] = ACTIONS(693),
    [anon_sym_address] = ACTIONS(693),
    [anon_sym_var] = ACTIONS(693),
    [anon_sym_mapping] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_string] = ACTIONS(693),
    [anon_sym_int] = ACTIONS(693),
    [anon_sym_int8] = ACTIONS(693),
    [anon_sym_int16] = ACTIONS(693),
    [anon_sym_int24] = ACTIONS(693),
    [anon_sym_int32] = ACTIONS(693),
    [anon_sym_int40] = ACTIONS(693),
    [anon_sym_int48] = ACTIONS(693),
    [anon_sym_int56] = ACTIONS(693),
    [anon_sym_int64] = ACTIONS(693),
    [anon_sym_int72] = ACTIONS(693),
    [anon_sym_int80] = ACTIONS(693),
    [anon_sym_int88] = ACTIONS(693),
    [anon_sym_int96] = ACTIONS(693),
    [anon_sym_int104] = ACTIONS(693),
    [anon_sym_int112] = ACTIONS(693),
    [anon_sym_int120] = ACTIONS(693),
    [anon_sym_int128] = ACTIONS(693),
    [anon_sym_int136] = ACTIONS(693),
    [anon_sym_int144] = ACTIONS(693),
    [anon_sym_int152] = ACTIONS(693),
    [anon_sym_int160] = ACTIONS(693),
    [anon_sym_int168] = ACTIONS(693),
    [anon_sym_int176] = ACTIONS(693),
    [anon_sym_int184] = ACTIONS(693),
    [anon_sym_int192] = ACTIONS(693),
    [anon_sym_int200] = ACTIONS(693),
    [anon_sym_int208] = ACTIONS(693),
    [anon_sym_int216] = ACTIONS(693),
    [anon_sym_int224] = ACTIONS(693),
    [anon_sym_int232] = ACTIONS(693),
    [anon_sym_int240] = ACTIONS(693),
    [anon_sym_int248] = ACTIONS(693),
    [anon_sym_int256] = ACTIONS(693),
    [anon_sym_uint] = ACTIONS(693),
    [anon_sym_uint8] = ACTIONS(693),
    [anon_sym_uint16] = ACTIONS(693),
    [anon_sym_uint24] = ACTIONS(693),
    [anon_sym_uint32] = ACTIONS(693),
    [anon_sym_uint40] = ACTIONS(693),
    [anon_sym_uint48] = ACTIONS(693),
    [anon_sym_uint56] = ACTIONS(693),
    [anon_sym_uint64] = ACTIONS(693),
    [anon_sym_uint72] = ACTIONS(693),
    [anon_sym_uint80] = ACTIONS(693),
    [anon_sym_uint88] = ACTIONS(693),
    [anon_sym_uint96] = ACTIONS(693),
    [anon_sym_uint104] = ACTIONS(693),
    [anon_sym_uint112] = ACTIONS(693),
    [anon_sym_uint120] = ACTIONS(693),
    [anon_sym_uint128] = ACTIONS(693),
    [anon_sym_uint136] = ACTIONS(693),
    [anon_sym_uint144] = ACTIONS(693),
    [anon_sym_uint152] = ACTIONS(693),
    [anon_sym_uint160] = ACTIONS(693),
    [anon_sym_uint168] = ACTIONS(693),
    [anon_sym_uint176] = ACTIONS(693),
    [anon_sym_uint184] = ACTIONS(693),
    [anon_sym_uint192] = ACTIONS(693),
    [anon_sym_uint200] = ACTIONS(693),
    [anon_sym_uint208] = ACTIONS(693),
    [anon_sym_uint216] = ACTIONS(693),
    [anon_sym_uint224] = ACTIONS(693),
    [anon_sym_uint232] = ACTIONS(693),
    [anon_sym_uint240] = ACTIONS(693),
    [anon_sym_uint248] = ACTIONS(693),
    [anon_sym_uint256] = ACTIONS(693),
    [anon_sym_bytes] = ACTIONS(693),
    [anon_sym_bytes1] = ACTIONS(693),
    [anon_sym_bytes2] = ACTIONS(693),
    [anon_sym_bytes3] = ACTIONS(693),
    [anon_sym_bytes4] = ACTIONS(693),
    [anon_sym_bytes5] = ACTIONS(693),
    [anon_sym_bytes6] = ACTIONS(693),
    [anon_sym_bytes7] = ACTIONS(693),
    [anon_sym_bytes8] = ACTIONS(693),
    [anon_sym_bytes9] = ACTIONS(693),
    [anon_sym_bytes10] = ACTIONS(693),
    [anon_sym_bytes11] = ACTIONS(693),
    [anon_sym_bytes12] = ACTIONS(693),
    [anon_sym_bytes13] = ACTIONS(693),
    [anon_sym_bytes14] = ACTIONS(693),
    [anon_sym_bytes15] = ACTIONS(693),
    [anon_sym_bytes16] = ACTIONS(693),
    [anon_sym_bytes17] = ACTIONS(693),
    [anon_sym_bytes18] = ACTIONS(693),
    [anon_sym_bytes19] = ACTIONS(693),
    [anon_sym_bytes20] = ACTIONS(693),
    [anon_sym_bytes21] = ACTIONS(693),
    [anon_sym_bytes22] = ACTIONS(693),
    [anon_sym_bytes23] = ACTIONS(693),
    [anon_sym_bytes24] = ACTIONS(693),
    [anon_sym_bytes25] = ACTIONS(693),
    [anon_sym_bytes26] = ACTIONS(693),
    [anon_sym_bytes27] = ACTIONS(693),
    [anon_sym_bytes28] = ACTIONS(693),
    [anon_sym_bytes29] = ACTIONS(693),
    [anon_sym_bytes30] = ACTIONS(693),
    [anon_sym_bytes31] = ACTIONS(693),
    [anon_sym_bytes32] = ACTIONS(693),
    [anon_sym_fixed] = ACTIONS(693),
    [aux_sym__fixed_token1] = ACTIONS(693),
    [anon_sym_ufixed] = ACTIONS(693),
    [aux_sym__ufixed_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_identifier] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_error] = ACTIONS(695),
    [anon_sym_struct] = ACTIONS(695),
    [anon_sym_enum] = ACTIONS(695),
    [anon_sym_event] = ACTIONS(695),
    [anon_sym_using] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_byte] = ACTIONS(695),
    [anon_sym_address] = ACTIONS(695),
    [anon_sym_var] = ACTIONS(695),
    [anon_sym_modifier] = ACTIONS(695),
    [anon_sym_constructor] = ACTIONS(695),
    [anon_sym_fallback] = ACTIONS(695),
    [anon_sym_receive] = ACTIONS(695),
    [anon_sym_mapping] = ACTIONS(695),
    [anon_sym_bool] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_int] = ACTIONS(695),
    [anon_sym_int8] = ACTIONS(695),
    [anon_sym_int16] = ACTIONS(695),
    [anon_sym_int24] = ACTIONS(695),
    [anon_sym_int32] = ACTIONS(695),
    [anon_sym_int40] = ACTIONS(695),
    [anon_sym_int48] = ACTIONS(695),
    [anon_sym_int56] = ACTIONS(695),
    [anon_sym_int64] = ACTIONS(695),
    [anon_sym_int72] = ACTIONS(695),
    [anon_sym_int80] = ACTIONS(695),
    [anon_sym_int88] = ACTIONS(695),
    [anon_sym_int96] = ACTIONS(695),
    [anon_sym_int104] = ACTIONS(695),
    [anon_sym_int112] = ACTIONS(695),
    [anon_sym_int120] = ACTIONS(695),
    [anon_sym_int128] = ACTIONS(695),
    [anon_sym_int136] = ACTIONS(695),
    [anon_sym_int144] = ACTIONS(695),
    [anon_sym_int152] = ACTIONS(695),
    [anon_sym_int160] = ACTIONS(695),
    [anon_sym_int168] = ACTIONS(695),
    [anon_sym_int176] = ACTIONS(695),
    [anon_sym_int184] = ACTIONS(695),
    [anon_sym_int192] = ACTIONS(695),
    [anon_sym_int200] = ACTIONS(695),
    [anon_sym_int208] = ACTIONS(695),
    [anon_sym_int216] = ACTIONS(695),
    [anon_sym_int224] = ACTIONS(695),
    [anon_sym_int232] = ACTIONS(695),
    [anon_sym_int240] = ACTIONS(695),
    [anon_sym_int248] = ACTIONS(695),
    [anon_sym_int256] = ACTIONS(695),
    [anon_sym_uint] = ACTIONS(695),
    [anon_sym_uint8] = ACTIONS(695),
    [anon_sym_uint16] = ACTIONS(695),
    [anon_sym_uint24] = ACTIONS(695),
    [anon_sym_uint32] = ACTIONS(695),
    [anon_sym_uint40] = ACTIONS(695),
    [anon_sym_uint48] = ACTIONS(695),
    [anon_sym_uint56] = ACTIONS(695),
    [anon_sym_uint64] = ACTIONS(695),
    [anon_sym_uint72] = ACTIONS(695),
    [anon_sym_uint80] = ACTIONS(695),
    [anon_sym_uint88] = ACTIONS(695),
    [anon_sym_uint96] = ACTIONS(695),
    [anon_sym_uint104] = ACTIONS(695),
    [anon_sym_uint112] = ACTIONS(695),
    [anon_sym_uint120] = ACTIONS(695),
    [anon_sym_uint128] = ACTIONS(695),
    [anon_sym_uint136] = ACTIONS(695),
    [anon_sym_uint144] = ACTIONS(695),
    [anon_sym_uint152] = ACTIONS(695),
    [anon_sym_uint160] = ACTIONS(695),
    [anon_sym_uint168] = ACTIONS(695),
    [anon_sym_uint176] = ACTIONS(695),
    [anon_sym_uint184] = ACTIONS(695),
    [anon_sym_uint192] = ACTIONS(695),
    [anon_sym_uint200] = ACTIONS(695),
    [anon_sym_uint208] = ACTIONS(695),
    [anon_sym_uint216] = ACTIONS(695),
    [anon_sym_uint224] = ACTIONS(695),
    [anon_sym_uint232] = ACTIONS(695),
    [anon_sym_uint240] = ACTIONS(695),
    [anon_sym_uint248] = ACTIONS(695),
    [anon_sym_uint256] = ACTIONS(695),
    [anon_sym_bytes] = ACTIONS(695),
    [anon_sym_bytes1] = ACTIONS(695),
    [anon_sym_bytes2] = ACTIONS(695),
    [anon_sym_bytes3] = ACTIONS(695),
    [anon_sym_bytes4] = ACTIONS(695),
    [anon_sym_bytes5] = ACTIONS(695),
    [anon_sym_bytes6] = ACTIONS(695),
    [anon_sym_bytes7] = ACTIONS(695),
    [anon_sym_bytes8] = ACTIONS(695),
    [anon_sym_bytes9] = ACTIONS(695),
    [anon_sym_bytes10] = ACTIONS(695),
    [anon_sym_bytes11] = ACTIONS(695),
    [anon_sym_bytes12] = ACTIONS(695),
    [anon_sym_bytes13] = ACTIONS(695),
    [anon_sym_bytes14] = ACTIONS(695),
    [anon_sym_bytes15] = ACTIONS(695),
    [anon_sym_bytes16] = ACTIONS(695),
    [anon_sym_bytes17] = ACTIONS(695),
    [anon_sym_bytes18] = ACTIONS(695),
    [anon_sym_bytes19] = ACTIONS(695),
    [anon_sym_bytes20] = ACTIONS(695),
    [anon_sym_bytes21] = ACTIONS(695),
    [anon_sym_bytes22] = ACTIONS(695),
    [anon_sym_bytes23] = ACTIONS(695),
    [anon_sym_bytes24] = ACTIONS(695),
    [anon_sym_bytes25] = ACTIONS(695),
    [anon_sym_bytes26] = ACTIONS(695),
    [anon_sym_bytes27] = ACTIONS(695),
    [anon_sym_bytes28] = ACTIONS(695),
    [anon_sym_bytes29] = ACTIONS(695),
    [anon_sym_bytes30] = ACTIONS(695),
    [anon_sym_bytes31] = ACTIONS(695),
    [anon_sym_bytes32] = ACTIONS(695),
    [anon_sym_fixed] = ACTIONS(695),
    [aux_sym__fixed_token1] = ACTIONS(695),
    [anon_sym_ufixed] = ACTIONS(695),
    [aux_sym__ufixed_token1] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_identifier] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_type] = ACTIONS(693),
    [anon_sym_error] = ACTIONS(693),
    [anon_sym_struct] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_event] = ACTIONS(693),
    [anon_sym_using] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(693),
    [anon_sym_byte] = ACTIONS(693),
    [anon_sym_address] = ACTIONS(693),
    [anon_sym_var] = ACTIONS(693),
    [anon_sym_modifier] = ACTIONS(693),
    [anon_sym_constructor] = ACTIONS(693),
    [anon_sym_fallback] = ACTIONS(693),
    [anon_sym_receive] = ACTIONS(693),
    [anon_sym_mapping] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(693),
    [anon_sym_string] = ACTIONS(693),
    [anon_sym_int] = ACTIONS(693),
    [anon_sym_int8] = ACTIONS(693),
    [anon_sym_int16] = ACTIONS(693),
    [anon_sym_int24] = ACTIONS(693),
    [anon_sym_int32] = ACTIONS(693),
    [anon_sym_int40] = ACTIONS(693),
    [anon_sym_int48] = ACTIONS(693),
    [anon_sym_int56] = ACTIONS(693),
    [anon_sym_int64] = ACTIONS(693),
    [anon_sym_int72] = ACTIONS(693),
    [anon_sym_int80] = ACTIONS(693),
    [anon_sym_int88] = ACTIONS(693),
    [anon_sym_int96] = ACTIONS(693),
    [anon_sym_int104] = ACTIONS(693),
    [anon_sym_int112] = ACTIONS(693),
    [anon_sym_int120] = ACTIONS(693),
    [anon_sym_int128] = ACTIONS(693),
    [anon_sym_int136] = ACTIONS(693),
    [anon_sym_int144] = ACTIONS(693),
    [anon_sym_int152] = ACTIONS(693),
    [anon_sym_int160] = ACTIONS(693),
    [anon_sym_int168] = ACTIONS(693),
    [anon_sym_int176] = ACTIONS(693),
    [anon_sym_int184] = ACTIONS(693),
    [anon_sym_int192] = ACTIONS(693),
    [anon_sym_int200] = ACTIONS(693),
    [anon_sym_int208] = ACTIONS(693),
    [anon_sym_int216] = ACTIONS(693),
    [anon_sym_int224] = ACTIONS(693),
    [anon_sym_int232] = ACTIONS(693),
    [anon_sym_int240] = ACTIONS(693),
    [anon_sym_int248] = ACTIONS(693),
    [anon_sym_int256] = ACTIONS(693),
    [anon_sym_uint] = ACTIONS(693),
    [anon_sym_uint8] = ACTIONS(693),
    [anon_sym_uint16] = ACTIONS(693),
    [anon_sym_uint24] = ACTIONS(693),
    [anon_sym_uint32] = ACTIONS(693),
    [anon_sym_uint40] = ACTIONS(693),
    [anon_sym_uint48] = ACTIONS(693),
    [anon_sym_uint56] = ACTIONS(693),
    [anon_sym_uint64] = ACTIONS(693),
    [anon_sym_uint72] = ACTIONS(693),
    [anon_sym_uint80] = ACTIONS(693),
    [anon_sym_uint88] = ACTIONS(693),
    [anon_sym_uint96] = ACTIONS(693),
    [anon_sym_uint104] = ACTIONS(693),
    [anon_sym_uint112] = ACTIONS(693),
    [anon_sym_uint120] = ACTIONS(693),
    [anon_sym_uint128] = ACTIONS(693),
    [anon_sym_uint136] = ACTIONS(693),
    [anon_sym_uint144] = ACTIONS(693),
    [anon_sym_uint152] = ACTIONS(693),
    [anon_sym_uint160] = ACTIONS(693),
    [anon_sym_uint168] = ACTIONS(693),
    [anon_sym_uint176] = ACTIONS(693),
    [anon_sym_uint184] = ACTIONS(693),
    [anon_sym_uint192] = ACTIONS(693),
    [anon_sym_uint200] = ACTIONS(693),
    [anon_sym_uint208] = ACTIONS(693),
    [anon_sym_uint216] = ACTIONS(693),
    [anon_sym_uint224] = ACTIONS(693),
    [anon_sym_uint232] = ACTIONS(693),
    [anon_sym_uint240] = ACTIONS(693),
    [anon_sym_uint248] = ACTIONS(693),
    [anon_sym_uint256] = ACTIONS(693),
    [anon_sym_bytes] = ACTIONS(693),
    [anon_sym_bytes1] = ACTIONS(693),
    [anon_sym_bytes2] = ACTIONS(693),
    [anon_sym_bytes3] = ACTIONS(693),
    [anon_sym_bytes4] = ACTIONS(693),
    [anon_sym_bytes5] = ACTIONS(693),
    [anon_sym_bytes6] = ACTIONS(693),
    [anon_sym_bytes7] = ACTIONS(693),
    [anon_sym_bytes8] = ACTIONS(693),
    [anon_sym_bytes9] = ACTIONS(693),
    [anon_sym_bytes10] = ACTIONS(693),
    [anon_sym_bytes11] = ACTIONS(693),
    [anon_sym_bytes12] = ACTIONS(693),
    [anon_sym_bytes13] = ACTIONS(693),
    [anon_sym_bytes14] = ACTIONS(693),
    [anon_sym_bytes15] = ACTIONS(693),
    [anon_sym_bytes16] = ACTIONS(693),
    [anon_sym_bytes17] = ACTIONS(693),
    [anon_sym_bytes18] = ACTIONS(693),
    [anon_sym_bytes19] = ACTIONS(693),
    [anon_sym_bytes20] = ACTIONS(693),
    [anon_sym_bytes21] = ACTIONS(693),
    [anon_sym_bytes22] = ACTIONS(693),
    [anon_sym_bytes23] = ACTIONS(693),
    [anon_sym_bytes24] = ACTIONS(693),
    [anon_sym_bytes25] = ACTIONS(693),
    [anon_sym_bytes26] = ACTIONS(693),
    [anon_sym_bytes27] = ACTIONS(693),
    [anon_sym_bytes28] = ACTIONS(693),
    [anon_sym_bytes29] = ACTIONS(693),
    [anon_sym_bytes30] = ACTIONS(693),
    [anon_sym_bytes31] = ACTIONS(693),
    [anon_sym_bytes32] = ACTIONS(693),
    [anon_sym_fixed] = ACTIONS(693),
    [aux_sym__fixed_token1] = ACTIONS(693),
    [anon_sym_ufixed] = ACTIONS(693),
    [aux_sym__ufixed_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_identifier] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_type] = ACTIONS(699),
    [anon_sym_error] = ACTIONS(699),
    [anon_sym_struct] = ACTIONS(699),
    [anon_sym_enum] = ACTIONS(699),
    [anon_sym_event] = ACTIONS(699),
    [anon_sym_using] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_byte] = ACTIONS(699),
    [anon_sym_address] = ACTIONS(699),
    [anon_sym_var] = ACTIONS(699),
    [anon_sym_modifier] = ACTIONS(699),
    [anon_sym_constructor] = ACTIONS(699),
    [anon_sym_fallback] = ACTIONS(699),
    [anon_sym_receive] = ACTIONS(699),
    [anon_sym_mapping] = ACTIONS(699),
    [anon_sym_bool] = ACTIONS(699),
    [anon_sym_string] = ACTIONS(699),
    [anon_sym_int] = ACTIONS(699),
    [anon_sym_int8] = ACTIONS(699),
    [anon_sym_int16] = ACTIONS(699),
    [anon_sym_int24] = ACTIONS(699),
    [anon_sym_int32] = ACTIONS(699),
    [anon_sym_int40] = ACTIONS(699),
    [anon_sym_int48] = ACTIONS(699),
    [anon_sym_int56] = ACTIONS(699),
    [anon_sym_int64] = ACTIONS(699),
    [anon_sym_int72] = ACTIONS(699),
    [anon_sym_int80] = ACTIONS(699),
    [anon_sym_int88] = ACTIONS(699),
    [anon_sym_int96] = ACTIONS(699),
    [anon_sym_int104] = ACTIONS(699),
    [anon_sym_int112] = ACTIONS(699),
    [anon_sym_int120] = ACTIONS(699),
    [anon_sym_int128] = ACTIONS(699),
    [anon_sym_int136] = ACTIONS(699),
    [anon_sym_int144] = ACTIONS(699),
    [anon_sym_int152] = ACTIONS(699),
    [anon_sym_int160] = ACTIONS(699),
    [anon_sym_int168] = ACTIONS(699),
    [anon_sym_int176] = ACTIONS(699),
    [anon_sym_int184] = ACTIONS(699),
    [anon_sym_int192] = ACTIONS(699),
    [anon_sym_int200] = ACTIONS(699),
    [anon_sym_int208] = ACTIONS(699),
    [anon_sym_int216] = ACTIONS(699),
    [anon_sym_int224] = ACTIONS(699),
    [anon_sym_int232] = ACTIONS(699),
    [anon_sym_int240] = ACTIONS(699),
    [anon_sym_int248] = ACTIONS(699),
    [anon_sym_int256] = ACTIONS(699),
    [anon_sym_uint] = ACTIONS(699),
    [anon_sym_uint8] = ACTIONS(699),
    [anon_sym_uint16] = ACTIONS(699),
    [anon_sym_uint24] = ACTIONS(699),
    [anon_sym_uint32] = ACTIONS(699),
    [anon_sym_uint40] = ACTIONS(699),
    [anon_sym_uint48] = ACTIONS(699),
    [anon_sym_uint56] = ACTIONS(699),
    [anon_sym_uint64] = ACTIONS(699),
    [anon_sym_uint72] = ACTIONS(699),
    [anon_sym_uint80] = ACTIONS(699),
    [anon_sym_uint88] = ACTIONS(699),
    [anon_sym_uint96] = ACTIONS(699),
    [anon_sym_uint104] = ACTIONS(699),
    [anon_sym_uint112] = ACTIONS(699),
    [anon_sym_uint120] = ACTIONS(699),
    [anon_sym_uint128] = ACTIONS(699),
    [anon_sym_uint136] = ACTIONS(699),
    [anon_sym_uint144] = ACTIONS(699),
    [anon_sym_uint152] = ACTIONS(699),
    [anon_sym_uint160] = ACTIONS(699),
    [anon_sym_uint168] = ACTIONS(699),
    [anon_sym_uint176] = ACTIONS(699),
    [anon_sym_uint184] = ACTIONS(699),
    [anon_sym_uint192] = ACTIONS(699),
    [anon_sym_uint200] = ACTIONS(699),
    [anon_sym_uint208] = ACTIONS(699),
    [anon_sym_uint216] = ACTIONS(699),
    [anon_sym_uint224] = ACTIONS(699),
    [anon_sym_uint232] = ACTIONS(699),
    [anon_sym_uint240] = ACTIONS(699),
    [anon_sym_uint248] = ACTIONS(699),
    [anon_sym_uint256] = ACTIONS(699),
    [anon_sym_bytes] = ACTIONS(699),
    [anon_sym_bytes1] = ACTIONS(699),
    [anon_sym_bytes2] = ACTIONS(699),
    [anon_sym_bytes3] = ACTIONS(699),
    [anon_sym_bytes4] = ACTIONS(699),
    [anon_sym_bytes5] = ACTIONS(699),
    [anon_sym_bytes6] = ACTIONS(699),
    [anon_sym_bytes7] = ACTIONS(699),
    [anon_sym_bytes8] = ACTIONS(699),
    [anon_sym_bytes9] = ACTIONS(699),
    [anon_sym_bytes10] = ACTIONS(699),
    [anon_sym_bytes11] = ACTIONS(699),
    [anon_sym_bytes12] = ACTIONS(699),
    [anon_sym_bytes13] = ACTIONS(699),
    [anon_sym_bytes14] = ACTIONS(699),
    [anon_sym_bytes15] = ACTIONS(699),
    [anon_sym_bytes16] = ACTIONS(699),
    [anon_sym_bytes17] = ACTIONS(699),
    [anon_sym_bytes18] = ACTIONS(699),
    [anon_sym_bytes19] = ACTIONS(699),
    [anon_sym_bytes20] = ACTIONS(699),
    [anon_sym_bytes21] = ACTIONS(699),
    [anon_sym_bytes22] = ACTIONS(699),
    [anon_sym_bytes23] = ACTIONS(699),
    [anon_sym_bytes24] = ACTIONS(699),
    [anon_sym_bytes25] = ACTIONS(699),
    [anon_sym_bytes26] = ACTIONS(699),
    [anon_sym_bytes27] = ACTIONS(699),
    [anon_sym_bytes28] = ACTIONS(699),
    [anon_sym_bytes29] = ACTIONS(699),
    [anon_sym_bytes30] = ACTIONS(699),
    [anon_sym_bytes31] = ACTIONS(699),
    [anon_sym_bytes32] = ACTIONS(699),
    [anon_sym_fixed] = ACTIONS(699),
    [aux_sym__fixed_token1] = ACTIONS(699),
    [anon_sym_ufixed] = ACTIONS(699),
    [aux_sym__ufixed_token1] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_identifier] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(705),
    [anon_sym_type] = ACTIONS(703),
    [anon_sym_error] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_event] = ACTIONS(703),
    [anon_sym_using] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_byte] = ACTIONS(703),
    [anon_sym_address] = ACTIONS(703),
    [anon_sym_var] = ACTIONS(703),
    [anon_sym_modifier] = ACTIONS(703),
    [anon_sym_constructor] = ACTIONS(703),
    [anon_sym_fallback] = ACTIONS(703),
    [anon_sym_receive] = ACTIONS(703),
    [anon_sym_mapping] = ACTIONS(703),
    [anon_sym_bool] = ACTIONS(703),
    [anon_sym_string] = ACTIONS(703),
    [anon_sym_int] = ACTIONS(703),
    [anon_sym_int8] = ACTIONS(703),
    [anon_sym_int16] = ACTIONS(703),
    [anon_sym_int24] = ACTIONS(703),
    [anon_sym_int32] = ACTIONS(703),
    [anon_sym_int40] = ACTIONS(703),
    [anon_sym_int48] = ACTIONS(703),
    [anon_sym_int56] = ACTIONS(703),
    [anon_sym_int64] = ACTIONS(703),
    [anon_sym_int72] = ACTIONS(703),
    [anon_sym_int80] = ACTIONS(703),
    [anon_sym_int88] = ACTIONS(703),
    [anon_sym_int96] = ACTIONS(703),
    [anon_sym_int104] = ACTIONS(703),
    [anon_sym_int112] = ACTIONS(703),
    [anon_sym_int120] = ACTIONS(703),
    [anon_sym_int128] = ACTIONS(703),
    [anon_sym_int136] = ACTIONS(703),
    [anon_sym_int144] = ACTIONS(703),
    [anon_sym_int152] = ACTIONS(703),
    [anon_sym_int160] = ACTIONS(703),
    [anon_sym_int168] = ACTIONS(703),
    [anon_sym_int176] = ACTIONS(703),
    [anon_sym_int184] = ACTIONS(703),
    [anon_sym_int192] = ACTIONS(703),
    [anon_sym_int200] = ACTIONS(703),
    [anon_sym_int208] = ACTIONS(703),
    [anon_sym_int216] = ACTIONS(703),
    [anon_sym_int224] = ACTIONS(703),
    [anon_sym_int232] = ACTIONS(703),
    [anon_sym_int240] = ACTIONS(703),
    [anon_sym_int248] = ACTIONS(703),
    [anon_sym_int256] = ACTIONS(703),
    [anon_sym_uint] = ACTIONS(703),
    [anon_sym_uint8] = ACTIONS(703),
    [anon_sym_uint16] = ACTIONS(703),
    [anon_sym_uint24] = ACTIONS(703),
    [anon_sym_uint32] = ACTIONS(703),
    [anon_sym_uint40] = ACTIONS(703),
    [anon_sym_uint48] = ACTIONS(703),
    [anon_sym_uint56] = ACTIONS(703),
    [anon_sym_uint64] = ACTIONS(703),
    [anon_sym_uint72] = ACTIONS(703),
    [anon_sym_uint80] = ACTIONS(703),
    [anon_sym_uint88] = ACTIONS(703),
    [anon_sym_uint96] = ACTIONS(703),
    [anon_sym_uint104] = ACTIONS(703),
    [anon_sym_uint112] = ACTIONS(703),
    [anon_sym_uint120] = ACTIONS(703),
    [anon_sym_uint128] = ACTIONS(703),
    [anon_sym_uint136] = ACTIONS(703),
    [anon_sym_uint144] = ACTIONS(703),
    [anon_sym_uint152] = ACTIONS(703),
    [anon_sym_uint160] = ACTIONS(703),
    [anon_sym_uint168] = ACTIONS(703),
    [anon_sym_uint176] = ACTIONS(703),
    [anon_sym_uint184] = ACTIONS(703),
    [anon_sym_uint192] = ACTIONS(703),
    [anon_sym_uint200] = ACTIONS(703),
    [anon_sym_uint208] = ACTIONS(703),
    [anon_sym_uint216] = ACTIONS(703),
    [anon_sym_uint224] = ACTIONS(703),
    [anon_sym_uint232] = ACTIONS(703),
    [anon_sym_uint240] = ACTIONS(703),
    [anon_sym_uint248] = ACTIONS(703),
    [anon_sym_uint256] = ACTIONS(703),
    [anon_sym_bytes] = ACTIONS(703),
    [anon_sym_bytes1] = ACTIONS(703),
    [anon_sym_bytes2] = ACTIONS(703),
    [anon_sym_bytes3] = ACTIONS(703),
    [anon_sym_bytes4] = ACTIONS(703),
    [anon_sym_bytes5] = ACTIONS(703),
    [anon_sym_bytes6] = ACTIONS(703),
    [anon_sym_bytes7] = ACTIONS(703),
    [anon_sym_bytes8] = ACTIONS(703),
    [anon_sym_bytes9] = ACTIONS(703),
    [anon_sym_bytes10] = ACTIONS(703),
    [anon_sym_bytes11] = ACTIONS(703),
    [anon_sym_bytes12] = ACTIONS(703),
    [anon_sym_bytes13] = ACTIONS(703),
    [anon_sym_bytes14] = ACTIONS(703),
    [anon_sym_bytes15] = ACTIONS(703),
    [anon_sym_bytes16] = ACTIONS(703),
    [anon_sym_bytes17] = ACTIONS(703),
    [anon_sym_bytes18] = ACTIONS(703),
    [anon_sym_bytes19] = ACTIONS(703),
    [anon_sym_bytes20] = ACTIONS(703),
    [anon_sym_bytes21] = ACTIONS(703),
    [anon_sym_bytes22] = ACTIONS(703),
    [anon_sym_bytes23] = ACTIONS(703),
    [anon_sym_bytes24] = ACTIONS(703),
    [anon_sym_bytes25] = ACTIONS(703),
    [anon_sym_bytes26] = ACTIONS(703),
    [anon_sym_bytes27] = ACTIONS(703),
    [anon_sym_bytes28] = ACTIONS(703),
    [anon_sym_bytes29] = ACTIONS(703),
    [anon_sym_bytes30] = ACTIONS(703),
    [anon_sym_bytes31] = ACTIONS(703),
    [anon_sym_bytes32] = ACTIONS(703),
    [anon_sym_fixed] = ACTIONS(703),
    [aux_sym__fixed_token1] = ACTIONS(703),
    [anon_sym_ufixed] = ACTIONS(703),
    [aux_sym__ufixed_token1] = ACTIONS(703),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(707),
    [sym_identifier] = ACTIONS(709),
    [anon_sym_pragma] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(709),
    [anon_sym_type] = ACTIONS(709),
    [anon_sym_abstract] = ACTIONS(709),
    [anon_sym_contract] = ACTIONS(709),
    [anon_sym_error] = ACTIONS(709),
    [anon_sym_interface] = ACTIONS(709),
    [anon_sym_library] = ACTIONS(709),
    [anon_sym_struct] = ACTIONS(709),
    [anon_sym_enum] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_byte] = ACTIONS(709),
    [anon_sym_address] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_mapping] = ACTIONS(709),
    [anon_sym_bool] = ACTIONS(709),
    [anon_sym_string] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int24] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int40] = ACTIONS(709),
    [anon_sym_int48] = ACTIONS(709),
    [anon_sym_int56] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int72] = ACTIONS(709),
    [anon_sym_int80] = ACTIONS(709),
    [anon_sym_int88] = ACTIONS(709),
    [anon_sym_int96] = ACTIONS(709),
    [anon_sym_int104] = ACTIONS(709),
    [anon_sym_int112] = ACTIONS(709),
    [anon_sym_int120] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [anon_sym_int136] = ACTIONS(709),
    [anon_sym_int144] = ACTIONS(709),
    [anon_sym_int152] = ACTIONS(709),
    [anon_sym_int160] = ACTIONS(709),
    [anon_sym_int168] = ACTIONS(709),
    [anon_sym_int176] = ACTIONS(709),
    [anon_sym_int184] = ACTIONS(709),
    [anon_sym_int192] = ACTIONS(709),
    [anon_sym_int200] = ACTIONS(709),
    [anon_sym_int208] = ACTIONS(709),
    [anon_sym_int216] = ACTIONS(709),
    [anon_sym_int224] = ACTIONS(709),
    [anon_sym_int232] = ACTIONS(709),
    [anon_sym_int240] = ACTIONS(709),
    [anon_sym_int248] = ACTIONS(709),
    [anon_sym_int256] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint24] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint40] = ACTIONS(709),
    [anon_sym_uint48] = ACTIONS(709),
    [anon_sym_uint56] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint72] = ACTIONS(709),
    [anon_sym_uint80] = ACTIONS(709),
    [anon_sym_uint88] = ACTIONS(709),
    [anon_sym_uint96] = ACTIONS(709),
    [anon_sym_uint104] = ACTIONS(709),
    [anon_sym_uint112] = ACTIONS(709),
    [anon_sym_uint120] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_uint136] = ACTIONS(709),
    [anon_sym_uint144] = ACTIONS(709),
    [anon_sym_uint152] = ACTIONS(709),
    [anon_sym_uint160] = ACTIONS(709),
    [anon_sym_uint168] = ACTIONS(709),
    [anon_sym_uint176] = ACTIONS(709),
    [anon_sym_uint184] = ACTIONS(709),
    [anon_sym_uint192] = ACTIONS(709),
    [anon_sym_uint200] = ACTIONS(709),
    [anon_sym_uint208] = ACTIONS(709),
    [anon_sym_uint216] = ACTIONS(709),
    [anon_sym_uint224] = ACTIONS(709),
    [anon_sym_uint232] = ACTIONS(709),
    [anon_sym_uint240] = ACTIONS(709),
    [anon_sym_uint248] = ACTIONS(709),
    [anon_sym_uint256] = ACTIONS(709),
    [anon_sym_bytes] = ACTIONS(709),
    [anon_sym_bytes1] = ACTIONS(709),
    [anon_sym_bytes2] = ACTIONS(709),
    [anon_sym_bytes3] = ACTIONS(709),
    [anon_sym_bytes4] = ACTIONS(709),
    [anon_sym_bytes5] = ACTIONS(709),
    [anon_sym_bytes6] = ACTIONS(709),
    [anon_sym_bytes7] = ACTIONS(709),
    [anon_sym_bytes8] = ACTIONS(709),
    [anon_sym_bytes9] = ACTIONS(709),
    [anon_sym_bytes10] = ACTIONS(709),
    [anon_sym_bytes11] = ACTIONS(709),
    [anon_sym_bytes12] = ACTIONS(709),
    [anon_sym_bytes13] = ACTIONS(709),
    [anon_sym_bytes14] = ACTIONS(709),
    [anon_sym_bytes15] = ACTIONS(709),
    [anon_sym_bytes16] = ACTIONS(709),
    [anon_sym_bytes17] = ACTIONS(709),
    [anon_sym_bytes18] = ACTIONS(709),
    [anon_sym_bytes19] = ACTIONS(709),
    [anon_sym_bytes20] = ACTIONS(709),
    [anon_sym_bytes21] = ACTIONS(709),
    [anon_sym_bytes22] = ACTIONS(709),
    [anon_sym_bytes23] = ACTIONS(709),
    [anon_sym_bytes24] = ACTIONS(709),
    [anon_sym_bytes25] = ACTIONS(709),
    [anon_sym_bytes26] = ACTIONS(709),
    [anon_sym_bytes27] = ACTIONS(709),
    [anon_sym_bytes28] = ACTIONS(709),
    [anon_sym_bytes29] = ACTIONS(709),
    [anon_sym_bytes30] = ACTIONS(709),
    [anon_sym_bytes31] = ACTIONS(709),
    [anon_sym_bytes32] = ACTIONS(709),
    [anon_sym_fixed] = ACTIONS(709),
    [aux_sym__fixed_token1] = ACTIONS(709),
    [anon_sym_ufixed] = ACTIONS(709),
    [aux_sym__ufixed_token1] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_identifier] = ACTIONS(711),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_error] = ACTIONS(711),
    [anon_sym_struct] = ACTIONS(711),
    [anon_sym_enum] = ACTIONS(711),
    [anon_sym_event] = ACTIONS(711),
    [anon_sym_using] = ACTIONS(711),
    [anon_sym_function] = ACTIONS(711),
    [anon_sym_byte] = ACTIONS(711),
    [anon_sym_address] = ACTIONS(711),
    [anon_sym_var] = ACTIONS(711),
    [anon_sym_modifier] = ACTIONS(711),
    [anon_sym_constructor] = ACTIONS(711),
    [anon_sym_fallback] = ACTIONS(711),
    [anon_sym_receive] = ACTIONS(711),
    [anon_sym_mapping] = ACTIONS(711),
    [anon_sym_bool] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_int] = ACTIONS(711),
    [anon_sym_int8] = ACTIONS(711),
    [anon_sym_int16] = ACTIONS(711),
    [anon_sym_int24] = ACTIONS(711),
    [anon_sym_int32] = ACTIONS(711),
    [anon_sym_int40] = ACTIONS(711),
    [anon_sym_int48] = ACTIONS(711),
    [anon_sym_int56] = ACTIONS(711),
    [anon_sym_int64] = ACTIONS(711),
    [anon_sym_int72] = ACTIONS(711),
    [anon_sym_int80] = ACTIONS(711),
    [anon_sym_int88] = ACTIONS(711),
    [anon_sym_int96] = ACTIONS(711),
    [anon_sym_int104] = ACTIONS(711),
    [anon_sym_int112] = ACTIONS(711),
    [anon_sym_int120] = ACTIONS(711),
    [anon_sym_int128] = ACTIONS(711),
    [anon_sym_int136] = ACTIONS(711),
    [anon_sym_int144] = ACTIONS(711),
    [anon_sym_int152] = ACTIONS(711),
    [anon_sym_int160] = ACTIONS(711),
    [anon_sym_int168] = ACTIONS(711),
    [anon_sym_int176] = ACTIONS(711),
    [anon_sym_int184] = ACTIONS(711),
    [anon_sym_int192] = ACTIONS(711),
    [anon_sym_int200] = ACTIONS(711),
    [anon_sym_int208] = ACTIONS(711),
    [anon_sym_int216] = ACTIONS(711),
    [anon_sym_int224] = ACTIONS(711),
    [anon_sym_int232] = ACTIONS(711),
    [anon_sym_int240] = ACTIONS(711),
    [anon_sym_int248] = ACTIONS(711),
    [anon_sym_int256] = ACTIONS(711),
    [anon_sym_uint] = ACTIONS(711),
    [anon_sym_uint8] = ACTIONS(711),
    [anon_sym_uint16] = ACTIONS(711),
    [anon_sym_uint24] = ACTIONS(711),
    [anon_sym_uint32] = ACTIONS(711),
    [anon_sym_uint40] = ACTIONS(711),
    [anon_sym_uint48] = ACTIONS(711),
    [anon_sym_uint56] = ACTIONS(711),
    [anon_sym_uint64] = ACTIONS(711),
    [anon_sym_uint72] = ACTIONS(711),
    [anon_sym_uint80] = ACTIONS(711),
    [anon_sym_uint88] = ACTIONS(711),
    [anon_sym_uint96] = ACTIONS(711),
    [anon_sym_uint104] = ACTIONS(711),
    [anon_sym_uint112] = ACTIONS(711),
    [anon_sym_uint120] = ACTIONS(711),
    [anon_sym_uint128] = ACTIONS(711),
    [anon_sym_uint136] = ACTIONS(711),
    [anon_sym_uint144] = ACTIONS(711),
    [anon_sym_uint152] = ACTIONS(711),
    [anon_sym_uint160] = ACTIONS(711),
    [anon_sym_uint168] = ACTIONS(711),
    [anon_sym_uint176] = ACTIONS(711),
    [anon_sym_uint184] = ACTIONS(711),
    [anon_sym_uint192] = ACTIONS(711),
    [anon_sym_uint200] = ACTIONS(711),
    [anon_sym_uint208] = ACTIONS(711),
    [anon_sym_uint216] = ACTIONS(711),
    [anon_sym_uint224] = ACTIONS(711),
    [anon_sym_uint232] = ACTIONS(711),
    [anon_sym_uint240] = ACTIONS(711),
    [anon_sym_uint248] = ACTIONS(711),
    [anon_sym_uint256] = ACTIONS(711),
    [anon_sym_bytes] = ACTIONS(711),
    [anon_sym_bytes1] = ACTIONS(711),
    [anon_sym_bytes2] = ACTIONS(711),
    [anon_sym_bytes3] = ACTIONS(711),
    [anon_sym_bytes4] = ACTIONS(711),
    [anon_sym_bytes5] = ACTIONS(711),
    [anon_sym_bytes6] = ACTIONS(711),
    [anon_sym_bytes7] = ACTIONS(711),
    [anon_sym_bytes8] = ACTIONS(711),
    [anon_sym_bytes9] = ACTIONS(711),
    [anon_sym_bytes10] = ACTIONS(711),
    [anon_sym_bytes11] = ACTIONS(711),
    [anon_sym_bytes12] = ACTIONS(711),
    [anon_sym_bytes13] = ACTIONS(711),
    [anon_sym_bytes14] = ACTIONS(711),
    [anon_sym_bytes15] = ACTIONS(711),
    [anon_sym_bytes16] = ACTIONS(711),
    [anon_sym_bytes17] = ACTIONS(711),
    [anon_sym_bytes18] = ACTIONS(711),
    [anon_sym_bytes19] = ACTIONS(711),
    [anon_sym_bytes20] = ACTIONS(711),
    [anon_sym_bytes21] = ACTIONS(711),
    [anon_sym_bytes22] = ACTIONS(711),
    [anon_sym_bytes23] = ACTIONS(711),
    [anon_sym_bytes24] = ACTIONS(711),
    [anon_sym_bytes25] = ACTIONS(711),
    [anon_sym_bytes26] = ACTIONS(711),
    [anon_sym_bytes27] = ACTIONS(711),
    [anon_sym_bytes28] = ACTIONS(711),
    [anon_sym_bytes29] = ACTIONS(711),
    [anon_sym_bytes30] = ACTIONS(711),
    [anon_sym_bytes31] = ACTIONS(711),
    [anon_sym_bytes32] = ACTIONS(711),
    [anon_sym_fixed] = ACTIONS(711),
    [aux_sym__fixed_token1] = ACTIONS(711),
    [anon_sym_ufixed] = ACTIONS(711),
    [aux_sym__ufixed_token1] = ACTIONS(711),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(715),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_type] = ACTIONS(715),
    [anon_sym_error] = ACTIONS(715),
    [anon_sym_struct] = ACTIONS(715),
    [anon_sym_enum] = ACTIONS(715),
    [anon_sym_event] = ACTIONS(715),
    [anon_sym_using] = ACTIONS(715),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_byte] = ACTIONS(715),
    [anon_sym_address] = ACTIONS(715),
    [anon_sym_var] = ACTIONS(715),
    [anon_sym_modifier] = ACTIONS(715),
    [anon_sym_constructor] = ACTIONS(715),
    [anon_sym_fallback] = ACTIONS(715),
    [anon_sym_receive] = ACTIONS(715),
    [anon_sym_mapping] = ACTIONS(715),
    [anon_sym_bool] = ACTIONS(715),
    [anon_sym_string] = ACTIONS(715),
    [anon_sym_int] = ACTIONS(715),
    [anon_sym_int8] = ACTIONS(715),
    [anon_sym_int16] = ACTIONS(715),
    [anon_sym_int24] = ACTIONS(715),
    [anon_sym_int32] = ACTIONS(715),
    [anon_sym_int40] = ACTIONS(715),
    [anon_sym_int48] = ACTIONS(715),
    [anon_sym_int56] = ACTIONS(715),
    [anon_sym_int64] = ACTIONS(715),
    [anon_sym_int72] = ACTIONS(715),
    [anon_sym_int80] = ACTIONS(715),
    [anon_sym_int88] = ACTIONS(715),
    [anon_sym_int96] = ACTIONS(715),
    [anon_sym_int104] = ACTIONS(715),
    [anon_sym_int112] = ACTIONS(715),
    [anon_sym_int120] = ACTIONS(715),
    [anon_sym_int128] = ACTIONS(715),
    [anon_sym_int136] = ACTIONS(715),
    [anon_sym_int144] = ACTIONS(715),
    [anon_sym_int152] = ACTIONS(715),
    [anon_sym_int160] = ACTIONS(715),
    [anon_sym_int168] = ACTIONS(715),
    [anon_sym_int176] = ACTIONS(715),
    [anon_sym_int184] = ACTIONS(715),
    [anon_sym_int192] = ACTIONS(715),
    [anon_sym_int200] = ACTIONS(715),
    [anon_sym_int208] = ACTIONS(715),
    [anon_sym_int216] = ACTIONS(715),
    [anon_sym_int224] = ACTIONS(715),
    [anon_sym_int232] = ACTIONS(715),
    [anon_sym_int240] = ACTIONS(715),
    [anon_sym_int248] = ACTIONS(715),
    [anon_sym_int256] = ACTIONS(715),
    [anon_sym_uint] = ACTIONS(715),
    [anon_sym_uint8] = ACTIONS(715),
    [anon_sym_uint16] = ACTIONS(715),
    [anon_sym_uint24] = ACTIONS(715),
    [anon_sym_uint32] = ACTIONS(715),
    [anon_sym_uint40] = ACTIONS(715),
    [anon_sym_uint48] = ACTIONS(715),
    [anon_sym_uint56] = ACTIONS(715),
    [anon_sym_uint64] = ACTIONS(715),
    [anon_sym_uint72] = ACTIONS(715),
    [anon_sym_uint80] = ACTIONS(715),
    [anon_sym_uint88] = ACTIONS(715),
    [anon_sym_uint96] = ACTIONS(715),
    [anon_sym_uint104] = ACTIONS(715),
    [anon_sym_uint112] = ACTIONS(715),
    [anon_sym_uint120] = ACTIONS(715),
    [anon_sym_uint128] = ACTIONS(715),
    [anon_sym_uint136] = ACTIONS(715),
    [anon_sym_uint144] = ACTIONS(715),
    [anon_sym_uint152] = ACTIONS(715),
    [anon_sym_uint160] = ACTIONS(715),
    [anon_sym_uint168] = ACTIONS(715),
    [anon_sym_uint176] = ACTIONS(715),
    [anon_sym_uint184] = ACTIONS(715),
    [anon_sym_uint192] = ACTIONS(715),
    [anon_sym_uint200] = ACTIONS(715),
    [anon_sym_uint208] = ACTIONS(715),
    [anon_sym_uint216] = ACTIONS(715),
    [anon_sym_uint224] = ACTIONS(715),
    [anon_sym_uint232] = ACTIONS(715),
    [anon_sym_uint240] = ACTIONS(715),
    [anon_sym_uint248] = ACTIONS(715),
    [anon_sym_uint256] = ACTIONS(715),
    [anon_sym_bytes] = ACTIONS(715),
    [anon_sym_bytes1] = ACTIONS(715),
    [anon_sym_bytes2] = ACTIONS(715),
    [anon_sym_bytes3] = ACTIONS(715),
    [anon_sym_bytes4] = ACTIONS(715),
    [anon_sym_bytes5] = ACTIONS(715),
    [anon_sym_bytes6] = ACTIONS(715),
    [anon_sym_bytes7] = ACTIONS(715),
    [anon_sym_bytes8] = ACTIONS(715),
    [anon_sym_bytes9] = ACTIONS(715),
    [anon_sym_bytes10] = ACTIONS(715),
    [anon_sym_bytes11] = ACTIONS(715),
    [anon_sym_bytes12] = ACTIONS(715),
    [anon_sym_bytes13] = ACTIONS(715),
    [anon_sym_bytes14] = ACTIONS(715),
    [anon_sym_bytes15] = ACTIONS(715),
    [anon_sym_bytes16] = ACTIONS(715),
    [anon_sym_bytes17] = ACTIONS(715),
    [anon_sym_bytes18] = ACTIONS(715),
    [anon_sym_bytes19] = ACTIONS(715),
    [anon_sym_bytes20] = ACTIONS(715),
    [anon_sym_bytes21] = ACTIONS(715),
    [anon_sym_bytes22] = ACTIONS(715),
    [anon_sym_bytes23] = ACTIONS(715),
    [anon_sym_bytes24] = ACTIONS(715),
    [anon_sym_bytes25] = ACTIONS(715),
    [anon_sym_bytes26] = ACTIONS(715),
    [anon_sym_bytes27] = ACTIONS(715),
    [anon_sym_bytes28] = ACTIONS(715),
    [anon_sym_bytes29] = ACTIONS(715),
    [anon_sym_bytes30] = ACTIONS(715),
    [anon_sym_bytes31] = ACTIONS(715),
    [anon_sym_bytes32] = ACTIONS(715),
    [anon_sym_fixed] = ACTIONS(715),
    [aux_sym__fixed_token1] = ACTIONS(715),
    [anon_sym_ufixed] = ACTIONS(715),
    [aux_sym__ufixed_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_identifier] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_type] = ACTIONS(719),
    [anon_sym_error] = ACTIONS(719),
    [anon_sym_struct] = ACTIONS(719),
    [anon_sym_enum] = ACTIONS(719),
    [anon_sym_event] = ACTIONS(719),
    [anon_sym_using] = ACTIONS(719),
    [anon_sym_function] = ACTIONS(719),
    [anon_sym_byte] = ACTIONS(719),
    [anon_sym_address] = ACTIONS(719),
    [anon_sym_var] = ACTIONS(719),
    [anon_sym_modifier] = ACTIONS(719),
    [anon_sym_constructor] = ACTIONS(719),
    [anon_sym_fallback] = ACTIONS(719),
    [anon_sym_receive] = ACTIONS(719),
    [anon_sym_mapping] = ACTIONS(719),
    [anon_sym_bool] = ACTIONS(719),
    [anon_sym_string] = ACTIONS(719),
    [anon_sym_int] = ACTIONS(719),
    [anon_sym_int8] = ACTIONS(719),
    [anon_sym_int16] = ACTIONS(719),
    [anon_sym_int24] = ACTIONS(719),
    [anon_sym_int32] = ACTIONS(719),
    [anon_sym_int40] = ACTIONS(719),
    [anon_sym_int48] = ACTIONS(719),
    [anon_sym_int56] = ACTIONS(719),
    [anon_sym_int64] = ACTIONS(719),
    [anon_sym_int72] = ACTIONS(719),
    [anon_sym_int80] = ACTIONS(719),
    [anon_sym_int88] = ACTIONS(719),
    [anon_sym_int96] = ACTIONS(719),
    [anon_sym_int104] = ACTIONS(719),
    [anon_sym_int112] = ACTIONS(719),
    [anon_sym_int120] = ACTIONS(719),
    [anon_sym_int128] = ACTIONS(719),
    [anon_sym_int136] = ACTIONS(719),
    [anon_sym_int144] = ACTIONS(719),
    [anon_sym_int152] = ACTIONS(719),
    [anon_sym_int160] = ACTIONS(719),
    [anon_sym_int168] = ACTIONS(719),
    [anon_sym_int176] = ACTIONS(719),
    [anon_sym_int184] = ACTIONS(719),
    [anon_sym_int192] = ACTIONS(719),
    [anon_sym_int200] = ACTIONS(719),
    [anon_sym_int208] = ACTIONS(719),
    [anon_sym_int216] = ACTIONS(719),
    [anon_sym_int224] = ACTIONS(719),
    [anon_sym_int232] = ACTIONS(719),
    [anon_sym_int240] = ACTIONS(719),
    [anon_sym_int248] = ACTIONS(719),
    [anon_sym_int256] = ACTIONS(719),
    [anon_sym_uint] = ACTIONS(719),
    [anon_sym_uint8] = ACTIONS(719),
    [anon_sym_uint16] = ACTIONS(719),
    [anon_sym_uint24] = ACTIONS(719),
    [anon_sym_uint32] = ACTIONS(719),
    [anon_sym_uint40] = ACTIONS(719),
    [anon_sym_uint48] = ACTIONS(719),
    [anon_sym_uint56] = ACTIONS(719),
    [anon_sym_uint64] = ACTIONS(719),
    [anon_sym_uint72] = ACTIONS(719),
    [anon_sym_uint80] = ACTIONS(719),
    [anon_sym_uint88] = ACTIONS(719),
    [anon_sym_uint96] = ACTIONS(719),
    [anon_sym_uint104] = ACTIONS(719),
    [anon_sym_uint112] = ACTIONS(719),
    [anon_sym_uint120] = ACTIONS(719),
    [anon_sym_uint128] = ACTIONS(719),
    [anon_sym_uint136] = ACTIONS(719),
    [anon_sym_uint144] = ACTIONS(719),
    [anon_sym_uint152] = ACTIONS(719),
    [anon_sym_uint160] = ACTIONS(719),
    [anon_sym_uint168] = ACTIONS(719),
    [anon_sym_uint176] = ACTIONS(719),
    [anon_sym_uint184] = ACTIONS(719),
    [anon_sym_uint192] = ACTIONS(719),
    [anon_sym_uint200] = ACTIONS(719),
    [anon_sym_uint208] = ACTIONS(719),
    [anon_sym_uint216] = ACTIONS(719),
    [anon_sym_uint224] = ACTIONS(719),
    [anon_sym_uint232] = ACTIONS(719),
    [anon_sym_uint240] = ACTIONS(719),
    [anon_sym_uint248] = ACTIONS(719),
    [anon_sym_uint256] = ACTIONS(719),
    [anon_sym_bytes] = ACTIONS(719),
    [anon_sym_bytes1] = ACTIONS(719),
    [anon_sym_bytes2] = ACTIONS(719),
    [anon_sym_bytes3] = ACTIONS(719),
    [anon_sym_bytes4] = ACTIONS(719),
    [anon_sym_bytes5] = ACTIONS(719),
    [anon_sym_bytes6] = ACTIONS(719),
    [anon_sym_bytes7] = ACTIONS(719),
    [anon_sym_bytes8] = ACTIONS(719),
    [anon_sym_bytes9] = ACTIONS(719),
    [anon_sym_bytes10] = ACTIONS(719),
    [anon_sym_bytes11] = ACTIONS(719),
    [anon_sym_bytes12] = ACTIONS(719),
    [anon_sym_bytes13] = ACTIONS(719),
    [anon_sym_bytes14] = ACTIONS(719),
    [anon_sym_bytes15] = ACTIONS(719),
    [anon_sym_bytes16] = ACTIONS(719),
    [anon_sym_bytes17] = ACTIONS(719),
    [anon_sym_bytes18] = ACTIONS(719),
    [anon_sym_bytes19] = ACTIONS(719),
    [anon_sym_bytes20] = ACTIONS(719),
    [anon_sym_bytes21] = ACTIONS(719),
    [anon_sym_bytes22] = ACTIONS(719),
    [anon_sym_bytes23] = ACTIONS(719),
    [anon_sym_bytes24] = ACTIONS(719),
    [anon_sym_bytes25] = ACTIONS(719),
    [anon_sym_bytes26] = ACTIONS(719),
    [anon_sym_bytes27] = ACTIONS(719),
    [anon_sym_bytes28] = ACTIONS(719),
    [anon_sym_bytes29] = ACTIONS(719),
    [anon_sym_bytes30] = ACTIONS(719),
    [anon_sym_bytes31] = ACTIONS(719),
    [anon_sym_bytes32] = ACTIONS(719),
    [anon_sym_fixed] = ACTIONS(719),
    [aux_sym__fixed_token1] = ACTIONS(719),
    [anon_sym_ufixed] = ACTIONS(719),
    [aux_sym__ufixed_token1] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_identifier] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_type] = ACTIONS(723),
    [anon_sym_error] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(723),
    [anon_sym_enum] = ACTIONS(723),
    [anon_sym_event] = ACTIONS(723),
    [anon_sym_using] = ACTIONS(723),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_byte] = ACTIONS(723),
    [anon_sym_address] = ACTIONS(723),
    [anon_sym_var] = ACTIONS(723),
    [anon_sym_modifier] = ACTIONS(723),
    [anon_sym_constructor] = ACTIONS(723),
    [anon_sym_fallback] = ACTIONS(723),
    [anon_sym_receive] = ACTIONS(723),
    [anon_sym_mapping] = ACTIONS(723),
    [anon_sym_bool] = ACTIONS(723),
    [anon_sym_string] = ACTIONS(723),
    [anon_sym_int] = ACTIONS(723),
    [anon_sym_int8] = ACTIONS(723),
    [anon_sym_int16] = ACTIONS(723),
    [anon_sym_int24] = ACTIONS(723),
    [anon_sym_int32] = ACTIONS(723),
    [anon_sym_int40] = ACTIONS(723),
    [anon_sym_int48] = ACTIONS(723),
    [anon_sym_int56] = ACTIONS(723),
    [anon_sym_int64] = ACTIONS(723),
    [anon_sym_int72] = ACTIONS(723),
    [anon_sym_int80] = ACTIONS(723),
    [anon_sym_int88] = ACTIONS(723),
    [anon_sym_int96] = ACTIONS(723),
    [anon_sym_int104] = ACTIONS(723),
    [anon_sym_int112] = ACTIONS(723),
    [anon_sym_int120] = ACTIONS(723),
    [anon_sym_int128] = ACTIONS(723),
    [anon_sym_int136] = ACTIONS(723),
    [anon_sym_int144] = ACTIONS(723),
    [anon_sym_int152] = ACTIONS(723),
    [anon_sym_int160] = ACTIONS(723),
    [anon_sym_int168] = ACTIONS(723),
    [anon_sym_int176] = ACTIONS(723),
    [anon_sym_int184] = ACTIONS(723),
    [anon_sym_int192] = ACTIONS(723),
    [anon_sym_int200] = ACTIONS(723),
    [anon_sym_int208] = ACTIONS(723),
    [anon_sym_int216] = ACTIONS(723),
    [anon_sym_int224] = ACTIONS(723),
    [anon_sym_int232] = ACTIONS(723),
    [anon_sym_int240] = ACTIONS(723),
    [anon_sym_int248] = ACTIONS(723),
    [anon_sym_int256] = ACTIONS(723),
    [anon_sym_uint] = ACTIONS(723),
    [anon_sym_uint8] = ACTIONS(723),
    [anon_sym_uint16] = ACTIONS(723),
    [anon_sym_uint24] = ACTIONS(723),
    [anon_sym_uint32] = ACTIONS(723),
    [anon_sym_uint40] = ACTIONS(723),
    [anon_sym_uint48] = ACTIONS(723),
    [anon_sym_uint56] = ACTIONS(723),
    [anon_sym_uint64] = ACTIONS(723),
    [anon_sym_uint72] = ACTIONS(723),
    [anon_sym_uint80] = ACTIONS(723),
    [anon_sym_uint88] = ACTIONS(723),
    [anon_sym_uint96] = ACTIONS(723),
    [anon_sym_uint104] = ACTIONS(723),
    [anon_sym_uint112] = ACTIONS(723),
    [anon_sym_uint120] = ACTIONS(723),
    [anon_sym_uint128] = ACTIONS(723),
    [anon_sym_uint136] = ACTIONS(723),
    [anon_sym_uint144] = ACTIONS(723),
    [anon_sym_uint152] = ACTIONS(723),
    [anon_sym_uint160] = ACTIONS(723),
    [anon_sym_uint168] = ACTIONS(723),
    [anon_sym_uint176] = ACTIONS(723),
    [anon_sym_uint184] = ACTIONS(723),
    [anon_sym_uint192] = ACTIONS(723),
    [anon_sym_uint200] = ACTIONS(723),
    [anon_sym_uint208] = ACTIONS(723),
    [anon_sym_uint216] = ACTIONS(723),
    [anon_sym_uint224] = ACTIONS(723),
    [anon_sym_uint232] = ACTIONS(723),
    [anon_sym_uint240] = ACTIONS(723),
    [anon_sym_uint248] = ACTIONS(723),
    [anon_sym_uint256] = ACTIONS(723),
    [anon_sym_bytes] = ACTIONS(723),
    [anon_sym_bytes1] = ACTIONS(723),
    [anon_sym_bytes2] = ACTIONS(723),
    [anon_sym_bytes3] = ACTIONS(723),
    [anon_sym_bytes4] = ACTIONS(723),
    [anon_sym_bytes5] = ACTIONS(723),
    [anon_sym_bytes6] = ACTIONS(723),
    [anon_sym_bytes7] = ACTIONS(723),
    [anon_sym_bytes8] = ACTIONS(723),
    [anon_sym_bytes9] = ACTIONS(723),
    [anon_sym_bytes10] = ACTIONS(723),
    [anon_sym_bytes11] = ACTIONS(723),
    [anon_sym_bytes12] = ACTIONS(723),
    [anon_sym_bytes13] = ACTIONS(723),
    [anon_sym_bytes14] = ACTIONS(723),
    [anon_sym_bytes15] = ACTIONS(723),
    [anon_sym_bytes16] = ACTIONS(723),
    [anon_sym_bytes17] = ACTIONS(723),
    [anon_sym_bytes18] = ACTIONS(723),
    [anon_sym_bytes19] = ACTIONS(723),
    [anon_sym_bytes20] = ACTIONS(723),
    [anon_sym_bytes21] = ACTIONS(723),
    [anon_sym_bytes22] = ACTIONS(723),
    [anon_sym_bytes23] = ACTIONS(723),
    [anon_sym_bytes24] = ACTIONS(723),
    [anon_sym_bytes25] = ACTIONS(723),
    [anon_sym_bytes26] = ACTIONS(723),
    [anon_sym_bytes27] = ACTIONS(723),
    [anon_sym_bytes28] = ACTIONS(723),
    [anon_sym_bytes29] = ACTIONS(723),
    [anon_sym_bytes30] = ACTIONS(723),
    [anon_sym_bytes31] = ACTIONS(723),
    [anon_sym_bytes32] = ACTIONS(723),
    [anon_sym_fixed] = ACTIONS(723),
    [aux_sym__fixed_token1] = ACTIONS(723),
    [anon_sym_ufixed] = ACTIONS(723),
    [aux_sym__ufixed_token1] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_pragma] = ACTIONS(699),
    [anon_sym_import] = ACTIONS(699),
    [anon_sym_type] = ACTIONS(699),
    [anon_sym_abstract] = ACTIONS(699),
    [anon_sym_contract] = ACTIONS(699),
    [anon_sym_error] = ACTIONS(699),
    [anon_sym_interface] = ACTIONS(699),
    [anon_sym_library] = ACTIONS(699),
    [anon_sym_struct] = ACTIONS(699),
    [anon_sym_enum] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_byte] = ACTIONS(699),
    [anon_sym_address] = ACTIONS(699),
    [anon_sym_var] = ACTIONS(699),
    [anon_sym_mapping] = ACTIONS(699),
    [anon_sym_bool] = ACTIONS(699),
    [anon_sym_string] = ACTIONS(699),
    [anon_sym_int] = ACTIONS(699),
    [anon_sym_int8] = ACTIONS(699),
    [anon_sym_int16] = ACTIONS(699),
    [anon_sym_int24] = ACTIONS(699),
    [anon_sym_int32] = ACTIONS(699),
    [anon_sym_int40] = ACTIONS(699),
    [anon_sym_int48] = ACTIONS(699),
    [anon_sym_int56] = ACTIONS(699),
    [anon_sym_int64] = ACTIONS(699),
    [anon_sym_int72] = ACTIONS(699),
    [anon_sym_int80] = ACTIONS(699),
    [anon_sym_int88] = ACTIONS(699),
    [anon_sym_int96] = ACTIONS(699),
    [anon_sym_int104] = ACTIONS(699),
    [anon_sym_int112] = ACTIONS(699),
    [anon_sym_int120] = ACTIONS(699),
    [anon_sym_int128] = ACTIONS(699),
    [anon_sym_int136] = ACTIONS(699),
    [anon_sym_int144] = ACTIONS(699),
    [anon_sym_int152] = ACTIONS(699),
    [anon_sym_int160] = ACTIONS(699),
    [anon_sym_int168] = ACTIONS(699),
    [anon_sym_int176] = ACTIONS(699),
    [anon_sym_int184] = ACTIONS(699),
    [anon_sym_int192] = ACTIONS(699),
    [anon_sym_int200] = ACTIONS(699),
    [anon_sym_int208] = ACTIONS(699),
    [anon_sym_int216] = ACTIONS(699),
    [anon_sym_int224] = ACTIONS(699),
    [anon_sym_int232] = ACTIONS(699),
    [anon_sym_int240] = ACTIONS(699),
    [anon_sym_int248] = ACTIONS(699),
    [anon_sym_int256] = ACTIONS(699),
    [anon_sym_uint] = ACTIONS(699),
    [anon_sym_uint8] = ACTIONS(699),
    [anon_sym_uint16] = ACTIONS(699),
    [anon_sym_uint24] = ACTIONS(699),
    [anon_sym_uint32] = ACTIONS(699),
    [anon_sym_uint40] = ACTIONS(699),
    [anon_sym_uint48] = ACTIONS(699),
    [anon_sym_uint56] = ACTIONS(699),
    [anon_sym_uint64] = ACTIONS(699),
    [anon_sym_uint72] = ACTIONS(699),
    [anon_sym_uint80] = ACTIONS(699),
    [anon_sym_uint88] = ACTIONS(699),
    [anon_sym_uint96] = ACTIONS(699),
    [anon_sym_uint104] = ACTIONS(699),
    [anon_sym_uint112] = ACTIONS(699),
    [anon_sym_uint120] = ACTIONS(699),
    [anon_sym_uint128] = ACTIONS(699),
    [anon_sym_uint136] = ACTIONS(699),
    [anon_sym_uint144] = ACTIONS(699),
    [anon_sym_uint152] = ACTIONS(699),
    [anon_sym_uint160] = ACTIONS(699),
    [anon_sym_uint168] = ACTIONS(699),
    [anon_sym_uint176] = ACTIONS(699),
    [anon_sym_uint184] = ACTIONS(699),
    [anon_sym_uint192] = ACTIONS(699),
    [anon_sym_uint200] = ACTIONS(699),
    [anon_sym_uint208] = ACTIONS(699),
    [anon_sym_uint216] = ACTIONS(699),
    [anon_sym_uint224] = ACTIONS(699),
    [anon_sym_uint232] = ACTIONS(699),
    [anon_sym_uint240] = ACTIONS(699),
    [anon_sym_uint248] = ACTIONS(699),
    [anon_sym_uint256] = ACTIONS(699),
    [anon_sym_bytes] = ACTIONS(699),
    [anon_sym_bytes1] = ACTIONS(699),
    [anon_sym_bytes2] = ACTIONS(699),
    [anon_sym_bytes3] = ACTIONS(699),
    [anon_sym_bytes4] = ACTIONS(699),
    [anon_sym_bytes5] = ACTIONS(699),
    [anon_sym_bytes6] = ACTIONS(699),
    [anon_sym_bytes7] = ACTIONS(699),
    [anon_sym_bytes8] = ACTIONS(699),
    [anon_sym_bytes9] = ACTIONS(699),
    [anon_sym_bytes10] = ACTIONS(699),
    [anon_sym_bytes11] = ACTIONS(699),
    [anon_sym_bytes12] = ACTIONS(699),
    [anon_sym_bytes13] = ACTIONS(699),
    [anon_sym_bytes14] = ACTIONS(699),
    [anon_sym_bytes15] = ACTIONS(699),
    [anon_sym_bytes16] = ACTIONS(699),
    [anon_sym_bytes17] = ACTIONS(699),
    [anon_sym_bytes18] = ACTIONS(699),
    [anon_sym_bytes19] = ACTIONS(699),
    [anon_sym_bytes20] = ACTIONS(699),
    [anon_sym_bytes21] = ACTIONS(699),
    [anon_sym_bytes22] = ACTIONS(699),
    [anon_sym_bytes23] = ACTIONS(699),
    [anon_sym_bytes24] = ACTIONS(699),
    [anon_sym_bytes25] = ACTIONS(699),
    [anon_sym_bytes26] = ACTIONS(699),
    [anon_sym_bytes27] = ACTIONS(699),
    [anon_sym_bytes28] = ACTIONS(699),
    [anon_sym_bytes29] = ACTIONS(699),
    [anon_sym_bytes30] = ACTIONS(699),
    [anon_sym_bytes31] = ACTIONS(699),
    [anon_sym_bytes32] = ACTIONS(699),
    [anon_sym_fixed] = ACTIONS(699),
    [aux_sym__fixed_token1] = ACTIONS(699),
    [anon_sym_ufixed] = ACTIONS(699),
    [aux_sym__ufixed_token1] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_identifier] = ACTIONS(727),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_type] = ACTIONS(727),
    [anon_sym_error] = ACTIONS(727),
    [anon_sym_struct] = ACTIONS(727),
    [anon_sym_enum] = ACTIONS(727),
    [anon_sym_event] = ACTIONS(727),
    [anon_sym_using] = ACTIONS(727),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_byte] = ACTIONS(727),
    [anon_sym_address] = ACTIONS(727),
    [anon_sym_var] = ACTIONS(727),
    [anon_sym_modifier] = ACTIONS(727),
    [anon_sym_constructor] = ACTIONS(727),
    [anon_sym_fallback] = ACTIONS(727),
    [anon_sym_receive] = ACTIONS(727),
    [anon_sym_mapping] = ACTIONS(727),
    [anon_sym_bool] = ACTIONS(727),
    [anon_sym_string] = ACTIONS(727),
    [anon_sym_int] = ACTIONS(727),
    [anon_sym_int8] = ACTIONS(727),
    [anon_sym_int16] = ACTIONS(727),
    [anon_sym_int24] = ACTIONS(727),
    [anon_sym_int32] = ACTIONS(727),
    [anon_sym_int40] = ACTIONS(727),
    [anon_sym_int48] = ACTIONS(727),
    [anon_sym_int56] = ACTIONS(727),
    [anon_sym_int64] = ACTIONS(727),
    [anon_sym_int72] = ACTIONS(727),
    [anon_sym_int80] = ACTIONS(727),
    [anon_sym_int88] = ACTIONS(727),
    [anon_sym_int96] = ACTIONS(727),
    [anon_sym_int104] = ACTIONS(727),
    [anon_sym_int112] = ACTIONS(727),
    [anon_sym_int120] = ACTIONS(727),
    [anon_sym_int128] = ACTIONS(727),
    [anon_sym_int136] = ACTIONS(727),
    [anon_sym_int144] = ACTIONS(727),
    [anon_sym_int152] = ACTIONS(727),
    [anon_sym_int160] = ACTIONS(727),
    [anon_sym_int168] = ACTIONS(727),
    [anon_sym_int176] = ACTIONS(727),
    [anon_sym_int184] = ACTIONS(727),
    [anon_sym_int192] = ACTIONS(727),
    [anon_sym_int200] = ACTIONS(727),
    [anon_sym_int208] = ACTIONS(727),
    [anon_sym_int216] = ACTIONS(727),
    [anon_sym_int224] = ACTIONS(727),
    [anon_sym_int232] = ACTIONS(727),
    [anon_sym_int240] = ACTIONS(727),
    [anon_sym_int248] = ACTIONS(727),
    [anon_sym_int256] = ACTIONS(727),
    [anon_sym_uint] = ACTIONS(727),
    [anon_sym_uint8] = ACTIONS(727),
    [anon_sym_uint16] = ACTIONS(727),
    [anon_sym_uint24] = ACTIONS(727),
    [anon_sym_uint32] = ACTIONS(727),
    [anon_sym_uint40] = ACTIONS(727),
    [anon_sym_uint48] = ACTIONS(727),
    [anon_sym_uint56] = ACTIONS(727),
    [anon_sym_uint64] = ACTIONS(727),
    [anon_sym_uint72] = ACTIONS(727),
    [anon_sym_uint80] = ACTIONS(727),
    [anon_sym_uint88] = ACTIONS(727),
    [anon_sym_uint96] = ACTIONS(727),
    [anon_sym_uint104] = ACTIONS(727),
    [anon_sym_uint112] = ACTIONS(727),
    [anon_sym_uint120] = ACTIONS(727),
    [anon_sym_uint128] = ACTIONS(727),
    [anon_sym_uint136] = ACTIONS(727),
    [anon_sym_uint144] = ACTIONS(727),
    [anon_sym_uint152] = ACTIONS(727),
    [anon_sym_uint160] = ACTIONS(727),
    [anon_sym_uint168] = ACTIONS(727),
    [anon_sym_uint176] = ACTIONS(727),
    [anon_sym_uint184] = ACTIONS(727),
    [anon_sym_uint192] = ACTIONS(727),
    [anon_sym_uint200] = ACTIONS(727),
    [anon_sym_uint208] = ACTIONS(727),
    [anon_sym_uint216] = ACTIONS(727),
    [anon_sym_uint224] = ACTIONS(727),
    [anon_sym_uint232] = ACTIONS(727),
    [anon_sym_uint240] = ACTIONS(727),
    [anon_sym_uint248] = ACTIONS(727),
    [anon_sym_uint256] = ACTIONS(727),
    [anon_sym_bytes] = ACTIONS(727),
    [anon_sym_bytes1] = ACTIONS(727),
    [anon_sym_bytes2] = ACTIONS(727),
    [anon_sym_bytes3] = ACTIONS(727),
    [anon_sym_bytes4] = ACTIONS(727),
    [anon_sym_bytes5] = ACTIONS(727),
    [anon_sym_bytes6] = ACTIONS(727),
    [anon_sym_bytes7] = ACTIONS(727),
    [anon_sym_bytes8] = ACTIONS(727),
    [anon_sym_bytes9] = ACTIONS(727),
    [anon_sym_bytes10] = ACTIONS(727),
    [anon_sym_bytes11] = ACTIONS(727),
    [anon_sym_bytes12] = ACTIONS(727),
    [anon_sym_bytes13] = ACTIONS(727),
    [anon_sym_bytes14] = ACTIONS(727),
    [anon_sym_bytes15] = ACTIONS(727),
    [anon_sym_bytes16] = ACTIONS(727),
    [anon_sym_bytes17] = ACTIONS(727),
    [anon_sym_bytes18] = ACTIONS(727),
    [anon_sym_bytes19] = ACTIONS(727),
    [anon_sym_bytes20] = ACTIONS(727),
    [anon_sym_bytes21] = ACTIONS(727),
    [anon_sym_bytes22] = ACTIONS(727),
    [anon_sym_bytes23] = ACTIONS(727),
    [anon_sym_bytes24] = ACTIONS(727),
    [anon_sym_bytes25] = ACTIONS(727),
    [anon_sym_bytes26] = ACTIONS(727),
    [anon_sym_bytes27] = ACTIONS(727),
    [anon_sym_bytes28] = ACTIONS(727),
    [anon_sym_bytes29] = ACTIONS(727),
    [anon_sym_bytes30] = ACTIONS(727),
    [anon_sym_bytes31] = ACTIONS(727),
    [anon_sym_bytes32] = ACTIONS(727),
    [anon_sym_fixed] = ACTIONS(727),
    [aux_sym__fixed_token1] = ACTIONS(727),
    [anon_sym_ufixed] = ACTIONS(727),
    [aux_sym__ufixed_token1] = ACTIONS(727),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(705),
    [sym_identifier] = ACTIONS(703),
    [anon_sym_pragma] = ACTIONS(703),
    [anon_sym_import] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(703),
    [anon_sym_abstract] = ACTIONS(703),
    [anon_sym_contract] = ACTIONS(703),
    [anon_sym_error] = ACTIONS(703),
    [anon_sym_interface] = ACTIONS(703),
    [anon_sym_library] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_byte] = ACTIONS(703),
    [anon_sym_address] = ACTIONS(703),
    [anon_sym_var] = ACTIONS(703),
    [anon_sym_mapping] = ACTIONS(703),
    [anon_sym_bool] = ACTIONS(703),
    [anon_sym_string] = ACTIONS(703),
    [anon_sym_int] = ACTIONS(703),
    [anon_sym_int8] = ACTIONS(703),
    [anon_sym_int16] = ACTIONS(703),
    [anon_sym_int24] = ACTIONS(703),
    [anon_sym_int32] = ACTIONS(703),
    [anon_sym_int40] = ACTIONS(703),
    [anon_sym_int48] = ACTIONS(703),
    [anon_sym_int56] = ACTIONS(703),
    [anon_sym_int64] = ACTIONS(703),
    [anon_sym_int72] = ACTIONS(703),
    [anon_sym_int80] = ACTIONS(703),
    [anon_sym_int88] = ACTIONS(703),
    [anon_sym_int96] = ACTIONS(703),
    [anon_sym_int104] = ACTIONS(703),
    [anon_sym_int112] = ACTIONS(703),
    [anon_sym_int120] = ACTIONS(703),
    [anon_sym_int128] = ACTIONS(703),
    [anon_sym_int136] = ACTIONS(703),
    [anon_sym_int144] = ACTIONS(703),
    [anon_sym_int152] = ACTIONS(703),
    [anon_sym_int160] = ACTIONS(703),
    [anon_sym_int168] = ACTIONS(703),
    [anon_sym_int176] = ACTIONS(703),
    [anon_sym_int184] = ACTIONS(703),
    [anon_sym_int192] = ACTIONS(703),
    [anon_sym_int200] = ACTIONS(703),
    [anon_sym_int208] = ACTIONS(703),
    [anon_sym_int216] = ACTIONS(703),
    [anon_sym_int224] = ACTIONS(703),
    [anon_sym_int232] = ACTIONS(703),
    [anon_sym_int240] = ACTIONS(703),
    [anon_sym_int248] = ACTIONS(703),
    [anon_sym_int256] = ACTIONS(703),
    [anon_sym_uint] = ACTIONS(703),
    [anon_sym_uint8] = ACTIONS(703),
    [anon_sym_uint16] = ACTIONS(703),
    [anon_sym_uint24] = ACTIONS(703),
    [anon_sym_uint32] = ACTIONS(703),
    [anon_sym_uint40] = ACTIONS(703),
    [anon_sym_uint48] = ACTIONS(703),
    [anon_sym_uint56] = ACTIONS(703),
    [anon_sym_uint64] = ACTIONS(703),
    [anon_sym_uint72] = ACTIONS(703),
    [anon_sym_uint80] = ACTIONS(703),
    [anon_sym_uint88] = ACTIONS(703),
    [anon_sym_uint96] = ACTIONS(703),
    [anon_sym_uint104] = ACTIONS(703),
    [anon_sym_uint112] = ACTIONS(703),
    [anon_sym_uint120] = ACTIONS(703),
    [anon_sym_uint128] = ACTIONS(703),
    [anon_sym_uint136] = ACTIONS(703),
    [anon_sym_uint144] = ACTIONS(703),
    [anon_sym_uint152] = ACTIONS(703),
    [anon_sym_uint160] = ACTIONS(703),
    [anon_sym_uint168] = ACTIONS(703),
    [anon_sym_uint176] = ACTIONS(703),
    [anon_sym_uint184] = ACTIONS(703),
    [anon_sym_uint192] = ACTIONS(703),
    [anon_sym_uint200] = ACTIONS(703),
    [anon_sym_uint208] = ACTIONS(703),
    [anon_sym_uint216] = ACTIONS(703),
    [anon_sym_uint224] = ACTIONS(703),
    [anon_sym_uint232] = ACTIONS(703),
    [anon_sym_uint240] = ACTIONS(703),
    [anon_sym_uint248] = ACTIONS(703),
    [anon_sym_uint256] = ACTIONS(703),
    [anon_sym_bytes] = ACTIONS(703),
    [anon_sym_bytes1] = ACTIONS(703),
    [anon_sym_bytes2] = ACTIONS(703),
    [anon_sym_bytes3] = ACTIONS(703),
    [anon_sym_bytes4] = ACTIONS(703),
    [anon_sym_bytes5] = ACTIONS(703),
    [anon_sym_bytes6] = ACTIONS(703),
    [anon_sym_bytes7] = ACTIONS(703),
    [anon_sym_bytes8] = ACTIONS(703),
    [anon_sym_bytes9] = ACTIONS(703),
    [anon_sym_bytes10] = ACTIONS(703),
    [anon_sym_bytes11] = ACTIONS(703),
    [anon_sym_bytes12] = ACTIONS(703),
    [anon_sym_bytes13] = ACTIONS(703),
    [anon_sym_bytes14] = ACTIONS(703),
    [anon_sym_bytes15] = ACTIONS(703),
    [anon_sym_bytes16] = ACTIONS(703),
    [anon_sym_bytes17] = ACTIONS(703),
    [anon_sym_bytes18] = ACTIONS(703),
    [anon_sym_bytes19] = ACTIONS(703),
    [anon_sym_bytes20] = ACTIONS(703),
    [anon_sym_bytes21] = ACTIONS(703),
    [anon_sym_bytes22] = ACTIONS(703),
    [anon_sym_bytes23] = ACTIONS(703),
    [anon_sym_bytes24] = ACTIONS(703),
    [anon_sym_bytes25] = ACTIONS(703),
    [anon_sym_bytes26] = ACTIONS(703),
    [anon_sym_bytes27] = ACTIONS(703),
    [anon_sym_bytes28] = ACTIONS(703),
    [anon_sym_bytes29] = ACTIONS(703),
    [anon_sym_bytes30] = ACTIONS(703),
    [anon_sym_bytes31] = ACTIONS(703),
    [anon_sym_bytes32] = ACTIONS(703),
    [anon_sym_fixed] = ACTIONS(703),
    [aux_sym__fixed_token1] = ACTIONS(703),
    [anon_sym_ufixed] = ACTIONS(703),
    [aux_sym__ufixed_token1] = ACTIONS(703),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_identifier] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_error] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_event] = ACTIONS(731),
    [anon_sym_using] = ACTIONS(731),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_byte] = ACTIONS(731),
    [anon_sym_address] = ACTIONS(731),
    [anon_sym_var] = ACTIONS(731),
    [anon_sym_modifier] = ACTIONS(731),
    [anon_sym_constructor] = ACTIONS(731),
    [anon_sym_fallback] = ACTIONS(731),
    [anon_sym_receive] = ACTIONS(731),
    [anon_sym_mapping] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_int] = ACTIONS(731),
    [anon_sym_int8] = ACTIONS(731),
    [anon_sym_int16] = ACTIONS(731),
    [anon_sym_int24] = ACTIONS(731),
    [anon_sym_int32] = ACTIONS(731),
    [anon_sym_int40] = ACTIONS(731),
    [anon_sym_int48] = ACTIONS(731),
    [anon_sym_int56] = ACTIONS(731),
    [anon_sym_int64] = ACTIONS(731),
    [anon_sym_int72] = ACTIONS(731),
    [anon_sym_int80] = ACTIONS(731),
    [anon_sym_int88] = ACTIONS(731),
    [anon_sym_int96] = ACTIONS(731),
    [anon_sym_int104] = ACTIONS(731),
    [anon_sym_int112] = ACTIONS(731),
    [anon_sym_int120] = ACTIONS(731),
    [anon_sym_int128] = ACTIONS(731),
    [anon_sym_int136] = ACTIONS(731),
    [anon_sym_int144] = ACTIONS(731),
    [anon_sym_int152] = ACTIONS(731),
    [anon_sym_int160] = ACTIONS(731),
    [anon_sym_int168] = ACTIONS(731),
    [anon_sym_int176] = ACTIONS(731),
    [anon_sym_int184] = ACTIONS(731),
    [anon_sym_int192] = ACTIONS(731),
    [anon_sym_int200] = ACTIONS(731),
    [anon_sym_int208] = ACTIONS(731),
    [anon_sym_int216] = ACTIONS(731),
    [anon_sym_int224] = ACTIONS(731),
    [anon_sym_int232] = ACTIONS(731),
    [anon_sym_int240] = ACTIONS(731),
    [anon_sym_int248] = ACTIONS(731),
    [anon_sym_int256] = ACTIONS(731),
    [anon_sym_uint] = ACTIONS(731),
    [anon_sym_uint8] = ACTIONS(731),
    [anon_sym_uint16] = ACTIONS(731),
    [anon_sym_uint24] = ACTIONS(731),
    [anon_sym_uint32] = ACTIONS(731),
    [anon_sym_uint40] = ACTIONS(731),
    [anon_sym_uint48] = ACTIONS(731),
    [anon_sym_uint56] = ACTIONS(731),
    [anon_sym_uint64] = ACTIONS(731),
    [anon_sym_uint72] = ACTIONS(731),
    [anon_sym_uint80] = ACTIONS(731),
    [anon_sym_uint88] = ACTIONS(731),
    [anon_sym_uint96] = ACTIONS(731),
    [anon_sym_uint104] = ACTIONS(731),
    [anon_sym_uint112] = ACTIONS(731),
    [anon_sym_uint120] = ACTIONS(731),
    [anon_sym_uint128] = ACTIONS(731),
    [anon_sym_uint136] = ACTIONS(731),
    [anon_sym_uint144] = ACTIONS(731),
    [anon_sym_uint152] = ACTIONS(731),
    [anon_sym_uint160] = ACTIONS(731),
    [anon_sym_uint168] = ACTIONS(731),
    [anon_sym_uint176] = ACTIONS(731),
    [anon_sym_uint184] = ACTIONS(731),
    [anon_sym_uint192] = ACTIONS(731),
    [anon_sym_uint200] = ACTIONS(731),
    [anon_sym_uint208] = ACTIONS(731),
    [anon_sym_uint216] = ACTIONS(731),
    [anon_sym_uint224] = ACTIONS(731),
    [anon_sym_uint232] = ACTIONS(731),
    [anon_sym_uint240] = ACTIONS(731),
    [anon_sym_uint248] = ACTIONS(731),
    [anon_sym_uint256] = ACTIONS(731),
    [anon_sym_bytes] = ACTIONS(731),
    [anon_sym_bytes1] = ACTIONS(731),
    [anon_sym_bytes2] = ACTIONS(731),
    [anon_sym_bytes3] = ACTIONS(731),
    [anon_sym_bytes4] = ACTIONS(731),
    [anon_sym_bytes5] = ACTIONS(731),
    [anon_sym_bytes6] = ACTIONS(731),
    [anon_sym_bytes7] = ACTIONS(731),
    [anon_sym_bytes8] = ACTIONS(731),
    [anon_sym_bytes9] = ACTIONS(731),
    [anon_sym_bytes10] = ACTIONS(731),
    [anon_sym_bytes11] = ACTIONS(731),
    [anon_sym_bytes12] = ACTIONS(731),
    [anon_sym_bytes13] = ACTIONS(731),
    [anon_sym_bytes14] = ACTIONS(731),
    [anon_sym_bytes15] = ACTIONS(731),
    [anon_sym_bytes16] = ACTIONS(731),
    [anon_sym_bytes17] = ACTIONS(731),
    [anon_sym_bytes18] = ACTIONS(731),
    [anon_sym_bytes19] = ACTIONS(731),
    [anon_sym_bytes20] = ACTIONS(731),
    [anon_sym_bytes21] = ACTIONS(731),
    [anon_sym_bytes22] = ACTIONS(731),
    [anon_sym_bytes23] = ACTIONS(731),
    [anon_sym_bytes24] = ACTIONS(731),
    [anon_sym_bytes25] = ACTIONS(731),
    [anon_sym_bytes26] = ACTIONS(731),
    [anon_sym_bytes27] = ACTIONS(731),
    [anon_sym_bytes28] = ACTIONS(731),
    [anon_sym_bytes29] = ACTIONS(731),
    [anon_sym_bytes30] = ACTIONS(731),
    [anon_sym_bytes31] = ACTIONS(731),
    [anon_sym_bytes32] = ACTIONS(731),
    [anon_sym_fixed] = ACTIONS(731),
    [aux_sym__fixed_token1] = ACTIONS(731),
    [anon_sym_ufixed] = ACTIONS(731),
    [aux_sym__ufixed_token1] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_identifier] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_type] = ACTIONS(735),
    [anon_sym_error] = ACTIONS(735),
    [anon_sym_struct] = ACTIONS(735),
    [anon_sym_enum] = ACTIONS(735),
    [anon_sym_event] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_function] = ACTIONS(735),
    [anon_sym_byte] = ACTIONS(735),
    [anon_sym_address] = ACTIONS(735),
    [anon_sym_var] = ACTIONS(735),
    [anon_sym_modifier] = ACTIONS(735),
    [anon_sym_constructor] = ACTIONS(735),
    [anon_sym_fallback] = ACTIONS(735),
    [anon_sym_receive] = ACTIONS(735),
    [anon_sym_mapping] = ACTIONS(735),
    [anon_sym_bool] = ACTIONS(735),
    [anon_sym_string] = ACTIONS(735),
    [anon_sym_int] = ACTIONS(735),
    [anon_sym_int8] = ACTIONS(735),
    [anon_sym_int16] = ACTIONS(735),
    [anon_sym_int24] = ACTIONS(735),
    [anon_sym_int32] = ACTIONS(735),
    [anon_sym_int40] = ACTIONS(735),
    [anon_sym_int48] = ACTIONS(735),
    [anon_sym_int56] = ACTIONS(735),
    [anon_sym_int64] = ACTIONS(735),
    [anon_sym_int72] = ACTIONS(735),
    [anon_sym_int80] = ACTIONS(735),
    [anon_sym_int88] = ACTIONS(735),
    [anon_sym_int96] = ACTIONS(735),
    [anon_sym_int104] = ACTIONS(735),
    [anon_sym_int112] = ACTIONS(735),
    [anon_sym_int120] = ACTIONS(735),
    [anon_sym_int128] = ACTIONS(735),
    [anon_sym_int136] = ACTIONS(735),
    [anon_sym_int144] = ACTIONS(735),
    [anon_sym_int152] = ACTIONS(735),
    [anon_sym_int160] = ACTIONS(735),
    [anon_sym_int168] = ACTIONS(735),
    [anon_sym_int176] = ACTIONS(735),
    [anon_sym_int184] = ACTIONS(735),
    [anon_sym_int192] = ACTIONS(735),
    [anon_sym_int200] = ACTIONS(735),
    [anon_sym_int208] = ACTIONS(735),
    [anon_sym_int216] = ACTIONS(735),
    [anon_sym_int224] = ACTIONS(735),
    [anon_sym_int232] = ACTIONS(735),
    [anon_sym_int240] = ACTIONS(735),
    [anon_sym_int248] = ACTIONS(735),
    [anon_sym_int256] = ACTIONS(735),
    [anon_sym_uint] = ACTIONS(735),
    [anon_sym_uint8] = ACTIONS(735),
    [anon_sym_uint16] = ACTIONS(735),
    [anon_sym_uint24] = ACTIONS(735),
    [anon_sym_uint32] = ACTIONS(735),
    [anon_sym_uint40] = ACTIONS(735),
    [anon_sym_uint48] = ACTIONS(735),
    [anon_sym_uint56] = ACTIONS(735),
    [anon_sym_uint64] = ACTIONS(735),
    [anon_sym_uint72] = ACTIONS(735),
    [anon_sym_uint80] = ACTIONS(735),
    [anon_sym_uint88] = ACTIONS(735),
    [anon_sym_uint96] = ACTIONS(735),
    [anon_sym_uint104] = ACTIONS(735),
    [anon_sym_uint112] = ACTIONS(735),
    [anon_sym_uint120] = ACTIONS(735),
    [anon_sym_uint128] = ACTIONS(735),
    [anon_sym_uint136] = ACTIONS(735),
    [anon_sym_uint144] = ACTIONS(735),
    [anon_sym_uint152] = ACTIONS(735),
    [anon_sym_uint160] = ACTIONS(735),
    [anon_sym_uint168] = ACTIONS(735),
    [anon_sym_uint176] = ACTIONS(735),
    [anon_sym_uint184] = ACTIONS(735),
    [anon_sym_uint192] = ACTIONS(735),
    [anon_sym_uint200] = ACTIONS(735),
    [anon_sym_uint208] = ACTIONS(735),
    [anon_sym_uint216] = ACTIONS(735),
    [anon_sym_uint224] = ACTIONS(735),
    [anon_sym_uint232] = ACTIONS(735),
    [anon_sym_uint240] = ACTIONS(735),
    [anon_sym_uint248] = ACTIONS(735),
    [anon_sym_uint256] = ACTIONS(735),
    [anon_sym_bytes] = ACTIONS(735),
    [anon_sym_bytes1] = ACTIONS(735),
    [anon_sym_bytes2] = ACTIONS(735),
    [anon_sym_bytes3] = ACTIONS(735),
    [anon_sym_bytes4] = ACTIONS(735),
    [anon_sym_bytes5] = ACTIONS(735),
    [anon_sym_bytes6] = ACTIONS(735),
    [anon_sym_bytes7] = ACTIONS(735),
    [anon_sym_bytes8] = ACTIONS(735),
    [anon_sym_bytes9] = ACTIONS(735),
    [anon_sym_bytes10] = ACTIONS(735),
    [anon_sym_bytes11] = ACTIONS(735),
    [anon_sym_bytes12] = ACTIONS(735),
    [anon_sym_bytes13] = ACTIONS(735),
    [anon_sym_bytes14] = ACTIONS(735),
    [anon_sym_bytes15] = ACTIONS(735),
    [anon_sym_bytes16] = ACTIONS(735),
    [anon_sym_bytes17] = ACTIONS(735),
    [anon_sym_bytes18] = ACTIONS(735),
    [anon_sym_bytes19] = ACTIONS(735),
    [anon_sym_bytes20] = ACTIONS(735),
    [anon_sym_bytes21] = ACTIONS(735),
    [anon_sym_bytes22] = ACTIONS(735),
    [anon_sym_bytes23] = ACTIONS(735),
    [anon_sym_bytes24] = ACTIONS(735),
    [anon_sym_bytes25] = ACTIONS(735),
    [anon_sym_bytes26] = ACTIONS(735),
    [anon_sym_bytes27] = ACTIONS(735),
    [anon_sym_bytes28] = ACTIONS(735),
    [anon_sym_bytes29] = ACTIONS(735),
    [anon_sym_bytes30] = ACTIONS(735),
    [anon_sym_bytes31] = ACTIONS(735),
    [anon_sym_bytes32] = ACTIONS(735),
    [anon_sym_fixed] = ACTIONS(735),
    [aux_sym__fixed_token1] = ACTIONS(735),
    [anon_sym_ufixed] = ACTIONS(735),
    [aux_sym__ufixed_token1] = ACTIONS(735),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_identifier] = ACTIONS(673),
    [anon_sym_RBRACE] = ACTIONS(671),
    [anon_sym_type] = ACTIONS(673),
    [anon_sym_error] = ACTIONS(673),
    [anon_sym_struct] = ACTIONS(673),
    [anon_sym_enum] = ACTIONS(673),
    [anon_sym_event] = ACTIONS(673),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_function] = ACTIONS(673),
    [anon_sym_byte] = ACTIONS(673),
    [anon_sym_address] = ACTIONS(673),
    [anon_sym_var] = ACTIONS(673),
    [anon_sym_modifier] = ACTIONS(673),
    [anon_sym_constructor] = ACTIONS(673),
    [anon_sym_fallback] = ACTIONS(673),
    [anon_sym_receive] = ACTIONS(673),
    [anon_sym_mapping] = ACTIONS(673),
    [anon_sym_bool] = ACTIONS(673),
    [anon_sym_string] = ACTIONS(673),
    [anon_sym_int] = ACTIONS(673),
    [anon_sym_int8] = ACTIONS(673),
    [anon_sym_int16] = ACTIONS(673),
    [anon_sym_int24] = ACTIONS(673),
    [anon_sym_int32] = ACTIONS(673),
    [anon_sym_int40] = ACTIONS(673),
    [anon_sym_int48] = ACTIONS(673),
    [anon_sym_int56] = ACTIONS(673),
    [anon_sym_int64] = ACTIONS(673),
    [anon_sym_int72] = ACTIONS(673),
    [anon_sym_int80] = ACTIONS(673),
    [anon_sym_int88] = ACTIONS(673),
    [anon_sym_int96] = ACTIONS(673),
    [anon_sym_int104] = ACTIONS(673),
    [anon_sym_int112] = ACTIONS(673),
    [anon_sym_int120] = ACTIONS(673),
    [anon_sym_int128] = ACTIONS(673),
    [anon_sym_int136] = ACTIONS(673),
    [anon_sym_int144] = ACTIONS(673),
    [anon_sym_int152] = ACTIONS(673),
    [anon_sym_int160] = ACTIONS(673),
    [anon_sym_int168] = ACTIONS(673),
    [anon_sym_int176] = ACTIONS(673),
    [anon_sym_int184] = ACTIONS(673),
    [anon_sym_int192] = ACTIONS(673),
    [anon_sym_int200] = ACTIONS(673),
    [anon_sym_int208] = ACTIONS(673),
    [anon_sym_int216] = ACTIONS(673),
    [anon_sym_int224] = ACTIONS(673),
    [anon_sym_int232] = ACTIONS(673),
    [anon_sym_int240] = ACTIONS(673),
    [anon_sym_int248] = ACTIONS(673),
    [anon_sym_int256] = ACTIONS(673),
    [anon_sym_uint] = ACTIONS(673),
    [anon_sym_uint8] = ACTIONS(673),
    [anon_sym_uint16] = ACTIONS(673),
    [anon_sym_uint24] = ACTIONS(673),
    [anon_sym_uint32] = ACTIONS(673),
    [anon_sym_uint40] = ACTIONS(673),
    [anon_sym_uint48] = ACTIONS(673),
    [anon_sym_uint56] = ACTIONS(673),
    [anon_sym_uint64] = ACTIONS(673),
    [anon_sym_uint72] = ACTIONS(673),
    [anon_sym_uint80] = ACTIONS(673),
    [anon_sym_uint88] = ACTIONS(673),
    [anon_sym_uint96] = ACTIONS(673),
    [anon_sym_uint104] = ACTIONS(673),
    [anon_sym_uint112] = ACTIONS(673),
    [anon_sym_uint120] = ACTIONS(673),
    [anon_sym_uint128] = ACTIONS(673),
    [anon_sym_uint136] = ACTIONS(673),
    [anon_sym_uint144] = ACTIONS(673),
    [anon_sym_uint152] = ACTIONS(673),
    [anon_sym_uint160] = ACTIONS(673),
    [anon_sym_uint168] = ACTIONS(673),
    [anon_sym_uint176] = ACTIONS(673),
    [anon_sym_uint184] = ACTIONS(673),
    [anon_sym_uint192] = ACTIONS(673),
    [anon_sym_uint200] = ACTIONS(673),
    [anon_sym_uint208] = ACTIONS(673),
    [anon_sym_uint216] = ACTIONS(673),
    [anon_sym_uint224] = ACTIONS(673),
    [anon_sym_uint232] = ACTIONS(673),
    [anon_sym_uint240] = ACTIONS(673),
    [anon_sym_uint248] = ACTIONS(673),
    [anon_sym_uint256] = ACTIONS(673),
    [anon_sym_bytes] = ACTIONS(673),
    [anon_sym_bytes1] = ACTIONS(673),
    [anon_sym_bytes2] = ACTIONS(673),
    [anon_sym_bytes3] = ACTIONS(673),
    [anon_sym_bytes4] = ACTIONS(673),
    [anon_sym_bytes5] = ACTIONS(673),
    [anon_sym_bytes6] = ACTIONS(673),
    [anon_sym_bytes7] = ACTIONS(673),
    [anon_sym_bytes8] = ACTIONS(673),
    [anon_sym_bytes9] = ACTIONS(673),
    [anon_sym_bytes10] = ACTIONS(673),
    [anon_sym_bytes11] = ACTIONS(673),
    [anon_sym_bytes12] = ACTIONS(673),
    [anon_sym_bytes13] = ACTIONS(673),
    [anon_sym_bytes14] = ACTIONS(673),
    [anon_sym_bytes15] = ACTIONS(673),
    [anon_sym_bytes16] = ACTIONS(673),
    [anon_sym_bytes17] = ACTIONS(673),
    [anon_sym_bytes18] = ACTIONS(673),
    [anon_sym_bytes19] = ACTIONS(673),
    [anon_sym_bytes20] = ACTIONS(673),
    [anon_sym_bytes21] = ACTIONS(673),
    [anon_sym_bytes22] = ACTIONS(673),
    [anon_sym_bytes23] = ACTIONS(673),
    [anon_sym_bytes24] = ACTIONS(673),
    [anon_sym_bytes25] = ACTIONS(673),
    [anon_sym_bytes26] = ACTIONS(673),
    [anon_sym_bytes27] = ACTIONS(673),
    [anon_sym_bytes28] = ACTIONS(673),
    [anon_sym_bytes29] = ACTIONS(673),
    [anon_sym_bytes30] = ACTIONS(673),
    [anon_sym_bytes31] = ACTIONS(673),
    [anon_sym_bytes32] = ACTIONS(673),
    [anon_sym_fixed] = ACTIONS(673),
    [aux_sym__fixed_token1] = ACTIONS(673),
    [anon_sym_ufixed] = ACTIONS(673),
    [aux_sym__ufixed_token1] = ACTIONS(673),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(725),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_pragma] = ACTIONS(723),
    [anon_sym_import] = ACTIONS(723),
    [anon_sym_type] = ACTIONS(723),
    [anon_sym_abstract] = ACTIONS(723),
    [anon_sym_contract] = ACTIONS(723),
    [anon_sym_error] = ACTIONS(723),
    [anon_sym_interface] = ACTIONS(723),
    [anon_sym_library] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(723),
    [anon_sym_enum] = ACTIONS(723),
    [anon_sym_function] = ACTIONS(723),
    [anon_sym_byte] = ACTIONS(723),
    [anon_sym_address] = ACTIONS(723),
    [anon_sym_var] = ACTIONS(723),
    [anon_sym_mapping] = ACTIONS(723),
    [anon_sym_bool] = ACTIONS(723),
    [anon_sym_string] = ACTIONS(723),
    [anon_sym_int] = ACTIONS(723),
    [anon_sym_int8] = ACTIONS(723),
    [anon_sym_int16] = ACTIONS(723),
    [anon_sym_int24] = ACTIONS(723),
    [anon_sym_int32] = ACTIONS(723),
    [anon_sym_int40] = ACTIONS(723),
    [anon_sym_int48] = ACTIONS(723),
    [anon_sym_int56] = ACTIONS(723),
    [anon_sym_int64] = ACTIONS(723),
    [anon_sym_int72] = ACTIONS(723),
    [anon_sym_int80] = ACTIONS(723),
    [anon_sym_int88] = ACTIONS(723),
    [anon_sym_int96] = ACTIONS(723),
    [anon_sym_int104] = ACTIONS(723),
    [anon_sym_int112] = ACTIONS(723),
    [anon_sym_int120] = ACTIONS(723),
    [anon_sym_int128] = ACTIONS(723),
    [anon_sym_int136] = ACTIONS(723),
    [anon_sym_int144] = ACTIONS(723),
    [anon_sym_int152] = ACTIONS(723),
    [anon_sym_int160] = ACTIONS(723),
    [anon_sym_int168] = ACTIONS(723),
    [anon_sym_int176] = ACTIONS(723),
    [anon_sym_int184] = ACTIONS(723),
    [anon_sym_int192] = ACTIONS(723),
    [anon_sym_int200] = ACTIONS(723),
    [anon_sym_int208] = ACTIONS(723),
    [anon_sym_int216] = ACTIONS(723),
    [anon_sym_int224] = ACTIONS(723),
    [anon_sym_int232] = ACTIONS(723),
    [anon_sym_int240] = ACTIONS(723),
    [anon_sym_int248] = ACTIONS(723),
    [anon_sym_int256] = ACTIONS(723),
    [anon_sym_uint] = ACTIONS(723),
    [anon_sym_uint8] = ACTIONS(723),
    [anon_sym_uint16] = ACTIONS(723),
    [anon_sym_uint24] = ACTIONS(723),
    [anon_sym_uint32] = ACTIONS(723),
    [anon_sym_uint40] = ACTIONS(723),
    [anon_sym_uint48] = ACTIONS(723),
    [anon_sym_uint56] = ACTIONS(723),
    [anon_sym_uint64] = ACTIONS(723),
    [anon_sym_uint72] = ACTIONS(723),
    [anon_sym_uint80] = ACTIONS(723),
    [anon_sym_uint88] = ACTIONS(723),
    [anon_sym_uint96] = ACTIONS(723),
    [anon_sym_uint104] = ACTIONS(723),
    [anon_sym_uint112] = ACTIONS(723),
    [anon_sym_uint120] = ACTIONS(723),
    [anon_sym_uint128] = ACTIONS(723),
    [anon_sym_uint136] = ACTIONS(723),
    [anon_sym_uint144] = ACTIONS(723),
    [anon_sym_uint152] = ACTIONS(723),
    [anon_sym_uint160] = ACTIONS(723),
    [anon_sym_uint168] = ACTIONS(723),
    [anon_sym_uint176] = ACTIONS(723),
    [anon_sym_uint184] = ACTIONS(723),
    [anon_sym_uint192] = ACTIONS(723),
    [anon_sym_uint200] = ACTIONS(723),
    [anon_sym_uint208] = ACTIONS(723),
    [anon_sym_uint216] = ACTIONS(723),
    [anon_sym_uint224] = ACTIONS(723),
    [anon_sym_uint232] = ACTIONS(723),
    [anon_sym_uint240] = ACTIONS(723),
    [anon_sym_uint248] = ACTIONS(723),
    [anon_sym_uint256] = ACTIONS(723),
    [anon_sym_bytes] = ACTIONS(723),
    [anon_sym_bytes1] = ACTIONS(723),
    [anon_sym_bytes2] = ACTIONS(723),
    [anon_sym_bytes3] = ACTIONS(723),
    [anon_sym_bytes4] = ACTIONS(723),
    [anon_sym_bytes5] = ACTIONS(723),
    [anon_sym_bytes6] = ACTIONS(723),
    [anon_sym_bytes7] = ACTIONS(723),
    [anon_sym_bytes8] = ACTIONS(723),
    [anon_sym_bytes9] = ACTIONS(723),
    [anon_sym_bytes10] = ACTIONS(723),
    [anon_sym_bytes11] = ACTIONS(723),
    [anon_sym_bytes12] = ACTIONS(723),
    [anon_sym_bytes13] = ACTIONS(723),
    [anon_sym_bytes14] = ACTIONS(723),
    [anon_sym_bytes15] = ACTIONS(723),
    [anon_sym_bytes16] = ACTIONS(723),
    [anon_sym_bytes17] = ACTIONS(723),
    [anon_sym_bytes18] = ACTIONS(723),
    [anon_sym_bytes19] = ACTIONS(723),
    [anon_sym_bytes20] = ACTIONS(723),
    [anon_sym_bytes21] = ACTIONS(723),
    [anon_sym_bytes22] = ACTIONS(723),
    [anon_sym_bytes23] = ACTIONS(723),
    [anon_sym_bytes24] = ACTIONS(723),
    [anon_sym_bytes25] = ACTIONS(723),
    [anon_sym_bytes26] = ACTIONS(723),
    [anon_sym_bytes27] = ACTIONS(723),
    [anon_sym_bytes28] = ACTIONS(723),
    [anon_sym_bytes29] = ACTIONS(723),
    [anon_sym_bytes30] = ACTIONS(723),
    [anon_sym_bytes31] = ACTIONS(723),
    [anon_sym_bytes32] = ACTIONS(723),
    [anon_sym_fixed] = ACTIONS(723),
    [aux_sym__fixed_token1] = ACTIONS(723),
    [anon_sym_ufixed] = ACTIONS(723),
    [aux_sym__ufixed_token1] = ACTIONS(723),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_identifier] = ACTIONS(739),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_type] = ACTIONS(739),
    [anon_sym_error] = ACTIONS(739),
    [anon_sym_struct] = ACTIONS(739),
    [anon_sym_enum] = ACTIONS(739),
    [anon_sym_event] = ACTIONS(739),
    [anon_sym_using] = ACTIONS(739),
    [anon_sym_function] = ACTIONS(739),
    [anon_sym_byte] = ACTIONS(739),
    [anon_sym_address] = ACTIONS(739),
    [anon_sym_var] = ACTIONS(739),
    [anon_sym_modifier] = ACTIONS(739),
    [anon_sym_constructor] = ACTIONS(739),
    [anon_sym_fallback] = ACTIONS(739),
    [anon_sym_receive] = ACTIONS(739),
    [anon_sym_mapping] = ACTIONS(739),
    [anon_sym_bool] = ACTIONS(739),
    [anon_sym_string] = ACTIONS(739),
    [anon_sym_int] = ACTIONS(739),
    [anon_sym_int8] = ACTIONS(739),
    [anon_sym_int16] = ACTIONS(739),
    [anon_sym_int24] = ACTIONS(739),
    [anon_sym_int32] = ACTIONS(739),
    [anon_sym_int40] = ACTIONS(739),
    [anon_sym_int48] = ACTIONS(739),
    [anon_sym_int56] = ACTIONS(739),
    [anon_sym_int64] = ACTIONS(739),
    [anon_sym_int72] = ACTIONS(739),
    [anon_sym_int80] = ACTIONS(739),
    [anon_sym_int88] = ACTIONS(739),
    [anon_sym_int96] = ACTIONS(739),
    [anon_sym_int104] = ACTIONS(739),
    [anon_sym_int112] = ACTIONS(739),
    [anon_sym_int120] = ACTIONS(739),
    [anon_sym_int128] = ACTIONS(739),
    [anon_sym_int136] = ACTIONS(739),
    [anon_sym_int144] = ACTIONS(739),
    [anon_sym_int152] = ACTIONS(739),
    [anon_sym_int160] = ACTIONS(739),
    [anon_sym_int168] = ACTIONS(739),
    [anon_sym_int176] = ACTIONS(739),
    [anon_sym_int184] = ACTIONS(739),
    [anon_sym_int192] = ACTIONS(739),
    [anon_sym_int200] = ACTIONS(739),
    [anon_sym_int208] = ACTIONS(739),
    [anon_sym_int216] = ACTIONS(739),
    [anon_sym_int224] = ACTIONS(739),
    [anon_sym_int232] = ACTIONS(739),
    [anon_sym_int240] = ACTIONS(739),
    [anon_sym_int248] = ACTIONS(739),
    [anon_sym_int256] = ACTIONS(739),
    [anon_sym_uint] = ACTIONS(739),
    [anon_sym_uint8] = ACTIONS(739),
    [anon_sym_uint16] = ACTIONS(739),
    [anon_sym_uint24] = ACTIONS(739),
    [anon_sym_uint32] = ACTIONS(739),
    [anon_sym_uint40] = ACTIONS(739),
    [anon_sym_uint48] = ACTIONS(739),
    [anon_sym_uint56] = ACTIONS(739),
    [anon_sym_uint64] = ACTIONS(739),
    [anon_sym_uint72] = ACTIONS(739),
    [anon_sym_uint80] = ACTIONS(739),
    [anon_sym_uint88] = ACTIONS(739),
    [anon_sym_uint96] = ACTIONS(739),
    [anon_sym_uint104] = ACTIONS(739),
    [anon_sym_uint112] = ACTIONS(739),
    [anon_sym_uint120] = ACTIONS(739),
    [anon_sym_uint128] = ACTIONS(739),
    [anon_sym_uint136] = ACTIONS(739),
    [anon_sym_uint144] = ACTIONS(739),
    [anon_sym_uint152] = ACTIONS(739),
    [anon_sym_uint160] = ACTIONS(739),
    [anon_sym_uint168] = ACTIONS(739),
    [anon_sym_uint176] = ACTIONS(739),
    [anon_sym_uint184] = ACTIONS(739),
    [anon_sym_uint192] = ACTIONS(739),
    [anon_sym_uint200] = ACTIONS(739),
    [anon_sym_uint208] = ACTIONS(739),
    [anon_sym_uint216] = ACTIONS(739),
    [anon_sym_uint224] = ACTIONS(739),
    [anon_sym_uint232] = ACTIONS(739),
    [anon_sym_uint240] = ACTIONS(739),
    [anon_sym_uint248] = ACTIONS(739),
    [anon_sym_uint256] = ACTIONS(739),
    [anon_sym_bytes] = ACTIONS(739),
    [anon_sym_bytes1] = ACTIONS(739),
    [anon_sym_bytes2] = ACTIONS(739),
    [anon_sym_bytes3] = ACTIONS(739),
    [anon_sym_bytes4] = ACTIONS(739),
    [anon_sym_bytes5] = ACTIONS(739),
    [anon_sym_bytes6] = ACTIONS(739),
    [anon_sym_bytes7] = ACTIONS(739),
    [anon_sym_bytes8] = ACTIONS(739),
    [anon_sym_bytes9] = ACTIONS(739),
    [anon_sym_bytes10] = ACTIONS(739),
    [anon_sym_bytes11] = ACTIONS(739),
    [anon_sym_bytes12] = ACTIONS(739),
    [anon_sym_bytes13] = ACTIONS(739),
    [anon_sym_bytes14] = ACTIONS(739),
    [anon_sym_bytes15] = ACTIONS(739),
    [anon_sym_bytes16] = ACTIONS(739),
    [anon_sym_bytes17] = ACTIONS(739),
    [anon_sym_bytes18] = ACTIONS(739),
    [anon_sym_bytes19] = ACTIONS(739),
    [anon_sym_bytes20] = ACTIONS(739),
    [anon_sym_bytes21] = ACTIONS(739),
    [anon_sym_bytes22] = ACTIONS(739),
    [anon_sym_bytes23] = ACTIONS(739),
    [anon_sym_bytes24] = ACTIONS(739),
    [anon_sym_bytes25] = ACTIONS(739),
    [anon_sym_bytes26] = ACTIONS(739),
    [anon_sym_bytes27] = ACTIONS(739),
    [anon_sym_bytes28] = ACTIONS(739),
    [anon_sym_bytes29] = ACTIONS(739),
    [anon_sym_bytes30] = ACTIONS(739),
    [anon_sym_bytes31] = ACTIONS(739),
    [anon_sym_bytes32] = ACTIONS(739),
    [anon_sym_fixed] = ACTIONS(739),
    [aux_sym__fixed_token1] = ACTIONS(739),
    [anon_sym_ufixed] = ACTIONS(739),
    [aux_sym__ufixed_token1] = ACTIONS(739),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(743),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_pragma] = ACTIONS(745),
    [anon_sym_import] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_abstract] = ACTIONS(745),
    [anon_sym_contract] = ACTIONS(745),
    [anon_sym_error] = ACTIONS(745),
    [anon_sym_interface] = ACTIONS(745),
    [anon_sym_library] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_function] = ACTIONS(745),
    [anon_sym_byte] = ACTIONS(745),
    [anon_sym_address] = ACTIONS(745),
    [anon_sym_var] = ACTIONS(745),
    [anon_sym_mapping] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_int8] = ACTIONS(745),
    [anon_sym_int16] = ACTIONS(745),
    [anon_sym_int24] = ACTIONS(745),
    [anon_sym_int32] = ACTIONS(745),
    [anon_sym_int40] = ACTIONS(745),
    [anon_sym_int48] = ACTIONS(745),
    [anon_sym_int56] = ACTIONS(745),
    [anon_sym_int64] = ACTIONS(745),
    [anon_sym_int72] = ACTIONS(745),
    [anon_sym_int80] = ACTIONS(745),
    [anon_sym_int88] = ACTIONS(745),
    [anon_sym_int96] = ACTIONS(745),
    [anon_sym_int104] = ACTIONS(745),
    [anon_sym_int112] = ACTIONS(745),
    [anon_sym_int120] = ACTIONS(745),
    [anon_sym_int128] = ACTIONS(745),
    [anon_sym_int136] = ACTIONS(745),
    [anon_sym_int144] = ACTIONS(745),
    [anon_sym_int152] = ACTIONS(745),
    [anon_sym_int160] = ACTIONS(745),
    [anon_sym_int168] = ACTIONS(745),
    [anon_sym_int176] = ACTIONS(745),
    [anon_sym_int184] = ACTIONS(745),
    [anon_sym_int192] = ACTIONS(745),
    [anon_sym_int200] = ACTIONS(745),
    [anon_sym_int208] = ACTIONS(745),
    [anon_sym_int216] = ACTIONS(745),
    [anon_sym_int224] = ACTIONS(745),
    [anon_sym_int232] = ACTIONS(745),
    [anon_sym_int240] = ACTIONS(745),
    [anon_sym_int248] = ACTIONS(745),
    [anon_sym_int256] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_uint8] = ACTIONS(745),
    [anon_sym_uint16] = ACTIONS(745),
    [anon_sym_uint24] = ACTIONS(745),
    [anon_sym_uint32] = ACTIONS(745),
    [anon_sym_uint40] = ACTIONS(745),
    [anon_sym_uint48] = ACTIONS(745),
    [anon_sym_uint56] = ACTIONS(745),
    [anon_sym_uint64] = ACTIONS(745),
    [anon_sym_uint72] = ACTIONS(745),
    [anon_sym_uint80] = ACTIONS(745),
    [anon_sym_uint88] = ACTIONS(745),
    [anon_sym_uint96] = ACTIONS(745),
    [anon_sym_uint104] = ACTIONS(745),
    [anon_sym_uint112] = ACTIONS(745),
    [anon_sym_uint120] = ACTIONS(745),
    [anon_sym_uint128] = ACTIONS(745),
    [anon_sym_uint136] = ACTIONS(745),
    [anon_sym_uint144] = ACTIONS(745),
    [anon_sym_uint152] = ACTIONS(745),
    [anon_sym_uint160] = ACTIONS(745),
    [anon_sym_uint168] = ACTIONS(745),
    [anon_sym_uint176] = ACTIONS(745),
    [anon_sym_uint184] = ACTIONS(745),
    [anon_sym_uint192] = ACTIONS(745),
    [anon_sym_uint200] = ACTIONS(745),
    [anon_sym_uint208] = ACTIONS(745),
    [anon_sym_uint216] = ACTIONS(745),
    [anon_sym_uint224] = ACTIONS(745),
    [anon_sym_uint232] = ACTIONS(745),
    [anon_sym_uint240] = ACTIONS(745),
    [anon_sym_uint248] = ACTIONS(745),
    [anon_sym_uint256] = ACTIONS(745),
    [anon_sym_bytes] = ACTIONS(745),
    [anon_sym_bytes1] = ACTIONS(745),
    [anon_sym_bytes2] = ACTIONS(745),
    [anon_sym_bytes3] = ACTIONS(745),
    [anon_sym_bytes4] = ACTIONS(745),
    [anon_sym_bytes5] = ACTIONS(745),
    [anon_sym_bytes6] = ACTIONS(745),
    [anon_sym_bytes7] = ACTIONS(745),
    [anon_sym_bytes8] = ACTIONS(745),
    [anon_sym_bytes9] = ACTIONS(745),
    [anon_sym_bytes10] = ACTIONS(745),
    [anon_sym_bytes11] = ACTIONS(745),
    [anon_sym_bytes12] = ACTIONS(745),
    [anon_sym_bytes13] = ACTIONS(745),
    [anon_sym_bytes14] = ACTIONS(745),
    [anon_sym_bytes15] = ACTIONS(745),
    [anon_sym_bytes16] = ACTIONS(745),
    [anon_sym_bytes17] = ACTIONS(745),
    [anon_sym_bytes18] = ACTIONS(745),
    [anon_sym_bytes19] = ACTIONS(745),
    [anon_sym_bytes20] = ACTIONS(745),
    [anon_sym_bytes21] = ACTIONS(745),
    [anon_sym_bytes22] = ACTIONS(745),
    [anon_sym_bytes23] = ACTIONS(745),
    [anon_sym_bytes24] = ACTIONS(745),
    [anon_sym_bytes25] = ACTIONS(745),
    [anon_sym_bytes26] = ACTIONS(745),
    [anon_sym_bytes27] = ACTIONS(745),
    [anon_sym_bytes28] = ACTIONS(745),
    [anon_sym_bytes29] = ACTIONS(745),
    [anon_sym_bytes30] = ACTIONS(745),
    [anon_sym_bytes31] = ACTIONS(745),
    [anon_sym_bytes32] = ACTIONS(745),
    [anon_sym_fixed] = ACTIONS(745),
    [aux_sym__fixed_token1] = ACTIONS(745),
    [anon_sym_ufixed] = ACTIONS(745),
    [aux_sym__ufixed_token1] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(677),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_pragma] = ACTIONS(675),
    [anon_sym_import] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_abstract] = ACTIONS(675),
    [anon_sym_contract] = ACTIONS(675),
    [anon_sym_error] = ACTIONS(675),
    [anon_sym_interface] = ACTIONS(675),
    [anon_sym_library] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(675),
    [anon_sym_byte] = ACTIONS(675),
    [anon_sym_address] = ACTIONS(675),
    [anon_sym_var] = ACTIONS(675),
    [anon_sym_mapping] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_string] = ACTIONS(675),
    [anon_sym_int] = ACTIONS(675),
    [anon_sym_int8] = ACTIONS(675),
    [anon_sym_int16] = ACTIONS(675),
    [anon_sym_int24] = ACTIONS(675),
    [anon_sym_int32] = ACTIONS(675),
    [anon_sym_int40] = ACTIONS(675),
    [anon_sym_int48] = ACTIONS(675),
    [anon_sym_int56] = ACTIONS(675),
    [anon_sym_int64] = ACTIONS(675),
    [anon_sym_int72] = ACTIONS(675),
    [anon_sym_int80] = ACTIONS(675),
    [anon_sym_int88] = ACTIONS(675),
    [anon_sym_int96] = ACTIONS(675),
    [anon_sym_int104] = ACTIONS(675),
    [anon_sym_int112] = ACTIONS(675),
    [anon_sym_int120] = ACTIONS(675),
    [anon_sym_int128] = ACTIONS(675),
    [anon_sym_int136] = ACTIONS(675),
    [anon_sym_int144] = ACTIONS(675),
    [anon_sym_int152] = ACTIONS(675),
    [anon_sym_int160] = ACTIONS(675),
    [anon_sym_int168] = ACTIONS(675),
    [anon_sym_int176] = ACTIONS(675),
    [anon_sym_int184] = ACTIONS(675),
    [anon_sym_int192] = ACTIONS(675),
    [anon_sym_int200] = ACTIONS(675),
    [anon_sym_int208] = ACTIONS(675),
    [anon_sym_int216] = ACTIONS(675),
    [anon_sym_int224] = ACTIONS(675),
    [anon_sym_int232] = ACTIONS(675),
    [anon_sym_int240] = ACTIONS(675),
    [anon_sym_int248] = ACTIONS(675),
    [anon_sym_int256] = ACTIONS(675),
    [anon_sym_uint] = ACTIONS(675),
    [anon_sym_uint8] = ACTIONS(675),
    [anon_sym_uint16] = ACTIONS(675),
    [anon_sym_uint24] = ACTIONS(675),
    [anon_sym_uint32] = ACTIONS(675),
    [anon_sym_uint40] = ACTIONS(675),
    [anon_sym_uint48] = ACTIONS(675),
    [anon_sym_uint56] = ACTIONS(675),
    [anon_sym_uint64] = ACTIONS(675),
    [anon_sym_uint72] = ACTIONS(675),
    [anon_sym_uint80] = ACTIONS(675),
    [anon_sym_uint88] = ACTIONS(675),
    [anon_sym_uint96] = ACTIONS(675),
    [anon_sym_uint104] = ACTIONS(675),
    [anon_sym_uint112] = ACTIONS(675),
    [anon_sym_uint120] = ACTIONS(675),
    [anon_sym_uint128] = ACTIONS(675),
    [anon_sym_uint136] = ACTIONS(675),
    [anon_sym_uint144] = ACTIONS(675),
    [anon_sym_uint152] = ACTIONS(675),
    [anon_sym_uint160] = ACTIONS(675),
    [anon_sym_uint168] = ACTIONS(675),
    [anon_sym_uint176] = ACTIONS(675),
    [anon_sym_uint184] = ACTIONS(675),
    [anon_sym_uint192] = ACTIONS(675),
    [anon_sym_uint200] = ACTIONS(675),
    [anon_sym_uint208] = ACTIONS(675),
    [anon_sym_uint216] = ACTIONS(675),
    [anon_sym_uint224] = ACTIONS(675),
    [anon_sym_uint232] = ACTIONS(675),
    [anon_sym_uint240] = ACTIONS(675),
    [anon_sym_uint248] = ACTIONS(675),
    [anon_sym_uint256] = ACTIONS(675),
    [anon_sym_bytes] = ACTIONS(675),
    [anon_sym_bytes1] = ACTIONS(675),
    [anon_sym_bytes2] = ACTIONS(675),
    [anon_sym_bytes3] = ACTIONS(675),
    [anon_sym_bytes4] = ACTIONS(675),
    [anon_sym_bytes5] = ACTIONS(675),
    [anon_sym_bytes6] = ACTIONS(675),
    [anon_sym_bytes7] = ACTIONS(675),
    [anon_sym_bytes8] = ACTIONS(675),
    [anon_sym_bytes9] = ACTIONS(675),
    [anon_sym_bytes10] = ACTIONS(675),
    [anon_sym_bytes11] = ACTIONS(675),
    [anon_sym_bytes12] = ACTIONS(675),
    [anon_sym_bytes13] = ACTIONS(675),
    [anon_sym_bytes14] = ACTIONS(675),
    [anon_sym_bytes15] = ACTIONS(675),
    [anon_sym_bytes16] = ACTIONS(675),
    [anon_sym_bytes17] = ACTIONS(675),
    [anon_sym_bytes18] = ACTIONS(675),
    [anon_sym_bytes19] = ACTIONS(675),
    [anon_sym_bytes20] = ACTIONS(675),
    [anon_sym_bytes21] = ACTIONS(675),
    [anon_sym_bytes22] = ACTIONS(675),
    [anon_sym_bytes23] = ACTIONS(675),
    [anon_sym_bytes24] = ACTIONS(675),
    [anon_sym_bytes25] = ACTIONS(675),
    [anon_sym_bytes26] = ACTIONS(675),
    [anon_sym_bytes27] = ACTIONS(675),
    [anon_sym_bytes28] = ACTIONS(675),
    [anon_sym_bytes29] = ACTIONS(675),
    [anon_sym_bytes30] = ACTIONS(675),
    [anon_sym_bytes31] = ACTIONS(675),
    [anon_sym_bytes32] = ACTIONS(675),
    [anon_sym_fixed] = ACTIONS(675),
    [aux_sym__fixed_token1] = ACTIONS(675),
    [anon_sym_ufixed] = ACTIONS(675),
    [aux_sym__ufixed_token1] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_identifier] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(645),
    [anon_sym_error] = ACTIONS(645),
    [anon_sym_struct] = ACTIONS(645),
    [anon_sym_enum] = ACTIONS(645),
    [anon_sym_event] = ACTIONS(645),
    [anon_sym_using] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(645),
    [anon_sym_byte] = ACTIONS(645),
    [anon_sym_address] = ACTIONS(645),
    [anon_sym_var] = ACTIONS(645),
    [anon_sym_modifier] = ACTIONS(645),
    [anon_sym_constructor] = ACTIONS(645),
    [anon_sym_fallback] = ACTIONS(645),
    [anon_sym_receive] = ACTIONS(645),
    [anon_sym_mapping] = ACTIONS(645),
    [anon_sym_bool] = ACTIONS(645),
    [anon_sym_string] = ACTIONS(645),
    [anon_sym_int] = ACTIONS(645),
    [anon_sym_int8] = ACTIONS(645),
    [anon_sym_int16] = ACTIONS(645),
    [anon_sym_int24] = ACTIONS(645),
    [anon_sym_int32] = ACTIONS(645),
    [anon_sym_int40] = ACTIONS(645),
    [anon_sym_int48] = ACTIONS(645),
    [anon_sym_int56] = ACTIONS(645),
    [anon_sym_int64] = ACTIONS(645),
    [anon_sym_int72] = ACTIONS(645),
    [anon_sym_int80] = ACTIONS(645),
    [anon_sym_int88] = ACTIONS(645),
    [anon_sym_int96] = ACTIONS(645),
    [anon_sym_int104] = ACTIONS(645),
    [anon_sym_int112] = ACTIONS(645),
    [anon_sym_int120] = ACTIONS(645),
    [anon_sym_int128] = ACTIONS(645),
    [anon_sym_int136] = ACTIONS(645),
    [anon_sym_int144] = ACTIONS(645),
    [anon_sym_int152] = ACTIONS(645),
    [anon_sym_int160] = ACTIONS(645),
    [anon_sym_int168] = ACTIONS(645),
    [anon_sym_int176] = ACTIONS(645),
    [anon_sym_int184] = ACTIONS(645),
    [anon_sym_int192] = ACTIONS(645),
    [anon_sym_int200] = ACTIONS(645),
    [anon_sym_int208] = ACTIONS(645),
    [anon_sym_int216] = ACTIONS(645),
    [anon_sym_int224] = ACTIONS(645),
    [anon_sym_int232] = ACTIONS(645),
    [anon_sym_int240] = ACTIONS(645),
    [anon_sym_int248] = ACTIONS(645),
    [anon_sym_int256] = ACTIONS(645),
    [anon_sym_uint] = ACTIONS(645),
    [anon_sym_uint8] = ACTIONS(645),
    [anon_sym_uint16] = ACTIONS(645),
    [anon_sym_uint24] = ACTIONS(645),
    [anon_sym_uint32] = ACTIONS(645),
    [anon_sym_uint40] = ACTIONS(645),
    [anon_sym_uint48] = ACTIONS(645),
    [anon_sym_uint56] = ACTIONS(645),
    [anon_sym_uint64] = ACTIONS(645),
    [anon_sym_uint72] = ACTIONS(645),
    [anon_sym_uint80] = ACTIONS(645),
    [anon_sym_uint88] = ACTIONS(645),
    [anon_sym_uint96] = ACTIONS(645),
    [anon_sym_uint104] = ACTIONS(645),
    [anon_sym_uint112] = ACTIONS(645),
    [anon_sym_uint120] = ACTIONS(645),
    [anon_sym_uint128] = ACTIONS(645),
    [anon_sym_uint136] = ACTIONS(645),
    [anon_sym_uint144] = ACTIONS(645),
    [anon_sym_uint152] = ACTIONS(645),
    [anon_sym_uint160] = ACTIONS(645),
    [anon_sym_uint168] = ACTIONS(645),
    [anon_sym_uint176] = ACTIONS(645),
    [anon_sym_uint184] = ACTIONS(645),
    [anon_sym_uint192] = ACTIONS(645),
    [anon_sym_uint200] = ACTIONS(645),
    [anon_sym_uint208] = ACTIONS(645),
    [anon_sym_uint216] = ACTIONS(645),
    [anon_sym_uint224] = ACTIONS(645),
    [anon_sym_uint232] = ACTIONS(645),
    [anon_sym_uint240] = ACTIONS(645),
    [anon_sym_uint248] = ACTIONS(645),
    [anon_sym_uint256] = ACTIONS(645),
    [anon_sym_bytes] = ACTIONS(645),
    [anon_sym_bytes1] = ACTIONS(645),
    [anon_sym_bytes2] = ACTIONS(645),
    [anon_sym_bytes3] = ACTIONS(645),
    [anon_sym_bytes4] = ACTIONS(645),
    [anon_sym_bytes5] = ACTIONS(645),
    [anon_sym_bytes6] = ACTIONS(645),
    [anon_sym_bytes7] = ACTIONS(645),
    [anon_sym_bytes8] = ACTIONS(645),
    [anon_sym_bytes9] = ACTIONS(645),
    [anon_sym_bytes10] = ACTIONS(645),
    [anon_sym_bytes11] = ACTIONS(645),
    [anon_sym_bytes12] = ACTIONS(645),
    [anon_sym_bytes13] = ACTIONS(645),
    [anon_sym_bytes14] = ACTIONS(645),
    [anon_sym_bytes15] = ACTIONS(645),
    [anon_sym_bytes16] = ACTIONS(645),
    [anon_sym_bytes17] = ACTIONS(645),
    [anon_sym_bytes18] = ACTIONS(645),
    [anon_sym_bytes19] = ACTIONS(645),
    [anon_sym_bytes20] = ACTIONS(645),
    [anon_sym_bytes21] = ACTIONS(645),
    [anon_sym_bytes22] = ACTIONS(645),
    [anon_sym_bytes23] = ACTIONS(645),
    [anon_sym_bytes24] = ACTIONS(645),
    [anon_sym_bytes25] = ACTIONS(645),
    [anon_sym_bytes26] = ACTIONS(645),
    [anon_sym_bytes27] = ACTIONS(645),
    [anon_sym_bytes28] = ACTIONS(645),
    [anon_sym_bytes29] = ACTIONS(645),
    [anon_sym_bytes30] = ACTIONS(645),
    [anon_sym_bytes31] = ACTIONS(645),
    [anon_sym_bytes32] = ACTIONS(645),
    [anon_sym_fixed] = ACTIONS(645),
    [aux_sym__fixed_token1] = ACTIONS(645),
    [anon_sym_ufixed] = ACTIONS(645),
    [aux_sym__ufixed_token1] = ACTIONS(645),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_identifier] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_type] = ACTIONS(747),
    [anon_sym_error] = ACTIONS(747),
    [anon_sym_struct] = ACTIONS(747),
    [anon_sym_enum] = ACTIONS(747),
    [anon_sym_event] = ACTIONS(747),
    [anon_sym_using] = ACTIONS(747),
    [anon_sym_function] = ACTIONS(747),
    [anon_sym_byte] = ACTIONS(747),
    [anon_sym_address] = ACTIONS(747),
    [anon_sym_var] = ACTIONS(747),
    [anon_sym_modifier] = ACTIONS(747),
    [anon_sym_constructor] = ACTIONS(747),
    [anon_sym_fallback] = ACTIONS(747),
    [anon_sym_receive] = ACTIONS(747),
    [anon_sym_mapping] = ACTIONS(747),
    [anon_sym_bool] = ACTIONS(747),
    [anon_sym_string] = ACTIONS(747),
    [anon_sym_int] = ACTIONS(747),
    [anon_sym_int8] = ACTIONS(747),
    [anon_sym_int16] = ACTIONS(747),
    [anon_sym_int24] = ACTIONS(747),
    [anon_sym_int32] = ACTIONS(747),
    [anon_sym_int40] = ACTIONS(747),
    [anon_sym_int48] = ACTIONS(747),
    [anon_sym_int56] = ACTIONS(747),
    [anon_sym_int64] = ACTIONS(747),
    [anon_sym_int72] = ACTIONS(747),
    [anon_sym_int80] = ACTIONS(747),
    [anon_sym_int88] = ACTIONS(747),
    [anon_sym_int96] = ACTIONS(747),
    [anon_sym_int104] = ACTIONS(747),
    [anon_sym_int112] = ACTIONS(747),
    [anon_sym_int120] = ACTIONS(747),
    [anon_sym_int128] = ACTIONS(747),
    [anon_sym_int136] = ACTIONS(747),
    [anon_sym_int144] = ACTIONS(747),
    [anon_sym_int152] = ACTIONS(747),
    [anon_sym_int160] = ACTIONS(747),
    [anon_sym_int168] = ACTIONS(747),
    [anon_sym_int176] = ACTIONS(747),
    [anon_sym_int184] = ACTIONS(747),
    [anon_sym_int192] = ACTIONS(747),
    [anon_sym_int200] = ACTIONS(747),
    [anon_sym_int208] = ACTIONS(747),
    [anon_sym_int216] = ACTIONS(747),
    [anon_sym_int224] = ACTIONS(747),
    [anon_sym_int232] = ACTIONS(747),
    [anon_sym_int240] = ACTIONS(747),
    [anon_sym_int248] = ACTIONS(747),
    [anon_sym_int256] = ACTIONS(747),
    [anon_sym_uint] = ACTIONS(747),
    [anon_sym_uint8] = ACTIONS(747),
    [anon_sym_uint16] = ACTIONS(747),
    [anon_sym_uint24] = ACTIONS(747),
    [anon_sym_uint32] = ACTIONS(747),
    [anon_sym_uint40] = ACTIONS(747),
    [anon_sym_uint48] = ACTIONS(747),
    [anon_sym_uint56] = ACTIONS(747),
    [anon_sym_uint64] = ACTIONS(747),
    [anon_sym_uint72] = ACTIONS(747),
    [anon_sym_uint80] = ACTIONS(747),
    [anon_sym_uint88] = ACTIONS(747),
    [anon_sym_uint96] = ACTIONS(747),
    [anon_sym_uint104] = ACTIONS(747),
    [anon_sym_uint112] = ACTIONS(747),
    [anon_sym_uint120] = ACTIONS(747),
    [anon_sym_uint128] = ACTIONS(747),
    [anon_sym_uint136] = ACTIONS(747),
    [anon_sym_uint144] = ACTIONS(747),
    [anon_sym_uint152] = ACTIONS(747),
    [anon_sym_uint160] = ACTIONS(747),
    [anon_sym_uint168] = ACTIONS(747),
    [anon_sym_uint176] = ACTIONS(747),
    [anon_sym_uint184] = ACTIONS(747),
    [anon_sym_uint192] = ACTIONS(747),
    [anon_sym_uint200] = ACTIONS(747),
    [anon_sym_uint208] = ACTIONS(747),
    [anon_sym_uint216] = ACTIONS(747),
    [anon_sym_uint224] = ACTIONS(747),
    [anon_sym_uint232] = ACTIONS(747),
    [anon_sym_uint240] = ACTIONS(747),
    [anon_sym_uint248] = ACTIONS(747),
    [anon_sym_uint256] = ACTIONS(747),
    [anon_sym_bytes] = ACTIONS(747),
    [anon_sym_bytes1] = ACTIONS(747),
    [anon_sym_bytes2] = ACTIONS(747),
    [anon_sym_bytes3] = ACTIONS(747),
    [anon_sym_bytes4] = ACTIONS(747),
    [anon_sym_bytes5] = ACTIONS(747),
    [anon_sym_bytes6] = ACTIONS(747),
    [anon_sym_bytes7] = ACTIONS(747),
    [anon_sym_bytes8] = ACTIONS(747),
    [anon_sym_bytes9] = ACTIONS(747),
    [anon_sym_bytes10] = ACTIONS(747),
    [anon_sym_bytes11] = ACTIONS(747),
    [anon_sym_bytes12] = ACTIONS(747),
    [anon_sym_bytes13] = ACTIONS(747),
    [anon_sym_bytes14] = ACTIONS(747),
    [anon_sym_bytes15] = ACTIONS(747),
    [anon_sym_bytes16] = ACTIONS(747),
    [anon_sym_bytes17] = ACTIONS(747),
    [anon_sym_bytes18] = ACTIONS(747),
    [anon_sym_bytes19] = ACTIONS(747),
    [anon_sym_bytes20] = ACTIONS(747),
    [anon_sym_bytes21] = ACTIONS(747),
    [anon_sym_bytes22] = ACTIONS(747),
    [anon_sym_bytes23] = ACTIONS(747),
    [anon_sym_bytes24] = ACTIONS(747),
    [anon_sym_bytes25] = ACTIONS(747),
    [anon_sym_bytes26] = ACTIONS(747),
    [anon_sym_bytes27] = ACTIONS(747),
    [anon_sym_bytes28] = ACTIONS(747),
    [anon_sym_bytes29] = ACTIONS(747),
    [anon_sym_bytes30] = ACTIONS(747),
    [anon_sym_bytes31] = ACTIONS(747),
    [anon_sym_bytes32] = ACTIONS(747),
    [anon_sym_fixed] = ACTIONS(747),
    [aux_sym__fixed_token1] = ACTIONS(747),
    [anon_sym_ufixed] = ACTIONS(747),
    [aux_sym__ufixed_token1] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_error] = ACTIONS(751),
    [anon_sym_struct] = ACTIONS(751),
    [anon_sym_enum] = ACTIONS(751),
    [anon_sym_event] = ACTIONS(751),
    [anon_sym_using] = ACTIONS(751),
    [anon_sym_function] = ACTIONS(751),
    [anon_sym_byte] = ACTIONS(751),
    [anon_sym_address] = ACTIONS(751),
    [anon_sym_var] = ACTIONS(751),
    [anon_sym_modifier] = ACTIONS(751),
    [anon_sym_constructor] = ACTIONS(751),
    [anon_sym_fallback] = ACTIONS(751),
    [anon_sym_receive] = ACTIONS(751),
    [anon_sym_mapping] = ACTIONS(751),
    [anon_sym_bool] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_int] = ACTIONS(751),
    [anon_sym_int8] = ACTIONS(751),
    [anon_sym_int16] = ACTIONS(751),
    [anon_sym_int24] = ACTIONS(751),
    [anon_sym_int32] = ACTIONS(751),
    [anon_sym_int40] = ACTIONS(751),
    [anon_sym_int48] = ACTIONS(751),
    [anon_sym_int56] = ACTIONS(751),
    [anon_sym_int64] = ACTIONS(751),
    [anon_sym_int72] = ACTIONS(751),
    [anon_sym_int80] = ACTIONS(751),
    [anon_sym_int88] = ACTIONS(751),
    [anon_sym_int96] = ACTIONS(751),
    [anon_sym_int104] = ACTIONS(751),
    [anon_sym_int112] = ACTIONS(751),
    [anon_sym_int120] = ACTIONS(751),
    [anon_sym_int128] = ACTIONS(751),
    [anon_sym_int136] = ACTIONS(751),
    [anon_sym_int144] = ACTIONS(751),
    [anon_sym_int152] = ACTIONS(751),
    [anon_sym_int160] = ACTIONS(751),
    [anon_sym_int168] = ACTIONS(751),
    [anon_sym_int176] = ACTIONS(751),
    [anon_sym_int184] = ACTIONS(751),
    [anon_sym_int192] = ACTIONS(751),
    [anon_sym_int200] = ACTIONS(751),
    [anon_sym_int208] = ACTIONS(751),
    [anon_sym_int216] = ACTIONS(751),
    [anon_sym_int224] = ACTIONS(751),
    [anon_sym_int232] = ACTIONS(751),
    [anon_sym_int240] = ACTIONS(751),
    [anon_sym_int248] = ACTIONS(751),
    [anon_sym_int256] = ACTIONS(751),
    [anon_sym_uint] = ACTIONS(751),
    [anon_sym_uint8] = ACTIONS(751),
    [anon_sym_uint16] = ACTIONS(751),
    [anon_sym_uint24] = ACTIONS(751),
    [anon_sym_uint32] = ACTIONS(751),
    [anon_sym_uint40] = ACTIONS(751),
    [anon_sym_uint48] = ACTIONS(751),
    [anon_sym_uint56] = ACTIONS(751),
    [anon_sym_uint64] = ACTIONS(751),
    [anon_sym_uint72] = ACTIONS(751),
    [anon_sym_uint80] = ACTIONS(751),
    [anon_sym_uint88] = ACTIONS(751),
    [anon_sym_uint96] = ACTIONS(751),
    [anon_sym_uint104] = ACTIONS(751),
    [anon_sym_uint112] = ACTIONS(751),
    [anon_sym_uint120] = ACTIONS(751),
    [anon_sym_uint128] = ACTIONS(751),
    [anon_sym_uint136] = ACTIONS(751),
    [anon_sym_uint144] = ACTIONS(751),
    [anon_sym_uint152] = ACTIONS(751),
    [anon_sym_uint160] = ACTIONS(751),
    [anon_sym_uint168] = ACTIONS(751),
    [anon_sym_uint176] = ACTIONS(751),
    [anon_sym_uint184] = ACTIONS(751),
    [anon_sym_uint192] = ACTIONS(751),
    [anon_sym_uint200] = ACTIONS(751),
    [anon_sym_uint208] = ACTIONS(751),
    [anon_sym_uint216] = ACTIONS(751),
    [anon_sym_uint224] = ACTIONS(751),
    [anon_sym_uint232] = ACTIONS(751),
    [anon_sym_uint240] = ACTIONS(751),
    [anon_sym_uint248] = ACTIONS(751),
    [anon_sym_uint256] = ACTIONS(751),
    [anon_sym_bytes] = ACTIONS(751),
    [anon_sym_bytes1] = ACTIONS(751),
    [anon_sym_bytes2] = ACTIONS(751),
    [anon_sym_bytes3] = ACTIONS(751),
    [anon_sym_bytes4] = ACTIONS(751),
    [anon_sym_bytes5] = ACTIONS(751),
    [anon_sym_bytes6] = ACTIONS(751),
    [anon_sym_bytes7] = ACTIONS(751),
    [anon_sym_bytes8] = ACTIONS(751),
    [anon_sym_bytes9] = ACTIONS(751),
    [anon_sym_bytes10] = ACTIONS(751),
    [anon_sym_bytes11] = ACTIONS(751),
    [anon_sym_bytes12] = ACTIONS(751),
    [anon_sym_bytes13] = ACTIONS(751),
    [anon_sym_bytes14] = ACTIONS(751),
    [anon_sym_bytes15] = ACTIONS(751),
    [anon_sym_bytes16] = ACTIONS(751),
    [anon_sym_bytes17] = ACTIONS(751),
    [anon_sym_bytes18] = ACTIONS(751),
    [anon_sym_bytes19] = ACTIONS(751),
    [anon_sym_bytes20] = ACTIONS(751),
    [anon_sym_bytes21] = ACTIONS(751),
    [anon_sym_bytes22] = ACTIONS(751),
    [anon_sym_bytes23] = ACTIONS(751),
    [anon_sym_bytes24] = ACTIONS(751),
    [anon_sym_bytes25] = ACTIONS(751),
    [anon_sym_bytes26] = ACTIONS(751),
    [anon_sym_bytes27] = ACTIONS(751),
    [anon_sym_bytes28] = ACTIONS(751),
    [anon_sym_bytes29] = ACTIONS(751),
    [anon_sym_bytes30] = ACTIONS(751),
    [anon_sym_bytes31] = ACTIONS(751),
    [anon_sym_bytes32] = ACTIONS(751),
    [anon_sym_fixed] = ACTIONS(751),
    [aux_sym__fixed_token1] = ACTIONS(751),
    [anon_sym_ufixed] = ACTIONS(751),
    [aux_sym__ufixed_token1] = ACTIONS(751),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(755),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_pragma] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_abstract] = ACTIONS(757),
    [anon_sym_contract] = ACTIONS(757),
    [anon_sym_error] = ACTIONS(757),
    [anon_sym_interface] = ACTIONS(757),
    [anon_sym_library] = ACTIONS(757),
    [anon_sym_struct] = ACTIONS(757),
    [anon_sym_enum] = ACTIONS(757),
    [anon_sym_function] = ACTIONS(757),
    [anon_sym_byte] = ACTIONS(757),
    [anon_sym_address] = ACTIONS(757),
    [anon_sym_var] = ACTIONS(757),
    [anon_sym_mapping] = ACTIONS(757),
    [anon_sym_bool] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_int] = ACTIONS(757),
    [anon_sym_int8] = ACTIONS(757),
    [anon_sym_int16] = ACTIONS(757),
    [anon_sym_int24] = ACTIONS(757),
    [anon_sym_int32] = ACTIONS(757),
    [anon_sym_int40] = ACTIONS(757),
    [anon_sym_int48] = ACTIONS(757),
    [anon_sym_int56] = ACTIONS(757),
    [anon_sym_int64] = ACTIONS(757),
    [anon_sym_int72] = ACTIONS(757),
    [anon_sym_int80] = ACTIONS(757),
    [anon_sym_int88] = ACTIONS(757),
    [anon_sym_int96] = ACTIONS(757),
    [anon_sym_int104] = ACTIONS(757),
    [anon_sym_int112] = ACTIONS(757),
    [anon_sym_int120] = ACTIONS(757),
    [anon_sym_int128] = ACTIONS(757),
    [anon_sym_int136] = ACTIONS(757),
    [anon_sym_int144] = ACTIONS(757),
    [anon_sym_int152] = ACTIONS(757),
    [anon_sym_int160] = ACTIONS(757),
    [anon_sym_int168] = ACTIONS(757),
    [anon_sym_int176] = ACTIONS(757),
    [anon_sym_int184] = ACTIONS(757),
    [anon_sym_int192] = ACTIONS(757),
    [anon_sym_int200] = ACTIONS(757),
    [anon_sym_int208] = ACTIONS(757),
    [anon_sym_int216] = ACTIONS(757),
    [anon_sym_int224] = ACTIONS(757),
    [anon_sym_int232] = ACTIONS(757),
    [anon_sym_int240] = ACTIONS(757),
    [anon_sym_int248] = ACTIONS(757),
    [anon_sym_int256] = ACTIONS(757),
    [anon_sym_uint] = ACTIONS(757),
    [anon_sym_uint8] = ACTIONS(757),
    [anon_sym_uint16] = ACTIONS(757),
    [anon_sym_uint24] = ACTIONS(757),
    [anon_sym_uint32] = ACTIONS(757),
    [anon_sym_uint40] = ACTIONS(757),
    [anon_sym_uint48] = ACTIONS(757),
    [anon_sym_uint56] = ACTIONS(757),
    [anon_sym_uint64] = ACTIONS(757),
    [anon_sym_uint72] = ACTIONS(757),
    [anon_sym_uint80] = ACTIONS(757),
    [anon_sym_uint88] = ACTIONS(757),
    [anon_sym_uint96] = ACTIONS(757),
    [anon_sym_uint104] = ACTIONS(757),
    [anon_sym_uint112] = ACTIONS(757),
    [anon_sym_uint120] = ACTIONS(757),
    [anon_sym_uint128] = ACTIONS(757),
    [anon_sym_uint136] = ACTIONS(757),
    [anon_sym_uint144] = ACTIONS(757),
    [anon_sym_uint152] = ACTIONS(757),
    [anon_sym_uint160] = ACTIONS(757),
    [anon_sym_uint168] = ACTIONS(757),
    [anon_sym_uint176] = ACTIONS(757),
    [anon_sym_uint184] = ACTIONS(757),
    [anon_sym_uint192] = ACTIONS(757),
    [anon_sym_uint200] = ACTIONS(757),
    [anon_sym_uint208] = ACTIONS(757),
    [anon_sym_uint216] = ACTIONS(757),
    [anon_sym_uint224] = ACTIONS(757),
    [anon_sym_uint232] = ACTIONS(757),
    [anon_sym_uint240] = ACTIONS(757),
    [anon_sym_uint248] = ACTIONS(757),
    [anon_sym_uint256] = ACTIONS(757),
    [anon_sym_bytes] = ACTIONS(757),
    [anon_sym_bytes1] = ACTIONS(757),
    [anon_sym_bytes2] = ACTIONS(757),
    [anon_sym_bytes3] = ACTIONS(757),
    [anon_sym_bytes4] = ACTIONS(757),
    [anon_sym_bytes5] = ACTIONS(757),
    [anon_sym_bytes6] = ACTIONS(757),
    [anon_sym_bytes7] = ACTIONS(757),
    [anon_sym_bytes8] = ACTIONS(757),
    [anon_sym_bytes9] = ACTIONS(757),
    [anon_sym_bytes10] = ACTIONS(757),
    [anon_sym_bytes11] = ACTIONS(757),
    [anon_sym_bytes12] = ACTIONS(757),
    [anon_sym_bytes13] = ACTIONS(757),
    [anon_sym_bytes14] = ACTIONS(757),
    [anon_sym_bytes15] = ACTIONS(757),
    [anon_sym_bytes16] = ACTIONS(757),
    [anon_sym_bytes17] = ACTIONS(757),
    [anon_sym_bytes18] = ACTIONS(757),
    [anon_sym_bytes19] = ACTIONS(757),
    [anon_sym_bytes20] = ACTIONS(757),
    [anon_sym_bytes21] = ACTIONS(757),
    [anon_sym_bytes22] = ACTIONS(757),
    [anon_sym_bytes23] = ACTIONS(757),
    [anon_sym_bytes24] = ACTIONS(757),
    [anon_sym_bytes25] = ACTIONS(757),
    [anon_sym_bytes26] = ACTIONS(757),
    [anon_sym_bytes27] = ACTIONS(757),
    [anon_sym_bytes28] = ACTIONS(757),
    [anon_sym_bytes29] = ACTIONS(757),
    [anon_sym_bytes30] = ACTIONS(757),
    [anon_sym_bytes31] = ACTIONS(757),
    [anon_sym_bytes32] = ACTIONS(757),
    [anon_sym_fixed] = ACTIONS(757),
    [aux_sym__fixed_token1] = ACTIONS(757),
    [anon_sym_ufixed] = ACTIONS(757),
    [aux_sym__ufixed_token1] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(733),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_pragma] = ACTIONS(731),
    [anon_sym_import] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_abstract] = ACTIONS(731),
    [anon_sym_contract] = ACTIONS(731),
    [anon_sym_error] = ACTIONS(731),
    [anon_sym_interface] = ACTIONS(731),
    [anon_sym_library] = ACTIONS(731),
    [anon_sym_struct] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_byte] = ACTIONS(731),
    [anon_sym_address] = ACTIONS(731),
    [anon_sym_var] = ACTIONS(731),
    [anon_sym_mapping] = ACTIONS(731),
    [anon_sym_bool] = ACTIONS(731),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_int] = ACTIONS(731),
    [anon_sym_int8] = ACTIONS(731),
    [anon_sym_int16] = ACTIONS(731),
    [anon_sym_int24] = ACTIONS(731),
    [anon_sym_int32] = ACTIONS(731),
    [anon_sym_int40] = ACTIONS(731),
    [anon_sym_int48] = ACTIONS(731),
    [anon_sym_int56] = ACTIONS(731),
    [anon_sym_int64] = ACTIONS(731),
    [anon_sym_int72] = ACTIONS(731),
    [anon_sym_int80] = ACTIONS(731),
    [anon_sym_int88] = ACTIONS(731),
    [anon_sym_int96] = ACTIONS(731),
    [anon_sym_int104] = ACTIONS(731),
    [anon_sym_int112] = ACTIONS(731),
    [anon_sym_int120] = ACTIONS(731),
    [anon_sym_int128] = ACTIONS(731),
    [anon_sym_int136] = ACTIONS(731),
    [anon_sym_int144] = ACTIONS(731),
    [anon_sym_int152] = ACTIONS(731),
    [anon_sym_int160] = ACTIONS(731),
    [anon_sym_int168] = ACTIONS(731),
    [anon_sym_int176] = ACTIONS(731),
    [anon_sym_int184] = ACTIONS(731),
    [anon_sym_int192] = ACTIONS(731),
    [anon_sym_int200] = ACTIONS(731),
    [anon_sym_int208] = ACTIONS(731),
    [anon_sym_int216] = ACTIONS(731),
    [anon_sym_int224] = ACTIONS(731),
    [anon_sym_int232] = ACTIONS(731),
    [anon_sym_int240] = ACTIONS(731),
    [anon_sym_int248] = ACTIONS(731),
    [anon_sym_int256] = ACTIONS(731),
    [anon_sym_uint] = ACTIONS(731),
    [anon_sym_uint8] = ACTIONS(731),
    [anon_sym_uint16] = ACTIONS(731),
    [anon_sym_uint24] = ACTIONS(731),
    [anon_sym_uint32] = ACTIONS(731),
    [anon_sym_uint40] = ACTIONS(731),
    [anon_sym_uint48] = ACTIONS(731),
    [anon_sym_uint56] = ACTIONS(731),
    [anon_sym_uint64] = ACTIONS(731),
    [anon_sym_uint72] = ACTIONS(731),
    [anon_sym_uint80] = ACTIONS(731),
    [anon_sym_uint88] = ACTIONS(731),
    [anon_sym_uint96] = ACTIONS(731),
    [anon_sym_uint104] = ACTIONS(731),
    [anon_sym_uint112] = ACTIONS(731),
    [anon_sym_uint120] = ACTIONS(731),
    [anon_sym_uint128] = ACTIONS(731),
    [anon_sym_uint136] = ACTIONS(731),
    [anon_sym_uint144] = ACTIONS(731),
    [anon_sym_uint152] = ACTIONS(731),
    [anon_sym_uint160] = ACTIONS(731),
    [anon_sym_uint168] = ACTIONS(731),
    [anon_sym_uint176] = ACTIONS(731),
    [anon_sym_uint184] = ACTIONS(731),
    [anon_sym_uint192] = ACTIONS(731),
    [anon_sym_uint200] = ACTIONS(731),
    [anon_sym_uint208] = ACTIONS(731),
    [anon_sym_uint216] = ACTIONS(731),
    [anon_sym_uint224] = ACTIONS(731),
    [anon_sym_uint232] = ACTIONS(731),
    [anon_sym_uint240] = ACTIONS(731),
    [anon_sym_uint248] = ACTIONS(731),
    [anon_sym_uint256] = ACTIONS(731),
    [anon_sym_bytes] = ACTIONS(731),
    [anon_sym_bytes1] = ACTIONS(731),
    [anon_sym_bytes2] = ACTIONS(731),
    [anon_sym_bytes3] = ACTIONS(731),
    [anon_sym_bytes4] = ACTIONS(731),
    [anon_sym_bytes5] = ACTIONS(731),
    [anon_sym_bytes6] = ACTIONS(731),
    [anon_sym_bytes7] = ACTIONS(731),
    [anon_sym_bytes8] = ACTIONS(731),
    [anon_sym_bytes9] = ACTIONS(731),
    [anon_sym_bytes10] = ACTIONS(731),
    [anon_sym_bytes11] = ACTIONS(731),
    [anon_sym_bytes12] = ACTIONS(731),
    [anon_sym_bytes13] = ACTIONS(731),
    [anon_sym_bytes14] = ACTIONS(731),
    [anon_sym_bytes15] = ACTIONS(731),
    [anon_sym_bytes16] = ACTIONS(731),
    [anon_sym_bytes17] = ACTIONS(731),
    [anon_sym_bytes18] = ACTIONS(731),
    [anon_sym_bytes19] = ACTIONS(731),
    [anon_sym_bytes20] = ACTIONS(731),
    [anon_sym_bytes21] = ACTIONS(731),
    [anon_sym_bytes22] = ACTIONS(731),
    [anon_sym_bytes23] = ACTIONS(731),
    [anon_sym_bytes24] = ACTIONS(731),
    [anon_sym_bytes25] = ACTIONS(731),
    [anon_sym_bytes26] = ACTIONS(731),
    [anon_sym_bytes27] = ACTIONS(731),
    [anon_sym_bytes28] = ACTIONS(731),
    [anon_sym_bytes29] = ACTIONS(731),
    [anon_sym_bytes30] = ACTIONS(731),
    [anon_sym_bytes31] = ACTIONS(731),
    [anon_sym_bytes32] = ACTIONS(731),
    [anon_sym_fixed] = ACTIONS(731),
    [aux_sym__fixed_token1] = ACTIONS(731),
    [anon_sym_ufixed] = ACTIONS(731),
    [aux_sym__ufixed_token1] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_identifier] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_type] = ACTIONS(759),
    [anon_sym_error] = ACTIONS(759),
    [anon_sym_struct] = ACTIONS(759),
    [anon_sym_enum] = ACTIONS(759),
    [anon_sym_event] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(759),
    [anon_sym_function] = ACTIONS(759),
    [anon_sym_byte] = ACTIONS(759),
    [anon_sym_address] = ACTIONS(759),
    [anon_sym_var] = ACTIONS(759),
    [anon_sym_modifier] = ACTIONS(759),
    [anon_sym_constructor] = ACTIONS(759),
    [anon_sym_fallback] = ACTIONS(759),
    [anon_sym_receive] = ACTIONS(759),
    [anon_sym_mapping] = ACTIONS(759),
    [anon_sym_bool] = ACTIONS(759),
    [anon_sym_string] = ACTIONS(759),
    [anon_sym_int] = ACTIONS(759),
    [anon_sym_int8] = ACTIONS(759),
    [anon_sym_int16] = ACTIONS(759),
    [anon_sym_int24] = ACTIONS(759),
    [anon_sym_int32] = ACTIONS(759),
    [anon_sym_int40] = ACTIONS(759),
    [anon_sym_int48] = ACTIONS(759),
    [anon_sym_int56] = ACTIONS(759),
    [anon_sym_int64] = ACTIONS(759),
    [anon_sym_int72] = ACTIONS(759),
    [anon_sym_int80] = ACTIONS(759),
    [anon_sym_int88] = ACTIONS(759),
    [anon_sym_int96] = ACTIONS(759),
    [anon_sym_int104] = ACTIONS(759),
    [anon_sym_int112] = ACTIONS(759),
    [anon_sym_int120] = ACTIONS(759),
    [anon_sym_int128] = ACTIONS(759),
    [anon_sym_int136] = ACTIONS(759),
    [anon_sym_int144] = ACTIONS(759),
    [anon_sym_int152] = ACTIONS(759),
    [anon_sym_int160] = ACTIONS(759),
    [anon_sym_int168] = ACTIONS(759),
    [anon_sym_int176] = ACTIONS(759),
    [anon_sym_int184] = ACTIONS(759),
    [anon_sym_int192] = ACTIONS(759),
    [anon_sym_int200] = ACTIONS(759),
    [anon_sym_int208] = ACTIONS(759),
    [anon_sym_int216] = ACTIONS(759),
    [anon_sym_int224] = ACTIONS(759),
    [anon_sym_int232] = ACTIONS(759),
    [anon_sym_int240] = ACTIONS(759),
    [anon_sym_int248] = ACTIONS(759),
    [anon_sym_int256] = ACTIONS(759),
    [anon_sym_uint] = ACTIONS(759),
    [anon_sym_uint8] = ACTIONS(759),
    [anon_sym_uint16] = ACTIONS(759),
    [anon_sym_uint24] = ACTIONS(759),
    [anon_sym_uint32] = ACTIONS(759),
    [anon_sym_uint40] = ACTIONS(759),
    [anon_sym_uint48] = ACTIONS(759),
    [anon_sym_uint56] = ACTIONS(759),
    [anon_sym_uint64] = ACTIONS(759),
    [anon_sym_uint72] = ACTIONS(759),
    [anon_sym_uint80] = ACTIONS(759),
    [anon_sym_uint88] = ACTIONS(759),
    [anon_sym_uint96] = ACTIONS(759),
    [anon_sym_uint104] = ACTIONS(759),
    [anon_sym_uint112] = ACTIONS(759),
    [anon_sym_uint120] = ACTIONS(759),
    [anon_sym_uint128] = ACTIONS(759),
    [anon_sym_uint136] = ACTIONS(759),
    [anon_sym_uint144] = ACTIONS(759),
    [anon_sym_uint152] = ACTIONS(759),
    [anon_sym_uint160] = ACTIONS(759),
    [anon_sym_uint168] = ACTIONS(759),
    [anon_sym_uint176] = ACTIONS(759),
    [anon_sym_uint184] = ACTIONS(759),
    [anon_sym_uint192] = ACTIONS(759),
    [anon_sym_uint200] = ACTIONS(759),
    [anon_sym_uint208] = ACTIONS(759),
    [anon_sym_uint216] = ACTIONS(759),
    [anon_sym_uint224] = ACTIONS(759),
    [anon_sym_uint232] = ACTIONS(759),
    [anon_sym_uint240] = ACTIONS(759),
    [anon_sym_uint248] = ACTIONS(759),
    [anon_sym_uint256] = ACTIONS(759),
    [anon_sym_bytes] = ACTIONS(759),
    [anon_sym_bytes1] = ACTIONS(759),
    [anon_sym_bytes2] = ACTIONS(759),
    [anon_sym_bytes3] = ACTIONS(759),
    [anon_sym_bytes4] = ACTIONS(759),
    [anon_sym_bytes5] = ACTIONS(759),
    [anon_sym_bytes6] = ACTIONS(759),
    [anon_sym_bytes7] = ACTIONS(759),
    [anon_sym_bytes8] = ACTIONS(759),
    [anon_sym_bytes9] = ACTIONS(759),
    [anon_sym_bytes10] = ACTIONS(759),
    [anon_sym_bytes11] = ACTIONS(759),
    [anon_sym_bytes12] = ACTIONS(759),
    [anon_sym_bytes13] = ACTIONS(759),
    [anon_sym_bytes14] = ACTIONS(759),
    [anon_sym_bytes15] = ACTIONS(759),
    [anon_sym_bytes16] = ACTIONS(759),
    [anon_sym_bytes17] = ACTIONS(759),
    [anon_sym_bytes18] = ACTIONS(759),
    [anon_sym_bytes19] = ACTIONS(759),
    [anon_sym_bytes20] = ACTIONS(759),
    [anon_sym_bytes21] = ACTIONS(759),
    [anon_sym_bytes22] = ACTIONS(759),
    [anon_sym_bytes23] = ACTIONS(759),
    [anon_sym_bytes24] = ACTIONS(759),
    [anon_sym_bytes25] = ACTIONS(759),
    [anon_sym_bytes26] = ACTIONS(759),
    [anon_sym_bytes27] = ACTIONS(759),
    [anon_sym_bytes28] = ACTIONS(759),
    [anon_sym_bytes29] = ACTIONS(759),
    [anon_sym_bytes30] = ACTIONS(759),
    [anon_sym_bytes31] = ACTIONS(759),
    [anon_sym_bytes32] = ACTIONS(759),
    [anon_sym_fixed] = ACTIONS(759),
    [aux_sym__fixed_token1] = ACTIONS(759),
    [anon_sym_ufixed] = ACTIONS(759),
    [aux_sym__ufixed_token1] = ACTIONS(759),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(763),
    [sym_identifier] = ACTIONS(765),
    [anon_sym_pragma] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(765),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_abstract] = ACTIONS(765),
    [anon_sym_contract] = ACTIONS(765),
    [anon_sym_error] = ACTIONS(765),
    [anon_sym_interface] = ACTIONS(765),
    [anon_sym_library] = ACTIONS(765),
    [anon_sym_struct] = ACTIONS(765),
    [anon_sym_enum] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_byte] = ACTIONS(765),
    [anon_sym_address] = ACTIONS(765),
    [anon_sym_var] = ACTIONS(765),
    [anon_sym_mapping] = ACTIONS(765),
    [anon_sym_bool] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_int] = ACTIONS(765),
    [anon_sym_int8] = ACTIONS(765),
    [anon_sym_int16] = ACTIONS(765),
    [anon_sym_int24] = ACTIONS(765),
    [anon_sym_int32] = ACTIONS(765),
    [anon_sym_int40] = ACTIONS(765),
    [anon_sym_int48] = ACTIONS(765),
    [anon_sym_int56] = ACTIONS(765),
    [anon_sym_int64] = ACTIONS(765),
    [anon_sym_int72] = ACTIONS(765),
    [anon_sym_int80] = ACTIONS(765),
    [anon_sym_int88] = ACTIONS(765),
    [anon_sym_int96] = ACTIONS(765),
    [anon_sym_int104] = ACTIONS(765),
    [anon_sym_int112] = ACTIONS(765),
    [anon_sym_int120] = ACTIONS(765),
    [anon_sym_int128] = ACTIONS(765),
    [anon_sym_int136] = ACTIONS(765),
    [anon_sym_int144] = ACTIONS(765),
    [anon_sym_int152] = ACTIONS(765),
    [anon_sym_int160] = ACTIONS(765),
    [anon_sym_int168] = ACTIONS(765),
    [anon_sym_int176] = ACTIONS(765),
    [anon_sym_int184] = ACTIONS(765),
    [anon_sym_int192] = ACTIONS(765),
    [anon_sym_int200] = ACTIONS(765),
    [anon_sym_int208] = ACTIONS(765),
    [anon_sym_int216] = ACTIONS(765),
    [anon_sym_int224] = ACTIONS(765),
    [anon_sym_int232] = ACTIONS(765),
    [anon_sym_int240] = ACTIONS(765),
    [anon_sym_int248] = ACTIONS(765),
    [anon_sym_int256] = ACTIONS(765),
    [anon_sym_uint] = ACTIONS(765),
    [anon_sym_uint8] = ACTIONS(765),
    [anon_sym_uint16] = ACTIONS(765),
    [anon_sym_uint24] = ACTIONS(765),
    [anon_sym_uint32] = ACTIONS(765),
    [anon_sym_uint40] = ACTIONS(765),
    [anon_sym_uint48] = ACTIONS(765),
    [anon_sym_uint56] = ACTIONS(765),
    [anon_sym_uint64] = ACTIONS(765),
    [anon_sym_uint72] = ACTIONS(765),
    [anon_sym_uint80] = ACTIONS(765),
    [anon_sym_uint88] = ACTIONS(765),
    [anon_sym_uint96] = ACTIONS(765),
    [anon_sym_uint104] = ACTIONS(765),
    [anon_sym_uint112] = ACTIONS(765),
    [anon_sym_uint120] = ACTIONS(765),
    [anon_sym_uint128] = ACTIONS(765),
    [anon_sym_uint136] = ACTIONS(765),
    [anon_sym_uint144] = ACTIONS(765),
    [anon_sym_uint152] = ACTIONS(765),
    [anon_sym_uint160] = ACTIONS(765),
    [anon_sym_uint168] = ACTIONS(765),
    [anon_sym_uint176] = ACTIONS(765),
    [anon_sym_uint184] = ACTIONS(765),
    [anon_sym_uint192] = ACTIONS(765),
    [anon_sym_uint200] = ACTIONS(765),
    [anon_sym_uint208] = ACTIONS(765),
    [anon_sym_uint216] = ACTIONS(765),
    [anon_sym_uint224] = ACTIONS(765),
    [anon_sym_uint232] = ACTIONS(765),
    [anon_sym_uint240] = ACTIONS(765),
    [anon_sym_uint248] = ACTIONS(765),
    [anon_sym_uint256] = ACTIONS(765),
    [anon_sym_bytes] = ACTIONS(765),
    [anon_sym_bytes1] = ACTIONS(765),
    [anon_sym_bytes2] = ACTIONS(765),
    [anon_sym_bytes3] = ACTIONS(765),
    [anon_sym_bytes4] = ACTIONS(765),
    [anon_sym_bytes5] = ACTIONS(765),
    [anon_sym_bytes6] = ACTIONS(765),
    [anon_sym_bytes7] = ACTIONS(765),
    [anon_sym_bytes8] = ACTIONS(765),
    [anon_sym_bytes9] = ACTIONS(765),
    [anon_sym_bytes10] = ACTIONS(765),
    [anon_sym_bytes11] = ACTIONS(765),
    [anon_sym_bytes12] = ACTIONS(765),
    [anon_sym_bytes13] = ACTIONS(765),
    [anon_sym_bytes14] = ACTIONS(765),
    [anon_sym_bytes15] = ACTIONS(765),
    [anon_sym_bytes16] = ACTIONS(765),
    [anon_sym_bytes17] = ACTIONS(765),
    [anon_sym_bytes18] = ACTIONS(765),
    [anon_sym_bytes19] = ACTIONS(765),
    [anon_sym_bytes20] = ACTIONS(765),
    [anon_sym_bytes21] = ACTIONS(765),
    [anon_sym_bytes22] = ACTIONS(765),
    [anon_sym_bytes23] = ACTIONS(765),
    [anon_sym_bytes24] = ACTIONS(765),
    [anon_sym_bytes25] = ACTIONS(765),
    [anon_sym_bytes26] = ACTIONS(765),
    [anon_sym_bytes27] = ACTIONS(765),
    [anon_sym_bytes28] = ACTIONS(765),
    [anon_sym_bytes29] = ACTIONS(765),
    [anon_sym_bytes30] = ACTIONS(765),
    [anon_sym_bytes31] = ACTIONS(765),
    [anon_sym_bytes32] = ACTIONS(765),
    [anon_sym_fixed] = ACTIONS(765),
    [aux_sym__fixed_token1] = ACTIONS(765),
    [anon_sym_ufixed] = ACTIONS(765),
    [aux_sym__ufixed_token1] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_identifier] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_type] = ACTIONS(661),
    [anon_sym_error] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(661),
    [anon_sym_enum] = ACTIONS(661),
    [anon_sym_event] = ACTIONS(661),
    [anon_sym_using] = ACTIONS(661),
    [anon_sym_function] = ACTIONS(661),
    [anon_sym_byte] = ACTIONS(661),
    [anon_sym_address] = ACTIONS(661),
    [anon_sym_var] = ACTIONS(661),
    [anon_sym_modifier] = ACTIONS(661),
    [anon_sym_constructor] = ACTIONS(661),
    [anon_sym_fallback] = ACTIONS(661),
    [anon_sym_receive] = ACTIONS(661),
    [anon_sym_mapping] = ACTIONS(661),
    [anon_sym_bool] = ACTIONS(661),
    [anon_sym_string] = ACTIONS(661),
    [anon_sym_int] = ACTIONS(661),
    [anon_sym_int8] = ACTIONS(661),
    [anon_sym_int16] = ACTIONS(661),
    [anon_sym_int24] = ACTIONS(661),
    [anon_sym_int32] = ACTIONS(661),
    [anon_sym_int40] = ACTIONS(661),
    [anon_sym_int48] = ACTIONS(661),
    [anon_sym_int56] = ACTIONS(661),
    [anon_sym_int64] = ACTIONS(661),
    [anon_sym_int72] = ACTIONS(661),
    [anon_sym_int80] = ACTIONS(661),
    [anon_sym_int88] = ACTIONS(661),
    [anon_sym_int96] = ACTIONS(661),
    [anon_sym_int104] = ACTIONS(661),
    [anon_sym_int112] = ACTIONS(661),
    [anon_sym_int120] = ACTIONS(661),
    [anon_sym_int128] = ACTIONS(661),
    [anon_sym_int136] = ACTIONS(661),
    [anon_sym_int144] = ACTIONS(661),
    [anon_sym_int152] = ACTIONS(661),
    [anon_sym_int160] = ACTIONS(661),
    [anon_sym_int168] = ACTIONS(661),
    [anon_sym_int176] = ACTIONS(661),
    [anon_sym_int184] = ACTIONS(661),
    [anon_sym_int192] = ACTIONS(661),
    [anon_sym_int200] = ACTIONS(661),
    [anon_sym_int208] = ACTIONS(661),
    [anon_sym_int216] = ACTIONS(661),
    [anon_sym_int224] = ACTIONS(661),
    [anon_sym_int232] = ACTIONS(661),
    [anon_sym_int240] = ACTIONS(661),
    [anon_sym_int248] = ACTIONS(661),
    [anon_sym_int256] = ACTIONS(661),
    [anon_sym_uint] = ACTIONS(661),
    [anon_sym_uint8] = ACTIONS(661),
    [anon_sym_uint16] = ACTIONS(661),
    [anon_sym_uint24] = ACTIONS(661),
    [anon_sym_uint32] = ACTIONS(661),
    [anon_sym_uint40] = ACTIONS(661),
    [anon_sym_uint48] = ACTIONS(661),
    [anon_sym_uint56] = ACTIONS(661),
    [anon_sym_uint64] = ACTIONS(661),
    [anon_sym_uint72] = ACTIONS(661),
    [anon_sym_uint80] = ACTIONS(661),
    [anon_sym_uint88] = ACTIONS(661),
    [anon_sym_uint96] = ACTIONS(661),
    [anon_sym_uint104] = ACTIONS(661),
    [anon_sym_uint112] = ACTIONS(661),
    [anon_sym_uint120] = ACTIONS(661),
    [anon_sym_uint128] = ACTIONS(661),
    [anon_sym_uint136] = ACTIONS(661),
    [anon_sym_uint144] = ACTIONS(661),
    [anon_sym_uint152] = ACTIONS(661),
    [anon_sym_uint160] = ACTIONS(661),
    [anon_sym_uint168] = ACTIONS(661),
    [anon_sym_uint176] = ACTIONS(661),
    [anon_sym_uint184] = ACTIONS(661),
    [anon_sym_uint192] = ACTIONS(661),
    [anon_sym_uint200] = ACTIONS(661),
    [anon_sym_uint208] = ACTIONS(661),
    [anon_sym_uint216] = ACTIONS(661),
    [anon_sym_uint224] = ACTIONS(661),
    [anon_sym_uint232] = ACTIONS(661),
    [anon_sym_uint240] = ACTIONS(661),
    [anon_sym_uint248] = ACTIONS(661),
    [anon_sym_uint256] = ACTIONS(661),
    [anon_sym_bytes] = ACTIONS(661),
    [anon_sym_bytes1] = ACTIONS(661),
    [anon_sym_bytes2] = ACTIONS(661),
    [anon_sym_bytes3] = ACTIONS(661),
    [anon_sym_bytes4] = ACTIONS(661),
    [anon_sym_bytes5] = ACTIONS(661),
    [anon_sym_bytes6] = ACTIONS(661),
    [anon_sym_bytes7] = ACTIONS(661),
    [anon_sym_bytes8] = ACTIONS(661),
    [anon_sym_bytes9] = ACTIONS(661),
    [anon_sym_bytes10] = ACTIONS(661),
    [anon_sym_bytes11] = ACTIONS(661),
    [anon_sym_bytes12] = ACTIONS(661),
    [anon_sym_bytes13] = ACTIONS(661),
    [anon_sym_bytes14] = ACTIONS(661),
    [anon_sym_bytes15] = ACTIONS(661),
    [anon_sym_bytes16] = ACTIONS(661),
    [anon_sym_bytes17] = ACTIONS(661),
    [anon_sym_bytes18] = ACTIONS(661),
    [anon_sym_bytes19] = ACTIONS(661),
    [anon_sym_bytes20] = ACTIONS(661),
    [anon_sym_bytes21] = ACTIONS(661),
    [anon_sym_bytes22] = ACTIONS(661),
    [anon_sym_bytes23] = ACTIONS(661),
    [anon_sym_bytes24] = ACTIONS(661),
    [anon_sym_bytes25] = ACTIONS(661),
    [anon_sym_bytes26] = ACTIONS(661),
    [anon_sym_bytes27] = ACTIONS(661),
    [anon_sym_bytes28] = ACTIONS(661),
    [anon_sym_bytes29] = ACTIONS(661),
    [anon_sym_bytes30] = ACTIONS(661),
    [anon_sym_bytes31] = ACTIONS(661),
    [anon_sym_bytes32] = ACTIONS(661),
    [anon_sym_fixed] = ACTIONS(661),
    [aux_sym__fixed_token1] = ACTIONS(661),
    [anon_sym_ufixed] = ACTIONS(661),
    [aux_sym__ufixed_token1] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_pragma] = ACTIONS(769),
    [anon_sym_import] = ACTIONS(769),
    [anon_sym_type] = ACTIONS(769),
    [anon_sym_abstract] = ACTIONS(769),
    [anon_sym_contract] = ACTIONS(769),
    [anon_sym_error] = ACTIONS(769),
    [anon_sym_interface] = ACTIONS(769),
    [anon_sym_library] = ACTIONS(769),
    [anon_sym_struct] = ACTIONS(769),
    [anon_sym_enum] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(769),
    [anon_sym_byte] = ACTIONS(769),
    [anon_sym_address] = ACTIONS(769),
    [anon_sym_var] = ACTIONS(769),
    [anon_sym_mapping] = ACTIONS(769),
    [anon_sym_bool] = ACTIONS(769),
    [anon_sym_string] = ACTIONS(769),
    [anon_sym_int] = ACTIONS(769),
    [anon_sym_int8] = ACTIONS(769),
    [anon_sym_int16] = ACTIONS(769),
    [anon_sym_int24] = ACTIONS(769),
    [anon_sym_int32] = ACTIONS(769),
    [anon_sym_int40] = ACTIONS(769),
    [anon_sym_int48] = ACTIONS(769),
    [anon_sym_int56] = ACTIONS(769),
    [anon_sym_int64] = ACTIONS(769),
    [anon_sym_int72] = ACTIONS(769),
    [anon_sym_int80] = ACTIONS(769),
    [anon_sym_int88] = ACTIONS(769),
    [anon_sym_int96] = ACTIONS(769),
    [anon_sym_int104] = ACTIONS(769),
    [anon_sym_int112] = ACTIONS(769),
    [anon_sym_int120] = ACTIONS(769),
    [anon_sym_int128] = ACTIONS(769),
    [anon_sym_int136] = ACTIONS(769),
    [anon_sym_int144] = ACTIONS(769),
    [anon_sym_int152] = ACTIONS(769),
    [anon_sym_int160] = ACTIONS(769),
    [anon_sym_int168] = ACTIONS(769),
    [anon_sym_int176] = ACTIONS(769),
    [anon_sym_int184] = ACTIONS(769),
    [anon_sym_int192] = ACTIONS(769),
    [anon_sym_int200] = ACTIONS(769),
    [anon_sym_int208] = ACTIONS(769),
    [anon_sym_int216] = ACTIONS(769),
    [anon_sym_int224] = ACTIONS(769),
    [anon_sym_int232] = ACTIONS(769),
    [anon_sym_int240] = ACTIONS(769),
    [anon_sym_int248] = ACTIONS(769),
    [anon_sym_int256] = ACTIONS(769),
    [anon_sym_uint] = ACTIONS(769),
    [anon_sym_uint8] = ACTIONS(769),
    [anon_sym_uint16] = ACTIONS(769),
    [anon_sym_uint24] = ACTIONS(769),
    [anon_sym_uint32] = ACTIONS(769),
    [anon_sym_uint40] = ACTIONS(769),
    [anon_sym_uint48] = ACTIONS(769),
    [anon_sym_uint56] = ACTIONS(769),
    [anon_sym_uint64] = ACTIONS(769),
    [anon_sym_uint72] = ACTIONS(769),
    [anon_sym_uint80] = ACTIONS(769),
    [anon_sym_uint88] = ACTIONS(769),
    [anon_sym_uint96] = ACTIONS(769),
    [anon_sym_uint104] = ACTIONS(769),
    [anon_sym_uint112] = ACTIONS(769),
    [anon_sym_uint120] = ACTIONS(769),
    [anon_sym_uint128] = ACTIONS(769),
    [anon_sym_uint136] = ACTIONS(769),
    [anon_sym_uint144] = ACTIONS(769),
    [anon_sym_uint152] = ACTIONS(769),
    [anon_sym_uint160] = ACTIONS(769),
    [anon_sym_uint168] = ACTIONS(769),
    [anon_sym_uint176] = ACTIONS(769),
    [anon_sym_uint184] = ACTIONS(769),
    [anon_sym_uint192] = ACTIONS(769),
    [anon_sym_uint200] = ACTIONS(769),
    [anon_sym_uint208] = ACTIONS(769),
    [anon_sym_uint216] = ACTIONS(769),
    [anon_sym_uint224] = ACTIONS(769),
    [anon_sym_uint232] = ACTIONS(769),
    [anon_sym_uint240] = ACTIONS(769),
    [anon_sym_uint248] = ACTIONS(769),
    [anon_sym_uint256] = ACTIONS(769),
    [anon_sym_bytes] = ACTIONS(769),
    [anon_sym_bytes1] = ACTIONS(769),
    [anon_sym_bytes2] = ACTIONS(769),
    [anon_sym_bytes3] = ACTIONS(769),
    [anon_sym_bytes4] = ACTIONS(769),
    [anon_sym_bytes5] = ACTIONS(769),
    [anon_sym_bytes6] = ACTIONS(769),
    [anon_sym_bytes7] = ACTIONS(769),
    [anon_sym_bytes8] = ACTIONS(769),
    [anon_sym_bytes9] = ACTIONS(769),
    [anon_sym_bytes10] = ACTIONS(769),
    [anon_sym_bytes11] = ACTIONS(769),
    [anon_sym_bytes12] = ACTIONS(769),
    [anon_sym_bytes13] = ACTIONS(769),
    [anon_sym_bytes14] = ACTIONS(769),
    [anon_sym_bytes15] = ACTIONS(769),
    [anon_sym_bytes16] = ACTIONS(769),
    [anon_sym_bytes17] = ACTIONS(769),
    [anon_sym_bytes18] = ACTIONS(769),
    [anon_sym_bytes19] = ACTIONS(769),
    [anon_sym_bytes20] = ACTIONS(769),
    [anon_sym_bytes21] = ACTIONS(769),
    [anon_sym_bytes22] = ACTIONS(769),
    [anon_sym_bytes23] = ACTIONS(769),
    [anon_sym_bytes24] = ACTIONS(769),
    [anon_sym_bytes25] = ACTIONS(769),
    [anon_sym_bytes26] = ACTIONS(769),
    [anon_sym_bytes27] = ACTIONS(769),
    [anon_sym_bytes28] = ACTIONS(769),
    [anon_sym_bytes29] = ACTIONS(769),
    [anon_sym_bytes30] = ACTIONS(769),
    [anon_sym_bytes31] = ACTIONS(769),
    [anon_sym_bytes32] = ACTIONS(769),
    [anon_sym_fixed] = ACTIONS(769),
    [aux_sym__fixed_token1] = ACTIONS(769),
    [anon_sym_ufixed] = ACTIONS(769),
    [aux_sym__ufixed_token1] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(771),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(771),
    [anon_sym_error] = ACTIONS(771),
    [anon_sym_struct] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_event] = ACTIONS(771),
    [anon_sym_using] = ACTIONS(771),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_byte] = ACTIONS(771),
    [anon_sym_address] = ACTIONS(771),
    [anon_sym_var] = ACTIONS(771),
    [anon_sym_modifier] = ACTIONS(771),
    [anon_sym_constructor] = ACTIONS(771),
    [anon_sym_fallback] = ACTIONS(771),
    [anon_sym_receive] = ACTIONS(771),
    [anon_sym_mapping] = ACTIONS(771),
    [anon_sym_bool] = ACTIONS(771),
    [anon_sym_string] = ACTIONS(771),
    [anon_sym_int] = ACTIONS(771),
    [anon_sym_int8] = ACTIONS(771),
    [anon_sym_int16] = ACTIONS(771),
    [anon_sym_int24] = ACTIONS(771),
    [anon_sym_int32] = ACTIONS(771),
    [anon_sym_int40] = ACTIONS(771),
    [anon_sym_int48] = ACTIONS(771),
    [anon_sym_int56] = ACTIONS(771),
    [anon_sym_int64] = ACTIONS(771),
    [anon_sym_int72] = ACTIONS(771),
    [anon_sym_int80] = ACTIONS(771),
    [anon_sym_int88] = ACTIONS(771),
    [anon_sym_int96] = ACTIONS(771),
    [anon_sym_int104] = ACTIONS(771),
    [anon_sym_int112] = ACTIONS(771),
    [anon_sym_int120] = ACTIONS(771),
    [anon_sym_int128] = ACTIONS(771),
    [anon_sym_int136] = ACTIONS(771),
    [anon_sym_int144] = ACTIONS(771),
    [anon_sym_int152] = ACTIONS(771),
    [anon_sym_int160] = ACTIONS(771),
    [anon_sym_int168] = ACTIONS(771),
    [anon_sym_int176] = ACTIONS(771),
    [anon_sym_int184] = ACTIONS(771),
    [anon_sym_int192] = ACTIONS(771),
    [anon_sym_int200] = ACTIONS(771),
    [anon_sym_int208] = ACTIONS(771),
    [anon_sym_int216] = ACTIONS(771),
    [anon_sym_int224] = ACTIONS(771),
    [anon_sym_int232] = ACTIONS(771),
    [anon_sym_int240] = ACTIONS(771),
    [anon_sym_int248] = ACTIONS(771),
    [anon_sym_int256] = ACTIONS(771),
    [anon_sym_uint] = ACTIONS(771),
    [anon_sym_uint8] = ACTIONS(771),
    [anon_sym_uint16] = ACTIONS(771),
    [anon_sym_uint24] = ACTIONS(771),
    [anon_sym_uint32] = ACTIONS(771),
    [anon_sym_uint40] = ACTIONS(771),
    [anon_sym_uint48] = ACTIONS(771),
    [anon_sym_uint56] = ACTIONS(771),
    [anon_sym_uint64] = ACTIONS(771),
    [anon_sym_uint72] = ACTIONS(771),
    [anon_sym_uint80] = ACTIONS(771),
    [anon_sym_uint88] = ACTIONS(771),
    [anon_sym_uint96] = ACTIONS(771),
    [anon_sym_uint104] = ACTIONS(771),
    [anon_sym_uint112] = ACTIONS(771),
    [anon_sym_uint120] = ACTIONS(771),
    [anon_sym_uint128] = ACTIONS(771),
    [anon_sym_uint136] = ACTIONS(771),
    [anon_sym_uint144] = ACTIONS(771),
    [anon_sym_uint152] = ACTIONS(771),
    [anon_sym_uint160] = ACTIONS(771),
    [anon_sym_uint168] = ACTIONS(771),
    [anon_sym_uint176] = ACTIONS(771),
    [anon_sym_uint184] = ACTIONS(771),
    [anon_sym_uint192] = ACTIONS(771),
    [anon_sym_uint200] = ACTIONS(771),
    [anon_sym_uint208] = ACTIONS(771),
    [anon_sym_uint216] = ACTIONS(771),
    [anon_sym_uint224] = ACTIONS(771),
    [anon_sym_uint232] = ACTIONS(771),
    [anon_sym_uint240] = ACTIONS(771),
    [anon_sym_uint248] = ACTIONS(771),
    [anon_sym_uint256] = ACTIONS(771),
    [anon_sym_bytes] = ACTIONS(771),
    [anon_sym_bytes1] = ACTIONS(771),
    [anon_sym_bytes2] = ACTIONS(771),
    [anon_sym_bytes3] = ACTIONS(771),
    [anon_sym_bytes4] = ACTIONS(771),
    [anon_sym_bytes5] = ACTIONS(771),
    [anon_sym_bytes6] = ACTIONS(771),
    [anon_sym_bytes7] = ACTIONS(771),
    [anon_sym_bytes8] = ACTIONS(771),
    [anon_sym_bytes9] = ACTIONS(771),
    [anon_sym_bytes10] = ACTIONS(771),
    [anon_sym_bytes11] = ACTIONS(771),
    [anon_sym_bytes12] = ACTIONS(771),
    [anon_sym_bytes13] = ACTIONS(771),
    [anon_sym_bytes14] = ACTIONS(771),
    [anon_sym_bytes15] = ACTIONS(771),
    [anon_sym_bytes16] = ACTIONS(771),
    [anon_sym_bytes17] = ACTIONS(771),
    [anon_sym_bytes18] = ACTIONS(771),
    [anon_sym_bytes19] = ACTIONS(771),
    [anon_sym_bytes20] = ACTIONS(771),
    [anon_sym_bytes21] = ACTIONS(771),
    [anon_sym_bytes22] = ACTIONS(771),
    [anon_sym_bytes23] = ACTIONS(771),
    [anon_sym_bytes24] = ACTIONS(771),
    [anon_sym_bytes25] = ACTIONS(771),
    [anon_sym_bytes26] = ACTIONS(771),
    [anon_sym_bytes27] = ACTIONS(771),
    [anon_sym_bytes28] = ACTIONS(771),
    [anon_sym_bytes29] = ACTIONS(771),
    [anon_sym_bytes30] = ACTIONS(771),
    [anon_sym_bytes31] = ACTIONS(771),
    [anon_sym_bytes32] = ACTIONS(771),
    [anon_sym_fixed] = ACTIONS(771),
    [aux_sym__fixed_token1] = ACTIONS(771),
    [anon_sym_ufixed] = ACTIONS(771),
    [aux_sym__ufixed_token1] = ACTIONS(771),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(601),
    [sym_identifier] = ACTIONS(599),
    [anon_sym_pragma] = ACTIONS(599),
    [anon_sym_import] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(599),
    [anon_sym_abstract] = ACTIONS(599),
    [anon_sym_contract] = ACTIONS(599),
    [anon_sym_error] = ACTIONS(599),
    [anon_sym_interface] = ACTIONS(599),
    [anon_sym_library] = ACTIONS(599),
    [anon_sym_struct] = ACTIONS(599),
    [anon_sym_enum] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(599),
    [anon_sym_byte] = ACTIONS(599),
    [anon_sym_address] = ACTIONS(599),
    [anon_sym_var] = ACTIONS(599),
    [anon_sym_mapping] = ACTIONS(599),
    [anon_sym_bool] = ACTIONS(599),
    [anon_sym_string] = ACTIONS(599),
    [anon_sym_int] = ACTIONS(599),
    [anon_sym_int8] = ACTIONS(599),
    [anon_sym_int16] = ACTIONS(599),
    [anon_sym_int24] = ACTIONS(599),
    [anon_sym_int32] = ACTIONS(599),
    [anon_sym_int40] = ACTIONS(599),
    [anon_sym_int48] = ACTIONS(599),
    [anon_sym_int56] = ACTIONS(599),
    [anon_sym_int64] = ACTIONS(599),
    [anon_sym_int72] = ACTIONS(599),
    [anon_sym_int80] = ACTIONS(599),
    [anon_sym_int88] = ACTIONS(599),
    [anon_sym_int96] = ACTIONS(599),
    [anon_sym_int104] = ACTIONS(599),
    [anon_sym_int112] = ACTIONS(599),
    [anon_sym_int120] = ACTIONS(599),
    [anon_sym_int128] = ACTIONS(599),
    [anon_sym_int136] = ACTIONS(599),
    [anon_sym_int144] = ACTIONS(599),
    [anon_sym_int152] = ACTIONS(599),
    [anon_sym_int160] = ACTIONS(599),
    [anon_sym_int168] = ACTIONS(599),
    [anon_sym_int176] = ACTIONS(599),
    [anon_sym_int184] = ACTIONS(599),
    [anon_sym_int192] = ACTIONS(599),
    [anon_sym_int200] = ACTIONS(599),
    [anon_sym_int208] = ACTIONS(599),
    [anon_sym_int216] = ACTIONS(599),
    [anon_sym_int224] = ACTIONS(599),
    [anon_sym_int232] = ACTIONS(599),
    [anon_sym_int240] = ACTIONS(599),
    [anon_sym_int248] = ACTIONS(599),
    [anon_sym_int256] = ACTIONS(599),
    [anon_sym_uint] = ACTIONS(599),
    [anon_sym_uint8] = ACTIONS(599),
    [anon_sym_uint16] = ACTIONS(599),
    [anon_sym_uint24] = ACTIONS(599),
    [anon_sym_uint32] = ACTIONS(599),
    [anon_sym_uint40] = ACTIONS(599),
    [anon_sym_uint48] = ACTIONS(599),
    [anon_sym_uint56] = ACTIONS(599),
    [anon_sym_uint64] = ACTIONS(599),
    [anon_sym_uint72] = ACTIONS(599),
    [anon_sym_uint80] = ACTIONS(599),
    [anon_sym_uint88] = ACTIONS(599),
    [anon_sym_uint96] = ACTIONS(599),
    [anon_sym_uint104] = ACTIONS(599),
    [anon_sym_uint112] = ACTIONS(599),
    [anon_sym_uint120] = ACTIONS(599),
    [anon_sym_uint128] = ACTIONS(599),
    [anon_sym_uint136] = ACTIONS(599),
    [anon_sym_uint144] = ACTIONS(599),
    [anon_sym_uint152] = ACTIONS(599),
    [anon_sym_uint160] = ACTIONS(599),
    [anon_sym_uint168] = ACTIONS(599),
    [anon_sym_uint176] = ACTIONS(599),
    [anon_sym_uint184] = ACTIONS(599),
    [anon_sym_uint192] = ACTIONS(599),
    [anon_sym_uint200] = ACTIONS(599),
    [anon_sym_uint208] = ACTIONS(599),
    [anon_sym_uint216] = ACTIONS(599),
    [anon_sym_uint224] = ACTIONS(599),
    [anon_sym_uint232] = ACTIONS(599),
    [anon_sym_uint240] = ACTIONS(599),
    [anon_sym_uint248] = ACTIONS(599),
    [anon_sym_uint256] = ACTIONS(599),
    [anon_sym_bytes] = ACTIONS(599),
    [anon_sym_bytes1] = ACTIONS(599),
    [anon_sym_bytes2] = ACTIONS(599),
    [anon_sym_bytes3] = ACTIONS(599),
    [anon_sym_bytes4] = ACTIONS(599),
    [anon_sym_bytes5] = ACTIONS(599),
    [anon_sym_bytes6] = ACTIONS(599),
    [anon_sym_bytes7] = ACTIONS(599),
    [anon_sym_bytes8] = ACTIONS(599),
    [anon_sym_bytes9] = ACTIONS(599),
    [anon_sym_bytes10] = ACTIONS(599),
    [anon_sym_bytes11] = ACTIONS(599),
    [anon_sym_bytes12] = ACTIONS(599),
    [anon_sym_bytes13] = ACTIONS(599),
    [anon_sym_bytes14] = ACTIONS(599),
    [anon_sym_bytes15] = ACTIONS(599),
    [anon_sym_bytes16] = ACTIONS(599),
    [anon_sym_bytes17] = ACTIONS(599),
    [anon_sym_bytes18] = ACTIONS(599),
    [anon_sym_bytes19] = ACTIONS(599),
    [anon_sym_bytes20] = ACTIONS(599),
    [anon_sym_bytes21] = ACTIONS(599),
    [anon_sym_bytes22] = ACTIONS(599),
    [anon_sym_bytes23] = ACTIONS(599),
    [anon_sym_bytes24] = ACTIONS(599),
    [anon_sym_bytes25] = ACTIONS(599),
    [anon_sym_bytes26] = ACTIONS(599),
    [anon_sym_bytes27] = ACTIONS(599),
    [anon_sym_bytes28] = ACTIONS(599),
    [anon_sym_bytes29] = ACTIONS(599),
    [anon_sym_bytes30] = ACTIONS(599),
    [anon_sym_bytes31] = ACTIONS(599),
    [anon_sym_bytes32] = ACTIONS(599),
    [anon_sym_fixed] = ACTIONS(599),
    [aux_sym__fixed_token1] = ACTIONS(599),
    [anon_sym_ufixed] = ACTIONS(599),
    [aux_sym__ufixed_token1] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(775),
    [sym_identifier] = ACTIONS(777),
    [anon_sym_pragma] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(777),
    [anon_sym_contract] = ACTIONS(777),
    [anon_sym_error] = ACTIONS(777),
    [anon_sym_interface] = ACTIONS(777),
    [anon_sym_library] = ACTIONS(777),
    [anon_sym_struct] = ACTIONS(777),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(777),
    [anon_sym_byte] = ACTIONS(777),
    [anon_sym_address] = ACTIONS(777),
    [anon_sym_var] = ACTIONS(777),
    [anon_sym_mapping] = ACTIONS(777),
    [anon_sym_bool] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_int] = ACTIONS(777),
    [anon_sym_int8] = ACTIONS(777),
    [anon_sym_int16] = ACTIONS(777),
    [anon_sym_int24] = ACTIONS(777),
    [anon_sym_int32] = ACTIONS(777),
    [anon_sym_int40] = ACTIONS(777),
    [anon_sym_int48] = ACTIONS(777),
    [anon_sym_int56] = ACTIONS(777),
    [anon_sym_int64] = ACTIONS(777),
    [anon_sym_int72] = ACTIONS(777),
    [anon_sym_int80] = ACTIONS(777),
    [anon_sym_int88] = ACTIONS(777),
    [anon_sym_int96] = ACTIONS(777),
    [anon_sym_int104] = ACTIONS(777),
    [anon_sym_int112] = ACTIONS(777),
    [anon_sym_int120] = ACTIONS(777),
    [anon_sym_int128] = ACTIONS(777),
    [anon_sym_int136] = ACTIONS(777),
    [anon_sym_int144] = ACTIONS(777),
    [anon_sym_int152] = ACTIONS(777),
    [anon_sym_int160] = ACTIONS(777),
    [anon_sym_int168] = ACTIONS(777),
    [anon_sym_int176] = ACTIONS(777),
    [anon_sym_int184] = ACTIONS(777),
    [anon_sym_int192] = ACTIONS(777),
    [anon_sym_int200] = ACTIONS(777),
    [anon_sym_int208] = ACTIONS(777),
    [anon_sym_int216] = ACTIONS(777),
    [anon_sym_int224] = ACTIONS(777),
    [anon_sym_int232] = ACTIONS(777),
    [anon_sym_int240] = ACTIONS(777),
    [anon_sym_int248] = ACTIONS(777),
    [anon_sym_int256] = ACTIONS(777),
    [anon_sym_uint] = ACTIONS(777),
    [anon_sym_uint8] = ACTIONS(777),
    [anon_sym_uint16] = ACTIONS(777),
    [anon_sym_uint24] = ACTIONS(777),
    [anon_sym_uint32] = ACTIONS(777),
    [anon_sym_uint40] = ACTIONS(777),
    [anon_sym_uint48] = ACTIONS(777),
    [anon_sym_uint56] = ACTIONS(777),
    [anon_sym_uint64] = ACTIONS(777),
    [anon_sym_uint72] = ACTIONS(777),
    [anon_sym_uint80] = ACTIONS(777),
    [anon_sym_uint88] = ACTIONS(777),
    [anon_sym_uint96] = ACTIONS(777),
    [anon_sym_uint104] = ACTIONS(777),
    [anon_sym_uint112] = ACTIONS(777),
    [anon_sym_uint120] = ACTIONS(777),
    [anon_sym_uint128] = ACTIONS(777),
    [anon_sym_uint136] = ACTIONS(777),
    [anon_sym_uint144] = ACTIONS(777),
    [anon_sym_uint152] = ACTIONS(777),
    [anon_sym_uint160] = ACTIONS(777),
    [anon_sym_uint168] = ACTIONS(777),
    [anon_sym_uint176] = ACTIONS(777),
    [anon_sym_uint184] = ACTIONS(777),
    [anon_sym_uint192] = ACTIONS(777),
    [anon_sym_uint200] = ACTIONS(777),
    [anon_sym_uint208] = ACTIONS(777),
    [anon_sym_uint216] = ACTIONS(777),
    [anon_sym_uint224] = ACTIONS(777),
    [anon_sym_uint232] = ACTIONS(777),
    [anon_sym_uint240] = ACTIONS(777),
    [anon_sym_uint248] = ACTIONS(777),
    [anon_sym_uint256] = ACTIONS(777),
    [anon_sym_bytes] = ACTIONS(777),
    [anon_sym_bytes1] = ACTIONS(777),
    [anon_sym_bytes2] = ACTIONS(777),
    [anon_sym_bytes3] = ACTIONS(777),
    [anon_sym_bytes4] = ACTIONS(777),
    [anon_sym_bytes5] = ACTIONS(777),
    [anon_sym_bytes6] = ACTIONS(777),
    [anon_sym_bytes7] = ACTIONS(777),
    [anon_sym_bytes8] = ACTIONS(777),
    [anon_sym_bytes9] = ACTIONS(777),
    [anon_sym_bytes10] = ACTIONS(777),
    [anon_sym_bytes11] = ACTIONS(777),
    [anon_sym_bytes12] = ACTIONS(777),
    [anon_sym_bytes13] = ACTIONS(777),
    [anon_sym_bytes14] = ACTIONS(777),
    [anon_sym_bytes15] = ACTIONS(777),
    [anon_sym_bytes16] = ACTIONS(777),
    [anon_sym_bytes17] = ACTIONS(777),
    [anon_sym_bytes18] = ACTIONS(777),
    [anon_sym_bytes19] = ACTIONS(777),
    [anon_sym_bytes20] = ACTIONS(777),
    [anon_sym_bytes21] = ACTIONS(777),
    [anon_sym_bytes22] = ACTIONS(777),
    [anon_sym_bytes23] = ACTIONS(777),
    [anon_sym_bytes24] = ACTIONS(777),
    [anon_sym_bytes25] = ACTIONS(777),
    [anon_sym_bytes26] = ACTIONS(777),
    [anon_sym_bytes27] = ACTIONS(777),
    [anon_sym_bytes28] = ACTIONS(777),
    [anon_sym_bytes29] = ACTIONS(777),
    [anon_sym_bytes30] = ACTIONS(777),
    [anon_sym_bytes31] = ACTIONS(777),
    [anon_sym_bytes32] = ACTIONS(777),
    [anon_sym_fixed] = ACTIONS(777),
    [aux_sym__fixed_token1] = ACTIONS(777),
    [anon_sym_ufixed] = ACTIONS(777),
    [aux_sym__ufixed_token1] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(779),
    [sym_identifier] = ACTIONS(781),
    [anon_sym_pragma] = ACTIONS(781),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_abstract] = ACTIONS(781),
    [anon_sym_contract] = ACTIONS(781),
    [anon_sym_error] = ACTIONS(781),
    [anon_sym_interface] = ACTIONS(781),
    [anon_sym_library] = ACTIONS(781),
    [anon_sym_struct] = ACTIONS(781),
    [anon_sym_enum] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(781),
    [anon_sym_byte] = ACTIONS(781),
    [anon_sym_address] = ACTIONS(781),
    [anon_sym_var] = ACTIONS(781),
    [anon_sym_mapping] = ACTIONS(781),
    [anon_sym_bool] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_int] = ACTIONS(781),
    [anon_sym_int8] = ACTIONS(781),
    [anon_sym_int16] = ACTIONS(781),
    [anon_sym_int24] = ACTIONS(781),
    [anon_sym_int32] = ACTIONS(781),
    [anon_sym_int40] = ACTIONS(781),
    [anon_sym_int48] = ACTIONS(781),
    [anon_sym_int56] = ACTIONS(781),
    [anon_sym_int64] = ACTIONS(781),
    [anon_sym_int72] = ACTIONS(781),
    [anon_sym_int80] = ACTIONS(781),
    [anon_sym_int88] = ACTIONS(781),
    [anon_sym_int96] = ACTIONS(781),
    [anon_sym_int104] = ACTIONS(781),
    [anon_sym_int112] = ACTIONS(781),
    [anon_sym_int120] = ACTIONS(781),
    [anon_sym_int128] = ACTIONS(781),
    [anon_sym_int136] = ACTIONS(781),
    [anon_sym_int144] = ACTIONS(781),
    [anon_sym_int152] = ACTIONS(781),
    [anon_sym_int160] = ACTIONS(781),
    [anon_sym_int168] = ACTIONS(781),
    [anon_sym_int176] = ACTIONS(781),
    [anon_sym_int184] = ACTIONS(781),
    [anon_sym_int192] = ACTIONS(781),
    [anon_sym_int200] = ACTIONS(781),
    [anon_sym_int208] = ACTIONS(781),
    [anon_sym_int216] = ACTIONS(781),
    [anon_sym_int224] = ACTIONS(781),
    [anon_sym_int232] = ACTIONS(781),
    [anon_sym_int240] = ACTIONS(781),
    [anon_sym_int248] = ACTIONS(781),
    [anon_sym_int256] = ACTIONS(781),
    [anon_sym_uint] = ACTIONS(781),
    [anon_sym_uint8] = ACTIONS(781),
    [anon_sym_uint16] = ACTIONS(781),
    [anon_sym_uint24] = ACTIONS(781),
    [anon_sym_uint32] = ACTIONS(781),
    [anon_sym_uint40] = ACTIONS(781),
    [anon_sym_uint48] = ACTIONS(781),
    [anon_sym_uint56] = ACTIONS(781),
    [anon_sym_uint64] = ACTIONS(781),
    [anon_sym_uint72] = ACTIONS(781),
    [anon_sym_uint80] = ACTIONS(781),
    [anon_sym_uint88] = ACTIONS(781),
    [anon_sym_uint96] = ACTIONS(781),
    [anon_sym_uint104] = ACTIONS(781),
    [anon_sym_uint112] = ACTIONS(781),
    [anon_sym_uint120] = ACTIONS(781),
    [anon_sym_uint128] = ACTIONS(781),
    [anon_sym_uint136] = ACTIONS(781),
    [anon_sym_uint144] = ACTIONS(781),
    [anon_sym_uint152] = ACTIONS(781),
    [anon_sym_uint160] = ACTIONS(781),
    [anon_sym_uint168] = ACTIONS(781),
    [anon_sym_uint176] = ACTIONS(781),
    [anon_sym_uint184] = ACTIONS(781),
    [anon_sym_uint192] = ACTIONS(781),
    [anon_sym_uint200] = ACTIONS(781),
    [anon_sym_uint208] = ACTIONS(781),
    [anon_sym_uint216] = ACTIONS(781),
    [anon_sym_uint224] = ACTIONS(781),
    [anon_sym_uint232] = ACTIONS(781),
    [anon_sym_uint240] = ACTIONS(781),
    [anon_sym_uint248] = ACTIONS(781),
    [anon_sym_uint256] = ACTIONS(781),
    [anon_sym_bytes] = ACTIONS(781),
    [anon_sym_bytes1] = ACTIONS(781),
    [anon_sym_bytes2] = ACTIONS(781),
    [anon_sym_bytes3] = ACTIONS(781),
    [anon_sym_bytes4] = ACTIONS(781),
    [anon_sym_bytes5] = ACTIONS(781),
    [anon_sym_bytes6] = ACTIONS(781),
    [anon_sym_bytes7] = ACTIONS(781),
    [anon_sym_bytes8] = ACTIONS(781),
    [anon_sym_bytes9] = ACTIONS(781),
    [anon_sym_bytes10] = ACTIONS(781),
    [anon_sym_bytes11] = ACTIONS(781),
    [anon_sym_bytes12] = ACTIONS(781),
    [anon_sym_bytes13] = ACTIONS(781),
    [anon_sym_bytes14] = ACTIONS(781),
    [anon_sym_bytes15] = ACTIONS(781),
    [anon_sym_bytes16] = ACTIONS(781),
    [anon_sym_bytes17] = ACTIONS(781),
    [anon_sym_bytes18] = ACTIONS(781),
    [anon_sym_bytes19] = ACTIONS(781),
    [anon_sym_bytes20] = ACTIONS(781),
    [anon_sym_bytes21] = ACTIONS(781),
    [anon_sym_bytes22] = ACTIONS(781),
    [anon_sym_bytes23] = ACTIONS(781),
    [anon_sym_bytes24] = ACTIONS(781),
    [anon_sym_bytes25] = ACTIONS(781),
    [anon_sym_bytes26] = ACTIONS(781),
    [anon_sym_bytes27] = ACTIONS(781),
    [anon_sym_bytes28] = ACTIONS(781),
    [anon_sym_bytes29] = ACTIONS(781),
    [anon_sym_bytes30] = ACTIONS(781),
    [anon_sym_bytes31] = ACTIONS(781),
    [anon_sym_bytes32] = ACTIONS(781),
    [anon_sym_fixed] = ACTIONS(781),
    [aux_sym__fixed_token1] = ACTIONS(781),
    [anon_sym_ufixed] = ACTIONS(781),
    [aux_sym__ufixed_token1] = ACTIONS(781),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(783),
    [sym_identifier] = ACTIONS(785),
    [anon_sym_pragma] = ACTIONS(785),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(785),
    [anon_sym_abstract] = ACTIONS(785),
    [anon_sym_contract] = ACTIONS(785),
    [anon_sym_error] = ACTIONS(785),
    [anon_sym_interface] = ACTIONS(785),
    [anon_sym_library] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(785),
    [anon_sym_byte] = ACTIONS(785),
    [anon_sym_address] = ACTIONS(785),
    [anon_sym_var] = ACTIONS(785),
    [anon_sym_mapping] = ACTIONS(785),
    [anon_sym_bool] = ACTIONS(785),
    [anon_sym_string] = ACTIONS(785),
    [anon_sym_int] = ACTIONS(785),
    [anon_sym_int8] = ACTIONS(785),
    [anon_sym_int16] = ACTIONS(785),
    [anon_sym_int24] = ACTIONS(785),
    [anon_sym_int32] = ACTIONS(785),
    [anon_sym_int40] = ACTIONS(785),
    [anon_sym_int48] = ACTIONS(785),
    [anon_sym_int56] = ACTIONS(785),
    [anon_sym_int64] = ACTIONS(785),
    [anon_sym_int72] = ACTIONS(785),
    [anon_sym_int80] = ACTIONS(785),
    [anon_sym_int88] = ACTIONS(785),
    [anon_sym_int96] = ACTIONS(785),
    [anon_sym_int104] = ACTIONS(785),
    [anon_sym_int112] = ACTIONS(785),
    [anon_sym_int120] = ACTIONS(785),
    [anon_sym_int128] = ACTIONS(785),
    [anon_sym_int136] = ACTIONS(785),
    [anon_sym_int144] = ACTIONS(785),
    [anon_sym_int152] = ACTIONS(785),
    [anon_sym_int160] = ACTIONS(785),
    [anon_sym_int168] = ACTIONS(785),
    [anon_sym_int176] = ACTIONS(785),
    [anon_sym_int184] = ACTIONS(785),
    [anon_sym_int192] = ACTIONS(785),
    [anon_sym_int200] = ACTIONS(785),
    [anon_sym_int208] = ACTIONS(785),
    [anon_sym_int216] = ACTIONS(785),
    [anon_sym_int224] = ACTIONS(785),
    [anon_sym_int232] = ACTIONS(785),
    [anon_sym_int240] = ACTIONS(785),
    [anon_sym_int248] = ACTIONS(785),
    [anon_sym_int256] = ACTIONS(785),
    [anon_sym_uint] = ACTIONS(785),
    [anon_sym_uint8] = ACTIONS(785),
    [anon_sym_uint16] = ACTIONS(785),
    [anon_sym_uint24] = ACTIONS(785),
    [anon_sym_uint32] = ACTIONS(785),
    [anon_sym_uint40] = ACTIONS(785),
    [anon_sym_uint48] = ACTIONS(785),
    [anon_sym_uint56] = ACTIONS(785),
    [anon_sym_uint64] = ACTIONS(785),
    [anon_sym_uint72] = ACTIONS(785),
    [anon_sym_uint80] = ACTIONS(785),
    [anon_sym_uint88] = ACTIONS(785),
    [anon_sym_uint96] = ACTIONS(785),
    [anon_sym_uint104] = ACTIONS(785),
    [anon_sym_uint112] = ACTIONS(785),
    [anon_sym_uint120] = ACTIONS(785),
    [anon_sym_uint128] = ACTIONS(785),
    [anon_sym_uint136] = ACTIONS(785),
    [anon_sym_uint144] = ACTIONS(785),
    [anon_sym_uint152] = ACTIONS(785),
    [anon_sym_uint160] = ACTIONS(785),
    [anon_sym_uint168] = ACTIONS(785),
    [anon_sym_uint176] = ACTIONS(785),
    [anon_sym_uint184] = ACTIONS(785),
    [anon_sym_uint192] = ACTIONS(785),
    [anon_sym_uint200] = ACTIONS(785),
    [anon_sym_uint208] = ACTIONS(785),
    [anon_sym_uint216] = ACTIONS(785),
    [anon_sym_uint224] = ACTIONS(785),
    [anon_sym_uint232] = ACTIONS(785),
    [anon_sym_uint240] = ACTIONS(785),
    [anon_sym_uint248] = ACTIONS(785),
    [anon_sym_uint256] = ACTIONS(785),
    [anon_sym_bytes] = ACTIONS(785),
    [anon_sym_bytes1] = ACTIONS(785),
    [anon_sym_bytes2] = ACTIONS(785),
    [anon_sym_bytes3] = ACTIONS(785),
    [anon_sym_bytes4] = ACTIONS(785),
    [anon_sym_bytes5] = ACTIONS(785),
    [anon_sym_bytes6] = ACTIONS(785),
    [anon_sym_bytes7] = ACTIONS(785),
    [anon_sym_bytes8] = ACTIONS(785),
    [anon_sym_bytes9] = ACTIONS(785),
    [anon_sym_bytes10] = ACTIONS(785),
    [anon_sym_bytes11] = ACTIONS(785),
    [anon_sym_bytes12] = ACTIONS(785),
    [anon_sym_bytes13] = ACTIONS(785),
    [anon_sym_bytes14] = ACTIONS(785),
    [anon_sym_bytes15] = ACTIONS(785),
    [anon_sym_bytes16] = ACTIONS(785),
    [anon_sym_bytes17] = ACTIONS(785),
    [anon_sym_bytes18] = ACTIONS(785),
    [anon_sym_bytes19] = ACTIONS(785),
    [anon_sym_bytes20] = ACTIONS(785),
    [anon_sym_bytes21] = ACTIONS(785),
    [anon_sym_bytes22] = ACTIONS(785),
    [anon_sym_bytes23] = ACTIONS(785),
    [anon_sym_bytes24] = ACTIONS(785),
    [anon_sym_bytes25] = ACTIONS(785),
    [anon_sym_bytes26] = ACTIONS(785),
    [anon_sym_bytes27] = ACTIONS(785),
    [anon_sym_bytes28] = ACTIONS(785),
    [anon_sym_bytes29] = ACTIONS(785),
    [anon_sym_bytes30] = ACTIONS(785),
    [anon_sym_bytes31] = ACTIONS(785),
    [anon_sym_bytes32] = ACTIONS(785),
    [anon_sym_fixed] = ACTIONS(785),
    [aux_sym__fixed_token1] = ACTIONS(785),
    [anon_sym_ufixed] = ACTIONS(785),
    [aux_sym__ufixed_token1] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_identifier] = ACTIONS(785),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_type] = ACTIONS(785),
    [anon_sym_error] = ACTIONS(785),
    [anon_sym_struct] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_event] = ACTIONS(785),
    [anon_sym_using] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(785),
    [anon_sym_byte] = ACTIONS(785),
    [anon_sym_address] = ACTIONS(785),
    [anon_sym_var] = ACTIONS(785),
    [anon_sym_modifier] = ACTIONS(785),
    [anon_sym_constructor] = ACTIONS(785),
    [anon_sym_fallback] = ACTIONS(785),
    [anon_sym_receive] = ACTIONS(785),
    [anon_sym_mapping] = ACTIONS(785),
    [anon_sym_bool] = ACTIONS(785),
    [anon_sym_string] = ACTIONS(785),
    [anon_sym_int] = ACTIONS(785),
    [anon_sym_int8] = ACTIONS(785),
    [anon_sym_int16] = ACTIONS(785),
    [anon_sym_int24] = ACTIONS(785),
    [anon_sym_int32] = ACTIONS(785),
    [anon_sym_int40] = ACTIONS(785),
    [anon_sym_int48] = ACTIONS(785),
    [anon_sym_int56] = ACTIONS(785),
    [anon_sym_int64] = ACTIONS(785),
    [anon_sym_int72] = ACTIONS(785),
    [anon_sym_int80] = ACTIONS(785),
    [anon_sym_int88] = ACTIONS(785),
    [anon_sym_int96] = ACTIONS(785),
    [anon_sym_int104] = ACTIONS(785),
    [anon_sym_int112] = ACTIONS(785),
    [anon_sym_int120] = ACTIONS(785),
    [anon_sym_int128] = ACTIONS(785),
    [anon_sym_int136] = ACTIONS(785),
    [anon_sym_int144] = ACTIONS(785),
    [anon_sym_int152] = ACTIONS(785),
    [anon_sym_int160] = ACTIONS(785),
    [anon_sym_int168] = ACTIONS(785),
    [anon_sym_int176] = ACTIONS(785),
    [anon_sym_int184] = ACTIONS(785),
    [anon_sym_int192] = ACTIONS(785),
    [anon_sym_int200] = ACTIONS(785),
    [anon_sym_int208] = ACTIONS(785),
    [anon_sym_int216] = ACTIONS(785),
    [anon_sym_int224] = ACTIONS(785),
    [anon_sym_int232] = ACTIONS(785),
    [anon_sym_int240] = ACTIONS(785),
    [anon_sym_int248] = ACTIONS(785),
    [anon_sym_int256] = ACTIONS(785),
    [anon_sym_uint] = ACTIONS(785),
    [anon_sym_uint8] = ACTIONS(785),
    [anon_sym_uint16] = ACTIONS(785),
    [anon_sym_uint24] = ACTIONS(785),
    [anon_sym_uint32] = ACTIONS(785),
    [anon_sym_uint40] = ACTIONS(785),
    [anon_sym_uint48] = ACTIONS(785),
    [anon_sym_uint56] = ACTIONS(785),
    [anon_sym_uint64] = ACTIONS(785),
    [anon_sym_uint72] = ACTIONS(785),
    [anon_sym_uint80] = ACTIONS(785),
    [anon_sym_uint88] = ACTIONS(785),
    [anon_sym_uint96] = ACTIONS(785),
    [anon_sym_uint104] = ACTIONS(785),
    [anon_sym_uint112] = ACTIONS(785),
    [anon_sym_uint120] = ACTIONS(785),
    [anon_sym_uint128] = ACTIONS(785),
    [anon_sym_uint136] = ACTIONS(785),
    [anon_sym_uint144] = ACTIONS(785),
    [anon_sym_uint152] = ACTIONS(785),
    [anon_sym_uint160] = ACTIONS(785),
    [anon_sym_uint168] = ACTIONS(785),
    [anon_sym_uint176] = ACTIONS(785),
    [anon_sym_uint184] = ACTIONS(785),
    [anon_sym_uint192] = ACTIONS(785),
    [anon_sym_uint200] = ACTIONS(785),
    [anon_sym_uint208] = ACTIONS(785),
    [anon_sym_uint216] = ACTIONS(785),
    [anon_sym_uint224] = ACTIONS(785),
    [anon_sym_uint232] = ACTIONS(785),
    [anon_sym_uint240] = ACTIONS(785),
    [anon_sym_uint248] = ACTIONS(785),
    [anon_sym_uint256] = ACTIONS(785),
    [anon_sym_bytes] = ACTIONS(785),
    [anon_sym_bytes1] = ACTIONS(785),
    [anon_sym_bytes2] = ACTIONS(785),
    [anon_sym_bytes3] = ACTIONS(785),
    [anon_sym_bytes4] = ACTIONS(785),
    [anon_sym_bytes5] = ACTIONS(785),
    [anon_sym_bytes6] = ACTIONS(785),
    [anon_sym_bytes7] = ACTIONS(785),
    [anon_sym_bytes8] = ACTIONS(785),
    [anon_sym_bytes9] = ACTIONS(785),
    [anon_sym_bytes10] = ACTIONS(785),
    [anon_sym_bytes11] = ACTIONS(785),
    [anon_sym_bytes12] = ACTIONS(785),
    [anon_sym_bytes13] = ACTIONS(785),
    [anon_sym_bytes14] = ACTIONS(785),
    [anon_sym_bytes15] = ACTIONS(785),
    [anon_sym_bytes16] = ACTIONS(785),
    [anon_sym_bytes17] = ACTIONS(785),
    [anon_sym_bytes18] = ACTIONS(785),
    [anon_sym_bytes19] = ACTIONS(785),
    [anon_sym_bytes20] = ACTIONS(785),
    [anon_sym_bytes21] = ACTIONS(785),
    [anon_sym_bytes22] = ACTIONS(785),
    [anon_sym_bytes23] = ACTIONS(785),
    [anon_sym_bytes24] = ACTIONS(785),
    [anon_sym_bytes25] = ACTIONS(785),
    [anon_sym_bytes26] = ACTIONS(785),
    [anon_sym_bytes27] = ACTIONS(785),
    [anon_sym_bytes28] = ACTIONS(785),
    [anon_sym_bytes29] = ACTIONS(785),
    [anon_sym_bytes30] = ACTIONS(785),
    [anon_sym_bytes31] = ACTIONS(785),
    [anon_sym_bytes32] = ACTIONS(785),
    [anon_sym_fixed] = ACTIONS(785),
    [aux_sym__fixed_token1] = ACTIONS(785),
    [anon_sym_ufixed] = ACTIONS(785),
    [aux_sym__ufixed_token1] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(787),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_pragma] = ACTIONS(789),
    [anon_sym_import] = ACTIONS(789),
    [anon_sym_type] = ACTIONS(789),
    [anon_sym_abstract] = ACTIONS(789),
    [anon_sym_contract] = ACTIONS(789),
    [anon_sym_error] = ACTIONS(789),
    [anon_sym_interface] = ACTIONS(789),
    [anon_sym_library] = ACTIONS(789),
    [anon_sym_struct] = ACTIONS(789),
    [anon_sym_enum] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(789),
    [anon_sym_byte] = ACTIONS(789),
    [anon_sym_address] = ACTIONS(789),
    [anon_sym_var] = ACTIONS(789),
    [anon_sym_mapping] = ACTIONS(789),
    [anon_sym_bool] = ACTIONS(789),
    [anon_sym_string] = ACTIONS(789),
    [anon_sym_int] = ACTIONS(789),
    [anon_sym_int8] = ACTIONS(789),
    [anon_sym_int16] = ACTIONS(789),
    [anon_sym_int24] = ACTIONS(789),
    [anon_sym_int32] = ACTIONS(789),
    [anon_sym_int40] = ACTIONS(789),
    [anon_sym_int48] = ACTIONS(789),
    [anon_sym_int56] = ACTIONS(789),
    [anon_sym_int64] = ACTIONS(789),
    [anon_sym_int72] = ACTIONS(789),
    [anon_sym_int80] = ACTIONS(789),
    [anon_sym_int88] = ACTIONS(789),
    [anon_sym_int96] = ACTIONS(789),
    [anon_sym_int104] = ACTIONS(789),
    [anon_sym_int112] = ACTIONS(789),
    [anon_sym_int120] = ACTIONS(789),
    [anon_sym_int128] = ACTIONS(789),
    [anon_sym_int136] = ACTIONS(789),
    [anon_sym_int144] = ACTIONS(789),
    [anon_sym_int152] = ACTIONS(789),
    [anon_sym_int160] = ACTIONS(789),
    [anon_sym_int168] = ACTIONS(789),
    [anon_sym_int176] = ACTIONS(789),
    [anon_sym_int184] = ACTIONS(789),
    [anon_sym_int192] = ACTIONS(789),
    [anon_sym_int200] = ACTIONS(789),
    [anon_sym_int208] = ACTIONS(789),
    [anon_sym_int216] = ACTIONS(789),
    [anon_sym_int224] = ACTIONS(789),
    [anon_sym_int232] = ACTIONS(789),
    [anon_sym_int240] = ACTIONS(789),
    [anon_sym_int248] = ACTIONS(789),
    [anon_sym_int256] = ACTIONS(789),
    [anon_sym_uint] = ACTIONS(789),
    [anon_sym_uint8] = ACTIONS(789),
    [anon_sym_uint16] = ACTIONS(789),
    [anon_sym_uint24] = ACTIONS(789),
    [anon_sym_uint32] = ACTIONS(789),
    [anon_sym_uint40] = ACTIONS(789),
    [anon_sym_uint48] = ACTIONS(789),
    [anon_sym_uint56] = ACTIONS(789),
    [anon_sym_uint64] = ACTIONS(789),
    [anon_sym_uint72] = ACTIONS(789),
    [anon_sym_uint80] = ACTIONS(789),
    [anon_sym_uint88] = ACTIONS(789),
    [anon_sym_uint96] = ACTIONS(789),
    [anon_sym_uint104] = ACTIONS(789),
    [anon_sym_uint112] = ACTIONS(789),
    [anon_sym_uint120] = ACTIONS(789),
    [anon_sym_uint128] = ACTIONS(789),
    [anon_sym_uint136] = ACTIONS(789),
    [anon_sym_uint144] = ACTIONS(789),
    [anon_sym_uint152] = ACTIONS(789),
    [anon_sym_uint160] = ACTIONS(789),
    [anon_sym_uint168] = ACTIONS(789),
    [anon_sym_uint176] = ACTIONS(789),
    [anon_sym_uint184] = ACTIONS(789),
    [anon_sym_uint192] = ACTIONS(789),
    [anon_sym_uint200] = ACTIONS(789),
    [anon_sym_uint208] = ACTIONS(789),
    [anon_sym_uint216] = ACTIONS(789),
    [anon_sym_uint224] = ACTIONS(789),
    [anon_sym_uint232] = ACTIONS(789),
    [anon_sym_uint240] = ACTIONS(789),
    [anon_sym_uint248] = ACTIONS(789),
    [anon_sym_uint256] = ACTIONS(789),
    [anon_sym_bytes] = ACTIONS(789),
    [anon_sym_bytes1] = ACTIONS(789),
    [anon_sym_bytes2] = ACTIONS(789),
    [anon_sym_bytes3] = ACTIONS(789),
    [anon_sym_bytes4] = ACTIONS(789),
    [anon_sym_bytes5] = ACTIONS(789),
    [anon_sym_bytes6] = ACTIONS(789),
    [anon_sym_bytes7] = ACTIONS(789),
    [anon_sym_bytes8] = ACTIONS(789),
    [anon_sym_bytes9] = ACTIONS(789),
    [anon_sym_bytes10] = ACTIONS(789),
    [anon_sym_bytes11] = ACTIONS(789),
    [anon_sym_bytes12] = ACTIONS(789),
    [anon_sym_bytes13] = ACTIONS(789),
    [anon_sym_bytes14] = ACTIONS(789),
    [anon_sym_bytes15] = ACTIONS(789),
    [anon_sym_bytes16] = ACTIONS(789),
    [anon_sym_bytes17] = ACTIONS(789),
    [anon_sym_bytes18] = ACTIONS(789),
    [anon_sym_bytes19] = ACTIONS(789),
    [anon_sym_bytes20] = ACTIONS(789),
    [anon_sym_bytes21] = ACTIONS(789),
    [anon_sym_bytes22] = ACTIONS(789),
    [anon_sym_bytes23] = ACTIONS(789),
    [anon_sym_bytes24] = ACTIONS(789),
    [anon_sym_bytes25] = ACTIONS(789),
    [anon_sym_bytes26] = ACTIONS(789),
    [anon_sym_bytes27] = ACTIONS(789),
    [anon_sym_bytes28] = ACTIONS(789),
    [anon_sym_bytes29] = ACTIONS(789),
    [anon_sym_bytes30] = ACTIONS(789),
    [anon_sym_bytes31] = ACTIONS(789),
    [anon_sym_bytes32] = ACTIONS(789),
    [anon_sym_fixed] = ACTIONS(789),
    [aux_sym__fixed_token1] = ACTIONS(789),
    [anon_sym_ufixed] = ACTIONS(789),
    [aux_sym__ufixed_token1] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_error] = ACTIONS(791),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_enum] = ACTIONS(791),
    [anon_sym_event] = ACTIONS(791),
    [anon_sym_using] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_byte] = ACTIONS(791),
    [anon_sym_address] = ACTIONS(791),
    [anon_sym_var] = ACTIONS(791),
    [anon_sym_modifier] = ACTIONS(791),
    [anon_sym_constructor] = ACTIONS(791),
    [anon_sym_fallback] = ACTIONS(791),
    [anon_sym_receive] = ACTIONS(791),
    [anon_sym_mapping] = ACTIONS(791),
    [anon_sym_bool] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_int] = ACTIONS(791),
    [anon_sym_int8] = ACTIONS(791),
    [anon_sym_int16] = ACTIONS(791),
    [anon_sym_int24] = ACTIONS(791),
    [anon_sym_int32] = ACTIONS(791),
    [anon_sym_int40] = ACTIONS(791),
    [anon_sym_int48] = ACTIONS(791),
    [anon_sym_int56] = ACTIONS(791),
    [anon_sym_int64] = ACTIONS(791),
    [anon_sym_int72] = ACTIONS(791),
    [anon_sym_int80] = ACTIONS(791),
    [anon_sym_int88] = ACTIONS(791),
    [anon_sym_int96] = ACTIONS(791),
    [anon_sym_int104] = ACTIONS(791),
    [anon_sym_int112] = ACTIONS(791),
    [anon_sym_int120] = ACTIONS(791),
    [anon_sym_int128] = ACTIONS(791),
    [anon_sym_int136] = ACTIONS(791),
    [anon_sym_int144] = ACTIONS(791),
    [anon_sym_int152] = ACTIONS(791),
    [anon_sym_int160] = ACTIONS(791),
    [anon_sym_int168] = ACTIONS(791),
    [anon_sym_int176] = ACTIONS(791),
    [anon_sym_int184] = ACTIONS(791),
    [anon_sym_int192] = ACTIONS(791),
    [anon_sym_int200] = ACTIONS(791),
    [anon_sym_int208] = ACTIONS(791),
    [anon_sym_int216] = ACTIONS(791),
    [anon_sym_int224] = ACTIONS(791),
    [anon_sym_int232] = ACTIONS(791),
    [anon_sym_int240] = ACTIONS(791),
    [anon_sym_int248] = ACTIONS(791),
    [anon_sym_int256] = ACTIONS(791),
    [anon_sym_uint] = ACTIONS(791),
    [anon_sym_uint8] = ACTIONS(791),
    [anon_sym_uint16] = ACTIONS(791),
    [anon_sym_uint24] = ACTIONS(791),
    [anon_sym_uint32] = ACTIONS(791),
    [anon_sym_uint40] = ACTIONS(791),
    [anon_sym_uint48] = ACTIONS(791),
    [anon_sym_uint56] = ACTIONS(791),
    [anon_sym_uint64] = ACTIONS(791),
    [anon_sym_uint72] = ACTIONS(791),
    [anon_sym_uint80] = ACTIONS(791),
    [anon_sym_uint88] = ACTIONS(791),
    [anon_sym_uint96] = ACTIONS(791),
    [anon_sym_uint104] = ACTIONS(791),
    [anon_sym_uint112] = ACTIONS(791),
    [anon_sym_uint120] = ACTIONS(791),
    [anon_sym_uint128] = ACTIONS(791),
    [anon_sym_uint136] = ACTIONS(791),
    [anon_sym_uint144] = ACTIONS(791),
    [anon_sym_uint152] = ACTIONS(791),
    [anon_sym_uint160] = ACTIONS(791),
    [anon_sym_uint168] = ACTIONS(791),
    [anon_sym_uint176] = ACTIONS(791),
    [anon_sym_uint184] = ACTIONS(791),
    [anon_sym_uint192] = ACTIONS(791),
    [anon_sym_uint200] = ACTIONS(791),
    [anon_sym_uint208] = ACTIONS(791),
    [anon_sym_uint216] = ACTIONS(791),
    [anon_sym_uint224] = ACTIONS(791),
    [anon_sym_uint232] = ACTIONS(791),
    [anon_sym_uint240] = ACTIONS(791),
    [anon_sym_uint248] = ACTIONS(791),
    [anon_sym_uint256] = ACTIONS(791),
    [anon_sym_bytes] = ACTIONS(791),
    [anon_sym_bytes1] = ACTIONS(791),
    [anon_sym_bytes2] = ACTIONS(791),
    [anon_sym_bytes3] = ACTIONS(791),
    [anon_sym_bytes4] = ACTIONS(791),
    [anon_sym_bytes5] = ACTIONS(791),
    [anon_sym_bytes6] = ACTIONS(791),
    [anon_sym_bytes7] = ACTIONS(791),
    [anon_sym_bytes8] = ACTIONS(791),
    [anon_sym_bytes9] = ACTIONS(791),
    [anon_sym_bytes10] = ACTIONS(791),
    [anon_sym_bytes11] = ACTIONS(791),
    [anon_sym_bytes12] = ACTIONS(791),
    [anon_sym_bytes13] = ACTIONS(791),
    [anon_sym_bytes14] = ACTIONS(791),
    [anon_sym_bytes15] = ACTIONS(791),
    [anon_sym_bytes16] = ACTIONS(791),
    [anon_sym_bytes17] = ACTIONS(791),
    [anon_sym_bytes18] = ACTIONS(791),
    [anon_sym_bytes19] = ACTIONS(791),
    [anon_sym_bytes20] = ACTIONS(791),
    [anon_sym_bytes21] = ACTIONS(791),
    [anon_sym_bytes22] = ACTIONS(791),
    [anon_sym_bytes23] = ACTIONS(791),
    [anon_sym_bytes24] = ACTIONS(791),
    [anon_sym_bytes25] = ACTIONS(791),
    [anon_sym_bytes26] = ACTIONS(791),
    [anon_sym_bytes27] = ACTIONS(791),
    [anon_sym_bytes28] = ACTIONS(791),
    [anon_sym_bytes29] = ACTIONS(791),
    [anon_sym_bytes30] = ACTIONS(791),
    [anon_sym_bytes31] = ACTIONS(791),
    [anon_sym_bytes32] = ACTIONS(791),
    [anon_sym_fixed] = ACTIONS(791),
    [aux_sym__fixed_token1] = ACTIONS(791),
    [anon_sym_ufixed] = ACTIONS(791),
    [aux_sym__ufixed_token1] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(653),
    [anon_sym_error] = ACTIONS(653),
    [anon_sym_struct] = ACTIONS(653),
    [anon_sym_enum] = ACTIONS(653),
    [anon_sym_event] = ACTIONS(653),
    [anon_sym_using] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(653),
    [anon_sym_byte] = ACTIONS(653),
    [anon_sym_address] = ACTIONS(653),
    [anon_sym_var] = ACTIONS(653),
    [anon_sym_modifier] = ACTIONS(653),
    [anon_sym_constructor] = ACTIONS(653),
    [anon_sym_fallback] = ACTIONS(653),
    [anon_sym_receive] = ACTIONS(653),
    [anon_sym_mapping] = ACTIONS(653),
    [anon_sym_bool] = ACTIONS(653),
    [anon_sym_string] = ACTIONS(653),
    [anon_sym_int] = ACTIONS(653),
    [anon_sym_int8] = ACTIONS(653),
    [anon_sym_int16] = ACTIONS(653),
    [anon_sym_int24] = ACTIONS(653),
    [anon_sym_int32] = ACTIONS(653),
    [anon_sym_int40] = ACTIONS(653),
    [anon_sym_int48] = ACTIONS(653),
    [anon_sym_int56] = ACTIONS(653),
    [anon_sym_int64] = ACTIONS(653),
    [anon_sym_int72] = ACTIONS(653),
    [anon_sym_int80] = ACTIONS(653),
    [anon_sym_int88] = ACTIONS(653),
    [anon_sym_int96] = ACTIONS(653),
    [anon_sym_int104] = ACTIONS(653),
    [anon_sym_int112] = ACTIONS(653),
    [anon_sym_int120] = ACTIONS(653),
    [anon_sym_int128] = ACTIONS(653),
    [anon_sym_int136] = ACTIONS(653),
    [anon_sym_int144] = ACTIONS(653),
    [anon_sym_int152] = ACTIONS(653),
    [anon_sym_int160] = ACTIONS(653),
    [anon_sym_int168] = ACTIONS(653),
    [anon_sym_int176] = ACTIONS(653),
    [anon_sym_int184] = ACTIONS(653),
    [anon_sym_int192] = ACTIONS(653),
    [anon_sym_int200] = ACTIONS(653),
    [anon_sym_int208] = ACTIONS(653),
    [anon_sym_int216] = ACTIONS(653),
    [anon_sym_int224] = ACTIONS(653),
    [anon_sym_int232] = ACTIONS(653),
    [anon_sym_int240] = ACTIONS(653),
    [anon_sym_int248] = ACTIONS(653),
    [anon_sym_int256] = ACTIONS(653),
    [anon_sym_uint] = ACTIONS(653),
    [anon_sym_uint8] = ACTIONS(653),
    [anon_sym_uint16] = ACTIONS(653),
    [anon_sym_uint24] = ACTIONS(653),
    [anon_sym_uint32] = ACTIONS(653),
    [anon_sym_uint40] = ACTIONS(653),
    [anon_sym_uint48] = ACTIONS(653),
    [anon_sym_uint56] = ACTIONS(653),
    [anon_sym_uint64] = ACTIONS(653),
    [anon_sym_uint72] = ACTIONS(653),
    [anon_sym_uint80] = ACTIONS(653),
    [anon_sym_uint88] = ACTIONS(653),
    [anon_sym_uint96] = ACTIONS(653),
    [anon_sym_uint104] = ACTIONS(653),
    [anon_sym_uint112] = ACTIONS(653),
    [anon_sym_uint120] = ACTIONS(653),
    [anon_sym_uint128] = ACTIONS(653),
    [anon_sym_uint136] = ACTIONS(653),
    [anon_sym_uint144] = ACTIONS(653),
    [anon_sym_uint152] = ACTIONS(653),
    [anon_sym_uint160] = ACTIONS(653),
    [anon_sym_uint168] = ACTIONS(653),
    [anon_sym_uint176] = ACTIONS(653),
    [anon_sym_uint184] = ACTIONS(653),
    [anon_sym_uint192] = ACTIONS(653),
    [anon_sym_uint200] = ACTIONS(653),
    [anon_sym_uint208] = ACTIONS(653),
    [anon_sym_uint216] = ACTIONS(653),
    [anon_sym_uint224] = ACTIONS(653),
    [anon_sym_uint232] = ACTIONS(653),
    [anon_sym_uint240] = ACTIONS(653),
    [anon_sym_uint248] = ACTIONS(653),
    [anon_sym_uint256] = ACTIONS(653),
    [anon_sym_bytes] = ACTIONS(653),
    [anon_sym_bytes1] = ACTIONS(653),
    [anon_sym_bytes2] = ACTIONS(653),
    [anon_sym_bytes3] = ACTIONS(653),
    [anon_sym_bytes4] = ACTIONS(653),
    [anon_sym_bytes5] = ACTIONS(653),
    [anon_sym_bytes6] = ACTIONS(653),
    [anon_sym_bytes7] = ACTIONS(653),
    [anon_sym_bytes8] = ACTIONS(653),
    [anon_sym_bytes9] = ACTIONS(653),
    [anon_sym_bytes10] = ACTIONS(653),
    [anon_sym_bytes11] = ACTIONS(653),
    [anon_sym_bytes12] = ACTIONS(653),
    [anon_sym_bytes13] = ACTIONS(653),
    [anon_sym_bytes14] = ACTIONS(653),
    [anon_sym_bytes15] = ACTIONS(653),
    [anon_sym_bytes16] = ACTIONS(653),
    [anon_sym_bytes17] = ACTIONS(653),
    [anon_sym_bytes18] = ACTIONS(653),
    [anon_sym_bytes19] = ACTIONS(653),
    [anon_sym_bytes20] = ACTIONS(653),
    [anon_sym_bytes21] = ACTIONS(653),
    [anon_sym_bytes22] = ACTIONS(653),
    [anon_sym_bytes23] = ACTIONS(653),
    [anon_sym_bytes24] = ACTIONS(653),
    [anon_sym_bytes25] = ACTIONS(653),
    [anon_sym_bytes26] = ACTIONS(653),
    [anon_sym_bytes27] = ACTIONS(653),
    [anon_sym_bytes28] = ACTIONS(653),
    [anon_sym_bytes29] = ACTIONS(653),
    [anon_sym_bytes30] = ACTIONS(653),
    [anon_sym_bytes31] = ACTIONS(653),
    [anon_sym_bytes32] = ACTIONS(653),
    [anon_sym_fixed] = ACTIONS(653),
    [aux_sym__fixed_token1] = ACTIONS(653),
    [anon_sym_ufixed] = ACTIONS(653),
    [aux_sym__ufixed_token1] = ACTIONS(653),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(609),
    [sym_identifier] = ACTIONS(607),
    [anon_sym_pragma] = ACTIONS(607),
    [anon_sym_import] = ACTIONS(607),
    [anon_sym_type] = ACTIONS(607),
    [anon_sym_abstract] = ACTIONS(607),
    [anon_sym_contract] = ACTIONS(607),
    [anon_sym_error] = ACTIONS(607),
    [anon_sym_interface] = ACTIONS(607),
    [anon_sym_library] = ACTIONS(607),
    [anon_sym_struct] = ACTIONS(607),
    [anon_sym_enum] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(607),
    [anon_sym_byte] = ACTIONS(607),
    [anon_sym_address] = ACTIONS(607),
    [anon_sym_var] = ACTIONS(607),
    [anon_sym_mapping] = ACTIONS(607),
    [anon_sym_bool] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_int8] = ACTIONS(607),
    [anon_sym_int16] = ACTIONS(607),
    [anon_sym_int24] = ACTIONS(607),
    [anon_sym_int32] = ACTIONS(607),
    [anon_sym_int40] = ACTIONS(607),
    [anon_sym_int48] = ACTIONS(607),
    [anon_sym_int56] = ACTIONS(607),
    [anon_sym_int64] = ACTIONS(607),
    [anon_sym_int72] = ACTIONS(607),
    [anon_sym_int80] = ACTIONS(607),
    [anon_sym_int88] = ACTIONS(607),
    [anon_sym_int96] = ACTIONS(607),
    [anon_sym_int104] = ACTIONS(607),
    [anon_sym_int112] = ACTIONS(607),
    [anon_sym_int120] = ACTIONS(607),
    [anon_sym_int128] = ACTIONS(607),
    [anon_sym_int136] = ACTIONS(607),
    [anon_sym_int144] = ACTIONS(607),
    [anon_sym_int152] = ACTIONS(607),
    [anon_sym_int160] = ACTIONS(607),
    [anon_sym_int168] = ACTIONS(607),
    [anon_sym_int176] = ACTIONS(607),
    [anon_sym_int184] = ACTIONS(607),
    [anon_sym_int192] = ACTIONS(607),
    [anon_sym_int200] = ACTIONS(607),
    [anon_sym_int208] = ACTIONS(607),
    [anon_sym_int216] = ACTIONS(607),
    [anon_sym_int224] = ACTIONS(607),
    [anon_sym_int232] = ACTIONS(607),
    [anon_sym_int240] = ACTIONS(607),
    [anon_sym_int248] = ACTIONS(607),
    [anon_sym_int256] = ACTIONS(607),
    [anon_sym_uint] = ACTIONS(607),
    [anon_sym_uint8] = ACTIONS(607),
    [anon_sym_uint16] = ACTIONS(607),
    [anon_sym_uint24] = ACTIONS(607),
    [anon_sym_uint32] = ACTIONS(607),
    [anon_sym_uint40] = ACTIONS(607),
    [anon_sym_uint48] = ACTIONS(607),
    [anon_sym_uint56] = ACTIONS(607),
    [anon_sym_uint64] = ACTIONS(607),
    [anon_sym_uint72] = ACTIONS(607),
    [anon_sym_uint80] = ACTIONS(607),
    [anon_sym_uint88] = ACTIONS(607),
    [anon_sym_uint96] = ACTIONS(607),
    [anon_sym_uint104] = ACTIONS(607),
    [anon_sym_uint112] = ACTIONS(607),
    [anon_sym_uint120] = ACTIONS(607),
    [anon_sym_uint128] = ACTIONS(607),
    [anon_sym_uint136] = ACTIONS(607),
    [anon_sym_uint144] = ACTIONS(607),
    [anon_sym_uint152] = ACTIONS(607),
    [anon_sym_uint160] = ACTIONS(607),
    [anon_sym_uint168] = ACTIONS(607),
    [anon_sym_uint176] = ACTIONS(607),
    [anon_sym_uint184] = ACTIONS(607),
    [anon_sym_uint192] = ACTIONS(607),
    [anon_sym_uint200] = ACTIONS(607),
    [anon_sym_uint208] = ACTIONS(607),
    [anon_sym_uint216] = ACTIONS(607),
    [anon_sym_uint224] = ACTIONS(607),
    [anon_sym_uint232] = ACTIONS(607),
    [anon_sym_uint240] = ACTIONS(607),
    [anon_sym_uint248] = ACTIONS(607),
    [anon_sym_uint256] = ACTIONS(607),
    [anon_sym_bytes] = ACTIONS(607),
    [anon_sym_bytes1] = ACTIONS(607),
    [anon_sym_bytes2] = ACTIONS(607),
    [anon_sym_bytes3] = ACTIONS(607),
    [anon_sym_bytes4] = ACTIONS(607),
    [anon_sym_bytes5] = ACTIONS(607),
    [anon_sym_bytes6] = ACTIONS(607),
    [anon_sym_bytes7] = ACTIONS(607),
    [anon_sym_bytes8] = ACTIONS(607),
    [anon_sym_bytes9] = ACTIONS(607),
    [anon_sym_bytes10] = ACTIONS(607),
    [anon_sym_bytes11] = ACTIONS(607),
    [anon_sym_bytes12] = ACTIONS(607),
    [anon_sym_bytes13] = ACTIONS(607),
    [anon_sym_bytes14] = ACTIONS(607),
    [anon_sym_bytes15] = ACTIONS(607),
    [anon_sym_bytes16] = ACTIONS(607),
    [anon_sym_bytes17] = ACTIONS(607),
    [anon_sym_bytes18] = ACTIONS(607),
    [anon_sym_bytes19] = ACTIONS(607),
    [anon_sym_bytes20] = ACTIONS(607),
    [anon_sym_bytes21] = ACTIONS(607),
    [anon_sym_bytes22] = ACTIONS(607),
    [anon_sym_bytes23] = ACTIONS(607),
    [anon_sym_bytes24] = ACTIONS(607),
    [anon_sym_bytes25] = ACTIONS(607),
    [anon_sym_bytes26] = ACTIONS(607),
    [anon_sym_bytes27] = ACTIONS(607),
    [anon_sym_bytes28] = ACTIONS(607),
    [anon_sym_bytes29] = ACTIONS(607),
    [anon_sym_bytes30] = ACTIONS(607),
    [anon_sym_bytes31] = ACTIONS(607),
    [anon_sym_bytes32] = ACTIONS(607),
    [anon_sym_fixed] = ACTIONS(607),
    [aux_sym__fixed_token1] = ACTIONS(607),
    [anon_sym_ufixed] = ACTIONS(607),
    [aux_sym__ufixed_token1] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_type] = ACTIONS(657),
    [anon_sym_error] = ACTIONS(657),
    [anon_sym_struct] = ACTIONS(657),
    [anon_sym_enum] = ACTIONS(657),
    [anon_sym_event] = ACTIONS(657),
    [anon_sym_using] = ACTIONS(657),
    [anon_sym_function] = ACTIONS(657),
    [anon_sym_byte] = ACTIONS(657),
    [anon_sym_address] = ACTIONS(657),
    [anon_sym_var] = ACTIONS(657),
    [anon_sym_modifier] = ACTIONS(657),
    [anon_sym_constructor] = ACTIONS(657),
    [anon_sym_fallback] = ACTIONS(657),
    [anon_sym_receive] = ACTIONS(657),
    [anon_sym_mapping] = ACTIONS(657),
    [anon_sym_bool] = ACTIONS(657),
    [anon_sym_string] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_int8] = ACTIONS(657),
    [anon_sym_int16] = ACTIONS(657),
    [anon_sym_int24] = ACTIONS(657),
    [anon_sym_int32] = ACTIONS(657),
    [anon_sym_int40] = ACTIONS(657),
    [anon_sym_int48] = ACTIONS(657),
    [anon_sym_int56] = ACTIONS(657),
    [anon_sym_int64] = ACTIONS(657),
    [anon_sym_int72] = ACTIONS(657),
    [anon_sym_int80] = ACTIONS(657),
    [anon_sym_int88] = ACTIONS(657),
    [anon_sym_int96] = ACTIONS(657),
    [anon_sym_int104] = ACTIONS(657),
    [anon_sym_int112] = ACTIONS(657),
    [anon_sym_int120] = ACTIONS(657),
    [anon_sym_int128] = ACTIONS(657),
    [anon_sym_int136] = ACTIONS(657),
    [anon_sym_int144] = ACTIONS(657),
    [anon_sym_int152] = ACTIONS(657),
    [anon_sym_int160] = ACTIONS(657),
    [anon_sym_int168] = ACTIONS(657),
    [anon_sym_int176] = ACTIONS(657),
    [anon_sym_int184] = ACTIONS(657),
    [anon_sym_int192] = ACTIONS(657),
    [anon_sym_int200] = ACTIONS(657),
    [anon_sym_int208] = ACTIONS(657),
    [anon_sym_int216] = ACTIONS(657),
    [anon_sym_int224] = ACTIONS(657),
    [anon_sym_int232] = ACTIONS(657),
    [anon_sym_int240] = ACTIONS(657),
    [anon_sym_int248] = ACTIONS(657),
    [anon_sym_int256] = ACTIONS(657),
    [anon_sym_uint] = ACTIONS(657),
    [anon_sym_uint8] = ACTIONS(657),
    [anon_sym_uint16] = ACTIONS(657),
    [anon_sym_uint24] = ACTIONS(657),
    [anon_sym_uint32] = ACTIONS(657),
    [anon_sym_uint40] = ACTIONS(657),
    [anon_sym_uint48] = ACTIONS(657),
    [anon_sym_uint56] = ACTIONS(657),
    [anon_sym_uint64] = ACTIONS(657),
    [anon_sym_uint72] = ACTIONS(657),
    [anon_sym_uint80] = ACTIONS(657),
    [anon_sym_uint88] = ACTIONS(657),
    [anon_sym_uint96] = ACTIONS(657),
    [anon_sym_uint104] = ACTIONS(657),
    [anon_sym_uint112] = ACTIONS(657),
    [anon_sym_uint120] = ACTIONS(657),
    [anon_sym_uint128] = ACTIONS(657),
    [anon_sym_uint136] = ACTIONS(657),
    [anon_sym_uint144] = ACTIONS(657),
    [anon_sym_uint152] = ACTIONS(657),
    [anon_sym_uint160] = ACTIONS(657),
    [anon_sym_uint168] = ACTIONS(657),
    [anon_sym_uint176] = ACTIONS(657),
    [anon_sym_uint184] = ACTIONS(657),
    [anon_sym_uint192] = ACTIONS(657),
    [anon_sym_uint200] = ACTIONS(657),
    [anon_sym_uint208] = ACTIONS(657),
    [anon_sym_uint216] = ACTIONS(657),
    [anon_sym_uint224] = ACTIONS(657),
    [anon_sym_uint232] = ACTIONS(657),
    [anon_sym_uint240] = ACTIONS(657),
    [anon_sym_uint248] = ACTIONS(657),
    [anon_sym_uint256] = ACTIONS(657),
    [anon_sym_bytes] = ACTIONS(657),
    [anon_sym_bytes1] = ACTIONS(657),
    [anon_sym_bytes2] = ACTIONS(657),
    [anon_sym_bytes3] = ACTIONS(657),
    [anon_sym_bytes4] = ACTIONS(657),
    [anon_sym_bytes5] = ACTIONS(657),
    [anon_sym_bytes6] = ACTIONS(657),
    [anon_sym_bytes7] = ACTIONS(657),
    [anon_sym_bytes8] = ACTIONS(657),
    [anon_sym_bytes9] = ACTIONS(657),
    [anon_sym_bytes10] = ACTIONS(657),
    [anon_sym_bytes11] = ACTIONS(657),
    [anon_sym_bytes12] = ACTIONS(657),
    [anon_sym_bytes13] = ACTIONS(657),
    [anon_sym_bytes14] = ACTIONS(657),
    [anon_sym_bytes15] = ACTIONS(657),
    [anon_sym_bytes16] = ACTIONS(657),
    [anon_sym_bytes17] = ACTIONS(657),
    [anon_sym_bytes18] = ACTIONS(657),
    [anon_sym_bytes19] = ACTIONS(657),
    [anon_sym_bytes20] = ACTIONS(657),
    [anon_sym_bytes21] = ACTIONS(657),
    [anon_sym_bytes22] = ACTIONS(657),
    [anon_sym_bytes23] = ACTIONS(657),
    [anon_sym_bytes24] = ACTIONS(657),
    [anon_sym_bytes25] = ACTIONS(657),
    [anon_sym_bytes26] = ACTIONS(657),
    [anon_sym_bytes27] = ACTIONS(657),
    [anon_sym_bytes28] = ACTIONS(657),
    [anon_sym_bytes29] = ACTIONS(657),
    [anon_sym_bytes30] = ACTIONS(657),
    [anon_sym_bytes31] = ACTIONS(657),
    [anon_sym_bytes32] = ACTIONS(657),
    [anon_sym_fixed] = ACTIONS(657),
    [aux_sym__fixed_token1] = ACTIONS(657),
    [anon_sym_ufixed] = ACTIONS(657),
    [aux_sym__ufixed_token1] = ACTIONS(657),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_pragma] = ACTIONS(615),
    [anon_sym_import] = ACTIONS(615),
    [anon_sym_type] = ACTIONS(615),
    [anon_sym_abstract] = ACTIONS(615),
    [anon_sym_contract] = ACTIONS(615),
    [anon_sym_error] = ACTIONS(615),
    [anon_sym_interface] = ACTIONS(615),
    [anon_sym_library] = ACTIONS(615),
    [anon_sym_struct] = ACTIONS(615),
    [anon_sym_enum] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(615),
    [anon_sym_byte] = ACTIONS(615),
    [anon_sym_address] = ACTIONS(615),
    [anon_sym_var] = ACTIONS(615),
    [anon_sym_mapping] = ACTIONS(615),
    [anon_sym_bool] = ACTIONS(615),
    [anon_sym_string] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_int8] = ACTIONS(615),
    [anon_sym_int16] = ACTIONS(615),
    [anon_sym_int24] = ACTIONS(615),
    [anon_sym_int32] = ACTIONS(615),
    [anon_sym_int40] = ACTIONS(615),
    [anon_sym_int48] = ACTIONS(615),
    [anon_sym_int56] = ACTIONS(615),
    [anon_sym_int64] = ACTIONS(615),
    [anon_sym_int72] = ACTIONS(615),
    [anon_sym_int80] = ACTIONS(615),
    [anon_sym_int88] = ACTIONS(615),
    [anon_sym_int96] = ACTIONS(615),
    [anon_sym_int104] = ACTIONS(615),
    [anon_sym_int112] = ACTIONS(615),
    [anon_sym_int120] = ACTIONS(615),
    [anon_sym_int128] = ACTIONS(615),
    [anon_sym_int136] = ACTIONS(615),
    [anon_sym_int144] = ACTIONS(615),
    [anon_sym_int152] = ACTIONS(615),
    [anon_sym_int160] = ACTIONS(615),
    [anon_sym_int168] = ACTIONS(615),
    [anon_sym_int176] = ACTIONS(615),
    [anon_sym_int184] = ACTIONS(615),
    [anon_sym_int192] = ACTIONS(615),
    [anon_sym_int200] = ACTIONS(615),
    [anon_sym_int208] = ACTIONS(615),
    [anon_sym_int216] = ACTIONS(615),
    [anon_sym_int224] = ACTIONS(615),
    [anon_sym_int232] = ACTIONS(615),
    [anon_sym_int240] = ACTIONS(615),
    [anon_sym_int248] = ACTIONS(615),
    [anon_sym_int256] = ACTIONS(615),
    [anon_sym_uint] = ACTIONS(615),
    [anon_sym_uint8] = ACTIONS(615),
    [anon_sym_uint16] = ACTIONS(615),
    [anon_sym_uint24] = ACTIONS(615),
    [anon_sym_uint32] = ACTIONS(615),
    [anon_sym_uint40] = ACTIONS(615),
    [anon_sym_uint48] = ACTIONS(615),
    [anon_sym_uint56] = ACTIONS(615),
    [anon_sym_uint64] = ACTIONS(615),
    [anon_sym_uint72] = ACTIONS(615),
    [anon_sym_uint80] = ACTIONS(615),
    [anon_sym_uint88] = ACTIONS(615),
    [anon_sym_uint96] = ACTIONS(615),
    [anon_sym_uint104] = ACTIONS(615),
    [anon_sym_uint112] = ACTIONS(615),
    [anon_sym_uint120] = ACTIONS(615),
    [anon_sym_uint128] = ACTIONS(615),
    [anon_sym_uint136] = ACTIONS(615),
    [anon_sym_uint144] = ACTIONS(615),
    [anon_sym_uint152] = ACTIONS(615),
    [anon_sym_uint160] = ACTIONS(615),
    [anon_sym_uint168] = ACTIONS(615),
    [anon_sym_uint176] = ACTIONS(615),
    [anon_sym_uint184] = ACTIONS(615),
    [anon_sym_uint192] = ACTIONS(615),
    [anon_sym_uint200] = ACTIONS(615),
    [anon_sym_uint208] = ACTIONS(615),
    [anon_sym_uint216] = ACTIONS(615),
    [anon_sym_uint224] = ACTIONS(615),
    [anon_sym_uint232] = ACTIONS(615),
    [anon_sym_uint240] = ACTIONS(615),
    [anon_sym_uint248] = ACTIONS(615),
    [anon_sym_uint256] = ACTIONS(615),
    [anon_sym_bytes] = ACTIONS(615),
    [anon_sym_bytes1] = ACTIONS(615),
    [anon_sym_bytes2] = ACTIONS(615),
    [anon_sym_bytes3] = ACTIONS(615),
    [anon_sym_bytes4] = ACTIONS(615),
    [anon_sym_bytes5] = ACTIONS(615),
    [anon_sym_bytes6] = ACTIONS(615),
    [anon_sym_bytes7] = ACTIONS(615),
    [anon_sym_bytes8] = ACTIONS(615),
    [anon_sym_bytes9] = ACTIONS(615),
    [anon_sym_bytes10] = ACTIONS(615),
    [anon_sym_bytes11] = ACTIONS(615),
    [anon_sym_bytes12] = ACTIONS(615),
    [anon_sym_bytes13] = ACTIONS(615),
    [anon_sym_bytes14] = ACTIONS(615),
    [anon_sym_bytes15] = ACTIONS(615),
    [anon_sym_bytes16] = ACTIONS(615),
    [anon_sym_bytes17] = ACTIONS(615),
    [anon_sym_bytes18] = ACTIONS(615),
    [anon_sym_bytes19] = ACTIONS(615),
    [anon_sym_bytes20] = ACTIONS(615),
    [anon_sym_bytes21] = ACTIONS(615),
    [anon_sym_bytes22] = ACTIONS(615),
    [anon_sym_bytes23] = ACTIONS(615),
    [anon_sym_bytes24] = ACTIONS(615),
    [anon_sym_bytes25] = ACTIONS(615),
    [anon_sym_bytes26] = ACTIONS(615),
    [anon_sym_bytes27] = ACTIONS(615),
    [anon_sym_bytes28] = ACTIONS(615),
    [anon_sym_bytes29] = ACTIONS(615),
    [anon_sym_bytes30] = ACTIONS(615),
    [anon_sym_bytes31] = ACTIONS(615),
    [anon_sym_bytes32] = ACTIONS(615),
    [anon_sym_fixed] = ACTIONS(615),
    [aux_sym__fixed_token1] = ACTIONS(615),
    [anon_sym_ufixed] = ACTIONS(615),
    [aux_sym__ufixed_token1] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(795),
    [sym_identifier] = ACTIONS(797),
    [anon_sym_pragma] = ACTIONS(797),
    [anon_sym_import] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_abstract] = ACTIONS(797),
    [anon_sym_contract] = ACTIONS(797),
    [anon_sym_error] = ACTIONS(797),
    [anon_sym_interface] = ACTIONS(797),
    [anon_sym_library] = ACTIONS(797),
    [anon_sym_struct] = ACTIONS(797),
    [anon_sym_enum] = ACTIONS(797),
    [anon_sym_function] = ACTIONS(797),
    [anon_sym_byte] = ACTIONS(797),
    [anon_sym_address] = ACTIONS(797),
    [anon_sym_var] = ACTIONS(797),
    [anon_sym_mapping] = ACTIONS(797),
    [anon_sym_bool] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_int] = ACTIONS(797),
    [anon_sym_int8] = ACTIONS(797),
    [anon_sym_int16] = ACTIONS(797),
    [anon_sym_int24] = ACTIONS(797),
    [anon_sym_int32] = ACTIONS(797),
    [anon_sym_int40] = ACTIONS(797),
    [anon_sym_int48] = ACTIONS(797),
    [anon_sym_int56] = ACTIONS(797),
    [anon_sym_int64] = ACTIONS(797),
    [anon_sym_int72] = ACTIONS(797),
    [anon_sym_int80] = ACTIONS(797),
    [anon_sym_int88] = ACTIONS(797),
    [anon_sym_int96] = ACTIONS(797),
    [anon_sym_int104] = ACTIONS(797),
    [anon_sym_int112] = ACTIONS(797),
    [anon_sym_int120] = ACTIONS(797),
    [anon_sym_int128] = ACTIONS(797),
    [anon_sym_int136] = ACTIONS(797),
    [anon_sym_int144] = ACTIONS(797),
    [anon_sym_int152] = ACTIONS(797),
    [anon_sym_int160] = ACTIONS(797),
    [anon_sym_int168] = ACTIONS(797),
    [anon_sym_int176] = ACTIONS(797),
    [anon_sym_int184] = ACTIONS(797),
    [anon_sym_int192] = ACTIONS(797),
    [anon_sym_int200] = ACTIONS(797),
    [anon_sym_int208] = ACTIONS(797),
    [anon_sym_int216] = ACTIONS(797),
    [anon_sym_int224] = ACTIONS(797),
    [anon_sym_int232] = ACTIONS(797),
    [anon_sym_int240] = ACTIONS(797),
    [anon_sym_int248] = ACTIONS(797),
    [anon_sym_int256] = ACTIONS(797),
    [anon_sym_uint] = ACTIONS(797),
    [anon_sym_uint8] = ACTIONS(797),
    [anon_sym_uint16] = ACTIONS(797),
    [anon_sym_uint24] = ACTIONS(797),
    [anon_sym_uint32] = ACTIONS(797),
    [anon_sym_uint40] = ACTIONS(797),
    [anon_sym_uint48] = ACTIONS(797),
    [anon_sym_uint56] = ACTIONS(797),
    [anon_sym_uint64] = ACTIONS(797),
    [anon_sym_uint72] = ACTIONS(797),
    [anon_sym_uint80] = ACTIONS(797),
    [anon_sym_uint88] = ACTIONS(797),
    [anon_sym_uint96] = ACTIONS(797),
    [anon_sym_uint104] = ACTIONS(797),
    [anon_sym_uint112] = ACTIONS(797),
    [anon_sym_uint120] = ACTIONS(797),
    [anon_sym_uint128] = ACTIONS(797),
    [anon_sym_uint136] = ACTIONS(797),
    [anon_sym_uint144] = ACTIONS(797),
    [anon_sym_uint152] = ACTIONS(797),
    [anon_sym_uint160] = ACTIONS(797),
    [anon_sym_uint168] = ACTIONS(797),
    [anon_sym_uint176] = ACTIONS(797),
    [anon_sym_uint184] = ACTIONS(797),
    [anon_sym_uint192] = ACTIONS(797),
    [anon_sym_uint200] = ACTIONS(797),
    [anon_sym_uint208] = ACTIONS(797),
    [anon_sym_uint216] = ACTIONS(797),
    [anon_sym_uint224] = ACTIONS(797),
    [anon_sym_uint232] = ACTIONS(797),
    [anon_sym_uint240] = ACTIONS(797),
    [anon_sym_uint248] = ACTIONS(797),
    [anon_sym_uint256] = ACTIONS(797),
    [anon_sym_bytes] = ACTIONS(797),
    [anon_sym_bytes1] = ACTIONS(797),
    [anon_sym_bytes2] = ACTIONS(797),
    [anon_sym_bytes3] = ACTIONS(797),
    [anon_sym_bytes4] = ACTIONS(797),
    [anon_sym_bytes5] = ACTIONS(797),
    [anon_sym_bytes6] = ACTIONS(797),
    [anon_sym_bytes7] = ACTIONS(797),
    [anon_sym_bytes8] = ACTIONS(797),
    [anon_sym_bytes9] = ACTIONS(797),
    [anon_sym_bytes10] = ACTIONS(797),
    [anon_sym_bytes11] = ACTIONS(797),
    [anon_sym_bytes12] = ACTIONS(797),
    [anon_sym_bytes13] = ACTIONS(797),
    [anon_sym_bytes14] = ACTIONS(797),
    [anon_sym_bytes15] = ACTIONS(797),
    [anon_sym_bytes16] = ACTIONS(797),
    [anon_sym_bytes17] = ACTIONS(797),
    [anon_sym_bytes18] = ACTIONS(797),
    [anon_sym_bytes19] = ACTIONS(797),
    [anon_sym_bytes20] = ACTIONS(797),
    [anon_sym_bytes21] = ACTIONS(797),
    [anon_sym_bytes22] = ACTIONS(797),
    [anon_sym_bytes23] = ACTIONS(797),
    [anon_sym_bytes24] = ACTIONS(797),
    [anon_sym_bytes25] = ACTIONS(797),
    [anon_sym_bytes26] = ACTIONS(797),
    [anon_sym_bytes27] = ACTIONS(797),
    [anon_sym_bytes28] = ACTIONS(797),
    [anon_sym_bytes29] = ACTIONS(797),
    [anon_sym_bytes30] = ACTIONS(797),
    [anon_sym_bytes31] = ACTIONS(797),
    [anon_sym_bytes32] = ACTIONS(797),
    [anon_sym_fixed] = ACTIONS(797),
    [aux_sym__fixed_token1] = ACTIONS(797),
    [anon_sym_ufixed] = ACTIONS(797),
    [aux_sym__ufixed_token1] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(799),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_pragma] = ACTIONS(801),
    [anon_sym_import] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_abstract] = ACTIONS(801),
    [anon_sym_contract] = ACTIONS(801),
    [anon_sym_error] = ACTIONS(801),
    [anon_sym_interface] = ACTIONS(801),
    [anon_sym_library] = ACTIONS(801),
    [anon_sym_struct] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_byte] = ACTIONS(801),
    [anon_sym_address] = ACTIONS(801),
    [anon_sym_var] = ACTIONS(801),
    [anon_sym_mapping] = ACTIONS(801),
    [anon_sym_bool] = ACTIONS(801),
    [anon_sym_string] = ACTIONS(801),
    [anon_sym_int] = ACTIONS(801),
    [anon_sym_int8] = ACTIONS(801),
    [anon_sym_int16] = ACTIONS(801),
    [anon_sym_int24] = ACTIONS(801),
    [anon_sym_int32] = ACTIONS(801),
    [anon_sym_int40] = ACTIONS(801),
    [anon_sym_int48] = ACTIONS(801),
    [anon_sym_int56] = ACTIONS(801),
    [anon_sym_int64] = ACTIONS(801),
    [anon_sym_int72] = ACTIONS(801),
    [anon_sym_int80] = ACTIONS(801),
    [anon_sym_int88] = ACTIONS(801),
    [anon_sym_int96] = ACTIONS(801),
    [anon_sym_int104] = ACTIONS(801),
    [anon_sym_int112] = ACTIONS(801),
    [anon_sym_int120] = ACTIONS(801),
    [anon_sym_int128] = ACTIONS(801),
    [anon_sym_int136] = ACTIONS(801),
    [anon_sym_int144] = ACTIONS(801),
    [anon_sym_int152] = ACTIONS(801),
    [anon_sym_int160] = ACTIONS(801),
    [anon_sym_int168] = ACTIONS(801),
    [anon_sym_int176] = ACTIONS(801),
    [anon_sym_int184] = ACTIONS(801),
    [anon_sym_int192] = ACTIONS(801),
    [anon_sym_int200] = ACTIONS(801),
    [anon_sym_int208] = ACTIONS(801),
    [anon_sym_int216] = ACTIONS(801),
    [anon_sym_int224] = ACTIONS(801),
    [anon_sym_int232] = ACTIONS(801),
    [anon_sym_int240] = ACTIONS(801),
    [anon_sym_int248] = ACTIONS(801),
    [anon_sym_int256] = ACTIONS(801),
    [anon_sym_uint] = ACTIONS(801),
    [anon_sym_uint8] = ACTIONS(801),
    [anon_sym_uint16] = ACTIONS(801),
    [anon_sym_uint24] = ACTIONS(801),
    [anon_sym_uint32] = ACTIONS(801),
    [anon_sym_uint40] = ACTIONS(801),
    [anon_sym_uint48] = ACTIONS(801),
    [anon_sym_uint56] = ACTIONS(801),
    [anon_sym_uint64] = ACTIONS(801),
    [anon_sym_uint72] = ACTIONS(801),
    [anon_sym_uint80] = ACTIONS(801),
    [anon_sym_uint88] = ACTIONS(801),
    [anon_sym_uint96] = ACTIONS(801),
    [anon_sym_uint104] = ACTIONS(801),
    [anon_sym_uint112] = ACTIONS(801),
    [anon_sym_uint120] = ACTIONS(801),
    [anon_sym_uint128] = ACTIONS(801),
    [anon_sym_uint136] = ACTIONS(801),
    [anon_sym_uint144] = ACTIONS(801),
    [anon_sym_uint152] = ACTIONS(801),
    [anon_sym_uint160] = ACTIONS(801),
    [anon_sym_uint168] = ACTIONS(801),
    [anon_sym_uint176] = ACTIONS(801),
    [anon_sym_uint184] = ACTIONS(801),
    [anon_sym_uint192] = ACTIONS(801),
    [anon_sym_uint200] = ACTIONS(801),
    [anon_sym_uint208] = ACTIONS(801),
    [anon_sym_uint216] = ACTIONS(801),
    [anon_sym_uint224] = ACTIONS(801),
    [anon_sym_uint232] = ACTIONS(801),
    [anon_sym_uint240] = ACTIONS(801),
    [anon_sym_uint248] = ACTIONS(801),
    [anon_sym_uint256] = ACTIONS(801),
    [anon_sym_bytes] = ACTIONS(801),
    [anon_sym_bytes1] = ACTIONS(801),
    [anon_sym_bytes2] = ACTIONS(801),
    [anon_sym_bytes3] = ACTIONS(801),
    [anon_sym_bytes4] = ACTIONS(801),
    [anon_sym_bytes5] = ACTIONS(801),
    [anon_sym_bytes6] = ACTIONS(801),
    [anon_sym_bytes7] = ACTIONS(801),
    [anon_sym_bytes8] = ACTIONS(801),
    [anon_sym_bytes9] = ACTIONS(801),
    [anon_sym_bytes10] = ACTIONS(801),
    [anon_sym_bytes11] = ACTIONS(801),
    [anon_sym_bytes12] = ACTIONS(801),
    [anon_sym_bytes13] = ACTIONS(801),
    [anon_sym_bytes14] = ACTIONS(801),
    [anon_sym_bytes15] = ACTIONS(801),
    [anon_sym_bytes16] = ACTIONS(801),
    [anon_sym_bytes17] = ACTIONS(801),
    [anon_sym_bytes18] = ACTIONS(801),
    [anon_sym_bytes19] = ACTIONS(801),
    [anon_sym_bytes20] = ACTIONS(801),
    [anon_sym_bytes21] = ACTIONS(801),
    [anon_sym_bytes22] = ACTIONS(801),
    [anon_sym_bytes23] = ACTIONS(801),
    [anon_sym_bytes24] = ACTIONS(801),
    [anon_sym_bytes25] = ACTIONS(801),
    [anon_sym_bytes26] = ACTIONS(801),
    [anon_sym_bytes27] = ACTIONS(801),
    [anon_sym_bytes28] = ACTIONS(801),
    [anon_sym_bytes29] = ACTIONS(801),
    [anon_sym_bytes30] = ACTIONS(801),
    [anon_sym_bytes31] = ACTIONS(801),
    [anon_sym_bytes32] = ACTIONS(801),
    [anon_sym_fixed] = ACTIONS(801),
    [aux_sym__fixed_token1] = ACTIONS(801),
    [anon_sym_ufixed] = ACTIONS(801),
    [aux_sym__ufixed_token1] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_identifier] = ACTIONS(637),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_type] = ACTIONS(637),
    [anon_sym_error] = ACTIONS(637),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_enum] = ACTIONS(637),
    [anon_sym_event] = ACTIONS(637),
    [anon_sym_using] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(637),
    [anon_sym_byte] = ACTIONS(637),
    [anon_sym_address] = ACTIONS(637),
    [anon_sym_var] = ACTIONS(637),
    [anon_sym_modifier] = ACTIONS(637),
    [anon_sym_constructor] = ACTIONS(637),
    [anon_sym_fallback] = ACTIONS(637),
    [anon_sym_receive] = ACTIONS(637),
    [anon_sym_mapping] = ACTIONS(637),
    [anon_sym_bool] = ACTIONS(637),
    [anon_sym_string] = ACTIONS(637),
    [anon_sym_int] = ACTIONS(637),
    [anon_sym_int8] = ACTIONS(637),
    [anon_sym_int16] = ACTIONS(637),
    [anon_sym_int24] = ACTIONS(637),
    [anon_sym_int32] = ACTIONS(637),
    [anon_sym_int40] = ACTIONS(637),
    [anon_sym_int48] = ACTIONS(637),
    [anon_sym_int56] = ACTIONS(637),
    [anon_sym_int64] = ACTIONS(637),
    [anon_sym_int72] = ACTIONS(637),
    [anon_sym_int80] = ACTIONS(637),
    [anon_sym_int88] = ACTIONS(637),
    [anon_sym_int96] = ACTIONS(637),
    [anon_sym_int104] = ACTIONS(637),
    [anon_sym_int112] = ACTIONS(637),
    [anon_sym_int120] = ACTIONS(637),
    [anon_sym_int128] = ACTIONS(637),
    [anon_sym_int136] = ACTIONS(637),
    [anon_sym_int144] = ACTIONS(637),
    [anon_sym_int152] = ACTIONS(637),
    [anon_sym_int160] = ACTIONS(637),
    [anon_sym_int168] = ACTIONS(637),
    [anon_sym_int176] = ACTIONS(637),
    [anon_sym_int184] = ACTIONS(637),
    [anon_sym_int192] = ACTIONS(637),
    [anon_sym_int200] = ACTIONS(637),
    [anon_sym_int208] = ACTIONS(637),
    [anon_sym_int216] = ACTIONS(637),
    [anon_sym_int224] = ACTIONS(637),
    [anon_sym_int232] = ACTIONS(637),
    [anon_sym_int240] = ACTIONS(637),
    [anon_sym_int248] = ACTIONS(637),
    [anon_sym_int256] = ACTIONS(637),
    [anon_sym_uint] = ACTIONS(637),
    [anon_sym_uint8] = ACTIONS(637),
    [anon_sym_uint16] = ACTIONS(637),
    [anon_sym_uint24] = ACTIONS(637),
    [anon_sym_uint32] = ACTIONS(637),
    [anon_sym_uint40] = ACTIONS(637),
    [anon_sym_uint48] = ACTIONS(637),
    [anon_sym_uint56] = ACTIONS(637),
    [anon_sym_uint64] = ACTIONS(637),
    [anon_sym_uint72] = ACTIONS(637),
    [anon_sym_uint80] = ACTIONS(637),
    [anon_sym_uint88] = ACTIONS(637),
    [anon_sym_uint96] = ACTIONS(637),
    [anon_sym_uint104] = ACTIONS(637),
    [anon_sym_uint112] = ACTIONS(637),
    [anon_sym_uint120] = ACTIONS(637),
    [anon_sym_uint128] = ACTIONS(637),
    [anon_sym_uint136] = ACTIONS(637),
    [anon_sym_uint144] = ACTIONS(637),
    [anon_sym_uint152] = ACTIONS(637),
    [anon_sym_uint160] = ACTIONS(637),
    [anon_sym_uint168] = ACTIONS(637),
    [anon_sym_uint176] = ACTIONS(637),
    [anon_sym_uint184] = ACTIONS(637),
    [anon_sym_uint192] = ACTIONS(637),
    [anon_sym_uint200] = ACTIONS(637),
    [anon_sym_uint208] = ACTIONS(637),
    [anon_sym_uint216] = ACTIONS(637),
    [anon_sym_uint224] = ACTIONS(637),
    [anon_sym_uint232] = ACTIONS(637),
    [anon_sym_uint240] = ACTIONS(637),
    [anon_sym_uint248] = ACTIONS(637),
    [anon_sym_uint256] = ACTIONS(637),
    [anon_sym_bytes] = ACTIONS(637),
    [anon_sym_bytes1] = ACTIONS(637),
    [anon_sym_bytes2] = ACTIONS(637),
    [anon_sym_bytes3] = ACTIONS(637),
    [anon_sym_bytes4] = ACTIONS(637),
    [anon_sym_bytes5] = ACTIONS(637),
    [anon_sym_bytes6] = ACTIONS(637),
    [anon_sym_bytes7] = ACTIONS(637),
    [anon_sym_bytes8] = ACTIONS(637),
    [anon_sym_bytes9] = ACTIONS(637),
    [anon_sym_bytes10] = ACTIONS(637),
    [anon_sym_bytes11] = ACTIONS(637),
    [anon_sym_bytes12] = ACTIONS(637),
    [anon_sym_bytes13] = ACTIONS(637),
    [anon_sym_bytes14] = ACTIONS(637),
    [anon_sym_bytes15] = ACTIONS(637),
    [anon_sym_bytes16] = ACTIONS(637),
    [anon_sym_bytes17] = ACTIONS(637),
    [anon_sym_bytes18] = ACTIONS(637),
    [anon_sym_bytes19] = ACTIONS(637),
    [anon_sym_bytes20] = ACTIONS(637),
    [anon_sym_bytes21] = ACTIONS(637),
    [anon_sym_bytes22] = ACTIONS(637),
    [anon_sym_bytes23] = ACTIONS(637),
    [anon_sym_bytes24] = ACTIONS(637),
    [anon_sym_bytes25] = ACTIONS(637),
    [anon_sym_bytes26] = ACTIONS(637),
    [anon_sym_bytes27] = ACTIONS(637),
    [anon_sym_bytes28] = ACTIONS(637),
    [anon_sym_bytes29] = ACTIONS(637),
    [anon_sym_bytes30] = ACTIONS(637),
    [anon_sym_bytes31] = ACTIONS(637),
    [anon_sym_bytes32] = ACTIONS(637),
    [anon_sym_fixed] = ACTIONS(637),
    [aux_sym__fixed_token1] = ACTIONS(637),
    [anon_sym_ufixed] = ACTIONS(637),
    [aux_sym__ufixed_token1] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym_identifier] = ACTIONS(805),
    [anon_sym_pragma] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_type] = ACTIONS(805),
    [anon_sym_abstract] = ACTIONS(805),
    [anon_sym_contract] = ACTIONS(805),
    [anon_sym_error] = ACTIONS(805),
    [anon_sym_interface] = ACTIONS(805),
    [anon_sym_library] = ACTIONS(805),
    [anon_sym_struct] = ACTIONS(805),
    [anon_sym_enum] = ACTIONS(805),
    [anon_sym_function] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(805),
    [anon_sym_address] = ACTIONS(805),
    [anon_sym_var] = ACTIONS(805),
    [anon_sym_mapping] = ACTIONS(805),
    [anon_sym_bool] = ACTIONS(805),
    [anon_sym_string] = ACTIONS(805),
    [anon_sym_int] = ACTIONS(805),
    [anon_sym_int8] = ACTIONS(805),
    [anon_sym_int16] = ACTIONS(805),
    [anon_sym_int24] = ACTIONS(805),
    [anon_sym_int32] = ACTIONS(805),
    [anon_sym_int40] = ACTIONS(805),
    [anon_sym_int48] = ACTIONS(805),
    [anon_sym_int56] = ACTIONS(805),
    [anon_sym_int64] = ACTIONS(805),
    [anon_sym_int72] = ACTIONS(805),
    [anon_sym_int80] = ACTIONS(805),
    [anon_sym_int88] = ACTIONS(805),
    [anon_sym_int96] = ACTIONS(805),
    [anon_sym_int104] = ACTIONS(805),
    [anon_sym_int112] = ACTIONS(805),
    [anon_sym_int120] = ACTIONS(805),
    [anon_sym_int128] = ACTIONS(805),
    [anon_sym_int136] = ACTIONS(805),
    [anon_sym_int144] = ACTIONS(805),
    [anon_sym_int152] = ACTIONS(805),
    [anon_sym_int160] = ACTIONS(805),
    [anon_sym_int168] = ACTIONS(805),
    [anon_sym_int176] = ACTIONS(805),
    [anon_sym_int184] = ACTIONS(805),
    [anon_sym_int192] = ACTIONS(805),
    [anon_sym_int200] = ACTIONS(805),
    [anon_sym_int208] = ACTIONS(805),
    [anon_sym_int216] = ACTIONS(805),
    [anon_sym_int224] = ACTIONS(805),
    [anon_sym_int232] = ACTIONS(805),
    [anon_sym_int240] = ACTIONS(805),
    [anon_sym_int248] = ACTIONS(805),
    [anon_sym_int256] = ACTIONS(805),
    [anon_sym_uint] = ACTIONS(805),
    [anon_sym_uint8] = ACTIONS(805),
    [anon_sym_uint16] = ACTIONS(805),
    [anon_sym_uint24] = ACTIONS(805),
    [anon_sym_uint32] = ACTIONS(805),
    [anon_sym_uint40] = ACTIONS(805),
    [anon_sym_uint48] = ACTIONS(805),
    [anon_sym_uint56] = ACTIONS(805),
    [anon_sym_uint64] = ACTIONS(805),
    [anon_sym_uint72] = ACTIONS(805),
    [anon_sym_uint80] = ACTIONS(805),
    [anon_sym_uint88] = ACTIONS(805),
    [anon_sym_uint96] = ACTIONS(805),
    [anon_sym_uint104] = ACTIONS(805),
    [anon_sym_uint112] = ACTIONS(805),
    [anon_sym_uint120] = ACTIONS(805),
    [anon_sym_uint128] = ACTIONS(805),
    [anon_sym_uint136] = ACTIONS(805),
    [anon_sym_uint144] = ACTIONS(805),
    [anon_sym_uint152] = ACTIONS(805),
    [anon_sym_uint160] = ACTIONS(805),
    [anon_sym_uint168] = ACTIONS(805),
    [anon_sym_uint176] = ACTIONS(805),
    [anon_sym_uint184] = ACTIONS(805),
    [anon_sym_uint192] = ACTIONS(805),
    [anon_sym_uint200] = ACTIONS(805),
    [anon_sym_uint208] = ACTIONS(805),
    [anon_sym_uint216] = ACTIONS(805),
    [anon_sym_uint224] = ACTIONS(805),
    [anon_sym_uint232] = ACTIONS(805),
    [anon_sym_uint240] = ACTIONS(805),
    [anon_sym_uint248] = ACTIONS(805),
    [anon_sym_uint256] = ACTIONS(805),
    [anon_sym_bytes] = ACTIONS(805),
    [anon_sym_bytes1] = ACTIONS(805),
    [anon_sym_bytes2] = ACTIONS(805),
    [anon_sym_bytes3] = ACTIONS(805),
    [anon_sym_bytes4] = ACTIONS(805),
    [anon_sym_bytes5] = ACTIONS(805),
    [anon_sym_bytes6] = ACTIONS(805),
    [anon_sym_bytes7] = ACTIONS(805),
    [anon_sym_bytes8] = ACTIONS(805),
    [anon_sym_bytes9] = ACTIONS(805),
    [anon_sym_bytes10] = ACTIONS(805),
    [anon_sym_bytes11] = ACTIONS(805),
    [anon_sym_bytes12] = ACTIONS(805),
    [anon_sym_bytes13] = ACTIONS(805),
    [anon_sym_bytes14] = ACTIONS(805),
    [anon_sym_bytes15] = ACTIONS(805),
    [anon_sym_bytes16] = ACTIONS(805),
    [anon_sym_bytes17] = ACTIONS(805),
    [anon_sym_bytes18] = ACTIONS(805),
    [anon_sym_bytes19] = ACTIONS(805),
    [anon_sym_bytes20] = ACTIONS(805),
    [anon_sym_bytes21] = ACTIONS(805),
    [anon_sym_bytes22] = ACTIONS(805),
    [anon_sym_bytes23] = ACTIONS(805),
    [anon_sym_bytes24] = ACTIONS(805),
    [anon_sym_bytes25] = ACTIONS(805),
    [anon_sym_bytes26] = ACTIONS(805),
    [anon_sym_bytes27] = ACTIONS(805),
    [anon_sym_bytes28] = ACTIONS(805),
    [anon_sym_bytes29] = ACTIONS(805),
    [anon_sym_bytes30] = ACTIONS(805),
    [anon_sym_bytes31] = ACTIONS(805),
    [anon_sym_bytes32] = ACTIONS(805),
    [anon_sym_fixed] = ACTIONS(805),
    [aux_sym__fixed_token1] = ACTIONS(805),
    [anon_sym_ufixed] = ACTIONS(805),
    [aux_sym__ufixed_token1] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_identifier] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_error] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_event] = ACTIONS(745),
    [anon_sym_using] = ACTIONS(745),
    [anon_sym_function] = ACTIONS(745),
    [anon_sym_byte] = ACTIONS(745),
    [anon_sym_address] = ACTIONS(745),
    [anon_sym_var] = ACTIONS(745),
    [anon_sym_modifier] = ACTIONS(745),
    [anon_sym_constructor] = ACTIONS(745),
    [anon_sym_fallback] = ACTIONS(745),
    [anon_sym_receive] = ACTIONS(745),
    [anon_sym_mapping] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_int8] = ACTIONS(745),
    [anon_sym_int16] = ACTIONS(745),
    [anon_sym_int24] = ACTIONS(745),
    [anon_sym_int32] = ACTIONS(745),
    [anon_sym_int40] = ACTIONS(745),
    [anon_sym_int48] = ACTIONS(745),
    [anon_sym_int56] = ACTIONS(745),
    [anon_sym_int64] = ACTIONS(745),
    [anon_sym_int72] = ACTIONS(745),
    [anon_sym_int80] = ACTIONS(745),
    [anon_sym_int88] = ACTIONS(745),
    [anon_sym_int96] = ACTIONS(745),
    [anon_sym_int104] = ACTIONS(745),
    [anon_sym_int112] = ACTIONS(745),
    [anon_sym_int120] = ACTIONS(745),
    [anon_sym_int128] = ACTIONS(745),
    [anon_sym_int136] = ACTIONS(745),
    [anon_sym_int144] = ACTIONS(745),
    [anon_sym_int152] = ACTIONS(745),
    [anon_sym_int160] = ACTIONS(745),
    [anon_sym_int168] = ACTIONS(745),
    [anon_sym_int176] = ACTIONS(745),
    [anon_sym_int184] = ACTIONS(745),
    [anon_sym_int192] = ACTIONS(745),
    [anon_sym_int200] = ACTIONS(745),
    [anon_sym_int208] = ACTIONS(745),
    [anon_sym_int216] = ACTIONS(745),
    [anon_sym_int224] = ACTIONS(745),
    [anon_sym_int232] = ACTIONS(745),
    [anon_sym_int240] = ACTIONS(745),
    [anon_sym_int248] = ACTIONS(745),
    [anon_sym_int256] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_uint8] = ACTIONS(745),
    [anon_sym_uint16] = ACTIONS(745),
    [anon_sym_uint24] = ACTIONS(745),
    [anon_sym_uint32] = ACTIONS(745),
    [anon_sym_uint40] = ACTIONS(745),
    [anon_sym_uint48] = ACTIONS(745),
    [anon_sym_uint56] = ACTIONS(745),
    [anon_sym_uint64] = ACTIONS(745),
    [anon_sym_uint72] = ACTIONS(745),
    [anon_sym_uint80] = ACTIONS(745),
    [anon_sym_uint88] = ACTIONS(745),
    [anon_sym_uint96] = ACTIONS(745),
    [anon_sym_uint104] = ACTIONS(745),
    [anon_sym_uint112] = ACTIONS(745),
    [anon_sym_uint120] = ACTIONS(745),
    [anon_sym_uint128] = ACTIONS(745),
    [anon_sym_uint136] = ACTIONS(745),
    [anon_sym_uint144] = ACTIONS(745),
    [anon_sym_uint152] = ACTIONS(745),
    [anon_sym_uint160] = ACTIONS(745),
    [anon_sym_uint168] = ACTIONS(745),
    [anon_sym_uint176] = ACTIONS(745),
    [anon_sym_uint184] = ACTIONS(745),
    [anon_sym_uint192] = ACTIONS(745),
    [anon_sym_uint200] = ACTIONS(745),
    [anon_sym_uint208] = ACTIONS(745),
    [anon_sym_uint216] = ACTIONS(745),
    [anon_sym_uint224] = ACTIONS(745),
    [anon_sym_uint232] = ACTIONS(745),
    [anon_sym_uint240] = ACTIONS(745),
    [anon_sym_uint248] = ACTIONS(745),
    [anon_sym_uint256] = ACTIONS(745),
    [anon_sym_bytes] = ACTIONS(745),
    [anon_sym_bytes1] = ACTIONS(745),
    [anon_sym_bytes2] = ACTIONS(745),
    [anon_sym_bytes3] = ACTIONS(745),
    [anon_sym_bytes4] = ACTIONS(745),
    [anon_sym_bytes5] = ACTIONS(745),
    [anon_sym_bytes6] = ACTIONS(745),
    [anon_sym_bytes7] = ACTIONS(745),
    [anon_sym_bytes8] = ACTIONS(745),
    [anon_sym_bytes9] = ACTIONS(745),
    [anon_sym_bytes10] = ACTIONS(745),
    [anon_sym_bytes11] = ACTIONS(745),
    [anon_sym_bytes12] = ACTIONS(745),
    [anon_sym_bytes13] = ACTIONS(745),
    [anon_sym_bytes14] = ACTIONS(745),
    [anon_sym_bytes15] = ACTIONS(745),
    [anon_sym_bytes16] = ACTIONS(745),
    [anon_sym_bytes17] = ACTIONS(745),
    [anon_sym_bytes18] = ACTIONS(745),
    [anon_sym_bytes19] = ACTIONS(745),
    [anon_sym_bytes20] = ACTIONS(745),
    [anon_sym_bytes21] = ACTIONS(745),
    [anon_sym_bytes22] = ACTIONS(745),
    [anon_sym_bytes23] = ACTIONS(745),
    [anon_sym_bytes24] = ACTIONS(745),
    [anon_sym_bytes25] = ACTIONS(745),
    [anon_sym_bytes26] = ACTIONS(745),
    [anon_sym_bytes27] = ACTIONS(745),
    [anon_sym_bytes28] = ACTIONS(745),
    [anon_sym_bytes29] = ACTIONS(745),
    [anon_sym_bytes30] = ACTIONS(745),
    [anon_sym_bytes31] = ACTIONS(745),
    [anon_sym_bytes32] = ACTIONS(745),
    [anon_sym_fixed] = ACTIONS(745),
    [aux_sym__fixed_token1] = ACTIONS(745),
    [anon_sym_ufixed] = ACTIONS(745),
    [aux_sym__ufixed_token1] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_type] = ACTIONS(709),
    [anon_sym_error] = ACTIONS(709),
    [anon_sym_struct] = ACTIONS(709),
    [anon_sym_enum] = ACTIONS(709),
    [anon_sym_event] = ACTIONS(709),
    [anon_sym_using] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_byte] = ACTIONS(709),
    [anon_sym_address] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_modifier] = ACTIONS(709),
    [anon_sym_constructor] = ACTIONS(709),
    [anon_sym_fallback] = ACTIONS(709),
    [anon_sym_receive] = ACTIONS(709),
    [anon_sym_mapping] = ACTIONS(709),
    [anon_sym_bool] = ACTIONS(709),
    [anon_sym_string] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int24] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int40] = ACTIONS(709),
    [anon_sym_int48] = ACTIONS(709),
    [anon_sym_int56] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int72] = ACTIONS(709),
    [anon_sym_int80] = ACTIONS(709),
    [anon_sym_int88] = ACTIONS(709),
    [anon_sym_int96] = ACTIONS(709),
    [anon_sym_int104] = ACTIONS(709),
    [anon_sym_int112] = ACTIONS(709),
    [anon_sym_int120] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [anon_sym_int136] = ACTIONS(709),
    [anon_sym_int144] = ACTIONS(709),
    [anon_sym_int152] = ACTIONS(709),
    [anon_sym_int160] = ACTIONS(709),
    [anon_sym_int168] = ACTIONS(709),
    [anon_sym_int176] = ACTIONS(709),
    [anon_sym_int184] = ACTIONS(709),
    [anon_sym_int192] = ACTIONS(709),
    [anon_sym_int200] = ACTIONS(709),
    [anon_sym_int208] = ACTIONS(709),
    [anon_sym_int216] = ACTIONS(709),
    [anon_sym_int224] = ACTIONS(709),
    [anon_sym_int232] = ACTIONS(709),
    [anon_sym_int240] = ACTIONS(709),
    [anon_sym_int248] = ACTIONS(709),
    [anon_sym_int256] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint24] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint40] = ACTIONS(709),
    [anon_sym_uint48] = ACTIONS(709),
    [anon_sym_uint56] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint72] = ACTIONS(709),
    [anon_sym_uint80] = ACTIONS(709),
    [anon_sym_uint88] = ACTIONS(709),
    [anon_sym_uint96] = ACTIONS(709),
    [anon_sym_uint104] = ACTIONS(709),
    [anon_sym_uint112] = ACTIONS(709),
    [anon_sym_uint120] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_uint136] = ACTIONS(709),
    [anon_sym_uint144] = ACTIONS(709),
    [anon_sym_uint152] = ACTIONS(709),
    [anon_sym_uint160] = ACTIONS(709),
    [anon_sym_uint168] = ACTIONS(709),
    [anon_sym_uint176] = ACTIONS(709),
    [anon_sym_uint184] = ACTIONS(709),
    [anon_sym_uint192] = ACTIONS(709),
    [anon_sym_uint200] = ACTIONS(709),
    [anon_sym_uint208] = ACTIONS(709),
    [anon_sym_uint216] = ACTIONS(709),
    [anon_sym_uint224] = ACTIONS(709),
    [anon_sym_uint232] = ACTIONS(709),
    [anon_sym_uint240] = ACTIONS(709),
    [anon_sym_uint248] = ACTIONS(709),
    [anon_sym_uint256] = ACTIONS(709),
    [anon_sym_bytes] = ACTIONS(709),
    [anon_sym_bytes1] = ACTIONS(709),
    [anon_sym_bytes2] = ACTIONS(709),
    [anon_sym_bytes3] = ACTIONS(709),
    [anon_sym_bytes4] = ACTIONS(709),
    [anon_sym_bytes5] = ACTIONS(709),
    [anon_sym_bytes6] = ACTIONS(709),
    [anon_sym_bytes7] = ACTIONS(709),
    [anon_sym_bytes8] = ACTIONS(709),
    [anon_sym_bytes9] = ACTIONS(709),
    [anon_sym_bytes10] = ACTIONS(709),
    [anon_sym_bytes11] = ACTIONS(709),
    [anon_sym_bytes12] = ACTIONS(709),
    [anon_sym_bytes13] = ACTIONS(709),
    [anon_sym_bytes14] = ACTIONS(709),
    [anon_sym_bytes15] = ACTIONS(709),
    [anon_sym_bytes16] = ACTIONS(709),
    [anon_sym_bytes17] = ACTIONS(709),
    [anon_sym_bytes18] = ACTIONS(709),
    [anon_sym_bytes19] = ACTIONS(709),
    [anon_sym_bytes20] = ACTIONS(709),
    [anon_sym_bytes21] = ACTIONS(709),
    [anon_sym_bytes22] = ACTIONS(709),
    [anon_sym_bytes23] = ACTIONS(709),
    [anon_sym_bytes24] = ACTIONS(709),
    [anon_sym_bytes25] = ACTIONS(709),
    [anon_sym_bytes26] = ACTIONS(709),
    [anon_sym_bytes27] = ACTIONS(709),
    [anon_sym_bytes28] = ACTIONS(709),
    [anon_sym_bytes29] = ACTIONS(709),
    [anon_sym_bytes30] = ACTIONS(709),
    [anon_sym_bytes31] = ACTIONS(709),
    [anon_sym_bytes32] = ACTIONS(709),
    [anon_sym_fixed] = ACTIONS(709),
    [aux_sym__fixed_token1] = ACTIONS(709),
    [anon_sym_ufixed] = ACTIONS(709),
    [aux_sym__ufixed_token1] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(757),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_error] = ACTIONS(757),
    [anon_sym_struct] = ACTIONS(757),
    [anon_sym_enum] = ACTIONS(757),
    [anon_sym_event] = ACTIONS(757),
    [anon_sym_using] = ACTIONS(757),
    [anon_sym_function] = ACTIONS(757),
    [anon_sym_byte] = ACTIONS(757),
    [anon_sym_address] = ACTIONS(757),
    [anon_sym_var] = ACTIONS(757),
    [anon_sym_modifier] = ACTIONS(757),
    [anon_sym_constructor] = ACTIONS(757),
    [anon_sym_fallback] = ACTIONS(757),
    [anon_sym_receive] = ACTIONS(757),
    [anon_sym_mapping] = ACTIONS(757),
    [anon_sym_bool] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_int] = ACTIONS(757),
    [anon_sym_int8] = ACTIONS(757),
    [anon_sym_int16] = ACTIONS(757),
    [anon_sym_int24] = ACTIONS(757),
    [anon_sym_int32] = ACTIONS(757),
    [anon_sym_int40] = ACTIONS(757),
    [anon_sym_int48] = ACTIONS(757),
    [anon_sym_int56] = ACTIONS(757),
    [anon_sym_int64] = ACTIONS(757),
    [anon_sym_int72] = ACTIONS(757),
    [anon_sym_int80] = ACTIONS(757),
    [anon_sym_int88] = ACTIONS(757),
    [anon_sym_int96] = ACTIONS(757),
    [anon_sym_int104] = ACTIONS(757),
    [anon_sym_int112] = ACTIONS(757),
    [anon_sym_int120] = ACTIONS(757),
    [anon_sym_int128] = ACTIONS(757),
    [anon_sym_int136] = ACTIONS(757),
    [anon_sym_int144] = ACTIONS(757),
    [anon_sym_int152] = ACTIONS(757),
    [anon_sym_int160] = ACTIONS(757),
    [anon_sym_int168] = ACTIONS(757),
    [anon_sym_int176] = ACTIONS(757),
    [anon_sym_int184] = ACTIONS(757),
    [anon_sym_int192] = ACTIONS(757),
    [anon_sym_int200] = ACTIONS(757),
    [anon_sym_int208] = ACTIONS(757),
    [anon_sym_int216] = ACTIONS(757),
    [anon_sym_int224] = ACTIONS(757),
    [anon_sym_int232] = ACTIONS(757),
    [anon_sym_int240] = ACTIONS(757),
    [anon_sym_int248] = ACTIONS(757),
    [anon_sym_int256] = ACTIONS(757),
    [anon_sym_uint] = ACTIONS(757),
    [anon_sym_uint8] = ACTIONS(757),
    [anon_sym_uint16] = ACTIONS(757),
    [anon_sym_uint24] = ACTIONS(757),
    [anon_sym_uint32] = ACTIONS(757),
    [anon_sym_uint40] = ACTIONS(757),
    [anon_sym_uint48] = ACTIONS(757),
    [anon_sym_uint56] = ACTIONS(757),
    [anon_sym_uint64] = ACTIONS(757),
    [anon_sym_uint72] = ACTIONS(757),
    [anon_sym_uint80] = ACTIONS(757),
    [anon_sym_uint88] = ACTIONS(757),
    [anon_sym_uint96] = ACTIONS(757),
    [anon_sym_uint104] = ACTIONS(757),
    [anon_sym_uint112] = ACTIONS(757),
    [anon_sym_uint120] = ACTIONS(757),
    [anon_sym_uint128] = ACTIONS(757),
    [anon_sym_uint136] = ACTIONS(757),
    [anon_sym_uint144] = ACTIONS(757),
    [anon_sym_uint152] = ACTIONS(757),
    [anon_sym_uint160] = ACTIONS(757),
    [anon_sym_uint168] = ACTIONS(757),
    [anon_sym_uint176] = ACTIONS(757),
    [anon_sym_uint184] = ACTIONS(757),
    [anon_sym_uint192] = ACTIONS(757),
    [anon_sym_uint200] = ACTIONS(757),
    [anon_sym_uint208] = ACTIONS(757),
    [anon_sym_uint216] = ACTIONS(757),
    [anon_sym_uint224] = ACTIONS(757),
    [anon_sym_uint232] = ACTIONS(757),
    [anon_sym_uint240] = ACTIONS(757),
    [anon_sym_uint248] = ACTIONS(757),
    [anon_sym_uint256] = ACTIONS(757),
    [anon_sym_bytes] = ACTIONS(757),
    [anon_sym_bytes1] = ACTIONS(757),
    [anon_sym_bytes2] = ACTIONS(757),
    [anon_sym_bytes3] = ACTIONS(757),
    [anon_sym_bytes4] = ACTIONS(757),
    [anon_sym_bytes5] = ACTIONS(757),
    [anon_sym_bytes6] = ACTIONS(757),
    [anon_sym_bytes7] = ACTIONS(757),
    [anon_sym_bytes8] = ACTIONS(757),
    [anon_sym_bytes9] = ACTIONS(757),
    [anon_sym_bytes10] = ACTIONS(757),
    [anon_sym_bytes11] = ACTIONS(757),
    [anon_sym_bytes12] = ACTIONS(757),
    [anon_sym_bytes13] = ACTIONS(757),
    [anon_sym_bytes14] = ACTIONS(757),
    [anon_sym_bytes15] = ACTIONS(757),
    [anon_sym_bytes16] = ACTIONS(757),
    [anon_sym_bytes17] = ACTIONS(757),
    [anon_sym_bytes18] = ACTIONS(757),
    [anon_sym_bytes19] = ACTIONS(757),
    [anon_sym_bytes20] = ACTIONS(757),
    [anon_sym_bytes21] = ACTIONS(757),
    [anon_sym_bytes22] = ACTIONS(757),
    [anon_sym_bytes23] = ACTIONS(757),
    [anon_sym_bytes24] = ACTIONS(757),
    [anon_sym_bytes25] = ACTIONS(757),
    [anon_sym_bytes26] = ACTIONS(757),
    [anon_sym_bytes27] = ACTIONS(757),
    [anon_sym_bytes28] = ACTIONS(757),
    [anon_sym_bytes29] = ACTIONS(757),
    [anon_sym_bytes30] = ACTIONS(757),
    [anon_sym_bytes31] = ACTIONS(757),
    [anon_sym_bytes32] = ACTIONS(757),
    [anon_sym_fixed] = ACTIONS(757),
    [aux_sym__fixed_token1] = ACTIONS(757),
    [anon_sym_ufixed] = ACTIONS(757),
    [aux_sym__ufixed_token1] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_error] = ACTIONS(765),
    [anon_sym_struct] = ACTIONS(765),
    [anon_sym_enum] = ACTIONS(765),
    [anon_sym_event] = ACTIONS(765),
    [anon_sym_using] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_byte] = ACTIONS(765),
    [anon_sym_address] = ACTIONS(765),
    [anon_sym_var] = ACTIONS(765),
    [anon_sym_modifier] = ACTIONS(765),
    [anon_sym_constructor] = ACTIONS(765),
    [anon_sym_fallback] = ACTIONS(765),
    [anon_sym_receive] = ACTIONS(765),
    [anon_sym_mapping] = ACTIONS(765),
    [anon_sym_bool] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_int] = ACTIONS(765),
    [anon_sym_int8] = ACTIONS(765),
    [anon_sym_int16] = ACTIONS(765),
    [anon_sym_int24] = ACTIONS(765),
    [anon_sym_int32] = ACTIONS(765),
    [anon_sym_int40] = ACTIONS(765),
    [anon_sym_int48] = ACTIONS(765),
    [anon_sym_int56] = ACTIONS(765),
    [anon_sym_int64] = ACTIONS(765),
    [anon_sym_int72] = ACTIONS(765),
    [anon_sym_int80] = ACTIONS(765),
    [anon_sym_int88] = ACTIONS(765),
    [anon_sym_int96] = ACTIONS(765),
    [anon_sym_int104] = ACTIONS(765),
    [anon_sym_int112] = ACTIONS(765),
    [anon_sym_int120] = ACTIONS(765),
    [anon_sym_int128] = ACTIONS(765),
    [anon_sym_int136] = ACTIONS(765),
    [anon_sym_int144] = ACTIONS(765),
    [anon_sym_int152] = ACTIONS(765),
    [anon_sym_int160] = ACTIONS(765),
    [anon_sym_int168] = ACTIONS(765),
    [anon_sym_int176] = ACTIONS(765),
    [anon_sym_int184] = ACTIONS(765),
    [anon_sym_int192] = ACTIONS(765),
    [anon_sym_int200] = ACTIONS(765),
    [anon_sym_int208] = ACTIONS(765),
    [anon_sym_int216] = ACTIONS(765),
    [anon_sym_int224] = ACTIONS(765),
    [anon_sym_int232] = ACTIONS(765),
    [anon_sym_int240] = ACTIONS(765),
    [anon_sym_int248] = ACTIONS(765),
    [anon_sym_int256] = ACTIONS(765),
    [anon_sym_uint] = ACTIONS(765),
    [anon_sym_uint8] = ACTIONS(765),
    [anon_sym_uint16] = ACTIONS(765),
    [anon_sym_uint24] = ACTIONS(765),
    [anon_sym_uint32] = ACTIONS(765),
    [anon_sym_uint40] = ACTIONS(765),
    [anon_sym_uint48] = ACTIONS(765),
    [anon_sym_uint56] = ACTIONS(765),
    [anon_sym_uint64] = ACTIONS(765),
    [anon_sym_uint72] = ACTIONS(765),
    [anon_sym_uint80] = ACTIONS(765),
    [anon_sym_uint88] = ACTIONS(765),
    [anon_sym_uint96] = ACTIONS(765),
    [anon_sym_uint104] = ACTIONS(765),
    [anon_sym_uint112] = ACTIONS(765),
    [anon_sym_uint120] = ACTIONS(765),
    [anon_sym_uint128] = ACTIONS(765),
    [anon_sym_uint136] = ACTIONS(765),
    [anon_sym_uint144] = ACTIONS(765),
    [anon_sym_uint152] = ACTIONS(765),
    [anon_sym_uint160] = ACTIONS(765),
    [anon_sym_uint168] = ACTIONS(765),
    [anon_sym_uint176] = ACTIONS(765),
    [anon_sym_uint184] = ACTIONS(765),
    [anon_sym_uint192] = ACTIONS(765),
    [anon_sym_uint200] = ACTIONS(765),
    [anon_sym_uint208] = ACTIONS(765),
    [anon_sym_uint216] = ACTIONS(765),
    [anon_sym_uint224] = ACTIONS(765),
    [anon_sym_uint232] = ACTIONS(765),
    [anon_sym_uint240] = ACTIONS(765),
    [anon_sym_uint248] = ACTIONS(765),
    [anon_sym_uint256] = ACTIONS(765),
    [anon_sym_bytes] = ACTIONS(765),
    [anon_sym_bytes1] = ACTIONS(765),
    [anon_sym_bytes2] = ACTIONS(765),
    [anon_sym_bytes3] = ACTIONS(765),
    [anon_sym_bytes4] = ACTIONS(765),
    [anon_sym_bytes5] = ACTIONS(765),
    [anon_sym_bytes6] = ACTIONS(765),
    [anon_sym_bytes7] = ACTIONS(765),
    [anon_sym_bytes8] = ACTIONS(765),
    [anon_sym_bytes9] = ACTIONS(765),
    [anon_sym_bytes10] = ACTIONS(765),
    [anon_sym_bytes11] = ACTIONS(765),
    [anon_sym_bytes12] = ACTIONS(765),
    [anon_sym_bytes13] = ACTIONS(765),
    [anon_sym_bytes14] = ACTIONS(765),
    [anon_sym_bytes15] = ACTIONS(765),
    [anon_sym_bytes16] = ACTIONS(765),
    [anon_sym_bytes17] = ACTIONS(765),
    [anon_sym_bytes18] = ACTIONS(765),
    [anon_sym_bytes19] = ACTIONS(765),
    [anon_sym_bytes20] = ACTIONS(765),
    [anon_sym_bytes21] = ACTIONS(765),
    [anon_sym_bytes22] = ACTIONS(765),
    [anon_sym_bytes23] = ACTIONS(765),
    [anon_sym_bytes24] = ACTIONS(765),
    [anon_sym_bytes25] = ACTIONS(765),
    [anon_sym_bytes26] = ACTIONS(765),
    [anon_sym_bytes27] = ACTIONS(765),
    [anon_sym_bytes28] = ACTIONS(765),
    [anon_sym_bytes29] = ACTIONS(765),
    [anon_sym_bytes30] = ACTIONS(765),
    [anon_sym_bytes31] = ACTIONS(765),
    [anon_sym_bytes32] = ACTIONS(765),
    [anon_sym_fixed] = ACTIONS(765),
    [aux_sym__fixed_token1] = ACTIONS(765),
    [anon_sym_ufixed] = ACTIONS(765),
    [aux_sym__ufixed_token1] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_type] = ACTIONS(621),
    [anon_sym_error] = ACTIONS(621),
    [anon_sym_struct] = ACTIONS(621),
    [anon_sym_enum] = ACTIONS(621),
    [anon_sym_event] = ACTIONS(621),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(621),
    [anon_sym_byte] = ACTIONS(621),
    [anon_sym_address] = ACTIONS(621),
    [anon_sym_var] = ACTIONS(621),
    [anon_sym_modifier] = ACTIONS(621),
    [anon_sym_constructor] = ACTIONS(621),
    [anon_sym_fallback] = ACTIONS(621),
    [anon_sym_receive] = ACTIONS(621),
    [anon_sym_mapping] = ACTIONS(621),
    [anon_sym_bool] = ACTIONS(621),
    [anon_sym_string] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_int8] = ACTIONS(621),
    [anon_sym_int16] = ACTIONS(621),
    [anon_sym_int24] = ACTIONS(621),
    [anon_sym_int32] = ACTIONS(621),
    [anon_sym_int40] = ACTIONS(621),
    [anon_sym_int48] = ACTIONS(621),
    [anon_sym_int56] = ACTIONS(621),
    [anon_sym_int64] = ACTIONS(621),
    [anon_sym_int72] = ACTIONS(621),
    [anon_sym_int80] = ACTIONS(621),
    [anon_sym_int88] = ACTIONS(621),
    [anon_sym_int96] = ACTIONS(621),
    [anon_sym_int104] = ACTIONS(621),
    [anon_sym_int112] = ACTIONS(621),
    [anon_sym_int120] = ACTIONS(621),
    [anon_sym_int128] = ACTIONS(621),
    [anon_sym_int136] = ACTIONS(621),
    [anon_sym_int144] = ACTIONS(621),
    [anon_sym_int152] = ACTIONS(621),
    [anon_sym_int160] = ACTIONS(621),
    [anon_sym_int168] = ACTIONS(621),
    [anon_sym_int176] = ACTIONS(621),
    [anon_sym_int184] = ACTIONS(621),
    [anon_sym_int192] = ACTIONS(621),
    [anon_sym_int200] = ACTIONS(621),
    [anon_sym_int208] = ACTIONS(621),
    [anon_sym_int216] = ACTIONS(621),
    [anon_sym_int224] = ACTIONS(621),
    [anon_sym_int232] = ACTIONS(621),
    [anon_sym_int240] = ACTIONS(621),
    [anon_sym_int248] = ACTIONS(621),
    [anon_sym_int256] = ACTIONS(621),
    [anon_sym_uint] = ACTIONS(621),
    [anon_sym_uint8] = ACTIONS(621),
    [anon_sym_uint16] = ACTIONS(621),
    [anon_sym_uint24] = ACTIONS(621),
    [anon_sym_uint32] = ACTIONS(621),
    [anon_sym_uint40] = ACTIONS(621),
    [anon_sym_uint48] = ACTIONS(621),
    [anon_sym_uint56] = ACTIONS(621),
    [anon_sym_uint64] = ACTIONS(621),
    [anon_sym_uint72] = ACTIONS(621),
    [anon_sym_uint80] = ACTIONS(621),
    [anon_sym_uint88] = ACTIONS(621),
    [anon_sym_uint96] = ACTIONS(621),
    [anon_sym_uint104] = ACTIONS(621),
    [anon_sym_uint112] = ACTIONS(621),
    [anon_sym_uint120] = ACTIONS(621),
    [anon_sym_uint128] = ACTIONS(621),
    [anon_sym_uint136] = ACTIONS(621),
    [anon_sym_uint144] = ACTIONS(621),
    [anon_sym_uint152] = ACTIONS(621),
    [anon_sym_uint160] = ACTIONS(621),
    [anon_sym_uint168] = ACTIONS(621),
    [anon_sym_uint176] = ACTIONS(621),
    [anon_sym_uint184] = ACTIONS(621),
    [anon_sym_uint192] = ACTIONS(621),
    [anon_sym_uint200] = ACTIONS(621),
    [anon_sym_uint208] = ACTIONS(621),
    [anon_sym_uint216] = ACTIONS(621),
    [anon_sym_uint224] = ACTIONS(621),
    [anon_sym_uint232] = ACTIONS(621),
    [anon_sym_uint240] = ACTIONS(621),
    [anon_sym_uint248] = ACTIONS(621),
    [anon_sym_uint256] = ACTIONS(621),
    [anon_sym_bytes] = ACTIONS(621),
    [anon_sym_bytes1] = ACTIONS(621),
    [anon_sym_bytes2] = ACTIONS(621),
    [anon_sym_bytes3] = ACTIONS(621),
    [anon_sym_bytes4] = ACTIONS(621),
    [anon_sym_bytes5] = ACTIONS(621),
    [anon_sym_bytes6] = ACTIONS(621),
    [anon_sym_bytes7] = ACTIONS(621),
    [anon_sym_bytes8] = ACTIONS(621),
    [anon_sym_bytes9] = ACTIONS(621),
    [anon_sym_bytes10] = ACTIONS(621),
    [anon_sym_bytes11] = ACTIONS(621),
    [anon_sym_bytes12] = ACTIONS(621),
    [anon_sym_bytes13] = ACTIONS(621),
    [anon_sym_bytes14] = ACTIONS(621),
    [anon_sym_bytes15] = ACTIONS(621),
    [anon_sym_bytes16] = ACTIONS(621),
    [anon_sym_bytes17] = ACTIONS(621),
    [anon_sym_bytes18] = ACTIONS(621),
    [anon_sym_bytes19] = ACTIONS(621),
    [anon_sym_bytes20] = ACTIONS(621),
    [anon_sym_bytes21] = ACTIONS(621),
    [anon_sym_bytes22] = ACTIONS(621),
    [anon_sym_bytes23] = ACTIONS(621),
    [anon_sym_bytes24] = ACTIONS(621),
    [anon_sym_bytes25] = ACTIONS(621),
    [anon_sym_bytes26] = ACTIONS(621),
    [anon_sym_bytes27] = ACTIONS(621),
    [anon_sym_bytes28] = ACTIONS(621),
    [anon_sym_bytes29] = ACTIONS(621),
    [anon_sym_bytes30] = ACTIONS(621),
    [anon_sym_bytes31] = ACTIONS(621),
    [anon_sym_bytes32] = ACTIONS(621),
    [anon_sym_fixed] = ACTIONS(621),
    [aux_sym__fixed_token1] = ACTIONS(621),
    [anon_sym_ufixed] = ACTIONS(621),
    [aux_sym__ufixed_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(807),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_pragma] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(809),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_abstract] = ACTIONS(809),
    [anon_sym_contract] = ACTIONS(809),
    [anon_sym_error] = ACTIONS(809),
    [anon_sym_interface] = ACTIONS(809),
    [anon_sym_library] = ACTIONS(809),
    [anon_sym_struct] = ACTIONS(809),
    [anon_sym_enum] = ACTIONS(809),
    [anon_sym_function] = ACTIONS(809),
    [anon_sym_byte] = ACTIONS(809),
    [anon_sym_address] = ACTIONS(809),
    [anon_sym_var] = ACTIONS(809),
    [anon_sym_mapping] = ACTIONS(809),
    [anon_sym_bool] = ACTIONS(809),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_int] = ACTIONS(809),
    [anon_sym_int8] = ACTIONS(809),
    [anon_sym_int16] = ACTIONS(809),
    [anon_sym_int24] = ACTIONS(809),
    [anon_sym_int32] = ACTIONS(809),
    [anon_sym_int40] = ACTIONS(809),
    [anon_sym_int48] = ACTIONS(809),
    [anon_sym_int56] = ACTIONS(809),
    [anon_sym_int64] = ACTIONS(809),
    [anon_sym_int72] = ACTIONS(809),
    [anon_sym_int80] = ACTIONS(809),
    [anon_sym_int88] = ACTIONS(809),
    [anon_sym_int96] = ACTIONS(809),
    [anon_sym_int104] = ACTIONS(809),
    [anon_sym_int112] = ACTIONS(809),
    [anon_sym_int120] = ACTIONS(809),
    [anon_sym_int128] = ACTIONS(809),
    [anon_sym_int136] = ACTIONS(809),
    [anon_sym_int144] = ACTIONS(809),
    [anon_sym_int152] = ACTIONS(809),
    [anon_sym_int160] = ACTIONS(809),
    [anon_sym_int168] = ACTIONS(809),
    [anon_sym_int176] = ACTIONS(809),
    [anon_sym_int184] = ACTIONS(809),
    [anon_sym_int192] = ACTIONS(809),
    [anon_sym_int200] = ACTIONS(809),
    [anon_sym_int208] = ACTIONS(809),
    [anon_sym_int216] = ACTIONS(809),
    [anon_sym_int224] = ACTIONS(809),
    [anon_sym_int232] = ACTIONS(809),
    [anon_sym_int240] = ACTIONS(809),
    [anon_sym_int248] = ACTIONS(809),
    [anon_sym_int256] = ACTIONS(809),
    [anon_sym_uint] = ACTIONS(809),
    [anon_sym_uint8] = ACTIONS(809),
    [anon_sym_uint16] = ACTIONS(809),
    [anon_sym_uint24] = ACTIONS(809),
    [anon_sym_uint32] = ACTIONS(809),
    [anon_sym_uint40] = ACTIONS(809),
    [anon_sym_uint48] = ACTIONS(809),
    [anon_sym_uint56] = ACTIONS(809),
    [anon_sym_uint64] = ACTIONS(809),
    [anon_sym_uint72] = ACTIONS(809),
    [anon_sym_uint80] = ACTIONS(809),
    [anon_sym_uint88] = ACTIONS(809),
    [anon_sym_uint96] = ACTIONS(809),
    [anon_sym_uint104] = ACTIONS(809),
    [anon_sym_uint112] = ACTIONS(809),
    [anon_sym_uint120] = ACTIONS(809),
    [anon_sym_uint128] = ACTIONS(809),
    [anon_sym_uint136] = ACTIONS(809),
    [anon_sym_uint144] = ACTIONS(809),
    [anon_sym_uint152] = ACTIONS(809),
    [anon_sym_uint160] = ACTIONS(809),
    [anon_sym_uint168] = ACTIONS(809),
    [anon_sym_uint176] = ACTIONS(809),
    [anon_sym_uint184] = ACTIONS(809),
    [anon_sym_uint192] = ACTIONS(809),
    [anon_sym_uint200] = ACTIONS(809),
    [anon_sym_uint208] = ACTIONS(809),
    [anon_sym_uint216] = ACTIONS(809),
    [anon_sym_uint224] = ACTIONS(809),
    [anon_sym_uint232] = ACTIONS(809),
    [anon_sym_uint240] = ACTIONS(809),
    [anon_sym_uint248] = ACTIONS(809),
    [anon_sym_uint256] = ACTIONS(809),
    [anon_sym_bytes] = ACTIONS(809),
    [anon_sym_bytes1] = ACTIONS(809),
    [anon_sym_bytes2] = ACTIONS(809),
    [anon_sym_bytes3] = ACTIONS(809),
    [anon_sym_bytes4] = ACTIONS(809),
    [anon_sym_bytes5] = ACTIONS(809),
    [anon_sym_bytes6] = ACTIONS(809),
    [anon_sym_bytes7] = ACTIONS(809),
    [anon_sym_bytes8] = ACTIONS(809),
    [anon_sym_bytes9] = ACTIONS(809),
    [anon_sym_bytes10] = ACTIONS(809),
    [anon_sym_bytes11] = ACTIONS(809),
    [anon_sym_bytes12] = ACTIONS(809),
    [anon_sym_bytes13] = ACTIONS(809),
    [anon_sym_bytes14] = ACTIONS(809),
    [anon_sym_bytes15] = ACTIONS(809),
    [anon_sym_bytes16] = ACTIONS(809),
    [anon_sym_bytes17] = ACTIONS(809),
    [anon_sym_bytes18] = ACTIONS(809),
    [anon_sym_bytes19] = ACTIONS(809),
    [anon_sym_bytes20] = ACTIONS(809),
    [anon_sym_bytes21] = ACTIONS(809),
    [anon_sym_bytes22] = ACTIONS(809),
    [anon_sym_bytes23] = ACTIONS(809),
    [anon_sym_bytes24] = ACTIONS(809),
    [anon_sym_bytes25] = ACTIONS(809),
    [anon_sym_bytes26] = ACTIONS(809),
    [anon_sym_bytes27] = ACTIONS(809),
    [anon_sym_bytes28] = ACTIONS(809),
    [anon_sym_bytes29] = ACTIONS(809),
    [anon_sym_bytes30] = ACTIONS(809),
    [anon_sym_bytes31] = ACTIONS(809),
    [anon_sym_bytes32] = ACTIONS(809),
    [anon_sym_fixed] = ACTIONS(809),
    [aux_sym__fixed_token1] = ACTIONS(809),
    [anon_sym_ufixed] = ACTIONS(809),
    [aux_sym__ufixed_token1] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(753),
    [sym_identifier] = ACTIONS(751),
    [anon_sym_pragma] = ACTIONS(751),
    [anon_sym_import] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(751),
    [anon_sym_abstract] = ACTIONS(751),
    [anon_sym_contract] = ACTIONS(751),
    [anon_sym_error] = ACTIONS(751),
    [anon_sym_interface] = ACTIONS(751),
    [anon_sym_library] = ACTIONS(751),
    [anon_sym_struct] = ACTIONS(751),
    [anon_sym_enum] = ACTIONS(751),
    [anon_sym_function] = ACTIONS(751),
    [anon_sym_byte] = ACTIONS(751),
    [anon_sym_address] = ACTIONS(751),
    [anon_sym_var] = ACTIONS(751),
    [anon_sym_mapping] = ACTIONS(751),
    [anon_sym_bool] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_int] = ACTIONS(751),
    [anon_sym_int8] = ACTIONS(751),
    [anon_sym_int16] = ACTIONS(751),
    [anon_sym_int24] = ACTIONS(751),
    [anon_sym_int32] = ACTIONS(751),
    [anon_sym_int40] = ACTIONS(751),
    [anon_sym_int48] = ACTIONS(751),
    [anon_sym_int56] = ACTIONS(751),
    [anon_sym_int64] = ACTIONS(751),
    [anon_sym_int72] = ACTIONS(751),
    [anon_sym_int80] = ACTIONS(751),
    [anon_sym_int88] = ACTIONS(751),
    [anon_sym_int96] = ACTIONS(751),
    [anon_sym_int104] = ACTIONS(751),
    [anon_sym_int112] = ACTIONS(751),
    [anon_sym_int120] = ACTIONS(751),
    [anon_sym_int128] = ACTIONS(751),
    [anon_sym_int136] = ACTIONS(751),
    [anon_sym_int144] = ACTIONS(751),
    [anon_sym_int152] = ACTIONS(751),
    [anon_sym_int160] = ACTIONS(751),
    [anon_sym_int168] = ACTIONS(751),
    [anon_sym_int176] = ACTIONS(751),
    [anon_sym_int184] = ACTIONS(751),
    [anon_sym_int192] = ACTIONS(751),
    [anon_sym_int200] = ACTIONS(751),
    [anon_sym_int208] = ACTIONS(751),
    [anon_sym_int216] = ACTIONS(751),
    [anon_sym_int224] = ACTIONS(751),
    [anon_sym_int232] = ACTIONS(751),
    [anon_sym_int240] = ACTIONS(751),
    [anon_sym_int248] = ACTIONS(751),
    [anon_sym_int256] = ACTIONS(751),
    [anon_sym_uint] = ACTIONS(751),
    [anon_sym_uint8] = ACTIONS(751),
    [anon_sym_uint16] = ACTIONS(751),
    [anon_sym_uint24] = ACTIONS(751),
    [anon_sym_uint32] = ACTIONS(751),
    [anon_sym_uint40] = ACTIONS(751),
    [anon_sym_uint48] = ACTIONS(751),
    [anon_sym_uint56] = ACTIONS(751),
    [anon_sym_uint64] = ACTIONS(751),
    [anon_sym_uint72] = ACTIONS(751),
    [anon_sym_uint80] = ACTIONS(751),
    [anon_sym_uint88] = ACTIONS(751),
    [anon_sym_uint96] = ACTIONS(751),
    [anon_sym_uint104] = ACTIONS(751),
    [anon_sym_uint112] = ACTIONS(751),
    [anon_sym_uint120] = ACTIONS(751),
    [anon_sym_uint128] = ACTIONS(751),
    [anon_sym_uint136] = ACTIONS(751),
    [anon_sym_uint144] = ACTIONS(751),
    [anon_sym_uint152] = ACTIONS(751),
    [anon_sym_uint160] = ACTIONS(751),
    [anon_sym_uint168] = ACTIONS(751),
    [anon_sym_uint176] = ACTIONS(751),
    [anon_sym_uint184] = ACTIONS(751),
    [anon_sym_uint192] = ACTIONS(751),
    [anon_sym_uint200] = ACTIONS(751),
    [anon_sym_uint208] = ACTIONS(751),
    [anon_sym_uint216] = ACTIONS(751),
    [anon_sym_uint224] = ACTIONS(751),
    [anon_sym_uint232] = ACTIONS(751),
    [anon_sym_uint240] = ACTIONS(751),
    [anon_sym_uint248] = ACTIONS(751),
    [anon_sym_uint256] = ACTIONS(751),
    [anon_sym_bytes] = ACTIONS(751),
    [anon_sym_bytes1] = ACTIONS(751),
    [anon_sym_bytes2] = ACTIONS(751),
    [anon_sym_bytes3] = ACTIONS(751),
    [anon_sym_bytes4] = ACTIONS(751),
    [anon_sym_bytes5] = ACTIONS(751),
    [anon_sym_bytes6] = ACTIONS(751),
    [anon_sym_bytes7] = ACTIONS(751),
    [anon_sym_bytes8] = ACTIONS(751),
    [anon_sym_bytes9] = ACTIONS(751),
    [anon_sym_bytes10] = ACTIONS(751),
    [anon_sym_bytes11] = ACTIONS(751),
    [anon_sym_bytes12] = ACTIONS(751),
    [anon_sym_bytes13] = ACTIONS(751),
    [anon_sym_bytes14] = ACTIONS(751),
    [anon_sym_bytes15] = ACTIONS(751),
    [anon_sym_bytes16] = ACTIONS(751),
    [anon_sym_bytes17] = ACTIONS(751),
    [anon_sym_bytes18] = ACTIONS(751),
    [anon_sym_bytes19] = ACTIONS(751),
    [anon_sym_bytes20] = ACTIONS(751),
    [anon_sym_bytes21] = ACTIONS(751),
    [anon_sym_bytes22] = ACTIONS(751),
    [anon_sym_bytes23] = ACTIONS(751),
    [anon_sym_bytes24] = ACTIONS(751),
    [anon_sym_bytes25] = ACTIONS(751),
    [anon_sym_bytes26] = ACTIONS(751),
    [anon_sym_bytes27] = ACTIONS(751),
    [anon_sym_bytes28] = ACTIONS(751),
    [anon_sym_bytes29] = ACTIONS(751),
    [anon_sym_bytes30] = ACTIONS(751),
    [anon_sym_bytes31] = ACTIONS(751),
    [anon_sym_bytes32] = ACTIONS(751),
    [anon_sym_fixed] = ACTIONS(751),
    [aux_sym__fixed_token1] = ACTIONS(751),
    [anon_sym_ufixed] = ACTIONS(751),
    [aux_sym__ufixed_token1] = ACTIONS(751),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(811),
    [anon_sym_error] = ACTIONS(811),
    [anon_sym_struct] = ACTIONS(811),
    [anon_sym_enum] = ACTIONS(811),
    [anon_sym_event] = ACTIONS(811),
    [anon_sym_using] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(811),
    [anon_sym_byte] = ACTIONS(811),
    [anon_sym_address] = ACTIONS(811),
    [anon_sym_var] = ACTIONS(811),
    [anon_sym_modifier] = ACTIONS(811),
    [anon_sym_constructor] = ACTIONS(811),
    [anon_sym_fallback] = ACTIONS(811),
    [anon_sym_receive] = ACTIONS(811),
    [anon_sym_mapping] = ACTIONS(811),
    [anon_sym_bool] = ACTIONS(811),
    [anon_sym_string] = ACTIONS(811),
    [anon_sym_int] = ACTIONS(811),
    [anon_sym_int8] = ACTIONS(811),
    [anon_sym_int16] = ACTIONS(811),
    [anon_sym_int24] = ACTIONS(811),
    [anon_sym_int32] = ACTIONS(811),
    [anon_sym_int40] = ACTIONS(811),
    [anon_sym_int48] = ACTIONS(811),
    [anon_sym_int56] = ACTIONS(811),
    [anon_sym_int64] = ACTIONS(811),
    [anon_sym_int72] = ACTIONS(811),
    [anon_sym_int80] = ACTIONS(811),
    [anon_sym_int88] = ACTIONS(811),
    [anon_sym_int96] = ACTIONS(811),
    [anon_sym_int104] = ACTIONS(811),
    [anon_sym_int112] = ACTIONS(811),
    [anon_sym_int120] = ACTIONS(811),
    [anon_sym_int128] = ACTIONS(811),
    [anon_sym_int136] = ACTIONS(811),
    [anon_sym_int144] = ACTIONS(811),
    [anon_sym_int152] = ACTIONS(811),
    [anon_sym_int160] = ACTIONS(811),
    [anon_sym_int168] = ACTIONS(811),
    [anon_sym_int176] = ACTIONS(811),
    [anon_sym_int184] = ACTIONS(811),
    [anon_sym_int192] = ACTIONS(811),
    [anon_sym_int200] = ACTIONS(811),
    [anon_sym_int208] = ACTIONS(811),
    [anon_sym_int216] = ACTIONS(811),
    [anon_sym_int224] = ACTIONS(811),
    [anon_sym_int232] = ACTIONS(811),
    [anon_sym_int240] = ACTIONS(811),
    [anon_sym_int248] = ACTIONS(811),
    [anon_sym_int256] = ACTIONS(811),
    [anon_sym_uint] = ACTIONS(811),
    [anon_sym_uint8] = ACTIONS(811),
    [anon_sym_uint16] = ACTIONS(811),
    [anon_sym_uint24] = ACTIONS(811),
    [anon_sym_uint32] = ACTIONS(811),
    [anon_sym_uint40] = ACTIONS(811),
    [anon_sym_uint48] = ACTIONS(811),
    [anon_sym_uint56] = ACTIONS(811),
    [anon_sym_uint64] = ACTIONS(811),
    [anon_sym_uint72] = ACTIONS(811),
    [anon_sym_uint80] = ACTIONS(811),
    [anon_sym_uint88] = ACTIONS(811),
    [anon_sym_uint96] = ACTIONS(811),
    [anon_sym_uint104] = ACTIONS(811),
    [anon_sym_uint112] = ACTIONS(811),
    [anon_sym_uint120] = ACTIONS(811),
    [anon_sym_uint128] = ACTIONS(811),
    [anon_sym_uint136] = ACTIONS(811),
    [anon_sym_uint144] = ACTIONS(811),
    [anon_sym_uint152] = ACTIONS(811),
    [anon_sym_uint160] = ACTIONS(811),
    [anon_sym_uint168] = ACTIONS(811),
    [anon_sym_uint176] = ACTIONS(811),
    [anon_sym_uint184] = ACTIONS(811),
    [anon_sym_uint192] = ACTIONS(811),
    [anon_sym_uint200] = ACTIONS(811),
    [anon_sym_uint208] = ACTIONS(811),
    [anon_sym_uint216] = ACTIONS(811),
    [anon_sym_uint224] = ACTIONS(811),
    [anon_sym_uint232] = ACTIONS(811),
    [anon_sym_uint240] = ACTIONS(811),
    [anon_sym_uint248] = ACTIONS(811),
    [anon_sym_uint256] = ACTIONS(811),
    [anon_sym_bytes] = ACTIONS(811),
    [anon_sym_bytes1] = ACTIONS(811),
    [anon_sym_bytes2] = ACTIONS(811),
    [anon_sym_bytes3] = ACTIONS(811),
    [anon_sym_bytes4] = ACTIONS(811),
    [anon_sym_bytes5] = ACTIONS(811),
    [anon_sym_bytes6] = ACTIONS(811),
    [anon_sym_bytes7] = ACTIONS(811),
    [anon_sym_bytes8] = ACTIONS(811),
    [anon_sym_bytes9] = ACTIONS(811),
    [anon_sym_bytes10] = ACTIONS(811),
    [anon_sym_bytes11] = ACTIONS(811),
    [anon_sym_bytes12] = ACTIONS(811),
    [anon_sym_bytes13] = ACTIONS(811),
    [anon_sym_bytes14] = ACTIONS(811),
    [anon_sym_bytes15] = ACTIONS(811),
    [anon_sym_bytes16] = ACTIONS(811),
    [anon_sym_bytes17] = ACTIONS(811),
    [anon_sym_bytes18] = ACTIONS(811),
    [anon_sym_bytes19] = ACTIONS(811),
    [anon_sym_bytes20] = ACTIONS(811),
    [anon_sym_bytes21] = ACTIONS(811),
    [anon_sym_bytes22] = ACTIONS(811),
    [anon_sym_bytes23] = ACTIONS(811),
    [anon_sym_bytes24] = ACTIONS(811),
    [anon_sym_bytes25] = ACTIONS(811),
    [anon_sym_bytes26] = ACTIONS(811),
    [anon_sym_bytes27] = ACTIONS(811),
    [anon_sym_bytes28] = ACTIONS(811),
    [anon_sym_bytes29] = ACTIONS(811),
    [anon_sym_bytes30] = ACTIONS(811),
    [anon_sym_bytes31] = ACTIONS(811),
    [anon_sym_bytes32] = ACTIONS(811),
    [anon_sym_fixed] = ACTIONS(811),
    [aux_sym__fixed_token1] = ACTIONS(811),
    [anon_sym_ufixed] = ACTIONS(811),
    [aux_sym__ufixed_token1] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_user_defined_type] = STATE(694),
    [sym__identifier_path] = STATE(315),
    [sym__mapping_key] = STATE(694),
    [sym_primitive_type] = STATE(694),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(31),
    [anon_sym_bool] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(31),
    [anon_sym_int40] = ACTIONS(31),
    [anon_sym_int48] = ACTIONS(31),
    [anon_sym_int56] = ACTIONS(31),
    [anon_sym_int64] = ACTIONS(31),
    [anon_sym_int72] = ACTIONS(31),
    [anon_sym_int80] = ACTIONS(31),
    [anon_sym_int88] = ACTIONS(31),
    [anon_sym_int96] = ACTIONS(31),
    [anon_sym_int104] = ACTIONS(31),
    [anon_sym_int112] = ACTIONS(31),
    [anon_sym_int120] = ACTIONS(31),
    [anon_sym_int128] = ACTIONS(31),
    [anon_sym_int136] = ACTIONS(31),
    [anon_sym_int144] = ACTIONS(31),
    [anon_sym_int152] = ACTIONS(31),
    [anon_sym_int160] = ACTIONS(31),
    [anon_sym_int168] = ACTIONS(31),
    [anon_sym_int176] = ACTIONS(31),
    [anon_sym_int184] = ACTIONS(31),
    [anon_sym_int192] = ACTIONS(31),
    [anon_sym_int200] = ACTIONS(31),
    [anon_sym_int208] = ACTIONS(31),
    [anon_sym_int216] = ACTIONS(31),
    [anon_sym_int224] = ACTIONS(31),
    [anon_sym_int232] = ACTIONS(31),
    [anon_sym_int240] = ACTIONS(31),
    [anon_sym_int248] = ACTIONS(31),
    [anon_sym_int256] = ACTIONS(31),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(31),
    [anon_sym_uint40] = ACTIONS(31),
    [anon_sym_uint48] = ACTIONS(31),
    [anon_sym_uint56] = ACTIONS(31),
    [anon_sym_uint64] = ACTIONS(31),
    [anon_sym_uint72] = ACTIONS(31),
    [anon_sym_uint80] = ACTIONS(31),
    [anon_sym_uint88] = ACTIONS(31),
    [anon_sym_uint96] = ACTIONS(31),
    [anon_sym_uint104] = ACTIONS(31),
    [anon_sym_uint112] = ACTIONS(31),
    [anon_sym_uint120] = ACTIONS(31),
    [anon_sym_uint128] = ACTIONS(31),
    [anon_sym_uint136] = ACTIONS(31),
    [anon_sym_uint144] = ACTIONS(31),
    [anon_sym_uint152] = ACTIONS(31),
    [anon_sym_uint160] = ACTIONS(31),
    [anon_sym_uint168] = ACTIONS(31),
    [anon_sym_uint176] = ACTIONS(31),
    [anon_sym_uint184] = ACTIONS(31),
    [anon_sym_uint192] = ACTIONS(31),
    [anon_sym_uint200] = ACTIONS(31),
    [anon_sym_uint208] = ACTIONS(31),
    [anon_sym_uint216] = ACTIONS(31),
    [anon_sym_uint224] = ACTIONS(31),
    [anon_sym_uint232] = ACTIONS(31),
    [anon_sym_uint240] = ACTIONS(31),
    [anon_sym_uint248] = ACTIONS(31),
    [anon_sym_uint256] = ACTIONS(31),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(31),
    [anon_sym_bytes5] = ACTIONS(31),
    [anon_sym_bytes6] = ACTIONS(31),
    [anon_sym_bytes7] = ACTIONS(31),
    [anon_sym_bytes8] = ACTIONS(31),
    [anon_sym_bytes9] = ACTIONS(31),
    [anon_sym_bytes10] = ACTIONS(31),
    [anon_sym_bytes11] = ACTIONS(31),
    [anon_sym_bytes12] = ACTIONS(31),
    [anon_sym_bytes13] = ACTIONS(31),
    [anon_sym_bytes14] = ACTIONS(31),
    [anon_sym_bytes15] = ACTIONS(31),
    [anon_sym_bytes16] = ACTIONS(31),
    [anon_sym_bytes17] = ACTIONS(31),
    [anon_sym_bytes18] = ACTIONS(31),
    [anon_sym_bytes19] = ACTIONS(31),
    [anon_sym_bytes20] = ACTIONS(31),
    [anon_sym_bytes21] = ACTIONS(31),
    [anon_sym_bytes22] = ACTIONS(31),
    [anon_sym_bytes23] = ACTIONS(31),
    [anon_sym_bytes24] = ACTIONS(31),
    [anon_sym_bytes25] = ACTIONS(31),
    [anon_sym_bytes26] = ACTIONS(31),
    [anon_sym_bytes27] = ACTIONS(31),
    [anon_sym_bytes28] = ACTIONS(31),
    [anon_sym_bytes29] = ACTIONS(31),
    [anon_sym_bytes30] = ACTIONS(31),
    [anon_sym_bytes31] = ACTIONS(31),
    [anon_sym_bytes32] = ACTIONS(31),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(31),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(31),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_primitive_type] = STATE(768),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(815),
    [anon_sym_var] = ACTIONS(817),
    [anon_sym_bool] = ACTIONS(817),
    [anon_sym_string] = ACTIONS(817),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(817),
    [anon_sym_int40] = ACTIONS(817),
    [anon_sym_int48] = ACTIONS(817),
    [anon_sym_int56] = ACTIONS(817),
    [anon_sym_int64] = ACTIONS(817),
    [anon_sym_int72] = ACTIONS(817),
    [anon_sym_int80] = ACTIONS(817),
    [anon_sym_int88] = ACTIONS(817),
    [anon_sym_int96] = ACTIONS(817),
    [anon_sym_int104] = ACTIONS(817),
    [anon_sym_int112] = ACTIONS(817),
    [anon_sym_int120] = ACTIONS(817),
    [anon_sym_int128] = ACTIONS(817),
    [anon_sym_int136] = ACTIONS(817),
    [anon_sym_int144] = ACTIONS(817),
    [anon_sym_int152] = ACTIONS(817),
    [anon_sym_int160] = ACTIONS(817),
    [anon_sym_int168] = ACTIONS(817),
    [anon_sym_int176] = ACTIONS(817),
    [anon_sym_int184] = ACTIONS(817),
    [anon_sym_int192] = ACTIONS(817),
    [anon_sym_int200] = ACTIONS(817),
    [anon_sym_int208] = ACTIONS(817),
    [anon_sym_int216] = ACTIONS(817),
    [anon_sym_int224] = ACTIONS(817),
    [anon_sym_int232] = ACTIONS(817),
    [anon_sym_int240] = ACTIONS(817),
    [anon_sym_int248] = ACTIONS(817),
    [anon_sym_int256] = ACTIONS(817),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(817),
    [anon_sym_uint40] = ACTIONS(817),
    [anon_sym_uint48] = ACTIONS(817),
    [anon_sym_uint56] = ACTIONS(817),
    [anon_sym_uint64] = ACTIONS(817),
    [anon_sym_uint72] = ACTIONS(817),
    [anon_sym_uint80] = ACTIONS(817),
    [anon_sym_uint88] = ACTIONS(817),
    [anon_sym_uint96] = ACTIONS(817),
    [anon_sym_uint104] = ACTIONS(817),
    [anon_sym_uint112] = ACTIONS(817),
    [anon_sym_uint120] = ACTIONS(817),
    [anon_sym_uint128] = ACTIONS(817),
    [anon_sym_uint136] = ACTIONS(817),
    [anon_sym_uint144] = ACTIONS(817),
    [anon_sym_uint152] = ACTIONS(817),
    [anon_sym_uint160] = ACTIONS(817),
    [anon_sym_uint168] = ACTIONS(817),
    [anon_sym_uint176] = ACTIONS(817),
    [anon_sym_uint184] = ACTIONS(817),
    [anon_sym_uint192] = ACTIONS(817),
    [anon_sym_uint200] = ACTIONS(817),
    [anon_sym_uint208] = ACTIONS(817),
    [anon_sym_uint216] = ACTIONS(817),
    [anon_sym_uint224] = ACTIONS(817),
    [anon_sym_uint232] = ACTIONS(817),
    [anon_sym_uint240] = ACTIONS(817),
    [anon_sym_uint248] = ACTIONS(817),
    [anon_sym_uint256] = ACTIONS(817),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(817),
    [anon_sym_bytes5] = ACTIONS(817),
    [anon_sym_bytes6] = ACTIONS(817),
    [anon_sym_bytes7] = ACTIONS(817),
    [anon_sym_bytes8] = ACTIONS(817),
    [anon_sym_bytes9] = ACTIONS(817),
    [anon_sym_bytes10] = ACTIONS(817),
    [anon_sym_bytes11] = ACTIONS(817),
    [anon_sym_bytes12] = ACTIONS(817),
    [anon_sym_bytes13] = ACTIONS(817),
    [anon_sym_bytes14] = ACTIONS(817),
    [anon_sym_bytes15] = ACTIONS(817),
    [anon_sym_bytes16] = ACTIONS(817),
    [anon_sym_bytes17] = ACTIONS(817),
    [anon_sym_bytes18] = ACTIONS(817),
    [anon_sym_bytes19] = ACTIONS(817),
    [anon_sym_bytes20] = ACTIONS(817),
    [anon_sym_bytes21] = ACTIONS(817),
    [anon_sym_bytes22] = ACTIONS(817),
    [anon_sym_bytes23] = ACTIONS(817),
    [anon_sym_bytes24] = ACTIONS(817),
    [anon_sym_bytes25] = ACTIONS(817),
    [anon_sym_bytes26] = ACTIONS(817),
    [anon_sym_bytes27] = ACTIONS(817),
    [anon_sym_bytes28] = ACTIONS(817),
    [anon_sym_bytes29] = ACTIONS(817),
    [anon_sym_bytes30] = ACTIONS(817),
    [anon_sym_bytes31] = ACTIONS(817),
    [anon_sym_bytes32] = ACTIONS(817),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(817),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(817),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_primitive_type] = STATE(798),
    [sym__int] = STATE(316),
    [sym__uint] = STATE(316),
    [sym__bytes] = STATE(316),
    [sym__fixed] = STATE(316),
    [sym__ufixed] = STATE(316),
    [anon_sym_byte] = ACTIONS(31),
    [anon_sym_address] = ACTIONS(815),
    [anon_sym_var] = ACTIONS(817),
    [anon_sym_bool] = ACTIONS(817),
    [anon_sym_string] = ACTIONS(817),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_int8] = ACTIONS(31),
    [anon_sym_int16] = ACTIONS(31),
    [anon_sym_int24] = ACTIONS(31),
    [anon_sym_int32] = ACTIONS(817),
    [anon_sym_int40] = ACTIONS(817),
    [anon_sym_int48] = ACTIONS(817),
    [anon_sym_int56] = ACTIONS(817),
    [anon_sym_int64] = ACTIONS(817),
    [anon_sym_int72] = ACTIONS(817),
    [anon_sym_int80] = ACTIONS(817),
    [anon_sym_int88] = ACTIONS(817),
    [anon_sym_int96] = ACTIONS(817),
    [anon_sym_int104] = ACTIONS(817),
    [anon_sym_int112] = ACTIONS(817),
    [anon_sym_int120] = ACTIONS(817),
    [anon_sym_int128] = ACTIONS(817),
    [anon_sym_int136] = ACTIONS(817),
    [anon_sym_int144] = ACTIONS(817),
    [anon_sym_int152] = ACTIONS(817),
    [anon_sym_int160] = ACTIONS(817),
    [anon_sym_int168] = ACTIONS(817),
    [anon_sym_int176] = ACTIONS(817),
    [anon_sym_int184] = ACTIONS(817),
    [anon_sym_int192] = ACTIONS(817),
    [anon_sym_int200] = ACTIONS(817),
    [anon_sym_int208] = ACTIONS(817),
    [anon_sym_int216] = ACTIONS(817),
    [anon_sym_int224] = ACTIONS(817),
    [anon_sym_int232] = ACTIONS(817),
    [anon_sym_int240] = ACTIONS(817),
    [anon_sym_int248] = ACTIONS(817),
    [anon_sym_int256] = ACTIONS(817),
    [anon_sym_uint] = ACTIONS(31),
    [anon_sym_uint8] = ACTIONS(31),
    [anon_sym_uint16] = ACTIONS(31),
    [anon_sym_uint24] = ACTIONS(31),
    [anon_sym_uint32] = ACTIONS(817),
    [anon_sym_uint40] = ACTIONS(817),
    [anon_sym_uint48] = ACTIONS(817),
    [anon_sym_uint56] = ACTIONS(817),
    [anon_sym_uint64] = ACTIONS(817),
    [anon_sym_uint72] = ACTIONS(817),
    [anon_sym_uint80] = ACTIONS(817),
    [anon_sym_uint88] = ACTIONS(817),
    [anon_sym_uint96] = ACTIONS(817),
    [anon_sym_uint104] = ACTIONS(817),
    [anon_sym_uint112] = ACTIONS(817),
    [anon_sym_uint120] = ACTIONS(817),
    [anon_sym_uint128] = ACTIONS(817),
    [anon_sym_uint136] = ACTIONS(817),
    [anon_sym_uint144] = ACTIONS(817),
    [anon_sym_uint152] = ACTIONS(817),
    [anon_sym_uint160] = ACTIONS(817),
    [anon_sym_uint168] = ACTIONS(817),
    [anon_sym_uint176] = ACTIONS(817),
    [anon_sym_uint184] = ACTIONS(817),
    [anon_sym_uint192] = ACTIONS(817),
    [anon_sym_uint200] = ACTIONS(817),
    [anon_sym_uint208] = ACTIONS(817),
    [anon_sym_uint216] = ACTIONS(817),
    [anon_sym_uint224] = ACTIONS(817),
    [anon_sym_uint232] = ACTIONS(817),
    [anon_sym_uint240] = ACTIONS(817),
    [anon_sym_uint248] = ACTIONS(817),
    [anon_sym_uint256] = ACTIONS(817),
    [anon_sym_bytes] = ACTIONS(31),
    [anon_sym_bytes1] = ACTIONS(31),
    [anon_sym_bytes2] = ACTIONS(31),
    [anon_sym_bytes3] = ACTIONS(31),
    [anon_sym_bytes4] = ACTIONS(817),
    [anon_sym_bytes5] = ACTIONS(817),
    [anon_sym_bytes6] = ACTIONS(817),
    [anon_sym_bytes7] = ACTIONS(817),
    [anon_sym_bytes8] = ACTIONS(817),
    [anon_sym_bytes9] = ACTIONS(817),
    [anon_sym_bytes10] = ACTIONS(817),
    [anon_sym_bytes11] = ACTIONS(817),
    [anon_sym_bytes12] = ACTIONS(817),
    [anon_sym_bytes13] = ACTIONS(817),
    [anon_sym_bytes14] = ACTIONS(817),
    [anon_sym_bytes15] = ACTIONS(817),
    [anon_sym_bytes16] = ACTIONS(817),
    [anon_sym_bytes17] = ACTIONS(817),
    [anon_sym_bytes18] = ACTIONS(817),
    [anon_sym_bytes19] = ACTIONS(817),
    [anon_sym_bytes20] = ACTIONS(817),
    [anon_sym_bytes21] = ACTIONS(817),
    [anon_sym_bytes22] = ACTIONS(817),
    [anon_sym_bytes23] = ACTIONS(817),
    [anon_sym_bytes24] = ACTIONS(817),
    [anon_sym_bytes25] = ACTIONS(817),
    [anon_sym_bytes26] = ACTIONS(817),
    [anon_sym_bytes27] = ACTIONS(817),
    [anon_sym_bytes28] = ACTIONS(817),
    [anon_sym_bytes29] = ACTIONS(817),
    [anon_sym_bytes30] = ACTIONS(817),
    [anon_sym_bytes31] = ACTIONS(817),
    [anon_sym_bytes32] = ACTIONS(817),
    [anon_sym_fixed] = ACTIONS(31),
    [aux_sym__fixed_token1] = ACTIONS(817),
    [anon_sym_ufixed] = ACTIONS(31),
    [aux_sym__ufixed_token1] = ACTIONS(817),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_identifier] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(819),
    [anon_sym_byte] = ACTIONS(819),
    [anon_sym_address] = ACTIONS(819),
    [anon_sym_var] = ACTIONS(819),
    [anon_sym_mapping] = ACTIONS(819),
    [anon_sym_bool] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_int] = ACTIONS(819),
    [anon_sym_int8] = ACTIONS(819),
    [anon_sym_int16] = ACTIONS(819),
    [anon_sym_int24] = ACTIONS(819),
    [anon_sym_int32] = ACTIONS(819),
    [anon_sym_int40] = ACTIONS(819),
    [anon_sym_int48] = ACTIONS(819),
    [anon_sym_int56] = ACTIONS(819),
    [anon_sym_int64] = ACTIONS(819),
    [anon_sym_int72] = ACTIONS(819),
    [anon_sym_int80] = ACTIONS(819),
    [anon_sym_int88] = ACTIONS(819),
    [anon_sym_int96] = ACTIONS(819),
    [anon_sym_int104] = ACTIONS(819),
    [anon_sym_int112] = ACTIONS(819),
    [anon_sym_int120] = ACTIONS(819),
    [anon_sym_int128] = ACTIONS(819),
    [anon_sym_int136] = ACTIONS(819),
    [anon_sym_int144] = ACTIONS(819),
    [anon_sym_int152] = ACTIONS(819),
    [anon_sym_int160] = ACTIONS(819),
    [anon_sym_int168] = ACTIONS(819),
    [anon_sym_int176] = ACTIONS(819),
    [anon_sym_int184] = ACTIONS(819),
    [anon_sym_int192] = ACTIONS(819),
    [anon_sym_int200] = ACTIONS(819),
    [anon_sym_int208] = ACTIONS(819),
    [anon_sym_int216] = ACTIONS(819),
    [anon_sym_int224] = ACTIONS(819),
    [anon_sym_int232] = ACTIONS(819),
    [anon_sym_int240] = ACTIONS(819),
    [anon_sym_int248] = ACTIONS(819),
    [anon_sym_int256] = ACTIONS(819),
    [anon_sym_uint] = ACTIONS(819),
    [anon_sym_uint8] = ACTIONS(819),
    [anon_sym_uint16] = ACTIONS(819),
    [anon_sym_uint24] = ACTIONS(819),
    [anon_sym_uint32] = ACTIONS(819),
    [anon_sym_uint40] = ACTIONS(819),
    [anon_sym_uint48] = ACTIONS(819),
    [anon_sym_uint56] = ACTIONS(819),
    [anon_sym_uint64] = ACTIONS(819),
    [anon_sym_uint72] = ACTIONS(819),
    [anon_sym_uint80] = ACTIONS(819),
    [anon_sym_uint88] = ACTIONS(819),
    [anon_sym_uint96] = ACTIONS(819),
    [anon_sym_uint104] = ACTIONS(819),
    [anon_sym_uint112] = ACTIONS(819),
    [anon_sym_uint120] = ACTIONS(819),
    [anon_sym_uint128] = ACTIONS(819),
    [anon_sym_uint136] = ACTIONS(819),
    [anon_sym_uint144] = ACTIONS(819),
    [anon_sym_uint152] = ACTIONS(819),
    [anon_sym_uint160] = ACTIONS(819),
    [anon_sym_uint168] = ACTIONS(819),
    [anon_sym_uint176] = ACTIONS(819),
    [anon_sym_uint184] = ACTIONS(819),
    [anon_sym_uint192] = ACTIONS(819),
    [anon_sym_uint200] = ACTIONS(819),
    [anon_sym_uint208] = ACTIONS(819),
    [anon_sym_uint216] = ACTIONS(819),
    [anon_sym_uint224] = ACTIONS(819),
    [anon_sym_uint232] = ACTIONS(819),
    [anon_sym_uint240] = ACTIONS(819),
    [anon_sym_uint248] = ACTIONS(819),
    [anon_sym_uint256] = ACTIONS(819),
    [anon_sym_bytes] = ACTIONS(819),
    [anon_sym_bytes1] = ACTIONS(819),
    [anon_sym_bytes2] = ACTIONS(819),
    [anon_sym_bytes3] = ACTIONS(819),
    [anon_sym_bytes4] = ACTIONS(819),
    [anon_sym_bytes5] = ACTIONS(819),
    [anon_sym_bytes6] = ACTIONS(819),
    [anon_sym_bytes7] = ACTIONS(819),
    [anon_sym_bytes8] = ACTIONS(819),
    [anon_sym_bytes9] = ACTIONS(819),
    [anon_sym_bytes10] = ACTIONS(819),
    [anon_sym_bytes11] = ACTIONS(819),
    [anon_sym_bytes12] = ACTIONS(819),
    [anon_sym_bytes13] = ACTIONS(819),
    [anon_sym_bytes14] = ACTIONS(819),
    [anon_sym_bytes15] = ACTIONS(819),
    [anon_sym_bytes16] = ACTIONS(819),
    [anon_sym_bytes17] = ACTIONS(819),
    [anon_sym_bytes18] = ACTIONS(819),
    [anon_sym_bytes19] = ACTIONS(819),
    [anon_sym_bytes20] = ACTIONS(819),
    [anon_sym_bytes21] = ACTIONS(819),
    [anon_sym_bytes22] = ACTIONS(819),
    [anon_sym_bytes23] = ACTIONS(819),
    [anon_sym_bytes24] = ACTIONS(819),
    [anon_sym_bytes25] = ACTIONS(819),
    [anon_sym_bytes26] = ACTIONS(819),
    [anon_sym_bytes27] = ACTIONS(819),
    [anon_sym_bytes28] = ACTIONS(819),
    [anon_sym_bytes29] = ACTIONS(819),
    [anon_sym_bytes30] = ACTIONS(819),
    [anon_sym_bytes31] = ACTIONS(819),
    [anon_sym_bytes32] = ACTIONS(819),
    [anon_sym_fixed] = ACTIONS(819),
    [aux_sym__fixed_token1] = ACTIONS(819),
    [anon_sym_ufixed] = ACTIONS(819),
    [aux_sym__ufixed_token1] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym__yul_statement] = STATE(220),
    [sym_yul_label] = STATE(220),
    [sym_yul_break] = STATE(220),
    [sym_yul_continue] = STATE(220),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(220),
    [sym_yul_string_literal] = STATE(220),
    [sym_yul_boolean] = STATE(220),
    [sym_yul_block] = STATE(220),
    [sym_yul_variable_declaration] = STATE(220),
    [sym_yul_assignment] = STATE(220),
    [sym_yul_function_call] = STATE(220),
    [sym_yul_if_statement] = STATE(220),
    [sym_yul_for_statement] = STATE(220),
    [sym_yul_switch_statement] = STATE(220),
    [sym_yul_function_definition] = STATE(220),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(831),
    [sym_yul_hex_number] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__yul_statement] = STATE(224),
    [sym_yul_label] = STATE(224),
    [sym_yul_break] = STATE(224),
    [sym_yul_continue] = STATE(224),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(224),
    [sym_yul_string_literal] = STATE(224),
    [sym_yul_boolean] = STATE(224),
    [sym_yul_block] = STATE(224),
    [sym_yul_variable_declaration] = STATE(224),
    [sym_yul_assignment] = STATE(224),
    [sym_yul_function_call] = STATE(224),
    [sym_yul_if_statement] = STATE(224),
    [sym_yul_for_statement] = STATE(224),
    [sym_yul_switch_statement] = STATE(224),
    [sym_yul_function_definition] = STATE(224),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(857),
    [sym_yul_hex_number] = ACTIONS(859),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__yul_statement] = STATE(223),
    [sym_yul_label] = STATE(223),
    [sym_yul_break] = STATE(223),
    [sym_yul_continue] = STATE(223),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(223),
    [sym_yul_string_literal] = STATE(223),
    [sym_yul_boolean] = STATE(223),
    [sym_yul_block] = STATE(223),
    [sym_yul_variable_declaration] = STATE(223),
    [sym_yul_assignment] = STATE(223),
    [sym_yul_function_call] = STATE(223),
    [sym_yul_if_statement] = STATE(223),
    [sym_yul_for_statement] = STATE(223),
    [sym_yul_switch_statement] = STATE(223),
    [sym_yul_function_definition] = STATE(223),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(863),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(863),
    [sym_yul_hex_number] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__yul_statement] = STATE(217),
    [sym_yul_label] = STATE(217),
    [sym_yul_break] = STATE(217),
    [sym_yul_continue] = STATE(217),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(217),
    [sym_yul_string_literal] = STATE(217),
    [sym_yul_boolean] = STATE(217),
    [sym_yul_block] = STATE(217),
    [sym_yul_variable_declaration] = STATE(217),
    [sym_yul_assignment] = STATE(217),
    [sym_yul_function_call] = STATE(217),
    [sym_yul_if_statement] = STATE(217),
    [sym_yul_for_statement] = STATE(217),
    [sym_yul_switch_statement] = STATE(217),
    [sym_yul_function_definition] = STATE(217),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(869),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(869),
    [sym_yul_hex_number] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__yul_statement] = STATE(224),
    [sym_yul_label] = STATE(224),
    [sym_yul_break] = STATE(224),
    [sym_yul_continue] = STATE(224),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(224),
    [sym_yul_string_literal] = STATE(224),
    [sym_yul_boolean] = STATE(224),
    [sym_yul_block] = STATE(224),
    [sym_yul_variable_declaration] = STATE(224),
    [sym_yul_assignment] = STATE(224),
    [sym_yul_function_call] = STATE(224),
    [sym_yul_if_statement] = STATE(224),
    [sym_yul_for_statement] = STATE(224),
    [sym_yul_switch_statement] = STATE(224),
    [sym_yul_function_definition] = STATE(224),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(857),
    [sym_yul_hex_number] = ACTIONS(859),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__yul_statement] = STATE(222),
    [sym_yul_label] = STATE(222),
    [sym_yul_break] = STATE(222),
    [sym_yul_continue] = STATE(222),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(222),
    [sym_yul_string_literal] = STATE(222),
    [sym_yul_boolean] = STATE(222),
    [sym_yul_block] = STATE(222),
    [sym_yul_variable_declaration] = STATE(222),
    [sym_yul_assignment] = STATE(222),
    [sym_yul_function_call] = STATE(222),
    [sym_yul_if_statement] = STATE(222),
    [sym_yul_for_statement] = STATE(222),
    [sym_yul_switch_statement] = STATE(222),
    [sym_yul_function_definition] = STATE(222),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(222),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(877),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(877),
    [sym_yul_hex_number] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__yul_statement] = STATE(224),
    [sym_yul_label] = STATE(224),
    [sym_yul_break] = STATE(224),
    [sym_yul_continue] = STATE(224),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(224),
    [sym_yul_string_literal] = STATE(224),
    [sym_yul_boolean] = STATE(224),
    [sym_yul_block] = STATE(224),
    [sym_yul_variable_declaration] = STATE(224),
    [sym_yul_assignment] = STATE(224),
    [sym_yul_function_call] = STATE(224),
    [sym_yul_if_statement] = STATE(224),
    [sym_yul_for_statement] = STATE(224),
    [sym_yul_switch_statement] = STATE(224),
    [sym_yul_function_definition] = STATE(224),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(857),
    [sym_yul_hex_number] = ACTIONS(859),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__yul_statement] = STATE(224),
    [sym_yul_label] = STATE(224),
    [sym_yul_break] = STATE(224),
    [sym_yul_continue] = STATE(224),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(224),
    [sym_yul_string_literal] = STATE(224),
    [sym_yul_boolean] = STATE(224),
    [sym_yul_block] = STATE(224),
    [sym_yul_variable_declaration] = STATE(224),
    [sym_yul_assignment] = STATE(224),
    [sym_yul_function_call] = STATE(224),
    [sym_yul_if_statement] = STATE(224),
    [sym_yul_for_statement] = STATE(224),
    [sym_yul_switch_statement] = STATE(224),
    [sym_yul_function_definition] = STATE(224),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(829),
    [sym_yul_leave] = ACTIONS(857),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(835),
    [sym_yul_decimal_number] = ACTIONS(857),
    [sym_yul_hex_number] = ACTIONS(859),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__yul_statement] = STATE(224),
    [sym_yul_label] = STATE(224),
    [sym_yul_break] = STATE(224),
    [sym_yul_continue] = STATE(224),
    [sym_yul_identifier] = STATE(225),
    [sym_yul_path] = STATE(234),
    [sym__yul_literal] = STATE(224),
    [sym_yul_string_literal] = STATE(224),
    [sym_yul_boolean] = STATE(224),
    [sym_yul_block] = STATE(224),
    [sym_yul_variable_declaration] = STATE(224),
    [sym_yul_assignment] = STATE(224),
    [sym_yul_function_call] = STATE(224),
    [sym_yul_if_statement] = STATE(224),
    [sym_yul_for_statement] = STATE(224),
    [sym_yul_switch_statement] = STATE(224),
    [sym_yul_function_definition] = STATE(224),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [aux_sym_assembly_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(884),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(889),
    [sym_yul_leave] = ACTIONS(892),
    [anon_sym_break] = ACTIONS(895),
    [anon_sym_continue] = ACTIONS(898),
    [sym_yul_decimal_number] = ACTIONS(892),
    [sym_yul_hex_number] = ACTIONS(901),
    [anon_sym_true] = ACTIONS(904),
    [anon_sym_false] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(913),
    [anon_sym_function] = ACTIONS(916),
    [anon_sym_stop] = ACTIONS(919),
    [anon_sym_add] = ACTIONS(919),
    [anon_sym_sub] = ACTIONS(919),
    [anon_sym_mul] = ACTIONS(919),
    [anon_sym_div] = ACTIONS(919),
    [anon_sym_sdiv] = ACTIONS(919),
    [anon_sym_mod] = ACTIONS(919),
    [anon_sym_smod] = ACTIONS(919),
    [anon_sym_exp] = ACTIONS(919),
    [anon_sym_not] = ACTIONS(919),
    [anon_sym_lt] = ACTIONS(919),
    [anon_sym_gt] = ACTIONS(919),
    [anon_sym_slt] = ACTIONS(919),
    [anon_sym_sgt] = ACTIONS(919),
    [anon_sym_eq] = ACTIONS(919),
    [anon_sym_iszero] = ACTIONS(919),
    [anon_sym_and] = ACTIONS(919),
    [anon_sym_or] = ACTIONS(919),
    [anon_sym_xor] = ACTIONS(919),
    [anon_sym_byte] = ACTIONS(919),
    [anon_sym_shl] = ACTIONS(919),
    [anon_sym_shr] = ACTIONS(919),
    [anon_sym_sar] = ACTIONS(919),
    [anon_sym_addmod] = ACTIONS(919),
    [anon_sym_mulmod] = ACTIONS(919),
    [anon_sym_signextend] = ACTIONS(919),
    [anon_sym_keccak256] = ACTIONS(919),
    [anon_sym_pop] = ACTIONS(919),
    [anon_sym_mload] = ACTIONS(919),
    [anon_sym_mstore] = ACTIONS(919),
    [anon_sym_mstore8] = ACTIONS(919),
    [anon_sym_sload] = ACTIONS(919),
    [anon_sym_sstore] = ACTIONS(919),
    [anon_sym_msize] = ACTIONS(919),
    [anon_sym_gas] = ACTIONS(919),
    [anon_sym_address] = ACTIONS(919),
    [anon_sym_balance] = ACTIONS(919),
    [anon_sym_selfbalance] = ACTIONS(919),
    [anon_sym_caller] = ACTIONS(919),
    [anon_sym_callvalue] = ACTIONS(919),
    [anon_sym_calldataload] = ACTIONS(919),
    [anon_sym_calldatasize] = ACTIONS(919),
    [anon_sym_calldatacopy] = ACTIONS(919),
    [anon_sym_extcodesize] = ACTIONS(919),
    [anon_sym_extcodecopy] = ACTIONS(919),
    [anon_sym_returndatasize] = ACTIONS(919),
    [anon_sym_returndatacopy] = ACTIONS(919),
    [anon_sym_extcodehash] = ACTIONS(919),
    [anon_sym_create] = ACTIONS(919),
    [anon_sym_create2] = ACTIONS(919),
    [anon_sym_call] = ACTIONS(919),
    [anon_sym_callcode] = ACTIONS(919),
    [anon_sym_delegatecall] = ACTIONS(919),
    [anon_sym_staticcall] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_revert] = ACTIONS(919),
    [anon_sym_selfdestruct] = ACTIONS(919),
    [anon_sym_invalid] = ACTIONS(919),
    [anon_sym_log0] = ACTIONS(919),
    [anon_sym_log1] = ACTIONS(919),
    [anon_sym_log2] = ACTIONS(919),
    [anon_sym_log3] = ACTIONS(919),
    [anon_sym_log4] = ACTIONS(919),
    [anon_sym_chainid] = ACTIONS(919),
    [anon_sym_origin] = ACTIONS(919),
    [anon_sym_gasprice] = ACTIONS(919),
    [anon_sym_blockhash] = ACTIONS(919),
    [anon_sym_coinbase] = ACTIONS(919),
    [anon_sym_timestamp] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_difficulty] = ACTIONS(919),
    [anon_sym_gaslimit] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(922),
    [anon_sym_SQUOTE] = ACTIONS(925),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [aux_sym_yul_path_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_LBRACE] = ACTIONS(930),
    [anon_sym_COMMA] = ACTIONS(930),
    [anon_sym_RBRACE] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_RPAREN] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_COLON] = ACTIONS(928),
    [sym_yul_leave] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_DOT] = ACTIONS(934),
    [sym_yul_decimal_number] = ACTIONS(928),
    [sym_yul_hex_number] = ACTIONS(930),
    [anon_sym_true] = ACTIONS(928),
    [anon_sym_false] = ACTIONS(928),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_COLON_EQ] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_switch] = ACTIONS(928),
    [anon_sym_default] = ACTIONS(928),
    [anon_sym_case] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(928),
    [anon_sym_stop] = ACTIONS(928),
    [anon_sym_add] = ACTIONS(928),
    [anon_sym_sub] = ACTIONS(928),
    [anon_sym_mul] = ACTIONS(928),
    [anon_sym_div] = ACTIONS(928),
    [anon_sym_sdiv] = ACTIONS(928),
    [anon_sym_mod] = ACTIONS(928),
    [anon_sym_smod] = ACTIONS(928),
    [anon_sym_exp] = ACTIONS(928),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_lt] = ACTIONS(928),
    [anon_sym_gt] = ACTIONS(928),
    [anon_sym_slt] = ACTIONS(928),
    [anon_sym_sgt] = ACTIONS(928),
    [anon_sym_eq] = ACTIONS(928),
    [anon_sym_iszero] = ACTIONS(928),
    [anon_sym_and] = ACTIONS(928),
    [anon_sym_or] = ACTIONS(928),
    [anon_sym_xor] = ACTIONS(928),
    [anon_sym_byte] = ACTIONS(928),
    [anon_sym_shl] = ACTIONS(928),
    [anon_sym_shr] = ACTIONS(928),
    [anon_sym_sar] = ACTIONS(928),
    [anon_sym_addmod] = ACTIONS(928),
    [anon_sym_mulmod] = ACTIONS(928),
    [anon_sym_signextend] = ACTIONS(928),
    [anon_sym_keccak256] = ACTIONS(928),
    [anon_sym_pop] = ACTIONS(928),
    [anon_sym_mload] = ACTIONS(928),
    [anon_sym_mstore] = ACTIONS(928),
    [anon_sym_mstore8] = ACTIONS(928),
    [anon_sym_sload] = ACTIONS(928),
    [anon_sym_sstore] = ACTIONS(928),
    [anon_sym_msize] = ACTIONS(928),
    [anon_sym_gas] = ACTIONS(928),
    [anon_sym_address] = ACTIONS(928),
    [anon_sym_balance] = ACTIONS(928),
    [anon_sym_selfbalance] = ACTIONS(928),
    [anon_sym_caller] = ACTIONS(928),
    [anon_sym_callvalue] = ACTIONS(928),
    [anon_sym_calldataload] = ACTIONS(928),
    [anon_sym_calldatasize] = ACTIONS(928),
    [anon_sym_calldatacopy] = ACTIONS(928),
    [anon_sym_extcodesize] = ACTIONS(928),
    [anon_sym_extcodecopy] = ACTIONS(928),
    [anon_sym_returndatasize] = ACTIONS(928),
    [anon_sym_returndatacopy] = ACTIONS(928),
    [anon_sym_extcodehash] = ACTIONS(928),
    [anon_sym_create] = ACTIONS(928),
    [anon_sym_create2] = ACTIONS(928),
    [anon_sym_call] = ACTIONS(928),
    [anon_sym_callcode] = ACTIONS(928),
    [anon_sym_delegatecall] = ACTIONS(928),
    [anon_sym_staticcall] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_revert] = ACTIONS(928),
    [anon_sym_selfdestruct] = ACTIONS(928),
    [anon_sym_invalid] = ACTIONS(928),
    [anon_sym_log0] = ACTIONS(928),
    [anon_sym_log1] = ACTIONS(928),
    [anon_sym_log2] = ACTIONS(928),
    [anon_sym_log3] = ACTIONS(928),
    [anon_sym_log4] = ACTIONS(928),
    [anon_sym_chainid] = ACTIONS(928),
    [anon_sym_origin] = ACTIONS(928),
    [anon_sym_gasprice] = ACTIONS(928),
    [anon_sym_blockhash] = ACTIONS(928),
    [anon_sym_coinbase] = ACTIONS(928),
    [anon_sym_timestamp] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_difficulty] = ACTIONS(928),
    [anon_sym_gaslimit] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [aux_sym_yul_path_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_COMMA] = ACTIONS(938),
    [anon_sym_RBRACE] = ACTIONS(938),
    [anon_sym_RPAREN] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(936),
    [anon_sym_COLON] = ACTIONS(936),
    [sym_yul_leave] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(936),
    [anon_sym_continue] = ACTIONS(936),
    [anon_sym_DOT] = ACTIONS(934),
    [sym_yul_decimal_number] = ACTIONS(936),
    [sym_yul_hex_number] = ACTIONS(938),
    [anon_sym_true] = ACTIONS(936),
    [anon_sym_false] = ACTIONS(936),
    [anon_sym_let] = ACTIONS(936),
    [anon_sym_COLON_EQ] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(936),
    [anon_sym_switch] = ACTIONS(936),
    [anon_sym_default] = ACTIONS(936),
    [anon_sym_case] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(936),
    [anon_sym_stop] = ACTIONS(936),
    [anon_sym_add] = ACTIONS(936),
    [anon_sym_sub] = ACTIONS(936),
    [anon_sym_mul] = ACTIONS(936),
    [anon_sym_div] = ACTIONS(936),
    [anon_sym_sdiv] = ACTIONS(936),
    [anon_sym_mod] = ACTIONS(936),
    [anon_sym_smod] = ACTIONS(936),
    [anon_sym_exp] = ACTIONS(936),
    [anon_sym_not] = ACTIONS(936),
    [anon_sym_lt] = ACTIONS(936),
    [anon_sym_gt] = ACTIONS(936),
    [anon_sym_slt] = ACTIONS(936),
    [anon_sym_sgt] = ACTIONS(936),
    [anon_sym_eq] = ACTIONS(936),
    [anon_sym_iszero] = ACTIONS(936),
    [anon_sym_and] = ACTIONS(936),
    [anon_sym_or] = ACTIONS(936),
    [anon_sym_xor] = ACTIONS(936),
    [anon_sym_byte] = ACTIONS(936),
    [anon_sym_shl] = ACTIONS(936),
    [anon_sym_shr] = ACTIONS(936),
    [anon_sym_sar] = ACTIONS(936),
    [anon_sym_addmod] = ACTIONS(936),
    [anon_sym_mulmod] = ACTIONS(936),
    [anon_sym_signextend] = ACTIONS(936),
    [anon_sym_keccak256] = ACTIONS(936),
    [anon_sym_pop] = ACTIONS(936),
    [anon_sym_mload] = ACTIONS(936),
    [anon_sym_mstore] = ACTIONS(936),
    [anon_sym_mstore8] = ACTIONS(936),
    [anon_sym_sload] = ACTIONS(936),
    [anon_sym_sstore] = ACTIONS(936),
    [anon_sym_msize] = ACTIONS(936),
    [anon_sym_gas] = ACTIONS(936),
    [anon_sym_address] = ACTIONS(936),
    [anon_sym_balance] = ACTIONS(936),
    [anon_sym_selfbalance] = ACTIONS(936),
    [anon_sym_caller] = ACTIONS(936),
    [anon_sym_callvalue] = ACTIONS(936),
    [anon_sym_calldataload] = ACTIONS(936),
    [anon_sym_calldatasize] = ACTIONS(936),
    [anon_sym_calldatacopy] = ACTIONS(936),
    [anon_sym_extcodesize] = ACTIONS(936),
    [anon_sym_extcodecopy] = ACTIONS(936),
    [anon_sym_returndatasize] = ACTIONS(936),
    [anon_sym_returndatacopy] = ACTIONS(936),
    [anon_sym_extcodehash] = ACTIONS(936),
    [anon_sym_create] = ACTIONS(936),
    [anon_sym_create2] = ACTIONS(936),
    [anon_sym_call] = ACTIONS(936),
    [anon_sym_callcode] = ACTIONS(936),
    [anon_sym_delegatecall] = ACTIONS(936),
    [anon_sym_staticcall] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(936),
    [anon_sym_revert] = ACTIONS(936),
    [anon_sym_selfdestruct] = ACTIONS(936),
    [anon_sym_invalid] = ACTIONS(936),
    [anon_sym_log0] = ACTIONS(936),
    [anon_sym_log1] = ACTIONS(936),
    [anon_sym_log2] = ACTIONS(936),
    [anon_sym_log3] = ACTIONS(936),
    [anon_sym_log4] = ACTIONS(936),
    [anon_sym_chainid] = ACTIONS(936),
    [anon_sym_origin] = ACTIONS(936),
    [anon_sym_gasprice] = ACTIONS(936),
    [anon_sym_blockhash] = ACTIONS(936),
    [anon_sym_coinbase] = ACTIONS(936),
    [anon_sym_timestamp] = ACTIONS(936),
    [anon_sym_number] = ACTIONS(936),
    [anon_sym_difficulty] = ACTIONS(936),
    [anon_sym_gaslimit] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [anon_sym_SQUOTE] = ACTIONS(938),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_COMMA] = ACTIONS(942),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_RPAREN] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_COLON] = ACTIONS(940),
    [sym_yul_leave] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_DOT] = ACTIONS(942),
    [sym_yul_decimal_number] = ACTIONS(940),
    [sym_yul_hex_number] = ACTIONS(942),
    [anon_sym_true] = ACTIONS(940),
    [anon_sym_false] = ACTIONS(940),
    [anon_sym_let] = ACTIONS(940),
    [anon_sym_COLON_EQ] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(940),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_stop] = ACTIONS(940),
    [anon_sym_add] = ACTIONS(940),
    [anon_sym_sub] = ACTIONS(940),
    [anon_sym_mul] = ACTIONS(940),
    [anon_sym_div] = ACTIONS(940),
    [anon_sym_sdiv] = ACTIONS(940),
    [anon_sym_mod] = ACTIONS(940),
    [anon_sym_smod] = ACTIONS(940),
    [anon_sym_exp] = ACTIONS(940),
    [anon_sym_not] = ACTIONS(940),
    [anon_sym_lt] = ACTIONS(940),
    [anon_sym_gt] = ACTIONS(940),
    [anon_sym_slt] = ACTIONS(940),
    [anon_sym_sgt] = ACTIONS(940),
    [anon_sym_eq] = ACTIONS(940),
    [anon_sym_iszero] = ACTIONS(940),
    [anon_sym_and] = ACTIONS(940),
    [anon_sym_or] = ACTIONS(940),
    [anon_sym_xor] = ACTIONS(940),
    [anon_sym_byte] = ACTIONS(940),
    [anon_sym_shl] = ACTIONS(940),
    [anon_sym_shr] = ACTIONS(940),
    [anon_sym_sar] = ACTIONS(940),
    [anon_sym_addmod] = ACTIONS(940),
    [anon_sym_mulmod] = ACTIONS(940),
    [anon_sym_signextend] = ACTIONS(940),
    [anon_sym_keccak256] = ACTIONS(940),
    [anon_sym_pop] = ACTIONS(940),
    [anon_sym_mload] = ACTIONS(940),
    [anon_sym_mstore] = ACTIONS(940),
    [anon_sym_mstore8] = ACTIONS(940),
    [anon_sym_sload] = ACTIONS(940),
    [anon_sym_sstore] = ACTIONS(940),
    [anon_sym_msize] = ACTIONS(940),
    [anon_sym_gas] = ACTIONS(940),
    [anon_sym_address] = ACTIONS(940),
    [anon_sym_balance] = ACTIONS(940),
    [anon_sym_selfbalance] = ACTIONS(940),
    [anon_sym_caller] = ACTIONS(940),
    [anon_sym_callvalue] = ACTIONS(940),
    [anon_sym_calldataload] = ACTIONS(940),
    [anon_sym_calldatasize] = ACTIONS(940),
    [anon_sym_calldatacopy] = ACTIONS(940),
    [anon_sym_extcodesize] = ACTIONS(940),
    [anon_sym_extcodecopy] = ACTIONS(940),
    [anon_sym_returndatasize] = ACTIONS(940),
    [anon_sym_returndatacopy] = ACTIONS(940),
    [anon_sym_extcodehash] = ACTIONS(940),
    [anon_sym_create] = ACTIONS(940),
    [anon_sym_create2] = ACTIONS(940),
    [anon_sym_call] = ACTIONS(940),
    [anon_sym_callcode] = ACTIONS(940),
    [anon_sym_delegatecall] = ACTIONS(940),
    [anon_sym_staticcall] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_revert] = ACTIONS(940),
    [anon_sym_selfdestruct] = ACTIONS(940),
    [anon_sym_invalid] = ACTIONS(940),
    [anon_sym_log0] = ACTIONS(940),
    [anon_sym_log1] = ACTIONS(940),
    [anon_sym_log2] = ACTIONS(940),
    [anon_sym_log3] = ACTIONS(940),
    [anon_sym_log4] = ACTIONS(940),
    [anon_sym_chainid] = ACTIONS(940),
    [anon_sym_origin] = ACTIONS(940),
    [anon_sym_gasprice] = ACTIONS(940),
    [anon_sym_blockhash] = ACTIONS(940),
    [anon_sym_coinbase] = ACTIONS(940),
    [anon_sym_timestamp] = ACTIONS(940),
    [anon_sym_number] = ACTIONS(940),
    [anon_sym_difficulty] = ACTIONS(940),
    [anon_sym_gaslimit] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [aux_sym_yul_path_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_COMMA] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_RPAREN] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_COLON] = ACTIONS(944),
    [sym_yul_leave] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_DOT] = ACTIONS(948),
    [sym_yul_decimal_number] = ACTIONS(944),
    [sym_yul_hex_number] = ACTIONS(946),
    [anon_sym_true] = ACTIONS(944),
    [anon_sym_false] = ACTIONS(944),
    [anon_sym_let] = ACTIONS(944),
    [anon_sym_COLON_EQ] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_function] = ACTIONS(944),
    [anon_sym_stop] = ACTIONS(944),
    [anon_sym_add] = ACTIONS(944),
    [anon_sym_sub] = ACTIONS(944),
    [anon_sym_mul] = ACTIONS(944),
    [anon_sym_div] = ACTIONS(944),
    [anon_sym_sdiv] = ACTIONS(944),
    [anon_sym_mod] = ACTIONS(944),
    [anon_sym_smod] = ACTIONS(944),
    [anon_sym_exp] = ACTIONS(944),
    [anon_sym_not] = ACTIONS(944),
    [anon_sym_lt] = ACTIONS(944),
    [anon_sym_gt] = ACTIONS(944),
    [anon_sym_slt] = ACTIONS(944),
    [anon_sym_sgt] = ACTIONS(944),
    [anon_sym_eq] = ACTIONS(944),
    [anon_sym_iszero] = ACTIONS(944),
    [anon_sym_and] = ACTIONS(944),
    [anon_sym_or] = ACTIONS(944),
    [anon_sym_xor] = ACTIONS(944),
    [anon_sym_byte] = ACTIONS(944),
    [anon_sym_shl] = ACTIONS(944),
    [anon_sym_shr] = ACTIONS(944),
    [anon_sym_sar] = ACTIONS(944),
    [anon_sym_addmod] = ACTIONS(944),
    [anon_sym_mulmod] = ACTIONS(944),
    [anon_sym_signextend] = ACTIONS(944),
    [anon_sym_keccak256] = ACTIONS(944),
    [anon_sym_pop] = ACTIONS(944),
    [anon_sym_mload] = ACTIONS(944),
    [anon_sym_mstore] = ACTIONS(944),
    [anon_sym_mstore8] = ACTIONS(944),
    [anon_sym_sload] = ACTIONS(944),
    [anon_sym_sstore] = ACTIONS(944),
    [anon_sym_msize] = ACTIONS(944),
    [anon_sym_gas] = ACTIONS(944),
    [anon_sym_address] = ACTIONS(944),
    [anon_sym_balance] = ACTIONS(944),
    [anon_sym_selfbalance] = ACTIONS(944),
    [anon_sym_caller] = ACTIONS(944),
    [anon_sym_callvalue] = ACTIONS(944),
    [anon_sym_calldataload] = ACTIONS(944),
    [anon_sym_calldatasize] = ACTIONS(944),
    [anon_sym_calldatacopy] = ACTIONS(944),
    [anon_sym_extcodesize] = ACTIONS(944),
    [anon_sym_extcodecopy] = ACTIONS(944),
    [anon_sym_returndatasize] = ACTIONS(944),
    [anon_sym_returndatacopy] = ACTIONS(944),
    [anon_sym_extcodehash] = ACTIONS(944),
    [anon_sym_create] = ACTIONS(944),
    [anon_sym_create2] = ACTIONS(944),
    [anon_sym_call] = ACTIONS(944),
    [anon_sym_callcode] = ACTIONS(944),
    [anon_sym_delegatecall] = ACTIONS(944),
    [anon_sym_staticcall] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_revert] = ACTIONS(944),
    [anon_sym_selfdestruct] = ACTIONS(944),
    [anon_sym_invalid] = ACTIONS(944),
    [anon_sym_log0] = ACTIONS(944),
    [anon_sym_log1] = ACTIONS(944),
    [anon_sym_log2] = ACTIONS(944),
    [anon_sym_log3] = ACTIONS(944),
    [anon_sym_log4] = ACTIONS(944),
    [anon_sym_chainid] = ACTIONS(944),
    [anon_sym_origin] = ACTIONS(944),
    [anon_sym_gasprice] = ACTIONS(944),
    [anon_sym_blockhash] = ACTIONS(944),
    [anon_sym_coinbase] = ACTIONS(944),
    [anon_sym_timestamp] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_difficulty] = ACTIONS(944),
    [anon_sym_gaslimit] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_identifier] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_COMMA] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_RPAREN] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_COLON] = ACTIONS(944),
    [sym_yul_leave] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_DOT] = ACTIONS(946),
    [sym_yul_decimal_number] = ACTIONS(944),
    [sym_yul_hex_number] = ACTIONS(946),
    [anon_sym_true] = ACTIONS(944),
    [anon_sym_false] = ACTIONS(944),
    [anon_sym_let] = ACTIONS(944),
    [anon_sym_COLON_EQ] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_function] = ACTIONS(944),
    [anon_sym_stop] = ACTIONS(944),
    [anon_sym_add] = ACTIONS(944),
    [anon_sym_sub] = ACTIONS(944),
    [anon_sym_mul] = ACTIONS(944),
    [anon_sym_div] = ACTIONS(944),
    [anon_sym_sdiv] = ACTIONS(944),
    [anon_sym_mod] = ACTIONS(944),
    [anon_sym_smod] = ACTIONS(944),
    [anon_sym_exp] = ACTIONS(944),
    [anon_sym_not] = ACTIONS(944),
    [anon_sym_lt] = ACTIONS(944),
    [anon_sym_gt] = ACTIONS(944),
    [anon_sym_slt] = ACTIONS(944),
    [anon_sym_sgt] = ACTIONS(944),
    [anon_sym_eq] = ACTIONS(944),
    [anon_sym_iszero] = ACTIONS(944),
    [anon_sym_and] = ACTIONS(944),
    [anon_sym_or] = ACTIONS(944),
    [anon_sym_xor] = ACTIONS(944),
    [anon_sym_byte] = ACTIONS(944),
    [anon_sym_shl] = ACTIONS(944),
    [anon_sym_shr] = ACTIONS(944),
    [anon_sym_sar] = ACTIONS(944),
    [anon_sym_addmod] = ACTIONS(944),
    [anon_sym_mulmod] = ACTIONS(944),
    [anon_sym_signextend] = ACTIONS(944),
    [anon_sym_keccak256] = ACTIONS(944),
    [anon_sym_pop] = ACTIONS(944),
    [anon_sym_mload] = ACTIONS(944),
    [anon_sym_mstore] = ACTIONS(944),
    [anon_sym_mstore8] = ACTIONS(944),
    [anon_sym_sload] = ACTIONS(944),
    [anon_sym_sstore] = ACTIONS(944),
    [anon_sym_msize] = ACTIONS(944),
    [anon_sym_gas] = ACTIONS(944),
    [anon_sym_address] = ACTIONS(944),
    [anon_sym_balance] = ACTIONS(944),
    [anon_sym_selfbalance] = ACTIONS(944),
    [anon_sym_caller] = ACTIONS(944),
    [anon_sym_callvalue] = ACTIONS(944),
    [anon_sym_calldataload] = ACTIONS(944),
    [anon_sym_calldatasize] = ACTIONS(944),
    [anon_sym_calldatacopy] = ACTIONS(944),
    [anon_sym_extcodesize] = ACTIONS(944),
    [anon_sym_extcodecopy] = ACTIONS(944),
    [anon_sym_returndatasize] = ACTIONS(944),
    [anon_sym_returndatacopy] = ACTIONS(944),
    [anon_sym_extcodehash] = ACTIONS(944),
    [anon_sym_create] = ACTIONS(944),
    [anon_sym_create2] = ACTIONS(944),
    [anon_sym_call] = ACTIONS(944),
    [anon_sym_callcode] = ACTIONS(944),
    [anon_sym_delegatecall] = ACTIONS(944),
    [anon_sym_staticcall] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_revert] = ACTIONS(944),
    [anon_sym_selfdestruct] = ACTIONS(944),
    [anon_sym_invalid] = ACTIONS(944),
    [anon_sym_log0] = ACTIONS(944),
    [anon_sym_log1] = ACTIONS(944),
    [anon_sym_log2] = ACTIONS(944),
    [anon_sym_log3] = ACTIONS(944),
    [anon_sym_log4] = ACTIONS(944),
    [anon_sym_chainid] = ACTIONS(944),
    [anon_sym_origin] = ACTIONS(944),
    [anon_sym_gasprice] = ACTIONS(944),
    [anon_sym_blockhash] = ACTIONS(944),
    [anon_sym_coinbase] = ACTIONS(944),
    [anon_sym_timestamp] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_difficulty] = ACTIONS(944),
    [anon_sym_gaslimit] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(946),
    [anon_sym_SQUOTE] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [aux_sym_yul_path_repeat1] = STATE(226),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_LBRACE] = ACTIONS(930),
    [anon_sym_COMMA] = ACTIONS(930),
    [anon_sym_RBRACE] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_COLON] = ACTIONS(928),
    [sym_yul_leave] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_DOT] = ACTIONS(934),
    [sym_yul_decimal_number] = ACTIONS(928),
    [sym_yul_hex_number] = ACTIONS(930),
    [anon_sym_true] = ACTIONS(928),
    [anon_sym_false] = ACTIONS(928),
    [anon_sym_let] = ACTIONS(928),
    [anon_sym_COLON_EQ] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_switch] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(928),
    [anon_sym_stop] = ACTIONS(928),
    [anon_sym_add] = ACTIONS(928),
    [anon_sym_sub] = ACTIONS(928),
    [anon_sym_mul] = ACTIONS(928),
    [anon_sym_div] = ACTIONS(928),
    [anon_sym_sdiv] = ACTIONS(928),
    [anon_sym_mod] = ACTIONS(928),
    [anon_sym_smod] = ACTIONS(928),
    [anon_sym_exp] = ACTIONS(928),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_lt] = ACTIONS(928),
    [anon_sym_gt] = ACTIONS(928),
    [anon_sym_slt] = ACTIONS(928),
    [anon_sym_sgt] = ACTIONS(928),
    [anon_sym_eq] = ACTIONS(928),
    [anon_sym_iszero] = ACTIONS(928),
    [anon_sym_and] = ACTIONS(928),
    [anon_sym_or] = ACTIONS(928),
    [anon_sym_xor] = ACTIONS(928),
    [anon_sym_byte] = ACTIONS(928),
    [anon_sym_shl] = ACTIONS(928),
    [anon_sym_shr] = ACTIONS(928),
    [anon_sym_sar] = ACTIONS(928),
    [anon_sym_addmod] = ACTIONS(928),
    [anon_sym_mulmod] = ACTIONS(928),
    [anon_sym_signextend] = ACTIONS(928),
    [anon_sym_keccak256] = ACTIONS(928),
    [anon_sym_pop] = ACTIONS(928),
    [anon_sym_mload] = ACTIONS(928),
    [anon_sym_mstore] = ACTIONS(928),
    [anon_sym_mstore8] = ACTIONS(928),
    [anon_sym_sload] = ACTIONS(928),
    [anon_sym_sstore] = ACTIONS(928),
    [anon_sym_msize] = ACTIONS(928),
    [anon_sym_gas] = ACTIONS(928),
    [anon_sym_address] = ACTIONS(928),
    [anon_sym_balance] = ACTIONS(928),
    [anon_sym_selfbalance] = ACTIONS(928),
    [anon_sym_caller] = ACTIONS(928),
    [anon_sym_callvalue] = ACTIONS(928),
    [anon_sym_calldataload] = ACTIONS(928),
    [anon_sym_calldatasize] = ACTIONS(928),
    [anon_sym_calldatacopy] = ACTIONS(928),
    [anon_sym_extcodesize] = ACTIONS(928),
    [anon_sym_extcodecopy] = ACTIONS(928),
    [anon_sym_returndatasize] = ACTIONS(928),
    [anon_sym_returndatacopy] = ACTIONS(928),
    [anon_sym_extcodehash] = ACTIONS(928),
    [anon_sym_create] = ACTIONS(928),
    [anon_sym_create2] = ACTIONS(928),
    [anon_sym_call] = ACTIONS(928),
    [anon_sym_callcode] = ACTIONS(928),
    [anon_sym_delegatecall] = ACTIONS(928),
    [anon_sym_staticcall] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_revert] = ACTIONS(928),
    [anon_sym_selfdestruct] = ACTIONS(928),
    [anon_sym_invalid] = ACTIONS(928),
    [anon_sym_log0] = ACTIONS(928),
    [anon_sym_log1] = ACTIONS(928),
    [anon_sym_log2] = ACTIONS(928),
    [anon_sym_log3] = ACTIONS(928),
    [anon_sym_log4] = ACTIONS(928),
    [anon_sym_chainid] = ACTIONS(928),
    [anon_sym_origin] = ACTIONS(928),
    [anon_sym_gasprice] = ACTIONS(928),
    [anon_sym_blockhash] = ACTIONS(928),
    [anon_sym_coinbase] = ACTIONS(928),
    [anon_sym_timestamp] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_difficulty] = ACTIONS(928),
    [anon_sym_gaslimit] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_yul_identifier] = STATE(230),
    [sym_yul_path] = STATE(248),
    [sym__yul_assignment_operator] = STATE(301),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_COLON] = ACTIONS(955),
    [sym_yul_leave] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [sym_yul_decimal_number] = ACTIONS(951),
    [sym_yul_hex_number] = ACTIONS(953),
    [anon_sym_true] = ACTIONS(951),
    [anon_sym_false] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_COLON_EQ] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(951),
    [anon_sym_stop] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_sub] = ACTIONS(951),
    [anon_sym_mul] = ACTIONS(951),
    [anon_sym_div] = ACTIONS(951),
    [anon_sym_sdiv] = ACTIONS(951),
    [anon_sym_mod] = ACTIONS(951),
    [anon_sym_smod] = ACTIONS(951),
    [anon_sym_exp] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(951),
    [anon_sym_lt] = ACTIONS(951),
    [anon_sym_gt] = ACTIONS(951),
    [anon_sym_slt] = ACTIONS(951),
    [anon_sym_sgt] = ACTIONS(951),
    [anon_sym_eq] = ACTIONS(951),
    [anon_sym_iszero] = ACTIONS(951),
    [anon_sym_and] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(951),
    [anon_sym_xor] = ACTIONS(951),
    [anon_sym_byte] = ACTIONS(951),
    [anon_sym_shl] = ACTIONS(951),
    [anon_sym_shr] = ACTIONS(951),
    [anon_sym_sar] = ACTIONS(951),
    [anon_sym_addmod] = ACTIONS(951),
    [anon_sym_mulmod] = ACTIONS(951),
    [anon_sym_signextend] = ACTIONS(951),
    [anon_sym_keccak256] = ACTIONS(951),
    [anon_sym_pop] = ACTIONS(951),
    [anon_sym_mload] = ACTIONS(951),
    [anon_sym_mstore] = ACTIONS(951),
    [anon_sym_mstore8] = ACTIONS(951),
    [anon_sym_sload] = ACTIONS(951),
    [anon_sym_sstore] = ACTIONS(951),
    [anon_sym_msize] = ACTIONS(951),
    [anon_sym_gas] = ACTIONS(951),
    [anon_sym_address] = ACTIONS(951),
    [anon_sym_balance] = ACTIONS(951),
    [anon_sym_selfbalance] = ACTIONS(951),
    [anon_sym_caller] = ACTIONS(951),
    [anon_sym_callvalue] = ACTIONS(951),
    [anon_sym_calldataload] = ACTIONS(951),
    [anon_sym_calldatasize] = ACTIONS(951),
    [anon_sym_calldatacopy] = ACTIONS(951),
    [anon_sym_extcodesize] = ACTIONS(951),
    [anon_sym_extcodecopy] = ACTIONS(951),
    [anon_sym_returndatasize] = ACTIONS(951),
    [anon_sym_returndatacopy] = ACTIONS(951),
    [anon_sym_extcodehash] = ACTIONS(951),
    [anon_sym_create] = ACTIONS(951),
    [anon_sym_create2] = ACTIONS(951),
    [anon_sym_call] = ACTIONS(951),
    [anon_sym_callcode] = ACTIONS(951),
    [anon_sym_delegatecall] = ACTIONS(951),
    [anon_sym_staticcall] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_revert] = ACTIONS(951),
    [anon_sym_selfdestruct] = ACTIONS(951),
    [anon_sym_invalid] = ACTIONS(951),
    [anon_sym_log0] = ACTIONS(951),
    [anon_sym_log1] = ACTIONS(951),
    [anon_sym_log2] = ACTIONS(951),
    [anon_sym_log3] = ACTIONS(951),
    [anon_sym_log4] = ACTIONS(951),
    [anon_sym_chainid] = ACTIONS(951),
    [anon_sym_origin] = ACTIONS(951),
    [anon_sym_gasprice] = ACTIONS(951),
    [anon_sym_blockhash] = ACTIONS(951),
    [anon_sym_coinbase] = ACTIONS(951),
    [anon_sym_timestamp] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(951),
    [anon_sym_difficulty] = ACTIONS(951),
    [anon_sym_gaslimit] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__yul_assignment_operator] = STATE(301),
    [aux_sym_yul_assignment_repeat1] = STATE(239),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_COLON] = ACTIONS(955),
    [sym_yul_leave] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [sym_yul_decimal_number] = ACTIONS(951),
    [sym_yul_hex_number] = ACTIONS(953),
    [anon_sym_true] = ACTIONS(951),
    [anon_sym_false] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_COLON_EQ] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(951),
    [anon_sym_function] = ACTIONS(951),
    [anon_sym_stop] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_sub] = ACTIONS(951),
    [anon_sym_mul] = ACTIONS(951),
    [anon_sym_div] = ACTIONS(951),
    [anon_sym_sdiv] = ACTIONS(951),
    [anon_sym_mod] = ACTIONS(951),
    [anon_sym_smod] = ACTIONS(951),
    [anon_sym_exp] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(951),
    [anon_sym_lt] = ACTIONS(951),
    [anon_sym_gt] = ACTIONS(951),
    [anon_sym_slt] = ACTIONS(951),
    [anon_sym_sgt] = ACTIONS(951),
    [anon_sym_eq] = ACTIONS(951),
    [anon_sym_iszero] = ACTIONS(951),
    [anon_sym_and] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(951),
    [anon_sym_xor] = ACTIONS(951),
    [anon_sym_byte] = ACTIONS(951),
    [anon_sym_shl] = ACTIONS(951),
    [anon_sym_shr] = ACTIONS(951),
    [anon_sym_sar] = ACTIONS(951),
    [anon_sym_addmod] = ACTIONS(951),
    [anon_sym_mulmod] = ACTIONS(951),
    [anon_sym_signextend] = ACTIONS(951),
    [anon_sym_keccak256] = ACTIONS(951),
    [anon_sym_pop] = ACTIONS(951),
    [anon_sym_mload] = ACTIONS(951),
    [anon_sym_mstore] = ACTIONS(951),
    [anon_sym_mstore8] = ACTIONS(951),
    [anon_sym_sload] = ACTIONS(951),
    [anon_sym_sstore] = ACTIONS(951),
    [anon_sym_msize] = ACTIONS(951),
    [anon_sym_gas] = ACTIONS(951),
    [anon_sym_address] = ACTIONS(951),
    [anon_sym_balance] = ACTIONS(951),
    [anon_sym_selfbalance] = ACTIONS(951),
    [anon_sym_caller] = ACTIONS(951),
    [anon_sym_callvalue] = ACTIONS(951),
    [anon_sym_calldataload] = ACTIONS(951),
    [anon_sym_calldatasize] = ACTIONS(951),
    [anon_sym_calldatacopy] = ACTIONS(951),
    [anon_sym_extcodesize] = ACTIONS(951),
    [anon_sym_extcodecopy] = ACTIONS(951),
    [anon_sym_returndatasize] = ACTIONS(951),
    [anon_sym_returndatacopy] = ACTIONS(951),
    [anon_sym_extcodehash] = ACTIONS(951),
    [anon_sym_create] = ACTIONS(951),
    [anon_sym_create2] = ACTIONS(951),
    [anon_sym_call] = ACTIONS(951),
    [anon_sym_callcode] = ACTIONS(951),
    [anon_sym_delegatecall] = ACTIONS(951),
    [anon_sym_staticcall] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_revert] = ACTIONS(951),
    [anon_sym_selfdestruct] = ACTIONS(951),
    [anon_sym_invalid] = ACTIONS(951),
    [anon_sym_log0] = ACTIONS(951),
    [anon_sym_log1] = ACTIONS(951),
    [anon_sym_log2] = ACTIONS(951),
    [anon_sym_log3] = ACTIONS(951),
    [anon_sym_log4] = ACTIONS(951),
    [anon_sym_chainid] = ACTIONS(951),
    [anon_sym_origin] = ACTIONS(951),
    [anon_sym_gasprice] = ACTIONS(951),
    [anon_sym_blockhash] = ACTIONS(951),
    [anon_sym_coinbase] = ACTIONS(951),
    [anon_sym_timestamp] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(951),
    [anon_sym_difficulty] = ACTIONS(951),
    [anon_sym_gaslimit] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_COMMA] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_for] = ACTIONS(961),
    [sym_yul_leave] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [sym_yul_decimal_number] = ACTIONS(961),
    [sym_yul_hex_number] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(961),
    [anon_sym_false] = ACTIONS(961),
    [anon_sym_let] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_default] = ACTIONS(961),
    [anon_sym_case] = ACTIONS(961),
    [anon_sym_function] = ACTIONS(961),
    [anon_sym_stop] = ACTIONS(961),
    [anon_sym_add] = ACTIONS(961),
    [anon_sym_sub] = ACTIONS(961),
    [anon_sym_mul] = ACTIONS(961),
    [anon_sym_div] = ACTIONS(961),
    [anon_sym_sdiv] = ACTIONS(961),
    [anon_sym_mod] = ACTIONS(961),
    [anon_sym_smod] = ACTIONS(961),
    [anon_sym_exp] = ACTIONS(961),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_lt] = ACTIONS(961),
    [anon_sym_gt] = ACTIONS(961),
    [anon_sym_slt] = ACTIONS(961),
    [anon_sym_sgt] = ACTIONS(961),
    [anon_sym_eq] = ACTIONS(961),
    [anon_sym_iszero] = ACTIONS(961),
    [anon_sym_and] = ACTIONS(961),
    [anon_sym_or] = ACTIONS(961),
    [anon_sym_xor] = ACTIONS(961),
    [anon_sym_byte] = ACTIONS(961),
    [anon_sym_shl] = ACTIONS(961),
    [anon_sym_shr] = ACTIONS(961),
    [anon_sym_sar] = ACTIONS(961),
    [anon_sym_addmod] = ACTIONS(961),
    [anon_sym_mulmod] = ACTIONS(961),
    [anon_sym_signextend] = ACTIONS(961),
    [anon_sym_keccak256] = ACTIONS(961),
    [anon_sym_pop] = ACTIONS(961),
    [anon_sym_mload] = ACTIONS(961),
    [anon_sym_mstore] = ACTIONS(961),
    [anon_sym_mstore8] = ACTIONS(961),
    [anon_sym_sload] = ACTIONS(961),
    [anon_sym_sstore] = ACTIONS(961),
    [anon_sym_msize] = ACTIONS(961),
    [anon_sym_gas] = ACTIONS(961),
    [anon_sym_address] = ACTIONS(961),
    [anon_sym_balance] = ACTIONS(961),
    [anon_sym_selfbalance] = ACTIONS(961),
    [anon_sym_caller] = ACTIONS(961),
    [anon_sym_callvalue] = ACTIONS(961),
    [anon_sym_calldataload] = ACTIONS(961),
    [anon_sym_calldatasize] = ACTIONS(961),
    [anon_sym_calldatacopy] = ACTIONS(961),
    [anon_sym_extcodesize] = ACTIONS(961),
    [anon_sym_extcodecopy] = ACTIONS(961),
    [anon_sym_returndatasize] = ACTIONS(961),
    [anon_sym_returndatacopy] = ACTIONS(961),
    [anon_sym_extcodehash] = ACTIONS(961),
    [anon_sym_create] = ACTIONS(961),
    [anon_sym_create2] = ACTIONS(961),
    [anon_sym_call] = ACTIONS(961),
    [anon_sym_callcode] = ACTIONS(961),
    [anon_sym_delegatecall] = ACTIONS(961),
    [anon_sym_staticcall] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_revert] = ACTIONS(961),
    [anon_sym_selfdestruct] = ACTIONS(961),
    [anon_sym_invalid] = ACTIONS(961),
    [anon_sym_log0] = ACTIONS(961),
    [anon_sym_log1] = ACTIONS(961),
    [anon_sym_log2] = ACTIONS(961),
    [anon_sym_log3] = ACTIONS(961),
    [anon_sym_log4] = ACTIONS(961),
    [anon_sym_chainid] = ACTIONS(961),
    [anon_sym_origin] = ACTIONS(961),
    [anon_sym_gasprice] = ACTIONS(961),
    [anon_sym_blockhash] = ACTIONS(961),
    [anon_sym_coinbase] = ACTIONS(961),
    [anon_sym_timestamp] = ACTIONS(961),
    [anon_sym_number] = ACTIONS(961),
    [anon_sym_difficulty] = ACTIONS(961),
    [anon_sym_gaslimit] = ACTIONS(961),
    [anon_sym_DQUOTE] = ACTIONS(963),
    [anon_sym_SQUOTE] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym__yul_assignment_operator] = STATE(295),
    [aux_sym_yul_assignment_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(965),
    [anon_sym_LBRACE] = ACTIONS(967),
    [anon_sym_COMMA] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_for] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(955),
    [sym_yul_leave] = ACTIONS(965),
    [anon_sym_break] = ACTIONS(965),
    [anon_sym_continue] = ACTIONS(965),
    [sym_yul_decimal_number] = ACTIONS(965),
    [sym_yul_hex_number] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(965),
    [anon_sym_false] = ACTIONS(965),
    [anon_sym_let] = ACTIONS(965),
    [anon_sym_COLON_EQ] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(965),
    [anon_sym_switch] = ACTIONS(965),
    [anon_sym_function] = ACTIONS(965),
    [anon_sym_stop] = ACTIONS(965),
    [anon_sym_add] = ACTIONS(965),
    [anon_sym_sub] = ACTIONS(965),
    [anon_sym_mul] = ACTIONS(965),
    [anon_sym_div] = ACTIONS(965),
    [anon_sym_sdiv] = ACTIONS(965),
    [anon_sym_mod] = ACTIONS(965),
    [anon_sym_smod] = ACTIONS(965),
    [anon_sym_exp] = ACTIONS(965),
    [anon_sym_not] = ACTIONS(965),
    [anon_sym_lt] = ACTIONS(965),
    [anon_sym_gt] = ACTIONS(965),
    [anon_sym_slt] = ACTIONS(965),
    [anon_sym_sgt] = ACTIONS(965),
    [anon_sym_eq] = ACTIONS(965),
    [anon_sym_iszero] = ACTIONS(965),
    [anon_sym_and] = ACTIONS(965),
    [anon_sym_or] = ACTIONS(965),
    [anon_sym_xor] = ACTIONS(965),
    [anon_sym_byte] = ACTIONS(965),
    [anon_sym_shl] = ACTIONS(965),
    [anon_sym_shr] = ACTIONS(965),
    [anon_sym_sar] = ACTIONS(965),
    [anon_sym_addmod] = ACTIONS(965),
    [anon_sym_mulmod] = ACTIONS(965),
    [anon_sym_signextend] = ACTIONS(965),
    [anon_sym_keccak256] = ACTIONS(965),
    [anon_sym_pop] = ACTIONS(965),
    [anon_sym_mload] = ACTIONS(965),
    [anon_sym_mstore] = ACTIONS(965),
    [anon_sym_mstore8] = ACTIONS(965),
    [anon_sym_sload] = ACTIONS(965),
    [anon_sym_sstore] = ACTIONS(965),
    [anon_sym_msize] = ACTIONS(965),
    [anon_sym_gas] = ACTIONS(965),
    [anon_sym_address] = ACTIONS(965),
    [anon_sym_balance] = ACTIONS(965),
    [anon_sym_selfbalance] = ACTIONS(965),
    [anon_sym_caller] = ACTIONS(965),
    [anon_sym_callvalue] = ACTIONS(965),
    [anon_sym_calldataload] = ACTIONS(965),
    [anon_sym_calldatasize] = ACTIONS(965),
    [anon_sym_calldatacopy] = ACTIONS(965),
    [anon_sym_extcodesize] = ACTIONS(965),
    [anon_sym_extcodecopy] = ACTIONS(965),
    [anon_sym_returndatasize] = ACTIONS(965),
    [anon_sym_returndatacopy] = ACTIONS(965),
    [anon_sym_extcodehash] = ACTIONS(965),
    [anon_sym_create] = ACTIONS(965),
    [anon_sym_create2] = ACTIONS(965),
    [anon_sym_call] = ACTIONS(965),
    [anon_sym_callcode] = ACTIONS(965),
    [anon_sym_delegatecall] = ACTIONS(965),
    [anon_sym_staticcall] = ACTIONS(965),
    [anon_sym_return] = ACTIONS(965),
    [anon_sym_revert] = ACTIONS(965),
    [anon_sym_selfdestruct] = ACTIONS(965),
    [anon_sym_invalid] = ACTIONS(965),
    [anon_sym_log0] = ACTIONS(965),
    [anon_sym_log1] = ACTIONS(965),
    [anon_sym_log2] = ACTIONS(965),
    [anon_sym_log3] = ACTIONS(965),
    [anon_sym_log4] = ACTIONS(965),
    [anon_sym_chainid] = ACTIONS(965),
    [anon_sym_origin] = ACTIONS(965),
    [anon_sym_gasprice] = ACTIONS(965),
    [anon_sym_blockhash] = ACTIONS(965),
    [anon_sym_coinbase] = ACTIONS(965),
    [anon_sym_timestamp] = ACTIONS(965),
    [anon_sym_number] = ACTIONS(965),
    [anon_sym_difficulty] = ACTIONS(965),
    [anon_sym_gaslimit] = ACTIONS(965),
    [anon_sym_DQUOTE] = ACTIONS(967),
    [anon_sym_SQUOTE] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_yul_identifier] = STATE(230),
    [sym_yul_path] = STATE(248),
    [sym__yul_assignment_operator] = STATE(299),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(973),
    [anon_sym_COLON] = ACTIONS(955),
    [sym_yul_leave] = ACTIONS(973),
    [anon_sym_break] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [sym_yul_decimal_number] = ACTIONS(973),
    [sym_yul_hex_number] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_let] = ACTIONS(973),
    [anon_sym_COLON_EQ] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(973),
    [anon_sym_stop] = ACTIONS(973),
    [anon_sym_add] = ACTIONS(973),
    [anon_sym_sub] = ACTIONS(973),
    [anon_sym_mul] = ACTIONS(973),
    [anon_sym_div] = ACTIONS(973),
    [anon_sym_sdiv] = ACTIONS(973),
    [anon_sym_mod] = ACTIONS(973),
    [anon_sym_smod] = ACTIONS(973),
    [anon_sym_exp] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(973),
    [anon_sym_lt] = ACTIONS(973),
    [anon_sym_gt] = ACTIONS(973),
    [anon_sym_slt] = ACTIONS(973),
    [anon_sym_sgt] = ACTIONS(973),
    [anon_sym_eq] = ACTIONS(973),
    [anon_sym_iszero] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(973),
    [anon_sym_or] = ACTIONS(973),
    [anon_sym_xor] = ACTIONS(973),
    [anon_sym_byte] = ACTIONS(973),
    [anon_sym_shl] = ACTIONS(973),
    [anon_sym_shr] = ACTIONS(973),
    [anon_sym_sar] = ACTIONS(973),
    [anon_sym_addmod] = ACTIONS(973),
    [anon_sym_mulmod] = ACTIONS(973),
    [anon_sym_signextend] = ACTIONS(973),
    [anon_sym_keccak256] = ACTIONS(973),
    [anon_sym_pop] = ACTIONS(973),
    [anon_sym_mload] = ACTIONS(973),
    [anon_sym_mstore] = ACTIONS(973),
    [anon_sym_mstore8] = ACTIONS(973),
    [anon_sym_sload] = ACTIONS(973),
    [anon_sym_sstore] = ACTIONS(973),
    [anon_sym_msize] = ACTIONS(973),
    [anon_sym_gas] = ACTIONS(973),
    [anon_sym_address] = ACTIONS(973),
    [anon_sym_balance] = ACTIONS(973),
    [anon_sym_selfbalance] = ACTIONS(973),
    [anon_sym_caller] = ACTIONS(973),
    [anon_sym_callvalue] = ACTIONS(973),
    [anon_sym_calldataload] = ACTIONS(973),
    [anon_sym_calldatasize] = ACTIONS(973),
    [anon_sym_calldatacopy] = ACTIONS(973),
    [anon_sym_extcodesize] = ACTIONS(973),
    [anon_sym_extcodecopy] = ACTIONS(973),
    [anon_sym_returndatasize] = ACTIONS(973),
    [anon_sym_returndatacopy] = ACTIONS(973),
    [anon_sym_extcodehash] = ACTIONS(973),
    [anon_sym_create] = ACTIONS(973),
    [anon_sym_create2] = ACTIONS(973),
    [anon_sym_call] = ACTIONS(973),
    [anon_sym_callcode] = ACTIONS(973),
    [anon_sym_delegatecall] = ACTIONS(973),
    [anon_sym_staticcall] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_revert] = ACTIONS(973),
    [anon_sym_selfdestruct] = ACTIONS(973),
    [anon_sym_invalid] = ACTIONS(973),
    [anon_sym_log0] = ACTIONS(973),
    [anon_sym_log1] = ACTIONS(973),
    [anon_sym_log2] = ACTIONS(973),
    [anon_sym_log3] = ACTIONS(973),
    [anon_sym_log4] = ACTIONS(973),
    [anon_sym_chainid] = ACTIONS(973),
    [anon_sym_origin] = ACTIONS(973),
    [anon_sym_gasprice] = ACTIONS(973),
    [anon_sym_blockhash] = ACTIONS(973),
    [anon_sym_coinbase] = ACTIONS(973),
    [anon_sym_timestamp] = ACTIONS(973),
    [anon_sym_number] = ACTIONS(973),
    [anon_sym_difficulty] = ACTIONS(973),
    [anon_sym_gaslimit] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_identifier] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_COMMA] = ACTIONS(942),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_COLON] = ACTIONS(979),
    [sym_yul_leave] = ACTIONS(940),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_DOT] = ACTIONS(942),
    [sym_yul_decimal_number] = ACTIONS(940),
    [sym_yul_hex_number] = ACTIONS(942),
    [anon_sym_true] = ACTIONS(940),
    [anon_sym_false] = ACTIONS(940),
    [anon_sym_let] = ACTIONS(940),
    [anon_sym_COLON_EQ] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_stop] = ACTIONS(940),
    [anon_sym_add] = ACTIONS(940),
    [anon_sym_sub] = ACTIONS(940),
    [anon_sym_mul] = ACTIONS(940),
    [anon_sym_div] = ACTIONS(940),
    [anon_sym_sdiv] = ACTIONS(940),
    [anon_sym_mod] = ACTIONS(940),
    [anon_sym_smod] = ACTIONS(940),
    [anon_sym_exp] = ACTIONS(940),
    [anon_sym_not] = ACTIONS(940),
    [anon_sym_lt] = ACTIONS(940),
    [anon_sym_gt] = ACTIONS(940),
    [anon_sym_slt] = ACTIONS(940),
    [anon_sym_sgt] = ACTIONS(940),
    [anon_sym_eq] = ACTIONS(940),
    [anon_sym_iszero] = ACTIONS(940),
    [anon_sym_and] = ACTIONS(940),
    [anon_sym_or] = ACTIONS(940),
    [anon_sym_xor] = ACTIONS(940),
    [anon_sym_byte] = ACTIONS(940),
    [anon_sym_shl] = ACTIONS(940),
    [anon_sym_shr] = ACTIONS(940),
    [anon_sym_sar] = ACTIONS(940),
    [anon_sym_addmod] = ACTIONS(940),
    [anon_sym_mulmod] = ACTIONS(940),
    [anon_sym_signextend] = ACTIONS(940),
    [anon_sym_keccak256] = ACTIONS(940),
    [anon_sym_pop] = ACTIONS(940),
    [anon_sym_mload] = ACTIONS(940),
    [anon_sym_mstore] = ACTIONS(940),
    [anon_sym_mstore8] = ACTIONS(940),
    [anon_sym_sload] = ACTIONS(940),
    [anon_sym_sstore] = ACTIONS(940),
    [anon_sym_msize] = ACTIONS(940),
    [anon_sym_gas] = ACTIONS(940),
    [anon_sym_address] = ACTIONS(940),
    [anon_sym_balance] = ACTIONS(940),
    [anon_sym_selfbalance] = ACTIONS(940),
    [anon_sym_caller] = ACTIONS(940),
    [anon_sym_callvalue] = ACTIONS(940),
    [anon_sym_calldataload] = ACTIONS(940),
    [anon_sym_calldatasize] = ACTIONS(940),
    [anon_sym_calldatacopy] = ACTIONS(940),
    [anon_sym_extcodesize] = ACTIONS(940),
    [anon_sym_extcodecopy] = ACTIONS(940),
    [anon_sym_returndatasize] = ACTIONS(940),
    [anon_sym_returndatacopy] = ACTIONS(940),
    [anon_sym_extcodehash] = ACTIONS(940),
    [anon_sym_create] = ACTIONS(940),
    [anon_sym_create2] = ACTIONS(940),
    [anon_sym_call] = ACTIONS(940),
    [anon_sym_callcode] = ACTIONS(940),
    [anon_sym_delegatecall] = ACTIONS(940),
    [anon_sym_staticcall] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_revert] = ACTIONS(940),
    [anon_sym_selfdestruct] = ACTIONS(940),
    [anon_sym_invalid] = ACTIONS(940),
    [anon_sym_log0] = ACTIONS(940),
    [anon_sym_log1] = ACTIONS(940),
    [anon_sym_log2] = ACTIONS(940),
    [anon_sym_log3] = ACTIONS(940),
    [anon_sym_log4] = ACTIONS(940),
    [anon_sym_chainid] = ACTIONS(940),
    [anon_sym_origin] = ACTIONS(940),
    [anon_sym_gasprice] = ACTIONS(940),
    [anon_sym_blockhash] = ACTIONS(940),
    [anon_sym_coinbase] = ACTIONS(940),
    [anon_sym_timestamp] = ACTIONS(940),
    [anon_sym_number] = ACTIONS(940),
    [anon_sym_difficulty] = ACTIONS(940),
    [anon_sym_gaslimit] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(942),
    [anon_sym_SQUOTE] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_COMMA] = ACTIONS(984),
    [anon_sym_RBRACE] = ACTIONS(984),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_RPAREN] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(982),
    [sym_yul_leave] = ACTIONS(982),
    [anon_sym_break] = ACTIONS(982),
    [anon_sym_continue] = ACTIONS(982),
    [sym_yul_decimal_number] = ACTIONS(982),
    [sym_yul_hex_number] = ACTIONS(984),
    [anon_sym_true] = ACTIONS(982),
    [anon_sym_false] = ACTIONS(982),
    [anon_sym_let] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(982),
    [anon_sym_switch] = ACTIONS(982),
    [anon_sym_default] = ACTIONS(982),
    [anon_sym_case] = ACTIONS(982),
    [anon_sym_function] = ACTIONS(982),
    [anon_sym_stop] = ACTIONS(982),
    [anon_sym_add] = ACTIONS(982),
    [anon_sym_sub] = ACTIONS(982),
    [anon_sym_mul] = ACTIONS(982),
    [anon_sym_div] = ACTIONS(982),
    [anon_sym_sdiv] = ACTIONS(982),
    [anon_sym_mod] = ACTIONS(982),
    [anon_sym_smod] = ACTIONS(982),
    [anon_sym_exp] = ACTIONS(982),
    [anon_sym_not] = ACTIONS(982),
    [anon_sym_lt] = ACTIONS(982),
    [anon_sym_gt] = ACTIONS(982),
    [anon_sym_slt] = ACTIONS(982),
    [anon_sym_sgt] = ACTIONS(982),
    [anon_sym_eq] = ACTIONS(982),
    [anon_sym_iszero] = ACTIONS(982),
    [anon_sym_and] = ACTIONS(982),
    [anon_sym_or] = ACTIONS(982),
    [anon_sym_xor] = ACTIONS(982),
    [anon_sym_byte] = ACTIONS(982),
    [anon_sym_shl] = ACTIONS(982),
    [anon_sym_shr] = ACTIONS(982),
    [anon_sym_sar] = ACTIONS(982),
    [anon_sym_addmod] = ACTIONS(982),
    [anon_sym_mulmod] = ACTIONS(982),
    [anon_sym_signextend] = ACTIONS(982),
    [anon_sym_keccak256] = ACTIONS(982),
    [anon_sym_pop] = ACTIONS(982),
    [anon_sym_mload] = ACTIONS(982),
    [anon_sym_mstore] = ACTIONS(982),
    [anon_sym_mstore8] = ACTIONS(982),
    [anon_sym_sload] = ACTIONS(982),
    [anon_sym_sstore] = ACTIONS(982),
    [anon_sym_msize] = ACTIONS(982),
    [anon_sym_gas] = ACTIONS(982),
    [anon_sym_address] = ACTIONS(982),
    [anon_sym_balance] = ACTIONS(982),
    [anon_sym_selfbalance] = ACTIONS(982),
    [anon_sym_caller] = ACTIONS(982),
    [anon_sym_callvalue] = ACTIONS(982),
    [anon_sym_calldataload] = ACTIONS(982),
    [anon_sym_calldatasize] = ACTIONS(982),
    [anon_sym_calldatacopy] = ACTIONS(982),
    [anon_sym_extcodesize] = ACTIONS(982),
    [anon_sym_extcodecopy] = ACTIONS(982),
    [anon_sym_returndatasize] = ACTIONS(982),
    [anon_sym_returndatacopy] = ACTIONS(982),
    [anon_sym_extcodehash] = ACTIONS(982),
    [anon_sym_create] = ACTIONS(982),
    [anon_sym_create2] = ACTIONS(982),
    [anon_sym_call] = ACTIONS(982),
    [anon_sym_callcode] = ACTIONS(982),
    [anon_sym_delegatecall] = ACTIONS(982),
    [anon_sym_staticcall] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(982),
    [anon_sym_revert] = ACTIONS(982),
    [anon_sym_selfdestruct] = ACTIONS(982),
    [anon_sym_invalid] = ACTIONS(982),
    [anon_sym_log0] = ACTIONS(982),
    [anon_sym_log1] = ACTIONS(982),
    [anon_sym_log2] = ACTIONS(982),
    [anon_sym_log3] = ACTIONS(982),
    [anon_sym_log4] = ACTIONS(982),
    [anon_sym_chainid] = ACTIONS(982),
    [anon_sym_origin] = ACTIONS(982),
    [anon_sym_gasprice] = ACTIONS(982),
    [anon_sym_blockhash] = ACTIONS(982),
    [anon_sym_coinbase] = ACTIONS(982),
    [anon_sym_timestamp] = ACTIONS(982),
    [anon_sym_number] = ACTIONS(982),
    [anon_sym_difficulty] = ACTIONS(982),
    [anon_sym_gaslimit] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_identifier] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(988),
    [anon_sym_COMMA] = ACTIONS(988),
    [anon_sym_RBRACE] = ACTIONS(988),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(986),
    [sym_yul_leave] = ACTIONS(986),
    [anon_sym_break] = ACTIONS(986),
    [anon_sym_continue] = ACTIONS(986),
    [sym_yul_decimal_number] = ACTIONS(986),
    [sym_yul_hex_number] = ACTIONS(988),
    [anon_sym_true] = ACTIONS(986),
    [anon_sym_false] = ACTIONS(986),
    [anon_sym_let] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(986),
    [anon_sym_switch] = ACTIONS(986),
    [anon_sym_default] = ACTIONS(986),
    [anon_sym_case] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(986),
    [anon_sym_stop] = ACTIONS(986),
    [anon_sym_add] = ACTIONS(986),
    [anon_sym_sub] = ACTIONS(986),
    [anon_sym_mul] = ACTIONS(986),
    [anon_sym_div] = ACTIONS(986),
    [anon_sym_sdiv] = ACTIONS(986),
    [anon_sym_mod] = ACTIONS(986),
    [anon_sym_smod] = ACTIONS(986),
    [anon_sym_exp] = ACTIONS(986),
    [anon_sym_not] = ACTIONS(986),
    [anon_sym_lt] = ACTIONS(986),
    [anon_sym_gt] = ACTIONS(986),
    [anon_sym_slt] = ACTIONS(986),
    [anon_sym_sgt] = ACTIONS(986),
    [anon_sym_eq] = ACTIONS(986),
    [anon_sym_iszero] = ACTIONS(986),
    [anon_sym_and] = ACTIONS(986),
    [anon_sym_or] = ACTIONS(986),
    [anon_sym_xor] = ACTIONS(986),
    [anon_sym_byte] = ACTIONS(986),
    [anon_sym_shl] = ACTIONS(986),
    [anon_sym_shr] = ACTIONS(986),
    [anon_sym_sar] = ACTIONS(986),
    [anon_sym_addmod] = ACTIONS(986),
    [anon_sym_mulmod] = ACTIONS(986),
    [anon_sym_signextend] = ACTIONS(986),
    [anon_sym_keccak256] = ACTIONS(986),
    [anon_sym_pop] = ACTIONS(986),
    [anon_sym_mload] = ACTIONS(986),
    [anon_sym_mstore] = ACTIONS(986),
    [anon_sym_mstore8] = ACTIONS(986),
    [anon_sym_sload] = ACTIONS(986),
    [anon_sym_sstore] = ACTIONS(986),
    [anon_sym_msize] = ACTIONS(986),
    [anon_sym_gas] = ACTIONS(986),
    [anon_sym_address] = ACTIONS(986),
    [anon_sym_balance] = ACTIONS(986),
    [anon_sym_selfbalance] = ACTIONS(986),
    [anon_sym_caller] = ACTIONS(986),
    [anon_sym_callvalue] = ACTIONS(986),
    [anon_sym_calldataload] = ACTIONS(986),
    [anon_sym_calldatasize] = ACTIONS(986),
    [anon_sym_calldatacopy] = ACTIONS(986),
    [anon_sym_extcodesize] = ACTIONS(986),
    [anon_sym_extcodecopy] = ACTIONS(986),
    [anon_sym_returndatasize] = ACTIONS(986),
    [anon_sym_returndatacopy] = ACTIONS(986),
    [anon_sym_extcodehash] = ACTIONS(986),
    [anon_sym_create] = ACTIONS(986),
    [anon_sym_create2] = ACTIONS(986),
    [anon_sym_call] = ACTIONS(986),
    [anon_sym_callcode] = ACTIONS(986),
    [anon_sym_delegatecall] = ACTIONS(986),
    [anon_sym_staticcall] = ACTIONS(986),
    [anon_sym_return] = ACTIONS(986),
    [anon_sym_revert] = ACTIONS(986),
    [anon_sym_selfdestruct] = ACTIONS(986),
    [anon_sym_invalid] = ACTIONS(986),
    [anon_sym_log0] = ACTIONS(986),
    [anon_sym_log1] = ACTIONS(986),
    [anon_sym_log2] = ACTIONS(986),
    [anon_sym_log3] = ACTIONS(986),
    [anon_sym_log4] = ACTIONS(986),
    [anon_sym_chainid] = ACTIONS(986),
    [anon_sym_origin] = ACTIONS(986),
    [anon_sym_gasprice] = ACTIONS(986),
    [anon_sym_blockhash] = ACTIONS(986),
    [anon_sym_coinbase] = ACTIONS(986),
    [anon_sym_timestamp] = ACTIONS(986),
    [anon_sym_number] = ACTIONS(986),
    [anon_sym_difficulty] = ACTIONS(986),
    [anon_sym_gaslimit] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [aux_sym_yul_assignment_repeat1] = STATE(239),
    [sym_identifier] = ACTIONS(990),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(990),
    [anon_sym_COLON] = ACTIONS(990),
    [sym_yul_leave] = ACTIONS(990),
    [anon_sym_break] = ACTIONS(990),
    [anon_sym_continue] = ACTIONS(990),
    [sym_yul_decimal_number] = ACTIONS(990),
    [sym_yul_hex_number] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(990),
    [anon_sym_false] = ACTIONS(990),
    [anon_sym_let] = ACTIONS(990),
    [anon_sym_COLON_EQ] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(990),
    [anon_sym_switch] = ACTIONS(990),
    [anon_sym_function] = ACTIONS(990),
    [anon_sym_stop] = ACTIONS(990),
    [anon_sym_add] = ACTIONS(990),
    [anon_sym_sub] = ACTIONS(990),
    [anon_sym_mul] = ACTIONS(990),
    [anon_sym_div] = ACTIONS(990),
    [anon_sym_sdiv] = ACTIONS(990),
    [anon_sym_mod] = ACTIONS(990),
    [anon_sym_smod] = ACTIONS(990),
    [anon_sym_exp] = ACTIONS(990),
    [anon_sym_not] = ACTIONS(990),
    [anon_sym_lt] = ACTIONS(990),
    [anon_sym_gt] = ACTIONS(990),
    [anon_sym_slt] = ACTIONS(990),
    [anon_sym_sgt] = ACTIONS(990),
    [anon_sym_eq] = ACTIONS(990),
    [anon_sym_iszero] = ACTIONS(990),
    [anon_sym_and] = ACTIONS(990),
    [anon_sym_or] = ACTIONS(990),
    [anon_sym_xor] = ACTIONS(990),
    [anon_sym_byte] = ACTIONS(990),
    [anon_sym_shl] = ACTIONS(990),
    [anon_sym_shr] = ACTIONS(990),
    [anon_sym_sar] = ACTIONS(990),
    [anon_sym_addmod] = ACTIONS(990),
    [anon_sym_mulmod] = ACTIONS(990),
    [anon_sym_signextend] = ACTIONS(990),
    [anon_sym_keccak256] = ACTIONS(990),
    [anon_sym_pop] = ACTIONS(990),
    [anon_sym_mload] = ACTIONS(990),
    [anon_sym_mstore] = ACTIONS(990),
    [anon_sym_mstore8] = ACTIONS(990),
    [anon_sym_sload] = ACTIONS(990),
    [anon_sym_sstore] = ACTIONS(990),
    [anon_sym_msize] = ACTIONS(990),
    [anon_sym_gas] = ACTIONS(990),
    [anon_sym_address] = ACTIONS(990),
    [anon_sym_balance] = ACTIONS(990),
    [anon_sym_selfbalance] = ACTIONS(990),
    [anon_sym_caller] = ACTIONS(990),
    [anon_sym_callvalue] = ACTIONS(990),
    [anon_sym_calldataload] = ACTIONS(990),
    [anon_sym_calldatasize] = ACTIONS(990),
    [anon_sym_calldatacopy] = ACTIONS(990),
    [anon_sym_extcodesize] = ACTIONS(990),
    [anon_sym_extcodecopy] = ACTIONS(990),
    [anon_sym_returndatasize] = ACTIONS(990),
    [anon_sym_returndatacopy] = ACTIONS(990),
    [anon_sym_extcodehash] = ACTIONS(990),
    [anon_sym_create] = ACTIONS(990),
    [anon_sym_create2] = ACTIONS(990),
    [anon_sym_call] = ACTIONS(990),
    [anon_sym_callcode] = ACTIONS(990),
    [anon_sym_delegatecall] = ACTIONS(990),
    [anon_sym_staticcall] = ACTIONS(990),
    [anon_sym_return] = ACTIONS(990),
    [anon_sym_revert] = ACTIONS(990),
    [anon_sym_selfdestruct] = ACTIONS(990),
    [anon_sym_invalid] = ACTIONS(990),
    [anon_sym_log0] = ACTIONS(990),
    [anon_sym_log1] = ACTIONS(990),
    [anon_sym_log2] = ACTIONS(990),
    [anon_sym_log3] = ACTIONS(990),
    [anon_sym_log4] = ACTIONS(990),
    [anon_sym_chainid] = ACTIONS(990),
    [anon_sym_origin] = ACTIONS(990),
    [anon_sym_gasprice] = ACTIONS(990),
    [anon_sym_blockhash] = ACTIONS(990),
    [anon_sym_coinbase] = ACTIONS(990),
    [anon_sym_timestamp] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_difficulty] = ACTIONS(990),
    [anon_sym_gaslimit] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_identifier] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(997),
    [sym_yul_leave] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [sym_yul_decimal_number] = ACTIONS(997),
    [sym_yul_hex_number] = ACTIONS(999),
    [anon_sym_true] = ACTIONS(997),
    [anon_sym_false] = ACTIONS(997),
    [anon_sym_let] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_switch] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(997),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_stop] = ACTIONS(997),
    [anon_sym_add] = ACTIONS(997),
    [anon_sym_sub] = ACTIONS(997),
    [anon_sym_mul] = ACTIONS(997),
    [anon_sym_div] = ACTIONS(997),
    [anon_sym_sdiv] = ACTIONS(997),
    [anon_sym_mod] = ACTIONS(997),
    [anon_sym_smod] = ACTIONS(997),
    [anon_sym_exp] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_lt] = ACTIONS(997),
    [anon_sym_gt] = ACTIONS(997),
    [anon_sym_slt] = ACTIONS(997),
    [anon_sym_sgt] = ACTIONS(997),
    [anon_sym_eq] = ACTIONS(997),
    [anon_sym_iszero] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_xor] = ACTIONS(997),
    [anon_sym_byte] = ACTIONS(997),
    [anon_sym_shl] = ACTIONS(997),
    [anon_sym_shr] = ACTIONS(997),
    [anon_sym_sar] = ACTIONS(997),
    [anon_sym_addmod] = ACTIONS(997),
    [anon_sym_mulmod] = ACTIONS(997),
    [anon_sym_signextend] = ACTIONS(997),
    [anon_sym_keccak256] = ACTIONS(997),
    [anon_sym_pop] = ACTIONS(997),
    [anon_sym_mload] = ACTIONS(997),
    [anon_sym_mstore] = ACTIONS(997),
    [anon_sym_mstore8] = ACTIONS(997),
    [anon_sym_sload] = ACTIONS(997),
    [anon_sym_sstore] = ACTIONS(997),
    [anon_sym_msize] = ACTIONS(997),
    [anon_sym_gas] = ACTIONS(997),
    [anon_sym_address] = ACTIONS(997),
    [anon_sym_balance] = ACTIONS(997),
    [anon_sym_selfbalance] = ACTIONS(997),
    [anon_sym_caller] = ACTIONS(997),
    [anon_sym_callvalue] = ACTIONS(997),
    [anon_sym_calldataload] = ACTIONS(997),
    [anon_sym_calldatasize] = ACTIONS(997),
    [anon_sym_calldatacopy] = ACTIONS(997),
    [anon_sym_extcodesize] = ACTIONS(997),
    [anon_sym_extcodecopy] = ACTIONS(997),
    [anon_sym_returndatasize] = ACTIONS(997),
    [anon_sym_returndatacopy] = ACTIONS(997),
    [anon_sym_extcodehash] = ACTIONS(997),
    [anon_sym_create] = ACTIONS(997),
    [anon_sym_create2] = ACTIONS(997),
    [anon_sym_call] = ACTIONS(997),
    [anon_sym_callcode] = ACTIONS(997),
    [anon_sym_delegatecall] = ACTIONS(997),
    [anon_sym_staticcall] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_revert] = ACTIONS(997),
    [anon_sym_selfdestruct] = ACTIONS(997),
    [anon_sym_invalid] = ACTIONS(997),
    [anon_sym_log0] = ACTIONS(997),
    [anon_sym_log1] = ACTIONS(997),
    [anon_sym_log2] = ACTIONS(997),
    [anon_sym_log3] = ACTIONS(997),
    [anon_sym_log4] = ACTIONS(997),
    [anon_sym_chainid] = ACTIONS(997),
    [anon_sym_origin] = ACTIONS(997),
    [anon_sym_gasprice] = ACTIONS(997),
    [anon_sym_blockhash] = ACTIONS(997),
    [anon_sym_coinbase] = ACTIONS(997),
    [anon_sym_timestamp] = ACTIONS(997),
    [anon_sym_number] = ACTIONS(997),
    [anon_sym_difficulty] = ACTIONS(997),
    [anon_sym_gaslimit] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [anon_sym_COMMA] = ACTIONS(1003),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_RPAREN] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1001),
    [sym_yul_leave] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [sym_yul_decimal_number] = ACTIONS(1001),
    [sym_yul_hex_number] = ACTIONS(1003),
    [anon_sym_true] = ACTIONS(1001),
    [anon_sym_false] = ACTIONS(1001),
    [anon_sym_let] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(1001),
    [anon_sym_case] = ACTIONS(1001),
    [anon_sym_function] = ACTIONS(1001),
    [anon_sym_stop] = ACTIONS(1001),
    [anon_sym_add] = ACTIONS(1001),
    [anon_sym_sub] = ACTIONS(1001),
    [anon_sym_mul] = ACTIONS(1001),
    [anon_sym_div] = ACTIONS(1001),
    [anon_sym_sdiv] = ACTIONS(1001),
    [anon_sym_mod] = ACTIONS(1001),
    [anon_sym_smod] = ACTIONS(1001),
    [anon_sym_exp] = ACTIONS(1001),
    [anon_sym_not] = ACTIONS(1001),
    [anon_sym_lt] = ACTIONS(1001),
    [anon_sym_gt] = ACTIONS(1001),
    [anon_sym_slt] = ACTIONS(1001),
    [anon_sym_sgt] = ACTIONS(1001),
    [anon_sym_eq] = ACTIONS(1001),
    [anon_sym_iszero] = ACTIONS(1001),
    [anon_sym_and] = ACTIONS(1001),
    [anon_sym_or] = ACTIONS(1001),
    [anon_sym_xor] = ACTIONS(1001),
    [anon_sym_byte] = ACTIONS(1001),
    [anon_sym_shl] = ACTIONS(1001),
    [anon_sym_shr] = ACTIONS(1001),
    [anon_sym_sar] = ACTIONS(1001),
    [anon_sym_addmod] = ACTIONS(1001),
    [anon_sym_mulmod] = ACTIONS(1001),
    [anon_sym_signextend] = ACTIONS(1001),
    [anon_sym_keccak256] = ACTIONS(1001),
    [anon_sym_pop] = ACTIONS(1001),
    [anon_sym_mload] = ACTIONS(1001),
    [anon_sym_mstore] = ACTIONS(1001),
    [anon_sym_mstore8] = ACTIONS(1001),
    [anon_sym_sload] = ACTIONS(1001),
    [anon_sym_sstore] = ACTIONS(1001),
    [anon_sym_msize] = ACTIONS(1001),
    [anon_sym_gas] = ACTIONS(1001),
    [anon_sym_address] = ACTIONS(1001),
    [anon_sym_balance] = ACTIONS(1001),
    [anon_sym_selfbalance] = ACTIONS(1001),
    [anon_sym_caller] = ACTIONS(1001),
    [anon_sym_callvalue] = ACTIONS(1001),
    [anon_sym_calldataload] = ACTIONS(1001),
    [anon_sym_calldatasize] = ACTIONS(1001),
    [anon_sym_calldatacopy] = ACTIONS(1001),
    [anon_sym_extcodesize] = ACTIONS(1001),
    [anon_sym_extcodecopy] = ACTIONS(1001),
    [anon_sym_returndatasize] = ACTIONS(1001),
    [anon_sym_returndatacopy] = ACTIONS(1001),
    [anon_sym_extcodehash] = ACTIONS(1001),
    [anon_sym_create] = ACTIONS(1001),
    [anon_sym_create2] = ACTIONS(1001),
    [anon_sym_call] = ACTIONS(1001),
    [anon_sym_callcode] = ACTIONS(1001),
    [anon_sym_delegatecall] = ACTIONS(1001),
    [anon_sym_staticcall] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_revert] = ACTIONS(1001),
    [anon_sym_selfdestruct] = ACTIONS(1001),
    [anon_sym_invalid] = ACTIONS(1001),
    [anon_sym_log0] = ACTIONS(1001),
    [anon_sym_log1] = ACTIONS(1001),
    [anon_sym_log2] = ACTIONS(1001),
    [anon_sym_log3] = ACTIONS(1001),
    [anon_sym_log4] = ACTIONS(1001),
    [anon_sym_chainid] = ACTIONS(1001),
    [anon_sym_origin] = ACTIONS(1001),
    [anon_sym_gasprice] = ACTIONS(1001),
    [anon_sym_blockhash] = ACTIONS(1001),
    [anon_sym_coinbase] = ACTIONS(1001),
    [anon_sym_timestamp] = ACTIONS(1001),
    [anon_sym_number] = ACTIONS(1001),
    [anon_sym_difficulty] = ACTIONS(1001),
    [anon_sym_gaslimit] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1003),
    [anon_sym_SQUOTE] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(242),
    [sym_identifier] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1005),
    [sym_yul_leave] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [sym_yul_decimal_number] = ACTIONS(1005),
    [sym_yul_hex_number] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1005),
    [anon_sym_false] = ACTIONS(1005),
    [anon_sym_let] = ACTIONS(1005),
    [anon_sym_COLON_EQ] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1005),
    [anon_sym_stop] = ACTIONS(1005),
    [anon_sym_add] = ACTIONS(1005),
    [anon_sym_sub] = ACTIONS(1005),
    [anon_sym_mul] = ACTIONS(1005),
    [anon_sym_div] = ACTIONS(1005),
    [anon_sym_sdiv] = ACTIONS(1005),
    [anon_sym_mod] = ACTIONS(1005),
    [anon_sym_smod] = ACTIONS(1005),
    [anon_sym_exp] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1005),
    [anon_sym_lt] = ACTIONS(1005),
    [anon_sym_gt] = ACTIONS(1005),
    [anon_sym_slt] = ACTIONS(1005),
    [anon_sym_sgt] = ACTIONS(1005),
    [anon_sym_eq] = ACTIONS(1005),
    [anon_sym_iszero] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1005),
    [anon_sym_or] = ACTIONS(1005),
    [anon_sym_xor] = ACTIONS(1005),
    [anon_sym_byte] = ACTIONS(1005),
    [anon_sym_shl] = ACTIONS(1005),
    [anon_sym_shr] = ACTIONS(1005),
    [anon_sym_sar] = ACTIONS(1005),
    [anon_sym_addmod] = ACTIONS(1005),
    [anon_sym_mulmod] = ACTIONS(1005),
    [anon_sym_signextend] = ACTIONS(1005),
    [anon_sym_keccak256] = ACTIONS(1005),
    [anon_sym_pop] = ACTIONS(1005),
    [anon_sym_mload] = ACTIONS(1005),
    [anon_sym_mstore] = ACTIONS(1005),
    [anon_sym_mstore8] = ACTIONS(1005),
    [anon_sym_sload] = ACTIONS(1005),
    [anon_sym_sstore] = ACTIONS(1005),
    [anon_sym_msize] = ACTIONS(1005),
    [anon_sym_gas] = ACTIONS(1005),
    [anon_sym_address] = ACTIONS(1005),
    [anon_sym_balance] = ACTIONS(1005),
    [anon_sym_selfbalance] = ACTIONS(1005),
    [anon_sym_caller] = ACTIONS(1005),
    [anon_sym_callvalue] = ACTIONS(1005),
    [anon_sym_calldataload] = ACTIONS(1005),
    [anon_sym_calldatasize] = ACTIONS(1005),
    [anon_sym_calldatacopy] = ACTIONS(1005),
    [anon_sym_extcodesize] = ACTIONS(1005),
    [anon_sym_extcodecopy] = ACTIONS(1005),
    [anon_sym_returndatasize] = ACTIONS(1005),
    [anon_sym_returndatacopy] = ACTIONS(1005),
    [anon_sym_extcodehash] = ACTIONS(1005),
    [anon_sym_create] = ACTIONS(1005),
    [anon_sym_create2] = ACTIONS(1005),
    [anon_sym_call] = ACTIONS(1005),
    [anon_sym_callcode] = ACTIONS(1005),
    [anon_sym_delegatecall] = ACTIONS(1005),
    [anon_sym_staticcall] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_revert] = ACTIONS(1005),
    [anon_sym_selfdestruct] = ACTIONS(1005),
    [anon_sym_invalid] = ACTIONS(1005),
    [anon_sym_log0] = ACTIONS(1005),
    [anon_sym_log1] = ACTIONS(1005),
    [anon_sym_log2] = ACTIONS(1005),
    [anon_sym_log3] = ACTIONS(1005),
    [anon_sym_log4] = ACTIONS(1005),
    [anon_sym_chainid] = ACTIONS(1005),
    [anon_sym_origin] = ACTIONS(1005),
    [anon_sym_gasprice] = ACTIONS(1005),
    [anon_sym_blockhash] = ACTIONS(1005),
    [anon_sym_coinbase] = ACTIONS(1005),
    [anon_sym_timestamp] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_difficulty] = ACTIONS(1005),
    [anon_sym_gaslimit] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_SQUOTE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_COMMA] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [anon_sym_RPAREN] = ACTIONS(1014),
    [anon_sym_for] = ACTIONS(1012),
    [sym_yul_leave] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [sym_yul_decimal_number] = ACTIONS(1012),
    [sym_yul_hex_number] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(1012),
    [anon_sym_false] = ACTIONS(1012),
    [anon_sym_let] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_function] = ACTIONS(1012),
    [anon_sym_stop] = ACTIONS(1012),
    [anon_sym_add] = ACTIONS(1012),
    [anon_sym_sub] = ACTIONS(1012),
    [anon_sym_mul] = ACTIONS(1012),
    [anon_sym_div] = ACTIONS(1012),
    [anon_sym_sdiv] = ACTIONS(1012),
    [anon_sym_mod] = ACTIONS(1012),
    [anon_sym_smod] = ACTIONS(1012),
    [anon_sym_exp] = ACTIONS(1012),
    [anon_sym_not] = ACTIONS(1012),
    [anon_sym_lt] = ACTIONS(1012),
    [anon_sym_gt] = ACTIONS(1012),
    [anon_sym_slt] = ACTIONS(1012),
    [anon_sym_sgt] = ACTIONS(1012),
    [anon_sym_eq] = ACTIONS(1012),
    [anon_sym_iszero] = ACTIONS(1012),
    [anon_sym_and] = ACTIONS(1012),
    [anon_sym_or] = ACTIONS(1012),
    [anon_sym_xor] = ACTIONS(1012),
    [anon_sym_byte] = ACTIONS(1012),
    [anon_sym_shl] = ACTIONS(1012),
    [anon_sym_shr] = ACTIONS(1012),
    [anon_sym_sar] = ACTIONS(1012),
    [anon_sym_addmod] = ACTIONS(1012),
    [anon_sym_mulmod] = ACTIONS(1012),
    [anon_sym_signextend] = ACTIONS(1012),
    [anon_sym_keccak256] = ACTIONS(1012),
    [anon_sym_pop] = ACTIONS(1012),
    [anon_sym_mload] = ACTIONS(1012),
    [anon_sym_mstore] = ACTIONS(1012),
    [anon_sym_mstore8] = ACTIONS(1012),
    [anon_sym_sload] = ACTIONS(1012),
    [anon_sym_sstore] = ACTIONS(1012),
    [anon_sym_msize] = ACTIONS(1012),
    [anon_sym_gas] = ACTIONS(1012),
    [anon_sym_address] = ACTIONS(1012),
    [anon_sym_balance] = ACTIONS(1012),
    [anon_sym_selfbalance] = ACTIONS(1012),
    [anon_sym_caller] = ACTIONS(1012),
    [anon_sym_callvalue] = ACTIONS(1012),
    [anon_sym_calldataload] = ACTIONS(1012),
    [anon_sym_calldatasize] = ACTIONS(1012),
    [anon_sym_calldatacopy] = ACTIONS(1012),
    [anon_sym_extcodesize] = ACTIONS(1012),
    [anon_sym_extcodecopy] = ACTIONS(1012),
    [anon_sym_returndatasize] = ACTIONS(1012),
    [anon_sym_returndatacopy] = ACTIONS(1012),
    [anon_sym_extcodehash] = ACTIONS(1012),
    [anon_sym_create] = ACTIONS(1012),
    [anon_sym_create2] = ACTIONS(1012),
    [anon_sym_call] = ACTIONS(1012),
    [anon_sym_callcode] = ACTIONS(1012),
    [anon_sym_delegatecall] = ACTIONS(1012),
    [anon_sym_staticcall] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_revert] = ACTIONS(1012),
    [anon_sym_selfdestruct] = ACTIONS(1012),
    [anon_sym_invalid] = ACTIONS(1012),
    [anon_sym_log0] = ACTIONS(1012),
    [anon_sym_log1] = ACTIONS(1012),
    [anon_sym_log2] = ACTIONS(1012),
    [anon_sym_log3] = ACTIONS(1012),
    [anon_sym_log4] = ACTIONS(1012),
    [anon_sym_chainid] = ACTIONS(1012),
    [anon_sym_origin] = ACTIONS(1012),
    [anon_sym_gasprice] = ACTIONS(1012),
    [anon_sym_blockhash] = ACTIONS(1012),
    [anon_sym_coinbase] = ACTIONS(1012),
    [anon_sym_timestamp] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_difficulty] = ACTIONS(1012),
    [anon_sym_gaslimit] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_identifier] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_COMMA] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1016),
    [sym_yul_leave] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [sym_yul_decimal_number] = ACTIONS(1016),
    [sym_yul_hex_number] = ACTIONS(1018),
    [anon_sym_true] = ACTIONS(1016),
    [anon_sym_false] = ACTIONS(1016),
    [anon_sym_let] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_function] = ACTIONS(1016),
    [anon_sym_stop] = ACTIONS(1016),
    [anon_sym_add] = ACTIONS(1016),
    [anon_sym_sub] = ACTIONS(1016),
    [anon_sym_mul] = ACTIONS(1016),
    [anon_sym_div] = ACTIONS(1016),
    [anon_sym_sdiv] = ACTIONS(1016),
    [anon_sym_mod] = ACTIONS(1016),
    [anon_sym_smod] = ACTIONS(1016),
    [anon_sym_exp] = ACTIONS(1016),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_lt] = ACTIONS(1016),
    [anon_sym_gt] = ACTIONS(1016),
    [anon_sym_slt] = ACTIONS(1016),
    [anon_sym_sgt] = ACTIONS(1016),
    [anon_sym_eq] = ACTIONS(1016),
    [anon_sym_iszero] = ACTIONS(1016),
    [anon_sym_and] = ACTIONS(1016),
    [anon_sym_or] = ACTIONS(1016),
    [anon_sym_xor] = ACTIONS(1016),
    [anon_sym_byte] = ACTIONS(1016),
    [anon_sym_shl] = ACTIONS(1016),
    [anon_sym_shr] = ACTIONS(1016),
    [anon_sym_sar] = ACTIONS(1016),
    [anon_sym_addmod] = ACTIONS(1016),
    [anon_sym_mulmod] = ACTIONS(1016),
    [anon_sym_signextend] = ACTIONS(1016),
    [anon_sym_keccak256] = ACTIONS(1016),
    [anon_sym_pop] = ACTIONS(1016),
    [anon_sym_mload] = ACTIONS(1016),
    [anon_sym_mstore] = ACTIONS(1016),
    [anon_sym_mstore8] = ACTIONS(1016),
    [anon_sym_sload] = ACTIONS(1016),
    [anon_sym_sstore] = ACTIONS(1016),
    [anon_sym_msize] = ACTIONS(1016),
    [anon_sym_gas] = ACTIONS(1016),
    [anon_sym_address] = ACTIONS(1016),
    [anon_sym_balance] = ACTIONS(1016),
    [anon_sym_selfbalance] = ACTIONS(1016),
    [anon_sym_caller] = ACTIONS(1016),
    [anon_sym_callvalue] = ACTIONS(1016),
    [anon_sym_calldataload] = ACTIONS(1016),
    [anon_sym_calldatasize] = ACTIONS(1016),
    [anon_sym_calldatacopy] = ACTIONS(1016),
    [anon_sym_extcodesize] = ACTIONS(1016),
    [anon_sym_extcodecopy] = ACTIONS(1016),
    [anon_sym_returndatasize] = ACTIONS(1016),
    [anon_sym_returndatacopy] = ACTIONS(1016),
    [anon_sym_extcodehash] = ACTIONS(1016),
    [anon_sym_create] = ACTIONS(1016),
    [anon_sym_create2] = ACTIONS(1016),
    [anon_sym_call] = ACTIONS(1016),
    [anon_sym_callcode] = ACTIONS(1016),
    [anon_sym_delegatecall] = ACTIONS(1016),
    [anon_sym_staticcall] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_revert] = ACTIONS(1016),
    [anon_sym_selfdestruct] = ACTIONS(1016),
    [anon_sym_invalid] = ACTIONS(1016),
    [anon_sym_log0] = ACTIONS(1016),
    [anon_sym_log1] = ACTIONS(1016),
    [anon_sym_log2] = ACTIONS(1016),
    [anon_sym_log3] = ACTIONS(1016),
    [anon_sym_log4] = ACTIONS(1016),
    [anon_sym_chainid] = ACTIONS(1016),
    [anon_sym_origin] = ACTIONS(1016),
    [anon_sym_gasprice] = ACTIONS(1016),
    [anon_sym_blockhash] = ACTIONS(1016),
    [anon_sym_coinbase] = ACTIONS(1016),
    [anon_sym_timestamp] = ACTIONS(1016),
    [anon_sym_number] = ACTIONS(1016),
    [anon_sym_difficulty] = ACTIONS(1016),
    [anon_sym_gaslimit] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_identifier] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_COMMA] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [anon_sym_RPAREN] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1020),
    [sym_yul_leave] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [sym_yul_decimal_number] = ACTIONS(1020),
    [sym_yul_hex_number] = ACTIONS(1022),
    [anon_sym_true] = ACTIONS(1020),
    [anon_sym_false] = ACTIONS(1020),
    [anon_sym_let] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_function] = ACTIONS(1020),
    [anon_sym_stop] = ACTIONS(1020),
    [anon_sym_add] = ACTIONS(1020),
    [anon_sym_sub] = ACTIONS(1020),
    [anon_sym_mul] = ACTIONS(1020),
    [anon_sym_div] = ACTIONS(1020),
    [anon_sym_sdiv] = ACTIONS(1020),
    [anon_sym_mod] = ACTIONS(1020),
    [anon_sym_smod] = ACTIONS(1020),
    [anon_sym_exp] = ACTIONS(1020),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_lt] = ACTIONS(1020),
    [anon_sym_gt] = ACTIONS(1020),
    [anon_sym_slt] = ACTIONS(1020),
    [anon_sym_sgt] = ACTIONS(1020),
    [anon_sym_eq] = ACTIONS(1020),
    [anon_sym_iszero] = ACTIONS(1020),
    [anon_sym_and] = ACTIONS(1020),
    [anon_sym_or] = ACTIONS(1020),
    [anon_sym_xor] = ACTIONS(1020),
    [anon_sym_byte] = ACTIONS(1020),
    [anon_sym_shl] = ACTIONS(1020),
    [anon_sym_shr] = ACTIONS(1020),
    [anon_sym_sar] = ACTIONS(1020),
    [anon_sym_addmod] = ACTIONS(1020),
    [anon_sym_mulmod] = ACTIONS(1020),
    [anon_sym_signextend] = ACTIONS(1020),
    [anon_sym_keccak256] = ACTIONS(1020),
    [anon_sym_pop] = ACTIONS(1020),
    [anon_sym_mload] = ACTIONS(1020),
    [anon_sym_mstore] = ACTIONS(1020),
    [anon_sym_mstore8] = ACTIONS(1020),
    [anon_sym_sload] = ACTIONS(1020),
    [anon_sym_sstore] = ACTIONS(1020),
    [anon_sym_msize] = ACTIONS(1020),
    [anon_sym_gas] = ACTIONS(1020),
    [anon_sym_address] = ACTIONS(1020),
    [anon_sym_balance] = ACTIONS(1020),
    [anon_sym_selfbalance] = ACTIONS(1020),
    [anon_sym_caller] = ACTIONS(1020),
    [anon_sym_callvalue] = ACTIONS(1020),
    [anon_sym_calldataload] = ACTIONS(1020),
    [anon_sym_calldatasize] = ACTIONS(1020),
    [anon_sym_calldatacopy] = ACTIONS(1020),
    [anon_sym_extcodesize] = ACTIONS(1020),
    [anon_sym_extcodecopy] = ACTIONS(1020),
    [anon_sym_returndatasize] = ACTIONS(1020),
    [anon_sym_returndatacopy] = ACTIONS(1020),
    [anon_sym_extcodehash] = ACTIONS(1020),
    [anon_sym_create] = ACTIONS(1020),
    [anon_sym_create2] = ACTIONS(1020),
    [anon_sym_call] = ACTIONS(1020),
    [anon_sym_callcode] = ACTIONS(1020),
    [anon_sym_delegatecall] = ACTIONS(1020),
    [anon_sym_staticcall] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_revert] = ACTIONS(1020),
    [anon_sym_selfdestruct] = ACTIONS(1020),
    [anon_sym_invalid] = ACTIONS(1020),
    [anon_sym_log0] = ACTIONS(1020),
    [anon_sym_log1] = ACTIONS(1020),
    [anon_sym_log2] = ACTIONS(1020),
    [anon_sym_log3] = ACTIONS(1020),
    [anon_sym_log4] = ACTIONS(1020),
    [anon_sym_chainid] = ACTIONS(1020),
    [anon_sym_origin] = ACTIONS(1020),
    [anon_sym_gasprice] = ACTIONS(1020),
    [anon_sym_blockhash] = ACTIONS(1020),
    [anon_sym_coinbase] = ACTIONS(1020),
    [anon_sym_timestamp] = ACTIONS(1020),
    [anon_sym_number] = ACTIONS(1020),
    [anon_sym_difficulty] = ACTIONS(1020),
    [anon_sym_gaslimit] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(242),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_COMMA] = ACTIONS(1028),
    [anon_sym_RBRACE] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1024),
    [sym_yul_leave] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [sym_yul_decimal_number] = ACTIONS(1024),
    [sym_yul_hex_number] = ACTIONS(1026),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_COLON_EQ] = ACTIONS(1030),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_function] = ACTIONS(1024),
    [anon_sym_stop] = ACTIONS(1024),
    [anon_sym_add] = ACTIONS(1024),
    [anon_sym_sub] = ACTIONS(1024),
    [anon_sym_mul] = ACTIONS(1024),
    [anon_sym_div] = ACTIONS(1024),
    [anon_sym_sdiv] = ACTIONS(1024),
    [anon_sym_mod] = ACTIONS(1024),
    [anon_sym_smod] = ACTIONS(1024),
    [anon_sym_exp] = ACTIONS(1024),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_lt] = ACTIONS(1024),
    [anon_sym_gt] = ACTIONS(1024),
    [anon_sym_slt] = ACTIONS(1024),
    [anon_sym_sgt] = ACTIONS(1024),
    [anon_sym_eq] = ACTIONS(1024),
    [anon_sym_iszero] = ACTIONS(1024),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_byte] = ACTIONS(1024),
    [anon_sym_shl] = ACTIONS(1024),
    [anon_sym_shr] = ACTIONS(1024),
    [anon_sym_sar] = ACTIONS(1024),
    [anon_sym_addmod] = ACTIONS(1024),
    [anon_sym_mulmod] = ACTIONS(1024),
    [anon_sym_signextend] = ACTIONS(1024),
    [anon_sym_keccak256] = ACTIONS(1024),
    [anon_sym_pop] = ACTIONS(1024),
    [anon_sym_mload] = ACTIONS(1024),
    [anon_sym_mstore] = ACTIONS(1024),
    [anon_sym_mstore8] = ACTIONS(1024),
    [anon_sym_sload] = ACTIONS(1024),
    [anon_sym_sstore] = ACTIONS(1024),
    [anon_sym_msize] = ACTIONS(1024),
    [anon_sym_gas] = ACTIONS(1024),
    [anon_sym_address] = ACTIONS(1024),
    [anon_sym_balance] = ACTIONS(1024),
    [anon_sym_selfbalance] = ACTIONS(1024),
    [anon_sym_caller] = ACTIONS(1024),
    [anon_sym_callvalue] = ACTIONS(1024),
    [anon_sym_calldataload] = ACTIONS(1024),
    [anon_sym_calldatasize] = ACTIONS(1024),
    [anon_sym_calldatacopy] = ACTIONS(1024),
    [anon_sym_extcodesize] = ACTIONS(1024),
    [anon_sym_extcodecopy] = ACTIONS(1024),
    [anon_sym_returndatasize] = ACTIONS(1024),
    [anon_sym_returndatacopy] = ACTIONS(1024),
    [anon_sym_extcodehash] = ACTIONS(1024),
    [anon_sym_create] = ACTIONS(1024),
    [anon_sym_create2] = ACTIONS(1024),
    [anon_sym_call] = ACTIONS(1024),
    [anon_sym_callcode] = ACTIONS(1024),
    [anon_sym_delegatecall] = ACTIONS(1024),
    [anon_sym_staticcall] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_revert] = ACTIONS(1024),
    [anon_sym_selfdestruct] = ACTIONS(1024),
    [anon_sym_invalid] = ACTIONS(1024),
    [anon_sym_log0] = ACTIONS(1024),
    [anon_sym_log1] = ACTIONS(1024),
    [anon_sym_log2] = ACTIONS(1024),
    [anon_sym_log3] = ACTIONS(1024),
    [anon_sym_log4] = ACTIONS(1024),
    [anon_sym_chainid] = ACTIONS(1024),
    [anon_sym_origin] = ACTIONS(1024),
    [anon_sym_gasprice] = ACTIONS(1024),
    [anon_sym_blockhash] = ACTIONS(1024),
    [anon_sym_coinbase] = ACTIONS(1024),
    [anon_sym_timestamp] = ACTIONS(1024),
    [anon_sym_number] = ACTIONS(1024),
    [anon_sym_difficulty] = ACTIONS(1024),
    [anon_sym_gaslimit] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(246),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_COMMA] = ACTIONS(1036),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1032),
    [sym_yul_leave] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [sym_yul_decimal_number] = ACTIONS(1032),
    [sym_yul_hex_number] = ACTIONS(1034),
    [anon_sym_true] = ACTIONS(1032),
    [anon_sym_false] = ACTIONS(1032),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_COLON_EQ] = ACTIONS(1038),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_function] = ACTIONS(1032),
    [anon_sym_stop] = ACTIONS(1032),
    [anon_sym_add] = ACTIONS(1032),
    [anon_sym_sub] = ACTIONS(1032),
    [anon_sym_mul] = ACTIONS(1032),
    [anon_sym_div] = ACTIONS(1032),
    [anon_sym_sdiv] = ACTIONS(1032),
    [anon_sym_mod] = ACTIONS(1032),
    [anon_sym_smod] = ACTIONS(1032),
    [anon_sym_exp] = ACTIONS(1032),
    [anon_sym_not] = ACTIONS(1032),
    [anon_sym_lt] = ACTIONS(1032),
    [anon_sym_gt] = ACTIONS(1032),
    [anon_sym_slt] = ACTIONS(1032),
    [anon_sym_sgt] = ACTIONS(1032),
    [anon_sym_eq] = ACTIONS(1032),
    [anon_sym_iszero] = ACTIONS(1032),
    [anon_sym_and] = ACTIONS(1032),
    [anon_sym_or] = ACTIONS(1032),
    [anon_sym_xor] = ACTIONS(1032),
    [anon_sym_byte] = ACTIONS(1032),
    [anon_sym_shl] = ACTIONS(1032),
    [anon_sym_shr] = ACTIONS(1032),
    [anon_sym_sar] = ACTIONS(1032),
    [anon_sym_addmod] = ACTIONS(1032),
    [anon_sym_mulmod] = ACTIONS(1032),
    [anon_sym_signextend] = ACTIONS(1032),
    [anon_sym_keccak256] = ACTIONS(1032),
    [anon_sym_pop] = ACTIONS(1032),
    [anon_sym_mload] = ACTIONS(1032),
    [anon_sym_mstore] = ACTIONS(1032),
    [anon_sym_mstore8] = ACTIONS(1032),
    [anon_sym_sload] = ACTIONS(1032),
    [anon_sym_sstore] = ACTIONS(1032),
    [anon_sym_msize] = ACTIONS(1032),
    [anon_sym_gas] = ACTIONS(1032),
    [anon_sym_address] = ACTIONS(1032),
    [anon_sym_balance] = ACTIONS(1032),
    [anon_sym_selfbalance] = ACTIONS(1032),
    [anon_sym_caller] = ACTIONS(1032),
    [anon_sym_callvalue] = ACTIONS(1032),
    [anon_sym_calldataload] = ACTIONS(1032),
    [anon_sym_calldatasize] = ACTIONS(1032),
    [anon_sym_calldatacopy] = ACTIONS(1032),
    [anon_sym_extcodesize] = ACTIONS(1032),
    [anon_sym_extcodecopy] = ACTIONS(1032),
    [anon_sym_returndatasize] = ACTIONS(1032),
    [anon_sym_returndatacopy] = ACTIONS(1032),
    [anon_sym_extcodehash] = ACTIONS(1032),
    [anon_sym_create] = ACTIONS(1032),
    [anon_sym_create2] = ACTIONS(1032),
    [anon_sym_call] = ACTIONS(1032),
    [anon_sym_callcode] = ACTIONS(1032),
    [anon_sym_delegatecall] = ACTIONS(1032),
    [anon_sym_staticcall] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_revert] = ACTIONS(1032),
    [anon_sym_selfdestruct] = ACTIONS(1032),
    [anon_sym_invalid] = ACTIONS(1032),
    [anon_sym_log0] = ACTIONS(1032),
    [anon_sym_log1] = ACTIONS(1032),
    [anon_sym_log2] = ACTIONS(1032),
    [anon_sym_log3] = ACTIONS(1032),
    [anon_sym_log4] = ACTIONS(1032),
    [anon_sym_chainid] = ACTIONS(1032),
    [anon_sym_origin] = ACTIONS(1032),
    [anon_sym_gasprice] = ACTIONS(1032),
    [anon_sym_blockhash] = ACTIONS(1032),
    [anon_sym_coinbase] = ACTIONS(1032),
    [anon_sym_timestamp] = ACTIONS(1032),
    [anon_sym_number] = ACTIONS(1032),
    [anon_sym_difficulty] = ACTIONS(1032),
    [anon_sym_gaslimit] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_identifier] = ACTIONS(990),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(990),
    [anon_sym_COLON] = ACTIONS(990),
    [sym_yul_leave] = ACTIONS(990),
    [anon_sym_break] = ACTIONS(990),
    [anon_sym_continue] = ACTIONS(990),
    [sym_yul_decimal_number] = ACTIONS(990),
    [sym_yul_hex_number] = ACTIONS(992),
    [anon_sym_true] = ACTIONS(990),
    [anon_sym_false] = ACTIONS(990),
    [anon_sym_let] = ACTIONS(990),
    [anon_sym_COLON_EQ] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(990),
    [anon_sym_switch] = ACTIONS(990),
    [anon_sym_function] = ACTIONS(990),
    [anon_sym_stop] = ACTIONS(990),
    [anon_sym_add] = ACTIONS(990),
    [anon_sym_sub] = ACTIONS(990),
    [anon_sym_mul] = ACTIONS(990),
    [anon_sym_div] = ACTIONS(990),
    [anon_sym_sdiv] = ACTIONS(990),
    [anon_sym_mod] = ACTIONS(990),
    [anon_sym_smod] = ACTIONS(990),
    [anon_sym_exp] = ACTIONS(990),
    [anon_sym_not] = ACTIONS(990),
    [anon_sym_lt] = ACTIONS(990),
    [anon_sym_gt] = ACTIONS(990),
    [anon_sym_slt] = ACTIONS(990),
    [anon_sym_sgt] = ACTIONS(990),
    [anon_sym_eq] = ACTIONS(990),
    [anon_sym_iszero] = ACTIONS(990),
    [anon_sym_and] = ACTIONS(990),
    [anon_sym_or] = ACTIONS(990),
    [anon_sym_xor] = ACTIONS(990),
    [anon_sym_byte] = ACTIONS(990),
    [anon_sym_shl] = ACTIONS(990),
    [anon_sym_shr] = ACTIONS(990),
    [anon_sym_sar] = ACTIONS(990),
    [anon_sym_addmod] = ACTIONS(990),
    [anon_sym_mulmod] = ACTIONS(990),
    [anon_sym_signextend] = ACTIONS(990),
    [anon_sym_keccak256] = ACTIONS(990),
    [anon_sym_pop] = ACTIONS(990),
    [anon_sym_mload] = ACTIONS(990),
    [anon_sym_mstore] = ACTIONS(990),
    [anon_sym_mstore8] = ACTIONS(990),
    [anon_sym_sload] = ACTIONS(990),
    [anon_sym_sstore] = ACTIONS(990),
    [anon_sym_msize] = ACTIONS(990),
    [anon_sym_gas] = ACTIONS(990),
    [anon_sym_address] = ACTIONS(990),
    [anon_sym_balance] = ACTIONS(990),
    [anon_sym_selfbalance] = ACTIONS(990),
    [anon_sym_caller] = ACTIONS(990),
    [anon_sym_callvalue] = ACTIONS(990),
    [anon_sym_calldataload] = ACTIONS(990),
    [anon_sym_calldatasize] = ACTIONS(990),
    [anon_sym_calldatacopy] = ACTIONS(990),
    [anon_sym_extcodesize] = ACTIONS(990),
    [anon_sym_extcodecopy] = ACTIONS(990),
    [anon_sym_returndatasize] = ACTIONS(990),
    [anon_sym_returndatacopy] = ACTIONS(990),
    [anon_sym_extcodehash] = ACTIONS(990),
    [anon_sym_create] = ACTIONS(990),
    [anon_sym_create2] = ACTIONS(990),
    [anon_sym_call] = ACTIONS(990),
    [anon_sym_callcode] = ACTIONS(990),
    [anon_sym_delegatecall] = ACTIONS(990),
    [anon_sym_staticcall] = ACTIONS(990),
    [anon_sym_return] = ACTIONS(990),
    [anon_sym_revert] = ACTIONS(990),
    [anon_sym_selfdestruct] = ACTIONS(990),
    [anon_sym_invalid] = ACTIONS(990),
    [anon_sym_log0] = ACTIONS(990),
    [anon_sym_log1] = ACTIONS(990),
    [anon_sym_log2] = ACTIONS(990),
    [anon_sym_log3] = ACTIONS(990),
    [anon_sym_log4] = ACTIONS(990),
    [anon_sym_chainid] = ACTIONS(990),
    [anon_sym_origin] = ACTIONS(990),
    [anon_sym_gasprice] = ACTIONS(990),
    [anon_sym_blockhash] = ACTIONS(990),
    [anon_sym_coinbase] = ACTIONS(990),
    [anon_sym_timestamp] = ACTIONS(990),
    [anon_sym_number] = ACTIONS(990),
    [anon_sym_difficulty] = ACTIONS(990),
    [anon_sym_gaslimit] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_COMMA] = ACTIONS(1007),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1005),
    [sym_yul_leave] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [sym_yul_decimal_number] = ACTIONS(1005),
    [sym_yul_hex_number] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1005),
    [anon_sym_false] = ACTIONS(1005),
    [anon_sym_let] = ACTIONS(1005),
    [anon_sym_COLON_EQ] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1005),
    [anon_sym_stop] = ACTIONS(1005),
    [anon_sym_add] = ACTIONS(1005),
    [anon_sym_sub] = ACTIONS(1005),
    [anon_sym_mul] = ACTIONS(1005),
    [anon_sym_div] = ACTIONS(1005),
    [anon_sym_sdiv] = ACTIONS(1005),
    [anon_sym_mod] = ACTIONS(1005),
    [anon_sym_smod] = ACTIONS(1005),
    [anon_sym_exp] = ACTIONS(1005),
    [anon_sym_not] = ACTIONS(1005),
    [anon_sym_lt] = ACTIONS(1005),
    [anon_sym_gt] = ACTIONS(1005),
    [anon_sym_slt] = ACTIONS(1005),
    [anon_sym_sgt] = ACTIONS(1005),
    [anon_sym_eq] = ACTIONS(1005),
    [anon_sym_iszero] = ACTIONS(1005),
    [anon_sym_and] = ACTIONS(1005),
    [anon_sym_or] = ACTIONS(1005),
    [anon_sym_xor] = ACTIONS(1005),
    [anon_sym_byte] = ACTIONS(1005),
    [anon_sym_shl] = ACTIONS(1005),
    [anon_sym_shr] = ACTIONS(1005),
    [anon_sym_sar] = ACTIONS(1005),
    [anon_sym_addmod] = ACTIONS(1005),
    [anon_sym_mulmod] = ACTIONS(1005),
    [anon_sym_signextend] = ACTIONS(1005),
    [anon_sym_keccak256] = ACTIONS(1005),
    [anon_sym_pop] = ACTIONS(1005),
    [anon_sym_mload] = ACTIONS(1005),
    [anon_sym_mstore] = ACTIONS(1005),
    [anon_sym_mstore8] = ACTIONS(1005),
    [anon_sym_sload] = ACTIONS(1005),
    [anon_sym_sstore] = ACTIONS(1005),
    [anon_sym_msize] = ACTIONS(1005),
    [anon_sym_gas] = ACTIONS(1005),
    [anon_sym_address] = ACTIONS(1005),
    [anon_sym_balance] = ACTIONS(1005),
    [anon_sym_selfbalance] = ACTIONS(1005),
    [anon_sym_caller] = ACTIONS(1005),
    [anon_sym_callvalue] = ACTIONS(1005),
    [anon_sym_calldataload] = ACTIONS(1005),
    [anon_sym_calldatasize] = ACTIONS(1005),
    [anon_sym_calldatacopy] = ACTIONS(1005),
    [anon_sym_extcodesize] = ACTIONS(1005),
    [anon_sym_extcodecopy] = ACTIONS(1005),
    [anon_sym_returndatasize] = ACTIONS(1005),
    [anon_sym_returndatacopy] = ACTIONS(1005),
    [anon_sym_extcodehash] = ACTIONS(1005),
    [anon_sym_create] = ACTIONS(1005),
    [anon_sym_create2] = ACTIONS(1005),
    [anon_sym_call] = ACTIONS(1005),
    [anon_sym_callcode] = ACTIONS(1005),
    [anon_sym_delegatecall] = ACTIONS(1005),
    [anon_sym_staticcall] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_revert] = ACTIONS(1005),
    [anon_sym_selfdestruct] = ACTIONS(1005),
    [anon_sym_invalid] = ACTIONS(1005),
    [anon_sym_log0] = ACTIONS(1005),
    [anon_sym_log1] = ACTIONS(1005),
    [anon_sym_log2] = ACTIONS(1005),
    [anon_sym_log3] = ACTIONS(1005),
    [anon_sym_log4] = ACTIONS(1005),
    [anon_sym_chainid] = ACTIONS(1005),
    [anon_sym_origin] = ACTIONS(1005),
    [anon_sym_gasprice] = ACTIONS(1005),
    [anon_sym_blockhash] = ACTIONS(1005),
    [anon_sym_coinbase] = ACTIONS(1005),
    [anon_sym_timestamp] = ACTIONS(1005),
    [anon_sym_number] = ACTIONS(1005),
    [anon_sym_difficulty] = ACTIONS(1005),
    [anon_sym_gaslimit] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1007),
    [anon_sym_SQUOTE] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [aux_sym_yul_switch_statement_repeat1] = STATE(251),
    [sym_identifier] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1040),
    [sym_yul_leave] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [sym_yul_decimal_number] = ACTIONS(1040),
    [sym_yul_hex_number] = ACTIONS(1042),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1046),
    [anon_sym_function] = ACTIONS(1040),
    [anon_sym_stop] = ACTIONS(1040),
    [anon_sym_add] = ACTIONS(1040),
    [anon_sym_sub] = ACTIONS(1040),
    [anon_sym_mul] = ACTIONS(1040),
    [anon_sym_div] = ACTIONS(1040),
    [anon_sym_sdiv] = ACTIONS(1040),
    [anon_sym_mod] = ACTIONS(1040),
    [anon_sym_smod] = ACTIONS(1040),
    [anon_sym_exp] = ACTIONS(1040),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_lt] = ACTIONS(1040),
    [anon_sym_gt] = ACTIONS(1040),
    [anon_sym_slt] = ACTIONS(1040),
    [anon_sym_sgt] = ACTIONS(1040),
    [anon_sym_eq] = ACTIONS(1040),
    [anon_sym_iszero] = ACTIONS(1040),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_byte] = ACTIONS(1040),
    [anon_sym_shl] = ACTIONS(1040),
    [anon_sym_shr] = ACTIONS(1040),
    [anon_sym_sar] = ACTIONS(1040),
    [anon_sym_addmod] = ACTIONS(1040),
    [anon_sym_mulmod] = ACTIONS(1040),
    [anon_sym_signextend] = ACTIONS(1040),
    [anon_sym_keccak256] = ACTIONS(1040),
    [anon_sym_pop] = ACTIONS(1040),
    [anon_sym_mload] = ACTIONS(1040),
    [anon_sym_mstore] = ACTIONS(1040),
    [anon_sym_mstore8] = ACTIONS(1040),
    [anon_sym_sload] = ACTIONS(1040),
    [anon_sym_sstore] = ACTIONS(1040),
    [anon_sym_msize] = ACTIONS(1040),
    [anon_sym_gas] = ACTIONS(1040),
    [anon_sym_address] = ACTIONS(1040),
    [anon_sym_balance] = ACTIONS(1040),
    [anon_sym_selfbalance] = ACTIONS(1040),
    [anon_sym_caller] = ACTIONS(1040),
    [anon_sym_callvalue] = ACTIONS(1040),
    [anon_sym_calldataload] = ACTIONS(1040),
    [anon_sym_calldatasize] = ACTIONS(1040),
    [anon_sym_calldatacopy] = ACTIONS(1040),
    [anon_sym_extcodesize] = ACTIONS(1040),
    [anon_sym_extcodecopy] = ACTIONS(1040),
    [anon_sym_returndatasize] = ACTIONS(1040),
    [anon_sym_returndatacopy] = ACTIONS(1040),
    [anon_sym_extcodehash] = ACTIONS(1040),
    [anon_sym_create] = ACTIONS(1040),
    [anon_sym_create2] = ACTIONS(1040),
    [anon_sym_call] = ACTIONS(1040),
    [anon_sym_callcode] = ACTIONS(1040),
    [anon_sym_delegatecall] = ACTIONS(1040),
    [anon_sym_staticcall] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_revert] = ACTIONS(1040),
    [anon_sym_selfdestruct] = ACTIONS(1040),
    [anon_sym_invalid] = ACTIONS(1040),
    [anon_sym_log0] = ACTIONS(1040),
    [anon_sym_log1] = ACTIONS(1040),
    [anon_sym_log2] = ACTIONS(1040),
    [anon_sym_log3] = ACTIONS(1040),
    [anon_sym_log4] = ACTIONS(1040),
    [anon_sym_chainid] = ACTIONS(1040),
    [anon_sym_origin] = ACTIONS(1040),
    [anon_sym_gasprice] = ACTIONS(1040),
    [anon_sym_blockhash] = ACTIONS(1040),
    [anon_sym_coinbase] = ACTIONS(1040),
    [anon_sym_timestamp] = ACTIONS(1040),
    [anon_sym_number] = ACTIONS(1040),
    [anon_sym_difficulty] = ACTIONS(1040),
    [anon_sym_gaslimit] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [aux_sym_yul_switch_statement_repeat1] = STATE(251),
    [sym_identifier] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1048),
    [sym_yul_leave] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [sym_yul_decimal_number] = ACTIONS(1048),
    [sym_yul_hex_number] = ACTIONS(1050),
    [anon_sym_true] = ACTIONS(1048),
    [anon_sym_false] = ACTIONS(1048),
    [anon_sym_let] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(1048),
    [anon_sym_stop] = ACTIONS(1048),
    [anon_sym_add] = ACTIONS(1048),
    [anon_sym_sub] = ACTIONS(1048),
    [anon_sym_mul] = ACTIONS(1048),
    [anon_sym_div] = ACTIONS(1048),
    [anon_sym_sdiv] = ACTIONS(1048),
    [anon_sym_mod] = ACTIONS(1048),
    [anon_sym_smod] = ACTIONS(1048),
    [anon_sym_exp] = ACTIONS(1048),
    [anon_sym_not] = ACTIONS(1048),
    [anon_sym_lt] = ACTIONS(1048),
    [anon_sym_gt] = ACTIONS(1048),
    [anon_sym_slt] = ACTIONS(1048),
    [anon_sym_sgt] = ACTIONS(1048),
    [anon_sym_eq] = ACTIONS(1048),
    [anon_sym_iszero] = ACTIONS(1048),
    [anon_sym_and] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(1048),
    [anon_sym_xor] = ACTIONS(1048),
    [anon_sym_byte] = ACTIONS(1048),
    [anon_sym_shl] = ACTIONS(1048),
    [anon_sym_shr] = ACTIONS(1048),
    [anon_sym_sar] = ACTIONS(1048),
    [anon_sym_addmod] = ACTIONS(1048),
    [anon_sym_mulmod] = ACTIONS(1048),
    [anon_sym_signextend] = ACTIONS(1048),
    [anon_sym_keccak256] = ACTIONS(1048),
    [anon_sym_pop] = ACTIONS(1048),
    [anon_sym_mload] = ACTIONS(1048),
    [anon_sym_mstore] = ACTIONS(1048),
    [anon_sym_mstore8] = ACTIONS(1048),
    [anon_sym_sload] = ACTIONS(1048),
    [anon_sym_sstore] = ACTIONS(1048),
    [anon_sym_msize] = ACTIONS(1048),
    [anon_sym_gas] = ACTIONS(1048),
    [anon_sym_address] = ACTIONS(1048),
    [anon_sym_balance] = ACTIONS(1048),
    [anon_sym_selfbalance] = ACTIONS(1048),
    [anon_sym_caller] = ACTIONS(1048),
    [anon_sym_callvalue] = ACTIONS(1048),
    [anon_sym_calldataload] = ACTIONS(1048),
    [anon_sym_calldatasize] = ACTIONS(1048),
    [anon_sym_calldatacopy] = ACTIONS(1048),
    [anon_sym_extcodesize] = ACTIONS(1048),
    [anon_sym_extcodecopy] = ACTIONS(1048),
    [anon_sym_returndatasize] = ACTIONS(1048),
    [anon_sym_returndatacopy] = ACTIONS(1048),
    [anon_sym_extcodehash] = ACTIONS(1048),
    [anon_sym_create] = ACTIONS(1048),
    [anon_sym_create2] = ACTIONS(1048),
    [anon_sym_call] = ACTIONS(1048),
    [anon_sym_callcode] = ACTIONS(1048),
    [anon_sym_delegatecall] = ACTIONS(1048),
    [anon_sym_staticcall] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_revert] = ACTIONS(1048),
    [anon_sym_selfdestruct] = ACTIONS(1048),
    [anon_sym_invalid] = ACTIONS(1048),
    [anon_sym_log0] = ACTIONS(1048),
    [anon_sym_log1] = ACTIONS(1048),
    [anon_sym_log2] = ACTIONS(1048),
    [anon_sym_log3] = ACTIONS(1048),
    [anon_sym_log4] = ACTIONS(1048),
    [anon_sym_chainid] = ACTIONS(1048),
    [anon_sym_origin] = ACTIONS(1048),
    [anon_sym_gasprice] = ACTIONS(1048),
    [anon_sym_blockhash] = ACTIONS(1048),
    [anon_sym_coinbase] = ACTIONS(1048),
    [anon_sym_timestamp] = ACTIONS(1048),
    [anon_sym_number] = ACTIONS(1048),
    [anon_sym_difficulty] = ACTIONS(1048),
    [anon_sym_gaslimit] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_identifier] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_for] = ACTIONS(1055),
    [sym_yul_leave] = ACTIONS(1055),
    [anon_sym_break] = ACTIONS(1055),
    [anon_sym_continue] = ACTIONS(1055),
    [sym_yul_decimal_number] = ACTIONS(1055),
    [sym_yul_hex_number] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(1055),
    [anon_sym_false] = ACTIONS(1055),
    [anon_sym_let] = ACTIONS(1055),
    [anon_sym_if] = ACTIONS(1055),
    [anon_sym_switch] = ACTIONS(1055),
    [anon_sym_default] = ACTIONS(1055),
    [anon_sym_case] = ACTIONS(1055),
    [anon_sym_function] = ACTIONS(1055),
    [anon_sym_stop] = ACTIONS(1055),
    [anon_sym_add] = ACTIONS(1055),
    [anon_sym_sub] = ACTIONS(1055),
    [anon_sym_mul] = ACTIONS(1055),
    [anon_sym_div] = ACTIONS(1055),
    [anon_sym_sdiv] = ACTIONS(1055),
    [anon_sym_mod] = ACTIONS(1055),
    [anon_sym_smod] = ACTIONS(1055),
    [anon_sym_exp] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1055),
    [anon_sym_lt] = ACTIONS(1055),
    [anon_sym_gt] = ACTIONS(1055),
    [anon_sym_slt] = ACTIONS(1055),
    [anon_sym_sgt] = ACTIONS(1055),
    [anon_sym_eq] = ACTIONS(1055),
    [anon_sym_iszero] = ACTIONS(1055),
    [anon_sym_and] = ACTIONS(1055),
    [anon_sym_or] = ACTIONS(1055),
    [anon_sym_xor] = ACTIONS(1055),
    [anon_sym_byte] = ACTIONS(1055),
    [anon_sym_shl] = ACTIONS(1055),
    [anon_sym_shr] = ACTIONS(1055),
    [anon_sym_sar] = ACTIONS(1055),
    [anon_sym_addmod] = ACTIONS(1055),
    [anon_sym_mulmod] = ACTIONS(1055),
    [anon_sym_signextend] = ACTIONS(1055),
    [anon_sym_keccak256] = ACTIONS(1055),
    [anon_sym_pop] = ACTIONS(1055),
    [anon_sym_mload] = ACTIONS(1055),
    [anon_sym_mstore] = ACTIONS(1055),
    [anon_sym_mstore8] = ACTIONS(1055),
    [anon_sym_sload] = ACTIONS(1055),
    [anon_sym_sstore] = ACTIONS(1055),
    [anon_sym_msize] = ACTIONS(1055),
    [anon_sym_gas] = ACTIONS(1055),
    [anon_sym_address] = ACTIONS(1055),
    [anon_sym_balance] = ACTIONS(1055),
    [anon_sym_selfbalance] = ACTIONS(1055),
    [anon_sym_caller] = ACTIONS(1055),
    [anon_sym_callvalue] = ACTIONS(1055),
    [anon_sym_calldataload] = ACTIONS(1055),
    [anon_sym_calldatasize] = ACTIONS(1055),
    [anon_sym_calldatacopy] = ACTIONS(1055),
    [anon_sym_extcodesize] = ACTIONS(1055),
    [anon_sym_extcodecopy] = ACTIONS(1055),
    [anon_sym_returndatasize] = ACTIONS(1055),
    [anon_sym_returndatacopy] = ACTIONS(1055),
    [anon_sym_extcodehash] = ACTIONS(1055),
    [anon_sym_create] = ACTIONS(1055),
    [anon_sym_create2] = ACTIONS(1055),
    [anon_sym_call] = ACTIONS(1055),
    [anon_sym_callcode] = ACTIONS(1055),
    [anon_sym_delegatecall] = ACTIONS(1055),
    [anon_sym_staticcall] = ACTIONS(1055),
    [anon_sym_return] = ACTIONS(1055),
    [anon_sym_revert] = ACTIONS(1055),
    [anon_sym_selfdestruct] = ACTIONS(1055),
    [anon_sym_invalid] = ACTIONS(1055),
    [anon_sym_log0] = ACTIONS(1055),
    [anon_sym_log1] = ACTIONS(1055),
    [anon_sym_log2] = ACTIONS(1055),
    [anon_sym_log3] = ACTIONS(1055),
    [anon_sym_log4] = ACTIONS(1055),
    [anon_sym_chainid] = ACTIONS(1055),
    [anon_sym_origin] = ACTIONS(1055),
    [anon_sym_gasprice] = ACTIONS(1055),
    [anon_sym_blockhash] = ACTIONS(1055),
    [anon_sym_coinbase] = ACTIONS(1055),
    [anon_sym_timestamp] = ACTIONS(1055),
    [anon_sym_number] = ACTIONS(1055),
    [anon_sym_difficulty] = ACTIONS(1055),
    [anon_sym_gaslimit] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1059),
    [sym_yul_leave] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1059),
    [sym_yul_decimal_number] = ACTIONS(1059),
    [sym_yul_hex_number] = ACTIONS(1061),
    [anon_sym_true] = ACTIONS(1059),
    [anon_sym_false] = ACTIONS(1059),
    [anon_sym_let] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_default] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_stop] = ACTIONS(1059),
    [anon_sym_add] = ACTIONS(1059),
    [anon_sym_sub] = ACTIONS(1059),
    [anon_sym_mul] = ACTIONS(1059),
    [anon_sym_div] = ACTIONS(1059),
    [anon_sym_sdiv] = ACTIONS(1059),
    [anon_sym_mod] = ACTIONS(1059),
    [anon_sym_smod] = ACTIONS(1059),
    [anon_sym_exp] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1059),
    [anon_sym_lt] = ACTIONS(1059),
    [anon_sym_gt] = ACTIONS(1059),
    [anon_sym_slt] = ACTIONS(1059),
    [anon_sym_sgt] = ACTIONS(1059),
    [anon_sym_eq] = ACTIONS(1059),
    [anon_sym_iszero] = ACTIONS(1059),
    [anon_sym_and] = ACTIONS(1059),
    [anon_sym_or] = ACTIONS(1059),
    [anon_sym_xor] = ACTIONS(1059),
    [anon_sym_byte] = ACTIONS(1059),
    [anon_sym_shl] = ACTIONS(1059),
    [anon_sym_shr] = ACTIONS(1059),
    [anon_sym_sar] = ACTIONS(1059),
    [anon_sym_addmod] = ACTIONS(1059),
    [anon_sym_mulmod] = ACTIONS(1059),
    [anon_sym_signextend] = ACTIONS(1059),
    [anon_sym_keccak256] = ACTIONS(1059),
    [anon_sym_pop] = ACTIONS(1059),
    [anon_sym_mload] = ACTIONS(1059),
    [anon_sym_mstore] = ACTIONS(1059),
    [anon_sym_mstore8] = ACTIONS(1059),
    [anon_sym_sload] = ACTIONS(1059),
    [anon_sym_sstore] = ACTIONS(1059),
    [anon_sym_msize] = ACTIONS(1059),
    [anon_sym_gas] = ACTIONS(1059),
    [anon_sym_address] = ACTIONS(1059),
    [anon_sym_balance] = ACTIONS(1059),
    [anon_sym_selfbalance] = ACTIONS(1059),
    [anon_sym_caller] = ACTIONS(1059),
    [anon_sym_callvalue] = ACTIONS(1059),
    [anon_sym_calldataload] = ACTIONS(1059),
    [anon_sym_calldatasize] = ACTIONS(1059),
    [anon_sym_calldatacopy] = ACTIONS(1059),
    [anon_sym_extcodesize] = ACTIONS(1059),
    [anon_sym_extcodecopy] = ACTIONS(1059),
    [anon_sym_returndatasize] = ACTIONS(1059),
    [anon_sym_returndatacopy] = ACTIONS(1059),
    [anon_sym_extcodehash] = ACTIONS(1059),
    [anon_sym_create] = ACTIONS(1059),
    [anon_sym_create2] = ACTIONS(1059),
    [anon_sym_call] = ACTIONS(1059),
    [anon_sym_callcode] = ACTIONS(1059),
    [anon_sym_delegatecall] = ACTIONS(1059),
    [anon_sym_staticcall] = ACTIONS(1059),
    [anon_sym_return] = ACTIONS(1059),
    [anon_sym_revert] = ACTIONS(1059),
    [anon_sym_selfdestruct] = ACTIONS(1059),
    [anon_sym_invalid] = ACTIONS(1059),
    [anon_sym_log0] = ACTIONS(1059),
    [anon_sym_log1] = ACTIONS(1059),
    [anon_sym_log2] = ACTIONS(1059),
    [anon_sym_log3] = ACTIONS(1059),
    [anon_sym_log4] = ACTIONS(1059),
    [anon_sym_chainid] = ACTIONS(1059),
    [anon_sym_origin] = ACTIONS(1059),
    [anon_sym_gasprice] = ACTIONS(1059),
    [anon_sym_blockhash] = ACTIONS(1059),
    [anon_sym_coinbase] = ACTIONS(1059),
    [anon_sym_timestamp] = ACTIONS(1059),
    [anon_sym_number] = ACTIONS(1059),
    [anon_sym_difficulty] = ACTIONS(1059),
    [anon_sym_gaslimit] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_yul_identifier] = STATE(249),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_RBRACE] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1024),
    [sym_yul_leave] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [sym_yul_decimal_number] = ACTIONS(1024),
    [sym_yul_hex_number] = ACTIONS(1026),
    [anon_sym_true] = ACTIONS(1024),
    [anon_sym_false] = ACTIONS(1024),
    [anon_sym_let] = ACTIONS(1024),
    [anon_sym_COLON_EQ] = ACTIONS(1030),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_function] = ACTIONS(1024),
    [anon_sym_stop] = ACTIONS(1024),
    [anon_sym_add] = ACTIONS(1024),
    [anon_sym_sub] = ACTIONS(1024),
    [anon_sym_mul] = ACTIONS(1024),
    [anon_sym_div] = ACTIONS(1024),
    [anon_sym_sdiv] = ACTIONS(1024),
    [anon_sym_mod] = ACTIONS(1024),
    [anon_sym_smod] = ACTIONS(1024),
    [anon_sym_exp] = ACTIONS(1024),
    [anon_sym_not] = ACTIONS(1024),
    [anon_sym_lt] = ACTIONS(1024),
    [anon_sym_gt] = ACTIONS(1024),
    [anon_sym_slt] = ACTIONS(1024),
    [anon_sym_sgt] = ACTIONS(1024),
    [anon_sym_eq] = ACTIONS(1024),
    [anon_sym_iszero] = ACTIONS(1024),
    [anon_sym_and] = ACTIONS(1024),
    [anon_sym_or] = ACTIONS(1024),
    [anon_sym_xor] = ACTIONS(1024),
    [anon_sym_byte] = ACTIONS(1024),
    [anon_sym_shl] = ACTIONS(1024),
    [anon_sym_shr] = ACTIONS(1024),
    [anon_sym_sar] = ACTIONS(1024),
    [anon_sym_addmod] = ACTIONS(1024),
    [anon_sym_mulmod] = ACTIONS(1024),
    [anon_sym_signextend] = ACTIONS(1024),
    [anon_sym_keccak256] = ACTIONS(1024),
    [anon_sym_pop] = ACTIONS(1024),
    [anon_sym_mload] = ACTIONS(1024),
    [anon_sym_mstore] = ACTIONS(1024),
    [anon_sym_mstore8] = ACTIONS(1024),
    [anon_sym_sload] = ACTIONS(1024),
    [anon_sym_sstore] = ACTIONS(1024),
    [anon_sym_msize] = ACTIONS(1024),
    [anon_sym_gas] = ACTIONS(1024),
    [anon_sym_address] = ACTIONS(1024),
    [anon_sym_balance] = ACTIONS(1024),
    [anon_sym_selfbalance] = ACTIONS(1024),
    [anon_sym_caller] = ACTIONS(1024),
    [anon_sym_callvalue] = ACTIONS(1024),
    [anon_sym_calldataload] = ACTIONS(1024),
    [anon_sym_calldatasize] = ACTIONS(1024),
    [anon_sym_calldatacopy] = ACTIONS(1024),
    [anon_sym_extcodesize] = ACTIONS(1024),
    [anon_sym_extcodecopy] = ACTIONS(1024),
    [anon_sym_returndatasize] = ACTIONS(1024),
    [anon_sym_returndatacopy] = ACTIONS(1024),
    [anon_sym_extcodehash] = ACTIONS(1024),
    [anon_sym_create] = ACTIONS(1024),
    [anon_sym_create2] = ACTIONS(1024),
    [anon_sym_call] = ACTIONS(1024),
    [anon_sym_callcode] = ACTIONS(1024),
    [anon_sym_delegatecall] = ACTIONS(1024),
    [anon_sym_staticcall] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_revert] = ACTIONS(1024),
    [anon_sym_selfdestruct] = ACTIONS(1024),
    [anon_sym_invalid] = ACTIONS(1024),
    [anon_sym_log0] = ACTIONS(1024),
    [anon_sym_log1] = ACTIONS(1024),
    [anon_sym_log2] = ACTIONS(1024),
    [anon_sym_log3] = ACTIONS(1024),
    [anon_sym_log4] = ACTIONS(1024),
    [anon_sym_chainid] = ACTIONS(1024),
    [anon_sym_origin] = ACTIONS(1024),
    [anon_sym_gasprice] = ACTIONS(1024),
    [anon_sym_blockhash] = ACTIONS(1024),
    [anon_sym_coinbase] = ACTIONS(1024),
    [anon_sym_timestamp] = ACTIONS(1024),
    [anon_sym_number] = ACTIONS(1024),
    [anon_sym_difficulty] = ACTIONS(1024),
    [anon_sym_gaslimit] = ACTIONS(1024),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1063),
    [sym_yul_leave] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1063),
    [anon_sym_continue] = ACTIONS(1063),
    [sym_yul_decimal_number] = ACTIONS(1063),
    [sym_yul_hex_number] = ACTIONS(1065),
    [anon_sym_true] = ACTIONS(1063),
    [anon_sym_false] = ACTIONS(1063),
    [anon_sym_let] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1063),
    [anon_sym_default] = ACTIONS(1063),
    [anon_sym_case] = ACTIONS(1063),
    [anon_sym_function] = ACTIONS(1063),
    [anon_sym_stop] = ACTIONS(1063),
    [anon_sym_add] = ACTIONS(1063),
    [anon_sym_sub] = ACTIONS(1063),
    [anon_sym_mul] = ACTIONS(1063),
    [anon_sym_div] = ACTIONS(1063),
    [anon_sym_sdiv] = ACTIONS(1063),
    [anon_sym_mod] = ACTIONS(1063),
    [anon_sym_smod] = ACTIONS(1063),
    [anon_sym_exp] = ACTIONS(1063),
    [anon_sym_not] = ACTIONS(1063),
    [anon_sym_lt] = ACTIONS(1063),
    [anon_sym_gt] = ACTIONS(1063),
    [anon_sym_slt] = ACTIONS(1063),
    [anon_sym_sgt] = ACTIONS(1063),
    [anon_sym_eq] = ACTIONS(1063),
    [anon_sym_iszero] = ACTIONS(1063),
    [anon_sym_and] = ACTIONS(1063),
    [anon_sym_or] = ACTIONS(1063),
    [anon_sym_xor] = ACTIONS(1063),
    [anon_sym_byte] = ACTIONS(1063),
    [anon_sym_shl] = ACTIONS(1063),
    [anon_sym_shr] = ACTIONS(1063),
    [anon_sym_sar] = ACTIONS(1063),
    [anon_sym_addmod] = ACTIONS(1063),
    [anon_sym_mulmod] = ACTIONS(1063),
    [anon_sym_signextend] = ACTIONS(1063),
    [anon_sym_keccak256] = ACTIONS(1063),
    [anon_sym_pop] = ACTIONS(1063),
    [anon_sym_mload] = ACTIONS(1063),
    [anon_sym_mstore] = ACTIONS(1063),
    [anon_sym_mstore8] = ACTIONS(1063),
    [anon_sym_sload] = ACTIONS(1063),
    [anon_sym_sstore] = ACTIONS(1063),
    [anon_sym_msize] = ACTIONS(1063),
    [anon_sym_gas] = ACTIONS(1063),
    [anon_sym_address] = ACTIONS(1063),
    [anon_sym_balance] = ACTIONS(1063),
    [anon_sym_selfbalance] = ACTIONS(1063),
    [anon_sym_caller] = ACTIONS(1063),
    [anon_sym_callvalue] = ACTIONS(1063),
    [anon_sym_calldataload] = ACTIONS(1063),
    [anon_sym_calldatasize] = ACTIONS(1063),
    [anon_sym_calldatacopy] = ACTIONS(1063),
    [anon_sym_extcodesize] = ACTIONS(1063),
    [anon_sym_extcodecopy] = ACTIONS(1063),
    [anon_sym_returndatasize] = ACTIONS(1063),
    [anon_sym_returndatacopy] = ACTIONS(1063),
    [anon_sym_extcodehash] = ACTIONS(1063),
    [anon_sym_create] = ACTIONS(1063),
    [anon_sym_create2] = ACTIONS(1063),
    [anon_sym_call] = ACTIONS(1063),
    [anon_sym_callcode] = ACTIONS(1063),
    [anon_sym_delegatecall] = ACTIONS(1063),
    [anon_sym_staticcall] = ACTIONS(1063),
    [anon_sym_return] = ACTIONS(1063),
    [anon_sym_revert] = ACTIONS(1063),
    [anon_sym_selfdestruct] = ACTIONS(1063),
    [anon_sym_invalid] = ACTIONS(1063),
    [anon_sym_log0] = ACTIONS(1063),
    [anon_sym_log1] = ACTIONS(1063),
    [anon_sym_log2] = ACTIONS(1063),
    [anon_sym_log3] = ACTIONS(1063),
    [anon_sym_log4] = ACTIONS(1063),
    [anon_sym_chainid] = ACTIONS(1063),
    [anon_sym_origin] = ACTIONS(1063),
    [anon_sym_gasprice] = ACTIONS(1063),
    [anon_sym_blockhash] = ACTIONS(1063),
    [anon_sym_coinbase] = ACTIONS(1063),
    [anon_sym_timestamp] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_difficulty] = ACTIONS(1063),
    [anon_sym_gaslimit] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_yul_identifier] = STATE(249),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1067),
    [sym_yul_leave] = ACTIONS(1067),
    [anon_sym_break] = ACTIONS(1067),
    [anon_sym_continue] = ACTIONS(1067),
    [sym_yul_decimal_number] = ACTIONS(1067),
    [sym_yul_hex_number] = ACTIONS(1069),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [anon_sym_let] = ACTIONS(1067),
    [anon_sym_COLON_EQ] = ACTIONS(1071),
    [anon_sym_if] = ACTIONS(1067),
    [anon_sym_switch] = ACTIONS(1067),
    [anon_sym_function] = ACTIONS(1067),
    [anon_sym_stop] = ACTIONS(1067),
    [anon_sym_add] = ACTIONS(1067),
    [anon_sym_sub] = ACTIONS(1067),
    [anon_sym_mul] = ACTIONS(1067),
    [anon_sym_div] = ACTIONS(1067),
    [anon_sym_sdiv] = ACTIONS(1067),
    [anon_sym_mod] = ACTIONS(1067),
    [anon_sym_smod] = ACTIONS(1067),
    [anon_sym_exp] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1067),
    [anon_sym_lt] = ACTIONS(1067),
    [anon_sym_gt] = ACTIONS(1067),
    [anon_sym_slt] = ACTIONS(1067),
    [anon_sym_sgt] = ACTIONS(1067),
    [anon_sym_eq] = ACTIONS(1067),
    [anon_sym_iszero] = ACTIONS(1067),
    [anon_sym_and] = ACTIONS(1067),
    [anon_sym_or] = ACTIONS(1067),
    [anon_sym_xor] = ACTIONS(1067),
    [anon_sym_byte] = ACTIONS(1067),
    [anon_sym_shl] = ACTIONS(1067),
    [anon_sym_shr] = ACTIONS(1067),
    [anon_sym_sar] = ACTIONS(1067),
    [anon_sym_addmod] = ACTIONS(1067),
    [anon_sym_mulmod] = ACTIONS(1067),
    [anon_sym_signextend] = ACTIONS(1067),
    [anon_sym_keccak256] = ACTIONS(1067),
    [anon_sym_pop] = ACTIONS(1067),
    [anon_sym_mload] = ACTIONS(1067),
    [anon_sym_mstore] = ACTIONS(1067),
    [anon_sym_mstore8] = ACTIONS(1067),
    [anon_sym_sload] = ACTIONS(1067),
    [anon_sym_sstore] = ACTIONS(1067),
    [anon_sym_msize] = ACTIONS(1067),
    [anon_sym_gas] = ACTIONS(1067),
    [anon_sym_address] = ACTIONS(1067),
    [anon_sym_balance] = ACTIONS(1067),
    [anon_sym_selfbalance] = ACTIONS(1067),
    [anon_sym_caller] = ACTIONS(1067),
    [anon_sym_callvalue] = ACTIONS(1067),
    [anon_sym_calldataload] = ACTIONS(1067),
    [anon_sym_calldatasize] = ACTIONS(1067),
    [anon_sym_calldatacopy] = ACTIONS(1067),
    [anon_sym_extcodesize] = ACTIONS(1067),
    [anon_sym_extcodecopy] = ACTIONS(1067),
    [anon_sym_returndatasize] = ACTIONS(1067),
    [anon_sym_returndatacopy] = ACTIONS(1067),
    [anon_sym_extcodehash] = ACTIONS(1067),
    [anon_sym_create] = ACTIONS(1067),
    [anon_sym_create2] = ACTIONS(1067),
    [anon_sym_call] = ACTIONS(1067),
    [anon_sym_callcode] = ACTIONS(1067),
    [anon_sym_delegatecall] = ACTIONS(1067),
    [anon_sym_staticcall] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_revert] = ACTIONS(1067),
    [anon_sym_selfdestruct] = ACTIONS(1067),
    [anon_sym_invalid] = ACTIONS(1067),
    [anon_sym_log0] = ACTIONS(1067),
    [anon_sym_log1] = ACTIONS(1067),
    [anon_sym_log2] = ACTIONS(1067),
    [anon_sym_log3] = ACTIONS(1067),
    [anon_sym_log4] = ACTIONS(1067),
    [anon_sym_chainid] = ACTIONS(1067),
    [anon_sym_origin] = ACTIONS(1067),
    [anon_sym_gasprice] = ACTIONS(1067),
    [anon_sym_blockhash] = ACTIONS(1067),
    [anon_sym_coinbase] = ACTIONS(1067),
    [anon_sym_timestamp] = ACTIONS(1067),
    [anon_sym_number] = ACTIONS(1067),
    [anon_sym_difficulty] = ACTIONS(1067),
    [anon_sym_gaslimit] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym_for] = ACTIONS(1073),
    [sym_yul_leave] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [sym_yul_decimal_number] = ACTIONS(1073),
    [sym_yul_hex_number] = ACTIONS(1075),
    [anon_sym_true] = ACTIONS(1073),
    [anon_sym_false] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1073),
    [anon_sym_COLON_EQ] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1073),
    [anon_sym_stop] = ACTIONS(1073),
    [anon_sym_add] = ACTIONS(1073),
    [anon_sym_sub] = ACTIONS(1073),
    [anon_sym_mul] = ACTIONS(1073),
    [anon_sym_div] = ACTIONS(1073),
    [anon_sym_sdiv] = ACTIONS(1073),
    [anon_sym_mod] = ACTIONS(1073),
    [anon_sym_smod] = ACTIONS(1073),
    [anon_sym_exp] = ACTIONS(1073),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_lt] = ACTIONS(1073),
    [anon_sym_gt] = ACTIONS(1073),
    [anon_sym_slt] = ACTIONS(1073),
    [anon_sym_sgt] = ACTIONS(1073),
    [anon_sym_eq] = ACTIONS(1073),
    [anon_sym_iszero] = ACTIONS(1073),
    [anon_sym_and] = ACTIONS(1073),
    [anon_sym_or] = ACTIONS(1073),
    [anon_sym_xor] = ACTIONS(1073),
    [anon_sym_byte] = ACTIONS(1073),
    [anon_sym_shl] = ACTIONS(1073),
    [anon_sym_shr] = ACTIONS(1073),
    [anon_sym_sar] = ACTIONS(1073),
    [anon_sym_addmod] = ACTIONS(1073),
    [anon_sym_mulmod] = ACTIONS(1073),
    [anon_sym_signextend] = ACTIONS(1073),
    [anon_sym_keccak256] = ACTIONS(1073),
    [anon_sym_pop] = ACTIONS(1073),
    [anon_sym_mload] = ACTIONS(1073),
    [anon_sym_mstore] = ACTIONS(1073),
    [anon_sym_mstore8] = ACTIONS(1073),
    [anon_sym_sload] = ACTIONS(1073),
    [anon_sym_sstore] = ACTIONS(1073),
    [anon_sym_msize] = ACTIONS(1073),
    [anon_sym_gas] = ACTIONS(1073),
    [anon_sym_address] = ACTIONS(1073),
    [anon_sym_balance] = ACTIONS(1073),
    [anon_sym_selfbalance] = ACTIONS(1073),
    [anon_sym_caller] = ACTIONS(1073),
    [anon_sym_callvalue] = ACTIONS(1073),
    [anon_sym_calldataload] = ACTIONS(1073),
    [anon_sym_calldatasize] = ACTIONS(1073),
    [anon_sym_calldatacopy] = ACTIONS(1073),
    [anon_sym_extcodesize] = ACTIONS(1073),
    [anon_sym_extcodecopy] = ACTIONS(1073),
    [anon_sym_returndatasize] = ACTIONS(1073),
    [anon_sym_returndatacopy] = ACTIONS(1073),
    [anon_sym_extcodehash] = ACTIONS(1073),
    [anon_sym_create] = ACTIONS(1073),
    [anon_sym_create2] = ACTIONS(1073),
    [anon_sym_call] = ACTIONS(1073),
    [anon_sym_callcode] = ACTIONS(1073),
    [anon_sym_delegatecall] = ACTIONS(1073),
    [anon_sym_staticcall] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_revert] = ACTIONS(1073),
    [anon_sym_selfdestruct] = ACTIONS(1073),
    [anon_sym_invalid] = ACTIONS(1073),
    [anon_sym_log0] = ACTIONS(1073),
    [anon_sym_log1] = ACTIONS(1073),
    [anon_sym_log2] = ACTIONS(1073),
    [anon_sym_log3] = ACTIONS(1073),
    [anon_sym_log4] = ACTIONS(1073),
    [anon_sym_chainid] = ACTIONS(1073),
    [anon_sym_origin] = ACTIONS(1073),
    [anon_sym_gasprice] = ACTIONS(1073),
    [anon_sym_blockhash] = ACTIONS(1073),
    [anon_sym_coinbase] = ACTIONS(1073),
    [anon_sym_timestamp] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1073),
    [anon_sym_difficulty] = ACTIONS(1073),
    [anon_sym_gaslimit] = ACTIONS(1073),
    [anon_sym_DQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1067),
    [sym_yul_leave] = ACTIONS(1067),
    [anon_sym_break] = ACTIONS(1067),
    [anon_sym_continue] = ACTIONS(1067),
    [sym_yul_decimal_number] = ACTIONS(1067),
    [sym_yul_hex_number] = ACTIONS(1069),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [anon_sym_let] = ACTIONS(1067),
    [anon_sym_COLON_EQ] = ACTIONS(1071),
    [anon_sym_if] = ACTIONS(1067),
    [anon_sym_switch] = ACTIONS(1067),
    [anon_sym_function] = ACTIONS(1067),
    [anon_sym_stop] = ACTIONS(1067),
    [anon_sym_add] = ACTIONS(1067),
    [anon_sym_sub] = ACTIONS(1067),
    [anon_sym_mul] = ACTIONS(1067),
    [anon_sym_div] = ACTIONS(1067),
    [anon_sym_sdiv] = ACTIONS(1067),
    [anon_sym_mod] = ACTIONS(1067),
    [anon_sym_smod] = ACTIONS(1067),
    [anon_sym_exp] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1067),
    [anon_sym_lt] = ACTIONS(1067),
    [anon_sym_gt] = ACTIONS(1067),
    [anon_sym_slt] = ACTIONS(1067),
    [anon_sym_sgt] = ACTIONS(1067),
    [anon_sym_eq] = ACTIONS(1067),
    [anon_sym_iszero] = ACTIONS(1067),
    [anon_sym_and] = ACTIONS(1067),
    [anon_sym_or] = ACTIONS(1067),
    [anon_sym_xor] = ACTIONS(1067),
    [anon_sym_byte] = ACTIONS(1067),
    [anon_sym_shl] = ACTIONS(1067),
    [anon_sym_shr] = ACTIONS(1067),
    [anon_sym_sar] = ACTIONS(1067),
    [anon_sym_addmod] = ACTIONS(1067),
    [anon_sym_mulmod] = ACTIONS(1067),
    [anon_sym_signextend] = ACTIONS(1067),
    [anon_sym_keccak256] = ACTIONS(1067),
    [anon_sym_pop] = ACTIONS(1067),
    [anon_sym_mload] = ACTIONS(1067),
    [anon_sym_mstore] = ACTIONS(1067),
    [anon_sym_mstore8] = ACTIONS(1067),
    [anon_sym_sload] = ACTIONS(1067),
    [anon_sym_sstore] = ACTIONS(1067),
    [anon_sym_msize] = ACTIONS(1067),
    [anon_sym_gas] = ACTIONS(1067),
    [anon_sym_address] = ACTIONS(1067),
    [anon_sym_balance] = ACTIONS(1067),
    [anon_sym_selfbalance] = ACTIONS(1067),
    [anon_sym_caller] = ACTIONS(1067),
    [anon_sym_callvalue] = ACTIONS(1067),
    [anon_sym_calldataload] = ACTIONS(1067),
    [anon_sym_calldatasize] = ACTIONS(1067),
    [anon_sym_calldatacopy] = ACTIONS(1067),
    [anon_sym_extcodesize] = ACTIONS(1067),
    [anon_sym_extcodecopy] = ACTIONS(1067),
    [anon_sym_returndatasize] = ACTIONS(1067),
    [anon_sym_returndatacopy] = ACTIONS(1067),
    [anon_sym_extcodehash] = ACTIONS(1067),
    [anon_sym_create] = ACTIONS(1067),
    [anon_sym_create2] = ACTIONS(1067),
    [anon_sym_call] = ACTIONS(1067),
    [anon_sym_callcode] = ACTIONS(1067),
    [anon_sym_delegatecall] = ACTIONS(1067),
    [anon_sym_staticcall] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_revert] = ACTIONS(1067),
    [anon_sym_selfdestruct] = ACTIONS(1067),
    [anon_sym_invalid] = ACTIONS(1067),
    [anon_sym_log0] = ACTIONS(1067),
    [anon_sym_log1] = ACTIONS(1067),
    [anon_sym_log2] = ACTIONS(1067),
    [anon_sym_log3] = ACTIONS(1067),
    [anon_sym_log4] = ACTIONS(1067),
    [anon_sym_chainid] = ACTIONS(1067),
    [anon_sym_origin] = ACTIONS(1067),
    [anon_sym_gasprice] = ACTIONS(1067),
    [anon_sym_blockhash] = ACTIONS(1067),
    [anon_sym_coinbase] = ACTIONS(1067),
    [anon_sym_timestamp] = ACTIONS(1067),
    [anon_sym_number] = ACTIONS(1067),
    [anon_sym_difficulty] = ACTIONS(1067),
    [anon_sym_gaslimit] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1079),
    [sym_yul_leave] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [sym_yul_decimal_number] = ACTIONS(1079),
    [sym_yul_hex_number] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(1079),
    [anon_sym_false] = ACTIONS(1079),
    [anon_sym_let] = ACTIONS(1079),
    [anon_sym_COLON_EQ] = ACTIONS(1083),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_switch] = ACTIONS(1079),
    [anon_sym_function] = ACTIONS(1079),
    [anon_sym_stop] = ACTIONS(1079),
    [anon_sym_add] = ACTIONS(1079),
    [anon_sym_sub] = ACTIONS(1079),
    [anon_sym_mul] = ACTIONS(1079),
    [anon_sym_div] = ACTIONS(1079),
    [anon_sym_sdiv] = ACTIONS(1079),
    [anon_sym_mod] = ACTIONS(1079),
    [anon_sym_smod] = ACTIONS(1079),
    [anon_sym_exp] = ACTIONS(1079),
    [anon_sym_not] = ACTIONS(1079),
    [anon_sym_lt] = ACTIONS(1079),
    [anon_sym_gt] = ACTIONS(1079),
    [anon_sym_slt] = ACTIONS(1079),
    [anon_sym_sgt] = ACTIONS(1079),
    [anon_sym_eq] = ACTIONS(1079),
    [anon_sym_iszero] = ACTIONS(1079),
    [anon_sym_and] = ACTIONS(1079),
    [anon_sym_or] = ACTIONS(1079),
    [anon_sym_xor] = ACTIONS(1079),
    [anon_sym_byte] = ACTIONS(1079),
    [anon_sym_shl] = ACTIONS(1079),
    [anon_sym_shr] = ACTIONS(1079),
    [anon_sym_sar] = ACTIONS(1079),
    [anon_sym_addmod] = ACTIONS(1079),
    [anon_sym_mulmod] = ACTIONS(1079),
    [anon_sym_signextend] = ACTIONS(1079),
    [anon_sym_keccak256] = ACTIONS(1079),
    [anon_sym_pop] = ACTIONS(1079),
    [anon_sym_mload] = ACTIONS(1079),
    [anon_sym_mstore] = ACTIONS(1079),
    [anon_sym_mstore8] = ACTIONS(1079),
    [anon_sym_sload] = ACTIONS(1079),
    [anon_sym_sstore] = ACTIONS(1079),
    [anon_sym_msize] = ACTIONS(1079),
    [anon_sym_gas] = ACTIONS(1079),
    [anon_sym_address] = ACTIONS(1079),
    [anon_sym_balance] = ACTIONS(1079),
    [anon_sym_selfbalance] = ACTIONS(1079),
    [anon_sym_caller] = ACTIONS(1079),
    [anon_sym_callvalue] = ACTIONS(1079),
    [anon_sym_calldataload] = ACTIONS(1079),
    [anon_sym_calldatasize] = ACTIONS(1079),
    [anon_sym_calldatacopy] = ACTIONS(1079),
    [anon_sym_extcodesize] = ACTIONS(1079),
    [anon_sym_extcodecopy] = ACTIONS(1079),
    [anon_sym_returndatasize] = ACTIONS(1079),
    [anon_sym_returndatacopy] = ACTIONS(1079),
    [anon_sym_extcodehash] = ACTIONS(1079),
    [anon_sym_create] = ACTIONS(1079),
    [anon_sym_create2] = ACTIONS(1079),
    [anon_sym_call] = ACTIONS(1079),
    [anon_sym_callcode] = ACTIONS(1079),
    [anon_sym_delegatecall] = ACTIONS(1079),
    [anon_sym_staticcall] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_revert] = ACTIONS(1079),
    [anon_sym_selfdestruct] = ACTIONS(1079),
    [anon_sym_invalid] = ACTIONS(1079),
    [anon_sym_log0] = ACTIONS(1079),
    [anon_sym_log1] = ACTIONS(1079),
    [anon_sym_log2] = ACTIONS(1079),
    [anon_sym_log3] = ACTIONS(1079),
    [anon_sym_log4] = ACTIONS(1079),
    [anon_sym_chainid] = ACTIONS(1079),
    [anon_sym_origin] = ACTIONS(1079),
    [anon_sym_gasprice] = ACTIONS(1079),
    [anon_sym_blockhash] = ACTIONS(1079),
    [anon_sym_coinbase] = ACTIONS(1079),
    [anon_sym_timestamp] = ACTIONS(1079),
    [anon_sym_number] = ACTIONS(1079),
    [anon_sym_difficulty] = ACTIONS(1079),
    [anon_sym_gaslimit] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_SQUOTE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1087),
    [anon_sym_for] = ACTIONS(1085),
    [sym_yul_leave] = ACTIONS(1085),
    [anon_sym_break] = ACTIONS(1085),
    [anon_sym_continue] = ACTIONS(1085),
    [sym_yul_decimal_number] = ACTIONS(1085),
    [sym_yul_hex_number] = ACTIONS(1087),
    [anon_sym_true] = ACTIONS(1085),
    [anon_sym_false] = ACTIONS(1085),
    [anon_sym_let] = ACTIONS(1085),
    [anon_sym_if] = ACTIONS(1085),
    [anon_sym_switch] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(1085),
    [anon_sym_stop] = ACTIONS(1085),
    [anon_sym_add] = ACTIONS(1085),
    [anon_sym_sub] = ACTIONS(1085),
    [anon_sym_mul] = ACTIONS(1085),
    [anon_sym_div] = ACTIONS(1085),
    [anon_sym_sdiv] = ACTIONS(1085),
    [anon_sym_mod] = ACTIONS(1085),
    [anon_sym_smod] = ACTIONS(1085),
    [anon_sym_exp] = ACTIONS(1085),
    [anon_sym_not] = ACTIONS(1085),
    [anon_sym_lt] = ACTIONS(1085),
    [anon_sym_gt] = ACTIONS(1085),
    [anon_sym_slt] = ACTIONS(1085),
    [anon_sym_sgt] = ACTIONS(1085),
    [anon_sym_eq] = ACTIONS(1085),
    [anon_sym_iszero] = ACTIONS(1085),
    [anon_sym_and] = ACTIONS(1085),
    [anon_sym_or] = ACTIONS(1085),
    [anon_sym_xor] = ACTIONS(1085),
    [anon_sym_byte] = ACTIONS(1085),
    [anon_sym_shl] = ACTIONS(1085),
    [anon_sym_shr] = ACTIONS(1085),
    [anon_sym_sar] = ACTIONS(1085),
    [anon_sym_addmod] = ACTIONS(1085),
    [anon_sym_mulmod] = ACTIONS(1085),
    [anon_sym_signextend] = ACTIONS(1085),
    [anon_sym_keccak256] = ACTIONS(1085),
    [anon_sym_pop] = ACTIONS(1085),
    [anon_sym_mload] = ACTIONS(1085),
    [anon_sym_mstore] = ACTIONS(1085),
    [anon_sym_mstore8] = ACTIONS(1085),
    [anon_sym_sload] = ACTIONS(1085),
    [anon_sym_sstore] = ACTIONS(1085),
    [anon_sym_msize] = ACTIONS(1085),
    [anon_sym_gas] = ACTIONS(1085),
    [anon_sym_address] = ACTIONS(1085),
    [anon_sym_balance] = ACTIONS(1085),
    [anon_sym_selfbalance] = ACTIONS(1085),
    [anon_sym_caller] = ACTIONS(1085),
    [anon_sym_callvalue] = ACTIONS(1085),
    [anon_sym_calldataload] = ACTIONS(1085),
    [anon_sym_calldatasize] = ACTIONS(1085),
    [anon_sym_calldatacopy] = ACTIONS(1085),
    [anon_sym_extcodesize] = ACTIONS(1085),
    [anon_sym_extcodecopy] = ACTIONS(1085),
    [anon_sym_returndatasize] = ACTIONS(1085),
    [anon_sym_returndatacopy] = ACTIONS(1085),
    [anon_sym_extcodehash] = ACTIONS(1085),
    [anon_sym_create] = ACTIONS(1085),
    [anon_sym_create2] = ACTIONS(1085),
    [anon_sym_call] = ACTIONS(1085),
    [anon_sym_callcode] = ACTIONS(1085),
    [anon_sym_delegatecall] = ACTIONS(1085),
    [anon_sym_staticcall] = ACTIONS(1085),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_revert] = ACTIONS(1085),
    [anon_sym_selfdestruct] = ACTIONS(1085),
    [anon_sym_invalid] = ACTIONS(1085),
    [anon_sym_log0] = ACTIONS(1085),
    [anon_sym_log1] = ACTIONS(1085),
    [anon_sym_log2] = ACTIONS(1085),
    [anon_sym_log3] = ACTIONS(1085),
    [anon_sym_log4] = ACTIONS(1085),
    [anon_sym_chainid] = ACTIONS(1085),
    [anon_sym_origin] = ACTIONS(1085),
    [anon_sym_gasprice] = ACTIONS(1085),
    [anon_sym_blockhash] = ACTIONS(1085),
    [anon_sym_coinbase] = ACTIONS(1085),
    [anon_sym_timestamp] = ACTIONS(1085),
    [anon_sym_number] = ACTIONS(1085),
    [anon_sym_difficulty] = ACTIONS(1085),
    [anon_sym_gaslimit] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1087),
    [anon_sym_SQUOTE] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1089),
    [sym_yul_leave] = ACTIONS(1089),
    [anon_sym_break] = ACTIONS(1089),
    [anon_sym_continue] = ACTIONS(1089),
    [sym_yul_decimal_number] = ACTIONS(1089),
    [sym_yul_hex_number] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1089),
    [anon_sym_false] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1089),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_stop] = ACTIONS(1089),
    [anon_sym_add] = ACTIONS(1089),
    [anon_sym_sub] = ACTIONS(1089),
    [anon_sym_mul] = ACTIONS(1089),
    [anon_sym_div] = ACTIONS(1089),
    [anon_sym_sdiv] = ACTIONS(1089),
    [anon_sym_mod] = ACTIONS(1089),
    [anon_sym_smod] = ACTIONS(1089),
    [anon_sym_exp] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1089),
    [anon_sym_lt] = ACTIONS(1089),
    [anon_sym_gt] = ACTIONS(1089),
    [anon_sym_slt] = ACTIONS(1089),
    [anon_sym_sgt] = ACTIONS(1089),
    [anon_sym_eq] = ACTIONS(1089),
    [anon_sym_iszero] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1089),
    [anon_sym_or] = ACTIONS(1089),
    [anon_sym_xor] = ACTIONS(1089),
    [anon_sym_byte] = ACTIONS(1089),
    [anon_sym_shl] = ACTIONS(1089),
    [anon_sym_shr] = ACTIONS(1089),
    [anon_sym_sar] = ACTIONS(1089),
    [anon_sym_addmod] = ACTIONS(1089),
    [anon_sym_mulmod] = ACTIONS(1089),
    [anon_sym_signextend] = ACTIONS(1089),
    [anon_sym_keccak256] = ACTIONS(1089),
    [anon_sym_pop] = ACTIONS(1089),
    [anon_sym_mload] = ACTIONS(1089),
    [anon_sym_mstore] = ACTIONS(1089),
    [anon_sym_mstore8] = ACTIONS(1089),
    [anon_sym_sload] = ACTIONS(1089),
    [anon_sym_sstore] = ACTIONS(1089),
    [anon_sym_msize] = ACTIONS(1089),
    [anon_sym_gas] = ACTIONS(1089),
    [anon_sym_address] = ACTIONS(1089),
    [anon_sym_balance] = ACTIONS(1089),
    [anon_sym_selfbalance] = ACTIONS(1089),
    [anon_sym_caller] = ACTIONS(1089),
    [anon_sym_callvalue] = ACTIONS(1089),
    [anon_sym_calldataload] = ACTIONS(1089),
    [anon_sym_calldatasize] = ACTIONS(1089),
    [anon_sym_calldatacopy] = ACTIONS(1089),
    [anon_sym_extcodesize] = ACTIONS(1089),
    [anon_sym_extcodecopy] = ACTIONS(1089),
    [anon_sym_returndatasize] = ACTIONS(1089),
    [anon_sym_returndatacopy] = ACTIONS(1089),
    [anon_sym_extcodehash] = ACTIONS(1089),
    [anon_sym_create] = ACTIONS(1089),
    [anon_sym_create2] = ACTIONS(1089),
    [anon_sym_call] = ACTIONS(1089),
    [anon_sym_callcode] = ACTIONS(1089),
    [anon_sym_delegatecall] = ACTIONS(1089),
    [anon_sym_staticcall] = ACTIONS(1089),
    [anon_sym_return] = ACTIONS(1089),
    [anon_sym_revert] = ACTIONS(1089),
    [anon_sym_selfdestruct] = ACTIONS(1089),
    [anon_sym_invalid] = ACTIONS(1089),
    [anon_sym_log0] = ACTIONS(1089),
    [anon_sym_log1] = ACTIONS(1089),
    [anon_sym_log2] = ACTIONS(1089),
    [anon_sym_log3] = ACTIONS(1089),
    [anon_sym_log4] = ACTIONS(1089),
    [anon_sym_chainid] = ACTIONS(1089),
    [anon_sym_origin] = ACTIONS(1089),
    [anon_sym_gasprice] = ACTIONS(1089),
    [anon_sym_blockhash] = ACTIONS(1089),
    [anon_sym_coinbase] = ACTIONS(1089),
    [anon_sym_timestamp] = ACTIONS(1089),
    [anon_sym_number] = ACTIONS(1089),
    [anon_sym_difficulty] = ACTIONS(1089),
    [anon_sym_gaslimit] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1093),
    [sym_yul_leave] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [sym_yul_decimal_number] = ACTIONS(1093),
    [sym_yul_hex_number] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1093),
    [anon_sym_false] = ACTIONS(1093),
    [anon_sym_let] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1093),
    [anon_sym_function] = ACTIONS(1093),
    [anon_sym_stop] = ACTIONS(1093),
    [anon_sym_add] = ACTIONS(1093),
    [anon_sym_sub] = ACTIONS(1093),
    [anon_sym_mul] = ACTIONS(1093),
    [anon_sym_div] = ACTIONS(1093),
    [anon_sym_sdiv] = ACTIONS(1093),
    [anon_sym_mod] = ACTIONS(1093),
    [anon_sym_smod] = ACTIONS(1093),
    [anon_sym_exp] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1093),
    [anon_sym_lt] = ACTIONS(1093),
    [anon_sym_gt] = ACTIONS(1093),
    [anon_sym_slt] = ACTIONS(1093),
    [anon_sym_sgt] = ACTIONS(1093),
    [anon_sym_eq] = ACTIONS(1093),
    [anon_sym_iszero] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1093),
    [anon_sym_or] = ACTIONS(1093),
    [anon_sym_xor] = ACTIONS(1093),
    [anon_sym_byte] = ACTIONS(1093),
    [anon_sym_shl] = ACTIONS(1093),
    [anon_sym_shr] = ACTIONS(1093),
    [anon_sym_sar] = ACTIONS(1093),
    [anon_sym_addmod] = ACTIONS(1093),
    [anon_sym_mulmod] = ACTIONS(1093),
    [anon_sym_signextend] = ACTIONS(1093),
    [anon_sym_keccak256] = ACTIONS(1093),
    [anon_sym_pop] = ACTIONS(1093),
    [anon_sym_mload] = ACTIONS(1093),
    [anon_sym_mstore] = ACTIONS(1093),
    [anon_sym_mstore8] = ACTIONS(1093),
    [anon_sym_sload] = ACTIONS(1093),
    [anon_sym_sstore] = ACTIONS(1093),
    [anon_sym_msize] = ACTIONS(1093),
    [anon_sym_gas] = ACTIONS(1093),
    [anon_sym_address] = ACTIONS(1093),
    [anon_sym_balance] = ACTIONS(1093),
    [anon_sym_selfbalance] = ACTIONS(1093),
    [anon_sym_caller] = ACTIONS(1093),
    [anon_sym_callvalue] = ACTIONS(1093),
    [anon_sym_calldataload] = ACTIONS(1093),
    [anon_sym_calldatasize] = ACTIONS(1093),
    [anon_sym_calldatacopy] = ACTIONS(1093),
    [anon_sym_extcodesize] = ACTIONS(1093),
    [anon_sym_extcodecopy] = ACTIONS(1093),
    [anon_sym_returndatasize] = ACTIONS(1093),
    [anon_sym_returndatacopy] = ACTIONS(1093),
    [anon_sym_extcodehash] = ACTIONS(1093),
    [anon_sym_create] = ACTIONS(1093),
    [anon_sym_create2] = ACTIONS(1093),
    [anon_sym_call] = ACTIONS(1093),
    [anon_sym_callcode] = ACTIONS(1093),
    [anon_sym_delegatecall] = ACTIONS(1093),
    [anon_sym_staticcall] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_revert] = ACTIONS(1093),
    [anon_sym_selfdestruct] = ACTIONS(1093),
    [anon_sym_invalid] = ACTIONS(1093),
    [anon_sym_log0] = ACTIONS(1093),
    [anon_sym_log1] = ACTIONS(1093),
    [anon_sym_log2] = ACTIONS(1093),
    [anon_sym_log3] = ACTIONS(1093),
    [anon_sym_log4] = ACTIONS(1093),
    [anon_sym_chainid] = ACTIONS(1093),
    [anon_sym_origin] = ACTIONS(1093),
    [anon_sym_gasprice] = ACTIONS(1093),
    [anon_sym_blockhash] = ACTIONS(1093),
    [anon_sym_coinbase] = ACTIONS(1093),
    [anon_sym_timestamp] = ACTIONS(1093),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_difficulty] = ACTIONS(1093),
    [anon_sym_gaslimit] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1097),
    [sym_yul_leave] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [sym_yul_decimal_number] = ACTIONS(1097),
    [sym_yul_hex_number] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(1097),
    [anon_sym_false] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_stop] = ACTIONS(1097),
    [anon_sym_add] = ACTIONS(1097),
    [anon_sym_sub] = ACTIONS(1097),
    [anon_sym_mul] = ACTIONS(1097),
    [anon_sym_div] = ACTIONS(1097),
    [anon_sym_sdiv] = ACTIONS(1097),
    [anon_sym_mod] = ACTIONS(1097),
    [anon_sym_smod] = ACTIONS(1097),
    [anon_sym_exp] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1097),
    [anon_sym_lt] = ACTIONS(1097),
    [anon_sym_gt] = ACTIONS(1097),
    [anon_sym_slt] = ACTIONS(1097),
    [anon_sym_sgt] = ACTIONS(1097),
    [anon_sym_eq] = ACTIONS(1097),
    [anon_sym_iszero] = ACTIONS(1097),
    [anon_sym_and] = ACTIONS(1097),
    [anon_sym_or] = ACTIONS(1097),
    [anon_sym_xor] = ACTIONS(1097),
    [anon_sym_byte] = ACTIONS(1097),
    [anon_sym_shl] = ACTIONS(1097),
    [anon_sym_shr] = ACTIONS(1097),
    [anon_sym_sar] = ACTIONS(1097),
    [anon_sym_addmod] = ACTIONS(1097),
    [anon_sym_mulmod] = ACTIONS(1097),
    [anon_sym_signextend] = ACTIONS(1097),
    [anon_sym_keccak256] = ACTIONS(1097),
    [anon_sym_pop] = ACTIONS(1097),
    [anon_sym_mload] = ACTIONS(1097),
    [anon_sym_mstore] = ACTIONS(1097),
    [anon_sym_mstore8] = ACTIONS(1097),
    [anon_sym_sload] = ACTIONS(1097),
    [anon_sym_sstore] = ACTIONS(1097),
    [anon_sym_msize] = ACTIONS(1097),
    [anon_sym_gas] = ACTIONS(1097),
    [anon_sym_address] = ACTIONS(1097),
    [anon_sym_balance] = ACTIONS(1097),
    [anon_sym_selfbalance] = ACTIONS(1097),
    [anon_sym_caller] = ACTIONS(1097),
    [anon_sym_callvalue] = ACTIONS(1097),
    [anon_sym_calldataload] = ACTIONS(1097),
    [anon_sym_calldatasize] = ACTIONS(1097),
    [anon_sym_calldatacopy] = ACTIONS(1097),
    [anon_sym_extcodesize] = ACTIONS(1097),
    [anon_sym_extcodecopy] = ACTIONS(1097),
    [anon_sym_returndatasize] = ACTIONS(1097),
    [anon_sym_returndatacopy] = ACTIONS(1097),
    [anon_sym_extcodehash] = ACTIONS(1097),
    [anon_sym_create] = ACTIONS(1097),
    [anon_sym_create2] = ACTIONS(1097),
    [anon_sym_call] = ACTIONS(1097),
    [anon_sym_callcode] = ACTIONS(1097),
    [anon_sym_delegatecall] = ACTIONS(1097),
    [anon_sym_staticcall] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_revert] = ACTIONS(1097),
    [anon_sym_selfdestruct] = ACTIONS(1097),
    [anon_sym_invalid] = ACTIONS(1097),
    [anon_sym_log0] = ACTIONS(1097),
    [anon_sym_log1] = ACTIONS(1097),
    [anon_sym_log2] = ACTIONS(1097),
    [anon_sym_log3] = ACTIONS(1097),
    [anon_sym_log4] = ACTIONS(1097),
    [anon_sym_chainid] = ACTIONS(1097),
    [anon_sym_origin] = ACTIONS(1097),
    [anon_sym_gasprice] = ACTIONS(1097),
    [anon_sym_blockhash] = ACTIONS(1097),
    [anon_sym_coinbase] = ACTIONS(1097),
    [anon_sym_timestamp] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_difficulty] = ACTIONS(1097),
    [anon_sym_gaslimit] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(973),
    [sym_yul_leave] = ACTIONS(973),
    [anon_sym_break] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [sym_yul_decimal_number] = ACTIONS(973),
    [sym_yul_hex_number] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_let] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(973),
    [anon_sym_stop] = ACTIONS(973),
    [anon_sym_add] = ACTIONS(973),
    [anon_sym_sub] = ACTIONS(973),
    [anon_sym_mul] = ACTIONS(973),
    [anon_sym_div] = ACTIONS(973),
    [anon_sym_sdiv] = ACTIONS(973),
    [anon_sym_mod] = ACTIONS(973),
    [anon_sym_smod] = ACTIONS(973),
    [anon_sym_exp] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(973),
    [anon_sym_lt] = ACTIONS(973),
    [anon_sym_gt] = ACTIONS(973),
    [anon_sym_slt] = ACTIONS(973),
    [anon_sym_sgt] = ACTIONS(973),
    [anon_sym_eq] = ACTIONS(973),
    [anon_sym_iszero] = ACTIONS(973),
    [anon_sym_and] = ACTIONS(973),
    [anon_sym_or] = ACTIONS(973),
    [anon_sym_xor] = ACTIONS(973),
    [anon_sym_byte] = ACTIONS(973),
    [anon_sym_shl] = ACTIONS(973),
    [anon_sym_shr] = ACTIONS(973),
    [anon_sym_sar] = ACTIONS(973),
    [anon_sym_addmod] = ACTIONS(973),
    [anon_sym_mulmod] = ACTIONS(973),
    [anon_sym_signextend] = ACTIONS(973),
    [anon_sym_keccak256] = ACTIONS(973),
    [anon_sym_pop] = ACTIONS(973),
    [anon_sym_mload] = ACTIONS(973),
    [anon_sym_mstore] = ACTIONS(973),
    [anon_sym_mstore8] = ACTIONS(973),
    [anon_sym_sload] = ACTIONS(973),
    [anon_sym_sstore] = ACTIONS(973),
    [anon_sym_msize] = ACTIONS(973),
    [anon_sym_gas] = ACTIONS(973),
    [anon_sym_address] = ACTIONS(973),
    [anon_sym_balance] = ACTIONS(973),
    [anon_sym_selfbalance] = ACTIONS(973),
    [anon_sym_caller] = ACTIONS(973),
    [anon_sym_callvalue] = ACTIONS(973),
    [anon_sym_calldataload] = ACTIONS(973),
    [anon_sym_calldatasize] = ACTIONS(973),
    [anon_sym_calldatacopy] = ACTIONS(973),
    [anon_sym_extcodesize] = ACTIONS(973),
    [anon_sym_extcodecopy] = ACTIONS(973),
    [anon_sym_returndatasize] = ACTIONS(973),
    [anon_sym_returndatacopy] = ACTIONS(973),
    [anon_sym_extcodehash] = ACTIONS(973),
    [anon_sym_create] = ACTIONS(973),
    [anon_sym_create2] = ACTIONS(973),
    [anon_sym_call] = ACTIONS(973),
    [anon_sym_callcode] = ACTIONS(973),
    [anon_sym_delegatecall] = ACTIONS(973),
    [anon_sym_staticcall] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_revert] = ACTIONS(973),
    [anon_sym_selfdestruct] = ACTIONS(973),
    [anon_sym_invalid] = ACTIONS(973),
    [anon_sym_log0] = ACTIONS(973),
    [anon_sym_log1] = ACTIONS(973),
    [anon_sym_log2] = ACTIONS(973),
    [anon_sym_log3] = ACTIONS(973),
    [anon_sym_log4] = ACTIONS(973),
    [anon_sym_chainid] = ACTIONS(973),
    [anon_sym_origin] = ACTIONS(973),
    [anon_sym_gasprice] = ACTIONS(973),
    [anon_sym_blockhash] = ACTIONS(973),
    [anon_sym_coinbase] = ACTIONS(973),
    [anon_sym_timestamp] = ACTIONS(973),
    [anon_sym_number] = ACTIONS(973),
    [anon_sym_difficulty] = ACTIONS(973),
    [anon_sym_gaslimit] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1104),
    [anon_sym_RBRACE] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1101),
    [sym_yul_leave] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [sym_yul_decimal_number] = ACTIONS(1101),
    [sym_yul_hex_number] = ACTIONS(1104),
    [anon_sym_true] = ACTIONS(1101),
    [anon_sym_false] = ACTIONS(1101),
    [anon_sym_let] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1101),
    [anon_sym_stop] = ACTIONS(1101),
    [anon_sym_add] = ACTIONS(1101),
    [anon_sym_sub] = ACTIONS(1101),
    [anon_sym_mul] = ACTIONS(1101),
    [anon_sym_div] = ACTIONS(1101),
    [anon_sym_sdiv] = ACTIONS(1101),
    [anon_sym_mod] = ACTIONS(1101),
    [anon_sym_smod] = ACTIONS(1101),
    [anon_sym_exp] = ACTIONS(1101),
    [anon_sym_not] = ACTIONS(1101),
    [anon_sym_lt] = ACTIONS(1101),
    [anon_sym_gt] = ACTIONS(1101),
    [anon_sym_slt] = ACTIONS(1101),
    [anon_sym_sgt] = ACTIONS(1101),
    [anon_sym_eq] = ACTIONS(1101),
    [anon_sym_iszero] = ACTIONS(1101),
    [anon_sym_and] = ACTIONS(1101),
    [anon_sym_or] = ACTIONS(1101),
    [anon_sym_xor] = ACTIONS(1101),
    [anon_sym_byte] = ACTIONS(1101),
    [anon_sym_shl] = ACTIONS(1101),
    [anon_sym_shr] = ACTIONS(1101),
    [anon_sym_sar] = ACTIONS(1101),
    [anon_sym_addmod] = ACTIONS(1101),
    [anon_sym_mulmod] = ACTIONS(1101),
    [anon_sym_signextend] = ACTIONS(1101),
    [anon_sym_keccak256] = ACTIONS(1101),
    [anon_sym_pop] = ACTIONS(1101),
    [anon_sym_mload] = ACTIONS(1101),
    [anon_sym_mstore] = ACTIONS(1101),
    [anon_sym_mstore8] = ACTIONS(1101),
    [anon_sym_sload] = ACTIONS(1101),
    [anon_sym_sstore] = ACTIONS(1101),
    [anon_sym_msize] = ACTIONS(1101),
    [anon_sym_gas] = ACTIONS(1101),
    [anon_sym_address] = ACTIONS(1101),
    [anon_sym_balance] = ACTIONS(1101),
    [anon_sym_selfbalance] = ACTIONS(1101),
    [anon_sym_caller] = ACTIONS(1101),
    [anon_sym_callvalue] = ACTIONS(1101),
    [anon_sym_calldataload] = ACTIONS(1101),
    [anon_sym_calldatasize] = ACTIONS(1101),
    [anon_sym_calldatacopy] = ACTIONS(1101),
    [anon_sym_extcodesize] = ACTIONS(1101),
    [anon_sym_extcodecopy] = ACTIONS(1101),
    [anon_sym_returndatasize] = ACTIONS(1101),
    [anon_sym_returndatacopy] = ACTIONS(1101),
    [anon_sym_extcodehash] = ACTIONS(1101),
    [anon_sym_create] = ACTIONS(1101),
    [anon_sym_create2] = ACTIONS(1101),
    [anon_sym_call] = ACTIONS(1101),
    [anon_sym_callcode] = ACTIONS(1101),
    [anon_sym_delegatecall] = ACTIONS(1101),
    [anon_sym_staticcall] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_revert] = ACTIONS(1101),
    [anon_sym_selfdestruct] = ACTIONS(1101),
    [anon_sym_invalid] = ACTIONS(1101),
    [anon_sym_log0] = ACTIONS(1101),
    [anon_sym_log1] = ACTIONS(1101),
    [anon_sym_log2] = ACTIONS(1101),
    [anon_sym_log3] = ACTIONS(1101),
    [anon_sym_log4] = ACTIONS(1101),
    [anon_sym_chainid] = ACTIONS(1101),
    [anon_sym_origin] = ACTIONS(1101),
    [anon_sym_gasprice] = ACTIONS(1101),
    [anon_sym_blockhash] = ACTIONS(1101),
    [anon_sym_coinbase] = ACTIONS(1101),
    [anon_sym_timestamp] = ACTIONS(1101),
    [anon_sym_number] = ACTIONS(1101),
    [anon_sym_difficulty] = ACTIONS(1101),
    [anon_sym_gaslimit] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1104),
    [anon_sym_SQUOTE] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_identifier] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1107),
    [sym_yul_leave] = ACTIONS(1107),
    [anon_sym_break] = ACTIONS(1107),
    [anon_sym_continue] = ACTIONS(1107),
    [sym_yul_decimal_number] = ACTIONS(1107),
    [sym_yul_hex_number] = ACTIONS(1109),
    [anon_sym_true] = ACTIONS(1107),
    [anon_sym_false] = ACTIONS(1107),
    [anon_sym_let] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1107),
    [anon_sym_switch] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(1107),
    [anon_sym_stop] = ACTIONS(1107),
    [anon_sym_add] = ACTIONS(1107),
    [anon_sym_sub] = ACTIONS(1107),
    [anon_sym_mul] = ACTIONS(1107),
    [anon_sym_div] = ACTIONS(1107),
    [anon_sym_sdiv] = ACTIONS(1107),
    [anon_sym_mod] = ACTIONS(1107),
    [anon_sym_smod] = ACTIONS(1107),
    [anon_sym_exp] = ACTIONS(1107),
    [anon_sym_not] = ACTIONS(1107),
    [anon_sym_lt] = ACTIONS(1107),
    [anon_sym_gt] = ACTIONS(1107),
    [anon_sym_slt] = ACTIONS(1107),
    [anon_sym_sgt] = ACTIONS(1107),
    [anon_sym_eq] = ACTIONS(1107),
    [anon_sym_iszero] = ACTIONS(1107),
    [anon_sym_and] = ACTIONS(1107),
    [anon_sym_or] = ACTIONS(1107),
    [anon_sym_xor] = ACTIONS(1107),
    [anon_sym_byte] = ACTIONS(1107),
    [anon_sym_shl] = ACTIONS(1107),
    [anon_sym_shr] = ACTIONS(1107),
    [anon_sym_sar] = ACTIONS(1107),
    [anon_sym_addmod] = ACTIONS(1107),
    [anon_sym_mulmod] = ACTIONS(1107),
    [anon_sym_signextend] = ACTIONS(1107),
    [anon_sym_keccak256] = ACTIONS(1107),
    [anon_sym_pop] = ACTIONS(1107),
    [anon_sym_mload] = ACTIONS(1107),
    [anon_sym_mstore] = ACTIONS(1107),
    [anon_sym_mstore8] = ACTIONS(1107),
    [anon_sym_sload] = ACTIONS(1107),
    [anon_sym_sstore] = ACTIONS(1107),
    [anon_sym_msize] = ACTIONS(1107),
    [anon_sym_gas] = ACTIONS(1107),
    [anon_sym_address] = ACTIONS(1107),
    [anon_sym_balance] = ACTIONS(1107),
    [anon_sym_selfbalance] = ACTIONS(1107),
    [anon_sym_caller] = ACTIONS(1107),
    [anon_sym_callvalue] = ACTIONS(1107),
    [anon_sym_calldataload] = ACTIONS(1107),
    [anon_sym_calldatasize] = ACTIONS(1107),
    [anon_sym_calldatacopy] = ACTIONS(1107),
    [anon_sym_extcodesize] = ACTIONS(1107),
    [anon_sym_extcodecopy] = ACTIONS(1107),
    [anon_sym_returndatasize] = ACTIONS(1107),
    [anon_sym_returndatacopy] = ACTIONS(1107),
    [anon_sym_extcodehash] = ACTIONS(1107),
    [anon_sym_create] = ACTIONS(1107),
    [anon_sym_create2] = ACTIONS(1107),
    [anon_sym_call] = ACTIONS(1107),
    [anon_sym_callcode] = ACTIONS(1107),
    [anon_sym_delegatecall] = ACTIONS(1107),
    [anon_sym_staticcall] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1107),
    [anon_sym_revert] = ACTIONS(1107),
    [anon_sym_selfdestruct] = ACTIONS(1107),
    [anon_sym_invalid] = ACTIONS(1107),
    [anon_sym_log0] = ACTIONS(1107),
    [anon_sym_log1] = ACTIONS(1107),
    [anon_sym_log2] = ACTIONS(1107),
    [anon_sym_log3] = ACTIONS(1107),
    [anon_sym_log4] = ACTIONS(1107),
    [anon_sym_chainid] = ACTIONS(1107),
    [anon_sym_origin] = ACTIONS(1107),
    [anon_sym_gasprice] = ACTIONS(1107),
    [anon_sym_blockhash] = ACTIONS(1107),
    [anon_sym_coinbase] = ACTIONS(1107),
    [anon_sym_timestamp] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1107),
    [anon_sym_difficulty] = ACTIONS(1107),
    [anon_sym_gaslimit] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1111),
    [sym_yul_leave] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1111),
    [anon_sym_continue] = ACTIONS(1111),
    [sym_yul_decimal_number] = ACTIONS(1111),
    [sym_yul_hex_number] = ACTIONS(1113),
    [anon_sym_true] = ACTIONS(1111),
    [anon_sym_false] = ACTIONS(1111),
    [anon_sym_let] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_switch] = ACTIONS(1111),
    [anon_sym_function] = ACTIONS(1111),
    [anon_sym_stop] = ACTIONS(1111),
    [anon_sym_add] = ACTIONS(1111),
    [anon_sym_sub] = ACTIONS(1111),
    [anon_sym_mul] = ACTIONS(1111),
    [anon_sym_div] = ACTIONS(1111),
    [anon_sym_sdiv] = ACTIONS(1111),
    [anon_sym_mod] = ACTIONS(1111),
    [anon_sym_smod] = ACTIONS(1111),
    [anon_sym_exp] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1111),
    [anon_sym_lt] = ACTIONS(1111),
    [anon_sym_gt] = ACTIONS(1111),
    [anon_sym_slt] = ACTIONS(1111),
    [anon_sym_sgt] = ACTIONS(1111),
    [anon_sym_eq] = ACTIONS(1111),
    [anon_sym_iszero] = ACTIONS(1111),
    [anon_sym_and] = ACTIONS(1111),
    [anon_sym_or] = ACTIONS(1111),
    [anon_sym_xor] = ACTIONS(1111),
    [anon_sym_byte] = ACTIONS(1111),
    [anon_sym_shl] = ACTIONS(1111),
    [anon_sym_shr] = ACTIONS(1111),
    [anon_sym_sar] = ACTIONS(1111),
    [anon_sym_addmod] = ACTIONS(1111),
    [anon_sym_mulmod] = ACTIONS(1111),
    [anon_sym_signextend] = ACTIONS(1111),
    [anon_sym_keccak256] = ACTIONS(1111),
    [anon_sym_pop] = ACTIONS(1111),
    [anon_sym_mload] = ACTIONS(1111),
    [anon_sym_mstore] = ACTIONS(1111),
    [anon_sym_mstore8] = ACTIONS(1111),
    [anon_sym_sload] = ACTIONS(1111),
    [anon_sym_sstore] = ACTIONS(1111),
    [anon_sym_msize] = ACTIONS(1111),
    [anon_sym_gas] = ACTIONS(1111),
    [anon_sym_address] = ACTIONS(1111),
    [anon_sym_balance] = ACTIONS(1111),
    [anon_sym_selfbalance] = ACTIONS(1111),
    [anon_sym_caller] = ACTIONS(1111),
    [anon_sym_callvalue] = ACTIONS(1111),
    [anon_sym_calldataload] = ACTIONS(1111),
    [anon_sym_calldatasize] = ACTIONS(1111),
    [anon_sym_calldatacopy] = ACTIONS(1111),
    [anon_sym_extcodesize] = ACTIONS(1111),
    [anon_sym_extcodecopy] = ACTIONS(1111),
    [anon_sym_returndatasize] = ACTIONS(1111),
    [anon_sym_returndatacopy] = ACTIONS(1111),
    [anon_sym_extcodehash] = ACTIONS(1111),
    [anon_sym_create] = ACTIONS(1111),
    [anon_sym_create2] = ACTIONS(1111),
    [anon_sym_call] = ACTIONS(1111),
    [anon_sym_callcode] = ACTIONS(1111),
    [anon_sym_delegatecall] = ACTIONS(1111),
    [anon_sym_staticcall] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_revert] = ACTIONS(1111),
    [anon_sym_selfdestruct] = ACTIONS(1111),
    [anon_sym_invalid] = ACTIONS(1111),
    [anon_sym_log0] = ACTIONS(1111),
    [anon_sym_log1] = ACTIONS(1111),
    [anon_sym_log2] = ACTIONS(1111),
    [anon_sym_log3] = ACTIONS(1111),
    [anon_sym_log4] = ACTIONS(1111),
    [anon_sym_chainid] = ACTIONS(1111),
    [anon_sym_origin] = ACTIONS(1111),
    [anon_sym_gasprice] = ACTIONS(1111),
    [anon_sym_blockhash] = ACTIONS(1111),
    [anon_sym_coinbase] = ACTIONS(1111),
    [anon_sym_timestamp] = ACTIONS(1111),
    [anon_sym_number] = ACTIONS(1111),
    [anon_sym_difficulty] = ACTIONS(1111),
    [anon_sym_gaslimit] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1115),
    [sym_yul_leave] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [sym_yul_decimal_number] = ACTIONS(1115),
    [sym_yul_hex_number] = ACTIONS(1117),
    [anon_sym_true] = ACTIONS(1115),
    [anon_sym_false] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_stop] = ACTIONS(1115),
    [anon_sym_add] = ACTIONS(1115),
    [anon_sym_sub] = ACTIONS(1115),
    [anon_sym_mul] = ACTIONS(1115),
    [anon_sym_div] = ACTIONS(1115),
    [anon_sym_sdiv] = ACTIONS(1115),
    [anon_sym_mod] = ACTIONS(1115),
    [anon_sym_smod] = ACTIONS(1115),
    [anon_sym_exp] = ACTIONS(1115),
    [anon_sym_not] = ACTIONS(1115),
    [anon_sym_lt] = ACTIONS(1115),
    [anon_sym_gt] = ACTIONS(1115),
    [anon_sym_slt] = ACTIONS(1115),
    [anon_sym_sgt] = ACTIONS(1115),
    [anon_sym_eq] = ACTIONS(1115),
    [anon_sym_iszero] = ACTIONS(1115),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_or] = ACTIONS(1115),
    [anon_sym_xor] = ACTIONS(1115),
    [anon_sym_byte] = ACTIONS(1115),
    [anon_sym_shl] = ACTIONS(1115),
    [anon_sym_shr] = ACTIONS(1115),
    [anon_sym_sar] = ACTIONS(1115),
    [anon_sym_addmod] = ACTIONS(1115),
    [anon_sym_mulmod] = ACTIONS(1115),
    [anon_sym_signextend] = ACTIONS(1115),
    [anon_sym_keccak256] = ACTIONS(1115),
    [anon_sym_pop] = ACTIONS(1115),
    [anon_sym_mload] = ACTIONS(1115),
    [anon_sym_mstore] = ACTIONS(1115),
    [anon_sym_mstore8] = ACTIONS(1115),
    [anon_sym_sload] = ACTIONS(1115),
    [anon_sym_sstore] = ACTIONS(1115),
    [anon_sym_msize] = ACTIONS(1115),
    [anon_sym_gas] = ACTIONS(1115),
    [anon_sym_address] = ACTIONS(1115),
    [anon_sym_balance] = ACTIONS(1115),
    [anon_sym_selfbalance] = ACTIONS(1115),
    [anon_sym_caller] = ACTIONS(1115),
    [anon_sym_callvalue] = ACTIONS(1115),
    [anon_sym_calldataload] = ACTIONS(1115),
    [anon_sym_calldatasize] = ACTIONS(1115),
    [anon_sym_calldatacopy] = ACTIONS(1115),
    [anon_sym_extcodesize] = ACTIONS(1115),
    [anon_sym_extcodecopy] = ACTIONS(1115),
    [anon_sym_returndatasize] = ACTIONS(1115),
    [anon_sym_returndatacopy] = ACTIONS(1115),
    [anon_sym_extcodehash] = ACTIONS(1115),
    [anon_sym_create] = ACTIONS(1115),
    [anon_sym_create2] = ACTIONS(1115),
    [anon_sym_call] = ACTIONS(1115),
    [anon_sym_callcode] = ACTIONS(1115),
    [anon_sym_delegatecall] = ACTIONS(1115),
    [anon_sym_staticcall] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_revert] = ACTIONS(1115),
    [anon_sym_selfdestruct] = ACTIONS(1115),
    [anon_sym_invalid] = ACTIONS(1115),
    [anon_sym_log0] = ACTIONS(1115),
    [anon_sym_log1] = ACTIONS(1115),
    [anon_sym_log2] = ACTIONS(1115),
    [anon_sym_log3] = ACTIONS(1115),
    [anon_sym_log4] = ACTIONS(1115),
    [anon_sym_chainid] = ACTIONS(1115),
    [anon_sym_origin] = ACTIONS(1115),
    [anon_sym_gasprice] = ACTIONS(1115),
    [anon_sym_blockhash] = ACTIONS(1115),
    [anon_sym_coinbase] = ACTIONS(1115),
    [anon_sym_timestamp] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_difficulty] = ACTIONS(1115),
    [anon_sym_gaslimit] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_for] = ACTIONS(1119),
    [sym_yul_leave] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1119),
    [anon_sym_continue] = ACTIONS(1119),
    [sym_yul_decimal_number] = ACTIONS(1119),
    [sym_yul_hex_number] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_switch] = ACTIONS(1119),
    [anon_sym_function] = ACTIONS(1119),
    [anon_sym_stop] = ACTIONS(1119),
    [anon_sym_add] = ACTIONS(1119),
    [anon_sym_sub] = ACTIONS(1119),
    [anon_sym_mul] = ACTIONS(1119),
    [anon_sym_div] = ACTIONS(1119),
    [anon_sym_sdiv] = ACTIONS(1119),
    [anon_sym_mod] = ACTIONS(1119),
    [anon_sym_smod] = ACTIONS(1119),
    [anon_sym_exp] = ACTIONS(1119),
    [anon_sym_not] = ACTIONS(1119),
    [anon_sym_lt] = ACTIONS(1119),
    [anon_sym_gt] = ACTIONS(1119),
    [anon_sym_slt] = ACTIONS(1119),
    [anon_sym_sgt] = ACTIONS(1119),
    [anon_sym_eq] = ACTIONS(1119),
    [anon_sym_iszero] = ACTIONS(1119),
    [anon_sym_and] = ACTIONS(1119),
    [anon_sym_or] = ACTIONS(1119),
    [anon_sym_xor] = ACTIONS(1119),
    [anon_sym_byte] = ACTIONS(1119),
    [anon_sym_shl] = ACTIONS(1119),
    [anon_sym_shr] = ACTIONS(1119),
    [anon_sym_sar] = ACTIONS(1119),
    [anon_sym_addmod] = ACTIONS(1119),
    [anon_sym_mulmod] = ACTIONS(1119),
    [anon_sym_signextend] = ACTIONS(1119),
    [anon_sym_keccak256] = ACTIONS(1119),
    [anon_sym_pop] = ACTIONS(1119),
    [anon_sym_mload] = ACTIONS(1119),
    [anon_sym_mstore] = ACTIONS(1119),
    [anon_sym_mstore8] = ACTIONS(1119),
    [anon_sym_sload] = ACTIONS(1119),
    [anon_sym_sstore] = ACTIONS(1119),
    [anon_sym_msize] = ACTIONS(1119),
    [anon_sym_gas] = ACTIONS(1119),
    [anon_sym_address] = ACTIONS(1119),
    [anon_sym_balance] = ACTIONS(1119),
    [anon_sym_selfbalance] = ACTIONS(1119),
    [anon_sym_caller] = ACTIONS(1119),
    [anon_sym_callvalue] = ACTIONS(1119),
    [anon_sym_calldataload] = ACTIONS(1119),
    [anon_sym_calldatasize] = ACTIONS(1119),
    [anon_sym_calldatacopy] = ACTIONS(1119),
    [anon_sym_extcodesize] = ACTIONS(1119),
    [anon_sym_extcodecopy] = ACTIONS(1119),
    [anon_sym_returndatasize] = ACTIONS(1119),
    [anon_sym_returndatacopy] = ACTIONS(1119),
    [anon_sym_extcodehash] = ACTIONS(1119),
    [anon_sym_create] = ACTIONS(1119),
    [anon_sym_create2] = ACTIONS(1119),
    [anon_sym_call] = ACTIONS(1119),
    [anon_sym_callcode] = ACTIONS(1119),
    [anon_sym_delegatecall] = ACTIONS(1119),
    [anon_sym_staticcall] = ACTIONS(1119),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_revert] = ACTIONS(1119),
    [anon_sym_selfdestruct] = ACTIONS(1119),
    [anon_sym_invalid] = ACTIONS(1119),
    [anon_sym_log0] = ACTIONS(1119),
    [anon_sym_log1] = ACTIONS(1119),
    [anon_sym_log2] = ACTIONS(1119),
    [anon_sym_log3] = ACTIONS(1119),
    [anon_sym_log4] = ACTIONS(1119),
    [anon_sym_chainid] = ACTIONS(1119),
    [anon_sym_origin] = ACTIONS(1119),
    [anon_sym_gasprice] = ACTIONS(1119),
    [anon_sym_blockhash] = ACTIONS(1119),
    [anon_sym_coinbase] = ACTIONS(1119),
    [anon_sym_timestamp] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_difficulty] = ACTIONS(1119),
    [anon_sym_gaslimit] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1121),
    [anon_sym_SQUOTE] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(724),
    [sym_yul_path] = STATE(724),
    [sym__yul_literal] = STATE(724),
    [sym_yul_string_literal] = STATE(724),
    [sym_yul_boolean] = STATE(724),
    [sym_yul_function_call] = STATE(724),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1125),
    [sym_yul_decimal_number] = ACTIONS(1127),
    [sym_yul_hex_number] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1131),
    [sym_yul_leave] = ACTIONS(1131),
    [anon_sym_break] = ACTIONS(1131),
    [anon_sym_continue] = ACTIONS(1131),
    [sym_yul_decimal_number] = ACTIONS(1131),
    [sym_yul_hex_number] = ACTIONS(1133),
    [anon_sym_true] = ACTIONS(1131),
    [anon_sym_false] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1131),
    [anon_sym_switch] = ACTIONS(1131),
    [anon_sym_function] = ACTIONS(1131),
    [anon_sym_stop] = ACTIONS(1131),
    [anon_sym_add] = ACTIONS(1131),
    [anon_sym_sub] = ACTIONS(1131),
    [anon_sym_mul] = ACTIONS(1131),
    [anon_sym_div] = ACTIONS(1131),
    [anon_sym_sdiv] = ACTIONS(1131),
    [anon_sym_mod] = ACTIONS(1131),
    [anon_sym_smod] = ACTIONS(1131),
    [anon_sym_exp] = ACTIONS(1131),
    [anon_sym_not] = ACTIONS(1131),
    [anon_sym_lt] = ACTIONS(1131),
    [anon_sym_gt] = ACTIONS(1131),
    [anon_sym_slt] = ACTIONS(1131),
    [anon_sym_sgt] = ACTIONS(1131),
    [anon_sym_eq] = ACTIONS(1131),
    [anon_sym_iszero] = ACTIONS(1131),
    [anon_sym_and] = ACTIONS(1131),
    [anon_sym_or] = ACTIONS(1131),
    [anon_sym_xor] = ACTIONS(1131),
    [anon_sym_byte] = ACTIONS(1131),
    [anon_sym_shl] = ACTIONS(1131),
    [anon_sym_shr] = ACTIONS(1131),
    [anon_sym_sar] = ACTIONS(1131),
    [anon_sym_addmod] = ACTIONS(1131),
    [anon_sym_mulmod] = ACTIONS(1131),
    [anon_sym_signextend] = ACTIONS(1131),
    [anon_sym_keccak256] = ACTIONS(1131),
    [anon_sym_pop] = ACTIONS(1131),
    [anon_sym_mload] = ACTIONS(1131),
    [anon_sym_mstore] = ACTIONS(1131),
    [anon_sym_mstore8] = ACTIONS(1131),
    [anon_sym_sload] = ACTIONS(1131),
    [anon_sym_sstore] = ACTIONS(1131),
    [anon_sym_msize] = ACTIONS(1131),
    [anon_sym_gas] = ACTIONS(1131),
    [anon_sym_address] = ACTIONS(1131),
    [anon_sym_balance] = ACTIONS(1131),
    [anon_sym_selfbalance] = ACTIONS(1131),
    [anon_sym_caller] = ACTIONS(1131),
    [anon_sym_callvalue] = ACTIONS(1131),
    [anon_sym_calldataload] = ACTIONS(1131),
    [anon_sym_calldatasize] = ACTIONS(1131),
    [anon_sym_calldatacopy] = ACTIONS(1131),
    [anon_sym_extcodesize] = ACTIONS(1131),
    [anon_sym_extcodecopy] = ACTIONS(1131),
    [anon_sym_returndatasize] = ACTIONS(1131),
    [anon_sym_returndatacopy] = ACTIONS(1131),
    [anon_sym_extcodehash] = ACTIONS(1131),
    [anon_sym_create] = ACTIONS(1131),
    [anon_sym_create2] = ACTIONS(1131),
    [anon_sym_call] = ACTIONS(1131),
    [anon_sym_callcode] = ACTIONS(1131),
    [anon_sym_delegatecall] = ACTIONS(1131),
    [anon_sym_staticcall] = ACTIONS(1131),
    [anon_sym_return] = ACTIONS(1131),
    [anon_sym_revert] = ACTIONS(1131),
    [anon_sym_selfdestruct] = ACTIONS(1131),
    [anon_sym_invalid] = ACTIONS(1131),
    [anon_sym_log0] = ACTIONS(1131),
    [anon_sym_log1] = ACTIONS(1131),
    [anon_sym_log2] = ACTIONS(1131),
    [anon_sym_log3] = ACTIONS(1131),
    [anon_sym_log4] = ACTIONS(1131),
    [anon_sym_chainid] = ACTIONS(1131),
    [anon_sym_origin] = ACTIONS(1131),
    [anon_sym_gasprice] = ACTIONS(1131),
    [anon_sym_blockhash] = ACTIONS(1131),
    [anon_sym_coinbase] = ACTIONS(1131),
    [anon_sym_timestamp] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_difficulty] = ACTIONS(1131),
    [anon_sym_gaslimit] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_RBRACE] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1135),
    [sym_yul_leave] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [sym_yul_decimal_number] = ACTIONS(1135),
    [sym_yul_hex_number] = ACTIONS(1137),
    [anon_sym_true] = ACTIONS(1135),
    [anon_sym_false] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_stop] = ACTIONS(1135),
    [anon_sym_add] = ACTIONS(1135),
    [anon_sym_sub] = ACTIONS(1135),
    [anon_sym_mul] = ACTIONS(1135),
    [anon_sym_div] = ACTIONS(1135),
    [anon_sym_sdiv] = ACTIONS(1135),
    [anon_sym_mod] = ACTIONS(1135),
    [anon_sym_smod] = ACTIONS(1135),
    [anon_sym_exp] = ACTIONS(1135),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_lt] = ACTIONS(1135),
    [anon_sym_gt] = ACTIONS(1135),
    [anon_sym_slt] = ACTIONS(1135),
    [anon_sym_sgt] = ACTIONS(1135),
    [anon_sym_eq] = ACTIONS(1135),
    [anon_sym_iszero] = ACTIONS(1135),
    [anon_sym_and] = ACTIONS(1135),
    [anon_sym_or] = ACTIONS(1135),
    [anon_sym_xor] = ACTIONS(1135),
    [anon_sym_byte] = ACTIONS(1135),
    [anon_sym_shl] = ACTIONS(1135),
    [anon_sym_shr] = ACTIONS(1135),
    [anon_sym_sar] = ACTIONS(1135),
    [anon_sym_addmod] = ACTIONS(1135),
    [anon_sym_mulmod] = ACTIONS(1135),
    [anon_sym_signextend] = ACTIONS(1135),
    [anon_sym_keccak256] = ACTIONS(1135),
    [anon_sym_pop] = ACTIONS(1135),
    [anon_sym_mload] = ACTIONS(1135),
    [anon_sym_mstore] = ACTIONS(1135),
    [anon_sym_mstore8] = ACTIONS(1135),
    [anon_sym_sload] = ACTIONS(1135),
    [anon_sym_sstore] = ACTIONS(1135),
    [anon_sym_msize] = ACTIONS(1135),
    [anon_sym_gas] = ACTIONS(1135),
    [anon_sym_address] = ACTIONS(1135),
    [anon_sym_balance] = ACTIONS(1135),
    [anon_sym_selfbalance] = ACTIONS(1135),
    [anon_sym_caller] = ACTIONS(1135),
    [anon_sym_callvalue] = ACTIONS(1135),
    [anon_sym_calldataload] = ACTIONS(1135),
    [anon_sym_calldatasize] = ACTIONS(1135),
    [anon_sym_calldatacopy] = ACTIONS(1135),
    [anon_sym_extcodesize] = ACTIONS(1135),
    [anon_sym_extcodecopy] = ACTIONS(1135),
    [anon_sym_returndatasize] = ACTIONS(1135),
    [anon_sym_returndatacopy] = ACTIONS(1135),
    [anon_sym_extcodehash] = ACTIONS(1135),
    [anon_sym_create] = ACTIONS(1135),
    [anon_sym_create2] = ACTIONS(1135),
    [anon_sym_call] = ACTIONS(1135),
    [anon_sym_callcode] = ACTIONS(1135),
    [anon_sym_delegatecall] = ACTIONS(1135),
    [anon_sym_staticcall] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_revert] = ACTIONS(1135),
    [anon_sym_selfdestruct] = ACTIONS(1135),
    [anon_sym_invalid] = ACTIONS(1135),
    [anon_sym_log0] = ACTIONS(1135),
    [anon_sym_log1] = ACTIONS(1135),
    [anon_sym_log2] = ACTIONS(1135),
    [anon_sym_log3] = ACTIONS(1135),
    [anon_sym_log4] = ACTIONS(1135),
    [anon_sym_chainid] = ACTIONS(1135),
    [anon_sym_origin] = ACTIONS(1135),
    [anon_sym_gasprice] = ACTIONS(1135),
    [anon_sym_blockhash] = ACTIONS(1135),
    [anon_sym_coinbase] = ACTIONS(1135),
    [anon_sym_timestamp] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_difficulty] = ACTIONS(1135),
    [anon_sym_gaslimit] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1137),
    [anon_sym_SQUOTE] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1139),
    [sym_yul_leave] = ACTIONS(1139),
    [anon_sym_break] = ACTIONS(1139),
    [anon_sym_continue] = ACTIONS(1139),
    [sym_yul_decimal_number] = ACTIONS(1139),
    [sym_yul_hex_number] = ACTIONS(1141),
    [anon_sym_true] = ACTIONS(1139),
    [anon_sym_false] = ACTIONS(1139),
    [anon_sym_let] = ACTIONS(1139),
    [anon_sym_if] = ACTIONS(1139),
    [anon_sym_switch] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(1139),
    [anon_sym_stop] = ACTIONS(1139),
    [anon_sym_add] = ACTIONS(1139),
    [anon_sym_sub] = ACTIONS(1139),
    [anon_sym_mul] = ACTIONS(1139),
    [anon_sym_div] = ACTIONS(1139),
    [anon_sym_sdiv] = ACTIONS(1139),
    [anon_sym_mod] = ACTIONS(1139),
    [anon_sym_smod] = ACTIONS(1139),
    [anon_sym_exp] = ACTIONS(1139),
    [anon_sym_not] = ACTIONS(1139),
    [anon_sym_lt] = ACTIONS(1139),
    [anon_sym_gt] = ACTIONS(1139),
    [anon_sym_slt] = ACTIONS(1139),
    [anon_sym_sgt] = ACTIONS(1139),
    [anon_sym_eq] = ACTIONS(1139),
    [anon_sym_iszero] = ACTIONS(1139),
    [anon_sym_and] = ACTIONS(1139),
    [anon_sym_or] = ACTIONS(1139),
    [anon_sym_xor] = ACTIONS(1139),
    [anon_sym_byte] = ACTIONS(1139),
    [anon_sym_shl] = ACTIONS(1139),
    [anon_sym_shr] = ACTIONS(1139),
    [anon_sym_sar] = ACTIONS(1139),
    [anon_sym_addmod] = ACTIONS(1139),
    [anon_sym_mulmod] = ACTIONS(1139),
    [anon_sym_signextend] = ACTIONS(1139),
    [anon_sym_keccak256] = ACTIONS(1139),
    [anon_sym_pop] = ACTIONS(1139),
    [anon_sym_mload] = ACTIONS(1139),
    [anon_sym_mstore] = ACTIONS(1139),
    [anon_sym_mstore8] = ACTIONS(1139),
    [anon_sym_sload] = ACTIONS(1139),
    [anon_sym_sstore] = ACTIONS(1139),
    [anon_sym_msize] = ACTIONS(1139),
    [anon_sym_gas] = ACTIONS(1139),
    [anon_sym_address] = ACTIONS(1139),
    [anon_sym_balance] = ACTIONS(1139),
    [anon_sym_selfbalance] = ACTIONS(1139),
    [anon_sym_caller] = ACTIONS(1139),
    [anon_sym_callvalue] = ACTIONS(1139),
    [anon_sym_calldataload] = ACTIONS(1139),
    [anon_sym_calldatasize] = ACTIONS(1139),
    [anon_sym_calldatacopy] = ACTIONS(1139),
    [anon_sym_extcodesize] = ACTIONS(1139),
    [anon_sym_extcodecopy] = ACTIONS(1139),
    [anon_sym_returndatasize] = ACTIONS(1139),
    [anon_sym_returndatacopy] = ACTIONS(1139),
    [anon_sym_extcodehash] = ACTIONS(1139),
    [anon_sym_create] = ACTIONS(1139),
    [anon_sym_create2] = ACTIONS(1139),
    [anon_sym_call] = ACTIONS(1139),
    [anon_sym_callcode] = ACTIONS(1139),
    [anon_sym_delegatecall] = ACTIONS(1139),
    [anon_sym_staticcall] = ACTIONS(1139),
    [anon_sym_return] = ACTIONS(1139),
    [anon_sym_revert] = ACTIONS(1139),
    [anon_sym_selfdestruct] = ACTIONS(1139),
    [anon_sym_invalid] = ACTIONS(1139),
    [anon_sym_log0] = ACTIONS(1139),
    [anon_sym_log1] = ACTIONS(1139),
    [anon_sym_log2] = ACTIONS(1139),
    [anon_sym_log3] = ACTIONS(1139),
    [anon_sym_log4] = ACTIONS(1139),
    [anon_sym_chainid] = ACTIONS(1139),
    [anon_sym_origin] = ACTIONS(1139),
    [anon_sym_gasprice] = ACTIONS(1139),
    [anon_sym_blockhash] = ACTIONS(1139),
    [anon_sym_coinbase] = ACTIONS(1139),
    [anon_sym_timestamp] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1139),
    [anon_sym_difficulty] = ACTIONS(1139),
    [anon_sym_gaslimit] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1143),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1143),
    [sym_yul_leave] = ACTIONS(1143),
    [anon_sym_break] = ACTIONS(1143),
    [anon_sym_continue] = ACTIONS(1143),
    [sym_yul_decimal_number] = ACTIONS(1143),
    [sym_yul_hex_number] = ACTIONS(1145),
    [anon_sym_true] = ACTIONS(1143),
    [anon_sym_false] = ACTIONS(1143),
    [anon_sym_let] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1143),
    [anon_sym_switch] = ACTIONS(1143),
    [anon_sym_function] = ACTIONS(1143),
    [anon_sym_stop] = ACTIONS(1143),
    [anon_sym_add] = ACTIONS(1143),
    [anon_sym_sub] = ACTIONS(1143),
    [anon_sym_mul] = ACTIONS(1143),
    [anon_sym_div] = ACTIONS(1143),
    [anon_sym_sdiv] = ACTIONS(1143),
    [anon_sym_mod] = ACTIONS(1143),
    [anon_sym_smod] = ACTIONS(1143),
    [anon_sym_exp] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1143),
    [anon_sym_lt] = ACTIONS(1143),
    [anon_sym_gt] = ACTIONS(1143),
    [anon_sym_slt] = ACTIONS(1143),
    [anon_sym_sgt] = ACTIONS(1143),
    [anon_sym_eq] = ACTIONS(1143),
    [anon_sym_iszero] = ACTIONS(1143),
    [anon_sym_and] = ACTIONS(1143),
    [anon_sym_or] = ACTIONS(1143),
    [anon_sym_xor] = ACTIONS(1143),
    [anon_sym_byte] = ACTIONS(1143),
    [anon_sym_shl] = ACTIONS(1143),
    [anon_sym_shr] = ACTIONS(1143),
    [anon_sym_sar] = ACTIONS(1143),
    [anon_sym_addmod] = ACTIONS(1143),
    [anon_sym_mulmod] = ACTIONS(1143),
    [anon_sym_signextend] = ACTIONS(1143),
    [anon_sym_keccak256] = ACTIONS(1143),
    [anon_sym_pop] = ACTIONS(1143),
    [anon_sym_mload] = ACTIONS(1143),
    [anon_sym_mstore] = ACTIONS(1143),
    [anon_sym_mstore8] = ACTIONS(1143),
    [anon_sym_sload] = ACTIONS(1143),
    [anon_sym_sstore] = ACTIONS(1143),
    [anon_sym_msize] = ACTIONS(1143),
    [anon_sym_gas] = ACTIONS(1143),
    [anon_sym_address] = ACTIONS(1143),
    [anon_sym_balance] = ACTIONS(1143),
    [anon_sym_selfbalance] = ACTIONS(1143),
    [anon_sym_caller] = ACTIONS(1143),
    [anon_sym_callvalue] = ACTIONS(1143),
    [anon_sym_calldataload] = ACTIONS(1143),
    [anon_sym_calldatasize] = ACTIONS(1143),
    [anon_sym_calldatacopy] = ACTIONS(1143),
    [anon_sym_extcodesize] = ACTIONS(1143),
    [anon_sym_extcodecopy] = ACTIONS(1143),
    [anon_sym_returndatasize] = ACTIONS(1143),
    [anon_sym_returndatacopy] = ACTIONS(1143),
    [anon_sym_extcodehash] = ACTIONS(1143),
    [anon_sym_create] = ACTIONS(1143),
    [anon_sym_create2] = ACTIONS(1143),
    [anon_sym_call] = ACTIONS(1143),
    [anon_sym_callcode] = ACTIONS(1143),
    [anon_sym_delegatecall] = ACTIONS(1143),
    [anon_sym_staticcall] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1143),
    [anon_sym_revert] = ACTIONS(1143),
    [anon_sym_selfdestruct] = ACTIONS(1143),
    [anon_sym_invalid] = ACTIONS(1143),
    [anon_sym_log0] = ACTIONS(1143),
    [anon_sym_log1] = ACTIONS(1143),
    [anon_sym_log2] = ACTIONS(1143),
    [anon_sym_log3] = ACTIONS(1143),
    [anon_sym_log4] = ACTIONS(1143),
    [anon_sym_chainid] = ACTIONS(1143),
    [anon_sym_origin] = ACTIONS(1143),
    [anon_sym_gasprice] = ACTIONS(1143),
    [anon_sym_blockhash] = ACTIONS(1143),
    [anon_sym_coinbase] = ACTIONS(1143),
    [anon_sym_timestamp] = ACTIONS(1143),
    [anon_sym_number] = ACTIONS(1143),
    [anon_sym_difficulty] = ACTIONS(1143),
    [anon_sym_gaslimit] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(642),
    [sym_yul_path] = STATE(642),
    [sym__yul_literal] = STATE(642),
    [sym_yul_string_literal] = STATE(642),
    [sym_yul_boolean] = STATE(642),
    [sym_yul_function_call] = STATE(642),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1147),
    [sym_yul_decimal_number] = ACTIONS(1149),
    [sym_yul_hex_number] = ACTIONS(1151),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_identifier] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1153),
    [sym_yul_leave] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [sym_yul_decimal_number] = ACTIONS(1153),
    [sym_yul_hex_number] = ACTIONS(1155),
    [anon_sym_true] = ACTIONS(1153),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_let] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_function] = ACTIONS(1153),
    [anon_sym_stop] = ACTIONS(1153),
    [anon_sym_add] = ACTIONS(1153),
    [anon_sym_sub] = ACTIONS(1153),
    [anon_sym_mul] = ACTIONS(1153),
    [anon_sym_div] = ACTIONS(1153),
    [anon_sym_sdiv] = ACTIONS(1153),
    [anon_sym_mod] = ACTIONS(1153),
    [anon_sym_smod] = ACTIONS(1153),
    [anon_sym_exp] = ACTIONS(1153),
    [anon_sym_not] = ACTIONS(1153),
    [anon_sym_lt] = ACTIONS(1153),
    [anon_sym_gt] = ACTIONS(1153),
    [anon_sym_slt] = ACTIONS(1153),
    [anon_sym_sgt] = ACTIONS(1153),
    [anon_sym_eq] = ACTIONS(1153),
    [anon_sym_iszero] = ACTIONS(1153),
    [anon_sym_and] = ACTIONS(1153),
    [anon_sym_or] = ACTIONS(1153),
    [anon_sym_xor] = ACTIONS(1153),
    [anon_sym_byte] = ACTIONS(1153),
    [anon_sym_shl] = ACTIONS(1153),
    [anon_sym_shr] = ACTIONS(1153),
    [anon_sym_sar] = ACTIONS(1153),
    [anon_sym_addmod] = ACTIONS(1153),
    [anon_sym_mulmod] = ACTIONS(1153),
    [anon_sym_signextend] = ACTIONS(1153),
    [anon_sym_keccak256] = ACTIONS(1153),
    [anon_sym_pop] = ACTIONS(1153),
    [anon_sym_mload] = ACTIONS(1153),
    [anon_sym_mstore] = ACTIONS(1153),
    [anon_sym_mstore8] = ACTIONS(1153),
    [anon_sym_sload] = ACTIONS(1153),
    [anon_sym_sstore] = ACTIONS(1153),
    [anon_sym_msize] = ACTIONS(1153),
    [anon_sym_gas] = ACTIONS(1153),
    [anon_sym_address] = ACTIONS(1153),
    [anon_sym_balance] = ACTIONS(1153),
    [anon_sym_selfbalance] = ACTIONS(1153),
    [anon_sym_caller] = ACTIONS(1153),
    [anon_sym_callvalue] = ACTIONS(1153),
    [anon_sym_calldataload] = ACTIONS(1153),
    [anon_sym_calldatasize] = ACTIONS(1153),
    [anon_sym_calldatacopy] = ACTIONS(1153),
    [anon_sym_extcodesize] = ACTIONS(1153),
    [anon_sym_extcodecopy] = ACTIONS(1153),
    [anon_sym_returndatasize] = ACTIONS(1153),
    [anon_sym_returndatacopy] = ACTIONS(1153),
    [anon_sym_extcodehash] = ACTIONS(1153),
    [anon_sym_create] = ACTIONS(1153),
    [anon_sym_create2] = ACTIONS(1153),
    [anon_sym_call] = ACTIONS(1153),
    [anon_sym_callcode] = ACTIONS(1153),
    [anon_sym_delegatecall] = ACTIONS(1153),
    [anon_sym_staticcall] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_revert] = ACTIONS(1153),
    [anon_sym_selfdestruct] = ACTIONS(1153),
    [anon_sym_invalid] = ACTIONS(1153),
    [anon_sym_log0] = ACTIONS(1153),
    [anon_sym_log1] = ACTIONS(1153),
    [anon_sym_log2] = ACTIONS(1153),
    [anon_sym_log3] = ACTIONS(1153),
    [anon_sym_log4] = ACTIONS(1153),
    [anon_sym_chainid] = ACTIONS(1153),
    [anon_sym_origin] = ACTIONS(1153),
    [anon_sym_gasprice] = ACTIONS(1153),
    [anon_sym_blockhash] = ACTIONS(1153),
    [anon_sym_coinbase] = ACTIONS(1153),
    [anon_sym_timestamp] = ACTIONS(1153),
    [anon_sym_number] = ACTIONS(1153),
    [anon_sym_difficulty] = ACTIONS(1153),
    [anon_sym_gaslimit] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_identifier] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_for] = ACTIONS(1157),
    [sym_yul_leave] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [sym_yul_decimal_number] = ACTIONS(1157),
    [sym_yul_hex_number] = ACTIONS(1159),
    [anon_sym_true] = ACTIONS(1157),
    [anon_sym_false] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_function] = ACTIONS(1157),
    [anon_sym_stop] = ACTIONS(1157),
    [anon_sym_add] = ACTIONS(1157),
    [anon_sym_sub] = ACTIONS(1157),
    [anon_sym_mul] = ACTIONS(1157),
    [anon_sym_div] = ACTIONS(1157),
    [anon_sym_sdiv] = ACTIONS(1157),
    [anon_sym_mod] = ACTIONS(1157),
    [anon_sym_smod] = ACTIONS(1157),
    [anon_sym_exp] = ACTIONS(1157),
    [anon_sym_not] = ACTIONS(1157),
    [anon_sym_lt] = ACTIONS(1157),
    [anon_sym_gt] = ACTIONS(1157),
    [anon_sym_slt] = ACTIONS(1157),
    [anon_sym_sgt] = ACTIONS(1157),
    [anon_sym_eq] = ACTIONS(1157),
    [anon_sym_iszero] = ACTIONS(1157),
    [anon_sym_and] = ACTIONS(1157),
    [anon_sym_or] = ACTIONS(1157),
    [anon_sym_xor] = ACTIONS(1157),
    [anon_sym_byte] = ACTIONS(1157),
    [anon_sym_shl] = ACTIONS(1157),
    [anon_sym_shr] = ACTIONS(1157),
    [anon_sym_sar] = ACTIONS(1157),
    [anon_sym_addmod] = ACTIONS(1157),
    [anon_sym_mulmod] = ACTIONS(1157),
    [anon_sym_signextend] = ACTIONS(1157),
    [anon_sym_keccak256] = ACTIONS(1157),
    [anon_sym_pop] = ACTIONS(1157),
    [anon_sym_mload] = ACTIONS(1157),
    [anon_sym_mstore] = ACTIONS(1157),
    [anon_sym_mstore8] = ACTIONS(1157),
    [anon_sym_sload] = ACTIONS(1157),
    [anon_sym_sstore] = ACTIONS(1157),
    [anon_sym_msize] = ACTIONS(1157),
    [anon_sym_gas] = ACTIONS(1157),
    [anon_sym_address] = ACTIONS(1157),
    [anon_sym_balance] = ACTIONS(1157),
    [anon_sym_selfbalance] = ACTIONS(1157),
    [anon_sym_caller] = ACTIONS(1157),
    [anon_sym_callvalue] = ACTIONS(1157),
    [anon_sym_calldataload] = ACTIONS(1157),
    [anon_sym_calldatasize] = ACTIONS(1157),
    [anon_sym_calldatacopy] = ACTIONS(1157),
    [anon_sym_extcodesize] = ACTIONS(1157),
    [anon_sym_extcodecopy] = ACTIONS(1157),
    [anon_sym_returndatasize] = ACTIONS(1157),
    [anon_sym_returndatacopy] = ACTIONS(1157),
    [anon_sym_extcodehash] = ACTIONS(1157),
    [anon_sym_create] = ACTIONS(1157),
    [anon_sym_create2] = ACTIONS(1157),
    [anon_sym_call] = ACTIONS(1157),
    [anon_sym_callcode] = ACTIONS(1157),
    [anon_sym_delegatecall] = ACTIONS(1157),
    [anon_sym_staticcall] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_revert] = ACTIONS(1157),
    [anon_sym_selfdestruct] = ACTIONS(1157),
    [anon_sym_invalid] = ACTIONS(1157),
    [anon_sym_log0] = ACTIONS(1157),
    [anon_sym_log1] = ACTIONS(1157),
    [anon_sym_log2] = ACTIONS(1157),
    [anon_sym_log3] = ACTIONS(1157),
    [anon_sym_log4] = ACTIONS(1157),
    [anon_sym_chainid] = ACTIONS(1157),
    [anon_sym_origin] = ACTIONS(1157),
    [anon_sym_gasprice] = ACTIONS(1157),
    [anon_sym_blockhash] = ACTIONS(1157),
    [anon_sym_coinbase] = ACTIONS(1157),
    [anon_sym_timestamp] = ACTIONS(1157),
    [anon_sym_number] = ACTIONS(1157),
    [anon_sym_difficulty] = ACTIONS(1157),
    [anon_sym_gaslimit] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_for] = ACTIONS(1161),
    [sym_yul_leave] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [sym_yul_decimal_number] = ACTIONS(1161),
    [sym_yul_hex_number] = ACTIONS(1163),
    [anon_sym_true] = ACTIONS(1161),
    [anon_sym_false] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_function] = ACTIONS(1161),
    [anon_sym_stop] = ACTIONS(1161),
    [anon_sym_add] = ACTIONS(1161),
    [anon_sym_sub] = ACTIONS(1161),
    [anon_sym_mul] = ACTIONS(1161),
    [anon_sym_div] = ACTIONS(1161),
    [anon_sym_sdiv] = ACTIONS(1161),
    [anon_sym_mod] = ACTIONS(1161),
    [anon_sym_smod] = ACTIONS(1161),
    [anon_sym_exp] = ACTIONS(1161),
    [anon_sym_not] = ACTIONS(1161),
    [anon_sym_lt] = ACTIONS(1161),
    [anon_sym_gt] = ACTIONS(1161),
    [anon_sym_slt] = ACTIONS(1161),
    [anon_sym_sgt] = ACTIONS(1161),
    [anon_sym_eq] = ACTIONS(1161),
    [anon_sym_iszero] = ACTIONS(1161),
    [anon_sym_and] = ACTIONS(1161),
    [anon_sym_or] = ACTIONS(1161),
    [anon_sym_xor] = ACTIONS(1161),
    [anon_sym_byte] = ACTIONS(1161),
    [anon_sym_shl] = ACTIONS(1161),
    [anon_sym_shr] = ACTIONS(1161),
    [anon_sym_sar] = ACTIONS(1161),
    [anon_sym_addmod] = ACTIONS(1161),
    [anon_sym_mulmod] = ACTIONS(1161),
    [anon_sym_signextend] = ACTIONS(1161),
    [anon_sym_keccak256] = ACTIONS(1161),
    [anon_sym_pop] = ACTIONS(1161),
    [anon_sym_mload] = ACTIONS(1161),
    [anon_sym_mstore] = ACTIONS(1161),
    [anon_sym_mstore8] = ACTIONS(1161),
    [anon_sym_sload] = ACTIONS(1161),
    [anon_sym_sstore] = ACTIONS(1161),
    [anon_sym_msize] = ACTIONS(1161),
    [anon_sym_gas] = ACTIONS(1161),
    [anon_sym_address] = ACTIONS(1161),
    [anon_sym_balance] = ACTIONS(1161),
    [anon_sym_selfbalance] = ACTIONS(1161),
    [anon_sym_caller] = ACTIONS(1161),
    [anon_sym_callvalue] = ACTIONS(1161),
    [anon_sym_calldataload] = ACTIONS(1161),
    [anon_sym_calldatasize] = ACTIONS(1161),
    [anon_sym_calldatacopy] = ACTIONS(1161),
    [anon_sym_extcodesize] = ACTIONS(1161),
    [anon_sym_extcodecopy] = ACTIONS(1161),
    [anon_sym_returndatasize] = ACTIONS(1161),
    [anon_sym_returndatacopy] = ACTIONS(1161),
    [anon_sym_extcodehash] = ACTIONS(1161),
    [anon_sym_create] = ACTIONS(1161),
    [anon_sym_create2] = ACTIONS(1161),
    [anon_sym_call] = ACTIONS(1161),
    [anon_sym_callcode] = ACTIONS(1161),
    [anon_sym_delegatecall] = ACTIONS(1161),
    [anon_sym_staticcall] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_revert] = ACTIONS(1161),
    [anon_sym_selfdestruct] = ACTIONS(1161),
    [anon_sym_invalid] = ACTIONS(1161),
    [anon_sym_log0] = ACTIONS(1161),
    [anon_sym_log1] = ACTIONS(1161),
    [anon_sym_log2] = ACTIONS(1161),
    [anon_sym_log3] = ACTIONS(1161),
    [anon_sym_log4] = ACTIONS(1161),
    [anon_sym_chainid] = ACTIONS(1161),
    [anon_sym_origin] = ACTIONS(1161),
    [anon_sym_gasprice] = ACTIONS(1161),
    [anon_sym_blockhash] = ACTIONS(1161),
    [anon_sym_coinbase] = ACTIONS(1161),
    [anon_sym_timestamp] = ACTIONS(1161),
    [anon_sym_number] = ACTIONS(1161),
    [anon_sym_difficulty] = ACTIONS(1161),
    [anon_sym_gaslimit] = ACTIONS(1161),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_for] = ACTIONS(1165),
    [sym_yul_leave] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [sym_yul_decimal_number] = ACTIONS(1165),
    [sym_yul_hex_number] = ACTIONS(1167),
    [anon_sym_true] = ACTIONS(1165),
    [anon_sym_false] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_stop] = ACTIONS(1165),
    [anon_sym_add] = ACTIONS(1165),
    [anon_sym_sub] = ACTIONS(1165),
    [anon_sym_mul] = ACTIONS(1165),
    [anon_sym_div] = ACTIONS(1165),
    [anon_sym_sdiv] = ACTIONS(1165),
    [anon_sym_mod] = ACTIONS(1165),
    [anon_sym_smod] = ACTIONS(1165),
    [anon_sym_exp] = ACTIONS(1165),
    [anon_sym_not] = ACTIONS(1165),
    [anon_sym_lt] = ACTIONS(1165),
    [anon_sym_gt] = ACTIONS(1165),
    [anon_sym_slt] = ACTIONS(1165),
    [anon_sym_sgt] = ACTIONS(1165),
    [anon_sym_eq] = ACTIONS(1165),
    [anon_sym_iszero] = ACTIONS(1165),
    [anon_sym_and] = ACTIONS(1165),
    [anon_sym_or] = ACTIONS(1165),
    [anon_sym_xor] = ACTIONS(1165),
    [anon_sym_byte] = ACTIONS(1165),
    [anon_sym_shl] = ACTIONS(1165),
    [anon_sym_shr] = ACTIONS(1165),
    [anon_sym_sar] = ACTIONS(1165),
    [anon_sym_addmod] = ACTIONS(1165),
    [anon_sym_mulmod] = ACTIONS(1165),
    [anon_sym_signextend] = ACTIONS(1165),
    [anon_sym_keccak256] = ACTIONS(1165),
    [anon_sym_pop] = ACTIONS(1165),
    [anon_sym_mload] = ACTIONS(1165),
    [anon_sym_mstore] = ACTIONS(1165),
    [anon_sym_mstore8] = ACTIONS(1165),
    [anon_sym_sload] = ACTIONS(1165),
    [anon_sym_sstore] = ACTIONS(1165),
    [anon_sym_msize] = ACTIONS(1165),
    [anon_sym_gas] = ACTIONS(1165),
    [anon_sym_address] = ACTIONS(1165),
    [anon_sym_balance] = ACTIONS(1165),
    [anon_sym_selfbalance] = ACTIONS(1165),
    [anon_sym_caller] = ACTIONS(1165),
    [anon_sym_callvalue] = ACTIONS(1165),
    [anon_sym_calldataload] = ACTIONS(1165),
    [anon_sym_calldatasize] = ACTIONS(1165),
    [anon_sym_calldatacopy] = ACTIONS(1165),
    [anon_sym_extcodesize] = ACTIONS(1165),
    [anon_sym_extcodecopy] = ACTIONS(1165),
    [anon_sym_returndatasize] = ACTIONS(1165),
    [anon_sym_returndatacopy] = ACTIONS(1165),
    [anon_sym_extcodehash] = ACTIONS(1165),
    [anon_sym_create] = ACTIONS(1165),
    [anon_sym_create2] = ACTIONS(1165),
    [anon_sym_call] = ACTIONS(1165),
    [anon_sym_callcode] = ACTIONS(1165),
    [anon_sym_delegatecall] = ACTIONS(1165),
    [anon_sym_staticcall] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_revert] = ACTIONS(1165),
    [anon_sym_selfdestruct] = ACTIONS(1165),
    [anon_sym_invalid] = ACTIONS(1165),
    [anon_sym_log0] = ACTIONS(1165),
    [anon_sym_log1] = ACTIONS(1165),
    [anon_sym_log2] = ACTIONS(1165),
    [anon_sym_log3] = ACTIONS(1165),
    [anon_sym_log4] = ACTIONS(1165),
    [anon_sym_chainid] = ACTIONS(1165),
    [anon_sym_origin] = ACTIONS(1165),
    [anon_sym_gasprice] = ACTIONS(1165),
    [anon_sym_blockhash] = ACTIONS(1165),
    [anon_sym_coinbase] = ACTIONS(1165),
    [anon_sym_timestamp] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_difficulty] = ACTIONS(1165),
    [anon_sym_gaslimit] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_for] = ACTIONS(1169),
    [sym_yul_leave] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [sym_yul_decimal_number] = ACTIONS(1169),
    [sym_yul_hex_number] = ACTIONS(1171),
    [anon_sym_true] = ACTIONS(1169),
    [anon_sym_false] = ACTIONS(1169),
    [anon_sym_let] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(1169),
    [anon_sym_stop] = ACTIONS(1169),
    [anon_sym_add] = ACTIONS(1169),
    [anon_sym_sub] = ACTIONS(1169),
    [anon_sym_mul] = ACTIONS(1169),
    [anon_sym_div] = ACTIONS(1169),
    [anon_sym_sdiv] = ACTIONS(1169),
    [anon_sym_mod] = ACTIONS(1169),
    [anon_sym_smod] = ACTIONS(1169),
    [anon_sym_exp] = ACTIONS(1169),
    [anon_sym_not] = ACTIONS(1169),
    [anon_sym_lt] = ACTIONS(1169),
    [anon_sym_gt] = ACTIONS(1169),
    [anon_sym_slt] = ACTIONS(1169),
    [anon_sym_sgt] = ACTIONS(1169),
    [anon_sym_eq] = ACTIONS(1169),
    [anon_sym_iszero] = ACTIONS(1169),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_xor] = ACTIONS(1169),
    [anon_sym_byte] = ACTIONS(1169),
    [anon_sym_shl] = ACTIONS(1169),
    [anon_sym_shr] = ACTIONS(1169),
    [anon_sym_sar] = ACTIONS(1169),
    [anon_sym_addmod] = ACTIONS(1169),
    [anon_sym_mulmod] = ACTIONS(1169),
    [anon_sym_signextend] = ACTIONS(1169),
    [anon_sym_keccak256] = ACTIONS(1169),
    [anon_sym_pop] = ACTIONS(1169),
    [anon_sym_mload] = ACTIONS(1169),
    [anon_sym_mstore] = ACTIONS(1169),
    [anon_sym_mstore8] = ACTIONS(1169),
    [anon_sym_sload] = ACTIONS(1169),
    [anon_sym_sstore] = ACTIONS(1169),
    [anon_sym_msize] = ACTIONS(1169),
    [anon_sym_gas] = ACTIONS(1169),
    [anon_sym_address] = ACTIONS(1169),
    [anon_sym_balance] = ACTIONS(1169),
    [anon_sym_selfbalance] = ACTIONS(1169),
    [anon_sym_caller] = ACTIONS(1169),
    [anon_sym_callvalue] = ACTIONS(1169),
    [anon_sym_calldataload] = ACTIONS(1169),
    [anon_sym_calldatasize] = ACTIONS(1169),
    [anon_sym_calldatacopy] = ACTIONS(1169),
    [anon_sym_extcodesize] = ACTIONS(1169),
    [anon_sym_extcodecopy] = ACTIONS(1169),
    [anon_sym_returndatasize] = ACTIONS(1169),
    [anon_sym_returndatacopy] = ACTIONS(1169),
    [anon_sym_extcodehash] = ACTIONS(1169),
    [anon_sym_create] = ACTIONS(1169),
    [anon_sym_create2] = ACTIONS(1169),
    [anon_sym_call] = ACTIONS(1169),
    [anon_sym_callcode] = ACTIONS(1169),
    [anon_sym_delegatecall] = ACTIONS(1169),
    [anon_sym_staticcall] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_revert] = ACTIONS(1169),
    [anon_sym_selfdestruct] = ACTIONS(1169),
    [anon_sym_invalid] = ACTIONS(1169),
    [anon_sym_log0] = ACTIONS(1169),
    [anon_sym_log1] = ACTIONS(1169),
    [anon_sym_log2] = ACTIONS(1169),
    [anon_sym_log3] = ACTIONS(1169),
    [anon_sym_log4] = ACTIONS(1169),
    [anon_sym_chainid] = ACTIONS(1169),
    [anon_sym_origin] = ACTIONS(1169),
    [anon_sym_gasprice] = ACTIONS(1169),
    [anon_sym_blockhash] = ACTIONS(1169),
    [anon_sym_coinbase] = ACTIONS(1169),
    [anon_sym_timestamp] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_difficulty] = ACTIONS(1169),
    [anon_sym_gaslimit] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_for] = ACTIONS(1173),
    [sym_yul_leave] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [sym_yul_decimal_number] = ACTIONS(1173),
    [sym_yul_hex_number] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1173),
    [anon_sym_false] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_stop] = ACTIONS(1173),
    [anon_sym_add] = ACTIONS(1173),
    [anon_sym_sub] = ACTIONS(1173),
    [anon_sym_mul] = ACTIONS(1173),
    [anon_sym_div] = ACTIONS(1173),
    [anon_sym_sdiv] = ACTIONS(1173),
    [anon_sym_mod] = ACTIONS(1173),
    [anon_sym_smod] = ACTIONS(1173),
    [anon_sym_exp] = ACTIONS(1173),
    [anon_sym_not] = ACTIONS(1173),
    [anon_sym_lt] = ACTIONS(1173),
    [anon_sym_gt] = ACTIONS(1173),
    [anon_sym_slt] = ACTIONS(1173),
    [anon_sym_sgt] = ACTIONS(1173),
    [anon_sym_eq] = ACTIONS(1173),
    [anon_sym_iszero] = ACTIONS(1173),
    [anon_sym_and] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1173),
    [anon_sym_xor] = ACTIONS(1173),
    [anon_sym_byte] = ACTIONS(1173),
    [anon_sym_shl] = ACTIONS(1173),
    [anon_sym_shr] = ACTIONS(1173),
    [anon_sym_sar] = ACTIONS(1173),
    [anon_sym_addmod] = ACTIONS(1173),
    [anon_sym_mulmod] = ACTIONS(1173),
    [anon_sym_signextend] = ACTIONS(1173),
    [anon_sym_keccak256] = ACTIONS(1173),
    [anon_sym_pop] = ACTIONS(1173),
    [anon_sym_mload] = ACTIONS(1173),
    [anon_sym_mstore] = ACTIONS(1173),
    [anon_sym_mstore8] = ACTIONS(1173),
    [anon_sym_sload] = ACTIONS(1173),
    [anon_sym_sstore] = ACTIONS(1173),
    [anon_sym_msize] = ACTIONS(1173),
    [anon_sym_gas] = ACTIONS(1173),
    [anon_sym_address] = ACTIONS(1173),
    [anon_sym_balance] = ACTIONS(1173),
    [anon_sym_selfbalance] = ACTIONS(1173),
    [anon_sym_caller] = ACTIONS(1173),
    [anon_sym_callvalue] = ACTIONS(1173),
    [anon_sym_calldataload] = ACTIONS(1173),
    [anon_sym_calldatasize] = ACTIONS(1173),
    [anon_sym_calldatacopy] = ACTIONS(1173),
    [anon_sym_extcodesize] = ACTIONS(1173),
    [anon_sym_extcodecopy] = ACTIONS(1173),
    [anon_sym_returndatasize] = ACTIONS(1173),
    [anon_sym_returndatacopy] = ACTIONS(1173),
    [anon_sym_extcodehash] = ACTIONS(1173),
    [anon_sym_create] = ACTIONS(1173),
    [anon_sym_create2] = ACTIONS(1173),
    [anon_sym_call] = ACTIONS(1173),
    [anon_sym_callcode] = ACTIONS(1173),
    [anon_sym_delegatecall] = ACTIONS(1173),
    [anon_sym_staticcall] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_revert] = ACTIONS(1173),
    [anon_sym_selfdestruct] = ACTIONS(1173),
    [anon_sym_invalid] = ACTIONS(1173),
    [anon_sym_log0] = ACTIONS(1173),
    [anon_sym_log1] = ACTIONS(1173),
    [anon_sym_log2] = ACTIONS(1173),
    [anon_sym_log3] = ACTIONS(1173),
    [anon_sym_log4] = ACTIONS(1173),
    [anon_sym_chainid] = ACTIONS(1173),
    [anon_sym_origin] = ACTIONS(1173),
    [anon_sym_gasprice] = ACTIONS(1173),
    [anon_sym_blockhash] = ACTIONS(1173),
    [anon_sym_coinbase] = ACTIONS(1173),
    [anon_sym_timestamp] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_difficulty] = ACTIONS(1173),
    [anon_sym_gaslimit] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(724),
    [sym_yul_path] = STATE(724),
    [sym__yul_literal] = STATE(724),
    [sym_yul_string_literal] = STATE(724),
    [sym_yul_boolean] = STATE(724),
    [sym_yul_function_call] = STATE(724),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1177),
    [sym_yul_decimal_number] = ACTIONS(1127),
    [sym_yul_hex_number] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1179),
    [sym_yul_leave] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1179),
    [anon_sym_continue] = ACTIONS(1179),
    [sym_yul_decimal_number] = ACTIONS(1179),
    [sym_yul_hex_number] = ACTIONS(1181),
    [anon_sym_true] = ACTIONS(1179),
    [anon_sym_false] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1179),
    [anon_sym_switch] = ACTIONS(1179),
    [anon_sym_function] = ACTIONS(1179),
    [anon_sym_stop] = ACTIONS(1179),
    [anon_sym_add] = ACTIONS(1179),
    [anon_sym_sub] = ACTIONS(1179),
    [anon_sym_mul] = ACTIONS(1179),
    [anon_sym_div] = ACTIONS(1179),
    [anon_sym_sdiv] = ACTIONS(1179),
    [anon_sym_mod] = ACTIONS(1179),
    [anon_sym_smod] = ACTIONS(1179),
    [anon_sym_exp] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1179),
    [anon_sym_lt] = ACTIONS(1179),
    [anon_sym_gt] = ACTIONS(1179),
    [anon_sym_slt] = ACTIONS(1179),
    [anon_sym_sgt] = ACTIONS(1179),
    [anon_sym_eq] = ACTIONS(1179),
    [anon_sym_iszero] = ACTIONS(1179),
    [anon_sym_and] = ACTIONS(1179),
    [anon_sym_or] = ACTIONS(1179),
    [anon_sym_xor] = ACTIONS(1179),
    [anon_sym_byte] = ACTIONS(1179),
    [anon_sym_shl] = ACTIONS(1179),
    [anon_sym_shr] = ACTIONS(1179),
    [anon_sym_sar] = ACTIONS(1179),
    [anon_sym_addmod] = ACTIONS(1179),
    [anon_sym_mulmod] = ACTIONS(1179),
    [anon_sym_signextend] = ACTIONS(1179),
    [anon_sym_keccak256] = ACTIONS(1179),
    [anon_sym_pop] = ACTIONS(1179),
    [anon_sym_mload] = ACTIONS(1179),
    [anon_sym_mstore] = ACTIONS(1179),
    [anon_sym_mstore8] = ACTIONS(1179),
    [anon_sym_sload] = ACTIONS(1179),
    [anon_sym_sstore] = ACTIONS(1179),
    [anon_sym_msize] = ACTIONS(1179),
    [anon_sym_gas] = ACTIONS(1179),
    [anon_sym_address] = ACTIONS(1179),
    [anon_sym_balance] = ACTIONS(1179),
    [anon_sym_selfbalance] = ACTIONS(1179),
    [anon_sym_caller] = ACTIONS(1179),
    [anon_sym_callvalue] = ACTIONS(1179),
    [anon_sym_calldataload] = ACTIONS(1179),
    [anon_sym_calldatasize] = ACTIONS(1179),
    [anon_sym_calldatacopy] = ACTIONS(1179),
    [anon_sym_extcodesize] = ACTIONS(1179),
    [anon_sym_extcodecopy] = ACTIONS(1179),
    [anon_sym_returndatasize] = ACTIONS(1179),
    [anon_sym_returndatacopy] = ACTIONS(1179),
    [anon_sym_extcodehash] = ACTIONS(1179),
    [anon_sym_create] = ACTIONS(1179),
    [anon_sym_create2] = ACTIONS(1179),
    [anon_sym_call] = ACTIONS(1179),
    [anon_sym_callcode] = ACTIONS(1179),
    [anon_sym_delegatecall] = ACTIONS(1179),
    [anon_sym_staticcall] = ACTIONS(1179),
    [anon_sym_return] = ACTIONS(1179),
    [anon_sym_revert] = ACTIONS(1179),
    [anon_sym_selfdestruct] = ACTIONS(1179),
    [anon_sym_invalid] = ACTIONS(1179),
    [anon_sym_log0] = ACTIONS(1179),
    [anon_sym_log1] = ACTIONS(1179),
    [anon_sym_log2] = ACTIONS(1179),
    [anon_sym_log3] = ACTIONS(1179),
    [anon_sym_log4] = ACTIONS(1179),
    [anon_sym_chainid] = ACTIONS(1179),
    [anon_sym_origin] = ACTIONS(1179),
    [anon_sym_gasprice] = ACTIONS(1179),
    [anon_sym_blockhash] = ACTIONS(1179),
    [anon_sym_coinbase] = ACTIONS(1179),
    [anon_sym_timestamp] = ACTIONS(1179),
    [anon_sym_number] = ACTIONS(1179),
    [anon_sym_difficulty] = ACTIONS(1179),
    [anon_sym_gaslimit] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1183),
    [sym_yul_leave] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [sym_yul_decimal_number] = ACTIONS(1183),
    [sym_yul_hex_number] = ACTIONS(1185),
    [anon_sym_true] = ACTIONS(1183),
    [anon_sym_false] = ACTIONS(1183),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(1183),
    [anon_sym_stop] = ACTIONS(1183),
    [anon_sym_add] = ACTIONS(1183),
    [anon_sym_sub] = ACTIONS(1183),
    [anon_sym_mul] = ACTIONS(1183),
    [anon_sym_div] = ACTIONS(1183),
    [anon_sym_sdiv] = ACTIONS(1183),
    [anon_sym_mod] = ACTIONS(1183),
    [anon_sym_smod] = ACTIONS(1183),
    [anon_sym_exp] = ACTIONS(1183),
    [anon_sym_not] = ACTIONS(1183),
    [anon_sym_lt] = ACTIONS(1183),
    [anon_sym_gt] = ACTIONS(1183),
    [anon_sym_slt] = ACTIONS(1183),
    [anon_sym_sgt] = ACTIONS(1183),
    [anon_sym_eq] = ACTIONS(1183),
    [anon_sym_iszero] = ACTIONS(1183),
    [anon_sym_and] = ACTIONS(1183),
    [anon_sym_or] = ACTIONS(1183),
    [anon_sym_xor] = ACTIONS(1183),
    [anon_sym_byte] = ACTIONS(1183),
    [anon_sym_shl] = ACTIONS(1183),
    [anon_sym_shr] = ACTIONS(1183),
    [anon_sym_sar] = ACTIONS(1183),
    [anon_sym_addmod] = ACTIONS(1183),
    [anon_sym_mulmod] = ACTIONS(1183),
    [anon_sym_signextend] = ACTIONS(1183),
    [anon_sym_keccak256] = ACTIONS(1183),
    [anon_sym_pop] = ACTIONS(1183),
    [anon_sym_mload] = ACTIONS(1183),
    [anon_sym_mstore] = ACTIONS(1183),
    [anon_sym_mstore8] = ACTIONS(1183),
    [anon_sym_sload] = ACTIONS(1183),
    [anon_sym_sstore] = ACTIONS(1183),
    [anon_sym_msize] = ACTIONS(1183),
    [anon_sym_gas] = ACTIONS(1183),
    [anon_sym_address] = ACTIONS(1183),
    [anon_sym_balance] = ACTIONS(1183),
    [anon_sym_selfbalance] = ACTIONS(1183),
    [anon_sym_caller] = ACTIONS(1183),
    [anon_sym_callvalue] = ACTIONS(1183),
    [anon_sym_calldataload] = ACTIONS(1183),
    [anon_sym_calldatasize] = ACTIONS(1183),
    [anon_sym_calldatacopy] = ACTIONS(1183),
    [anon_sym_extcodesize] = ACTIONS(1183),
    [anon_sym_extcodecopy] = ACTIONS(1183),
    [anon_sym_returndatasize] = ACTIONS(1183),
    [anon_sym_returndatacopy] = ACTIONS(1183),
    [anon_sym_extcodehash] = ACTIONS(1183),
    [anon_sym_create] = ACTIONS(1183),
    [anon_sym_create2] = ACTIONS(1183),
    [anon_sym_call] = ACTIONS(1183),
    [anon_sym_callcode] = ACTIONS(1183),
    [anon_sym_delegatecall] = ACTIONS(1183),
    [anon_sym_staticcall] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_revert] = ACTIONS(1183),
    [anon_sym_selfdestruct] = ACTIONS(1183),
    [anon_sym_invalid] = ACTIONS(1183),
    [anon_sym_log0] = ACTIONS(1183),
    [anon_sym_log1] = ACTIONS(1183),
    [anon_sym_log2] = ACTIONS(1183),
    [anon_sym_log3] = ACTIONS(1183),
    [anon_sym_log4] = ACTIONS(1183),
    [anon_sym_chainid] = ACTIONS(1183),
    [anon_sym_origin] = ACTIONS(1183),
    [anon_sym_gasprice] = ACTIONS(1183),
    [anon_sym_blockhash] = ACTIONS(1183),
    [anon_sym_coinbase] = ACTIONS(1183),
    [anon_sym_timestamp] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_difficulty] = ACTIONS(1183),
    [anon_sym_gaslimit] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1187),
    [sym_yul_leave] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [sym_yul_decimal_number] = ACTIONS(1187),
    [sym_yul_hex_number] = ACTIONS(1189),
    [anon_sym_true] = ACTIONS(1187),
    [anon_sym_false] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_stop] = ACTIONS(1187),
    [anon_sym_add] = ACTIONS(1187),
    [anon_sym_sub] = ACTIONS(1187),
    [anon_sym_mul] = ACTIONS(1187),
    [anon_sym_div] = ACTIONS(1187),
    [anon_sym_sdiv] = ACTIONS(1187),
    [anon_sym_mod] = ACTIONS(1187),
    [anon_sym_smod] = ACTIONS(1187),
    [anon_sym_exp] = ACTIONS(1187),
    [anon_sym_not] = ACTIONS(1187),
    [anon_sym_lt] = ACTIONS(1187),
    [anon_sym_gt] = ACTIONS(1187),
    [anon_sym_slt] = ACTIONS(1187),
    [anon_sym_sgt] = ACTIONS(1187),
    [anon_sym_eq] = ACTIONS(1187),
    [anon_sym_iszero] = ACTIONS(1187),
    [anon_sym_and] = ACTIONS(1187),
    [anon_sym_or] = ACTIONS(1187),
    [anon_sym_xor] = ACTIONS(1187),
    [anon_sym_byte] = ACTIONS(1187),
    [anon_sym_shl] = ACTIONS(1187),
    [anon_sym_shr] = ACTIONS(1187),
    [anon_sym_sar] = ACTIONS(1187),
    [anon_sym_addmod] = ACTIONS(1187),
    [anon_sym_mulmod] = ACTIONS(1187),
    [anon_sym_signextend] = ACTIONS(1187),
    [anon_sym_keccak256] = ACTIONS(1187),
    [anon_sym_pop] = ACTIONS(1187),
    [anon_sym_mload] = ACTIONS(1187),
    [anon_sym_mstore] = ACTIONS(1187),
    [anon_sym_mstore8] = ACTIONS(1187),
    [anon_sym_sload] = ACTIONS(1187),
    [anon_sym_sstore] = ACTIONS(1187),
    [anon_sym_msize] = ACTIONS(1187),
    [anon_sym_gas] = ACTIONS(1187),
    [anon_sym_address] = ACTIONS(1187),
    [anon_sym_balance] = ACTIONS(1187),
    [anon_sym_selfbalance] = ACTIONS(1187),
    [anon_sym_caller] = ACTIONS(1187),
    [anon_sym_callvalue] = ACTIONS(1187),
    [anon_sym_calldataload] = ACTIONS(1187),
    [anon_sym_calldatasize] = ACTIONS(1187),
    [anon_sym_calldatacopy] = ACTIONS(1187),
    [anon_sym_extcodesize] = ACTIONS(1187),
    [anon_sym_extcodecopy] = ACTIONS(1187),
    [anon_sym_returndatasize] = ACTIONS(1187),
    [anon_sym_returndatacopy] = ACTIONS(1187),
    [anon_sym_extcodehash] = ACTIONS(1187),
    [anon_sym_create] = ACTIONS(1187),
    [anon_sym_create2] = ACTIONS(1187),
    [anon_sym_call] = ACTIONS(1187),
    [anon_sym_callcode] = ACTIONS(1187),
    [anon_sym_delegatecall] = ACTIONS(1187),
    [anon_sym_staticcall] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_revert] = ACTIONS(1187),
    [anon_sym_selfdestruct] = ACTIONS(1187),
    [anon_sym_invalid] = ACTIONS(1187),
    [anon_sym_log0] = ACTIONS(1187),
    [anon_sym_log1] = ACTIONS(1187),
    [anon_sym_log2] = ACTIONS(1187),
    [anon_sym_log3] = ACTIONS(1187),
    [anon_sym_log4] = ACTIONS(1187),
    [anon_sym_chainid] = ACTIONS(1187),
    [anon_sym_origin] = ACTIONS(1187),
    [anon_sym_gasprice] = ACTIONS(1187),
    [anon_sym_blockhash] = ACTIONS(1187),
    [anon_sym_coinbase] = ACTIONS(1187),
    [anon_sym_timestamp] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_difficulty] = ACTIONS(1187),
    [anon_sym_gaslimit] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1187),
    [sym_yul_leave] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [sym_yul_decimal_number] = ACTIONS(1187),
    [sym_yul_hex_number] = ACTIONS(1189),
    [anon_sym_true] = ACTIONS(1187),
    [anon_sym_false] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_stop] = ACTIONS(1187),
    [anon_sym_add] = ACTIONS(1187),
    [anon_sym_sub] = ACTIONS(1187),
    [anon_sym_mul] = ACTIONS(1187),
    [anon_sym_div] = ACTIONS(1187),
    [anon_sym_sdiv] = ACTIONS(1187),
    [anon_sym_mod] = ACTIONS(1187),
    [anon_sym_smod] = ACTIONS(1187),
    [anon_sym_exp] = ACTIONS(1187),
    [anon_sym_not] = ACTIONS(1187),
    [anon_sym_lt] = ACTIONS(1187),
    [anon_sym_gt] = ACTIONS(1187),
    [anon_sym_slt] = ACTIONS(1187),
    [anon_sym_sgt] = ACTIONS(1187),
    [anon_sym_eq] = ACTIONS(1187),
    [anon_sym_iszero] = ACTIONS(1187),
    [anon_sym_and] = ACTIONS(1187),
    [anon_sym_or] = ACTIONS(1187),
    [anon_sym_xor] = ACTIONS(1187),
    [anon_sym_byte] = ACTIONS(1187),
    [anon_sym_shl] = ACTIONS(1187),
    [anon_sym_shr] = ACTIONS(1187),
    [anon_sym_sar] = ACTIONS(1187),
    [anon_sym_addmod] = ACTIONS(1187),
    [anon_sym_mulmod] = ACTIONS(1187),
    [anon_sym_signextend] = ACTIONS(1187),
    [anon_sym_keccak256] = ACTIONS(1187),
    [anon_sym_pop] = ACTIONS(1187),
    [anon_sym_mload] = ACTIONS(1187),
    [anon_sym_mstore] = ACTIONS(1187),
    [anon_sym_mstore8] = ACTIONS(1187),
    [anon_sym_sload] = ACTIONS(1187),
    [anon_sym_sstore] = ACTIONS(1187),
    [anon_sym_msize] = ACTIONS(1187),
    [anon_sym_gas] = ACTIONS(1187),
    [anon_sym_address] = ACTIONS(1187),
    [anon_sym_balance] = ACTIONS(1187),
    [anon_sym_selfbalance] = ACTIONS(1187),
    [anon_sym_caller] = ACTIONS(1187),
    [anon_sym_callvalue] = ACTIONS(1187),
    [anon_sym_calldataload] = ACTIONS(1187),
    [anon_sym_calldatasize] = ACTIONS(1187),
    [anon_sym_calldatacopy] = ACTIONS(1187),
    [anon_sym_extcodesize] = ACTIONS(1187),
    [anon_sym_extcodecopy] = ACTIONS(1187),
    [anon_sym_returndatasize] = ACTIONS(1187),
    [anon_sym_returndatacopy] = ACTIONS(1187),
    [anon_sym_extcodehash] = ACTIONS(1187),
    [anon_sym_create] = ACTIONS(1187),
    [anon_sym_create2] = ACTIONS(1187),
    [anon_sym_call] = ACTIONS(1187),
    [anon_sym_callcode] = ACTIONS(1187),
    [anon_sym_delegatecall] = ACTIONS(1187),
    [anon_sym_staticcall] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_revert] = ACTIONS(1187),
    [anon_sym_selfdestruct] = ACTIONS(1187),
    [anon_sym_invalid] = ACTIONS(1187),
    [anon_sym_log0] = ACTIONS(1187),
    [anon_sym_log1] = ACTIONS(1187),
    [anon_sym_log2] = ACTIONS(1187),
    [anon_sym_log3] = ACTIONS(1187),
    [anon_sym_log4] = ACTIONS(1187),
    [anon_sym_chainid] = ACTIONS(1187),
    [anon_sym_origin] = ACTIONS(1187),
    [anon_sym_gasprice] = ACTIONS(1187),
    [anon_sym_blockhash] = ACTIONS(1187),
    [anon_sym_coinbase] = ACTIONS(1187),
    [anon_sym_timestamp] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_difficulty] = ACTIONS(1187),
    [anon_sym_gaslimit] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1191),
    [sym_yul_leave] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [sym_yul_decimal_number] = ACTIONS(1191),
    [sym_yul_hex_number] = ACTIONS(1193),
    [anon_sym_true] = ACTIONS(1191),
    [anon_sym_false] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [anon_sym_stop] = ACTIONS(1191),
    [anon_sym_add] = ACTIONS(1191),
    [anon_sym_sub] = ACTIONS(1191),
    [anon_sym_mul] = ACTIONS(1191),
    [anon_sym_div] = ACTIONS(1191),
    [anon_sym_sdiv] = ACTIONS(1191),
    [anon_sym_mod] = ACTIONS(1191),
    [anon_sym_smod] = ACTIONS(1191),
    [anon_sym_exp] = ACTIONS(1191),
    [anon_sym_not] = ACTIONS(1191),
    [anon_sym_lt] = ACTIONS(1191),
    [anon_sym_gt] = ACTIONS(1191),
    [anon_sym_slt] = ACTIONS(1191),
    [anon_sym_sgt] = ACTIONS(1191),
    [anon_sym_eq] = ACTIONS(1191),
    [anon_sym_iszero] = ACTIONS(1191),
    [anon_sym_and] = ACTIONS(1191),
    [anon_sym_or] = ACTIONS(1191),
    [anon_sym_xor] = ACTIONS(1191),
    [anon_sym_byte] = ACTIONS(1191),
    [anon_sym_shl] = ACTIONS(1191),
    [anon_sym_shr] = ACTIONS(1191),
    [anon_sym_sar] = ACTIONS(1191),
    [anon_sym_addmod] = ACTIONS(1191),
    [anon_sym_mulmod] = ACTIONS(1191),
    [anon_sym_signextend] = ACTIONS(1191),
    [anon_sym_keccak256] = ACTIONS(1191),
    [anon_sym_pop] = ACTIONS(1191),
    [anon_sym_mload] = ACTIONS(1191),
    [anon_sym_mstore] = ACTIONS(1191),
    [anon_sym_mstore8] = ACTIONS(1191),
    [anon_sym_sload] = ACTIONS(1191),
    [anon_sym_sstore] = ACTIONS(1191),
    [anon_sym_msize] = ACTIONS(1191),
    [anon_sym_gas] = ACTIONS(1191),
    [anon_sym_address] = ACTIONS(1191),
    [anon_sym_balance] = ACTIONS(1191),
    [anon_sym_selfbalance] = ACTIONS(1191),
    [anon_sym_caller] = ACTIONS(1191),
    [anon_sym_callvalue] = ACTIONS(1191),
    [anon_sym_calldataload] = ACTIONS(1191),
    [anon_sym_calldatasize] = ACTIONS(1191),
    [anon_sym_calldatacopy] = ACTIONS(1191),
    [anon_sym_extcodesize] = ACTIONS(1191),
    [anon_sym_extcodecopy] = ACTIONS(1191),
    [anon_sym_returndatasize] = ACTIONS(1191),
    [anon_sym_returndatacopy] = ACTIONS(1191),
    [anon_sym_extcodehash] = ACTIONS(1191),
    [anon_sym_create] = ACTIONS(1191),
    [anon_sym_create2] = ACTIONS(1191),
    [anon_sym_call] = ACTIONS(1191),
    [anon_sym_callcode] = ACTIONS(1191),
    [anon_sym_delegatecall] = ACTIONS(1191),
    [anon_sym_staticcall] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_revert] = ACTIONS(1191),
    [anon_sym_selfdestruct] = ACTIONS(1191),
    [anon_sym_invalid] = ACTIONS(1191),
    [anon_sym_log0] = ACTIONS(1191),
    [anon_sym_log1] = ACTIONS(1191),
    [anon_sym_log2] = ACTIONS(1191),
    [anon_sym_log3] = ACTIONS(1191),
    [anon_sym_log4] = ACTIONS(1191),
    [anon_sym_chainid] = ACTIONS(1191),
    [anon_sym_origin] = ACTIONS(1191),
    [anon_sym_gasprice] = ACTIONS(1191),
    [anon_sym_blockhash] = ACTIONS(1191),
    [anon_sym_coinbase] = ACTIONS(1191),
    [anon_sym_timestamp] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_difficulty] = ACTIONS(1191),
    [anon_sym_gaslimit] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1193),
    [anon_sym_SQUOTE] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1195),
    [sym_yul_leave] = ACTIONS(1195),
    [anon_sym_break] = ACTIONS(1195),
    [anon_sym_continue] = ACTIONS(1195),
    [sym_yul_decimal_number] = ACTIONS(1195),
    [sym_yul_hex_number] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(1195),
    [anon_sym_false] = ACTIONS(1195),
    [anon_sym_let] = ACTIONS(1195),
    [anon_sym_if] = ACTIONS(1195),
    [anon_sym_switch] = ACTIONS(1195),
    [anon_sym_function] = ACTIONS(1195),
    [anon_sym_stop] = ACTIONS(1195),
    [anon_sym_add] = ACTIONS(1195),
    [anon_sym_sub] = ACTIONS(1195),
    [anon_sym_mul] = ACTIONS(1195),
    [anon_sym_div] = ACTIONS(1195),
    [anon_sym_sdiv] = ACTIONS(1195),
    [anon_sym_mod] = ACTIONS(1195),
    [anon_sym_smod] = ACTIONS(1195),
    [anon_sym_exp] = ACTIONS(1195),
    [anon_sym_not] = ACTIONS(1195),
    [anon_sym_lt] = ACTIONS(1195),
    [anon_sym_gt] = ACTIONS(1195),
    [anon_sym_slt] = ACTIONS(1195),
    [anon_sym_sgt] = ACTIONS(1195),
    [anon_sym_eq] = ACTIONS(1195),
    [anon_sym_iszero] = ACTIONS(1195),
    [anon_sym_and] = ACTIONS(1195),
    [anon_sym_or] = ACTIONS(1195),
    [anon_sym_xor] = ACTIONS(1195),
    [anon_sym_byte] = ACTIONS(1195),
    [anon_sym_shl] = ACTIONS(1195),
    [anon_sym_shr] = ACTIONS(1195),
    [anon_sym_sar] = ACTIONS(1195),
    [anon_sym_addmod] = ACTIONS(1195),
    [anon_sym_mulmod] = ACTIONS(1195),
    [anon_sym_signextend] = ACTIONS(1195),
    [anon_sym_keccak256] = ACTIONS(1195),
    [anon_sym_pop] = ACTIONS(1195),
    [anon_sym_mload] = ACTIONS(1195),
    [anon_sym_mstore] = ACTIONS(1195),
    [anon_sym_mstore8] = ACTIONS(1195),
    [anon_sym_sload] = ACTIONS(1195),
    [anon_sym_sstore] = ACTIONS(1195),
    [anon_sym_msize] = ACTIONS(1195),
    [anon_sym_gas] = ACTIONS(1195),
    [anon_sym_address] = ACTIONS(1195),
    [anon_sym_balance] = ACTIONS(1195),
    [anon_sym_selfbalance] = ACTIONS(1195),
    [anon_sym_caller] = ACTIONS(1195),
    [anon_sym_callvalue] = ACTIONS(1195),
    [anon_sym_calldataload] = ACTIONS(1195),
    [anon_sym_calldatasize] = ACTIONS(1195),
    [anon_sym_calldatacopy] = ACTIONS(1195),
    [anon_sym_extcodesize] = ACTIONS(1195),
    [anon_sym_extcodecopy] = ACTIONS(1195),
    [anon_sym_returndatasize] = ACTIONS(1195),
    [anon_sym_returndatacopy] = ACTIONS(1195),
    [anon_sym_extcodehash] = ACTIONS(1195),
    [anon_sym_create] = ACTIONS(1195),
    [anon_sym_create2] = ACTIONS(1195),
    [anon_sym_call] = ACTIONS(1195),
    [anon_sym_callcode] = ACTIONS(1195),
    [anon_sym_delegatecall] = ACTIONS(1195),
    [anon_sym_staticcall] = ACTIONS(1195),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_revert] = ACTIONS(1195),
    [anon_sym_selfdestruct] = ACTIONS(1195),
    [anon_sym_invalid] = ACTIONS(1195),
    [anon_sym_log0] = ACTIONS(1195),
    [anon_sym_log1] = ACTIONS(1195),
    [anon_sym_log2] = ACTIONS(1195),
    [anon_sym_log3] = ACTIONS(1195),
    [anon_sym_log4] = ACTIONS(1195),
    [anon_sym_chainid] = ACTIONS(1195),
    [anon_sym_origin] = ACTIONS(1195),
    [anon_sym_gasprice] = ACTIONS(1195),
    [anon_sym_blockhash] = ACTIONS(1195),
    [anon_sym_coinbase] = ACTIONS(1195),
    [anon_sym_timestamp] = ACTIONS(1195),
    [anon_sym_number] = ACTIONS(1195),
    [anon_sym_difficulty] = ACTIONS(1195),
    [anon_sym_gaslimit] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [anon_sym_SQUOTE] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1199),
    [sym_yul_leave] = ACTIONS(1199),
    [anon_sym_break] = ACTIONS(1199),
    [anon_sym_continue] = ACTIONS(1199),
    [sym_yul_decimal_number] = ACTIONS(1199),
    [sym_yul_hex_number] = ACTIONS(1201),
    [anon_sym_true] = ACTIONS(1199),
    [anon_sym_false] = ACTIONS(1199),
    [anon_sym_let] = ACTIONS(1199),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_switch] = ACTIONS(1199),
    [anon_sym_function] = ACTIONS(1199),
    [anon_sym_stop] = ACTIONS(1199),
    [anon_sym_add] = ACTIONS(1199),
    [anon_sym_sub] = ACTIONS(1199),
    [anon_sym_mul] = ACTIONS(1199),
    [anon_sym_div] = ACTIONS(1199),
    [anon_sym_sdiv] = ACTIONS(1199),
    [anon_sym_mod] = ACTIONS(1199),
    [anon_sym_smod] = ACTIONS(1199),
    [anon_sym_exp] = ACTIONS(1199),
    [anon_sym_not] = ACTIONS(1199),
    [anon_sym_lt] = ACTIONS(1199),
    [anon_sym_gt] = ACTIONS(1199),
    [anon_sym_slt] = ACTIONS(1199),
    [anon_sym_sgt] = ACTIONS(1199),
    [anon_sym_eq] = ACTIONS(1199),
    [anon_sym_iszero] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1199),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_xor] = ACTIONS(1199),
    [anon_sym_byte] = ACTIONS(1199),
    [anon_sym_shl] = ACTIONS(1199),
    [anon_sym_shr] = ACTIONS(1199),
    [anon_sym_sar] = ACTIONS(1199),
    [anon_sym_addmod] = ACTIONS(1199),
    [anon_sym_mulmod] = ACTIONS(1199),
    [anon_sym_signextend] = ACTIONS(1199),
    [anon_sym_keccak256] = ACTIONS(1199),
    [anon_sym_pop] = ACTIONS(1199),
    [anon_sym_mload] = ACTIONS(1199),
    [anon_sym_mstore] = ACTIONS(1199),
    [anon_sym_mstore8] = ACTIONS(1199),
    [anon_sym_sload] = ACTIONS(1199),
    [anon_sym_sstore] = ACTIONS(1199),
    [anon_sym_msize] = ACTIONS(1199),
    [anon_sym_gas] = ACTIONS(1199),
    [anon_sym_address] = ACTIONS(1199),
    [anon_sym_balance] = ACTIONS(1199),
    [anon_sym_selfbalance] = ACTIONS(1199),
    [anon_sym_caller] = ACTIONS(1199),
    [anon_sym_callvalue] = ACTIONS(1199),
    [anon_sym_calldataload] = ACTIONS(1199),
    [anon_sym_calldatasize] = ACTIONS(1199),
    [anon_sym_calldatacopy] = ACTIONS(1199),
    [anon_sym_extcodesize] = ACTIONS(1199),
    [anon_sym_extcodecopy] = ACTIONS(1199),
    [anon_sym_returndatasize] = ACTIONS(1199),
    [anon_sym_returndatacopy] = ACTIONS(1199),
    [anon_sym_extcodehash] = ACTIONS(1199),
    [anon_sym_create] = ACTIONS(1199),
    [anon_sym_create2] = ACTIONS(1199),
    [anon_sym_call] = ACTIONS(1199),
    [anon_sym_callcode] = ACTIONS(1199),
    [anon_sym_delegatecall] = ACTIONS(1199),
    [anon_sym_staticcall] = ACTIONS(1199),
    [anon_sym_return] = ACTIONS(1199),
    [anon_sym_revert] = ACTIONS(1199),
    [anon_sym_selfdestruct] = ACTIONS(1199),
    [anon_sym_invalid] = ACTIONS(1199),
    [anon_sym_log0] = ACTIONS(1199),
    [anon_sym_log1] = ACTIONS(1199),
    [anon_sym_log2] = ACTIONS(1199),
    [anon_sym_log3] = ACTIONS(1199),
    [anon_sym_log4] = ACTIONS(1199),
    [anon_sym_chainid] = ACTIONS(1199),
    [anon_sym_origin] = ACTIONS(1199),
    [anon_sym_gasprice] = ACTIONS(1199),
    [anon_sym_blockhash] = ACTIONS(1199),
    [anon_sym_coinbase] = ACTIONS(1199),
    [anon_sym_timestamp] = ACTIONS(1199),
    [anon_sym_number] = ACTIONS(1199),
    [anon_sym_difficulty] = ACTIONS(1199),
    [anon_sym_gaslimit] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1201),
    [anon_sym_SQUOTE] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(713),
    [sym_yul_path] = STATE(713),
    [sym__yul_literal] = STATE(713),
    [sym_yul_string_literal] = STATE(713),
    [sym_yul_boolean] = STATE(713),
    [sym_yul_function_call] = STATE(713),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [sym_yul_decimal_number] = ACTIONS(1203),
    [sym_yul_hex_number] = ACTIONS(1205),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(659),
    [sym_yul_path] = STATE(659),
    [sym__yul_literal] = STATE(659),
    [sym_yul_string_literal] = STATE(659),
    [sym_yul_boolean] = STATE(659),
    [sym_yul_function_call] = STATE(659),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [sym_yul_decimal_number] = ACTIONS(1207),
    [sym_yul_hex_number] = ACTIONS(1209),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(286),
    [sym_yul_path] = STATE(286),
    [sym__yul_literal] = STATE(286),
    [sym_yul_string_literal] = STATE(286),
    [sym_yul_boolean] = STATE(286),
    [sym_yul_function_call] = STATE(285),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [sym_yul_decimal_number] = ACTIONS(1211),
    [sym_yul_hex_number] = ACTIONS(1213),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(724),
    [sym_yul_path] = STATE(724),
    [sym__yul_literal] = STATE(724),
    [sym_yul_string_literal] = STATE(724),
    [sym_yul_boolean] = STATE(724),
    [sym_yul_function_call] = STATE(724),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [sym_yul_decimal_number] = ACTIONS(1127),
    [sym_yul_hex_number] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(571),
    [sym_yul_path] = STATE(571),
    [sym__yul_literal] = STATE(571),
    [sym_yul_string_literal] = STATE(571),
    [sym_yul_boolean] = STATE(571),
    [sym_yul_function_call] = STATE(571),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [sym_yul_decimal_number] = ACTIONS(1215),
    [sym_yul_hex_number] = ACTIONS(1217),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_yul_identifier] = STATE(225),
    [sym__yul_expression] = STATE(264),
    [sym_yul_path] = STATE(264),
    [sym__yul_literal] = STATE(264),
    [sym_yul_string_literal] = STATE(264),
    [sym_yul_boolean] = STATE(264),
    [sym_yul_function_call] = STATE(265),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_string] = STATE(244),
    [sym_identifier] = ACTIONS(1123),
    [sym_yul_decimal_number] = ACTIONS(1219),
    [sym_yul_hex_number] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(839),
    [anon_sym_false] = ACTIONS(839),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(851),
    [anon_sym_SQUOTE] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1223),
    [sym_yul_decimal_number] = ACTIONS(1223),
    [sym_yul_hex_number] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(1223),
    [anon_sym_false] = ACTIONS(1223),
    [anon_sym_stop] = ACTIONS(1223),
    [anon_sym_add] = ACTIONS(1223),
    [anon_sym_sub] = ACTIONS(1223),
    [anon_sym_mul] = ACTIONS(1223),
    [anon_sym_div] = ACTIONS(1223),
    [anon_sym_sdiv] = ACTIONS(1223),
    [anon_sym_mod] = ACTIONS(1223),
    [anon_sym_smod] = ACTIONS(1223),
    [anon_sym_exp] = ACTIONS(1223),
    [anon_sym_not] = ACTIONS(1223),
    [anon_sym_lt] = ACTIONS(1223),
    [anon_sym_gt] = ACTIONS(1223),
    [anon_sym_slt] = ACTIONS(1223),
    [anon_sym_sgt] = ACTIONS(1223),
    [anon_sym_eq] = ACTIONS(1223),
    [anon_sym_iszero] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_xor] = ACTIONS(1223),
    [anon_sym_byte] = ACTIONS(1223),
    [anon_sym_shl] = ACTIONS(1223),
    [anon_sym_shr] = ACTIONS(1223),
    [anon_sym_sar] = ACTIONS(1223),
    [anon_sym_addmod] = ACTIONS(1223),
    [anon_sym_mulmod] = ACTIONS(1223),
    [anon_sym_signextend] = ACTIONS(1223),
    [anon_sym_keccak256] = ACTIONS(1223),
    [anon_sym_pop] = ACTIONS(1223),
    [anon_sym_mload] = ACTIONS(1223),
    [anon_sym_mstore] = ACTIONS(1223),
    [anon_sym_mstore8] = ACTIONS(1223),
    [anon_sym_sload] = ACTIONS(1223),
    [anon_sym_sstore] = ACTIONS(1223),
    [anon_sym_msize] = ACTIONS(1223),
    [anon_sym_gas] = ACTIONS(1223),
    [anon_sym_address] = ACTIONS(1223),
    [anon_sym_balance] = ACTIONS(1223),
    [anon_sym_selfbalance] = ACTIONS(1223),
    [anon_sym_caller] = ACTIONS(1223),
    [anon_sym_callvalue] = ACTIONS(1223),
    [anon_sym_calldataload] = ACTIONS(1223),
    [anon_sym_calldatasize] = ACTIONS(1223),
    [anon_sym_calldatacopy] = ACTIONS(1223),
    [anon_sym_extcodesize] = ACTIONS(1223),
    [anon_sym_extcodecopy] = ACTIONS(1223),
    [anon_sym_returndatasize] = ACTIONS(1223),
    [anon_sym_returndatacopy] = ACTIONS(1223),
    [anon_sym_extcodehash] = ACTIONS(1223),
    [anon_sym_create] = ACTIONS(1223),
    [anon_sym_create2] = ACTIONS(1223),
    [anon_sym_call] = ACTIONS(1223),
    [anon_sym_callcode] = ACTIONS(1223),
    [anon_sym_delegatecall] = ACTIONS(1223),
    [anon_sym_staticcall] = ACTIONS(1223),
    [anon_sym_return] = ACTIONS(1223),
    [anon_sym_revert] = ACTIONS(1223),
    [anon_sym_selfdestruct] = ACTIONS(1223),
    [anon_sym_invalid] = ACTIONS(1223),
    [anon_sym_log0] = ACTIONS(1223),
    [anon_sym_log1] = ACTIONS(1223),
    [anon_sym_log2] = ACTIONS(1223),
    [anon_sym_log3] = ACTIONS(1223),
    [anon_sym_log4] = ACTIONS(1223),
    [anon_sym_chainid] = ACTIONS(1223),
    [anon_sym_origin] = ACTIONS(1223),
    [anon_sym_gasprice] = ACTIONS(1223),
    [anon_sym_blockhash] = ACTIONS(1223),
    [anon_sym_coinbase] = ACTIONS(1223),
    [anon_sym_timestamp] = ACTIONS(1223),
    [anon_sym_number] = ACTIONS(1223),
    [anon_sym_difficulty] = ACTIONS(1223),
    [anon_sym_gaslimit] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_yul_identifier] = STATE(776),
    [sym_yul_function_call] = STATE(263),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_yul_identifier] = STATE(776),
    [sym_yul_function_call] = STATE(289),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_yul_identifier] = STATE(776),
    [sym_yul_function_call] = STATE(269),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_yul_identifier] = STATE(776),
    [sym_yul_function_call] = STATE(287),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_yul_identifier] = STATE(776),
    [sym_yul_function_call] = STATE(280),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_yul_identifier] = STATE(776),
    [sym_yul_function_call] = STATE(267),
    [sym_yul_evm_builtin] = STATE(233),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_stop] = ACTIONS(849),
    [anon_sym_add] = ACTIONS(849),
    [anon_sym_sub] = ACTIONS(849),
    [anon_sym_mul] = ACTIONS(849),
    [anon_sym_div] = ACTIONS(849),
    [anon_sym_sdiv] = ACTIONS(849),
    [anon_sym_mod] = ACTIONS(849),
    [anon_sym_smod] = ACTIONS(849),
    [anon_sym_exp] = ACTIONS(849),
    [anon_sym_not] = ACTIONS(849),
    [anon_sym_lt] = ACTIONS(849),
    [anon_sym_gt] = ACTIONS(849),
    [anon_sym_slt] = ACTIONS(849),
    [anon_sym_sgt] = ACTIONS(849),
    [anon_sym_eq] = ACTIONS(849),
    [anon_sym_iszero] = ACTIONS(849),
    [anon_sym_and] = ACTIONS(849),
    [anon_sym_or] = ACTIONS(849),
    [anon_sym_xor] = ACTIONS(849),
    [anon_sym_byte] = ACTIONS(849),
    [anon_sym_shl] = ACTIONS(849),
    [anon_sym_shr] = ACTIONS(849),
    [anon_sym_sar] = ACTIONS(849),
    [anon_sym_addmod] = ACTIONS(849),
    [anon_sym_mulmod] = ACTIONS(849),
    [anon_sym_signextend] = ACTIONS(849),
    [anon_sym_keccak256] = ACTIONS(849),
    [anon_sym_pop] = ACTIONS(849),
    [anon_sym_mload] = ACTIONS(849),
    [anon_sym_mstore] = ACTIONS(849),
    [anon_sym_mstore8] = ACTIONS(849),
    [anon_sym_sload] = ACTIONS(849),
    [anon_sym_sstore] = ACTIONS(849),
    [anon_sym_msize] = ACTIONS(849),
    [anon_sym_gas] = ACTIONS(849),
    [anon_sym_address] = ACTIONS(849),
    [anon_sym_balance] = ACTIONS(849),
    [anon_sym_selfbalance] = ACTIONS(849),
    [anon_sym_caller] = ACTIONS(849),
    [anon_sym_callvalue] = ACTIONS(849),
    [anon_sym_calldataload] = ACTIONS(849),
    [anon_sym_calldatasize] = ACTIONS(849),
    [anon_sym_calldatacopy] = ACTIONS(849),
    [anon_sym_extcodesize] = ACTIONS(849),
    [anon_sym_extcodecopy] = ACTIONS(849),
    [anon_sym_returndatasize] = ACTIONS(849),
    [anon_sym_returndatacopy] = ACTIONS(849),
    [anon_sym_extcodehash] = ACTIONS(849),
    [anon_sym_create] = ACTIONS(849),
    [anon_sym_create2] = ACTIONS(849),
    [anon_sym_call] = ACTIONS(849),
    [anon_sym_callcode] = ACTIONS(849),
    [anon_sym_delegatecall] = ACTIONS(849),
    [anon_sym_staticcall] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_revert] = ACTIONS(849),
    [anon_sym_selfdestruct] = ACTIONS(849),
    [anon_sym_invalid] = ACTIONS(849),
    [anon_sym_log0] = ACTIONS(849),
    [anon_sym_log1] = ACTIONS(849),
    [anon_sym_log2] = ACTIONS(849),
    [anon_sym_log3] = ACTIONS(849),
    [anon_sym_log4] = ACTIONS(849),
    [anon_sym_chainid] = ACTIONS(849),
    [anon_sym_origin] = ACTIONS(849),
    [anon_sym_gasprice] = ACTIONS(849),
    [anon_sym_blockhash] = ACTIONS(849),
    [anon_sym_coinbase] = ACTIONS(849),
    [anon_sym_timestamp] = ACTIONS(849),
    [anon_sym_number] = ACTIONS(849),
    [anon_sym_difficulty] = ACTIONS(849),
    [anon_sym_gaslimit] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_visibility] = STATE(305),
    [sym_state_mutability] = STATE(305),
    [sym__return_parameters] = STATE(319),
    [aux_sym__function_type_repeat1] = STATE(305),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_constant] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_indexed] = ACTIONS(1227),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1229),
    [sym_unchecked] = ACTIONS(1227),
    [anon_sym_memory] = ACTIONS(1227),
    [anon_sym_storage] = ACTIONS(1227),
    [anon_sym_calldata] = ACTIONS(1227),
    [anon_sym_returns] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1233),
    [anon_sym_internal] = ACTIONS(1233),
    [anon_sym_private] = ACTIONS(1233),
    [anon_sym_external] = ACTIONS(1233),
    [anon_sym_pure] = ACTIONS(1235),
    [anon_sym_view] = ACTIONS(1235),
    [anon_sym_payable] = ACTIONS(1235),
    [sym_immutable] = ACTIONS(1227),
    [anon_sym_override] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_PLUS_EQ] = ACTIONS(1229),
    [anon_sym_DASH_EQ] = ACTIONS(1229),
    [anon_sym_STAR_EQ] = ACTIONS(1229),
    [anon_sym_SLASH_EQ] = ACTIONS(1229),
    [anon_sym_PERCENT_EQ] = ACTIONS(1229),
    [anon_sym_CARET_EQ] = ACTIONS(1229),
    [anon_sym_AMP_EQ] = ACTIONS(1229),
    [anon_sym_PIPE_EQ] = ACTIONS(1229),
    [anon_sym_GT_GT_EQ] = ACTIONS(1229),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1229),
    [anon_sym_LT_LT_EQ] = ACTIONS(1229),
    [sym__semicolon] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [aux_sym__identifier_path_repeat1] = STATE(304),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_constant] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_indexed] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1241),
    [sym_unchecked] = ACTIONS(1237),
    [anon_sym_memory] = ACTIONS(1237),
    [anon_sym_storage] = ACTIONS(1237),
    [anon_sym_calldata] = ACTIONS(1237),
    [anon_sym_returns] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_internal] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_external] = ACTIONS(1237),
    [anon_sym_pure] = ACTIONS(1237),
    [anon_sym_view] = ACTIONS(1237),
    [anon_sym_payable] = ACTIONS(1237),
    [sym_immutable] = ACTIONS(1237),
    [anon_sym_override] = ACTIONS(1237),
    [sym_virtual] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_GT] = ACTIONS(1239),
    [sym__semicolon] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_visibility] = STATE(305),
    [sym_state_mutability] = STATE(305),
    [aux_sym__function_type_repeat1] = STATE(305),
    [sym_identifier] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_CARET] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_GT_EQ] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_COMMA] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_constant] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_RPAREN] = ACTIONS(1246),
    [anon_sym_indexed] = ACTIONS(1244),
    [anon_sym_COLON] = ACTIONS(1246),
    [anon_sym_DOT] = ACTIONS(1246),
    [sym_unchecked] = ACTIONS(1244),
    [anon_sym_memory] = ACTIONS(1244),
    [anon_sym_storage] = ACTIONS(1244),
    [anon_sym_calldata] = ACTIONS(1244),
    [anon_sym_returns] = ACTIONS(1244),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_internal] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_external] = ACTIONS(1248),
    [anon_sym_pure] = ACTIONS(1251),
    [anon_sym_view] = ACTIONS(1251),
    [anon_sym_payable] = ACTIONS(1251),
    [sym_immutable] = ACTIONS(1244),
    [anon_sym_override] = ACTIONS(1244),
    [anon_sym_QMARK] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_RBRACK] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1244),
    [anon_sym_GT_GT_GT] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1244),
    [anon_sym_SLASH] = ACTIONS(1244),
    [anon_sym_PERCENT] = ACTIONS(1244),
    [anon_sym_STAR_STAR] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ] = ACTIONS(1244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_EQ] = ACTIONS(1246),
    [anon_sym_DASH_EQ] = ACTIONS(1246),
    [anon_sym_STAR_EQ] = ACTIONS(1246),
    [anon_sym_SLASH_EQ] = ACTIONS(1246),
    [anon_sym_PERCENT_EQ] = ACTIONS(1246),
    [anon_sym_CARET_EQ] = ACTIONS(1246),
    [anon_sym_AMP_EQ] = ACTIONS(1246),
    [anon_sym_PIPE_EQ] = ACTIONS(1246),
    [anon_sym_GT_GT_EQ] = ACTIONS(1246),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1246),
    [anon_sym_LT_LT_EQ] = ACTIONS(1246),
    [sym__semicolon] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_constant] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_indexed] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1239),
    [sym_unchecked] = ACTIONS(1237),
    [anon_sym_memory] = ACTIONS(1237),
    [anon_sym_storage] = ACTIONS(1237),
    [anon_sym_calldata] = ACTIONS(1237),
    [anon_sym_returns] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_internal] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_external] = ACTIONS(1237),
    [anon_sym_pure] = ACTIONS(1237),
    [anon_sym_view] = ACTIONS(1237),
    [anon_sym_payable] = ACTIONS(1237),
    [sym_immutable] = ACTIONS(1237),
    [anon_sym_override] = ACTIONS(1237),
    [sym_virtual] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_EQ] = ACTIONS(1239),
    [anon_sym_DASH_EQ] = ACTIONS(1239),
    [anon_sym_STAR_EQ] = ACTIONS(1239),
    [anon_sym_SLASH_EQ] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1239),
    [anon_sym_CARET_EQ] = ACTIONS(1239),
    [anon_sym_AMP_EQ] = ACTIONS(1239),
    [anon_sym_PIPE_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1239),
    [anon_sym_LT_LT_EQ] = ACTIONS(1239),
    [anon_sym_EQ_GT] = ACTIONS(1239),
    [sym__semicolon] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_visibility] = STATE(303),
    [sym_state_mutability] = STATE(303),
    [sym__return_parameters] = STATE(321),
    [aux_sym__function_type_repeat1] = STATE(303),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_CARET] = ACTIONS(1254),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_constant] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_indexed] = ACTIONS(1254),
    [anon_sym_COLON] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1256),
    [sym_unchecked] = ACTIONS(1254),
    [anon_sym_memory] = ACTIONS(1254),
    [anon_sym_storage] = ACTIONS(1254),
    [anon_sym_calldata] = ACTIONS(1254),
    [anon_sym_returns] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1233),
    [anon_sym_internal] = ACTIONS(1233),
    [anon_sym_private] = ACTIONS(1233),
    [anon_sym_external] = ACTIONS(1233),
    [anon_sym_pure] = ACTIONS(1235),
    [anon_sym_view] = ACTIONS(1235),
    [anon_sym_payable] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_RBRACK] = ACTIONS(1256),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_GT_GT_GT] = ACTIONS(1254),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_STAR_STAR] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1256),
    [anon_sym_PLUS_PLUS] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1256),
    [anon_sym_PLUS_EQ] = ACTIONS(1256),
    [anon_sym_DASH_EQ] = ACTIONS(1256),
    [anon_sym_STAR_EQ] = ACTIONS(1256),
    [anon_sym_SLASH_EQ] = ACTIONS(1256),
    [anon_sym_PERCENT_EQ] = ACTIONS(1256),
    [anon_sym_CARET_EQ] = ACTIONS(1256),
    [anon_sym_AMP_EQ] = ACTIONS(1256),
    [anon_sym_PIPE_EQ] = ACTIONS(1256),
    [anon_sym_GT_GT_EQ] = ACTIONS(1256),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1256),
    [anon_sym_LT_LT_EQ] = ACTIONS(1256),
    [sym__semicolon] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_PIPE_PIPE] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_LT_EQ] = ACTIONS(1260),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_CARET] = ACTIONS(1258),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1260),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1260),
    [anon_sym_constant] = ACTIONS(1258),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_indexed] = ACTIONS(1258),
    [anon_sym_COLON] = ACTIONS(1260),
    [anon_sym_DOT] = ACTIONS(1260),
    [sym_unchecked] = ACTIONS(1258),
    [anon_sym_memory] = ACTIONS(1258),
    [anon_sym_storage] = ACTIONS(1258),
    [anon_sym_calldata] = ACTIONS(1258),
    [anon_sym_returns] = ACTIONS(1258),
    [anon_sym_public] = ACTIONS(1258),
    [anon_sym_internal] = ACTIONS(1258),
    [anon_sym_private] = ACTIONS(1258),
    [anon_sym_external] = ACTIONS(1258),
    [anon_sym_pure] = ACTIONS(1258),
    [anon_sym_view] = ACTIONS(1258),
    [anon_sym_payable] = ACTIONS(1258),
    [sym_immutable] = ACTIONS(1258),
    [anon_sym_override] = ACTIONS(1258),
    [sym_virtual] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_RBRACK] = ACTIONS(1260),
    [anon_sym_AMP_AMP] = ACTIONS(1260),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_GT_GT_GT] = ACTIONS(1258),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_STAR_STAR] = ACTIONS(1260),
    [anon_sym_EQ_EQ] = ACTIONS(1260),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1260),
    [anon_sym_PLUS_PLUS] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1260),
    [anon_sym_PLUS_EQ] = ACTIONS(1260),
    [anon_sym_DASH_EQ] = ACTIONS(1260),
    [anon_sym_STAR_EQ] = ACTIONS(1260),
    [anon_sym_SLASH_EQ] = ACTIONS(1260),
    [anon_sym_PERCENT_EQ] = ACTIONS(1260),
    [anon_sym_CARET_EQ] = ACTIONS(1260),
    [anon_sym_AMP_EQ] = ACTIONS(1260),
    [anon_sym_PIPE_EQ] = ACTIONS(1260),
    [anon_sym_GT_GT_EQ] = ACTIONS(1260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1260),
    [anon_sym_LT_LT_EQ] = ACTIONS(1260),
    [sym__semicolon] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_PIPE_PIPE] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_LT_EQ] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_CARET] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1264),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1264),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_RBRACE] = ACTIONS(1264),
    [anon_sym_constant] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_indexed] = ACTIONS(1262),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1264),
    [sym_unchecked] = ACTIONS(1262),
    [anon_sym_memory] = ACTIONS(1262),
    [anon_sym_storage] = ACTIONS(1262),
    [anon_sym_calldata] = ACTIONS(1262),
    [anon_sym_returns] = ACTIONS(1262),
    [anon_sym_public] = ACTIONS(1262),
    [anon_sym_internal] = ACTIONS(1262),
    [anon_sym_private] = ACTIONS(1262),
    [anon_sym_external] = ACTIONS(1262),
    [anon_sym_pure] = ACTIONS(1262),
    [anon_sym_view] = ACTIONS(1262),
    [anon_sym_payable] = ACTIONS(1262),
    [sym_immutable] = ACTIONS(1262),
    [anon_sym_override] = ACTIONS(1262),
    [sym_virtual] = ACTIONS(1262),
    [anon_sym_QMARK] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1264),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_AMP_AMP] = ACTIONS(1264),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_GT_GT_GT] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_AMP] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_STAR_STAR] = ACTIONS(1264),
    [anon_sym_EQ_EQ] = ACTIONS(1264),
    [anon_sym_BANG_EQ] = ACTIONS(1262),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1264),
    [anon_sym_PLUS_PLUS] = ACTIONS(1264),
    [anon_sym_DASH_DASH] = ACTIONS(1264),
    [anon_sym_PLUS_EQ] = ACTIONS(1264),
    [anon_sym_DASH_EQ] = ACTIONS(1264),
    [anon_sym_STAR_EQ] = ACTIONS(1264),
    [anon_sym_SLASH_EQ] = ACTIONS(1264),
    [anon_sym_PERCENT_EQ] = ACTIONS(1264),
    [anon_sym_CARET_EQ] = ACTIONS(1264),
    [anon_sym_AMP_EQ] = ACTIONS(1264),
    [anon_sym_PIPE_EQ] = ACTIONS(1264),
    [anon_sym_GT_GT_EQ] = ACTIONS(1264),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1264),
    [anon_sym_LT_LT_EQ] = ACTIONS(1264),
    [sym__semicolon] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1266),
    [anon_sym_PIPE_PIPE] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_LT_EQ] = ACTIONS(1268),
    [anon_sym_LT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1266),
    [anon_sym_GT] = ACTIONS(1266),
    [anon_sym_GT_EQ] = ACTIONS(1268),
    [anon_sym_EQ] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_COMMA] = ACTIONS(1268),
    [anon_sym_RBRACE] = ACTIONS(1268),
    [anon_sym_constant] = ACTIONS(1266),
    [anon_sym_LPAREN] = ACTIONS(1268),
    [anon_sym_RPAREN] = ACTIONS(1268),
    [anon_sym_indexed] = ACTIONS(1266),
    [anon_sym_COLON] = ACTIONS(1268),
    [anon_sym_DOT] = ACTIONS(1268),
    [sym_unchecked] = ACTIONS(1266),
    [anon_sym_memory] = ACTIONS(1266),
    [anon_sym_storage] = ACTIONS(1266),
    [anon_sym_calldata] = ACTIONS(1266),
    [anon_sym_returns] = ACTIONS(1266),
    [anon_sym_public] = ACTIONS(1266),
    [anon_sym_internal] = ACTIONS(1266),
    [anon_sym_private] = ACTIONS(1266),
    [anon_sym_external] = ACTIONS(1266),
    [anon_sym_pure] = ACTIONS(1266),
    [anon_sym_view] = ACTIONS(1266),
    [anon_sym_payable] = ACTIONS(1266),
    [sym_immutable] = ACTIONS(1266),
    [anon_sym_override] = ACTIONS(1266),
    [sym_virtual] = ACTIONS(1266),
    [anon_sym_QMARK] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_AMP_AMP] = ACTIONS(1268),
    [anon_sym_GT_GT] = ACTIONS(1266),
    [anon_sym_GT_GT_GT] = ACTIONS(1266),
    [anon_sym_LT_LT] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1266),
    [anon_sym_PIPE] = ACTIONS(1266),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1266),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_STAR_STAR] = ACTIONS(1268),
    [anon_sym_EQ_EQ] = ACTIONS(1268),
    [anon_sym_BANG_EQ] = ACTIONS(1266),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1268),
    [anon_sym_DASH_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_EQ] = ACTIONS(1268),
    [anon_sym_DASH_EQ] = ACTIONS(1268),
    [anon_sym_STAR_EQ] = ACTIONS(1268),
    [anon_sym_SLASH_EQ] = ACTIONS(1268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1268),
    [anon_sym_CARET_EQ] = ACTIONS(1268),
    [anon_sym_AMP_EQ] = ACTIONS(1268),
    [anon_sym_PIPE_EQ] = ACTIONS(1268),
    [anon_sym_GT_GT_EQ] = ACTIONS(1268),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1268),
    [anon_sym_LT_LT_EQ] = ACTIONS(1268),
    [sym__semicolon] = ACTIONS(1268),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_identifier] = ACTIONS(1270),
    [anon_sym_PIPE_PIPE] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_LT_EQ] = ACTIONS(1272),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_EQ] = ACTIONS(1272),
    [anon_sym_EQ] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1272),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_RBRACE] = ACTIONS(1272),
    [anon_sym_constant] = ACTIONS(1270),
    [anon_sym_LPAREN] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(1272),
    [anon_sym_indexed] = ACTIONS(1270),
    [anon_sym_COLON] = ACTIONS(1272),
    [anon_sym_DOT] = ACTIONS(1272),
    [sym_unchecked] = ACTIONS(1270),
    [anon_sym_memory] = ACTIONS(1270),
    [anon_sym_storage] = ACTIONS(1270),
    [anon_sym_calldata] = ACTIONS(1270),
    [anon_sym_returns] = ACTIONS(1270),
    [anon_sym_public] = ACTIONS(1270),
    [anon_sym_internal] = ACTIONS(1270),
    [anon_sym_private] = ACTIONS(1270),
    [anon_sym_external] = ACTIONS(1270),
    [anon_sym_pure] = ACTIONS(1270),
    [anon_sym_view] = ACTIONS(1270),
    [anon_sym_payable] = ACTIONS(1270),
    [sym_immutable] = ACTIONS(1270),
    [anon_sym_override] = ACTIONS(1270),
    [sym_virtual] = ACTIONS(1270),
    [anon_sym_QMARK] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(1270),
    [anon_sym_GT_GT_GT] = ACTIONS(1270),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_AMP] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_PLUS] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_STAR_STAR] = ACTIONS(1272),
    [anon_sym_EQ_EQ] = ACTIONS(1272),
    [anon_sym_BANG_EQ] = ACTIONS(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1272),
    [anon_sym_PLUS_PLUS] = ACTIONS(1272),
    [anon_sym_DASH_DASH] = ACTIONS(1272),
    [anon_sym_PLUS_EQ] = ACTIONS(1272),
    [anon_sym_DASH_EQ] = ACTIONS(1272),
    [anon_sym_STAR_EQ] = ACTIONS(1272),
    [anon_sym_SLASH_EQ] = ACTIONS(1272),
    [anon_sym_PERCENT_EQ] = ACTIONS(1272),
    [anon_sym_CARET_EQ] = ACTIONS(1272),
    [anon_sym_AMP_EQ] = ACTIONS(1272),
    [anon_sym_PIPE_EQ] = ACTIONS(1272),
    [anon_sym_GT_GT_EQ] = ACTIONS(1272),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1272),
    [anon_sym_LT_LT_EQ] = ACTIONS(1272),
    [sym__semicolon] = ACTIONS(1272),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1274),
    [anon_sym_PIPE_PIPE] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_LT_EQ] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_CARET] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_GT_EQ] = ACTIONS(1276),
    [anon_sym_EQ] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1276),
    [anon_sym_RBRACE] = ACTIONS(1276),
    [anon_sym_constant] = ACTIONS(1274),
    [anon_sym_LPAREN] = ACTIONS(1276),
    [anon_sym_RPAREN] = ACTIONS(1276),
    [anon_sym_indexed] = ACTIONS(1274),
    [anon_sym_COLON] = ACTIONS(1276),
    [anon_sym_DOT] = ACTIONS(1276),
    [sym_unchecked] = ACTIONS(1274),
    [anon_sym_memory] = ACTIONS(1274),
    [anon_sym_storage] = ACTIONS(1274),
    [anon_sym_calldata] = ACTIONS(1274),
    [anon_sym_returns] = ACTIONS(1274),
    [anon_sym_public] = ACTIONS(1274),
    [anon_sym_internal] = ACTIONS(1274),
    [anon_sym_private] = ACTIONS(1274),
    [anon_sym_external] = ACTIONS(1274),
    [anon_sym_pure] = ACTIONS(1274),
    [anon_sym_view] = ACTIONS(1274),
    [anon_sym_payable] = ACTIONS(1274),
    [sym_immutable] = ACTIONS(1274),
    [anon_sym_override] = ACTIONS(1274),
    [sym_virtual] = ACTIONS(1274),
    [anon_sym_QMARK] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(1276),
    [anon_sym_AMP_AMP] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1274),
    [anon_sym_GT_GT_GT] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_STAR_STAR] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1276),
    [anon_sym_BANG_EQ] = ACTIONS(1274),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1276),
    [anon_sym_PLUS_PLUS] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1276),
    [anon_sym_PLUS_EQ] = ACTIONS(1276),
    [anon_sym_DASH_EQ] = ACTIONS(1276),
    [anon_sym_STAR_EQ] = ACTIONS(1276),
    [anon_sym_SLASH_EQ] = ACTIONS(1276),
    [anon_sym_PERCENT_EQ] = ACTIONS(1276),
    [anon_sym_CARET_EQ] = ACTIONS(1276),
    [anon_sym_AMP_EQ] = ACTIONS(1276),
    [anon_sym_PIPE_EQ] = ACTIONS(1276),
    [anon_sym_GT_GT_EQ] = ACTIONS(1276),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1276),
    [anon_sym_LT_LT_EQ] = ACTIONS(1276),
    [sym__semicolon] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_identifier] = ACTIONS(1278),
    [anon_sym_PIPE_PIPE] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_CARET] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_EQ] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_constant] = ACTIONS(1278),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_indexed] = ACTIONS(1278),
    [anon_sym_COLON] = ACTIONS(1280),
    [anon_sym_DOT] = ACTIONS(1280),
    [sym_unchecked] = ACTIONS(1278),
    [anon_sym_memory] = ACTIONS(1278),
    [anon_sym_storage] = ACTIONS(1278),
    [anon_sym_calldata] = ACTIONS(1278),
    [anon_sym_returns] = ACTIONS(1278),
    [anon_sym_public] = ACTIONS(1278),
    [anon_sym_internal] = ACTIONS(1278),
    [anon_sym_private] = ACTIONS(1278),
    [anon_sym_external] = ACTIONS(1278),
    [anon_sym_pure] = ACTIONS(1278),
    [anon_sym_view] = ACTIONS(1278),
    [anon_sym_payable] = ACTIONS(1278),
    [sym_immutable] = ACTIONS(1278),
    [anon_sym_override] = ACTIONS(1278),
    [sym_virtual] = ACTIONS(1278),
    [anon_sym_QMARK] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_AMP_AMP] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(1278),
    [anon_sym_GT_GT_GT] = ACTIONS(1278),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(1278),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1278),
    [anon_sym_STAR_STAR] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1280),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1280),
    [anon_sym_PLUS_PLUS] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1280),
    [anon_sym_PLUS_EQ] = ACTIONS(1280),
    [anon_sym_DASH_EQ] = ACTIONS(1280),
    [anon_sym_STAR_EQ] = ACTIONS(1280),
    [anon_sym_SLASH_EQ] = ACTIONS(1280),
    [anon_sym_PERCENT_EQ] = ACTIONS(1280),
    [anon_sym_CARET_EQ] = ACTIONS(1280),
    [anon_sym_AMP_EQ] = ACTIONS(1280),
    [anon_sym_PIPE_EQ] = ACTIONS(1280),
    [anon_sym_GT_GT_EQ] = ACTIONS(1280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_LT_EQ] = ACTIONS(1280),
    [sym__semicolon] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_payable,
    ACTIONS(1282), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1284), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [72] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 30,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1290), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1284), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1294), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1296), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1298), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1302), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1306), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1229), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1310), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1310), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1314), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1318), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(386), 1,
      sym_number_unit,
    ACTIONS(1324), 11,
      anon_sym_wei,
      anon_sym_szabo,
      anon_sym_finney,
      anon_sym_gwei,
      anon_sym_ether,
      anon_sym_seconds,
      anon_sym_minutes,
      anon_sym_hours,
      anon_sym_days,
      anon_sym_weeks,
      anon_sym_years,
    ACTIONS(1322), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1320), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1328), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1332), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1336), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1340), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1342), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1344), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1348), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1352), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1354), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1356), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1360), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1362), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1364), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1368), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 1,
      anon_sym_DOT,
    STATE(339), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1370), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1375), 17,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(304), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1382), 21,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1384), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1167), 38,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_case,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [1827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1173), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1175), 38,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_case,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [1888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 1,
      anon_sym_DQUOTE,
    ACTIONS(1393), 1,
      anon_sym_SQUOTE,
    STATE(342), 2,
      sym_string,
      aux_sym_string_literal_repeat1,
    ACTIONS(1388), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1386), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1954] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    STATE(342), 2,
      sym_string,
      aux_sym_string_literal_repeat1,
    ACTIONS(1398), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1396), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1403), 17,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1400), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      anon_sym_hex,
    STATE(345), 1,
      aux_sym_hex_string_literal_repeat2,
    ACTIONS(1408), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1406), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_unicode,
    STATE(346), 1,
      aux_sym_unicode_string_literal_repeat3,
    ACTIONS(1415), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1413), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 1,
      anon_sym_hex,
    STATE(345), 1,
      aux_sym_hex_string_literal_repeat2,
    ACTIONS(1422), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1420), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 1,
      anon_sym_unicode,
    STATE(346), 1,
      aux_sym_unicode_string_literal_repeat3,
    ACTIONS(1428), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1426), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2330] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1434), 9,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
    ACTIONS(1432), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1444), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_hex,
  [2454] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1462), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [2545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1434), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1432), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1434), 4,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1432), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_LPAREN,
    STATE(373), 1,
      sym__call_arguments,
    ACTIONS(1478), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1434), 7,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
    ACTIONS(1432), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1485), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1483), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2874] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1434), 3,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1432), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1487), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_hex,
  [3008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    STATE(398), 1,
      sym__call_arguments,
    ACTIONS(1493), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1491), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1485), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1483), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1497), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_hex,
  [3189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_unicode,
  [3246] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1505), 1,
      anon_sym_EQ,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1507), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1485), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1483), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1509), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_unicode,
  [3447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1434), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1432), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1515), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1513), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3573] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1517), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [3664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1519), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1523), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1527), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1531), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1539), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1575), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1579), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1583), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1587), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1591), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4728] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_LPAREN,
    ACTIONS(1595), 1,
      anon_sym_LBRACK,
    STATE(373), 1,
      sym__call_arguments,
    ACTIONS(1296), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1478), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1598), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1602), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1606), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1610), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1616), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1614), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1620), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1618), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1622), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1626), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1630), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1634), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1638), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1642), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_LBRACK,
    ACTIONS(1296), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1478), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 27,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5523] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 1,
      anon_sym_DOT,
    ACTIONS(1646), 1,
      anon_sym_COLON,
    STATE(339), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1370), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1375), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1648), 1,
      anon_sym_LPAREN,
    ACTIONS(1282), 19,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1284), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5641] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1650), 1,
      anon_sym_COMMA,
    ACTIONS(1652), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym__call_arguments,
    STATE(622), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [5731] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1654), 1,
      anon_sym_LBRACE,
    ACTIONS(1656), 1,
      sym_unchecked,
    ACTIONS(1658), 1,
      anon_sym_returns,
    STATE(371), 1,
      sym__call_arguments,
    STATE(539), 1,
      sym_block_statement,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [5821] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1660), 1,
      anon_sym_COMMA,
    ACTIONS(1662), 1,
      anon_sym_RBRACK,
    STATE(371), 1,
      sym__call_arguments,
    STATE(633), 1,
      aux_sym_inline_array_expression_repeat1,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [5911] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1650), 1,
      anon_sym_COMMA,
    ACTIONS(1652), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym__call_arguments,
    STATE(622), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6001] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1664), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6086] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1666), 1,
      anon_sym_COLON,
    ACTIONS(1668), 1,
      anon_sym_RBRACK,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6173] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1670), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(364), 1,
      anon_sym_catch,
    ACTIONS(1553), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 27,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6311] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1672), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6396] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1674), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6481] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1676), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6566] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1678), 1,
      anon_sym_COLON,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6650] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6734] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1682), 1,
      sym__semicolon,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6818] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1684), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6902] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1686), 1,
      sym__semicolon,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6986] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1688), 1,
      anon_sym_RBRACK,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7070] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1690), 1,
      sym__semicolon,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7154] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1692), 1,
      sym__semicolon,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7238] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1694), 1,
      sym__semicolon,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7322] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1696), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7406] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1698), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7490] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1700), 1,
      anon_sym_RBRACK,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7574] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1702), 1,
      sym__semicolon,
    STATE(430), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7658] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1704), 1,
      anon_sym_RBRACK,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7742] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    ACTIONS(1706), 1,
      sym__semicolon,
    STATE(371), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym__semicolon,
    ACTIONS(1529), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1527), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_EQ,
    ACTIONS(1557), 14,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [7928] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 1,
      anon_sym_DOT,
    ACTIONS(1466), 1,
      anon_sym_QMARK,
    ACTIONS(1468), 1,
      anon_sym_LBRACK,
    ACTIONS(1470), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1472), 1,
      anon_sym_AMP,
    STATE(434), 1,
      sym__call_arguments,
    ACTIONS(1442), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1450), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1456), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1454), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1452), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1436), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1474), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_EQ,
    ACTIONS(1561), 14,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [8060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      sym__semicolon,
    ACTIONS(1529), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1527), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 1,
      sym__semicolon,
    ACTIONS(1561), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8162] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_DOT,
    STATE(437), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1716), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      sym__semicolon,
    ACTIONS(1370), 18,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_DOT,
    STATE(304), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1384), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      sym__semicolon,
    ACTIONS(1382), 18,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8240] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1231), 1,
      anon_sym_returns,
    ACTIONS(1256), 1,
      anon_sym_LBRACK,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1724), 1,
      sym_virtual,
    ACTIONS(1726), 1,
      sym__semicolon,
    STATE(180), 1,
      sym_function_body,
    STATE(303), 1,
      aux_sym__function_type_repeat1,
    STATE(321), 1,
      sym__return_parameters,
    STATE(451), 1,
      sym__identifier_path,
    ACTIONS(1254), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(448), 2,
      sym_visibility,
      sym_state_mutability,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    STATE(444), 3,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [8301] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1728), 1,
      anon_sym_LBRACE,
    ACTIONS(1730), 1,
      anon_sym_returns,
    ACTIONS(1732), 1,
      sym_virtual,
    ACTIONS(1734), 1,
      sym__semicolon,
    STATE(171), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    STATE(575), 1,
      sym_return_type_definition,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(442), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8350] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1730), 1,
      anon_sym_returns,
    ACTIONS(1736), 1,
      sym_virtual,
    ACTIONS(1738), 1,
      sym__semicolon,
    STATE(196), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    STATE(543), 1,
      sym_return_type_definition,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(443), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8399] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1730), 1,
      anon_sym_returns,
    ACTIONS(1740), 1,
      sym_virtual,
    ACTIONS(1742), 1,
      sym__semicolon,
    STATE(163), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    STATE(547), 1,
      sym_return_type_definition,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(440), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8448] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1728), 1,
      anon_sym_LBRACE,
    ACTIONS(1730), 1,
      anon_sym_returns,
    ACTIONS(1736), 1,
      sym_virtual,
    ACTIONS(1744), 1,
      sym__semicolon,
    STATE(149), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    STATE(616), 1,
      sym_return_type_definition,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(443), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8497] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_returns,
    ACTIONS(1759), 1,
      anon_sym_override,
    ACTIONS(1762), 1,
      sym_virtual,
    STATE(451), 1,
      sym__identifier_path,
    ACTIONS(1749), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1756), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1753), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(443), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8538] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1765), 1,
      sym_virtual,
    ACTIONS(1767), 1,
      sym__semicolon,
    STATE(160), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(446), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [8581] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1724), 1,
      sym_virtual,
    ACTIONS(1726), 1,
      sym__semicolon,
    STATE(180), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    ACTIONS(1235), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(444), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [8624] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 1,
      sym_identifier,
    ACTIONS(1780), 1,
      anon_sym_override,
    ACTIONS(1783), 1,
      sym_virtual,
    STATE(451), 1,
      sym__identifier_path,
    ACTIONS(1772), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1777), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1774), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(446), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [8662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    ACTIONS(1788), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1786), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1799), 1,
      sym_virtual,
    ACTIONS(1801), 1,
      anon_sym_LBRACK,
    ACTIONS(1795), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1797), 3,
      anon_sym_constant,
      anon_sym_returns,
      sym_immutable,
    ACTIONS(1792), 9,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_identifier,
  [8718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1803), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1807), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(453), 1,
      sym__call_arguments,
    ACTIONS(1813), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1811), 11,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1817), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1815), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1819), 11,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      sym_solidity_version,
    ACTIONS(1829), 1,
      sym__semicolon,
    STATE(455), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(459), 1,
      sym__pragma_version_constraint,
    STATE(797), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1827), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1825), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [8865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1831), 1,
      sym_solidity_version,
    ACTIONS(1840), 1,
      sym__semicolon,
    STATE(455), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(459), 1,
      sym__pragma_version_constraint,
    STATE(797), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1837), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [8895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1842), 1,
      sym_identifier,
    STATE(470), 1,
      sym_visibility,
    ACTIONS(1844), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(458), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [8925] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      sym_solidity_version,
    ACTIONS(1846), 1,
      sym__semicolon,
    STATE(454), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(459), 1,
      sym__pragma_version_constraint,
    STATE(797), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1827), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1825), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [8955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 1,
      anon_sym_override,
    ACTIONS(1848), 1,
      sym_identifier,
    STATE(470), 1,
      sym_visibility,
    ACTIONS(1850), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(461), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1233), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [8982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH,
    ACTIONS(1856), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 7,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      sym__semicolon,
  [9003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1860), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      sym__semicolon,
  [9022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1862), 1,
      sym_identifier,
    ACTIONS(1870), 1,
      anon_sym_override,
    STATE(470), 1,
      sym_visibility,
    ACTIONS(1864), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(461), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1867), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [9049] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(1873), 1,
      sym_identifier,
    ACTIONS(1875), 1,
      anon_sym_STAR,
    ACTIONS(1877), 1,
      anon_sym_LBRACE,
    STATE(582), 1,
      sym_string,
    STATE(690), 1,
      sym__import_clause,
    STATE(762), 1,
      sym__multiple_import,
    STATE(767), 1,
      sym__single_import,
    STATE(784), 1,
      sym__source_import,
  [9083] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(1879), 1,
      sym_yul_decimal_number,
    ACTIONS(1881), 1,
      sym_yul_hex_number,
    STATE(244), 1,
      sym_string,
    ACTIONS(1883), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(688), 3,
      sym__yul_literal,
      sym_yul_string_literal,
      sym_yul_boolean,
  [9111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    STATE(170), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    STATE(467), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1885), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [9136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1887), 7,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      sym__semicolon,
  [9153] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1893), 1,
      anon_sym_override,
    ACTIONS(1895), 1,
      sym_virtual,
    ACTIONS(1897), 1,
      sym__semicolon,
    STATE(173), 1,
      sym_function_body,
    STATE(474), 1,
      sym__parameter_list,
    STATE(473), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9182] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_function_body,
    STATE(451), 1,
      sym__identifier_path,
    STATE(468), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1899), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [9207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 1,
      sym_identifier,
    ACTIONS(1904), 1,
      anon_sym_LBRACE,
    STATE(451), 1,
      sym__identifier_path,
    STATE(468), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1906), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [9229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(1909), 1,
      sym_identifier,
    STATE(570), 1,
      sym__storage_location,
    ACTIONS(1911), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1913), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [9251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 8,
      anon_sym_constant,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      sym_identifier,
  [9265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    STATE(679), 1,
      sym__storage_location,
    ACTIONS(1917), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1919), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [9284] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_override,
    ACTIONS(1921), 1,
      sym_virtual,
    ACTIONS(1923), 1,
      sym__semicolon,
    STATE(211), 1,
      sym_function_body,
    STATE(476), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_override,
    ACTIONS(1921), 1,
      sym_virtual,
    ACTIONS(1925), 1,
      sym__semicolon,
    STATE(148), 1,
      sym_function_body,
    STATE(476), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(1893), 1,
      anon_sym_override,
    ACTIONS(1925), 1,
      sym__semicolon,
    ACTIONS(1927), 1,
      sym_virtual,
    STATE(148), 1,
      sym_function_body,
    STATE(472), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9353] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      sym_unchecked,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1929), 1,
      sym_identifier,
    STATE(79), 1,
      sym_block_statement,
    STATE(623), 1,
      sym__parameter_list,
  [9375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1933), 1,
      anon_sym_override,
    ACTIONS(1936), 1,
      sym_virtual,
    ACTIONS(1931), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    STATE(476), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9393] = 5,
    ACTIONS(1939), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym__escape_sequence,
    ACTIONS(1944), 1,
      aux_sym__double_quoted_unicode_char_token1,
    ACTIONS(1947), 1,
      sym_comment,
    STATE(477), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 1,
      sym__hex_digit,
    ACTIONS(1954), 1,
      anon_sym__,
    STATE(478), 1,
      aux_sym_hex_string_literal_repeat1,
    ACTIONS(1952), 2,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [9427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1961), 1,
      anon_sym_indexed,
    ACTIONS(1959), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    ACTIONS(1965), 1,
      anon_sym_LBRACE,
    STATE(315), 1,
      sym__identifier_path,
    STATE(507), 1,
      sym_user_defined_type,
    STATE(647), 1,
      sym_inheritance_specifier,
  [9463] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(1969), 1,
      sym__escape_sequence,
    ACTIONS(1971), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(492), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9480] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_DQUOTE,
    ACTIONS(1973), 1,
      sym__escape_sequence,
    ACTIONS(1975), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(477), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9497] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1977), 1,
      anon_sym_SQUOTE,
    ACTIONS(1979), 1,
      sym__escape_sequence,
    ACTIONS(1981), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(481), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9514] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1977), 1,
      anon_sym_DQUOTE,
    ACTIONS(1983), 1,
      sym__escape_sequence,
    ACTIONS(1985), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(482), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9531] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_DQUOTE,
    ACTIONS(1989), 1,
      sym__escape_sequence,
    ACTIONS(1991), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(488), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(1993), 1,
      sym_identifier,
    ACTIONS(1995), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [9563] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_SQUOTE,
    ACTIONS(1997), 1,
      sym__escape_sequence,
    ACTIONS(1999), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(491), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9580] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1973), 1,
      sym__escape_sequence,
    ACTIONS(1975), 1,
      aux_sym__double_quoted_unicode_char_token1,
    ACTIONS(2001), 1,
      anon_sym_DQUOTE,
    STATE(477), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      sym_identifier,
    ACTIONS(2005), 1,
      anon_sym_solidity,
    STATE(457), 1,
      sym__solidity,
    STATE(819), 2,
      sym_solidity_pragma_token,
      sym_any_pragma_token,
  [9614] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    STATE(315), 1,
      sym__identifier_path,
    STATE(507), 1,
      sym_user_defined_type,
    STATE(647), 1,
      sym_inheritance_specifier,
  [9633] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(1969), 1,
      sym__escape_sequence,
    ACTIONS(1971), 1,
      aux_sym__single_quoted_unicode_char_token1,
    ACTIONS(2001), 1,
      anon_sym_SQUOTE,
    STATE(492), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9650] = 5,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_SQUOTE,
    ACTIONS(2011), 1,
      sym__escape_sequence,
    ACTIONS(2014), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(492), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2017), 1,
      anon_sym_COMMA,
    STATE(271), 1,
      sym_yul_block,
    STATE(511), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [9683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    ACTIONS(2019), 1,
      anon_sym_RPAREN,
    STATE(315), 1,
      sym__identifier_path,
    STATE(699), 1,
      sym_user_defined_type,
  [9699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2021), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(266), 1,
      sym_yul_block,
  [9715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2021), 1,
      anon_sym_COMMA,
    STATE(266), 1,
      sym_yul_block,
    STATE(501), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [9731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    ACTIONS(2025), 1,
      anon_sym_is,
    STATE(201), 1,
      sym_contract_body,
    STATE(686), 1,
      sym__class_heritage,
  [9747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    ACTIONS(2025), 1,
      anon_sym_is,
    STATE(203), 1,
      sym_contract_body,
    STATE(685), 1,
      sym__class_heritage,
  [9763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(268), 1,
      sym_yul_block,
  [9779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2029), 1,
      anon_sym_COMMA,
    STATE(268), 1,
      sym_yul_block,
    STATE(504), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [9795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2029), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(268), 1,
      sym_yul_block,
  [9811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(271), 1,
      sym_yul_block,
  [9827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      sym_identifier,
    ACTIONS(2033), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2017), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(271), 1,
      sym_yul_block,
  [9857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 4,
      sym__hex_digit,
      anon_sym_DQUOTE,
      anon_sym__,
      anon_sym_SQUOTE,
  [9867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    STATE(315), 1,
      sym__identifier_path,
    STATE(507), 1,
      sym_user_defined_type,
    STATE(647), 1,
      sym_inheritance_specifier,
  [9883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(719), 1,
      sym__call_arguments,
    ACTIONS(2035), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [9897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2037), 1,
      sym__hex_digit,
    ACTIONS(2039), 1,
      anon_sym__,
    ACTIONS(2041), 1,
      anon_sym_SQUOTE,
    STATE(478), 1,
      aux_sym_hex_string_literal_repeat1,
  [9913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_RPAREN,
    STATE(562), 1,
      sym_string,
  [9929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(274), 1,
      sym_yul_block,
  [9945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2045), 1,
      anon_sym_COMMA,
    STATE(242), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(274), 1,
      sym_yul_block,
  [9961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(278), 1,
      sym_yul_block,
  [9977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__semicolon,
  [9987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(266), 1,
      sym_yul_block,
  [10003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2037), 1,
      sym__hex_digit,
    ACTIONS(2039), 1,
      anon_sym__,
    ACTIONS(2041), 1,
      anon_sym_DQUOTE,
    STATE(478), 1,
      aux_sym_hex_string_literal_repeat1,
  [10019] = 4,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2049), 1,
      anon_sym_DQUOTE,
    ACTIONS(2051), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(530), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [10033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(2053), 1,
      anon_sym_RPAREN,
    STATE(654), 1,
      sym_string,
  [10049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 4,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym__semicolon,
  [10059] = 4,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2057), 1,
      anon_sym_SQUOTE,
    ACTIONS(2059), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(519), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [10073] = 4,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_DQUOTE,
    ACTIONS(2064), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(520), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [10087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 1,
      sym_identifier,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_RPAREN,
    STATE(613), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [10103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2073), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__semicolon,
  [10113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    STATE(315), 1,
      sym__identifier_path,
    STATE(507), 1,
      sym_user_defined_type,
    STATE(565), 1,
      sym_inheritance_specifier,
  [10129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    ACTIONS(2025), 1,
      anon_sym_is,
    STATE(142), 1,
      sym_contract_body,
    STATE(700), 1,
      sym__class_heritage,
  [10145] = 4,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2049), 1,
      anon_sym_SQUOTE,
    ACTIONS(2075), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(532), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [10159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2077), 1,
      anon_sym_COMMA,
    STATE(262), 1,
      sym_yul_block,
    STATE(495), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [10175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 1,
      anon_sym_as,
    STATE(698), 1,
      sym__import_alias,
    ACTIONS(2079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [10189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2083), 1,
      anon_sym_LBRACE,
    ACTIONS(2085), 1,
      anon_sym_LPAREN,
    ACTIONS(2087), 1,
      anon_sym_DQUOTEevmasm_DQUOTE,
    STATE(815), 1,
      sym_assembly_flags,
  [10205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 1,
      anon_sym__,
    ACTIONS(2089), 1,
      sym__hex_digit,
    ACTIONS(2091), 1,
      anon_sym_SQUOTE,
    STATE(508), 1,
      aux_sym_hex_string_literal_repeat1,
  [10221] = 4,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2093), 1,
      anon_sym_DQUOTE,
    ACTIONS(2095), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(520), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [10235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    ACTIONS(2097), 1,
      anon_sym_RPAREN,
    STATE(315), 1,
      sym__identifier_path,
    STATE(699), 1,
      sym_user_defined_type,
  [10251] = 4,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2093), 1,
      anon_sym_SQUOTE,
    ACTIONS(2099), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(519), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [10265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(2101), 1,
      anon_sym_RPAREN,
    STATE(654), 1,
      sym_string,
  [10281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 1,
      anon_sym__,
    ACTIONS(2091), 1,
      anon_sym_DQUOTE,
    ACTIONS(2103), 1,
      sym__hex_digit,
    STATE(515), 1,
      aux_sym_hex_string_literal_repeat1,
  [10297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 1,
      anon_sym_LBRACE,
    ACTIONS(2105), 1,
      anon_sym_COMMA,
    STATE(641), 1,
      aux_sym__class_heritage_repeat1,
  [10310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 1,
      anon_sym_COMMA,
    ACTIONS(2109), 1,
      anon_sym_RPAREN,
    STATE(242), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [10323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_RPAREN,
    ACTIONS(2111), 1,
      anon_sym_COMMA,
    STATE(643), 1,
      aux_sym_error_declaration_repeat1,
  [10336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 1,
      anon_sym_COMMA,
    ACTIONS(2115), 1,
      anon_sym_RPAREN,
    STATE(537), 1,
      aux_sym_error_declaration_repeat1,
  [10349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_catch,
    STATE(68), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [10360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 1,
      anon_sym_RPAREN,
    ACTIONS(2119), 1,
      anon_sym_COMMA,
    STATE(607), 1,
      aux_sym_override_specifier_repeat1,
  [10373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 1,
      anon_sym_COMMA,
    ACTIONS(2123), 1,
      anon_sym_RBRACE,
    STATE(552), 1,
      aux_sym_struct_expression_repeat1,
  [10386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 1,
      anon_sym_COMMA,
    ACTIONS(2128), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      aux_sym__return_parameters_repeat1,
  [10399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(2130), 1,
      sym__semicolon,
    STATE(207), 1,
      sym_function_body,
  [10412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      sym_identifier,
    ACTIONS(2134), 1,
      anon_sym_RBRACE,
    STATE(680), 1,
      sym_call_struct_argument,
  [10425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2136), 1,
      anon_sym_COMMA,
    ACTIONS(2138), 1,
      anon_sym_RBRACE,
    STATE(638), 1,
      aux_sym_enum_body_repeat1,
  [10438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 1,
      anon_sym_RBRACE,
    ACTIONS(2140), 1,
      anon_sym_COMMA,
    STATE(615), 1,
      aux_sym_call_argument_repeat1,
  [10451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LBRACE,
    ACTIONS(2142), 1,
      sym__semicolon,
    STATE(193), 1,
      sym_function_body,
  [10464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(2144), 1,
      sym_identifier,
    STATE(307), 1,
      sym__parameter_list,
  [10477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2146), 1,
      anon_sym_COMMA,
    ACTIONS(2149), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      aux_sym__call_arguments_repeat1,
  [10490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_COMMA,
    ACTIONS(2153), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      aux_sym_enum_body_repeat1,
  [10503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 1,
      sym_identifier,
    ACTIONS(2157), 1,
      anon_sym_RBRACE,
    STATE(664), 1,
      sym_struct_field_assignment,
  [10516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 1,
      anon_sym_COMMA,
    ACTIONS(2162), 1,
      anon_sym_RBRACE,
    STATE(552), 1,
      aux_sym_struct_expression_repeat1,
  [10529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_COMMA,
    ACTIONS(2166), 1,
      anon_sym_RBRACE,
    STATE(561), 1,
      aux_sym__multiple_import_repeat1,
  [10542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_RPAREN,
    ACTIONS(2168), 1,
      anon_sym_COMMA,
    STATE(624), 1,
      aux_sym__event_parameter_list_repeat1,
  [10555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2170), 1,
      sym_identifier,
    ACTIONS(2172), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [10566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    STATE(769), 1,
      sym_string,
  [10579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2174), 1,
      anon_sym_COMMA,
    ACTIONS(2176), 1,
      anon_sym_RPAREN,
    STATE(572), 1,
      aux_sym__parameter_list_repeat1,
  [10592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(2178), 1,
      anon_sym_COMMA,
    STATE(593), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [10605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(2180), 1,
      sym_identifier,
    ACTIONS(2182), 1,
      anon_sym_COMMA,
  [10618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      sym_identifier,
    ACTIONS(2186), 1,
      anon_sym_RBRACE,
    STATE(732), 1,
      sym__import_declaration,
  [10631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 1,
      anon_sym_COMMA,
    ACTIONS(2190), 1,
      anon_sym_RBRACE,
    STATE(584), 1,
      aux_sym__multiple_import_repeat1,
  [10644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2192), 1,
      anon_sym_COMMA,
    ACTIONS(2194), 1,
      anon_sym_RPAREN,
    STATE(585), 1,
      aux_sym_assembly_flags_repeat1,
  [10657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    STATE(315), 1,
      sym__identifier_path,
    STATE(746), 1,
      sym_user_defined_type,
  [10670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(2196), 1,
      sym_identifier,
    STATE(438), 1,
      sym__parameter_list,
  [10683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 1,
      anon_sym_LBRACE,
    ACTIONS(2200), 1,
      anon_sym_COMMA,
    STATE(535), 1,
      aux_sym__class_heritage_repeat1,
  [10696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2202), 1,
      anon_sym_LPAREN,
    STATE(247), 1,
      sym_yul_identifier,
  [10709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2206), 1,
      anon_sym_RPAREN,
    STATE(591), 1,
      aux_sym_error_declaration_repeat1,
  [10722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 1,
      anon_sym_RBRACE,
    ACTIONS(2155), 1,
      sym_identifier,
    STATE(664), 1,
      sym_struct_field_assignment,
  [10735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_COMMA,
    ACTIONS(2210), 1,
      anon_sym_RBRACE,
    STATE(596), 1,
      aux_sym_enum_body_repeat1,
  [10748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2212), 1,
      sym_identifier,
    ACTIONS(2214), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [10759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      anon_sym_default,
    ACTIONS(2218), 1,
      anon_sym_case,
    STATE(250), 1,
      aux_sym_yul_switch_statement_repeat1,
  [10772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_RPAREN,
    ACTIONS(2220), 1,
      anon_sym_COMMA,
    STATE(601), 1,
      aux_sym__parameter_list_repeat1,
  [10785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_COMMA,
    ACTIONS(2225), 1,
      anon_sym_RPAREN,
    STATE(573), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [10798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    STATE(573), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [10811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym__semicolon,
    STATE(192), 1,
      sym_function_body,
  [10824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2231), 1,
      anon_sym_DASH_GT,
    STATE(266), 1,
      sym_yul_block,
  [10837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 1,
      anon_sym_as,
    ACTIONS(2233), 1,
      anon_sym_from,
    STATE(789), 1,
      sym__import_alias,
  [10850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(272), 1,
      anon_sym_RPAREN,
    ACTIONS(1650), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_tuple_expression_repeat1,
  [10863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 1,
      sym_identifier,
    ACTIONS(2235), 1,
      anon_sym_RBRACE,
    STATE(637), 1,
      sym_struct_field_assignment,
  [10876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2237), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [10889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2239), 1,
      anon_sym_DASH_GT,
    STATE(262), 1,
      sym_yul_block,
  [10902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 1,
      anon_sym_as,
    ACTIONS(2241), 1,
      sym__semicolon,
    STATE(786), 1,
      sym__import_alias,
  [10915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      sym_identifier,
    ACTIONS(2243), 1,
      anon_sym_RBRACE,
    STATE(732), 1,
      sym__import_declaration,
  [10928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 1,
      anon_sym_COMMA,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    STATE(584), 1,
      aux_sym__multiple_import_repeat1,
  [10941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2053), 1,
      anon_sym_RPAREN,
    ACTIONS(2250), 1,
      anon_sym_COMMA,
    STATE(636), 1,
      aux_sym_assembly_flags_repeat1,
  [10954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_COMMA,
    ACTIONS(2255), 1,
      anon_sym_RPAREN,
    STATE(586), 1,
      aux_sym_yul_function_call_repeat1,
  [10967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
    ACTIONS(2259), 1,
      anon_sym_RPAREN,
    STATE(554), 1,
      aux_sym__event_parameter_list_repeat1,
  [10980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      anon_sym_COMMA,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
    STATE(242), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [10993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2265), 1,
      anon_sym_DASH_GT,
    STATE(284), 1,
      sym_yul_block,
  [11006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [11019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(573), 1,
      anon_sym_RPAREN,
    ACTIONS(2267), 1,
      anon_sym_COMMA,
    STATE(643), 1,
      aux_sym_error_declaration_repeat1,
  [11032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 1,
      anon_sym_RPAREN,
    ACTIONS(2180), 1,
      sym_identifier,
    ACTIONS(2182), 1,
      anon_sym_COMMA,
  [11045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 1,
      anon_sym_RPAREN,
    ACTIONS(2269), 1,
      anon_sym_COMMA,
    STATE(594), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [11058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_COMMA,
    ACTIONS(2274), 1,
      anon_sym_RPAREN,
    STATE(594), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [11071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2276), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [11084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_COMMA,
    ACTIONS(2280), 1,
      anon_sym_RBRACE,
    STATE(638), 1,
      aux_sym_enum_body_repeat1,
  [11097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      sym_identifier,
    ACTIONS(2282), 1,
      anon_sym_RBRACE,
    STATE(604), 1,
      sym_call_struct_argument,
  [11110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(1656), 1,
      sym_unchecked,
    STATE(77), 1,
      sym_block_statement,
  [11123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(1656), 1,
      sym_unchecked,
    STATE(626), 1,
      sym_block_statement,
  [11136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_RBRACK,
    ACTIONS(2284), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      aux_sym_inline_array_expression_repeat1,
  [11149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_COMMA,
    ACTIONS(2290), 1,
      anon_sym_RPAREN,
    STATE(601), 1,
      aux_sym__parameter_list_repeat1,
  [11162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(254), 1,
      anon_sym_RPAREN,
    ACTIONS(2292), 1,
      anon_sym_COMMA,
    STATE(549), 1,
      aux_sym__call_arguments_repeat1,
  [11175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    STATE(654), 1,
      sym_string,
  [11188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_COMMA,
    ACTIONS(2296), 1,
      anon_sym_RBRACE,
    STATE(546), 1,
      aux_sym_call_argument_repeat1,
  [11201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(230), 1,
      sym_yul_identifier,
    STATE(248), 1,
      sym_yul_path,
  [11214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_RPAREN,
    ACTIONS(2298), 1,
      anon_sym_COMMA,
    STATE(586), 1,
      aux_sym_yul_function_call_repeat1,
  [11227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 1,
      anon_sym_COMMA,
    ACTIONS(2303), 1,
      anon_sym_RPAREN,
    STATE(607), 1,
      aux_sym_override_specifier_repeat1,
  [11240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_COMMA,
    ACTIONS(2307), 1,
      anon_sym_RPAREN,
    STATE(588), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2309), 1,
      sym_identifier,
    ACTIONS(2311), 1,
      anon_sym_RPAREN,
  [11266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    ACTIONS(2313), 1,
      anon_sym_DASH_GT,
    STATE(272), 1,
      sym_yul_block,
  [11279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2315), 1,
      anon_sym_COMMA,
    ACTIONS(2317), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      aux_sym__return_parameters_repeat1,
  [11292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    STATE(315), 1,
      sym__identifier_path,
    STATE(618), 1,
      sym_user_defined_type,
  [11305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(2178), 1,
      anon_sym_COMMA,
    STATE(594), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [11318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      sym_identifier,
    ACTIONS(2319), 1,
      anon_sym_RBRACE,
    STATE(680), 1,
      sym_call_struct_argument,
  [11331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_COMMA,
    ACTIONS(2324), 1,
      anon_sym_RBRACE,
    STATE(615), 1,
      aux_sym_call_argument_repeat1,
  [11344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_LBRACE,
    ACTIONS(2326), 1,
      sym__semicolon,
    STATE(185), 1,
      sym_function_body,
  [11357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2109), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [11370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 1,
      anon_sym_COMMA,
    ACTIONS(2330), 1,
      anon_sym_RPAREN,
    STATE(540), 1,
      aux_sym_override_specifier_repeat1,
  [11383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_COMMA,
    ACTIONS(2334), 1,
      anon_sym_RPAREN,
    STATE(611), 1,
      aux_sym__return_parameters_repeat1,
  [11396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2336), 1,
      sym_identifier,
    ACTIONS(2338), 1,
      anon_sym_RPAREN,
  [11409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_identifier,
    STATE(315), 1,
      sym__identifier_path,
    STATE(699), 1,
      sym_user_defined_type,
  [11422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(260), 1,
      anon_sym_RPAREN,
    ACTIONS(2340), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_tuple_expression_repeat1,
  [11435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACE,
    ACTIONS(1656), 1,
      sym_unchecked,
    STATE(76), 1,
      sym_block_statement,
  [11448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 1,
      anon_sym_COMMA,
    ACTIONS(2345), 1,
      anon_sym_RPAREN,
    STATE(624), 1,
      aux_sym__event_parameter_list_repeat1,
  [11461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_RPAREN,
    ACTIONS(2347), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_tuple_expression_repeat1,
  [11474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_catch,
    STATE(70), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [11485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COMMA,
    ACTIONS(2352), 1,
      anon_sym_RPAREN,
    STATE(602), 1,
      aux_sym__call_arguments_repeat1,
  [11498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      sym_identifier,
    ACTIONS(2182), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      sym_identifier,
    ACTIONS(2182), 1,
      anon_sym_COMMA,
    ACTIONS(2354), 1,
      anon_sym_RPAREN,
  [11522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 1,
      anon_sym_LPAREN,
    ACTIONS(2356), 1,
      anon_sym_LBRACE,
    STATE(770), 1,
      sym_assembly_flags,
  [11535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      sym_identifier,
    ACTIONS(2358), 1,
      anon_sym_RBRACE,
    STATE(553), 1,
      sym__import_declaration,
  [11548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2360), 1,
      anon_sym_COMMA,
    ACTIONS(2362), 1,
      anon_sym_RPAREN,
    STATE(536), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 1,
      anon_sym_RBRACK,
    ACTIONS(2364), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      aux_sym_inline_array_expression_repeat1,
  [11574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_RPAREN,
    ACTIONS(2366), 1,
      anon_sym_COMMA,
    STATE(573), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [11587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_RPAREN,
    ACTIONS(2366), 1,
      anon_sym_COMMA,
    STATE(574), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [11600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 1,
      anon_sym_RPAREN,
    STATE(636), 1,
      aux_sym_assembly_flags_repeat1,
  [11613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_COMMA,
    ACTIONS(2375), 1,
      anon_sym_RBRACE,
    STATE(541), 1,
      aux_sym_struct_expression_repeat1,
  [11626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_COMMA,
    ACTIONS(2380), 1,
      anon_sym_RBRACE,
    STATE(638), 1,
      aux_sym_enum_body_repeat1,
  [11639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 1,
      anon_sym_as,
    ACTIONS(2382), 1,
      anon_sym_from,
    STATE(794), 1,
      sym__import_alias,
  [11652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    ACTIONS(2384), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      sym_yul_identifier,
  [11665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 1,
      anon_sym_LBRACE,
    ACTIONS(2388), 1,
      anon_sym_COMMA,
    STATE(641), 1,
      aux_sym__class_heritage_repeat1,
  [11678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2391), 1,
      anon_sym_COMMA,
    ACTIONS(2393), 1,
      anon_sym_RPAREN,
    STATE(606), 1,
      aux_sym_yul_function_call_repeat1,
  [11691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2395), 1,
      anon_sym_COMMA,
    ACTIONS(2398), 1,
      anon_sym_RPAREN,
    STATE(643), 1,
      aux_sym_error_declaration_repeat1,
  [11704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_LBRACE,
    STATE(199), 1,
      sym_struct_body,
  [11722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2402), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [11730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [11738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_EQ,
    ACTIONS(2406), 1,
      sym__semicolon,
  [11748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_anonymous,
    ACTIONS(2410), 1,
      sym__semicolon,
  [11758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      sym_identifier,
    STATE(732), 1,
      sym__import_declaration,
  [11768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 1,
      anon_sym_LBRACE,
    STATE(197), 1,
      sym_enum_body,
  [11778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2416), 1,
      anon_sym_RBRACE,
  [11788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(599), 1,
      sym__parameter_list,
  [11798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(283), 1,
      sym_yul_block,
  [11816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(441), 1,
      sym__parameter_list,
  [11834] = 3,
    ACTIONS(1947), 1,
      sym_comment,
    ACTIONS(2420), 1,
      aux_sym_pragma_value_token1,
    STATE(804), 1,
      sym_pragma_value,
  [11844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(677), 1,
      sym_yul_block,
  [11854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym_identifier,
    ACTIONS(2422), 1,
      anon_sym_RBRACE,
  [11864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      anon_sym_RBRACE,
    ACTIONS(2414), 1,
      sym_identifier,
  [11882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2162), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [11898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(598), 1,
      sym__parameter_list,
  [11908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      sym_identifier,
    ACTIONS(2430), 1,
      anon_sym_RBRACE,
  [11926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2345), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2432), 1,
      anon_sym_RPAREN,
  [11944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [11952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      sym_identifier,
    STATE(680), 1,
      sym_call_struct_argument,
  [11970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [11978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_enum_body,
  [11988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 1,
      sym_identifier,
    STATE(664), 1,
      sym_struct_field_assignment,
  [11998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      anon_sym_LBRACE,
    STATE(140), 1,
      sym_struct_body,
  [12008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(276), 1,
      sym_yul_block,
  [12018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [12026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [12042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 2,
      anon_sym_LBRACE,
      sym__semicolon,
  [12058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_EQ,
    ACTIONS(2456), 1,
      sym__semicolon,
  [12076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    STATE(152), 1,
      sym_contract_body,
  [12086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_contract_body,
  [12096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      sym_identifier,
    ACTIONS(2460), 1,
      anon_sym_RBRACE,
  [12106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(252), 1,
      sym_yul_block,
  [12116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(273), 1,
      sym_yul_block,
  [12126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_from,
    STATE(787), 1,
      sym__from_clause,
  [12136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(307), 1,
      sym__parameter_list,
  [12146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2464), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(291), 1,
      sym_yul_block,
  [12164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      sym_identifier,
    ACTIONS(2468), 1,
      anon_sym_EQ_GT,
  [12174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    STATE(370), 1,
      sym__call_arguments,
  [12184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_DQUOTE,
    ACTIONS(2472), 1,
      anon_sym_SQUOTE,
  [12194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_DQUOTE,
    ACTIONS(2476), 1,
      anon_sym_SQUOTE,
  [12204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [12212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    STATE(194), 1,
      sym_contract_body,
  [12230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2480), 1,
      anon_sym_constant,
  [12240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(464), 1,
      sym__parameter_list,
  [12250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(445), 1,
      sym__parameter_list,
  [12260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(752), 1,
      sym_yul_identifier,
  [12270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(632), 1,
      sym_yul_identifier,
  [12280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2482), 1,
      sym_identifier,
  [12290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(439), 1,
      sym__parameter_list,
  [12324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 1,
      anon_sym_RBRACE,
    ACTIONS(2414), 1,
      sym_identifier,
  [12334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(493), 1,
      sym_yul_identifier,
  [12344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(825), 1,
      anon_sym_LBRACE,
    STATE(277), 1,
      sym_yul_block,
  [12354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
  [12372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(682), 1,
      sym__parameter_list,
  [12390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(526), 1,
      sym_yul_identifier,
  [12400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [12408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(229), 1,
      sym_yul_identifier,
  [12418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [12426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_LBRACE,
    STATE(200), 1,
      sym_contract_body,
  [12436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_EQ,
    ACTIONS(2496), 1,
      sym__semicolon,
  [12462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(500), 1,
      sym_yul_identifier,
  [12472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      sym__hex_digit,
    ACTIONS(2500), 1,
      anon_sym_DQUOTE,
  [12482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 1,
      anon_sym_LPAREN,
    STATE(649), 1,
      sym__event_parameter_list,
  [12492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      anon_sym_SQUOTE,
    ACTIONS(2504), 1,
      sym__hex_digit,
  [12502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(496), 1,
      sym_yul_identifier,
  [12512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_LBRACK,
    ACTIONS(2506), 1,
      sym__semicolon,
  [12522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [12530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_from,
  [12537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
  [12544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      sym__semicolon,
  [12551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      sym__semicolon,
  [12558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_is,
  [12565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      sym__semicolon,
  [12572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      sym_identifier,
  [12579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 1,
      sym_identifier,
  [12586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      anon_sym_from,
  [12593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_LBRACE,
  [12600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 1,
      sym_identifier,
  [12607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      sym_identifier,
  [12614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      anon_sym_EQ,
  [12621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_for,
  [12628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 1,
      sym__semicolon,
  [12635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_EQ,
  [12642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      anon_sym_LPAREN,
  [12649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      sym_identifier,
  [12656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      sym_identifier,
  [12663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_LPAREN,
  [12670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      sym__semicolon,
  [12677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      sym_identifier,
  [12684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      sym__semicolon,
  [12691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_LPAREN,
  [12698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      sym__hex_digit,
  [12705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      ts_builtin_sym_end,
  [12712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      sym__semicolon,
  [12719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      sym__semicolon,
  [12726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_EQ,
  [12733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      anon_sym_from,
  [12740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 1,
      sym_identifier,
  [12747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LBRACE,
  [12754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_contract,
  [12761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      sym_identifier,
  [12768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      anon_sym_from,
  [12775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym__semicolon,
  [12782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      sym__semicolon,
  [12789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_LBRACE,
  [12796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_from,
  [12803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_EQ,
  [12810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_LBRACE,
  [12817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_LPAREN,
  [12824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_EQ_GT,
  [12831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(932), 1,
      anon_sym_LPAREN,
  [12838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_LPAREN,
  [12845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_EQ,
  [12852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_COLON,
  [12859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      sym__semicolon,
  [12866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      sym__semicolon,
  [12873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_LPAREN,
  [12880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_RPAREN,
  [12887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      sym__semicolon,
  [12894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      anon_sym_LBRACE,
  [12901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 1,
      sym__semicolon,
  [12908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      sym__semicolon,
  [12915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
  [12922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_from,
  [12929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_EQ,
  [12936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_from,
  [12943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 1,
      sym_identifier,
  [12950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 1,
      sym_identifier,
  [12957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_from,
  [12964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      sym_identifier,
  [12971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 1,
      sym_identifier,
  [12978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      sym_solidity_version,
  [12985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      sym__semicolon,
  [12992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      sym__semicolon,
  [12999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 1,
      sym_solidity_version,
  [13006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_while,
  [13013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 1,
      sym_identifier,
  [13020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      sym__semicolon,
  [13027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 1,
      sym__semicolon,
  [13034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      sym__semicolon,
  [13041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      sym__semicolon,
  [13048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_EQ,
  [13055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      sym__semicolon,
  [13062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_RPAREN,
  [13069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 1,
      sym__semicolon,
  [13076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      sym_identifier,
  [13083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      sym__semicolon,
  [13090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 1,
      sym_identifier,
  [13097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2662), 1,
      sym_identifier,
  [13104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 1,
      anon_sym_LBRACE,
  [13111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 1,
      sym_identifier,
  [13118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2666), 1,
      sym_identifier,
  [13125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_COLON,
  [13132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      sym__semicolon,
  [13139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
  [13146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      anon_sym_LPAREN,
  [13153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_from,
  [13160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_is,
  [13167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_LPAREN,
  [13174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 1,
      sym_identifier,
  [13181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(314)] = 0,
  [SMALL_STATE(315)] = 72,
  [SMALL_STATE(316)] = 142,
  [SMALL_STATE(317)] = 211,
  [SMALL_STATE(318)] = 280,
  [SMALL_STATE(319)] = 348,
  [SMALL_STATE(320)] = 416,
  [SMALL_STATE(321)] = 484,
  [SMALL_STATE(322)] = 552,
  [SMALL_STATE(323)] = 620,
  [SMALL_STATE(324)] = 688,
  [SMALL_STATE(325)] = 756,
  [SMALL_STATE(326)] = 824,
  [SMALL_STATE(327)] = 896,
  [SMALL_STATE(328)] = 964,
  [SMALL_STATE(329)] = 1032,
  [SMALL_STATE(330)] = 1100,
  [SMALL_STATE(331)] = 1168,
  [SMALL_STATE(332)] = 1236,
  [SMALL_STATE(333)] = 1304,
  [SMALL_STATE(334)] = 1372,
  [SMALL_STATE(335)] = 1438,
  [SMALL_STATE(336)] = 1504,
  [SMALL_STATE(337)] = 1570,
  [SMALL_STATE(338)] = 1636,
  [SMALL_STATE(339)] = 1703,
  [SMALL_STATE(340)] = 1766,
  [SMALL_STATE(341)] = 1827,
  [SMALL_STATE(342)] = 1888,
  [SMALL_STATE(343)] = 1954,
  [SMALL_STATE(344)] = 2020,
  [SMALL_STATE(345)] = 2082,
  [SMALL_STATE(346)] = 2144,
  [SMALL_STATE(347)] = 2206,
  [SMALL_STATE(348)] = 2268,
  [SMALL_STATE(349)] = 2330,
  [SMALL_STATE(350)] = 2397,
  [SMALL_STATE(351)] = 2454,
  [SMALL_STATE(352)] = 2545,
  [SMALL_STATE(353)] = 2608,
  [SMALL_STATE(354)] = 2681,
  [SMALL_STATE(355)] = 2742,
  [SMALL_STATE(356)] = 2811,
  [SMALL_STATE(357)] = 2874,
  [SMALL_STATE(358)] = 2951,
  [SMALL_STATE(359)] = 3008,
  [SMALL_STATE(360)] = 3069,
  [SMALL_STATE(361)] = 3132,
  [SMALL_STATE(362)] = 3189,
  [SMALL_STATE(363)] = 3246,
  [SMALL_STATE(364)] = 3327,
  [SMALL_STATE(365)] = 3390,
  [SMALL_STATE(366)] = 3447,
  [SMALL_STATE(367)] = 3512,
  [SMALL_STATE(368)] = 3573,
  [SMALL_STATE(369)] = 3664,
  [SMALL_STATE(370)] = 3720,
  [SMALL_STATE(371)] = 3776,
  [SMALL_STATE(372)] = 3832,
  [SMALL_STATE(373)] = 3888,
  [SMALL_STATE(374)] = 3944,
  [SMALL_STATE(375)] = 4000,
  [SMALL_STATE(376)] = 4056,
  [SMALL_STATE(377)] = 4112,
  [SMALL_STATE(378)] = 4168,
  [SMALL_STATE(379)] = 4224,
  [SMALL_STATE(380)] = 4280,
  [SMALL_STATE(381)] = 4336,
  [SMALL_STATE(382)] = 4392,
  [SMALL_STATE(383)] = 4448,
  [SMALL_STATE(384)] = 4504,
  [SMALL_STATE(385)] = 4560,
  [SMALL_STATE(386)] = 4616,
  [SMALL_STATE(387)] = 4672,
  [SMALL_STATE(388)] = 4728,
  [SMALL_STATE(389)] = 4792,
  [SMALL_STATE(390)] = 4848,
  [SMALL_STATE(391)] = 4904,
  [SMALL_STATE(392)] = 4960,
  [SMALL_STATE(393)] = 5016,
  [SMALL_STATE(394)] = 5072,
  [SMALL_STATE(395)] = 5128,
  [SMALL_STATE(396)] = 5184,
  [SMALL_STATE(397)] = 5240,
  [SMALL_STATE(398)] = 5296,
  [SMALL_STATE(399)] = 5352,
  [SMALL_STATE(400)] = 5408,
  [SMALL_STATE(401)] = 5464,
  [SMALL_STATE(402)] = 5523,
  [SMALL_STATE(403)] = 5586,
  [SMALL_STATE(404)] = 5641,
  [SMALL_STATE(405)] = 5731,
  [SMALL_STATE(406)] = 5821,
  [SMALL_STATE(407)] = 5911,
  [SMALL_STATE(408)] = 6001,
  [SMALL_STATE(409)] = 6086,
  [SMALL_STATE(410)] = 6173,
  [SMALL_STATE(411)] = 6258,
  [SMALL_STATE(412)] = 6311,
  [SMALL_STATE(413)] = 6396,
  [SMALL_STATE(414)] = 6481,
  [SMALL_STATE(415)] = 6566,
  [SMALL_STATE(416)] = 6650,
  [SMALL_STATE(417)] = 6734,
  [SMALL_STATE(418)] = 6818,
  [SMALL_STATE(419)] = 6902,
  [SMALL_STATE(420)] = 6986,
  [SMALL_STATE(421)] = 7070,
  [SMALL_STATE(422)] = 7154,
  [SMALL_STATE(423)] = 7238,
  [SMALL_STATE(424)] = 7322,
  [SMALL_STATE(425)] = 7406,
  [SMALL_STATE(426)] = 7490,
  [SMALL_STATE(427)] = 7574,
  [SMALL_STATE(428)] = 7658,
  [SMALL_STATE(429)] = 7742,
  [SMALL_STATE(430)] = 7826,
  [SMALL_STATE(431)] = 7877,
  [SMALL_STATE(432)] = 7928,
  [SMALL_STATE(433)] = 8009,
  [SMALL_STATE(434)] = 8060,
  [SMALL_STATE(435)] = 8111,
  [SMALL_STATE(436)] = 8162,
  [SMALL_STATE(437)] = 8201,
  [SMALL_STATE(438)] = 8240,
  [SMALL_STATE(439)] = 8301,
  [SMALL_STATE(440)] = 8350,
  [SMALL_STATE(441)] = 8399,
  [SMALL_STATE(442)] = 8448,
  [SMALL_STATE(443)] = 8497,
  [SMALL_STATE(444)] = 8538,
  [SMALL_STATE(445)] = 8581,
  [SMALL_STATE(446)] = 8624,
  [SMALL_STATE(447)] = 8662,
  [SMALL_STATE(448)] = 8688,
  [SMALL_STATE(449)] = 8718,
  [SMALL_STATE(450)] = 8741,
  [SMALL_STATE(451)] = 8764,
  [SMALL_STATE(452)] = 8791,
  [SMALL_STATE(453)] = 8814,
  [SMALL_STATE(454)] = 8835,
  [SMALL_STATE(455)] = 8865,
  [SMALL_STATE(456)] = 8895,
  [SMALL_STATE(457)] = 8925,
  [SMALL_STATE(458)] = 8955,
  [SMALL_STATE(459)] = 8982,
  [SMALL_STATE(460)] = 9003,
  [SMALL_STATE(461)] = 9022,
  [SMALL_STATE(462)] = 9049,
  [SMALL_STATE(463)] = 9083,
  [SMALL_STATE(464)] = 9111,
  [SMALL_STATE(465)] = 9136,
  [SMALL_STATE(466)] = 9153,
  [SMALL_STATE(467)] = 9182,
  [SMALL_STATE(468)] = 9207,
  [SMALL_STATE(469)] = 9229,
  [SMALL_STATE(470)] = 9251,
  [SMALL_STATE(471)] = 9265,
  [SMALL_STATE(472)] = 9284,
  [SMALL_STATE(473)] = 9307,
  [SMALL_STATE(474)] = 9330,
  [SMALL_STATE(475)] = 9353,
  [SMALL_STATE(476)] = 9375,
  [SMALL_STATE(477)] = 9393,
  [SMALL_STATE(478)] = 9410,
  [SMALL_STATE(479)] = 9427,
  [SMALL_STATE(480)] = 9444,
  [SMALL_STATE(481)] = 9463,
  [SMALL_STATE(482)] = 9480,
  [SMALL_STATE(483)] = 9497,
  [SMALL_STATE(484)] = 9514,
  [SMALL_STATE(485)] = 9531,
  [SMALL_STATE(486)] = 9548,
  [SMALL_STATE(487)] = 9563,
  [SMALL_STATE(488)] = 9580,
  [SMALL_STATE(489)] = 9597,
  [SMALL_STATE(490)] = 9614,
  [SMALL_STATE(491)] = 9633,
  [SMALL_STATE(492)] = 9650,
  [SMALL_STATE(493)] = 9667,
  [SMALL_STATE(494)] = 9683,
  [SMALL_STATE(495)] = 9699,
  [SMALL_STATE(496)] = 9715,
  [SMALL_STATE(497)] = 9731,
  [SMALL_STATE(498)] = 9747,
  [SMALL_STATE(499)] = 9763,
  [SMALL_STATE(500)] = 9779,
  [SMALL_STATE(501)] = 9795,
  [SMALL_STATE(502)] = 9811,
  [SMALL_STATE(503)] = 9827,
  [SMALL_STATE(504)] = 9841,
  [SMALL_STATE(505)] = 9857,
  [SMALL_STATE(506)] = 9867,
  [SMALL_STATE(507)] = 9883,
  [SMALL_STATE(508)] = 9897,
  [SMALL_STATE(509)] = 9913,
  [SMALL_STATE(510)] = 9929,
  [SMALL_STATE(511)] = 9945,
  [SMALL_STATE(512)] = 9961,
  [SMALL_STATE(513)] = 9977,
  [SMALL_STATE(514)] = 9987,
  [SMALL_STATE(515)] = 10003,
  [SMALL_STATE(516)] = 10019,
  [SMALL_STATE(517)] = 10033,
  [SMALL_STATE(518)] = 10049,
  [SMALL_STATE(519)] = 10059,
  [SMALL_STATE(520)] = 10073,
  [SMALL_STATE(521)] = 10087,
  [SMALL_STATE(522)] = 10103,
  [SMALL_STATE(523)] = 10113,
  [SMALL_STATE(524)] = 10129,
  [SMALL_STATE(525)] = 10145,
  [SMALL_STATE(526)] = 10159,
  [SMALL_STATE(527)] = 10175,
  [SMALL_STATE(528)] = 10189,
  [SMALL_STATE(529)] = 10205,
  [SMALL_STATE(530)] = 10221,
  [SMALL_STATE(531)] = 10235,
  [SMALL_STATE(532)] = 10251,
  [SMALL_STATE(533)] = 10265,
  [SMALL_STATE(534)] = 10281,
  [SMALL_STATE(535)] = 10297,
  [SMALL_STATE(536)] = 10310,
  [SMALL_STATE(537)] = 10323,
  [SMALL_STATE(538)] = 10336,
  [SMALL_STATE(539)] = 10349,
  [SMALL_STATE(540)] = 10360,
  [SMALL_STATE(541)] = 10373,
  [SMALL_STATE(542)] = 10386,
  [SMALL_STATE(543)] = 10399,
  [SMALL_STATE(544)] = 10412,
  [SMALL_STATE(545)] = 10425,
  [SMALL_STATE(546)] = 10438,
  [SMALL_STATE(547)] = 10451,
  [SMALL_STATE(548)] = 10464,
  [SMALL_STATE(549)] = 10477,
  [SMALL_STATE(550)] = 10490,
  [SMALL_STATE(551)] = 10503,
  [SMALL_STATE(552)] = 10516,
  [SMALL_STATE(553)] = 10529,
  [SMALL_STATE(554)] = 10542,
  [SMALL_STATE(555)] = 10555,
  [SMALL_STATE(556)] = 10566,
  [SMALL_STATE(557)] = 10579,
  [SMALL_STATE(558)] = 10592,
  [SMALL_STATE(559)] = 10605,
  [SMALL_STATE(560)] = 10618,
  [SMALL_STATE(561)] = 10631,
  [SMALL_STATE(562)] = 10644,
  [SMALL_STATE(563)] = 10657,
  [SMALL_STATE(564)] = 10670,
  [SMALL_STATE(565)] = 10683,
  [SMALL_STATE(566)] = 10696,
  [SMALL_STATE(567)] = 10709,
  [SMALL_STATE(568)] = 10722,
  [SMALL_STATE(569)] = 10735,
  [SMALL_STATE(570)] = 10748,
  [SMALL_STATE(571)] = 10759,
  [SMALL_STATE(572)] = 10772,
  [SMALL_STATE(573)] = 10785,
  [SMALL_STATE(574)] = 10798,
  [SMALL_STATE(575)] = 10811,
  [SMALL_STATE(576)] = 10824,
  [SMALL_STATE(577)] = 10837,
  [SMALL_STATE(578)] = 10850,
  [SMALL_STATE(579)] = 10863,
  [SMALL_STATE(580)] = 10876,
  [SMALL_STATE(581)] = 10889,
  [SMALL_STATE(582)] = 10902,
  [SMALL_STATE(583)] = 10915,
  [SMALL_STATE(584)] = 10928,
  [SMALL_STATE(585)] = 10941,
  [SMALL_STATE(586)] = 10954,
  [SMALL_STATE(587)] = 10967,
  [SMALL_STATE(588)] = 10980,
  [SMALL_STATE(589)] = 10993,
  [SMALL_STATE(590)] = 11006,
  [SMALL_STATE(591)] = 11019,
  [SMALL_STATE(592)] = 11032,
  [SMALL_STATE(593)] = 11045,
  [SMALL_STATE(594)] = 11058,
  [SMALL_STATE(595)] = 11071,
  [SMALL_STATE(596)] = 11084,
  [SMALL_STATE(597)] = 11097,
  [SMALL_STATE(598)] = 11110,
  [SMALL_STATE(599)] = 11123,
  [SMALL_STATE(600)] = 11136,
  [SMALL_STATE(601)] = 11149,
  [SMALL_STATE(602)] = 11162,
  [SMALL_STATE(603)] = 11175,
  [SMALL_STATE(604)] = 11188,
  [SMALL_STATE(605)] = 11201,
  [SMALL_STATE(606)] = 11214,
  [SMALL_STATE(607)] = 11227,
  [SMALL_STATE(608)] = 11240,
  [SMALL_STATE(609)] = 11253,
  [SMALL_STATE(610)] = 11266,
  [SMALL_STATE(611)] = 11279,
  [SMALL_STATE(612)] = 11292,
  [SMALL_STATE(613)] = 11305,
  [SMALL_STATE(614)] = 11318,
  [SMALL_STATE(615)] = 11331,
  [SMALL_STATE(616)] = 11344,
  [SMALL_STATE(617)] = 11357,
  [SMALL_STATE(618)] = 11370,
  [SMALL_STATE(619)] = 11383,
  [SMALL_STATE(620)] = 11396,
  [SMALL_STATE(621)] = 11409,
  [SMALL_STATE(622)] = 11422,
  [SMALL_STATE(623)] = 11435,
  [SMALL_STATE(624)] = 11448,
  [SMALL_STATE(625)] = 11461,
  [SMALL_STATE(626)] = 11474,
  [SMALL_STATE(627)] = 11485,
  [SMALL_STATE(628)] = 11498,
  [SMALL_STATE(629)] = 11509,
  [SMALL_STATE(630)] = 11522,
  [SMALL_STATE(631)] = 11535,
  [SMALL_STATE(632)] = 11548,
  [SMALL_STATE(633)] = 11561,
  [SMALL_STATE(634)] = 11574,
  [SMALL_STATE(635)] = 11587,
  [SMALL_STATE(636)] = 11600,
  [SMALL_STATE(637)] = 11613,
  [SMALL_STATE(638)] = 11626,
  [SMALL_STATE(639)] = 11639,
  [SMALL_STATE(640)] = 11652,
  [SMALL_STATE(641)] = 11665,
  [SMALL_STATE(642)] = 11678,
  [SMALL_STATE(643)] = 11691,
  [SMALL_STATE(644)] = 11704,
  [SMALL_STATE(645)] = 11712,
  [SMALL_STATE(646)] = 11722,
  [SMALL_STATE(647)] = 11730,
  [SMALL_STATE(648)] = 11738,
  [SMALL_STATE(649)] = 11748,
  [SMALL_STATE(650)] = 11758,
  [SMALL_STATE(651)] = 11768,
  [SMALL_STATE(652)] = 11778,
  [SMALL_STATE(653)] = 11788,
  [SMALL_STATE(654)] = 11798,
  [SMALL_STATE(655)] = 11806,
  [SMALL_STATE(656)] = 11816,
  [SMALL_STATE(657)] = 11824,
  [SMALL_STATE(658)] = 11834,
  [SMALL_STATE(659)] = 11844,
  [SMALL_STATE(660)] = 11854,
  [SMALL_STATE(661)] = 11864,
  [SMALL_STATE(662)] = 11872,
  [SMALL_STATE(663)] = 11882,
  [SMALL_STATE(664)] = 11890,
  [SMALL_STATE(665)] = 11898,
  [SMALL_STATE(666)] = 11908,
  [SMALL_STATE(667)] = 11916,
  [SMALL_STATE(668)] = 11926,
  [SMALL_STATE(669)] = 11934,
  [SMALL_STATE(670)] = 11944,
  [SMALL_STATE(671)] = 11952,
  [SMALL_STATE(672)] = 11960,
  [SMALL_STATE(673)] = 11970,
  [SMALL_STATE(674)] = 11978,
  [SMALL_STATE(675)] = 11988,
  [SMALL_STATE(676)] = 11998,
  [SMALL_STATE(677)] = 12008,
  [SMALL_STATE(678)] = 12018,
  [SMALL_STATE(679)] = 12026,
  [SMALL_STATE(680)] = 12034,
  [SMALL_STATE(681)] = 12042,
  [SMALL_STATE(682)] = 12050,
  [SMALL_STATE(683)] = 12058,
  [SMALL_STATE(684)] = 12066,
  [SMALL_STATE(685)] = 12076,
  [SMALL_STATE(686)] = 12086,
  [SMALL_STATE(687)] = 12096,
  [SMALL_STATE(688)] = 12106,
  [SMALL_STATE(689)] = 12116,
  [SMALL_STATE(690)] = 12126,
  [SMALL_STATE(691)] = 12136,
  [SMALL_STATE(692)] = 12146,
  [SMALL_STATE(693)] = 12154,
  [SMALL_STATE(694)] = 12164,
  [SMALL_STATE(695)] = 12174,
  [SMALL_STATE(696)] = 12184,
  [SMALL_STATE(697)] = 12194,
  [SMALL_STATE(698)] = 12204,
  [SMALL_STATE(699)] = 12212,
  [SMALL_STATE(700)] = 12220,
  [SMALL_STATE(701)] = 12230,
  [SMALL_STATE(702)] = 12240,
  [SMALL_STATE(703)] = 12250,
  [SMALL_STATE(704)] = 12260,
  [SMALL_STATE(705)] = 12270,
  [SMALL_STATE(706)] = 12280,
  [SMALL_STATE(707)] = 12290,
  [SMALL_STATE(708)] = 12298,
  [SMALL_STATE(709)] = 12306,
  [SMALL_STATE(710)] = 12314,
  [SMALL_STATE(711)] = 12324,
  [SMALL_STATE(712)] = 12334,
  [SMALL_STATE(713)] = 12344,
  [SMALL_STATE(714)] = 12354,
  [SMALL_STATE(715)] = 12362,
  [SMALL_STATE(716)] = 12372,
  [SMALL_STATE(717)] = 12380,
  [SMALL_STATE(718)] = 12390,
  [SMALL_STATE(719)] = 12400,
  [SMALL_STATE(720)] = 12408,
  [SMALL_STATE(721)] = 12418,
  [SMALL_STATE(722)] = 12426,
  [SMALL_STATE(723)] = 12436,
  [SMALL_STATE(724)] = 12444,
  [SMALL_STATE(725)] = 12452,
  [SMALL_STATE(726)] = 12462,
  [SMALL_STATE(727)] = 12472,
  [SMALL_STATE(728)] = 12482,
  [SMALL_STATE(729)] = 12492,
  [SMALL_STATE(730)] = 12502,
  [SMALL_STATE(731)] = 12512,
  [SMALL_STATE(732)] = 12522,
  [SMALL_STATE(733)] = 12530,
  [SMALL_STATE(734)] = 12537,
  [SMALL_STATE(735)] = 12544,
  [SMALL_STATE(736)] = 12551,
  [SMALL_STATE(737)] = 12558,
  [SMALL_STATE(738)] = 12565,
  [SMALL_STATE(739)] = 12572,
  [SMALL_STATE(740)] = 12579,
  [SMALL_STATE(741)] = 12586,
  [SMALL_STATE(742)] = 12593,
  [SMALL_STATE(743)] = 12600,
  [SMALL_STATE(744)] = 12607,
  [SMALL_STATE(745)] = 12614,
  [SMALL_STATE(746)] = 12621,
  [SMALL_STATE(747)] = 12628,
  [SMALL_STATE(748)] = 12635,
  [SMALL_STATE(749)] = 12642,
  [SMALL_STATE(750)] = 12649,
  [SMALL_STATE(751)] = 12656,
  [SMALL_STATE(752)] = 12663,
  [SMALL_STATE(753)] = 12670,
  [SMALL_STATE(754)] = 12677,
  [SMALL_STATE(755)] = 12684,
  [SMALL_STATE(756)] = 12691,
  [SMALL_STATE(757)] = 12698,
  [SMALL_STATE(758)] = 12705,
  [SMALL_STATE(759)] = 12712,
  [SMALL_STATE(760)] = 12719,
  [SMALL_STATE(761)] = 12726,
  [SMALL_STATE(762)] = 12733,
  [SMALL_STATE(763)] = 12740,
  [SMALL_STATE(764)] = 12747,
  [SMALL_STATE(765)] = 12754,
  [SMALL_STATE(766)] = 12761,
  [SMALL_STATE(767)] = 12768,
  [SMALL_STATE(768)] = 12775,
  [SMALL_STATE(769)] = 12782,
  [SMALL_STATE(770)] = 12789,
  [SMALL_STATE(771)] = 12796,
  [SMALL_STATE(772)] = 12803,
  [SMALL_STATE(773)] = 12810,
  [SMALL_STATE(774)] = 12817,
  [SMALL_STATE(775)] = 12824,
  [SMALL_STATE(776)] = 12831,
  [SMALL_STATE(777)] = 12838,
  [SMALL_STATE(778)] = 12845,
  [SMALL_STATE(779)] = 12852,
  [SMALL_STATE(780)] = 12859,
  [SMALL_STATE(781)] = 12866,
  [SMALL_STATE(782)] = 12873,
  [SMALL_STATE(783)] = 12880,
  [SMALL_STATE(784)] = 12887,
  [SMALL_STATE(785)] = 12894,
  [SMALL_STATE(786)] = 12901,
  [SMALL_STATE(787)] = 12908,
  [SMALL_STATE(788)] = 12915,
  [SMALL_STATE(789)] = 12922,
  [SMALL_STATE(790)] = 12929,
  [SMALL_STATE(791)] = 12936,
  [SMALL_STATE(792)] = 12943,
  [SMALL_STATE(793)] = 12950,
  [SMALL_STATE(794)] = 12957,
  [SMALL_STATE(795)] = 12964,
  [SMALL_STATE(796)] = 12971,
  [SMALL_STATE(797)] = 12978,
  [SMALL_STATE(798)] = 12985,
  [SMALL_STATE(799)] = 12992,
  [SMALL_STATE(800)] = 12999,
  [SMALL_STATE(801)] = 13006,
  [SMALL_STATE(802)] = 13013,
  [SMALL_STATE(803)] = 13020,
  [SMALL_STATE(804)] = 13027,
  [SMALL_STATE(805)] = 13034,
  [SMALL_STATE(806)] = 13041,
  [SMALL_STATE(807)] = 13048,
  [SMALL_STATE(808)] = 13055,
  [SMALL_STATE(809)] = 13062,
  [SMALL_STATE(810)] = 13069,
  [SMALL_STATE(811)] = 13076,
  [SMALL_STATE(812)] = 13083,
  [SMALL_STATE(813)] = 13090,
  [SMALL_STATE(814)] = 13097,
  [SMALL_STATE(815)] = 13104,
  [SMALL_STATE(816)] = 13111,
  [SMALL_STATE(817)] = 13118,
  [SMALL_STATE(818)] = 13125,
  [SMALL_STATE(819)] = 13132,
  [SMALL_STATE(820)] = 13139,
  [SMALL_STATE(821)] = 13146,
  [SMALL_STATE(822)] = 13153,
  [SMALL_STATE(823)] = 13160,
  [SMALL_STATE(824)] = 13167,
  [SMALL_STATE(825)] = 13174,
  [SMALL_STATE(826)] = 13181,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(338),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(43),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(60),
  [130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(6),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(777),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(18),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(774),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(528),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(806),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(781),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(400),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(397),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(782),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(691),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(316),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(314),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(37),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(28),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(785),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(403),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(788),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(12),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(55),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(53),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(695),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(135),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(40),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(52),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(50),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(756),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(326),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(326),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(696),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(485),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(487),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2), SHIFT_REPEAT(697),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 1), REDUCE(aux_sym_tuple_expression_repeat1, 1),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 1),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 65),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 65),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(475),
  [305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 77),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 77),
  [309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(436),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(489),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(462),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(802),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(765),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(793),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(811),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(792),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(754),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(750),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(751),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(548),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(316),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(314),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(756),
  [360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 2),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 2),
  [366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 4),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 4),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, .production_id = 43),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, .production_id = 43),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 4, .production_id = 51),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, .production_id = 51),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_statement, 4, .production_id = 66),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_statement, 4, .production_id = 66),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 73),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 73),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 3),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 3),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_statement, 2),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_statement, 2),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 3),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 3),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_while_statement, 7, .production_id = 82),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_while_statement, 7, .production_id = 82),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 3, .production_id = 54),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 3, .production_id = 54),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 6),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 6),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 3, .production_id = 53),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 3, .production_id = 53),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 72),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 72),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 4, .production_id = 64),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 4, .production_id = 64),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 72),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 72),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 5),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 5),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_emit_statement, 4, .production_id = 25),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_emit_statement, 4, .production_id = 25),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 2),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 2),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 74),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 74),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(436),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_contract_body_repeat1, 2),
  [493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(825),
  [496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(826),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(813),
  [502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(814),
  [505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(766),
  [508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(563),
  [511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(564),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(316),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(314),
  [520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(763),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(702),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(703),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2), SHIFT_REPEAT(756),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 4),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 4),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 81),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 81),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 1),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(436),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(691),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(316),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(314),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2), SHIFT_REPEAT(756),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 25),
  [601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 25),
  [603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 3, .production_id = 25),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 3, .production_id = 25),
  [607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 13),
  [609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 13),
  [611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 4, .production_id = 19),
  [613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_directive, 4, .production_id = 19),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3, .production_id = 13),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3, .production_id = 13),
  [619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 7, .production_id = 25),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 7, .production_id = 25),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 4, .production_id = 20),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 4, .production_id = 20),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_body, 2),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_body, 2),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 4, .production_id = 25),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 4, .production_id = 25),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 34),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 34),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_definition, 4, .production_id = 25),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_definition, 4, .production_id = 25),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 34),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 34),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 4, .production_id = 22),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 4, .production_id = 22),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 38),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 38),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 6, .production_id = 25),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 6, .production_id = 25),
  [659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 36),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 36),
  [663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 4, .production_id = 22),
  [665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 4, .production_id = 22),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 5, .production_id = 62),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 5, .production_id = 62),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 3),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_body, 3),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 8, .production_id = 25),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 8, .production_id = 25),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 22),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 22),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 4, .production_id = 52),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 4, .production_id = 52),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 6, .production_id = 70),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 6, .production_id = 70),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 4, .production_id = 51),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 4, .production_id = 51),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 25),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 25),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 22),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 22),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 34),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 34),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 3, .production_id = 23),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 3, .production_id = 23),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, .production_id = 61),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, .production_id = 61),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 4, .production_id = 51),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 4, .production_id = 51),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_type_definition, 5, .production_id = 25),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_type_definition, 5, .production_id = 25),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 3, .production_id = 43),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 3, .production_id = 43),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 5, .production_id = 25),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 5, .production_id = 25),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 3, .production_id = 13),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 3, .production_id = 13),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_definition, 5, .production_id = 25),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_definition, 5, .production_id = 25),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3),
  [747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 3, .production_id = 43),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 3, .production_id = 43),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 45),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 45),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 3),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 3),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 46),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 46),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_variable_declaration, 6, .production_id = 49),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_variable_declaration, 6, .production_id = 49),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 4),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 4),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 3),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_directive, 3),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_body, 3),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_body, 3),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 37),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 37),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 5, .production_id = 31),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 5, .production_id = 31),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 5, .production_id = 25),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 5, .production_id = 25),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_declaration, 3, .production_id = 13),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_declaration, 3, .production_id = 13),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 13),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 13),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 3, .production_id = 13),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 3, .production_id = 13),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 3, .production_id = 11),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_directive, 3, .production_id = 11),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 5, .production_id = 38),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 5, .production_id = 38),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_member, 3, .production_id = 23),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 3, .production_id = 23),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(236),
  [884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(216),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(693),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(224),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(288),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(261),
  [901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(224),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(243),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(566),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(290),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(294),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(704),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(237),
  [922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(484),
  [925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2), SHIFT_REPEAT(483),
  [928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_path, 1),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_path, 1),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_path, 2),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_path, 2),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_identifier, 1),
  [942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_identifier, 1),
  [944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_path_repeat1, 2),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_path_repeat1, 2),
  [948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_path_repeat1, 2), SHIFT_REPEAT(720),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 2),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 2),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 1, .production_id = 28),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 1, .production_id = 28),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 1),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 1),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 3),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 3),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_yul_identifier, 1), SHIFT(260),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_evm_builtin, 1),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_evm_builtin, 1),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 6, .production_id = 28),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 6, .production_id = 28),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_assignment_repeat1, 2),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_assignment_repeat1, 2),
  [994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_assignment_repeat1, 2), SHIFT_REPEAT(605),
  [997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 4, .production_id = 28),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 4, .production_id = 28),
  [1001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 5, .production_id = 28),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 5, .production_id = 28),
  [1005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2),
  [1009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2), SHIFT_REPEAT(715),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_boolean, 1),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_boolean, 1),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_string_literal, 1),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_string_literal, 1),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 3, .production_id = 28),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 3, .production_id = 28),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 3, .production_id = 71),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 3, .production_id = 71),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 2, .production_id = 63),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 2, .production_id = 63),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 3),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 3),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2),
  [1052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2), SHIFT_REPEAT(463),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 3),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 3),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_block, 2),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_block, 2),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_block, 3),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_block, 3),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 4, .production_id = 75),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 4, .production_id = 75),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 6, .production_id = 84),
  [1075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 6, .production_id = 84),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 5, .production_id = 79),
  [1081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 5, .production_id = 79),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_label, 2),
  [1087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_label, 2),
  [1089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_continue, 1),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_continue, 1),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 7),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 7),
  [1097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 8, .production_id = 86),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 8, .production_id = 86),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__yul_expression, 1), REDUCE(sym_yul_assignment, 3),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__yul_expression, 1), REDUCE(sym_yul_assignment, 3),
  [1107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 8),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 8),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 6, .production_id = 83),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 6, .production_id = 83),
  [1115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 9),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 9),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 5),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 5),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 10),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 10),
  [1135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 5),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 5),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 5),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 5),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 11),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 11),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_for_statement, 5),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_for_statement, 5),
  [1157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_if_statement, 3),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_if_statement, 3),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 12),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 12),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 4),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 4),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 4),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 4),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 6),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 6),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 4, .production_id = 76),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 4, .production_id = 76),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 7, .production_id = 85),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 7, .production_id = 85),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_break, 1),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_break, 1),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 5, .production_id = 80),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 5, .production_id = 80),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__yul_assignment_operator, 2),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__yul_assignment_operator, 2),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3, .production_id = 6),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3, .production_id = 6),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__identifier_path_repeat1, 2),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2),
  [1241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2), SHIFT_REPEAT(817),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_repeat1, 2),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2), SHIFT_REPEAT(313),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2), SHIFT_REPEAT(310),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 2, .production_id = 6),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 2, .production_id = 6),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 2),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 4),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 4),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_mutability, 1),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_mutability, 1),
  [1270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 5),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 5),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 3),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 3),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility, 1),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility, 1),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_type, 1),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_type, 1),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 2),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 2),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 4, .production_id = 6),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 4, .production_id = 6),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 6, .production_id = 47),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 6, .production_id = 47),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 5, .production_id = 47),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 5, .production_id = 47),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 2),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 2),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 4, .production_id = 47),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 4, .production_id = 47),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 1),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 1),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 7, .production_id = 57),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 7, .production_id = 57),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_type, 3),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 3),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 8, .production_id = 67),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 8, .production_id = 67),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 6, .production_id = 48),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 6, .production_id = 48),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 7, .production_id = 56),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 7, .production_id = 56),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_type, 4),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 4),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 4),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 4),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 2),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 2),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 5),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 5),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 3),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 3),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_path, 1),
  [1372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__identifier_path, 1),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__identifier_path, 1),
  [1378] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__identifier_path, 1), SHIFT(743),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_path, 2),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_path, 2),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(485),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(487),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1),
  [1400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2), REDUCE(sym_member_expression, 3, .dynamic_precedence = 1, .production_id = 39),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__identifier_path_repeat1, 2), REDUCE(sym_member_expression, 3, .dynamic_precedence = 1, .production_id = 39),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2),
  [1410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2), SHIFT_REPEAT(696),
  [1413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2),
  [1415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2),
  [1417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2), SHIFT_REPEAT(697),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hex_string_literal, 1),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hex_string_literal, 1),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_string_literal, 1),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unicode_string_literal, 1),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 40),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 40),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 4),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 4),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 41),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [1480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), SHIFT(23),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 26),
  [1485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 26),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 5),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 5),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 25),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 25),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 3),
  [1499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 3),
  [1501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 4),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 4),
  [1505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5),
  [1507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 3),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 3),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 26),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 26),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 41),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 4),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 4),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payable_conversion_expression, 2),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payable_conversion_expression, 2),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 28),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 28),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 3, .production_id = 42),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 3, .production_id = 42),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 2),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 2),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 5, .production_id = 60),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 5, .production_id = 60),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .dynamic_precedence = 1, .production_id = 39),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .dynamic_precedence = 1, .production_id = 39),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 5, .production_id = 59),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 5, .production_id = 59),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 3, .production_id = 14),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 3, .production_id = 14),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, .production_id = 50),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, .production_id = 50),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 5, .production_id = 14),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 5, .production_id = 14),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_type_expression, 4),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_type_expression, 4),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_unit, 1),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_unit, 1),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 2),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 2),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 4, .production_id = 42),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 4, .production_id = 42),
  [1595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym_type_name, 1),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 6, .production_id = 68),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 6, .production_id = 68),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 4, .production_id = 14),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 4, .production_id = 14),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 5),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 5),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 27),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 27),
  [1618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 3),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 3),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 6, .production_id = 14),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 6, .production_id = 14),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_false, 1),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_false, 1),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 25),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 25),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 2),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 2),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_true, 1),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_true, 1),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_field_assignment, 3, .production_id = 58),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 1),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_array_expression_repeat1, 2),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_struct_argument, 3, .production_id = 58),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_tuple, 3),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_tuple, 2),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_path, 1),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(436),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2),
  [1753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(313),
  [1756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(310),
  [1759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(447),
  [1762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2), SHIFT_REPEAT(443),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2), SHIFT_REPEAT(436),
  [1772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2),
  [1774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2), SHIFT_REPEAT(313),
  [1777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2), SHIFT_REPEAT(310),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2), SHIFT_REPEAT(447),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2), SHIFT_REPEAT(446),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 1),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 1),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1), REDUCE(aux_sym__function_type_repeat1, 1),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 1),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_repeat1, 1),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 5),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 5),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 4),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 4),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_invocation, 1),
  [1813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_invocation, 1),
  [1815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 6),
  [1817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 6),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_invocation, 2),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_invocation, 2),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_pragma_token, 2, .production_id = 8),
  [1831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, .production_id = 15), SHIFT_REPEAT(459),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, .production_id = 15), SHIFT_REPEAT(800),
  [1837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, .production_id = 15), SHIFT_REPEAT(800),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, .production_id = 15),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_pragma_token, 1),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 1, .production_id = 7),
  [1856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 1, .production_id = 7),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pragma_version_constraint, 2),
  [1860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pragma_version_constraint, 2),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, .production_id = 44),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, .production_id = 44), SHIFT_REPEAT(461),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, .production_id = 44), SHIFT_REPEAT(313),
  [1870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, .production_id = 44), SHIFT_REPEAT(447),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, .production_id = 7),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, .production_id = 7),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_definition_repeat1, 2), SHIFT_REPEAT(436),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_definition_repeat1, 2),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_definition_repeat1, 2), SHIFT_REPEAT(468),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, .production_id = 14),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 1, .production_id = 32),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nameless_parameter, 1, .production_id = 14),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2),
  [1933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2), SHIFT_REPEAT(447),
  [1936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2), SHIFT_REPEAT(476),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [1941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(477),
  [1944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(477),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2), SHIFT_REPEAT(478),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2),
  [1954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2), SHIFT_REPEAT(757),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 1, .production_id = 14),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 4),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 3),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [2011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(492),
  [2014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(492),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_parameter, 1, .production_id = 14),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inheritance_specifier, 1, .production_id = 21),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, .production_id = 35),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_alias, 2, .production_id = 16),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat2, 2),
  [2059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat2, 2), SHIFT_REPEAT(519),
  [2062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat1, 2),
  [2064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat1, 2), SHIFT_REPEAT(520),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, .production_id = 23),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_declaration, 1, .production_id = 3),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2), SHIFT_REPEAT(129),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__call_arguments_repeat1, 2), SHIFT_REPEAT(26),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__call_arguments_repeat1, 2),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_expression_repeat1, 2), SHIFT_REPEAT(675),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_expression_repeat1, 2),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 2, .production_id = 14),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 1),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 2),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 24),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 2), SHIFT_REPEAT(108),
  [2225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 2),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 1, .production_id = 3),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__source_import, 1, .production_id = 5),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, .production_id = 30), SHIFT_REPEAT(650),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, .production_id = 30),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_function_call_repeat1, 2), SHIFT_REPEAT(293),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_function_call_repeat1, 2),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 2), SHIFT_REPEAT(628),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 2),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_array_expression_repeat1, 2), SHIFT_REPEAT(63),
  [2287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2), SHIFT_REPEAT(131),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_override_specifier_repeat1, 2), SHIFT_REPEAT(621),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_specifier_repeat1, 2),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_argument_repeat1, 2), SHIFT_REPEAT(672),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_argument_repeat1, 2),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__event_parameter_list_repeat1, 2), SHIFT_REPEAT(128),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__event_parameter_list_repeat1, 2),
  [2347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(30),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_flags_repeat1, 2), SHIFT_REPEAT(603),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assembly_flags_repeat1, 2),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(740),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 1),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_heritage_repeat1, 2),
  [2388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_heritage_repeat1, 2), SHIFT_REPEAT(506),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_error_declaration_repeat1, 2), SHIFT_REPEAT(130),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_error_declaration_repeat1, 2),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 34),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, .production_id = 55),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 3),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 3, .production_id = 69),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 4),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 5),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 5),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 3),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nameless_parameter, 2, .production_id = 24),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 4),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_type_definition, 2),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 2, .production_id = 23),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 2),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_declaration, 2, .production_id = 10),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 23),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 35),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_parameter, 2, .production_id = 23),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inheritance_specifier, 2, .production_id = 33),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 2),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, .production_id = 17),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 4, .production_id = 17),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_source_type, 1),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 4, .production_id = 29),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 3),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 3),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [2558] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 6),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_clause, 1, .production_id = 4),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 2),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 18),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 3, .production_id = 17),
  [2584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 4),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 5),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__source_import, 2, .production_id = 12),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 2, .production_id = 10),
  [2616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 2),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 2, .production_id = 9),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_version_comparison_operator, 1),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_pragma_token, 2),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 5),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_value, 1),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 4),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 5, .production_id = 29),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_solidity() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
